(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/gambit/threads#spawn
    (lambda (_f66025_ . _args66026_)
      (gerbil/gambit/threads#spawn-actor _f66025_ _args66026_ '#!void '#f)))
  (define gerbil/gambit/threads#spawn/name
    (lambda (_name66021_ _f66022_ . _args66023_)
      (gerbil/gambit/threads#spawn-actor
       _f66022_
       _args66023_
       _name66021_
       '#f)))
  (define gerbil/gambit/threads#spawn/group
    (lambda (_name66015_ _f66016_ . _args66017_)
      (let ((_tgroup66019_ (make-thread-group _name66015_)))
        (gerbil/gambit/threads#spawn-actor
         _f66016_
         _args66017_
         _name66015_
         _tgroup66019_))))
  (define gerbil/gambit/threads#spawn-actor
    (lambda (_f65993_ _args65994_ _name65995_ _tgroup65996_)
      (letrec ((_thread-main65998_
                (lambda (_thunk66007_)
                  (lambda ()
                    (with-exception-handler
                     (lambda (_exn66010_)
                       (##continuation-capture
                        (lambda (_cont66012_)
                          (if gerbil/gambit/threads#unhandled-actor-exception-hook
                              (with-exception-catcher
                               void
                               (lambda ()
                                 (gerbil/gambit/threads#unhandled-actor-exception-hook
                                  _cont66012_
                                  _exn66010_)))
                              '#!void)
                          (##continuation-graft
                           (##continuation-last _cont66012_)
                           ##primordial-exception-handler
                           _exn66010_))))
                     _thunk66007_)))))
        (if (procedure? _f65993_)
            (let ((_thunk66004_
                   (if (null? _args65994_)
                       _f65993_
                       (lambda () (apply _f65993_ _args65994_))))
                  (_tgroup66005_
                   (let ((_$e66001_ _tgroup65996_))
                     (if _$e66001_
                         _$e66001_
                         (gerbil/gambit/threads#current-thread-group)))))
              (thread-start!
               (thread-init!
                (gerbil/gambit/threads#construct-actor-thread '#f)
                (_thread-main65998_ _thunk66004_)
                _name65995_
                _tgroup66005_)))
            (error '"Bad argument; expected procedure" _f65993_)))))
  (namespace
   ("gerbil/gambit/threads#"
    construct-actor-thread
    actor-thread?
    actor-thread-locals
    actor-thread-locals-set!))
  (define-type-of-thread
   actor-thread
   constructor:
   construct-actor-thread
   id:
   gerbil#actor-thread::t
   locals)
  (define gerbil/gambit/threads#spawn-thread__%
    (lambda (_thunk65971_ _name65972_ _tgroup65973_)
      (thread-start! (make-thread _thunk65971_ _name65972_ _tgroup65973_))))
  (define gerbil/gambit/threads#spawn-thread__0
    (lambda (_thunk65978_)
      (let* ((_name65980_ absent-obj) (_tgroup65982_ absent-obj))
        (gerbil/gambit/threads#spawn-thread__%
         _thunk65978_
         _name65980_
         _tgroup65982_))))
  (define gerbil/gambit/threads#spawn-thread__1
    (lambda (_thunk65984_ _name65985_)
      (let ((_tgroup65987_ absent-obj))
        (gerbil/gambit/threads#spawn-thread__%
         _thunk65984_
         _name65985_
         _tgroup65987_))))
  (define gerbil/gambit/threads#spawn-thread
    (lambda _g66028_
      (let ((_g66027_ (length _g66028_)))
        (cond ((##fx= _g66027_ 1)
               (apply gerbil/gambit/threads#spawn-thread__0 _g66028_))
              ((##fx= _g66027_ 2)
               (apply gerbil/gambit/threads#spawn-thread__1 _g66028_))
              ((##fx= _g66027_ 3)
               (apply gerbil/gambit/threads#spawn-thread__% _g66028_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/threads#spawn-thread
                _g66028_))))))
  (define gerbil/gambit/threads#thread-local-ref__%
    (lambda (_key65955_ _default65956_)
      (let ((_tab65958_ (gerbil/gambit/threads#thread-local-table)))
        (table-ref _tab65958_ _key65955_ _default65956_))))
  (define gerbil/gambit/threads#thread-local-ref__0
    (lambda (_key65963_)
      (let ((_default65965_ absent-obj))
        (gerbil/gambit/threads#thread-local-ref__%
         _key65963_
         _default65965_))))
  (define gerbil/gambit/threads#thread-local-ref
    (lambda _g66030_
      (let ((_g66029_ (length _g66030_)))
        (cond ((##fx= _g66029_ 1)
               (apply gerbil/gambit/threads#thread-local-ref__0 _g66030_))
              ((##fx= _g66029_ 2)
               (apply gerbil/gambit/threads#thread-local-ref__% _g66030_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/threads#thread-local-ref
                _g66030_))))))
  (define gerbil/gambit/threads#thread-local-get
    (lambda (_key65952_)
      (gerbil/gambit/threads#thread-local-ref__% _key65952_ '#f)))
  (define gerbil/gambit/threads#thread-local-set!
    (lambda (_key65947_ _value65948_)
      (let ((_tab65950_ (gerbil/gambit/threads#thread-local-table)))
        (table-set! _tab65950_ _key65947_ _value65948_))))
  (define gerbil/gambit/threads#thread-local-clear!
    (lambda (_key65943_)
      (let ((_tab65945_ (gerbil/gambit/threads#thread-local-table)))
        (table-set! _tab65945_ _key65943_))))
  (define gerbil/gambit/threads#thread-local-table
    (lambda ()
      (let ((_thr65929_ (current-thread)))
        (if (gerbil/gambit/threads#actor-thread? _thr65929_)
            (let ((_$e65931_
                   (gerbil/gambit/threads#actor-thread-locals _thr65929_)))
              (if _$e65931_
                  (values _$e65931_)
                  (let ((_tab65934_ (make-table 'test: eq?)))
                    (gerbil/gambit/threads#actor-thread-locals-set!
                     _thr65929_
                     _tab65934_)
                    _tab65934_)))
            (if (eq? _thr65929_ ##primordial-thread)
                gerbil/gambit/threads#*primordial-thread-locals*
                (begin
                  (mutex-lock! gerbil/gambit/threads#*thread-locals-mutex*)
                  (let ((_$e65936_
                         (table-ref
                          gerbil/gambit/threads#*thread-locals*
                          _thr65929_
                          '#f)))
                    (if _$e65936_
                        ((lambda (_tab65939_)
                           (mutex-unlock!
                            gerbil/gambit/threads#*thread-locals-mutex*)
                           _tab65939_)
                         _$e65936_)
                        (let ((_tab65941_ (make-table 'test: eq?)))
                          (table-set!
                           gerbil/gambit/threads#*thread-locals*
                           _thr65929_
                           _tab65941_)
                          (mutex-unlock!
                           gerbil/gambit/threads#*thread-locals-mutex*)
                          _tab65941_)))))))))
  (define gerbil/gambit/threads#*primordial-thread-locals*
    (make-table 'test: eq?))
  (define gerbil/gambit/threads#*thread-locals*
    (make-table 'test: eq? 'weak-keys: '#t))
  (define gerbil/gambit/threads#*thread-locals-mutex*
    (make-mutex 'thread-locals))
  (define gerbil/gambit/threads#unhandled-actor-exception-hook '#f)
  (define gerbil/gambit/threads#unhandled-actor-exception-hook-set!
    (lambda (_proc65923_)
      (if (or (not _proc65923_) (procedure? _proc65923_))
          (set! gerbil/gambit/threads#unhandled-actor-exception-hook
                _proc65923_)
          (error '"Bad argument; expected procedure or #f" _proc65923_))))
  (define gerbil/gambit/threads#with-exception-stack-trace__%
    (lambda (_thunk65904_ _error-port65905_)
      (with-exception-handler
       (let ((_E65907_ (current-exception-handler)))
         (lambda (_exn65909_)
           (##continuation-capture
            (lambda (_cont65911_)
              (gerbil/gambit/threads#dump-stack-trace!
               _cont65911_
               _exn65909_
               _error-port65905_)
              (_E65907_ _exn65909_)))))
       _thunk65904_)))
  (define gerbil/gambit/threads#with-exception-stack-trace__0
    (lambda (_thunk65916_)
      (let ((_error-port65918_ (current-error-port)))
        (gerbil/gambit/threads#with-exception-stack-trace__%
         _thunk65916_
         _error-port65918_))))
  (define gerbil/gambit/threads#with-exception-stack-trace
    (lambda _g66032_
      (let ((_g66031_ (length _g66032_)))
        (cond ((##fx= _g66031_ 1)
               (apply gerbil/gambit/threads#with-exception-stack-trace__0
                      _g66032_))
              ((##fx= _g66031_ 2)
               (apply gerbil/gambit/threads#with-exception-stack-trace__%
                      _g66032_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/threads#with-exception-stack-trace
                _g66032_))))))
  (namespace ("gerbil/gambit/threads#" dump-stack-trace!))
  (define (dump-stack-trace!
           cont
           exn
           #!optional
           (error-port (current-error-port)))
    (let ((out (open-output-string)))
      (display "*** Unhandled exception in " out)
      (display (current-thread) out)
      (newline out)
      (display-exception exn out)
      (display "Continuation backtrace: " out)
      (newline out)
      (##display-continuation-backtrace
       cont
       out
       #f
       #f
       ##backtrace-default-max-head
       ##backtrace-default-max-tail
       0)
      (##write-string (get-output-string out) error-port)))
  (define gerbil/gambit/threads#current-thread-group
    (lambda () (thread-thread-group (current-thread))))
  (define gerbil/gambit/threads#with-lock
    (lambda (_mx65897_ _proc65898_)
      (dynamic-wind
       (lambda () (mutex-lock! _mx65897_))
       _proc65898_
       (lambda () (mutex-unlock! _mx65897_))))))
