(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxprof#main
    (lambda _args180_
      (let* ((_args181189_ _args180_)
             (_else183197_
              (lambda () (displayln '"Usage: gxprof exe-module-path arg ...")))
             (_K185210_
              (lambda (_args200_ _mod201_)
                (_gx#load-expander!)
                (let* ((_ctx203_
                        (gx#import-module__%
                         (gerbil/tools/gxprof#module-path _mod201_)
                         '#f
                         '#t))
                       (_main-id205_
                        (gerbil/tools/gxprof#find-runtime-symbol
                         _ctx203_
                         'main))
                       (_main-fn207_ (eval _main-id205_)))
                  (gerbil/tools/gxprof#profile _main-fn207_ _args200_)))))
        (if (let () (declare (not safe)) (##pair? _args181189_))
            (let ((_hd186213_
                   (let () (declare (not safe)) (##car _args181189_)))
                  (_tl187215_
                   (let () (declare (not safe)) (##cdr _args181189_))))
              (let* ((_mod218_ _hd186213_) (_args220_ _tl187215_))
                (_K185210_ _args220_ _mod218_)))
            (_else183197_)))))
  (define gerbil/tools/gxprof#module-path
    (lambda (_str178_)
      (if (and (> (string-length _str178_) '0)
               (eq? (string-ref _str178_ '0) '#\:))
          (string->symbol _str178_)
          _str178_)))
  (define gerbil/tools/gxprof#find-export-binding
    (lambda (_ctx128_ _id129_)
      (let ((_$e175_ (find (lambda (_e130132_)
                             (let* ((_g134144_ _e130132_)
                                    (_else136152_ (lambda () '#f))
                                    (_K138156_ (lambda () '#t)))
                               (if (let ()
                                     (declare (not safe))
                                     (##structure-direct-instance-of?
                                      _g134144_
                                      'gx#module-export::t))
                                   (let* ((_e139159_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g134144_ '1)))
                                          (_e140162_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g134144_ '2)))
                                          (_e141165_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g134144_ '3))))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _e141165_ '0))
                                         (let ((_e142168_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   _g134144_
                                                   '4))))
                                           (if ((lambda (_g170172_)
                                                  (eq? _g170172_ _id129_))
                                                _e142168_)
                                               (_K138156_)
                                               (_else136152_)))
                                         (_else136152_)))
                                   (_else136152_))))
                           (##structure-ref
                            _ctx128_
                            '9
                            gx#module-context::t
                            '#f))))
        (if _$e175_ (gx#core-resolve-module-export _$e175_) '#f))))
  (define gerbil/tools/gxprof#find-runtime-symbol
    (lambda (_ctx120_ _id121_)
      (let ((_$e123_ (gerbil/tools/gxprof#find-export-binding
                      _ctx120_
                      _id121_)))
        (if _$e123_
            ((lambda (_bind126_)
               (if (let ()
                     (declare (not safe))
                     (##structure-instance-of?
                      _bind126_
                      'gx#runtime-binding::t))
                   '#!void
                   (error '"export is not a runtime binding" _id121_))
               (##structure-ref _bind126_ '1 gx#binding::t '#f))
             _$e123_)
            (error '"module does not export symbol"
                   (##structure-ref _ctx120_ '1 gx#expander-context::t '#f)
                   _id121_)))))
  (define gerbil/tools/gxprof#profile
    (lambda (_fun110_ _args111_)
      (with-unwind-protect
       (lambda ()
         (dynamic-wind
          gerbil/tools/gxprof#profile-start!
          (lambda () (apply _fun110_ _args111_))
          gerbil/tools/gxprof#profile-end!))
       (lambda ()
         (call-with-output-file
          '"gxprof.out"
          (lambda (_g115117_)
            (gerbil/tools/gxprof#write-samples
             gerbil/tools/gxprof#samples
             _g115117_)))))))
  (define gerbil/tools/gxprof#samples '())
  (define gerbil/tools/gxprof#profile-start!
    (lambda ()
      (let ((__tmp7002 (exact->inexact '1/1000)))
        (declare (not safe))
        (##set-heartbeat-interval! __tmp7002))
      (let ()
        (declare (not safe))
        (##interrupt-vector-set! '2 gerbil/tools/gxprof#profile-heartbeat!))))
  (define gerbil/tools/gxprof#profile-end!
    (lambda ()
      (let ((__tmp7003 (exact->inexact '1/100)))
        (declare (not safe))
        (##set-heartbeat-interval! __tmp7003))
      (let ()
        (declare (not safe))
        (##interrupt-vector-set! '2 ##thread-heartbeat!))))
  (define gerbil/tools/gxprof#profile-heartbeat!
    (lambda ()
      (let ((__tmp7004
             (lambda (_cont106_)
               (let () (declare (not safe)) (##thread-heartbeat!))
               (set! gerbil/tools/gxprof#samples
                     (cons (gerbil/tools/gxprof#continuation->sample _cont106_)
                           gerbil/tools/gxprof#samples)))))
        (declare (not safe))
        (##continuation-capture __tmp7004))))
  (define gerbil/tools/gxprof#continuation->sample
    (lambda (_cont96_)
      (let _lp98_ ((_cont100_
                    (let ()
                      (declare (not safe))
                      (##continuation-next-frame _cont96_ '#t)))
                   (_bt101_ '()))
        (if _cont100_
            (let ((_trace103_
                   (let ()
                     (declare (not safe))
                     (##continuation-creator _cont100_))))
              (_lp98_ (let ()
                        (declare (not safe))
                        (##continuation-next-frame _cont100_ '#t))
                      (cons _trace103_ _bt101_)))
            (reverse _bt101_)))))
  (define gerbil/tools/gxprof#write-samples
    (lambda (_samples79_ _port80_)
      (letrec* ((_traces82_ (make-table 'test: eq?))
                (_trace->name83_
                 (lambda (_trace89_)
                   (let ((_$e91_ (table-ref _traces82_ _trace89_ '#f)))
                     (if _$e91_
                         (values _$e91_)
                         (let ((_name94_
                                (let ()
                                  (declare (not safe))
                                  (##procedure-name _trace89_))))
                           (table-set! _traces82_ _trace89_ _name94_)
                           _name94_))))))
        (let ((_samples/names87_
               (map (lambda (_bt85_) (map _trace->name83_ _bt85_))
                    _samples79_)))
          (write _samples/names87_ _port80_))))))
