(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/message#rpc-proto-connect-hello '12)
  (define std/actor/rpc/proto/message#rpc-proto-connect-accept '1)
  (define std/actor/rpc/proto/message#rpc-proto-connect-reject '2)
  (define std/actor/rpc/proto/message#rpc-proto-challenge '3)
  (define std/actor/rpc/proto/message#rpc-proto-response '4)
  (define std/actor/rpc/proto/message#rpc-proto-key-exchange '5)
  (define std/actor/rpc/proto/message#rpc-proto-keep-alive '6)
  (define std/actor/rpc/proto/message#rpc-proto-message '7)
  (define std/actor/rpc/proto/message#rpc-proto-message-raw '0)
  (define std/actor/rpc/proto/message#rpc-proto-message-call '1)
  (define std/actor/rpc/proto/message#rpc-proto-message-value '2)
  (define std/actor/rpc/proto/message#rpc-proto-message-error '3)
  (define std/actor/rpc/proto/message#rpc-proto-message-event '4)
  (define std/actor/rpc/proto/message#rpc-proto-message-stream '5)
  (define std/actor/rpc/proto/message#rpc-proto-message-yield '6)
  (define std/actor/rpc/proto/message#rpc-proto-message-end '7)
  (define std/actor/rpc/proto/message#rpc-proto-message-continue '8)
  (define std/actor/rpc/proto/message#rpc-proto-message-close '9)
  (define std/actor/rpc/proto/message#rpc-proto-message-abort '10)
  (define std/actor/rpc/proto/message#rpc-proto-message-sync '11)
  (define std/actor/rpc/proto/message#rpc-proto-message-max-length
    (expt '2 '20))
  (define std/actor/rpc/proto/message#rpc-proto-null '0)
  (define std/actor/rpc/proto/message#rpc-proto-cookie '1)
  (define std/actor/rpc/proto/message#rpc-proto-cipher '2)
  (define std/actor/rpc/proto/message#rpc-proto-cookie-cipher '3)
  (define std/actor/rpc/proto/message#rpc-proto-marshal-message
    (lambda (_msg254283_ _proto254284_)
      (let ((_outp254286_
             (std/net/bio/buffer#open-serializer-output-buffer__0)))
        (std/actor/rpc/proto/message#rpc-proto-write-message
         _msg254283_
         _outp254286_
         _proto254284_)
        _outp254286_)))
  (define std/actor/rpc/proto/message#rpc-proto-write-message
    (lambda (_msg254014_ _buffer254015_ _proto254016_)
      (let* ((_msg254017254025_ _msg254014_)
             (_E254019254029_
              (lambda () (error '"No clause matching" _msg254017254025_)))
             (_K254020254267_
              (lambda (_dest254032_ _content254033_)
                (if _proto254016_
                    (std/actor/xdr#current-xdr-type-registry
                     (##direct-structure-ref
                      _proto254016_
                      '3
                      std/actor/proto#!protocol::t
                      '#f))
                    (std/actor/xdr#current-xdr-type-registry
                     std/actor/xdr#+xdr-default-type-registry+))
                (if (##structure-instance-of?
                     _content254033_
                     'std/actor/proto#!rpc::t)
                    (let* ((_content254034254076_ _content254033_)
                           (_else254046254084_
                            (lambda ()
                              (std/actor/proto#raise-rpc-io-error
                               'rpc-proto-write-message
                               '"unknown rpc message type"
                               _content254033_))))
                      (let ((_K254072254254_
                             (lambda (_k254251_ _e254252_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-call
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254251_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write
                                _e254252_
                                _buffer254015_)))
                            (_K254069254235_
                             (lambda (_k254232_ _e254233_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-value
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254232_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write
                                _e254233_
                                _buffer254015_)))
                            (_K254066254215_
                             (lambda (_k254212_ _e254213_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-error
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254212_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write
                                _e254213_
                                _buffer254015_)))
                            (_K254064254200_
                             (lambda (_e254198_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-event
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write
                                _e254198_
                                _buffer254015_)))
                            (_K254061254181_
                             (lambda (_k254178_ _e254179_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-stream
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254178_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write
                                _e254179_
                                _buffer254015_)))
                            (_K254058254161_
                             (lambda (_k254158_ _e254159_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-yield
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254158_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write
                                _e254159_
                                _buffer254015_)))
                            (_K254056254146_
                             (lambda (_k254144_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-end
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254144_
                                _buffer254015_)))
                            (_K254054254132_
                             (lambda (_k254130_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-continue
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254130_
                                _buffer254015_)))
                            (_K254052254118_
                             (lambda (_k254116_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-close
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254116_
                                _buffer254015_)))
                            (_K254050254104_
                             (lambda (_k254102_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-abort
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254102_
                                _buffer254015_)))
                            (_K254048254090_
                             (lambda (_k254088_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-sync
                                _buffer254015_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest254032_
                                _buffer254015_)
                               (std/actor/xdr#xdr-write-uint
                                _k254088_
                                _buffer254015_))))
                        (let* ((_try-match254045254098_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!sync::t)
                                      (let* ((_e254049254093_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_k254096_ _e254049254093_))
                                        (_K254048254090_ _k254096_))
                                      (_else254046254084_))))
                               (_try-match254044254112_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!abort::t)
                                      (let* ((_e254051254107_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_k254110_ _e254051254107_))
                                        (_K254050254104_ _k254110_))
                                      (_try-match254045254098_))))
                               (_try-match254043254126_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!close::t)
                                      (let* ((_e254053254121_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_k254124_ _e254053254121_))
                                        (_K254052254118_ _k254124_))
                                      (_try-match254044254112_))))
                               (_try-match254042254140_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!continue::t)
                                      (let* ((_e254055254135_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_k254138_ _e254055254135_))
                                        (_K254054254132_ _k254138_))
                                      (_try-match254043254126_))))
                               (_try-match254041254154_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!end::t)
                                      (let* ((_e254057254149_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_k254152_ _e254057254149_))
                                        (_K254056254146_ _k254152_))
                                      (_try-match254042254140_))))
                               (_try-match254040254174_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!yield::t)
                                      (let* ((_e254059254164_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_e254060254169_
                                              (##vector-ref
                                               _content254034254076_
                                               '2)))
                                        (let ((_e254167_ _e254059254164_)
                                              (_k254172_ _e254060254169_))
                                          (_K254058254161_
                                           _k254172_
                                           _e254167_)))
                                      (_try-match254041254154_))))
                               (_try-match254039254194_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!stream::t)
                                      (let* ((_e254062254184_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_e254063254189_
                                              (##vector-ref
                                               _content254034254076_
                                               '2)))
                                        (let ((_e254187_ _e254062254184_)
                                              (_k254192_ _e254063254189_))
                                          (_K254061254181_
                                           _k254192_
                                           _e254187_)))
                                      (_try-match254040254174_))))
                               (_try-match254038254208_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!event::t)
                                      (let* ((_e254065254203_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_e254206_ _e254065254203_))
                                        (_K254064254200_ _e254206_))
                                      (_try-match254039254194_))))
                               (_try-match254037254228_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!error::t)
                                      (let* ((_e254067254218_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_e254068254223_
                                              (##vector-ref
                                               _content254034254076_
                                               '2)))
                                        (let ((_e254221_ _e254067254218_)
                                              (_k254226_ _e254068254223_))
                                          (_K254066254215_
                                           _k254226_
                                           _e254221_)))
                                      (_try-match254038254208_))))
                               (_try-match254036254248_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254034254076_
                                       'std/actor/proto#!value::t)
                                      (let* ((_e254070254238_
                                              (##vector-ref
                                               _content254034254076_
                                               '1))
                                             (_e254071254243_
                                              (##vector-ref
                                               _content254034254076_
                                               '2)))
                                        (let ((_e254241_ _e254070254238_)
                                              (_k254246_ _e254071254243_))
                                          (_K254069254235_
                                           _k254246_
                                           _e254241_)))
                                      (_try-match254037254228_)))))
                          (if (##structure-direct-instance-of?
                               _content254034254076_
                               'std/actor/proto#!call::t)
                              (let* ((_e254073254257_
                                      (##vector-ref _content254034254076_ '1))
                                     (_e254074254262_
                                      (##vector-ref _content254034254076_ '2)))
                                (let ((_e254260_ _e254073254257_)
                                      (_k254265_ _e254074254262_))
                                  (_K254072254254_ _k254265_ _e254260_)))
                              (_try-match254036254248_)))))
                    (begin
                      (std/net/bio/output#bio-write-u8
                       std/actor/rpc/proto/message#rpc-proto-message-raw
                       _buffer254015_)
                      (std/actor/xdr#xdr-write
                       _content254033_
                       _buffer254015_))))))
        (if (##structure-direct-instance-of?
             _msg254017254025_
             'std/actor/message#message::t)
            (let* ((_e254021254270_ (##vector-ref _msg254017254025_ '1))
                   (_content254273_ _e254021254270_)
                   (_e254022254275_ (##vector-ref _msg254017254025_ '2))
                   (_e254023254278_ (##vector-ref _msg254017254025_ '3))
                   (_dest254281_ _e254023254278_))
              (_K254020254267_ _dest254281_ _content254273_))
            (_E254019254029_)))))
  (define std/actor/rpc/proto/message#rpc-proto-read-envelope
    (lambda (_buffer253987_)
      (let* ((_type253989_ (std/net/bio/input#bio-read-u8 _buffer253987_))
             (_dest253991_ (std/actor/rpc/base#xdr-read-uuid _buffer253987_)))
        (##structure
         std/actor/message#message::t
         (if (eq? _type253989_
                  std/actor/rpc/proto/message#rpc-proto-message-call)
             (let ((_k253994_ (std/actor/xdr#xdr-read-uint _buffer253987_)))
               (##structure std/actor/proto#!call::t '#!void _k253994_))
             (if (eq? _type253989_
                      std/actor/rpc/proto/message#rpc-proto-message-value)
                 (let ((_k253996_
                        (std/actor/xdr#xdr-read-uint _buffer253987_)))
                   (##structure std/actor/proto#!value::t '#!void _k253996_))
                 (if (eq? _type253989_
                          std/actor/rpc/proto/message#rpc-proto-message-error)
                     (let ((_k253998_
                            (std/actor/xdr#xdr-read-uint _buffer253987_)))
                       (##structure
                        std/actor/proto#!error::t
                        '#!void
                        _k253998_))
                     (if (eq? _type253989_
                              std/actor/rpc/proto/message#rpc-proto-message-event)
                         (##structure std/actor/proto#!event::t '#!void)
                         (if (eq? _type253989_
                                  std/actor/rpc/proto/message#rpc-proto-message-raw)
                             '#!void
                             (if (eq? _type253989_
                                      std/actor/rpc/proto/message#rpc-proto-message-stream)
                                 (let ((_k254000_
                                        (std/actor/xdr#xdr-read-uint
                                         _buffer253987_)))
                                   (##structure
                                    std/actor/proto#!stream::t
                                    '#!void
                                    _k254000_))
                                 (if (eq? _type253989_
                                          std/actor/rpc/proto/message#rpc-proto-message-yield)
                                     (let ((_k254002_
                                            (std/actor/xdr#xdr-read-uint
                                             _buffer253987_)))
                                       (##structure
                                        std/actor/proto#!yield::t
                                        '#!void
                                        _k254002_))
                                     (if (eq? _type253989_
                                              std/actor/rpc/proto/message#rpc-proto-message-end)
                                         (let ((_k254004_
                                                (std/actor/xdr#xdr-read-uint
                                                 _buffer253987_)))
                                           (##structure
                                            std/actor/proto#!end::t
                                            _k254004_))
                                         (if (eq? _type253989_
                                                  std/actor/rpc/proto/message#rpc-proto-message-continue)
                                             (let ((_k254006_
                                                    (std/actor/xdr#xdr-read-uint
                                                     _buffer253987_)))
                                               (##structure
                                                std/actor/proto#!continue::t
                                                _k254006_))
                                             (if (eq? _type253989_
                                                      std/actor/rpc/proto/message#rpc-proto-message-close)
                                                 (let ((_k254008_
                                                        (std/actor/xdr#xdr-read-uint
                                                         _buffer253987_)))
                                                   (##structure
                                                    std/actor/proto#!close::t
                                                    _k254008_))
                                                 (if (eq? _type253989_
                                                          std/actor/rpc/proto/message#rpc-proto-message-abort)
                                                     (let ((_k254010_
                                                            (std/actor/xdr#xdr-read-uint
                                                             _buffer253987_)))
                                                       (##structure
                                                        std/actor/proto#!abort::t
                                                        _k254010_))
                                                     (if (eq? _type253989_
                                                              std/actor/rpc/proto/message#rpc-proto-message-sync)
                                                         (let ((_k254012_
                                                                (std/actor/xdr#xdr-read-uint
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _buffer253987_)))
                   (##structure std/actor/proto#!sync::t _k254012_))
                 (std/actor/proto#raise-rpc-io-error
                  'rpc-proto-read-message
                  '"unmarshal error; unexpected message type"
                  _type253989_)))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         '#!void
         _dest253991_
         '#f))))
  (define std/actor/rpc/proto/message#rpc-proto-read-payload!
    (lambda (_msg253920_ _buffer253921_ _proto253922_)
      (std/actor/xdr#current-xdr-type-registry
       (##direct-structure-ref
        _proto253922_
        '3
        std/actor/proto#!protocol::t
        '#f))
      (let* ((_value253924_
              (##direct-structure-ref
               _msg253920_
               '1
               std/actor/message#message::t
               '#f))
             (_value253925253935_ _value253924_)
             (_else253929253943_ (lambda () '#!void)))
        (let ((_K253933253972_
               (lambda ()
                 (let ((_payload253970_
                        (std/actor/xdr#xdr-read _buffer253921_)))
                   (##vector-set! _value253924_ '1 _payload253970_))))
              (_K253932253963_
               (lambda ()
                 (let* ((_payload253958_
                         (std/actor/xdr#xdr-read _buffer253921_))
                        (_e253960_
                         (if (string? _payload253958_)
                             (make-struct-instance
                              std/actor/proto#remote-error::t
                              'rpc
                              _payload253958_)
                             _payload253958_)))
                   (##vector-set! _value253924_ '1 _e253960_))))
              (_K253931253950_
               (lambda ()
                 (let ((_payload253948_
                        (std/actor/xdr#xdr-read _buffer253921_)))
                   (##direct-structure-set!
                    _msg253920_
                    _payload253948_
                    '1
                    std/actor/message#message::t
                    '#f)))))
          (let* ((_try-match253928253953_
                  (lambda ()
                    (if (eq? _value253925253935_ '#!void)
                        (_K253931253950_)
                        '#!void)))
                 (_try-match253927253966_
                  (lambda ()
                    (if (##structure-direct-instance-of?
                         _value253925253935_
                         'std/actor/proto#!error::t)
                        (_K253932253963_)
                        (_try-match253928253953_)))))
            (if (or (##structure-direct-instance-of?
                     _value253925253935_
                     'std/actor/proto#!call::t)
                    (##structure-direct-instance-of?
                     _value253925253935_
                     'std/actor/proto#!value::t)
                    (##structure-direct-instance-of?
                     _value253925253935_
                     'std/actor/proto#!event::t)
                    (##structure-direct-instance-of?
                     _value253925253935_
                     'std/actor/proto#!stream::t)
                    (##structure-direct-instance-of?
                     _value253925253935_
                     'std/actor/proto#!yield::t))
                (_K253933253972_)
                (_try-match253927253966_))))))))
