(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/lmdb#lmdb-error::t
    (make-struct-type
     'std/db/lmdb#lmdb-error::t
     error::t
     '0
     'lmdb-error
     '()
     '#f
     '()))
  (define std/db/lmdb#lmdb-error?
    (make-struct-predicate std/db/lmdb#lmdb-error::t))
  (define std/db/lmdb#make-lmdb-error
    (lambda _$args275995_
      (apply make-struct-instance std/db/lmdb#lmdb-error::t _$args275995_)))
  (define std/db/lmdb#raise-lmdb-error
    (lambda (_where275992_ _errno275993_)
      (raise (make-struct-instance
              std/db/lmdb#lmdb-error::t
              (std/db/_lmdb#mdb_strerror _errno275993_)
              (cons _errno275993_ '())
              _where275992_))))
  (define std/db/lmdb#lmdb-env::t
    (make-struct-type
     'std/db/lmdb#lmdb-env::t
     '#f
     '3
     'lmdb-env
     '((final: . #t))
     '#f
     '(ptr dbs mx)))
  (define std/db/lmdb#lmdb-env?
    (make-struct-predicate std/db/lmdb#lmdb-env::t))
  (define std/db/lmdb#make-lmdb-env
    (lambda _$args275989_
      (apply make-struct-instance std/db/lmdb#lmdb-env::t _$args275989_)))
  (define std/db/lmdb#lmdb-env-ptr
    (make-struct-field-accessor std/db/lmdb#lmdb-env::t '0))
  (define std/db/lmdb#lmdb-env-dbs
    (make-struct-field-accessor std/db/lmdb#lmdb-env::t '1))
  (define std/db/lmdb#lmdb-env-mx
    (make-struct-field-accessor std/db/lmdb#lmdb-env::t '2))
  (define std/db/lmdb#lmdb-env-ptr-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-env::t '0))
  (define std/db/lmdb#lmdb-env-dbs-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-env::t '1))
  (define std/db/lmdb#lmdb-env-mx-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-env::t '2))
  (define std/db/lmdb#lmdb-db::t
    (make-struct-type
     'std/db/lmdb#lmdb-db::t
     '#f
     '3
     'lmdb-db
     '((final: . #t))
     '#f
     '(env dbi name)))
  (define std/db/lmdb#lmdb-db? (make-struct-predicate std/db/lmdb#lmdb-db::t))
  (define std/db/lmdb#make-lmdb-db
    (lambda _$args275986_
      (apply make-struct-instance std/db/lmdb#lmdb-db::t _$args275986_)))
  (define std/db/lmdb#lmdb-db-env
    (make-struct-field-accessor std/db/lmdb#lmdb-db::t '0))
  (define std/db/lmdb#lmdb-db-dbi
    (make-struct-field-accessor std/db/lmdb#lmdb-db::t '1))
  (define std/db/lmdb#lmdb-db-name
    (make-struct-field-accessor std/db/lmdb#lmdb-db::t '2))
  (define std/db/lmdb#lmdb-db-env-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-db::t '0))
  (define std/db/lmdb#lmdb-db-dbi-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-db::t '1))
  (define std/db/lmdb#lmdb-db-name-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-db::t '2))
  (define std/db/lmdb#lmdb-txn::t
    (make-struct-type
     'std/db/lmdb#lmdb-txn::t
     '#f
     '3
     'lmdb-txn
     '((final: . #t))
     '#f
     '(env ptr val)))
  (define std/db/lmdb#lmdb-txn?
    (make-struct-predicate std/db/lmdb#lmdb-txn::t))
  (define std/db/lmdb#make-lmdb-txn
    (lambda _$args275983_
      (apply make-struct-instance std/db/lmdb#lmdb-txn::t _$args275983_)))
  (define std/db/lmdb#lmdb-txn-env
    (make-struct-field-accessor std/db/lmdb#lmdb-txn::t '0))
  (define std/db/lmdb#lmdb-txn-ptr
    (make-struct-field-accessor std/db/lmdb#lmdb-txn::t '1))
  (define std/db/lmdb#lmdb-txn-val
    (make-struct-field-accessor std/db/lmdb#lmdb-txn::t '2))
  (define std/db/lmdb#lmdb-txn-env-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-txn::t '0))
  (define std/db/lmdb#lmdb-txn-ptr-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-txn::t '1))
  (define std/db/lmdb#lmdb-txn-val-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-txn::t '2))
  (define std/db/lmdb#lmdb-cursor::t
    (make-struct-type
     'std/db/lmdb#lmdb-cursor::t
     '#f
     '5
     'lmdb-cursor
     '((final: . #t))
     '#f
     '(txn db ptr val1 val2)))
  (define std/db/lmdb#lmdb-cursor?
    (make-struct-predicate std/db/lmdb#lmdb-cursor::t))
  (define std/db/lmdb#make-lmdb-cursor
    (lambda _$args275980_
      (apply make-struct-instance std/db/lmdb#lmdb-cursor::t _$args275980_)))
  (define std/db/lmdb#lmdb-cursor-txn
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '0))
  (define std/db/lmdb#lmdb-cursor-db
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '1))
  (define std/db/lmdb#lmdb-cursor-ptr
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '2))
  (define std/db/lmdb#lmdb-cursor-val1
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '3))
  (define std/db/lmdb#lmdb-cursor-val2
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '4))
  (define std/db/lmdb#lmdb-cursor-txn-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '0))
  (define std/db/lmdb#lmdb-cursor-db-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '1))
  (define std/db/lmdb#lmdb-cursor-ptr-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '2))
  (define std/db/lmdb#lmdb-cursor-val1-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '3))
  (define std/db/lmdb#lmdb-cursor-val2-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '4))
  (define std/db/lmdb#lmdb-open__%
    (lambda (_g312700_
             _maxdbs275918275925_
             _mapsize275919275927_
             _maxreaders275920275929_
             _flags275921275931_
             _mode275922275933_
             _path275935_)
      (let* ((_maxdbs275937_
              (if (eq? _maxdbs275918275925_ absent-value)
                  '1
                  _maxdbs275918275925_))
             (_mapsize275939_
              (if (eq? _mapsize275919275927_ absent-value)
                  '#f
                  _mapsize275919275927_))
             (_maxreaders275941_
              (if (eq? _maxreaders275920275929_ absent-value)
                  '#f
                  _maxreaders275920275929_))
             (_flags275943_
              (if (eq? _flags275921275931_ absent-value)
                  '0
                  _flags275921275931_))
             (_mode275945_
              (if (eq? _mode275922275933_ absent-value)
                  '432
                  _mode275922275933_)))
        (create-directory* _path275935_)
        (let ((_env**275947_ (std/db/_lmdb#ffi_make_mdb_env_ptr_ptr)))
          (if _env**275947_
              '#!void
              (error '"lmdb-open: memory allocation failure"))
          (let ((_res275949_ (std/db/_lmdb#mdb_env_create _env**275947_)))
            (if (let () (declare (not safe)) (##fxzero? _res275949_))
                '#!void
                (std/db/lmdb#raise-lmdb-error 'mdb_env_create _res275949_)))
          (let ((_env*275952_ (std/db/_lmdb#ffi_mdb_env_ptr _env**275947_)))
            (if _maxdbs275937_
                (let ((_res275954_
                       (std/db/_lmdb#mdb_env_set_maxdbs
                        _env*275952_
                        _maxdbs275937_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275954_))
                      '#!void
                      (begin
                        (std/db/_lmdb#mdb_env_close _env*275952_)
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_set_maxdbs
                         _res275954_))))
                '#!void)
            (if _mapsize275939_
                (let ((_res275957_
                       (std/db/_lmdb#mdb_env_set_mapsize
                        _env*275952_
                        _mapsize275939_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275957_))
                      '#!void
                      (begin
                        (std/db/_lmdb#mdb_env_close _env*275952_)
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_set_mapsize
                         _res275957_))))
                '#!void)
            (if _maxreaders275941_
                (let ((_res275960_
                       (std/db/_lmdb#mdb_env_set_maxreaders
                        _env*275952_
                        _maxreaders275941_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275960_))
                      '#!void
                      (begin
                        (std/db/_lmdb#mdb_env_close _env*275952_)
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_set_maxreaders
                         _res275960_))))
                '#!void)
            (let ((_res275963_
                   (std/db/_lmdb#mdb_env_open
                    _env*275952_
                    _path275935_
                    _flags275943_
                    _mode275945_)))
              (if (let () (declare (not safe)) (##fxzero? _res275963_))
                  '#!void
                  (begin
                    (std/db/_lmdb#mdb_env_close _env*275952_)
                    (std/db/lmdb#raise-lmdb-error 'mdb_env_open _res275963_))))
            (let ((__tmp312702 (make-table)) (__tmp312701 (make-mutex)))
              (declare (not safe))
              (##structure
               std/db/lmdb#lmdb-env::t
               _env*275952_
               __tmp312702
               __tmp312701)))))))
  (define std/db/lmdb#lmdb-open__@
    (lambda (_keys275917275969_ . _args275971_)
      (apply std/db/lmdb#lmdb-open__%
             _keys275917275969_
             (table-ref _keys275917275969_ 'max-dbs: absent-value)
             (table-ref _keys275917275969_ 'mapsize: absent-value)
             (table-ref _keys275917275969_ 'max-readers: absent-value)
             (table-ref _keys275917275969_ 'flags: absent-value)
             (table-ref _keys275917275969_ 'mode: absent-value)
             _args275971_)))
  (define std/db/lmdb#lmdb-open
    (lambda _args275923275977_
      (apply keyword-dispatch
             '#(mapsize: #f flags: #f mode: max-dbs: max-readers: #f #f #f)
             std/db/lmdb#lmdb-open__@
             _args275923275977_)))
  (define std/db/lmdb#lmdb-sync__%
    (lambda (_env275878_ _force?275879_)
      (let* ((_env275880275886_ _env275878_)
             (_E275882275890_
              (lambda () (error '"No clause matching" _env275880275886_)))
             (_K275883275898_
              (lambda (_env*275893_)
                (if _env*275893_ '#!void (error '"lmdb-open-db: invalid env"))
                (let ((_res275895_
                       (std/db/_lmdb#mdb_env_sync
                        _env*275893_
                        (if _force?275879_ '1 '0))))
                  (if (let () (declare (not safe)) (##fxzero? _res275895_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_env_sync
                       _res275895_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275880275886_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275884275901_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275880275886_ '1)))
                   (_env*275904_ _e275884275901_))
              (_K275883275898_ _env*275904_))
            (_E275882275890_)))))
  (define std/db/lmdb#lmdb-sync__0
    (lambda (_env275909_)
      (let ((_force?275911_ '#f))
        (std/db/lmdb#lmdb-sync__% _env275909_ _force?275911_))))
  (define std/db/lmdb#lmdb-sync
    (lambda _g312704_
      (let ((_g312703_ (let () (declare (not safe)) (##length _g312704_))))
        (cond ((let () (declare (not safe)) (##fx= _g312703_ 1))
               (apply std/db/lmdb#lmdb-sync__0 _g312704_))
              ((let () (declare (not safe)) (##fx= _g312703_ 2))
               (apply std/db/lmdb#lmdb-sync__% _g312704_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-sync
                _g312704_))))))
  (define std/db/lmdb#lmdb-close
    (lambda (_env275853_)
      (let* ((_env275854275860_ _env275853_)
             (_E275856275864_
              (lambda () (error '"No clause matching" _env275854275860_)))
             (_K275857275869_
              (lambda (_env*275867_)
                (if _env*275867_
                    '#!void
                    (begin
                      (std/db/_lmdb#mdb_env_close _env*275867_)
                      (##direct-structure-set!
                       _env275853_
                       '#f
                       '1
                       std/db/lmdb#lmdb-env::t
                       '#f))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275854275860_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275858275872_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275854275860_ '1)))
                   (_env*275875_ _e275858275872_))
              (_K275857275869_ _env*275875_))
            (_E275856275864_)))))
  (define std/db/lmdb#lmdb-env::destroy std/db/lmdb#lmdb-close)
  (bind-method!
   std/db/lmdb#lmdb-env::t
   'destroy
   std/db/lmdb#lmdb-env::destroy
   '#f)
  (define std/db/lmdb#lmdb-stat
    (lambda (_env275701_)
      (let* ((_env275702275708_ _env275701_)
             (_E275704275712_
              (lambda () (error '"No clause matching" _env275702275708_)))
             (_K275705275723_
              (lambda (_env*275715_)
                (if _env*275715_ '#!void (error '"lmdb-open-db: invalid env"))
                (let ((_stat*275717_ (std/db/_lmdb#ffi_make_mdb_stat_ptr)))
                  (if _stat*275717_
                      '#!void
                      (error '"lmdb-stat: memory allocation failure"))
                  (let ((_res275720_
                         (std/db/_lmdb#mdb_env_stat
                          _env*275715_
                          _stat*275717_)))
                    (if (let () (declare (not safe)) (##fxzero? _res275720_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_stat
                         _res275720_)))
                  (cons 'psize:
                        (cons (std/db/_lmdb#ffi_mdb_stat_psize)
                              (cons 'depth:
                                    (cons (std/db/_lmdb#ffi_mdb_stat_depth)
                                          (cons 'branch-pages:
                                                (cons (std/db/_lmdb#ffi_mdb_stat_branch_pages)
                                                      (cons 'leaf-pages:
                                                            (cons (std/db/_lmdb#ffi_mdb_stat_leaf_pages)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (cons 'overflow-pages:
                                (cons (std/db/_lmdb#ffi_mdb_stat_overflow_pages)
                                      (cons 'entries:
                                            (cons (std/db/_lmdb#ffi_mdb_stat_entries)
                                                  '()))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275702275708_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275706275726_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275702275708_ '1)))
                   (_env*275729_ _e275706275726_))
              (_K275705275723_ _env*275729_))
            (_E275704275712_)))))
  (define std/db/lmdb#lmdb-open-db__%
    (lambda (_env275626_ _name275627_ _flags275628_)
      (let* ((_env275629275637_ _env275626_)
             (_E275631275641_
              (lambda () (error '"No clause matching" _env275629275637_)))
             (_K275632275671_
              (lambda (_mx275644_ _dbs275645_ _env*275646_)
                (if _env*275646_ '#!void (error '"lmdb-open-db: invalid env"))
                (gerbil/gambit/threads#with-lock
                 _mx275644_
                 (lambda ()
                   (let ((_$e275649_ (table-ref _dbs275645_ _name275627_ '#f)))
                     (if _$e275649_
                         (values _$e275649_)
                         (let ((_txn**275652_
                                (std/db/_lmdb#ffi_make_mdb_txn_ptr_ptr))
                               (_dbi*275653_
                                (std/db/_lmdb#ffi_make_mdb_dbi_ptr)))
                           (if (and _txn**275652_ _dbi*275653_)
                               '#!void
                               (error '"lmdb-open-db: memory allocation failure"))
                           (let ((_res275655_
                                  (std/db/_lmdb#mdb_txn_begin
                                   _env*275646_
                                   '#f
                                   '0
                                   _txn**275652_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##fxzero? _res275655_))
                                 '#!void
                                 (std/db/lmdb#raise-lmdb-error
                                  'mdb_txn_begin
                                  _res275655_)))
                           (let ((_txn*275658_
                                  (std/db/_lmdb#ffi_mdb_txn_ptr
                                   _txn**275652_)))
                             (let ((_res275660_
                                    (std/db/_lmdb#mdb_dbi_open
                                     _txn*275658_
                                     _name275627_
                                     _flags275628_
                                     _dbi*275653_)))
                               (if (let ()
                                     (declare (not safe))
                                     (##fxzero? _res275660_))
                                   '#!void
                                   (begin
                                     (std/db/_lmdb#mdb_txn_abort _txn*275658_)
                                     (std/db/lmdb#raise-lmdb-error
                                      'mdb_dbi_open
                                      _res275660_))))
                             (let ((_res275663_
                                    (std/db/_lmdb#mdb_txn_commit
                                     _txn*275658_)))
                               (if (let ()
                                     (declare (not safe))
                                     (##fxzero? _res275663_))
                                   '#!void
                                   (std/db/lmdb#raise-lmdb-error
                                    'mdb_txn_commit
                                    _res275663_))))
                           (let* ((_dbi275666_
                                   (std/db/_lmdb#ffi_mdb_dbi_ptr_value
                                    _dbi*275653_))
                                  (_db275668_
                                   (let ()
                                     (declare (not safe))
                                     (##structure
                                      std/db/lmdb#lmdb-db::t
                                      _env275626_
                                      _dbi275666_
                                      _name275627_))))
                             (table-set! _dbs275645_ _name275627_ _db275668_)
                             _db275668_)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275629275637_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275633275674_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275629275637_ '1)))
                   (_env*275677_ _e275633275674_)
                   (_e275634275679_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275629275637_ '2)))
                   (_dbs275682_ _e275634275679_)
                   (_e275635275684_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275629275637_ '3)))
                   (_mx275687_ _e275635275684_))
              (_K275632275671_ _mx275687_ _dbs275682_ _env*275677_))
            (_E275631275641_)))))
  (define std/db/lmdb#lmdb-open-db__0
    (lambda (_env275692_ _name275693_)
      (let ((_flags275695_ std/db/_lmdb#MDB_CREATE))
        (std/db/lmdb#lmdb-open-db__% _env275692_ _name275693_ _flags275695_))))
  (define std/db/lmdb#lmdb-open-db
    (lambda _g312706_
      (let ((_g312705_ (let () (declare (not safe)) (##length _g312706_))))
        (cond ((let () (declare (not safe)) (##fx= _g312705_ 2))
               (apply std/db/lmdb#lmdb-open-db__0 _g312706_))
              ((let () (declare (not safe)) (##fx= _g312705_ 3))
               (apply std/db/lmdb#lmdb-open-db__% _g312706_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-open-db
                _g312706_))))))
  (define std/db/lmdb#lmdb-close-db
    (lambda (_db275550_)
      (let* ((_db275551275559_ _db275550_)
             (_E275553275563_
              (lambda () (error '"No clause matching" _db275551275559_)))
             (_K275554275607_
              (lambda (_name275566_ _dbi275567_ _env275568_)
                (if _dbi275567_
                    (let* ((_env275569275577_ _env275568_)
                           (_E275571275581_
                            (lambda ()
                              (error '"No clause matching" _env275569275577_)))
                           (_K275572275589_
                            (lambda (_mx275584_ _dbs275585_ _env*275586_)
                              (gerbil/gambit/threads#with-lock
                               _mx275584_
                               (lambda ()
                                 (std/db/_lmdb#mdb_dbi_close
                                  _env*275586_
                                  _dbi275567_)
                                 (##direct-structure-set!
                                  _db275550_
                                  '#f
                                  '2
                                  std/db/lmdb#lmdb-db::t
                                  '#f)
                                 (table-set! _dbs275585_ _name275566_))))))
                      (if (let ()
                            (declare (not safe))
                            (##structure-direct-instance-of?
                             _env275569275577_
                             'std/db/lmdb#lmdb-env::t))
                          (let* ((_e275573275592_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _env275569275577_ '1)))
                                 (_env*275595_ _e275573275592_)
                                 (_e275574275597_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _env275569275577_ '2)))
                                 (_dbs275600_ _e275574275597_)
                                 (_e275575275602_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _env275569275577_ '3)))
                                 (_mx275605_ _e275575275602_))
                            (_K275572275589_
                             _mx275605_
                             _dbs275600_
                             _env*275595_))
                          (_E275571275581_)))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _db275551275559_
               'std/db/lmdb#lmdb-db::t))
            (let* ((_e275555275610_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _db275551275559_ '1)))
                   (_env275613_ _e275555275610_)
                   (_e275556275615_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _db275551275559_ '2)))
                   (_dbi275618_ _e275556275615_)
                   (_e275557275620_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _db275551275559_ '3)))
                   (_name275623_ _e275557275620_))
              (_K275554275607_ _name275623_ _dbi275618_ _env275613_))
            (_E275553275563_)))))
  (define std/db/lmdb#lmdb-db::destroy std/db/lmdb#lmdb-close-db)
  (bind-method!
   std/db/lmdb#lmdb-db::t
   'destroy
   std/db/lmdb#lmdb-db::destroy
   '#f)
  (define std/db/lmdb#lmdb-txn-begin__%
    (lambda (_env275349_ _parent275350_ _flags275351_)
      (let* ((_env275352275358_ _env275349_)
             (_E275354275362_
              (lambda () (error '"No clause matching" _env275352275358_)))
             (_K275355275402_
              (lambda (_env*275365_)
                (if _env*275365_ '#!void (error '"lmdb-open-db: invalid env"))
                (let ((_txn**275393_ (std/db/_lmdb#ffi_make_mdb_txn_ptr_ptr))
                      (_partxn*275394_
                       (if _parent275350_
                           (let* ((_parent275366275373_ _parent275350_)
                                  (_E275368275377_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _parent275366275373_)))
                                  (_K275369275382_
                                   (lambda (_txn*275380_) _txn*275380_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##structure-direct-instance-of?
                                    _parent275366275373_
                                    'std/db/lmdb#lmdb-txn::t))
                                 (let* ((_e275370275385_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref
                                            _parent275366275373_
                                            '1)))
                                        (_e275371275388_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref
                                            _parent275366275373_
                                            '2)))
                                        (_txn*275391_ _e275371275388_))
                                   (_K275369275382_ _txn*275391_))
                                 (_E275368275377_)))
                           '#f)))
                  (if _txn**275393_
                      '#!void
                      (error '"lmdb-txn-begin: memory allocation failure"))
                  (let ((_res275396_
                         (std/db/_lmdb#mdb_txn_begin
                          _env*275365_
                          _parent275350_
                          _flags275351_
                          _txn**275393_)))
                    (if (let () (declare (not safe)) (##fxzero? _res275396_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_txn_begin
                         _res275396_)))
                  (let ((_txn*275399_
                         (std/db/_lmdb#ffi_mdb_txn_ptr _txn**275393_))
                        (_val*275400_ (std/db/_lmdb#ffi_make_mdb_val_ptr)))
                    (if (and _txn*275399_ _val*275400_)
                        '#!void
                        (error '"lmdb-stat: memory allocation failure"))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/db/lmdb#lmdb-txn::t
                       _env275349_
                       _txn*275399_
                       _val*275400_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275352275358_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275356275405_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275352275358_ '1)))
                   (_env*275408_ _e275356275405_))
              (_K275355275402_ _env*275408_))
            (_E275354275362_)))))
  (define std/db/lmdb#lmdb-txn-begin__0
    (lambda (_env275413_)
      (let* ((_parent275415_ '#f) (_flags275417_ '0))
        (std/db/lmdb#lmdb-txn-begin__%
         _env275413_
         _parent275415_
         _flags275417_))))
  (define std/db/lmdb#lmdb-txn-begin__1
    (lambda (_env275419_ _parent275420_)
      (let ((_flags275422_ '0))
        (std/db/lmdb#lmdb-txn-begin__%
         _env275419_
         _parent275420_
         _flags275422_))))
  (define std/db/lmdb#lmdb-txn-begin
    (lambda _g312708_
      (let ((_g312707_ (let () (declare (not safe)) (##length _g312708_))))
        (cond ((let () (declare (not safe)) (##fx= _g312707_ 1))
               (apply std/db/lmdb#lmdb-txn-begin__0 _g312708_))
              ((let () (declare (not safe)) (##fx= _g312707_ 2))
               (apply std/db/lmdb#lmdb-txn-begin__1 _g312708_))
              ((let () (declare (not safe)) (##fx= _g312707_ 3))
               (apply std/db/lmdb#lmdb-txn-begin__% _g312708_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-txn-begin
                _g312708_))))))
  (define std/db/lmdb#lmdb-txn-id
    (lambda (_txn275320_)
      (let* ((_txn275321275328_ _txn275320_)
             (_E275323275332_
              (lambda () (error '"No clause matching" _txn275321275328_)))
             (_K275324275337_
              (lambda (_txn*275335_) (std/db/_lmdb#mdb_txn_id _txn*275335_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275321275328_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275325275340_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275321275328_ '1)))
                   (_e275326275343_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275321275328_ '2)))
                   (_txn*275346_ _e275326275343_))
              (std/db/_lmdb#mdb_txn_id _txn*275346_))
            (_E275323275332_)))))
  (define std/db/lmdb#lmdb-txn-commit
    (lambda (_txn275289_)
      (let* ((_txn275290275297_ _txn275289_)
             (_E275292275301_
              (lambda () (error '"No clause matching" _txn275290275297_)))
             (_K275293275309_
              (lambda (_txn*275304_)
                (let ((_res275306_ (std/db/_lmdb#mdb_txn_commit _txn*275304_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275306_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_txn_commit
                       _res275306_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275290275297_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275294275312_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275290275297_ '1)))
                   (_e275295275315_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275290275297_ '2)))
                   (_txn*275318_ _e275295275315_))
              (_K275293275309_ _txn*275318_))
            (_E275292275301_)))))
  (define std/db/lmdb#lmdb-txn-abort
    (lambda (_txn275261_)
      (let* ((_txn275262275269_ _txn275261_)
             (_E275264275273_
              (lambda () (error '"No clause matching" _txn275262275269_)))
             (_K275265275278_
              (lambda (_txn*275276_)
                (std/db/_lmdb#mdb_txn_abort _txn*275276_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275262275269_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275266275281_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275262275269_ '1)))
                   (_e275267275284_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275262275269_ '2)))
                   (_txn*275287_ _e275267275284_))
              (std/db/_lmdb#mdb_txn_abort _txn*275287_))
            (_E275264275273_)))))
  (define std/db/lmdb#lmdb-txn-reset
    (lambda (_txn275233_)
      (let* ((_txn275234275241_ _txn275233_)
             (_E275236275245_
              (lambda () (error '"No clause matching" _txn275234275241_)))
             (_K275237275250_
              (lambda (_txn*275248_)
                (std/db/_lmdb#mdb_txn_reset _txn*275248_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275234275241_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275238275253_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275234275241_ '1)))
                   (_e275239275256_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275234275241_ '2)))
                   (_txn*275259_ _e275239275256_))
              (std/db/_lmdb#mdb_txn_reset _txn*275259_))
            (_E275236275245_)))))
  (define std/db/lmdb#lmdb-txn-renew
    (lambda (_txn275202_)
      (let* ((_txn275203275210_ _txn275202_)
             (_E275205275214_
              (lambda () (error '"No clause matching" _txn275203275210_)))
             (_K275206275222_
              (lambda (_txn*275217_)
                (let ((_res275219_ (std/db/_lmdb#mdb_txn_renew _txn*275217_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275219_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_txn_renew
                       _res275219_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275203275210_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275207275225_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275203275210_ '1)))
                   (_e275208275228_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275203275210_ '2)))
                   (_txn*275231_ _e275208275228_))
              (_K275206275222_ _txn*275231_))
            (_E275205275214_)))))
  (define std/db/lmdb#lmdb-db-stat
    (lambda (_txn275153_ _db275154_)
      (let ((_txn275155275165_ _txn275153_) (_db275156275167_ _db275154_))
        (let* ((_E275158275171_
                (lambda ()
                  (error '"No clause matching"
                         _txn275155275165_
                         _db275156275167_)))
               (_K275159275183_
                (lambda (_txn*275174_ _dbi275175_)
                  (let ((_stat*275177_ (std/db/_lmdb#ffi_make_mdb_stat_ptr)))
                    (if _stat*275177_
                        '#!void
                        (error '"lmdb-stat: memory allocation failure"))
                    (let ((_res275180_
                           (_txn*275174_ _dbi275175_ _stat*275177_)))
                      (if (let () (declare (not safe)) (##fxzero? _res275180_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error 'txn* _res275180_)))
                    (cons 'psize:
                          (cons (std/db/_lmdb#ffi_mdb_stat_psize)
                                (cons 'depth:
                                      (cons (std/db/_lmdb#ffi_mdb_stat_depth)
                                            (cons 'branch-pages:
                                                  (cons (std/db/_lmdb#ffi_mdb_stat_branch_pages)
                                                        (cons 'leaf-pages:
                                                              (cons (std/db/_lmdb#ffi_mdb_stat_leaf_pages)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (cons 'overflow-pages:
                                  (cons (std/db/_lmdb#ffi_mdb_stat_overflow_pages)
                                        (cons 'entries:
                                              (cons (std/db/_lmdb#ffi_mdb_stat_entries)
                                                    '()))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _txn275155275165_
                 'std/db/lmdb#lmdb-txn::t))
              (let* ((_e275162275186_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275155275165_ '1)))
                     (_e275163275189_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275155275165_ '2)))
                     (_txn*275192_ _e275163275189_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _db275156275167_
                       'std/db/lmdb#lmdb-db::t))
                    (let* ((_e275160275194_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275156275167_ '1)))
                           (_e275161275197_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275156275167_ '2)))
                           (_dbi275200_ _e275161275197_))
                      (_K275159275183_ _txn*275192_ _dbi275200_))
                    (_E275158275171_)))
              (_E275158275171_))))))
  (define std/db/lmdb#lmdb-db-drop__%
    (lambda (_txn275094_ _db275095_ _del?275096_)
      (let ((_txn275097275107_ _txn275094_) (_db275098275109_ _db275095_))
        (let* ((_E275100275113_
                (lambda ()
                  (error '"No clause matching"
                         _txn275097275107_
                         _db275098275109_)))
               (_K275101275122_
                (lambda (_txn*275116_ _dbi275117_)
                  (let ((_res275119_
                         (std/db/_lmdb#mdb_drop
                          _txn*275116_
                          _dbi275117_
                          (if _del?275096_ '1 '0))))
                    (if (let () (declare (not safe)) (##fxzero? _res275119_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_drop
                         _res275119_))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _txn275097275107_
                 'std/db/lmdb#lmdb-txn::t))
              (let* ((_e275104275125_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275097275107_ '1)))
                     (_e275105275128_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275097275107_ '2)))
                     (_txn*275131_ _e275105275128_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _db275098275109_
                       'std/db/lmdb#lmdb-db::t))
                    (let* ((_e275102275133_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275098275109_ '1)))
                           (_e275103275136_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275098275109_ '2)))
                           (_dbi275139_ _e275103275136_))
                      (_K275101275122_ _txn*275131_ _dbi275139_))
                    (_E275100275113_)))
              (_E275100275113_))))))
  (define std/db/lmdb#lmdb-db-drop__0
    (lambda (_txn275144_ _db275145_)
      (let ((_del?275147_ '#f))
        (std/db/lmdb#lmdb-db-drop__% _txn275144_ _db275145_ _del?275147_))))
  (define std/db/lmdb#lmdb-db-drop
    (lambda _g312710_
      (let ((_g312709_ (let () (declare (not safe)) (##length _g312710_))))
        (cond ((let () (declare (not safe)) (##fx= _g312709_ 2))
               (apply std/db/lmdb#lmdb-db-drop__0 _g312710_))
              ((let () (declare (not safe)) (##fx= _g312709_ 3))
               (apply std/db/lmdb#lmdb-db-drop__% _g312710_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-db-drop
                _g312710_))))))
  (define std/db/lmdb#value-bytes
    (lambda (_key275091_)
      (if (u8vector? _key275091_)
          _key275091_
          (if (string? _key275091_)
              (std/text/utf8#string->utf8__0 _key275091_)
              (error '"Bad argument: expected u8vector or string"
                     _key275091_)))))
  (define std/db/lmdb#value-data
    (lambda (_val*275084_)
      (let* ((_size275086_ (std/db/_lmdb#ffi_mdb_val_size _val*275084_))
             (_bytes275088_ (make-u8vector _size275086_)))
        (std/db/_lmdb#ffi_mdb_val_data _val*275084_ _bytes275088_)
        _bytes275088_)))
  (define std/db/lmdb#value-data*
    (lambda (_val*275078_)
      (let ((_size275080_ (std/db/_lmdb#ffi_mdb_val_size _val*275078_)))
        (if _size275080_
            (let ((_bytes275082_ (make-u8vector _size275080_)))
              (std/db/_lmdb#ffi_mdb_val_data _val*275078_ _bytes275082_)
              _bytes275082_)
            '#f))))
  (define std/db/lmdb#lmdb-get
    (lambda (_txn275023_ _db275024_ _key275025_)
      (let ((_keyb275027_ (std/db/lmdb#value-bytes _key275025_)))
        (let ((_txn275028275039_ _txn275023_) (_db275029275041_ _db275024_))
          (let* ((_E275031275045_
                  (lambda ()
                    (error '"No clause matching"
                           _txn275028275039_
                           _db275029275041_)))
                 (_K275032275054_
                  (lambda (_val*275048_ _txn*275049_ _dbi275050_)
                    (let ((_res275052_
                           (std/db/_lmdb#mdb_get
                            _txn*275049_
                            _dbi275050_
                            _keyb275027_
                            _val*275048_)))
                      (if (let () (declare (not safe)) (##fxzero? _res275052_))
                          (std/db/lmdb#value-data _val*275048_)
                          (if (eq? _res275052_ std/db/_lmdb#MDB_NOTFOUND)
                              '#f
                              (std/db/lmdb#raise-lmdb-error
                               'mdb_get
                               _res275052_)))))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _txn275028275039_
                   'std/db/lmdb#lmdb-txn::t))
                (let* ((_e275035275057_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn275028275039_ '1)))
                       (_e275036275060_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn275028275039_ '2)))
                       (_txn*275063_ _e275036275060_)
                       (_e275037275065_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn275028275039_ '3)))
                       (_val*275068_ _e275037275065_))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _db275029275041_
                         'std/db/lmdb#lmdb-db::t))
                      (let* ((_e275033275070_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db275029275041_ '1)))
                             (_e275034275073_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db275029275041_ '2)))
                             (_dbi275076_ _e275034275073_))
                        (_K275032275054_
                         _val*275068_
                         _txn*275063_
                         _dbi275076_))
                      (_E275031275045_)))
                (_E275031275045_)))))))
  (define std/db/lmdb#lmdb-put__%
    (lambda (_txn274955_ _db274956_ _key274957_ _val274958_ _flags274959_)
      (let ((_keyx274961_ (std/db/lmdb#value-bytes _key274957_))
            (_valx274962_ (std/db/lmdb#value-bytes _val274958_)))
        (let ((_txn274963274973_ _txn274955_) (_db274964274975_ _db274956_))
          (let* ((_E274966274979_
                  (lambda ()
                    (error '"No clause matching"
                           _txn274963274973_
                           _db274964274975_)))
                 (_K274967274988_
                  (lambda (_txn*274982_ _dbi274983_)
                    (let ((_res274985_
                           (std/db/_lmdb#mdb_put
                            _txn*274982_
                            _dbi274983_
                            _keyx274961_
                            _valx274962_
                            _flags274959_)))
                      (if (let () (declare (not safe)) (##fxzero? _res274985_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error
                           'mdb_put
                           _res274985_))))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _txn274963274973_
                   'std/db/lmdb#lmdb-txn::t))
                (let* ((_e274970274991_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274963274973_ '1)))
                       (_e274971274994_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274963274973_ '2)))
                       (_txn*274997_ _e274971274994_))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _db274964274975_
                         'std/db/lmdb#lmdb-db::t))
                      (let* ((_e274968274999_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274964274975_ '1)))
                             (_e274969275002_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274964274975_ '2)))
                             (_dbi275005_ _e274969275002_))
                        (_K274967274988_ _txn*274997_ _dbi275005_))
                      (_E274966274979_)))
                (_E274966274979_)))))))
  (define std/db/lmdb#lmdb-put__0
    (lambda (_txn275010_ _db275011_ _key275012_ _val275013_)
      (let ((_flags275015_ '0))
        (std/db/lmdb#lmdb-put__%
         _txn275010_
         _db275011_
         _key275012_
         _val275013_
         _flags275015_))))
  (define std/db/lmdb#lmdb-put
    (lambda _g312712_
      (let ((_g312711_ (let () (declare (not safe)) (##length _g312712_))))
        (cond ((let () (declare (not safe)) (##fx= _g312711_ 4))
               (apply std/db/lmdb#lmdb-put__0 _g312712_))
              ((let () (declare (not safe)) (##fx= _g312711_ 5))
               (apply std/db/lmdb#lmdb-put__% _g312712_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-put
                _g312712_))))))
  (define std/db/lmdb#lmdb-del__%
    (lambda (_txn274889_ _db274890_ _key274891_ _val274892_)
      (let ((_keyx274894_ (std/db/lmdb#value-bytes _key274891_))
            (_valx274895_
             (if _val274892_ (std/db/lmdb#value-bytes _val274892_) '#f)))
        (let ((_txn274896274906_ _txn274889_) (_db274897274908_ _db274890_))
          (let* ((_E274899274912_
                  (lambda ()
                    (error '"No clause matching"
                           _txn274896274906_
                           _db274897274908_)))
                 (_K274900274921_
                  (lambda (_txn*274915_ _dbi274916_)
                    (let ((_res274918_
                           (std/db/_lmdb#mdb_del
                            _txn*274915_
                            _dbi274916_
                            _keyx274894_
                            _valx274895_)))
                      (if (let () (declare (not safe)) (##fxzero? _res274918_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error
                           'mdb_del
                           _res274918_))))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _txn274896274906_
                   'std/db/lmdb#lmdb-txn::t))
                (let* ((_e274903274924_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274896274906_ '1)))
                       (_e274904274927_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274896274906_ '2)))
                       (_txn*274930_ _e274904274927_))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _db274897274908_
                         'std/db/lmdb#lmdb-db::t))
                      (let* ((_e274901274932_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274897274908_ '1)))
                             (_e274902274935_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274897274908_ '2)))
                             (_dbi274938_ _e274902274935_))
                        (_K274900274921_ _txn*274930_ _dbi274938_))
                      (_E274899274912_)))
                (_E274899274912_)))))))
  (define std/db/lmdb#lmdb-del__0
    (lambda (_txn274943_ _db274944_ _key274945_)
      (let ((_val274947_ '#f))
        (std/db/lmdb#lmdb-del__%
         _txn274943_
         _db274944_
         _key274945_
         _val274947_))))
  (define std/db/lmdb#lmdb-del
    (lambda _g312714_
      (let ((_g312713_ (let () (declare (not safe)) (##length _g312714_))))
        (cond ((let () (declare (not safe)) (##fx= _g312713_ 3))
               (apply std/db/lmdb#lmdb-del__0 _g312714_))
              ((let () (declare (not safe)) (##fx= _g312713_ 4))
               (apply std/db/lmdb#lmdb-del__% _g312714_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-del
                _g312714_))))))
  (define std/db/lmdb#lmdb-cursor-open
    (lambda (_txn274829_ _db274830_)
      (let ((_txn274831274842_ _txn274829_) (_db274832274844_ _db274830_))
        (let* ((_E274834274848_
                (lambda ()
                  (error '"No clause matching"
                         _txn274831274842_
                         _db274832274844_)))
               (_K274835274864_
                (lambda (_val*274851_ _txn*274852_ _dbi274853_)
                  (let ((_cursor**274855_
                         (std/db/_lmdb#ffi_make_mdb_cursor_ptr_ptr)))
                    (if _cursor**274855_
                        '#!void
                        (error '"lmdb-cursor-open: memory allocation failure"))
                    (let ((_res274857_
                           (std/db/_lmdb#mdb_cursor_open
                            _txn*274852_
                            _dbi274853_
                            _cursor**274855_)))
                      (if (let () (declare (not safe)) (##fxzero? _res274857_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error
                           'mdb_cursor_open
                           _res274857_)))
                    (let ((_val1*274860_ (std/db/_lmdb#ffi_make_mdb_val_ptr))
                          (_val2*274861_ (std/db/_lmdb#ffi_make_mdb_val_ptr))
                          (_cursor*274862_
                           (std/db/_lmdb#ffi_mdb_cursor_ptr _cursor**274855_)))
                      (if (and _val1*274860_ _val2*274861_)
                          '#!void
                          (error '"lmdb-cursor-open: memory allocation failure"))
                      (let ()
                        (declare (not safe))
                        (##structure
                         std/db/lmdb#lmdb-cursor::t
                         _txn274829_
                         _db274830_
                         _cursor*274862_
                         _val1*274860_
                         _val2*274861_)))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _txn274831274842_
                 'std/db/lmdb#lmdb-txn::t))
              (let* ((_e274838274867_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn274831274842_ '1)))
                     (_e274839274870_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn274831274842_ '2)))
                     (_txn*274873_ _e274839274870_)
                     (_e274840274875_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn274831274842_ '3)))
                     (_val*274878_ _e274840274875_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _db274832274844_
                       'std/db/lmdb#lmdb-db::t))
                    (let* ((_e274836274880_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db274832274844_ '1)))
                           (_e274837274883_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db274832274844_ '2)))
                           (_dbi274886_ _e274837274883_))
                      (_K274835274864_ _val*274878_ _txn*274873_ _dbi274886_))
                    (_E274834274848_)))
              (_E274834274848_))))))
  (define std/db/lmdb#lmdb-cursor-close
    (lambda (_cursor274797_)
      (let* ((_cursor274798274806_ _cursor274797_)
             (_E274800274810_
              (lambda () (error '"No clause matching" _cursor274798274806_)))
             (_K274801274815_
              (lambda (_cursor*274813_)
                (if _cursor*274813_
                    (begin
                      (std/db/_lmdb#mdb_cursor_close _cursor*274813_)
                      (##direct-structure-set!
                       _cursor274797_
                       '#f
                       '3
                       std/db/lmdb#lmdb-cursor::t
                       '#f)
                      (##direct-structure-set!
                       _cursor274797_
                       '#f
                       '4
                       std/db/lmdb#lmdb-cursor::t
                       '#f)
                      (##direct-structure-set!
                       _cursor274797_
                       '#f
                       '5
                       std/db/lmdb#lmdb-cursor::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cursor274798274806_
               'std/db/lmdb#lmdb-cursor::t))
            (let* ((_e274802274818_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274798274806_ '1)))
                   (_e274803274821_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274798274806_ '2)))
                   (_e274804274824_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274798274806_ '3)))
                   (_cursor*274827_ _e274804274824_))
              (_K274801274815_ _cursor*274827_))
            (_E274800274810_)))))
  (define std/db/lmdb#lmdb-cursor-renew
    (lambda (_cursor274747_ _txn274748_)
      (let ((_cursor274749274760_ _cursor274747_)
            (_txn274750274762_ _txn274748_))
        (let* ((_E274752274766_
                (lambda ()
                  (error '"No clause matching"
                         _cursor274749274760_
                         _txn274750274762_)))
               (_K274753274775_
                (lambda (_cursor*274769_ _txn*274770_)
                  (if _cursor*274769_
                      '#!void
                      (error '"lmdb-cursor-renew: invalid cursor"))
                  (let ((_res274772_
                         (std/db/_lmdb#mdb_cursor_renew
                          _txn*274770_
                          _cursor*274769_)))
                    (if (let () (declare (not safe)) (##fxzero? _res274772_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_cursor_renew
                         _res274772_)))
                  (##direct-structure-set!
                   _cursor274747_
                   _txn274748_
                   '1
                   std/db/lmdb#lmdb-cursor::t
                   '#f))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cursor274749274760_
                 'std/db/lmdb#lmdb-cursor::t))
              (let* ((_e274756274778_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274749274760_ '1)))
                     (_e274757274781_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274749274760_ '2)))
                     (_e274758274784_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274749274760_ '3)))
                     (_cursor*274787_ _e274758274784_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _txn274750274762_
                       'std/db/lmdb#lmdb-txn::t))
                    (let* ((_e274754274789_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _txn274750274762_ '1)))
                           (_e274755274792_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _txn274750274762_ '2)))
                           (_txn*274795_ _e274755274792_))
                      (_K274753274775_ _cursor*274787_ _txn*274795_))
                    (_E274752274766_)))
              (_E274752274766_))))))
  (define std/db/lmdb#lmdb-cursor-get__%
    (lambda (_cursor274672_ _op274673_ _key274674_ _val274675_)
      (let ((_keyx274677_
             (if _key274674_ (std/db/lmdb#value-bytes _key274674_) '#f))
            (_valx274678_
             (if _val274675_ (std/db/lmdb#value-bytes _val274675_) '#f)))
        (let* ((_cursor274679274689_ _cursor274672_)
               (_E274681274693_
                (lambda () (error '"No clause matching" _cursor274679274689_)))
               (_K274682274702_
                (lambda (_val2*274696_ _val1*274697_ _cursor*274698_)
                  (if _cursor*274698_
                      '#!void
                      (error '"lmdb-cursor-get: invalid cursor"))
                  (let ((_res274700_
                         (std/db/_lmdb#mdb_cursor_get
                          _cursor*274698_
                          _keyx274677_
                          _val1*274697_
                          _valx274678_
                          _val2*274696_
                          _op274673_)))
                    (if (let () (declare (not safe)) (##fxzero? _res274700_))
                        (values (std/db/lmdb#value-data* _val1*274697_)
                                (std/db/lmdb#value-data* _val2*274696_))
                        (if (eq? _res274700_ std/db/_lmdb#MDB_NOTFOUND)
                            '#f
                            (std/db/lmdb#raise-lmdb-error
                             'mdb_cursor_get
                             _res274700_)))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cursor274679274689_
                 'std/db/lmdb#lmdb-cursor::t))
              (let* ((_e274683274705_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274679274689_ '1)))
                     (_e274684274708_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274679274689_ '2)))
                     (_e274685274711_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274679274689_ '3)))
                     (_cursor*274714_ _e274685274711_)
                     (_e274686274716_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274679274689_ '4)))
                     (_val1*274719_ _e274686274716_)
                     (_e274687274721_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274679274689_ '5)))
                     (_val2*274724_ _e274687274721_))
                (_K274682274702_ _val2*274724_ _val1*274719_ _cursor*274714_))
              (_E274681274693_))))))
  (define std/db/lmdb#lmdb-cursor-get__0
    (lambda (_cursor274729_ _op274730_)
      (let* ((_key274732_ '#f) (_val274734_ '#f))
        (std/db/lmdb#lmdb-cursor-get__%
         _cursor274729_
         _op274730_
         _key274732_
         _val274734_))))
  (define std/db/lmdb#lmdb-cursor-get__1
    (lambda (_cursor274736_ _op274737_ _key274738_)
      (let ((_val274740_ '#f))
        (std/db/lmdb#lmdb-cursor-get__%
         _cursor274736_
         _op274737_
         _key274738_
         _val274740_))))
  (define std/db/lmdb#lmdb-cursor-get
    (lambda _g312716_
      (let ((_g312715_ (let () (declare (not safe)) (##length _g312716_))))
        (cond ((let () (declare (not safe)) (##fx= _g312715_ 2))
               (apply std/db/lmdb#lmdb-cursor-get__0 _g312716_))
              ((let () (declare (not safe)) (##fx= _g312715_ 3))
               (apply std/db/lmdb#lmdb-cursor-get__1 _g312716_))
              ((let () (declare (not safe)) (##fx= _g312715_ 4))
               (apply std/db/lmdb#lmdb-cursor-get__% _g312716_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-cursor-get
                _g312716_))))))
  (define std/db/lmdb#lmdb-cursor-put__%
    (lambda (_cursor274616_ _key274617_ _val274618_ _flags274619_)
      (let ((_keyx274621_ (std/db/lmdb#value-bytes _key274617_))
            (_valx274622_ (std/db/lmdb#value-bytes _val274618_)))
        (let* ((_cursor274623274631_ _cursor274616_)
               (_E274625274635_
                (lambda () (error '"No clause matching" _cursor274623274631_)))
               (_K274626274643_
                (lambda (_cursor*274638_)
                  (if _cursor*274638_
                      '#!void
                      (error '"lmdb-cursor-put: invalid cursor"))
                  (let ((_res274640_
                         (std/db/_lmdb#mdb_cursor_put
                          _cursor*274638_
                          _keyx274621_
                          _valx274622_
                          _flags274619_)))
                    (if (let () (declare (not safe)) (##fxzero? _res274640_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_cursor_put
                         _res274640_))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cursor274623274631_
                 'std/db/lmdb#lmdb-cursor::t))
              (let* ((_e274627274646_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274623274631_ '1)))
                     (_e274628274649_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274623274631_ '2)))
                     (_e274629274652_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274623274631_ '3)))
                     (_cursor*274655_ _e274629274652_))
                (_K274626274643_ _cursor*274655_))
              (_E274625274635_))))))
  (define std/db/lmdb#lmdb-cursor-put__0
    (lambda (_cursor274660_ _key274661_ _val274662_)
      (let ((_flags274664_ '0))
        (std/db/lmdb#lmdb-cursor-put__%
         _cursor274660_
         _key274661_
         _val274662_
         _flags274664_))))
  (define std/db/lmdb#lmdb-cursor-put
    (lambda _g312718_
      (let ((_g312717_ (let () (declare (not safe)) (##length _g312718_))))
        (cond ((let () (declare (not safe)) (##fx= _g312717_ 3))
               (apply std/db/lmdb#lmdb-cursor-put__0 _g312718_))
              ((let () (declare (not safe)) (##fx= _g312717_ 4))
               (apply std/db/lmdb#lmdb-cursor-put__% _g312718_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-cursor-put
                _g312718_))))))
  (define std/db/lmdb#lmdb-cursor-del__%
    (lambda (_cursor274569_ _flags274570_)
      (let* ((_cursor274571274579_ _cursor274569_)
             (_E274573274583_
              (lambda () (error '"No clause matching" _cursor274571274579_)))
             (_K274574274591_
              (lambda (_cursor*274586_)
                (if _cursor*274586_
                    '#!void
                    (error '"lmdb-cursor-del: invalid cursor"))
                (let ((_res274588_
                       (std/db/_lmdb#mdb_cursor_del
                        _cursor*274586_
                        _flags274570_)))
                  (if (let () (declare (not safe)) (##fxzero? _res274588_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_cursor_del
                       _res274588_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cursor274571274579_
               'std/db/lmdb#lmdb-cursor::t))
            (let* ((_e274575274594_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274571274579_ '1)))
                   (_e274576274597_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274571274579_ '2)))
                   (_e274577274600_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274571274579_ '3)))
                   (_cursor*274603_ _e274577274600_))
              (_K274574274591_ _cursor*274603_))
            (_E274573274583_)))))
  (define std/db/lmdb#lmdb-cursor-del__0
    (lambda (_cursor274608_)
      (let ((_flags274610_ '0))
        (std/db/lmdb#lmdb-cursor-del__% _cursor274608_ _flags274610_))))
  (define std/db/lmdb#lmdb-cursor-del
    (lambda _g312720_
      (let ((_g312719_ (let () (declare (not safe)) (##length _g312720_))))
        (cond ((let () (declare (not safe)) (##fx= _g312719_ 1))
               (apply std/db/lmdb#lmdb-cursor-del__0 _g312720_))
              ((let () (declare (not safe)) (##fx= _g312719_ 2))
               (apply std/db/lmdb#lmdb-cursor-del__% _g312720_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-cursor-del
                _g312720_))))))
  (define std/db/lmdb#lmdb-cursor-count
    (lambda (_cursor274534_)
      (let* ((_cursor274535274543_ _cursor274534_)
             (_E274537274547_
              (lambda () (error '"No clause matching" _cursor274535274543_)))
             (_K274538274554_
              (lambda (_cursor*274550_)
                (if _cursor*274550_
                    '#!void
                    (error '"lmdb-cursor-count: invalid cursor"))
                (let ((_size_t*274552_ (std/db/_lmdb#ffi_make_size_t_ptr)))
                  (if _size_t*274552_
                      '#!void
                      (error '"lmdb-cursor-open: memory allocation failure"))
                  (std/db/_lmdb#ffi_size_t_ptr_value _size_t*274552_)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cursor274535274543_
               'std/db/lmdb#lmdb-cursor::t))
            (let* ((_e274539274557_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274535274543_ '1)))
                   (_e274540274560_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274535274543_ '2)))
                   (_e274541274563_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274535274543_ '3)))
                   (_cursor*274566_ _e274541274563_))
              (_K274538274554_ _cursor*274566_))
            (_E274537274547_))))))
