(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/postgresql#postgresql-connection::t
    (make-struct-type
     'std/db/postgresql#postgresql-connection::t
     std/db/dbi#connection::t
     '4
     'postgresql-connection
     '((print: host port user db) (final: . #t))
     ':init!
     '(host port user db)))
  (define std/db/postgresql#postgresql-connection?
    (make-struct-predicate std/db/postgresql#postgresql-connection::t))
  (define std/db/postgresql#make-postgresql-connection
    (lambda _$args272308_
      (apply make-struct-instance
             std/db/postgresql#postgresql-connection::t
             _$args272308_)))
  (define std/db/postgresql#postgresql-connection-host
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '0))
  (define std/db/postgresql#postgresql-connection-port
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '1))
  (define std/db/postgresql#postgresql-connection-user
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '2))
  (define std/db/postgresql#postgresql-connection-db
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '3))
  (define std/db/postgresql#postgresql-connection-host-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '0))
  (define std/db/postgresql#postgresql-connection-port-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '1))
  (define std/db/postgresql#postgresql-connection-user-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '2))
  (define std/db/postgresql#postgresql-connection-db-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '3))
  (define std/db/postgresql#postgresql-connection:::init!
    (lambda (_self272301_
             _driver272302_
             _host272303_
             _port272304_
             _user272305_
             _db272306_)
      (if (let ((__tmp312577
                 (let () (declare (not safe)) (##vector-length _self272301_))))
            (declare (not safe))
            (##fx< '8 __tmp312577))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self272301_ '1 _driver272302_))
            (let () (declare (not safe)) (##vector-set! _self272301_ '2 '#f))
            (let () (declare (not safe)) (##vector-set! _self272301_ '3 '#f))
            (let () (declare (not safe)) (##vector-set! _self272301_ '4 '#f))
            (let ()
              (declare (not safe))
              (##vector-set! _self272301_ '5 _host272303_))
            (let ()
              (declare (not safe))
              (##vector-set! _self272301_ '6 _port272304_))
            (let ()
              (declare (not safe))
              (##vector-set! _self272301_ '7 _user272305_))
            (let ()
              (declare (not safe))
              (##vector-set! _self272301_ '8 _db272306_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self272301_))))
  (bind-method!
   std/db/postgresql#postgresql-connection::t
   ':init!
   std/db/postgresql#postgresql-connection:::init!
   '#f)
  (define std/db/postgresql#postgresql-connect__%
    (lambda (_g312578_
             _host272135272142_
             _port272136272144_
             _user272137272146_
             _passwd272138272148_
             _db272139272150_)
      (let* ((_host272153_
              (if (eq? _host272135272142_ absent-value)
                  '"127.0.0.1"
                  _host272135272142_))
             (_port272155_
              (if (eq? _port272136272144_ absent-value)
                  '5432
                  _port272136272144_))
             (_user272157_
              (if (eq? _user272137272146_ absent-value)
                  (error '"Missing required keyword argument" 'user:)
                  _user272137272146_))
             (_passwd272159_
              (if (eq? _passwd272138272148_ absent-value)
                  (error '"Missing required keyword argument" 'passwd:)
                  _passwd272138272148_))
             (_db272161_
              (if (eq? _db272139272150_ absent-value) '#f _db272139272150_))
             (_driver272163_
              (std/db/postgresql-driver#postgresql-connect!
               _host272153_
               _port272155_
               _user272157_
               _passwd272159_
               _db272161_))
             (__obj312571
              (make-object std/db/postgresql#postgresql-connection::t '8)))
        (std/db/postgresql#postgresql-connection:::init!
         __obj312571
         _driver272163_
         _host272153_
         _port272155_
         _user272157_
         _db272161_)
        __obj312571)))
  (define std/db/postgresql#postgresql-connect__@
    (lambda (_keys272134272168_ . _args272170_)
      (apply std/db/postgresql#postgresql-connect__%
             _keys272134272168_
             (table-ref _keys272134272168_ 'host: absent-value)
             (table-ref _keys272134272168_ 'port: absent-value)
             (table-ref _keys272134272168_ 'user: absent-value)
             (table-ref _keys272134272168_ 'passwd: absent-value)
             (table-ref _keys272134272168_ 'db: absent-value)
             _args272170_)))
  (define std/db/postgresql#postgresql-connect
    (lambda _args272140272176_
      (apply keyword-dispatch
             '#(#f passwd: #f #f port: host: user: #f #f db:)
             std/db/postgresql#postgresql-connect__@
             _args272140272176_)))
  (define std/db/postgresql#postgresql-connection::close
    (lambda (_self272131_)
      (std/db/postgresql-driver#postgresql-close! _self272131_)))
  (bind-method!
   std/db/postgresql#postgresql-connection::t
   'close
   std/db/postgresql#postgresql-connection::close
   '#f)
  (define std/db/postgresql#postgresql-command::t
    (make-struct-type
     'std/db/postgresql#postgresql-command::t
     std/db/dbi#statement::t
     '5
     'postgresql-command
     '((print: complete))
     ':init!
     '(conn complete notices input token)))
  (define std/db/postgresql#postgresql-command?
    (make-struct-predicate std/db/postgresql#postgresql-command::t))
  (define std/db/postgresql#make-postgresql-command
    (lambda _$args272006_
      (apply make-struct-instance
             std/db/postgresql#postgresql-command::t
             _$args272006_)))
  (define std/db/postgresql#postgresql-command-conn
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '0))
  (define std/db/postgresql#postgresql-command-complete
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '1))
  (define std/db/postgresql#postgresql-command-notices
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '2))
  (define std/db/postgresql#postgresql-command-input
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '3))
  (define std/db/postgresql#postgresql-command-token
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '4))
  (define std/db/postgresql#postgresql-command-conn-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '0))
  (define std/db/postgresql#postgresql-command-complete-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '1))
  (define std/db/postgresql#postgresql-command-notices-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '2))
  (define std/db/postgresql#postgresql-command-input-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '3))
  (define std/db/postgresql#postgresql-command-token-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '4))
  (define std/db/postgresql#!unnamed::t
    (make-struct-type
     'std/db/postgresql#!unnamed::t
     '#f
     '0
     '!unnamed
     '((final: . #t))
     '#f
     '()))
  (define std/db/postgresql#!unnamed?
    (make-struct-predicate std/db/postgresql#!unnamed::t))
  (define std/db/postgresql#make-!unnamed
    (lambda _$args272003_
      (apply make-struct-instance
             std/db/postgresql#!unnamed::t
             _$args272003_)))
  (define std/db/postgresql#unnamed-command
    (let () (declare (not safe)) (##structure std/db/postgresql#!unnamed::t)))
  (define std/db/postgresql#postgresql-command:::init!__%
    (lambda (_g312579_
             _name271974271978_
             _complete271975271980_
             _self271982_
             _conn271983_)
      (let* ((_name271985_
              (if (eq? _name271974271978_ absent-value)
                  std/db/postgresql#unnamed-command
                  _name271974271978_))
             (_complete271987_
              (if (eq? _complete271975271980_ absent-value)
                  '#f
                  _complete271975271980_)))
        (if (let ((__tmp312580
                   (let ()
                     (declare (not safe))
                     (##vector-length _self271982_))))
              (declare (not safe))
              (##fx< '4 __tmp312580))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self271982_ '1 _name271985_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271982_ '2 _conn271983_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271982_ '3 _complete271987_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271982_ '4 '())))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self271982_)))))
  (define std/db/postgresql#postgresql-command:::init!__@
    (lambda (_keys271973271992_ . _args271994_)
      (apply std/db/postgresql#postgresql-command:::init!__%
             _keys271973271992_
             (table-ref _keys271973271992_ 'name: absent-value)
             (table-ref _keys271973271992_ 'complete: absent-value)
             _args271994_)))
  (define std/db/postgresql#postgresql-command:::init!
    (lambda _args271976272000_
      (apply keyword-dispatch
             '#(name: #f complete:)
             std/db/postgresql#postgresql-command:::init!__@
             _args271976272000_)))
  (bind-method!
   std/db/postgresql#postgresql-command::t
   ':init!
   std/db/postgresql#postgresql-command:::init!
   '#f)
  (define std/db/postgresql#postgresql-command::query-start void)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-start
   std/db/postgresql#postgresql-command::query-start
   '#f)
  (define std/db/postgresql#postgresql-command::query-fini
    std/db/postgresql#postgresql-command::reset)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-fini
   std/db/postgresql#postgresql-command::query-fini
   '#f)
  (define std/db/postgresql#postgresql-command::query-fetch
    (lambda _g312581_ std/iter#iter-end))
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-fetch
   std/db/postgresql#postgresql-command::query-fetch
   '#f)
  (define std/db/postgresql#postgresql-command::query-row
    std/db/postgresql#postgresql-command-complete)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-row
   std/db/postgresql#postgresql-command::query-row
   '#f)
  (define std/db/postgresql#postgresql-command::columns (lambda _g312582_ '()))
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'columns
   std/db/postgresql#postgresql-command::columns
   '#f)
  (define std/db/postgresql#wrap-notice-handler
    (lambda (_cmd271233_ _thunk271234_)
      (std/db/postgresql-driver#with-postgresql-notice-handler
       (##structure-ref
        _cmd271233_
        '2
        std/db/postgresql#postgresql-command::t
        '#f)
       (lambda _args271236_
         (##structure-set!
          _cmd271233_
          (cons _args271236_
                (##structure-ref
                 _cmd271233_
                 '4
                 std/db/postgresql#postgresql-command::t
                 '#f))
          '4
          std/db/postgresql#postgresql-command::t
          '#f))
       _thunk271234_)))
  (define std/db/postgresql#postgresql-command::reset
    (lambda (_self271225_)
      (let ((_token271226271228_
             (##structure-ref
              _self271225_
              '6
              std/db/postgresql#postgresql-command::t
              '#f)))
        (if _token271226271228_
            (let ((_token271231_ _token271226271228_))
              (std/db/postgresql-driver#postgresql-reset!
               (##structure-ref
                _self271225_
                '2
                std/db/postgresql#postgresql-command::t
                '#f)
               _token271231_)
              (##structure-set!
               _self271225_
               '#f
               '6
               std/db/postgresql#postgresql-command::t
               '#f)
              (##structure-set!
               _self271225_
               '#f
               '5
               std/db/postgresql#postgresql-command::t
               '#f))
            '#f))))
  (define std/db/postgresql#postgresql-command::reset::specialize
    (lambda (__t312491)
      (let* ((__class312492
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312491))
             (__specializer312493
              (lambda (_self271225_)
                (let ((_token271226271228_
                       (if __class312492
                           (let ()
                             (declare (not safe))
                             (##unchecked-structure-ref
                              _self271225_
                              '6
                              std/db/postgresql#postgresql-command::t
                              '#f))
                           (error '"Type error; concrete type is not a subclass of expected type"
                                  std/db/postgresql#postgresql-command::t
                                  _self271225_))))
                  (if _token271226271228_
                      (let ((_token271231_ _token271226271228_))
                        (std/db/postgresql-driver#postgresql-reset!
                         (if __class312492
                             (let ()
                               (declare (not safe))
                               (##unchecked-structure-ref
                                _self271225_
                                '2
                                std/db/postgresql#postgresql-command::t
                                '#f))
                             (error '"Type error; concrete type is not a subclass of expected type"
                                    std/db/postgresql#postgresql-command::t
                                    _self271225_))
                         _token271231_)
                        (if __class312492
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-set!
                               _self271225_
                               '#f
                               '6
                               std/db/postgresql#postgresql-command::t
                               '#f))
                            (error '"Type error; concrete type is not a subclass of expected type"
                                   std/db/postgresql#postgresql-command::t
                                   _self271225_))
                        (if __class312492
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-set!
                               _self271225_
                               '#f
                               '5
                               std/db/postgresql#postgresql-command::t
                               '#f))
                            (error '"Type error; concrete type is not a subclass of expected type"
                                   std/db/postgresql#postgresql-command::t
                                   _self271225_)))
                      '#f)))))
        (if __class312492
            std/db/postgresql#postgresql-command::reset::specialize::unchecked
            __specializer312493))))
  (define std/db/postgresql#postgresql-command::reset::specialize::unchecked
    (lambda (_self271225_)
      (let ((_token271226271228_
             (let ()
               (declare (not safe))
               (##unchecked-structure-ref
                _self271225_
                '6
                std/db/postgresql#postgresql-command::t
                '#f))))
        (if _token271226271228_
            (let ((_token271231_ _token271226271228_))
              (std/db/postgresql-driver#postgresql-reset!
               (let ()
                 (declare (not safe))
                 (##unchecked-structure-ref
                  _self271225_
                  '2
                  std/db/postgresql#postgresql-command::t
                  '#f))
               _token271231_)
              (let ()
                (declare (not safe))
                (##unchecked-structure-set!
                 _self271225_
                 '#f
                 '6
                 std/db/postgresql#postgresql-command::t
                 '#f))
              (let ()
                (declare (not safe))
                (##unchecked-structure-set!
                 _self271225_
                 '#f
                 '5
                 std/db/postgresql#postgresql-command::t
                 '#f)))
            '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-command::reset
   std/db/postgresql#postgresql-command::reset::specialize)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'reset
   std/db/postgresql#postgresql-command::reset
   '#f)
  (define std/db/postgresql#postgresql-statement::t
    (make-struct-type
     'std/db/postgresql#postgresql-statement::t
     std/db/postgresql#postgresql-command::t
     '4
     'postgresql-statement
     '((final: . #t))
     ':init!
     '(cols params bind row)))
  (define std/db/postgresql#postgresql-statement?
    (make-struct-predicate std/db/postgresql#postgresql-statement::t))
  (define std/db/postgresql#make-postgresql-statement
    (lambda _$args271100_
      (apply make-struct-instance
             std/db/postgresql#postgresql-statement::t
             _$args271100_)))
  (define std/db/postgresql#postgresql-statement-cols
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '0))
  (define std/db/postgresql#postgresql-statement-params
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '1))
  (define std/db/postgresql#postgresql-statement-bind
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '2))
  (define std/db/postgresql#postgresql-statement-row
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '3))
  (define std/db/postgresql#postgresql-statement-cols-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '0))
  (define std/db/postgresql#postgresql-statement-params-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '1))
  (define std/db/postgresql#postgresql-statement-bind-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '2))
  (define std/db/postgresql#postgresql-statement-row-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '3))
  (define std/db/postgresql#postgresql-statement:::init!__%
    (lambda (_g312583_
             _name271070271074_
             _params271071271076_
             _self271078_
             _conn271079_
             _cols271080_)
      (let* ((_name271082_
              (if (eq? _name271070271074_ absent-value)
                  std/db/postgresql#unnamed-command
                  _name271070271074_))
             (_params271084_
              (if (eq? _params271071271076_ absent-value)
                  '()
                  _params271071271076_)))
        (if (let ((__tmp312584
                   (let ()
                     (declare (not safe))
                     (##vector-length _self271078_))))
              (declare (not safe))
              (##fx< '8 __tmp312584))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self271078_ '1 _name271082_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271078_ '2 _conn271079_))
              (let () (declare (not safe)) (##vector-set! _self271078_ '3 '#f))
              (let () (declare (not safe)) (##vector-set! _self271078_ '4 '()))
              (let () (declare (not safe)) (##vector-set! _self271078_ '5 '#f))
              (let () (declare (not safe)) (##vector-set! _self271078_ '6 '#f))
              (let ()
                (declare (not safe))
                (##vector-set! _self271078_ '7 _cols271080_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271078_ '8 _params271084_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self271078_)))))
  (define std/db/postgresql#postgresql-statement:::init!__@
    (lambda (_keys271069271089_ . _args271091_)
      (apply std/db/postgresql#postgresql-statement:::init!__%
             _keys271069271089_
             (table-ref _keys271069271089_ 'name: absent-value)
             (table-ref _keys271069271089_ 'params: absent-value)
             _args271091_)))
  (define std/db/postgresql#postgresql-statement:::init!
    (lambda _args271072271097_
      (apply keyword-dispatch
             '#(name: params:)
             std/db/postgresql#postgresql-statement:::init!__@
             _args271072271097_)))
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   ':init!
   std/db/postgresql#postgresql-statement:::init!
   '#f)
  (define std/db/postgresql#postgresql-statement::query-row
    (lambda (_self270944_)
      (##direct-structure-ref
       _self270944_
       '10
       std/db/postgresql#postgresql-statement::t
       '#f)))
  (define std/db/postgresql#postgresql-statement::query-row::specialize
    (lambda (__t312494)
      (let* ((__class312495
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312494))
             (__specializer312496
              (lambda (_self270944_)
                (if __class312495
                    (let ()
                      (declare (not safe))
                      (##unchecked-structure-ref
                       _self270944_
                       '10
                       std/db/postgresql#postgresql-statement::t
                       '#f))
                    (error '"Type error; concrete type is not a subclass of expected type"
                           std/db/postgresql#postgresql-statement::t
                           _self270944_)))))
        (if __class312495
            std/db/postgresql#postgresql-statement::query-row::specialize::unchecked
            __specializer312496))))
  (define std/db/postgresql#postgresql-statement::query-row::specialize::unchecked
    (lambda (_self270944_)
      (let ()
        (declare (not safe))
        (##unchecked-structure-ref
         _self270944_
         '10
         std/db/postgresql#postgresql-statement::t
         '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::query-row
   std/db/postgresql#postgresql-statement::query-row::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-row
   std/db/postgresql#postgresql-statement::query-row
   '#f)
  (define std/db/postgresql#postgresql-statement::columns
    (lambda (_self270820_)
      (map car
           (##direct-structure-ref
            _self270820_
            '7
            std/db/postgresql#postgresql-statement::t
            '#f))))
  (define std/db/postgresql#postgresql-statement::columns::specialize
    (lambda (__t312497)
      (let* ((__class312498
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312497))
             (__specializer312499
              (lambda (_self270820_)
                (map car
                     (if __class312498
                         (let ()
                           (declare (not safe))
                           (##unchecked-structure-ref
                            _self270820_
                            '7
                            std/db/postgresql#postgresql-statement::t
                            '#f))
                         (error '"Type error; concrete type is not a subclass of expected type"
                                std/db/postgresql#postgresql-statement::t
                                _self270820_))))))
        (if __class312498
            std/db/postgresql#postgresql-statement::columns::specialize::unchecked
            __specializer312499))))
  (define std/db/postgresql#postgresql-statement::columns::specialize::unchecked
    (lambda (_self270820_)
      (map car
           (let ()
             (declare (not safe))
             (##unchecked-structure-ref
              _self270820_
              '7
              std/db/postgresql#postgresql-statement::t
              '#f)))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::columns
   std/db/postgresql#postgresql-statement::columns::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'columns
   std/db/postgresql#postgresql-statement::columns
   '#f)
  (define std/db/postgresql#postgresql-statement::query-fini
    std/db/postgresql#postgresql-statement::reset)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-fini
   std/db/postgresql#postgresql-statement::query-fini
   '#f)
  (define std/db/postgresql#postgresql-statement-in-query?
    (lambda (_stmt270574_)
      (let ((__tmp312585
             (##structure-ref _stmt270574_ '1 std/db/dbi#statement::t '#f)))
        (declare (not safe))
        (##structure-direct-instance-of?
         __tmp312585
         'std/db/postgresql#!unnamed::t))))
  (define std/db/postgresql#postgresql-statement::query-start
    (lambda (_self270505_)
      (std/db/postgresql#wrap-notice-handler
       _self270505_
       (lambda ()
         (if (std/db/postgresql#postgresql-statement-in-query? _self270505_)
             '#!void
             (let* ((_self270507270521_ _self270505_)
                    (_E270509270525_
                     (lambda ()
                       (error '"No clause matching" _self270507270521_)))
                    (_K270510270538_
                     (lambda (_bind270528_ _conn270529_ _name270530_)
                       (let ((_g312586_
                              (std/db/postgresql-driver#postgresql-query!
                               _conn270529_
                               _name270530_
                               (let ((_$e270532_ _bind270528_))
                                 (if _$e270532_ _$e270532_ '())))))
                         (begin
                           (let ((_g312587_
                                  (let ()
                                    (declare (not safe))
                                    (if (##values? _g312586_)
                                        (##vector-length _g312586_)
                                        1))))
                             (if (not (let ()
                                        (declare (not safe))
                                        (##fx= _g312587_ 2)))
                                 (error "Context expects 2 values" _g312587_)))
                           (let ((_inp270535_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312586_ 0)))
                                 (_token270536_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312586_ 1))))
                             (begin
                               (##structure-set!
                                _self270505_
                                _token270536_
                                '6
                                std/db/postgresql#postgresql-command::t
                                '#f)
                               (##structure-set!
                                _self270505_
                                _inp270535_
                                '5
                                std/db/postgresql#postgresql-command::t
                                '#f)
                               (##direct-structure-set!
                                _self270505_
                                '#f
                                '10
                                std/db/postgresql#postgresql-statement::t
                                '#f))))))))
               (if (let ()
                     (declare (not safe))
                     (##structure-direct-instance-of?
                      _self270507270521_
                      'std/db/postgresql#postgresql-statement::t))
                   (let* ((_e270511270541_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '1)))
                          (_name270544_ _e270511270541_)
                          (_e270512270546_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '2)))
                          (_conn270549_ _e270512270546_)
                          (_e270513270551_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '3)))
                          (_e270514270554_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '4)))
                          (_e270515270557_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '5)))
                          (_e270516270560_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '6)))
                          (_e270517270563_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '7)))
                          (_e270518270566_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '8)))
                          (_e270519270569_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '9)))
                          (_bind270572_ _e270519270569_))
                     (_K270510270538_ _bind270572_ _conn270549_ _name270544_))
                   (_E270509270525_))))))))
  (define std/db/postgresql#postgresql-statement::query-start::specialize
    (lambda (__t312500)
      (let ((__class312501
             (struct-subtype?
              std/db/postgresql#postgresql-command::t
              __t312500))
            (__class312502
             (struct-subtype?
              std/db/postgresql#postgresql-statement::t
              __t312500)))
        (let ((__specializer312503
               (lambda (_self270505_)
                 (std/db/postgresql#wrap-notice-handler
                  _self270505_
                  (lambda ()
                    (if (std/db/postgresql#postgresql-statement-in-query?
                         _self270505_)
                        '#!void
                        (let* ((_self270507270521_ _self270505_)
                               (_E270509270525_
                                (lambda ()
                                  (error '"No clause matching"
                                         _self270507270521_)))
                               (_K270510270538_
                                (lambda (_bind270528_
                                         _conn270529_
                                         _name270530_)
                                  (let ((_g312588_
                                         (std/db/postgresql-driver#postgresql-query!
                                          _conn270529_
                                          _name270530_
                                          (let ((_$e270532_ _bind270528_))
                                            (if _$e270532_ _$e270532_ '())))))
                                    (begin
                                      (let ((_g312589_
                                             (let ()
                                               (declare (not safe))
                                               (if (##values? _g312588_)
                                                   (##vector-length _g312588_)
                                                   1))))
                                        (if (not (let ()
                                                   (declare (not safe))
                                                   (##fx= _g312589_ 2)))
                                            (error "Context expects 2 values"
                                                   _g312589_)))
                                      (let ((_inp270535_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref _g312588_ 0)))
                                            (_token270536_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref _g312588_ 1))))
                                        (begin
                                          (if __class312501
                                              (let ()
                                                (declare (not safe))
                                                (##unchecked-structure-set!
                                                 _self270505_
                                                 _token270536_
                                                 '6
                                                 std/db/postgresql#postgresql-command::t
                                                 '#f))
                                              (error '"Type error; concrete type is not a subclass of expected type"
                                                     std/db/postgresql#postgresql-command::t
                                                     _self270505_))
                                          (if __class312501
                                              (let ()
                                                (declare (not safe))
                                                (##unchecked-structure-set!
                                                 _self270505_
                                                 _inp270535_
                                                 '5
                                                 std/db/postgresql#postgresql-command::t
                                                 '#f))
                                              (error '"Type error; concrete type is not a subclass of expected type"
                                                     std/db/postgresql#postgresql-command::t
                                                     _self270505_))
                                          (if __class312502
                                              (let ()
                                                (declare (not safe))
                                                (##unchecked-structure-set!
                                                 _self270505_
                                                 '#f
                                                 '10
                                                 std/db/postgresql#postgresql-statement::t
                                                 '#f))
                                              (error '"Type error; concrete type is not a subclass of expected type"
                                                     std/db/postgresql#postgresql-statement::t
                                                     _self270505_)))))))))
                          (if (let ()
                                (declare (not safe))
                                (##structure-direct-instance-of?
                                 _self270507270521_
                                 'std/db/postgresql#postgresql-statement::t))
                              (let* ((_e270511270541_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '1)))
                                     (_name270544_ _e270511270541_)
                                     (_e270512270546_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '2)))
                                     (_conn270549_ _e270512270546_)
                                     (_e270513270551_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '3)))
                                     (_e270514270554_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '4)))
                                     (_e270515270557_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '5)))
                                     (_e270516270560_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '6)))
                                     (_e270517270563_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '7)))
                                     (_e270518270566_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '8)))
                                     (_e270519270569_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270507270521_ '9)))
                                     (_bind270572_ _e270519270569_))
                                (_K270510270538_
                                 _bind270572_
                                 _conn270549_
                                 _name270544_))
                              (_E270509270525_)))))))))
          (if __class312501
              (if __class312502
                  std/db/postgresql#postgresql-statement::query-start::specialize::unchecked
                  __specializer312503)
              __specializer312503)))))
  (define std/db/postgresql#postgresql-statement::query-start::specialize::unchecked
    (lambda (_self270505_)
      (std/db/postgresql#wrap-notice-handler
       _self270505_
       (lambda ()
         (if (std/db/postgresql#postgresql-statement-in-query? _self270505_)
             '#!void
             (let* ((_self270507270521_ _self270505_)
                    (_E270509270525_
                     (lambda ()
                       (error '"No clause matching" _self270507270521_)))
                    (_K270510270538_
                     (lambda (_bind270528_ _conn270529_ _name270530_)
                       (let ((_g312590_
                              (std/db/postgresql-driver#postgresql-query!
                               _conn270529_
                               _name270530_
                               (let ((_$e270532_ _bind270528_))
                                 (if _$e270532_ _$e270532_ '())))))
                         (begin
                           (let ((_g312591_
                                  (let ()
                                    (declare (not safe))
                                    (if (##values? _g312590_)
                                        (##vector-length _g312590_)
                                        1))))
                             (if (not (let ()
                                        (declare (not safe))
                                        (##fx= _g312591_ 2)))
                                 (error "Context expects 2 values" _g312591_)))
                           (let ((_inp270535_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312590_ 0)))
                                 (_token270536_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312590_ 1))))
                             (begin
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-set!
                                  _self270505_
                                  _token270536_
                                  '6
                                  std/db/postgresql#postgresql-command::t
                                  '#f))
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-set!
                                  _self270505_
                                  _inp270535_
                                  '5
                                  std/db/postgresql#postgresql-command::t
                                  '#f))
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-set!
                                  _self270505_
                                  '#f
                                  '10
                                  std/db/postgresql#postgresql-statement::t
                                  '#f)))))))))
               (if (let ()
                     (declare (not safe))
                     (##structure-direct-instance-of?
                      _self270507270521_
                      'std/db/postgresql#postgresql-statement::t))
                   (let* ((_e270511270541_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '1)))
                          (_name270544_ _e270511270541_)
                          (_e270512270546_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '2)))
                          (_conn270549_ _e270512270546_)
                          (_e270513270551_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '3)))
                          (_e270514270554_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '4)))
                          (_e270515270557_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '5)))
                          (_e270516270560_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '6)))
                          (_e270517270563_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '7)))
                          (_e270518270566_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '8)))
                          (_e270519270569_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270507270521_ '9)))
                          (_bind270572_ _e270519270569_))
                     (_K270510270538_ _bind270572_ _conn270549_ _name270544_))
                   (_E270509270525_))))))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::query-start
   std/db/postgresql#postgresql-statement::query-start::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-start
   std/db/postgresql#postgresql-statement::query-start
   '#f)
  (define std/db/postgresql#postgresql-statement::query-fetch
    (lambda (_self270343_)
      (letrec ((_result->row270345_
                (lambda (_cols270379_)
                  (let ((_res270381_
                         (map _result->value270346_
                              _cols270379_
                              (##direct-structure-ref
                               _self270343_
                               '7
                               std/db/postgresql#postgresql-statement::t
                               '#f))))
                    (if (null? _res270381_)
                        '#f
                        (if (null? (cdr _res270381_))
                            (car _res270381_)
                            (list->vector _res270381_))))))
               (_result->value270346_
                (lambda (_res270374_ _col270375_)
                  (if _res270374_
                      (let ((_type-oid270377_ (list-ref _col270375_ '3)))
                        (_value-e270347_ _res270374_ _type-oid270377_))
                      '#f)))
               (_value-e270347_
                (lambda (_res270364_ _type-oid270365_)
                  (let ((_$e270367_
                         (std/db/postgresql#catalog-deserializer
                          (std/db/postgresql#current-catalog)
                          _type-oid270365_)))
                    (if _$e270367_
                        ((lambda (_g270369270371_)
                           (_g270369270371_ _res270364_))
                         _$e270367_)
                        _res270364_)))))
        (let ((_$e270349_
               (##structure-ref
                _self270343_
                '5
                std/db/postgresql#postgresql-command::t
                '#f)))
          (if _$e270349_
              ((lambda (_inp270352_)
                 (let _again270354_ ()
                   (let ((_next270357_
                          (std/misc/channel#channel-get__0 _inp270352_)))
                     (if (or (eof-object? _next270357_)
                             (let ()
                               (declare (not safe))
                               (##structure-direct-instance-of?
                                _next270357_
                                'std/db/postgresql-driver#postgresql-CommandComplete::t)))
                         (begin
                           (if (let ()
                                 (declare (not safe))
                                 (##structure-direct-instance-of?
                                  _next270357_
                                  'std/db/postgresql-driver#postgresql-CommandComplete::t))
                               (##structure-set!
                                _self270343_
                                (##structure-ref
                                 _next270357_
                                 '2
                                 std/db/postgresql-driver#postgresql-message::t
                                 '#f)
                                '3
                                std/db/postgresql#postgresql-command::t
                                '#f)
                               '#!void)
                           (##structure-set!
                            _self270343_
                            '#f
                            '6
                            std/db/postgresql#postgresql-command::t
                            '#f)
                           (##structure-set!
                            _self270343_
                            '#f
                            '5
                            std/db/postgresql#postgresql-command::t
                            '#f)
                           (##direct-structure-set!
                            _self270343_
                            '#f
                            '10
                            std/db/postgresql#postgresql-statement::t
                            '#f)
                           std/iter#iter-end)
                         (if (exception? _next270357_)
                             (raise _next270357_)
                             (if (let ()
                                   (declare (not safe))
                                   (##structure-direct-instance-of?
                                    _next270357_
                                    'std/actor/proto#!token::t))
                                 (begin
                                   (std/db/postgresql-driver#postgresql-continue!
                                    (##structure-ref
                                     _self270343_
                                     '2
                                     std/db/postgresql#postgresql-command::t
                                     '#f)
                                    _next270357_)
                                   (_again270354_))
                                 (let ((_row270362_
                                        (_result->row270345_ _next270357_)))
                                   (##direct-structure-set!
                                    _self270343_
                                    _row270362_
                                    '10
                                    std/db/postgresql#postgresql-statement::t
                                    '#f)
                                   '#!void)))))))
               _$e270349_)
              std/iter#iter-end)))))
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-fetch
   std/db/postgresql#postgresql-statement::query-fetch
   '#f)
  (define std/db/postgresql#postgresql-connection::prepare
    (lambda (_self270212_ _sql270213_)
      (let* ((_name270215_ (symbol->string (gensym 'stmt)))
             (_g312592_
              (std/db/postgresql-driver#postgresql-prepare-statement!
               _self270212_
               _name270215_
               _sql270213_)))
        (begin
          (let ((_g312593_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g312592_) (##vector-length _g312592_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g312593_ 2)))
                (error "Context expects 2 values" _g312593_)))
          (let ((_params270217_
                 (let () (declare (not safe)) (##vector-ref _g312592_ 0)))
                (_cols270218_
                 (let () (declare (not safe)) (##vector-ref _g312592_ 1))))
            (let ()
              (let ((__obj312572
                     (make-object
                      std/db/postgresql#postgresql-statement::t
                      '10)))
                (std/db/postgresql#postgresql-statement:::init!__%
                 '#f
                 _name270215_
                 _params270217_
                 __obj312572
                 _self270212_
                 _cols270218_)
                __obj312572)))))))
  (bind-method!
   std/db/postgresql#postgresql-connection::t
   'prepare
   std/db/postgresql#postgresql-connection::prepare
   '#f)
  (define std/db/postgresql#postgresql-statement::bind
    (lambda (_self270070_ . _args270071_)
      (letrec ((_value->binding270073_
                (lambda (_type-oid270080_ _arg270081_)
                  (if (not _arg270081_)
                      (if (fx= _type-oid270080_ '16)
                          (std/db/postgresql#serialize-boolean _arg270081_)
                          '#f)
                      (if (string? _arg270081_)
                          _arg270081_
                          (let ((_$e270083_
                                 (std/db/postgresql#catalog-serializer
                                  (std/db/postgresql#current-catalog)
                                  _type-oid270080_)))
                            (if _$e270083_
                                ((lambda (_g270085270087_)
                                   (_g270085270087_ _arg270081_))
                                 _$e270083_)
                                (error '"Cannot bind; Parameter type oid not in (current-catalog)"
                                       _type-oid270080_
                                       _arg270081_))))))))
        (let* ((_params270075_
                (##direct-structure-ref
                 _self270070_
                 '8
                 std/db/postgresql#postgresql-statement::t
                 '#f))
               (_bind270077_
                (map _value->binding270073_ _params270075_ _args270071_)))
          (##direct-structure-set!
           _self270070_
           _bind270077_
           '9
           std/db/postgresql#postgresql-statement::t
           '#f)
          '#!void))))
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'bind
   std/db/postgresql#postgresql-statement::bind
   '#f)
  (define std/db/postgresql#postgresql-statement::clear
    (lambda (_self269946_)
      (##direct-structure-set!
       _self269946_
       '#f
       '9
       std/db/postgresql#postgresql-statement::t
       '#f)))
  (define std/db/postgresql#postgresql-statement::clear::specialize
    (lambda (__t312504)
      (let* ((__class312505
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312504))
             (__specializer312506
              (lambda (_self269946_)
                (if __class312505
                    (let ()
                      (declare (not safe))
                      (##unchecked-structure-set!
                       _self269946_
                       '#f
                       '9
                       std/db/postgresql#postgresql-statement::t
                       '#f))
                    (error '"Type error; concrete type is not a subclass of expected type"
                           std/db/postgresql#postgresql-statement::t
                           _self269946_)))))
        (if __class312505
            std/db/postgresql#postgresql-statement::clear::specialize::unchecked
            __specializer312506))))
  (define std/db/postgresql#postgresql-statement::clear::specialize::unchecked
    (lambda (_self269946_)
      (let ()
        (declare (not safe))
        (##unchecked-structure-set!
         _self269946_
         '#f
         '9
         std/db/postgresql#postgresql-statement::t
         '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::clear
   std/db/postgresql#postgresql-statement::clear::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'clear
   std/db/postgresql#postgresql-statement::clear
   '#f)
  (define std/db/postgresql#postgresql-statement::exec
    (lambda (_self269753_)
      (let* ((_self269754269768_ _self269753_)
             (_E269756269772_
              (lambda () (error '"No clause matching" _self269754269768_)))
             (_K269757269788_
              (lambda (_bind269775_ _conn269776_ _name269777_)
                (std/db/postgresql#wrap-notice-handler
                 _self269753_
                 (lambda ()
                   (let* ((_comp269783_
                           (std/db/postgresql-driver#postgresql-exec!
                            _conn269776_
                            _name269777_
                            (let ((_$e269780_ _bind269775_))
                              (if _$e269780_ _$e269780_ '()))))
                          (_$r269785_ _comp269783_))
                     (##structure-set!
                      _self269753_
                      _comp269783_
                      '3
                      std/db/postgresql#postgresql-command::t
                      '#f)
                     _$r269785_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269754269768_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269758269791_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '1)))
                   (_name269794_ _e269758269791_)
                   (_e269759269796_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '2)))
                   (_conn269799_ _e269759269796_)
                   (_e269760269801_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '3)))
                   (_e269761269804_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '4)))
                   (_e269762269807_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '5)))
                   (_e269763269810_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '6)))
                   (_e269764269813_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '7)))
                   (_e269765269816_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '8)))
                   (_e269766269819_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '9)))
                   (_bind269822_ _e269766269819_))
              (_K269757269788_ _bind269822_ _conn269799_ _name269794_))
            (_E269756269772_)))))
  (define std/db/postgresql#postgresql-statement::exec::specialize
    (lambda (__t312507)
      (let* ((__class312508
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312507))
             (__specializer312509
              (lambda (_self269753_)
                (let* ((_self269754269768_ _self269753_)
                       (_E269756269772_
                        (lambda ()
                          (error '"No clause matching" _self269754269768_)))
                       (_K269757269788_
                        (lambda (_bind269775_ _conn269776_ _name269777_)
                          (std/db/postgresql#wrap-notice-handler
                           _self269753_
                           (lambda ()
                             (let* ((_comp269783_
                                     (std/db/postgresql-driver#postgresql-exec!
                                      _conn269776_
                                      _name269777_
                                      (let ((_$e269780_ _bind269775_))
                                        (if _$e269780_ _$e269780_ '()))))
                                    (_$r269785_ _comp269783_))
                               (if __class312508
                                   (let ()
                                     (declare (not safe))
                                     (##unchecked-structure-set!
                                      _self269753_
                                      _comp269783_
                                      '3
                                      std/db/postgresql#postgresql-command::t
                                      '#f))
                                   (error '"Type error; concrete type is not a subclass of expected type"
                                          std/db/postgresql#postgresql-command::t
                                          _self269753_))
                               _$r269785_))))))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _self269754269768_
                         'std/db/postgresql#postgresql-statement::t))
                      (let* ((_e269758269791_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '1)))
                             (_name269794_ _e269758269791_)
                             (_e269759269796_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '2)))
                             (_conn269799_ _e269759269796_)
                             (_e269760269801_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '3)))
                             (_e269761269804_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '4)))
                             (_e269762269807_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '5)))
                             (_e269763269810_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '6)))
                             (_e269764269813_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '7)))
                             (_e269765269816_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '8)))
                             (_e269766269819_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269754269768_ '9)))
                             (_bind269822_ _e269766269819_))
                        (_K269757269788_
                         _bind269822_
                         _conn269799_
                         _name269794_))
                      (_E269756269772_))))))
        (if __class312508
            std/db/postgresql#postgresql-statement::exec::specialize::unchecked
            __specializer312509))))
  (define std/db/postgresql#postgresql-statement::exec::specialize::unchecked
    (lambda (_self269753_)
      (let* ((_self269754269768_ _self269753_)
             (_E269756269772_
              (lambda () (error '"No clause matching" _self269754269768_)))
             (_K269757269788_
              (lambda (_bind269775_ _conn269776_ _name269777_)
                (std/db/postgresql#wrap-notice-handler
                 _self269753_
                 (lambda ()
                   (let* ((_comp269783_
                           (std/db/postgresql-driver#postgresql-exec!
                            _conn269776_
                            _name269777_
                            (let ((_$e269780_ _bind269775_))
                              (if _$e269780_ _$e269780_ '()))))
                          (_$r269785_ _comp269783_))
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-set!
                        _self269753_
                        _comp269783_
                        '3
                        std/db/postgresql#postgresql-command::t
                        '#f))
                     _$r269785_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269754269768_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269758269791_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '1)))
                   (_name269794_ _e269758269791_)
                   (_e269759269796_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '2)))
                   (_conn269799_ _e269759269796_)
                   (_e269760269801_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '3)))
                   (_e269761269804_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '4)))
                   (_e269762269807_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '5)))
                   (_e269763269810_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '6)))
                   (_e269764269813_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '7)))
                   (_e269765269816_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '8)))
                   (_e269766269819_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269754269768_ '9)))
                   (_bind269822_ _e269766269819_))
              (_K269757269788_ _bind269822_ _conn269799_ _name269794_))
            (_E269756269772_)))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::exec
   std/db/postgresql#postgresql-statement::exec::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'exec
   std/db/postgresql#postgresql-statement::exec
   '#f)
  (define std/db/postgresql#postgresql-statement::finalize
    (lambda (_self269600_)
      (let* ((_self269601269608_ _self269600_)
             (_E269603269612_
              (lambda () (error '"No clause matching" _self269601269608_)))
             (_K269604269618_
              (lambda (_conn269615_ _name269616_)
                (std/db/postgresql#postgresql-statement::reset _self269600_)
                (##structure-set!
                 _self269600_
                 '#f
                 '3
                 std/db/postgresql#postgresql-command::t
                 '#f)
                (std/db/postgresql-driver#postgresql-close-statement!
                 _conn269615_
                 _name269616_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269601269608_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269605269621_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269601269608_ '1)))
                   (_name269624_ _e269605269621_)
                   (_e269606269626_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269601269608_ '2)))
                   (_conn269629_ _e269606269626_))
              (_K269604269618_ _conn269629_ _name269624_))
            (_E269603269612_)))))
  (define std/db/postgresql#postgresql-statement::finalize::specialize
    (lambda (__t312510)
      (let* ((__class312511
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312510))
             (__specializer312512
              (lambda (_self269600_)
                (let* ((_self269601269608_ _self269600_)
                       (_E269603269612_
                        (lambda ()
                          (error '"No clause matching" _self269601269608_)))
                       (_K269604269618_
                        (lambda (_conn269615_ _name269616_)
                          (std/db/postgresql#postgresql-statement::reset
                           _self269600_)
                          (if __class312511
                              (let ()
                                (declare (not safe))
                                (##unchecked-structure-set!
                                 _self269600_
                                 '#f
                                 '3
                                 std/db/postgresql#postgresql-command::t
                                 '#f))
                              (error '"Type error; concrete type is not a subclass of expected type"
                                     std/db/postgresql#postgresql-command::t
                                     _self269600_))
                          (std/db/postgresql-driver#postgresql-close-statement!
                           _conn269615_
                           _name269616_))))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _self269601269608_
                         'std/db/postgresql#postgresql-statement::t))
                      (let* ((_e269605269621_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269601269608_ '1)))
                             (_name269624_ _e269605269621_)
                             (_e269606269626_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269601269608_ '2)))
                             (_conn269629_ _e269606269626_))
                        (_K269604269618_ _conn269629_ _name269624_))
                      (_E269603269612_))))))
        (if __class312511
            std/db/postgresql#postgresql-statement::finalize::specialize::unchecked
            __specializer312512))))
  (define std/db/postgresql#postgresql-statement::finalize::specialize::unchecked
    (lambda (_self269600_)
      (let* ((_self269601269608_ _self269600_)
             (_E269603269612_
              (lambda () (error '"No clause matching" _self269601269608_)))
             (_K269604269618_
              (lambda (_conn269615_ _name269616_)
                (std/db/postgresql#postgresql-statement::reset _self269600_)
                (let ()
                  (declare (not safe))
                  (##unchecked-structure-set!
                   _self269600_
                   '#f
                   '3
                   std/db/postgresql#postgresql-command::t
                   '#f))
                (std/db/postgresql-driver#postgresql-close-statement!
                 _conn269615_
                 _name269616_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269601269608_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269605269621_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269601269608_ '1)))
                   (_name269624_ _e269605269621_)
                   (_e269606269626_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269601269608_ '2)))
                   (_conn269629_ _e269606269626_))
              (_K269604269618_ _conn269629_ _name269624_))
            (_E269603269612_)))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::finalize
   std/db/postgresql#postgresql-statement::finalize::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'finalize
   std/db/postgresql#postgresql-statement::finalize
   '#f)
  (define std/db/postgresql#postgresql-statement::reset
    (lambda (_self269476_)
      (std/db/postgresql#postgresql-command::reset _self269476_)
      (##direct-structure-set!
       _self269476_
       '#f
       '10
       std/db/postgresql#postgresql-statement::t
       '#f)))
  (define std/db/postgresql#postgresql-statement::reset::specialize
    (lambda (__t312513)
      (let* ((__class312514
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312513))
             (__specializer312515
              (lambda (_self269476_)
                (std/db/postgresql#postgresql-command::reset _self269476_)
                (if __class312514
                    (let ()
                      (declare (not safe))
                      (##unchecked-structure-set!
                       _self269476_
                       '#f
                       '10
                       std/db/postgresql#postgresql-statement::t
                       '#f))
                    (error '"Type error; concrete type is not a subclass of expected type"
                           std/db/postgresql#postgresql-statement::t
                           _self269476_)))))
        (if __class312514
            std/db/postgresql#postgresql-statement::reset::specialize::unchecked
            __specializer312515))))
  (define std/db/postgresql#postgresql-statement::reset::specialize::unchecked
    (lambda (_self269476_)
      (std/db/postgresql#postgresql-command::reset _self269476_)
      (let ()
        (declare (not safe))
        (##unchecked-structure-set!
         _self269476_
         '#f
         '10
         std/db/postgresql#postgresql-statement::t
         '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::reset
   std/db/postgresql#postgresql-statement::reset::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'reset
   std/db/postgresql#postgresql-statement::reset
   '#f)
  (define std/db/postgresql#postgresql-query::t
    (make-struct-type
     'std/db/postgresql#postgresql-query::t
     std/db/postgresql#postgresql-command::t
     '3
     'postgresql-query
     '((print: greedy str) (final: . #t))
     ':init!
     '(str cmd greedy)))
  (define std/db/postgresql#postgresql-query?
    (make-struct-predicate std/db/postgresql#postgresql-query::t))
  (define std/db/postgresql#make-postgresql-query
    (lambda _$args269351_
      (apply make-struct-instance
             std/db/postgresql#postgresql-query::t
             _$args269351_)))
  (define std/db/postgresql#postgresql-query-str
    (make-struct-field-accessor std/db/postgresql#postgresql-query::t '0))
  (define std/db/postgresql#postgresql-query-cmd
    (make-struct-field-accessor std/db/postgresql#postgresql-query::t '1))
  (define std/db/postgresql#postgresql-query-greedy
    (make-struct-field-accessor std/db/postgresql#postgresql-query::t '2))
  (define std/db/postgresql#postgresql-query-str-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-query::t '0))
  (define std/db/postgresql#postgresql-query-cmd-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-query::t '1))
  (define std/db/postgresql#postgresql-query-greedy-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-query::t '2))
  (define std/db/postgresql#postgresql-query:::init!__%
    (lambda (_g312594_
             _greedy269326269329_
             _self269331_
             _conn269332_
             _str269333_)
      (let ((_greedy269335_
             (if (eq? _greedy269326269329_ absent-value)
                 '#t
                 _greedy269326269329_)))
        (if (let ((__tmp312595
                   (let ()
                     (declare (not safe))
                     (##vector-length _self269331_))))
              (declare (not safe))
              (##fx< '9 __tmp312595))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set!
                 _self269331_
                 '1
                 std/db/postgresql#unnamed-command))
              (let ()
                (declare (not safe))
                (##vector-set! _self269331_ '2 _conn269332_))
              (let () (declare (not safe)) (##vector-set! _self269331_ '3 '#f))
              (let () (declare (not safe)) (##vector-set! _self269331_ '4 '()))
              (let () (declare (not safe)) (##vector-set! _self269331_ '5 '#f))
              (let () (declare (not safe)) (##vector-set! _self269331_ '6 '#f))
              (let ()
                (declare (not safe))
                (##vector-set! _self269331_ '7 _str269333_))
              (let () (declare (not safe)) (##vector-set! _self269331_ '8 '#f))
              (let ()
                (declare (not safe))
                (##vector-set! _self269331_ '9 _greedy269335_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self269331_)))))
  (define std/db/postgresql#postgresql-query:::init!__@
    (lambda (_keys269325269340_ . _args269342_)
      (apply std/db/postgresql#postgresql-query:::init!__%
             _keys269325269340_
             (table-ref _keys269325269340_ 'greedy: absent-value)
             _args269342_)))
  (define std/db/postgresql#postgresql-query:::init!
    (lambda _args269327269348_
      (apply keyword-dispatch
             '#(greedy:)
             std/db/postgresql#postgresql-query:::init!__@
             _args269327269348_)))
  (bind-method!
   std/db/postgresql#postgresql-query::t
   ':init!
   std/db/postgresql#postgresql-query:::init!
   '#f)
  (define std/db/postgresql#postgresql-query::exec
    (lambda (_self269147_)
      (std/db/postgresql#postgresql-query::query-start _self269147_)
      (std/db/postgresql#wrap-notice-handler
       _self269147_
       (lambda ()
         (let* ((_self269149269161_ _self269147_)
                (_E269151269165_
                 (lambda () (error '"No clause matching" _self269149269161_)))
                (_K269152269172_
                 (lambda (_str269168_ _token269169_ _conn269170_)
                   (std/db/postgresql-driver#postgresql-reset!
                    _conn269170_
                    _token269169_))))
           (if (let ()
                 (declare (not safe))
                 (##structure-direct-instance-of?
                  _self269149269161_
                  'std/db/postgresql#postgresql-query::t))
               (let* ((_e269153269175_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '1)))
                      (_e269154269178_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '2)))
                      (_conn269181_ _e269154269178_)
                      (_e269155269183_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '3)))
                      (_e269156269186_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '4)))
                      (_e269157269189_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '5)))
                      (_e269158269192_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '6)))
                      (_token269195_ _e269158269192_)
                      (_e269159269197_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269149269161_ '7)))
                      (_str269200_ _e269159269197_))
                 (_K269152269172_ _str269200_ _token269195_ _conn269181_))
               (_E269151269165_)))))))
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'exec
   std/db/postgresql#postgresql-query::exec
   '#f)
  (define std/db/postgresql#postgresql-query::query-row
    std/db/postgresql#postgresql-query-cmd)
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'query-row
   std/db/postgresql#postgresql-query::query-row
   '#f)
  (define std/db/postgresql#postgresql-query::query-start
    (lambda (_self268848_)
      (std/db/postgresql#wrap-notice-handler
       _self268848_
       (lambda ()
         (let* ((_self268850268862_ _self268848_)
                (_E268852268866_
                 (lambda () (error '"No clause matching" _self268850268862_)))
                (_K268853268875_
                 (lambda (_str268869_ _conn268870_)
                   (let ((_g312596_
                          (std/db/postgresql-driver#postgresql-simple-query!
                           _conn268870_
                           _str268869_)))
                     (begin
                       (let ((_g312597_
                              (let ()
                                (declare (not safe))
                                (if (##values? _g312596_)
                                    (##vector-length _g312596_)
                                    1))))
                         (if (not (let ()
                                    (declare (not safe))
                                    (##fx= _g312597_ 2)))
                             (error "Context expects 2 values" _g312597_)))
                       (let ((_inp268872_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312596_ 0)))
                             (_token268873_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312596_ 1))))
                         (begin
                           (##structure-set!
                            _self268848_
                            _token268873_
                            '6
                            std/db/postgresql#postgresql-command::t
                            '#f)
                           (##structure-set!
                            _self268848_
                            _inp268872_
                            '5
                            std/db/postgresql#postgresql-command::t
                            '#f))))))))
           (if (let ()
                 (declare (not safe))
                 (##structure-direct-instance-of?
                  _self268850268862_
                  'std/db/postgresql#postgresql-query::t))
               (let* ((_e268854268878_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '1)))
                      (_e268855268881_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '2)))
                      (_conn268884_ _e268855268881_)
                      (_e268856268886_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '3)))
                      (_e268857268889_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '4)))
                      (_e268858268892_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '5)))
                      (_e268859268895_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '6)))
                      (_e268860268898_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '7)))
                      (_str268901_ _e268860268898_))
                 (_K268853268875_ _str268901_ _conn268884_))
               (_E268852268866_)))))))
  (define std/db/postgresql#postgresql-query::query-start::specialize
    (lambda (__t312516)
      (let* ((__class312517
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312516))
             (__specializer312518
              (lambda (_self268848_)
                (std/db/postgresql#wrap-notice-handler
                 _self268848_
                 (lambda ()
                   (let* ((_self268850268862_ _self268848_)
                          (_E268852268866_
                           (lambda ()
                             (error '"No clause matching" _self268850268862_)))
                          (_K268853268875_
                           (lambda (_str268869_ _conn268870_)
                             (let ((_g312598_
                                    (std/db/postgresql-driver#postgresql-simple-query!
                                     _conn268870_
                                     _str268869_)))
                               (begin
                                 (let ((_g312599_
                                        (let ()
                                          (declare (not safe))
                                          (if (##values? _g312598_)
                                              (##vector-length _g312598_)
                                              1))))
                                   (if (not (let ()
                                              (declare (not safe))
                                              (##fx= _g312599_ 2)))
                                       (error "Context expects 2 values"
                                              _g312599_)))
                                 (let ((_inp268872_
                                        (let ()
                                          (declare (not safe))
                                          (##vector-ref _g312598_ 0)))
                                       (_token268873_
                                        (let ()
                                          (declare (not safe))
                                          (##vector-ref _g312598_ 1))))
                                   (begin
                                     (if __class312517
                                         (let ()
                                           (declare (not safe))
                                           (##unchecked-structure-set!
                                            _self268848_
                                            _token268873_
                                            '6
                                            std/db/postgresql#postgresql-command::t
                                            '#f))
                                         (error '"Type error; concrete type is not a subclass of expected type"
                                                std/db/postgresql#postgresql-command::t
                                                _self268848_))
                                     (if __class312517
                                         (let ()
                                           (declare (not safe))
                                           (##unchecked-structure-set!
                                            _self268848_
                                            _inp268872_
                                            '5
                                            std/db/postgresql#postgresql-command::t
                                            '#f))
                                         (error '"Type error; concrete type is not a subclass of expected type"
                                                std/db/postgresql#postgresql-command::t
                                                _self268848_)))))))))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _self268850268862_
                            'std/db/postgresql#postgresql-query::t))
                         (let* ((_e268854268878_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '1)))
                                (_e268855268881_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '2)))
                                (_conn268884_ _e268855268881_)
                                (_e268856268886_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '3)))
                                (_e268857268889_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '4)))
                                (_e268858268892_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '5)))
                                (_e268859268895_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '6)))
                                (_e268860268898_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268850268862_ '7)))
                                (_str268901_ _e268860268898_))
                           (_K268853268875_ _str268901_ _conn268884_))
                         (_E268852268866_))))))))
        (if __class312517
            std/db/postgresql#postgresql-query::query-start::specialize::unchecked
            __specializer312518))))
  (define std/db/postgresql#postgresql-query::query-start::specialize::unchecked
    (lambda (_self268848_)
      (std/db/postgresql#wrap-notice-handler
       _self268848_
       (lambda ()
         (let* ((_self268850268862_ _self268848_)
                (_E268852268866_
                 (lambda () (error '"No clause matching" _self268850268862_)))
                (_K268853268875_
                 (lambda (_str268869_ _conn268870_)
                   (let ((_g312600_
                          (std/db/postgresql-driver#postgresql-simple-query!
                           _conn268870_
                           _str268869_)))
                     (begin
                       (let ((_g312601_
                              (let ()
                                (declare (not safe))
                                (if (##values? _g312600_)
                                    (##vector-length _g312600_)
                                    1))))
                         (if (not (let ()
                                    (declare (not safe))
                                    (##fx= _g312601_ 2)))
                             (error "Context expects 2 values" _g312601_)))
                       (let ((_inp268872_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312600_ 0)))
                             (_token268873_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312600_ 1))))
                         (begin
                           (let ()
                             (declare (not safe))
                             (##unchecked-structure-set!
                              _self268848_
                              _token268873_
                              '6
                              std/db/postgresql#postgresql-command::t
                              '#f))
                           (let ()
                             (declare (not safe))
                             (##unchecked-structure-set!
                              _self268848_
                              _inp268872_
                              '5
                              std/db/postgresql#postgresql-command::t
                              '#f)))))))))
           (if (let ()
                 (declare (not safe))
                 (##structure-direct-instance-of?
                  _self268850268862_
                  'std/db/postgresql#postgresql-query::t))
               (let* ((_e268854268878_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '1)))
                      (_e268855268881_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '2)))
                      (_conn268884_ _e268855268881_)
                      (_e268856268886_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '3)))
                      (_e268857268889_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '4)))
                      (_e268858268892_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '5)))
                      (_e268859268895_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '6)))
                      (_e268860268898_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268850268862_ '7)))
                      (_str268901_ _e268860268898_))
                 (_K268853268875_ _str268901_ _conn268884_))
               (_E268852268866_)))))))
  (bind-specializer!
   std/db/postgresql#postgresql-query::query-start
   std/db/postgresql#postgresql-query::query-start::specialize)
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'query-start
   std/db/postgresql#postgresql-query::query-start
   '#f)
  (define std/db/postgresql#postgresql-query::query-fetch
    (lambda (_self268643_)
      (letrec* ((_greedy-in268645_ '#f))
        (std/db/postgresql#wrap-notice-handler
         _self268643_
         (lambda ()
           (let* ((_self268647268661_ _self268643_)
                  (_E268649268665_
                   (lambda ()
                     (error '"No clause matching" _self268647268661_)))
                  (_K268650268686_
                   (lambda (_greedy268668_
                            _cmd268669_
                            _token268670_
                            _inp268671_
                            _conn268672_)
                     (if (not _inp268671_)
                         std/iter#iter-end
                         (let _again268674_ ()
                           (let ((_next268677_
                                  (std/misc/channel#channel-get__0
                                   _inp268671_)))
                             (if (eof-object? _next268677_)
                                 (begin
                                   (##structure-set!
                                    _self268643_
                                    '#f
                                    '6
                                    std/db/postgresql#postgresql-command::t
                                    '#f)
                                   (##structure-set!
                                    _self268643_
                                    '#f
                                    '5
                                    std/db/postgresql#postgresql-command::t
                                    '#f)
                                   (##structure-set!
                                    _self268643_
                                    '#t
                                    '3
                                    std/db/postgresql#postgresql-command::t
                                    '#f)
                                   std/iter#iter-end)
                                 (if (exception? _next268677_)
                                     (raise _next268677_)
                                     (if (let ()
                                           (declare (not safe))
                                           (##structure-direct-instance-of?
                                            _next268677_
                                            'std/actor/proto#!token::t))
                                         (begin
                                           (std/db/postgresql-driver#postgresql-continue!
                                            (##structure-ref
                                             _self268643_
                                             '2
                                             std/db/postgresql#postgresql-command::t
                                             '#f)
                                            _next268677_)
                                           (_again268674_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##structure-direct-instance-of?
                                                _next268677_
                                                'std/db/postgresql-driver#postgresql-CommandComplete::t))
                                             (let ((_comp268679_
                                                    (##structure-ref
                                                     _next268677_
                                                     '2
                                                     std/db/postgresql-driver#postgresql-message::t
                                                     '#f)))
                                               (if (and _cmd268669_
                                                        (not _greedy268668_))
                                                   (##structure-set!
                                                    _cmd268669_
                                                    '#f
                                                    '5
                                                    std/db/postgresql#postgresql-command::t
                                                    '#f)
                                                   '#!void)
                                               (if _greedy-in268645_
                                                   (begin
                                                     (std/misc/channel#channel-sync
                                                      _greedy-in268645_
                                                      _next268677_)
                                                     (set! _greedy-in268645_
                                                           '#f))
                                                   '#!void)
                                               (if (or (not _cmd268669_)
                                                       (##structure-ref
                                                        _cmd268669_
                                                        '3
                                                        std/db/postgresql#postgresql-command::t
                                                        '#f))
                                                   (##direct-structure-set!
                                                    _self268643_
                                                    (let ((__obj312573
                                                           (make-object
                                                            std/db/postgresql#postgresql-command::t
                                                            '6)))
                                                      (std/db/postgresql#postgresql-command:::init!__%
                                                       '#f
                                                       absent-value
                                                       _comp268679_
                                                       __obj312573
                                                       _conn268672_)
                                                      __obj312573)
                                                    '8
                                                    std/db/postgresql#postgresql-query::t
                                                    '#f)
                                                   (##structure-set!
                                                    _cmd268669_
                                                    _comp268679_
                                                    '3
                                                    std/db/postgresql#postgresql-command::t
                                                    '#f))
                                               (if (not _greedy268668_)
                                                   (begin
                                                     (##direct-structure-set!
                                                      _self268643_
                                                      '#f
                                                      '8
                                                      std/db/postgresql#postgresql-query::t
                                                      '#f)
                                                     (set! _cmd268669_ '#f)
                                                     (_again268674_))
                                                   '#!void))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##structure-direct-instance-of?
                                                    _next268677_
                                                    'std/db/postgresql-driver#postgresql-RowDescription::t))
                                                 (let ((_stmt268684_
                                                        (let ((__obj312574
                                                               (make-object
                                                                std/db/postgresql#postgresql-statement::t
                                                                '10)))
                                                          (std/db/postgresql#postgresql-statement:::init!__%
                                                           '#f
                                                           absent-value
                                                           absent-value
                                                           __obj312574
                                                           _conn268672_
                                                           (##structure-ref
                                                            _next268677_
                                                            '2
                                                            std/db/postgresql-driver#postgresql-message::t
                                                            '#f))
                                                          __obj312574)))
                                                   (##direct-structure-set!
                                                    _self268643_
                                                    _stmt268684_
                                                    '8
                                                    std/db/postgresql#postgresql-query::t
                                                    '#f)
                                                   (set! _cmd268669_
                                                         _stmt268684_)
                                                   (if (not _greedy268668_)
                                                       (begin
                                                         (##structure-set!
                                                          _stmt268684_
                                                          _inp268671_
                                                          '5
                                                          std/db/postgresql#postgresql-command::t
                                                          '#f)
                                                         '#!void)
                                                       (begin
                                                         (set! _greedy-in268645_
                                                               (let ((__obj312575
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (make-object std/misc/channel#channel::t '5)))
                         (std/misc/channel#channel:::init!__0 __obj312575)
                         __obj312575))
                 (##structure-set!
                  _stmt268684_
                  _greedy-in268645_
                  '5
                  std/db/postgresql#postgresql-command::t
                  '#f)
                 (_again268674_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (begin
                                                   (if _greedy-in268645_
                                                       (std/misc/channel#channel-sync
                                                        _greedy-in268645_
                                                        _next268677_)
                                                       '#!void)
                                                   (_again268674_)))))))))))))
             (if (let ()
                   (declare (not safe))
                   (##structure-direct-instance-of?
                    _self268647268661_
                    'std/db/postgresql#postgresql-query::t))
                 (let* ((_e268651268689_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '1)))
                        (_e268652268692_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '2)))
                        (_conn268695_ _e268652268692_)
                        (_e268653268697_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '3)))
                        (_e268654268700_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '4)))
                        (_e268655268703_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '5)))
                        (_inp268706_ _e268655268703_)
                        (_e268656268708_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '6)))
                        (_token268711_ _e268656268708_)
                        (_e268657268713_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '7)))
                        (_e268658268716_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '8)))
                        (_cmd268719_ _e268658268716_)
                        (_e268659268721_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268647268661_ '9)))
                        (_greedy268724_ _e268659268721_))
                   (_K268650268686_
                    _greedy268724_
                    _cmd268719_
                    _token268711_
                    _inp268706_
                    _conn268695_))
                 (_E268649268665_))))))))
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'query-fetch
   std/db/postgresql#postgresql-query::query-fetch
   '#f)
  (define std/db/postgresql#catalog::t
    (make-struct-type
     'std/db/postgresql#catalog::t
     '#f
     '2
     'catalog
     '((final: . #t))
     ':init!
     '(s d)))
  (define std/db/postgresql#catalog?
    (make-struct-predicate std/db/postgresql#catalog::t))
  (define std/db/postgresql#make-catalog
    (lambda _$args268518_
      (apply make-struct-instance std/db/postgresql#catalog::t _$args268518_)))
  (define std/db/postgresql#catalog-s
    (make-struct-field-accessor std/db/postgresql#catalog::t '0))
  (define std/db/postgresql#catalog-d
    (make-struct-field-accessor std/db/postgresql#catalog::t '1))
  (define std/db/postgresql#catalog-s-set!
    (make-struct-field-mutator std/db/postgresql#catalog::t '0))
  (define std/db/postgresql#catalog-d-set!
    (make-struct-field-mutator std/db/postgresql#catalog::t '1))
  (define std/db/postgresql#catalog:::init!
    (lambda (_self268510_ . _mixin268511_)
      (let ((_s268513_ (make-table 'test: eq?))
            (_d268514_ (make-table 'test: eq?)))
        (for-each
         (lambda (_mixin268516_)
           (hash-merge!
            _s268513_
            (##direct-structure-ref
             _mixin268516_
             '1
             std/db/postgresql#catalog::t
             '#f))
           (hash-merge!
            _d268514_
            (##direct-structure-ref
             _mixin268516_
             '2
             std/db/postgresql#catalog::t
             '#f)))
         _mixin268511_)
        (if (let ((__tmp312602
                   (let ()
                     (declare (not safe))
                     (##vector-length _self268510_))))
              (declare (not safe))
              (##fx< '2 __tmp312602))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self268510_ '1 _s268513_))
              (let ()
                (declare (not safe))
                (##vector-set! _self268510_ '2 _d268514_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self268510_)))))
  (bind-method!
   std/db/postgresql#catalog::t
   ':init!
   std/db/postgresql#catalog:::init!
   '#f)
  (define std/db/postgresql#catalog-serializer
    (lambda (_c268385_ _oid268386_)
      (table-ref
       (##direct-structure-ref _c268385_ '1 std/db/postgresql#catalog::t '#f)
       _oid268386_
       '#f)))
  (define std/db/postgresql#catalog-deserializer
    (lambda (_c268382_ _oid268383_)
      (table-ref
       (##direct-structure-ref _c268382_ '2 std/db/postgresql#catalog::t '#f)
       _oid268383_
       '#f)))
  (define std/db/postgresql#serialize-boolean
    (lambda (_arg268380_) (if _arg268380_ '"t" '"f")))
  (define std/db/postgresql#deserialize-boolean
    (lambda (_str268378_)
      (if (member _str268378_ '("t" "true" "TRUE" "y" "yes" "on" "1"))
          '#t
          '#f)))
  (define std/db/postgresql#serialize-date
    (lambda (_date268376_)
      (std/srfi/19#date->string _date268376_ '"~Y-~m-~d")))
  (define std/db/postgresql#deserialize-date
    (lambda (_str268374_) (std/srfi/19#string->date _str268374_ '"~Y-~m-~d")))
  (define std/db/postgresql#serialize-timestamp
    (lambda (_date268372_)
      (std/srfi/19#date->string _date268372_ '"~Y-~m-~d ~H:~M:~S")))
  (define std/db/postgresql#deserialize-timestamp
    (lambda (_str268370_)
      (std/srfi/19#string->date _str268370_ '"~Y-~m-~d ~H:~M:~S")))
  (define std/db/postgresql#serialize-timestamptz
    (lambda (_date268368_)
      (std/srfi/19#date->string _date268368_ '"~Y-~m-~d ~H:~M:~S~z")))
  (define std/db/postgresql#deserialize-timestamptz
    (lambda (_str268366_)
      (std/srfi/19#string->date _str268366_ '"~Y-~m-~d ~H:~M:~S~z")))
  (define std/db/postgresql#identity-string
    (lambda (_obj268364_)
      (if (string? _obj268364_)
          _obj268364_
          (error '"Bad argument; expected string" _obj268364_))))
  (define std/db/postgresql#default-catalog
    (let ((__obj312576 (make-object std/db/postgresql#catalog::t '2)))
      (std/db/postgresql#catalog:::init! __obj312576)
      __obj312576))
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '16
   std/db/postgresql#serialize-boolean)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '16
   std/db/postgresql#deserialize-boolean)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '20
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '21
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '23
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '700
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '701
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1700
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '20
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '21
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '23
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '700
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '701
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1700
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '18
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '25
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1042
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1043
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '18
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '25
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1042
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1043
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1082
   std/db/postgresql#serialize-date)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1082
   std/db/postgresql#deserialize-date)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1114
   std/db/postgresql#serialize-timestamp)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1114
   std/db/postgresql#deserialize-timestamp)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1184
   std/db/postgresql#serialize-timestamptz)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1184
   std/db/postgresql#deserialize-timestamptz)
  (define std/db/postgresql#current-catalog
    (make-parameter std/db/postgresql#default-catalog)))
