(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/sqlite#sqlite-connection::t
    (make-struct-type
     'std/db/sqlite#sqlite-connection::t
     std/db/dbi#connection::t
     '0
     'sqlite-connection
     '((final: . #t))
     '#f
     '()))
  (define std/db/sqlite#sqlite-connection?
    (make-struct-predicate std/db/sqlite#sqlite-connection::t))
  (define std/db/sqlite#make-sqlite-connection
    (lambda _$args274205_
      (apply make-struct-instance
             std/db/sqlite#sqlite-connection::t
             _$args274205_)))
  (define std/db/sqlite#sqlite-statement::t
    (make-struct-type
     'std/db/sqlite#sqlite-statement::t
     std/db/dbi#statement::t
     '0
     'sqlite-statement
     '((final: . #t))
     '#f
     '()))
  (define std/db/sqlite#sqlite-statement?
    (make-struct-predicate std/db/sqlite#sqlite-statement::t))
  (define std/db/sqlite#make-sqlite-statement
    (lambda _$args274202_
      (apply make-struct-instance
             std/db/sqlite#sqlite-statement::t
             _$args274202_)))
  (define std/db/sqlite#sqlite-connection:::init!
    std/db/dbi#connection:::init!)
  (bind-method!
   std/db/sqlite#sqlite-connection::t
   ':init!
   std/db/sqlite#sqlite-connection:::init!
   '#f)
  (define std/db/sqlite#raise-sqlite-error
    (lambda (_where274075_ _err274076_)
      (let ((_errstr274078_ (std/db/_sqlite#sqlite3_errstr _err274076_)))
        (std/db/dbi#raise-sql-error
         _where274075_
         (std/format#format '"SQLite error: ~a" _errstr274078_)
         _err274076_))))
  (define std/db/sqlite#sqlite-open__%
    (lambda (_file274057_ _flags274058_)
      (let* ((_ptr274060_ (std/db/_sqlite#make_sqlite3_ptr_ptr))
             (_r274062_
              (std/db/_sqlite#sqlite3_open
               _ptr274060_
               _file274057_
               _flags274058_)))
        (if (let ()
              (declare (not safe))
              (##fx= _r274062_ std/db/_sqlite#SQLITE_OK))
            (let ((__obj312681
                   (make-object std/db/sqlite#sqlite-connection::t '4)))
              (if (let ((__tmp312682
                         (let ()
                           (declare (not safe))
                           (##vector-length __obj312681))))
                    (declare (not safe))
                    (##fx< '1 __tmp312682))
                  (let ((__tmp312683 (std/db/_sqlite#sqlite3_ptr _ptr274060_)))
                    (declare (not safe))
                    (##vector-set! __obj312681 '1 __tmp312683))
                  (error '"struct-instance-init!: too many arguments for struct"
                         __obj312681))
              __obj312681)
            (std/db/sqlite#raise-sqlite-error 'sqlite-open _r274062_)))))
  (define std/db/sqlite#sqlite-open__0
    (lambda (_file274068_)
      (let ((_flags274070_
             (fxior std/db/_sqlite#SQLITE_OPEN_READWRITE
                    std/db/_sqlite#SQLITE_OPEN_CREATE)))
        (std/db/sqlite#sqlite-open__% _file274068_ _flags274070_))))
  (define std/db/sqlite#sqlite-open
    (lambda _g312685_
      (let ((_g312684_ (let () (declare (not safe)) (##length _g312685_))))
        (cond ((let () (declare (not safe)) (##fx= _g312684_ 1))
               (apply std/db/sqlite#sqlite-open__0 _g312685_))
              ((let () (declare (not safe)) (##fx= _g312684_ 2))
               (apply std/db/sqlite#sqlite-open__% _g312685_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/sqlite#sqlite-open
                _g312685_))))))
  (define std/db/sqlite#sqlite-connection::close
    (lambda (_self274054_)
      (std/db/_sqlite#sqlite3_close
       (##structure-ref _self274054_ '1 std/db/dbi#connection::t '#f))))
  (define std/db/sqlite#sqlite-connection::close::specialize
    (lambda (__t312666)
      (let* ((__class312667
              (struct-subtype? std/db/dbi#connection::t __t312666))
             (__specializer312668
              (lambda (_self274054_)
                (std/db/_sqlite#sqlite3_close
                 (if __class312667
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self274054_
                        '1
                        std/db/dbi#connection::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#connection::t
                            _self274054_))))))
        (if __class312667
            std/db/sqlite#sqlite-connection::close::specialize::unchecked
            __specializer312668))))
  (define std/db/sqlite#sqlite-connection::close::specialize::unchecked
    (lambda (_self274054_)
      (std/db/_sqlite#sqlite3_close
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self274054_
          '1
          std/db/dbi#connection::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-connection::close
   std/db/sqlite#sqlite-connection::close::specialize)
  (bind-method!
   std/db/sqlite#sqlite-connection::t
   'close
   std/db/sqlite#sqlite-connection::close
   '#f)
  (define std/db/sqlite#sqlite-connection::prepare
    (lambda (_self273924_ _sql273925_)
      (let* ((_ptr273927_ (std/db/_sqlite#make_sqlite3_stmt_ptr_ptr))
             (_r273929_
              (std/db/_sqlite#sqlite3_prepare
               _ptr273927_
               (##structure-ref _self273924_ '1 std/db/dbi#connection::t '#f)
               _sql273925_)))
        (if (let ()
              (declare (not safe))
              (##fx= _r273929_ std/db/_sqlite#SQLITE_OK))
            (let ((__tmp312686 (std/db/_sqlite#sqlite3_stmt_ptr _ptr273927_)))
              (declare (not safe))
              (##structure std/db/sqlite#sqlite-statement::t __tmp312686))
            (std/db/sqlite#raise-sqlite-error 'sqlite-prepare _r273929_)))))
  (define std/db/sqlite#sqlite-connection::prepare::specialize
    (lambda (__t312669)
      (let* ((__class312670
              (struct-subtype? std/db/dbi#connection::t __t312669))
             (__specializer312671
              (lambda (_self273924_ _sql273925_)
                (let* ((_ptr273927_ (std/db/_sqlite#make_sqlite3_stmt_ptr_ptr))
                       (_r273929_
                        (std/db/_sqlite#sqlite3_prepare
                         _ptr273927_
                         (if __class312670
                             (let ()
                               (declare (not safe))
                               (##unchecked-structure-ref
                                _self273924_
                                '1
                                std/db/dbi#connection::t
                                '#f))
                             (error '"Type error; concrete type is not a subclass of expected type"
                                    std/db/dbi#connection::t
                                    _self273924_))
                         _sql273925_)))
                  (if (let ()
                        (declare (not safe))
                        (##fx= _r273929_ std/db/_sqlite#SQLITE_OK))
                      (let ((__tmp312687
                             (std/db/_sqlite#sqlite3_stmt_ptr _ptr273927_)))
                        (declare (not safe))
                        (##structure
                         std/db/sqlite#sqlite-statement::t
                         __tmp312687))
                      (std/db/sqlite#raise-sqlite-error
                       'sqlite-prepare
                       _r273929_))))))
        (if __class312670
            std/db/sqlite#sqlite-connection::prepare::specialize::unchecked
            __specializer312671))))
  (define std/db/sqlite#sqlite-connection::prepare::specialize::unchecked
    (lambda (_self273924_ _sql273925_)
      (let* ((_ptr273927_ (std/db/_sqlite#make_sqlite3_stmt_ptr_ptr))
             (_r273929_
              (std/db/_sqlite#sqlite3_prepare
               _ptr273927_
               (let ()
                 (declare (not safe))
                 (##unchecked-structure-ref
                  _self273924_
                  '1
                  std/db/dbi#connection::t
                  '#f))
               _sql273925_)))
        (if (let ()
              (declare (not safe))
              (##fx= _r273929_ std/db/_sqlite#SQLITE_OK))
            (let ((__tmp312688 (std/db/_sqlite#sqlite3_stmt_ptr _ptr273927_)))
              (declare (not safe))
              (##structure std/db/sqlite#sqlite-statement::t __tmp312688))
            (std/db/sqlite#raise-sqlite-error 'sqlite-prepare _r273929_)))))
  (bind-specializer!
   std/db/sqlite#sqlite-connection::prepare
   std/db/sqlite#sqlite-connection::prepare::specialize)
  (bind-method!
   std/db/sqlite#sqlite-connection::t
   'prepare
   std/db/sqlite#sqlite-connection::prepare
   '#f)
  (define std/db/sqlite#sqlite-statement::finalize
    (lambda (_self273800_)
      (std/db/_sqlite#sqlite3_finalize
       (##structure-ref _self273800_ '1 std/db/dbi#statement::t '#f))))
  (define std/db/sqlite#sqlite-statement::finalize::specialize
    (lambda (__t312672)
      (let* ((__class312673
              (struct-subtype? std/db/dbi#statement::t __t312672))
             (__specializer312674
              (lambda (_self273800_)
                (std/db/_sqlite#sqlite3_finalize
                 (if __class312673
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self273800_
                        '1
                        std/db/dbi#statement::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#statement::t
                            _self273800_))))))
        (if __class312673
            std/db/sqlite#sqlite-statement::finalize::specialize::unchecked
            __specializer312674))))
  (define std/db/sqlite#sqlite-statement::finalize::specialize::unchecked
    (lambda (_self273800_)
      (std/db/_sqlite#sqlite3_finalize
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self273800_
          '1
          std/db/dbi#statement::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-statement::finalize
   std/db/sqlite#sqlite-statement::finalize::specialize)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'finalize
   std/db/sqlite#sqlite-statement::finalize
   '#f)
  (define std/db/sqlite#sqlite-statement::bind
    (lambda (_self273573_ . _args273574_)
      (let* ((_self273575273581_ _self273573_)
             (_E273577273585_
              (lambda () (error '"No clause matching" _self273575273581_)))
             (_K273578273670_
              (lambda (_stmt273588_)
                (let* ((_params273590_
                        (std/db/_sqlite#sqlite3_bind_parameter_count
                         _stmt273588_))
                       (_g312689_
                        (if (= _params273590_ (length _args273574_))
                            '#!void
                            (error '"bind parameters do not match statement count"
                                   _args273574_
                                   _params273590_))))
                  (let* ((_g273593273600_ (std/iter#iter _args273574_))
                         (_g273594273603_
                          (std/iter#iter
                           (std/iter#in-iota__1 _params273590_ '1)))
                         (_g273595273606_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _g273593273600_
                             '2
                             std/iter#iterator::t
                             '#f)))
                         (_g273596273609_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _g273594273603_
                             '2
                             std/iter#iterator::t
                             '#f)))
                         (_iter-do273641_
                          (lambda (_g273597273612_ _g273598273614_)
                            (let ((_g273616273622_ _g273597273612_)
                                  (_g273617273624_ _g273598273614_))
                              (let* ((_E273619273628_
                                      (lambda ()
                                        (error '"No clause matching"
                                               _g273616273622_
                                               _g273617273624_)))
                                     (_K273620273634_
                                      (lambda (_arg273631_ _param273632_)
                                        (if (not _arg273631_)
                                            (std/db/_sqlite#sqlite3_bind_null
                                             _stmt273588_
                                             _param273632_)
                                            (if (number? _arg273631_)
                                                (if (integer? _arg273631_)
                                                    (if (< (abs _arg273631_)
                                                           (expt '2 '32))
                                                        (std/db/_sqlite#sqlite3_bind_int
                                                         _stmt273588_
                                                         _param273632_
                                                         _arg273631_)
                                                        (std/db/_sqlite#sqlite3_bind_int64
                                                         _stmt273588_
                                                         _param273632_
                                                         _arg273631_))
                                                    (if (real? _arg273631_)
                                                        (std/db/_sqlite#sqlite3_bind_double
                                                         _stmt273588_
                                                         _param273632_
                                                         (exact->inexact
                                                          _arg273631_))
                                                        (error '"cannot bind number; not a real"
                                                               _arg273631_)))
                                                (if (string? _arg273631_)
                                                    (std/db/_sqlite#sqlite3_bind_text
                                                     _stmt273588_
                                                     _param273632_
                                                     _arg273631_)
                                                    (if (u8vector? _arg273631_)
                                                        (std/db/_sqlite#sqlite3_bind_blob
                                                         _stmt273588_
                                                         _param273632_
                                                         _arg273631_)
                                                        (if error
                                                            _arg273631_
                                                            '#!void)))))))
                                     (_arg273637_ _g273616273622_)
                                     (_param273639_ _g273617273624_))
                                (_K273620273634_
                                 _arg273637_
                                 _param273639_))))))
                    (declare (not safe))
                    (begin
                      (let _lp273646_ ()
                        (let ((_g273597273650_
                               (_g273595273606_ _g273593273600_))
                              (_g273598273651_
                               (_g273596273609_ _g273594273603_)))
                          (if (or (eq? std/iter#iter-end _g273597273650_)
                                  (eq? std/iter#iter-end _g273598273651_))
                              '#!void
                              (begin
                                (_iter-do273641_
                                 _g273597273650_
                                 _g273598273651_)
                                (_lp273646_)))))
                      (let ((_$e273656_
                             (##unchecked-structure-ref
                              _g273593273600_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e273656_
                            ((lambda (_g273658273660_)
                               (_g273658273660_ _g273593273600_))
                             _$e273656_)
                            '#!void))
                      (let ((_$e273663_
                             (##unchecked-structure-ref
                              _g273594273603_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e273663_
                            ((lambda (_g273665273667_)
                               (_g273665273667_ _g273594273603_))
                             _$e273663_)
                            '#!void))
                      '#!void))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self273575273581_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e273579273673_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self273575273581_ '1)))
                   (_stmt273676_ _e273579273673_))
              (_K273578273670_ _stmt273676_))
            (_E273577273585_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'bind
   std/db/sqlite#sqlite-statement::bind
   '#f)
  (define std/db/sqlite#sqlite-statement::clear
    (lambda (_self273449_)
      (std/db/_sqlite#sqlite3_clear_bindings
       (##structure-ref _self273449_ '1 std/db/dbi#statement::t '#f))))
  (define std/db/sqlite#sqlite-statement::clear::specialize
    (lambda (__t312675)
      (let* ((__class312676
              (struct-subtype? std/db/dbi#statement::t __t312675))
             (__specializer312677
              (lambda (_self273449_)
                (std/db/_sqlite#sqlite3_clear_bindings
                 (if __class312676
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self273449_
                        '1
                        std/db/dbi#statement::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#statement::t
                            _self273449_))))))
        (if __class312676
            std/db/sqlite#sqlite-statement::clear::specialize::unchecked
            __specializer312677))))
  (define std/db/sqlite#sqlite-statement::clear::specialize::unchecked
    (lambda (_self273449_)
      (std/db/_sqlite#sqlite3_clear_bindings
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self273449_
          '1
          std/db/dbi#statement::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-statement::clear
   std/db/sqlite#sqlite-statement::clear::specialize)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'clear
   std/db/sqlite#sqlite-statement::clear
   '#f)
  (define std/db/sqlite#sqlite-statement::reset
    (lambda (_self273325_)
      (std/db/_sqlite#sqlite3_reset
       (##structure-ref _self273325_ '1 std/db/dbi#statement::t '#f))))
  (define std/db/sqlite#sqlite-statement::reset::specialize
    (lambda (__t312678)
      (let* ((__class312679
              (struct-subtype? std/db/dbi#statement::t __t312678))
             (__specializer312680
              (lambda (_self273325_)
                (std/db/_sqlite#sqlite3_reset
                 (if __class312679
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self273325_
                        '1
                        std/db/dbi#statement::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#statement::t
                            _self273325_))))))
        (if __class312679
            std/db/sqlite#sqlite-statement::reset::specialize::unchecked
            __specializer312680))))
  (define std/db/sqlite#sqlite-statement::reset::specialize::unchecked
    (lambda (_self273325_)
      (std/db/_sqlite#sqlite3_reset
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self273325_
          '1
          std/db/dbi#statement::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-statement::reset
   std/db/sqlite#sqlite-statement::reset::specialize)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'reset
   std/db/sqlite#sqlite-statement::reset
   '#f)
  (define std/db/sqlite#sqlite-statement::exec
    (lambda (_self273174_)
      (let* ((_self273175273181_ _self273174_)
             (_E273177273185_
              (lambda () (error '"No clause matching" _self273175273181_)))
             (_K273178273195_
              (lambda (_stmt273188_)
                (let ((_r273190_ (std/db/_sqlite#sqlite3_step _stmt273188_)))
                  (if (or (eq? _r273190_ std/db/_sqlite#SQLITE_DONE)
                          (eq? _r273190_ std/db/_sqlite#SQLITE_ROW))
                      '#!void
                      (std/db/sqlite#raise-sqlite-error
                       'sqlite-exec
                       _r273190_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self273175273181_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e273179273198_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self273175273181_ '1)))
                   (_stmt273201_ _e273179273198_))
              (_K273178273195_ _stmt273201_))
            (_E273177273185_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'exec
   std/db/sqlite#sqlite-statement::exec
   '#f)
  (define std/db/sqlite#sqlite-statement::query-start void)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-start
   std/db/sqlite#sqlite-statement::query-start
   '#f)
  (define std/db/sqlite#sqlite-statement::query-fetch
    (lambda (_self272904_)
      (let* ((_self272905272911_ _self272904_)
             (_E272907272915_
              (lambda () (error '"No clause matching" _self272905272911_)))
             (_K272908272922_
              (lambda (_stmt272918_)
                (let ((_r272920_ (std/db/_sqlite#sqlite3_step _stmt272918_)))
                  (if (eq? _r272920_ std/db/_sqlite#SQLITE_ROW)
                      '#!void
                      (if (eq? _r272920_ std/db/_sqlite#SQLITE_DONE)
                          std/iter#iter-end
                          (std/db/sqlite#raise-sqlite-error
                           'sqlite-query-fetch
                           _r272920_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self272905272911_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e272909272925_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self272905272911_ '1)))
                   (_stmt272928_ _e272909272925_))
              (_K272908272922_ _stmt272928_))
            (_E272907272915_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-fetch
   std/db/sqlite#sqlite-statement::query-fetch
   '#f)
  (define std/db/sqlite#sqlite-statement::query-row
    (lambda (_self272712_)
      (let* ((_self272713272719_ _self272712_)
             (_E272715272723_
              (lambda () (error '"No clause matching" _self272713272719_)))
             (_K272716272774_
              (lambda (_stmt272726_)
                (letrec ((_column-e272728_
                          (lambda (_col272765_)
                            (let ((_t272767_
                                   (std/db/_sqlite#sqlite3_column_type
                                    _stmt272726_
                                    _col272765_)))
                              (if (eq? _t272767_ std/db/_sqlite#SQLITE_INTEGER)
                                  (std/db/_sqlite#sqlite3_column_int64
                                   _stmt272726_
                                   _col272765_)
                                  (if (eq? _t272767_
                                           std/db/_sqlite#SQLITE_FLOAT)
                                      (std/db/_sqlite#sqlite3_column_double
                                       _stmt272726_
                                       _col272765_)
                                      (if (eq? _t272767_
                                               std/db/_sqlite#SQLITE_TEXT)
                                          (std/db/_sqlite#sqlite3_column_text
                                           _stmt272726_
                                           _col272765_)
                                          (if (eq? _t272767_
                                                   std/db/_sqlite#SQLITE_NULL)
                                              '#f
                                              (if (eq? _t272767_
                                                       std/db/_sqlite#SQLITE_BLOB)
                                                  (let* ((_count272769_
                                                          (std/db/_sqlite#sqlite3_column_bytes
                                                           _stmt272726_
                                                           _col272765_))
                                                         (_bytes272771_
                                                          (make-u8vector
                                                           _count272769_)))
                                                    (std/db/_sqlite#sqlite3_column_blob
                                                     _stmt272726_
                                                     _col272765_
                                                     _bytes272771_)
                                                    _bytes272771_)
                                                  (error '"Unexpected column type"
                                                         _t272767_))))))))))
                  (let* ((_count272730_
                          (std/db/_sqlite#sqlite3_column_count _stmt272726_))
                         (_$e272732_ _count272730_))
                    (if (eq? '0 _$e272732_)
                        '#!void
                        (if (eq? '1 _$e272732_)
                            (_column-e272728_ '0)
                            (list->vector
                             (let ((_iter-do272740_
                                    (lambda (_n272735_)
                                      (let ((_x272738_ _n272735_))
                                        (_column-e272728_ _x272738_))))
                                   (_$count272742_ _count272730_)
                                   (_$start272744_ '0)
                                   (_$step272746_ '1))
                               (let ((_root272749_ (cons '#f '())))
                                 (let _lp272752_ ((_i272755_ '0)
                                                  (_val272757_ _$start272744_)
                                                  (_tl272759_ _root272749_))
                                   (if (fx< _i272755_ _$count272742_)
                                       (_lp272752_
                                        (let ()
                                          (declare (not safe))
                                          (##fx+ _i272755_ '1))
                                        (+ _val272757_ _$step272746_)
                                        (let ((_tl*272762_
                                               (cons (_iter-do272740_
                                                      _val272757_)
                                                     '())))
                                          (let ()
                                            (declare (not safe))
                                            (##set-cdr!
                                             _tl272759_
                                             _tl*272762_))
                                          _tl*272762_))
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _root272749_))))))))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self272713272719_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e272717272777_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self272713272719_ '1)))
                   (_stmt272780_ _e272717272777_))
              (_K272716272774_ _stmt272780_))
            (_E272715272723_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-row
   std/db/sqlite#sqlite-statement::query-row
   '#f)
  (define std/db/sqlite#sqlite-statement::query-fini
    std/db/sqlite#sqlite-statement::reset)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-fini
   std/db/sqlite#sqlite-statement::query-fini
   '#f)
  (define std/db/sqlite#sqlite-statement::columns
    (lambda (_self272435_)
      (let* ((_self272436272442_ _self272435_)
             (_E272438272446_
              (lambda () (error '"No clause matching" _self272436272442_)))
             (_K272439272460_
              (lambda (_stmt272449_)
                (let ((_count272451_
                       (std/db/_sqlite#sqlite3_column_count _stmt272449_)))
                  (let _lp272453_ ((_k272455_ '0) (_cols272456_ '()))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _k272455_ _count272451_))
                        (let ((_name272458_
                               (std/db/_sqlite#sqlite3_column_name
                                _stmt272449_
                                _k272455_)))
                          (_lp272453_
                           (let () (declare (not safe)) (##fx+ _k272455_ '1))
                           (cons _name272458_ _cols272456_)))
                        (reverse _cols272456_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self272436272442_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e272440272463_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self272436272442_ '1)))
                   (_stmt272466_ _e272440272463_))
              (_K272439272460_ _stmt272466_))
            (_E272438272446_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'columns
   std/db/sqlite#sqlite-statement::columns
   '#f))
