(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/make#default-gambit-gsc
    '"@@HOMEBREW_PREFIX@@/opt/gambit-scheme/bin/gsc")
  (define std/make#default-gerbil-gxc
    '"@@HOMEBREW_CELLAR@@/gerbil-scheme/0.17_3/bin/gxc")
  (define std/make#force-outputs
    (lambda () (force-output (current-error-port)) (force-output)))
  (define std/make#message
    (lambda _lst41448_ (apply displayln _lst41448_) (std/make#force-outputs)))
  (define std/make#writeln
    (lambda (_x41446_) (write _x41446_) (newline) (std/make#force-outputs)))
  (define std/make#prefix/
    (lambda (_prefix41443_ _path41444_)
      (if _prefix41443_
          (string-append _prefix41443_ '"/" _path41444_)
          _path41444_)))
  (define std/make#vector-for-each
    (lambda (_f41434_ _v41435_)
      (letrec* ((_l41437_ (vector-length _v41435_)))
        (let _loop41439_ ((_i41441_ '0))
          (if (< _i41441_ _l41437_)
              (begin
                (_f41434_ _i41441_ (vector-ref _v41435_ _i41441_))
                (_loop41439_ (+ '1 _i41441_)))
              '#!void)))))
  (define std/make#vector-ensure-ref
    (lambda (_v41425_ _i41426_ _f41427_)
      (let ((_$e41429_ (vector-ref _v41425_ _i41426_)))
        (if _$e41429_
            _$e41429_
            (let ((_x41432_ (_f41427_)))
              (vector-set! _v41425_ _i41426_ _x41432_)
              _x41432_)))))
  (define std/make#settings::t
    (make-struct-type
     'std/make#settings::t
     '#f
     '13
     'settings
     '((transparent: . #t))
     ':init!
     '(srcdir libdir
              bindir
              prefix
              force
              optimize
              debug
              static
              static-debug
              verbose
              build-deps
              libdir-prefix
              parallelize)))
  (define std/make#settings? (make-struct-predicate std/make#settings::t))
  (define std/make#make-settings
    (lambda _$args41422_
      (apply make-struct-instance std/make#settings::t _$args41422_)))
  (define std/make#settings-srcdir
    (make-struct-field-accessor std/make#settings::t '0))
  (define std/make#settings-libdir
    (make-struct-field-accessor std/make#settings::t '1))
  (define std/make#settings-bindir
    (make-struct-field-accessor std/make#settings::t '2))
  (define std/make#settings-prefix
    (make-struct-field-accessor std/make#settings::t '3))
  (define std/make#settings-force
    (make-struct-field-accessor std/make#settings::t '4))
  (define std/make#settings-optimize
    (make-struct-field-accessor std/make#settings::t '5))
  (define std/make#settings-debug
    (make-struct-field-accessor std/make#settings::t '6))
  (define std/make#settings-static
    (make-struct-field-accessor std/make#settings::t '7))
  (define std/make#settings-static-debug
    (make-struct-field-accessor std/make#settings::t '8))
  (define std/make#settings-verbose
    (make-struct-field-accessor std/make#settings::t '9))
  (define std/make#settings-build-deps
    (make-struct-field-accessor std/make#settings::t '10))
  (define std/make#settings-libdir-prefix
    (make-struct-field-accessor std/make#settings::t '11))
  (define std/make#settings-parallelize
    (make-struct-field-accessor std/make#settings::t '12))
  (define std/make#settings-srcdir-set!
    (make-struct-field-mutator std/make#settings::t '0))
  (define std/make#settings-libdir-set!
    (make-struct-field-mutator std/make#settings::t '1))
  (define std/make#settings-bindir-set!
    (make-struct-field-mutator std/make#settings::t '2))
  (define std/make#settings-prefix-set!
    (make-struct-field-mutator std/make#settings::t '3))
  (define std/make#settings-force-set!
    (make-struct-field-mutator std/make#settings::t '4))
  (define std/make#settings-optimize-set!
    (make-struct-field-mutator std/make#settings::t '5))
  (define std/make#settings-debug-set!
    (make-struct-field-mutator std/make#settings::t '6))
  (define std/make#settings-static-set!
    (make-struct-field-mutator std/make#settings::t '7))
  (define std/make#settings-static-debug-set!
    (make-struct-field-mutator std/make#settings::t '8))
  (define std/make#settings-verbose-set!
    (make-struct-field-mutator std/make#settings::t '9))
  (define std/make#settings-build-deps-set!
    (make-struct-field-mutator std/make#settings::t '10))
  (define std/make#settings-libdir-prefix-set!
    (make-struct-field-mutator std/make#settings::t '11))
  (define std/make#settings-parallelize-set!
    (make-struct-field-mutator std/make#settings::t '12))
  (define std/make#settings:::init!__%
    (lambda (_g304855_
             _srcdir_4132041334_
             _libdir_4132141336_
             _bindir_4132241338_
             _prefix_4132341340_
             _force?4132441342_
             _optimize4132541344_
             _debug4132641346_
             _static4132741348_
             _static-debug4132841350_
             _verbose4132941352_
             _build-deps_4133041354_
             _parallelize_4133141356_
             _self41358_)
      (let* ((_srcdir_41360_
              (if (eq? _srcdir_4132041334_ absent-value)
                  '#f
                  _srcdir_4132041334_))
             (_libdir_41362_
              (if (eq? _libdir_4132141336_ absent-value)
                  '#f
                  _libdir_4132141336_))
             (_bindir_41364_
              (if (eq? _bindir_4132241338_ absent-value)
                  '#f
                  _bindir_4132241338_))
             (_prefix_41366_
              (if (eq? _prefix_4132341340_ absent-value)
                  '#f
                  _prefix_4132341340_))
             (_force?41368_
              (if (eq? _force?4132441342_ absent-value)
                  '#f
                  _force?4132441342_))
             (_optimize41370_
              (if (eq? _optimize4132541344_ absent-value)
                  '#t
                  _optimize4132541344_))
             (_debug41372_
              (if (eq? _debug4132641346_ absent-value) 'env _debug4132641346_))
             (_static41374_
              (if (eq? _static4132741348_ absent-value)
                  '#t
                  _static4132741348_))
             (_static-debug41376_
              (if (eq? _static-debug4132841350_ absent-value)
                  '#f
                  _static-debug4132841350_))
             (_verbose41378_
              (if (eq? _verbose4132941352_ absent-value)
                  '#f
                  _verbose4132941352_))
             (_build-deps_41380_
              (if (eq? _build-deps_4133041354_ absent-value)
                  '#f
                  _build-deps_4133041354_))
             (_parallelize_41382_
              (if (eq? _parallelize_4133141356_ absent-value)
                  '#f
                  _parallelize_4133141356_)))
        (letrec* ((_gerbil-path41384_ (getenv '"GERBIL_PATH" '"~/.gerbil"))
                  (_srcdir41385_
                   (let ((_$e41405_ _srcdir_41360_))
                     (if _$e41405_
                         _$e41405_
                         (error '"srcdir must be specified"))))
                  (_libdir41386_
                   (let ((_$e41402_ _libdir_41362_))
                     (if _$e41402_
                         _$e41402_
                         (path-expand '"lib" _gerbil-path41384_))))
                  (_bindir41387_
                   (let ((_$e41399_ _bindir_41364_))
                     (if _$e41399_
                         _$e41399_
                         (path-expand '"bin" _gerbil-path41384_))))
                  (_prefix41388_
                   (let ((_$e41396_ _prefix_41366_))
                     (if _$e41396_
                         _$e41396_
                         (std/make#read-package-prefix _srcdir41385_))))
                  (_libdir-prefix41389_
                   (if _prefix41388_
                       (path-expand _prefix41388_ _libdir41386_)
                       _libdir41386_))
                  (_build-deps41390_
                   (path-expand
                    (let ((_$e41393_ _build-deps_41380_))
                      (if _$e41393_ _$e41393_ '"build-deps"))
                    _srcdir41385_))
                  (_parallelize41391_
                   (std/make#gerbil-build-cores__% _parallelize41391_)))
          (if (let ((__tmp304856
                     (let ()
                       (declare (not safe))
                       (##vector-length _self41358_))))
                (declare (not safe))
                (##fx< '13 __tmp304856))
              (begin
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '1 _srcdir41385_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '2 _libdir41386_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '3 _bindir41387_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '4 _prefix41388_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '5 _force?41368_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '6 _optimize41370_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '7 _debug41372_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '8 _static41374_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '9 _static-debug41376_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '10 _verbose41378_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '11 _build-deps41390_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '12 _libdir-prefix41389_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41358_ '13 _parallelize41391_)))
              (error '"struct-instance-init!: too many arguments for struct"
                     _self41358_))))))
  (define std/make#settings:::init!__@
    (lambda (_keys4131941411_ . _args41413_)
      (apply std/make#settings:::init!__%
             _keys4131941411_
             (table-ref _keys4131941411_ 'srcdir: absent-value)
             (table-ref _keys4131941411_ 'libdir: absent-value)
             (table-ref _keys4131941411_ 'bindir: absent-value)
             (table-ref _keys4131941411_ 'prefix: absent-value)
             (table-ref _keys4131941411_ 'force: absent-value)
             (table-ref _keys4131941411_ 'optimize: absent-value)
             (table-ref _keys4131941411_ 'debug: absent-value)
             (table-ref _keys4131941411_ 'static: absent-value)
             (table-ref _keys4131941411_ 'static-debug: absent-value)
             (table-ref _keys4131941411_ 'verbose: absent-value)
             (table-ref _keys4131941411_ 'build-deps: absent-value)
             (table-ref _keys4131941411_ 'parallelize: absent-value)
             _args41413_)))
  (define std/make#settings:::init!
    (lambda _args4133241419_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                srcdir:
                #f
                #f
                #f
                #f
                #f
                #f
                force:
                #f
                #f
                #f
                #f
                #f
                libdir:
                #f
                optimize:
                #f
                #f
                #f
                parallelize:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                bindir:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                static:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                prefix:
                build-deps:
                #f
                #f
                #f
                static-debug:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                verbose:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                debug:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f)
             std/make#settings:::init!__@
             _args4133241419_)))
  (bind-method! std/make#settings::t ':init! std/make#settings:::init! '#f)
  (define std/make#gerbil-build-cores__%
    (lambda (_cpu-count-spec41184_)
      (if (real? _cpu-count-spec41184_)
          _cpu-count-spec41184_
          (if (eq? _cpu-count-spec41184_ '#t)
              (with-exception-catcher
               (lambda (_g304857_) '0)
               (lambda () (string->number (getenv '"GERBIL_BUILD_CORES"))))
              '0))))
  (define std/make#gerbil-build-cores__0
    (lambda ()
      (let ((_cpu-count-spec41192_ '#t))
        (std/make#gerbil-build-cores__% _cpu-count-spec41192_))))
  (define std/make#gerbil-build-cores
    (lambda _g304859_
      (let ((_g304858_ (let () (declare (not safe)) (##length _g304859_))))
        (cond ((let () (declare (not safe)) (##fx= _g304858_ 0))
               (apply std/make#gerbil-build-cores__0 _g304859_))
              ((let () (declare (not safe)) (##fx= _g304858_ 1))
               (apply std/make#gerbil-build-cores__% _g304859_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/make#gerbil-build-cores
                _g304859_))))))
  (define std/make#settings-verbose>=?
    (lambda (_settings41178_ _level41179_)
      (letrec* ((_verbose41181_
                 (##structure-ref
                  _settings41178_
                  '10
                  std/make#settings::t
                  '#f)))
        (if (real? _level41179_)
            (if (real? _verbose41181_) (>= _verbose41181_ _level41179_) '#f)
            '#f))))
  (define std/make#read-package-prefix
    (lambda (_srcdir41167_)
      (let* ((_plist41170_
              (with-exception-catcher
               false
               (lambda ()
                 (call-with-input-file
                  (path-expand '"gerbil.pkg" _srcdir41167_)
                  read))))
             (_pkg4117141173_ (pgetq 'package: _plist41170_)))
        (if _pkg4117141173_
            (let ((_pkg41176_ _pkg4117141173_))
              (if (symbol? _pkg41176_) (symbol->string _pkg41176_) '#f))
            '#f))))
  (define std/make#spec-type
    (lambda (_spec41127_)
      (let* ((_spec4112841138_ _spec41127_)
             (_else4113141146_
              (lambda () (error '"Bad buildspec" _spec41127_))))
        (let ((_K4113641164_ (lambda () 'gxc:))
              (_K4113341152_ (lambda (_type41150_) _type41150_)))
          (let ((_try-match4113041160_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec4112841138_))
                       (let ((_hd4113441155_
                              (let ()
                                (declare (not safe))
                                (##car _spec4112841138_))))
                         (if (keyword? _hd4113441155_)
                             (let ((_type41158_ _hd4113441155_))
                               (_K4113341152_ _type41158_))
                             (_else4113141146_)))
                       (_else4113141146_)))))
            (if (string? _spec4112841138_)
                (_K4113641164_)
                (_try-match4113041160_)))))))
  (define std/make#spec-file
    (lambda (_spec40897_ _settings40898_)
      (let* ((_spec4089940947_ _spec40897_)
             (_else4090840955_
              (lambda () (error '"Bad buildspec" _spec40897_))))
        (let ((_K4094541122_
               (lambda (_modf41120_)
                 (std/make#source-path _modf41120_ '".ss" _settings40898_)))
              (_K4094041100_
               (lambda (_opts41097_ _modf41098_)
                 (std/make#source-path _modf41098_ '".ss" _settings40898_)))
              (_K4093541076_
               (lambda (_opts41073_ _modf41074_)
                 (std/make#source-path _modf41074_ '".scm" _settings40898_)))
              (_K4093041052_
               (lambda (_deps41049_ _modf41050_)
                 (std/make#source-path _modf41050_ '".ssi" _settings40898_)))
              (_K4092541028_
               (lambda (_opts41025_ _modf41026_)
                 (std/make#source-path _modf41026_ '".ss" _settings40898_)))
              (_K4092041004_
               (lambda (_opts41001_ _modf41002_)
                 (std/make#source-path _modf41002_ '".ss" _settings40898_)))
              (_K4091540982_
               (lambda (_file40980_)
                 (std/make#static-file-path _file40980_ _settings40898_)))
              (_K4091040961_ (lambda (_file40959_) _file40959_)))
          (let ((_try-match4090141117_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec4089940947_))
                       (let ((_tl4094241105_
                              (let ()
                                (declare (not safe))
                                (##cdr _spec4089940947_)))
                             (_hd4094141103_
                              (let ()
                                (declare (not safe))
                                (##car _spec4089940947_))))
                         (if (let ()
                               (declare (not safe))
                               (##eq? _hd4094141103_ 'gxc:))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _tl4094241105_))
                                 (let ((_tl4094441110_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _tl4094241105_)))
                                       (_hd4094341108_
                                        (let ()
                                          (declare (not safe))
                                          (##car _tl4094241105_))))
                                   (let ((_modf41113_ _hd4094341108_)
                                         (_opts41115_ _tl4094441110_))
                                     (_K4094041100_ _opts41115_ _modf41113_)))
                                 (_else4090840955_))
                             (if (let ()
                                   (declare (not safe))
                                   (##eq? _hd4094141103_ 'gsc:))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl4094241105_))
                                     (let ((_tl4093941086_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl4094241105_)))
                                           (_hd4093841084_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl4094241105_))))
                                       (let ((_modf41089_ _hd4093841084_)
                                             (_opts41091_ _tl4093941086_))
                                         (_K4093541076_
                                          _opts41091_
                                          _modf41089_)))
                                     (_else4090840955_))
                                 (if (let ()
                                       (declare (not safe))
                                       (##eq? _hd4094141103_ 'ssi:))
                                     (if (let ()
                                           (declare (not safe))
                                           (##pair? _tl4094241105_))
                                         (let ((_tl4093441062_
                                                (let ()
                                                  (declare (not safe))
                                                  (##cdr _tl4094241105_)))
                                               (_hd4093341060_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl4094241105_))))
                                           (let ((_modf41065_ _hd4093341060_)
                                                 (_deps41067_ _tl4093441062_))
                                             (_K4093041052_
                                              _deps41067_
                                              _modf41065_)))
                                         (_else4090840955_))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _hd4094141103_ 'exe:))
                                         (if (let ()
                                               (declare (not safe))
                                               (##pair? _tl4094241105_))
                                             (let ((_tl4092941038_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _tl4094241105_)))
                                                   (_hd4092841036_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl4094241105_))))
                                               (let ((_modf41041_
                                                      _hd4092841036_)
                                                     (_opts41043_
                                                      _tl4092941038_))
                                                 (_K4092541028_
                                                  _opts41043_
                                                  _modf41041_)))
                                             (_else4090840955_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##eq? _hd4094141103_
                                                      'static-exe:))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##pair? _tl4094241105_))
                                                 (let ((_tl4092441014_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _tl4094241105_)))
                                                       (_hd4092341012_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl4094241105_))))
                                                   (let ((_modf41017_
                                                          _hd4092341012_)
                                                         (_opts41019_
                                                          _tl4092441014_))
                                                     (_K4092041004_
                                                      _opts41019_
                                                      _modf41017_)))
                                                 (_else4090840955_))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##eq? _hd4094141103_
                                                          'static-include:))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##pair? _tl4094241105_))
                                                     (let ((_tl4091940992_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##cdr _tl4094241105_)))
                                                           (_hd4091840990_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##car _tl4094241105_))))
                                                       (if (let ()
                                                             (declare
                                                               (not safe))
                                                             (##null? _tl4091940992_))
                                                           (let ((_file40995_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _hd4091840990_))
                     (_K4091540982_ _file40995_))
                   (_else4090840955_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4090840955_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##eq? _hd4094141103_
                                                              'copy:))
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##pair? _tl4094241105_))
                                                         (let ((_tl4091440971_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##cdr _tl4094241105_)))
                       (_hd4091340969_
                        (let () (declare (not safe)) (##car _tl4094241105_))))
                   (if (let () (declare (not safe)) (##null? _tl4091440971_))
                       (let ((_file40974_ _hd4091340969_))
                         (_K4091040961_ _file40974_))
                       (_else4090840955_)))
                 (_else4090840955_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4090840955_)))))))))
                       (_else4090840955_)))))
            (if (string? _spec4089940947_)
                (let ((_modf41125_ _spec4089940947_))
                  (_K4094541122_ _modf41125_))
                (_try-match4090141117_)))))))
  (define std/make#spec-inputs
    (lambda (_spec40890_ _settings40891_)
      (cons (std/make#spec-file _spec40890_ _settings40891_)
            (foldr1 cons
                    (std/srfi/1#append-map
                     (lambda (_g4089240894_)
                       (std/make#spec-inputs _g4089240894_ _settings40891_))
                     (std/make#spec-submodules _spec40890_))
                    (std/make#spec-extra-inputs
                     _spec40890_
                     _settings40891_)))))
  (define std/make#spec-extra-inputs
    (lambda (_spec40842_ _settings40843_)
      (let* ((_spec4084440857_ _spec40842_)
             (_E4084840861_
              (lambda () (error '"No clause matching" _spec4084440857_))))
        (let ((_K4085340884_
               (lambda ()
                 (pgetq 'extra-inputs: (std/make#spec-plist _spec40842_) '())))
              (_K4085040874_
               (lambda ()
                 (pgetq 'extra-inputs: (std/make#spec-plist _spec40842_) '())))
              (_K4084940866_ (lambda () '())))
          (if (let () (declare (not safe)) (##pair? _spec4084440857_))
              (let ((_hd4085440887_
                     (let () (declare (not safe)) (##car _spec4084440857_))))
                (if (let () (declare (not safe)) (##eq? _hd4085440887_ 'gxc:))
                    (_K4085340884_)
                    (if (let ()
                          (declare (not safe))
                          (##eq? _hd4085440887_ 'gsc:))
                        (_K4085040874_)
                        (_K4084940866_))))
              (_K4084940866_))))))
  (define std/make#spec-submodules
    (lambda (_spec40785_)
      (let* ((_spec4078640801_ _spec40785_)
             (_E4079040805_
              (lambda () (error '"No clause matching" _spec4078640801_))))
        (let ((_K4079740836_
               (lambda ()
                 (pgetq 'submodules: (std/make#spec-plist _spec40785_) '())))
              (_K4079240819_ (lambda (_submodules40817_) _submodules40817_))
              (_K4079140810_ (lambda () '())))
          (if (let () (declare (not safe)) (##pair? _spec4078640801_))
              (let ((_hd4079840839_
                     (let () (declare (not safe)) (##car _spec4078640801_))))
                (if (let () (declare (not safe)) (##eq? _hd4079840839_ 'gxc:))
                    (_K4079740836_)
                    (let ((_tl4079440824_
                           (let ()
                             (declare (not safe))
                             (##cdr _spec4078640801_))))
                      (if (let ()
                            (declare (not safe))
                            (##eq? _hd4079840839_ 'ssi:))
                          (if (let ()
                                (declare (not safe))
                                (##pair? _tl4079440824_))
                              (let* ((_tl4079640827_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _tl4079440824_)))
                                     (_submodules40830_ _tl4079640827_))
                                (_K4079240819_ _submodules40830_))
                              (_K4079140810_))
                          (_K4079140810_)))))
              (_K4079140810_))))))
  (define std/make#spec-plist
    (lambda (_spec40708_)
      (let* ((_spec4070940728_ _spec40708_)
             (_E4071240732_
              (lambda () (error '"No clause matching" _spec4070940728_))))
        (let ((_K4071440745_ (lambda (_plist40743_) _plist40743_))
              (_K4071340737_ (lambda () '())))
          (let ((___match304647304648_
                 (lambda (_hd4071540748_
                          _tl4071640750_
                          _tl4071840757_
                          _hd4071940760_)
                   (letrec ((_splice-rest4072240763_
                             (lambda (_rest4072640770_ _plist40772_)
                               (if (let ()
                                     (declare (not safe))
                                     (##null? _rest4072640770_))
                                   (_K4071440745_ _plist40772_)
                                   (_K4071340737_))))
                            (_splice-try4072440765_
                             (lambda (_hd4072540774_
                                      _rest4072640776_
                                      _plist4072140777_)
                               (let ((_plist40780_ _hd4072540774_))
                                 (_splice-loop4072340767_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _rest4072640776_))
                                  (cons _plist40780_ _plist4072140777_)))))
                            (_splice-loop4072340767_
                             (lambda (_rest4072640782_ _plist4072140783_)
                               (if (pair? _rest4072640782_)
                                   (_splice-try4072440765_
                                    (let ()
                                      (declare (not safe))
                                      (##car _rest4072640782_))
                                    _rest4072640782_
                                    _plist4072140783_)
                                   (_splice-rest4072240763_
                                    _rest4072640782_
                                    (reverse _plist4072140783_))))))
                     (_splice-loop4072340767_ _hd4071940760_ '())))))
            (if (let () (declare (not safe)) (##pair? _spec4070940728_))
                (let ((_tl4071640750_
                       (let () (declare (not safe)) (##cdr _spec4070940728_)))
                      (_hd4071540748_
                       (let () (declare (not safe)) (##car _spec4070940728_))))
                  (if ((lambda (_g4075240754_)
                         (member _g4075240754_ '(gxc: gsc:)))
                       _hd4071540748_)
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl4071640750_))
                          (let ((_tl4071840757_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl4071640750_))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl4071840757_))
                                (let ((_hd4071940760_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl4071840757_))))
                                  (___match304647304648_
                                   _hd4071540748_
                                   _tl4071640750_
                                   _tl4071840757_
                                   _hd4071940760_))
                                (_K4071340737_)))
                          (_K4071340737_))
                      (_K4071340737_)))
                (_K4071340737_)))))))
  (define std/make#spec-outputs
    (lambda (_spec40474_ _settings40475_)
      (let* ((_spec4047640524_ _spec40474_)
             (_else4048540532_
              (lambda () (error '"Bad buildspec" _spec40474_))))
        (let ((_K4052240703_
               (lambda (_modf40701_)
                 (std/make#gxc-outputs _modf40701_ '#f _settings40475_)))
              (_K4051740681_
               (lambda (_opts40678_ _modf40679_)
                 (std/make#gxc-outputs
                  _modf40679_
                  _opts40678_
                  _settings40475_)))
              (_K4051240657_
               (lambda (_opts40654_ _modf40655_)
                 (cons (std/make#gsc-c-path _modf40655_ _settings40475_) '())))
              (_K4050740633_
               (lambda (_submodules40626_ _modf40627_)
                 (cons (std/make#library-path
                        _modf40627_
                        '".ssi"
                        _settings40475_)
                       (std/srfi/1#append-map
                        (lambda (_g4062840630_)
                          (std/make#spec-outputs
                           _g4062840630_
                           _settings40475_))
                        _submodules40626_))))
              (_K4050240605_
               (lambda (_opts40602_ _modf40603_)
                 (cons (std/make#library-path
                        _modf40603_
                        '".ssi"
                        _settings40475_)
                       (cons (std/make#binary-path
                              _modf40603_
                              _opts40602_
                              _settings40475_)
                             '()))))
              (_K4049740581_
               (lambda (_opts40578_ _modf40579_)
                 (cons (std/make#binary-path
                        _modf40579_
                        _opts40578_
                        _settings40475_)
                       (cons (std/make#static-path _modf40579_ _settings40475_)
                             '()))))
              (_K4049240559_
               (lambda (_file40557_)
                 (cons (std/make#static-file-path _file40557_ _settings40475_)
                       '())))
              (_K4048740538_
               (lambda (_file40536_)
                 (cons (std/make#library-path _file40536_ '#f _settings40475_)
                       '()))))
          (let ((_try-match4047840698_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec4047640524_))
                       (let ((_tl4051940686_
                              (let ()
                                (declare (not safe))
                                (##cdr _spec4047640524_)))
                             (_hd4051840684_
                              (let ()
                                (declare (not safe))
                                (##car _spec4047640524_))))
                         (if (let ()
                               (declare (not safe))
                               (##eq? _hd4051840684_ 'gxc:))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _tl4051940686_))
                                 (let ((_tl4052140691_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _tl4051940686_)))
                                       (_hd4052040689_
                                        (let ()
                                          (declare (not safe))
                                          (##car _tl4051940686_))))
                                   (let ((_modf40694_ _hd4052040689_)
                                         (_opts40696_ _tl4052140691_))
                                     (_K4051740681_ _opts40696_ _modf40694_)))
                                 (_else4048540532_))
                             (if (let ()
                                   (declare (not safe))
                                   (##eq? _hd4051840684_ 'gsc:))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl4051940686_))
                                     (let ((_tl4051640667_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl4051940686_)))
                                           (_hd4051540665_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl4051940686_))))
                                       (let ((_modf40670_ _hd4051540665_)
                                             (_opts40672_ _tl4051640667_))
                                         (_K4051240657_
                                          _opts40672_
                                          _modf40670_)))
                                     (_else4048540532_))
                                 (if (let ()
                                       (declare (not safe))
                                       (##eq? _hd4051840684_ 'ssi:))
                                     (if (let ()
                                           (declare (not safe))
                                           (##pair? _tl4051940686_))
                                         (let ((_tl4051140643_
                                                (let ()
                                                  (declare (not safe))
                                                  (##cdr _tl4051940686_)))
                                               (_hd4051040641_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl4051940686_))))
                                           (let ((_modf40646_ _hd4051040641_)
                                                 (_submodules40648_
                                                  _tl4051140643_))
                                             (_K4050740633_
                                              _submodules40648_
                                              _modf40646_)))
                                         (_else4048540532_))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _hd4051840684_ 'exe:))
                                         (if (let ()
                                               (declare (not safe))
                                               (##pair? _tl4051940686_))
                                             (let ((_tl4050640615_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _tl4051940686_)))
                                                   (_hd4050540613_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl4051940686_))))
                                               (let ((_modf40618_
                                                      _hd4050540613_)
                                                     (_opts40620_
                                                      _tl4050640615_))
                                                 (_K4050240605_
                                                  _opts40620_
                                                  _modf40618_)))
                                             (_else4048540532_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##eq? _hd4051840684_
                                                      'static-exe:))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##pair? _tl4051940686_))
                                                 (let ((_tl4050140591_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _tl4051940686_)))
                                                       (_hd4050040589_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl4051940686_))))
                                                   (let ((_modf40594_
                                                          _hd4050040589_)
                                                         (_opts40596_
                                                          _tl4050140591_))
                                                     (_K4049740581_
                                                      _opts40596_
                                                      _modf40594_)))
                                                 (_else4048540532_))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##eq? _hd4051840684_
                                                          'static-include:))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##pair? _tl4051940686_))
                                                     (let ((_tl4049640569_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##cdr _tl4051940686_)))
                                                           (_hd4049540567_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##car _tl4051940686_))))
                                                       (if (let ()
                                                             (declare
                                                               (not safe))
                                                             (##null? _tl4049640569_))
                                                           (let ((_file40572_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _hd4049540567_))
                     (_K4049240559_ _file40572_))
                   (_else4048540532_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4048540532_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##eq? _hd4051840684_
                                                              'copy:))
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##pair? _tl4051940686_))
                                                         (let ((_tl4049140548_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##cdr _tl4051940686_)))
                       (_hd4049040546_
                        (let () (declare (not safe)) (##car _tl4051940686_))))
                   (if (let () (declare (not safe)) (##null? _tl4049140548_))
                       (let ((_file40551_ _hd4049040546_))
                         (_K4048740538_ _file40551_))
                       (_else4048540532_)))
                 (_else4048540532_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4048540532_)))))))))
                       (_else4048540532_)))))
            (if (string? _spec4047640524_)
                (let ((_modf40706_ _spec4047640524_))
                  (_K4052240703_ _modf40706_))
                (_try-match4047840698_)))))))
  (define std/make#spec-backgroundable?
    (lambda (_spec40469_)
      (let ((_$e40471_ (std/make#spec-type _spec40469_)))
        (if (eq? 'gxc: _$e40471_)
            (not (pgetq 'foreground: (std/make#spec-plist _spec40469_)))
            (if (eq? 'gsc: _$e40471_) '#t '#f)))))
  (define std/make#cache (make-parameter '#f))
  (define std/make#cache-put!
    (lambda (_key40464_ _value40465_)
      (letrec* ((_c40467_ (std/make#cache)))
        (if _c40467_ (table-set! _c40467_ _key40464_ _value40465_) '#!void)
        _value40465_)))
  (define std/make#cache-remove!
    (lambda (_key40460_)
      (letrec* ((_c40462_ (std/make#cache)))
        (if _c40462_ (table-set! _c40462_ _key40460_) '#!void))))
  (define std/make#call-with-cache__%
    (lambda (_key40445_ _thunk40446_)
      (letrec* ((_c40448_ (std/make#cache)))
        (if _c40448_
            (std/misc/hash#hash-ensure-ref _c40448_ _key40445_ _thunk40446_)
            (_thunk40446_)))))
  (define std/make#call-with-cache__0
    (lambda (_key40453_)
      (let ((_thunk40455_ false))
        (std/make#call-with-cache__% _key40453_ _thunk40455_))))
  (define std/make#call-with-cache
    (lambda _g304861_
      (let ((_g304860_ (let () (declare (not safe)) (##length _g304861_))))
        (cond ((let () (declare (not safe)) (##fx= _g304860_ 1))
               (apply std/make#call-with-cache__0 _g304861_))
              ((let () (declare (not safe)) (##fx= _g304860_ 2))
               (apply std/make#call-with-cache__% _g304861_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/make#call-with-cache
                _g304861_))))))
  (define std/make#call-with-fresh-cache
    (lambda (_thunk40438_)
      (call-with-parameters
       (lambda () (_thunk40438_))
       std/make#cache
       (let ((_ht40441_ (make-table 'size: '0))) _ht40441_))))
  (define std/make#modification-time
    (lambda (_file40430_)
      (call-with-current-continuation
       (lambda (_return40432_)
         (letrec* ((_info40434_
                    (with-exception-catcher
                     (lambda (_g304862_) (_return40432_ '#f))
                     (lambda () (file-info _file40430_ '#t)))))
           (time->seconds (file-info-last-modification-time _info40434_)))))))
  (define std/make#modification-time/cache
    (lambda (_file40427_)
      (std/make#call-with-cache__%
       (cons 'modification-time (cons _file40427_ '()))
       (lambda () (std/make#modification-time _file40427_)))))
  (define std/make#file-timestamp
    (lambda (_file40422_)
      (let ((_$e40424_ (std/make#modification-time/cache _file40422_)))
        (if _$e40424_ _$e40424_ '+inf.0))))
  (define std/make#module-strip-nesting
    (lambda (_module40413_)
      (letrec* ((_name40415_ (symbol->string _module40413_)))
        (let ((_$e40417_ (string-rindex _name40415_ '#\$)))
          (if _$e40417_
              ((lambda (_ix40420_)
                 (string->symbol (substring _name40415_ '0 _ix40420_)))
               _$e40417_)
              _module40413_)))))
  (define std/make#library-symbol
    (lambda (_module40411_)
      (make-symbol '":" (std/make#module-strip-nesting _module40411_))))
  (define std/make#library-file
    (lambda (_library40406_)
      (with-exception-catcher
       (lambda (_e40408_)
         (error '"missing library"
                'context:
                'library-file
                'library:
                _library40406_
                'symbol:
                (std/make#library-symbol _library40406_)
                'load-path:
                (let ((__values304851 (load-path)))
                  (if (let () (declare (not safe)) (##values? __values304851))
                      (let ()
                        (declare (not safe))
                        (##vector->list __values304851))
                      (list __values304851)))
                'error-message:
                (error-message _e40408_)
                'error:
                _e40408_))
       (lambda ()
         (gx#core-resolve-library-module-path
          (std/make#library-symbol _library40406_))))))
  (define std/make#library-timestamp
    (lambda (_library40404_)
      (std/make#file-timestamp (std/make#library-file _library40404_))))
  (define std/make#build-deps-tag 'gerbil-build-deps-v2:)
  (define std/make#read-build-deps
    (lambda (_file40362_)
      (let* ((_g4036340373_
              (with-exception-catcher
               void
               (lambda () (call-with-input-file _file40362_ read))))
             (_E4036640377_
              (lambda () (error '"No clause matching" _g4036340373_))))
        (let ((_K4036840390_ (lambda (_s40388_) _s40388_))
              (_K4036740382_ (lambda () '())))
          (if (let () (declare (not safe)) (##pair? _g4036340373_))
              (let ((_tl4037040395_
                     (let () (declare (not safe)) (##cdr _g4036340373_)))
                    (_hd4036940393_
                     (let () (declare (not safe)) (##car _g4036340373_))))
                (if ((lambda (_g4039740399_)
                       (equal? _g4039740399_ std/make#build-deps-tag))
                     _hd4036940393_)
                    (let ((_s40402_ _tl4037040395_)) (_K4036840390_ _s40402_))
                    (_K4036740382_)))
              (_K4036740382_))))))
  (define std/make#write-build-deps
    (lambda (_file40357_ _build-deps40358_)
      (create-directory* (path-directory _file40357_))
      (call-with-output-file
       _file40357_
       (lambda (_port40360_)
         (pretty-print
          (cons std/make#build-deps-tag _build-deps40358_)
          _port40360_)
         (newline _port40360_)))))
  (define std/make#make
    (lambda _args40313_
      (letrec* ((_g304863_
                 (let ((_g304864_
                        (std/misc/list#separate-keyword-arguments__%
                         _args40313_
                         '#t)))
                   (let ((_g304865_
                          (let ()
                            (declare (not safe))
                            (if (##values? _g304864_)
                                (##vector-length _g304864_)
                                1))))
                     (if (not (let ()
                                (declare (not safe))
                                (##fx= _g304865_ 2)))
                         (error "Context expects 2 values" _g304865_)))
                   _g304864_))
                (_positionals40315_
                 (let () (declare (not safe)) (##vector-ref _g304863_ 0)))
                (_keywords40316_
                 (let () (declare (not safe)) (##vector-ref _g304863_ 1)))
                (_buildspec40317_
                 (let* ((_positionals4032140330_ _positionals40315_)
                        (_E4032440334_
                         (lambda ()
                           (error '"No clause matching"
                                  _positionals4032140330_))))
                   (let ((_K4032640347_ (lambda (_x40345_) _x40345_))
                         (_K4032540339_
                          (lambda ()
                            (error '"invalid arguments"
                                   std/make#make
                                   _positionals40315_))))
                     (if (let ()
                           (declare (not safe))
                           (##pair? _positionals4032140330_))
                         (let ((_tl4032840352_
                                (let ()
                                  (declare (not safe))
                                  (##cdr _positionals4032140330_)))
                               (_hd4032740350_
                                (let ()
                                  (declare (not safe))
                                  (##car _positionals4032140330_))))
                           (if (let ()
                                 (declare (not safe))
                                 (##null? _tl4032840352_))
                               (let ((_x40355_ _hd4032740350_))
                                 (_K4032640347_ _x40355_))
                               (_K4032540339_)))
                         (_K4032540339_)))))
                (_settings40318_
                 (apply std/make#make-settings _keywords40316_)))
        (call-with-parameters
         (lambda ()
           (std/make#call-with-fresh-cache
            (lambda () (std/make#%make _buildspec40317_ _settings40318_))))
         current-directory
         (##structure-ref _settings40318_ '1 std/make#settings::t '#f)
         gx#current-expander-compiling?
         '#t))))
  (define std/make#%make
    (lambda (_buildspec39920_ _settings39921_)
      (letrec* ((_force?39923_
                 (##structure-ref _settings39921_ '5 std/make#settings::t '#f))
                (_build-deps-file39924_
                 (##structure-ref
                  _settings39921_
                  '11
                  std/make#settings::t
                  '#f))
                (_verbose39925_
                 (##structure-ref
                  _settings39921_
                  '10
                  std/make#settings::t
                  '#f))
                (_verbose>=?39926_
                 (lambda (_n40311_)
                   (std/make#settings-verbose>=? _settings39921_ _n40311_)))
                (_g304866_
                 (let ((_g304867_
                        (if (_verbose>=?39926_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '0
                                         (cons 'settings:
                                               (cons _settings39921_ '())))))
                            '#!void)))
                   #!void
                   _g304867_))
                (_spec@39927_
                 (list->vector
                  (std/make#normalize-buildspec _buildspec39920_)))
                (_nspec39928_ (vector-length _spec@39927_))
                (_specvec39929_ (lambda () (make-vector _nspec39928_ '#f)))
                (_spec-index%39930_
                 (std/misc/hash#invert-hash<-vector__%
                  '#f
                  absent-value
                  absent-value
                  absent-value
                  absent-value
                  _spec@39927_))
                (_id@39931_ (_specvec39929_))
                (_id-index%39932_
                 (let ((_ht40307_ (make-table 'size: '0))) _ht40307_))
                (_deps@39933_ (_specvec39929_))
                (_timestamp%39934_
                 (let ((_ht40304_ (make-table 'size: '0))) _ht40304_))
                (_blocked-by@39935_ (_specvec39929_))
                (_blocking@39936_ (_specvec39929_))
                (_ready-fg39937_
                 (let ((__obj304852
                        (make-object std/misc/pqueue#pqueue::t '3)))
                   (std/misc/pqueue#pqueue:::init!__1 __obj304852 identity <)
                   __obj304852))
                (_ready-bg39938_
                 (let ((__obj304853
                        (make-object std/misc/pqueue#pqueue::t '3)))
                   (std/misc/pqueue#pqueue:::init!__1 __obj304853 identity >)
                   __obj304853))
                (_g304869_
                 (let ((_g304870_
                        (if (_verbose>=?39926_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '1
                                         (cons 'spec@:
                                               (cons _spec@39927_ '())))))
                            '#!void)))
                   #!void
                   _g304870_))
                (_dependency-timestamp39939_
                 (lambda (_dep40299_)
                   (with-exception-catcher
                    (lambda (_g304872_) '+inf.0)
                    (lambda ()
                      (std/misc/hash#hash-ensure-ref
                       _timestamp%39934_
                       _dep40299_
                       (lambda () (std/make#library-timestamp _dep40299_)))))))
                (_g304873_
                 (let ((_g304874_
                        (let ((_build-deps-timestamp3994039943_
                               (std/make#modification-time/cache
                                _build-deps-file39924_))
                              (_previous@3994139945_
                               (std/make#read-build-deps
                                _build-deps-file39924_)))
                          (if _build-deps-timestamp3994039943_
                              (if _previous@3994139945_
                                  (let ((_build-deps-timestamp39948_
                                         _build-deps-timestamp3994039943_)
                                        (_previous@39949_
                                         _previous@3994139945_))
                                    (letrec* ((_previous-out-of-date%39951_
                                               (let ((_ht39977_
                                                      (make-table 'size: '0)))
                                                 _ht39977_))
                                              (_previous-file-up-to-date?39952_
                                               (lambda (_file39975_)
                                                 (<= (std/make#file-timestamp
                                                      _file39975_)
                                                     _build-deps-timestamp39948_)))
                                              (_previous-dependency-up-to-date?39953_
                                               (lambda (_dep39970_)
                                                 (let ((_$e39972_
                                                        (table-ref
                                                         _id-index%39932_
                                                         _dep39970_
                                                         '#f)))
                                                   (if _$e39972_
                                                       _$e39972_
                                                       (if (not (table-ref
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _previous-out-of-date%39951_
                         _dep39970_
                         '#f))
                   (<= (_dependency-timestamp39939_ _dep39970_)
                       _build-deps-timestamp39948_)
                   '#f)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_previous-entry-up-to-date?39954_
                                               (lambda (_spec39967_
                                                        _deps39968_)
                                                 (if (andmap1 _previous-file-up-to-date?39952_
                                                              (std/make#spec-inputs
                                                               _spec39967_
                                                               _settings39921_))
                                                     (andmap1 _previous-dependency-up-to-date?39953_
                                                              _deps39968_)
                                                     '#f)))
                                              (_consider-previous39955_
                                               (lambda (_id39961_
                                                        _spec39962_
                                                        _deps39963_)
                                                 (if (_verbose>=?39926_ '7)
                                                     (std/make#writeln
                                                      (cons 'previous:
                                                            (cons _id39961_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (cons 'spec:
                                (cons _spec39962_
                                      (cons 'deps:
                                            (cons _deps39963_
                                                  (cons 'target:
                                                        (cons (table-ref
                                                               _spec-index%39930_
                                                               _spec39962_
                                                               '#f)
                                                              (cons 'up-to-date?:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (cons (if (table-ref
                                       _spec-index%39930_
                                       _spec39962_
                                       '#f)
                                      (_previous-entry-up-to-date?39954_
                                       _spec39962_
                                       _deps39963_)
                                      '#f)
                                  '())))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     '#!void)
                                                 (letrec* ((_target39965_
                                                            (table-ref
                                                             _spec-index%39930_
                                                             _spec39962_
                                                             '#f)))
                                                   (if (and _target39965_
                                                            (_previous-entry-up-to-date?39954_
                                                             _spec39962_
                                                             _deps39963_))
                                                       (begin
                                                         (vector-set!
                                                          _id@39931_
                                                          _target39965_
                                                          _id39961_)
                                                         (table-set!
                                                          _id-index%39932_
                                                          _id39961_
                                                          _target39965_)
                                                         (vector-set!
                                                          _deps@39933_
                                                          _target39965_
                                                          _deps39963_))
                                                       (table-set!
                                                        _previous-out-of-date%39951_
                                                        _id39961_
                                                        '#t))))))
                                      (for-each
                                       (lambda (_g3995639958_)
                                         (apply _consider-previous39955_
                                                _g3995639958_))
                                       _previous@39949_)))
                                  '#f)
                              '#f))))
                   #!void
                   _g304874_))
                (_g304876_
                 (let ((_g304877_
                        (if (_verbose>=?39926_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '2
                                         (cons 'previous-up-to-date:
                                               (cons (std/misc/hash#hash->list/sort
                                                      _id-index%39932_
                                                      std/misc/symbol#symbol<?)
                                                     '())))))
                            '#!void)))
                   #!void
                   _g304877_))
                (_g304879_
                 (let ((_g304880_
                        ((lambda (_g3997939981_)
                           (std/make#vector-for-each
                            _g3997939981_
                            _spec@39927_))
                         (lambda (_target39984_ _spec39985_)
                           (if (_verbose>=?39926_ '7)
                               (std/make#writeln
                                (cons 'Step:
                                      (cons '3.
                                            (cons 'target:
                                                  (cons _target39984_
                                                        (cons _spec39985_
                                                              '()))))))
                               '#!void)
                           (if (vector-ref _id@39931_ _target39984_)
                               '#!void
                               (let ((_g304882_
                                      (std/make#file-dependencies
                                       (std/make#spec-file
                                        _spec39985_
                                        _settings39921_)
                                       _settings39921_)))
                                 (begin
                                   (let ((_g304883_
                                          (let ()
                                            (declare (not safe))
                                            (if (##values? _g304882_)
                                                (##vector-length _g304882_)
                                                1))))
                                     (if (not (let ()
                                                (declare (not safe))
                                                (##fx= _g304883_ 2)))
                                         (error "Context expects 2 values"
                                                _g304883_)))
                                   (let ((_id39987_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g304882_ 0)))
                                         (_deps39988_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g304882_ 1))))
                                     (begin
                                       (if (_verbose>=?39926_ '7)
                                           (std/make#writeln
                                            (cons _target39984_
                                                  (cons _spec39985_
                                                        (cons _id39987_
                                                              (cons _deps39988_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            '())))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           '#!void)
                                       (vector-set!
                                        _id@39931_
                                        _target39984_
                                        _id39987_)
                                       (table-set!
                                        _id-index%39932_
                                        _id39987_
                                        _target39984_)
                                       (vector-set!
                                        _deps@39933_
                                        _target39984_
                                        _deps39988_))))))))))
                   #!void
                   _g304880_))
                (_g304884_
                 (let ((_g304885_
                        (if (_verbose>=?39926_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '3
                                         (cons 'deps:
                                               (cons (apply std/srfi/1#srfi-1-map
                                                            list
                                                            (map vector->list
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (cons _id@39931_
                               (cons _spec@39927_ (cons _deps@39933_ '())))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     '())))))
                            '#!void)))
                   #!void
                   _g304885_))
                (_blockings39989_
                 (lambda (_blocks40285_)
                   (let _loop40287_ ((_i40289_ (- _nspec39928_ '1))
                                     (_l40290_ '()))
                     (if (> '0 _i40289_)
                         _l40290_
                         (let* ((_h140292_ (vector-ref _blocks40285_ _i40289_))
                                (_h240294_
                                 (if _h140292_ (hash-keys _h140292_) '#f))
                                (_h340296_
                                 (if _h240294_
                                     (if (pair? _h240294_) _h240294_ '#f)
                                     '#f)))
                           (_loop40287_
                            (- _i40289_ '1)
                            (if _h340296_
                                (cons (cons _i40289_ (cons _h340296_ '()))
                                      _l40290_)
                                _l40290_)))))))
                (_init-walk39990_
                 (lambda ()
                   (if (_verbose>=?39926_ '8)
                       (std/make#writeln
                        (cons 'ready-fg:
                              (cons (std/misc/pqueue#pqueue-contents
                                     _ready-fg39937_)
                                    (cons 'ready-bg:
                                          (cons (std/misc/pqueue#pqueue-contents
                                                 _ready-bg39938_)
                                                (cons 'blocked-by:
                                                      (cons (_blockings39989_
                                                             _blocked-by@39935_)
                                                            (cons 'len:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (cons (length (_blockings39989_ _blocked-by@39935_))
                                (cons 'blocking:
                                      (cons (_blockings39989_ _blocking@39936_)
                                            (cons 'len:
                                                  (cons (length (_blockings39989_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _blocking@39936_))
                '())))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                       '#!void)
                   (let ((_g4024740249_ (_blockings39989_ _blocked-by@39935_)))
                     (if (null? _g4024740249_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@358.14"
                          '(null? (blockings blocked-by@))
                          (cons (cons '(blockings blocked-by@) _g4024740249_)
                                '()))))
                   (let ((_g4025140253_ (_blockings39989_ _blocking@39936_)))
                     (if (null? _g4025140253_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@359.14"
                          '(null? (blockings blocking@))
                          (cons (cons '(blockings blocking@) _g4025140253_)
                                '()))))
                   (let ((_ready-fg4025540257_ _ready-fg39937_))
                     (if (std/misc/pqueue#pqueue-empty? _ready-fg4025540257_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@360.14"
                          '(pqueue-empty? ready-fg)
                          (cons (cons 'ready-fg _ready-fg4025540257_) '()))))
                   (let ((_ready-bg4025940261_ _ready-bg39938_))
                     (if (std/misc/pqueue#pqueue-empty? _ready-bg4025940261_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@361.14"
                          '(pqueue-empty? ready-bg)
                          (cons (cons 'ready-bg _ready-bg4025940261_) '()))))
                   ((lambda (_g4026340265_)
                      (std/make#vector-for-each _g4026340265_ _deps@39933_))
                    (lambda (_target40268_ _deps40269_)
                      ((lambda (_g4027040272_)
                         (for-each _g4027040272_ _deps40269_))
                       (lambda (_dep40275_)
                         (let ((_other-target40277_
                                (table-ref _id-index%39932_ _dep40275_ '#f)))
                           (if _other-target40277_
                               (begin
                                 (table-set!
                                  (std/make#vector-ensure-ref
                                   _blocked-by@39935_
                                   _target40268_
                                   make-hash-table)
                                  _other-target40277_
                                  '#t)
                                 (table-set!
                                  (std/make#vector-ensure-ref
                                   _blocking@39936_
                                   _other-target40277_
                                   make-hash-table)
                                  _target40268_
                                  '#t))
                               '#!void))))))
                   ((lambda (_g4027840280_)
                      (std/make#vector-for-each _g4027840280_ _spec@39927_))
                    (lambda (_target40283_ _g304887_)
                      (if (vector-ref _blocked-by@39935_ _target40283_)
                          '#!void
                          (std/misc/pqueue#pqueue-push!
                           _ready-fg39937_
                           _target40283_))))))
                (_mark-built39991_
                 (lambda (_target40231_ . _g304888_)
                   (let ((_blocking4023240234_
                          (vector-ref _blocking@39936_ _target40231_)))
                     (if _blocking4023240234_
                         (let ((_blocking40237_ _blocking4023240234_))
                           ((lambda (_g4023840240_)
                              (table-for-each _g4023840240_ _blocking40237_))
                            (lambda (_unblocked40243_ _g304889_)
                              (table-set! _blocking40237_ _unblocked40243_)
                              (letrec* ((_blocked-by40245_
                                         (vector-ref
                                          _blocked-by@39935_
                                          _unblocked40243_)))
                                (table-set! _blocked-by40245_ _target40231_)
                                (if (std/misc/hash#hash-empty?
                                     _blocked-by40245_)
                                    (std/misc/pqueue#pqueue-push!
                                     _ready-fg39937_
                                     _unblocked40243_)
                                    '#!void)))))
                         '#f))))
                (_g304890_
                 (let ((_g304891_ (_init-walk39990_))) #!void _g304891_))
                (_build-list39992_
                 (let* ((_head40061_ (cons '#f '())) (_tail40064_ _head40061_))
                   (std/misc/concurrent-plan#perform-plan/threads__%
                    '#f
                    void
                    (lambda (_val40225_)
                      (let ((_new-tail40228_ (cons _val40225_ '())))
                        (let ()
                          (declare (not safe))
                          (##set-cdr! _tail40064_ _new-tail40228_))
                        (set! _tail40064_ _new-tail40228_)))
                    _mark-built39991_
                    void
                    '#t
                    '1
                    _ready-fg39937_
                    _ready-bg39938_)
                   (let () (declare (not safe)) (##cdr _head40061_))))
                (_g304893_
                 (let ((_g304894_
                        (std/make#write-build-deps
                         _build-deps-file39924_
                         (map (lambda (_target39994_)
                                (map (lambda (_g3999539997_)
                                       (vector-ref
                                        _g3999539997_
                                        _target39994_))
                                     (cons _id@39931_
                                           (cons _spec@39927_
                                                 (cons _deps@39933_ '())))))
                              _build-list39992_))))
                   #!void
                   _g304894_))
                (_g304896_
                 (let ((_g304897_
                        (if (= (length _build-list39992_) _nspec39928_)
                            '#!void
                            (error '"Circular dependency in build??? Remove build-deps and try again?"))))
                   #!void
                   _g304897_))
                (_g304899_
                 (let ((_g304900_
                        (if (_verbose>=?39926_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '4
                                         (cons 'build-deps:
                                               (cons _build-deps-file39924_
                                                     '())))))
                            '#!void)))
                   #!void
                   _g304900_))
                (_compute-timestamp39999_
                 (lambda (_target40047_)
                   (letrec* ((_spec40049_
                              (vector-ref _spec@39927_ _target40047_))
                             (_deps40050_
                              (vector-ref _deps@39933_ _target40047_))
                             (_inputs40051_
                              (std/make#spec-inputs
                               _spec40049_
                               _settings39921_))
                             (_outputs40052_
                              (std/make#spec-outputs
                               _spec40049_
                               _settings39921_))
                             (_dep-timestamps40053_
                              (map _dependency-timestamp39939_ _deps40050_))
                             (_in-timestamps40054_
                              (map std/make#file-timestamp _inputs40051_))
                             (_out-timestamps40055_
                              (map std/make#file-timestamp _outputs40052_))
                             (_dep-max40056_
                              (std/misc/number#xmax/list
                               _dep-timestamps40053_))
                             (_in-max40057_
                              (std/misc/number#xmax__0
                               _dep-max40056_
                               (std/misc/number#xmax/list
                                _in-timestamps40054_)))
                             (_out-min40058_
                              (std/misc/number#xmin/list
                               _out-timestamps40055_))
                             (_out-max40059_
                              (std/misc/number#xmax/list
                               _out-timestamps40055_)))
                     (if (_verbose>=?39926_ '6)
                         (std/make#writeln
                          (cons 'compute-timestamp:
                                (cons (cons 'target: (cons _target40047_ '()))
                                      (cons (cons 'spec:
                                                  (cons _spec40049_ '()))
                                            (cons (cons 'in-max:
                                                        (cons _in-max40057_
                                                              '()))
                                                  (cons (cons 'out-min:
                                                              (cons _out-min40058_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            '()))
                (cons (cons 'out-max: (cons _out-max40059_ '()))
                      (cons (cons 'deps:
                                  (cons (std/srfi/1#map2
                                         list
                                         _dep-timestamps40053_
                                         _deps40050_)
                                        '()))
                            (cons (cons 'ins:
                                        (cons (std/srfi/1#map2
                                               list
                                               _in-timestamps40054_
                                               _inputs40051_)
                                              '()))
                                  (cons (cons 'outs:
                                              (cons (std/srfi/1#map2
                                                     list
                                                     _outputs40052_
                                                     _out-timestamps40055_)
                                                    '()))
                                        (cons (cons 'result:
                                                    (cons (if (<= _in-max40057_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _out-min40058_)
                      _out-max40059_
                      '+inf.0)
                  '()))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              '())))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                         '#!void)
                     (if (<= _in-max40057_ _out-min40058_)
                         _out-max40059_
                         '+inf.0))))
                (_compute-new-timestamp40000_
                 (lambda (_target40037_)
                   (letrec* ((_spec40039_
                              (vector-ref _spec@39927_ _target40037_))
                             (_outputs40040_
                              (std/make#spec-outputs
                               _spec40039_
                               _settings39921_))
                             (_g304902_
                              (let ((_g304903_
                                     (for-each
                                      (lambda (_x40042_)
                                        (std/make#cache-remove!
                                         (cons 'modification-time
                                               (cons _x40042_ '()))))
                                      _outputs40040_)))
                                #!void
                                _g304903_))
                             (_out-timestamp40043_
                              (std/misc/number#xmax/map__0
                               std/make#file-timestamp
                               _outputs40040_)))
                     (begin
                       (if (< _out-timestamp40043_ '+inf.0)
                           '#!void
                           (begin
                             (if _verbose39925_
                                 (std/make#writeln
                                  (cons 'compute-timestamp-failed:
                                        (cons _spec40039_
                                              (cons (map (lambda (_x40045_)
                                                           (cons _x40045_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (cons (std/make#file-timestamp _x40045_) '())))
                 _outputs40040_)
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    '()))))
                                 '#!void)
                             (error '"Build failed to generate expected outputs"
                                    _spec40039_
                                    _outputs40040_)))
                       _out-timestamp40043_))))
                (_target<-item40001_
                 (lambda (_item40035_)
                   (if (<= '0 _item40035_)
                       _item40035_
                       (bitwise-not _item40035_))))
                (_perform40002_
                 (lambda (_target40033_)
                   (if (<= '0 _target40033_)
                       (_fg-perform40003_ _target40033_)
                       (_bg-perform40005_ _target40033_))))
                (_fg-perform40003_
                 (lambda (_target40027_)
                   (letrec* ((_spec40029_
                              (vector-ref _spec@39927_ _target40027_))
                             (_id40030_ (vector-ref _id@39931_ _target40027_)))
                     (if (_verbose>=?39926_ '7)
                         (std/make#writeln
                          (cons 'Perform:
                                (cons _target40027_
                                      (cons _spec40029_
                                            (cons _id40030_
                                                  (cons (table-ref
                                                         _timestamp%39934_
                                                         _id40030_
                                                         '#f)
                                                        '()))))))
                         '#!void)
                     (if (and (not _force?39923_)
                              (< (std/misc/hash#hash-ensure-ref
                                  _timestamp%39934_
                                  _id40030_
                                  (lambda ()
                                    (_compute-timestamp39999_ _target40027_)))
                                 '+inf.0))
                         (begin
                           (if (_verbose>=?39926_ '5)
                               (std/make#writeln
                                (cons 'Up-to-date:
                                      (cons _target40027_
                                            (cons _spec40029_
                                                  (cons (table-ref
                                                         _timestamp%39934_
                                                         _id40030_)
                                                        '())))))
                               '#!void)
                           (table-ref _timestamp%39934_ _id40030_))
                         (if (std/make#spec-backgroundable? _spec40029_)
                             (begin
                               (std/misc/pqueue#pqueue-push!
                                _ready-bg39938_
                                (bitwise-not _target40027_))
                               '+inf.0)
                             (_build-target40004_ _target40027_))))))
                (_build-target40004_
                 (lambda (_target40025_)
                   (std/make#build
                    (vector-ref _spec@39927_ _target40025_)
                    _settings39921_)
                   (_compute-new-timestamp40000_ _target40025_)))
                (_bg-perform40005_
                 (lambda (_target40023_)
                   (_build-target40004_ (bitwise-not _target40023_))))
                (_on-success40006_
                 (lambda (_item40016_ _timestamp40017_)
                   (letrec* ((_target40019_ (_target<-item40001_ _item40016_))
                             (_spec40020_
                              (vector-ref _spec@39927_ _target40019_))
                             (_id40021_ (vector-ref _id@39931_ _target40019_)))
                     (if (_verbose>=?39926_ '7)
                         (std/make#writeln
                          (cons 'on-success:
                                (cons _item40016_
                                      (cons _target40019_
                                            (cons _id40021_
                                                  (cons _spec40020_
                                                        (cons _timestamp40017_
                                                              '())))))))
                         '#!void)
                     (if (< _timestamp40017_ '+inf.0)
                         (begin
                           (table-set!
                            _timestamp%39934_
                            _id40021_
                            _timestamp40017_)
                           (_mark-built39991_ _target40019_))
                         '#!void))))
                (_on-failure40007_
                 (lambda (_item40013_ _exception40014_)
                   (error '"Failure to build"
                          (vector-ref
                           _spec@39927_
                           (_target<-item40001_ _item40013_))
                          (error-message _exception40014_)))))
        (begin
          (create-directory*
           (##structure-ref _settings39921_ '3 std/make#settings::t '#f))
          (create-directory*
           (##structure-ref _settings39921_ '2 std/make#settings::t '#f))
          (if (##structure-ref _settings39921_ '8 std/make#settings::t '#f)
              (create-directory*
               (path-expand
                '"static"
                (##structure-ref _settings39921_ '2 std/make#settings::t '#f)))
              '#!void)
          (_init-walk39990_)
          (if (_verbose>=?39926_ '6)
              (std/make#writeln
               (cons 'Step:
                     (cons '5.
                           (cons 'queue:
                                 (cons (std/sort#sort
                                        (std/misc/pqueue#pqueue-contents
                                         _ready-fg39937_)
                                        <)
                                       '())))))
              '#!void)
          (std/misc/concurrent-plan#perform-plan/threads__%
           '#f
           _perform40002_
           (if (_verbose>=?39926_ '8)
               (lambda (_item40009_)
                 (letrec* ((_target40011_ (_target<-item40001_ _item40009_)))
                   (std/make#writeln
                    (cons 'announcing:
                          (cons _item40009_
                                (cons (vector-ref _spec@39927_ _target40011_)
                                      '()))))))
               void)
           _on-success40006_
           _on-failure40007_
           '#f
           (max (##structure-ref _settings39921_ '13 std/make#settings::t '#f)
                '1)
           _ready-fg39937_
           _ready-bg39938_)
          (if (_verbose>=?39926_ '3)
              (std/make#writeln
               (cons 'Step: (cons '5 (cons '"All built" '()))))
              '#!void)))))
  (define std/make#file-dependencies
    (lambda (_file39890_ _settings39891_)
      (letrec* ((_ht39893_ (make-table 'test: eq?))
                (_q39894_
                 (let ((__obj304854 (make-object std/misc/queue#queue::t '3)))
                   (std/misc/queue#queue:::init! __obj304854)
                   __obj304854))
                (_mod39895_
                 (with-cons-load-path
                  (lambda () (gx#import-module__0 _file39890_))
                  (##structure-ref
                   _settings39891_
                   '1
                   std/make#settings::t
                   '#f)))
                (_mod-id39896_
                 (##structure-ref _mod39895_ '1 gx#expander-context::t '#f))
                (_consider39897_
                 (lambda (_m39905_)
                   (let ((_id3990639908_
                          (##structure-ref
                           _m39905_
                           '1
                           gx#expander-context::t
                           '#f)))
                     (if _id3990639908_
                         (let* ((_id39911_ _id3990639908_)
                                (_module-id39913_
                                 (std/make#module-strip-nesting _id39911_)))
                           (if (eq? _module-id39913_ _mod-id39896_)
                               (for-each
                                (lambda (_g3991439916_)
                                  (std/misc/queue#enqueue!
                                   _q39894_
                                   _g3991439916_))
                                (cons (gx#core-context-prelude__% _m39905_)
                                      (##structure-ref
                                       _m39905_
                                       '8
                                       gx#module-context::t
                                       '#f)))
                               (table-set! _ht39893_ _module-id39913_ '#t)))
                         '#f)))))
        (_consider39897_ _mod39895_)
        (let _lp39899_ ()
          (if (std/misc/queue#queue-empty? _q39894_)
              '#!void
              (begin
                (let ((_hd39903_ (std/misc/queue#dequeue!__% _q39894_ '#f)))
                  (if (let ()
                        (declare (not safe))
                        (##structure-instance-of?
                         _hd39903_
                         'gx#module-context::t))
                      (_consider39897_ _hd39903_)
                      (if (let ()
                            (declare (not safe))
                            (##structure-instance-of?
                             _hd39903_
                             'gx#prelude-context::t))
                          (_consider39897_ _hd39903_)
                          (if (let ()
                                (declare (not safe))
                                (##structure-direct-instance-of?
                                 _hd39903_
                                 'gx#module-import::t))
                              (std/misc/queue#enqueue!
                               _q39894_
                               (##direct-structure-ref
                                _hd39903_
                                '1
                                gx#module-import::t
                                '#f))
                              (if (let ()
                                    (declare (not safe))
                                    (##structure-direct-instance-of?
                                     _hd39903_
                                     'gx#module-export::t))
                                  (std/misc/queue#enqueue!
                                   _q39894_
                                   (##direct-structure-ref
                                    _hd39903_
                                    '1
                                    gx#module-export::t
                                    '#f))
                                  (if (let ()
                                        (declare (not safe))
                                        (##structure-direct-instance-of?
                                         _hd39903_
                                         'gx#import-set::t))
                                      (std/misc/queue#enqueue!
                                       _q39894_
                                       (##direct-structure-ref
                                        _hd39903_
                                        '1
                                        gx#import-set::t
                                        '#f))
                                      (error '"Unexpected module import"
                                             _hd39903_)))))))
                (_lp39899_))))
        (values _mod-id39896_
                (std/sort#sort
                 (hash-keys _ht39893_)
                 std/misc/symbol#symbol<?)))))
  (define std/make#normalize-buildspec
    (lambda (_buildspec39591_)
      (letrec* ((_submodules39593_ '())
                (_get-submodules39594_
                 (lambda ()
                   (let ((_$r39887_ (reverse _submodules39593_)))
                     (set! _submodules39593_ '())
                     _$r39887_)))
                (_no-submodules39595_
                 (lambda (_spec39884_)
                   (if (null? _submodules39593_)
                       '#!void
                       (error '"incompatible sequence of build specifications"
                              (reverse (cons _spec39884_
                                             _submodules39593_))))))
                (_push-submodule39596_
                 (lambda (_spec39882_)
                   (set! _submodules39593_
                         (cons _spec39882_ _submodules39593_)))))
        (let* ((_head39598_ (cons '#f '())) (_tail39601_ _head39598_))
          ((lambda (_g3976139763_) (for-each _g3976139763_ _buildspec39591_))
           (lambda (_spec39766_)
             (let ((_$e39768_ (std/make#spec-type _spec39766_)))
               (if (eq? 'gxc: _$e39768_)
                   (let ((_s39771_ (_get-submodules39594_)))
                     (if (null? _s39771_)
                         (let ((_new-tail39773_ (cons _spec39766_ '())))
                           (let ()
                             (declare (not safe))
                             (##set-cdr! _tail39601_ _new-tail39773_))
                           (set! _tail39601_ _new-tail39773_))
                         (let ((_new-tail39864_
                                (cons (let* ((_spec3977539794_ _spec39766_)
                                             (_E3977939798_
                                              (lambda ()
                                                (error '"No clause matching"
                                                       _spec3977539794_))))
                                        (let ((_K3978639840_
                                               (lambda (_args39836_
                                                        _plist39837_
                                                        _name39838_)
                                                 (cons 'gxc:
                                                       (cons _name39838_
                                                             (cons (std/misc/plist#psetq
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _plist39837_
                            'submodules:
                            (append (pgetq _plist39837_ 'submodules:)
                                    _s39771_))
                           '())))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_K3978139816_
                                               (lambda (_args39813_
                                                        _name39814_)
                                                 (cons 'gxc:
                                                       (cons _name39814_
                                                             (cons (cons 'submodules:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 (cons _s39771_ '()))
                           _args39813_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_K3978039804_
                                               (lambda (_spec39802_)
                                                 (cons 'gxc:
                                                       (cons _spec39802_
                                                             (cons (cons 'submodules:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 (cons _s39771_ '()))
                           '()))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                          (let ((_try-match3977839809_
                                                 (lambda ()
                                                   (if (string? _spec3977539794_)
                                                       (let ((_spec39807_
                                                              _spec3977539794_))
                                                         (_K3978039804_
                                                          _spec39807_))
                                                       (_E3977939798_)))))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _spec3977539794_))
                                                (let ((_tl3978839845_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _spec3977539794_)))
                                                      (_hd3978739843_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _spec3977539794_))))
                                                  (if (let ()
                                                        (declare (not safe))
                                                        (##eq? _hd3978739843_
                                                               'gxc:))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##pair? _tl3978839845_))
                                                          (let ((_tl3979039850_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let () (declare (not safe)) (##cdr _tl3978839845_)))
                        (_hd3978939848_
                         (let () (declare (not safe)) (##car _tl3978839845_))))
                    (if (let () (declare (not safe)) (##pair? _tl3979039850_))
                        (let ((_tl3979239857_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl3979039850_)))
                              (_hd3979139855_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl3979039850_))))
                          (if (pair? _hd3979139855_)
                              (let ((_name39853_ _hd3978939848_)
                                    (_plist39860_ _hd3979139855_)
                                    (_args39862_ _tl3979239857_))
                                (_K3978639840_
                                 _args39862_
                                 _plist39860_
                                 _name39853_))
                              (let ((_name39829_ _hd3978939848_)
                                    (_args39831_ _tl3979039850_))
                                (_K3978139816_ _args39831_ _name39829_))))
                        (let ((_name39829_ _hd3978939848_)
                              (_args39831_ _tl3979039850_))
                          (_K3978139816_ _args39831_ _name39829_))))
                  (if (string? _spec3977539794_)
                      (let ((_spec39807_ _spec3977539794_))
                        (_K3978039804_ _spec39807_))
                      (_E3977939798_)))
              (if (string? _spec3977539794_)
                  (let ((_spec39807_ _spec3977539794_))
                    (_K3978039804_ _spec39807_))
                  (_E3977939798_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (_try-match3977839809_)))))
                                      '())))
                           (let ()
                             (declare (not safe))
                             (##set-cdr! _tail39601_ _new-tail39864_))
                           (set! _tail39601_ _new-tail39864_))))
                   (if (or (eq? 'exe: _$e39768_) (eq? 'static-exe: _$e39768_))
                       (begin
                         (_no-submodules39595_ _spec39766_)
                         (let ((_new-tail39870_ (cons _spec39766_ '())))
                           (let ()
                             (declare (not safe))
                             (##set-cdr! _tail39601_ _new-tail39870_))
                           (set! _tail39601_ _new-tail39870_)))
                       (if (or (eq? 'gsc: _$e39768_)
                               (eq? 'static-include: _$e39768_)
                               (eq? 'copy: _$e39768_))
                           (_push-submodule39596_ _spec39766_)
                           (if (eq? 'ssi: _$e39768_)
                               (let ((_new-tail39879_
                                      (cons (append _spec39766_
                                                    (_get-submodules39594_))
                                            '())))
                                 (let ()
                                   (declare (not safe))
                                   (##set-cdr! _tail39601_ _new-tail39879_))
                                 (set! _tail39601_ _new-tail39879_))
                               (error '"Unrecognized spec type"
                                      _spec39766_))))))))
          (_no-submodules39595_ '#!eof)
          (let () (declare (not safe)) (##cdr _head39598_))))))
  (define std/make#shell-config
    (lambda (_cmd39583_ . _args39584_)
      (let* ((_proc39586_
              (open-input-process
               (cons 'path:
                     (cons _cmd39583_
                           (cons 'arguments: (cons _args39584_ '()))))))
             (_status39588_ (process-status _proc39586_)))
        (if (zero? _status39588_)
            '#!void
            (error '"Error executing config script"
                   _cmd39583_
                   _args39584_
                   _status39588_))
        (read-line _proc39586_))))
  (define std/make#env-ldflags
    (lambda ()
      (let ((_$e39576_ (getenv '"LDFLAGS" '#f)))
        (if _$e39576_
            ((lambda (_flags39579_)
               (lambda (_lib39581_)
                 (string-append _flags39579_ '" " _lib39581_)))
             _$e39576_)
            identity))))
  (define std/make#env-cppflags
    (lambda ()
      (let ((_$e39568_ (getenv '"CPPFLAGS" '#f)))
        (if _$e39568_
            ((lambda (_flags39571_)
               (lambda (_more39573_)
                 (if (string-empty? _more39573_)
                     _flags39571_
                     (string-append _flags39571_ '" " _more39573_))))
             _$e39568_)
            identity))))
  (define std/make#include-gambit-sharp
    (lambda ()
      (if (gerbil-runtime-smp?)
          '("-e"
            "(define-cond-expand-feature|enable-smp|)"
            "-e"
            "(include \"~~lib/_gambit#.scm\")")
          '("-e" "(include \"~~lib/_gambit#.scm\")"))))
  (define std/make#build
    (lambda (_spec39332_ _settings39333_)
      (let* ((_spec3933439382_ _spec39332_)
             (_else3934339390_
              (lambda () (error '"Bad buildspec" _spec39332_))))
        (let ((_K3938039561_
               (lambda (_modf39559_)
                 (std/make#gxc-compile__%
                  _modf39559_
                  '#f
                  _settings39333_
                  '#t)))
              (_K3937539539_
               (lambda (_opts39536_ _modf39537_)
                 (std/make#gxc-compile__%
                  _modf39537_
                  _opts39536_
                  _settings39333_
                  '#t)))
              (_K3937039515_
               (lambda (_opts39512_ _modf39513_)
                 (std/make#gsc-compile
                  _modf39513_
                  _opts39512_
                  _settings39333_)))
              (_K3936539491_
               (lambda (_submodules39484_ _modf39485_)
                 (for-each
                  (lambda (_g3948639488_)
                    (std/make#build _g3948639488_ _settings39333_))
                  _submodules39484_)
                 (std/make#compile-ssi _modf39485_ '() _settings39333_)))
              (_K3936039463_
               (lambda (_opts39460_ _modf39461_)
                 (std/make#compile-exe
                  _modf39461_
                  _opts39460_
                  _settings39333_)))
              (_K3935539439_
               (lambda (_opts39436_ _modf39437_)
                 (std/make#compile-static-exe
                  _modf39437_
                  _opts39436_
                  _settings39333_)))
              (_K3935039417_
               (lambda (_file39415_)
                 (std/make#copy-static _file39415_ _settings39333_)))
              (_K3934539396_
               (lambda (_file39394_)
                 (std/make#copy-compiled _file39394_ _settings39333_))))
          (let ((_try-match3933639556_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec3933439382_))
                       (let ((_tl3937739544_
                              (let ()
                                (declare (not safe))
                                (##cdr _spec3933439382_)))
                             (_hd3937639542_
                              (let ()
                                (declare (not safe))
                                (##car _spec3933439382_))))
                         (if (let ()
                               (declare (not safe))
                               (##eq? _hd3937639542_ 'gxc:))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _tl3937739544_))
                                 (let ((_tl3937939549_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _tl3937739544_)))
                                       (_hd3937839547_
                                        (let ()
                                          (declare (not safe))
                                          (##car _tl3937739544_))))
                                   (let ((_modf39552_ _hd3937839547_)
                                         (_opts39554_ _tl3937939549_))
                                     (_K3937539539_ _opts39554_ _modf39552_)))
                                 (_else3934339390_))
                             (if (let ()
                                   (declare (not safe))
                                   (##eq? _hd3937639542_ 'gsc:))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl3937739544_))
                                     (let ((_tl3937439525_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl3937739544_)))
                                           (_hd3937339523_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl3937739544_))))
                                       (let ((_modf39528_ _hd3937339523_)
                                             (_opts39530_ _tl3937439525_))
                                         (_K3937039515_
                                          _opts39530_
                                          _modf39528_)))
                                     (_else3934339390_))
                                 (if (let ()
                                       (declare (not safe))
                                       (##eq? _hd3937639542_ 'ssi:))
                                     (if (let ()
                                           (declare (not safe))
                                           (##pair? _tl3937739544_))
                                         (let ((_tl3936939501_
                                                (let ()
                                                  (declare (not safe))
                                                  (##cdr _tl3937739544_)))
                                               (_hd3936839499_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl3937739544_))))
                                           (let ((_modf39504_ _hd3936839499_)
                                                 (_submodules39506_
                                                  _tl3936939501_))
                                             (_K3936539491_
                                              _submodules39506_
                                              _modf39504_)))
                                         (_else3934339390_))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _hd3937639542_ 'exe:))
                                         (if (let ()
                                               (declare (not safe))
                                               (##pair? _tl3937739544_))
                                             (let ((_tl3936439473_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _tl3937739544_)))
                                                   (_hd3936339471_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl3937739544_))))
                                               (let ((_modf39476_
                                                      _hd3936339471_)
                                                     (_opts39478_
                                                      _tl3936439473_))
                                                 (_K3936039463_
                                                  _opts39478_
                                                  _modf39476_)))
                                             (_else3934339390_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##eq? _hd3937639542_
                                                      'static-exe:))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##pair? _tl3937739544_))
                                                 (let ((_tl3935939449_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _tl3937739544_)))
                                                       (_hd3935839447_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl3937739544_))))
                                                   (let ((_modf39452_
                                                          _hd3935839447_)
                                                         (_opts39454_
                                                          _tl3935939449_))
                                                     (_K3935539439_
                                                      _opts39454_
                                                      _modf39452_)))
                                                 (_else3934339390_))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##eq? _hd3937639542_
                                                          'static-include:))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##pair? _tl3937739544_))
                                                     (let ((_tl3935439427_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##cdr _tl3937739544_)))
                                                           (_hd3935339425_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##car _tl3937739544_))))
                                                       (if (let ()
                                                             (declare
                                                               (not safe))
                                                             (##null? _tl3935439427_))
                                                           (let ((_file39430_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _hd3935339425_))
                     (_K3935039417_ _file39430_))
                   (_else3934339390_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else3934339390_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##eq? _hd3937639542_
                                                              'copy:))
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##pair? _tl3937739544_))
                                                         (let ((_tl3934939406_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##cdr _tl3937739544_)))
                       (_hd3934839404_
                        (let () (declare (not safe)) (##car _tl3937739544_))))
                   (if (let () (declare (not safe)) (##null? _tl3934939406_))
                       (let ((_file39409_ _hd3934839404_))
                         (_K3934539396_ _file39409_))
                       (_else3934339390_)))
                 (_else3934339390_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else3934339390_)))))))))
                       (_else3934339390_)))))
            (if (string? _spec3933439382_)
                (let ((_modf39564_ _spec3933439382_))
                  (_K3938039561_ _modf39564_))
                (_try-match3933639556_)))))))
  (define std/make#gxc-outputs
    (lambda (_mod39328_ _opts39329_ _settings39330_)
      (cons (std/make#library-path _mod39328_ '".ssi" _settings39330_)
            (if (##structure-ref _settings39330_ '8 std/make#settings::t '#f)
                (cons (std/make#static-path _mod39328_ _settings39330_) '())
                '()))))
  (define std/make#gsc-compile-opts
    (lambda (_opts39262_)
      (let* ((_opts3926339278_ _opts39262_)
             (_E3926639282_
              (lambda () (error '"No clause matching" _opts3926339278_))))
        (let ((_K3926839296_
               (lambda (_rest39293_ _plist39294_)
                 (std/misc/list#listify _rest39293_)))
              (_K3926739287_ (lambda () (std/misc/list#listify _opts39262_))))
          (let ((___match304849304850_
                 (lambda (_hd3926939299_ _tl3927039301_)
                   (letrec ((_splice-rest3927239304_
                             (lambda (_rest3927639311_ _plist39313_)
                               (if (let ()
                                     (declare (not safe))
                                     (##null? _rest3927639311_))
                                   (let ((_rest39315_ _tl3927039301_))
                                     (_K3926839296_ _rest39315_ _plist39313_))
                                   (_K3926739287_))))
                            (_splice-try3927439306_
                             (lambda (_hd3927539317_
                                      _rest3927639319_
                                      _plist3927139320_)
                               (let ((_plist39323_ _hd3927539317_))
                                 (_splice-loop3927339308_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _rest3927639319_))
                                  (cons _plist39323_ _plist3927139320_)))))
                            (_splice-loop3927339308_
                             (lambda (_rest3927639325_ _plist3927139326_)
                               (if (pair? _rest3927639325_)
                                   (_splice-try3927439306_
                                    (let ()
                                      (declare (not safe))
                                      (##car _rest3927639325_))
                                    _rest3927639325_
                                    _plist3927139326_)
                                   (_splice-rest3927239304_
                                    _rest3927639325_
                                    (reverse _plist3927139326_))))))
                     (_splice-loop3927339308_ _hd3926939299_ '())))))
            (if (let () (declare (not safe)) (##pair? _opts3926339278_))
                (let ((_tl3927039301_
                       (let () (declare (not safe)) (##cdr _opts3926339278_)))
                      (_hd3926939299_
                       (let () (declare (not safe)) (##car _opts3926339278_))))
                  (___match304849304850_ _hd3926939299_ _tl3927039301_))
                (_K3926739287_)))))))
  (define std/make#gxc-compile__%
    (lambda (_mod39223_ _opts39224_ _settings39225_ _invoke-gsc?39226_)
      (std/make#message '"... compile " _mod39223_)
      (letrec* ((_foreground?39228_
                 (if (pair? _opts39224_)
                     (if (pair? (car _opts39224_))
                         (pgetq 'foreground: (car _opts39224_))
                         '#f)
                     '#f))
                (_gsc-opts39229_ (std/make#gsc-compile-opts _opts39224_))
                (_srcpath39230_
                 (std/make#source-path _mod39223_ '".ss" _settings39225_)))
        (if (or _foreground?39228_
                (> '1
                   (##structure-ref
                    _settings39225_
                    '13
                    std/make#settings::t
                    '#f)))
            (let ((_gxc-opts39235_
                   (cons 'invoke-gsc:
                         (cons _invoke-gsc?39226_
                               (cons 'keep-scm:
                                     (cons (not _invoke-gsc?39226_)
                                           (cons 'output-dir:
                                                 (cons (##structure-ref
                                                        _settings39225_
                                                        '2
                                                        std/make#settings::t
                                                        '#f)
                                                       (cons 'optimize:
                                                             (cons (##structure-ref
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _settings39225_
                            '6
                            std/make#settings::t
                            '#f)
                           (cons 'debug:
                                 (cons (##structure-ref
                                        _settings39225_
                                        '7
                                        std/make#settings::t
                                        '#f)
                                       (cons 'generate-ssxi:
                                             (cons '#t
                                                   (cons 'static:
                                                         (cons (##structure-ref
                                                                _settings39225_
                                                                '8
                                                                std/make#settings::t
                                                                '#f)
                                                               (cons 'verbose:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (cons (std/make#settings-verbose>=?
                                    _settings39225_
                                    '9)
                                   (if _gsc-opts39229_
                                       (cons 'gsc-options:
                                             (cons _gsc-opts39229_ '()))
                                       '())))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
              (gxc#compile-file__% _srcpath39230_ _gxc-opts39235_))
            (let* ((_arguments39239_
                    (cons '"-d"
                          (cons (##structure-ref
                                 _settings39225_
                                 '2
                                 std/make#settings::t
                                 '#f)
                                (foldr1 cons
                                        (foldr1 cons
                                                (foldr1 cons
                                                        (foldr1 cons
                                                                (foldr1 cons
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                (foldr1 cons
                                        (cons _srcpath39230_ '())
                                        (if _gsc-opts39229_
                                            (std/srfi/1#append-map
                                             (lambda (_x39237_)
                                               (cons '"-gsc-flag"
                                                     (cons _x39237_ '())))
                                             _gsc-opts39229_)
                                            '()))
                                (if (std/make#settings-verbose>=?
                                     _settings39225_
                                     '9)
                                    (cons '"-v" '())
                                    '()))
                        (if (##structure-ref
                             _settings39225_
                             '8
                             std/make#settings::t
                             '#f)
                            (cons '"-static" '())
                            '()))
                (if (##structure-ref
                     _settings39225_
                     '7
                     std/make#settings::t
                     '#f)
                    (cons '"-g" '())
                    '()))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (if (##structure-ref
                                                     _settings39225_
                                                     '6
                                                     std/make#settings::t
                                                     '#f)
                                                    (cons '"-O" '())
                                                    '()))
                                        (if (not _invoke-gsc?39226_)
                                            (cons '"-s" (cons '"-S" '()))
                                            '())))))
                   (___39241_
                    (if (std/make#settings-verbose>=? _settings39225_ '7)
                        (std/make#writeln
                         (cons 'invoking:
                               (cons (std/make#gerbil-gxc) _arguments39239_)))
                        '#!void))
                   (_proc39243_
                    (open-process
                     (cons 'path:
                           (cons (std/make#gerbil-gxc)
                                 (cons 'arguments:
                                       (cons _arguments39239_
                                             (cons 'stdout-redirection:
                                                   (cons '#f '()))))))))
                   (_status39245_ (process-status _proc39243_)))
              (close-port _proc39243_)
              (if (zero? _status39245_)
                  '#!void
                  (error '"Compilation error; gxc exited with nonzero status"
                         _status39245_)))))))
  (define std/make#gxc-compile__0
    (lambda (_mod39251_ _opts39252_ _settings39253_)
      (let ((_invoke-gsc?39255_ '#t))
        (std/make#gxc-compile__%
         _mod39251_
         _opts39252_
         _settings39253_
         _invoke-gsc?39255_))))
  (define std/make#gxc-compile
    (lambda _g304906_
      (let ((_g304905_ (let () (declare (not safe)) (##length _g304906_))))
        (cond ((let () (declare (not safe)) (##fx= _g304905_ 3))
               (apply std/make#gxc-compile__0 _g304906_))
              ((let () (declare (not safe)) (##fx= _g304905_ 4))
               (apply std/make#gxc-compile__% _g304906_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/make#gxc-compile
                _g304906_))))))
  (define std/make#gsc-libpath
    (lambda (_mod39212_ _settings39213_)
      (letrec* ((_libdir-prefix39215_
                 (##structure-ref
                  _settings39213_
                  '12
                  std/make#settings::t
                  '#f)))
        (let ((_$e39217_ (string-rindex _mod39212_ '#\/)))
          (if _$e39217_
              ((lambda (_ix39220_)
                 (path-expand
                  (substring _mod39212_ '0 _ix39220_)
                  _libdir-prefix39215_))
               _$e39217_)
              _libdir-prefix39215_)))))
  (define std/make#gsc-base
    (lambda (_mod39205_)
      (let ((_$e39207_ (string-rindex _mod39205_ '#\/)))
        (if _$e39207_
            ((lambda (_ix39210_)
               (substring
                _mod39205_
                (fx+ _ix39210_ '1)
                (string-length _mod39205_)))
             _$e39207_)
            _mod39205_))))
  (define std/make#gsc-c-path
    (lambda (_modf39191_ _settings39192_)
      (letrec* ((_mod39194_ (path-strip-extension _modf39191_))
                (_libpath39195_
                 (std/make#gsc-libpath _mod39194_ _settings39192_))
                (_base39196_ (std/make#gsc-base _mod39194_)))
        (let _lp39198_ ((_n39200_ '1) (_cpath39201_ '#f))
          (let ((_next39203_
                 (path-expand
                  (string-append _base39196_ '".o" (number->string _n39200_))
                  _libpath39195_)))
            (if (file-exists? _next39203_)
                (_lp39198_ (fx+ _n39200_ '1) _next39203_)
                _cpath39201_))))))
  (define std/make#gsc-compile
    (lambda (_mod39176_ _opts39177_ _settings39178_)
      (letrec* ((_gsc-opts39180_ (std/make#gsc-compile-opts _opts39177_))
                (_srcpath39181_
                 (std/make#source-path _mod39176_ '".scm" _settings39178_))
                (_libpath39182_
                 (std/make#gsc-libpath _mod39176_ _settings39178_)))
        (create-directory* _libpath39182_)
        (std/make#message '"... compile foreign " _mod39176_)
        (let* ((_proc39184_
                (open-process
                 (cons 'path:
                       (cons (std/make#gerbil-gsc)
                             (cons 'arguments:
                                   (cons (cons '"-o"
                                               (cons _libpath39182_
                                                     (foldr1 cons
                                                             (cons _srcpath39181_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           '())
                     _gsc-opts39180_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                         (cons 'stdout-redirection:
                                               (cons '#f '()))))))))
               (_status39186_ (process-status _proc39184_)))
          (close-port _proc39184_)
          (if (zero? _status39186_)
              '#!void
              (error '"Compilation error; gsc exited with nonzero status"
                     _status39186_)))
        (if (##structure-ref _settings39178_ '8 std/make#settings::t '#f)
            (let ((_statpath39189_
                   (std/make#static-path _mod39176_ _settings39178_)))
              (if (file-exists? _statpath39189_)
                  (delete-file _statpath39189_)
                  '#!void)
              (copy-file _srcpath39181_ _statpath39189_))
            '#!void))))
  (define std/make#gerbil-gsc
    (lambda () (getenv '"GERBIL_GSC" std/make#default-gambit-gsc)))
  (define std/make#gerbil-gxc
    (lambda () (getenv '"GERBIL_GXC" std/make#default-gerbil-gxc)))
  (define std/make#compile-ssi
    (lambda (_mod39157_ _deps39158_ _settings39159_)
      (letrec* ((_srcpath39161_
                 (std/make#source-path _mod39157_ '".ssi" _settings39159_))
                (_libpath39162_
                 (std/make#library-path _mod39157_ '".ssi" _settings39159_))
                (_rtpath39163_
                 (std/make#library-path
                  _mod39157_
                  '"__rt.scm"
                  _settings39159_))
                (_prefix39164_
                 (##structure-ref
                  _settings39159_
                  '4
                  std/make#settings::t
                  '#f)))
        (std/make#message '"... copy ssi " _mod39157_)
        (create-directory* (path-directory _libpath39162_))
        (if (file-exists? _libpath39162_) (delete-file _libpath39162_) '#!void)
        (copy-file _srcpath39161_ _libpath39162_)
        (std/make#message '"... compile loader " _mod39157_)
        (with-output-to-file
         _rtpath39163_
         (lambda ()
           (for-each
            (lambda (_dep39167_)
              (pretty-print (cons 'load-module (cons _dep39167_ '()))))
            _deps39158_)
           (pretty-print
            (cons 'load-module
                  (cons (std/make#prefix/ _prefix39164_ _mod39157_) '())))))
        (let* ((_proc39169_
                (open-process
                 (cons 'path:
                       (cons (std/make#gerbil-gsc)
                             (cons 'arguments:
                                   (cons (cons _rtpath39163_ '())
                                         (cons 'stdout-redirection:
                                               (cons '#f '()))))))))
               (_status39171_ (process-status _proc39169_)))
          (close-port _proc39169_)
          (if (zero? _status39171_)
              '#!void
              (error '"Compilation error; gsc exited with nonzero status"
                     _status39171_))
          (delete-file _rtpath39163_)))))
  (define std/make#compile-exe
    (lambda (_mod39148_ _opts39149_ _settings39150_)
      (letrec* ((_srcpath39152_
                 (std/make#source-path _mod39148_ '".ss" _settings39150_))
                (_binpath39153_
                 (std/make#binary-path _mod39148_ _opts39149_ _settings39150_))
                (_gsc-opts39154_ (std/make#compile-exe-gsc-opts _opts39149_))
                (_gxc-opts39155_
                 (cons 'invoke-gsc:
                       (cons '#t
                             (cons 'output-file:
                                   (cons _binpath39153_
                                         (cons 'verbose:
                                               (cons (std/make#settings-verbose>=?
                                                      _settings39150_
                                                      '9)
                                                     '()))))))))
        (std/make#gxc-compile__0 _mod39148_ _gsc-opts39154_ _settings39150_)
        (std/make#message
         '"... compile exe "
         _mod39148_
         '" -> "
         _binpath39153_)
        (gxc#compile-exe-stub__% _srcpath39152_ _gxc-opts39155_))))
  (define std/make#compile-exe-gsc-opts
    (lambda (_opts39106_)
      (let* ((_opts3910739117_ _opts39106_)
             (_else3910939125_ (lambda () _opts39106_))
             (_K3911139131_
              (lambda (_rest39128_ _opt39129_)
                (std/make#compile-exe-gsc-opts _rest39128_))))
        (if (let () (declare (not safe)) (##pair? _opts3910739117_))
            (let ((_hd3911239134_
                   (let () (declare (not safe)) (##car _opts3910739117_)))
                  (_tl3911339136_
                   (let () (declare (not safe)) (##cdr _opts3910739117_))))
              (if (keyword? _hd3911239134_)
                  (if (let () (declare (not safe)) (##pair? _tl3911339136_))
                      (let ((_hd3911439139_
                             (let ()
                               (declare (not safe))
                               (##car _tl3911339136_)))
                            (_tl3911539141_
                             (let ()
                               (declare (not safe))
                               (##cdr _tl3911339136_))))
                        (let* ((_opt39144_ _hd3911439139_)
                               (_rest39146_ _tl3911539141_))
                          (_K3911139131_ _rest39146_ _opt39144_)))
                      (_else3910939125_))
                  (_else3910939125_)))
            (_else3910939125_)))))
  (define std/make#make-settings-static
    (lambda (_settings39102_)
      (letrec* ((_s39104_ (struct-copy _settings39102_)))
        (##structure-set! _s39104_ '#t '8 std/make#settings::t '#f)
        _s39104_)))
  (define std/make#compile-static-exe
    (lambda (_mod39093_ _opts39094_ _settings39095_)
      (letrec* ((_srcpath39097_
                 (std/make#source-path _mod39093_ '".ss" _settings39095_))
                (_binpath39098_
                 (std/make#binary-path _mod39093_ _opts39094_ _settings39095_))
                (_gsc-opts39099_ (std/make#compile-exe-gsc-opts _opts39094_))
                (_gxc-opts39100_
                 (cons 'invoke-gsc:
                       (cons '#t
                             (cons 'output-file:
                                   (cons _binpath39098_
                                         (cons 'verbose:
                                               (cons (std/make#settings-verbose>=?
                                                      _settings39095_
                                                      '9)
                                                     (cons 'debug:
                                                           (cons (##structure-ref
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _settings39095_
                          '9
                          std/make#settings::t
                          '#f)
                         (if _gsc-opts39099_
                             (cons 'gsc-options: (cons _gsc-opts39099_ '()))
                             '())))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        (std/make#gxc-compile__0
         _mod39093_
         _gsc-opts39099_
         (std/make#make-settings-static _settings39095_))
        (std/make#message
         '"... compile static exe "
         _mod39093_
         '" -> "
         _binpath39098_)
        (gxc#compile-static-exe__% _srcpath39097_ _gxc-opts39100_))))
  (define std/make#copy-static
    (lambda (_file39088_ _settings39089_)
      (letrec* ((_spath39091_
                 (std/make#static-file-path _file39088_ _settings39089_)))
        (std/make#message '"... copy static include " _file39088_)
        (if (file-exists? _spath39091_) (delete-file _spath39091_) '#!void)
        (copy-file _file39088_ _spath39091_))))
  (define std/make#copy-compiled
    (lambda (_file39082_ _settings39083_)
      (letrec* ((_srcpath39085_
                 (std/make#source-path _file39082_ '#f _settings39083_))
                (_libpath39086_
                 (std/make#library-path _file39082_ '#f _settings39083_)))
        (std/make#message '"... copy std/" _file39082_)
        (if (file-exists? _libpath39086_) (delete-file _libpath39086_) '#!void)
        (copy-file _srcpath39085_ _libpath39086_))))
  (define std/make#source-path
    (lambda (_mod39078_ _ext39079_ _settings39080_)
      (path-expand
       (std/misc/path#path-default-extension _mod39078_ _ext39079_)
       (##structure-ref _settings39080_ '1 std/make#settings::t '#f))))
  (define std/make#library-path
    (lambda (_mod39074_ _ext39075_ _settings39076_)
      (path-expand
       (std/misc/path#path-force-extension _mod39074_ _ext39075_)
       (##structure-ref _settings39076_ '12 std/make#settings::t '#f))))
  (define std/make#binary-path
    (lambda (_mod39054_ _opts39055_ _settings39056_)
      (let* ((_bindir39058_
              (##structure-ref _settings39056_ '3 std/make#settings::t '#f))
             (_g304907_
              (if _bindir39058_ '#!void (error '"bindir must be specified")))
             (_bin39069_
              (let ((_$e39061_ (pgetq 'bin: _opts39055_)))
                (if _$e39061_
                    (values _$e39061_)
                    (let ((_$e39064_ (string-rindex _mod39054_ '#\/)))
                      (if _$e39064_
                          ((lambda (_ix39067_)
                             (substring
                              _mod39054_
                              (fx+ _ix39067_ '1)
                              (string-length _mod39054_)))
                           _$e39064_)
                          _mod39054_)))))
             (_bin39071_
              (if (string-empty? (path-extension _bin39069_))
                  _bin39069_
                  (path-strip-extension _bin39069_))))
        (path-expand _bin39071_ _bindir39058_))))
  (define std/make#static-path
    (lambda (_mod39040_ _settings39041_)
      (let* ((_libdir39043_
              (##structure-ref _settings39041_ '2 std/make#settings::t '#f))
             (_staticdir39045_ (path-expand '"static" _libdir39043_))
             (_mod39047_
              (std/make#prefix/
               (##structure-ref _settings39041_ '4 std/make#settings::t '#f)
               _mod39040_))
             (_base39049_ (string-join (string-split _mod39047_ '#\/) '"__"))
             (_scm39051_
              (std/misc/path#path-force-extension _base39049_ '".scm")))
        (path-expand _scm39051_ _staticdir39045_))))
  (define std/make#static-file-path
    (lambda (_file39030_ _settings39031_)
      (let* ((_libdir39033_
              (##structure-ref _settings39031_ '2 std/make#settings::t '#f))
             (_staticdir39035_ (path-expand '"static" _libdir39033_))
             (_filename39037_ (path-strip-directory _file39030_)))
        (path-expand _filename39037_ _staticdir39035_))))
  (define std/make#pkg-config
    (lambda (_lib39027_ . _args39028_)
      (apply std/make#shell-config
             '"pkg-config"
             '"--silence-errors"
             _lib39027_
             _args39028_)))
  (define std/make#pkg-config-libs
    (lambda _libs39023_
      (string-join
       (map (lambda (_l39025_) (std/make#pkg-config _l39025_ '"--libs"))
            _libs39023_)
       '" ")))
  (define std/make#pkg-config-cflags
    (lambda _libs39019_
      (string-join
       (map (lambda (_l39021_) (std/make#pkg-config _l39021_ '"--cflags"))
            _libs39019_)
       '" ")))
  (define std/make#ldflags
    (lambda (_lib39009_ _flags39010_)
      (with-exception-catcher
       (lambda (_g3901139013_)
         (if '#t
             (let ((_e39016_ _g3901139013_))
               ((std/make#env-ldflags) _flags39010_))
             (raise _g3901139013_)))
       (lambda () (std/make#pkg-config-libs _lib39009_)))))
  (define std/make#cppflags
    (lambda (_lib38999_ _flags39000_)
      (with-exception-catcher
       (lambda (_g3900139003_)
         (if '#t
             (let ((_e39006_ _g3900139003_))
               ((std/make#env-cppflags) _flags39000_))
             (raise _g3900139003_)))
       (lambda () (std/make#pkg-config-cflags _lib38999_))))))
