(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/bytes#big 'big)
  (define std/misc/bytes#little 'little)
  (define std/misc/bytes#native 'native)
  (define std/misc/bytes#u8vector-s8-ref
    (lambda (_v166974_ _i166975_)
      (if (u8vector? _v166974_) '#!void (error '"Expected u8vector" _v166974_))
      (if (and (fixnum? _i166975_)
               (fx<= '0
                     _i166975_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166974_))
                          '1)))
          '#!void
          (error '"Bad index" _v166974_ _i166975_))
      (if (and (fixnum? '1)
               (fx<= '0
                     '1
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166974_))
                          _i166975_)))
          '#!void
          (error '"Bad integer size" _v166974_ _i166975_ '1))
      (std/misc/bytes#&u8vector-s8-ref _v166974_ _i166975_)))
  (define std/misc/bytes#&u8vector-s8-ref
    (lambda (_v166968_ _i166969_)
      (declare (not safe))
      (let ((_u8166972_ (u8vector-ref _v166968_ _i166969_)))
        (if (fx> _u8166972_ '127) (fx- _u8166972_ '256) _u8166972_))))
  (define std/misc/bytes#u8vector-s8-set!
    (lambda (_v166964_ _i166965_ _s8166966_)
      (if (u8vector? _v166964_) '#!void (error '"Expected u8vector" _v166964_))
      (if (and (fixnum? _i166965_)
               (fx<= '0
                     _i166965_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166964_))
                          '1)))
          '#!void
          (error '"Bad index" _v166964_ _i166965_))
      (if (and (fixnum? '1)
               (fx<= '0
                     '1
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166964_))
                          _i166965_)))
          '#!void
          (error '"Bad integer size" _v166964_ _i166965_ '1))
      (if (fixnum? _s8166966_) '#!void (error '"expected fixnum" _s8166966_))
      (std/misc/bytes#&u8vector-s8-set! _v166964_ _i166965_ _s8166966_)))
  (define std/misc/bytes#&u8vector-s8-set!
    (lambda (_v166957_ _i166958_ _s8166959_)
      (declare (not safe))
      (let ((_u8166962_
             (if (fx< _s8166959_ '0) (fx+ _s8166959_ '256) _s8166959_)))
        (u8vector-set! _v166957_ _i166958_ _u8166962_))))
  (define std/misc/bytes#u8vector-uint-ref
    (lambda (_v166949_ _k166950_ _endianness166951_ _size166952_)
      (if (u8vector? _v166949_) '#!void (error '"Expected u8vector" _v166949_))
      (if (and (fixnum? _k166950_)
               (fx<= '0
                     _k166950_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166949_))
                          '1)))
          '#!void
          (error '"Bad index" _v166949_ _k166950_))
      (if (and (fixnum? _size166952_)
               (fx<= '0
                     _size166952_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166949_))
                          _k166950_)))
          '#!void
          (error '"Bad integer size" _v166949_ _k166950_ _size166952_))
      (let ((_$e166954_ _endianness166951_))
        (if (eq? 'big _$e166954_)
            (std/misc/bytes#&u8vector-uint-ref/be
             _v166949_
             _k166950_
             _size166952_)
            (if (eq? 'little _$e166954_)
                (std/misc/bytes#&u8vector-uint-ref/le
                 _v166949_
                 _k166950_
                 _size166952_)
                (if (eq? 'native _$e166954_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-uint-ref/le
                         _v166949_
                         _k166950_
                         _size166952_)
                        (std/misc/bytes#&u8vector-uint-ref/be
                         _v166949_
                         _k166950_
                         _size166952_))
                    (error '"Bad endianness" _endianness166951_)))))))
  (define std/misc/bytes#&u8vector-uint-ref/be
    (lambda (_v166935_ _k166936_ _size166937_)
      (declare (not safe))
      (let ((_k+size166940_ (fx+ _k166936_ _size166937_)))
        (let _lp166942_ ((_i166944_ _k166936_) (_r166945_ '0))
          (if (fx< _i166944_ _k+size166940_)
              (let ((_u8166947_ (u8vector-ref _v166935_ _i166944_)))
                (_lp166942_
                 (fx+ _i166944_ '1)
                 (bitwise-ior (arithmetic-shift _r166945_ '8) _u8166947_)))
              _r166945_)))))
  (define std/misc/bytes#&u8vector-uint-ref/le
    (lambda (_v166921_ _k166922_ _size166923_)
      (declare (not safe))
      (let ((_k+size-1166926_ (fx- (fx+ _k166922_ _size166923_) '1)))
        (let _lp166928_ ((_i166930_ _k+size-1166926_) (_r166931_ '0))
          (if (fx>= _i166930_ _k166922_)
              (let ((_u8166933_ (u8vector-ref _v166921_ _i166930_)))
                (_lp166928_
                 (fx- _i166930_ '1)
                 (bitwise-ior (arithmetic-shift _r166931_ '8) _u8166933_)))
              _r166931_)))))
  (define std/misc/bytes#u8vector-uint-set!
    (lambda (_v166912_ _k166913_ _uint166914_ _endianness166915_ _size166916_)
      (if (u8vector? _v166912_) '#!void (error '"Expected u8vector" _v166912_))
      (if (and (fixnum? _k166913_)
               (fx<= '0
                     _k166913_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166912_))
                          '1)))
          '#!void
          (error '"Bad index" _v166912_ _k166913_))
      (if (and (fixnum? _size166916_)
               (fx<= '0
                     _size166916_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166912_))
                          _k166913_)))
          '#!void
          (error '"Bad integer size" _v166912_ _k166913_ _size166916_))
      (let ((_$e166918_ _endianness166915_))
        (if (eq? 'big _$e166918_)
            (std/misc/bytes#&u8vector-uint-set!/be
             _v166912_
             _k166913_
             _uint166914_
             _size166916_)
            (if (eq? 'little _$e166918_)
                (std/misc/bytes#&u8vector-uint-set!/le
                 _v166912_
                 _k166913_
                 _uint166914_
                 _size166916_)
                (if (eq? 'native _$e166918_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-uint-set!/le
                         _v166912_
                         _k166913_
                         _uint166914_
                         _size166916_)
                        (std/misc/bytes#&u8vector-uint-set!/be
                         _v166912_
                         _k166913_
                         _uint166914_
                         _size166916_))
                    (error '"Bad endianness" _endianness166915_)))))))
  (define std/misc/bytes#&u8vector-uint-set!/be
    (lambda (_v166897_ _k166898_ _uint166899_ _size166900_)
      (declare (not safe))
      (let ((_k+size-1166903_ (fx- (fx+ _k166898_ _size166900_) '1)))
        (let _lp166905_ ((_i166907_ _k+size-1166903_)
                         (_uint166908_ _uint166899_))
          (if (fx>= _i166907_ _k166898_)
              (let ((_u8166910_ (bitwise-and _uint166908_ '255)))
                (u8vector-set! _v166897_ _i166907_ _u8166910_)
                (_lp166905_
                 (fx- _i166907_ '1)
                 (arithmetic-shift _uint166908_ '-8)))
              '#!void)))))
  (define std/misc/bytes#&u8vector-uint-set!/le
    (lambda (_v166882_ _k166883_ _uint166884_ _size166885_)
      (declare (not safe))
      (let ((_k+size166888_ (fx+ _k166883_ _size166885_)))
        (let _lp166890_ ((_i166892_ _k166883_) (_uint166893_ _uint166884_))
          (if (fx< _i166892_ _k+size166888_)
              (let ((_u8166895_ (bitwise-and _uint166893_ '255)))
                (u8vector-set! _v166882_ _i166892_ _u8166895_)
                (_lp166890_
                 (fx+ _i166892_ '1)
                 (arithmetic-shift _uint166893_ '-8)))
              '#!void)))))
  (define std/misc/bytes#u8vector-sint-ref
    (lambda (_v166874_ _k166875_ _endianness166876_ _size166877_)
      (if (u8vector? _v166874_) '#!void (error '"Expected u8vector" _v166874_))
      (if (and (fixnum? _k166875_)
               (fx<= '0
                     _k166875_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166874_))
                          '1)))
          '#!void
          (error '"Bad index" _v166874_ _k166875_))
      (if (and (fixnum? _size166877_)
               (fx<= '0
                     _size166877_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166874_))
                          _k166875_)))
          '#!void
          (error '"Bad integer size" _v166874_ _k166875_ _size166877_))
      (let ((_$e166879_ _endianness166876_))
        (if (eq? 'big _$e166879_)
            (std/misc/bytes#&u8vector-sint-ref/be
             _v166874_
             _k166875_
             _size166877_)
            (if (eq? 'little _$e166879_)
                (std/misc/bytes#&u8vector-sint-ref/le
                 _v166874_
                 _k166875_
                 _size166877_)
                (if (eq? 'native _$e166879_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-sint-ref/le
                         _v166874_
                         _k166875_
                         _size166877_)
                        (std/misc/bytes#&u8vector-sint-ref/be
                         _v166874_
                         _k166875_
                         _size166877_))
                    (error '"Bad endianness" _endianness166876_)))))))
  (define std/misc/bytes#&u8vector-sint-ref/be
    (lambda (_v166867_ _k166868_ _size166869_)
      (let ((_uint166871_
             (std/misc/bytes#&u8vector-uint-ref/be
              _v166867_
              _k166868_
              _size166869_)))
        (if (> _uint166871_ (- (expt '2 (- (fx* _size166869_ '8) '1)) '1))
            (- _uint166871_ (expt '2 (fx* _size166869_ '8)))
            _uint166871_))))
  (define std/misc/bytes#&u8vector-sint-ref/le
    (lambda (_v166860_ _k166861_ _size166862_)
      (let ((_uint166864_
             (std/misc/bytes#&u8vector-uint-ref/le
              _v166860_
              _k166861_
              _size166862_)))
        (if (> _uint166864_ (- (expt '2 (- (fx* _size166862_ '8) '1)) '1))
            (- _uint166864_ (expt '2 (fx* _size166862_ '8)))
            _uint166864_))))
  (define std/misc/bytes#u8vector-sint-set!
    (lambda (_v166851_ _k166852_ _sint166853_ _endianness166854_ _size166855_)
      (if (u8vector? _v166851_) '#!void (error '"Expected u8vector" _v166851_))
      (if (and (fixnum? _k166852_)
               (fx<= '0
                     _k166852_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166851_))
                          '1)))
          '#!void
          (error '"Bad index" _v166851_ _k166852_))
      (if (and (fixnum? _size166855_)
               (fx<= '0
                     _size166855_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166851_))
                          _k166852_)))
          '#!void
          (error '"Bad integer size" _v166851_ _k166852_ _size166855_))
      (let ((_$e166857_ _endianness166854_))
        (if (eq? 'big _$e166857_)
            (std/misc/bytes#&u8vector-sint-set!/be
             _v166851_
             _k166852_
             _sint166853_
             _size166855_)
            (if (eq? 'little _$e166857_)
                (std/misc/bytes#&u8vector-sint-set!/le
                 _v166851_
                 _k166852_
                 _sint166853_
                 _size166855_)
                (if (eq? 'native _$e166857_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-sint-set!/le
                         _v166851_
                         _k166852_
                         _sint166853_
                         _size166855_)
                        (std/misc/bytes#&u8vector-sint-set!/be
                         _v166851_
                         _k166852_
                         _sint166853_
                         _size166855_))
                    (error '"Bad endianness" _endianness166854_)))))))
  (define std/misc/bytes#&u8vector-sint-set!/be
    (lambda (_v166844_ _k166845_ _sint166846_ _size166847_)
      (let ((_uint166849_
             (if (< _sint166846_ '0)
                 (+ _sint166846_ (expt '2 (fx* _size166847_ '8)))
                 _sint166846_)))
        (std/misc/bytes#&u8vector-uint-set!/be
         _v166844_
         _k166845_
         _uint166849_
         _size166847_))))
  (define std/misc/bytes#&u8vector-sint-set!/le
    (lambda (_v166837_ _k166838_ _sint166839_ _size166840_)
      (let ((_uint166842_
             (if (< _sint166839_ '0)
                 (+ _sint166839_ (expt '2 (fx* _size166840_ '8)))
                 _sint166839_)))
        (std/misc/bytes#&u8vector-uint-set!/le
         _v166837_
         _k166838_
         _uint166842_
         _size166840_))))
  (define std/misc/bytes#u8vector->uint-list
    (lambda (_v166830_ _endianness166831_ _size166832_)
      (if (u8vector? _v166830_) '#!void (error '"Expected u8vector" _v166830_))
      (if (and (fixnum? _size166832_)
               (fx> _size166832_ '0)
               (fxzero? (fxremainder
                         (let ()
                           (declare (not safe))
                           (##u8vector-length _v166830_))
                         _size166832_)))
          '#!void
          (error '"Bad size" _v166830_ _size166832_))
      (let ((_$e166834_ _endianness166831_))
        (if (eq? 'big _$e166834_)
            (std/misc/bytes#&u8vector->int-list
             _v166830_
             _size166832_
             std/misc/bytes#&u8vector-uint-ref/be)
            (if (eq? 'little _$e166834_)
                (std/misc/bytes#&u8vector->int-list
                 _v166830_
                 _size166832_
                 std/misc/bytes#&u8vector-uint-ref/le)
                (if (eq? 'native _$e166834_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector->int-list
                         _v166830_
                         _size166832_
                         std/misc/bytes#&u8vector-uint-ref/le)
                        (std/misc/bytes#&u8vector->int-list
                         _v166830_
                         _size166832_
                         std/misc/bytes#&u8vector-uint-ref/be))
                    (error '"Bad endianness" _endianness166831_)))))))
  (define std/misc/bytes#u8vector->sint-list
    (lambda (_v166823_ _endianness166824_ _size166825_)
      (if (u8vector? _v166823_) '#!void (error '"Expected u8vector" _v166823_))
      (if (and (fixnum? _size166825_)
               (fx> _size166825_ '0)
               (fxzero? (fxremainder
                         (let ()
                           (declare (not safe))
                           (##u8vector-length _v166823_))
                         _size166825_)))
          '#!void
          (error '"Bad size" _v166823_ _size166825_))
      (let ((_$e166827_ _endianness166824_))
        (if (eq? 'big _$e166827_)
            (std/misc/bytes#&u8vector->int-list
             _v166823_
             _size166825_
             std/misc/bytes#&u8vector-sint-ref/be)
            (if (eq? 'little _$e166827_)
                (std/misc/bytes#&u8vector->int-list
                 _v166823_
                 _size166825_
                 std/misc/bytes#&u8vector-sint-ref/le)
                (if (eq? 'native _$e166827_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector->int-list
                         _v166823_
                         _size166825_
                         std/misc/bytes#&u8vector-sint-ref/le)
                        (std/misc/bytes#&u8vector->int-list
                         _v166823_
                         _size166825_
                         std/misc/bytes#&u8vector-sint-ref/be))
                    (error '"Bad endianness" _endianness166824_)))))))
  (define std/misc/bytes#&u8vector->int-list
    (lambda (_v166809_ _size166810_ _getf166811_)
      (declare (fixnum) (not safe))
      (let ((_len166814_ (u8vector-length _v166809_)))
        (let _lp166816_ ((_i166818_ '0) (_r166819_ '()))
          (if (< _i166818_ _len166814_)
              (let ((_next166821_
                     (_getf166811_ _v166809_ _i166818_ _size166810_)))
                (_lp166816_
                 (+ _i166818_ _size166810_)
                 (cons _next166821_ _r166819_)))
              (reverse _r166819_))))))
  (define std/misc/bytes#uint-list->u8vector
    (lambda (_lst166802_ _endianness166803_ _size166804_)
      (if (and (list? _lst166802_) (andmap1 exact-integer? _lst166802_))
          '#!void
          (error '"Expected list of exact integers" _lst166802_))
      (if (and (fixnum? _size166804_) (fx> _size166804_ '0))
          '#!void
          (error '"Bad size" _size166804_))
      (let ((_$e166806_ _endianness166803_))
        (if (eq? 'big _$e166806_)
            (std/misc/bytes#&int-list->u8vector
             _lst166802_
             _size166804_
             std/misc/bytes#&u8vector-uint-set!/be)
            (if (eq? 'little _$e166806_)
                (std/misc/bytes#&int-list->u8vector
                 _lst166802_
                 _size166804_
                 std/misc/bytes#&u8vector-uint-set!/le)
                (if (eq? 'native _$e166806_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166802_
                         _size166804_
                         std/misc/bytes#&u8vector-uint-set!/le)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166802_
                         _size166804_
                         std/misc/bytes#&u8vector-uint-set!/be))
                    (error '"Bad endianness" _endianness166803_)))))))
  (define std/misc/bytes#sint-list->u8vector
    (lambda (_lst166795_ _endianness166796_ _size166797_)
      (if (and (list? _lst166795_) (andmap1 exact-integer? _lst166795_))
          '#!void
          (error '"Expected list of exact integers" _lst166795_))
      (if (and (fixnum? _size166797_) (fx> _size166797_ '0))
          '#!void
          (error '"Bad size" _size166797_))
      (let ((_$e166799_ _endianness166796_))
        (if (eq? 'big _$e166799_)
            (std/misc/bytes#&int-list->u8vector
             _lst166795_
             _size166797_
             std/misc/bytes#&u8vector-sint-set!/be)
            (if (eq? 'little _$e166799_)
                (std/misc/bytes#&int-list->u8vector
                 _lst166795_
                 _size166797_
                 std/misc/bytes#&u8vector-sint-set!/le)
                (if (eq? 'native _$e166799_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166795_
                         _size166797_
                         std/misc/bytes#&u8vector-sint-set!/le)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166795_
                         _size166797_
                         std/misc/bytes#&u8vector-sint-set!/be))
                    (error '"Bad endianness" _endianness166796_)))))))
  (define std/misc/bytes#&int-list->u8vector
    (lambda (_lst166747_ _size166748_ _setf166749_)
      (declare (fixnum) (not safe))
      (let* ((_len166752_ (* (length _lst166747_) _size166748_))
             (_v166754_ (make-u8vector _len166752_)))
        (let _lp166757_ ((_rest166759_ _lst166747_) (_i166760_ '0))
          (let* ((_rest166761166769_ _rest166759_)
                 (_else166763166777_ (lambda () _v166754_))
                 (_K166765166783_
                  (lambda (_rest166780_ _int166781_)
                    (_setf166749_ _v166754_ _i166760_ _int166781_ _size166748_)
                    (_lp166757_ _rest166780_ (+ _i166760_ _size166748_)))))
            (if (##pair? _rest166761166769_)
                (let ((_hd166766166786_ (##car _rest166761166769_))
                      (_tl166767166788_ (##cdr _rest166761166769_)))
                  (let* ((_int166791_ _hd166766166786_)
                         (_rest166793_ _tl166767166788_))
                    (_K166765166783_ _rest166793_ _int166791_)))
                (_else166763166777_)))))))
  (define std/misc/bytes#u8vector-u16-ref
    (lambda (_v166740_ _k166741_ _endianness166742_)
      (if (u8vector? _v166740_) '#!void (error '"Expected u8vector" _v166740_))
      (if (and (fixnum? _k166741_)
               (fx<= '0
                     _k166741_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166740_))
                          '1)))
          '#!void
          (error '"Bad index" _v166740_ _k166741_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166740_))
                          _k166741_)))
          '#!void
          (error '"Bad integer size" _v166740_ _k166741_ '2))
      (if (eq? _endianness166742_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u16-ref/native _v166740_ _k166741_)
          (let ((_$e166744_ _endianness166742_))
            (if (eq? 'big _$e166744_)
                (std/misc/bytes#&u8vector-uint-ref/be _v166740_ _k166741_ '2)
                (if (eq? 'little _$e166744_)
                    (std/misc/bytes#&u8vector-uint-ref/le
                     _v166740_
                     _k166741_
                     '2)
                    (if (eq? 'native _$e166744_)
                        (std/misc/bytes#&u8vector-u16-ref/native
                         _v166740_
                         _k166741_)
                        (error '"Bad endianness" _endianness166742_))))))))
  (define std/misc/bytes#u8vector-u16-set!
    (lambda (_v166732_ _k166733_ _n166734_ _endianness166735_)
      (if (u8vector? _v166732_) '#!void (error '"Expected u8vector" _v166732_))
      (if (and (fixnum? _k166733_)
               (fx<= '0
                     _k166733_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166732_))
                          '1)))
          '#!void
          (error '"Bad index" _v166732_ _k166733_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166732_))
                          _k166733_)))
          '#!void
          (error '"Bad integer size" _v166732_ _k166733_ '2))
      (if (eq? _endianness166735_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u16-set!/native
           _v166732_
           _k166733_
           _n166734_)
          (let ((_$e166737_ _endianness166735_))
            (if (eq? 'big _$e166737_)
                (std/misc/bytes#&u8vector-uint-set!/be
                 _v166732_
                 _k166733_
                 _n166734_
                 '2)
                (if (eq? 'little _$e166737_)
                    (std/misc/bytes#&u8vector-uint-set!/le
                     _v166732_
                     _k166733_
                     _n166734_
                     '2)
                    (if (eq? 'native _$e166737_)
                        (std/misc/bytes#&u8vector-u16-set!/native
                         _v166732_
                         _k166733_
                         _n166734_)
                        (error '"Bad endianness" _endianness166735_))))))))
  (define std/misc/bytes#u8vector-u16-native-ref
    (lambda (_v166729_ _k166730_)
      (if (u8vector? _v166729_) '#!void (error '"Expected u8vector" _v166729_))
      (if (and (fixnum? _k166730_)
               (fx<= '0
                     _k166730_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166729_))
                          '1)))
          '#!void
          (error '"Bad index" _v166729_ _k166730_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166729_))
                          _k166730_)))
          '#!void
          (error '"Bad integer size" _v166729_ _k166730_ '2))
      (std/misc/bytes#&u8vector-u16-ref/native _v166729_ _k166730_)))
  (define std/misc/bytes#u8vector-u16-native-set!
    (lambda (_v166725_ _k166726_ _n166727_)
      (if (u8vector? _v166725_) '#!void (error '"Expected u8vector" _v166725_))
      (if (and (fixnum? _k166726_)
               (fx<= '0
                     _k166726_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166725_))
                          '1)))
          '#!void
          (error '"Bad index" _v166725_ _k166726_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166725_))
                          _k166726_)))
          '#!void
          (error '"Bad integer size" _v166725_ _k166726_ '2))
      (std/misc/bytes#&u8vector-u16-set!/native
       _v166725_
       _k166726_
       _n166727_)))
  (define std/misc/bytes#u8vector-s16-ref
    (lambda (_v166718_ _k166719_ _endianness166720_)
      (if (u8vector? _v166718_) '#!void (error '"Expected u8vector" _v166718_))
      (if (and (fixnum? _k166719_)
               (fx<= '0
                     _k166719_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166718_))
                          '1)))
          '#!void
          (error '"Bad index" _v166718_ _k166719_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166718_))
                          _k166719_)))
          '#!void
          (error '"Bad integer size" _v166718_ _k166719_ '2))
      (if (eq? _endianness166720_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s16-ref/native _v166718_ _k166719_)
          (let ((_$e166722_ _endianness166720_))
            (if (eq? 'big _$e166722_)
                (std/misc/bytes#&u8vector-sint-ref/be _v166718_ _k166719_ '2)
                (if (eq? 'little _$e166722_)
                    (std/misc/bytes#&u8vector-sint-ref/le
                     _v166718_
                     _k166719_
                     '2)
                    (if (eq? 'native _$e166722_)
                        (std/misc/bytes#&u8vector-s16-ref/native
                         _v166718_
                         _k166719_)
                        (error '"Bad endianness" _endianness166720_))))))))
  (define std/misc/bytes#u8vector-s16-set!
    (lambda (_v166710_ _k166711_ _n166712_ _endianness166713_)
      (if (u8vector? _v166710_) '#!void (error '"Expected u8vector" _v166710_))
      (if (and (fixnum? _k166711_)
               (fx<= '0
                     _k166711_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166710_))
                          '1)))
          '#!void
          (error '"Bad index" _v166710_ _k166711_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166710_))
                          _k166711_)))
          '#!void
          (error '"Bad integer size" _v166710_ _k166711_ '2))
      (if (eq? _endianness166713_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s16-set!/native
           _v166710_
           _k166711_
           _n166712_)
          (let ((_$e166715_ _endianness166713_))
            (if (eq? 'big _$e166715_)
                (std/misc/bytes#&u8vector-sint-set!/be
                 _v166710_
                 _k166711_
                 _n166712_
                 '2)
                (if (eq? 'little _$e166715_)
                    (std/misc/bytes#&u8vector-sint-set!/le
                     _v166710_
                     _k166711_
                     _n166712_
                     '2)
                    (if (eq? 'native _$e166715_)
                        (std/misc/bytes#&u8vector-s16-set!/native
                         _v166710_
                         _k166711_
                         _n166712_)
                        (error '"Bad endianness" _endianness166713_))))))))
  (define std/misc/bytes#u8vector-s16-native-ref
    (lambda (_v166707_ _k166708_)
      (if (u8vector? _v166707_) '#!void (error '"Expected u8vector" _v166707_))
      (if (and (fixnum? _k166708_)
               (fx<= '0
                     _k166708_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166707_))
                          '1)))
          '#!void
          (error '"Bad index" _v166707_ _k166708_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166707_))
                          _k166708_)))
          '#!void
          (error '"Bad integer size" _v166707_ _k166708_ '2))
      (std/misc/bytes#&u8vector-s16-ref/native _v166707_ _k166708_)))
  (define std/misc/bytes#u8vector-s16-native-set!
    (lambda (_v166703_ _k166704_ _n166705_)
      (if (u8vector? _v166703_) '#!void (error '"Expected u8vector" _v166703_))
      (if (and (fixnum? _k166704_)
               (fx<= '0
                     _k166704_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166703_))
                          '1)))
          '#!void
          (error '"Bad index" _v166703_ _k166704_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166703_))
                          _k166704_)))
          '#!void
          (error '"Bad integer size" _v166703_ _k166704_ '2))
      (std/misc/bytes#&u8vector-s16-set!/native
       _v166703_
       _k166704_
       _n166705_)))
  (define std/misc/bytes#u8vector-u32-ref
    (lambda (_v166696_ _k166697_ _endianness166698_)
      (if (u8vector? _v166696_) '#!void (error '"Expected u8vector" _v166696_))
      (if (and (fixnum? _k166697_)
               (fx<= '0
                     _k166697_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166696_))
                          '1)))
          '#!void
          (error '"Bad index" _v166696_ _k166697_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166696_))
                          _k166697_)))
          '#!void
          (error '"Bad integer size" _v166696_ _k166697_ '4))
      (if (eq? _endianness166698_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u32-ref/native _v166696_ _k166697_)
          (let ((_$e166700_ _endianness166698_))
            (if (eq? 'big _$e166700_)
                (std/misc/bytes#&u8vector-uint-ref/be _v166696_ _k166697_ '4)
                (if (eq? 'little _$e166700_)
                    (std/misc/bytes#&u8vector-uint-ref/le
                     _v166696_
                     _k166697_
                     '4)
                    (if (eq? 'native _$e166700_)
                        (std/misc/bytes#&u8vector-u32-ref/native
                         _v166696_
                         _k166697_)
                        (error '"Bad endianness" _endianness166698_))))))))
  (define std/misc/bytes#u8vector-u32-set!
    (lambda (_v166688_ _k166689_ _n166690_ _endianness166691_)
      (if (u8vector? _v166688_) '#!void (error '"Expected u8vector" _v166688_))
      (if (and (fixnum? _k166689_)
               (fx<= '0
                     _k166689_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166688_))
                          '1)))
          '#!void
          (error '"Bad index" _v166688_ _k166689_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166688_))
                          _k166689_)))
          '#!void
          (error '"Bad integer size" _v166688_ _k166689_ '4))
      (if (eq? _endianness166691_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u32-set!/native
           _v166688_
           _k166689_
           _n166690_)
          (let ((_$e166693_ _endianness166691_))
            (if (eq? 'big _$e166693_)
                (std/misc/bytes#&u8vector-uint-set!/be
                 _v166688_
                 _k166689_
                 _n166690_
                 '4)
                (if (eq? 'little _$e166693_)
                    (std/misc/bytes#&u8vector-uint-set!/le
                     _v166688_
                     _k166689_
                     _n166690_
                     '4)
                    (if (eq? 'native _$e166693_)
                        (std/misc/bytes#&u8vector-u32-set!/native
                         _v166688_
                         _k166689_
                         _n166690_)
                        (error '"Bad endianness" _endianness166691_))))))))
  (define std/misc/bytes#u8vector-u32-native-ref
    (lambda (_v166685_ _k166686_)
      (if (u8vector? _v166685_) '#!void (error '"Expected u8vector" _v166685_))
      (if (and (fixnum? _k166686_)
               (fx<= '0
                     _k166686_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166685_))
                          '1)))
          '#!void
          (error '"Bad index" _v166685_ _k166686_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166685_))
                          _k166686_)))
          '#!void
          (error '"Bad integer size" _v166685_ _k166686_ '4))
      (std/misc/bytes#&u8vector-u32-ref/native _v166685_ _k166686_)))
  (define std/misc/bytes#u8vector-u32-native-set!
    (lambda (_v166681_ _k166682_ _n166683_)
      (if (u8vector? _v166681_) '#!void (error '"Expected u8vector" _v166681_))
      (if (and (fixnum? _k166682_)
               (fx<= '0
                     _k166682_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166681_))
                          '1)))
          '#!void
          (error '"Bad index" _v166681_ _k166682_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166681_))
                          _k166682_)))
          '#!void
          (error '"Bad integer size" _v166681_ _k166682_ '4))
      (std/misc/bytes#&u8vector-u32-set!/native
       _v166681_
       _k166682_
       _n166683_)))
  (define std/misc/bytes#u8vector-s32-ref
    (lambda (_v166674_ _k166675_ _endianness166676_)
      (if (u8vector? _v166674_) '#!void (error '"Expected u8vector" _v166674_))
      (if (and (fixnum? _k166675_)
               (fx<= '0
                     _k166675_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166674_))
                          '1)))
          '#!void
          (error '"Bad index" _v166674_ _k166675_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166674_))
                          _k166675_)))
          '#!void
          (error '"Bad integer size" _v166674_ _k166675_ '4))
      (if (eq? _endianness166676_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s32-ref/native _v166674_ _k166675_)
          (let ((_$e166678_ _endianness166676_))
            (if (eq? 'big _$e166678_)
                (std/misc/bytes#&u8vector-sint-ref/be _v166674_ _k166675_ '4)
                (if (eq? 'little _$e166678_)
                    (std/misc/bytes#&u8vector-sint-ref/le
                     _v166674_
                     _k166675_
                     '4)
                    (if (eq? 'native _$e166678_)
                        (std/misc/bytes#&u8vector-s32-ref/native
                         _v166674_
                         _k166675_)
                        (error '"Bad endianness" _endianness166676_))))))))
  (define std/misc/bytes#u8vector-s32-set!
    (lambda (_v166666_ _k166667_ _n166668_ _endianness166669_)
      (if (u8vector? _v166666_) '#!void (error '"Expected u8vector" _v166666_))
      (if (and (fixnum? _k166667_)
               (fx<= '0
                     _k166667_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166666_))
                          '1)))
          '#!void
          (error '"Bad index" _v166666_ _k166667_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166666_))
                          _k166667_)))
          '#!void
          (error '"Bad integer size" _v166666_ _k166667_ '4))
      (if (eq? _endianness166669_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s32-set!/native
           _v166666_
           _k166667_
           _n166668_)
          (let ((_$e166671_ _endianness166669_))
            (if (eq? 'big _$e166671_)
                (std/misc/bytes#&u8vector-sint-set!/be
                 _v166666_
                 _k166667_
                 _n166668_
                 '4)
                (if (eq? 'little _$e166671_)
                    (std/misc/bytes#&u8vector-sint-set!/le
                     _v166666_
                     _k166667_
                     _n166668_
                     '4)
                    (if (eq? 'native _$e166671_)
                        (std/misc/bytes#&u8vector-s32-set!/native
                         _v166666_
                         _k166667_
                         _n166668_)
                        (error '"Bad endianness" _endianness166669_))))))))
  (define std/misc/bytes#u8vector-s32-native-ref
    (lambda (_v166663_ _k166664_)
      (if (u8vector? _v166663_) '#!void (error '"Expected u8vector" _v166663_))
      (if (and (fixnum? _k166664_)
               (fx<= '0
                     _k166664_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166663_))
                          '1)))
          '#!void
          (error '"Bad index" _v166663_ _k166664_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166663_))
                          _k166664_)))
          '#!void
          (error '"Bad integer size" _v166663_ _k166664_ '4))
      (std/misc/bytes#&u8vector-s32-ref/native _v166663_ _k166664_)))
  (define std/misc/bytes#u8vector-s32-native-set!
    (lambda (_v166659_ _k166660_ _n166661_)
      (if (u8vector? _v166659_) '#!void (error '"Expected u8vector" _v166659_))
      (if (and (fixnum? _k166660_)
               (fx<= '0
                     _k166660_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166659_))
                          '1)))
          '#!void
          (error '"Bad index" _v166659_ _k166660_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166659_))
                          _k166660_)))
          '#!void
          (error '"Bad integer size" _v166659_ _k166660_ '4))
      (std/misc/bytes#&u8vector-s32-set!/native
       _v166659_
       _k166660_
       _n166661_)))
  (define std/misc/bytes#u8vector-u64-ref
    (lambda (_v166652_ _k166653_ _endianness166654_)
      (if (u8vector? _v166652_) '#!void (error '"Expected u8vector" _v166652_))
      (if (and (fixnum? _k166653_)
               (fx<= '0
                     _k166653_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166652_))
                          '1)))
          '#!void
          (error '"Bad index" _v166652_ _k166653_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166652_))
                          _k166653_)))
          '#!void
          (error '"Bad integer size" _v166652_ _k166653_ '8))
      (if (eq? _endianness166654_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u64-ref/native _v166652_ _k166653_)
          (let ((_$e166656_ _endianness166654_))
            (if (eq? 'big _$e166656_)
                (std/misc/bytes#&u8vector-uint-ref/be _v166652_ _k166653_ '8)
                (if (eq? 'little _$e166656_)
                    (std/misc/bytes#&u8vector-uint-ref/le
                     _v166652_
                     _k166653_
                     '8)
                    (if (eq? 'native _$e166656_)
                        (std/misc/bytes#&u8vector-u64-ref/native
                         _v166652_
                         _k166653_)
                        (error '"Bad endianness" _endianness166654_))))))))
  (define std/misc/bytes#u8vector-u64-set!
    (lambda (_v166644_ _k166645_ _n166646_ _endianness166647_)
      (if (u8vector? _v166644_) '#!void (error '"Expected u8vector" _v166644_))
      (if (and (fixnum? _k166645_)
               (fx<= '0
                     _k166645_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166644_))
                          '1)))
          '#!void
          (error '"Bad index" _v166644_ _k166645_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166644_))
                          _k166645_)))
          '#!void
          (error '"Bad integer size" _v166644_ _k166645_ '8))
      (if (eq? _endianness166647_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u64-set!/native
           _v166644_
           _k166645_
           _n166646_)
          (let ((_$e166649_ _endianness166647_))
            (if (eq? 'big _$e166649_)
                (std/misc/bytes#&u8vector-uint-set!/be
                 _v166644_
                 _k166645_
                 _n166646_
                 '8)
                (if (eq? 'little _$e166649_)
                    (std/misc/bytes#&u8vector-uint-set!/le
                     _v166644_
                     _k166645_
                     _n166646_
                     '8)
                    (if (eq? 'native _$e166649_)
                        (std/misc/bytes#&u8vector-u64-set!/native
                         _v166644_
                         _k166645_
                         _n166646_)
                        (error '"Bad endianness" _endianness166647_))))))))
  (define std/misc/bytes#u8vector-u64-native-ref
    (lambda (_v166641_ _k166642_)
      (if (u8vector? _v166641_) '#!void (error '"Expected u8vector" _v166641_))
      (if (and (fixnum? _k166642_)
               (fx<= '0
                     _k166642_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166641_))
                          '1)))
          '#!void
          (error '"Bad index" _v166641_ _k166642_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166641_))
                          _k166642_)))
          '#!void
          (error '"Bad integer size" _v166641_ _k166642_ '8))
      (std/misc/bytes#&u8vector-u64-ref/native _v166641_ _k166642_)))
  (define std/misc/bytes#u8vector-u64-native-set!
    (lambda (_v166637_ _k166638_ _n166639_)
      (if (u8vector? _v166637_) '#!void (error '"Expected u8vector" _v166637_))
      (if (and (fixnum? _k166638_)
               (fx<= '0
                     _k166638_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166637_))
                          '1)))
          '#!void
          (error '"Bad index" _v166637_ _k166638_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166637_))
                          _k166638_)))
          '#!void
          (error '"Bad integer size" _v166637_ _k166638_ '8))
      (std/misc/bytes#&u8vector-u64-set!/native
       _v166637_
       _k166638_
       _n166639_)))
  (define std/misc/bytes#u8vector-s64-ref
    (lambda (_v166630_ _k166631_ _endianness166632_)
      (if (u8vector? _v166630_) '#!void (error '"Expected u8vector" _v166630_))
      (if (and (fixnum? _k166631_)
               (fx<= '0
                     _k166631_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166630_))
                          '1)))
          '#!void
          (error '"Bad index" _v166630_ _k166631_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166630_))
                          _k166631_)))
          '#!void
          (error '"Bad integer size" _v166630_ _k166631_ '8))
      (if (eq? _endianness166632_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s64-ref/native _v166630_ _k166631_)
          (let ((_$e166634_ _endianness166632_))
            (if (eq? 'big _$e166634_)
                (std/misc/bytes#&u8vector-sint-ref/be _v166630_ _k166631_ '8)
                (if (eq? 'little _$e166634_)
                    (std/misc/bytes#&u8vector-sint-ref/le
                     _v166630_
                     _k166631_
                     '8)
                    (if (eq? 'native _$e166634_)
                        (std/misc/bytes#&u8vector-s64-ref/native
                         _v166630_
                         _k166631_)
                        (error '"Bad endianness" _endianness166632_))))))))
  (define std/misc/bytes#u8vector-s64-set!
    (lambda (_v166621_ _k166622_ _n166623_ _endianness166624_)
      (if (u8vector? _v166621_) '#!void (error '"Expected u8vector" _v166621_))
      (if (and (fixnum? _k166622_)
               (fx<= '0
                     _k166622_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166621_))
                          '1)))
          '#!void
          (error '"Bad index" _v166621_ _k166622_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166621_))
                          _k166622_)))
          '#!void
          (error '"Bad integer size" _v166621_ _k166622_ '8))
      (if (eq? _endianness166624_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s64-set!/native
           _v166621_
           _k166622_
           _n166623_)
          (let ((_$e166627_ _endianness166624_))
            (if (eq? 'big _$e166627_)
                (std/misc/bytes#&u8vector-sint-set!/be
                 _v166621_
                 _k166622_
                 _n166623_
                 '8)
                (if (eq? 'little _$e166627_)
                    (std/misc/bytes#&u8vector-sint-set!/le
                     _v166621_
                     _k166622_
                     _n166623_
                     '8)
                    (if (eq? 'native _$e166627_)
                        (std/misc/bytes#&u8vector-s64-set!/native
                         _v166621_
                         _k166622_
                         _n166623_)
                        (error '"Bad endianness" _endianness166624_))))))))
  (define std/misc/bytes#u8vector-s64-native-ref
    (lambda (_v166618_ _k166619_)
      (if (u8vector? _v166618_) '#!void (error '"Expected u8vector" _v166618_))
      (if (and (fixnum? _k166619_)
               (fx<= '0
                     _k166619_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166618_))
                          '1)))
          '#!void
          (error '"Bad index" _v166618_ _k166619_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166618_))
                          _k166619_)))
          '#!void
          (error '"Bad integer size" _v166618_ _k166619_ '8))
      (std/misc/bytes#&u8vector-s64-ref/native _v166618_ _k166619_)))
  (define std/misc/bytes#u8vector-s64-native-set!
    (lambda (_v166611_ _k166613_ _n166615_)
      (if (u8vector? _v166611_) '#!void (error '"Expected u8vector" _v166611_))
      (if (and (fixnum? _k166613_)
               (fx<= '0
                     _k166613_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166611_))
                          '1)))
          '#!void
          (error '"Bad index" _v166611_ _k166613_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166611_))
                          _k166613_)))
          '#!void
          (error '"Bad integer size" _v166611_ _k166613_ '8))
      (std/misc/bytes#&u8vector-s64-set!/native
       _v166611_
       _k166613_
       _n166615_)))
  (define std/misc/bytes#u8vector-float-ref
    (lambda (_v166592_ _k166593_ _endianness166594_)
      (if (u8vector? _v166592_) '#!void (error '"Expected u8vector" _v166592_))
      (if (and (fixnum? _k166593_)
               (fx<= '0
                     _k166593_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166592_))
                          '1)))
          '#!void
          (error '"Bad index" _v166592_ _k166593_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166592_))
                          _k166593_)))
          '#!void
          (error '"Bad integer size" _v166592_ _k166593_ '4))
      (if (or (eq? _endianness166594_ std/misc/bytes#native-endianness)
              (eq? _endianness166594_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-float-ref/native _v166592_ _k166593_)
          (let ((_v*166599_ (make-u8vector '4)))
            (declare (fixnum) (not safe))
            (begin
              (let _$loop166603_ ((_i166606_ (- (+ _k166593_ '4) '1))
                                  (_j166608_ '0))
                (if (= _j166608_ '4)
                    '#!void
                    (begin
                      (u8vector-set!
                       _v*166599_
                       _j166608_
                       (u8vector-ref _v166592_ _i166606_))
                      (_$loop166603_ (- _i166606_ '1) (+ _j166608_ '1)))))
              (std/misc/bytes#&u8vector-float-ref/native _v*166599_ '0))))))
  (define std/misc/bytes#u8vector-float-set!
    (lambda (_v166584_ _k166585_ _x166586_ _endianness166587_)
      (if (u8vector? _v166584_) '#!void (error '"Expected u8vector" _v166584_))
      (if (and (fixnum? _k166585_)
               (fx<= '0
                     _k166585_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166584_))
                          '1)))
          '#!void
          (error '"Bad index" _v166584_ _k166585_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166584_))
                          _k166585_)))
          '#!void
          (error '"Bad integer size" _v166584_ _k166585_ '4))
      (if (or (eq? _endianness166587_ std/misc/bytes#native-endianness)
              (eq? _endianness166587_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-float-set!/native
           _v166584_
           _k166585_
           _x166586_)
          (begin
            (std/misc/bytes#&u8vector-float-set!/native
             _v166584_
             _k166585_
             _x166586_)
            (std/misc/bytes#&u8vector-reverse! _v166584_ _k166585_ '4)))))
  (define std/misc/bytes#u8vector-float-native-ref
    (lambda (_v166581_ _k166582_)
      (if (u8vector? _v166581_) '#!void (error '"Expected u8vector" _v166581_))
      (if (and (fixnum? _k166582_)
               (fx<= '0
                     _k166582_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166581_))
                          '1)))
          '#!void
          (error '"Bad index" _v166581_ _k166582_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166581_))
                          _k166582_)))
          '#!void
          (error '"Bad integer size" _v166581_ _k166582_ '4))
      (std/misc/bytes#&u8vector-float-ref/native _v166581_ _k166582_)))
  (define std/misc/bytes#u8vector-float-native-set!
    (lambda (_v166577_ _k166578_ _x166579_)
      (if (u8vector? _v166577_) '#!void (error '"Expected u8vector" _v166577_))
      (if (and (fixnum? _k166578_)
               (fx<= '0
                     _k166578_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166577_))
                          '1)))
          '#!void
          (error '"Bad index" _v166577_ _k166578_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166577_))
                          _k166578_)))
          '#!void
          (error '"Bad integer size" _v166577_ _k166578_ '4))
      (std/misc/bytes#&u8vector-float-set!/native
       _v166577_
       _k166578_
       _x166579_)))
  (define std/misc/bytes#u8vector-double-ref
    (lambda (_v166558_ _k166559_ _endianness166560_)
      (if (u8vector? _v166558_) '#!void (error '"Expected u8vector" _v166558_))
      (if (and (fixnum? _k166559_)
               (fx<= '0
                     _k166559_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166558_))
                          '1)))
          '#!void
          (error '"Bad index" _v166558_ _k166559_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166558_))
                          _k166559_)))
          '#!void
          (error '"Bad integer size" _v166558_ _k166559_ '8))
      (if (or (eq? _endianness166560_ std/misc/bytes#native-endianness)
              (eq? _endianness166560_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-double-ref/native _v166558_ _k166559_)
          (let ((_v*166565_ (make-u8vector '8)))
            (declare (fixnum) (not safe))
            (begin
              (let _$loop166569_ ((_i166572_ (- (+ _k166559_ '8) '1))
                                  (_j166574_ '0))
                (if (= _j166574_ '8)
                    '#!void
                    (begin
                      (u8vector-set!
                       _v*166565_
                       _j166574_
                       (u8vector-ref _v166558_ _i166572_))
                      (_$loop166569_ (- _i166572_ '1) (+ _j166574_ '1)))))
              (std/misc/bytes#&u8vector-double-ref/native _v*166565_ '0))))))
  (define std/misc/bytes#u8vector-double-set!
    (lambda (_v166550_ _k166551_ _x166552_ _endianness166553_)
      (if (u8vector? _v166550_) '#!void (error '"Expected u8vector" _v166550_))
      (if (and (fixnum? _k166551_)
               (fx<= '0
                     _k166551_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166550_))
                          '1)))
          '#!void
          (error '"Bad index" _v166550_ _k166551_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166550_))
                          _k166551_)))
          '#!void
          (error '"Bad integer size" _v166550_ _k166551_ '8))
      (if (or (eq? _endianness166553_ std/misc/bytes#native-endianness)
              (eq? _endianness166553_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-double-set!/native
           _v166550_
           _k166551_
           _x166552_)
          (begin
            (std/misc/bytes#&u8vector-double-set!/native
             _v166550_
             _k166551_
             _x166552_)
            (std/misc/bytes#&u8vector-reverse! _v166550_ _k166551_ '8)))))
  (define std/misc/bytes#u8vector-double-native-ref
    (lambda (_v166547_ _k166548_)
      (if (u8vector? _v166547_) '#!void (error '"Expected u8vector" _v166547_))
      (if (and (fixnum? _k166548_)
               (fx<= '0
                     _k166548_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166547_))
                          '1)))
          '#!void
          (error '"Bad index" _v166547_ _k166548_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166547_))
                          _k166548_)))
          '#!void
          (error '"Bad integer size" _v166547_ _k166548_ '8))
      (std/misc/bytes#&u8vector-double-ref/native _v166547_ _k166548_)))
  (define std/misc/bytes#u8vector-double-native-set!
    (lambda (_v166543_ _k166544_ _x166545_)
      (if (u8vector? _v166543_) '#!void (error '"Expected u8vector" _v166543_))
      (if (and (fixnum? _k166544_)
               (fx<= '0
                     _k166544_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166543_))
                          '1)))
          '#!void
          (error '"Bad index" _v166543_ _k166544_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166543_))
                          _k166544_)))
          '#!void
          (error '"Bad integer size" _v166543_ _k166544_ '8))
      (std/misc/bytes#&u8vector-double-set!/native
       _v166543_
       _k166544_
       _x166545_)))
  (define std/misc/bytes#u8vector-swap!
    (lambda (_v166537_ _j166538_ _k166539_)
      (if (u8vector? _v166537_) '#!void (error '"Expected u8vector" _v166537_))
      (let ((_len-1166541_
             (fx- (let () (declare (not safe)) (##u8vector-length _v166537_))
                  '1)))
        (if (fx<= '0 _j166538_ _len-1166541_)
            '#!void
            (error '"Index out of range" _v166537_ _j166538_))
        (if (fx<= '0 _k166539_ _len-1166541_)
            '#!void
            (error '"Index out of range" _v166537_ _k166539_)))
      (std/misc/bytes#&u8vector-swap! _v166537_ _j166538_ _k166539_)))
  (define std/misc/bytes#&u8vector-swap!
    (lambda (_v166529_ _j166530_ _k166531_)
      (declare (not safe))
      (let ((_j-val166534_ (u8vector-ref _v166529_ _j166530_))
            (_k-val166535_ (u8vector-ref _v166529_ _k166531_)))
        (u8vector-set! _v166529_ _j166530_ _k-val166535_)
        (u8vector-set! _v166529_ _k166531_ _j-val166534_))))
  (define std/misc/bytes#u8vector-reverse!
    (lambda (_v166527_)
      (if (u8vector? _v166527_) '#!void (error '"Expected u8vector" _v166527_))
      (std/misc/bytes#&u8vector-reverse!
       _v166527_
       '0
       (u8vector-length _v166527_))))
  (define std/misc/bytes#&u8vector-reverse!
    (lambda (_v166516_ _k166517_ _size166518_)
      (declare (fixnum) (not safe))
      (let _$loop166521_ ((_left-index166524_ _k166517_)
                          (_right-index166525_
                           (- (+ _k166517_ _size166518_) '1)))
        (if (<= _right-index166525_ _left-index166524_)
            '#!void
            (begin
              (std/misc/bytes#&u8vector-swap!
               _v166516_
               _left-index166524_
               _right-index166525_)
              (_$loop166521_
               (+ _left-index166524_ '1)
               (- _right-index166525_ '1)))))))
  (define std/misc/bytes#u8vector-reverse
    (lambda (_v166501_)
      (declare (fixnum) (not safe))
      (begin
        (if (u8vector? _v166501_)
            '#!void
            (error '"Expected u8vector" _v166501_))
        (let* ((_len166504_ (u8vector-length _v166501_))
               (_len-1166506_ (- _len166504_ '1))
               (_u166508_ (make-u8vector _len166504_)))
          (let _$loop166511_ ((_i166514_ _len-1166506_))
            (if (= _i166514_ '-1)
                '#!void
                (begin
                  (u8vector-set!
                   _u166508_
                   (- _len-1166506_ _i166514_)
                   (u8vector-ref _v166501_ _i166514_))
                  (_$loop166511_ (- _i166514_ '1)))))
          _u166508_))))
  (define std/misc/bytes#u8vector->bytestring__%
    (lambda (_v166472_ _delim166473_)
      (declare (fixnum) (not safe))
      (begin
        (if (u8vector? _v166472_)
            '#!void
            (error '"Expected u8vector" _v166472_))
        (if (or (not _delim166473_) (char? _delim166473_))
            '#!void
            (error '"Expected character or #f" _delim166473_))
        (let* ((_len166479_ (u8vector-length _v166472_))
               (_s166481_
                (make-string
                 (+ _len166479_
                    _len166479_
                    (if (and (< '0 _len166479_) _delim166473_)
                        (- _len166479_ '1)
                        '0)))))
          (let _lp166484_ ((_i166486_ '0) (_j166487_ '0))
            (if (< _i166486_ _len166479_)
                (let ((_next166489_ (u8vector-ref _v166472_ _i166486_)))
                  (if (and (< '0 _i166486_) _delim166473_)
                      (string-set! _s166481_ (- _j166487_ '1) _delim166473_)
                      '#!void)
                  (string-set!
                   _s166481_
                   _j166487_
                   (char-upcase
                    (std/text/hex#hex (fxarithmetic-shift _next166489_ '-4))))
                  (string-set!
                   _s166481_
                   (+ _j166487_ '1)
                   (char-upcase (std/text/hex#hex (fxand _next166489_ '15))))
                  (_lp166484_
                   (+ _i166486_ '1)
                   (+ _j166487_ '2 (if _delim166473_ '1 '0))))
                '#!void))
          _s166481_))))
  (define std/misc/bytes#u8vector->bytestring__0
    (lambda (_v166494_)
      (let ((_delim166496_ '#\space))
        (std/misc/bytes#u8vector->bytestring__% _v166494_ _delim166496_))))
  (define std/misc/bytes#u8vector->bytestring
    (lambda _g304051_
      (let ((_g304050_ (let () (declare (not safe)) (##length _g304051_))))
        (cond ((let () (declare (not safe)) (##fx= _g304050_ 1))
               (apply std/misc/bytes#u8vector->bytestring__0 _g304051_))
              ((let () (declare (not safe)) (##fx= _g304050_ 2))
               (apply std/misc/bytes#u8vector->bytestring__% _g304051_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#u8vector->bytestring
                _g304051_))))))
  (define std/misc/bytes#bytestring->u8vector__%
    (lambda (_bs166447_ _delim166448_)
      (declare (fixnum) (not safe))
      (if _delim166448_
          (let ()
            (letrec* ((_invalid166452_
                       (lambda ()
                         (error '"Invalid bytestring"
                                _bs166447_
                                _delim166448_)))
                      (_blen166453_ (string-length _bs166447_))
                      (_g304052_
                       (let ((_g304053_
                              (if (and (< '0 _blen166453_)
                                       (not (zero? (modulo (+ _blen166453_ '1)
                                                           '3))))
                                  (_invalid166452_)
                                  '#!void)))
                         #!void
                         _g304053_))
                      (_parse-byte166454_
                       (lambda (_i166456_)
                         (letrec* ((_offset166458_ (* _i166456_ '3)))
                           (if (and (< '0 _offset166458_)
                                    (not (eq? _delim166448_
                                              (string-ref
                                               _bs166447_
                                               (- _offset166458_ '1)))))
                               (_invalid166452_)
                               '#!void)
                           (std/text/hex#hex-decode-byte
                            _bs166447_
                            _offset166458_)))))
              (std/misc/bytes#u8vector-init!
               (quotient (+ _blen166453_ '1) '3)
               _parse-byte166454_)))
          (std/text/hex#hex-decode__0 _bs166447_))))
  (define std/misc/bytes#bytestring->u8vector__0
    (lambda (_bs166464_)
      (let ((_delim166466_ '#\space))
        (std/misc/bytes#bytestring->u8vector__% _bs166464_ _delim166466_))))
  (define std/misc/bytes#bytestring->u8vector
    (lambda _g304056_
      (let ((_g304055_ (let () (declare (not safe)) (##length _g304056_))))
        (cond ((let () (declare (not safe)) (##fx= _g304055_ 1))
               (apply std/misc/bytes#bytestring->u8vector__0 _g304056_))
              ((let () (declare (not safe)) (##fx= _g304055_ 2))
               (apply std/misc/bytes#bytestring->u8vector__% _g304056_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#bytestring->u8vector
                _g304056_))))))
  (define std/misc/bytes#u8vector->uint__%
    (lambda (_v166430_ _endianness166431_)
      (if (u8vector? _v166430_) '#!void (error '"Expected u8vector" _v166430_))
      (let ((_$e166433_ _endianness166431_))
        (if (eq? 'big _$e166433_)
            (std/misc/bytes#&u8vector->uint/be _v166430_)
            (if (eq? 'little _$e166433_)
                (std/misc/bytes#&u8vector->uint/le _v166430_)
                (if (eq? 'native _$e166433_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector->uint/le _v166430_)
                        (std/misc/bytes#&u8vector->uint/be _v166430_))
                    (error '"Bad endianness" _endianness166431_)))))))
  (define std/misc/bytes#u8vector->uint__0
    (lambda (_v166439_)
      (let ((_endianness166441_ std/misc/bytes#big))
        (std/misc/bytes#u8vector->uint__% _v166439_ _endianness166441_))))
  (define std/misc/bytes#u8vector->uint
    (lambda _g304058_
      (let ((_g304057_ (let () (declare (not safe)) (##length _g304058_))))
        (cond ((let () (declare (not safe)) (##fx= _g304057_ 1))
               (apply std/misc/bytes#u8vector->uint__0 _g304058_))
              ((let () (declare (not safe)) (##fx= _g304057_ 2))
               (apply std/misc/bytes#u8vector->uint__% _g304058_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#u8vector->uint
                _g304058_))))))
  (define std/misc/bytes#&u8vector->uint/be
    (lambda (_v166419_)
      (declare (not safe))
      (let ((_len166422_ (u8vector-length _v166419_)))
        (let _lp166424_ ((_i166426_ '0) (_r166427_ '0))
          (if (fx< _i166426_ _len166422_)
              (_lp166424_
               (fx+ _i166426_ '1)
               (bitwise-ior
                (arithmetic-shift _r166427_ '8)
                (u8vector-ref _v166419_ _i166426_)))
              _r166427_)))))
  (define std/misc/bytes#&u8vector->uint/le
    (lambda (_v166409_)
      (declare (not safe))
      (let ((_len166412_ (u8vector-length _v166409_)))
        (let _lp166414_ ((_i166416_ (fx- _len166412_ '1)) (_r166417_ '0))
          (if (fx>= _i166416_ '0)
              (_lp166414_
               (fx- _i166416_ '1)
               (bitwise-ior
                (arithmetic-shift _r166417_ '8)
                (u8vector-ref _v166409_ _i166416_)))
              _r166417_)))))
  (define std/misc/bytes#uint->u8vector__%
    (lambda (_uint166393_ _endianness166394_)
      (if (and (exact-integer? _uint166393_) (>= _uint166393_ '0))
          '#!void
          (error '"Non-negative exact integer expected" _uint166393_))
      (let ((_$e166396_ _endianness166394_))
        (if (eq? 'big _$e166396_)
            (std/misc/bytes#&uint->u8vector/be _uint166393_)
            (if (eq? 'little _$e166396_)
                (std/misc/bytes#&uint->u8vector/le _uint166393_)
                (if (eq? 'native _$e166396_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&uint->u8vector/le _uint166393_)
                        (std/misc/bytes#&uint->u8vector/be _uint166393_))
                    (error '"Bad endianness" _endianness166394_)))))))
  (define std/misc/bytes#uint->u8vector__0
    (lambda (_uint166402_)
      (let ((_endianness166404_ std/misc/bytes#big))
        (std/misc/bytes#uint->u8vector__% _uint166402_ _endianness166404_))))
  (define std/misc/bytes#uint->u8vector
    (lambda _g304060_
      (let ((_g304059_ (let () (declare (not safe)) (##length _g304060_))))
        (cond ((let () (declare (not safe)) (##fx= _g304059_ 1))
               (apply std/misc/bytes#uint->u8vector__0 _g304060_))
              ((let () (declare (not safe)) (##fx= _g304059_ 2))
               (apply std/misc/bytes#uint->u8vector__% _g304060_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#uint->u8vector
                _g304060_))))))
  (define std/misc/bytes#&uint->u8vector/be
    (lambda (_uint166377_)
      (declare (not safe))
      (let* ((_bits166380_ (integer-length _uint166377_))
             (_bytes166382_
              (fx+ (fxquotient _bits166380_ '8)
                   (if (fx> (fxremainder _bits166380_ '8) '0) '1 '0)))
             (_res166384_ (make-u8vector _bytes166382_)))
        (let _lp166387_ ((_uint166389_ _uint166377_)
                         (_i166390_ (fx- _bytes166382_ '1)))
          (if (> _uint166389_ '0)
              (begin
                (u8vector-set!
                 _res166384_
                 _i166390_
                 (bitwise-and _uint166389_ '255))
                (_lp166387_
                 (arithmetic-shift _uint166389_ '-8)
                 (fx- _i166390_ '1)))
              _res166384_)))))
  (define std/misc/bytes#&uint->u8vector/le
    (lambda (_uint166362_)
      (declare (not safe))
      (let* ((_bits166365_ (integer-length _uint166362_))
             (_bytes166367_
              (fx+ (fxquotient _bits166365_ '8)
                   (if (fx> (fxremainder _bits166365_ '8) '0) '1 '0)))
             (_res166369_ (make-u8vector _bytes166367_)))
        (let _lp166372_ ((_uint166374_ _uint166362_) (_i166375_ '0))
          (if (> _uint166374_ '0)
              (begin
                (u8vector-set!
                 _res166369_
                 _i166375_
                 (bitwise-and _uint166374_ '255))
                (_lp166372_
                 (arithmetic-shift _uint166374_ '-8)
                 (fx+ _i166375_ '1)))
              _res166369_)))))
  (define std/misc/bytes#u8vector-init!
    (lambda (_len166353_ _fun166354_)
      (declare (fixnum) (not safe))
      (letrec* ((_s166356_ (make-u8vector _len166353_)))
        (let _lp166358_ ((_i166360_ '0))
          (if (< _i166360_ _len166353_)
              (begin
                (u8vector-set! _s166356_ _i166360_ (_fun166354_ _i166360_))
                (_lp166358_ (+ _i166360_ '1)))
              '#!void))
        _s166356_)))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/misc/bytes#"
    &u8vector-double-set!/native
    &u8vector-double-ref/native
    &u8vector-float-set!/native
    &u8vector-float-ref/native
    &u8vector-s64-set!/native
    &u8vector-s64-ref/native
    &u8vector-u64-set!/native
    &u8vector-u64-ref/native
    &u8vector-s32-set!/native
    &u8vector-s32-ref/native
    &u8vector-u32-set!/native
    &u8vector-u32-ref/native
    &u8vector-s16-set!/native
    &u8vector-s16-ref/native
    &u8vector-u16-set!/native
    &u8vector-u16-ref/native
    native-endianness))
  (c-declare "#include <stdint.h>")
  (define native-endianness
    (if ((c-lambda
          ()
          scheme-object
          "#ifdef ___LITTLE_ENDIAN\n___return(___TRU);\n#else\n___return(___FAL);\n#endif"))
        'little
        'big))
  (define-c-lambda
   &u8vector-u16-ref/native
   (scheme-object int)
   unsigned-int16
   "uint16_t res = *(uint16_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-u16-set!/native
   (scheme-object int unsigned-int16)
   void
   "*(uint16_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-s16-ref/native
   (scheme-object int)
   int16
   "int16_t res = *(int16_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-s16-set!/native
   (scheme-object int int16)
   void
   "*(int16_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-u32-ref/native
   (scheme-object int)
   unsigned-int32
   "uint32_t res = *(uint32_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-u32-set!/native
   (scheme-object int unsigned-int32)
   void
   "*(uint32_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-s32-ref/native
   (scheme-object int)
   int32
   "int32_t res = *(int32_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-s32-set!/native
   (scheme-object int int32)
   void
   "*(int32_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-u64-ref/native
   (scheme-object int)
   unsigned-int64
   "uint64_t res = *(uint64_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-u64-set!/native
   (scheme-object int unsigned-int64)
   void
   "*(uint64_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-s64-ref/native
   (scheme-object int)
   int64
   "int64_t res = *(int64_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-s64-set!/native
   (scheme-object int int64)
   void
   "*(int64_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-float-ref/native
   (scheme-object int)
   float
   "float res = *(float*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-float-set!/native
   (scheme-object int float)
   void
   "*(float*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-double-ref/native
   (scheme-object int)
   double
   "double res = *(double*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-double-set!/native
   (scheme-object int double)
   void
   "*(double*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
