(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/channel#channel::t
    (make-struct-type
     'std/misc/channel#channel::t
     '#f
     '5
     'channel
     '((final: . #t))
     ':init!
     '(q mx cv limit eof)))
  (define std/misc/channel#channel?
    (make-struct-predicate std/misc/channel#channel::t))
  (define std/misc/channel#make-channel
    (lambda _$args230637_
      (apply make-struct-instance std/misc/channel#channel::t _$args230637_)))
  (define std/misc/channel#channel-q
    (make-struct-field-accessor std/misc/channel#channel::t '0))
  (define std/misc/channel#channel-mx
    (make-struct-field-accessor std/misc/channel#channel::t '1))
  (define std/misc/channel#channel-cv
    (make-struct-field-accessor std/misc/channel#channel::t '2))
  (define std/misc/channel#channel-limit
    (make-struct-field-accessor std/misc/channel#channel::t '3))
  (define std/misc/channel#channel-eof
    (make-struct-field-accessor std/misc/channel#channel::t '4))
  (define std/misc/channel#channel-q-set!
    (make-struct-field-mutator std/misc/channel#channel::t '0))
  (define std/misc/channel#channel-mx-set!
    (make-struct-field-mutator std/misc/channel#channel::t '1))
  (define std/misc/channel#channel-cv-set!
    (make-struct-field-mutator std/misc/channel#channel::t '2))
  (define std/misc/channel#channel-limit-set!
    (make-struct-field-mutator std/misc/channel#channel::t '3))
  (define std/misc/channel#channel-eof-set!
    (make-struct-field-mutator std/misc/channel#channel::t '4))
  (define std/misc/channel#&channel-q
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '0))
  (define std/misc/channel#&channel-mx
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '1))
  (define std/misc/channel#&channel-cv
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '2))
  (define std/misc/channel#&channel-limit
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '3))
  (define std/misc/channel#&channel-eof
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '4))
  (define std/misc/channel#&channel-q-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '0))
  (define std/misc/channel#&channel-mx-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '1))
  (define std/misc/channel#&channel-cv-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '2))
  (define std/misc/channel#&channel-limit-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '3))
  (define std/misc/channel#&channel-eof-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '4))
  (define std/misc/channel#channel:::init!__%
    (lambda (_self230624_ _limit230625_)
      (if (let ((__tmp303048
                 (let () (declare (not safe)) (##vector-length _self230624_))))
            (declare (not safe))
            (##fx< '5 __tmp303048))
          (begin
            (let ((__tmp303049
                   (let ((__obj303046
                          (make-object std/misc/queue#queue::t '3)))
                     (std/misc/queue#queue:::init! __obj303046)
                     __obj303046)))
              (declare (not safe))
              (##vector-set! _self230624_ '1 __tmp303049))
            (let ((__tmp303050 (make-mutex 'channel)))
              (declare (not safe))
              (##vector-set! _self230624_ '2 __tmp303050))
            (let ((__tmp303051 (make-condition-variable 'channel)))
              (declare (not safe))
              (##vector-set! _self230624_ '3 __tmp303051))
            (let ()
              (declare (not safe))
              (##vector-set! _self230624_ '4 _limit230625_))
            (let () (declare (not safe)) (##vector-set! _self230624_ '5 '#f)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self230624_))))
  (define std/misc/channel#channel:::init!__0
    (lambda (_self230630_)
      (let ((_limit230632_ '#f))
        (std/misc/channel#channel:::init!__% _self230630_ _limit230632_))))
  (define std/misc/channel#channel:::init!
    (lambda _g303053_
      (let ((_g303052_ (let () (declare (not safe)) (##length _g303053_))))
        (cond ((let () (declare (not safe)) (##fx= _g303052_ 1))
               (apply std/misc/channel#channel:::init!__0 _g303053_))
              ((let () (declare (not safe)) (##fx= _g303052_ 2))
               (apply std/misc/channel#channel:::init!__% _g303053_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel:::init!
                _g303053_))))))
  (bind-method!
   std/misc/channel#channel::t
   ':init!
   std/misc/channel#channel:::init!
   '#f)
  (define std/misc/channel#channel-put__%
    (lambda (_ch230434_ _val230435_ _timeo230436_)
      (let* ((_timeo230438_ (std/misc/timeout#make-timeout__0 _timeo230436_))
             (_ch230439230448_ _ch230434_)
             (_E230441230452_
              (lambda () (error '"No clause matching" _ch230439230448_)))
             (_K230442230466_
              (lambda (_limit230455_ _cv230456_ _mx230457_ _q230458_)
                (let _lp230460_ ()
                  (mutex-lock! _mx230457_)
                  (if (let ()
                        (declare (not safe))
                        (##unchecked-structure-ref
                         _ch230434_
                         '5
                         std/misc/channel#channel::t
                         '#f))
                      (begin
                        (mutex-unlock! _mx230457_)
                        (std/error#raise-io-error
                         'channel-put
                         '"channel is closed"
                         _ch230434_))
                      (if (or (not _limit230455_)
                              (let ((__tmp303054
                                     (##direct-structure-ref
                                      _q230458_
                                      '3
                                      std/misc/queue#queue::t
                                      '#f)))
                                (declare (not safe))
                                (##fx< __tmp303054 _limit230455_)))
                          (begin
                            (std/misc/queue#enqueue! _q230458_ _val230435_)
                            (if (let ((__tmp303055
                                       (##direct-structure-ref
                                        _q230458_
                                        '3
                                        std/misc/queue#queue::t
                                        '#f)))
                                  (declare (not safe))
                                  (##fx= __tmp303055 '1))
                                (condition-variable-broadcast! _cv230456_)
                                '#!void)
                            (mutex-unlock! _mx230457_)
                            '#t)
                          (if (mutex-unlock!
                               _mx230457_
                               _cv230456_
                               _timeo230438_)
                              (_lp230460_)
                              '#f)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230439230448_
               'std/misc/channel#channel::t))
            (let* ((_e230443230469_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230439230448_ '1)))
                   (_q230472_ _e230443230469_)
                   (_e230444230474_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230439230448_ '2)))
                   (_mx230477_ _e230444230474_)
                   (_e230445230479_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230439230448_ '3)))
                   (_cv230482_ _e230445230479_)
                   (_e230446230484_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230439230448_ '4)))
                   (_limit230487_ _e230446230484_))
              (_K230442230466_ _limit230487_ _cv230482_ _mx230477_ _q230472_))
            (_E230441230452_)))))
  (define std/misc/channel#channel-put__0
    (lambda (_ch230492_ _val230493_)
      (let ((_timeo230495_ '#f))
        (std/misc/channel#channel-put__%
         _ch230492_
         _val230493_
         _timeo230495_))))
  (define std/misc/channel#channel-put
    (lambda _g303057_
      (let ((_g303056_ (let () (declare (not safe)) (##length _g303057_))))
        (cond ((let () (declare (not safe)) (##fx= _g303056_ 2))
               (apply std/misc/channel#channel-put__0 _g303057_))
              ((let () (declare (not safe)) (##fx= _g303056_ 3))
               (apply std/misc/channel#channel-put__% _g303057_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel-put
                _g303057_))))))
  (define std/misc/channel#channel-try-put
    (lambda (_ch230384_ _val230385_)
      (let* ((_ch230386230395_ _ch230384_)
             (_E230388230399_
              (lambda () (error '"No clause matching" _ch230386230395_)))
             (_K230389230410_
              (lambda (_limit230402_ _cv230403_ _mx230404_ _q230405_)
                (mutex-lock! _mx230404_)
                (if (let ()
                      (declare (not safe))
                      (##unchecked-structure-ref
                       _ch230384_
                       '5
                       std/misc/channel#channel::t
                       '#f))
                    (begin
                      (mutex-unlock! _mx230404_)
                      (std/error#raise-io-error
                       'channel-try-put
                       '"channel is closed"
                       _ch230384_))
                    (if (or (not _limit230402_)
                            (let ((__tmp303058
                                   (##direct-structure-ref
                                    _q230405_
                                    '3
                                    std/misc/queue#queue::t
                                    '#f)))
                              (declare (not safe))
                              (##fx< __tmp303058 _limit230402_)))
                        (begin
                          (std/misc/queue#enqueue! _q230405_ _val230385_)
                          (if (let ((__tmp303059
                                     (##direct-structure-ref
                                      _q230405_
                                      '3
                                      std/misc/queue#queue::t
                                      '#f)))
                                (declare (not safe))
                                (##fx= __tmp303059 '1))
                              (condition-variable-broadcast! _cv230403_)
                              '#!void)
                          (mutex-unlock! _mx230404_)
                          '#t)
                        (begin (mutex-unlock! _mx230404_) '#f))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230386230395_
               'std/misc/channel#channel::t))
            (let* ((_e230390230413_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230386230395_ '1)))
                   (_q230416_ _e230390230413_)
                   (_e230391230418_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230386230395_ '2)))
                   (_mx230421_ _e230391230418_)
                   (_e230392230423_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230386230395_ '3)))
                   (_cv230426_ _e230392230423_)
                   (_e230393230428_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230386230395_ '4)))
                   (_limit230431_ _e230393230428_))
              (_K230389230410_ _limit230431_ _cv230426_ _mx230421_ _q230416_))
            (_E230388230399_)))))
  (define std/misc/channel#channel-sync
    (lambda (_ch230334_ . _vals230335_)
      (let* ((_ch230336230345_ _ch230334_)
             (_E230338230349_
              (lambda () (error '"No clause matching" _ch230336230345_)))
             (_K230339230361_
              (lambda (_limit230352_ _cv230353_ _mx230354_ _q230355_)
                (mutex-lock! _mx230354_)
                (if (let ()
                      (declare (not safe))
                      (##unchecked-structure-ref
                       _ch230334_
                       '5
                       std/misc/channel#channel::t
                       '#f))
                    (begin
                      (mutex-unlock! _mx230354_)
                      (std/error#raise-io-error
                       'channel-sync
                       '"channel is closed"
                       _ch230334_))
                    (begin
                      (if (null? _vals230335_)
                          '#!void
                          (begin
                            (for-each
                             (lambda (_g230356230358_)
                               (std/misc/queue#enqueue!
                                _q230355_
                                _g230356230358_))
                             _vals230335_)
                            (condition-variable-broadcast! _cv230353_)))
                      (mutex-unlock! _mx230354_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230336230345_
               'std/misc/channel#channel::t))
            (let* ((_e230340230364_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230336230345_ '1)))
                   (_q230367_ _e230340230364_)
                   (_e230341230369_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230336230345_ '2)))
                   (_mx230372_ _e230341230369_)
                   (_e230342230374_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230336230345_ '3)))
                   (_cv230377_ _e230342230374_)
                   (_e230343230379_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230336230345_ '4)))
                   (_limit230382_ _e230343230379_))
              (_K230339230361_ _limit230382_ _cv230377_ _mx230372_ _q230367_))
            (_E230338230349_)))))
  (define std/misc/channel#channel-get__%
    (lambda (_ch230262_ _timeo230263_ _default230264_)
      (let* ((_timeo230266_ (std/misc/timeout#make-timeout__0 _timeo230263_))
             (_ch230267230276_ _ch230262_)
             (_E230269230280_
              (lambda () (error '"No clause matching" _ch230267230276_)))
             (_K230270230293_
              (lambda (_limit230283_ _cv230284_ _mx230285_ _q230286_)
                (let _lp230288_ ()
                  (mutex-lock! _mx230285_)
                  (if (std/misc/queue#queue-empty? _q230286_)
                      (if (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _ch230262_
                             '5
                             std/misc/channel#channel::t
                             '#f))
                          (begin (mutex-unlock! _mx230285_) '#!eof)
                          (if (mutex-unlock!
                               _mx230285_
                               _cv230284_
                               _timeo230266_)
                              (_lp230288_)
                              _default230264_))
                      (let ((_next230291_
                             (std/misc/queue#dequeue!__0 _q230286_)))
                        (if (and _limit230283_
                                 (let ((__tmp303061
                                        (##direct-structure-ref
                                         _q230286_
                                         '3
                                         std/misc/queue#queue::t
                                         '#f))
                                       (__tmp303060
                                        (let ()
                                          (declare (not safe))
                                          (##fx- _limit230283_ '1))))
                                   (declare (not safe))
                                   (##fx= __tmp303061 __tmp303060)))
                            (condition-variable-broadcast! _cv230284_)
                            '#!void)
                        (mutex-unlock! _mx230285_)
                        _next230291_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230267230276_
               'std/misc/channel#channel::t))
            (let* ((_e230271230296_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230267230276_ '1)))
                   (_q230299_ _e230271230296_)
                   (_e230272230301_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230267230276_ '2)))
                   (_mx230304_ _e230272230301_)
                   (_e230273230306_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230267230276_ '3)))
                   (_cv230309_ _e230273230306_)
                   (_e230274230311_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230267230276_ '4)))
                   (_limit230314_ _e230274230311_))
              (_K230270230293_ _limit230314_ _cv230309_ _mx230304_ _q230299_))
            (_E230269230280_)))))
  (define std/misc/channel#channel-get__0
    (lambda (_ch230319_)
      (let* ((_timeo230321_ '#f) (_default230323_ '#f))
        (std/misc/channel#channel-get__%
         _ch230319_
         _timeo230321_
         _default230323_))))
  (define std/misc/channel#channel-get__1
    (lambda (_ch230325_ _timeo230326_)
      (let ((_default230328_ '#f))
        (std/misc/channel#channel-get__%
         _ch230325_
         _timeo230326_
         _default230328_))))
  (define std/misc/channel#channel-get
    (lambda _g303063_
      (let ((_g303062_ (let () (declare (not safe)) (##length _g303063_))))
        (cond ((let () (declare (not safe)) (##fx= _g303062_ 1))
               (apply std/misc/channel#channel-get__0 _g303063_))
              ((let () (declare (not safe)) (##fx= _g303062_ 2))
               (apply std/misc/channel#channel-get__1 _g303063_))
              ((let () (declare (not safe)) (##fx= _g303062_ 3))
               (apply std/misc/channel#channel-get__% _g303063_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel-get
                _g303063_))))))
  (define std/misc/channel#channel-try-get__%
    (lambda (_ch230203_ _default230204_)
      (let* ((_ch230205230214_ _ch230203_)
             (_E230207230218_
              (lambda () (error '"No clause matching" _ch230205230214_)))
             (_K230208230228_
              (lambda (_limit230221_ _cv230222_ _mx230223_ _q230224_)
                (mutex-lock! _mx230223_)
                (if (std/misc/queue#queue-empty? _q230224_)
                    (begin
                      (mutex-unlock! _mx230223_)
                      (if (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _ch230203_
                             '5
                             std/misc/channel#channel::t
                             '#f))
                          '#!eof
                          _default230204_))
                    (let ((_next230226_
                           (std/misc/queue#dequeue!__0 _q230224_)))
                      (if (and _limit230221_
                               (let ((__tmp303065
                                      (##direct-structure-ref
                                       _q230224_
                                       '3
                                       std/misc/queue#queue::t
                                       '#f))
                                     (__tmp303064
                                      (let ()
                                        (declare (not safe))
                                        (##fx- _limit230221_ '1))))
                                 (declare (not safe))
                                 (##fx= __tmp303065 __tmp303064)))
                          (condition-variable-broadcast! _cv230222_)
                          '#!void)
                      (mutex-unlock! _mx230223_)
                      _next230226_)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230205230214_
               'std/misc/channel#channel::t))
            (let* ((_e230209230231_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230205230214_ '1)))
                   (_q230234_ _e230209230231_)
                   (_e230210230236_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230205230214_ '2)))
                   (_mx230239_ _e230210230236_)
                   (_e230211230241_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230205230214_ '3)))
                   (_cv230244_ _e230211230241_)
                   (_e230212230246_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230205230214_ '4)))
                   (_limit230249_ _e230212230246_))
              (_K230208230228_ _limit230249_ _cv230244_ _mx230239_ _q230234_))
            (_E230207230218_)))))
  (define std/misc/channel#channel-try-get__0
    (lambda (_ch230254_)
      (let ((_default230256_ '#f))
        (std/misc/channel#channel-try-get__% _ch230254_ _default230256_))))
  (define std/misc/channel#channel-try-get
    (lambda _g303067_
      (let ((_g303066_ (let () (declare (not safe)) (##length _g303067_))))
        (cond ((let () (declare (not safe)) (##fx= _g303066_ 1))
               (apply std/misc/channel#channel-try-get__0 _g303067_))
              ((let () (declare (not safe)) (##fx= _g303066_ 2))
               (apply std/misc/channel#channel-try-get__% _g303067_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel-try-get
                _g303067_))))))
  (define std/misc/channel#channel-close
    (lambda (_ch230153_)
      (let* ((_ch230154230164_ _ch230153_)
             (_E230156230168_
              (lambda () (error '"No clause matching" _ch230154230164_)))
             (_K230157230176_
              (lambda (_eof230171_ _cv230172_ _mx230173_ _q230174_)
                (if _eof230171_
                    '#!void
                    (begin
                      (mutex-lock! _mx230173_)
                      (let ()
                        (declare (not safe))
                        (##unchecked-structure-set!
                         _ch230153_
                         '#t
                         '5
                         std/misc/channel#channel::t
                         '#f))
                      (condition-variable-broadcast!
                       (##direct-structure-ref
                        _ch230153_
                        '3
                        std/misc/channel#channel::t
                        '#f))
                      (mutex-unlock! _mx230173_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230154230164_
               'std/misc/channel#channel::t))
            (let* ((_e230158230179_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230154230164_ '1)))
                   (_q230182_ _e230158230179_)
                   (_e230159230184_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230154230164_ '2)))
                   (_mx230187_ _e230159230184_)
                   (_e230160230189_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230154230164_ '3)))
                   (_cv230192_ _e230160230189_)
                   (_e230161230194_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230154230164_ '4)))
                   (_e230162230197_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230154230164_ '5)))
                   (_eof230200_ _e230162230197_))
              (_K230157230176_ _eof230200_ _cv230192_ _mx230187_ _q230182_))
            (_E230156230168_)))))
  (define std/misc/channel#channel::destroy std/misc/channel#channel-close)
  (bind-method!
   std/misc/channel#channel::t
   'destroy
   std/misc/channel#channel::destroy
   '#f)
  (define std/misc/channel#channel-closed?
    (lambda (_ch230029_)
      (##direct-structure-ref _ch230029_ '5 std/misc/channel#channel::t '#f)))
  (define std/misc/channel#:iter::channel
    (lambda (_ch230027_) (std/misc/channel#iter-channel _ch230027_)))
  (std/generic/dispatch#generic-bind!
   std/iter#:iter::t
   (cons (std/generic/dispatch#type-linearize-class
          std/misc/channel#channel::t)
         '())
   std/misc/channel#:iter::channel)
  (define std/misc/channel#iter-channel
    (lambda (_ch229931_)
      (letrec ((_next229933_
                (lambda (_it229935_)
                  (let* ((_it229936229942_ _it229935_)
                         (_E229938229946_
                          (lambda ()
                            (error '"No clause matching" _it229936229942_)))
                         (_K229939229953_
                          (lambda (_ch229949_)
                            (let ((_val229951_
                                   (std/misc/channel#channel-get__0
                                    _ch229949_)))
                              (if (eof-object? _val229951_)
                                  std/iter#iter-end
                                  _val229951_)))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it229936229942_
                           'std/iter#iterator::t))
                        (let* ((_e229940229956_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it229936229942_ '1)))
                               (_ch229959_ _e229940229956_))
                          (_K229939229953_ _ch229959_))
                        (_E229938229946_))))))
        (let ((__obj303047 (make-object std/iter#iterator::t '3)))
          (std/iter#iterator:::init!__0 __obj303047 _ch229931_ _next229933_)
          __obj303047)))))
