(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/list#duplicates__%__%
    (lambda (__3630236305_ _key3630036307_ _list36309_ _test36310_)
      (let ((_key36312_
             (if (eq? _key3630036307_ absent-value) '#f _key3630036307_)))
        (if (pair? _list36309_)
            (let ((_ht36314_ (make-table 'test: _test36310_)))
              (if _key36312_
                  (for-each
                   (lambda (_v36316_)
                     (hash-update! _ht36314_ (_key36312_ _v36316_) 1+ '0))
                   _list36309_)
                  (for-each
                   (lambda (_g3631736319_)
                     (hash-update! _ht36314_ _g3631736319_ 1+ '0))
                   _list36309_))
              (hash-fold
               (lambda (_a36322_ _b36323_ _acc36324_)
                 (if (> _b36323_ '1)
                     (cons (cons _a36322_ _b36323_) _acc36324_)
                     _acc36324_))
               '()
               _ht36314_))
            '()))))
  (define std/misc/list#duplicates__%__0
    (lambda (__3630236329_ _key3630036330_ _list36331_)
      (let ((_test36333_ equal?))
        (std/misc/list#duplicates__%__%
         __3630236329_
         _key3630036330_
         _list36331_
         _test36333_))))
  (define std/misc/list#duplicates__%
    (lambda _g301772_
      (let ((_g301771_ (let () (declare (not safe)) (##length _g301772_))))
        (cond ((let () (declare (not safe)) (##fx= _g301771_ 3))
               (apply std/misc/list#duplicates__%__0 _g301772_))
              ((let () (declare (not safe)) (##fx= _g301771_ 4))
               (apply std/misc/list#duplicates__%__% _g301772_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#duplicates__%
                _g301772_))))))
  (define std/misc/list#duplicates__@
    (lambda (_keys3629936343_ . _args36345_)
      (apply std/misc/list#duplicates__%
             _keys3629936343_
             (table-ref _keys3629936343_ 'key: absent-value)
             _args36345_)))
  (define std/misc/list#duplicates
    (lambda _args3630136351_
      (apply keyword-dispatch
             '#(key:)
             std/misc/list#duplicates__@
             _args3630136351_)))
  (define std/misc/list#length=?
    (lambda (_x36292_ _y36293_)
      (let ((_nx?36295_ (not (pair? _x36292_)))
            (_ny?36296_ (not (pair? _y36293_))))
        (if _nx?36295_
            _ny?36296_
            (if _ny?36296_
                '#f
                (std/misc/list#length=? (cdr _x36292_) (cdr _y36293_)))))))
  (define std/misc/list#length=n?
    (lambda (_x36284_ _n36285_)
      (if (fixnum? _n36285_)
          (if (fx<= '0 _n36285_)
              (let _loop36287_ ((_x36289_ _x36284_) (_n36290_ _n36285_))
                (if (not (pair? _x36289_))
                    (fxzero? _n36290_)
                    (if (fxzero? _n36290_)
                        '#f
                        (_loop36287_ (cdr _x36289_) (fx- _n36290_ '1)))))
              '#f)
          (if (integer? _n36285_)
              (if (<= '0 _n36285_ ##max-fixnum)
                  (std/misc/list#length=n? _x36284_ (inexact->exact _n36285_))
                  '#f)
              (if (number? _n36285_) '#f (error '"not a number" _n36285_))))))
  (define std/misc/list#length<?
    (lambda (_x36278_ _y36279_)
      (let ((_nx?36281_ (not (pair? _x36278_)))
            (_ny?36282_ (not (pair? _y36279_))))
        (if _nx?36281_
            (not _ny?36282_)
            (if _ny?36282_
                '#f
                (std/misc/list#length<? (cdr _x36278_) (cdr _y36279_)))))))
  (define std/misc/list#length<=n?
    (lambda (_x36267_ _n36268_)
      (if (fixnum? _n36268_)
          (if (fx<= '0 _n36268_)
              (let _loop36270_ ((_x36272_ _x36267_) (_n36273_ _n36268_))
                (if (not (pair? _x36272_))
                    '#t
                    (if (fxzero? _n36273_)
                        '#f
                        (_loop36270_ (cdr _x36272_) (fx- _n36273_ '1)))))
              '#f)
          (if (real? _n36268_)
              (if (positive? _n36268_)
                  (let ((_$e36275_ (< ##max-fixnum _n36268_)))
                    (if _$e36275_
                        _$e36275_
                        (std/misc/list#length<=n?
                         _x36267_
                         (inexact->exact (floor _n36268_)))))
                  '#f)
              (error '"not a real number" _n36268_)))))
  (define std/misc/list#length<n?
    (lambda (_x36261_ _n36262_)
      (if (fixnum? _n36262_)
          (if (fxpositive? _n36262_)
              (std/misc/list#length<=n? _x36261_ (fx- _n36262_ '1))
              '#f)
          (if (real? _n36262_)
              (if (positive? _n36262_)
                  (let ((_$e36264_ (< ##max-fixnum _n36262_)))
                    (if _$e36264_
                        _$e36264_
                        (std/misc/list#length<n?
                         _x36261_
                         (inexact->exact (ceiling _n36262_)))))
                  '#f)
              (error '"not a real number" _n36262_)))))
  (define std/misc/list#length<=?
    (lambda (_x36258_ _y36259_)
      (not (std/misc/list#length<? _y36259_ _x36258_))))
  (define std/misc/list#length>?
    (lambda (_x36255_ _y36256_) (std/misc/list#length<? _y36256_ _x36255_)))
  (define std/misc/list#length>n?
    (lambda (_x36252_ _n36253_)
      (not (std/misc/list#length<=n? _x36252_ _n36253_))))
  (define std/misc/list#length>=?
    (lambda (_x36249_ _y36250_) (std/misc/list#length<=? _y36250_ _x36249_)))
  (define std/misc/list#length>=n?
    (lambda (_x36246_ _n36247_)
      (not (std/misc/list#length<n? _x36246_ _n36247_))))
  (define std/misc/list#snoc
    (lambda (_x36243_ _l36244_) (append _l36244_ (cons _x36243_ '()))))
  (define std/misc/list#append1
    (lambda (_l36240_ _x36241_) (append _l36240_ (cons _x36241_ '()))))
  (define std/misc/list#for-each!
    (lambda (_list36199_ _fun36200_)
      (let* ((_list3620136210_ _list36199_)
             (_E3620436214_
              (lambda () (error '"No clause matching" _list3620136210_))))
        (let ((_K3620636228_
               (lambda (_more36225_ _elem36226_)
                 (_fun36200_ _elem36226_)
                 (std/misc/list#for-each! _more36225_ _fun36200_)))
              (_K3620536219_ (lambda () '#!void)))
          (if (let () (declare (not safe)) (##pair? _list3620136210_))
              (let ((_tl3620836233_
                     (let () (declare (not safe)) (##cdr _list3620136210_)))
                    (_hd3620736231_
                     (let () (declare (not safe)) (##car _list3620136210_))))
                (let ((_elem36236_ _hd3620736231_)
                      (_more36238_ _tl3620836233_))
                  (_K3620636228_ _more36238_ _elem36236_)))
              '#!void)))))
  (define std/misc/list#flatten
    (lambda (_list-of-lists36194_)
      (foldr1 (lambda (_v36196_ _acc36197_)
                (if (null? _v36196_)
                    _acc36197_
                    (if (pair? _v36196_)
                        (append (std/misc/list#flatten _v36196_) _acc36197_)
                        (cons _v36196_ _acc36197_))))
              '()
              _list-of-lists36194_)))
  (define std/misc/list#flatten1
    (lambda (_list-of-lists36189_)
      (foldr1 (lambda (_v36191_ _acc36192_)
                (if (null? _v36191_)
                    _acc36192_
                    (if (pair? _v36191_)
                        (append _v36191_ _acc36192_)
                        (cons _v36191_ _acc36192_))))
              '()
              _list-of-lists36189_)))
  (define std/misc/list#rassoc__%
    (lambda (_x36136_ _alist36137_ _cmpf36138_)
      (let _loop36140_ ((_lst36142_ _alist36137_))
        (let* ((_lst3614336151_ _lst36142_)
               (_else3614536159_ (lambda () '#f))
               (_K3614736165_
                (lambda (_tail36162_ _head36163_)
                  (if (_cmpf36138_ _x36136_ (cdr _head36163_))
                      _head36163_
                      (_loop36140_ _tail36162_)))))
          (if (let () (declare (not safe)) (##pair? _lst3614336151_))
              (let ((_hd3614836168_
                     (let () (declare (not safe)) (##car _lst3614336151_)))
                    (_tl3614936170_
                     (let () (declare (not safe)) (##cdr _lst3614336151_))))
                (if (pair? _hd3614836168_)
                    (let* ((_head36173_ _hd3614836168_)
                           (_tail36175_ _tl3614936170_))
                      (_K3614736165_ _tail36175_ _head36173_))
                    (_else3614536159_)))
              (_else3614536159_))))))
  (define std/misc/list#rassoc__0
    (lambda (_x36180_ _alist36181_)
      (let ((_cmpf36183_ eqv?))
        (std/misc/list#rassoc__% _x36180_ _alist36181_ _cmpf36183_))))
  (define std/misc/list#rassoc
    (lambda _g301774_
      (let ((_g301773_ (let () (declare (not safe)) (##length _g301774_))))
        (cond ((let () (declare (not safe)) (##fx= _g301773_ 2))
               (apply std/misc/list#rassoc__0 _g301774_))
              ((let () (declare (not safe)) (##fx= _g301773_ 3))
               (apply std/misc/list#rassoc__% _g301774_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#rassoc
                _g301774_))))))
  (define std/misc/list#listify
    (lambda (_x36133_) (if (pair? _x36133_) _x36133_ '())))
  (define std/misc/list#keyword-when__%
    (lambda (_keyword36117_ _condition36118_ _value36119_)
      (if _condition36118_ (cons _keyword36117_ (cons _value36119_ '())) '())))
  (define std/misc/list#keyword-when__0
    (lambda (_keyword36124_ _condition36125_)
      (let ((_value36127_ _condition36125_))
        (std/misc/list#keyword-when__%
         _keyword36124_
         _condition36125_
         _value36127_))))
  (define std/misc/list#keyword-when
    (lambda _g301776_
      (let ((_g301775_ (let () (declare (not safe)) (##length _g301776_))))
        (cond ((let () (declare (not safe)) (##fx= _g301775_ 2))
               (apply std/misc/list#keyword-when__0 _g301776_))
              ((let () (declare (not safe)) (##fx= _g301775_ 3))
               (apply std/misc/list#keyword-when__% _g301776_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#keyword-when
                _g301776_))))))
  (define std/misc/list#slice__%
    (lambda (_lst36100_ _start36101_ _limit36102_)
      (if _limit36102_
          (std/srfi/1#take
           (std/srfi/1#drop _lst36100_ _start36101_)
           _limit36102_)
          (std/srfi/1#drop _lst36100_ _start36101_))))
  (define std/misc/list#slice__0
    (lambda (_lst36107_ _start36108_)
      (let ((_limit36110_ '#f))
        (std/misc/list#slice__% _lst36107_ _start36108_ _limit36110_))))
  (define std/misc/list#slice
    (lambda _g301778_
      (let ((_g301777_ (let () (declare (not safe)) (##length _g301778_))))
        (cond ((let () (declare (not safe)) (##fx= _g301777_ 2))
               (apply std/misc/list#slice__0 _g301778_))
              ((let () (declare (not safe)) (##fx= _g301777_ 3))
               (apply std/misc/list#slice__% _g301778_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#slice
                _g301778_))))))
  (define std/misc/list#slice-right__%
    (lambda (_lst36083_ _start36084_ _limit36085_)
      (if _limit36085_
          (std/srfi/1#take-right
           (std/srfi/1#drop-right _lst36083_ _start36084_)
           _limit36085_)
          (std/srfi/1#drop-right _lst36083_ _start36084_))))
  (define std/misc/list#slice-right__0
    (lambda (_lst36090_ _start36091_)
      (let ((_limit36093_ '#f))
        (std/misc/list#slice-right__% _lst36090_ _start36091_ _limit36093_))))
  (define std/misc/list#slice-right
    (lambda _g301780_
      (let ((_g301779_ (let () (declare (not safe)) (##length _g301780_))))
        (cond ((let () (declare (not safe)) (##fx= _g301779_ 2))
               (apply std/misc/list#slice-right__0 _g301780_))
              ((let () (declare (not safe)) (##fx= _g301779_ 3))
               (apply std/misc/list#slice-right__% _g301780_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#slice-right
                _g301780_))))))
  (define std/misc/list#slice!__%
    (lambda (_lst36066_ _start36067_ _limit36068_)
      (if _limit36068_
          (std/srfi/1#take!
           (std/srfi/1#drop _lst36066_ _start36067_)
           _limit36068_)
          (std/srfi/1#drop _lst36066_ _start36067_))))
  (define std/misc/list#slice!__0
    (lambda (_lst36073_ _start36074_)
      (let ((_limit36076_ '#f))
        (std/misc/list#slice!__% _lst36073_ _start36074_ _limit36076_))))
  (define std/misc/list#slice!
    (lambda _g301782_
      (let ((_g301781_ (let () (declare (not safe)) (##length _g301782_))))
        (cond ((let () (declare (not safe)) (##fx= _g301781_ 2))
               (apply std/misc/list#slice!__0 _g301782_))
              ((let () (declare (not safe)) (##fx= _g301781_ 3))
               (apply std/misc/list#slice!__% _g301782_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#slice!
                _g301782_))))))
  (define std/misc/list#slice-right!__%
    (lambda (_lst36049_ _start36050_ _limit36051_)
      (if _limit36051_
          (std/srfi/1#take-right
           (std/srfi/1#drop-right! _lst36049_ _start36050_)
           _limit36051_)
          (std/srfi/1#drop-right! _lst36049_ _start36050_))))
  (define std/misc/list#slice-right!__0
    (lambda (_lst36056_ _start36057_)
      (let ((_limit36059_ '#f))
        (std/misc/list#slice-right!__% _lst36056_ _start36057_ _limit36059_))))
  (define std/misc/list#slice-right!
    (lambda _g301784_
      (let ((_g301783_ (let () (declare (not safe)) (##length _g301784_))))
        (cond ((let () (declare (not safe)) (##fx= _g301783_ 2))
               (apply std/misc/list#slice-right!__0 _g301784_))
              ((let () (declare (not safe)) (##fx= _g301783_ 3))
               (apply std/misc/list#slice-right!__% _g301784_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#slice-right!
                _g301784_))))))
  (define std/misc/list#butlast
    (lambda (_lst36046_)
      (if (pair? _lst36046_)
          (std/srfi/1#take _lst36046_ (- (length _lst36046_) '1))
          _lst36046_)))
  (define std/misc/list#split__%
    (lambda (_lst35964_ _stop35965_ _limit35966_)
      (declare (fixnum))
      (letrec* ((_test35968_
                 (if (procedure? _stop35965_)
                     _stop35965_
                     (lambda (_g3602936031_)
                       (equal? _g3602936031_ _stop35965_)))))
        (let _loop35970_ ((_xs35972_ _lst35964_)
                          (_buf35973_ '())
                          (_n35974_
                           (if (fixnum? _limit35966_) _limit35966_ '-1)))
          (let ((_g3597535987_ (zero? _n35974_)) (_xs3597635989_ _xs35972_))
            (let ((_E3598035993_
                   (lambda ()
                     (error '"No clause matching"
                            _g3597535987_
                            _xs3597635989_))))
              (let ((_K3598536027_
                     (lambda ()
                       (if (pair? _buf35973_)
                           (cons (std/srfi/1#reverse! _buf35973_) '())
                           '())))
                    (_K3598236011_
                     (lambda (_xs36008_ _v36009_)
                       (if (_test35968_ _v36009_)
                           (cons (std/srfi/1#reverse! _buf35973_)
                                 (_loop35970_ _xs36008_ '() (- _n35974_ '1)))
                           (_loop35970_
                            _xs36008_
                            (cons _v36009_ _buf35973_)
                            _n35974_))))
                    (_K3598135999_
                     (lambda (_rest35997_)
                       (if (zero? _limit35966_)
                           _lst35964_
                           (if (pair? _rest35997_)
                               (cons _rest35997_ '())
                               '())))))
                (let ((_try-match3597936004_
                       (lambda ()
                         (if (let ()
                               (declare (not safe))
                               (##eq? _g3597535987_ '#t))
                             (let ((_rest36002_ _xs3597635989_))
                               (_K3598135999_ _rest36002_))
                             (_E3598035993_)))))
                  (if (let () (declare (not safe)) (##eq? _g3597535987_ '#f))
                      (if (let ()
                            (declare (not safe))
                            (##null? _xs3597635989_))
                          (_K3598536027_)
                          (if (let ()
                                (declare (not safe))
                                (##pair? _xs3597635989_))
                              (let ((_tl3598436016_
                                     (let ()
                                       (declare (not safe))
                                       (##cdr _xs3597635989_)))
                                    (_hd3598336014_
                                     (let ()
                                       (declare (not safe))
                                       (##car _xs3597635989_))))
                                (let ((_v36019_ _hd3598336014_)
                                      (_xs36021_ _tl3598436016_))
                                  (_K3598236011_ _xs36021_ _v36019_)))
                              (_E3598035993_)))
                      (_try-match3597936004_))))))))))
  (define std/misc/list#split__0
    (lambda (_lst36037_ _stop36038_)
      (let ((_limit36040_ '#f))
        (std/misc/list#split__% _lst36037_ _stop36038_ _limit36040_))))
  (define std/misc/list#split
    (lambda _g301786_
      (let ((_g301785_ (let () (declare (not safe)) (##length _g301786_))))
        (cond ((let () (declare (not safe)) (##fx= _g301785_ 2))
               (apply std/misc/list#split__0 _g301786_))
              ((let () (declare (not safe)) (##fx= _g301785_ 3))
               (apply std/misc/list#split__% _g301786_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#split
                _g301786_))))))
  (define std/misc/list#take-until
    (lambda (_pred35957_ _list35958_)
      (std/srfi/1#take-while
       (lambda (_$obj35960_) (not (_pred35957_ _$obj35960_)))
       _list35958_)))
  (define std/misc/list#take-until!
    (lambda (_pred35951_ _list35952_)
      (std/srfi/1#take-while!
       (lambda (_$obj35954_) (not (_pred35951_ _$obj35954_)))
       _list35952_)))
  (define std/misc/list#drop-until
    (lambda (_pred35945_ _list35946_)
      (std/srfi/1#drop-while
       (lambda (_$obj35948_) (not (_pred35945_ _$obj35948_)))
       _list35946_)))
  (define std/misc/list#group__%
    (lambda (_lst35842_ _test35843_)
      (letrec ((_helper35845_
                (lambda ()
                  (let _loop35893_ ((_rest35895_ _lst35842_)
                                    (_buf35896_ '())
                                    (_acc35897_ '()))
                    (let* ((_rest3589835906_ _rest35895_)
                           (_else3590035914_
                            (lambda ()
                              (std/srfi/1#reverse!
                               (cons _buf35896_ _acc35897_))))
                           (_K3590235923_
                            (lambda (_rest35917_ _it35918_)
                              (if (or (null? _buf35896_)
                                      (_test35843_ _it35918_ (car _buf35896_)))
                                  (_loop35893_
                                   _rest35917_
                                   (cons _it35918_ _buf35896_)
                                   _acc35897_)
                                  (_loop35893_
                                   _rest35917_
                                   (cons _it35918_ '())
                                   (cons _buf35896_ _acc35897_))))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _rest3589835906_))
                          (let ((_hd3590335926_
                                 (let ()
                                   (declare (not safe))
                                   (##car _rest3589835906_)))
                                (_tl3590435928_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _rest3589835906_))))
                            (let* ((_it35931_ _hd3590335926_)
                                   (_rest35933_ _tl3590435928_))
                              (_K3590235923_ _rest35933_ _it35931_)))
                          (_else3590035914_)))))))
        (let* ((_lst3584635857_ _lst35842_)
               (_E3585035861_
                (lambda () (error '"No clause matching" _lst3584635857_))))
          (let ((_K3585535889_ (lambda () _lst35842_))
                (_K3585235875_
                 (lambda (_a35873_) (cons (cons _a35873_ '()) '())))
                (_K3585135866_ (lambda () (_helper35845_))))
            (let ((_try-match3584835885_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##pair? _lst3584635857_))
                         (let ((_tl3585435880_
                                (let ()
                                  (declare (not safe))
                                  (##cdr _lst3584635857_)))
                               (_hd3585335878_
                                (let ()
                                  (declare (not safe))
                                  (##car _lst3584635857_))))
                           (if (let ()
                                 (declare (not safe))
                                 (##null? _tl3585435880_))
                               (let ((_a35883_ _hd3585335878_))
                                 (_K3585235875_ _a35883_))
                               (_helper35845_)))
                         (_helper35845_)))))
              (if (let () (declare (not safe)) (##null? _lst3584635857_))
                  (_K3585535889_)
                  (_try-match3584835885_))))))))
  (define std/misc/list#group__0
    (lambda (_lst35938_)
      (let ((_test35940_ equal?))
        (std/misc/list#group__% _lst35938_ _test35940_))))
  (define std/misc/list#group
    (lambda _g301788_
      (let ((_g301787_ (let () (declare (not safe)) (##length _g301788_))))
        (cond ((let () (declare (not safe)) (##fx= _g301787_ 1))
               (apply std/misc/list#group__0 _g301788_))
              ((let () (declare (not safe)) (##fx= _g301787_ 2))
               (apply std/misc/list#group__% _g301788_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#group
                _g301788_))))))
  (define std/misc/list#every-consecutive?
    (lambda (_f35792_ _l35793_)
      (let ((_$e35795_ (null? _l35793_)))
        (if _$e35795_
            _$e35795_
            (let _loop35798_ ((_x35800_ (car _l35793_))
                              (_r35801_ (cdr _l35793_)))
              (let* ((_r3580235811_ _r35801_)
                     (_E3580535815_
                      (lambda () (error '"No clause matching" _r3580235811_))))
                (let ((_K3580935838_ (lambda () '#t))
                      (_K3580635822_
                       (lambda (_rr35819_ _y35820_)
                         (if (_f35792_ _x35800_ _y35820_)
                             (_loop35798_ _y35820_ _rr35819_)
                             '#f))))
                  (let ((_try-match3580435834_
                         (lambda ()
                           (if (let ()
                                 (declare (not safe))
                                 (##pair? _r3580235811_))
                               (let ((_tl3580835827_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _r3580235811_)))
                                     (_hd3580735825_
                                      (let ()
                                        (declare (not safe))
                                        (##car _r3580235811_))))
                                 (let ((_y35830_ _hd3580735825_)
                                       (_rr35832_ _tl3580835827_))
                                   (_K3580635822_ _rr35832_ _y35830_)))
                               (_E3580535815_)))))
                    (if (let () (declare (not safe)) (##null? _r3580235811_))
                        (_K3580935838_)
                        (_try-match3580435834_))))))))))
  (define std/misc/list#separate-keyword-arguments__%
    (lambda (_args35652_ _positionals-only?35653_)
      (let _lp35655_ ((_rest35657_ _args35652_)
                      (_positionals35658_ '())
                      (_keywords35659_ '()))
        (let* ((_rest3566035685_ _rest35657_)
               (_E3566635689_
                (lambda () (error '"No clause matching" _rest3566035685_))))
          (let ((_K3568135772_
                 (lambda (_r35770_)
                   (values (foldl1 cons
                                   (if _positionals-only?35653_
                                       _r35770_
                                       _rest35657_)
                                   _positionals35658_)
                           (reverse _keywords35659_))))
                (_K3567635750_
                 (lambda (_r35747_ _k35748_)
                   (_lp35655_
                    _r35747_
                    (if _positionals-only?35653_
                        (cons _k35748_ _positionals35658_)
                        (cons _k35748_ (cons '#!key _positionals35658_)))
                    _keywords35659_)))
                (_K3567135724_
                 (lambda (_r35720_ _v35721_ _k35722_)
                   (_lp35655_
                    _r35720_
                    _positionals35658_
                    (cons _v35721_ (cons _k35722_ _keywords35659_)))))
                (_K3566835704_
                 (lambda (_r35701_ _a35702_)
                   (_lp35655_
                    _r35701_
                    (cons _a35702_ _positionals35658_)
                    _keywords35659_)))
                (_K3566735694_
                 (lambda ()
                   (values (reverse _positionals35658_)
                           (reverse _keywords35659_)))))
            (let ((_try-match3566535697_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _rest3566035685_))
                         (_K3566735694_)
                         (_E3566635689_)))))
              (if (let () (declare (not safe)) (##pair? _rest3566035685_))
                  (let ((_tl3568335777_
                         (let ()
                           (declare (not safe))
                           (##cdr _rest3566035685_)))
                        (_hd3568235775_
                         (let ()
                           (declare (not safe))
                           (##car _rest3566035685_))))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _hd3568235775_ '#!rest))
                        (let ((_r35780_ _tl3568335777_))
                          (_K3568135772_ _r35780_))
                        (if (let ()
                              (declare (not safe))
                              (##eq? _hd3568235775_ '#!key))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl3568335777_))
                                (let ((_tl3568035760_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl3568335777_)))
                                      (_hd3567935758_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl3568335777_))))
                                  (let ((_k35763_ _hd3567935758_)
                                        (_r35765_ _tl3568035760_))
                                    (_K3567635750_ _r35765_ _k35763_)))
                                (let ((_a35712_ _hd3568235775_)
                                      (_r35714_ _tl3568335777_))
                                  (_K3566835704_ _r35714_ _a35712_)))
                            (if (keyword? _hd3568235775_)
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl3568335777_))
                                    (let ((_tl3567535736_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl3568335777_)))
                                          (_hd3567435734_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl3568335777_))))
                                      (let ((_k35732_ _hd3568235775_)
                                            (_v35739_ _hd3567435734_)
                                            (_r35741_ _tl3567535736_))
                                        (_K3567135724_
                                         _r35741_
                                         _v35739_
                                         _k35732_)))
                                    (let ((_a35712_ _hd3568235775_)
                                          (_r35714_ _tl3568335777_))
                                      (_K3566835704_ _r35714_ _a35712_)))
                                (let ((_a35712_ _hd3568235775_)
                                      (_r35714_ _tl3568335777_))
                                  (_K3566835704_ _r35714_ _a35712_))))))
                  (_try-match3566535697_))))))))
  (define std/misc/list#separate-keyword-arguments__0
    (lambda (_args35785_)
      (let ((_positionals-only?35787_ '#f))
        (std/misc/list#separate-keyword-arguments__%
         _args35785_
         _positionals-only?35787_))))
  (define std/misc/list#separate-keyword-arguments
    (lambda _g301790_
      (let ((_g301789_ (let () (declare (not safe)) (##length _g301790_))))
        (cond ((let () (declare (not safe)) (##fx= _g301789_ 1))
               (apply std/misc/list#separate-keyword-arguments__0 _g301790_))
              ((let () (declare (not safe)) (##fx= _g301789_ 2))
               (apply std/misc/list#separate-keyword-arguments__% _g301790_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/list#separate-keyword-arguments
                _g301790_))))))
  (define std/misc/list#first-and-only
    (lambda (_x35648_)
      (let ()
        (if (and (pair? _x35648_) (null? (cdr _x35648_)))
            '#!void
            (std/assert#assert!/fail
             '"\"misc/list.ss\"@327.12"
             '(and (pair? x) (null? (cdr x)))
             '())))
      (car _x35648_))))
