(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/misc/queue#queue::t
    (make-struct-type
     'std/misc/queue#queue::t
     '#f
     '3
     'queue
     '((final: . #t))
     ':init!
     '(front back length)))
  (define std/misc/queue#queue?
    (make-struct-predicate std/misc/queue#queue::t))
  (define std/misc/queue#make-queue
    (lambda _$args38220_
      (apply make-struct-instance std/misc/queue#queue::t _$args38220_)))
  (define std/misc/queue#queue-front
    (make-struct-field-accessor std/misc/queue#queue::t '0))
  (define std/misc/queue#queue-back
    (make-struct-field-accessor std/misc/queue#queue::t '1))
  (define std/misc/queue#queue-length
    (make-struct-field-accessor std/misc/queue#queue::t '2))
  (define std/misc/queue#queue-front-set!
    (make-struct-field-mutator std/misc/queue#queue::t '0))
  (define std/misc/queue#queue-back-set!
    (make-struct-field-mutator std/misc/queue#queue::t '1))
  (define std/misc/queue#queue-length-set!
    (make-struct-field-mutator std/misc/queue#queue::t '2))
  (define std/misc/queue#&queue-front
    (make-struct-field-unchecked-accessor std/misc/queue#queue::t '0))
  (define std/misc/queue#&queue-back
    (make-struct-field-unchecked-accessor std/misc/queue#queue::t '1))
  (define std/misc/queue#&queue-length
    (make-struct-field-unchecked-accessor std/misc/queue#queue::t '2))
  (define std/misc/queue#&queue-front-set!
    (make-struct-field-unchecked-mutator std/misc/queue#queue::t '0))
  (define std/misc/queue#&queue-back-set!
    (make-struct-field-unchecked-mutator std/misc/queue#queue::t '1))
  (define std/misc/queue#&queue-length-set!
    (make-struct-field-unchecked-mutator std/misc/queue#queue::t '2))
  (define std/misc/queue#queue:::init!
    (lambda (_self38218_)
      (if (##fx< '3 (##vector-length _self38218_))
          (begin
            (##vector-set! _self38218_ '1 '())
            (##vector-set! _self38218_ '2 '#f)
            (##vector-set! _self38218_ '3 '0))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self38218_))))
  (bind-method!
   std/misc/queue#queue::t
   ':init!
   std/misc/queue#queue:::init!
   '#f)
  (define std/misc/queue#queue-empty?
    (lambda (_q38093_)
      (null? (##direct-structure-ref
              _q38093_
              '1
              std/misc/queue#queue::t
              '#f))))
  (define std/misc/queue#non-empty-queue?
    (lambda (_q38091_)
      (pair? (##direct-structure-ref
              _q38091_
              '1
              std/misc/queue#queue::t
              '#f))))
  (define std/misc/queue#enqueue!
    (lambda (_q38048_ _v38049_)
      (let* ((_q3805038058_ _q38048_)
             (_E3805238062_
              (lambda () (error '"No clause matching" _q3805038058_)))
             (_K3805338073_
              (lambda (_length38065_ _back38066_ _front38067_)
                (if (null? _front38067_)
                    (let ((_front38069_ (cons _v38049_ '())))
                      (##unchecked-structure-set!
                       _q38048_
                       _front38069_
                       '1
                       std/misc/queue#queue::t
                       '#f)
                      (##unchecked-structure-set!
                       _q38048_
                       _front38069_
                       '2
                       std/misc/queue#queue::t
                       '#f)
                      (##unchecked-structure-set!
                       _q38048_
                       '1
                       '3
                       std/misc/queue#queue::t
                       '#f))
                    (let ((_new-back38071_ (cons _v38049_ '())))
                      (set-cdr! _back38066_ _new-back38071_)
                      (##unchecked-structure-set!
                       _q38048_
                       _new-back38071_
                       '2
                       std/misc/queue#queue::t
                       '#f)
                      (##unchecked-structure-set!
                       _q38048_
                       (fx+ _length38065_ '1)
                       '3
                       std/misc/queue#queue::t
                       '#f))))))
        (if (##structure-direct-instance-of?
             _q3805038058_
             'std/misc/queue#queue::t)
            (let* ((_e3805438076_ (##vector-ref _q3805038058_ '1))
                   (_front38079_ _e3805438076_)
                   (_e3805538081_ (##vector-ref _q3805038058_ '2))
                   (_back38084_ _e3805538081_)
                   (_e3805638086_ (##vector-ref _q3805038058_ '3))
                   (_length38089_ _e3805638086_))
              (_K3805338073_ _length38089_ _back38084_ _front38079_))
            (_E3805238062_)))))
  (define std/misc/queue#enqueue-front!
    (lambda (_q38010_ _v38011_)
      (if (std/misc/queue#queue-empty? _q38010_)
          (std/misc/queue#enqueue! _q38010_ _v38011_)
          (let* ((_q3801238020_ _q38010_)
                 (_E3801438024_
                  (lambda () (error '"No clause matching" _q3801238020_)))
                 (_K3801538032_
                  (lambda (_length38027_ _front38028_)
                    (let ((_new-front38030_ (cons _v38011_ _front38028_)))
                      (##unchecked-structure-set!
                       _q38010_
                       _new-front38030_
                       '1
                       std/misc/queue#queue::t
                       '#f)
                      (##unchecked-structure-set!
                       _q38010_
                       (fx+ _length38027_ '1)
                       '3
                       std/misc/queue#queue::t
                       '#f)))))
            (if (##structure-direct-instance-of?
                 _q3801238020_
                 'std/misc/queue#queue::t)
                (let* ((_e3801638035_ (##vector-ref _q3801238020_ '1))
                       (_front38038_ _e3801638035_)
                       (_e3801738040_ (##vector-ref _q3801238020_ '2))
                       (_e3801838043_ (##vector-ref _q3801238020_ '3))
                       (_length38046_ _e3801838043_))
                  (_K3801538032_ _length38046_ _front38038_))
                (_E3801438024_))))))
  (define std/misc/queue#dequeue!__%
    (lambda (_q37956_ _default37957_)
      (let* ((_q3795837966_ _q37956_)
             (_E3796037970_
              (lambda () (error '"No clause matching" _q3795837966_)))
             (_K3796137982_
              (lambda (_length37973_ _back37974_ _front37975_)
                (if (eq? _front37975_ _back37974_)
                    (let ((_v37977_ (car _front37975_)))
                      (##unchecked-structure-set!
                       _q37956_
                       '()
                       '1
                       std/misc/queue#queue::t
                       '#f)
                      (##unchecked-structure-set!
                       _q37956_
                       '#f
                       '2
                       std/misc/queue#queue::t
                       '#f)
                      (##unchecked-structure-set!
                       _q37956_
                       '0
                       '3
                       std/misc/queue#queue::t
                       '#f)
                      _v37977_)
                    (if (pair? _front37975_)
                        (let ((_v37979_ (car _front37975_))
                              (_new-front37980_ (cdr _front37975_)))
                          (##unchecked-structure-set!
                           _q37956_
                           _new-front37980_
                           '1
                           std/misc/queue#queue::t
                           '#f)
                          (##unchecked-structure-set!
                           _q37956_
                           (fx- _length37973_ '1)
                           '3
                           std/misc/queue#queue::t
                           '#f)
                          _v37979_)
                        (if (eq? _default37957_ absent-obj)
                            (error '"cannot dequeue; empty queue" _q37956_)
                            _default37957_))))))
        (if (##structure-direct-instance-of?
             _q3795837966_
             'std/misc/queue#queue::t)
            (let* ((_e3796237985_ (##vector-ref _q3795837966_ '1))
                   (_front37988_ _e3796237985_)
                   (_e3796337990_ (##vector-ref _q3795837966_ '2))
                   (_back37993_ _e3796337990_)
                   (_e3796437995_ (##vector-ref _q3795837966_ '3))
                   (_length37998_ _e3796437995_))
              (_K3796137982_ _length37998_ _back37993_ _front37988_))
            (_E3796037970_)))))
  (define std/misc/queue#dequeue!__0
    (lambda (_q38003_)
      (let ((_default38005_ absent-obj))
        (std/misc/queue#dequeue!__% _q38003_ _default38005_))))
  (define std/misc/queue#dequeue!
    (lambda _g301969_
      (let ((_g301968_ (##length _g301969_)))
        (cond ((##fx= _g301968_ 1)
               (apply std/misc/queue#dequeue!__0 _g301969_))
              ((##fx= _g301968_ 2)
               (apply std/misc/queue#dequeue!__% _g301969_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/queue#dequeue!
                _g301969_))))))
  (define std/misc/queue#queue-peek__%
    (lambda (_q37920_ _default37921_)
      (let* ((_q3792237928_ _q37920_)
             (_E3792437932_
              (lambda () (error '"No clause matching" _q3792237928_)))
             (_K3792537937_
              (lambda (_front37935_)
                (if (pair? _front37935_)
                    (car _front37935_)
                    (if (eq? _default37921_ absent-obj)
                        (error '"cannot peek; empty queue" _q37920_)
                        _default37921_)))))
        (if (##structure-direct-instance-of?
             _q3792237928_
             'std/misc/queue#queue::t)
            (let* ((_e3792637940_ (##vector-ref _q3792237928_ '1))
                   (_front37943_ _e3792637940_))
              (_K3792537937_ _front37943_))
            (_E3792437932_)))))
  (define std/misc/queue#queue-peek__0
    (lambda (_q37948_)
      (let ((_default37950_ absent-obj))
        (std/misc/queue#queue-peek__% _q37948_ _default37950_))))
  (define std/misc/queue#queue-peek
    (lambda _g301971_
      (let ((_g301970_ (##length _g301971_)))
        (cond ((##fx= _g301970_ 1)
               (apply std/misc/queue#queue-peek__0 _g301971_))
              ((##fx= _g301970_ 2)
               (apply std/misc/queue#queue-peek__% _g301971_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/queue#queue-peek
                _g301971_))))))
  (define std/misc/queue#queue->list
    (lambda (_q37917_)
      (foldr1 cons
              '()
              (##direct-structure-ref
               _q37917_
               '1
               std/misc/queue#queue::t
               '#f)))))
