(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/string#string-trim-prefix
    (lambda (_prefix167864_ _string167865_)
      (if (std/srfi/13#string-prefix?__0 _prefix167864_ _string167865_)
          (std/srfi/13#string-drop
           _string167865_
           (string-length _prefix167864_))
          _string167865_)))
  (define std/misc/string#string-split-prefix
    (lambda (_prefix167859_ _string167860_)
      (let ((_trimmed167862_
             (std/misc/string#string-trim-prefix
              _prefix167859_
              _string167860_)))
        (if (eq? _trimmed167862_ _string167860_)
            (values _string167860_ '"")
            (values _trimmed167862_ _prefix167859_)))))
  (define std/misc/string#string-trim-suffix
    (lambda (_suffix167856_ _string167857_)
      (if (std/srfi/13#string-suffix?__0 _suffix167856_ _string167857_)
          (std/srfi/13#string-drop-right
           _string167857_
           (string-length _suffix167856_))
          _string167857_)))
  (define std/misc/string#string-split-suffix
    (lambda (_suffix167851_ _string167852_)
      (let ((_trimmed167854_
             (std/misc/string#string-trim-suffix
              _suffix167851_
              _string167852_)))
        (if (eq? _trimmed167854_ _string167852_)
            (values _string167852_ '"")
            (values _trimmed167854_ _suffix167851_)))))
  (define std/misc/string#+cr+ '"\r")
  (define std/misc/string#+lf+ '"\n")
  (define std/misc/string#+crlf+ '"\r\n")
  (define std/misc/string#string-trim-eol
    (lambda (_string167753_)
      (let ((_trimmed167842_
             (std/misc/string#string-trim-suffix
              std/misc/string#+crlf+
              _string167753_)))
        (if (eq? _trimmed167842_ _string167753_)
            (let ((_trimmed167845_
                   (std/misc/string#string-trim-suffix
                    std/misc/string#+lf+
                    _string167753_)))
              (if (eq? _trimmed167845_ _string167753_)
                  (let ((_trimmed167848_
                         (std/misc/string#string-trim-suffix
                          std/misc/string#+cr+
                          _string167753_)))
                    (if (eq? _trimmed167848_ _string167753_)
                        _string167753_
                        _trimmed167848_))
                  _trimmed167845_))
            _trimmed167842_))))
  (define std/misc/string#string-split-eol
    (lambda (_string167653_)
      (let ((_trimmed167744_
             (std/misc/string#string-trim-suffix
              std/misc/string#+crlf+
              _string167653_)))
        (if (eq? _trimmed167744_ _string167653_)
            (let ((_trimmed167747_
                   (std/misc/string#string-trim-suffix
                    std/misc/string#+lf+
                    _string167653_)))
              (if (eq? _trimmed167747_ _string167653_)
                  (let ((_trimmed167750_
                         (std/misc/string#string-trim-suffix
                          std/misc/string#+cr+
                          _string167653_)))
                    (if (eq? _trimmed167750_ _string167653_)
                        (values _string167653_ '"")
                        (values _trimmed167750_ std/misc/string#+cr+)))
                  (values _trimmed167747_ std/misc/string#+lf+)))
            (values _trimmed167744_ std/misc/string#+crlf+)))))
  (define std/misc/string#subst-helper-empty-old
    (lambda (_str167634_ _new167635_ _count167636_)
      (declare (fixnum))
      (letrec* ((_len-str167638_ (string-length _str167634_)))
        (if (= _count167636_ '1)
            (string-append _new167635_ _str167634_)
            (call-with-output-string
             (lambda (_port167640_)
               (gerbil/gambit/ports#write-string__% _new167635_ _port167640_)
               (let ((_stop167645_ (- _len-str167638_ '1))
                     (_count167646_
                      (if (or (negative? _count167636_)
                              (> _count167636_ _len-str167638_))
                          (+ _len-str167638_ '1)
                          _count167636_)))
                 (let _loop167648_ ((_i167650_ '0) (_matches167651_ '1))
                   (if (= _matches167651_ _count167646_)
                       (begin
                         (gerbil/gambit/ports#write-string__%
                          _new167635_
                          _port167640_)
                         (write-substring
                          _str167634_
                          _i167650_
                          _len-str167638_
                          _port167640_))
                       (if (= _i167650_ _stop167645_)
                           (begin
                             (if (zero? _i167650_)
                                 '#!void
                                 (gerbil/gambit/ports#write-string__%
                                  _new167635_
                                  _port167640_))
                             (write-char
                              (string-ref _str167634_ _i167650_)
                              _port167640_)
                             (gerbil/gambit/ports#write-string__%
                              _new167635_
                              _port167640_))
                           (begin
                             (if (zero? _i167650_)
                                 '#!void
                                 (gerbil/gambit/ports#write-string__%
                                  _new167635_
                                  _port167640_))
                             (write-char
                              (string-ref _str167634_ _i167650_)
                              _port167640_)
                             (_loop167648_
                              (+ _i167650_ '1)
                              (+ _matches167651_ '1)))))))))))))
  (define std/misc/string#subst-helper-nonempty-old
    (lambda (_str167616_ _old167617_ _new167618_ _count167619_)
      (declare (fixnum))
      (letrec* ((_len-str167621_ (string-length _str167616_))
                (_size-old167622_ (- (string-length _old167617_) '1))
                (_size-str167623_ (- (string-length _str167616_) '1)))
        (call-with-output-string
         (lambda (_port167625_)
           (let _loop167627_ ((_i167629_ '0)
                              (_matches167630_ '0)
                              (_last167631_ '0)
                              (_j167632_ '0))
             (if (= _matches167630_ _count167619_)
                 (write-substring
                  _str167616_
                  _i167629_
                  _len-str167621_
                  _port167625_)
                 (if (= _i167629_ _size-str167623_)
                     (if (and (eq? (string-ref _str167616_ _i167629_)
                                   (string-ref _old167617_ _j167632_))
                              (= _j167632_ _size-old167622_))
                         (gerbil/gambit/ports#write-string__%
                          _new167618_
                          _port167625_)
                         (write-substring
                          _str167616_
                          _last167631_
                          _len-str167621_
                          _port167625_))
                     (if (eq? (string-ref _str167616_ _i167629_)
                              (string-ref _old167617_ _j167632_))
                         (if (= _j167632_ _size-old167622_)
                             (begin
                               (gerbil/gambit/ports#write-string__%
                                _new167618_
                                _port167625_)
                               (_loop167627_
                                (+ _i167629_ '1)
                                (+ _matches167630_ '1)
                                (+ _i167629_ '1)
                                '0))
                             (_loop167627_
                              (+ _i167629_ '1)
                              _matches167630_
                              _last167631_
                              (+ _j167632_ '1)))
                         (begin
                           (write-substring
                            _str167616_
                            _last167631_
                            (+ _i167629_ '1)
                            _port167625_)
                           (_loop167627_
                            (+ _i167629_ '1)
                            _matches167630_
                            (+ _i167629_ '1)
                            '0)))))))))))
  (define std/misc/string#string-subst__%
    (lambda (_g302868_ _count167579167582_ _str167584_ _old167585_ _new167586_)
      (let ((_count167588_
             (if (eq? _count167579167582_ absent-value)
                 '#f
                 _count167579167582_)))
        (declare (fixnum))
        (letrec* ((_g302869_
                   (let ((_g302870_
                          (if (or (not _count167588_) (fixnum? _count167588_))
                              '#!void
                              (error '"Illegal argument; count must be a fixnum or #f, got:"
                                     _count167588_))))
                     #!void
                     _g302870_))
                  (_old-empty?167593_ (string-empty? _old167585_))
                  (_new-empty?167594_ (string-empty? _new167586_))
                  (_str-empty?167595_ (string-empty? _str167584_)))
          (if (or (and _old-empty?167593_ _new-empty?167594_)
                  (and _count167588_ (<= _count167588_ '0)))
              _str167584_
              (let ((_count167600_
                     (if (number? _count167588_) _count167588_ '-1)))
                (if _old-empty?167593_
                    (std/misc/string#subst-helper-empty-old
                     _str167584_
                     _new167586_
                     _count167600_)
                    (if _str-empty?167595_
                        _str167584_
                        (std/misc/string#subst-helper-nonempty-old
                         _str167584_
                         _old167585_
                         _new167586_
                         _count167600_)))))))))
  (define std/misc/string#string-subst__@
    (lambda (_keys167578167605_ . _args167607_)
      (apply std/misc/string#string-subst__%
             _keys167578167605_
             (table-ref _keys167578167605_ 'count: absent-value)
             _args167607_)))
  (define std/misc/string#string-subst
    (lambda _args167580167613_
      (apply keyword-dispatch
             '#(count:)
             std/misc/string#string-subst__@
             _args167580167613_)))
  (define std/misc/string#string-whitespace?
    (lambda (_s167575_)
      (std/srfi/13#string-every__0 char-whitespace? _s167575_)))
  (define std/misc/string#random-word-char
    (lambda ()
      (declare (not safe) (fixnum))
      (letrec* ((_n167573_ (random-integer '63)))
        (integer->char
         (+ _n167573_
            (if (< _n167573_ '10)
                '48
                (if (< _n167573_ '36) '55 (if (< _n167573_ '62) '61 '33))))))))
  (define std/misc/string#random-string__%
    (lambda (_len167554_)
      (declare (not safe) (fixnum))
      (begin
        (if (fixnum? _len167554_) '#!void (error '"len must be a fixnum"))
        (if (> _len167554_ '0)
            (let ((_str167557_ (make-string _len167554_)))
              (let _$loop167559_ ((_i167562_ '0))
                (if (= _i167562_ _len167554_)
                    '#!void
                    (begin
                      (string-set!
                       _str167557_
                       _i167562_
                       (std/misc/string#random-word-char))
                      (_$loop167559_ (+ _i167562_ '1)))))
              _str167557_)
            '""))))
  (define std/misc/string#random-string__0
    (lambda ()
      (let ((_len167568_ '10))
        (std/misc/string#random-string__% _len167568_))))
  (define std/misc/string#random-string
    (lambda _g302873_
      (let ((_g302872_ (let () (declare (not safe)) (##length _g302873_))))
        (cond ((let () (declare (not safe)) (##fx= _g302872_ 0))
               (apply std/misc/string#random-string__0 _g302873_))
              ((let () (declare (not safe)) (##fx= _g302872_ 1))
               (apply std/misc/string#random-string__% _g302873_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/string#random-string
                _g302873_))))))
  (define std/misc/string#str__0
    (lambda (_v167510_)
      (if (string? _v167510_)
          _v167510_
          (std/format#format
           (std/misc/string#str-format _v167510_)
           _v167510_))))
  (define std/misc/string#str__1
    (lambda _xs167512_
      (if (andmap1 string? _xs167512_)
          (std/srfi/13#string-concatenate _xs167512_)
          (call-with-output-string
           (lambda (_port167514_)
             (let _loop167516_ ((_rest167518_ _xs167512_))
               (let* ((_rest167519167527_ _rest167518_)
                      (_else167521167535_ (lambda () '#!void))
                      (_K167523167541_
                       (lambda (_rest167538_ _v167539_)
                         (if (string? _v167539_)
                             (gerbil/gambit/ports#write-string__%
                              _v167539_
                              _port167514_)
                             (std/format#fprintf
                              _port167514_
                              (std/misc/string#str-format _v167539_)
                              _v167539_))
                         (_loop167516_ _rest167538_))))
                 (if (let () (declare (not safe)) (##pair? _rest167519167527_))
                     (let ((_hd167524167544_
                            (let ()
                              (declare (not safe))
                              (##car _rest167519167527_)))
                           (_tl167525167546_
                            (let ()
                              (declare (not safe))
                              (##cdr _rest167519167527_))))
                       (let* ((_v167549_ _hd167524167544_)
                              (_rest167551_ _tl167525167546_))
                         (_K167523167541_ _rest167551_ _v167549_)))
                     '#!void))))))))
  (define std/misc/string#str
    (lambda _g302875_
      (let ((_g302874_ (let () (declare (not safe)) (##length _g302875_))))
        (cond ((let () (declare (not safe)) (##fx= _g302874_ 1))
               (apply std/misc/string#str__0 _g302875_))
              (#t (apply std/misc/string#str__1 _g302875_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/string#str
                _g302875_))))))
  (define std/misc/string#str-format
    (lambda (_v167492_)
      (letrec ((_obj-pr?167494_
                (lambda (_v167508_) (method-ref _v167508_ ':pr))))
        (if (and (number? _v167492_) (inexact? _v167492_))
            '"~f"
            (if (or (list? _v167492_)
                    (table? _v167492_)
                    (vector? _v167492_)
                    (let () (declare (not safe)) (##values? _v167492_))
                    (_obj-pr?167494_ _v167492_))
                '"~r"
                '"~a"))))))
