(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socket/basic-server#errorf
    (lambda (_fmt203086_ . _args203087_)
      (std/logger#log-message 'socket '0 _fmt203086_ _args203087_)))
  (define std/net/socket/basic-server#warnf
    (lambda (_fmt203083_ . _args203084_)
      (std/logger#log-message 'socket '1 _fmt203083_ _args203084_)))
  (define std/net/socket/basic-server#infof
    (lambda (_fmt203080_ . _args203081_)
      (std/logger#log-message 'socket '2 _fmt203080_ _args203081_)))
  (define std/net/socket/basic-server#debugf
    (lambda (_fmt203077_ . _args203078_)
      (std/logger#log-message 'socket '3 _fmt203077_ _args203078_)))
  (define std/net/socket/basic-server#verbosef
    (lambda (_fmt203072_ . _args203074_)
      (std/logger#log-message 'socket '4 _fmt203072_ _args203074_)))
  (define std/net/socket/basic-server#!io-state:::init!
    (lambda (_self203070_)
      (if (let ((__tmp309549
                 (let () (declare (not safe)) (##vector-length _self203070_))))
            (declare (not safe))
            (##fx< '3 __tmp309549))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self203070_ '1 'blocked))
            (let ((__tmp309550 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self203070_ '2 __tmp309550))
            (let ((__tmp309551 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self203070_ '3 __tmp309551)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self203070_))))
  (bind-method!
   std/net/socket/base#!io-state::t
   ':init!
   std/net/socket/basic-server#!io-state:::init!
   '#f)
  (define std/net/socket/basic-server#server-poll
    (lambda (_server202936_ _io202937_)
      (let _lp202939_ ()
        (let () (declare (not safe)) (##wait-for-io! _io202937_ '#t))
        (let ((_token202942_
               (let ()
                 (declare (not safe))
                 (##structure std/actor/proto#!token::t)))
              (_dest202944_ _server202936_))
          (std/actor/message#send-message__%
           _dest202944_
           (let ((__tmp309552
                  (let ()
                    (declare (not safe))
                    (##structure std/net/socket/base#socket-server.poll::t))))
             (declare (not safe))
             (##structure std/actor/proto#!call::t __tmp309552 _token202942_))
           '#f
           '#t)
          (std/actor/proto#!!call-recv _token202942_ _dest202944_))
        (_lp202939_))))
  (define std/net/socket/basic-server#server-loop
    (lambda (_poll-io202682_
             _do-poll202683_
             _add-socket202684_
             _close-socket202685_
             _shutdown!202686_)
      (letrec* ((_poll-thread202688_
                 (if _poll-io202682_
                     (gerbil/gambit/threads#spawn/name
                      'server-poll
                      std/net/socket/basic-server#server-poll
                      (current-thread)
                      _poll-io202682_)
                     '#f)))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g202689202692_)
              (if '#t
                  (let ((_e202695_ _g202689202692_))
                    (std/net/socket/basic-server#errorf
                     '"socket-server error: ~a"
                     _e202695_)
                    (_shutdown!202686_)
                    (raise _e202695_))
                  (raise _g202689202692_)))
            (lambda ()
              (let _loop202698_ ()
                (let _loop202700202702_ ()
                  (let ((_next202706_ (thread-mailbox-next)))
                    ((lambda (_$message202709_)
                       (let* ((_$message202711202721_ _$message202709_)
                              (_else202713202729_
                               (lambda () (_loop202700202702_)))
                              (_K202715202912_
                               (lambda (_$options202732_
                                        _$dest202734_
                                        _$source202736_
                                        _$value202738_)
                                 (let* ((_$value202760202785_ _$value202738_)
                                        (_else202766202793_
                                         (lambda () (_loop202700202702_))))
                                   (let ((_K202781202901_
                                          (lambda (_k202899_)
                                            (thread-mailbox-extract-and-rewind)
                                            (_do-poll202683_)
                                            (std/actor/message#send-message__%
                                             _$source202736_
                                             (let ()
                                               (declare (not safe))
                                               (##structure
                                                std/actor/proto#!value::t
                                                '#!void
                                                _k202899_))
                                             '#f
                                             '#f)
                                            (_loop202698_)))
                                         (_K202777202880_
                                          (lambda (_k202868_ _sock202869_)
                                            (thread-mailbox-extract-and-rewind)
                                            (with-exception-catcher
                                             (lambda (_g202870202872_)
                                               (if '#t
                                                   (let ((_e202875_
                                                          _g202870202872_))
                                                     (std/net/socket/basic-server#errorf
                                                      '"socket-server.add: ~a"
                                                      _e202875_)
                                                     (std/actor/message#send-message__%
                                                      _$source202736_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/actor/proto#!error::t
                                                         _e202875_
                                                         _k202868_))
                                                      '#f
                                                      '#f))
                                                   (raise _g202870202872_)))
                                             (lambda ()
                                               (let ((_ssock202878_
                                                      (_add-socket202684_
                                                       _sock202869_)))
                                                 (std/actor/message#send-message__%
                                                  _$source202736_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##structure
                                                     std/actor/proto#!value::t
                                                     _ssock202878_
                                                     _k202868_))
                                                  '#f
                                                  '#f))))
                                            (_loop202698_)))
                                         (_K202772202843_
                                          (lambda (_shutdown202832_
                                                   _dir202833_
                                                   _ssock202834_)
                                            (thread-mailbox-extract-and-rewind)
                                            (with-exception-catcher
                                             (lambda (_g202835202837_)
                                               (if '#t
                                                   (let ((_e202840_
                                                          _g202835202837_))
                                                     (std/net/socket/basic-server#errorf
                                                      '"socket-server.close: ~a"
                                                      _e202840_))
                                                   (raise _g202835202837_)))
                                             (lambda ()
                                               (_close-socket202685_
                                                _ssock202834_
                                                _dir202833_
                                                _shutdown202832_)))
                                            (_loop202698_)))
                                         (_K202769202817_
                                          (lambda (_k202808_)
                                            (thread-mailbox-extract-and-rewind)
                                            (with-exception-catcher
                                             (lambda (_g202809202811_)
                                               (if '#t
                                                   (let ((_e202814_
                                                          _g202809202811_))
                                                     (std/net/socket/basic-server#errorf
                                                      '"socket-server.shutdown!: ~a"
                                                      _e202814_)
                                                     (std/actor/message#send-message__%
                                                      _$source202736_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/actor/proto#!error::t
                                                         _e202814_
                                                         _k202808_))
                                                      '#f
                                                      '#f))
                                                   (raise _g202809202811_)))
                                             (lambda ()
                                               (_shutdown!202686_)
                                               (std/actor/message#send-message__%
                                                _$source202736_
                                                (let ()
                                                  (declare (not safe))
                                                  (##structure
                                                   std/actor/proto#!value::t
                                                   '#!void
                                                   _k202808_))
                                                '#f
                                                '#f)))))
                                         (_K202768202799_
                                          (lambda (_msg202797_)
                                            (thread-mailbox-extract-and-rewind)
                                            (std/net/socket/basic-server#warnf
                                             '"Unexpected message: ~a"
                                             _msg202797_)
                                            (_loop202698_))))
                                     (let ((_try-match202763202864_
                                            (lambda ()
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##structure-direct-instance-of?
                                                     _$value202760202785_
                                                     'std/actor/proto#!event::t))
                                                  (let ((_e202773202846_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##vector-ref
                                                            _$value202760202785_
                                                            '1))))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##structure-direct-instance-of?
                                                           _e202773202846_
                                                           'std/net/socket/base#socket-server.close::t))
                                                        (let* ((_e202774202849_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##vector-ref _e202773202846_ '1)))
                       (_e202775202854_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _e202773202846_ '2)))
                       (_e202776202859_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _e202773202846_ '3))))
                  (let ((_ssock202852_ _e202774202849_)
                        (_dir202857_ _e202775202854_)
                        (_shutdown202862_ _e202776202859_))
                    (_K202772202843_
                     _shutdown202862_
                     _dir202857_
                     _ssock202852_)))
                (let ((_msg202802_ _$value202760202785_))
                  (_K202768202799_ _msg202802_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (let ((_msg202802_
                                                         _$value202760202785_))
                                                    (_K202768202799_
                                                     _msg202802_))))))
                                       (if (let ()
                                             (declare (not safe))
                                             (##structure-direct-instance-of?
                                              _$value202760202785_
                                              'std/actor/proto#!call::t))
                                           (let ((_e202782202904_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _$value202760202785_
                                                     '1))))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##structure-direct-instance-of?
                                                    _e202782202904_
                                                    'std/net/socket/base#socket-server.poll::t))
                                                 (let* ((_e202783202907_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##vector-ref
                                                            _$value202760202785_
                                                            '2)))
                                                        (_k202910_
                                                         _e202783202907_))
                                                   (_K202781202901_ _k202910_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##structure-direct-instance-of?
                                                        _e202782202904_
                                                        'std/net/socket/base#socket-server.add::t))
                                                     (let* ((_e202780202886_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##vector-ref _e202782202904_ '1)))
                    (_e202779202891_
                     (let ()
                       (declare (not safe))
                       (##vector-ref _$value202760202785_ '2))))
               (let ((_sock202889_ _e202780202886_)
                     (_k202894_ _e202779202891_))
                 (_K202777202880_ _k202894_ _sock202889_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##structure-direct-instance-of?
                                                            _e202782202904_
                                                            'std/net/socket/base#socket-server.shutdown!::t))
                                                         (let* ((_e202771202823_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ()
                           (declare (not safe))
                           (##vector-ref _$value202760202785_ '2)))
                        (_k202826_ _e202771202823_))
                   (_K202769202817_ _k202826_))
                 (let ((_msg202802_ _$value202760202785_))
                   (_K202768202799_ _msg202802_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           (_try-match202763202864_))))))))
                         (if (let ()
                               (declare (not safe))
                               (##structure-direct-instance-of?
                                _$message202711202721_
                                'std/actor/message#message::t))
                             (let* ((_e202716202915_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202711202721_
                                        '1)))
                                    (_$value202918_ _e202716202915_)
                                    (_e202717202920_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202711202721_
                                        '2)))
                                    (_$source202923_ _e202717202920_)
                                    (_e202718202925_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202711202721_
                                        '3)))
                                    (_$dest202928_ _e202718202925_)
                                    (_e202719202930_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202711202721_
                                        '4)))
                                    (_$options202933_ _e202719202930_))
                               (_K202715202912_
                                _$options202933_
                                _$dest202928_
                                _$source202923_
                                _$value202918_))
                             (_loop202700202702_))))
                     _next202706_)))))))
         (lambda ()
           (if _poll-thread202688_
               (thread-terminate! _poll-thread202688_)
               '#!void))))))
  (define std/net/socket/basic-server#io-state-signal-ready!
    (lambda (_iostate202646_ _how202647_)
      (let* ((_iostate202648202656_ _iostate202646_)
             (_E202650202660_
              (lambda () (error '"No clause matching" _iostate202648202656_)))
             (_K202651202666_
              (lambda (_cv202663_ _mx202664_)
                (mutex-lock! _mx202664_)
                (##direct-structure-set!
                 _iostate202646_
                 _how202647_
                 '1
                 std/net/socket/base#!io-state::t
                 '#f)
                (condition-variable-broadcast! _cv202663_)
                (mutex-unlock! _mx202664_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _iostate202648202656_
               'std/net/socket/base#!io-state::t))
            (let* ((_e202652202669_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202648202656_ '1)))
                   (_e202653202672_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202648202656_ '2)))
                   (_mx202675_ _e202653202672_)
                   (_e202654202677_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202648202656_ '3)))
                   (_cv202680_ _e202654202677_))
              (_K202651202666_ _cv202680_ _mx202675_))
            (_E202650202660_)))))
  (define std/net/socket/basic-server#io-state-wait-io!
    (lambda (_iostate202600_ _timeo202601_ _how202602_)
      (let* ((_iostate202603202611_ _iostate202600_)
             (_E202605202615_
              (lambda () (error '"No clause matching" _iostate202603202611_)))
             (_K202606202630_
              (lambda (_cv202618_ _mx202619_)
                (let _lp202621_ ()
                  (mutex-lock! _mx202619_)
                  (let ((_$e202624_
                         (##direct-structure-ref
                          _iostate202600_
                          '1
                          std/net/socket/base#!io-state::t
                          '#f)))
                    (if (eq? 'closed _$e202624_)
                        (begin
                          (mutex-unlock! _mx202619_)
                          (error '"Socket direction has been closed"
                                 _how202602_))
                        (if (eq? 'ready _$e202624_)
                            (begin
                              (##direct-structure-set!
                               _iostate202600_
                               _how202602_
                               '1
                               std/net/socket/base#!io-state::t
                               '#f)
                              (mutex-unlock! _mx202619_)
                              '#!void)
                            (begin
                              (##direct-structure-set!
                               _iostate202600_
                               'blocked
                               '1
                               std/net/socket/base#!io-state::t
                               '#f)
                              (if (mutex-unlock!
                                   _mx202619_
                                   _cv202618_
                                   (or _timeo202601_ absent-obj))
                                  (_lp202621_)
                                  '#f)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _iostate202603202611_
               'std/net/socket/base#!io-state::t))
            (let* ((_e202607202633_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202603202611_ '1)))
                   (_e202608202636_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202603202611_ '2)))
                   (_mx202639_ _e202608202636_)
                   (_e202609202641_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202603202611_ '3)))
                   (_cv202644_ _e202609202641_))
              (_K202606202630_ _cv202644_ _mx202639_))
            (_E202605202615_)))))
  (define std/net/socket/basic-server#io-state-close-in!
    (lambda (_iostate202596_ _sock202597_ _shutdown202598_)
      (if _shutdown202598_
          (std/net/socket/basic-server#shutdown-socket!
           _sock202597_
           _shutdown202598_)
          (close-input-port _sock202597_))
      (std/net/socket/basic-server#io-state-signal-ready!
       _iostate202596_
       'closed)))
  (define std/net/socket/basic-server#io-state-close-out!
    (lambda (_iostate202592_ _sock202593_ _shutdown202594_)
      (if _shutdown202594_
          (std/net/socket/basic-server#shutdown-socket!
           _sock202593_
           _shutdown202594_)
          (close-output-port _sock202593_))
      (std/net/socket/basic-server#io-state-signal-ready!
       _iostate202592_
       'closed)))
  (define std/net/socket/basic-server#shutdown-socket!
    (lambda (_sock202582_ _how202583_)
      (with-exception-catcher
       (lambda (_g202584202586_)
         (if '#t
             (let ((_e202589_ _g202584202586_))
               (std/net/socket/basic-server#errorf
                '"socket-server.shutdown-socket!: ~a"
                _e202589_))
             (raise _g202584202586_)))
       (lambda () (std/os/socket#socket-shutdown _sock202582_ _how202583_))))))
