(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/parser/base#parse-error::t
    (make-struct-type
     'std/parser/base#parse-error::t
     error::t
     '0
     'parse-error
     '()
     '#f
     '()))
  (define std/parser/base#parse-error?
    (make-struct-predicate std/parser/base#parse-error::t))
  (define std/parser/base#make-parse-error
    (lambda _$args152598_
      (apply make-struct-instance
             std/parser/base#parse-error::t
             _$args152598_)))
  (define std/parser/base#token::t
    (make-struct-type
     'std/parser/base#token::t
     '#f
     '3
     'token
     '((final: . #t))
     '#f
     '(t e loc)))
  (define std/parser/base#token?
    (make-struct-predicate std/parser/base#token::t))
  (define std/parser/base#make-token
    (lambda _$args152595_
      (apply make-struct-instance std/parser/base#token::t _$args152595_)))
  (define std/parser/base#token-t
    (make-struct-field-accessor std/parser/base#token::t '0))
  (define std/parser/base#token-e
    (make-struct-field-accessor std/parser/base#token::t '1))
  (define std/parser/base#token-loc
    (make-struct-field-accessor std/parser/base#token::t '2))
  (define std/parser/base#token-t-set!
    (make-struct-field-mutator std/parser/base#token::t '0))
  (define std/parser/base#token-e-set!
    (make-struct-field-mutator std/parser/base#token::t '1))
  (define std/parser/base#token-loc-set!
    (make-struct-field-mutator std/parser/base#token::t '2))
  (define std/parser/base#location::t
    (make-struct-type
     'std/parser/base#location::t
     '#f
     '5
     'location
     '((final: . #t))
     '#f
     '(port line col off xoff)))
  (define std/parser/base#location?
    (make-struct-predicate std/parser/base#location::t))
  (define std/parser/base#make-location
    (lambda _$args152592_
      (apply make-struct-instance std/parser/base#location::t _$args152592_)))
  (define std/parser/base#location-port
    (make-struct-field-accessor std/parser/base#location::t '0))
  (define std/parser/base#location-line
    (make-struct-field-accessor std/parser/base#location::t '1))
  (define std/parser/base#location-col
    (make-struct-field-accessor std/parser/base#location::t '2))
  (define std/parser/base#location-off
    (make-struct-field-accessor std/parser/base#location::t '3))
  (define std/parser/base#location-xoff
    (make-struct-field-accessor std/parser/base#location::t '4))
  (define std/parser/base#location-port-set!
    (make-struct-field-mutator std/parser/base#location::t '0))
  (define std/parser/base#location-line-set!
    (make-struct-field-mutator std/parser/base#location::t '1))
  (define std/parser/base#location-col-set!
    (make-struct-field-mutator std/parser/base#location::t '2))
  (define std/parser/base#location-off-set!
    (make-struct-field-mutator std/parser/base#location::t '3))
  (define std/parser/base#location-xoff-set!
    (make-struct-field-mutator std/parser/base#location::t '4))
  (define std/parser/base#wrap-identity
    (lambda (_e152589_ _loc152590_) _e152589_))
  (define std/parser/base#wrap-ast
    (lambda (_e152583_ _loc152584_)
      (if (or (let ()
                (declare (not safe))
                (##structure-instance-of? _e152583_ 'gerbil#AST::t))
              (not _loc152584_))
          _e152583_
          (let ((__tmp290173
                 (std/parser/base#location->source-location _loc152584_)))
            (declare (not safe))
            (##structure AST::t _e152583_ __tmp290173)))))
  (define std/parser/base#unwrap-ast
    (lambda (_e152581_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _e152581_ 'gerbil#AST::t))
          (##structure-ref _e152581_ '1 AST::t '#f)
          _e152581_)))
  (define std/parser/base#token->syntax
    (lambda (_tok152538_)
      (let* ((_tok152539152548_ _tok152538_)
             (_else152541152556_ (lambda () _tok152538_))
             (_K152543152563_
              (lambda (_loc152559_ _e152560_ _t152561_)
                (std/parser/base#wrap-ast
                 (cons _t152561_ (cons _e152560_ '()))
                 _loc152559_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _tok152539152548_
               'std/parser/base#token::t))
            (let* ((_e152544152566_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _tok152539152548_ '1)))
                   (_t152569_ _e152544152566_)
                   (_e152545152571_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _tok152539152548_ '2)))
                   (_e152574_ _e152545152571_)
                   (_e152546152576_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _tok152539152548_ '3)))
                   (_loc152579_ _e152546152576_))
              (_K152543152563_ _loc152579_ _e152574_ _t152569_))
            (_else152541152556_)))))
  (define std/parser/base#raise-parse-error
    (lambda (_where152533_ _msg152534_ _tok152535_ . _rest152536_)
      (raise (make-struct-instance
              std/parser/base#parse-error::t
              _msg152534_
              (cons _tok152535_ _rest152536_)
              _where152533_))))
  (define std/parser/base#parse-error::display-exception
    (lambda (_self152387_ _port152388_)
      (let* ((_self152389152397_ _self152387_)
             (_E152391152401_
              (lambda () (error '"No clause matching" _self152389152397_)))
             (_K152392152515_
              (lambda (_where152404_ _irritants152405_ _msg152406_)
                (let* ((_irritants152407152418_ _irritants152405_)
                       (_else152409152428_
                        (lambda ()
                          (if _where152404_
                              (displayln
                               '"Parse error at "
                               _where152404_
                               '": "
                               _msg152406_)
                              (displayln '"Parse error: " _msg152406_))
                          (if (null? _irritants152405_)
                              '#!void
                              (begin
                                (display '"--- irritants: ")
                                (for-each
                                 (lambda (_obj152426_)
                                   (write _obj152426_)
                                   (display '" "))
                                 _irritants152405_)))))
                       (_K152411152490_
                        (lambda (_rest152431_ _loc152432_ _e152433_ _t152434_)
                          (call-with-parameters
                           (lambda ()
                             (displayln '"Parse Error")
                             (display '"*** ERROR IN ")
                             (if _loc152432_
                                 (std/parser/base#display-location__%
                                  _loc152432_
                                  _port152388_)
                                 (display '"?"))
                             (newline)
                             (display '"--- Parse error")
                             (if _where152404_
                                 (begin
                                   (display '" at ")
                                   (display _where152404_))
                                 '#!void)
                             (displayln '": " _msg152406_)
                             (display '"... token: (")
                             (display _t152434_)
                             (display '" ")
                             (write _e152433_)
                             (displayln '")")
                             (if (null? _rest152431_)
                                 '#!void
                                 (for-each
                                  (lambda (_e152436152438_)
                                    (let* ((_g152440152450_ _e152436152438_)
                                           (_E152443152454_
                                            (lambda ()
                                              (error '"No clause matching"
                                                     _g152440152450_))))
                                      (let ((_K152445152472_
                                             (lambda (_loc152468_
                                                      _e152469_
                                                      _t152470_)
                                               (display '"... detail: ")
                                               (display '"(")
                                               (display _t152470_)
                                               (display '" ")
                                               (write _e152469_)
                                               (display '")")
                                               (if _loc152468_
                                                   (begin
                                                     (display '" at ")
                                                     (std/parser/base#display-location__0
                                                      _loc152468_))
                                                   '#!void)
                                               (newline)))
                                            (_K152444152460_
                                             (lambda (_obj152458_)
                                               (write _obj152458_)
                                               (newline))))
                                        (if (let ()
                                              (declare (not safe))
                                              (##structure-direct-instance-of?
                                               _g152440152450_
                                               'std/parser/base#token::t))
                                            (let* ((_e152446152475_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##vector-ref
                                                       _g152440152450_
                                                       '1)))
                                                   (_e152447152480_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##vector-ref
                                                       _g152440152450_
                                                       '2)))
                                                   (_e152448152485_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##vector-ref
                                                       _g152440152450_
                                                       '3))))
                                              (let ((_t152478_ _e152446152475_)
                                                    (_e152483_ _e152447152480_)
                                                    (_loc152488_
                                                     _e152448152485_))
                                                (_K152445152472_
                                                 _loc152488_
                                                 _e152483_
                                                 _t152478_)))
                                            (let ((_obj152463_
                                                   _g152440152450_))
                                              (_K152444152460_
                                               _obj152463_))))))
                                  _rest152431_)))
                           current-output-port
                           _port152388_))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _irritants152407152418_))
                      (let ((_hd152412152493_
                             (let ()
                               (declare (not safe))
                               (##car _irritants152407152418_)))
                            (_tl152413152495_
                             (let ()
                               (declare (not safe))
                               (##cdr _irritants152407152418_))))
                        (if (let ()
                              (declare (not safe))
                              (##structure-direct-instance-of?
                               _hd152412152493_
                               'std/parser/base#token::t))
                            (let* ((_e152414152498_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _hd152412152493_ '1)))
                                   (_t152501_ _e152414152498_)
                                   (_e152415152503_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _hd152412152493_ '2)))
                                   (_e152506_ _e152415152503_)
                                   (_e152416152508_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _hd152412152493_ '3)))
                                   (_loc152511_ _e152416152508_)
                                   (_rest152513_ _tl152413152495_))
                              (_K152411152490_
                               _rest152513_
                               _loc152511_
                               _e152506_
                               _t152501_))
                            (_else152409152428_)))
                      (_else152409152428_))))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _self152389152397_
               'std/parser/base#parse-error::t))
            (if (let ((__tmp290174
                       (let ()
                         (declare (not safe))
                         (##vector-length _self152389152397_))))
                  (declare (not safe))
                  (##fx< '3 __tmp290174))
                (let* ((_e152393152518_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _self152389152397_ '1)))
                       (_msg152521_ _e152393152518_)
                       (_e152394152523_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _self152389152397_ '2)))
                       (_irritants152526_ _e152394152523_)
                       (_e152395152528_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _self152389152397_ '3)))
                       (_where152531_ _e152395152528_))
                  (_K152392152515_
                   _where152531_
                   _irritants152526_
                   _msg152521_))
                (_E152391152401_))
            (_E152391152401_)))))
  (bind-method!
   std/parser/base#parse-error::t
   'display-exception
   std/parser/base#parse-error::display-exception
   '#f)
  (define std/parser/base#location->source-location
    (lambda (_loc152214_)
      (let* ((_loc152215152224_ _loc152214_)
             (_E152217152228_
              (lambda () (error '"No clause matching" _loc152215152224_)))
             (_K152218152241_
              (lambda (_off152231_ _col152232_ _line152233_ _port152234_)
                (let* ((_container152236_
                        (let ((__tmp290175
                               (let ()
                                 (declare (not safe))
                                 (##port-name _port152234_))))
                          (declare (not safe))
                          (##port-name->container __tmp290175)))
                       (_filepos152238_
                        (let ()
                          (declare (not safe))
                          (##make-filepos
                           _line152233_
                           _col152232_
                           _off152231_))))
                  (let ()
                    (declare (not safe))
                    (##make-locat _container152236_ _filepos152238_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _loc152215152224_
               'std/parser/base#location::t))
            (let* ((_e152219152244_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152215152224_ '1)))
                   (_port152247_ _e152219152244_)
                   (_e152220152249_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152215152224_ '2)))
                   (_line152252_ _e152220152249_)
                   (_e152221152254_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152215152224_ '3)))
                   (_col152257_ _e152221152254_)
                   (_e152222152259_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152215152224_ '4)))
                   (_off152262_ _e152222152259_))
              (_K152218152241_
               _off152262_
               _col152257_
               _line152252_
               _port152247_))
            (_E152217152228_)))))
  (define std/parser/base#display-location__%
    (lambda (_loc152201_ _port152202_)
      (let ((__tmp290176
             (std/parser/base#location->source-location _loc152201_)))
        (declare (not safe))
        (##display-locat __tmp290176 '#t _port152202_))))
  (define std/parser/base#display-location__0
    (lambda (_loc152207_)
      (let ((_port152209_ (current-output-port)))
        (std/parser/base#display-location__% _loc152207_ _port152209_))))
  (define std/parser/base#display-location
    (lambda _g290178_
      (let ((_g290177_ (let () (declare (not safe)) (##length _g290178_))))
        (cond ((let () (declare (not safe)) (##fx= _g290177_ 1))
               (apply std/parser/base#display-location__0 _g290178_))
              ((let () (declare (not safe)) (##fx= _g290177_ 2))
               (apply std/parser/base#display-location__% _g290178_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/parser/base#display-location
                _g290178_))))))
  (define std/parser/base#location-delta
    (lambda (_start152121_ _end152122_)
      (let ((_start152123152139_ _start152121_)
            (_end152124152141_ _end152122_))
        (let* ((_E152126152145_
                (lambda ()
                  (error '"No clause matching"
                         _start152123152139_
                         _end152124152141_)))
               (_K152127152155_
                (lambda (_xoff152148_
                         _col152149_
                         _line152150_
                         _port152151_
                         _exoff152152_
                         _eoff152153_)
                  (let ((__tmp290179
                         (let ((__tmp290180
                                (let ()
                                  (declare (not safe))
                                  (##fx- _exoff152152_ _xoff152148_))))
                           (declare (not safe))
                           (##fx+ __tmp290180 _eoff152153_))))
                    (declare (not safe))
                    (##structure
                     std/parser/base#location::t
                     _port152151_
                     _line152150_
                     _col152149_
                     __tmp290179
                     _xoff152148_)))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _start152123152139_
                 'std/parser/base#location::t))
              (let* ((_e152133152158_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152123152139_ '1)))
                     (_port152161_ _e152133152158_)
                     (_e152134152163_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152123152139_ '2)))
                     (_line152166_ _e152134152163_)
                     (_e152135152168_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152123152139_ '3)))
                     (_col152171_ _e152135152168_)
                     (_e152136152173_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152123152139_ '4)))
                     (_e152137152176_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152123152139_ '5)))
                     (_xoff152179_ _e152137152176_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _end152124152141_
                       'std/parser/base#location::t))
                    (let* ((_e152128152181_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152124152141_ '1)))
                           (_e152129152184_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152124152141_ '2)))
                           (_e152130152187_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152124152141_ '3)))
                           (_e152131152190_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152124152141_ '4)))
                           (_eoff152193_ _e152131152190_)
                           (_e152132152195_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152124152141_ '5)))
                           (_exoff152198_ _e152132152195_))
                      (_K152127152155_
                       _xoff152179_
                       _col152171_
                       _line152166_
                       _port152161_
                       _exoff152198_
                       _eoff152193_))
                    (_E152126152145_)))
              (_E152126152145_))))))
  (define std/parser/base#location-delta*
    (lambda (_start152045_ _end152046_)
      (let ((_start152047152063_ _start152045_)
            (_end152048152065_ _end152046_))
        (let* ((_E152050152069_
                (lambda ()
                  (error '"No clause matching"
                         _start152047152063_
                         _end152048152065_)))
               (_K152051152078_
                (lambda (_xoff152072_
                         _col152073_
                         _line152074_
                         _port152075_
                         _exoff152076_)
                  (let ((__tmp290181
                         (let ()
                           (declare (not safe))
                           (##fx- _exoff152076_ _xoff152072_))))
                    (declare (not safe))
                    (##structure
                     std/parser/base#location::t
                     _port152075_
                     _line152074_
                     _col152073_
                     __tmp290181
                     _xoff152072_)))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _start152047152063_
                 'std/parser/base#location::t))
              (let* ((_e152057152081_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152047152063_ '1)))
                     (_port152084_ _e152057152081_)
                     (_e152058152086_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152047152063_ '2)))
                     (_line152089_ _e152058152086_)
                     (_e152059152091_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152047152063_ '3)))
                     (_col152094_ _e152059152091_)
                     (_e152060152096_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152047152063_ '4)))
                     (_e152061152099_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _start152047152063_ '5)))
                     (_xoff152102_ _e152061152099_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _end152048152065_
                       'std/parser/base#location::t))
                    (let* ((_e152052152104_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152048152065_ '1)))
                           (_e152053152107_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152048152065_ '2)))
                           (_e152054152110_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152048152065_ '3)))
                           (_e152055152113_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152048152065_ '4)))
                           (_e152056152116_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _end152048152065_ '5)))
                           (_exoff152119_ _e152056152116_))
                      (_K152051152078_
                       _xoff152102_
                       _col152094_
                       _line152089_
                       _port152084_
                       _exoff152119_))
                    (_E152050152069_)))
              (_E152050152069_)))))))
