(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/parser/grammar-reader#read-module-body
    (lambda (_port164038_)
      (let _lp164040_ ((_body164042_ '()))
        (let ((_next164044_ (read-syntax _port164038_)))
          (if (eof-object? _next164044_)
              (gx#raise-syntax-error
               '#f
               '"Bad syntax; no parser or lexer definitions"
               (std/parser/grammar-reader#read-error-token _port164038_))
              (if (or (eq? (gx#stx-e _next164044_) '%%parser)
                      (eq? (gx#stx-e _next164044_) '%%lexer))
                  (std/parser/grammar-reader#read-module-section
                   _port164038_
                   _body164042_
                   (let ((__tmp300704 (gx#stx-e _next164044_)))
                     (declare (not safe))
                     (##structure
                      std/parser/base#token::t
                      '$$
                      __tmp300704
                      '#f)))
                  (_lp164040_ (cons _next164044_ _body164042_))))))))
  (define std/parser/grammar-reader#read-error-token
    (lambda (_port164033_)
      (let ((_name164035_
             (let () (declare (not safe)) (##port-name _port164033_)))
            (_loc164036_ (std/parser/stream#port-location _port164033_)))
        (let ((__tmp300706 (cons 'read-module-body (cons _name164035_ '())))
              (__tmp300705
               (std/parser/base#location->source-location _loc164036_)))
          (declare (not safe))
          (##structure AST::t __tmp300706 __tmp300705)))))
  (define std/parser/grammar-reader#read-module-section
    (lambda (_port164027_ _body164028_ _tok164029_)
      (let ((_e164031_
             (##direct-structure-ref
              _tok164029_
              '2
              std/parser/base#token::t
              '#f)))
        (if (eof-object? _e164031_)
            (reverse _body164028_)
            (if (eq? _e164031_ '%%parser)
                (std/parser/grammar-reader#read-parser-section
                 _port164027_
                 _body164028_)
                (if (eq? _e164031_ '%%lexer)
                    (std/parser/grammar-reader#read-lexer-section
                     _port164027_
                     _body164028_)
                    (gx#raise-syntax-error
                     '#f
                     '"Bad syntax; unexpected token"
                     (std/parser/base#token->syntax _tok164029_))))))))
  (define std/parser/grammar-reader#read-parser-section
    (lambda (_port164024_ _body164025_)
      (std/parser/grammar-reader#read-%%-section
       _port164024_
       _body164025_
       'defparser
       std/parser/grammar-reader#read-parser-body)))
  (define std/parser/grammar-reader#read-lexer-section
    (lambda (_port164021_ _body164022_)
      (std/parser/grammar-reader#read-%%-section
       _port164021_
       _body164022_
       'deflexer
       std/parser/grammar-reader#read-lexer-body)))
  (define std/parser/grammar-reader#read-%%-section
    (lambda (_port163807_ _body163808_ _defmacro163809_ _read-body-e163810_)
      (letrec ((_raise-e163812_
                (lambda (_exn164014_)
                  (if (let ()
                        (declare (not safe))
                        (##structure-instance-of?
                         _exn164014_
                         'std/parser/base#parse-error::t))
                      (apply gx#raise-syntax-error
                             '#f
                             (string-append
                              '"Bad syntax; parse error: "
                              (let ((_$e164016_ (error-trace _exn164014_)))
                                (if _$e164016_
                                    ((lambda (_where164019_)
                                       (string-append
                                        (symbol->string _where164019_)
                                        '" :"))
                                     _$e164016_)
                                    '""))
                              (error-message _exn164014_))
                             (map std/parser/base#token->syntax
                                  (error-irritants _exn164014_)))
                      (raise _exn164014_)))))
        (let ((_g300707_
               (std/parser/grammar-reader#read-section-head _port163807_)))
          (begin
            (let ((_g300708_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g300707_)
                         (##vector-length _g300707_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g300708_ 2)))
                  (error "Context expects 2 values" _g300708_)))
            (let ((_macro-id163814_
                   (let () (declare (not safe)) (##vector-ref _g300707_ 0)))
                  (_opts163815_
                   (let () (declare (not safe)) (##vector-ref _g300707_ 1))))
              (let ((_g300709_
                     (with-exception-catcher
                      _raise-e163812_
                      (lambda () (_read-body-e163810_ _port163807_)))))
                (begin
                  (let ((_g300710_
                         (let ()
                           (declare (not safe))
                           (if (##values? _g300709_)
                               (##vector-length _g300709_)
                               1))))
                    (if (not (let () (declare (not safe)) (##fx= _g300710_ 2)))
                        (error "Context expects 2 values" _g300710_)))
                  (let ((_rules163818_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _g300709_ 0)))
                        (_end163819_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _g300709_ 1))))
                    (let* ((_g163821163828_
                            (lambda (_g163822163825_)
                              (gx#raise-syntax-error
                               '#f
                               '"Bad syntax"
                               _g163822163825_)))
                           (_g163820164011_
                            (lambda (_g163822163831_)
                              ((lambda (_L163833_)
                                 (let ()
                                   (let* ((_g163845163852_
                                           (lambda (_g163846163849_)
                                             (gx#raise-syntax-error
                                              '#f
                                              '"Bad syntax"
                                              _g163846163849_)))
                                          (_g163844164008_
                                           (lambda (_g163846163855_)
                                             ((lambda (_L163857_)
                                                (let ()
                                                  (let* ((_g163867163883_
                                                          (lambda (_g163868163880_)
                                                            (gx#raise-syntax-error
                                                             '#f
                                                             '"Bad syntax"
                                                             _g163868163880_)))
                                                         (_g163866164005_
                                                          (lambda (_g163868163886_)
                                                            (if (gx#stx-pair/null?
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _g163868163886_)
                        (let ((_g300711_
                               (gx#syntax-split-splice _g163868163886_ '0)))
                          (begin
                            (let ((_g300712_
                                   (let ()
                                     (declare (not safe))
                                     (if (##values? _g300711_)
                                         (##vector-length _g300711_)
                                         1))))
                              (if (not (let ()
                                         (declare (not safe))
                                         (##fx= _g300712_ 2)))
                                  (error "Context expects 2 values"
                                         _g300712_)))
                            (let ((_target163870163888_
                                   (let ()
                                     (declare (not safe))
                                     (##vector-ref _g300711_ 0)))
                                  (_tl163872163890_
                                   (let ()
                                     (declare (not safe))
                                     (##vector-ref _g300711_ 1))))
                              (if (gx#stx-null? _tl163872163890_)
                                  (letrec ((_loop163873163893_
                                            (lambda (_hd163871163896_
                                                     _macro-opt163877163898_)
                                              (if (gx#stx-pair?
                                                   _hd163871163896_)
                                                  (let ((_e163874163901_
                                                         (gx#syntax-e
                                                          _hd163871163896_)))
                                                    (let ((_lp-hd163875163904_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##car _e163874163901_)))
                                                          (_lp-tl163876163906_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##cdr _e163874163901_))))
                                                      (_loop163873163893_
                                                       _lp-tl163876163906_
                                                       (cons _lp-hd163875163904_
                                                             _macro-opt163877163898_))))
                                                  (let ((_macro-opt163878163909_
                                                         (reverse _macro-opt163877163898_)))
                                                    ((lambda (_L163912_)
                                                       (let ()
                                                         (let* ((_g163926163942_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (lambda (_g163927163939_)
                           (gx#raise-syntax-error
                            '#f
                            '"Bad syntax"
                            _g163927163939_)))
                        (_g163925164002_
                         (lambda (_g163927163945_)
                           (if (gx#stx-pair/null? _g163927163945_)
                               (let ((_g300713_
                                      (gx#syntax-split-splice
                                       _g163927163945_
                                       '0)))
                                 (begin
                                   (let ((_g300714_
                                          (let ()
                                            (declare (not safe))
                                            (if (##values? _g300713_)
                                                (##vector-length _g300713_)
                                                1))))
                                     (if (not (let ()
                                                (declare (not safe))
                                                (##fx= _g300714_ 2)))
                                         (error "Context expects 2 values"
                                                _g300714_)))
                                   (let ((_target163929163947_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g300713_ 0)))
                                         (_tl163931163949_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g300713_ 1))))
                                     (if (gx#stx-null? _tl163931163949_)
                                         (letrec ((_loop163932163952_
                                                   (lambda (_hd163930163955_
                                                            _rule163936163957_)
                                                     (if (gx#stx-pair?
                                                          _hd163930163955_)
                                                         (let ((_e163933163960_
                                                                (gx#syntax-e
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _hd163930163955_)))
                   (let ((_lp-hd163934163963_
                          (let ()
                            (declare (not safe))
                            (##car _e163933163960_)))
                         (_lp-tl163935163965_
                          (let ()
                            (declare (not safe))
                            (##cdr _e163933163960_))))
                     (_loop163932163952_
                      _lp-tl163935163965_
                      (cons _lp-hd163934163963_ _rule163936163957_))))
                 (let ((_rule163937163968_ (reverse _rule163936163957_)))
                   ((lambda (_L163971_)
                      (let ()
                        (let ()
                          (let ((_defn164000_
                                 (gx#stx-wrap-source
                                  (cons _L163833_
                                        (cons _L163857_
                                              (foldr1 (lambda (_g163985163990_
                                                               _g163986163992_)
                                                        (cons _g163985163990_
                                                              _g163986163992_))
                                                      (foldr1 (lambda (_g163987163995_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               _g163988163997_)
                        (cons _g163987163995_ _g163988163997_))
                      '()
                      _L163971_)
              _L163912_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                  (gx#stx-source _L163857_))))
                            (std/parser/grammar-reader#read-module-section
                             _port163807_
                             (cons _defn164000_ _body163808_)
                             _end163819_)))))
                    _rule163937163968_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           (_loop163932163952_
                                            _target163929163947_
                                            '()))
                                         (_g163926163942_ _g163927163945_)))))
                               (_g163926163942_ _g163927163945_)))))
                   (_g163925164002_ _rules163818_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     _macro-opt163878163909_))))))
                                    (_loop163873163893_
                                     _target163870163888_
                                     '()))
                                  (_g163867163883_ _g163868163886_)))))
                        (_g163867163883_ _g163868163886_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_g163866164005_
                                                     _opts163815_))))
                                              _g163846163855_))))
                                     (_g163844164008_ _macro-id163814_))))
                               _g163822163831_))))
                      (_g163820164011_ _defmacro163809_)))))))))))
  (define std/parser/grammar-reader#read-section-head
    (lambda (_port163787_)
      (letrec ((_read-id163789_
                (lambda ()
                  (let ((_next163800_ (peek-char _port163787_)))
                    (if (or (eof-object? _next163800_)
                            (memq _next163800_ '(#\newline #\# #\;)))
                        (gx#raise-syntax-error
                         '#f
                         '"Bad syntax; missing section id"
                         (std/parser/grammar-reader#read-error-token
                          _port163787_)
                         _next163800_)
                        (if (char-whitespace? _next163800_)
                            (begin (read-char _port163787_) (_read-id163789_))
                            (let ((_id163805_ (read-syntax _port163787_)))
                              (if (gx#identifier? _id163805_)
                                  '#!void
                                  (gx#raise-syntax-error
                                   '#f
                                   '"Bad syntax; expected identifier"
                                   _id163805_))
                              (_read-opts163790_ _id163805_ '())))))))
               (_read-opts163790_
                (lambda (_id163792_ _opts163793_)
                  (let ((_next163795_ (peek-char _port163787_)))
                    (if (eof-object? _next163795_)
                        (gx#raise-syntax-error
                         '#f
                         '"Bad syntax; premature end of input"
                         (std/parser/grammar-reader#read-error-token
                          _port163787_))
                        (if (eq? '#\newline _next163795_)
                            (begin
                              (read-char _port163787_)
                              (values _id163792_ (reverse _opts163793_)))
                            (if (eq? _next163795_ '#\;)
                                (begin
                                  (read-line _port163787_)
                                  (values _id163792_ (reverse _opts163793_)))
                                (if (eq? _next163795_ '#\#)
                                    (gx#raise-syntax-error
                                     '#f
                                     '"Bad syntax; unexpected character"
                                     (std/parser/grammar-reader#read-error-token
                                      _port163787_)
                                     _next163795_)
                                    (if (char-whitespace? _next163795_)
                                        (begin
                                          (read-char _port163787_)
                                          (_read-opts163790_
                                           _id163792_
                                           _opts163793_))
                                        (let ((_opt163797_
                                               (read-syntax _port163787_)))
                                          (_read-opts163790_
                                           _id163792_
                                           (cons _opt163797_
                                                 _opts163793_))))))))))))
        (_read-id163789_))))
  (define std/parser/grammar-reader#raise-unexpected-token
    (lambda (_tok163785_)
      (gx#raise-syntax-error
       '#f
       '"Bad syntax; unexpected token"
       (std/parser/base#token->syntax _tok163785_))))
  (define std/parser/grammar-reader#read-parser-body
    (lambda (_port163627_)
      (letrec ((_locat-delta*163629_
                (lambda (_start163782_ _end163783_)
                  (std/parser/base#location->source-location
                   (std/parser/base#location-delta*
                    (##direct-structure-ref
                     _start163782_
                     '3
                     std/parser/base#token::t
                     '#f)
                    (##direct-structure-ref
                     _end163783_
                     '3
                     std/parser/base#token::t
                     '#f)))))
               (_make-rule163630_
                (lambda (_rule-id163777_
                         _prods163778_
                         _start163779_
                         _end163780_)
                  (let ((__tmp300716
                         (cons _rule-id163777_ (reverse _prods163778_)))
                        (__tmp300715
                         (_locat-delta*163629_ _start163779_ _end163780_)))
                    (declare (not safe))
                    (##structure AST::t __tmp300716 __tmp300715))))
               (_parse-rule163631_
                (lambda (_ts163710_ _K163711_ _E163712_)
                  (let* ((_rule163714_
                          (std/parser/grammar-reader#parse-rule-head__0
                           _ts163710_))
                         (_$e163716_
                          (##direct-structure-ref
                           _rule163714_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? 'Rule _$e163716_)
                        (let* ((_g163719163733_
                                (lambda (_g163720163730_)
                                  (gx#raise-syntax-error
                                   '#f
                                   '"Bad syntax"
                                   _g163720163730_)))
                               (_g163718163774_
                                (lambda (_g163720163736_)
                                  (if (gx#stx-pair? _g163720163736_)
                                      (let ((_e163723163738_
                                             (gx#syntax-e _g163720163736_)))
                                        (let ((_hd163724163741_
                                               (let ()
                                                 (declare (not safe))
                                                 (##car _e163723163738_)))
                                              (_tl163725163743_
                                               (let ()
                                                 (declare (not safe))
                                                 (##cdr _e163723163738_))))
                                          (if (gx#stx-pair? _tl163725163743_)
                                              (let ((_e163726163746_
                                                     (gx#syntax-e
                                                      _tl163725163743_)))
                                                (let ((_hd163727163749_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _e163726163746_)))
                                                      (_tl163728163751_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _e163726163746_))))
                                                  (if (gx#stx-null?
                                                       _tl163728163751_)
                                                      ((lambda (_L163754_
                                                                _L163755_)
                                                         (let ()
                                                           (_parse-rule-k163632_
                                                            _ts163710_
                                                            _rule163714_
                                                            _L163755_
                                                            _L163754_
                                                            '()
                                                            _K163711_
                                                            _E163712_)))
                                                       _hd163727163749_
                                                       _hd163724163741_)
                                                      (_g163719163733_
                                                       _g163720163736_))))
                                              (_g163719163733_
                                               _g163720163736_))))
                                      (_g163719163733_ _g163720163736_)))))
                          (_g163718163774_
                           (##direct-structure-ref
                            _rule163714_
                            '2
                            std/parser/base#token::t
                            '#f)))
                        (_E163712_ _ts163710_ _rule163714_ '#f)))))
               (_parse-rule-k163632_
                (lambda (_ts163694_
                         _start163695_
                         _rule-id163696_
                         _head163697_
                         _prods163698_
                         _K163699_
                         _E163700_)
                  (let* ((_next163702_
                          (std/parser/lexer#token-stream-next _ts163694_))
                         (_$e163704_
                          (##direct-structure-ref
                           _next163702_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? '$$ _$e163704_)
                        (let ((_$e163707_
                               (##direct-structure-ref
                                _next163702_
                                '2
                                std/parser/base#token::t
                                '#f)))
                          (if (eq? 'ACTION _$e163707_)
                              (_parse-rule-action163633_
                               _ts163694_
                               _start163695_
                               _rule-id163696_
                               _head163697_
                               _prods163698_
                               _K163699_
                               _E163700_)
                              (if (eq? 'ALTRULE _$e163707_)
                                  (_parse-rule-altrule163634_
                                   _ts163694_
                                   _start163695_
                                   _rule-id163696_
                                   (cons _head163697_ _prods163698_)
                                   _K163699_
                                   _E163700_)
                                  (if (eq? 'ENDRULE _$e163707_)
                                      (_K163699_
                                       _ts163694_
                                       (_make-rule163630_
                                        _rule-id163696_
                                        (cons _head163697_ _prods163698_)
                                        _start163695_
                                        _next163702_))
                                      (_E163700_
                                       _ts163694_
                                       _next163702_
                                       (_make-rule163630_
                                        _rule-id163696_
                                        (cons _head163697_ _prods163698_)
                                        _start163695_
                                        _next163702_))))))
                        (std/parser/grammar-reader#raise-unexpected-token
                         _next163702_)))))
               (_parse-rule-action163633_
                (lambda (_ts163673_
                         _start163674_
                         _rule-id163675_
                         _head163676_
                         _prods163677_
                         _K163678_
                         _E163679_)
                  (let ((_action163681_ (read-syntax _port163627_)))
                    (if (eof-object? _action163681_)
                        (gx#raise-syntax-error
                         '#f
                         '"Bad syntax; unexpected end of input"
                         _rule-id163675_)
                        (let* ((_ts163683_
                                (std/parser/grammar-reader#lex-parser
                                 _port163627_))
                               (_next163685_
                                (std/parser/lexer#token-stream-next
                                 _ts163683_)))
                          (let ((_$e163688_
                                 (##direct-structure-ref
                                  _next163685_
                                  '1
                                  std/parser/base#token::t
                                  '#f)))
                            (if (eq? '$$ _$e163688_)
                                (let ((_$e163691_
                                       (##direct-structure-ref
                                        _next163685_
                                        '2
                                        std/parser/base#token::t
                                        '#f)))
                                  (if (eq? 'ACTION _$e163691_)
                                      (std/parser/grammar-reader#raise-unexpected-token
                                       _next163685_)
                                      (if (eq? 'ALTRULE _$e163691_)
                                          (_parse-rule-altrule163634_
                                           _ts163683_
                                           _start163674_
                                           _rule-id163675_
                                           (cons _action163681_
                                                 (cons '=>
                                                       (cons _head163676_
                                                             _prods163677_)))
                                           _K163678_
                                           _E163679_)
                                          (if (eq? 'ENDRULE _$e163691_)
                                              (_K163678_
                                               _ts163683_
                                               (_make-rule163630_
                                                _rule-id163675_
                                                (cons _action163681_
                                                      (cons '=>
                                                            (cons _head163676_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _prods163677_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                _start163674_
                                                _next163685_))
                                              (_E163679_
                                               _ts163683_
                                               _next163685_
                                               (_make-rule163630_
                                                _rule-id163675_
                                                (cons _action163681_
                                                      (cons '=>
                                                            (cons _head163676_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _prods163677_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                _start163674_
                                                _next163685_))))))
                                (std/parser/grammar-reader#raise-unexpected-token
                                 _next163685_))))))))
               (_parse-rule-altrule163634_
                (lambda (_ts163650_
                         _start163651_
                         _rule-id163652_
                         _prods163653_
                         _K163654_
                         _E163655_)
                  (let* ((_prod163657_
                          (std/parser/grammar-reader#parse-rule-prod__0
                           _ts163650_))
                         (_$e163659_
                          (##direct-structure-ref
                           _prod163657_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? 'Prod _$e163659_)
                        (let* ((_prod163662_
                                (##direct-structure-ref
                                 _prod163657_
                                 '2
                                 std/parser/base#token::t
                                 '#f))
                               (_next163664_
                                (std/parser/lexer#token-stream-next
                                 _ts163650_)))
                          (let ((_$e163667_
                                 (##direct-structure-ref
                                  _next163664_
                                  '1
                                  std/parser/base#token::t
                                  '#f)))
                            (if (eq? '$$ _$e163667_)
                                (let ((_$e163670_
                                       (##direct-structure-ref
                                        _next163664_
                                        '2
                                        std/parser/base#token::t
                                        '#f)))
                                  (if (eq? 'ACTION _$e163670_)
                                      (_parse-rule-action163633_
                                       _ts163650_
                                       _start163651_
                                       _rule-id163652_
                                       _prod163662_
                                       _prods163653_
                                       _K163654_
                                       _E163655_)
                                      (if (eq? 'ALTRULE _$e163670_)
                                          (_parse-rule-altrule163634_
                                           _ts163650_
                                           _start163651_
                                           _rule-id163652_
                                           (cons _prod163662_ _prods163653_)
                                           _K163654_
                                           _E163655_)
                                          (if (eq? 'ENDRULE _$e163670_)
                                              (_K163654_
                                               _ts163650_
                                               (_make-rule163630_
                                                _rule-id163652_
                                                (cons _prod163662_
                                                      _prods163653_)
                                                _start163651_
                                                _next163664_))
                                              (_E163655_
                                               _ts163650_
                                               _next163664_
                                               (_make-rule163630_
                                                _rule-id163652_
                                                (cons _prod163662_
                                                      _prods163653_)
                                                _start163651_
                                                _next163664_))))))
                                (std/parser/grammar-reader#raise-unexpected-token
                                 _next163664_))))
                        (std/parser/grammar-reader#raise-unexpected-token
                         _prod163657_))))))
        (let _lp163636_ ((_ts163638_
                          (std/parser/grammar-reader#lex-parser _port163627_))
                         (_rules163639_ '()))
          (_parse-rule163631_
           _ts163638_
           (lambda (_ts163641_ _rule163642_)
             (_lp163636_ _ts163641_ (cons _rule163642_ _rules163639_)))
           (lambda (_ts163644_ _tok163645_ _rule163646_)
             (let ((_rules163648_
                    (if _rule163646_
                        (cons _rule163646_ _rules163639_)
                        _rules163639_)))
               (if (eq? (##direct-structure-ref
                         _tok163645_
                         '2
                         std/parser/base#token::t
                         '#f)
                        'ENDRULE)
                   (_lp163636_ _ts163644_ _rules163648_)
                   (values (reverse _rules163648_) _tok163645_)))))))))
  (define std/parser/grammar-reader#read-lexer-body
    (lambda (_port163575_)
      (letrec ((_make-rule163577_
                (lambda (_rx163623_ _action163624_ _end163625_)
                  (let ((__tmp300718
                         (cons (##direct-structure-ref
                                _rx163623_
                                '2
                                std/parser/base#token::t
                                '#f)
                               (cons _action163624_ '())))
                        (__tmp300717
                         (std/parser/base#location->source-location
                          (std/parser/base#location-delta
                           (##direct-structure-ref
                            _rx163623_
                            '3
                            std/parser/base#token::t
                            '#f)
                           _end163625_))))
                    (declare (not safe))
                    (##structure AST::t __tmp300718 __tmp300717))))
               (_parse-rule163578_
                (lambda (_ts163614_ _K163615_ _E163616_)
                  (let* ((_next163618_
                          (std/parser/lexer#token-stream-next _ts163614_))
                         (_$e163620_
                          (##direct-structure-ref
                           _next163618_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? 'RX _$e163620_)
                        (_parse-rule-k163579_
                         _ts163614_
                         _next163618_
                         _K163615_
                         _E163616_)
                        (_E163616_ _ts163614_ _next163618_)))))
               (_parse-rule-k163579_
                (lambda (_ts163592_ _rx163593_ _K163594_ _E163595_)
                  (let* ((_next163597_
                          (std/parser/lexer#token-stream-next _ts163592_))
                         (_$e163599_
                          (##direct-structure-ref
                           _next163597_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? '$$ _$e163599_)
                        (let ((_$e163602_
                               (##direct-structure-ref
                                _next163597_
                                '2
                                std/parser/base#token::t
                                '#f)))
                          (if (eq? 'ACTION _$e163602_)
                              (let ((_action163605_
                                     (read-syntax _port163575_)))
                                (if (eof-object? _action163605_)
                                    (gx#raise-syntax-error
                                     '#f
                                     '"Bad syntax; unexpected end of input"
                                     (std/parser/base#token->syntax
                                      _next163597_))
                                    (let* ((_ts163607_
                                            (std/parser/grammar-reader#lex-lexer
                                             _port163575_))
                                           (_end163609_
                                            (std/parser/lexer#token-stream-loc
                                             _ts163607_))
                                           (_rule163611_
                                            (_make-rule163577_
                                             _rx163593_
                                             _action163605_
                                             _end163609_)))
                                      (_K163594_ _ts163607_ _rule163611_))))
                              (std/parser/grammar-reader#raise-unexpected-token
                               _next163597_)))
                        (std/parser/grammar-reader#raise-unexpected-token
                         _next163597_))))))
        (let _lp163581_ ((_ts163583_
                          (std/parser/grammar-reader#lex-lexer _port163575_))
                         (_rules163584_ '()))
          (_parse-rule163578_
           _ts163583_
           (lambda (_ts163586_ _rule163587_)
             (_lp163581_ _ts163586_ (cons _rule163587_ _rules163584_)))
           (lambda (_ts163589_ _tok163590_)
             (if (eq? (##direct-structure-ref
                       _tok163590_
                       '2
                       std/parser/base#token::t
                       '#f)
                      'ENDRULE)
                 (_lp163581_ _ts163589_ _rules163584_)
                 (values (reverse _rules163584_) _tok163590_))))))))
  (define std/parser/grammar-reader#WS
    (std/parser/rlang#@charset '(#\space #\tab)))
  (define std/parser/grammar-reader#lex-parser::L
    (cons (std/parser/rlang#@cat__2
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\p))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\a))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\s))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\e))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r)))
          (cons (std/parser/rlang#@cat__2
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\l))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\x))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\r)))
                (cons (std/parser/rlang#@cat__1
                       (let ()
                         (declare (not safe))
                         (##structure std/parser/rlang#char::t '#\=))
                       (let ()
                         (declare (not safe))
                         (##structure std/parser/rlang#char::t '#\>)))
                      (cons (let ()
                              (declare (not safe))
                              (##structure std/parser/rlang#char::t '#\|))
                            (cons (std/parser/rlang#@cat__1
                                   (std/parser/rlang#@rep+
                                    (let ()
                                      (declare (not safe))
                                      (##structure
                                       std/parser/rlang#char::t
                                       '#\newline)))
                                   (std/parser/rlang#@rep+
                                    std/parser/grammar-reader#WS))
                                  (cons (std/parser/rlang#@rep+
                                         (let ()
                                           (declare (not safe))
                                           (##structure
                                            std/parser/rlang#char::t
                                            '#\newline)))
                                        (cons (std/parser/rlang#@rep+
                                               std/parser/grammar-reader#WS)
                                              (cons (std/parser/rlang#@cat__1
                                                     (let ()
                                                       (declare (not safe))
                                                       (##structure
                                                        std/parser/rlang#char::t
                                                        '#\;))
                                                     (std/parser/rlang#@rep+
                                                      (std/parser/rlang#@negset
                                                       '(#\newline))))
                                                    (cons (std/parser/rlang#@cat__1
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##structure
                                                              std/parser/rlang#char::t
                                                              '#\<))
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##structure
                                                              std/parser/rlang#char::t
                                                              '#\-)))
                                                          (cons (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##structure std/parser/rlang#char::t '#\())
                        (cons (let ()
                                (declare (not safe))
                                (##structure std/parser/rlang#char::t '#\)))
                              (cons (std/parser/rlang#@cat__2
                                     (let ()
                                       (declare (not safe))
                                       (##structure
                                        std/parser/rlang#char::t
                                        '#\'))
                                     (std/parser/rlang#@rep*
                                      (std/parser/rlang#@negset '(#\')))
                                     (let ()
                                       (declare (not safe))
                                       (##structure
                                        std/parser/rlang#char::t
                                        '#\')))
                                    (cons (std/parser/rlang#@cat__2
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/parser/rlang#char::t
                                              '#\"))
                                           (std/parser/rlang#@rep*
                                            (std/parser/rlang#@alt__1
                                             (let ()
                                               (declare (not safe))
                                               (##structure
                                                std/parser/rlang#char::t
                                                '#\"))
                                             (std/parser/rlang#@negset
                                              '(#\"))))
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/parser/rlang#char::t
                                              '#\")))
                                          (cons (let ()
                                                  (declare (not safe))
                                                  (##structure
                                                   std/parser/rlang#char::t
                                                   '#\*))
                                                (cons (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/parser/rlang#char::t
                                                         '#\+))
                                                      (cons (let ()
                                                              (declare
                                                                (not safe))
                                                              (##structure
                                                               std/parser/rlang#char::t
                                                               '#\?))
                                                            (cons (std/parser/rlang#@rep+
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (std/parser/rlang#@charset
                            '(#\-
                              #\+
                              #\*
                              #\/
                              #\=
                              #\?
                              #\<
                              #\>
                              #\~
                              #\!
                              #\@
                              #\$
                              #\%
                              #\^
                              #\&
                              #\:
                              #\_
                              #\a
                              #\b
                              #\c
                              #\d
                              #\e
                              #\f
                              #\g
                              #\h
                              #\i
                              #\j
                              #\k
                              #\l
                              #\m
                              #\n
                              #\o
                              #\p
                              #\q
                              #\r
                              #\s
                              #\t
                              #\u
                              #\v
                              #\w
                              #\x
                              #\y
                              #\z
                              #\A
                              #\B
                              #\C
                              #\D
                              #\E
                              #\F
                              #\G
                              #\H
                              #\I
                              #\J
                              #\K
                              #\L
                              #\M
                              #\N
                              #\O
                              #\P
                              #\Q
                              #\R
                              #\S
                              #\T
                              #\U
                              #\V
                              #\W
                              #\X
                              #\Y
                              #\Z
                              #\0
                              #\1
                              #\2
                              #\3
                              #\4
                              #\5
                              #\6
                              #\7
                              #\8
                              #\9)))
                          '()))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  (define std/parser/grammar-reader#lex-parser::R
    (cons (lambda (_@@163522_ _@loc163523_)
            (let ()
              (declare (not safe))
              (##structure
               std/parser/base#token::t
               '$$
               '%%parser
               _@loc163523_)))
          (cons (lambda (_@@163525_ _@loc163526_)
                  (let ()
                    (declare (not safe))
                    (##structure
                     std/parser/base#token::t
                     '$$
                     '%%lexer
                     _@loc163526_)))
                (cons (lambda (_@@163528_ _@loc163529_)
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/parser/base#token::t
                           '$$
                           'ACTION
                           _@loc163529_)))
                      (cons (lambda (_@@163531_ _@loc163532_)
                              (let ()
                                (declare (not safe))
                                (##structure
                                 std/parser/base#token::t
                                 '$$
                                 'ALTRULE
                                 _@loc163532_)))
                            (cons (lambda (_@@163534_ _@loc163536_)
                                    std/parser/lexer#$)
                                  (cons (lambda (_@@163539_ _@loc163540_)
                                          (let ()
                                            (declare (not safe))
                                            (##structure
                                             std/parser/base#token::t
                                             '$$
                                             'ENDRULE
                                             _@loc163540_)))
                                        (cons (lambda (_@@163542_ _@loc163543_)
                                                std/parser/lexer#$)
                                              (cons (lambda (_@@163545_
                                                             _@loc163546_)
                                                      std/parser/lexer#$)
                                                    (cons (lambda (_@@163548_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _@loc163549_)
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/parser/base#token::t
                       'PROD
                       '<-
                       _@loc163549_)))
                  (cons (lambda (_@@163551_ _@loc163552_)
                          (let ()
                            (declare (not safe))
                            (##structure
                             std/parser/base#token::t
                             'LPAREN
                             '|(|
                             _@loc163552_)))
                        (cons (lambda (_@@163554_ _@loc163555_)
                                (let ()
                                  (declare (not safe))
                                  (##structure
                                   std/parser/base#token::t
                                   'RPAREN
                                   '|)|
                                   _@loc163555_)))
                              (cons (lambda (_@@163557_ _@loc163558_)
                                      (let ((__tmp300719
                                             (std/parser/grammar-reader#string->token-symbol
                                              _@@163557_)))
                                        (declare (not safe))
                                        (##structure
                                         std/parser/base#token::t
                                         'EQ
                                         __tmp300719
                                         _@loc163558_)))
                                    (cons (lambda (_@@163560_ _@loc163561_)
                                            (let ((__tmp300720
                                                   (std/parser/grammar-reader#string->token-string
                                                    _@@163560_)))
                                              (declare (not safe))
                                              (##structure
                                               std/parser/base#token::t
                                               'EQUAL
                                               __tmp300720
                                               _@loc163561_)))
                                          (cons (lambda (_@@163563_
                                                         _@loc163564_)
                                                  (let ()
                                                    (declare (not safe))
                                                    (##structure
                                                     std/parser/base#token::t
                                                     'STAR
                                                     '*
                                                     _@loc163564_)))
                                                (cons (lambda (_@@163566_
                                                               _@loc163567_)
                                                        (let ()
                                                          (declare (not safe))
                                                          (##structure
                                                           std/parser/base#token::t
                                                           'PLUS
                                                           '+
                                                           _@loc163567_)))
                                                      (cons (lambda (_@@163569_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             _@loc163570_)
                      (let ()
                        (declare (not safe))
                        (##structure
                         std/parser/base#token::t
                         'MAYBE
                         '?
                         _@loc163570_)))
                    (cons (lambda (_@@163572_ _@loc163573_)
                            (let ((__tmp300721 (string->symbol _@@163572_)))
                              (declare (not safe))
                              (##structure
                               std/parser/base#token::t
                               'Ident
                               __tmp300721
                               _@loc163573_)))
                          '()))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  (define std/parser/grammar-reader#lex-parser
    (lambda (_input163519_)
      (std/parser/lexer#lex
       _input163519_
       std/parser/grammar-reader#lex-parser::L
       std/parser/grammar-reader#lex-parser::R)))
  (define std/parser/grammar-reader#parse-rule-head__%
    (lambda (_input163495_ _$lexer163497_ _wrap-e163499_)
      (std/parser/defparser#parser-parse
       'parse-rule-head
       (std/parser/defparser#parser-input-stream _input163495_ _$lexer163497_)
       std/parser/grammar-reader#Rule
       _wrap-e163499_)))
  (define std/parser/grammar-reader#parse-rule-head__0
    (lambda (_input163504_)
      (let* ((_$lexer163506_ std/parser/grammar-reader#lex-parser)
             (_wrap-e163508_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-head__%
         _input163504_
         _$lexer163506_
         _wrap-e163508_))))
  (define std/parser/grammar-reader#parse-rule-head__1
    (lambda (_input163510_ _$lexer163511_)
      (let ((_wrap-e163513_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-head__%
         _input163510_
         _$lexer163511_
         _wrap-e163513_))))
  (define std/parser/grammar-reader#parse-rule-head
    (lambda _g300723_
      (let ((_g300722_ (let () (declare (not safe)) (##length _g300723_))))
        (cond ((let () (declare (not safe)) (##fx= _g300722_ 1))
               (apply std/parser/grammar-reader#parse-rule-head__0 _g300723_))
              ((let () (declare (not safe)) (##fx= _g300722_ 2))
               (apply std/parser/grammar-reader#parse-rule-head__1 _g300723_))
              ((let () (declare (not safe)) (##fx= _g300722_ 3))
               (apply std/parser/grammar-reader#parse-rule-head__% _g300723_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/parser/grammar-reader#parse-rule-head
                _g300723_))))))
  (define std/parser/grammar-reader#Rule::1::app::cat::1
    (lambda (_ts163488_ _toks163489_ _wrap-e163490_ _K163491_ _E163492_)
      (std/parser/grammar-reader#Ident
       _ts163488_
       _toks163489_
       _wrap-e163490_
       _K163491_
       _E163492_)))
  (define std/parser/grammar-reader#Rule::1::app::cat::2
    (lambda (_ts163477_ _toks163478_ _wrap-e163479_ _K163480_ _E163481_)
      (let* ((_next163483_ (std/parser/lexer#token-stream-next _ts163477_))
             (_toks163485_ (cons _next163483_ _toks163478_)))
        (if (eq? (##direct-structure-ref
                  _next163483_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '<-)
            (_K163480_ _toks163485_ _next163483_)
            (_E163481_ _toks163485_)))))
  (define std/parser/grammar-reader#Rule::1::app::cat::3
    (lambda (_ts163471_ _toks163472_ _wrap-e163473_ _K163474_ _E163475_)
      (std/parser/grammar-reader#Prod
       _ts163471_
       _toks163472_
       _wrap-e163473_
       _K163474_
       _E163475_)))
  (define std/parser/grammar-reader#Rule::1::app
    (lambda (_ts163455_ _toks163456_ _wrap-e163457_ _K163458_ _E163459_)
      (std/parser/grammar-reader#Ident
       _ts163455_
       _toks163456_
       _wrap-e163457_
       (lambda (_toks163461_ _$1162812163462_)
         (std/parser/grammar-reader#Rule::1::app::cat::2
          _ts163455_
          _toks163461_
          _wrap-e163457_
          (lambda (_toks163465_ _g300724_)
            (std/parser/grammar-reader#Prod
             _ts163455_
             _toks163465_
             _wrap-e163457_
             (lambda (_toks163467_ _$2162813163468_)
               (_K163458_ _toks163467_ _$1162812163462_ _$2162813163468_))
             _E163459_))
          _E163459_))
       _E163459_)))
  (define std/parser/grammar-reader#Rule::1
    (lambda (_ts163431_ _toks163432_ _wrap-e163433_ _K163434_ _E163435_)
      (let ((_start163437_ (std/parser/lexer#token-stream-loc _ts163431_)))
        (std/parser/grammar-reader#Rule::1::app
         _ts163431_
         _toks163432_
         _wrap-e163433_
         (lambda (_toks163440_ _$1162814163441_ _$2162815163443_)
           (let* ((_end163446_ (std/parser/lexer#token-stream-loc _ts163431_))
                  (_@loc163449_
                   (std/parser/base#location-delta*
                    _start163437_
                    _end163446_)))
             (_K163434_
              _toks163440_
              (let ((__tmp300725
                     (_wrap-e163433_
                      ((lambda (_$1163452_ _$2163453_)
                         (cons _$1163452_ (cons _$2163453_ '())))
                       (##direct-structure-ref
                        _$1162814163441_
                        '2
                        std/parser/base#token::t
                        '#f)
                       (##direct-structure-ref
                        _$2162815163443_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163449_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Rule
                 __tmp300725
                 _@loc163449_)))))
         _E163435_))))
  (define std/parser/grammar-reader#Rule::2
    (lambda (_ts163419_ _toks163420_ _wrap-e163421_ _K163422_ _E163423_)
      (let* ((_next163425_ (std/parser/lexer#token-stream-next _ts163419_))
             (_toks163428_ (cons _next163425_ _toks163420_)))
        (if (std/parser/lexer#$$? _next163425_)
            (_K163422_ _toks163428_ _next163425_)
            (_E163423_ _toks163428_)))))
  (define std/parser/grammar-reader#Rule
    (lambda (_ts163405_ _toks163407_ _wrap-e163409_ _K163411_ _E163413_)
      (std/parser/grammar-reader#Rule::1
       _ts163405_
       _toks163407_
       _wrap-e163409_
       _K163411_
       (lambda (_xtoks163416_)
         (std/parser/defparser#parser-rewind
          _ts163405_
          _xtoks163416_
          _toks163407_)
         (std/parser/grammar-reader#Rule::2
          _ts163405_
          _toks163407_
          _wrap-e163409_
          _K163411_
          _E163413_)))))
  (define std/parser/grammar-reader#parse-rule-prod__%
    (lambda (_input163381_ _$lexer163383_ _wrap-e163385_)
      (std/parser/defparser#parser-parse
       'parse-rule-prod
       (std/parser/defparser#parser-input-stream _input163381_ _$lexer163383_)
       std/parser/grammar-reader#Prod
       _wrap-e163385_)))
  (define std/parser/grammar-reader#parse-rule-prod__0
    (lambda (_input163390_)
      (let* ((_$lexer163392_ std/parser/grammar-reader#lex-parser)
             (_wrap-e163394_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-prod__%
         _input163390_
         _$lexer163392_
         _wrap-e163394_))))
  (define std/parser/grammar-reader#parse-rule-prod__1
    (lambda (_input163396_ _$lexer163397_)
      (let ((_wrap-e163399_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-prod__%
         _input163396_
         _$lexer163397_
         _wrap-e163399_))))
  (define std/parser/grammar-reader#parse-rule-prod
    (lambda _g300727_
      (let ((_g300726_ (let () (declare (not safe)) (##length _g300727_))))
        (cond ((let () (declare (not safe)) (##fx= _g300726_ 1))
               (apply std/parser/grammar-reader#parse-rule-prod__0 _g300727_))
              ((let () (declare (not safe)) (##fx= _g300726_ 2))
               (apply std/parser/grammar-reader#parse-rule-prod__1 _g300727_))
              ((let () (declare (not safe)) (##fx= _g300726_ 3))
               (apply std/parser/grammar-reader#parse-rule-prod__% _g300727_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/parser/grammar-reader#parse-rule-prod
                _g300727_))))))
  (define std/parser/grammar-reader#Prod::app::rep*
    (lambda (_ts163374_ _toks163375_ _wrap-e163376_ _K163377_ _E163378_)
      (std/parser/grammar-reader#Pattern
       _ts163374_
       _toks163375_
       _wrap-e163376_
       _K163377_
       _E163378_)))
  (define std/parser/grammar-reader#Prod::app
    (lambda (_ts163352_ _toks163353_ _wrap-e163354_ _K163355_ _E163356_)
      (std/parser/grammar-reader#Pattern
       _ts163352_
       _toks163353_
       _wrap-e163354_
       (lambda (_toks163358_ _g162817163359_)
         (let _lp163362_ ((_toks163365_ _toks163358_)
                          (_$1162816163366_ (cons _g162817163359_ '())))
           (std/parser/grammar-reader#Pattern
            _ts163352_
            _toks163365_
            _wrap-e163354_
            (lambda (_toks163369_ _g162817163370_)
              (_lp163362_
               _toks163369_
               (cons _g162817163370_ _$1162816163366_)))
            (lambda (_xtoks163372_)
              (std/parser/defparser#parser-rewind
               _ts163352_
               _xtoks163372_
               _toks163365_)
              (_K163355_ _toks163365_ (reverse _$1162816163366_))))))
       _E163356_)))
  (define std/parser/grammar-reader#Prod
    (lambda (_ts163330_ _toks163331_ _wrap-e163332_ _K163333_ _E163334_)
      (let ((_start163336_ (std/parser/lexer#token-stream-loc _ts163330_)))
        (std/parser/grammar-reader#Prod::app
         _ts163330_
         _toks163331_
         _wrap-e163332_
         (lambda (_toks163338_ _$1162818163339_)
           (let* ((_end163342_ (std/parser/lexer#token-stream-loc _ts163330_))
                  (_@loc163344_
                   (std/parser/base#location-delta*
                    _start163336_
                    _end163342_)))
             (_K163333_
              _toks163338_
              (let ((__tmp300728
                     (_wrap-e163332_
                      ((lambda (_$1163347_)
                         (std/parser/grammar-reader#simplify
                          (cons '@cat _$1163347_)))
                       ((lambda (_$x163349_)
                          (map std/parser/base#token-e _$x163349_))
                        _$1162818163339_))
                      _@loc163344_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Prod
                 __tmp300728
                 _@loc163344_)))))
         _E163334_))))
  (define std/parser/grammar-reader#Pattern::1::app::cat::1
    (lambda (_ts163324_ _toks163325_ _wrap-e163326_ _K163327_ _E163328_)
      (std/parser/grammar-reader#SimplePattern
       _ts163324_
       _toks163325_
       _wrap-e163326_
       _K163327_
       _E163328_)))
  (define std/parser/grammar-reader#Pattern::1::app::cat::2
    (lambda (_ts163313_ _toks163314_ _wrap-e163315_ _K163316_ _E163317_)
      (let* ((_next163319_ (std/parser/lexer#token-stream-next _ts163313_))
             (_toks163321_ (cons _next163319_ _toks163314_)))
        (if (eq? (##direct-structure-ref
                  _next163319_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '+)
            (_K163316_ _toks163321_ _next163319_)
            (_E163317_ _toks163321_)))))
  (define std/parser/grammar-reader#Pattern::1::app
    (lambda (_ts163301_ _toks163302_ _wrap-e163303_ _K163304_ _E163305_)
      (std/parser/grammar-reader#SimplePattern
       _ts163301_
       _toks163302_
       _wrap-e163303_
       (lambda (_toks163307_ _$1162819163308_)
         (std/parser/grammar-reader#Pattern::1::app::cat::2
          _ts163301_
          _toks163307_
          _wrap-e163303_
          (lambda (_toks163311_ _g300729_)
            (_K163304_ _toks163311_ _$1162819163308_))
          _E163305_))
       _E163305_)))
  (define std/parser/grammar-reader#Pattern::1
    (lambda (_ts163282_ _toks163283_ _wrap-e163284_ _K163285_ _E163286_)
      (let ((_start163288_ (std/parser/lexer#token-stream-loc _ts163282_)))
        (std/parser/grammar-reader#Pattern::1::app
         _ts163282_
         _toks163283_
         _wrap-e163284_
         (lambda (_toks163290_ _$1162820163291_)
           (let* ((_end163294_ (std/parser/lexer#token-stream-loc _ts163282_))
                  (_@loc163296_
                   (std/parser/base#location-delta*
                    _start163288_
                    _end163294_)))
             (_K163285_
              _toks163290_
              (let ((__tmp300730
                     (_wrap-e163284_
                      ((lambda (_$1163299_)
                         (cons '@rep+ (cons _$1163299_ '())))
                       (##direct-structure-ref
                        _$1162820163291_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163296_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300730
                 _@loc163296_)))))
         _E163286_))))
  (define std/parser/grammar-reader#Pattern::2::app::cat::1
    (lambda (_ts163276_ _toks163277_ _wrap-e163278_ _K163279_ _E163280_)
      (std/parser/grammar-reader#SimplePattern
       _ts163276_
       _toks163277_
       _wrap-e163278_
       _K163279_
       _E163280_)))
  (define std/parser/grammar-reader#Pattern::2::app::cat::2
    (lambda (_ts163265_ _toks163266_ _wrap-e163267_ _K163268_ _E163269_)
      (let* ((_next163271_ (std/parser/lexer#token-stream-next _ts163265_))
             (_toks163273_ (cons _next163271_ _toks163266_)))
        (if (eq? (##direct-structure-ref
                  _next163271_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '*)
            (_K163268_ _toks163273_ _next163271_)
            (_E163269_ _toks163273_)))))
  (define std/parser/grammar-reader#Pattern::2::app
    (lambda (_ts163253_ _toks163254_ _wrap-e163255_ _K163256_ _E163257_)
      (std/parser/grammar-reader#SimplePattern
       _ts163253_
       _toks163254_
       _wrap-e163255_
       (lambda (_toks163259_ _$1162821163260_)
         (std/parser/grammar-reader#Pattern::2::app::cat::2
          _ts163253_
          _toks163259_
          _wrap-e163255_
          (lambda (_toks163263_ _g300731_)
            (_K163256_ _toks163263_ _$1162821163260_))
          _E163257_))
       _E163257_)))
  (define std/parser/grammar-reader#Pattern::2
    (lambda (_ts163234_ _toks163235_ _wrap-e163236_ _K163237_ _E163238_)
      (let ((_start163240_ (std/parser/lexer#token-stream-loc _ts163234_)))
        (std/parser/grammar-reader#Pattern::2::app
         _ts163234_
         _toks163235_
         _wrap-e163236_
         (lambda (_toks163242_ _$1162822163243_)
           (let* ((_end163246_ (std/parser/lexer#token-stream-loc _ts163234_))
                  (_@loc163248_
                   (std/parser/base#location-delta*
                    _start163240_
                    _end163246_)))
             (_K163237_
              _toks163242_
              (let ((__tmp300732
                     (_wrap-e163236_
                      ((lambda (_$1163251_)
                         (cons '@rep* (cons _$1163251_ '())))
                       (##direct-structure-ref
                        _$1162822163243_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163248_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300732
                 _@loc163248_)))))
         _E163238_))))
  (define std/parser/grammar-reader#Pattern::3::app::cat::1
    (lambda (_ts163228_ _toks163229_ _wrap-e163230_ _K163231_ _E163232_)
      (std/parser/grammar-reader#SimplePattern
       _ts163228_
       _toks163229_
       _wrap-e163230_
       _K163231_
       _E163232_)))
  (define std/parser/grammar-reader#Pattern::3::app::cat::2
    (lambda (_ts163217_ _toks163218_ _wrap-e163219_ _K163220_ _E163221_)
      (let* ((_next163223_ (std/parser/lexer#token-stream-next _ts163217_))
             (_toks163225_ (cons _next163223_ _toks163218_)))
        (if (eq? (##direct-structure-ref
                  _next163223_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '?)
            (_K163220_ _toks163225_ _next163223_)
            (_E163221_ _toks163225_)))))
  (define std/parser/grammar-reader#Pattern::3::app
    (lambda (_ts163205_ _toks163206_ _wrap-e163207_ _K163208_ _E163209_)
      (std/parser/grammar-reader#SimplePattern
       _ts163205_
       _toks163206_
       _wrap-e163207_
       (lambda (_toks163211_ _$1162823163212_)
         (std/parser/grammar-reader#Pattern::3::app::cat::2
          _ts163205_
          _toks163211_
          _wrap-e163207_
          (lambda (_toks163215_ _g300733_)
            (_K163208_ _toks163215_ _$1162823163212_))
          _E163209_))
       _E163209_)))
  (define std/parser/grammar-reader#Pattern::3
    (lambda (_ts163186_ _toks163187_ _wrap-e163188_ _K163189_ _E163190_)
      (let ((_start163192_ (std/parser/lexer#token-stream-loc _ts163186_)))
        (std/parser/grammar-reader#Pattern::3::app
         _ts163186_
         _toks163187_
         _wrap-e163188_
         (lambda (_toks163194_ _$1162824163195_)
           (let* ((_end163198_ (std/parser/lexer#token-stream-loc _ts163186_))
                  (_@loc163200_
                   (std/parser/base#location-delta*
                    _start163192_
                    _end163198_)))
             (_K163189_
              _toks163194_
              (let ((__tmp300734
                     (_wrap-e163188_
                      ((lambda (_$1163203_)
                         (cons '@maybe (cons _$1163203_ '())))
                       (##direct-structure-ref
                        _$1162824163195_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163200_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300734
                 _@loc163200_)))))
         _E163190_))))
  (define std/parser/grammar-reader#Pattern::4::app
    (lambda (_ts163180_ _toks163181_ _wrap-e163182_ _K163183_ _E163184_)
      (std/parser/grammar-reader#SimplePattern
       _ts163180_
       _toks163181_
       _wrap-e163182_
       _K163183_
       _E163184_)))
  (define std/parser/grammar-reader#Pattern::4
    (lambda (_ts163161_ _toks163162_ _wrap-e163163_ _K163164_ _E163165_)
      (let ((_start163167_ (std/parser/lexer#token-stream-loc _ts163161_)))
        (std/parser/grammar-reader#SimplePattern
         _ts163161_
         _toks163162_
         _wrap-e163163_
         (lambda (_toks163169_ _$1162825163170_)
           (let* ((_end163173_ (std/parser/lexer#token-stream-loc _ts163161_))
                  (_@loc163175_
                   (std/parser/base#location-delta*
                    _start163167_
                    _end163173_)))
             (_K163164_
              _toks163169_
              (let ((__tmp300735
                     (_wrap-e163163_
                      ((lambda (_$1163178_) _$1163178_)
                       (##direct-structure-ref
                        _$1162825163170_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163175_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300735
                 _@loc163175_)))))
         _E163165_))))
  (define std/parser/grammar-reader#Pattern
    (lambda (_ts163149_ _toks163150_ _wrap-e163151_ _K163152_ _E163153_)
      (std/parser/grammar-reader#Pattern::1
       _ts163149_
       _toks163150_
       _wrap-e163151_
       _K163152_
       (lambda (_xtoks163155_)
         (std/parser/defparser#parser-rewind
          _ts163149_
          _xtoks163155_
          _toks163150_)
         (std/parser/grammar-reader#Pattern::2
          _ts163149_
          _toks163150_
          _wrap-e163151_
          _K163152_
          (lambda (_xtoks163157_)
            (std/parser/defparser#parser-rewind
             _ts163149_
             _xtoks163157_
             _toks163150_)
            (std/parser/grammar-reader#Pattern::3
             _ts163149_
             _toks163150_
             _wrap-e163151_
             _K163152_
             (lambda (_xtoks163159_)
               (std/parser/defparser#parser-rewind
                _ts163149_
                _xtoks163159_
                _toks163150_)
               (std/parser/grammar-reader#Pattern::4
                _ts163149_
                _toks163150_
                _wrap-e163151_
                _K163152_
                _E163153_)))))))))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::1
    (lambda (_ts163138_ _toks163139_ _wrap-e163140_ _K163141_ _E163142_)
      (let* ((_next163144_ (std/parser/lexer#token-stream-next _ts163138_))
             (_toks163146_ (cons _next163144_ _toks163139_)))
        (if (eq? (##direct-structure-ref
                  _next163144_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '|(|)
            (_K163141_ _toks163146_ _next163144_)
            (_E163142_ _toks163146_)))))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::2
    (lambda (_ts163132_ _toks163133_ _wrap-e163134_ _K163135_ _E163136_)
      (std/parser/grammar-reader#Ident
       _ts163132_
       _toks163133_
       _wrap-e163134_
       _K163135_
       _E163136_)))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::3
    (lambda (_ts163126_ _toks163127_ _wrap-e163128_ _K163129_ _E163130_)
      (std/parser/grammar-reader#Ident
       _ts163126_
       _toks163127_
       _wrap-e163128_
       _K163129_
       _E163130_)))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::4
    (lambda (_ts163115_ _toks163116_ _wrap-e163117_ _K163118_ _E163119_)
      (let* ((_next163121_ (std/parser/lexer#token-stream-next _ts163115_))
             (_toks163123_ (cons _next163121_ _toks163116_)))
        (if (eq? (##direct-structure-ref
                  _next163121_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '|)|)
            (_K163118_ _toks163123_ _next163121_)
            (_E163119_ _toks163123_)))))
  (define std/parser/grammar-reader#SimplePattern::1::app
    (lambda (_ts163097_ _toks163098_ _wrap-e163099_ _K163100_ _E163101_)
      (std/parser/grammar-reader#SimplePattern::1::app::cat::1
       _ts163097_
       _toks163098_
       _wrap-e163099_
       (lambda (_toks163103_ _g300736_)
         (std/parser/grammar-reader#Ident
          _ts163097_
          _toks163103_
          _wrap-e163099_
          (lambda (_toks163105_ _$1162826163106_)
            (std/parser/grammar-reader#Ident
             _ts163097_
             _toks163105_
             _wrap-e163099_
             (lambda (_toks163109_ _$2162827163110_)
               (std/parser/grammar-reader#SimplePattern::1::app::cat::4
                _ts163097_
                _toks163109_
                _wrap-e163099_
                (lambda (_toks163113_ _g300737_)
                  (_K163100_ _toks163113_ _$1162826163106_ _$2162827163110_))
                _E163101_))
             _E163101_))
          _E163101_))
       _E163101_)))
  (define std/parser/grammar-reader#SimplePattern::1
    (lambda (_ts163075_ _toks163076_ _wrap-e163077_ _K163078_ _E163079_)
      (let ((_start163081_ (std/parser/lexer#token-stream-loc _ts163075_)))
        (std/parser/grammar-reader#SimplePattern::1::app
         _ts163075_
         _toks163076_
         _wrap-e163077_
         (lambda (_toks163083_ _$1162828163084_ _$2162829163086_)
           (let* ((_end163089_ (std/parser/lexer#token-stream-loc _ts163075_))
                  (_@loc163091_
                   (std/parser/base#location-delta*
                    _start163081_
                    _end163089_)))
             (_K163078_
              _toks163083_
              (let ((__tmp300738
                     (_wrap-e163077_
                      ((lambda (_$1163094_ _$2163095_)
                         (cons _$1163094_ (cons _$2163095_ '())))
                       (##direct-structure-ref
                        _$1162828163084_
                        '2
                        std/parser/base#token::t
                        '#f)
                       (##direct-structure-ref
                        _$2162829163086_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163091_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300738
                 _@loc163091_)))))
         _E163079_))))
  (define std/parser/grammar-reader#SimplePattern::2::app
    (lambda (_ts163069_ _toks163070_ _wrap-e163071_ _K163072_ _E163073_)
      (std/parser/grammar-reader#Ident
       _ts163069_
       _toks163070_
       _wrap-e163071_
       _K163072_
       _E163073_)))
  (define std/parser/grammar-reader#SimplePattern::2
    (lambda (_ts163050_ _toks163051_ _wrap-e163052_ _K163053_ _E163054_)
      (let ((_start163056_ (std/parser/lexer#token-stream-loc _ts163050_)))
        (std/parser/grammar-reader#Ident
         _ts163050_
         _toks163051_
         _wrap-e163052_
         (lambda (_toks163058_ _$1162830163059_)
           (let* ((_end163062_ (std/parser/lexer#token-stream-loc _ts163050_))
                  (_@loc163064_
                   (std/parser/base#location-delta*
                    _start163056_
                    _end163062_)))
             (_K163053_
              _toks163058_
              (let ((__tmp300739
                     (_wrap-e163052_
                      ((lambda (_$1163067_) _$1163067_)
                       (##direct-structure-ref
                        _$1162830163059_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163064_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300739
                 _@loc163064_)))))
         _E163054_))))
  (define std/parser/grammar-reader#SimplePattern::3::app
    (lambda (_ts163044_ _toks163045_ _wrap-e163046_ _K163047_ _E163048_)
      (std/parser/grammar-reader#EQ
       _ts163044_
       _toks163045_
       _wrap-e163046_
       _K163047_
       _E163048_)))
  (define std/parser/grammar-reader#SimplePattern::3
    (lambda (_ts163025_ _toks163026_ _wrap-e163027_ _K163028_ _E163029_)
      (let ((_start163031_ (std/parser/lexer#token-stream-loc _ts163025_)))
        (std/parser/grammar-reader#EQ
         _ts163025_
         _toks163026_
         _wrap-e163027_
         (lambda (_toks163033_ _$1162831163034_)
           (let* ((_end163037_ (std/parser/lexer#token-stream-loc _ts163025_))
                  (_@loc163039_
                   (std/parser/base#location-delta*
                    _start163031_
                    _end163037_)))
             (_K163028_
              _toks163033_
              (let ((__tmp300740
                     (_wrap-e163027_
                      ((lambda (_$1163042_)
                         (cons '@eq
                               (cons (cons 'quote (cons _$1163042_ '())) '())))
                       (##direct-structure-ref
                        _$1162831163034_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163039_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300740
                 _@loc163039_)))))
         _E163029_))))
  (define std/parser/grammar-reader#SimplePattern::4::app
    (lambda (_ts163019_ _toks163020_ _wrap-e163021_ _K163022_ _E163023_)
      (std/parser/grammar-reader#EQUAL
       _ts163019_
       _toks163020_
       _wrap-e163021_
       _K163022_
       _E163023_)))
  (define std/parser/grammar-reader#SimplePattern::4
    (lambda (_ts162998_ _toks162999_ _wrap-e163000_ _K163001_ _E163002_)
      (let ((_start163004_ (std/parser/lexer#token-stream-loc _ts162998_)))
        (std/parser/grammar-reader#EQUAL
         _ts162998_
         _toks162999_
         _wrap-e163000_
         (lambda (_toks163007_ _$1162832163008_)
           (let* ((_end163011_ (std/parser/lexer#token-stream-loc _ts162998_))
                  (_@loc163014_
                   (std/parser/base#location-delta*
                    _start163004_
                    _end163011_)))
             (_K163001_
              _toks163007_
              (let ((__tmp300741
                     (_wrap-e163000_
                      ((lambda (_$1163017_)
                         (cons '@eq
                               (cons (cons 'quote (cons _$1163017_ '()))
                                     (cons equal? '()))))
                       (##direct-structure-ref
                        _$1162832163008_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163014_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300741
                 _@loc163014_)))))
         _E163002_))))
  (define std/parser/grammar-reader#SimplePattern
    (lambda (_ts162985_ _toks162986_ _wrap-e162987_ _K162988_ _E162989_)
      (std/parser/grammar-reader#SimplePattern::1
       _ts162985_
       _toks162986_
       _wrap-e162987_
       _K162988_
       (lambda (_xtoks162991_)
         (std/parser/defparser#parser-rewind
          _ts162985_
          _xtoks162991_
          _toks162986_)
         (std/parser/grammar-reader#SimplePattern::2
          _ts162985_
          _toks162986_
          _wrap-e162987_
          _K162988_
          (lambda (_xtoks162994_)
            (std/parser/defparser#parser-rewind
             _ts162985_
             _xtoks162994_
             _toks162986_)
            (std/parser/grammar-reader#SimplePattern::3
             _ts162985_
             _toks162986_
             _wrap-e162987_
             _K162988_
             (lambda (_xtoks162996_)
               (std/parser/defparser#parser-rewind
                _ts162985_
                _xtoks162996_
                _toks162986_)
               (std/parser/grammar-reader#SimplePattern::4
                _ts162985_
                _toks162986_
                _wrap-e162987_
                _K162988_
                _E162989_)))))))))
  (define std/parser/grammar-reader#Ident
    (lambda (_ts162974_ _toks162975_ _wrap-e162976_ _K162977_ _E162978_)
      (let* ((_next162980_ (std/parser/lexer#token-stream-next _ts162974_))
             (_toks162982_ (cons _next162980_ _toks162975_)))
        (if (eq? (##direct-structure-ref
                  _next162980_
                  '1
                  std/parser/base#token::t
                  '#f)
                 'Ident)
            (_K162977_ _toks162982_ _next162980_)
            (_E162978_ _toks162982_)))))
  (define std/parser/grammar-reader#EQ
    (lambda (_ts162963_ _toks162964_ _wrap-e162965_ _K162966_ _E162967_)
      (let* ((_next162969_ (std/parser/lexer#token-stream-next _ts162963_))
             (_toks162971_ (cons _next162969_ _toks162964_)))
        (if (eq? (##direct-structure-ref
                  _next162969_
                  '1
                  std/parser/base#token::t
                  '#f)
                 'EQ)
            (_K162966_ _toks162971_ _next162969_)
            (_E162967_ _toks162971_)))))
  (define std/parser/grammar-reader#EQUAL
    (lambda (_ts162946_ _toks162948_ _wrap-e162950_ _K162952_ _E162954_)
      (let* ((_next162957_ (std/parser/lexer#token-stream-next _ts162946_))
             (_toks162960_ (cons _next162957_ _toks162948_)))
        (if (eq? (##direct-structure-ref
                  _next162957_
                  '1
                  std/parser/base#token::t
                  '#f)
                 'EQUAL)
            (_K162952_ _toks162960_ _next162957_)
            (_E162954_ _toks162960_)))))
  (define std/parser/grammar-reader#lex-lexer::L
    (cons (std/parser/rlang#@cat__2
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\p))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\a))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\s))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\e))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r)))
          (cons (std/parser/rlang#@cat__2
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\l))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\x))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\r)))
                (cons (std/parser/rlang#@cat__1
                       (std/parser/rlang#@rep+ std/parser/grammar-reader#WS)
                       (std/parser/rlang#@cat__1
                        (let ()
                          (declare (not safe))
                          (##structure std/parser/rlang#char::t '#\-))
                        (let ()
                          (declare (not safe))
                          (##structure std/parser/rlang#char::t '#\>))))
                      (cons (std/parser/rlang#@rep+
                             (let ()
                               (declare (not safe))
                               (##structure
                                std/parser/rlang#char::t
                                '#\newline)))
                            (cons (std/parser/rlang#@rep+
                                   std/parser/grammar-reader#WS)
                                  (cons (std/parser/rlang#@cat__1
                                         (let ()
                                           (declare (not safe))
                                           (##structure
                                            std/parser/rlang#char::t
                                            '#\;))
                                         (std/parser/rlang#@rep+
                                          (std/parser/rlang#@negset
                                           '(#\newline))))
                                        (cons (std/parser/rlang#@rep+
                                               (std/parser/rlang#@alt__2
                                                (std/parser/rlang#@cat__1
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\\))
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\;)))
                                                (std/parser/rlang#@cat__1
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\\))
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\space)))
                                                (std/parser/rlang#@negset
                                                 '(#\space
                                                   #\newline
                                                   #\tab
                                                   #\;))))
                                              '()))))))))
  (define std/parser/grammar-reader#lex-lexer::R
    (cons (lambda (_@@162923_ _@loc162924_)
            (let ()
              (declare (not safe))
              (##structure
               std/parser/base#token::t
               '$$
               '%%parser
               _@loc162924_)))
          (cons (lambda (_@@162926_ _@loc162927_)
                  (let ()
                    (declare (not safe))
                    (##structure
                     std/parser/base#token::t
                     '$$
                     '%%lexer
                     _@loc162927_)))
                (cons (lambda (_@@162929_ _@loc162930_)
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/parser/base#token::t
                           '$$
                           'ACTION
                           _@loc162930_)))
                      (cons (lambda (_@@162932_ _@loc162933_)
                              (let ()
                                (declare (not safe))
                                (##structure
                                 std/parser/base#token::t
                                 '$$
                                 'ENDRULE
                                 _@loc162933_)))
                            (cons (lambda (_@@162935_ _@loc162937_)
                                    std/parser/lexer#$)
                                  (cons (lambda (_@@162940_ _@loc162941_)
                                          std/parser/lexer#$)
                                        (cons (lambda (_@@162943_ _@loc162944_)
                                                (let ((__tmp300742
                                                       (std/parser/grammar-reader#escape-chars
                                                        _@@162943_)))
                                                  (declare (not safe))
                                                  (##structure
                                                   std/parser/base#token::t
                                                   'RX
                                                   __tmp300742
                                                   _@loc162944_)))
                                              '()))))))))
  (define std/parser/grammar-reader#lex-lexer
    (lambda (_input162920_)
      (std/parser/lexer#lex
       _input162920_
       std/parser/grammar-reader#lex-lexer::L
       std/parser/grammar-reader#lex-lexer::R)))
  (define std/parser/grammar-reader#simplify
    (lambda (_cat162881_)
      (let* ((_cat162882162892_ _cat162881_)
             (_else162884162900_ (lambda () _cat162881_))
             (_K162886162905_ (lambda (_e162903_) _e162903_)))
        (if (let () (declare (not safe)) (##pair? _cat162882162892_))
            (let ((_hd162887162908_
                   (let () (declare (not safe)) (##car _cat162882162892_)))
                  (_tl162888162910_
                   (let () (declare (not safe)) (##cdr _cat162882162892_))))
              (if (let () (declare (not safe)) (##eq? _hd162887162908_ '@cat))
                  (if (let () (declare (not safe)) (##pair? _tl162888162910_))
                      (let ((_hd162889162913_
                             (let ()
                               (declare (not safe))
                               (##car _tl162888162910_)))
                            (_tl162890162915_
                             (let ()
                               (declare (not safe))
                               (##cdr _tl162888162910_))))
                        (let ((_e162918_ _hd162889162913_))
                          (if (let ()
                                (declare (not safe))
                                (##null? _tl162890162915_))
                              (_K162886162905_ _e162918_)
                              (_else162884162900_))))
                      (_else162884162900_))
                  (_else162884162900_)))
            (_else162884162900_)))))
  (define std/parser/grammar-reader#string->token-symbol
    (lambda (_str162879_)
      (string->symbol
       (std/parser/grammar-reader#string->token-string _str162879_))))
  (define std/parser/grammar-reader#string->token-string
    (lambda (_str162877_)
      (std/parser/grammar-reader#escape-chars
       (substring _str162877_ '1 (fx- (string-length _str162877_) '1)))))
  (define std/parser/grammar-reader#escape-chars
    (lambda (_str162834_)
      (let _lp162836_ ((_rest162838_ (string->list _str162834_))
                       (_chars162839_ '()))
        (let* ((_rest162840162848_ _rest162838_)
               (_else162842162856_
                (lambda () (list->string (reverse _chars162839_))))
               (_K162844162865_
                (lambda (_rest162859_ _char162860_)
                  (if (eq? _char162860_ '#\\)
                      (let ((_$e162862_ _char162860_))
                        (if (eq? '#\n _$e162862_)
                            (_lp162836_
                             _rest162859_
                             (cons '#\newline _chars162839_))
                            (if (eq? '#\r _$e162862_)
                                (_lp162836_
                                 _rest162859_
                                 (cons '#\return _chars162839_))
                                (if (eq? '#\t _$e162862_)
                                    (_lp162836_
                                     _rest162859_
                                     (cons '#\tab _chars162839_))
                                    (_lp162836_
                                     _rest162859_
                                     (cons _char162860_ _chars162839_))))))
                      (_lp162836_
                       _rest162859_
                       (cons _char162860_ _chars162839_))))))
          (if (let () (declare (not safe)) (##pair? _rest162840162848_))
              (let ((_hd162845162868_
                     (let () (declare (not safe)) (##car _rest162840162848_)))
                    (_tl162846162870_
                     (let () (declare (not safe)) (##cdr _rest162840162848_))))
                (let* ((_char162873_ _hd162845162868_)
                       (_rest162875_ _tl162846162870_))
                  (_K162844162865_ _rest162875_ _char162873_)))
              (_else162842162856_)))))))
