(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (fixnum))
  (define std/pregexp#*pregexp-version* '20050502)
  (define std/pregexp#*pregexp-comment-char* '#\;)
  (define std/pregexp#*pregexp-nul-char-int* (- (char->integer '#\a) '97))
  (define std/pregexp#*pregexp-return-char*
    (integer->char (+ '13 std/pregexp#*pregexp-nul-char-int*)))
  (define std/pregexp#*pregexp-tab-char*
    (integer->char (+ '9 std/pregexp#*pregexp-nul-char-int*)))
  (define std/pregexp#pregexp-space-sensitive? (make-parameter '#t))
  (define std/pregexp#pregexp-reverse!
    (lambda (_s46002_)
      (let _loop46004_ ((_s46006_ _s46002_) (_r46007_ '()))
        (if (null? _s46006_)
            _r46007_
            (let ((_d46009_ (cdr _s46006_)))
              (set-cdr! _s46006_ _r46007_)
              (_loop46004_ _d46009_ _s46006_))))))
  (define std/pregexp#pregexp-error
    (lambda _args46000_ (apply error '"Regular expression error" _args46000_)))
  (define std/pregexp#pregexp-read-pattern
    (lambda (_s45986_ _i45987_ _n45988_)
      (if (>= _i45987_ _n45988_)
          (list (list ':or (list ':seq)) _i45987_)
          (let _loop45990_ ((_branches45992_ '()) (_i45993_ _i45987_))
            (if (or (>= _i45993_ _n45988_)
                    (char=? (let ()
                              (declare (not safe))
                              (##string-ref _s45986_ _i45993_))
                            '#\)))
                (list (cons ':or
                            (std/pregexp#pregexp-reverse! _branches45992_))
                      _i45993_)
                (let ((_vv45998_
                       (std/pregexp#pregexp-read-branch
                        _s45986_
                        (if (char=? (let ()
                                      (declare (not safe))
                                      (##string-ref _s45986_ _i45993_))
                                    '#\|)
                            (+ _i45993_ '1)
                            _i45993_)
                        _n45988_)))
                  (_loop45990_
                   (cons (car _vv45998_) _branches45992_)
                   (cadr _vv45998_))))))))
  (define std/pregexp#pregexp-read-branch
    (lambda (_s45970_ _i45971_ _n45972_)
      (let _loop45974_ ((_pieces45976_ '()) (_i45977_ _i45971_))
        (if (>= _i45977_ _n45972_)
            (list (cons ':seq (std/pregexp#pregexp-reverse! _pieces45976_))
                  _i45977_)
            (if (let ((_c45979_
                       (let ()
                         (declare (not safe))
                         (##string-ref _s45970_ _i45977_))))
                  (or (char=? _c45979_ '#\|) (char=? _c45979_ '#\))))
                (list (cons ':seq (std/pregexp#pregexp-reverse! _pieces45976_))
                      _i45977_)
                (let ((_vv45984_
                       (std/pregexp#pregexp-read-piece
                        _s45970_
                        _i45977_
                        _n45972_)))
                  (_loop45974_
                   (cons (car _vv45984_) _pieces45976_)
                   (cadr _vv45984_))))))))
  (define std/pregexp#pregexp-read-piece
    (lambda (_s45920_ _i45921_ _n45922_)
      (let* ((_c45924_
              (let () (declare (not safe)) (##string-ref _s45920_ _i45921_)))
             (_$e45926_ _c45924_))
        (let ((_default4592845942_
               (lambda ()
                 (if (or (std/pregexp#pregexp-space-sensitive?)
                         (and (not (char-whitespace? _c45924_))
                              (not (char=? _c45924_
                                           std/pregexp#*pregexp-comment-char*))))
                     (std/pregexp#pregexp-wrap-quantifier-if-any
                      (list _c45924_ (+ _i45921_ '1))
                      _s45920_
                      _n45922_)
                     (let _loop45935_ ((_i45937_ _i45921_)
                                       (_in-comment?45938_ '#f))
                       (if (>= _i45937_ _n45922_)
                           (list ':empty _i45937_)
                           (let ((_c45940_
                                  (let ()
                                    (declare (not safe))
                                    (##string-ref _s45920_ _i45937_))))
                             (if _in-comment?45938_
                                 (_loop45935_
                                  (+ _i45937_ '1)
                                  (not (char=? _c45940_ '#\newline)))
                                 (if (char-whitespace? _c45940_)
                                     (_loop45935_ (+ _i45937_ '1) '#f)
                                     (if (char=? _c45940_
                                                 std/pregexp#*pregexp-comment-char*)
                                         (_loop45935_ (+ _i45937_ '1) '#t)
                                         (list ':empty _i45937_))))))))))
              (_table4592945944_
               '#(#f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  1
                  #f
                  #f
                  #f
                  4
                  #f
                  #f
                  #f
                  #f
                  #f
                  2
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  3
                  5
                  #f
                  0)))
          (if (char? _$e45926_)
              (let ((_ix45947_
                     (let ()
                       (declare (not safe))
                       (##char->integer _$e45926_))))
                (if (let () (declare (not safe)) (##fx< _ix45947_ '95))
                    (let ((_x45950_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _table4592945944_ _ix45947_))))
                      (if _x45950_
                          (if (let () (declare (not safe)) (##fx< _x45950_ '3))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x45950_ '0))
                                  (list ':bos (+ _i45921_ '1))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45950_ '1))
                                      (list ':eos (+ _i45921_ '1))
                                      (std/pregexp#pregexp-wrap-quantifier-if-any
                                       (list ':any (+ _i45921_ '1))
                                       _s45920_
                                       _n45922_)))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x45950_ '3))
                                  (let ((_i+145953_ (+ _i45921_ '1)))
                                    (std/pregexp#pregexp-wrap-quantifier-if-any
                                     (let ((_$e45955_
                                            (if (< _i+145953_ _n45922_)
                                                (let ()
                                                  (declare (not safe))
                                                  (##string-ref
                                                   _s45920_
                                                   _i+145953_))
                                                '#f)))
                                       (if (eq? '#\^ _$e45955_)
                                           (let ((_vv45958_
                                                  (std/pregexp#pregexp-read-char-list
                                                   _s45920_
                                                   (+ _i45921_ '2)
                                                   _n45922_)))
                                             (list (list ':neg-char
                                                         (car _vv45958_))
                                                   (cadr _vv45958_)))
                                           (std/pregexp#pregexp-read-char-list
                                            _s45920_
                                            _i+145953_
                                            _n45922_)))
                                     _s45920_
                                     _n45922_))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45950_ '4))
                                      (std/pregexp#pregexp-wrap-quantifier-if-any
                                       (std/pregexp#pregexp-read-subpattern
                                        _s45920_
                                        (+ _i45921_ '1)
                                        _n45922_)
                                       _s45920_
                                       _n45922_)
                                      (std/pregexp#pregexp-wrap-quantifier-if-any
                                       (let ((_$e45960_
                                              (std/pregexp#pregexp-read-escaped-number
                                               _s45920_
                                               _i45921_
                                               _n45922_)))
                                         (if _$e45960_
                                             ((lambda (_num-i45963_)
                                                (list (list ':backref
                                                            (car _num-i45963_))
                                                      (cadr _num-i45963_)))
                                              _$e45960_)
                                             (let ((_$e45965_
                                                    (std/pregexp#pregexp-read-escaped-char
                                                     _s45920_
                                                     _i45921_
                                                     _n45922_)))
                                               (if _$e45965_
                                                   ((lambda (_char-i45968_)
                                                      (list (car _char-i45968_)
                                                            (cadr _char-i45968_)))
                                                    _$e45965_)
                                                   (std/pregexp#pregexp-error
                                                    'pregexp-read-piece
                                                    'backslash)))))
                                       _s45920_
                                       _n45922_))))
                          (_default4592845942_)))
                    (_default4592845942_)))
              (_default4592845942_))))))
  (define std/pregexp#pregexp-read-escaped-number
    (lambda (_s45907_ _i45908_ _n45909_)
      (if (< (+ _i45908_ '1) _n45909_)
          (let ((_c45911_
                 (let ((__tmp281218 (+ _i45908_ '1)))
                   (declare (not safe))
                   (##string-ref _s45907_ __tmp281218))))
            (if (char-numeric? _c45911_)
                (let _loop45913_ ((_i45915_ (+ _i45908_ '2))
                                  (_r45916_ (list _c45911_)))
                  (if (>= _i45915_ _n45909_)
                      (list (string->number
                             (list->string
                              (std/pregexp#pregexp-reverse! _r45916_)))
                            _i45915_)
                      (let ((_c45918_
                             (let ()
                               (declare (not safe))
                               (##string-ref _s45907_ _i45915_))))
                        (if (char-numeric? _c45918_)
                            (_loop45913_
                             (+ _i45915_ '1)
                             (cons _c45918_ _r45916_))
                            (list (string->number
                                   (list->string
                                    (std/pregexp#pregexp-reverse! _r45916_)))
                                  _i45915_)))))
                '#f))
          '#f)))
  (define std/pregexp#pregexp-read-escaped-char
    (lambda (_s45884_ _i45885_ _n45886_)
      (if (< (+ _i45885_ '1) _n45886_)
          (let* ((_c45888_
                  (let ((__tmp281219 (+ _i45885_ '1)))
                    (declare (not safe))
                    (##string-ref _s45884_ __tmp281219)))
                 (_$e45890_ _c45888_))
            (let ((_default4589245896_
                   (lambda () (list _c45888_ (+ _i45885_ '2))))
                  (_table4589345898_
                   '#(#f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      1
                      #f
                      3
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      7
                      #f
                      #f
                      #f
                      10
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      0
                      #f
                      2
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      4
                      #f
                      #f
                      #f
                      5
                      6
                      8
                      #f
                      #f
                      9)))
              (if (char? _$e45890_)
                  (let ((_ix45901_
                         (let ()
                           (declare (not safe))
                           (##char->integer _$e45890_))))
                    (if (let () (declare (not safe)) (##fx< _ix45901_ '120))
                        (let ((_x45904_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _table4589345898_ _ix45901_))))
                          (if _x45904_
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45904_ '5))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45904_ '2))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45904_ '0))
                                          (list ':wbdry (+ _i45885_ '2))
                                          (list ':not-wbdry (+ _i45885_ '2)))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45904_ '2))
                                          (list ':digit (+ _i45885_ '2))
                                          (if (let ()
                                                (declare (not safe))
                                                (##fx= _x45904_ '3))
                                              (list '(:neg-char :digit)
                                                    (+ _i45885_ '2))
                                              (list '#\newline
                                                    (+ _i45885_ '2)))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45904_ '8))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45904_ '5))
                                          (list std/pregexp#*pregexp-return-char*
                                                (+ _i45885_ '2))
                                          (if (let ()
                                                (declare (not safe))
                                                (##fx= _x45904_ '6))
                                              (list ':space (+ _i45885_ '2))
                                              (list '(:neg-char :space)
                                                    (+ _i45885_ '2))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45904_ '8))
                                          (list std/pregexp#*pregexp-tab-char*
                                                (+ _i45885_ '2))
                                          (if (let ()
                                                (declare (not safe))
                                                (##fx= _x45904_ '9))
                                              (list ':word (+ _i45885_ '2))
                                              (list '(:neg-char :word)
                                                    (+ _i45885_ '2))))))
                              (_default4589245896_)))
                        (_default4589245896_)))
                  (_default4589245896_))))
          '#f)))
  (define std/pregexp#pregexp-read-posix-char-class
    (lambda (_s45866_ _i45867_ _n45868_)
      (let ((_neg?45870_ '#f))
        (let _loop45872_ ((_i45874_ _i45867_) (_r45875_ (list '#\:)))
          (if (>= _i45874_ _n45868_)
              (std/pregexp#pregexp-error 'pregexp-read-posix-char-class)
              (let ((_c45877_
                     (let ()
                       (declare (not safe))
                       (##string-ref _s45866_ _i45874_))))
                (if (char=? _c45877_ '#\^)
                    (begin
                      (set! _neg?45870_ '#t)
                      (_loop45872_ (+ _i45874_ '1) _r45875_))
                    (if (char-alphabetic? _c45877_)
                        (_loop45872_ (+ _i45874_ '1) (cons _c45877_ _r45875_))
                        (if (char=? _c45877_ '#\:)
                            (if (or (>= (+ _i45874_ '1) _n45868_)
                                    (not (char=? (let ((__tmp281220
                                                        (+ _i45874_ '1)))
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45866_
                                                    __tmp281220))
                                                 '#\])))
                                (std/pregexp#pregexp-error
                                 'pregexp-read-posix-char-class)
                                (let ((_posix-class45882_
                                       (string->symbol
                                        (list->string
                                         (std/pregexp#pregexp-reverse!
                                          _r45875_)))))
                                  (list (if _neg?45870_
                                            (list ':neg-char
                                                  _posix-class45882_)
                                            _posix-class45882_)
                                        (+ _i45874_ '2))))
                            (std/pregexp#pregexp-error
                             'pregexp-read-posix-char-class))))))))))
  (define std/pregexp#pregexp-read-cluster-type
    (lambda (_s45838_ _i45839_ _n45840_)
      (let* ((_c45842_
              (let () (declare (not safe)) (##string-ref _s45838_ _i45839_)))
             (_$e45844_ _c45842_))
        (if (eq? '#\? _$e45844_)
            (let* ((_i45847_ (+ _i45839_ '1))
                   (_$e45849_
                    (let ()
                      (declare (not safe))
                      (##string-ref _s45838_ _i45847_))))
              (if (eq? '#\: _$e45849_)
                  (list '() (+ _i45847_ '1))
                  (if (eq? '#\= _$e45849_)
                      (list '(:lookahead) (+ _i45847_ '1))
                      (if (eq? '#\! _$e45849_)
                          (list '(:neg-lookahead) (+ _i45847_ '1))
                          (if (eq? '#\> _$e45849_)
                              (list '(:no-backtrack) (+ _i45847_ '1))
                              (if (eq? '#\< _$e45849_)
                                  (list (let ((_$e45852_
                                               (let ((__tmp281221
                                                      (+ _i45847_ '1)))
                                                 (declare (not safe))
                                                 (##string-ref
                                                  _s45838_
                                                  __tmp281221))))
                                          (if (eq? '#\= _$e45852_)
                                              '(:lookbehind)
                                              (if (eq? '#\! _$e45852_)
                                                  '(:neg-lookbehind)
                                                  (std/pregexp#pregexp-error
                                                   'pregexp-read-cluster-type))))
                                        (+ _i45847_ '2))
                                  (let _loop45855_ ((_i45857_ _i45847_)
                                                    (_r45858_ '())
                                                    (_inv?45859_ '#f))
                                    (let* ((_c45861_
                                            (let ()
                                              (declare (not safe))
                                              (##string-ref
                                               _s45838_
                                               _i45857_)))
                                           (_$e45863_ _c45861_))
                                      (if (eq? '#\- _$e45863_)
                                          (_loop45855_
                                           (+ _i45857_ '1)
                                           _r45858_
                                           '#t)
                                          (if (eq? '#\i _$e45863_)
                                              (_loop45855_
                                               (+ _i45857_ '1)
                                               (cons (if _inv?45859_
                                                         ':case-sensitive
                                                         ':case-insensitive)
                                                     _r45858_)
                                               '#f)
                                              (if (eq? '#\x _$e45863_)
                                                  (begin
                                                    (std/pregexp#pregexp-space-sensitive?
                                                     _inv?45859_)
                                                    (_loop45855_
                                                     (+ _i45857_ '1)
                                                     _r45858_
                                                     '#f))
                                                  (if (eq? '#\: _$e45863_)
                                                      (list _r45858_
                                                            (+ _i45857_ '1))
                                                      (std/pregexp#pregexp-error
                                                       'pregexp-read-cluster-type)))))))))))))
            (list '(:sub) _i45839_)))))
  (define std/pregexp#pregexp-read-subpattern
    (lambda (_s45815_ _i45816_ _n45817_)
      (let* ((_remember-space-sensitive?45819_
              (std/pregexp#pregexp-space-sensitive?))
             (_ctyp-i45821_
              (std/pregexp#pregexp-read-cluster-type
               _s45815_
               _i45816_
               _n45817_))
             (_ctyp45823_ (car _ctyp-i45821_))
             (_i45825_ (cadr _ctyp-i45821_))
             (_vv45827_
              (std/pregexp#pregexp-read-pattern _s45815_ _i45825_ _n45817_)))
        (std/pregexp#pregexp-space-sensitive? _remember-space-sensitive?45819_)
        (let ((_vv-re45830_ (car _vv45827_)) (_vv-i45831_ (cadr _vv45827_)))
          (if (and (< _vv-i45831_ _n45817_)
                   (char=? (let ()
                             (declare (not safe))
                             (##string-ref _s45815_ _vv-i45831_))
                           '#\)))
              (list (let _loop45833_ ((_ctyp45835_ _ctyp45823_)
                                      (_re45836_ _vv-re45830_))
                      (if (null? _ctyp45835_)
                          _re45836_
                          (_loop45833_
                           (cdr _ctyp45835_)
                           (list (car _ctyp45835_) _re45836_))))
                    (+ _vv-i45831_ '1))
              (std/pregexp#pregexp-error 'pregexp-read-subpattern))))))
  (define std/pregexp#pregexp-wrap-quantifier-if-any
    (lambda (_vv45775_ _s45776_ _n45777_)
      (let ((_re45779_ (car _vv45775_)))
        (let _loop45781_ ((_i45783_ (cadr _vv45775_)))
          (if (>= _i45783_ _n45777_)
              _vv45775_
              (let ((_c45785_
                     (let ()
                       (declare (not safe))
                       (##string-ref _s45776_ _i45783_))))
                (if (and (char-whitespace? _c45785_)
                         (not (std/pregexp#pregexp-space-sensitive?)))
                    (_loop45781_ (+ _i45783_ '1))
                    (let ((_$e45787_ _c45785_))
                      (if (or (eq? '#\* _$e45787_)
                              (eq? '#\+ _$e45787_)
                              (eq? '#\? _$e45787_)
                              (eq? '#\{ _$e45787_))
                          (let* ((_new-re45799_
                                  (list ':between
                                        'minimal?
                                        'at-least
                                        'at-most
                                        _re45779_))
                                 (_new-vv45801_ (list _new-re45799_ 'next-i)))
                            (let ((_$e45804_ _c45785_))
                              (if (eq? '#\* _$e45804_)
                                  (begin
                                    (set-car! (cddr _new-re45799_) '0)
                                    (set-car! (cdddr _new-re45799_) '#f))
                                  (if (eq? '#\+ _$e45804_)
                                      (begin
                                        (set-car! (cddr _new-re45799_) '1)
                                        (set-car! (cdddr _new-re45799_) '#f))
                                      (if (eq? '#\? _$e45804_)
                                          (begin
                                            (set-car! (cddr _new-re45799_) '0)
                                            (set-car!
                                             (cdddr _new-re45799_)
                                             '1))
                                          (if (eq? '#\{ _$e45804_)
                                              (let ((_pq45807_
                                                     (std/pregexp#pregexp-read-nums
                                                      _s45776_
                                                      (+ _i45783_ '1)
                                                      _n45777_)))
                                                (if (not _pq45807_)
                                                    (std/pregexp#pregexp-error
                                                     'pregexp-wrap-quantifier-if-any
                                                     'left-brace-must-be-followed-by-number)
                                                    '#!void)
                                                (set-car!
                                                 (cddr _new-re45799_)
                                                 (car _pq45807_))
                                                (set-car!
                                                 (cdddr _new-re45799_)
                                                 (cadr _pq45807_))
                                                (set! _i45783_
                                                      (caddr _pq45807_)))
                                              '#!void)))))
                            (let _loop45809_ ((_i45811_ (+ _i45783_ '1)))
                              (if (>= _i45811_ _n45777_)
                                  (begin
                                    (set-car! (cdr _new-re45799_) '#f)
                                    (set-car! (cdr _new-vv45801_) _i45811_))
                                  (let ((_c45813_
                                         (let ()
                                           (declare (not safe))
                                           (##string-ref _s45776_ _i45811_))))
                                    (if (and (char-whitespace? _c45813_)
                                             (not (std/pregexp#pregexp-space-sensitive?)))
                                        (_loop45809_ (+ _i45811_ '1))
                                        (if (char=? _c45813_ '#\?)
                                            (begin
                                              (set-car!
                                               (cdr _new-re45799_)
                                               '#t)
                                              (set-car!
                                               (cdr _new-vv45801_)
                                               (+ _i45811_ '1)))
                                            (begin
                                              (set-car!
                                               (cdr _new-re45799_)
                                               '#f)
                                              (set-car!
                                               (cdr _new-vv45801_)
                                               _i45811_)))))))
                            _new-vv45801_)
                          _vv45775_)))))))))
  (define std/pregexp#pregexp-read-nums
    (lambda (_s45759_ _i45760_ _n45761_)
      (let _loop45763_ ((_p45765_ '())
                        (_q45766_ '())
                        (_k45767_ _i45760_)
                        (_reading45768_ '1))
        (if (>= _k45767_ _n45761_)
            (std/pregexp#pregexp-error 'pregexp-read-nums)
            '#!void)
        (let ((_c45770_
               (let () (declare (not safe)) (##string-ref _s45759_ _k45767_))))
          (if (char-numeric? _c45770_)
              (if (= _reading45768_ '1)
                  (_loop45763_
                   (cons _c45770_ _p45765_)
                   _q45766_
                   (+ _k45767_ '1)
                   '1)
                  (_loop45763_
                   _p45765_
                   (cons _c45770_ _q45766_)
                   (+ _k45767_ '1)
                   '2))
              (if (and (char-whitespace? _c45770_)
                       (not (std/pregexp#pregexp-space-sensitive?)))
                  (_loop45763_
                   _p45765_
                   _q45766_
                   (+ _k45767_ '1)
                   _reading45768_)
                  (if (and (char=? _c45770_ '#\,) (= _reading45768_ '1))
                      (_loop45763_ _p45765_ _q45766_ (+ _k45767_ '1) '2)
                      (if (char=? _c45770_ '#\})
                          (let ((_p45772_
                                 (string->number
                                  (list->string
                                   (std/pregexp#pregexp-reverse! _p45765_))))
                                (_q45773_
                                 (string->number
                                  (list->string
                                   (std/pregexp#pregexp-reverse! _q45766_)))))
                            (if (and (not _p45772_) (= _reading45768_ '1))
                                (list '0 '#f _k45767_)
                                (if (= _reading45768_ '1)
                                    (list _p45772_ _p45772_ _k45767_)
                                    (list _p45772_ _q45773_ _k45767_))))
                          '#f))))))))
  (define std/pregexp#pregexp-invert-char-list
    (lambda (_vv45757_) (set-car! (car _vv45757_) ':none-of-chars) _vv45757_))
  (define std/pregexp#pregexp-read-char-list
    (lambda (_s45732_ _i45733_ _n45734_)
      (let _loop45736_ ((_r45738_ '()) (_i45739_ _i45733_))
        (if (>= _i45739_ _n45734_)
            (std/pregexp#pregexp-error
             'pregexp-read-char-list
             'character-class-ended-too-soon)
            (let* ((_c45741_
                    (let ()
                      (declare (not safe))
                      (##string-ref _s45732_ _i45739_)))
                   (_$e45743_ _c45741_))
              (if (eq? '#\] _$e45743_)
                  (if (null? _r45738_)
                      (_loop45736_ (cons _c45741_ _r45738_) (+ _i45739_ '1))
                      (list (cons ':one-of-chars
                                  (std/pregexp#pregexp-reverse! _r45738_))
                            (+ _i45739_ '1)))
                  (if (eq? '#\\ _$e45743_)
                      (let ((_char-i45746_
                             (std/pregexp#pregexp-read-escaped-char
                              _s45732_
                              _i45739_
                              _n45734_)))
                        (if _char-i45746_
                            (_loop45736_
                             (cons (car _char-i45746_) _r45738_)
                             (cadr _char-i45746_))
                            (std/pregexp#pregexp-error
                             'pregexp-read-char-list
                             'backslash)))
                      (if (eq? '#\- _$e45743_)
                          (if (or (null? _r45738_)
                                  (let ((_i+145751_ (+ _i45739_ '1)))
                                    (and (< _i+145751_ _n45734_)
                                         (char=? (let ()
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45732_
                                                    _i+145751_))
                                                 '#\]))))
                              (_loop45736_
                               (cons _c45741_ _r45738_)
                               (+ _i45739_ '1))
                              (let ((_c-prev45753_ (car _r45738_)))
                                (if (char? _c-prev45753_)
                                    (_loop45736_
                                     (cons (list ':char-range
                                                 _c-prev45753_
                                                 (let ((__tmp281222
                                                        (+ _i45739_ '1)))
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45732_
                                                    __tmp281222)))
                                           (cdr _r45738_))
                                     (+ _i45739_ '2))
                                    (_loop45736_
                                     (cons _c45741_ _r45738_)
                                     (+ _i45739_ '1)))))
                          (if (eq? '#\[ _$e45743_)
                              (if (char=? (let ((__tmp281223 (+ _i45739_ '1)))
                                            (declare (not safe))
                                            (##string-ref
                                             _s45732_
                                             __tmp281223))
                                          '#\:)
                                  (let ((_posix-char-class-i45755_
                                         (std/pregexp#pregexp-read-posix-char-class
                                          _s45732_
                                          (+ _i45739_ '2)
                                          _n45734_)))
                                    (_loop45736_
                                     (cons (car _posix-char-class-i45755_)
                                           _r45738_)
                                     (cadr _posix-char-class-i45755_)))
                                  (_loop45736_
                                   (cons _c45741_ _r45738_)
                                   (+ _i45739_ '1)))
                              (_loop45736_
                               (cons _c45741_ _r45738_)
                               (+ _i45739_ '1)))))))))))
  (define std/pregexp#pregexp-string-match
    (lambda (_s145718_ _s45719_ _i45720_ _n45721_ _sk45722_ _fk45723_)
      (let ((_n145725_ (string-length _s145718_)))
        (if (> _n145725_ _n45721_)
            (_fk45723_)
            (let _loop45727_ ((_j45729_ '0) (_k45730_ _i45720_))
              (if (>= _j45729_ _n145725_)
                  (_sk45722_ _k45730_)
                  (if (>= _k45730_ _n45721_)
                      (_fk45723_)
                      (if (char=? (let ()
                                    (declare (not safe))
                                    (##string-ref _s145718_ _j45729_))
                                  (let ()
                                    (declare (not safe))
                                    (##string-ref _s45719_ _k45730_)))
                          (_loop45727_ (+ _j45729_ '1) (+ _k45730_ '1))
                          (_fk45723_)))))))))
  (define std/pregexp#pregexp-char-word?
    (lambda (_c45710_)
      (let ((_$e45712_ (char-alphabetic? _c45710_)))
        (if _$e45712_
            _$e45712_
            (let ((_$e45715_ (char-numeric? _c45710_)))
              (if _$e45715_ _$e45715_ (char=? _c45710_ '#\_)))))))
  (define std/pregexp#pregexp-at-word-boundary?
    (lambda (_s45691_ _i45692_ _n45693_)
      (let ((_$e45695_ (= _i45692_ '0)))
        (if _$e45695_
            _$e45695_
            (let ((_$e45698_ (>= _i45692_ _n45693_)))
              (if _$e45698_
                  _$e45698_
                  (let ((_c/i45701_
                         (let ()
                           (declare (not safe))
                           (##string-ref _s45691_ _i45692_)))
                        (_c/i-145702_
                         (let ((__tmp281224 (- _i45692_ '1)))
                           (declare (not safe))
                           (##string-ref _s45691_ __tmp281224))))
                    (let ((_c/i/w?45704_
                           (std/pregexp#pregexp-check-if-in-char-class?
                            _c/i45701_
                            ':word))
                          (_c/i-1/w?45705_
                           (std/pregexp#pregexp-check-if-in-char-class?
                            _c/i-145702_
                            ':word)))
                      (let ((_$e45707_
                             (if _c/i/w?45704_ (not _c/i-1/w?45705_) '#f)))
                        (if _$e45707_
                            _$e45707_
                            (if (not _c/i/w?45704_)
                                _c/i-1/w?45705_
                                '#f)))))))))))
  (define std/pregexp#pregexp-check-if-in-char-class?
    (lambda (_c45634_ _char-class45635_)
      (let ((_$e45637_ _char-class45635_))
        (let ((_default4563945643_
               (lambda ()
                 (std/pregexp#pregexp-error 'pregexp-check-if-in-char-class?)))
              (_table4564045645_
               '#(#f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:digit . 6)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:alnum . 1)
                  (:word . 13)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:cntrl . 5)
                  #f
                  #f
                  #f
                  #f
                  (:alpha . 2)
                  #f
                  #f
                  (:lower . 8)
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:xdigit . 14)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:space . 11)
                  #f
                  (:upper . 12)
                  #f
                  #f
                  #f
                  (:punct . 10)
                  #f
                  (:any . 0)
                  #f
                  #f
                  (:print . 9)
                  (:blank . 4)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:ascii . 3)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:graph . 7))))
          (if (symbol? _$e45637_)
              (let* ((_h45648_
                      (let () (declare (not safe)) (##symbol-hash _$e45637_)))
                     (_ix45651_
                      (let () (declare (not safe)) (##fxmodulo _h45648_ '100)))
                     (_q45654_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _table4564045645_ _ix45651_))))
                (if _q45654_
                    (if (eq? (let () (declare (not safe)) (##car _q45654_))
                             _$e45637_)
                        (let ((_x45658_
                               (let () (declare (not safe)) (##cdr _q45654_))))
                          (if (let () (declare (not safe)) (##fx< _x45658_ '7))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45658_ '3))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45658_ '0))
                                      (not (char=? _c45634_ '#\newline))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '1))
                                          (let ((_$e45661_
                                                 (char-alphabetic? _c45634_)))
                                            (if _$e45661_
                                                _$e45661_
                                                (char-numeric? _c45634_)))
                                          (char-alphabetic? _c45634_)))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45658_ '5))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '3))
                                          (< (char->integer _c45634_) '128)
                                          (let ((_$e45664_
                                                 (char=? _c45634_ '#\space)))
                                            (if _$e45664_
                                                _$e45664_
                                                (char=? _c45634_
                                                        std/pregexp#*pregexp-tab-char*))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '5))
                                          (< (char->integer _c45634_) '32)
                                          (char-numeric? _c45634_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45658_ '11))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45658_ '9))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '7))
                                          (if (>= (char->integer _c45634_) '32)
                                              (not (char-whitespace? _c45634_))
                                              '#f)
                                          (char-lower-case? _c45634_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '9))
                                          (>= (char->integer _c45634_) '32)
                                          (if (>= (char->integer _c45634_) '32)
                                              (if (not (char-whitespace?
                                                        _c45634_))
                                                  (if (not (char-alphabetic?
                                                            _c45634_))
                                                      (not (char-numeric?
                                                            _c45634_))
                                                      '#f)
                                                  '#f)
                                              '#f)))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45658_ '13))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '11))
                                          (char-whitespace? _c45634_)
                                          (char-upper-case? _c45634_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45658_ '13))
                                          (let ((_$e45667_
                                                 (char-alphabetic? _c45634_)))
                                            (if _$e45667_
                                                _$e45667_
                                                (let ((_$e45670_
                                                       (char-numeric?
                                                        _c45634_)))
                                                  (if _$e45670_
                                                      _$e45670_
                                                      (char=? _c45634_
                                                              '#\_)))))
                                          (let ((_$e45673_
                                                 (char-numeric? _c45634_)))
                                            (if _$e45673_
                                                _$e45673_
                                                (let ((_$e45676_
                                                       (char-ci=?
                                                        _c45634_
                                                        '#\a)))
                                                  (if _$e45676_
                                                      _$e45676_
                                                      (let ((_$e45679_
                                                             (char-ci=?
                                                              _c45634_
                                                              '#\b)))
                                                        (if _$e45679_
                                                            _$e45679_
                                                            (let ((_$e45682_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (char-ci=? _c45634_ '#\c)))
                      (if _$e45682_
                          _$e45682_
                          (let ((_$e45685_ (char-ci=? _c45634_ '#\d)))
                            (if _$e45685_
                                _$e45685_
                                (let ((_$e45688_ (char-ci=? _c45634_ '#\e)))
                                  (if _$e45688_
                                      _$e45688_
                                      (char-ci=?
                                       _c45634_
                                       '#\f))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        (_default4563945643_))
                    (_default4563945643_)))
              (_default4563945643_))))))
  (define std/pregexp#pregexp-list-ref
    (lambda (_s45626_ _i45627_)
      (let _loop45629_ ((_s45631_ _s45626_) (_k45632_ '0))
        (if (null? _s45631_)
            '#f
            (if (= _k45632_ _i45627_)
                (car _s45631_)
                (_loop45629_ (cdr _s45631_) (+ _k45632_ '1)))))))
  (define std/pregexp#pregexp-make-backref-list
    (lambda (_re45617_)
      (let _sub45619_ ((_re45621_ _re45617_))
        (if (pair? _re45621_)
            (let ((_car-re45623_ (car _re45621_))
                  (_sub-cdr-re45624_ (_sub45619_ (cdr _re45621_))))
              (if (eqv? _car-re45623_ ':sub)
                  (cons (cons _re45621_ '#f) _sub-cdr-re45624_)
                  (append (_sub45619_ _car-re45623_) _sub-cdr-re45624_)))
            '()))))
  (define std/pregexp#pregexp-match-positions-aux
    (lambda (_re45465_ _s45466_ _sn45467_ _start45468_ _n45469_ _i45470_)
      (let ((_identity45474_ (lambda (_x45472_) _x45472_))
            (_backrefs45475_ (std/pregexp#pregexp-make-backref-list _re45465_))
            (_case-sensitive?45476_ '#t))
        (let _sub45478_ ((_re45480_ _re45465_)
                         (_i45481_ _i45470_)
                         (_sk45482_ _identity45474_)
                         (_fk45483_ (lambda () '#f)))
          (if (eqv? _re45480_ ':bos)
              (if (= _i45481_ _start45468_) (_sk45482_ _i45481_) (_fk45483_))
              (if (eqv? _re45480_ ':eos)
                  (if (>= _i45481_ _n45469_) (_sk45482_ _i45481_) (_fk45483_))
                  (if (eqv? _re45480_ ':empty)
                      (_sk45482_ _i45481_)
                      (if (eqv? _re45480_ ':wbdry)
                          (if (std/pregexp#pregexp-at-word-boundary?
                               _s45466_
                               _i45481_
                               _n45469_)
                              (_sk45482_ _i45481_)
                              (_fk45483_))
                          (if (eqv? _re45480_ ':not-wbdry)
                              (if (std/pregexp#pregexp-at-word-boundary?
                                   _s45466_
                                   _i45481_
                                   _n45469_)
                                  (_fk45483_)
                                  (_sk45482_ _i45481_))
                              (if (and (char? _re45480_) (< _i45481_ _n45469_))
                                  (if ((if _case-sensitive?45476_
                                           char=?
                                           char-ci=?)
                                       (let ()
                                         (declare (not safe))
                                         (##string-ref _s45466_ _i45481_))
                                       _re45480_)
                                      (_sk45482_ (+ _i45481_ '1))
                                      (_fk45483_))
                                  (if (and (not (pair? _re45480_))
                                           (< _i45481_ _n45469_))
                                      (if (std/pregexp#pregexp-check-if-in-char-class?
                                           (let ()
                                             (declare (not safe))
                                             (##string-ref _s45466_ _i45481_))
                                           _re45480_)
                                          (_sk45482_ (+ _i45481_ '1))
                                          (_fk45483_))
                                      (if (and (pair? _re45480_)
                                               (eqv? (car _re45480_)
                                                     ':char-range)
                                               (< _i45481_ _n45469_))
                                          (let ((_c45485_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45466_
                                                    _i45481_))))
                                            (if (let ((_c<45487_
                                                       (if _case-sensitive?45476_
                                                           char<=?
                                                           char-ci<=?)))
                                                  (and (_c<45487_
                                                        (cadr _re45480_)
                                                        _c45485_)
                                                       (_c<45487_
                                                        _c45485_
                                                        (caddr _re45480_))))
                                                (_sk45482_ (+ _i45481_ '1))
                                                (_fk45483_)))
                                          (if (pair? _re45480_)
                                              (let ((_$e45489_
                                                     (car _re45480_)))
                                                (let ((_default4549145495_
                                                       (lambda ()
                                                         (std/pregexp#pregexp-error
                                                          'pregexp-match-positions-aux)))
                                                      (_table4549245497_
                                                       '#(#f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:neg-char . 2)
                                                          #f
                                                          #f
                                                          #f
                                                          (:neg-lookahead . 8)
                                                          (:sub . 6)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:or . 4)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:char-range . 0)
                                                          #f
                                                          #f
                                                          #f
                                                          (:case-insensitive
                                                           .
                                                           12)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:lookahead . 7)
                                                          #f
                                                          #f
                                                          #f
                                                          (:between . 13)
                                                          #f
                                                          #f
                                                          #f
                                                          (:one-of-chars . 1)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:backref . 5)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:lookbehind . 9)
                                                          (:neg-lookbehind
                                                           .
                                                           10)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:case-sensitive
                                                           .
                                                           12)
                                                          #f
                                                          #f
                                                          #f
                                                          (:seq . 3)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:no-backtrack . 11)
                                                          #f
                                                          #f)))
                                                  (if (symbol? _$e45489_)
                                                      (let* ((_h45500_
                                                              (let ()
                                                                (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (not safe))
                        (##symbol-hash _$e45489_)))
                     (_ix45503_
                      (let () (declare (not safe)) (##fxmodulo _h45500_ '100)))
                     (_q45506_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _table4549245497_ _ix45503_))))
                (if _q45506_
                    (if (eq? (let () (declare (not safe)) (##car _q45506_))
                             _$e45489_)
                        (let ((_x45510_
                               (let () (declare (not safe)) (##cdr _q45506_))))
                          (if (let () (declare (not safe)) (##fx< _x45510_ '7))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45510_ '3))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45510_ '0))
                                      (if (>= _i45481_ _n45469_)
                                          (_fk45483_)
                                          (std/pregexp#pregexp-error
                                           'pregexp-match-positions-aux))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45510_ '1))
                                          (if (>= _i45481_ _n45469_)
                                              (_fk45483_)
                                              (let _loup-one-of-chars45513_ ((_chars45515_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                      (cdr _re45480_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (if (null? _chars45515_)
                                                    (_fk45483_)
                                                    (_sub45478_
                                                     (car _chars45515_)
                                                     _i45481_
                                                     _sk45482_
                                                     (lambda ()
                                                       (_loup-one-of-chars45513_
                                                        (cdr _chars45515_)))))))
                                          (if (>= _i45481_ _n45469_)
                                              (_fk45483_)
                                              (_sub45478_
                                               (cadr _re45480_)
                                               _i45481_
                                               (lambda (_i145518_) (_fk45483_))
                                               (lambda ()
                                                 (_sk45482_
                                                  (+ _i45481_ '1)))))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45510_ '5))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45510_ '3))
                                          (let _loup-seq45521_ ((_res45523_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (cdr _re45480_))
                        (_i45524_ _i45481_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (if (null? _res45523_)
                                                (_sk45482_ _i45524_)
                                                (_sub45478_
                                                 (car _res45523_)
                                                 _i45524_
                                                 (lambda (_i145526_)
                                                   (_loup-seq45521_
                                                    (cdr _res45523_)
                                                    _i145526_))
                                                 _fk45483_)))
                                          (let _loup-or45528_ ((_res45530_
                                                                (cdr _re45480_)))
                                            (if (null? _res45530_)
                                                (_fk45483_)
                                                (_sub45478_
                                                 (car _res45530_)
                                                 _i45481_
                                                 (lambda (_i145532_)
                                                   (let ((_$e45534_
                                                          (_sk45482_
                                                           _i145532_)))
                                                     (if _$e45534_
                                                         _$e45534_
                                                         (_loup-or45528_
                                                          (cdr _res45530_)))))
                                                 (lambda ()
                                                   (_loup-or45528_
                                                    (cdr _res45530_)))))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45510_ '5))
                                          (let* ((_c45538_
                                                  (std/pregexp#pregexp-list-ref
                                                   _backrefs45475_
                                                   (cadr _re45480_)))
                                                 (_backref45543_
                                                  (let ((_$e45540_ _c45538_))
                                                    (if _$e45540_
                                                        (cdr _$e45540_)
                                                        (begin
                                                          (std/pregexp#pregexp-error
                                                           'pregexp-match-positions-aux
                                                           'non-existent-backref
                                                           _re45480_)
                                                          '#f)))))
                                            (if _backref45543_
                                                (std/pregexp#pregexp-string-match
                                                 (substring
                                                  _s45466_
                                                  (car _backref45543_)
                                                  (cdr _backref45543_))
                                                 _s45466_
                                                 _i45481_
                                                 _n45469_
                                                 (lambda (_i45546_)
                                                   (_sk45482_ _i45546_))
                                                 _fk45483_)
                                                (_sk45482_ _i45481_)))
                                          (_sub45478_
                                           (cadr _re45480_)
                                           _i45481_
                                           (lambda (_i145548_)
                                             (set-cdr!
                                              (assv _re45480_ _backrefs45475_)
                                              (cons _i45481_ _i145548_))
                                             (_sk45482_ _i145548_))
                                           _fk45483_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45510_ '10))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45510_ '7))
                                      (let ((_found-it?45551_
                                             (_sub45478_
                                              (cadr _re45480_)
                                              _i45481_
                                              _identity45474_
                                              (lambda () '#f))))
                                        (if _found-it?45551_
                                            (_sk45482_ _i45481_)
                                            (_fk45483_)))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45510_ '8))
                                          (let ((_found-it?45554_
                                                 (_sub45478_
                                                  (cadr _re45480_)
                                                  _i45481_
                                                  _identity45474_
                                                  (lambda () '#f))))
                                            (if _found-it?45554_
                                                (_fk45483_)
                                                (_sk45482_ _i45481_)))
                                          (let ((_n-actual45556_ _n45469_)
                                                (_sn-actual45557_ _sn45467_))
                                            (set! _n45469_ _i45481_)
                                            (set! _sn45467_ _i45481_)
                                            (let ((_found-it?45560_
                                                   (_sub45478_
                                                    (list ':seq
                                                          '(:between
                                                            #f
                                                            0
                                                            #f
                                                            :any)
                                                          (cadr _re45480_)
                                                          ':eos)
                                                    '0
                                                    _identity45474_
                                                    (lambda () '#f))))
                                              (set! _n45469_ _n-actual45556_)
                                              (set! _sn45467_ _sn-actual45557_)
                                              (if _found-it?45560_
                                                  (_sk45482_ _i45481_)
                                                  (_fk45483_))))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45510_ '12))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45510_ '10))
                                          (let ((_n-actual45562_ _n45469_)
                                                (_sn-actual45563_ _sn45467_))
                                            (set! _n45469_ _i45481_)
                                            (set! _sn45467_ _i45481_)
                                            (let ((_found-it?45566_
                                                   (_sub45478_
                                                    (list ':seq
                                                          '(:between
                                                            #f
                                                            0
                                                            #f
                                                            :any)
                                                          (cadr _re45480_)
                                                          ':eos)
                                                    '0
                                                    _identity45474_
                                                    (lambda () '#f))))
                                              (set! _n45469_ _n-actual45562_)
                                              (set! _sn45467_ _sn-actual45563_)
                                              (if _found-it?45566_
                                                  (_fk45483_)
                                                  (_sk45482_ _i45481_))))
                                          (let ((_found-it?45569_
                                                 (_sub45478_
                                                  (cadr _re45480_)
                                                  _i45481_
                                                  _identity45474_
                                                  (lambda () '#f))))
                                            (if _found-it?45569_
                                                (_sk45482_ _found-it?45569_)
                                                (_fk45483_))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45510_ '12))
                                          (let ((_old45571_
                                                 _case-sensitive?45476_))
                                            (set! _case-sensitive?45476_
                                                  (eqv? (car _re45480_)
                                                        ':case-sensitive))
                                            (_sub45478_
                                             (cadr _re45480_)
                                             _i45481_
                                             (lambda (_i145573_)
                                               (set! _case-sensitive?45476_
                                                     _old45571_)
                                               (_sk45482_ _i145573_))
                                             (lambda ()
                                               (set! _case-sensitive?45476_
                                                     _old45571_)
                                               (_fk45483_))))
                                          (let* ((_maximal?45576_
                                                  (not (cadr _re45480_)))
                                                 (_p45578_ (caddr _re45480_))
                                                 (_q45580_ (cadddr _re45480_))
                                                 (_could-loop-infinitely?45582_
                                                  (if _maximal?45576_
                                                      (not _q45580_)
                                                      '#f))
                                                 (_re45584_
                                                  (car (cddddr _re45480_))))
                                            (let _loup-p45587_ ((_k45589_ '0)
                                                                (_i45590_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _i45481_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (< _k45589_ _p45578_)
                                                  (_sub45478_
                                                   _re45584_
                                                   _i45590_
                                                   (lambda (_i145592_)
                                                     (if (and _could-loop-infinitely?45582_
                                                              (= _i145592_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _i45590_))
                 (std/pregexp#pregexp-error
                  'pregexp-match-positions-aux
                  'greedy-quantifier-operand-could-be-empty)
                 '#!void)
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loup-p45587_
                                                      (+ _k45589_ '1)
                                                      _i145592_))
                                                   _fk45483_)
                                                  (let ((_q45594_
                                                         (if _q45580_
                                                             (- _q45580_
                                                                _p45578_)
                                                             '#f)))
                                                    (let _loup-q45596_ ((_k45598_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 '0)
                                (_i45599_ _i45590_))
              (let ((_fk45602_ (lambda () (_sk45482_ _i45599_))))
                (if (and _q45594_ (>= _k45598_ _q45594_))
                    (_fk45602_)
                    (if _maximal?45576_
                        (_sub45478_
                         _re45584_
                         _i45599_
                         (lambda (_i145604_)
                           (if (and _could-loop-infinitely?45582_
                                    (= _i145604_ _i45599_))
                               (std/pregexp#pregexp-error
                                'pregexp-match-positions-aux
                                'greedy-quantifier-operand-could-be-empty)
                               '#!void)
                           (let ((_$e45606_
                                  (_loup-q45596_ (+ _k45598_ '1) _i145604_)))
                             (if _$e45606_ _$e45606_ (_fk45602_))))
                         _fk45602_)
                        (let ((_$e45609_ (_fk45602_)))
                          (if _$e45609_
                              _$e45609_
                              (_sub45478_
                               _re45584_
                               _i45599_
                               (lambda (_i145612_)
                                 (_loup-q45596_ (+ _k45598_ '1) _i145612_))
                               _fk45602_))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        (_default4549145495_))
                    (_default4549145495_)))
              (_default4549145495_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (>= _i45481_ _n45469_)
                                                  (_fk45483_)
                                                  (std/pregexp#pregexp-error
                                                   'pregexp-match-positions-aux))))))))))))
        (let ((_backrefs45615_ (map cdr _backrefs45475_)))
          (if (car _backrefs45615_) _backrefs45615_ '#f)))))
  (define std/pregexp#pregexp-replace-aux
    (lambda (_str45442_ _ins45443_ _n45444_ _backrefs45445_)
      (let _loop45447_ ((_i45449_ '0) (_r45450_ '""))
        (if (>= _i45449_ _n45444_)
            _r45450_
            (let ((_c45452_
                   (let ()
                     (declare (not safe))
                     (##string-ref _ins45443_ _i45449_))))
              (if (char=? _c45452_ '#\\)
                  (let* ((_br-i45454_
                          (std/pregexp#pregexp-read-escaped-number
                           _ins45443_
                           _i45449_
                           _n45444_))
                         (_br45456_
                          (if _br-i45454_
                              (car _br-i45454_)
                              (if (char=? (let ((__tmp281225 (+ _i45449_ '1)))
                                            (declare (not safe))
                                            (##string-ref
                                             _ins45443_
                                             __tmp281225))
                                          '#\&)
                                  '0
                                  '#f)))
                         (_i45458_
                          (if _br-i45454_
                              (cadr _br-i45454_)
                              (if _br45456_ (+ _i45449_ '2) (+ _i45449_ '1)))))
                    (if (not _br45456_)
                        (let ((_c245461_
                               (let ()
                                 (declare (not safe))
                                 (##string-ref _ins45443_ _i45458_))))
                          (_loop45447_
                           (+ _i45458_ '1)
                           (if (char=? _c245461_ '#\$)
                               _r45450_
                               (string-append _r45450_ (string _c245461_)))))
                        (_loop45447_
                         _i45458_
                         (let ((_backref45463_
                                (std/pregexp#pregexp-list-ref
                                 _backrefs45445_
                                 _br45456_)))
                           (if _backref45463_
                               (string-append
                                _r45450_
                                (substring
                                 _str45442_
                                 (car _backref45463_)
                                 (cdr _backref45463_)))
                               _r45450_)))))
                  (_loop45447_
                   (+ _i45449_ '1)
                   (string-append _r45450_ (string _c45452_)))))))))
  (define std/pregexp#pregexp
    (lambda (_s45439_)
      (call-with-parameters
       (lambda ()
         (list ':sub
               (car (std/pregexp#pregexp-read-pattern
                     _s45439_
                     '0
                     (string-length _s45439_)))))
       std/pregexp#pregexp-space-sensitive?
       '#t)))
  (define std/pregexp#pregexp-match-positions__%
    (lambda (_pat45399_ _str45400_ _start45401_ _end45402_)
      (if (string? _pat45399_)
          (set! _pat45399_ (std/pregexp#pregexp _pat45399_))
          (if (pair? _pat45399_)
              '#t
              (std/pregexp#pregexp-error
               'pregexp-match-positions
               'pattern-must-be-compiled-or-string-regexp
               _pat45399_)))
      (let* ((_str-len45404_ (string-length _str45400_))
             (_start45406_
              (if _start45401_
                  (if (fixnum? _start45401_)
                      (if (and (>= _start45401_ '0)
                               (< _start45401_ _str-len45404_))
                          _start45401_
                          (error '"Start index out of range" _start45401_))
                      (error '"Expected nonnegative fixnum" _start45401_))
                  '0))
             (_end45408_
              (if _end45402_
                  (if (fixnum? _end45402_)
                      (if (<= _end45402_ _str-len45404_)
                          _end45402_
                          (error '"End index out of range" _end45402_))
                      (error '"Expected fixnum" _end45402_))
                  _str-len45404_)))
        (let _loop45411_ ((_i45413_ _start45406_))
          (if (<= _i45413_ _end45408_)
              (let ((_$e45415_
                     (std/pregexp#pregexp-match-positions-aux
                      _pat45399_
                      _str45400_
                      _str-len45404_
                      _start45406_
                      _end45408_
                      _i45413_)))
                (if _$e45415_ _$e45415_ (_loop45411_ (+ _i45413_ '1))))
              '#f)))))
  (define std/pregexp#pregexp-match-positions__0
    (lambda (_pat45421_ _str45422_)
      (let* ((_start45424_ '#f) (_end45426_ '#f))
        (std/pregexp#pregexp-match-positions__%
         _pat45421_
         _str45422_
         _start45424_
         _end45426_))))
  (define std/pregexp#pregexp-match-positions__1
    (lambda (_pat45428_ _str45429_ _start45430_)
      (let ((_end45432_ '#f))
        (std/pregexp#pregexp-match-positions__%
         _pat45428_
         _str45429_
         _start45430_
         _end45432_))))
  (define std/pregexp#pregexp-match-positions
    (lambda _g281227_
      (let ((_g281226_ (let () (declare (not safe)) (##length _g281227_))))
        (cond ((let () (declare (not safe)) (##fx= _g281226_ 2))
               (apply std/pregexp#pregexp-match-positions__0 _g281227_))
              ((let () (declare (not safe)) (##fx= _g281226_ 3))
               (apply std/pregexp#pregexp-match-positions__1 _g281227_))
              ((let () (declare (not safe)) (##fx= _g281226_ 4))
               (apply std/pregexp#pregexp-match-positions__% _g281227_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/pregexp#pregexp-match-positions
                _g281227_))))))
  (define std/pregexp#pregexp-match
    (lambda (_pat45390_ _str45391_ . _opt-args45392_)
      (let ((_ix-prs45394_
             (apply std/pregexp#pregexp-match-positions
                    _pat45390_
                    _str45391_
                    _opt-args45392_)))
        (if _ix-prs45394_
            (map (lambda (_ix-pr45396_)
                   (if _ix-pr45396_
                       (substring
                        _str45391_
                        (car _ix-pr45396_)
                        (cdr _ix-pr45396_))
                       '#f))
                 _ix-prs45394_)
            '#f))))
  (define std/pregexp#pregexp-split
    (lambda (_pat45369_ _str45370_)
      (let ((_n45372_ (string-length _str45370_)))
        (let _loop45374_ ((_i45376_ '0)
                          (_r45377_ '())
                          (_picked-up-one-undelimited-char?45378_ '#f))
          (if (>= _i45376_ _n45372_)
              (std/pregexp#pregexp-reverse! _r45377_)
              (let ((_$e45380_
                     (std/pregexp#pregexp-match-positions__%
                      _pat45369_
                      _str45370_
                      _i45376_
                      _n45372_)))
                (if _$e45380_
                    ((lambda (_y45383_)
                       (let ((_jk45385_ (car _y45383_)))
                         (let ((_j45387_ (car _jk45385_))
                               (_k45388_ (cdr _jk45385_)))
                           (if (= _j45387_ _k45388_)
                               (_loop45374_
                                (+ _k45388_ '1)
                                (cons (substring
                                       _str45370_
                                       _i45376_
                                       (+ _j45387_ '1))
                                      _r45377_)
                                '#t)
                               (if (and (= _j45387_ _i45376_)
                                        _picked-up-one-undelimited-char?45378_)
                                   (_loop45374_ _k45388_ _r45377_ '#f)
                                   (_loop45374_
                                    _k45388_
                                    (cons (substring
                                           _str45370_
                                           _i45376_
                                           _j45387_)
                                          _r45377_)
                                    '#f))))))
                     _$e45380_)
                    (_loop45374_
                     _n45372_
                     (cons (substring _str45370_ _i45376_ _n45372_) _r45377_)
                     '#f))))))))
  (define std/pregexp#pregexp-replace
    (lambda (_pat45356_ _str45357_ _ins45358_)
      (let* ((_n45360_ (string-length _str45357_))
             (_pp45362_
              (std/pregexp#pregexp-match-positions__%
               _pat45356_
               _str45357_
               '0
               _n45360_)))
        (if (not _pp45362_)
            _str45357_
            (let ((_ins-len45365_ (string-length _ins45358_))
                  (_m-i45366_ (caar _pp45362_))
                  (_m-n45367_ (cdar _pp45362_)))
              (string-append
               (substring _str45357_ '0 _m-i45366_)
               (std/pregexp#pregexp-replace-aux
                _str45357_
                _ins45358_
                _ins-len45365_
                _pp45362_)
               (substring _str45357_ _m-n45367_ _n45360_)))))))
  (define std/pregexp#pregexp-replace*
    (lambda (_pat45341_ _str45342_ _ins45343_)
      (let ((_pat45345_
             (if (string? _pat45341_)
                 (std/pregexp#pregexp _pat45341_)
                 _pat45341_))
            (_n45346_ (string-length _str45342_))
            (_ins-len45347_ (string-length _ins45343_)))
        (let _loop45349_ ((_i45351_ '0) (_r45352_ '""))
          (if (>= _i45351_ _n45346_)
              _r45352_
              (let ((_pp45354_
                     (std/pregexp#pregexp-match-positions__%
                      _pat45345_
                      _str45342_
                      _i45351_
                      _n45346_)))
                (if (not _pp45354_)
                    (if (= _i45351_ '0)
                        _str45342_
                        (string-append
                         _r45352_
                         (substring _str45342_ _i45351_ _n45346_)))
                    (_loop45349_
                     (cdar _pp45354_)
                     (string-append
                      _r45352_
                      (substring _str45342_ _i45351_ (caar _pp45354_))
                      (std/pregexp#pregexp-replace-aux
                       _str45342_
                       _ins45343_
                       _ins-len45347_
                       _pp45354_))))))))))
  (define std/pregexp#pregexp-quote
    (lambda (_s45332_)
      (let _loop45334_ ((_i45336_ (- (string-length _s45332_) '1))
                        (_r45337_ '()))
        (if (< _i45336_ '0)
            (list->string _r45337_)
            (_loop45334_
             (- _i45336_ '1)
             (let ((_c45339_
                    (let ()
                      (declare (not safe))
                      (##string-ref _s45332_ _i45336_))))
               (if (memv _c45339_
                         '(#\\
                           #\.
                           #\?
                           #\*
                           #\+
                           #\|
                           #\^
                           #\$
                           #\[
                           #\]
                           #\{
                           #\}
                           #\(
                           #\)))
                   (cons '#\\ (cons _c45339_ _r45337_))
                   (cons _c45339_ _r45337_)))))))))
