(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/116#<ilist>
    (make-struct-type
     'std/srfi/116#<ilist>
     '#f
     '2
     '<ilist>
     '((fields: icar icdr))
     '#f))
  (define std/srfi/116#ipair? (make-struct-predicate std/srfi/116#<ilist>))
  (define std/srfi/116#icar
    (make-struct-field-accessor std/srfi/116#<ilist> '0))
  (define std/srfi/116#icdr
    (make-struct-field-accessor std/srfi/116#<ilist> '1))
  (define std/srfi/116#ipair
    (lambda (_icar95809_ _icdr95810_)
      (make-struct-instance std/srfi/116#<ilist> _icar95809_ _icdr95810_)))
  (define std/srfi/116#replace-icar
    (lambda (_old95806_ _new95807_)
      (let ((__tmp294926
             (##structure-ref _old95806_ '2 std/srfi/116#<ilist> '#f)))
        (declare (not safe))
        (##structure std/srfi/116#<ilist> _new95807_ __tmp294926))))
  (define std/srfi/116#replace-icdr
    (lambda (_old95803_ _new95804_)
      (let ((__tmp294927
             (##structure-ref _old95803_ '1 std/srfi/116#<ilist> '#f)))
        (declare (not safe))
        (##structure std/srfi/116#<ilist> __tmp294927 _new95804_))))
  (define std/srfi/116#pair->ipair
    (lambda (_pair95801_)
      (let ((__tmp294929 (car _pair95801_)) (__tmp294928 (cdr _pair95801_)))
        (declare (not safe))
        (##structure std/srfi/116#<ilist> __tmp294929 __tmp294928))))
  (define std/srfi/116#ipair->pair
    (lambda (_ipair95799_)
      (cons (##structure-ref _ipair95799_ '1 std/srfi/116#<ilist> '#f)
            (##structure-ref _ipair95799_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#list->ilist
    (lambda (_list95793_)
      (let _lp95795_ ((_list95797_ _list95793_))
        (if (pair? _list95797_)
            (let ((__tmp294931 (car _list95797_))
                  (__tmp294930 (_lp95795_ (cdr _list95797_))))
              (declare (not safe))
              (##structure std/srfi/116#<ilist> __tmp294931 __tmp294930))
            _list95797_))))
  (define std/srfi/116#ilist
    (lambda _objs95791_ (std/srfi/116#list->ilist _objs95791_)))
  (define std/srfi/116#ilist->list
    (lambda (_ilist95785_)
      (let _lp95787_ ((_ilist95789_ _ilist95785_))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _ilist95789_ 'std/srfi/116#<ilist>))
            (cons (##structure-ref _ilist95789_ '1 std/srfi/116#<ilist> '#f)
                  (_lp95787_
                   (##structure-ref _ilist95789_ '2 std/srfi/116#<ilist> '#f)))
            _ilist95789_))))
  (define std/srfi/116#tree->itree
    (lambda (_obj95783_)
      (if (pair? _obj95783_)
          (let ((__tmp294933 (std/srfi/116#tree->itree (car _obj95783_)))
                (__tmp294932 (std/srfi/116#tree->itree (cdr _obj95783_))))
            (declare (not safe))
            (##structure std/srfi/116#<ilist> __tmp294933 __tmp294932))
          _obj95783_)))
  (define std/srfi/116#itree->tree
    (lambda (_obj95781_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj95781_ 'std/srfi/116#<ilist>))
          (cons (std/srfi/116#itree->tree
                 (##structure-ref _obj95781_ '1 std/srfi/116#<ilist> '#f))
                (std/srfi/116#itree->tree
                 (##structure-ref _obj95781_ '2 std/srfi/116#<ilist> '#f)))
          _obj95781_)))
  (define std/srfi/116#gtree->itree
    (lambda (_obj95779_)
      (if (pair? _obj95779_)
          (let ((__tmp294935 (std/srfi/116#gtree->itree (car _obj95779_)))
                (__tmp294934 (std/srfi/116#gtree->itree (cdr _obj95779_))))
            (declare (not safe))
            (##structure std/srfi/116#<ilist> __tmp294935 __tmp294934))
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj95779_ 'std/srfi/116#<ilist>))
              (let ((__tmp294937
                     (std/srfi/116#gtree->itree
                      (##structure-ref
                       _obj95779_
                       '1
                       std/srfi/116#<ilist>
                       '#f)))
                    (__tmp294936
                     (std/srfi/116#gtree->itree
                      (##structure-ref
                       _obj95779_
                       '2
                       std/srfi/116#<ilist>
                       '#f))))
                (declare (not safe))
                (##structure std/srfi/116#<ilist> __tmp294937 __tmp294936))
              _obj95779_))))
  (define std/srfi/116#gtree->tree
    (lambda (_obj95777_)
      (if (pair? _obj95777_)
          (cons (std/srfi/116#gtree->tree (car _obj95777_))
                (std/srfi/116#gtree->tree (cdr _obj95777_)))
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj95777_ 'std/srfi/116#<ilist>))
              (cons (std/srfi/116#gtree->tree
                     (##structure-ref _obj95777_ '1 std/srfi/116#<ilist> '#f))
                    (std/srfi/116#gtree->tree
                     (##structure-ref _obj95777_ '2 std/srfi/116#<ilist> '#f)))
              _obj95777_))))
  (define std/srfi/116#take!
    (lambda (_ls95772_ _i95773_)
      (if (<= _i95773_ '0)
          '()
          (let ((_tail95775_ (list-tail _ls95772_ (- _i95773_ '1))))
            (set-cdr! _tail95775_ '())
            _ls95772_))))
  (define std/srfi/116#drop-right!
    (lambda (_ls95769_ _i95770_)
      (std/srfi/116#take! _ls95769_ (- (length _ls95769_) _i95770_))))
  (define std/srfi/116#last
    (lambda (_ls95767_)
      (if (null? (cdr _ls95767_))
          (car _ls95767_)
          (std/srfi/116#last (cdr _ls95767_)))))
  (define std/srfi/116#iapply
    (lambda (_proc95762_ . _ilists95763_)
      (if (null? _ilists95763_)
          (apply _proc95762_ '())
          (if (null? (cdr _ilists95763_))
              (apply _proc95762_
                     (std/srfi/116#ilist->list (car _ilists95763_)))
              (let ((_final95765_
                     (std/srfi/116#ilist->list
                      (std/srfi/116#last _ilists95763_))))
                (apply _proc95762_
                       (append (std/srfi/116#drop-right! _ilists95763_ '1)
                               _final95765_)))))))
  (define std/srfi/116#write-ipair
    (lambda (_ipair95759_ _port95760_)
      (write (std/srfi/116#gtree->tree _ipair95759_) _port95760_)))
  (define std/srfi/116#iassq
    (lambda (_x95754_ _lis95755_)
      (std/srfi/116#ifind
       (lambda (_entry95757_)
         (eq? _x95754_
              (##structure-ref _entry95757_ '1 std/srfi/116#<ilist> '#f)))
       _lis95755_)))
  (define std/srfi/116#iassv
    (lambda (_x95749_ _lis95750_)
      (std/srfi/116#ifind
       (lambda (_entry95752_)
         (eqv? _x95749_
               (##structure-ref _entry95752_ '1 std/srfi/116#<ilist> '#f)))
       _lis95750_)))
  (define std/srfi/116#ifor-each
    (lambda (_proc95733_ _lis195734_ . _lists95735_)
      (std/srfi/116#check-arg
       procedure?
       _proc95733_
       std/srfi/116#ipair-for-each)
      (if (pair? _lists95735_)
          (let _lp95737_ ((_lists95739_ (cons _lis195734_ _lists95735_)))
            (let ((_tails95741_ (std/srfi/116#%cdrs _lists95739_)))
              (if (pair? _tails95741_)
                  (begin
                    (apply _proc95733_ (map std/srfi/116#icar _lists95739_))
                    (_lp95737_ _tails95741_))
                  '#!void)))
          (let _lp95743_ ((_lis95745_ _lis195734_))
            (if (not (std/srfi/116#null-ilist? _lis95745_))
                (let ((_tail95747_
                       (##structure-ref
                        _lis95745_
                        '2
                        std/srfi/116#<ilist>
                        '#f)))
                  (_proc95733_
                   (##structure-ref _lis95745_ '1 std/srfi/116#<ilist> '#f))
                  (_lp95743_ _tail95747_))
                '#!void)))))
  (define std/srfi/116#check-arg
    (lambda (_pred95725_ _val95726_ _caller95727_)
      (let _lp95729_ ((_val95731_ _val95726_))
        (if (_pred95725_ _val95731_)
            _val95731_
            (_lp95729_
             (error '"Bad argument" _val95731_ _pred95725_ _caller95727_))))))
  (define std/srfi/116#xipair
    (lambda (_d95722_ _a95723_)
      (let ()
        (declare (not safe))
        (##structure std/srfi/116#<ilist> _a95723_ _d95722_))))
  (define std/srfi/116#make-ilist
    (lambda (_len95709_ . _maybe-elt95710_)
      (std/srfi/116#check-arg
       (lambda (_n95712_) (if (integer? _n95712_) (>= _n95712_ '0) '#f))
       _len95709_
       std/srfi/116#make-ilist)
      (let ((_elt95714_
             (if (null? _maybe-elt95710_)
                 '#f
                 (if (null? (cdr _maybe-elt95710_))
                     (car _maybe-elt95710_)
                     (error '"Too many arguments to MAKE-ILIST"
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/srfi/116#<ilist>
                               _len95709_
                               _maybe-elt95710_)))))))
        (let _$loop95716_ ((_i95719_ _len95709_) (_ans95720_ '()))
          (if (<= _i95719_ '0)
              _ans95720_
              (_$loop95716_
               (- _i95719_ '1)
               (let ()
                 (declare (not safe))
                 (##structure
                  std/srfi/116#<ilist>
                  _elt95714_
                  _ans95720_))))))))
  (define std/srfi/116#ilist-tabulate
    (lambda (_len95698_ _proc95699_)
      (std/srfi/116#check-arg
       (lambda (_n95701_) (if (integer? _n95701_) (>= _n95701_ '0) '#f))
       _len95698_
       std/srfi/116#ilist-tabulate)
      (std/srfi/116#check-arg
       procedure?
       _proc95699_
       std/srfi/116#ilist-tabulate)
      (let _$loop95703_ ((_i95706_ (- _len95698_ '1)) (_ans95707_ '()))
        (if (< _i95706_ '0)
            _ans95707_
            (_$loop95703_
             (- _i95706_ '1)
             (let ((__tmp294938 (_proc95699_ _i95706_)))
               (declare (not safe))
               (##structure std/srfi/116#<ilist> __tmp294938 _ans95707_)))))))
  (define std/srfi/116#ipair*
    (lambda (_ifirst95690_ . _rest95691_)
      (let _recur95693_ ((_x95695_ _ifirst95690_) (_rest95696_ _rest95691_))
        (if (pair? _rest95696_)
            (let ((__tmp294939
                   (_recur95693_ (car _rest95696_) (cdr _rest95696_))))
              (declare (not safe))
              (##structure std/srfi/116#<ilist> _x95695_ __tmp294939))
            _x95695_))))
  (define std/srfi/116#ilist-copy
    (lambda (_lis95684_)
      (let _recur95686_ ((_lis95688_ _lis95684_))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _lis95688_ 'std/srfi/116#<ilist>))
            (let ((__tmp294941
                   (##structure-ref _lis95688_ '1 std/srfi/116#<ilist> '#f))
                  (__tmp294940
                   (_recur95686_
                    (##structure-ref _lis95688_ '2 std/srfi/116#<ilist> '#f))))
              (declare (not safe))
              (##structure std/srfi/116#<ilist> __tmp294941 __tmp294940))
            _lis95688_))))
  (define std/srfi/116#iiota
    (lambda (_count95673_ . _maybe-start+step95674_)
      (std/srfi/116#check-arg integer? _count95673_ std/srfi/116#iiota)
      (if (< _count95673_ '0)
          (error '"Negative step count" std/srfi/116#iiota _count95673_)
          '#!void)
      (let ((_start95676_
             (if (pair? _maybe-start+step95674_)
                 (car _maybe-start+step95674_)
                 '0))
            (_step95677_
             (if (and (pair? _maybe-start+step95674_)
                      (pair? (cdr _maybe-start+step95674_)))
                 (cadr _maybe-start+step95674_)
                 '1)))
        (std/srfi/116#check-arg number? _start95676_ std/srfi/116#iiota)
        (std/srfi/116#check-arg number? _step95677_ std/srfi/116#iiota)
        (let _loop95679_ ((_n95681_ '0) (_r95682_ '()))
          (if (= _n95681_ _count95673_)
              (std/srfi/116#ireverse _r95682_)
              (_loop95679_
               (+ '1 _n95681_)
               (let ((__tmp294942 (+ _start95676_ (* _n95681_ _step95677_))))
                 (declare (not safe))
                 (##structure std/srfi/116#<ilist> __tmp294942 _r95682_))))))))
  (define std/srfi/116#ilist?
    (lambda (_x95671_) (std/srfi/116#proper-ilist? _x95671_)))
  (define std/srfi/116#proper-ilist?
    (lambda (_x95659_)
      (let _lp95661_ ((_x95663_ _x95659_) (_lag95664_ _x95659_))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _x95663_ 'std/srfi/116#<ilist>))
            (let ((_x95666_
                   (##structure-ref _x95663_ '2 std/srfi/116#<ilist> '#f)))
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of? _x95666_ 'std/srfi/116#<ilist>))
                  (let ((_x95668_
                         (##structure-ref
                          _x95666_
                          '2
                          std/srfi/116#<ilist>
                          '#f))
                        (_lag95669_
                         (##structure-ref
                          _lag95664_
                          '2
                          std/srfi/116#<ilist>
                          '#f)))
                    (if (not (eq? _x95668_ _lag95669_))
                        (_lp95661_ _x95668_ _lag95669_)
                        '#f))
                  (null? _x95666_)))
            (null? _x95663_)))))
  (define std/srfi/116#dotted-ilist?
    (lambda (_x95647_)
      (let _lp95649_ ((_x95651_ _x95647_) (_lag95652_ _x95647_))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _x95651_ 'std/srfi/116#<ilist>))
            (let ((_x95654_
                   (##structure-ref _x95651_ '2 std/srfi/116#<ilist> '#f)))
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of? _x95654_ 'std/srfi/116#<ilist>))
                  (let ((_x95656_
                         (##structure-ref
                          _x95654_
                          '2
                          std/srfi/116#<ilist>
                          '#f))
                        (_lag95657_
                         (##structure-ref
                          _lag95652_
                          '2
                          std/srfi/116#<ilist>
                          '#f)))
                    (if (not (eq? _x95656_ _lag95657_))
                        (_lp95649_ _x95656_ _lag95657_)
                        '#f))
                  (not (null? _x95654_))))
            (not (null? _x95651_))))))
  (define std/srfi/116#not-ipair?
    (lambda (_x95645_)
      (not (let ()
             (declare (not safe))
             (##structure-instance-of? _x95645_ 'std/srfi/116#<ilist>)))))
  (define std/srfi/116#null-ilist?
    (lambda (_l95643_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _l95643_ 'std/srfi/116#<ilist>))
          '#f
          (if (null? _l95643_)
              '#t
              (error '"null-ilist?: argument out of domain" _l95643_)))))
  (define std/srfi/116#ilist=
    (lambda (_=95621_ . _ilists95622_)
      (let ((_$e95624_ (null? _ilists95622_)))
        (if _$e95624_
            _$e95624_
            (let _lp195627_ ((_ilist-a95629_ (car _ilists95622_))
                             (_others95630_ (cdr _ilists95622_)))
              (let ((_$e95632_ (null? _others95630_)))
                (if _$e95632_
                    _$e95632_
                    (let ((_ilist-b95635_ (car _others95630_))
                          (_others95636_ (cdr _others95630_)))
                      (if (eq? _ilist-a95629_ _ilist-b95635_)
                          (_lp195627_ _ilist-b95635_ _others95636_)
                          (let _lp295638_ ((_pair-a95640_ _ilist-a95629_)
                                           (_pair-b95641_ _ilist-b95635_))
                            (if (std/srfi/116#null-ilist? _pair-a95640_)
                                (if (std/srfi/116#null-ilist? _pair-b95641_)
                                    (_lp195627_ _ilist-b95635_ _others95636_)
                                    '#f)
                                (if (not (std/srfi/116#null-ilist?
                                          _pair-b95641_))
                                    (if (_=95621_
                                         (##structure-ref
                                          _pair-a95640_
                                          '1
                                          std/srfi/116#<ilist>
                                          '#f)
                                         (##structure-ref
                                          _pair-b95641_
                                          '1
                                          std/srfi/116#<ilist>
                                          '#f))
                                        (_lp295638_
                                         (##structure-ref
                                          _pair-a95640_
                                          '2
                                          std/srfi/116#<ilist>
                                          '#f)
                                         (##structure-ref
                                          _pair-b95641_
                                          '2
                                          std/srfi/116#<ilist>
                                          '#f))
                                        '#f)
                                    '#f))))))))))))
  (define std/srfi/116#ilength
    (lambda (_x95614_)
      (let _lp95616_ ((_x95618_ _x95614_) (_len95619_ '0))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _x95618_ 'std/srfi/116#<ilist>))
            (_lp95616_
             (##structure-ref _x95618_ '2 std/srfi/116#<ilist> '#f)
             (+ _len95619_ '1))
            _len95619_))))
  (define std/srfi/116#izip
    (lambda (_ilist195611_ . _more-lists95612_)
      (apply std/srfi/116#imap
             std/srfi/116#ilist
             _ilist195611_
             _more-lists95612_)))
  (define std/srfi/116#icaar
    (lambda (_x95609_)
      (##structure-ref
       (##structure-ref _x95609_ '1 std/srfi/116#<ilist> '#f)
       '1
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#icadr
    (lambda (_x95607_)
      (##structure-ref
       (##structure-ref _x95607_ '2 std/srfi/116#<ilist> '#f)
       '1
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#icdar
    (lambda (_x95605_)
      (##structure-ref
       (##structure-ref _x95605_ '1 std/srfi/116#<ilist> '#f)
       '2
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#icddr
    (lambda (_x95603_)
      (##structure-ref
       (##structure-ref _x95603_ '2 std/srfi/116#<ilist> '#f)
       '2
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#icaaar
    (lambda (_x95601_)
      (std/srfi/116#icaar
       (##structure-ref _x95601_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaadr
    (lambda (_x95599_)
      (std/srfi/116#icaar
       (##structure-ref _x95599_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icadar
    (lambda (_x95597_)
      (std/srfi/116#icadr
       (##structure-ref _x95597_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaddr
    (lambda (_x95595_)
      (std/srfi/116#icadr
       (##structure-ref _x95595_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdaar
    (lambda (_x95593_)
      (std/srfi/116#icdar
       (##structure-ref _x95593_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdadr
    (lambda (_x95591_)
      (std/srfi/116#icdar
       (##structure-ref _x95591_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icddar
    (lambda (_x95589_)
      (std/srfi/116#icddr
       (##structure-ref _x95589_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdddr
    (lambda (_x95587_)
      (std/srfi/116#icddr
       (##structure-ref _x95587_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaaaar
    (lambda (_x95585_)
      (std/srfi/116#icaaar
       (##structure-ref _x95585_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaaadr
    (lambda (_x95583_)
      (std/srfi/116#icaaar
       (##structure-ref _x95583_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaadar
    (lambda (_x95581_)
      (std/srfi/116#icaadr
       (##structure-ref _x95581_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaaddr
    (lambda (_x95579_)
      (std/srfi/116#icaadr
       (##structure-ref _x95579_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icadaar
    (lambda (_x95577_)
      (std/srfi/116#icadar
       (##structure-ref _x95577_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icadadr
    (lambda (_x95575_)
      (std/srfi/116#icadar
       (##structure-ref _x95575_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icaddar
    (lambda (_x95573_)
      (std/srfi/116#icaddr
       (##structure-ref _x95573_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icadddr
    (lambda (_x95571_)
      (std/srfi/116#icaddr
       (##structure-ref _x95571_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdaaar
    (lambda (_x95569_)
      (std/srfi/116#icdaar
       (##structure-ref _x95569_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdaadr
    (lambda (_x95567_)
      (std/srfi/116#icdaar
       (##structure-ref _x95567_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdadar
    (lambda (_x95565_)
      (std/srfi/116#icdadr
       (##structure-ref _x95565_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdaddr
    (lambda (_x95563_)
      (std/srfi/116#icdadr
       (##structure-ref _x95563_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icddaar
    (lambda (_x95561_)
      (std/srfi/116#icddar
       (##structure-ref _x95561_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icddadr
    (lambda (_x95559_)
      (std/srfi/116#icddar
       (##structure-ref _x95559_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icdddar
    (lambda (_x95557_)
      (std/srfi/116#icdddr
       (##structure-ref _x95557_ '1 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#icddddr
    (lambda (_x95555_)
      (std/srfi/116#icdddr
       (##structure-ref _x95555_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#ifirst std/srfi/116#icar)
  (define std/srfi/116#isecond std/srfi/116#icadr)
  (define std/srfi/116#ithird std/srfi/116#icaddr)
  (define std/srfi/116#ifourth std/srfi/116#icadddr)
  (define std/srfi/116#ififth
    (lambda (_x95553_)
      (##structure-ref
       (std/srfi/116#icddddr _x95553_)
       '1
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#isixth
    (lambda (_x95551_) (std/srfi/116#icadr (std/srfi/116#icddddr _x95551_))))
  (define std/srfi/116#iseventh
    (lambda (_x95549_) (std/srfi/116#icaddr (std/srfi/116#icddddr _x95549_))))
  (define std/srfi/116#ieighth
    (lambda (_x95547_) (std/srfi/116#icadddr (std/srfi/116#icddddr _x95547_))))
  (define std/srfi/116#ininth
    (lambda (_x95545_)
      (##structure-ref
       (std/srfi/116#icddddr (std/srfi/116#icddddr _x95545_))
       '1
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#itenth
    (lambda (_x95543_)
      (std/srfi/116#icadr
       (std/srfi/116#icddddr (std/srfi/116#icddddr _x95543_)))))
  (define std/srfi/116#icar+icdr
    (lambda (_ipair95541_)
      (values (##structure-ref _ipair95541_ '1 std/srfi/116#<ilist> '#f)
              (##structure-ref _ipair95541_ '2 std/srfi/116#<ilist> '#f))))
  (define std/srfi/116#itake
    (lambda (_lis95533_ _k95534_)
      (std/srfi/116#check-arg integer? _k95534_ std/srfi/116#itake)
      (let _recur95536_ ((_lis95538_ _lis95533_) (_k95539_ _k95534_))
        (if (zero? _k95539_)
            '()
            (let ((__tmp294944
                   (##structure-ref _lis95538_ '1 std/srfi/116#<ilist> '#f))
                  (__tmp294943
                   (_recur95536_
                    (##structure-ref _lis95538_ '2 std/srfi/116#<ilist> '#f)
                    (- _k95539_ '1))))
              (declare (not safe))
              (##structure std/srfi/116#<ilist> __tmp294944 __tmp294943))))))
  (define std/srfi/116#ilist-tail
    (lambda (_lis95530_ _k95531_) (std/srfi/116#idrop _lis95530_ _k95531_)))
  (define std/srfi/116#idrop
    (lambda (_lis95522_ _k95523_)
      (std/srfi/116#check-arg integer? _k95523_ std/srfi/116#idrop)
      (let _iter95525_ ((_lis95527_ _lis95522_) (_k95528_ _k95523_))
        (if (zero? _k95528_)
            _lis95527_
            (_iter95525_
             (##structure-ref _lis95527_ '2 std/srfi/116#<ilist> '#f)
             (- _k95528_ '1))))))
  (define std/srfi/116#itake-right
    (lambda (_lis95514_ _k95515_)
      (std/srfi/116#check-arg integer? _k95515_ std/srfi/116#itake-right)
      (let _lp95517_ ((_lag95519_ _lis95514_)
                      (_lead95520_ (std/srfi/116#idrop _lis95514_ _k95515_)))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _lead95520_ 'std/srfi/116#<ilist>))
            (_lp95517_
             (##structure-ref _lag95519_ '2 std/srfi/116#<ilist> '#f)
             (##structure-ref _lead95520_ '2 std/srfi/116#<ilist> '#f))
            _lag95519_))))
  (define std/srfi/116#idrop-right
    (lambda (_lis95506_ _k95507_)
      (std/srfi/116#check-arg integer? _k95507_ std/srfi/116#idrop-right)
      (let _recur95509_ ((_lag95511_ _lis95506_)
                         (_lead95512_
                          (std/srfi/116#idrop _lis95506_ _k95507_)))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _lead95512_ 'std/srfi/116#<ilist>))
            (let ((__tmp294946
                   (##structure-ref _lag95511_ '1 std/srfi/116#<ilist> '#f))
                  (__tmp294945
                   (_recur95509_
                    (##structure-ref _lag95511_ '2 std/srfi/116#<ilist> '#f)
                    (##structure-ref
                     _lead95512_
                     '2
                     std/srfi/116#<ilist>
                     '#f))))
              (declare (not safe))
              (##structure std/srfi/116#<ilist> __tmp294946 __tmp294945))
            '()))))
  (define std/srfi/116#ilist-ref
    (lambda (_lis95503_ _i95504_)
      (##structure-ref
       (std/srfi/116#idrop _lis95503_ _i95504_)
       '1
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#isplit-at
    (lambda (_x95491_ _k95492_)
      (std/srfi/116#check-arg integer? _k95492_ std/srfi/116#isplit-at)
      (let _recur95494_ ((_lis95496_ _x95491_) (_k95497_ _k95492_))
        (if (zero? _k95497_)
            (values '() _lis95496_)
            (call-with-values
             (lambda ()
               (_recur95494_
                (##structure-ref _lis95496_ '2 std/srfi/116#<ilist> '#f)
                (- _k95497_ '1)))
             (lambda (_prefix95500_ _suffix95501_)
               (values (let ((__tmp294947
                              (##structure-ref
                               _lis95496_
                               '1
                               std/srfi/116#<ilist>
                               '#f)))
                         (declare (not safe))
                         (##structure
                          std/srfi/116#<ilist>
                          __tmp294947
                          _prefix95500_))
                       _suffix95501_)))))))
  (define std/srfi/116#ilast
    (lambda (_lis95489_)
      (##structure-ref
       (std/srfi/116#last-ipair _lis95489_)
       '1
       std/srfi/116#<ilist>
       '#f)))
  (define std/srfi/116#last-ipair
    (lambda (_lis95481_)
      (std/srfi/116#check-arg
       std/srfi/116#ipair?
       _lis95481_
       std/srfi/116#last-ipair)
      (let _lp95483_ ((_lis95485_ _lis95481_))
        (let ((_tail95487_
               (##structure-ref _lis95485_ '2 std/srfi/116#<ilist> '#f)))
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _tail95487_ 'std/srfi/116#<ilist>))
              (_lp95483_ _tail95487_)
              _lis95485_)))))
  (define std/srfi/116#iunzip1
    (lambda (_lis95479_) (std/srfi/116#imap std/srfi/116#icar _lis95479_)))
  (define std/srfi/116#iunzip2
    (lambda (_lis95467_)
      (let _recur95469_ ((_lis95471_ _lis95467_))
        (if (std/srfi/116#null-ilist? _lis95471_)
            (values _lis95471_ _lis95471_)
            (let ((_elt95473_
                   (##structure-ref _lis95471_ '1 std/srfi/116#<ilist> '#f)))
              (call-with-values
               (lambda ()
                 (_recur95469_
                  (##structure-ref _lis95471_ '2 std/srfi/116#<ilist> '#f)))
               (lambda (_a95476_ _b95477_)
                 (values (let ((__tmp294948
                                (##structure-ref
                                 _elt95473_
                                 '1
                                 std/srfi/116#<ilist>
                                 '#f)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294948
                            _a95476_))
                         (let ((__tmp294949 (std/srfi/116#icadr _elt95473_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294949
                            _b95477_))))))))))
  (define std/srfi/116#iunzip3
    (lambda (_lis95454_)
      (let _recur95456_ ((_lis95458_ _lis95454_))
        (if (std/srfi/116#null-ilist? _lis95458_)
            (values _lis95458_ _lis95458_ _lis95458_)
            (let ((_elt95460_
                   (##structure-ref _lis95458_ '1 std/srfi/116#<ilist> '#f)))
              (call-with-values
               (lambda ()
                 (_recur95456_
                  (##structure-ref _lis95458_ '2 std/srfi/116#<ilist> '#f)))
               (lambda (_a95463_ _b95464_ _c95465_)
                 (values (let ((__tmp294950
                                (##structure-ref
                                 _elt95460_
                                 '1
                                 std/srfi/116#<ilist>
                                 '#f)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294950
                            _a95463_))
                         (let ((__tmp294951 (std/srfi/116#icadr _elt95460_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294951
                            _b95464_))
                         (let ((__tmp294952 (std/srfi/116#icaddr _elt95460_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294952
                            _c95465_))))))))))
  (define std/srfi/116#iunzip4
    (lambda (_lis95440_)
      (let _recur95442_ ((_lis95444_ _lis95440_))
        (if (std/srfi/116#null-ilist? _lis95444_)
            (values _lis95444_ _lis95444_ _lis95444_ _lis95444_)
            (let ((_elt95446_
                   (##structure-ref _lis95444_ '1 std/srfi/116#<ilist> '#f)))
              (call-with-values
               (lambda ()
                 (_recur95442_
                  (##structure-ref _lis95444_ '2 std/srfi/116#<ilist> '#f)))
               (lambda (_a95449_ _b95450_ _c95451_ _d95452_)
                 (values (let ((__tmp294953
                                (##structure-ref
                                 _elt95446_
                                 '1
                                 std/srfi/116#<ilist>
                                 '#f)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294953
                            _a95449_))
                         (let ((__tmp294954 (std/srfi/116#icadr _elt95446_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294954
                            _b95450_))
                         (let ((__tmp294955 (std/srfi/116#icaddr _elt95446_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294955
                            _c95451_))
                         (let ((__tmp294956 (std/srfi/116#icadddr _elt95446_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294956
                            _d95452_))))))))))
  (define std/srfi/116#iunzip5
    (lambda (_lis95425_)
      (let _recur95427_ ((_lis95429_ _lis95425_))
        (if (std/srfi/116#null-ilist? _lis95429_)
            (values _lis95429_ _lis95429_ _lis95429_ _lis95429_ _lis95429_)
            (let ((_elt95431_
                   (##structure-ref _lis95429_ '1 std/srfi/116#<ilist> '#f)))
              (call-with-values
               (lambda ()
                 (_recur95427_
                  (##structure-ref _lis95429_ '2 std/srfi/116#<ilist> '#f)))
               (lambda (_a95434_ _b95435_ _c95436_ _d95437_ _e95438_)
                 (values (let ((__tmp294957
                                (##structure-ref
                                 _elt95431_
                                 '1
                                 std/srfi/116#<ilist>
                                 '#f)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294957
                            _a95434_))
                         (let ((__tmp294958 (std/srfi/116#icadr _elt95431_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294958
                            _b95435_))
                         (let ((__tmp294959 (std/srfi/116#icaddr _elt95431_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294959
                            _c95436_))
                         (let ((__tmp294960 (std/srfi/116#icadddr _elt95431_)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294960
                            _d95437_))
                         (let ((__tmp294961
                                (##structure-ref
                                 (std/srfi/116#icddddr _elt95431_)
                                 '1
                                 std/srfi/116#<ilist>
                                 '#f)))
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            __tmp294961
                            _e95438_))))))))))
  (define std/srfi/116#iappend
    (lambda _lists95416_
      (if (pair? _lists95416_)
          (let _recur95418_ ((_list195420_ (car _lists95416_))
                             (_lists95421_ (cdr _lists95416_)))
            (if (pair? _lists95421_)
                (let ((_tail95423_
                       (_recur95418_ (car _lists95421_) (cdr _lists95421_))))
                  (std/srfi/116#ifold-right
                   std/srfi/116#ipair
                   _tail95423_
                   _list195420_))
                _list195420_))
          '())))
  (define std/srfi/116#iappend-reverse
    (lambda (_rev-head95408_ _tail95409_)
      (let _lp95411_ ((_rev-head95413_ _rev-head95408_)
                      (_tail95414_ _tail95409_))
        (if (std/srfi/116#null-ilist? _rev-head95413_)
            _tail95414_
            (_lp95411_
             (##structure-ref _rev-head95413_ '2 std/srfi/116#<ilist> '#f)
             (let ((__tmp294962
                    (##structure-ref
                     _rev-head95413_
                     '1
                     std/srfi/116#<ilist>
                     '#f)))
               (declare (not safe))
               (##structure std/srfi/116#<ilist> __tmp294962 _tail95414_)))))))
  (define std/srfi/116#iconcatenate
    (lambda (_lists95406_)
      (std/srfi/116#ireduce-right std/srfi/116#iappend '() _lists95406_)))
  (define std/srfi/116#%cdrs
    (lambda (_lists95396_)
      (call-with-current-continuation
       (lambda (_abort95398_)
         (let _recur95400_ ((_lists95402_ _lists95396_))
           (if (pair? _lists95402_)
               (let ((_lis95404_ (car _lists95402_)))
                 (if (null? _lis95404_)
                     (_abort95398_ '())
                     (cons (##structure-ref
                            _lis95404_
                            '2
                            std/srfi/116#<ilist>
                            '#f)
                           (_recur95400_ (cdr _lists95402_)))))
               '()))))))
  (define std/srfi/116#%cars+
    (lambda (_lists95389_ _last-elt95390_)
      (let _recur95392_ ((_lists95394_ _lists95389_))
        (if (pair? _lists95394_)
            (cons (##structure-ref
                   (car _lists95394_)
                   '1
                   std/srfi/116#<ilist>
                   '#f)
                  (_recur95392_ (cdr _lists95394_)))
            (list _last-elt95390_)))))
  (define std/srfi/116#%cars+cdrs
    (lambda (_ilists95371_)
      (call-with-current-continuation
       (lambda (_abort95373_)
         (let _recur95375_ ((_ilists95377_ _ilists95371_))
           (if (pair? _ilists95377_)
               (let ((_ilist95379_ (car _ilists95377_))
                     (_other-ilists95380_ (cdr _ilists95377_)))
                 (if (null? _ilist95379_)
                     (_abort95373_ '() '())
                     (let ((_a95382_
                            (##structure-ref
                             _ilist95379_
                             '1
                             std/srfi/116#<ilist>
                             '#f))
                           (_d95383_
                            (##structure-ref
                             _ilist95379_
                             '2
                             std/srfi/116#<ilist>
                             '#f)))
                       (call-with-values
                        (lambda () (_recur95375_ _other-ilists95380_))
                        (lambda (_icars95386_ _icdrs95387_)
                          (values (cons _a95382_ _icars95386_)
                                  (cons _d95383_ _icdrs95387_)))))))
               (values '() '())))))))
  (define std/srfi/116#%cars+cdrs+
    (lambda (_ilists95351_ _cars-final95352_)
      (call-with-current-continuation
       (lambda (_abort95354_)
         (let _recur95356_ ((_ilists95358_ _ilists95351_))
           (if (pair? _ilists95358_)
               (let ((_ilist95360_ (car _ilists95358_))
                     (_other-ilists95361_ (cdr _ilists95358_)))
                 (if (null? _ilist95360_)
                     (_abort95354_ '() '())
                     (call-with-values
                      (lambda () (std/srfi/116#icar+icdr _ilist95360_))
                      (lambda (_a95364_ _d95365_)
                        (call-with-values
                         (lambda () (_recur95356_ _other-ilists95361_))
                         (lambda (_cars95368_ _cdrs95369_)
                           (values (cons _a95364_ _cars95368_)
                                   (cons _d95365_ _cdrs95369_))))))))
               (values (list _cars-final95352_) '())))))))
  (define std/srfi/116#%cars+cdrs/no-test
    (lambda (_ilists95335_)
      (let _recur95337_ ((_ilists95339_ _ilists95335_))
        (if (pair? _ilists95339_)
            (let ((_ilist95341_ (car _ilists95339_))
                  (_other-ilists95342_ (cdr _ilists95339_)))
              (let ((_a95344_
                     (##structure-ref
                      _ilist95341_
                      '1
                      std/srfi/116#<ilist>
                      '#f))
                    (_d95345_
                     (##structure-ref
                      _ilist95341_
                      '2
                      std/srfi/116#<ilist>
                      '#f)))
                (call-with-values
                 (lambda () (_recur95337_ _other-ilists95342_))
                 (lambda (_cars95348_ _cdrs95349_)
                   (values (cons _a95344_ _cars95348_)
                           (cons _d95345_ _cdrs95349_))))))
            (values '() '())))))
  (define std/srfi/116#icount
    (lambda (_pred95316_ _ilist195317_ . _ilists95318_)
      (std/srfi/116#check-arg procedure? _pred95316_ std/srfi/116#icount)
      (if (pair? _ilists95318_)
          (let _lp95320_ ((_ilist195322_ _ilist195317_)
                          (_ilists95323_ _ilists95318_)
                          (_i95324_ '0))
            (if (std/srfi/116#null-ilist? _ilist195322_)
                _i95324_
                (call-with-values
                 (lambda () (std/srfi/116#%cars+cdrs _ilists95323_))
                 (lambda (_as95327_ _ds95328_)
                   (if (null? _as95327_)
                       _i95324_
                       (_lp95320_
                        (##structure-ref
                         _ilist195322_
                         '2
                         std/srfi/116#<ilist>
                         '#f)
                        _ds95328_
                        (if (apply _pred95316_
                                   (##structure-ref
                                    _ilist195322_
                                    '1
                                    std/srfi/116#<ilist>
                                    '#f)
                                   _as95327_)
                            (+ _i95324_ '1)
                            _i95324_)))))))
          (let _lp95330_ ((_lis95332_ _ilist195317_) (_i95333_ '0))
            (if (std/srfi/116#null-ilist? _lis95332_)
                _i95333_
                (_lp95330_
                 (##structure-ref _lis95332_ '2 std/srfi/116#<ilist> '#f)
                 (if (_pred95316_
                      (##structure-ref _lis95332_ '1 std/srfi/116#<ilist> '#f))
                     (+ _i95333_ '1)
                     _i95333_)))))))
  (define std/srfi/116#iunfold-right
    (lambda (_p95305_ _f95306_ _g95307_ _seed95308_ . _maybe-tail95309_)
      (std/srfi/116#check-arg procedure? _p95305_ std/srfi/116#iunfold-right)
      (std/srfi/116#check-arg procedure? _f95306_ std/srfi/116#iunfold-right)
      (std/srfi/116#check-arg procedure? _g95307_ std/srfi/116#iunfold-right)
      (let _lp95311_ ((_seed95313_ _seed95308_)
                      (_ans95314_
                       (if (null? _maybe-tail95309_)
                           '()
                           (if (null? (cdr _maybe-tail95309_))
                               (car _maybe-tail95309_)
                               (error '"Too many arguments")))))
        (if (_p95305_ _seed95313_)
            _ans95314_
            (_lp95311_
             (_g95307_ _seed95313_)
             (let ((__tmp294963 (_f95306_ _seed95313_)))
               (declare (not safe))
               (##structure std/srfi/116#<ilist> __tmp294963 _ans95314_)))))))
  (define std/srfi/116#iunfold
    (lambda (_p95289_ _f95290_ _g95291_ _seed95292_ . _maybe-tail-gen95293_)
      (std/srfi/116#check-arg procedure? _p95289_ std/srfi/116#iunfold)
      (std/srfi/116#check-arg procedure? _f95290_ std/srfi/116#iunfold)
      (std/srfi/116#check-arg procedure? _g95291_ std/srfi/116#iunfold)
      (if (pair? _maybe-tail-gen95293_)
          (let ((_tail-gen95295_ (car _maybe-tail-gen95293_)))
            (if (pair? (cdr _maybe-tail-gen95293_))
                (apply error
                       '"Too many arguments"
                       std/srfi/116#iunfold
                       _p95289_
                       _f95290_
                       _g95291_
                       _seed95292_
                       _maybe-tail-gen95293_)
                (let _recur95297_ ((_seed95299_ _seed95292_))
                  (if (_p95289_ _seed95299_)
                      (_tail-gen95295_ _seed95299_)
                      (let ((__tmp294965 (_f95290_ _seed95299_))
                            (__tmp294964
                             (_recur95297_ (_g95291_ _seed95299_))))
                        (declare (not safe))
                        (##structure
                         std/srfi/116#<ilist>
                         __tmp294965
                         __tmp294964))))))
          (let _recur95301_ ((_seed95303_ _seed95292_))
            (if (_p95289_ _seed95303_)
                '()
                (let ((__tmp294967 (_f95290_ _seed95303_))
                      (__tmp294966 (_recur95301_ (_g95291_ _seed95303_))))
                  (declare (not safe))
                  (##structure
                   std/srfi/116#<ilist>
                   __tmp294967
                   __tmp294966)))))))
  (define std/srfi/116#ifold
    (lambda (_kons95270_ _knil95271_ _ilis195272_ . _ilists95273_)
      (std/srfi/116#check-arg procedure? _kons95270_ std/srfi/116#ifold)
      (if (pair? _ilists95273_)
          (let _lp95275_ ((_ilists95277_ (cons _ilis195272_ _ilists95273_))
                          (_ans95278_ _knil95271_))
            (call-with-values
             (lambda () (std/srfi/116#%cars+cdrs+ _ilists95277_ _ans95278_))
             (lambda (_cars+ans95281_ _cdrs95282_)
               (if (null? _cars+ans95281_)
                   _ans95278_
                   (_lp95275_
                    _cdrs95282_
                    (apply _kons95270_ _cars+ans95281_))))))
          (let _lp95284_ ((_ilis95286_ _ilis195272_) (_ans95287_ _knil95271_))
            (if (std/srfi/116#null-ilist? _ilis95286_)
                _ans95287_
                (_lp95284_
                 (##structure-ref _ilis95286_ '2 std/srfi/116#<ilist> '#f)
                 (_kons95270_
                  (##structure-ref _ilis95286_ '1 std/srfi/116#<ilist> '#f)
                  _ans95287_)))))))
  (define std/srfi/116#ifold-right
    (lambda (_kons95253_ _knil95254_ _ilis195255_ . _ilists95256_)
      (std/srfi/116#check-arg procedure? _kons95253_ std/srfi/116#ifold-right)
      (if (pair? _ilists95256_)
          (let _recur95258_ ((_ilists95260_ (cons _ilis195255_ _ilists95256_)))
            (let ((_cdrs95262_ (std/srfi/116#%cdrs _ilists95260_)))
              (if (null? _cdrs95262_)
                  _knil95254_
                  (apply _kons95253_
                         (std/srfi/116#%cars+
                          _ilists95260_
                          (_recur95258_ _cdrs95262_))))))
          (let _recur95264_ ((_ilis95266_ _ilis195255_))
            (if (null? _ilis95266_)
                _knil95254_
                (let ((_head95268_
                       (##structure-ref
                        _ilis95266_
                        '1
                        std/srfi/116#<ilist>
                        '#f)))
                  (_kons95253_
                   _head95268_
                   (_recur95264_
                    (##structure-ref
                     _ilis95266_
                     '2
                     std/srfi/116#<ilist>
                     '#f)))))))))
  (define std/srfi/116#ipair-fold-right
    (lambda (_f95238_ _zero95239_ _ilis195240_ . _ilists95241_)
      (std/srfi/116#check-arg
       procedure?
       _f95238_
       std/srfi/116#ipair-fold-right)
      (if (pair? _ilists95241_)
          (let _recur95243_ ((_ilists95245_ (cons _ilis195240_ _ilists95241_)))
            (let ((_cdrs95247_ (std/srfi/116#%cdrs _ilists95245_)))
              (if (null? _cdrs95247_)
                  _zero95239_
                  (apply _f95238_
                         (append _ilists95245_
                                 (list (_recur95243_ _cdrs95247_)))))))
          (let _recur95249_ ((_ilis95251_ _ilis195240_))
            (if (std/srfi/116#null-ilist? _ilis95251_)
                _zero95239_
                (_f95238_
                 _ilis95251_
                 (_recur95249_
                  (##structure-ref
                   _ilis95251_
                   '2
                   std/srfi/116#<ilist>
                   '#f))))))))
  (define std/srfi/116#ipair-fold
    (lambda (_f95219_ _zero95220_ _ilis195221_ . _ilists95222_)
      (std/srfi/116#check-arg procedure? _f95219_ std/srfi/116#ipair-fold)
      (if (pair? _ilists95222_)
          (let _lp95224_ ((_ilists95226_ (cons _ilis195221_ _ilists95222_))
                          (_ans95227_ _zero95220_))
            (let ((_tails95229_ (std/srfi/116#%cdrs _ilists95226_)))
              (if (null? _tails95229_)
                  _ans95227_
                  (_lp95224_
                   _tails95229_
                   (apply _f95219_
                          (append _ilists95226_ (list _ans95227_)))))))
          (let _lp95231_ ((_ilis95233_ _ilis195221_) (_ans95234_ _zero95220_))
            (if (std/srfi/116#null-ilist? _ilis95233_)
                _ans95234_
                (let ((_tail95236_
                       (##structure-ref
                        _ilis95233_
                        '2
                        std/srfi/116#<ilist>
                        '#f)))
                  (_lp95231_
                   _tail95236_
                   (_f95219_ _ilis95233_ _ans95234_))))))))
  (define std/srfi/116#ireduce
    (lambda (_f95215_ _ridentity95216_ _ilis95217_)
      (std/srfi/116#check-arg procedure? _f95215_ std/srfi/116#ireduce)
      (if (std/srfi/116#null-ilist? _ilis95217_)
          _ridentity95216_
          (std/srfi/116#ifold
           _f95215_
           (##structure-ref _ilis95217_ '1 std/srfi/116#<ilist> '#f)
           (##structure-ref _ilis95217_ '2 std/srfi/116#<ilist> '#f)))))
  (define std/srfi/116#ireduce-right
    (lambda (_f95206_ _ridentity95207_ _ilis95208_)
      (std/srfi/116#check-arg procedure? _f95206_ std/srfi/116#ireduce-right)
      (if (std/srfi/116#null-ilist? _ilis95208_)
          _ridentity95207_
          (let _recur95210_ ((_head95212_
                              (##structure-ref
                               _ilis95208_
                               '1
                               std/srfi/116#<ilist>
                               '#f))
                             (_ilis95213_
                              (##structure-ref
                               _ilis95208_
                               '2
                               std/srfi/116#<ilist>
                               '#f)))
            (if (let ()
                  (declare (not safe))
                  (##structure-instance-of? _ilis95213_ 'std/srfi/116#<ilist>))
                (_f95206_
                 _head95212_
                 (_recur95210_
                  (##structure-ref _ilis95213_ '1 std/srfi/116#<ilist> '#f)
                  (##structure-ref _ilis95213_ '2 std/srfi/116#<ilist> '#f)))
                _head95212_)))))
  (define std/srfi/116#iappend-map
    (lambda (_f95202_ _ilis195203_ . _ilists95204_)
      (std/srfi/116#really-iappend-map
       std/srfi/116#iappend-map
       std/srfi/116#iappend
       _f95202_
       _ilis195203_
       _ilists95204_)))
  (define std/srfi/116#really-iappend-map
    (lambda (_who95174_ _appender95175_ _f95176_ _ilis195177_ _ilists95178_)
      (std/srfi/116#check-arg procedure? _f95176_ _who95174_)
      (if (pair? _ilists95178_)
          (call-with-values
           (lambda ()
             (std/srfi/116#%cars+cdrs (cons _ilis195177_ _ilists95178_)))
           (lambda (_cars95181_ _cdrs95182_)
             (if (null? _cars95181_)
                 '()
                 (let _recur95184_ ((_cars95186_ _cars95181_)
                                    (_cdrs95187_ _cdrs95182_))
                   (let ((_vals95189_ (apply _f95176_ _cars95186_)))
                     (call-with-values
                      (lambda () (std/srfi/116#%cars+cdrs _cdrs95187_))
                      (lambda (_cars295192_ _cdrs295193_)
                        (if (null? _cars295192_)
                            _vals95189_
                            (_appender95175_
                             _vals95189_
                             (_recur95184_ _cars295192_ _cdrs295193_))))))))))
          (if (std/srfi/116#null-ilist? _ilis195177_)
              '()
              (let _recur95195_ ((_elt95197_
                                  (##structure-ref
                                   _ilis195177_
                                   '1
                                   std/srfi/116#<ilist>
                                   '#f))
                                 (_rest95198_
                                  (##structure-ref
                                   _ilis195177_
                                   '2
                                   std/srfi/116#<ilist>
                                   '#f)))
                (let ((_vals95200_ (_f95176_ _elt95197_)))
                  (if (std/srfi/116#null-ilist? _rest95198_)
                      _vals95200_
                      (_appender95175_
                       _vals95200_
                       (_recur95195_
                        (##structure-ref
                         _rest95198_
                         '1
                         std/srfi/116#<ilist>
                         '#f)
                        (##structure-ref
                         _rest95198_
                         '2
                         std/srfi/116#<ilist>
                         '#f))))))))))
  (define std/srfi/116#ipair-for-each
    (lambda (_proc95158_ _ilis195159_ . _ilists95160_)
      (std/srfi/116#check-arg
       procedure?
       _proc95158_
       std/srfi/116#ipair-for-each)
      (if (pair? _ilists95160_)
          (let _lp95162_ ((_ilists95164_ (cons _ilis195159_ _ilists95160_)))
            (let ((_itails95166_ (std/srfi/116#%cdrs _ilists95164_)))
              (if (pair? _itails95166_)
                  (begin
                    (apply _proc95158_ _ilists95164_)
                    (_lp95162_ _itails95166_))
                  '#!void)))
          (let _lp95168_ ((_ilis95170_ _ilis195159_))
            (if (not (std/srfi/116#null-ilist? _ilis95170_))
                (let ((_tail95172_
                       (##structure-ref
                        _ilis95170_
                        '2
                        std/srfi/116#<ilist>
                        '#f)))
                  (_proc95158_ _ilis95170_)
                  (_lp95168_ _tail95172_))
                '#!void)))))
  (define std/srfi/116#ifilter-map
    (lambda (_f95130_ _ilis195131_ . _ilists95132_)
      (std/srfi/116#check-arg procedure? _f95130_ std/srfi/116#ifilter-map)
      (if (pair? _ilists95132_)
          (let _recur95134_ ((_ilists95136_ (cons _ilis195131_ _ilists95132_)))
            (call-with-values
             (lambda () (std/srfi/116#%cars+cdrs _ilists95136_))
             (lambda (_cars95139_ _cdrs95140_)
               (if (pair? _cars95139_)
                   (let ((_$e95142_ (apply _f95130_ _cars95139_)))
                     (if _$e95142_
                         ((lambda (_x95145_)
                            (let ((__tmp294968 (_recur95134_ _cdrs95140_)))
                              (declare (not safe))
                              (##structure
                               std/srfi/116#<ilist>
                               _x95145_
                               __tmp294968)))
                          _$e95142_)
                         (_recur95134_ _cdrs95140_)))
                   '()))))
          (let _recur95147_ ((_ilis95149_ _ilis195131_))
            (if (std/srfi/116#null-ilist? _ilis95149_)
                _ilis95149_
                (let* ((_tail95151_
                        (_recur95147_
                         (##structure-ref
                          _ilis95149_
                          '2
                          std/srfi/116#<ilist>
                          '#f)))
                       (_$e95153_
                        (_f95130_
                         (##structure-ref
                          _ilis95149_
                          '1
                          std/srfi/116#<ilist>
                          '#f))))
                  (if _$e95153_
                      ((lambda (_x95156_)
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/srfi/116#<ilist>
                            _x95156_
                            _tail95151_)))
                       _$e95153_)
                      _tail95151_)))))))
  (define std/srfi/116#imap-in-order
    (lambda (_f95109_ _lis195110_ . _lists95111_)
      (std/srfi/116#check-arg procedure? _f95109_ std/srfi/116#imap-in-order)
      (if (pair? _lists95111_)
          (let _recur95113_ ((_lists95115_ (cons _lis195110_ _lists95111_)))
            (call-with-values
             (lambda () (std/srfi/116#%cars+cdrs _lists95115_))
             (lambda (_cars95118_ _cdrs95119_)
               (if (pair? _cars95118_)
                   (let* ((_x95121_ (apply _f95109_ _cars95118_))
                          (__tmp294969 (_recur95113_ _cdrs95119_)))
                     (declare (not safe))
                     (##structure std/srfi/116#<ilist> _x95121_ __tmp294969))
                   '()))))
          (let _recur95123_ ((_lis95125_ _lis195110_))
            (if (std/srfi/116#null-ilist? _lis95125_)
                _lis95125_
                (let ((_tail95127_
                       (##structure-ref
                        _lis95125_
                        '2
                        std/srfi/116#<ilist>
                        '#f))
                      (_x95128_
                       (_f95109_
                        (##structure-ref
                         _lis95125_
                         '1
                         std/srfi/116#<ilist>
                         '#f))))
                  (let ((__tmp294970 (_recur95123_ _tail95127_)))
                    (declare (not safe))
                    (##structure
                     std/srfi/116#<ilist>
                     _x95128_
                     __tmp294970))))))))
  (define std/srfi/116#imap std/srfi/116#imap-in-order)
  (define std/srfi/116#ifilter
    (lambda (_pred95097_ _lis95098_)
      (std/srfi/116#check-arg procedure? _pred95097_ std/srfi/116#ifilter)
      (let _recur95100_ ((_lis95102_ _lis95098_))
        (if (std/srfi/116#null-ilist? _lis95102_)
            _lis95102_
            (let ((_head95104_
                   (##structure-ref _lis95102_ '1 std/srfi/116#<ilist> '#f))
                  (_tail95105_
                   (##structure-ref _lis95102_ '2 std/srfi/116#<ilist> '#f)))
              (if (_pred95097_ _head95104_)
                  (let ((_new-tail95107_ (_recur95100_ _tail95105_)))
                    (if (eq? _tail95105_ _new-tail95107_)
                        _lis95102_
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/srfi/116#<ilist>
                           _head95104_
                           _new-tail95107_))))
                  (_recur95100_ _tail95105_)))))))
  (define std/srfi/116#ipartition
    (lambda (_pred95083_ _lis95084_)
      (std/srfi/116#check-arg procedure? _pred95083_ std/srfi/116#ipartition)
      (let _recur95086_ ((_lis95088_ _lis95084_))
        (if (std/srfi/116#null-ilist? _lis95088_)
            (values _lis95088_ _lis95088_)
            (let ((_elt95090_
                   (##structure-ref _lis95088_ '1 std/srfi/116#<ilist> '#f))
                  (_tail95091_
                   (##structure-ref _lis95088_ '2 std/srfi/116#<ilist> '#f)))
              (call-with-values
               (lambda () (_recur95086_ _tail95091_))
               (lambda (_in95094_ _out95095_)
                 (if (_pred95083_ _elt95090_)
                     (values (if (let ()
                                   (declare (not safe))
                                   (##structure-instance-of?
                                    _out95095_
                                    'std/srfi/116#<ilist>))
                                 (let ()
                                   (declare (not safe))
                                   (##structure
                                    std/srfi/116#<ilist>
                                    _elt95090_
                                    _in95094_))
                                 _lis95088_)
                             _out95095_)
                     (values _in95094_
                             (if (let ()
                                   (declare (not safe))
                                   (##structure-instance-of?
                                    _in95094_
                                    'std/srfi/116#<ilist>))
                                 (let ()
                                   (declare (not safe))
                                   (##structure
                                    std/srfi/116#<ilist>
                                    _elt95090_
                                    _out95095_))
                                 _lis95088_))))))))))
  (define std/srfi/116#iremove
    (lambda (_pred95078_ _l95079_)
      (std/srfi/116#ifilter
       (lambda (_x95081_) (not (_pred95078_ _x95081_)))
       _l95079_)))
  (define std/srfi/116#idelete
    (lambda (_x95070_ _lis95071_ . _maybe-=95072_)
      (let ((_=95074_
             (if (null? _maybe-=95072_)
                 equal?
                 (if (null? (cdr _maybe-=95072_))
                     (car _maybe-=95072_)
                     (error '"Too many arguments")))))
        (std/srfi/116#ifilter
         (lambda (_y95076_) (not (_=95074_ _x95070_ _y95076_)))
         _lis95071_))))
  (define std/srfi/116#imember
    (lambda (_x95062_ _lis95063_ . _maybe-=95064_)
      (let ((_=95066_
             (if (null? _maybe-=95064_)
                 equal?
                 (if (null? (cdr _maybe-=95064_))
                     (car _maybe-=95064_)
                     (error '"Too many arguments")))))
        (std/srfi/116#ifind-tail
         (lambda (_y95068_) (_=95066_ _x95062_ _y95068_))
         _lis95063_))))
  (define std/srfi/116#imemq
    (lambda (_x95059_ _lis95060_)
      (std/srfi/116#imember _x95059_ _lis95060_ eq?)))
  (define std/srfi/116#imemv
    (lambda (_x95056_ _lis95057_)
      (std/srfi/116#imember _x95056_ _lis95057_ eqv?)))
  (define std/srfi/116#idelete-duplicates
    (lambda (_lis95040_ . _maybe-=95041_)
      (let ((_elt=95043_
             (if (null? _maybe-=95041_)
                 equal?
                 (if (null? (cdr _maybe-=95041_))
                     (car _maybe-=95041_)
                     (error '"Too many arguments")))))
        (std/srfi/116#check-arg
         procedure?
         _elt=95043_
         std/srfi/116#idelete-duplicates)
        (let _recur95045_ ((_lis95047_ _lis95040_))
          (if (std/srfi/116#null-ilist? _lis95047_)
              _lis95047_
              (let* ((_x95049_
                      (##structure-ref _lis95047_ '1 std/srfi/116#<ilist> '#f))
                     (_tail95051_
                      (##structure-ref _lis95047_ '2 std/srfi/116#<ilist> '#f))
                     (_new-tail95053_
                      (_recur95045_
                       (std/srfi/116#idelete
                        _x95049_
                        _tail95051_
                        _elt=95043_))))
                (if (eq? _tail95051_ _new-tail95053_)
                    _lis95047_
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/116#<ilist>
                       _x95049_
                       _new-tail95053_)))))))))
  (define std/srfi/116#iassoc
    (lambda (_x95032_ _lis95033_ . _maybe-=95034_)
      (let ((_=95036_
             (if (null? _maybe-=95034_)
                 equal?
                 (if (null? (cdr _maybe-=95034_))
                     (car _maybe-=95034_)
                     (error '"Too many arguments")))))
        (std/srfi/116#ifind
         (lambda (_entry95038_)
           (_=95036_
            _x95032_
            (##structure-ref _entry95038_ '1 std/srfi/116#<ilist> '#f)))
         _lis95033_))))
  (define std/srfi/116#ialist-cons
    (lambda (_key95028_ _datum95029_ _alist95030_)
      (let ((__tmp294971
             (let ()
               (declare (not safe))
               (##structure std/srfi/116#<ilist> _key95028_ _datum95029_))))
        (declare (not safe))
        (##structure std/srfi/116#<ilist> __tmp294971 _alist95030_))))
  (define std/srfi/116#alist-copy
    (lambda (_alist95024_)
      (std/srfi/116#imap
       (lambda (_elt95026_)
         (let ((__tmp294973
                (##structure-ref _elt95026_ '1 std/srfi/116#<ilist> '#f))
               (__tmp294972
                (##structure-ref _elt95026_ '2 std/srfi/116#<ilist> '#f)))
           (declare (not safe))
           (##structure std/srfi/116#<ilist> __tmp294973 __tmp294972)))
       _alist95024_)))
  (define std/srfi/116#ialist-delete
    (lambda (_key95016_ _alist95017_ . _maybe-=95018_)
      (let ((_=95020_
             (if (null? _maybe-=95018_)
                 equal?
                 (if (null? (cdr _maybe-=95018_))
                     (car _maybe-=95018_)
                     (error '"Too many arguments")))))
        (std/srfi/116#ifilter
         (lambda (_elt95022_)
           (not (_=95020_
                 _key95016_
                 (##structure-ref _elt95022_ '1 std/srfi/116#<ilist> '#f))))
         _alist95017_))))
  (define std/srfi/116#ifind
    (lambda (_pred95010_ _ilist95011_)
      (let ((_$e95013_ (std/srfi/116#ifind-tail _pred95010_ _ilist95011_)))
        (if _$e95013_
            (##structure-ref _$e95013_ '1 std/srfi/116#<ilist> '#f)
            '#f))))
  (define std/srfi/116#ifind-tail
    (lambda (_pred95003_ _ilist95004_)
      (std/srfi/116#check-arg procedure? _pred95003_ std/srfi/116#ifind-tail)
      (let _lp95006_ ((_ilist95008_ _ilist95004_))
        (if (not (std/srfi/116#null-ilist? _ilist95008_))
            (if (_pred95003_
                 (##structure-ref _ilist95008_ '1 std/srfi/116#<ilist> '#f))
                _ilist95008_
                (_lp95006_
                 (##structure-ref _ilist95008_ '2 std/srfi/116#<ilist> '#f)))
            '#f))))
  (define std/srfi/116#itake-while
    (lambda (_pred94994_ _lis94995_)
      (std/srfi/116#check-arg procedure? _pred94994_ std/srfi/116#itake-while)
      (let _recur94997_ ((_lis94999_ _lis94995_))
        (if (std/srfi/116#null-ilist? _lis94999_)
            '()
            (let ((_x95001_
                   (##structure-ref _lis94999_ '1 std/srfi/116#<ilist> '#f)))
              (if (_pred94994_ _x95001_)
                  (let ((__tmp294974
                         (_recur94997_
                          (##structure-ref
                           _lis94999_
                           '2
                           std/srfi/116#<ilist>
                           '#f))))
                    (declare (not safe))
                    (##structure std/srfi/116#<ilist> _x95001_ __tmp294974))
                  '()))))))
  (define std/srfi/116#idrop-while
    (lambda (_pred94987_ _lis94988_)
      (std/srfi/116#check-arg procedure? _pred94987_ std/srfi/116#idrop-while)
      (let _lp94990_ ((_lis94992_ _lis94988_))
        (if (std/srfi/116#null-ilist? _lis94992_)
            '()
            (if (_pred94987_
                 (##structure-ref _lis94992_ '1 std/srfi/116#<ilist> '#f))
                (_lp94990_
                 (##structure-ref _lis94992_ '2 std/srfi/116#<ilist> '#f))
                _lis94992_)))))
  (define std/srfi/116#ispan
    (lambda (_pred94974_ _lis94975_)
      (std/srfi/116#check-arg procedure? _pred94974_ std/srfi/116#ispan)
      (let _recur94977_ ((_lis94979_ _lis94975_))
        (if (std/srfi/116#null-ilist? _lis94979_)
            (values '() '())
            (let ((_x94981_
                   (##structure-ref _lis94979_ '1 std/srfi/116#<ilist> '#f)))
              (if (_pred94974_ _x94981_)
                  (call-with-values
                   (lambda ()
                     (_recur94977_
                      (##structure-ref
                       _lis94979_
                       '2
                       std/srfi/116#<ilist>
                       '#f)))
                   (lambda (_prefix94984_ _suffix94985_)
                     (values (let ()
                               (declare (not safe))
                               (##structure
                                std/srfi/116#<ilist>
                                _x94981_
                                _prefix94984_))
                             _suffix94985_)))
                  (values '() _lis94979_)))))))
  (define std/srfi/116#ibreak
    (lambda (_pred94969_ _lis94970_)
      (std/srfi/116#ispan
       (lambda (_x94972_) (not (_pred94969_ _x94972_)))
       _lis94970_)))
  (define std/srfi/116#ievery
    (lambda (_pred94941_ _lis194942_ . _lists94943_)
      (std/srfi/116#check-arg procedure? _pred94941_ std/srfi/116#ievery)
      (if (pair? _lists94943_)
          (call-with-values
           (lambda ()
             (std/srfi/116#%cars+cdrs
              (let ()
                (declare (not safe))
                (##structure std/srfi/116#<ilist> _lis194942_ _lists94943_))))
           (lambda (_heads94946_ _tails94947_)
             (let ((_$e94949_
                    (not (let ()
                           (declare (not safe))
                           (##structure-instance-of?
                            _heads94946_
                            'std/srfi/116#<ilist>)))))
               (if _$e94949_
                   _$e94949_
                   (let _lp94952_ ((_heads94954_ _heads94946_)
                                   (_tails94955_ _tails94947_))
                     (call-with-values
                      (lambda () (std/srfi/116#%cars+cdrs _tails94955_))
                      (lambda (_next-heads94958_ _next-tails94959_)
                        (if (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _next-heads94958_
                               'std/srfi/116#<ilist>))
                            (if (apply _pred94941_ _heads94954_)
                                (_lp94952_ _next-heads94958_ _next-tails94959_)
                                '#f)
                            (apply _pred94941_ _heads94954_)))))))))
          (let ((_$e94961_ (std/srfi/116#null-ilist? _lis194942_)))
            (if _$e94961_
                _$e94961_
                (let _lp94964_ ((_head94966_
                                 (##structure-ref
                                  _lis194942_
                                  '1
                                  std/srfi/116#<ilist>
                                  '#f))
                                (_tail94967_
                                 (##structure-ref
                                  _lis194942_
                                  '2
                                  std/srfi/116#<ilist>
                                  '#f)))
                  (if (std/srfi/116#null-ilist? _tail94967_)
                      (_pred94941_ _head94966_)
                      (if (_pred94941_ _head94966_)
                          (_lp94964_
                           (##structure-ref
                            _tail94967_
                            '1
                            std/srfi/116#<ilist>
                            '#f)
                           (##structure-ref
                            _tail94967_
                            '2
                            std/srfi/116#<ilist>
                            '#f))
                          '#f))))))))
  (define std/srfi/116#iany
    (lambda (_pred94913_ _ilis194914_ . _ilists94915_)
      (std/srfi/116#check-arg procedure? _pred94913_ std/srfi/116#iany)
      (if (pair? _ilists94915_)
          (call-with-values
           (lambda ()
             (std/srfi/116#%cars+cdrs (cons _ilis194914_ _ilists94915_)))
           (lambda (_heads94918_ _tails94919_)
             (if (pair? _heads94918_)
                 (let _lp94921_ ((_heads94923_ _heads94918_)
                                 (_tails94924_ _tails94919_))
                   (call-with-values
                    (lambda () (std/srfi/116#%cars+cdrs _tails94924_))
                    (lambda (_next-heads94927_ _next-tails94928_)
                      (if (pair? _next-heads94927_)
                          (let ((_$e94930_ (apply _pred94913_ _heads94923_)))
                            (if _$e94930_
                                _$e94930_
                                (_lp94921_
                                 _next-heads94927_
                                 _next-tails94928_)))
                          (apply _pred94913_ _heads94923_)))))
                 '#f)))
          (if (not (std/srfi/116#null-ilist? _ilis194914_))
              (let _lp94933_ ((_head94935_
                               (##structure-ref
                                _ilis194914_
                                '1
                                std/srfi/116#<ilist>
                                '#f))
                              (_tail94936_
                               (##structure-ref
                                _ilis194914_
                                '2
                                std/srfi/116#<ilist>
                                '#f)))
                (if (std/srfi/116#null-ilist? _tail94936_)
                    (_pred94913_ _head94935_)
                    (let ((_$e94938_ (_pred94913_ _head94935_)))
                      (if _$e94938_
                          _$e94938_
                          (_lp94933_
                           (##structure-ref
                            _tail94936_
                            '1
                            std/srfi/116#<ilist>
                            '#f)
                           (##structure-ref
                            _tail94936_
                            '2
                            std/srfi/116#<ilist>
                            '#f))))))
              '#f))))
  (define std/srfi/116#ilist-index
    (lambda (_pred94895_ _lis194896_ . _lists94897_)
      (std/srfi/116#check-arg procedure? _pred94895_ std/srfi/116#ilist-index)
      (if (pair? _lists94897_)
          (let _lp94899_ ((_lists94901_ (cons _lis194896_ _lists94897_))
                          (_n94902_ '0))
            (call-with-values
             (lambda () (std/srfi/116#%cars+cdrs _lists94901_))
             (lambda (_heads94905_ _tails94906_)
               (if (pair? _heads94905_)
                   (if (apply _pred94895_ _heads94905_)
                       _n94902_
                       (_lp94899_ _tails94906_ (+ _n94902_ '1)))
                   '#f))))
          (let _lp94908_ ((_lis94910_ _lis194896_) (_n94911_ '0))
            (if (not (std/srfi/116#null-ilist? _lis94910_))
                (if (_pred94895_
                     (##structure-ref _lis94910_ '1 std/srfi/116#<ilist> '#f))
                    _n94911_
                    (_lp94908_
                     (##structure-ref _lis94910_ '2 std/srfi/116#<ilist> '#f)
                     (+ _n94911_ '1)))
                '#f)))))
  (define std/srfi/116#ireverse
    (lambda (_lis94893_)
      (std/srfi/116#ifold std/srfi/116#ipair '() _lis94893_))))
