(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/117#make-list
    (lambda (_n95970_ . _o95971_)
      (let ((_default95973_ (if (pair? _o95971_) (car _o95971_) '#!void)))
        (let _lp95975_ ((_n95977_ _n95970_) (_res95978_ '()))
          (if (<= _n95977_ '0)
              _res95978_
              (_lp95975_ (- _n95977_ '1) (cons _default95973_ _res95978_)))))))
  (define std/srfi/117#list-copy
    (lambda (_ls95963_)
      (let _lp95965_ ((_ls95967_ _ls95963_) (_res95968_ '()))
        (if (pair? _ls95967_)
            (_lp95965_ (cdr _ls95967_) (cons (car _ls95967_) _res95968_))
            (append (reverse _res95968_) _ls95967_)))))
  (define std/srfi/117#list-set!
    (lambda (_ls95959_ _k95960_ _x95961_)
      (if (null? _ls95959_)
          (error '"invalid list index")
          (if (zero? _k95960_)
              (set-car! _ls95959_ _x95961_)
              (std/srfi/117#list-set!
               (cdr _ls95959_)
               (- _k95960_ '1)
               _x95961_)))))
  (define std/srfi/117#last-pair
    (lambda (_ls95957_)
      (if (null? (cdr _ls95957_))
          _ls95957_
          (std/srfi/117#last-pair (cdr _ls95957_)))))
  (define std/srfi/117#map!
    (lambda (_f95950_ _lis95951_)
      (let _lp95953_ ((_lis95955_ _lis95951_))
        (if (pair? _lis95955_)
            (begin
              (set-car! _lis95955_ (_f95950_ (car _lis95955_)))
              (_lp95953_ (cdr _lis95955_)))
            '#!void))))
  (define std/srfi/117#<list-queue>
    (make-struct-type
     'std/srfi/117#<list-queue>
     '#f
     '2
     '<list-queue>
     '((fields: first last))
     '#f))
  (define std/srfi/117#list-queue?
    (make-struct-predicate std/srfi/117#<list-queue>))
  (define std/srfi/117#get-first
    (make-struct-field-accessor std/srfi/117#<list-queue> '0))
  (define std/srfi/117#get-last
    (make-struct-field-accessor std/srfi/117#<list-queue> '1))
  (define std/srfi/117#set-first!
    (make-struct-field-mutator std/srfi/117#<list-queue> '0))
  (define std/srfi/117#set-last!
    (make-struct-field-mutator std/srfi/117#<list-queue> '1))
  (define std/srfi/117#raw-make-list-queue
    (lambda (_first95947_ _last95948_)
      (make-struct-instance
       std/srfi/117#<list-queue>
       _first95947_
       _last95948_)))
  (define std/srfi/117#make-list-queue__0
    (lambda (_list95942_)
      (if (null? _list95942_)
          (let ()
            (declare (not safe))
            (##structure std/srfi/117#<list-queue> '() '()))
          (let ((__tmp294977 (std/srfi/117#last-pair _list95942_)))
            (declare (not safe))
            (##structure std/srfi/117#<list-queue> _list95942_ __tmp294977)))))
  (define std/srfi/117#make-list-queue
    (lambda _g294979_
      (let ((_g294978_ (let () (declare (not safe)) (##length _g294979_))))
        (cond ((let () (declare (not safe)) (##fx= _g294978_ 1))
               (apply std/srfi/117#make-list-queue__0 _g294979_))
              ((let () (declare (not safe)) (##fx= _g294978_ 2))
               (apply (lambda (_list95944_ _last95945_)
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/srfi/117#<list-queue>
                           _list95944_
                           _last95945_)))
                      _g294979_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#make-list-queue
                _g294979_))))))
  (define std/srfi/117#list-queue
    (lambda _objs95940_ (std/srfi/117#make-list-queue__0 _objs95940_)))
  (define std/srfi/117#list-queue-copy
    (lambda (_list-queue95938_)
      (std/srfi/117#make-list-queue__0
       (std/srfi/117#list-copy
        (##structure-ref
         _list-queue95938_
         '1
         std/srfi/117#<list-queue>
         '#f)))))
  (define std/srfi/117#list-queue-empty?
    (lambda (_list-queue95936_)
      (null? (##structure-ref
              _list-queue95936_
              '1
              std/srfi/117#<list-queue>
              '#f))))
  (define std/srfi/117#list-queue-front
    (lambda (_list-queue95934_)
      (if (std/srfi/117#list-queue-empty? _list-queue95934_)
          (error '"Empty list-queue")
          (car (##structure-ref
                _list-queue95934_
                '1
                std/srfi/117#<list-queue>
                '#f)))))
  (define std/srfi/117#list-queue-back
    (lambda (_list-queue95932_)
      (if (std/srfi/117#list-queue-empty? _list-queue95932_)
          (error '"Empty list-queue")
          (car (##structure-ref
                _list-queue95932_
                '2
                std/srfi/117#<list-queue>
                '#f)))))
  (define std/srfi/117#list-queue-add-front!
    (lambda (_list-queue95927_ _elem95928_)
      (let ((_new-first95930_
             (cons _elem95928_
                   (##structure-ref
                    _list-queue95927_
                    '1
                    std/srfi/117#<list-queue>
                    '#f))))
        (if (std/srfi/117#list-queue-empty? _list-queue95927_)
            (##structure-set!
             _list-queue95927_
             _new-first95930_
             '2
             std/srfi/117#<list-queue>
             '#f)
            '#!void)
        (##structure-set!
         _list-queue95927_
         _new-first95930_
         '1
         std/srfi/117#<list-queue>
         '#f))))
  (define std/srfi/117#list-queue-add-back!
    (lambda (_list-queue95922_ _elem95923_)
      (let ((_new-last95925_ (list _elem95923_)))
        (if (std/srfi/117#list-queue-empty? _list-queue95922_)
            (##structure-set!
             _list-queue95922_
             _new-last95925_
             '1
             std/srfi/117#<list-queue>
             '#f)
            (set-cdr!
             (##structure-ref
              _list-queue95922_
              '2
              std/srfi/117#<list-queue>
              '#f)
             _new-last95925_))
        (##structure-set!
         _list-queue95922_
         _new-last95925_
         '2
         std/srfi/117#<list-queue>
         '#f))))
  (define std/srfi/117#list-queue-remove-front!
    (lambda (_list-queue95913_)
      (if (std/srfi/117#list-queue-empty? _list-queue95913_)
          (error '"Empty list-queue")
          '#!void)
      (let* ((_old-first95915_
              (##structure-ref
               _list-queue95913_
               '1
               std/srfi/117#<list-queue>
               '#f))
             (_elem95917_ (car _old-first95915_))
             (_new-first95919_ (cdr _old-first95915_)))
        (if (null? _new-first95919_)
            (##structure-set!
             _list-queue95913_
             '()
             '2
             std/srfi/117#<list-queue>
             '#f)
            '#!void)
        (##structure-set!
         _list-queue95913_
         _new-first95919_
         '1
         std/srfi/117#<list-queue>
         '#f)
        _elem95917_)))
  (define std/srfi/117#list-queue-remove-back!
    (lambda (_list-queue95904_)
      (if (std/srfi/117#list-queue-empty? _list-queue95904_)
          (error '"Empty list-queue")
          '#!void)
      (let* ((_old-last95906_
              (##structure-ref
               _list-queue95904_
               '2
               std/srfi/117#<list-queue>
               '#f))
             (_elem95908_ (car _old-last95906_))
             (_new-last95910_
              (std/srfi/117#penult-pair
               (##structure-ref
                _list-queue95904_
                '1
                std/srfi/117#<list-queue>
                '#f))))
        (if (null? _new-last95910_)
            (##structure-set!
             _list-queue95904_
             '()
             '1
             std/srfi/117#<list-queue>
             '#f)
            (set-cdr! _new-last95910_ '()))
        (##structure-set!
         _list-queue95904_
         _new-last95910_
         '2
         std/srfi/117#<list-queue>
         '#f)
        _elem95908_)))
  (define std/srfi/117#list-queue-remove-all!
    (lambda (_list-queue95900_)
      (let ((_result95902_
             (##structure-ref
              _list-queue95900_
              '1
              std/srfi/117#<list-queue>
              '#f)))
        (##structure-set!
         _list-queue95900_
         '()
         '1
         std/srfi/117#<list-queue>
         '#f)
        (##structure-set!
         _list-queue95900_
         '()
         '2
         std/srfi/117#<list-queue>
         '#f)
        _result95902_)))
  (define std/srfi/117#penult-pair
    (lambda (_lis95894_)
      (let _lp95896_ ((_lis95898_ _lis95894_))
        (if (null? (cdr _lis95898_))
            '()
            (if (null? (cddr _lis95898_))
                _lis95898_
                (_lp95896_ (cdr _lis95898_)))))))
  (define std/srfi/117#list-queue-append
    (lambda _list-queues95892_
      (std/srfi/117#list-queue-concatenate _list-queues95892_)))
  (define std/srfi/117#list-queue-concatenate
    (lambda (_list-queues95884_)
      (let ((_result95886_ (std/srfi/117#list-queue)))
        (for-each
         (lambda (_list-queue95888_)
           (for-each
            (lambda (_elem95890_)
              (std/srfi/117#list-queue-add-back! _result95886_ _elem95890_))
            (##structure-ref
             _list-queue95888_
             '1
             std/srfi/117#<list-queue>
             '#f)))
         _list-queues95884_)
        _result95886_)))
  (define std/srfi/117#list-queue-append!__1
    (lambda (_queue95878_) _queue95878_))
  (define std/srfi/117#list-queue-append!__2
    (lambda _queues95880_
      (for-each
       (lambda (_queue95882_)
         (std/srfi/117#list-queue-join! (car _queues95880_) _queue95882_))
       (cdr _queues95880_))
      (car _queues95880_)))
  (define std/srfi/117#list-queue-append!
    (lambda _g294981_
      (let ((_g294980_ (let () (declare (not safe)) (##length _g294981_))))
        (cond ((let () (declare (not safe)) (##fx= _g294980_ 0))
               (apply std/srfi/117#list-queue _g294981_))
              ((let () (declare (not safe)) (##fx= _g294980_ 1))
               (apply std/srfi/117#list-queue-append!__1 _g294981_))
              (#t (apply std/srfi/117#list-queue-append!__2 _g294981_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-append!
                _g294981_))))))
  (define std/srfi/117#list-queue-join!
    (lambda (_queue195874_ _queue295875_)
      (set-cdr!
       (##structure-ref _queue195874_ '2 std/srfi/117#<list-queue> '#f)
       (##structure-ref _queue295875_ '1 std/srfi/117#<list-queue> '#f))))
  (define std/srfi/117#list-queue-map
    (lambda (_proc95871_ _list-queue95872_)
      (std/srfi/117#make-list-queue__0
       (map _proc95871_
            (##structure-ref
             _list-queue95872_
             '1
             std/srfi/117#<list-queue>
             '#f)))))
  (define std/srfi/117#list-queue-unfold__1
    (lambda (_stop?95866_ _mapper95867_ _successor95868_ _seed95869_)
      (std/srfi/117#list-queue-unfold*
       _stop?95866_
       _mapper95867_
       _successor95868_
       _seed95869_
       (std/srfi/117#list-queue))))
  (define std/srfi/117#list-queue-unfold
    (lambda _g294983_
      (let ((_g294982_ (let () (declare (not safe)) (##length _g294983_))))
        (cond ((let () (declare (not safe)) (##fx= _g294982_ 5))
               (apply std/srfi/117#list-queue-unfold* _g294983_))
              ((let () (declare (not safe)) (##fx= _g294982_ 4))
               (apply std/srfi/117#list-queue-unfold__1 _g294983_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-unfold
                _g294983_))))))
  (define std/srfi/117#list-queue-unfold*
    (lambda (_stop?95850_
             _mapper95851_
             _successor95852_
             _seed95853_
             _queue95854_)
      (let _loop95856_ ((_seed95858_ _seed95853_))
        (if (not (_stop?95850_ _seed95858_))
            (std/srfi/117#list-queue-add-front!
             (_loop95856_ (_successor95852_ _seed95858_))
             (_mapper95851_ _seed95858_))
            '#!void)
        _queue95854_)))
  (define std/srfi/117#list-queue-unfold-right__1
    (lambda (_stop?95845_ _mapper95846_ _successor95847_ _seed95848_)
      (std/srfi/117#list-queue-unfold-right*
       _stop?95845_
       _mapper95846_
       _successor95847_
       _seed95848_
       (std/srfi/117#list-queue))))
  (define std/srfi/117#list-queue-unfold-right
    (lambda _g294985_
      (let ((_g294984_ (let () (declare (not safe)) (##length _g294985_))))
        (cond ((let () (declare (not safe)) (##fx= _g294984_ 5))
               (apply std/srfi/117#list-queue-unfold-right* _g294985_))
              ((let () (declare (not safe)) (##fx= _g294984_ 4))
               (apply std/srfi/117#list-queue-unfold-right__1 _g294985_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-unfold-right
                _g294985_))))))
  (define std/srfi/117#list-queue-unfold-right*
    (lambda (_stop?95829_
             _mapper95830_
             _successor95831_
             _seed95832_
             _queue95833_)
      (let _loop95835_ ((_seed95837_ _seed95832_))
        (if (not (_stop?95829_ _seed95837_))
            (std/srfi/117#list-queue-add-back!
             (_loop95835_ (_successor95831_ _seed95837_))
             (_mapper95830_ _seed95837_))
            '#!void)
        _queue95833_)))
  (define std/srfi/117#list-queue-map!
    (lambda (_proc95826_ _list-queue95827_)
      (std/srfi/117#map!
       _proc95826_
       (##structure-ref _list-queue95827_ '1 std/srfi/117#<list-queue> '#f))))
  (define std/srfi/117#list-queue-for-each
    (lambda (_proc95823_ _list-queue95824_)
      (for-each
       _proc95823_
       (##structure-ref _list-queue95824_ '1 std/srfi/117#<list-queue> '#f))))
  (define std/srfi/117#list-queue-list
    (lambda (_list-queue95821_)
      (##structure-ref _list-queue95821_ '1 std/srfi/117#<list-queue> '#f)))
  (define std/srfi/117#list-queue-first-last
    (lambda (_list-queue95819_)
      (values (##structure-ref
               _list-queue95819_
               '1
               std/srfi/117#<list-queue>
               '#f)
              (##structure-ref
               _list-queue95819_
               '2
               std/srfi/117#<list-queue>
               '#f))))
  (define std/srfi/117#list-queue-set-list!__0
    (lambda (_list-queue95812_ _first95813_)
      (##structure-set!
       _list-queue95812_
       _first95813_
       '1
       std/srfi/117#<list-queue>
       '#f)
      (if (null? _first95813_)
          (##structure-set!
           _list-queue95812_
           '()
           '2
           std/srfi/117#<list-queue>
           '#f)
          (##structure-set!
           _list-queue95812_
           (std/srfi/117#last-pair _first95813_)
           '2
           std/srfi/117#<list-queue>
           '#f))))
  (define std/srfi/117#list-queue-set-list!__1
    (lambda (_list-queue95815_ _first95816_ _last95817_)
      (##structure-set!
       _list-queue95815_
       _first95816_
       '1
       std/srfi/117#<list-queue>
       '#f)
      (##structure-set!
       _list-queue95815_
       _last95817_
       '2
       std/srfi/117#<list-queue>
       '#f)))
  (define std/srfi/117#list-queue-set-list!
    (lambda _g294987_
      (let ((_g294986_ (let () (declare (not safe)) (##length _g294987_))))
        (cond ((let () (declare (not safe)) (##fx= _g294986_ 2))
               (apply std/srfi/117#list-queue-set-list!__0 _g294987_))
              ((let () (declare (not safe)) (##fx= _g294986_ 3))
               (apply std/srfi/117#list-queue-set-list!__1 _g294987_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-set-list!
                _g294987_)))))))
