(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/134#<ideque>
    (make-struct-type
     'std/srfi/134#<ideque>
     '#f
     '4
     '<ideque>
     '((fields: lenf f lenr r))
     '#f))
  (define std/srfi/134#ideque? (make-struct-predicate std/srfi/134#<ideque>))
  (define std/srfi/134#dq-lenf
    (make-struct-field-accessor std/srfi/134#<ideque> '0))
  (define std/srfi/134#dq-f
    (make-struct-field-accessor std/srfi/134#<ideque> '1))
  (define std/srfi/134#dq-lenr
    (make-struct-field-accessor std/srfi/134#<ideque> '2))
  (define std/srfi/134#dq-r
    (make-struct-field-accessor std/srfi/134#<ideque> '3))
  (define std/srfi/134#%make-dq
    (lambda (_lenf101134_ _f101135_ _lenr101136_ _r101137_)
      (make-struct-instance
       std/srfi/134#<ideque>
       _lenf101134_
       _f101135_
       _lenr101136_
       _r101137_)))
  (define std/srfi/134#*empty*
    (let ()
      (declare (not safe))
      (##structure std/srfi/134#<ideque> '0 '() '0 '())))
  (define std/srfi/134#%check-ideque
    (lambda (_x101132_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _x101132_ 'std/srfi/134#<ideque>))
          '#!void
          (error '"ideque expected, but got:" _x101132_))))
  (define std/srfi/134#ideque
    (lambda _args101130_ (std/srfi/134#list->ideque _args101130_)))
  (define std/srfi/134#ideque-tabulate
    (lambda (_size101118_ _init101119_)
      (let ((_lenf101121_ (quotient _size101118_ '2))
            (_lenr101122_ (quotient (+ _size101118_ '1) '2)))
        (let ((__tmp295192
               (std/srfi/1#list-tabulate _lenf101121_ _init101119_))
              (__tmp295191
               (std/srfi/1#unfold
                (lambda (_n101124_) (= _n101124_ _lenr101122_))
                (lambda (_n101126_)
                  (_init101119_ (- _size101118_ _n101126_ '1)))
                (lambda (_n101128_) (+ _n101128_ '1))
                '0)))
          (declare (not safe))
          (##structure
           std/srfi/134#<ideque>
           _lenf101121_
           __tmp295192
           _lenr101122_
           __tmp295191)))))
  (define std/srfi/134#ideque-unfold
    (lambda (_p101113_ _f101114_ _g101115_ _seed101116_)
      (std/srfi/134#list->ideque
       (std/srfi/1#unfold _p101113_ _f101114_ _g101115_ _seed101116_))))
  (define std/srfi/134#ideque-unfold-right
    (lambda (_p101108_ _f101109_ _g101110_ _seed101111_)
      (std/srfi/134#list->ideque
       (std/srfi/1#unfold-right _p101108_ _f101109_ _g101110_ _seed101111_))))
  (define std/srfi/134#C '3)
  (define std/srfi/134#check
    (lambda (_lenf101085_ _f101086_ _lenr101087_ _r101088_)
      (if (> _lenf101085_ (+ (* _lenr101087_ std/srfi/134#C) '1))
          (let* ((_i101090_ (quotient (+ _lenf101085_ _lenr101087_) '2))
                 (_j101092_ (- (+ _lenf101085_ _lenr101087_) _i101090_))
                 (_f.101094_ (std/srfi/1#take _f101086_ _i101090_))
                 (_r.101096_
                  (append _r101088_
                          (reverse (std/srfi/1#drop _f101086_ _i101090_)))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/134#<ideque>
               _i101090_
               _f.101094_
               _j101092_
               _r.101096_)))
          (if (> _lenr101087_ (+ (* _lenf101085_ std/srfi/134#C) '1))
              (let* ((_j101099_ (quotient (+ _lenf101085_ _lenr101087_) '2))
                     (_i101101_ (- (+ _lenf101085_ _lenr101087_) _j101099_))
                     (_r.101103_ (std/srfi/1#take _r101088_ _j101099_))
                     (_f.101105_
                      (append _f101086_
                              (reverse (std/srfi/1#drop
                                        _r101088_
                                        _j101099_)))))
                (let ()
                  (declare (not safe))
                  (##structure
                   std/srfi/134#<ideque>
                   _i101101_
                   _f.101105_
                   _j101099_
                   _r.101103_)))
              (let ()
                (declare (not safe))
                (##structure
                 std/srfi/134#<ideque>
                 _lenf101085_
                 _f101086_
                 _lenr101087_
                 _r101088_))))))
  (define std/srfi/134#ideque-empty?
    (lambda (_dq101083_)
      (std/srfi/134#%check-ideque _dq101083_)
      (if (zero? (##structure-ref _dq101083_ '1 std/srfi/134#<ideque> '#f))
          (zero? (##structure-ref _dq101083_ '3 std/srfi/134#<ideque> '#f))
          '#f)))
  (define std/srfi/134#ideque-add-front
    (lambda (_dq101080_ _x101081_)
      (std/srfi/134#%check-ideque _dq101080_)
      (std/srfi/134#check
       (+ (##structure-ref _dq101080_ '1 std/srfi/134#<ideque> '#f) '1)
       (cons _x101081_
             (##structure-ref _dq101080_ '2 std/srfi/134#<ideque> '#f))
       (##structure-ref _dq101080_ '3 std/srfi/134#<ideque> '#f)
       (##structure-ref _dq101080_ '4 std/srfi/134#<ideque> '#f))))
  (define std/srfi/134#ideque-front
    (lambda (_dq101078_)
      (std/srfi/134#%check-ideque _dq101078_)
      (if (zero? (##structure-ref _dq101078_ '1 std/srfi/134#<ideque> '#f))
          (if (zero? (##structure-ref _dq101078_ '3 std/srfi/134#<ideque> '#f))
              (error '"Empty deque:" _dq101078_)
              (car (##structure-ref _dq101078_ '4 std/srfi/134#<ideque> '#f)))
          (car (##structure-ref _dq101078_ '2 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-remove-front
    (lambda (_dq101076_)
      (std/srfi/134#%check-ideque _dq101076_)
      (if (zero? (##structure-ref _dq101076_ '1 std/srfi/134#<ideque> '#f))
          (if (zero? (##structure-ref _dq101076_ '3 std/srfi/134#<ideque> '#f))
              (error '"Empty deque:" _dq101076_)
              std/srfi/134#*empty*)
          (std/srfi/134#check
           (- (##structure-ref _dq101076_ '1 std/srfi/134#<ideque> '#f) '1)
           (cdr (##structure-ref _dq101076_ '2 std/srfi/134#<ideque> '#f))
           (##structure-ref _dq101076_ '3 std/srfi/134#<ideque> '#f)
           (##structure-ref _dq101076_ '4 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-add-back
    (lambda (_dq101073_ _x101074_)
      (std/srfi/134#%check-ideque _dq101073_)
      (std/srfi/134#check
       (##structure-ref _dq101073_ '1 std/srfi/134#<ideque> '#f)
       (##structure-ref _dq101073_ '2 std/srfi/134#<ideque> '#f)
       (+ (##structure-ref _dq101073_ '3 std/srfi/134#<ideque> '#f) '1)
       (cons _x101074_
             (##structure-ref _dq101073_ '4 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-back
    (lambda (_dq101071_)
      (std/srfi/134#%check-ideque _dq101071_)
      (if (zero? (##structure-ref _dq101071_ '3 std/srfi/134#<ideque> '#f))
          (if (zero? (##structure-ref _dq101071_ '1 std/srfi/134#<ideque> '#f))
              (error '"Empty deque:" _dq101071_)
              (car (##structure-ref _dq101071_ '2 std/srfi/134#<ideque> '#f)))
          (car (##structure-ref _dq101071_ '4 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-remove-back
    (lambda (_dq101069_)
      (std/srfi/134#%check-ideque _dq101069_)
      (if (zero? (##structure-ref _dq101069_ '3 std/srfi/134#<ideque> '#f))
          (if (zero? (##structure-ref _dq101069_ '1 std/srfi/134#<ideque> '#f))
              (error '"Empty deque:" _dq101069_)
              std/srfi/134#*empty*)
          (std/srfi/134#check
           (##structure-ref _dq101069_ '1 std/srfi/134#<ideque> '#f)
           (##structure-ref _dq101069_ '2 std/srfi/134#<ideque> '#f)
           (- (##structure-ref _dq101069_ '3 std/srfi/134#<ideque> '#f) '1)
           (cdr (##structure-ref _dq101069_ '4 std/srfi/134#<ideque> '#f))))))
  (define std/srfi/134#ideque-reverse
    (lambda (_dq101067_)
      (std/srfi/134#%check-ideque _dq101067_)
      (if (std/srfi/134#ideque-empty? _dq101067_)
          std/srfi/134#*empty*
          (let ((__tmp295196
                 (##structure-ref _dq101067_ '3 std/srfi/134#<ideque> '#f))
                (__tmp295195
                 (##structure-ref _dq101067_ '4 std/srfi/134#<ideque> '#f))
                (__tmp295194
                 (##structure-ref _dq101067_ '1 std/srfi/134#<ideque> '#f))
                (__tmp295193
                 (##structure-ref _dq101067_ '2 std/srfi/134#<ideque> '#f)))
            (declare (not safe))
            (##structure
             std/srfi/134#<ideque>
             __tmp295196
             __tmp295195
             __tmp295194
             __tmp295193)))))
  (define std/srfi/134#ideque=__0 (lambda (_elt=101041_) '#t))
  (define std/srfi/134#ideque=__1
    (lambda (_elt=101043_ _ideque101044_)
      (std/srfi/134#%check-ideque _ideque101044_)
      '#t))
  (define std/srfi/134#ideque=__2
    (lambda (_elt=101046_ _dq1101047_ _dq2101048_)
      (std/srfi/134#%check-ideque _dq1101047_)
      (std/srfi/134#%check-ideque _dq2101048_)
      (let ((_$e101050_ (eq? _dq1101047_ _dq2101048_)))
        (if _$e101050_
            _$e101050_
            (let ((_len1101053_
                   (+ (##structure-ref
                       _dq1101047_
                       '1
                       std/srfi/134#<ideque>
                       '#f)
                      (##structure-ref
                       _dq1101047_
                       '3
                       std/srfi/134#<ideque>
                       '#f)))
                  (_len2101054_
                   (+ (##structure-ref
                       _dq2101048_
                       '1
                       std/srfi/134#<ideque>
                       '#f)
                      (##structure-ref
                       _dq2101048_
                       '3
                       std/srfi/134#<ideque>
                       '#f))))
              (if (= _len1101053_ _len2101054_)
                  (let ((_g295197_
                         (std/srfi/134#list-prefix=
                          _elt=101046_
                          (##structure-ref
                           _dq1101047_
                           '2
                           std/srfi/134#<ideque>
                           '#f)
                          (##structure-ref
                           _dq2101048_
                           '2
                           std/srfi/134#<ideque>
                           '#f))))
                    (begin
                      (let ((_g295198_
                             (let ()
                               (declare (not safe))
                               (if (##values? _g295197_)
                                   (##vector-length _g295197_)
                                   1))))
                        (if (not (let ()
                                   (declare (not safe))
                                   (##fx= _g295198_ 3)))
                            (error "Context expects 3 values" _g295198_)))
                      (let ((_x101056_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g295197_ 0)))
                            (_t1101057_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g295197_ 1)))
                            (_t2101058_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g295197_ 2))))
                        (if _x101056_
                            (let ((_g295199_
                                   (std/srfi/134#list-prefix=
                                    _elt=101046_
                                    (##structure-ref
                                     _dq1101047_
                                     '4
                                     std/srfi/134#<ideque>
                                     '#f)
                                    (##structure-ref
                                     _dq2101048_
                                     '4
                                     std/srfi/134#<ideque>
                                     '#f))))
                              (begin
                                (let ((_g295200_
                                       (let ()
                                         (declare (not safe))
                                         (if (##values? _g295199_)
                                             (##vector-length _g295199_)
                                             1))))
                                  (if (not (let ()
                                             (declare (not safe))
                                             (##fx= _g295200_ 3)))
                                      (error "Context expects 3 values"
                                             _g295200_)))
                                (let ((_y101060_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g295199_ 0)))
                                      (_r1101061_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g295199_ 1)))
                                      (_r2101062_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g295199_ 2))))
                                  (if _y101060_
                                      (if (null? _t1101057_)
                                          (std/srfi/1#list=
                                           _elt=101046_
                                           _t2101058_
                                           (reverse _r1101061_))
                                          (std/srfi/1#list=
                                           _elt=101046_
                                           _t1101057_
                                           (reverse _r2101062_)))
                                      '#f))))
                            '#f))))
                  '#f))))))
  (define std/srfi/134#ideque=__3
    (lambda (_elt=101064_ . _dqs101065_)
      (apply std/srfi/1#list=
             _elt=101064_
             (map std/srfi/134#ideque->list _dqs101065_))))
  (define std/srfi/134#ideque=
    (lambda _g295202_
      (let ((_g295201_ (let () (declare (not safe)) (##length _g295202_))))
        (cond ((let () (declare (not safe)) (##fx= _g295201_ 1))
               (apply std/srfi/134#ideque=__0 _g295202_))
              ((let () (declare (not safe)) (##fx= _g295201_ 2))
               (apply std/srfi/134#ideque=__1 _g295202_))
              ((let () (declare (not safe)) (##fx= _g295201_ 3))
               (apply std/srfi/134#ideque=__2 _g295202_))
              ((let () (declare (not safe)) (##fx>= _g295201_ 1))
               (apply std/srfi/134#ideque=__3 _g295202_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/134#ideque=
                _g295202_))))))
  (define std/srfi/134#list-prefix=
    (lambda (_elt=101029_ _a101030_ _b101031_)
      (let _loop101033_ ((_a101035_ _a101030_) (_b101036_ _b101031_))
        (if (or (null? _a101035_) (null? _b101036_))
            (values '#t _a101035_ _b101036_)
            (if (_elt=101029_ (car _a101035_) (car _b101036_))
                (_loop101033_ (cdr _a101035_) (cdr _b101036_))
                (values '#f _a101035_ _b101036_))))))
  (define std/srfi/134#ideque-ref
    (lambda (_dq101021_ _n101022_)
      (std/srfi/134#%check-ideque _dq101021_)
      (let ((_len101024_
             (+ (##structure-ref _dq101021_ '1 std/srfi/134#<ideque> '#f)
                (##structure-ref _dq101021_ '3 std/srfi/134#<ideque> '#f))))
        (if (or (< _n101022_ '0) (>= _n101022_ _len101024_))
            (error '"Index out of range:" _n101022_)
            (if (< _n101022_
                   (##structure-ref _dq101021_ '1 std/srfi/134#<ideque> '#f))
                (list-ref
                 (##structure-ref _dq101021_ '2 std/srfi/134#<ideque> '#f)
                 _n101022_)
                (list-ref
                 (##structure-ref _dq101021_ '4 std/srfi/134#<ideque> '#f)
                 (- _len101024_ _n101022_ '1)))))))
  (define std/srfi/134#%ideque-take
    (lambda (_dq101013_ _n101014_)
      (let ((_lenf101016_
             (##structure-ref _dq101013_ '1 std/srfi/134#<ideque> '#f))
            (_f101017_
             (##structure-ref _dq101013_ '2 std/srfi/134#<ideque> '#f)))
        (if (<= _n101014_ _lenf101016_)
            (std/srfi/134#check
             _n101014_
             (std/srfi/1#take _f101017_ _n101014_)
             '0
             '())
            (let ((_lenr.101019_ (- _n101014_ _lenf101016_)))
              (std/srfi/134#check
               _lenf101016_
               _f101017_
               _lenr.101019_
               (std/srfi/1#take-right
                (##structure-ref _dq101013_ '4 std/srfi/134#<ideque> '#f)
                _lenr.101019_)))))))
  (define std/srfi/134#%ideque-drop
    (lambda (_dq101003_ _n101004_)
      (let ((_lenf101006_
             (##structure-ref _dq101003_ '1 std/srfi/134#<ideque> '#f))
            (_f101007_
             (##structure-ref _dq101003_ '2 std/srfi/134#<ideque> '#f))
            (_lenr101008_
             (##structure-ref _dq101003_ '3 std/srfi/134#<ideque> '#f))
            (_r101009_
             (##structure-ref _dq101003_ '4 std/srfi/134#<ideque> '#f)))
        (if (<= _n101004_ _lenf101006_)
            (std/srfi/134#check
             _n101004_
             (std/srfi/1#drop _f101007_ _n101004_)
             _lenr101008_
             _r101009_)
            (let ((_lenr.101011_ (- _lenr101008_ (- _n101004_ _lenf101006_))))
              (std/srfi/134#check
               '0
               '()
               _lenr.101011_
               (std/srfi/1#take _r101009_ _lenr.101011_)))))))
  (define std/srfi/134#%check-length
    (lambda (_dq101000_ _n101001_)
      (if (<= '0 _n101001_ (- (std/srfi/134#ideque-length _dq101000_) '1))
          '#!void
          (error '"argument is out of range:" _n101001_))))
  (define std/srfi/134#ideque-take
    (lambda (_dq100997_ _n100998_)
      (std/srfi/134#%check-ideque _dq100997_)
      (std/srfi/134#%check-length _dq100997_ _n100998_)
      (std/srfi/134#%ideque-take _dq100997_ _n100998_)))
  (define std/srfi/134#ideque-take-right
    (lambda (_dq100994_ _n100995_)
      (std/srfi/134#%check-ideque _dq100994_)
      (std/srfi/134#%check-length _dq100994_ _n100995_)
      (std/srfi/134#%ideque-drop
       _dq100994_
       (- (std/srfi/134#ideque-length _dq100994_) _n100995_))))
  (define std/srfi/134#ideque-drop
    (lambda (_dq100991_ _n100992_)
      (std/srfi/134#%check-ideque _dq100991_)
      (std/srfi/134#%check-length _dq100991_ _n100992_)
      (std/srfi/134#%ideque-drop _dq100991_ _n100992_)))
  (define std/srfi/134#ideque-drop-right
    (lambda (_dq100988_ _n100989_)
      (std/srfi/134#%check-ideque _dq100988_)
      (std/srfi/134#%check-length _dq100988_ _n100989_)
      (std/srfi/134#%ideque-take
       _dq100988_
       (- (std/srfi/134#ideque-length _dq100988_) _n100989_))))
  (define std/srfi/134#ideque-split-at
    (lambda (_dq100985_ _n100986_)
      (std/srfi/134#%check-ideque _dq100985_)
      (std/srfi/134#%check-length _dq100985_ _n100986_)
      (values (std/srfi/134#%ideque-take _dq100985_ _n100986_)
              (std/srfi/134#%ideque-drop _dq100985_ _n100986_))))
  (define std/srfi/134#ideque-length
    (lambda (_dq100983_)
      (std/srfi/134#%check-ideque _dq100983_)
      (+ (##structure-ref _dq100983_ '1 std/srfi/134#<ideque> '#f)
         (##structure-ref _dq100983_ '3 std/srfi/134#<ideque> '#f))))
  (define std/srfi/134#ideque-append
    (lambda _dqs100981_
      (std/srfi/134#list->ideque
       (std/srfi/1#concatenate (map std/srfi/134#ideque->list _dqs100981_)))))
  (define std/srfi/134#ideque-count
    (lambda (_pred100978_ _dq100979_)
      (std/srfi/134#%check-ideque _dq100979_)
      (+ (std/srfi/1#count
          _pred100978_
          (##structure-ref _dq100979_ '2 std/srfi/134#<ideque> '#f))
         (std/srfi/1#count
          _pred100978_
          (##structure-ref _dq100979_ '4 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-zip
    (lambda (_dq100973_ . _dqs100974_)
      (let ((_elts100976_
             (apply std/srfi/1#zip
                    (std/srfi/134#ideque->list _dq100973_)
                    (map std/srfi/134#ideque->list _dqs100974_))))
        (std/srfi/134#check (length _elts100976_) _elts100976_ '0 '()))))
  (define std/srfi/134#ideque-map
    (lambda (_proc100970_ _dq100971_)
      (std/srfi/134#%check-ideque _dq100971_)
      (let ((__tmp295206
             (##structure-ref _dq100971_ '1 std/srfi/134#<ideque> '#f))
            (__tmp295205
             (map _proc100970_
                  (##structure-ref _dq100971_ '2 std/srfi/134#<ideque> '#f)))
            (__tmp295204
             (##structure-ref _dq100971_ '3 std/srfi/134#<ideque> '#f))
            (__tmp295203
             (map _proc100970_
                  (##structure-ref _dq100971_ '4 std/srfi/134#<ideque> '#f))))
        (declare (not safe))
        (##structure
         std/srfi/134#<ideque>
         __tmp295206
         __tmp295205
         __tmp295204
         __tmp295203))))
  (define std/srfi/134#ideque-filter-map
    (lambda (_proc100964_ _dq100965_)
      (std/srfi/134#%check-ideque _dq100965_)
      (let ((_f100967_
             (filter-map1
              _proc100964_
              (##structure-ref _dq100965_ '2 std/srfi/134#<ideque> '#f)))
            (_r100968_
             (filter-map1
              _proc100964_
              (##structure-ref _dq100965_ '4 std/srfi/134#<ideque> '#f))))
        (std/srfi/134#check
         (length _f100967_)
         _f100967_
         (length _r100968_)
         _r100968_))))
  (define std/srfi/134#ideque-for-each
    (lambda (_proc100961_ _dq100962_)
      (std/srfi/134#%check-ideque _dq100962_)
      (for-each
       _proc100961_
       (##structure-ref _dq100962_ '2 std/srfi/134#<ideque> '#f))
      (for-each
       _proc100961_
       (reverse (##structure-ref _dq100962_ '4 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-for-each-right
    (lambda (_proc100958_ _dq100959_)
      (std/srfi/134#%check-ideque _dq100959_)
      (for-each
       _proc100958_
       (##structure-ref _dq100959_ '4 std/srfi/134#<ideque> '#f))
      (for-each
       _proc100958_
       (reverse (##structure-ref _dq100959_ '2 std/srfi/134#<ideque> '#f)))))
  (define std/srfi/134#ideque-fold
    (lambda (_proc100954_ _knil100955_ _dq100956_)
      (std/srfi/134#%check-ideque _dq100956_)
      (foldl1 _proc100954_
              (foldl1 _proc100954_
                      _knil100955_
                      (##structure-ref
                       _dq100956_
                       '2
                       std/srfi/134#<ideque>
                       '#f))
              (reverse (##structure-ref
                        _dq100956_
                        '4
                        std/srfi/134#<ideque>
                        '#f)))))
  (define std/srfi/134#ideque-fold-right
    (lambda (_proc100950_ _knil100951_ _dq100952_)
      (std/srfi/134#%check-ideque _dq100952_)
      (foldr1 _proc100950_
              (foldr1 _proc100950_
                      _knil100951_
                      (reverse (##structure-ref
                                _dq100952_
                                '4
                                std/srfi/134#<ideque>
                                '#f)))
              (##structure-ref _dq100952_ '2 std/srfi/134#<ideque> '#f))))
  (define std/srfi/134#ideque-append-map
    (lambda (_proc100947_ _dq100948_)
      (std/srfi/134#list->ideque
       (std/srfi/1#append-map
        _proc100947_
        (std/srfi/134#ideque->list _dq100948_)))))
  (define std/srfi/134#%ideque-filter-remove
    (lambda (_op100940_ _pred100941_ _dq100942_)
      (std/srfi/134#%check-ideque _dq100942_)
      (let ((_f100944_
             (_op100940_
              _pred100941_
              (##structure-ref _dq100942_ '2 std/srfi/134#<ideque> '#f)))
            (_r100945_
             (_op100940_
              _pred100941_
              (##structure-ref _dq100942_ '4 std/srfi/134#<ideque> '#f))))
        (std/srfi/134#check
         (length _f100944_)
         _f100944_
         (length _r100945_)
         _r100945_))))
  (define std/srfi/134#ideque-filter
    (lambda (_pred100937_ _dq100938_)
      (std/srfi/134#%ideque-filter-remove filter _pred100937_ _dq100938_)))
  (define std/srfi/134#ideque-remove
    (lambda (_pred100934_ _dq100935_)
      (std/srfi/134#%ideque-filter-remove
       std/srfi/1#remove
       _pred100934_
       _dq100935_)))
  (define std/srfi/134#ideque-partition
    (lambda (_pred100925_ _dq100926_)
      (std/srfi/134#%check-ideque _dq100926_)
      (let ((_g295207_
             (std/srfi/1#partition
              _pred100925_
              (##structure-ref _dq100926_ '2 std/srfi/134#<ideque> '#f))))
        (begin
          (let ((_g295208_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295207_) (##vector-length _g295207_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295208_ 2)))
                (error "Context expects 2 values" _g295208_)))
          (let ((_f1100928_
                 (let () (declare (not safe)) (##vector-ref _g295207_ 0)))
                (_f2100929_
                 (let () (declare (not safe)) (##vector-ref _g295207_ 1))))
            (let ((_g295209_
                   (std/srfi/1#partition
                    _pred100925_
                    (##structure-ref
                     _dq100926_
                     '4
                     std/srfi/134#<ideque>
                     '#f))))
              (begin
                (let ((_g295210_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g295209_)
                             (##vector-length _g295209_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g295210_ 2)))
                      (error "Context expects 2 values" _g295210_)))
                (let ((_r1100931_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g295209_ 0)))
                      (_r2100932_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g295209_ 1))))
                  (values (std/srfi/134#check
                           (length _f1100928_)
                           _f1100928_
                           (length _r1100931_)
                           _r1100931_)
                          (std/srfi/134#check
                           (length _f2100929_)
                           _f2100929_
                           (length _r2100932_)
                           _r2100932_))))))))))
  (define std/srfi/134#*not-found* (cons '#f '#f))
  (define std/srfi/134#%search
    (lambda (_pred100911_ _seq1100912_ _seq2100913_ _failure100914_)
      (letrec ((_seek100916_
                (lambda (_pred100922_ _s100923_)
                  (if (null? _s100923_)
                      std/srfi/134#*not-found*
                      (if (_pred100922_ (car _s100923_))
                          (car _s100923_)
                          (_seek100916_ _pred100922_ (cdr _s100923_)))))))
        (let ((_r100918_ (_seek100916_ _pred100911_ _seq1100912_)))
          (if (not (eq? _r100918_ std/srfi/134#*not-found*))
              _r100918_
              (let ((_r100920_
                     (_seek100916_ _pred100911_ (reverse _seq2100913_))))
                (if (not (eq? _r100920_ std/srfi/134#*not-found*))
                    _r100920_
                    (_failure100914_))))))))
  (define std/srfi/134#ideque-find
    (lambda (_pred100904_ _dq100905_ . _opts100906_)
      (std/srfi/134#%check-ideque _dq100905_)
      (let ((_failure100909_
             (if (pair? _opts100906_) (car _opts100906_) (lambda () '#f))))
        (std/srfi/134#%search
         _pred100904_
         (##structure-ref _dq100905_ '2 std/srfi/134#<ideque> '#f)
         (##structure-ref _dq100905_ '4 std/srfi/134#<ideque> '#f)
         _failure100909_))))
  (define std/srfi/134#ideque-find-right
    (lambda (_pred100897_ _dq100898_ . _opts100899_)
      (std/srfi/134#%check-ideque _dq100898_)
      (let ((_failure100902_
             (if (pair? _opts100899_) (car _opts100899_) (lambda () '#f))))
        (std/srfi/134#%search
         _pred100897_
         (##structure-ref _dq100898_ '4 std/srfi/134#<ideque> '#f)
         (##structure-ref _dq100898_ '2 std/srfi/134#<ideque> '#f)
         _failure100902_))))
  (define std/srfi/134#ideque-take-while
    (lambda (_pred100888_ _dq100889_)
      (std/srfi/134#%check-ideque _dq100889_)
      (let ((_g295211_
             (std/srfi/1#span
              _pred100888_
              (##structure-ref _dq100889_ '2 std/srfi/134#<ideque> '#f))))
        (begin
          (let ((_g295212_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295211_) (##vector-length _g295211_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295212_ 2)))
                (error "Context expects 2 values" _g295212_)))
          (let ((_hd100891_
                 (let () (declare (not safe)) (##vector-ref _g295211_ 0)))
                (_tl100892_
                 (let () (declare (not safe)) (##vector-ref _g295211_ 1))))
            (if (null? _tl100892_)
                (let ((_g295213_
                       (std/srfi/1#span
                        _pred100888_
                        (reverse (##structure-ref
                                  _dq100889_
                                  '4
                                  std/srfi/134#<ideque>
                                  '#f)))))
                  (begin
                    (let ((_g295214_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g295213_)
                                 (##vector-length _g295213_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g295214_ 2)))
                          (error "Context expects 2 values" _g295214_)))
                    (let ((_hd.100894_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295213_ 0)))
                          (_tl.100895_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295213_ 1))))
                      (std/srfi/134#check
                       (##structure-ref
                        _dq100889_
                        '1
                        std/srfi/134#<ideque>
                        '#f)
                       (##structure-ref
                        _dq100889_
                        '2
                        std/srfi/134#<ideque>
                        '#f)
                       (length _hd.100894_)
                       (reverse _hd.100894_)))))
                (std/srfi/134#check
                 (length _hd100891_)
                 _hd100891_
                 '0
                 '())))))))
  (define std/srfi/134#ideque-take-while-right
    (lambda (_pred100885_ _dq100886_)
      (std/srfi/134#%check-ideque _dq100886_)
      (std/srfi/134#ideque-reverse
       (std/srfi/134#ideque-take-while
        _pred100885_
        (std/srfi/134#ideque-reverse _dq100886_)))))
  (define std/srfi/134#ideque-drop-while
    (lambda (_pred100876_ _dq100877_)
      (std/srfi/134#%check-ideque _dq100877_)
      (let ((_g295215_
             (std/srfi/1#span
              _pred100876_
              (##structure-ref _dq100877_ '2 std/srfi/134#<ideque> '#f))))
        (begin
          (let ((_g295216_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295215_) (##vector-length _g295215_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295216_ 2)))
                (error "Context expects 2 values" _g295216_)))
          (let ((_hd100879_
                 (let () (declare (not safe)) (##vector-ref _g295215_ 0)))
                (_tl100880_
                 (let () (declare (not safe)) (##vector-ref _g295215_ 1))))
            (if (null? _tl100880_)
                (let ((_g295217_
                       (std/srfi/1#span
                        _pred100876_
                        (reverse (##structure-ref
                                  _dq100877_
                                  '4
                                  std/srfi/134#<ideque>
                                  '#f)))))
                  (begin
                    (let ((_g295218_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g295217_)
                                 (##vector-length _g295217_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g295218_ 2)))
                          (error "Context expects 2 values" _g295218_)))
                    (let ((_hd.100882_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295217_ 0)))
                          (_tl.100883_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295217_ 1))))
                      (std/srfi/134#check
                       (length _tl.100883_)
                       _tl.100883_
                       '0
                       '()))))
                (std/srfi/134#check
                 (length _tl100880_)
                 _tl100880_
                 (##structure-ref _dq100877_ '3 std/srfi/134#<ideque> '#f)
                 (##structure-ref
                  _dq100877_
                  '4
                  std/srfi/134#<ideque>
                  '#f))))))))
  (define std/srfi/134#ideque-drop-while-right
    (lambda (_pred100873_ _dq100874_)
      (std/srfi/134#%check-ideque _dq100874_)
      (std/srfi/134#ideque-reverse
       (std/srfi/134#ideque-drop-while
        _pred100873_
        (std/srfi/134#ideque-reverse _dq100874_)))))
  (define std/srfi/134#%idq-span-break
    (lambda (_op100863_ _pred100864_ _dq100865_)
      (std/srfi/134#%check-ideque _dq100865_)
      (let ((_g295219_
             (_op100863_
              _pred100864_
              (##structure-ref _dq100865_ '2 std/srfi/134#<ideque> '#f))))
        (begin
          (let ((_g295220_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295219_) (##vector-length _g295219_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295220_ 2)))
                (error "Context expects 2 values" _g295220_)))
          (let ((_head100867_
                 (let () (declare (not safe)) (##vector-ref _g295219_ 0)))
                (_tail100868_
                 (let () (declare (not safe)) (##vector-ref _g295219_ 1))))
            (if (null? _tail100868_)
                (let ((_g295221_
                       (_op100863_
                        _pred100864_
                        (reverse (##structure-ref
                                  _dq100865_
                                  '4
                                  std/srfi/134#<ideque>
                                  '#f)))))
                  (begin
                    (let ((_g295222_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g295221_)
                                 (##vector-length _g295221_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g295222_ 2)))
                          (error "Context expects 2 values" _g295222_)))
                    (let ((_head.100870_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295221_ 0)))
                          (_tail.100871_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295221_ 1))))
                      (values (std/srfi/134#check
                               (length _head100867_)
                               _head100867_
                               (length _head.100870_)
                               (reverse _head.100870_))
                              (std/srfi/134#check
                               (length _tail.100871_)
                               _tail.100871_
                               '0
                               '())))))
                (values (std/srfi/134#check
                         (length _head100867_)
                         _head100867_
                         '0
                         '())
                        (std/srfi/134#check
                         (length _tail100868_)
                         _tail100868_
                         (##structure-ref
                          _dq100865_
                          '3
                          std/srfi/134#<ideque>
                          '#f)
                         (##structure-ref
                          _dq100865_
                          '4
                          std/srfi/134#<ideque>
                          '#f)))))))))
  (define std/srfi/134#ideque-span
    (lambda (_pred100860_ _dq100861_)
      (std/srfi/134#%idq-span-break std/srfi/1#span _pred100860_ _dq100861_)))
  (define std/srfi/134#ideque-break
    (lambda (_pred100857_ _dq100858_)
      (std/srfi/134#%idq-span-break std/srfi/1#break _pred100857_ _dq100858_)))
  (define std/srfi/134#ideque-any
    (lambda (_pred100851_ _dq100852_)
      (std/srfi/134#%check-ideque _dq100852_)
      (if (null? (##structure-ref _dq100852_ '4 std/srfi/134#<ideque> '#f))
          (std/srfi/1#any
           _pred100851_
           (##structure-ref _dq100852_ '2 std/srfi/134#<ideque> '#f))
          (let ((_$e100854_
                 (std/srfi/1#any
                  _pred100851_
                  (##structure-ref _dq100852_ '2 std/srfi/134#<ideque> '#f))))
            (if _$e100854_
                _$e100854_
                (std/srfi/1#any
                 _pred100851_
                 (reverse (##structure-ref
                           _dq100852_
                           '4
                           std/srfi/134#<ideque>
                           '#f))))))))
  (define std/srfi/134#ideque-every
    (lambda (_pred100848_ _dq100849_)
      (std/srfi/134#%check-ideque _dq100849_)
      (if (null? (##structure-ref _dq100849_ '4 std/srfi/134#<ideque> '#f))
          (std/srfi/1#every
           _pred100848_
           (##structure-ref _dq100849_ '2 std/srfi/134#<ideque> '#f))
          (if (std/srfi/1#every
               _pred100848_
               (##structure-ref _dq100849_ '2 std/srfi/134#<ideque> '#f))
              (std/srfi/1#every
               _pred100848_
               (reverse (##structure-ref
                         _dq100849_
                         '4
                         std/srfi/134#<ideque>
                         '#f)))
              '#f))))
  (define std/srfi/134#ideque->list
    (lambda (_dq100846_)
      (std/srfi/134#%check-ideque _dq100846_)
      (append (##structure-ref _dq100846_ '2 std/srfi/134#<ideque> '#f)
              (reverse (##structure-ref
                        _dq100846_
                        '4
                        std/srfi/134#<ideque>
                        '#f)))))
  (define std/srfi/134#list->ideque
    (lambda (_lis100844_)
      (std/srfi/134#check (length _lis100844_) _lis100844_ '0 '())))
  (define std/srfi/134#ideque->generator
    (lambda (_dq100839_)
      (std/srfi/134#%check-ideque _dq100839_)
      (lambda ()
        (if (std/srfi/134#ideque-empty? _dq100839_)
            (eof-object)
            (let ((_v100842_ (std/srfi/134#ideque-front _dq100839_)))
              (set! _dq100839_ (std/srfi/134#ideque-remove-front _dq100839_))
              _v100842_)))))
  (define std/srfi/134#generator->ideque
    (lambda (_gen100837_)
      (std/srfi/134#list->ideque
       (std/srfi/121#generator->list__1 _gen100837_)))))
