(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/14#%latin1->char integer->char)
  (define std/srfi/14#%char->latin1 char->integer)
  (define std/srfi/14#:char-set
    (make-struct-type
     'std/srfi/14#:char-set
     '#f
     '1
     ':char-set
     '((fields: s))
     '#f))
  (define std/srfi/14#char-set? (make-struct-predicate std/srfi/14#:char-set))
  (define std/srfi/14#char-set:s
    (make-struct-field-accessor std/srfi/14#:char-set '0))
  (define std/srfi/14#make-char-set
    (lambda (_s58844_) (make-struct-instance std/srfi/14#:char-set _s58844_)))
  (define std/srfi/14#%string-copy
    (lambda (_s58842_) (substring _s58842_ '0 (string-length _s58842_))))
  (define std/srfi/14#%default-base
    (lambda (_maybe-base58836_ _proc58837_)
      (if (pair? _maybe-base58836_)
          (let ((_bcs58839_ (car _maybe-base58836_))
                (_tail58840_ (cdr _maybe-base58836_)))
            (if (null? _tail58840_)
                (if (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _bcs58839_
                       'std/srfi/14#:char-set))
                    (std/srfi/14#%string-copy
                     (##structure-ref _bcs58839_ '1 std/srfi/14#:char-set '#f))
                    (error '"BASE-CS parameter not a char-set"
                           _proc58837_
                           _bcs58839_))
                (error '"Expected final base char set -- too many parameters"
                       _proc58837_
                       _maybe-base58836_)))
          (make-string '256 (std/srfi/14#%latin1->char '0)))))
  (define std/srfi/14#%char-set:s/check
    (lambda (_cs58829_ _proc58830_)
      (let _lp58832_ ((_cs58834_ _cs58829_))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _cs58834_ 'std/srfi/14#:char-set))
            (##structure-ref _cs58834_ '1 std/srfi/14#:char-set '#f)
            (_lp58832_ (error '"Not a char-set" _cs58834_ _proc58830_))))))
  (define std/srfi/14#si=0?
    (lambda (_s58826_ _i58827_)
      (zero? (std/srfi/14#%char->latin1 (string-ref _s58826_ _i58827_)))))
  (define std/srfi/14#si=1?
    (lambda (_s58823_ _i58824_) (not (std/srfi/14#si=0? _s58823_ _i58824_))))
  (define std/srfi/14#c0 (std/srfi/14#%latin1->char '0))
  (define std/srfi/14#c1 (std/srfi/14#%latin1->char '1))
  (define std/srfi/14#si
    (lambda (_s58820_ _i58821_)
      (std/srfi/14#%char->latin1 (string-ref _s58820_ _i58821_))))
  (define std/srfi/14#%set0!
    (lambda (_s58817_ _i58818_)
      (string-set! _s58817_ _i58818_ std/srfi/14#c0)))
  (define std/srfi/14#%set1!
    (lambda (_s58814_ _i58815_)
      (string-set! _s58814_ _i58815_ std/srfi/14#c1)))
  (define std/srfi/14#setv!
    (lambda (_s58810_ _i58811_ _v58812_)
      (string-set! _s58810_ _i58811_ (std/srfi/14#%latin1->char _v58812_))))
  (define std/srfi/14#%not!
    (lambda (_s58806_ _i58807_ _v58808_)
      (std/srfi/14#setv! _s58806_ _i58807_ (- '1 _v58808_))))
  (define std/srfi/14#%and!
    (lambda (_s58802_ _i58803_ _v58804_)
      (if (zero? _v58804_) (std/srfi/14#%set0! _s58802_ _i58803_) '#!void)))
  (define std/srfi/14#%or!
    (lambda (_s58798_ _i58799_ _v58800_)
      (if (not (zero? _v58800_))
          (std/srfi/14#%set1! _s58798_ _i58799_)
          '#!void)))
  (define std/srfi/14#%minus!
    (lambda (_s58794_ _i58795_ _v58796_)
      (if (not (zero? _v58796_))
          (std/srfi/14#%set0! _s58794_ _i58795_)
          '#!void)))
  (define std/srfi/14#%xor!
    (lambda (_s58790_ _i58791_ _v58792_)
      (if (not (zero? _v58792_))
          (std/srfi/14#setv!
           _s58790_
           _i58791_
           (- '1 (std/srfi/14#si _s58790_ _i58791_)))
          '#!void)))
  (define std/srfi/14#char-set-copy
    (lambda (_cs58788_)
      (let ((__tmp294153
             (std/srfi/14#%string-copy
              (std/srfi/14#%char-set:s/check
               _cs58788_
               std/srfi/14#char-set-copy))))
        (declare (not safe))
        (##structure std/srfi/14#:char-set __tmp294153))))
  (define std/srfi/14#char-set=
    (lambda _rest58769_
      (let ((_$e58771_ (null? _rest58769_)))
        (if _$e58771_
            _$e58771_
            (let* ((_cs158774_ (car _rest58769_))
                   (_rest58776_ (cdr _rest58769_))
                   (_s158778_
                    (std/srfi/14#%char-set:s/check
                     _cs158774_
                     std/srfi/14#char-set=)))
              (let _lp58781_ ((_rest58783_ _rest58776_))
                (let ((_$e58785_ (not (pair? _rest58783_))))
                  (if _$e58785_
                      _$e58785_
                      (if (string=?
                           _s158778_
                           (std/srfi/14#%char-set:s/check
                            (car _rest58783_)
                            std/srfi/14#char-set=))
                          (_lp58781_ (cdr _rest58783_))
                          '#f)))))))))
  (define std/srfi/14#char-set<=
    (lambda _rest58746_
      (let ((_$e58748_ (null? _rest58746_)))
        (if _$e58748_
            _$e58748_
            (let ((_cs158751_ (car _rest58746_))
                  (_rest58752_ (cdr _rest58746_)))
              (let _lp58754_ ((_s158756_
                               (std/srfi/14#%char-set:s/check
                                _cs158751_
                                std/srfi/14#char-set<=))
                              (_rest58757_ _rest58752_))
                (let ((_$e58759_ (not (pair? _rest58757_))))
                  (if _$e58759_
                      _$e58759_
                      (let ((_s258762_
                             (std/srfi/14#%char-set:s/check
                              (car _rest58757_)
                              std/srfi/14#char-set<=))
                            (_rest58763_ (cdr _rest58757_)))
                        (if (eq? _s158756_ _s258762_)
                            (_lp58754_ _s258762_ _rest58763_)
                            (let _lp258765_ ((_i58767_ '255))
                              (if (< _i58767_ '0)
                                  (_lp58754_ _s258762_ _rest58763_)
                                  (if (<= (std/srfi/14#si _s158756_ _i58767_)
                                          (std/srfi/14#si _s258762_ _i58767_))
                                      (_lp258765_ (- _i58767_ '1))
                                      '#f)))))))))))))
  (define std/srfi/14#char-set-hash
    (lambda (_cs58717_ . _maybe-bound58718_)
      (let* ((_bound58728_
              (let ((_maybe-arg58720_ _maybe-bound58718_))
                (if (null? _maybe-arg58720_)
                    '4194304
                    (if (null? (cdr _maybe-arg58720_))
                        (let ((_val58723_ (car _maybe-arg58720_)))
                          (if ((lambda (_n58726_)
                                 (and (integer? _n58726_)
                                      (exact? _n58726_)
                                      (<= '0 _n58726_)))
                               _val58723_)
                              _val58723_
                              (error '"argument out of domain" _val58723_)))
                        (error '"too many optional arguments"
                               _maybe-arg58720_)))))
             (_bound58730_ (if (zero? _bound58728_) '4194304 _bound58728_))
             (_s58732_
              (std/srfi/14#%char-set:s/check
               _cs58717_
               std/srfi/14#char-set-hash))
             (_mask58738_
              (let _lp58734_ ((_i58736_ '65536))
                (if (>= _i58736_ _bound58730_)
                    (- _i58736_ '1)
                    (_lp58734_ (+ _i58736_ _i58736_))))))
        (let _lp58741_ ((_i58743_ '255) (_ans58744_ '0))
          (if (< _i58743_ '0)
              (modulo _ans58744_ _bound58730_)
              (_lp58741_
               (- _i58743_ '1)
               (if (std/srfi/14#si=0? _s58732_ _i58743_)
                   _ans58744_
                   (bitwise-and
                    _mask58738_
                    (+ (* '37 _ans58744_) _i58743_)))))))))
  (define std/srfi/14#char-set-contains?
    (lambda (_cs58714_ _char58715_)
      (std/srfi/14#si=1?
       (std/srfi/14#%char-set:s/check _cs58714_ std/srfi/14#char-set-contains?)
       (std/srfi/14#%char->latin1
        (if (char? _char58715_)
            _char58715_
            (error '"Bad argument" _char58715_ 'char? 'char-set-contains?))))))
  (define std/srfi/14#char-set-size
    (lambda (_cs58705_)
      (let ((_s58707_
             (std/srfi/14#%char-set:s/check
              _cs58705_
              std/srfi/14#char-set-size)))
        (let _lp58709_ ((_i58711_ '255) (_size58712_ '0))
          (if (< _i58711_ '0)
              _size58712_
              (_lp58709_
               (- _i58711_ '1)
               (+ _size58712_ (std/srfi/14#si _s58707_ _i58711_))))))))
  (define std/srfi/14#char-set-count
    (lambda (_pred58695_ _cset58696_)
      (if (procedure? _pred58695_)
          _pred58695_
          (error '"Bad argument" _pred58695_ 'procedure? 'char-set-count))
      (let ((_s58698_
             (std/srfi/14#%char-set:s/check
              _cset58696_
              std/srfi/14#char-set-count)))
        (let _lp58700_ ((_i58702_ '255) (_count58703_ '0))
          (if (< _i58702_ '0)
              _count58703_
              (_lp58700_
               (- _i58702_ '1)
               (if (and (std/srfi/14#si=1? _s58698_ _i58702_)
                        (_pred58695_ (std/srfi/14#%latin1->char _i58702_)))
                   (+ _count58703_ '1)
                   _count58703_)))))))
  (define std/srfi/14#%set-char-set
    (lambda (_set58686_ _proc58687_ _cs58688_ _chars58689_)
      (let ((_s58691_
             (std/srfi/14#%string-copy
              (std/srfi/14#%char-set:s/check _cs58688_ _proc58687_))))
        (for-each
         (lambda (_c58693_)
           (_set58686_ _s58691_ (std/srfi/14#%char->latin1 _c58693_)))
         _chars58689_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _s58691_)))))
  (define std/srfi/14#%set-char-set!
    (lambda (_set58677_ _proc58678_ _cs58679_ _chars58680_)
      (let ((_s58682_ (std/srfi/14#%char-set:s/check _cs58679_ _proc58678_)))
        (for-each
         (lambda (_c58684_)
           (_set58677_ _s58682_ (std/srfi/14#%char->latin1 _c58684_)))
         _chars58680_))
      _cs58679_))
  (define std/srfi/14#char-set-adjoin
    (lambda (_cs58674_ . _chars58675_)
      (std/srfi/14#%set-char-set
       std/srfi/14#%set1!
       std/srfi/14#char-set-adjoin
       _cs58674_
       _chars58675_)))
  (define std/srfi/14#char-set-adjoin!
    (lambda (_cs58671_ . _chars58672_)
      (std/srfi/14#%set-char-set!
       std/srfi/14#%set1!
       std/srfi/14#char-set-adjoin!
       _cs58671_
       _chars58672_)))
  (define std/srfi/14#char-set-delete
    (lambda (_cs58668_ . _chars58669_)
      (std/srfi/14#%set-char-set
       std/srfi/14#%set0!
       std/srfi/14#char-set-delete
       _cs58668_
       _chars58669_)))
  (define std/srfi/14#char-set-delete!
    (lambda (_cs58665_ . _chars58666_)
      (std/srfi/14#%set-char-set!
       std/srfi/14#%set0!
       std/srfi/14#char-set-delete!
       _cs58665_
       _chars58666_)))
  (define std/srfi/14#char-set-cursor
    (lambda (_cset58663_)
      (std/srfi/14#%char-set-cursor-next
       _cset58663_
       '256
       std/srfi/14#char-set-cursor)))
  (define std/srfi/14#end-of-char-set?
    (lambda (_cursor58661_) (< _cursor58661_ '0)))
  (define std/srfi/14#char-set-ref
    (lambda (_cset58658_ _cursor58659_)
      (std/srfi/14#%latin1->char _cursor58659_)))
  (define std/srfi/14#char-set-cursor-next
    (lambda (_cset58653_ _cursor58654_)
      (if ((lambda (_i58656_)
             (and (integer? _i58656_) (exact? _i58656_) (<= '0 _i58656_ '255)))
           _cursor58654_)
          _cursor58654_
          (error '"Bad argument"
                 _cursor58654_
                 '(lambda (i) (and (integer? i) (exact? i) (<= 0 i 255)))
                 'char-set-cursor-next))
      (std/srfi/14#%char-set-cursor-next
       _cset58653_
       _cursor58654_
       std/srfi/14#char-set-cursor-next)))
  (define std/srfi/14#%char-set-cursor-next
    (lambda (_cset58638_ _cursor58639_ _proc58640_)
      (let ((_s58642_ (std/srfi/14#%char-set:s/check _cset58638_ _proc58640_)))
        (let _lp58644_ ((_cur58646_ _cursor58639_))
          (let ((_cur58648_ (- _cur58646_ '1)))
            (if (or (< _cur58648_ '0) (std/srfi/14#si=1? _s58642_ _cur58648_))
                _cur58648_
                (_lp58644_ _cur58648_)))))))
  (define std/srfi/14#char-set-for-each
    (lambda (_proc58629_ _cs58630_)
      (if (procedure? _proc58629_)
          _proc58629_
          (error '"Bad argument" _proc58629_ 'procedure? 'char-set-for-each))
      (let ((_s58632_
             (std/srfi/14#%char-set:s/check
              _cs58630_
              std/srfi/14#char-set-for-each)))
        (let _lp58634_ ((_i58636_ '255))
          (if (>= _i58636_ '0)
              (begin
                (if (std/srfi/14#si=1? _s58632_ _i58636_)
                    (_proc58629_ (std/srfi/14#%latin1->char _i58636_))
                    '#!void)
                (_lp58634_ (- _i58636_ '1)))
              '#!void)))))
  (define std/srfi/14#char-set-map
    (lambda (_proc58619_ _cs58620_)
      (if (procedure? _proc58619_)
          _proc58619_
          (error '"Bad argument" _proc58619_ 'procedure? 'char-set-map))
      (let ((_s58622_
             (std/srfi/14#%char-set:s/check
              _cs58620_
              std/srfi/14#char-set-map))
            (_ans58623_ (make-string '256 std/srfi/14#c0)))
        (let _lp58625_ ((_i58627_ '255))
          (if (>= _i58627_ '0)
              (begin
                (if (std/srfi/14#si=1? _s58622_ _i58627_)
                    (std/srfi/14#%set1!
                     _ans58623_
                     (std/srfi/14#%char->latin1
                      (_proc58619_ (std/srfi/14#%latin1->char _i58627_))))
                    '#!void)
                (_lp58625_ (- _i58627_ '1)))
              '#!void))
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _ans58623_)))))
  (define std/srfi/14#char-set-fold
    (lambda (_kons58608_ _knil58609_ _cs58610_)
      (if (procedure? _kons58608_)
          _kons58608_
          (error '"Bad argument" _kons58608_ 'procedure? 'char-set-fold))
      (let ((_s58612_
             (std/srfi/14#%char-set:s/check
              _cs58610_
              std/srfi/14#char-set-fold)))
        (let _lp58614_ ((_i58616_ '255) (_ans58617_ _knil58609_))
          (if (< _i58616_ '0)
              _ans58617_
              (_lp58614_
               (- _i58616_ '1)
               (if (std/srfi/14#si=0? _s58612_ _i58616_)
                   _ans58617_
                   (_kons58608_
                    (std/srfi/14#%latin1->char _i58616_)
                    _ans58617_))))))))
  (define std/srfi/14#char-set-every
    (lambda (_pred58593_ _cs58594_)
      (if (procedure? _pred58593_)
          _pred58593_
          (error '"Bad argument" _pred58593_ 'procedure? 'char-set-every))
      (let ((_s58596_
             (std/srfi/14#%char-set:s/check
              _cs58594_
              std/srfi/14#char-set-every)))
        (let _lp58598_ ((_i58600_ '255))
          (let ((_$e58602_ (< _i58600_ '0)))
            (if _$e58602_
                _$e58602_
                (if (or (std/srfi/14#si=0? _s58596_ _i58600_)
                        (_pred58593_ (std/srfi/14#%latin1->char _i58600_)))
                    (_lp58598_ (- _i58600_ '1))
                    '#f)))))))
  (define std/srfi/14#char-set-any
    (lambda (_pred58581_ _cs58582_)
      (if (procedure? _pred58581_)
          _pred58581_
          (error '"Bad argument" _pred58581_ 'procedure? 'char-set-any))
      (let ((_s58584_
             (std/srfi/14#%char-set:s/check
              _cs58582_
              std/srfi/14#char-set-any)))
        (let _lp58586_ ((_i58588_ '255))
          (if (>= _i58588_ '0)
              (let ((_$e58590_
                     (if (std/srfi/14#si=1? _s58584_ _i58588_)
                         (_pred58581_ (std/srfi/14#%latin1->char _i58588_))
                         '#f)))
                (if _$e58590_ _$e58590_ (_lp58586_ (- _i58588_ '1))))
              '#f)))))
  (define std/srfi/14#%char-set-unfold!
    (lambda (_proc58570_ _p58571_ _f58572_ _g58573_ _s58574_ _seed58575_)
      (if (procedure? _p58571_)
          _p58571_
          (error '"Bad argument" _p58571_ 'procedure? 'proc))
      (if (procedure? _f58572_)
          _f58572_
          (error '"Bad argument" _f58572_ 'procedure? 'proc))
      (if (procedure? _g58573_)
          _g58573_
          (error '"Bad argument" _g58573_ 'procedure? 'proc))
      (let _lp58577_ ((_seed58579_ _seed58575_))
        (if (not (_p58571_ _seed58579_))
            (begin
              (std/srfi/14#%set1!
               _s58574_
               (std/srfi/14#%char->latin1 (_f58572_ _seed58579_)))
              (_lp58577_ (_g58573_ _seed58579_)))
            '#!void))))
  (define std/srfi/14#char-set-unfold
    (lambda (_p58562_ _f58563_ _g58564_ _seed58565_ . _maybe-base58566_)
      (let ((_bs58568_
             (std/srfi/14#%default-base
              _maybe-base58566_
              std/srfi/14#char-set-unfold)))
        (std/srfi/14#%char-set-unfold!
         std/srfi/14#char-set-unfold
         _p58562_
         _f58563_
         _g58564_
         _bs58568_
         _seed58565_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58568_)))))
  (define std/srfi/14#char-set-unfold!
    (lambda (_p58556_ _f58557_ _g58558_ _seed58559_ _base-cset58560_)
      (std/srfi/14#%char-set-unfold!
       std/srfi/14#char-set-unfold!
       _p58556_
       _f58557_
       _g58558_
       (std/srfi/14#%char-set:s/check
        _base-cset58560_
        std/srfi/14#char-set-unfold!)
       _seed58559_)
      _base-cset58560_))
  (define std/srfi/14#%list->char-set!
    (lambda (_chars58551_ _s58552_)
      (for-each
       (lambda (_char58554_)
         (std/srfi/14#%set1! _s58552_ (std/srfi/14#%char->latin1 _char58554_)))
       _chars58551_)))
  (define std/srfi/14#char-set
    (lambda _chars58547_
      (let ((_s58549_ (make-string '256 std/srfi/14#c0)))
        (std/srfi/14#%list->char-set! _chars58547_ _s58549_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _s58549_)))))
  (define std/srfi/14#list->char-set
    (lambda (_chars58542_ . _maybe-base58543_)
      (let ((_bs58545_
             (std/srfi/14#%default-base
              _maybe-base58543_
              std/srfi/14#list->char-set)))
        (std/srfi/14#%list->char-set! _chars58542_ _bs58545_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58545_)))))
  (define std/srfi/14#list->char-set!
    (lambda (_chars58539_ _base-cs58540_)
      (std/srfi/14#%list->char-set!
       _chars58539_
       (std/srfi/14#%char-set:s/check
        _base-cs58540_
        std/srfi/14#list->char-set!))
      _base-cs58540_))
  (define std/srfi/14#char-set->list
    (lambda (_cs58530_)
      (let ((_s58532_
             (std/srfi/14#%char-set:s/check
              _cs58530_
              std/srfi/14#char-set->list)))
        (let _lp58534_ ((_i58536_ '255) (_ans58537_ '()))
          (if (< _i58536_ '0)
              _ans58537_
              (_lp58534_
               (- _i58536_ '1)
               (if (std/srfi/14#si=0? _s58532_ _i58536_)
                   _ans58537_
                   (cons (std/srfi/14#%latin1->char _i58536_)
                         _ans58537_))))))))
  (define std/srfi/14#%string->char-set!
    (lambda (_str58521_ _bs58522_ _proc58523_)
      (if (string? _str58521_)
          _str58521_
          (error '"Bad argument" _str58521_ 'string? 'proc))
      (let _$loop58525_ ((_i58528_ (- (string-length _str58521_) '1)))
        (if (< _i58528_ '0)
            '#!void
            (begin
              (std/srfi/14#%set1!
               _bs58522_
               (std/srfi/14#%char->latin1 (string-ref _str58521_ _i58528_)))
              (_$loop58525_ (- _i58528_ '1)))))))
  (define std/srfi/14#string->char-set
    (lambda (_str58516_ . _maybe-base58517_)
      (let ((_bs58519_
             (std/srfi/14#%default-base
              _maybe-base58517_
              std/srfi/14#string->char-set)))
        (std/srfi/14#%string->char-set!
         _str58516_
         _bs58519_
         std/srfi/14#string->char-set)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58519_)))))
  (define std/srfi/14#string->char-set!
    (lambda (_str58513_ _base-cs58514_)
      (std/srfi/14#%string->char-set!
       _str58513_
       (std/srfi/14#%char-set:s/check
        _base-cs58514_
        std/srfi/14#string->char-set!)
       std/srfi/14#string->char-set!)
      _base-cs58514_))
  (define std/srfi/14#char-set->string
    (lambda (_cs58499_)
      (let* ((_s58501_
              (std/srfi/14#%char-set:s/check
               _cs58499_
               std/srfi/14#char-set->string))
             (_ans58503_ (make-string (std/srfi/14#char-set-size _cs58499_))))
        (let _lp58506_ ((_i58508_ '255) (_j58509_ '0))
          (if (< _i58508_ '0)
              _ans58503_
              (let ((_j58511_
                     (if (std/srfi/14#si=0? _s58501_ _i58508_)
                         _j58509_
                         (begin
                           (string-set!
                            _ans58503_
                            _j58509_
                            (std/srfi/14#%latin1->char _i58508_))
                           (+ _j58509_ '1)))))
                (_lp58506_ (- _i58508_ '1) _j58511_)))))))
  (define std/srfi/14#%ucs-range->char-set!
    (lambda (_lower58485_ _upper58486_ _error?58487_ _bs58488_ _proc58489_)
      (if ((lambda (_x58491_)
             (and (integer? _x58491_) (exact? _x58491_) (<= '0 _x58491_)))
           _lower58485_)
          _lower58485_
          (error '"Bad argument"
                 _lower58485_
                 '(lambda (x) (and (integer? x) (exact? x) (<= 0 x)))
                 'proc))
      (if ((lambda (_x58493_)
             (and (integer? _x58493_)
                  (exact? _x58493_)
                  (<= _lower58485_ _x58493_)))
           _upper58486_)
          _upper58486_
          (error '"Bad argument"
                 _upper58486_
                 '(lambda (x) (and (integer? x) (exact? x) (<= lower x)))
                 'proc))
      (if (and (< _lower58485_ _upper58486_)
               (< '256 _upper58486_)
               _error?58487_)
          (error '"Requested UCS range contains unavailable characters -- this implementation only supports Latin-1"
                 _proc58489_
                 _lower58485_
                 _upper58486_)
          '#!void)
      (let _lp58495_ ((_i58497_ (- (min _upper58486_ '256) '1)))
        (if (<= _lower58485_ _i58497_)
            (begin
              (std/srfi/14#%set1! _bs58488_ _i58497_)
              (_lp58495_ (- _i58497_ '1)))
            '#!void))))
  (define std/srfi/14#ucs-range->char-set
    (lambda (_lower58469_ _upper58470_ . _rest58471_)
      (let ((_rest58473_ _rest58471_))
        (call-with-values
         (lambda ()
           (if (null? _rest58473_)
               (values '#f '())
               (values (car _rest58473_) (cdr _rest58473_))))
         (lambda (_error?58477_ _rest58478_)
           (if '#t
               (let* ((_rest58481_ _rest58478_)
                      (_bs58483_
                       (std/srfi/14#%default-base
                        _rest58481_
                        std/srfi/14#ucs-range->char-set)))
                 (std/srfi/14#%ucs-range->char-set!
                  _lower58469_
                  _upper58470_
                  _error?58477_
                  _bs58483_
                  std/srfi/14#ucs-range->char-set)
                 (let ()
                   (declare (not safe))
                   (##structure std/srfi/14#:char-set _bs58483_)))
               (error '"argument out of domain" _error?58477_)))))))
  (define std/srfi/14#ucs-range->char-set!
    (lambda (_lower58464_ _upper58465_ _error?58466_ _base-cs58467_)
      (std/srfi/14#%ucs-range->char-set!
       _lower58464_
       _upper58465_
       _error?58466_
       (std/srfi/14#%char-set:s/check
        _base-cs58467_
        std/srfi/14#ucs-range->char-set!)
       std/srfi/14#ucs-range->char-set)
      _base-cs58467_))
  (define std/srfi/14#%char-set-filter!
    (lambda (_pred58455_ _ds58456_ _bs58457_ _proc58458_)
      (if (procedure? _pred58455_)
          _pred58455_
          (error '"Bad argument" _pred58455_ 'procedure? 'proc))
      (let _lp58460_ ((_i58462_ '255))
        (if (>= _i58462_ '0)
            (begin
              (if (and (std/srfi/14#si=1? _ds58456_ _i58462_)
                       (_pred58455_ (std/srfi/14#%latin1->char _i58462_)))
                  (std/srfi/14#%set1! _bs58457_ _i58462_)
                  '#!void)
              (_lp58460_ (- _i58462_ '1)))
            '#!void))))
  (define std/srfi/14#char-set-filter
    (lambda (_predicate58449_ _domain58450_ . _maybe-base58451_)
      (let ((_bs58453_
             (std/srfi/14#%default-base
              _maybe-base58451_
              std/srfi/14#char-set-filter)))
        (std/srfi/14#%char-set-filter!
         _predicate58449_
         (std/srfi/14#%char-set:s/check
          _domain58450_
          std/srfi/14#char-set-filter!)
         _bs58453_
         std/srfi/14#char-set-filter)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58453_)))))
  (define std/srfi/14#char-set-filter!
    (lambda (_predicate58445_ _domain58446_ _base-cs58447_)
      (std/srfi/14#%char-set-filter!
       _predicate58445_
       (std/srfi/14#%char-set:s/check
        _domain58446_
        std/srfi/14#char-set-filter!)
       (std/srfi/14#%char-set:s/check
        _base-cs58447_
        std/srfi/14#char-set-filter!)
       std/srfi/14#char-set-filter!)
      _base-cs58447_))
  (define std/srfi/14#->char-set
    (lambda (_x58443_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _x58443_ 'std/srfi/14#:char-set))
          _x58443_
          (if (string? _x58443_)
              (std/srfi/14#string->char-set _x58443_)
              (if (char? _x58443_)
                  (std/srfi/14#char-set _x58443_)
                  (error '"->char-set: Not a charset, string or char."
                         _x58443_))))))
  (define std/srfi/14#%string-iter
    (lambda (_p58436_ _s58437_)
      (let _lp58439_ ((_i58441_ (- (string-length _s58437_) '1)))
        (if (>= _i58441_ '0)
            (begin
              (_p58436_
               _i58441_
               (std/srfi/14#%char->latin1 (string-ref _s58437_ _i58441_)))
              (_lp58439_ (- _i58441_ '1)))
            '#!void))))
  (define std/srfi/14#%char-set-algebra
    (lambda (_s58423_ _csets58424_ _op58425_ _proc58426_)
      (for-each
       (lambda (_cset58428_)
         (let ((_s258430_
                (std/srfi/14#%char-set:s/check _cset58428_ _proc58426_)))
           (let _lp58432_ ((_i58434_ '255))
             (if (>= _i58434_ '0)
                 (begin
                   (_op58425_
                    _s58423_
                    _i58434_
                    (std/srfi/14#si _s258430_ _i58434_))
                   (_lp58432_ (- _i58434_ '1)))
                 '#!void))))
       _csets58424_)))
  (define std/srfi/14#char-set-complement
    (lambda (_cs58415_)
      (let ((_s58417_
             (std/srfi/14#%char-set:s/check
              _cs58415_
              std/srfi/14#char-set-complement))
            (_ans58418_ (make-string '256)))
        (std/srfi/14#%string-iter
         (lambda (_i58420_ _v58421_)
           (std/srfi/14#%not! _ans58418_ _i58420_ _v58421_))
         _s58417_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _ans58418_)))))
  (define std/srfi/14#char-set-complement!
    (lambda (_cset58408_)
      (let ((_s58410_
             (std/srfi/14#%char-set:s/check
              _cset58408_
              std/srfi/14#char-set-complement!)))
        (std/srfi/14#%string-iter
         (lambda (_i58412_ _v58413_)
           (std/srfi/14#%not! _s58410_ _i58412_ _v58413_))
         _s58410_))
      _cset58408_))
  (define std/srfi/14#char-set-union!
    (lambda (_cset158405_ . _csets58406_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check _cset158405_ std/srfi/14#char-set-union!)
       _csets58406_
       std/srfi/14#%or!
       std/srfi/14#char-set-union!)
      _cset158405_))
  (define std/srfi/14#char-set-union
    (lambda _csets58401_
      (if (pair? _csets58401_)
          (let ((_s58403_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   (car _csets58401_)
                   std/srfi/14#char-set-union))))
            (std/srfi/14#%char-set-algebra
             _s58403_
             (cdr _csets58401_)
             std/srfi/14#%or!
             std/srfi/14#char-set-union)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58403_)))
          (std/srfi/14#char-set-copy std/srfi/14#char-set:empty))))
  (define std/srfi/14#char-set-intersection!
    (lambda (_cset158398_ . _csets58399_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check
        _cset158398_
        std/srfi/14#char-set-intersection!)
       _csets58399_
       std/srfi/14#%and!
       std/srfi/14#char-set-intersection!)
      _cset158398_))
  (define std/srfi/14#char-set-intersection
    (lambda _csets58394_
      (if (pair? _csets58394_)
          (let ((_s58396_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   (car _csets58394_)
                   std/srfi/14#char-set-intersection))))
            (std/srfi/14#%char-set-algebra
             _s58396_
             (cdr _csets58394_)
             std/srfi/14#%and!
             std/srfi/14#char-set-intersection)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58396_)))
          (std/srfi/14#char-set-copy std/srfi/14#char-set:full))))
  (define std/srfi/14#char-set-difference!
    (lambda (_cset158391_ . _csets58392_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check
        _cset158391_
        std/srfi/14#char-set-difference!)
       _csets58392_
       std/srfi/14#%minus!
       std/srfi/14#char-set-difference!)
      _cset158391_))
  (define std/srfi/14#char-set-difference
    (lambda (_cs158386_ . _csets58387_)
      (if (pair? _csets58387_)
          (let ((_s58389_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   _cs158386_
                   std/srfi/14#char-set-difference))))
            (std/srfi/14#%char-set-algebra
             _s58389_
             _csets58387_
             std/srfi/14#%minus!
             std/srfi/14#char-set-difference)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58389_)))
          (std/srfi/14#char-set-copy _cs158386_))))
  (define std/srfi/14#char-set-xor!
    (lambda (_cset158383_ . _csets58384_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check _cset158383_ std/srfi/14#char-set-xor!)
       _csets58384_
       std/srfi/14#%xor!
       std/srfi/14#char-set-xor!)
      _cset158383_))
  (define std/srfi/14#char-set-xor
    (lambda _csets58379_
      (if (pair? _csets58379_)
          (let ((_s58381_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   (car _csets58379_)
                   std/srfi/14#char-set-xor))))
            (std/srfi/14#%char-set-algebra
             _s58381_
             (cdr _csets58379_)
             std/srfi/14#%xor!
             std/srfi/14#char-set-xor)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58381_)))
          (std/srfi/14#char-set-copy std/srfi/14#char-set:empty))))
  (define std/srfi/14#%char-set-diff+intersection!
    (lambda (_diff58369_ _int58370_ _csets58371_ _proc58372_)
      (for-each
       (lambda (_cs58374_)
         (std/srfi/14#%string-iter
          (lambda (_i58376_ _v58377_)
            (if (not (zero? _v58377_))
                (if (std/srfi/14#si=1? _diff58369_ _i58376_)
                    (begin
                      (std/srfi/14#%set0! _diff58369_ _i58376_)
                      (std/srfi/14#%set1! _int58370_ _i58376_))
                    '#!void)
                '#!void))
          (std/srfi/14#%char-set:s/check _cs58374_ _proc58372_)))
       _csets58371_)))
  (define std/srfi/14#char-set-diff+intersection!
    (lambda (_cs158359_ _cs258360_ . _csets58361_)
      (let ((_s158363_
             (std/srfi/14#%char-set:s/check
              _cs158359_
              std/srfi/14#char-set-diff+intersection!))
            (_s258364_
             (std/srfi/14#%char-set:s/check
              _cs258360_
              std/srfi/14#char-set-diff+intersection!)))
        (std/srfi/14#%string-iter
         (lambda (_i58366_ _v58367_)
           (if (zero? _v58367_)
               (std/srfi/14#%set0! _s258364_ _i58366_)
               (if (std/srfi/14#si=1? _s258364_ _i58366_)
                   (std/srfi/14#%set0! _s158363_ _i58366_)
                   '#!void)))
         _s158363_)
        (std/srfi/14#%char-set-diff+intersection!
         _s158363_
         _s258364_
         _csets58361_
         std/srfi/14#char-set-diff+intersection!))
      (values _cs158359_ _cs258360_)))
  (define std/srfi/14#char-set-diff+intersection
    (lambda (_cs158353_ . _csets58354_)
      (let ((_diff58356_
             (string-copy
              (std/srfi/14#%char-set:s/check
               _cs158353_
               std/srfi/14#char-set-diff+intersection)))
            (_int58357_ (make-string '256 std/srfi/14#c0)))
        (std/srfi/14#%char-set-diff+intersection!
         _diff58356_
         _int58357_
         _csets58354_
         std/srfi/14#char-set-diff+intersection)
        (values (let ()
                  (declare (not safe))
                  (##structure std/srfi/14#:char-set _diff58356_))
                (let ()
                  (declare (not safe))
                  (##structure std/srfi/14#:char-set _int58357_))))))
  (define std/srfi/14#char-set:empty (std/srfi/14#char-set))
  (define std/srfi/14#char-set:full
    (std/srfi/14#char-set-complement std/srfi/14#char-set:empty))
  (define std/srfi/14#char-set:lower-case
    (let* ((_a-z58346_ (std/srfi/14#ucs-range->char-set '97 '123))
           (_latin158348_
            (std/srfi/14#ucs-range->char-set! '223 '247 '#t _a-z58346_))
           (_latin258350_
            (std/srfi/14#ucs-range->char-set! '248 '256 '#t _latin158348_)))
      (std/srfi/14#char-set-adjoin!
       _latin258350_
       (std/srfi/14#%latin1->char '181))))
  (define std/srfi/14#char-set:upper-case
    (let ((_A-Z58344_ (std/srfi/14#ucs-range->char-set '65 '91)))
      (std/srfi/14#ucs-range->char-set!
       '216
       '223
       '#t
       (std/srfi/14#ucs-range->char-set! '192 '215 '#t _A-Z58344_))))
  (define std/srfi/14#char-set:title-case std/srfi/14#char-set:empty)
  (define std/srfi/14#char-set:letter
    (let ((_u/l58342_
           (std/srfi/14#char-set-union
            std/srfi/14#char-set:upper-case
            std/srfi/14#char-set:lower-case)))
      (std/srfi/14#char-set-adjoin!
       _u/l58342_
       (std/srfi/14#%latin1->char '170)
       (std/srfi/14#%latin1->char '186))))
  (define std/srfi/14#char-set:digit
    (std/srfi/14#string->char-set '"0123456789"))
  (define std/srfi/14#char-set:hex-digit
    (std/srfi/14#string->char-set '"0123456789abcdefABCDEF"))
  (define std/srfi/14#char-set:letter+digit
    (std/srfi/14#char-set-union
     std/srfi/14#char-set:letter
     std/srfi/14#char-set:digit))
  (define std/srfi/14#char-set:punctuation
    (let ((_ascii58339_
           (std/srfi/14#string->char-set '"!\"#%&'()*,-./:;?@[\\]_{}"))
          (_latin-1-chars58340_
           (map std/srfi/14#%latin1->char '(161 171 173 183 187 191))))
      (std/srfi/14#list->char-set! _latin-1-chars58340_ _ascii58339_)))
  (define std/srfi/14#char-set:symbol
    (let ((_ascii58336_ (std/srfi/14#string->char-set '"$+<=>^`|~"))
          (_latin-1-chars58337_
           (map std/srfi/14#%latin1->char
                '(162
                  163
                  164
                  165
                  166
                  167
                  168
                  169
                  172
                  174
                  175
                  176
                  177
                  180
                  182
                  184
                  215
                  247))))
      (std/srfi/14#list->char-set! _latin-1-chars58337_ _ascii58336_)))
  (define std/srfi/14#char-set:graphic
    (std/srfi/14#char-set-union
     std/srfi/14#char-set:letter+digit
     std/srfi/14#char-set:punctuation
     std/srfi/14#char-set:symbol))
  (define std/srfi/14#char-set:whitespace
    (std/srfi/14#list->char-set
     (map std/srfi/14#%latin1->char '(9 10 11 12 13 32 160))))
  (define std/srfi/14#char-set:printing
    (std/srfi/14#char-set-union
     std/srfi/14#char-set:whitespace
     std/srfi/14#char-set:graphic))
  (define std/srfi/14#char-set:blank
    (std/srfi/14#list->char-set (map std/srfi/14#%latin1->char '(9 32 160))))
  (define std/srfi/14#char-set:iso-control
    (std/srfi/14#ucs-range->char-set!
     '127
     '160
     '#t
     (std/srfi/14#ucs-range->char-set '0 '32)))
  (define std/srfi/14#char-set:ascii
    (std/srfi/14#ucs-range->char-set '0 '128)))
