(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/143#fx-width ##fixnum-width)
  (define std/srfi/143#fx-greatest ##max-fixnum)
  (define std/srfi/143#fx-least ##min-fixnum)
  (define std/srfi/143#fxneg (lambda (_x104827_) (fx- _x104827_)))
  (define std/srfi/143#fxsqrt
    (lambda (_x104825_)
      (let () (declare (not safe)) (##integer-sqrt _x104825_))))
  (define std/srfi/143#fxcopy-bit
    (lambda (_index104821_ _to104822_ _bool104823_)
      (if _bool104823_
          (fxior _to104822_ (fxarithmetic-shift-left '1 _index104821_))
          (fxand _to104822_
                 (fxnot (fxarithmetic-shift-left '1 _index104821_))))))
  (define std/srfi/143#mask
    (lambda (_start104818_ _end104819_)
      (fxnot (fxarithmetic-shift-left '-1 (fx- _end104819_ _start104818_)))))
  (define std/srfi/143#fxbit-field
    (lambda (_n104814_ _start104815_ _end104816_)
      (fxand (std/srfi/143#mask _start104815_ _end104816_)
             (fxarithmetic-shift _n104814_ (fx- _start104815_)))))
  (define std/srfi/143#fxbit-field-rotate
    (lambda (_n104803_ _count104804_ _start104805_ _end104806_)
      (letrec* ((_width104808_ (fx- _end104806_ _start104805_)))
        (set! _count104804_ (fxmodulo _count104804_ _width104808_))
        (let ((_mask104810_ (fxnot (fxarithmetic-shift '-1 _width104808_))))
          (letrec* ((_zn104812_
                     (fxand _mask104810_
                            (fxarithmetic-shift
                             _n104803_
                             (fx- _start104805_)))))
            (fxior (fxarithmetic-shift
                    (fxior (fxand _mask104810_
                                  (fxarithmetic-shift
                                   _zn104812_
                                   _count104804_))
                           (fxarithmetic-shift
                            _zn104812_
                            (fx- _count104804_ _width104808_)))
                    _start104805_)
                   (fxand (fxnot (fxarithmetic-shift
                                  _mask104810_
                                  _start104805_))
                          _n104803_)))))))
  (define std/srfi/143#fxreverse
    (lambda (_k104793_ _n104794_)
      (let _$loop104796_ ((_m104799_
                           (if (fxnegative? _n104794_)
                               (fxnot _n104794_)
                               _n104794_))
                          (_k104800_ (fx+ '-1 _k104793_))
                          (_rvs104801_ '0))
        (if (fxnegative? _k104800_)
            (if (fxnegative? _n104794_) (fxnot _rvs104801_) _rvs104801_)
            (_$loop104796_
             (fxarithmetic-shift-right _m104799_ '1)
             (fx+ '-1 _k104800_)
             (fxior (fxarithmetic-shift-left _rvs104801_ '1)
                    (fxand '1 _m104799_)))))))
  (define std/srfi/143#fxbit-field-reverse
    (lambda (_n104783_ _start104784_ _end104785_)
      (letrec* ((_width104787_ (fx- _end104785_ _start104784_)))
        (let ((_mask104789_
               (fxnot (fxarithmetic-shift-left '-1 _width104787_))))
          (letrec* ((_zn104791_
                     (fxand _mask104789_
                            (fxarithmetic-shift-right
                             _n104783_
                             _start104784_))))
            (fxior (fxarithmetic-shift-left
                    (std/srfi/143#fxreverse _width104787_ _zn104791_)
                    _start104784_)
                   (fxand (fxnot (fxarithmetic-shift-left
                                  _mask104789_
                                  _start104784_))
                          _n104783_)))))))
  (define std/srfi/143#exp-width (expt '2 std/srfi/143#fx-width))
  (define std/srfi/143#fx+/carry
    (lambda (_i104773_ _j104774_ _k104775_)
      (let* ((_s104777_ (+ _i104773_ _j104774_ _k104775_))
             (_g289735_
              (std/srfi/143#balanced/ _s104777_ std/srfi/143#exp-width)))
        (begin
          (let ((_g289736_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289735_) (##vector-length _g289735_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289736_ 2)))
                (error "Context expects 2 values" _g289736_)))
          (let ((_q104779_
                 (let () (declare (not safe)) (##vector-ref _g289735_ 0)))
                (_r104780_
                 (let () (declare (not safe)) (##vector-ref _g289735_ 1))))
            (let () (values _r104780_ _q104779_)))))))
  (define std/srfi/143#fx-/carry
    (lambda (_i104763_ _j104764_ _k104765_)
      (let* ((_d104767_ (- _i104763_ _j104764_ _k104765_))
             (_g289737_
              (std/srfi/143#balanced/ _d104767_ std/srfi/143#exp-width)))
        (begin
          (let ((_g289738_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289737_) (##vector-length _g289737_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289738_ 2)))
                (error "Context expects 2 values" _g289738_)))
          (let ((_q104769_
                 (let () (declare (not safe)) (##vector-ref _g289737_ 0)))
                (_r104770_
                 (let () (declare (not safe)) (##vector-ref _g289737_ 1))))
            (let () (values _r104770_ _q104769_)))))))
  (define std/srfi/143#fx*/carry
    (lambda (_i104753_ _j104754_ _k104755_)
      (let* ((_s104757_ (+ (* _i104753_ _j104754_) _k104755_))
             (_g289739_
              (std/srfi/143#balanced/ _s104757_ std/srfi/143#exp-width)))
        (begin
          (let ((_g289740_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289739_) (##vector-length _g289739_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289740_ 2)))
                (error "Context expects 2 values" _g289740_)))
          (let ((_q104759_
                 (let () (declare (not safe)) (##vector-ref _g289739_ 0)))
                (_r104760_
                 (let () (declare (not safe)) (##vector-ref _g289739_ 1))))
            (let () (values _r104760_ _q104759_)))))))
  (define std/srfi/143#floor-/+
    (lambda (_n104745_ _d104746_)
      (let ((_n104748_ (- '0 _n104745_)))
        (let ((_q104750_ (quotient _n104748_ _d104746_))
              (_r104751_ (remainder _n104748_ _d104746_)))
          (if (zero? _r104751_)
              (values (- '0 _q104750_) _r104751_)
              (values (- (- '0 _q104750_) '1) (- _d104746_ _r104751_)))))))
  (define std/srfi/143#ceiling-/-
    (lambda (_n104736_ _d104737_)
      (let ((_n104739_ (- '0 _n104736_)) (_d104740_ (- '0 _d104737_)))
        (let ((_q104742_ (quotient _n104739_ _d104740_))
              (_r104743_ (remainder _n104739_ _d104740_)))
          (if (zero? _r104743_)
              (values _q104742_ _r104743_)
              (values (+ _q104742_ '1) (- _d104740_ _r104743_)))))))
  (define std/srfi/143#euclidean/
    (lambda (_n104729_ _d104730_)
      (if (and (exact-integer? _n104729_) (exact-integer? _d104730_))
          (if (and (negative? _n104729_) (negative? _d104730_))
              (std/srfi/143#ceiling-/- _n104729_ _d104730_)
              (if (negative? _n104729_)
                  (std/srfi/143#floor-/+ _n104729_ _d104730_)
                  (if (negative? _d104730_)
                      (let ((_d104732_ (- '0 _d104730_)))
                        (values (- '0 (quotient _n104729_ _d104732_))
                                (remainder _n104729_ _d104732_)))
                      (values (quotient _n104729_ _d104730_)
                              (remainder _n104729_ _d104730_)))))
          (let ((_q104734_
                 (if (negative? _d104730_)
                     (ceiling (/ _n104729_ _d104730_))
                     (floor (/ _n104729_ _d104730_)))))
            (values _q104734_ (- _n104729_ (* _d104730_ _q104734_)))))))
  (define std/srfi/143#balanced/
    (lambda (_x104722_ _y104723_)
      (call-with-values
       (lambda () (std/srfi/143#euclidean/ _x104722_ _y104723_))
       (lambda (_q104726_ _r104727_)
         (if (< _r104727_ (abs (/ _y104723_ '2)))
             (values _q104726_ _r104727_)
             (if (> _y104723_ '0)
                 (values (+ _q104726_ '1)
                         (- _x104722_ (* (+ _q104726_ '1) _y104723_)))
                 (values (- _q104726_ '1)
                         (- _x104722_ (* (- _q104726_ '1) _y104723_))))))))))
