(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/158#any
    (lambda (_pred114318_ _ls114319_)
      (if (null? (cdr _ls114319_))
          (_pred114318_ (car _ls114319_))
          ((lambda (_x114321_)
             (if _x114321_
                 _x114321_
                 (std/srfi/158#any _pred114318_ (cdr _ls114319_))))
           (_pred114318_ (car _ls114319_))))))
  (define std/srfi/158#list->bytevector
    (lambda (_list114309_)
      (let ((_vec114311_ (make-u8vector (length _list114309_) '0)))
        (let _loop114313_ ((_i114315_ '0) (_list114316_ _list114309_))
          (if (null? _list114316_)
              _vec114311_
              (begin
                (u8vector-set! _vec114311_ _i114315_ (car _list114316_))
                (_loop114313_ (+ _i114315_ '1) (cdr _list114316_))))))))
  (define std/srfi/158#circular-generator
    (lambda _args114302_
      (let ((_base-args114304_ _args114302_))
        (lambda ()
          (if (null? _args114302_)
              (set! _args114302_ _base-args114304_)
              '#!void)
          (let ((_next114307_ (car _args114302_)))
            (set! _args114302_ (cdr _args114302_))
            _next114307_)))))
  (define std/srfi/158#gflatten
    (lambda (_gen114295_)
      (let ((_state114297_ '()))
        (lambda ()
          (if (null? _state114297_) (set! _state114297_ (_gen114295_)) '#!void)
          (if (eof-object? _state114297_)
              _state114297_
              (let ((_obj114300_ (car _state114297_)))
                (set! _state114297_ (cdr _state114297_))
                _obj114300_))))))
  (define std/srfi/158#ggroup__1
    (lambda (_gen114291_ _k114292_ _padding114293_)
      (std/srfi/158#padded-ggroup
       (std/srfi/158#simple-ggroup _gen114291_ _k114292_)
       _k114292_
       _padding114293_)))
  (define std/srfi/158#ggroup
    (lambda _g290028_
      (let ((_g290027_ (let () (declare (not safe)) (##length _g290028_))))
        (cond ((let () (declare (not safe)) (##fx= _g290027_ 2))
               (apply std/srfi/158#simple-ggroup _g290028_))
              ((let () (declare (not safe)) (##fx= _g290027_ 3))
               (apply std/srfi/158#ggroup__1 _g290028_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/158#ggroup
                _g290028_))))))
  (define std/srfi/158#simple-ggroup
    (lambda (_gen114278_ _k114279_)
      (lambda ()
        (let _loop114282_ ((_item114284_ (_gen114278_))
                           (_result114285_ '())
                           (_count114286_ (- _k114279_ '1)))
          (if (eof-object? _item114284_)
              (if (null? _result114285_) _item114284_ (reverse _result114285_))
              (if (= _count114286_ '0)
                  (reverse (cons _item114284_ _result114285_))
                  (_loop114282_
                   (_gen114278_)
                   (cons _item114284_ _result114285_)
                   (- _count114286_ '1))))))))
  (define std/srfi/158#padded-ggroup
    (lambda (_gen114269_ _k114270_ _padding114271_)
      (lambda ()
        (let ((_item114274_ (_gen114269_)))
          (if (eof-object? _item114274_)
              _item114274_
              (let ((_len114276_ (length _item114274_)))
                (if (= _len114276_ _k114270_)
                    _item114274_
                    (append _item114274_
                            (make-list
                             (- _k114270_ _len114276_)
                             _padding114271_)))))))))
  (define std/srfi/158#gmerge__0
    (lambda (_<114240_) (error '"wrong number of arguments for gmerge")))
  (define std/srfi/158#gmerge__1 (lambda (_<114242_ _gen114243_) _gen114243_))
  (define std/srfi/158#gmerge__2
    (lambda (_<114245_ _genleft114246_ _genright114247_)
      (let ((_left114249_ (_genleft114246_))
            (_right114250_ (_genright114247_)))
        (lambda ()
          (if (and (eof-object? _left114249_) (eof-object? _right114250_))
              _left114249_
              (if (eof-object? _left114249_)
                  (let ((_obj114253_ _right114250_))
                    (set! _right114250_ (_genright114247_))
                    _obj114253_)
                  (if (eof-object? _right114250_)
                      (let ((_obj114255_ _left114249_))
                        (set! _left114249_ (_genleft114246_))
                        _obj114255_)
                      (if (_<114245_ _right114250_ _left114249_)
                          (let ((_obj114257_ _right114250_))
                            (set! _right114250_ (_genright114247_))
                            _obj114257_)
                          (let ((_obj114259_ _left114249_))
                            (set! _left114249_ (_genleft114246_))
                            _obj114259_)))))))))
  (define std/srfi/158#gmerge__3
    (lambda (_<114261_ . _gens114262_)
      (apply std/srfi/158#gmerge
             _<114261_
             (let _loop114264_ ((_gens114266_ _gens114262_) (_gs114267_ '()))
               (if (null? _gens114266_)
                   (reverse _gs114267_)
                   (if (null? (cdr _gens114266_))
                       (reverse (cons (car _gens114266_) _gs114267_))
                       (_loop114264_
                        (cddr _gens114266_)
                        (cons (std/srfi/158#gmerge__2
                               _<114261_
                               (car _gens114266_)
                               (cadr _gens114266_))
                              _gs114267_))))))))
  (define std/srfi/158#gmerge
    (lambda _g290030_
      (let ((_g290029_ (let () (declare (not safe)) (##length _g290030_))))
        (cond ((let () (declare (not safe)) (##fx= _g290029_ 1))
               (apply std/srfi/158#gmerge__0 _g290030_))
              ((let () (declare (not safe)) (##fx= _g290029_ 2))
               (apply std/srfi/158#gmerge__1 _g290030_))
              ((let () (declare (not safe)) (##fx= _g290029_ 3))
               (apply std/srfi/158#gmerge__2 _g290030_))
              ((let () (declare (not safe)) (##fx>= _g290029_ 1))
               (apply std/srfi/158#gmerge__3 _g290030_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/158#gmerge
                _g290030_))))))
  (define std/srfi/158#gmap__0
    (lambda (_proc114224_) (error '"wrong number of arguments for gmap")))
  (define std/srfi/158#gmap__1
    (lambda (_proc114226_ _gen114227_)
      (lambda ()
        (let ((_item114230_ (_gen114227_)))
          (if (eof-object? _item114230_)
              _item114230_
              (_proc114226_ _item114230_))))))
  (define std/srfi/158#gmap__2
    (lambda (_proc114232_ . _gens114233_)
      (lambda ()
        (let ((_items114238_
               (map (lambda (_x114236_) (_x114236_)) _gens114233_)))
          (if (std/srfi/158#any eof-object? _items114238_)
              (eof-object)
              (apply _proc114232_ _items114238_))))))
  (define std/srfi/158#gmap
    (lambda _g290032_
      (let ((_g290031_ (let () (declare (not safe)) (##length _g290032_))))
        (cond ((let () (declare (not safe)) (##fx= _g290031_ 1))
               (apply std/srfi/158#gmap__0 _g290032_))
              ((let () (declare (not safe)) (##fx= _g290031_ 2))
               (apply std/srfi/158#gmap__1 _g290032_))
              ((let () (declare (not safe)) (##fx>= _g290031_ 1))
               (apply std/srfi/158#gmap__2 _g290032_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/158#gmap
                _g290032_))))))
  (define std/srfi/158#gstate-filter
    (lambda (_proc114210_ _seed114211_ _gen114212_)
      (let ((_state114214_ _seed114211_))
        (lambda ()
          (let _loop114217_ ((_item114219_ (_gen114212_)))
            (if (eof-object? _item114219_)
                _item114219_
                (let ((_g290033_ (_proc114210_ _item114219_ _state114214_)))
                  (begin
                    (let ((_g290034_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g290033_)
                                 (##vector-length _g290033_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g290034_ 2)))
                          (error "Context expects 2 values" _g290034_)))
                    (let ((_yes114221_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g290033_ 0)))
                          (_newstate114222_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g290033_ 1))))
                      (begin
                        (set! _state114214_ _newstate114222_)
                        (if _yes114221_
                            _item114219_
                            (_loop114217_ (_gen114212_)))))))))))))
  (define std/srfi/158#generator-map->list
    (lambda (_f114199_ . _gs114200_)
      (let _loop114202_ ((_result114204_ '()))
        (let ((_vs114208_ (map (lambda (_g114206_) (_g114206_)) _gs114200_)))
          (if (std/srfi/158#any eof-object? _vs114208_)
              (reverse _result114204_)
              (_loop114202_
               (cons (apply _f114199_ _vs114208_) _result114204_)))))))
  (define std/srfi/158#make-accumulator
    (lambda (_kons114191_ _knil114192_ _finalize114193_)
      (let ((_state114195_ _knil114192_))
        (lambda (_obj114197_)
          (if (eof-object? _obj114197_)
              (_finalize114193_ _state114195_)
              (set! _state114195_
                    (_kons114191_ _obj114197_ _state114195_)))))))
  (define std/srfi/158#count-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       (lambda (_obj114186_ _state114187_) (+ '1 _state114187_))
       '0
       (lambda (_x114189_) _x114189_))))
  (define std/srfi/158#list-accumulator
    (lambda () (std/srfi/158#make-accumulator cons '() reverse)))
  (define std/srfi/158#reverse-list-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator cons '() (lambda (_x114182_) _x114182_))))
  (define std/srfi/158#vector-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       cons
       '()
       (lambda (_x114179_) (list->vector (reverse _x114179_))))))
  (define std/srfi/158#reverse-vector-accumulator
    (lambda () (std/srfi/158#make-accumulator cons '() list->vector)))
  (define std/srfi/158#vector-accumulator!
    (lambda (_vec114172_ _at114173_)
      (lambda (_obj114175_)
        (if (eof-object? _obj114175_)
            _vec114172_
            (begin
              (vector-set! _vec114172_ _at114173_ _obj114175_)
              (set! _at114173_ (+ _at114173_ '1)))))))
  (define std/srfi/158#bytevector-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       cons
       '()
       (lambda (_x114170_)
         (std/srfi/158#list->bytevector (reverse _x114170_))))))
  (define std/srfi/158#bytevector-accumulator!
    (lambda (_bytevec114164_ _at114165_)
      (lambda (_obj114167_)
        (if (eof-object? _obj114167_)
            _bytevec114164_
            (begin
              (u8vector-set! _bytevec114164_ _at114165_ _obj114167_)
              (set! _at114165_ (+ _at114165_ '1)))))))
  (define std/srfi/158#string-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       cons
       '()
       (lambda (_lst114162_) (list->string (reverse _lst114162_))))))
  (define std/srfi/158#sum-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator + '0 (lambda (_x114159_) _x114159_))))
  (define std/srfi/158#product-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator * '1 (lambda (_x114156_) _x114156_)))))
