(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/c128#c128vector-unfold
    (lambda (_f151643_ _len151645_ _seed151647_)
      (declare (not safe))
      (begin
        (if (procedure? _f151643_)
            '#!void
            (error '"Bad argument; expected procedure" _f151643_))
        (let ((_v151651_
               (make-struct-instance
                std/srfi/160/cvector#c128vector::t
                _len151645_)))
          (let _lp151654_ ((_i151657_ '0) (_state151659_ _seed151647_))
            (if (fx< _i151657_ _len151645_)
                (let ((_g299515_ (_f151643_ _i151657_ _state151659_)))
                  (begin
                    (let ((_g299516_
                           (if (##values? _g299515_)
                               (##vector-length _g299515_)
                               1)))
                      (if (not (##fx= _g299516_ 2))
                          (error "Context expects 2 values" _g299516_)))
                    (let ((_x151662_ (##vector-ref _g299515_ 0))
                          (_state151664_ (##vector-ref _g299515_ 1)))
                      (begin
                        (if (std/srfi/160/base#c128? _x151662_)
                            '#!void
                            (error '"Bad generated value" _x151662_))
                        (std/srfi/160/cvector#c128vector-set!
                         _v151651_
                         _i151657_
                         _x151662_)
                        (_lp151654_ (fx+ _i151657_ '1) _state151664_)))))
                _v151651_))))))
  (define std/srfi/160/c128#c128vector-unfold-right
    (lambda (_f151620_ _len151622_ _seed151624_)
      (declare (not safe))
      (begin
        (if (procedure? _f151620_)
            '#!void
            (error '"Bad argument; expected procedure" _f151620_))
        (let ((_v151628_
               (make-struct-instance
                std/srfi/160/cvector#c128vector::t
                _len151622_)))
          (let _lp151631_ ((_i151634_ (fx- _len151622_ '1))
                           (_state151636_ _seed151624_))
            (if (fx>= _i151634_ '0)
                (let ((_g299517_ (_f151620_ _i151634_ _state151636_)))
                  (begin
                    (let ((_g299518_
                           (if (##values? _g299517_)
                               (##vector-length _g299517_)
                               1)))
                      (if (not (##fx= _g299518_ 2))
                          (error "Context expects 2 values" _g299518_)))
                    (let ((_x151639_ (##vector-ref _g299517_ 0))
                          (_state151641_ (##vector-ref _g299517_ 1)))
                      (begin
                        (if (std/srfi/160/base#c128? _x151639_)
                            '#!void
                            (error '"Bad generated value" _x151639_))
                        (std/srfi/160/cvector#c128vector-set!
                         _v151628_
                         _i151634_
                         _x151639_)
                        (_lp151631_ (fx- _i151634_ '1) _state151641_)))))
                _v151628_))))))
  (define std/srfi/160/c128#c128vector-copy__%
    (lambda (_vec151592_ _start151594_ _end151596_)
      (let ((_v151599_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              (fx- _end151596_ _start151594_))))
        (std/srfi/160/c128#c128vector-copy!
         _v151599_
         '0
         _vec151592_
         _start151594_
         _end151596_)
        _v151599_)))
  (define std/srfi/160/c128#c128vector-copy__0
    (lambda (_vec151605_)
      (let* ((_start151607_ '0)
             (_end151609_
              (std/srfi/160/cvector#c128vector-length _vec151605_)))
        (std/srfi/160/c128#c128vector-copy__%
         _vec151605_
         _start151607_
         _end151609_))))
  (define std/srfi/160/c128#c128vector-copy__1
    (lambda (_vec151611_ _start151612_)
      (let ((_end151614_ (std/srfi/160/cvector#c128vector-length _vec151611_)))
        (std/srfi/160/c128#c128vector-copy__%
         _vec151611_
         _start151612_
         _end151614_))))
  (define std/srfi/160/c128#c128vector-copy
    (lambda _g299520_
      (let ((_g299519_ (let () (declare (not safe)) (##length _g299520_))))
        (cond ((let () (declare (not safe)) (##fx= _g299519_ 1))
               (apply std/srfi/160/c128#c128vector-copy__0 _g299520_))
              ((let () (declare (not safe)) (##fx= _g299519_ 2))
               (apply std/srfi/160/c128#c128vector-copy__1 _g299520_))
              ((let () (declare (not safe)) (##fx= _g299519_ 3))
               (apply std/srfi/160/c128#c128vector-copy__% _g299520_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-copy
                _g299520_))))))
  (define std/srfi/160/c128#c128vector-copy!
    (lambda (_to151571_ _at151573_ _from151575_ _start151577_ _end151579_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to151571_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _to151571_))
        (if (##structure-direct-instance-of?
             _from151575_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _from151575_))
        (if (and (fixnum? _at151573_)
                 (fx<= '0
                       _at151573_
                       (fx- (std/srfi/160/cvector#c128vector-length _at151573_)
                            '1)))
            '#!void
            (error '"Index out of range" _to151571_ _at151573_))
        (if (and (fixnum? _start151577_)
                 (fx<= '0
                       _start151577_
                       (fx- (std/srfi/160/cvector#c128vector-length
                             _from151575_)
                            '1)))
            '#!void
            (error '"Index out of range" _from151575_ _start151577_))
        (if (and (fixnum? _end151579_)
                 (fx<= _start151577_
                       _end151579_
                       (std/srfi/160/cvector#c128vector-length _from151575_)))
            '#!void
            (error '"Index out of range" _from151575_ _end151579_))
        (if (fx<= (fx- _end151579_ _start151577_)
                  (fx- (std/srfi/160/cvector#c128vector-length _to151571_)
                       _at151573_))
            '#!void
            (error '"Destination area too small"
                   _to151571_
                   _at151573_
                   _from151575_
                   _start151577_
                   _end151579_))
        (let _lp151583_ ((_i151586_ _start151577_) (_j151588_ _at151573_))
          (if (fx< _i151586_ _end151579_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _to151571_
                 _j151588_
                 (std/srfi/160/cvector#c128vector-ref _from151575_ _i151586_))
                (_lp151583_ (fx+ _i151586_ '1) (fx+ _j151588_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-reverse-copy__%
    (lambda (_vec151543_ _start151545_ _end151547_)
      (let ((_v151550_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              (fx- _end151547_ _start151545_))))
        (std/srfi/160/c128#c128vector-reverse-copy!
         _v151550_
         '0
         _vec151543_
         _start151545_
         _end151547_)
        _v151550_)))
  (define std/srfi/160/c128#c128vector-reverse-copy__0
    (lambda (_vec151556_)
      (let* ((_start151558_ '0)
             (_end151560_
              (std/srfi/160/cvector#c128vector-length _vec151556_)))
        (std/srfi/160/c128#c128vector-reverse-copy__%
         _vec151556_
         _start151558_
         _end151560_))))
  (define std/srfi/160/c128#c128vector-reverse-copy__1
    (lambda (_vec151562_ _start151563_)
      (let ((_end151565_ (std/srfi/160/cvector#c128vector-length _vec151562_)))
        (std/srfi/160/c128#c128vector-reverse-copy__%
         _vec151562_
         _start151563_
         _end151565_))))
  (define std/srfi/160/c128#c128vector-reverse-copy
    (lambda _g299522_
      (let ((_g299521_ (let () (declare (not safe)) (##length _g299522_))))
        (cond ((let () (declare (not safe)) (##fx= _g299521_ 1))
               (apply std/srfi/160/c128#c128vector-reverse-copy__0 _g299522_))
              ((let () (declare (not safe)) (##fx= _g299521_ 2))
               (apply std/srfi/160/c128#c128vector-reverse-copy__1 _g299522_))
              ((let () (declare (not safe)) (##fx= _g299521_ 3))
               (apply std/srfi/160/c128#c128vector-reverse-copy__% _g299522_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-reverse-copy
                _g299522_))))))
  (define std/srfi/160/c128#c128vector-reverse-copy!
    (lambda (_to151522_ _at151524_ _from151526_ _start151528_ _end151530_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to151522_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _to151522_))
        (if (##structure-direct-instance-of?
             _from151526_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _from151526_))
        (if (and (fixnum? _at151524_)
                 (fx<= '0
                       _at151524_
                       (fx- (std/srfi/160/cvector#c128vector-length _at151524_)
                            '1)))
            '#!void
            (error '"Index out of range" _to151522_ _at151524_))
        (if (and (fixnum? _start151528_)
                 (fx<= '0
                       _start151528_
                       (fx- (std/srfi/160/cvector#c128vector-length
                             _from151526_)
                            '1)))
            '#!void
            (error '"Index out of range" _from151526_ _start151528_))
        (if (and (fixnum? _end151530_)
                 (fx<= _start151528_
                       _end151530_
                       (std/srfi/160/cvector#c128vector-length _from151526_)))
            '#!void
            (error '"Index out of range" _from151526_ _end151530_))
        (if (fx<= (fx- _end151530_ _start151528_)
                  (fx- (std/srfi/160/cvector#c128vector-length _to151522_)
                       _at151524_))
            '#!void
            (error '"Destination area too small"
                   _to151522_
                   _at151524_
                   _from151526_
                   _start151528_
                   _end151530_))
        (let _lp151534_ ((_i151537_ (fx- _end151530_ '1))
                         (_j151539_ _at151524_))
          (if (fx>= _i151537_ _start151528_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _to151522_
                 _j151539_
                 (std/srfi/160/cvector#c128vector-ref _from151526_ _i151537_))
                (_lp151534_ (fx- _i151537_ '1) (fx+ _j151539_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-append
    (lambda _args151519_
      (std/srfi/160/c128#c128vector-concatenate _args151519_)))
  (define std/srfi/160/c128#c128vector-concatenate
    (lambda (_lst151459_)
      (let* ((_len151467_
              (foldl1 (lambda (_v151462_ _r151464_)
                        (fx+ (std/srfi/160/cvector#c128vector-length _v151462_)
                             _r151464_))
                      '0
                      _lst151459_))
             (_v151470_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151467_)))
        (declare (not safe))
        (let _lp151474_ ((_rest151477_ _lst151459_) (_at151479_ '0))
          (let* ((_rest151481151489_ _rest151477_)
                 (_else151483151497_ (lambda () _v151470_))
                 (_K151485151507_
                  (lambda (_rest151500_ _u151501_)
                    (let ((_ulen151504_
                           (std/srfi/160/cvector#c128vector-length _u151501_)))
                      (std/srfi/160/c128#c128vector-copy!
                       _v151470_
                       _at151479_
                       _u151501_
                       '0
                       _ulen151504_)
                      (_lp151474_
                       _rest151500_
                       (fx+ _at151479_ _ulen151504_))))))
            (if (##pair? _rest151481151489_)
                (let ((_hd151486151510_ (##car _rest151481151489_))
                      (_tl151487151512_ (##cdr _rest151481151489_)))
                  (let* ((_u151515_ _hd151486151510_)
                         (_rest151517_ _tl151487151512_))
                    (_K151485151507_ _rest151517_ _u151515_)))
                (_else151483151497_)))))))
  (define std/srfi/160/c128#c128vector-append-subvectors
    (lambda _args151331_
      (let* ((_len151392_
              (let _lp151334_ ((_rest151337_ _args151331_) (_r151339_ '0))
                (let* ((_rest151341151353_ _rest151337_)
                       (_else151343151361_ (lambda () _r151339_))
                       (_K151345151370_
                        (lambda (_rest151364_ _end151365_ _start151367_)
                          (_lp151334_
                           _rest151364_
                           (fx+ _r151339_ (fx- _end151365_ _start151367_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest151341151353_))
                      (let ((_tl151347151373_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest151341151353_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl151347151373_))
                            (let ((_hd151348151376_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl151347151373_)))
                                  (_tl151349151378_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl151347151373_))))
                              (let ((_start151381_ _hd151348151376_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl151349151378_))
                                    (let ((_hd151350151383_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl151349151378_)))
                                          (_tl151351151385_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl151349151378_))))
                                      (let* ((_end151388_ _hd151350151383_)
                                             (_rest151390_ _tl151351151385_))
                                        (_K151345151370_
                                         _rest151390_
                                         _end151388_
                                         _start151381_)))
                                    (_else151343151361_))))
                            (_else151343151361_)))
                      (_else151343151361_)))))
             (_v151395_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151392_)))
        (let _lp151399_ ((_rest151401_ _args151331_) (_at151402_ '0))
          (let* ((_rest151404151416_ _rest151401_)
                 (_else151406151424_ (lambda () _v151395_))
                 (_K151408151433_
                  (lambda (_rest151427_ _end151428_ _start151429_ _u151430_)
                    (std/srfi/160/c128#c128vector-copy!
                     _v151395_
                     _at151402_
                     _u151430_
                     _start151429_
                     _end151428_)
                    (_lp151399_
                     _rest151427_
                     (fx+ _at151402_ (fx- _end151428_ _start151429_))))))
            (if (let () (declare (not safe)) (##pair? _rest151404151416_))
                (let ((_hd151409151436_
                       (let ()
                         (declare (not safe))
                         (##car _rest151404151416_)))
                      (_tl151410151438_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest151404151416_))))
                  (let ((_u151441_ _hd151409151436_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl151410151438_))
                        (let ((_hd151411151443_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl151410151438_)))
                              (_tl151412151445_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl151410151438_))))
                          (let ((_start151448_ _hd151411151443_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl151412151445_))
                                (let ((_hd151413151450_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl151412151445_)))
                                      (_tl151414151452_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl151412151445_))))
                                  (let* ((_end151455_ _hd151413151450_)
                                         (_rest151457_ _tl151414151452_))
                                    (_K151408151433_
                                     _rest151457_
                                     _end151455_
                                     _start151448_
                                     _u151441_)))
                                (_else151406151424_))))
                        (_else151406151424_))))
                (_else151406151424_)))))))
  (define std/srfi/160/c128#c128vector-empty?
    (lambda (_v151328_)
      (fxzero? (std/srfi/160/cvector#c128vector-length _v151328_))))
  (define std/srfi/160/c128#c128vector=
    (lambda (_v151270_ . _args151272_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v151270_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v151270_))
        (let ((_vlen151276_
               (std/srfi/160/cvector#c128vector-length _v151270_)))
          (let _lp151279_ ((_rest151282_ _args151272_))
            (let* ((_rest151284151292_ _rest151282_)
                   (_else151286151300_ (lambda () '#t))
                   (_K151288151316_
                    (lambda (_rest151303_ _u151304_)
                      (if (##structure-direct-instance-of?
                           _u151304_
                           'std/srfi/160/cvector#c128vector::t)
                          '#!void
                          (error '"Bad argument" _u151304_))
                      (let ((_ulen151307_
                             (std/srfi/160/cvector#c128vector-length
                              _u151304_)))
                        (if (fx= _vlen151276_ _ulen151307_)
                            (let _cmp151310_ ((_i151313_ '0))
                              (if (fx< _i151313_ _vlen151276_)
                                  (if (= (std/srfi/160/cvector#c128vector-ref
                                          _v151270_
                                          _i151313_)
                                         (std/srfi/160/cvector#c128vector-ref
                                          _u151304_
                                          _i151313_))
                                      (_cmp151310_ (fx+ _i151313_ '1))
                                      '#f)
                                  (_lp151279_ _rest151303_)))
                            '#f)))))
              (if (##pair? _rest151284151292_)
                  (let ((_hd151289151319_ (##car _rest151284151292_))
                        (_tl151290151321_ (##cdr _rest151284151292_)))
                    (let* ((_u151324_ _hd151289151319_)
                           (_rest151326_ _tl151290151321_))
                      (_K151288151316_ _rest151326_ _u151324_)))
                  (_else151286151300_))))))))
  (define std/srfi/160/c128#c128vector-take
    (lambda (_v151262_ _n151264_)
      (let ((_u151267_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              _n151264_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151267_
         '0
         _v151262_
         '0
         _n151264_)
        _u151267_)))
  (define std/srfi/160/c128#c128vector-take-right
    (lambda (_v151247_ _n151249_)
      (let* ((_vlen151252_ (std/srfi/160/cvector#c128vector-length _v151247_))
             (_ulen151255_ (fx- _vlen151252_ _n151249_))
             (_u151258_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _ulen151255_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151258_
         '0
         _v151247_
         _n151249_
         _vlen151252_)
        _u151258_)))
  (define std/srfi/160/c128#c128vector-drop
    (lambda (_v151232_ _n151234_)
      (let* ((_vlen151237_ (std/srfi/160/cvector#c128vector-length _v151232_))
             (_ulen151240_ (fx- _vlen151237_ _n151234_))
             (_u151243_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _ulen151240_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151243_
         '0
         _v151232_
         _n151234_
         _vlen151237_)
        _u151243_)))
  (define std/srfi/160/c128#c128vector-drop-right
    (lambda (_v151217_ _n151219_)
      (let* ((_vlen151222_ (std/srfi/160/cvector#c128vector-length _v151217_))
             (_ulen151225_ (fx- _vlen151222_ _n151219_))
             (_u151228_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _ulen151225_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151228_
         '0
         _v151217_
         '0
         _ulen151225_)
        _u151228_)))
  (define std/srfi/160/c128#c128vector-segment
    (lambda (_v151199_ _n151201_)
      (let _lp151204_ ((_i151207_ '0)
                       (_rest151209_
                        (std/srfi/160/cvector#c128vector-length _v151199_))
                       (_r151211_ '()))
        (if (fx> _r151211_ '0)
            (let ((_size151214_ (fxmin _n151201_ _rest151209_)))
              (_lp151204_
               (fx+ _i151207_ _size151214_)
               (fx- _rest151209_ _size151214_)
               (cons (std/srfi/160/c128#c128vector-copy__%
                      _v151199_
                      _i151207_
                      (fx+ _i151207_ _size151214_))
                     _r151211_)))
            (reverse _r151211_)))))
  (define std/srfi/160/c128#c128vector-fold__0
    (lambda (_kons151159_ _knil151161_ _v151163_)
      (if (procedure? _kons151159_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151159_))
      (let ((_end151166_ (std/srfi/160/cvector#c128vector-length _v151163_)))
        (declare (not safe))
        (let _lp151170_ ((_i151173_ '0) (_r151175_ _knil151161_))
          (if (fx< _i151173_ _end151166_)
              (_lp151170_
               (fx+ _i151173_ '1)
               (_kons151159_
                _r151175_
                (std/srfi/160/cvector#c128vector-ref _v151163_ _i151173_)))
              _r151175_)))))
  (define std/srfi/160/c128#c128vector-fold__1
    (lambda (_kons151178_ _knil151179_ _v151180_ . _vs151181_)
      (if (procedure? _kons151178_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151178_))
      (let* ((_vs151184_ (cons _v151180_ _vs151181_))
             (_end151186_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151184_))))
        (declare (not safe))
        (let _lp151190_ ((_i151192_ '0) (_r151193_ _knil151179_))
          (if (fx< _i151192_ _end151186_)
              (_lp151190_
               (fx+ _i151192_ '1)
               (apply _kons151178_
                      _r151193_
                      (map (lambda (_g151194151196_)
                             (std/srfi/160/cvector#c128vector-ref
                              _g151194151196_
                              _i151192_))
                           _vs151184_)))
              _r151193_)))))
  (define std/srfi/160/c128#c128vector-fold
    (lambda _g299524_
      (let ((_g299523_ (let () (declare (not safe)) (##length _g299524_))))
        (cond ((let () (declare (not safe)) (##fx= _g299523_ 3))
               (apply std/srfi/160/c128#c128vector-fold__0 _g299524_))
              ((let () (declare (not safe)) (##fx>= _g299523_ 3))
               (apply std/srfi/160/c128#c128vector-fold__1 _g299524_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-fold
                _g299524_))))))
  (define std/srfi/160/c128#c128vector-fold-right__0
    (lambda (_kons151119_ _knil151121_ _v151123_)
      (if (procedure? _kons151119_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151119_))
      (let ((_last151126_
             (fx- (std/srfi/160/cvector#c128vector-length _v151123_) '1)))
        (declare (not safe))
        (let _lp151130_ ((_i151133_ _last151126_) (_r151135_ _knil151121_))
          (if (fx>= _i151133_ '0)
              (_lp151130_
               (fx- _i151133_ '1)
               (_kons151119_
                _r151135_
                (std/srfi/160/cvector#c128vector-ref _v151123_ _i151133_)))
              _r151135_)))))
  (define std/srfi/160/c128#c128vector-fold-right__1
    (lambda (_kons151138_ _knil151139_ _v151140_ . _vs151141_)
      (if (procedure? _kons151138_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151138_))
      (let* ((_vs151144_ (cons _v151140_ _vs151141_))
             (_last151146_
              (fx- (apply min
                          (map std/srfi/160/cvector#c128vector-length
                               _vs151144_))
                   '1)))
        (declare (not safe))
        (let _lp151150_ ((_i151152_ _last151146_) (_r151153_ _knil151139_))
          (if (fx>= _i151152_ '0)
              (_lp151150_
               (fx- _i151152_ '1)
               (apply _kons151138_
                      _r151153_
                      (map (lambda (_g151154151156_)
                             (std/srfi/160/cvector#c128vector-ref
                              _g151154151156_
                              _i151152_))
                           _vs151144_)))
              _r151153_)))))
  (define std/srfi/160/c128#c128vector-fold-right
    (lambda _g299526_
      (let ((_g299525_ (let () (declare (not safe)) (##length _g299526_))))
        (cond ((let () (declare (not safe)) (##fx= _g299525_ 3))
               (apply std/srfi/160/c128#c128vector-fold-right__0 _g299526_))
              ((let () (declare (not safe)) (##fx>= _g299525_ 3))
               (apply std/srfi/160/c128#c128vector-fold-right__1 _g299526_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-fold-right
                _g299526_))))))
  (define std/srfi/160/c128#c128vector-map__0
    (lambda (_f151079_ _v151081_)
      (if (procedure? _f151079_)
          '#!void
          (error '"Bad argument; expected procedure" _f151079_))
      (let* ((_len151084_ (std/srfi/160/cvector#c128vector-length _v151081_))
             (_u151087_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151084_)))
        (declare (not safe))
        (let _lp151092_ ((_i151095_ '0))
          (if (fx< _i151095_ _len151084_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _u151087_
                 _i151095_
                 (std/srfi/160/cvector#c128vector-ref _v151081_ _i151095_))
                (_lp151092_ (fx+ _i151095_ '1)))
              _u151087_)))))
  (define std/srfi/160/c128#c128vector-map__1
    (lambda (_f151098_ _v151099_ . _vs151100_)
      (if (procedure? _f151098_)
          '#!void
          (error '"Bad argument; expected procedure" _f151098_))
      (let* ((_vs151103_ (cons _v151099_ _vs151100_))
             (_len151105_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151103_)))
             (_u151107_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151105_)))
        (declare (not safe))
        (let _lp151111_ ((_i151113_ '0))
          (if (fx< _i151113_ _len151105_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _u151107_
                 _i151113_
                 (apply _f151098_
                        (map (lambda (_g151114151116_)
                               (std/srfi/160/cvector#c128vector-ref
                                _g151114151116_
                                _i151113_))
                             _vs151103_)))
                (_lp151111_ (fx+ _i151113_ '1)))
              _u151107_)))))
  (define std/srfi/160/c128#c128vector-map
    (lambda _g299528_
      (let ((_g299527_ (let () (declare (not safe)) (##length _g299528_))))
        (cond ((let () (declare (not safe)) (##fx= _g299527_ 2))
               (apply std/srfi/160/c128#c128vector-map__0 _g299528_))
              ((let () (declare (not safe)) (##fx>= _g299527_ 2))
               (apply std/srfi/160/c128#c128vector-map__1 _g299528_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-map
                _g299528_))))))
  (define std/srfi/160/c128#c128vector-map!__0
    (lambda (_f151045_ _v151047_)
      (if (procedure? _f151045_)
          '#!void
          (error '"Bad argument; expected procedure" _f151045_))
      (let ((_len151050_ (std/srfi/160/cvector#c128vector-length _v151047_)))
        (declare (not safe))
        (let _lp151054_ ((_i151057_ '0))
          (if (fx< _i151057_ _len151050_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _v151047_
                 _i151057_
                 (_f151045_
                  (std/srfi/160/cvector#c128vector-ref _v151047_ _i151057_)))
                (_lp151054_ (fx+ _i151057_ '1)))
              _v151047_)))))
  (define std/srfi/160/c128#c128vector-map!__1
    (lambda (_f151060_ _v151061_ . _vs151062_)
      (if (procedure? _f151060_)
          '#!void
          (error '"Bad argument; expected procedure" _f151060_))
      (let* ((_vs151065_ (cons _v151061_ _vs151062_))
             (_len151067_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151065_))))
        (declare (not safe))
        (let _lp151071_ ((_i151073_ '0))
          (if (fx< _i151073_ _len151067_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _v151061_
                 _i151073_
                 (apply _f151060_
                        (map (lambda (_g151074151076_)
                               (std/srfi/160/cvector#c128vector-ref
                                _g151074151076_
                                _i151073_))
                             _vs151065_)))
                (_lp151071_ (fx+ _i151073_ '1)))
              _v151061_)))))
  (define std/srfi/160/c128#c128vector-map!
    (lambda _g299530_
      (let ((_g299529_ (let () (declare (not safe)) (##length _g299530_))))
        (cond ((let () (declare (not safe)) (##fx= _g299529_ 2))
               (apply std/srfi/160/c128#c128vector-map!__0 _g299530_))
              ((let () (declare (not safe)) (##fx>= _g299529_ 2))
               (apply std/srfi/160/c128#c128vector-map!__1 _g299530_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-map!
                _g299530_))))))
  (define std/srfi/160/c128#c128vector-for-each__0
    (lambda (_f151011_ _v151013_)
      (if (procedure? _f151011_)
          '#!void
          (error '"Bad argument; expected procedure" _f151011_))
      (let ((_len151016_ (std/srfi/160/cvector#c128vector-length _v151013_)))
        (declare (not safe))
        (let _lp151020_ ((_i151023_ '0))
          (if (fx< _i151023_ _len151016_)
              (begin
                (_f151011_
                 (std/srfi/160/cvector#c128vector-ref _v151013_ _i151023_))
                (_lp151020_ (fx+ _i151023_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-for-each__1
    (lambda (_f151026_ _v151027_ . _vs151028_)
      (let* ((_vs151031_ (cons _v151027_ _vs151028_))
             (_len151033_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151031_))))
        (declare (not safe))
        (let _lp151037_ ((_i151039_ '0))
          (if (fx< _i151039_ _len151033_)
              (begin
                (apply _f151026_
                       (map (lambda (_g151040151042_)
                              (std/srfi/160/cvector#c128vector-ref
                               _g151040151042_
                               _i151039_))
                            _vs151031_))
                (_lp151037_ (fx+ _i151039_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-for-each
    (lambda _g299532_
      (let ((_g299531_ (let () (declare (not safe)) (##length _g299532_))))
        (cond ((let () (declare (not safe)) (##fx= _g299531_ 2))
               (apply std/srfi/160/c128#c128vector-for-each__0 _g299532_))
              ((let () (declare (not safe)) (##fx>= _g299531_ 2))
               (apply std/srfi/160/c128#c128vector-for-each__1 _g299532_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-for-each
                _g299532_))))))
  (define std/srfi/160/c128#c128vector-count__0
    (lambda (_pred150974_ _v150976_)
      (if (procedure? _pred150974_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150974_))
      (let ((_end150979_ (std/srfi/160/cvector#c128vector-length _v150976_)))
        (declare (not safe))
        (let _lp150983_ ((_i150986_ '0) (_r150988_ '0))
          (if (fx< _i150986_ _end150979_)
              (if (_pred150974_
                   (std/srfi/160/cvector#c128vector-ref _v150976_ _i150986_))
                  (_lp150983_ (fx+ _i150986_ '1) (fx+ _r150988_ '1))
                  (_lp150983_ (fx+ _i150986_ '1) _r150988_))
              _r150988_)))))
  (define std/srfi/160/c128#c128vector-count__1
    (lambda (_pred150991_ _v150992_ . _vs150993_)
      (if (procedure? _pred150991_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150991_))
      (let* ((_vs150996_ (cons _v150992_ _vs150993_))
             (_end150998_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150996_))))
        (declare (not safe))
        (let _lp151002_ ((_i151004_ '0) (_r151005_ '0))
          (if (fx< _i151004_ _end150998_)
              (if (apply _pred150991_
                         (map (lambda (_g151006151008_)
                                (std/srfi/160/cvector#c128vector-ref
                                 _g151006151008_
                                 _i151004_))
                              _vs150996_))
                  (_lp151002_ (fx+ _i151004_ '1) (fx+ _r151005_ '1))
                  (_lp151002_ (fx+ _i151004_ '1) _r151005_))
              _r151005_)))))
  (define std/srfi/160/c128#c128vector-count
    (lambda _g299534_
      (let ((_g299533_ (let () (declare (not safe)) (##length _g299534_))))
        (cond ((let () (declare (not safe)) (##fx= _g299533_ 2))
               (apply std/srfi/160/c128#c128vector-count__0 _g299534_))
              ((let () (declare (not safe)) (##fx>= _g299533_ 2))
               (apply std/srfi/160/c128#c128vector-count__1 _g299534_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-count
                _g299534_))))))
  (define std/srfi/160/c128#c128vector-cumulate
    (lambda (_f150949_ _knil150951_ _v150953_)
      (if (procedure? _f150949_)
          '#!void
          (error '"Bad argument; expected procedure" _f150949_))
      (let* ((_len150956_ (std/srfi/160/cvector#c128vector-length _v150953_))
             (_r150959_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len150956_)))
        (declare (not safe))
        (let _lp150964_ ((_i150967_ '0) (_r150969_ _knil150951_))
          (if (fx< _i150967_ _len150956_)
              (let ((_next150971_
                     (_f150949_
                      _r150969_
                      (std/srfi/160/cvector#c128vector-ref
                       _v150953_
                       _i150967_))))
                (std/srfi/160/cvector#c128vector-set!
                 _v150953_
                 _i150967_
                 _next150971_)
                (_lp150964_ (fx+ _i150967_ '1) _next150971_))
              _v150953_)))))
  (define std/srfi/160/c128#c128vector-take-while
    (lambda (_pred150932_ _v150934_)
      (let* ((_len150937_ (std/srfi/160/cvector#c128vector-length _v150934_))
             (_idx150940_
              (std/srfi/160/c128#c128vector-skip__0 _pred150932_ _v150934_))
             (_idx150946_
              (let ((_$e150943_ _idx150940_))
                (if _$e150943_ _$e150943_ _len150937_))))
        (std/srfi/160/c128#c128vector-copy__% _v150934_ '0 _idx150946_))))
  (define std/srfi/160/c128#c128vector-take-while-right
    (lambda (_pred150918_ _v150920_)
      (let* ((_len150923_ (std/srfi/160/cvector#c128vector-length _v150920_))
             (_idx150926_
              (std/srfi/160/c128#c128vector-skip-right__0
               _pred150918_
               _v150920_))
             (_idx150929_ (if _idx150926_ (fx+ _idx150926_ '1) '0)))
        (std/srfi/160/c128#c128vector-copy__%
         _v150920_
         _idx150929_
         _len150923_))))
  (define std/srfi/160/c128#c128vector-drop-while
    (lambda (_pred150901_ _v150903_)
      (let* ((_len150906_ (std/srfi/160/cvector#c128vector-length _v150903_))
             (_idx150909_
              (std/srfi/160/c128#c128vector-skip__0 _pred150901_ _v150903_))
             (_idx150915_
              (let ((_$e150912_ _idx150909_))
                (if _$e150912_ _$e150912_ _len150906_))))
        (std/srfi/160/c128#c128vector-copy__%
         _v150903_
         _idx150915_
         _len150906_))))
  (define std/srfi/160/c128#c128vector-drop-while-right
    (lambda (_pred150887_ _v150889_)
      (let* ((_len150892_ (std/srfi/160/cvector#c128vector-length _v150889_))
             (_idx150895_
              (std/srfi/160/c128#c128vector-skip-right__0
               _pred150887_
               _v150889_))
             (_idx150898_ (if _idx150895_ (fx+ _idx150895_ '1) '0)))
        (std/srfi/160/c128#c128vector-copy__% _v150889_ '0 _idx150898_))))
  (define std/srfi/160/c128#c128vector-index__0
    (lambda (_pred150853_ _v150855_)
      (if (procedure? _pred150853_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150853_))
      (let ((_end150858_ (std/srfi/160/cvector#c128vector-length _v150855_)))
        (declare (not safe))
        (let _lp150862_ ((_i150865_ '0))
          (if (fx< _i150865_ _end150858_)
              (if (_pred150853_
                   (std/srfi/160/cvector#c128vector-ref _v150855_ _i150865_))
                  _i150865_
                  (_lp150862_ (fx+ _i150865_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index__1
    (lambda (_pred150868_ _v150869_ . _vs150870_)
      (if (procedure? _pred150868_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150868_))
      (let* ((_vs150873_ (cons _v150869_ _vs150870_))
             (_end150875_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150873_))))
        (declare (not safe))
        (let _lp150879_ ((_i150881_ '0))
          (if (fx< _i150881_ _end150875_)
              (if (apply _pred150868_
                         (map (lambda (_g150882150884_)
                                (std/srfi/160/cvector#c128vector-ref
                                 _g150882150884_
                                 _i150881_))
                              _vs150873_))
                  _i150881_
                  (_lp150879_ (fx+ _i150881_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index
    (lambda _g299536_
      (let ((_g299535_ (let () (declare (not safe)) (##length _g299536_))))
        (cond ((let () (declare (not safe)) (##fx= _g299535_ 2))
               (apply std/srfi/160/c128#c128vector-index__0 _g299536_))
              ((let () (declare (not safe)) (##fx>= _g299535_ 2))
               (apply std/srfi/160/c128#c128vector-index__1 _g299536_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-index
                _g299536_))))))
  (define std/srfi/160/c128#c128vector-index-right__0
    (lambda (_pred150819_ _v150821_)
      (if (procedure? _pred150819_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150819_))
      (let ((_start150824_
             (fx- (std/srfi/160/cvector#c128vector-length _v150821_) '1)))
        (declare (not safe))
        (let _lp150828_ ((_i150831_ _start150824_))
          (if (fx>= _i150831_ '0)
              (if (_pred150819_
                   (std/srfi/160/cvector#c128vector-ref _v150821_ _i150831_))
                  _i150831_
                  (_lp150828_ (fx- _i150831_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index-right__1
    (lambda (_pred150834_ _v150835_ . _vs150836_)
      (if (procedure? _pred150834_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150834_))
      (let* ((_vs150839_ (cons _v150835_ _vs150836_))
             (_start150841_
              (fx- (apply fxmin
                          (map std/srfi/160/cvector#c128vector-length
                               _vs150839_))
                   '1)))
        (declare (not safe))
        (let _lp150845_ ((_i150847_ _start150841_))
          (if (fx>= _i150847_ '0)
              (if (apply _pred150834_
                         (map (lambda (_g150848150850_)
                                (std/srfi/160/cvector#c128vector-ref
                                 _g150848150850_
                                 _i150847_))
                              _vs150839_))
                  _i150847_
                  (_lp150845_ (fx- _i150847_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index-right
    (lambda _g299538_
      (let ((_g299537_ (let () (declare (not safe)) (##length _g299538_))))
        (cond ((let () (declare (not safe)) (##fx= _g299537_ 2))
               (apply std/srfi/160/c128#c128vector-index-right__0 _g299538_))
              ((let () (declare (not safe)) (##fx>= _g299537_ 2))
               (apply std/srfi/160/c128#c128vector-index-right__1 _g299538_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-index-right
                _g299538_))))))
  (define std/srfi/160/c128#c128vector-skip__0
    (lambda (_pred150803_ _v150805_)
      (std/srfi/160/c128#c128vector-index__0
       (lambda (_$obj150808_) (not (_pred150803_ _$obj150808_)))
       _v150805_)))
  (define std/srfi/160/c128#c128vector-skip__1
    (lambda (_pred150811_ _v150812_ . _vs150813_)
      (apply std/srfi/160/c128#c128vector-index
             (lambda (_$obj150816_) (not (_pred150811_ _$obj150816_)))
             _v150812_
             _vs150813_)))
  (define std/srfi/160/c128#c128vector-skip
    (lambda _g299540_
      (let ((_g299539_ (let () (declare (not safe)) (##length _g299540_))))
        (cond ((let () (declare (not safe)) (##fx= _g299539_ 2))
               (apply std/srfi/160/c128#c128vector-skip__0 _g299540_))
              ((let () (declare (not safe)) (##fx>= _g299539_ 2))
               (apply std/srfi/160/c128#c128vector-skip__1 _g299540_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-skip
                _g299540_))))))
  (define std/srfi/160/c128#c128vector-skip-right__0
    (lambda (_pred150787_ _v150789_)
      (std/srfi/160/c128#c128vector-index-right__0
       (lambda (_$obj150792_) (not (_pred150787_ _$obj150792_)))
       _v150789_)))
  (define std/srfi/160/c128#c128vector-skip-right__1
    (lambda (_pred150795_ _v150796_ . _vs150797_)
      (apply std/srfi/160/c128#c128vector-index-right
             (lambda (_$obj150800_) (not (_pred150795_ _$obj150800_)))
             _v150796_
             _vs150797_)))
  (define std/srfi/160/c128#c128vector-skip-right
    (lambda _g299542_
      (let ((_g299541_ (let () (declare (not safe)) (##length _g299542_))))
        (cond ((let () (declare (not safe)) (##fx= _g299541_ 2))
               (apply std/srfi/160/c128#c128vector-skip-right__0 _g299542_))
              ((let () (declare (not safe)) (##fx>= _g299541_ 2))
               (apply std/srfi/160/c128#c128vector-skip-right__1 _g299542_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-skip-right
                _g299542_))))))
  (define std/srfi/160/c128#c128vector-any__0
    (lambda (_pred150747_ _v150749_)
      (if (procedure? _pred150747_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150747_))
      (let ((_end150752_ (std/srfi/160/cvector#c128vector-length _v150749_)))
        (declare (not safe))
        (let _lp150756_ ((_i150759_ '0))
          (if (fx< _i150759_ _end150752_)
              (let ((_$e150762_
                     (_pred150747_
                      (std/srfi/160/cvector#c128vector-ref
                       _v150749_
                       _i150759_))))
                (if _$e150762_
                    (values _$e150762_)
                    (_lp150756_ (fx+ _i150759_ '1))))
              '#f)))))
  (define std/srfi/160/c128#c128vector-any__1
    (lambda (_pred150765_ _v150766_ . _vs150767_)
      (if (procedure? _pred150765_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150765_))
      (let* ((_v150770_ (cons _v150766_ _vs150767_))
             (_end150772_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150767_))))
        (declare (not safe))
        (let _lp150776_ ((_i150778_ '0))
          (if (fx< _i150778_ _end150772_)
              (let ((_$e150784_
                     (apply _pred150765_
                            (map (lambda (_g150779150781_)
                                   (std/srfi/160/cvector#c128vector-ref
                                    _g150779150781_
                                    _i150778_))
                                 _vs150767_))))
                (if _$e150784_
                    (values _$e150784_)
                    (_lp150776_ (fx+ _i150778_ '1))))
              '#f)))))
  (define std/srfi/160/c128#c128vector-any
    (lambda _g299544_
      (let ((_g299543_ (let () (declare (not safe)) (##length _g299544_))))
        (cond ((let () (declare (not safe)) (##fx= _g299543_ 2))
               (apply std/srfi/160/c128#c128vector-any__0 _g299544_))
              ((let () (declare (not safe)) (##fx>= _g299543_ 2))
               (apply std/srfi/160/c128#c128vector-any__1 _g299544_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-any
                _g299544_))))))
  (define std/srfi/160/c128#c128vector-every__0
    (lambda (_pred150696_ _v150698_)
      (if (procedure? _pred150696_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150696_))
      (let ((_end150701_ (std/srfi/160/cvector#c128vector-length _v150698_)))
        (declare (not safe))
        (let _lp150705_ ((_i150708_ '0) (_r150710_ '#t))
          (if (fx< _i150708_ _end150701_)
              (let ((_$e150713_
                     (_pred150696_
                      (std/srfi/160/cvector#c128vector-ref
                       _v150698_
                       _i150708_))))
                (if _$e150713_
                    ((lambda (_g150715150717_)
                       (_lp150705_ (fx+ _i150708_ '1) _g150715150717_))
                     _$e150713_)
                    '#f))
              _r150710_)))))
  (define std/srfi/160/c128#c128vector-every__1
    (lambda (_pred150720_ _v150721_ . _vs150722_)
      (if (procedure? _pred150720_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150720_))
      (let* ((_v150725_ (cons _v150721_ _vs150722_))
             (_end150727_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150722_))))
        (declare (not safe))
        (let _lp150731_ ((_i150733_ '0) (_r150734_ '#t))
          (if (fx< _i150733_ _end150727_)
              (let ((_$e150740_
                     (apply _pred150720_
                            (map (lambda (_g150735150737_)
                                   (std/srfi/160/cvector#c128vector-ref
                                    _g150735150737_
                                    _i150733_))
                                 _vs150722_))))
                (if _$e150740_
                    ((lambda (_g150742150744_)
                       (_lp150731_ (fx+ _i150733_ '1) _g150742150744_))
                     _$e150740_)
                    '#f))
              _r150734_)))))
  (define std/srfi/160/c128#c128vector-every
    (lambda _g299546_
      (let ((_g299545_ (let () (declare (not safe)) (##length _g299546_))))
        (cond ((let () (declare (not safe)) (##fx= _g299545_ 2))
               (apply std/srfi/160/c128#c128vector-every__0 _g299546_))
              ((let () (declare (not safe)) (##fx>= _g299545_ 2))
               (apply std/srfi/160/c128#c128vector-every__1 _g299546_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-every
                _g299546_))))))
  (define std/srfi/160/c128#c128vector-partition
    (lambda (_pred150667_ _v150669_)
      (let* ((_count150672_
              (std/srfi/160/c128#c128vector-count__0 _pred150667_ _v150669_))
             (_len150675_ (std/srfi/160/cvector#c128vector-length _v150669_))
             (_u150678_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len150675_)))
        (declare (not safe))
        (let _lp150683_ ((_i150686_ '0)
                         (_left150688_ '0)
                         (_right150690_ _count150672_))
          (if (fx< _i150686_ _len150675_)
              (let ((_x150693_
                     (std/srfi/160/cvector#c128vector-ref
                      _v150669_
                      _i150686_)))
                (if (_pred150667_ _x150693_)
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _u150678_
                       _left150688_
                       _x150693_)
                      (_lp150683_
                       (fx+ _i150686_ '1)
                       (fx+ _left150688_ '1)
                       _right150690_))
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _u150678_
                       _right150690_
                       _x150693_)
                      (_lp150683_
                       (fx+ _i150686_ '1)
                       _left150688_
                       (fx+ _right150690_ '1)))))
              _u150678_)))))
  (define std/srfi/160/c128#c128vector-filter
    (lambda (_pred150640_ _v150642_)
      (let* ((_count150645_
              (std/srfi/160/c128#c128vector-count__0 _pred150640_ _v150642_))
             (_u150648_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _count150645_))
             (_end150651_ (std/srfi/160/cvector#c128vector-length _v150642_)))
        (declare (not safe))
        (let _lp150656_ ((_i150659_ '0) (_j150661_ '0))
          (if (fx< _i150659_ _end150651_)
              (let ((_x150664_
                     (std/srfi/160/cvector#c128vector-ref
                      _v150642_
                      _i150659_)))
                (if (_pred150640_ _x150664_)
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _u150648_
                       _j150661_
                       _x150664_)
                      (_lp150656_ (fx+ _i150659_ '1) (fx+ _j150661_ '1)))
                    (_lp150656_ (fx+ _i150659_ '1) _j150661_)))
              _u150648_)))))
  (define std/srfi/160/c128#c128vector-remove
    (lambda (_pred150632_ _v150634_)
      (std/srfi/160/c128#c128vector-filter
       (lambda (_$obj150637_) (not (_pred150632_ _$obj150637_)))
       _v150634_)))
  (define std/srfi/160/c128#c128vector-swap
    (lambda (_v150619_ _i150621_ _j150623_)
      (let ((_iv150626_
             (std/srfi/160/cvector#c128vector-ref _v150619_ _i150621_))
            (_jv150628_
             (std/srfi/160/cvector#c128vector-ref _v150619_ _j150623_)))
        (declare (not safe))
        (begin
          (std/srfi/160/cvector#c128vector-set! _v150619_ _i150621_ _jv150628_)
          (std/srfi/160/cvector#c128vector-set!
           _v150619_
           _j150623_
           _iv150626_)))))
  (define std/srfi/160/c128#c128vector-fill!__%
    (lambda (_v150582_ _fill150584_ _start150586_ _end150588_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150582_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150582_))
        (if (std/srfi/160/base#c128? _fill150584_)
            '#!void
            (error '"Bad argument" _fill150584_))
        (if (and (fixnum? _start150586_)
                 (fx<= '0
                       _start150586_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150582_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150586_))
        (if (and (fixnum? _end150588_)
                 (fx<= _start150586_
                       _end150588_
                       (std/srfi/160/cvector#c128vector-length _v150582_)))
            '#!void
            (error '"Index out of range" _end150588_))
        (let _lp150592_ ((_i150595_ _start150586_))
          (if (fx< _i150595_ _end150588_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _v150582_
                 _i150595_
                 _fill150584_)
                (_lp150592_ (fx+ _i150595_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-fill!__0
    (lambda (_v150601_ _fill150602_)
      (let* ((_start150604_ '0)
             (_end150606_ (std/srfi/160/cvector#c128vector-length _v150601_)))
        (std/srfi/160/c128#c128vector-fill!__%
         _v150601_
         _fill150602_
         _start150604_
         _end150606_))))
  (define std/srfi/160/c128#c128vector-fill!__1
    (lambda (_v150608_ _fill150609_ _start150610_)
      (let ((_end150612_ (std/srfi/160/cvector#c128vector-length _v150608_)))
        (std/srfi/160/c128#c128vector-fill!__%
         _v150608_
         _fill150609_
         _start150610_
         _end150612_))))
  (define std/srfi/160/c128#c128vector-fill!
    (lambda _g299548_
      (let ((_g299547_ (let () (declare (not safe)) (##length _g299548_))))
        (cond ((let () (declare (not safe)) (##fx= _g299547_ 2))
               (apply std/srfi/160/c128#c128vector-fill!__0 _g299548_))
              ((let () (declare (not safe)) (##fx= _g299547_ 3))
               (apply std/srfi/160/c128#c128vector-fill!__1 _g299548_))
              ((let () (declare (not safe)) (##fx= _g299547_ 4))
               (apply std/srfi/160/c128#c128vector-fill!__% _g299548_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-fill!
                _g299548_))))))
  (define std/srfi/160/c128#c128vector-reverse!__%
    (lambda (_v150542_ _start150544_ _end150546_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150542_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150542_))
        (if (and (fixnum? _start150544_)
                 (fx<= '0
                       _start150544_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150542_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150544_))
        (if (and (fixnum? _end150546_)
                 (fx<= _start150544_
                       _end150546_
                       (std/srfi/160/cvector#c128vector-length _v150542_)))
            '#!void
            (error '"Index out of range" _end150546_))
        (let _lp150550_ ((_i150553_ _start150544_)
                         (_j150555_ (fx- _end150546_ '1)))
          (if (fx< _i150553_ _j150555_)
              (let ((_iv150558_
                     (std/srfi/160/cvector#c128vector-ref _v150542_ _i150553_))
                    (_jv150560_
                     (std/srfi/160/cvector#c128vector-ref
                      _v150542_
                      _j150555_)))
                (std/srfi/160/cvector#c128vector-set!
                 _v150542_
                 _i150553_
                 _jv150560_)
                (std/srfi/160/cvector#c128vector-set!
                 _v150542_
                 _j150555_
                 _iv150558_)
                (_lp150550_ (fx+ _i150553_ '1) (fx- _j150555_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-reverse!__0
    (lambda (_v150566_)
      (let* ((_start150568_ '0)
             (_end150570_ (std/srfi/160/cvector#c128vector-length _v150566_)))
        (std/srfi/160/c128#c128vector-reverse!__%
         _v150566_
         _start150568_
         _end150570_))))
  (define std/srfi/160/c128#c128vector-reverse!__1
    (lambda (_v150572_ _start150573_)
      (let ((_end150575_ (std/srfi/160/cvector#c128vector-length _v150572_)))
        (std/srfi/160/c128#c128vector-reverse!__%
         _v150572_
         _start150573_
         _end150575_))))
  (define std/srfi/160/c128#c128vector-reverse!
    (lambda _g299550_
      (let ((_g299549_ (let () (declare (not safe)) (##length _g299550_))))
        (cond ((let () (declare (not safe)) (##fx= _g299549_ 1))
               (apply std/srfi/160/c128#c128vector-reverse!__0 _g299550_))
              ((let () (declare (not safe)) (##fx= _g299549_ 2))
               (apply std/srfi/160/c128#c128vector-reverse!__1 _g299550_))
              ((let () (declare (not safe)) (##fx= _g299549_ 3))
               (apply std/srfi/160/c128#c128vector-reverse!__% _g299550_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-reverse!
                _g299550_))))))
  (define std/srfi/160/c128#c128vector-unfold!
    (lambda (_f150517_ _v150519_ _start150521_ _end150523_ _seed150525_)
      (declare (not safe))
      (begin
        (if (procedure? _f150517_)
            '#!void
            (error '"Bad argument; expected procedure" _f150517_))
        (if (##structure-direct-instance-of?
             _v150519_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150519_))
        (if (and (fixnum? _start150521_)
                 (fx<= '0
                       _start150521_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150519_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150521_))
        (if (and (fixnum? _end150523_)
                 (fx<= _start150521_
                       _end150523_
                       (std/srfi/160/cvector#c128vector-length _v150519_)))
            '#!void
            (error '"Index out of range" _end150523_))
        (let _lp150529_ ((_i150532_ _start150521_)
                         (_state150534_ _seed150525_))
          (if (fx< _i150532_ _end150523_)
              (let ((_g299551_ (_f150517_ _state150534_)))
                (begin
                  (let ((_g299552_
                         (if (##values? _g299551_)
                             (##vector-length _g299551_)
                             1)))
                    (if (not (##fx= _g299552_ 2))
                        (error "Context expects 2 values" _g299552_)))
                  (let ((_x150537_ (##vector-ref _g299551_ 0))
                        (_state150539_ (##vector-ref _g299551_ 1)))
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _v150519_
                       _i150532_
                       _x150537_)
                      (_lp150529_ (fx+ _i150532_ '1) _state150539_)))))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-unfold-right!
    (lambda (_f150493_ _v150495_ _start150497_ _end150499_ _seed150501_)
      (declare (not safe))
      (begin
        (if (procedure? _f150493_)
            '#!void
            (error '"Bad argument; expected procedure" _f150493_))
        (if (##structure-direct-instance-of?
             _v150495_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150495_))
        (if (and (fixnum? _start150497_)
                 (fx<= '0
                       _start150497_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150495_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150497_))
        (if (and (fixnum? _end150499_)
                 (fx<= _start150497_
                       _end150499_
                       (std/srfi/160/cvector#c128vector-length _v150495_)))
            '#!void
            (error '"Index out of range" _end150499_))
        (let _lp150505_ ((_i150508_ (fx- _end150499_ '1))
                         (_state150510_ _seed150501_))
          (if (fx>= _i150508_ _start150497_)
              (let ((_g299553_ (_f150493_ _state150510_)))
                (begin
                  (let ((_g299554_
                         (if (##values? _g299553_)
                             (##vector-length _g299553_)
                             1)))
                    (if (not (##fx= _g299554_ 2))
                        (error "Context expects 2 values" _g299554_)))
                  (let ((_x150513_ (##vector-ref _g299553_ 0))
                        (_state150515_ (##vector-ref _g299553_ 1)))
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _v150495_
                       _i150508_
                       _x150513_)
                      (_lp150505_ (fx- _i150508_ '1) _state150515_)))))
              '#!void)))))
  (define std/srfi/160/c128#reverse-c128vector->list__%
    (lambda (_v150459_ _start150461_ _end150463_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150459_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150459_))
        (if (and (fixnum? _start150461_)
                 (fx<= '0
                       _start150461_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150459_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150461_))
        (if (and (fixnum? _end150463_)
                 (fx<= _start150461_
                       _end150463_
                       (std/srfi/160/cvector#c128vector-length _v150459_)))
            '#!void
            (error '"Index out of range" _end150463_))
        (let _lp150467_ ((_i150470_ _start150461_) (_r150472_ '()))
          (if (fx< _i150470_ _end150463_)
              (_lp150467_
               (fx+ _i150470_ '1)
               (cons (std/srfi/160/cvector#c128vector-ref _v150459_ _i150470_)
                     _r150472_))
              _r150472_)))))
  (define std/srfi/160/c128#reverse-c128vector->list__0
    (lambda (_v150478_)
      (let* ((_start150480_ '0)
             (_end150482_ (std/srfi/160/cvector#c128vector-length _v150478_)))
        (std/srfi/160/c128#reverse-c128vector->list__%
         _v150478_
         _start150480_
         _end150482_))))
  (define std/srfi/160/c128#reverse-c128vector->list__1
    (lambda (_v150484_ _start150485_)
      (let ((_end150487_ (std/srfi/160/cvector#c128vector-length _v150484_)))
        (std/srfi/160/c128#reverse-c128vector->list__%
         _v150484_
         _start150485_
         _end150487_))))
  (define std/srfi/160/c128#reverse-c128vector->list
    (lambda _g299556_
      (let ((_g299555_ (let () (declare (not safe)) (##length _g299556_))))
        (cond ((let () (declare (not safe)) (##fx= _g299555_ 1))
               (apply std/srfi/160/c128#reverse-c128vector->list__0 _g299556_))
              ((let () (declare (not safe)) (##fx= _g299555_ 2))
               (apply std/srfi/160/c128#reverse-c128vector->list__1 _g299556_))
              ((let () (declare (not safe)) (##fx= _g299555_ 3))
               (apply std/srfi/160/c128#reverse-c128vector->list__% _g299556_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#reverse-c128vector->list
                _g299556_))))))
  (define std/srfi/160/c128#reverse-list->c128vector
    (lambda (_lst150405_)
      (let* ((_len150408_ (length _lst150405_))
             (_v150411_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len150408_)))
        (declare (not safe))
        (let _lp150416_ ((_rest150419_ _lst150405_) (_i150421_ '0))
          (let* ((_rest150423150431_ _rest150419_)
                 (_else150425150439_ (lambda () _v150411_))
                 (_K150427150446_
                  (lambda (_rest150442_ _x150443_)
                    (if (std/srfi/160/base#c128? _x150443_)
                        '#!void
                        (error '"Bad element" _x150443_))
                    (std/srfi/160/cvector#c128vector-set!
                     _v150411_
                     _i150421_
                     _x150443_)
                    (_lp150416_ _rest150442_ (fx+ _i150421_ '1)))))
            (if (##pair? _rest150423150431_)
                (let ((_hd150428150449_ (##car _rest150423150431_))
                      (_tl150429150451_ (##cdr _rest150423150431_)))
                  (let* ((_x150454_ _hd150428150449_)
                         (_rest150456_ _tl150429150451_))
                    (_K150427150446_ _rest150456_ _x150454_)))
                (_else150425150439_)))))))
  (define std/srfi/160/c128#c128vector->vector__%
    (lambda (_v150366_ _start150368_ _end150370_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150366_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150366_))
        (if (and (fixnum? _start150368_)
                 (fx<= '0
                       _start150368_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150366_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150368_))
        (if (and (fixnum? _end150370_)
                 (fx<= _start150368_
                       _end150370_
                       (std/srfi/160/cvector#c128vector-length _v150366_)))
            '#!void
            (error '"Index out of range" _end150370_))
        (let* ((_len150374_ (std/srfi/160/cvector#c128vector-length _v150366_))
               (_u150377_ (make-vector _len150374_)))
          (let _lp150381_ ((_i150384_ '0))
            (if (fx< _i150384_ _len150374_)
                (begin
                  (vector-set!
                   _u150377_
                   _i150384_
                   (std/srfi/160/cvector#c128vector-ref _v150366_ _i150384_))
                  (_lp150381_ (fx+ _i150384_ '1)))
                _u150377_))))))
  (define std/srfi/160/c128#c128vector->vector__0
    (lambda (_v150390_)
      (let* ((_start150392_ '0)
             (_end150394_ (std/srfi/160/cvector#c128vector-length _v150390_)))
        (std/srfi/160/c128#c128vector->vector__%
         _v150390_
         _start150392_
         _end150394_))))
  (define std/srfi/160/c128#c128vector->vector__1
    (lambda (_v150396_ _start150397_)
      (let ((_end150399_ (std/srfi/160/cvector#c128vector-length _v150396_)))
        (std/srfi/160/c128#c128vector->vector__%
         _v150396_
         _start150397_
         _end150399_))))
  (define std/srfi/160/c128#c128vector->vector
    (lambda _g299558_
      (let ((_g299557_ (let () (declare (not safe)) (##length _g299558_))))
        (cond ((let () (declare (not safe)) (##fx= _g299557_ 1))
               (apply std/srfi/160/c128#c128vector->vector__0 _g299558_))
              ((let () (declare (not safe)) (##fx= _g299557_ 2))
               (apply std/srfi/160/c128#c128vector->vector__1 _g299558_))
              ((let () (declare (not safe)) (##fx= _g299557_ 3))
               (apply std/srfi/160/c128#c128vector->vector__% _g299558_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector->vector
                _g299558_))))))
  (define std/srfi/160/c128#vector->c128vector__%
    (lambda (_v150326_ _start150328_ _end150330_)
      (declare (not safe))
      (begin
        (if (vector? _v150326_)
            '#!void
            (error '"Bad argument; expected vector" _v150326_))
        (if (and (fixnum? _start150328_)
                 (fx<= '0 _start150328_ (fx- (vector-length _v150326_) '1)))
            '#!void
            (error '"Index out of range" _start150328_))
        (if (and (fixnum? _end150330_)
                 (fx<= _start150328_ _end150330_ (vector-length _v150326_)))
            '#!void
            (error '"Index out of range" _end150330_))
        (let* ((_len150334_ (vector-length _v150326_))
               (_u150337_
                (make-struct-instance
                 std/srfi/160/cvector#c128vector::t
                 _len150334_)))
          (let _lp150341_ ((_i150344_ '0))
            (if (fx< _i150344_ _len150334_)
                (begin
                  (std/srfi/160/cvector#c128vector-set!
                   _u150337_
                   _i150344_
                   (vector-ref _v150326_ _i150344_))
                  (_lp150341_ (fx+ _i150344_ '1)))
                _u150337_))))))
  (define std/srfi/160/c128#vector->c128vector__0
    (lambda (_v150350_)
      (let* ((_start150352_ '0) (_end150354_ (vector-length _v150350_)))
        (std/srfi/160/c128#vector->c128vector__%
         _v150350_
         _start150352_
         _end150354_))))
  (define std/srfi/160/c128#vector->c128vector__1
    (lambda (_v150356_ _start150357_)
      (let ((_end150359_ (vector-length _v150356_)))
        (std/srfi/160/c128#vector->c128vector__%
         _v150356_
         _start150357_
         _end150359_))))
  (define std/srfi/160/c128#vector->c128vector
    (lambda _g299560_
      (let ((_g299559_ (let () (declare (not safe)) (##length _g299560_))))
        (cond ((let () (declare (not safe)) (##fx= _g299559_ 1))
               (apply std/srfi/160/c128#vector->c128vector__0 _g299560_))
              ((let () (declare (not safe)) (##fx= _g299559_ 2))
               (apply std/srfi/160/c128#vector->c128vector__1 _g299560_))
              ((let () (declare (not safe)) (##fx= _g299559_ 3))
               (apply std/srfi/160/c128#vector->c128vector__% _g299560_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#vector->c128vector
                _g299560_))))))
  (define std/srfi/160/c128#make-c128vector-generator__%
    (lambda (_v150292_ _start150294_ _end150296_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150292_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150292_))
        (if (and (fixnum? _start150294_)
                 (fx<= '0
                       _start150294_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150292_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150294_))
        (if (and (fixnum? _end150296_)
                 (fx<= _start150294_
                       _end150296_
                       (std/srfi/160/cvector#c128vector-length _v150292_)))
            '#!void
            (error '"Index out of range" _end150296_))
        (let ((_i150300_ _start150294_))
          (lambda ()
            (if (fx< _i150300_ _end150296_)
                (let ((_next150304_
                       (std/srfi/160/cvector#c128vector-ref
                        _v150292_
                        _i150300_)))
                  (set! _i150300_ (fx+ _i150300_ '1))
                  _next150304_)
                '#!eof))))))
  (define std/srfi/160/c128#make-c128vector-generator__0
    (lambda (_v150310_)
      (let* ((_start150312_ '0)
             (_end150314_ (std/srfi/160/cvector#c128vector-length _v150310_)))
        (std/srfi/160/c128#make-c128vector-generator__%
         _v150310_
         _start150312_
         _end150314_))))
  (define std/srfi/160/c128#make-c128vector-generator__1
    (lambda (_v150316_ _start150317_)
      (let ((_end150319_ (std/srfi/160/cvector#c128vector-length _v150316_)))
        (std/srfi/160/c128#make-c128vector-generator__%
         _v150316_
         _start150317_
         _end150319_))))
  (define std/srfi/160/c128#make-c128vector-generator
    (lambda _g299562_
      (let ((_g299561_ (let () (declare (not safe)) (##length _g299562_))))
        (cond ((let () (declare (not safe)) (##fx= _g299561_ 1))
               (apply std/srfi/160/c128#make-c128vector-generator__0
                      _g299562_))
              ((let () (declare (not safe)) (##fx= _g299561_ 2))
               (apply std/srfi/160/c128#make-c128vector-generator__1
                      _g299562_))
              ((let () (declare (not safe)) (##fx= _g299561_ 3))
               (apply std/srfi/160/c128#make-c128vector-generator__%
                      _g299562_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#make-c128vector-generator
                _g299562_))))))
  (define std/srfi/160/c128#c128vector-comparator
    (let ()
      (letrec ((_<?150263_
                (lambda (_a150266_ _b150268_)
                  (let ((_len-a150271_
                         (std/srfi/160/cvector#c128vector-length _a150266_))
                        (_len-b150273_
                         (std/srfi/160/cvector#c128vector-length _b150268_)))
                    (declare (not safe))
                    (if (fx< _len-a150271_ _len-b150273_)
                        '#t
                        (if (fx> _len-a150271_ _len-b150273_)
                            '#f
                            (let ((_end150277_ _len-a150271_))
                              (let _lp150280_ ((_i150283_ '0))
                                (if (fx< _i150283_ _end150277_)
                                    (let ((_x150286_
                                           (std/srfi/160/cvector#c128vector-ref
                                            _a150266_
                                            _i150283_))
                                          (_y150288_
                                           (std/srfi/160/cvector#c128vector-ref
                                            _b150268_
                                            _i150283_)))
                                      (if (< _x150286_ _y150288_)
                                          '#t
                                          (if (> _x150286_ _y150288_)
                                              '#f
                                              (_lp150280_
                                               (fx+ _i150283_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           std/srfi/160/cvector#c128vector?
           std/srfi/160/c128#c128vector=
           _<?150263_
           equal?-hash)))))
  (define std/srfi/160/c128#write-c128vector__%
    (lambda (_v150240_ _port150242_)
      (let ((_$e150245_ (find-method _v150240_ ':write)))
        (if _$e150245_
            ((lambda (_g150247150249_)
               (_g150247150249_ _v150240_ _port150242_))
             _$e150245_)
            (write _v150240_ (current-output-port))))))
  (define std/srfi/160/c128#write-c128vector__0
    (lambda (_v150255_)
      (let ((_port150257_ (current-output-port)))
        (std/srfi/160/c128#write-c128vector__% _v150255_ _port150257_))))
  (define std/srfi/160/c128#write-c128vector
    (lambda _g299564_
      (let ((_g299563_ (let () (declare (not safe)) (##length _g299564_))))
        (cond ((let () (declare (not safe)) (##fx= _g299563_ 1))
               (apply std/srfi/160/c128#write-c128vector__0 _g299564_))
              ((let () (declare (not safe)) (##fx= _g299563_ 2))
               (apply std/srfi/160/c128#write-c128vector__% _g299564_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#write-c128vector
                _g299564_)))))))
