(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/c64#c64vector-unfold
    (lambda (_f150216_ _len150218_ _seed150220_)
      (declare (not safe))
      (begin
        (if (procedure? _f150216_)
            '#!void
            (error '"Bad argument; expected procedure" _f150216_))
        (let ((_v150224_
               (let ((__obj299448
                      (make-object std/srfi/160/cvector#c64vector::t '1)))
                 (std/srfi/160/cvector#c64vector:::init!__0
                  __obj299448
                  _len150218_)
                 __obj299448)))
          (let _lp150227_ ((_i150230_ '0) (_state150232_ _seed150220_))
            (if (fx< _i150230_ _len150218_)
                (let ((_g299465_ (_f150216_ _i150230_ _state150232_)))
                  (begin
                    (let ((_g299466_
                           (if (##values? _g299465_)
                               (##vector-length _g299465_)
                               1)))
                      (if (not (##fx= _g299466_ 2))
                          (error "Context expects 2 values" _g299466_)))
                    (let ((_x150235_ (##vector-ref _g299465_ 0))
                          (_state150237_ (##vector-ref _g299465_ 1)))
                      (begin
                        (if (std/srfi/160/base#c64? _x150235_)
                            '#!void
                            (error '"Bad generated value" _x150235_))
                        (std/srfi/160/cvector#c64vector-set!
                         _v150224_
                         _i150230_
                         _x150235_)
                        (_lp150227_ (fx+ _i150230_ '1) _state150237_)))))
                _v150224_))))))
  (define std/srfi/160/c64#c64vector-unfold-right
    (lambda (_f150193_ _len150195_ _seed150197_)
      (declare (not safe))
      (begin
        (if (procedure? _f150193_)
            '#!void
            (error '"Bad argument; expected procedure" _f150193_))
        (let ((_v150201_
               (let ((__obj299449
                      (make-object std/srfi/160/cvector#c64vector::t '1)))
                 (std/srfi/160/cvector#c64vector:::init!__0
                  __obj299449
                  _len150195_)
                 __obj299449)))
          (let _lp150204_ ((_i150207_ (fx- _len150195_ '1))
                           (_state150209_ _seed150197_))
            (if (fx>= _i150207_ '0)
                (let ((_g299467_ (_f150193_ _i150207_ _state150209_)))
                  (begin
                    (let ((_g299468_
                           (if (##values? _g299467_)
                               (##vector-length _g299467_)
                               1)))
                      (if (not (##fx= _g299468_ 2))
                          (error "Context expects 2 values" _g299468_)))
                    (let ((_x150212_ (##vector-ref _g299467_ 0))
                          (_state150214_ (##vector-ref _g299467_ 1)))
                      (begin
                        (if (std/srfi/160/base#c64? _x150212_)
                            '#!void
                            (error '"Bad generated value" _x150212_))
                        (std/srfi/160/cvector#c64vector-set!
                         _v150201_
                         _i150207_
                         _x150212_)
                        (_lp150204_ (fx- _i150207_ '1) _state150214_)))))
                _v150201_))))))
  (define std/srfi/160/c64#c64vector-copy__%
    (lambda (_vec150165_ _start150167_ _end150169_)
      (let ((_v150172_
             (let ((__obj299450
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj299450
                (fx- _end150169_ _start150167_))
               __obj299450)))
        (std/srfi/160/c64#c64vector-copy!
         _v150172_
         '0
         _vec150165_
         _start150167_
         _end150169_)
        _v150172_)))
  (define std/srfi/160/c64#c64vector-copy__0
    (lambda (_vec150178_)
      (let* ((_start150180_ '0)
             (_end150182_ (std/srfi/160/cvector#c64vector-length _vec150178_)))
        (std/srfi/160/c64#c64vector-copy__%
         _vec150178_
         _start150180_
         _end150182_))))
  (define std/srfi/160/c64#c64vector-copy__1
    (lambda (_vec150184_ _start150185_)
      (let ((_end150187_ (std/srfi/160/cvector#c64vector-length _vec150184_)))
        (std/srfi/160/c64#c64vector-copy__%
         _vec150184_
         _start150185_
         _end150187_))))
  (define std/srfi/160/c64#c64vector-copy
    (lambda _g299470_
      (let ((_g299469_ (let () (declare (not safe)) (##length _g299470_))))
        (cond ((let () (declare (not safe)) (##fx= _g299469_ 1))
               (apply std/srfi/160/c64#c64vector-copy__0 _g299470_))
              ((let () (declare (not safe)) (##fx= _g299469_ 2))
               (apply std/srfi/160/c64#c64vector-copy__1 _g299470_))
              ((let () (declare (not safe)) (##fx= _g299469_ 3))
               (apply std/srfi/160/c64#c64vector-copy__% _g299470_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-copy
                _g299470_))))))
  (define std/srfi/160/c64#c64vector-copy!
    (lambda (_to150144_ _at150146_ _from150148_ _start150150_ _end150152_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to150144_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _to150144_))
        (if (##structure-direct-instance-of?
             _from150148_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _from150148_))
        (if (and (fixnum? _at150146_)
                 (fx<= '0
                       _at150146_
                       (fx- (std/srfi/160/cvector#c64vector-length _at150146_)
                            '1)))
            '#!void
            (error '"Index out of range" _to150144_ _at150146_))
        (if (and (fixnum? _start150150_)
                 (fx<= '0
                       _start150150_
                       (fx- (std/srfi/160/cvector#c64vector-length
                             _from150148_)
                            '1)))
            '#!void
            (error '"Index out of range" _from150148_ _start150150_))
        (if (and (fixnum? _end150152_)
                 (fx<= _start150150_
                       _end150152_
                       (std/srfi/160/cvector#c64vector-length _from150148_)))
            '#!void
            (error '"Index out of range" _from150148_ _end150152_))
        (if (fx<= (fx- _end150152_ _start150150_)
                  (fx- (std/srfi/160/cvector#c64vector-length _to150144_)
                       _at150146_))
            '#!void
            (error '"Destination area too small"
                   _to150144_
                   _at150146_
                   _from150148_
                   _start150150_
                   _end150152_))
        (let _lp150156_ ((_i150159_ _start150150_) (_j150161_ _at150146_))
          (if (fx< _i150159_ _end150152_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _to150144_
                 _j150161_
                 (std/srfi/160/cvector#c64vector-ref _from150148_ _i150159_))
                (_lp150156_ (fx+ _i150159_ '1) (fx+ _j150161_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-reverse-copy__%
    (lambda (_vec150116_ _start150118_ _end150120_)
      (let ((_v150123_
             (let ((__obj299451
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj299451
                (fx- _end150120_ _start150118_))
               __obj299451)))
        (std/srfi/160/c64#c64vector-reverse-copy!
         _v150123_
         '0
         _vec150116_
         _start150118_
         _end150120_)
        _v150123_)))
  (define std/srfi/160/c64#c64vector-reverse-copy__0
    (lambda (_vec150129_)
      (let* ((_start150131_ '0)
             (_end150133_ (std/srfi/160/cvector#c64vector-length _vec150129_)))
        (std/srfi/160/c64#c64vector-reverse-copy__%
         _vec150129_
         _start150131_
         _end150133_))))
  (define std/srfi/160/c64#c64vector-reverse-copy__1
    (lambda (_vec150135_ _start150136_)
      (let ((_end150138_ (std/srfi/160/cvector#c64vector-length _vec150135_)))
        (std/srfi/160/c64#c64vector-reverse-copy__%
         _vec150135_
         _start150136_
         _end150138_))))
  (define std/srfi/160/c64#c64vector-reverse-copy
    (lambda _g299472_
      (let ((_g299471_ (let () (declare (not safe)) (##length _g299472_))))
        (cond ((let () (declare (not safe)) (##fx= _g299471_ 1))
               (apply std/srfi/160/c64#c64vector-reverse-copy__0 _g299472_))
              ((let () (declare (not safe)) (##fx= _g299471_ 2))
               (apply std/srfi/160/c64#c64vector-reverse-copy__1 _g299472_))
              ((let () (declare (not safe)) (##fx= _g299471_ 3))
               (apply std/srfi/160/c64#c64vector-reverse-copy__% _g299472_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-reverse-copy
                _g299472_))))))
  (define std/srfi/160/c64#c64vector-reverse-copy!
    (lambda (_to150095_ _at150097_ _from150099_ _start150101_ _end150103_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to150095_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _to150095_))
        (if (##structure-direct-instance-of?
             _from150099_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _from150099_))
        (if (and (fixnum? _at150097_)
                 (fx<= '0
                       _at150097_
                       (fx- (std/srfi/160/cvector#c64vector-length _at150097_)
                            '1)))
            '#!void
            (error '"Index out of range" _to150095_ _at150097_))
        (if (and (fixnum? _start150101_)
                 (fx<= '0
                       _start150101_
                       (fx- (std/srfi/160/cvector#c64vector-length
                             _from150099_)
                            '1)))
            '#!void
            (error '"Index out of range" _from150099_ _start150101_))
        (if (and (fixnum? _end150103_)
                 (fx<= _start150101_
                       _end150103_
                       (std/srfi/160/cvector#c64vector-length _from150099_)))
            '#!void
            (error '"Index out of range" _from150099_ _end150103_))
        (if (fx<= (fx- _end150103_ _start150101_)
                  (fx- (std/srfi/160/cvector#c64vector-length _to150095_)
                       _at150097_))
            '#!void
            (error '"Destination area too small"
                   _to150095_
                   _at150097_
                   _from150099_
                   _start150101_
                   _end150103_))
        (let _lp150107_ ((_i150110_ (fx- _end150103_ '1))
                         (_j150112_ _at150097_))
          (if (fx>= _i150110_ _start150101_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _to150095_
                 _j150112_
                 (std/srfi/160/cvector#c64vector-ref _from150099_ _i150110_))
                (_lp150107_ (fx- _i150110_ '1) (fx+ _j150112_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-append
    (lambda _args150092_
      (std/srfi/160/c64#c64vector-concatenate _args150092_)))
  (define std/srfi/160/c64#c64vector-concatenate
    (lambda (_lst150032_)
      (let* ((_len150040_
              (foldl1 (lambda (_v150035_ _r150037_)
                        (fx+ (std/srfi/160/cvector#c64vector-length _v150035_)
                             _r150037_))
                      '0
                      _lst150032_))
             (_v150043_
              (let ((__obj299452
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299452
                 _len150040_)
                __obj299452)))
        (declare (not safe))
        (let _lp150047_ ((_rest150050_ _lst150032_) (_at150052_ '0))
          (let* ((_rest150054150062_ _rest150050_)
                 (_else150056150070_ (lambda () _v150043_))
                 (_K150058150080_
                  (lambda (_rest150073_ _u150074_)
                    (let ((_ulen150077_
                           (std/srfi/160/cvector#c64vector-length _u150074_)))
                      (std/srfi/160/c64#c64vector-copy!
                       _v150043_
                       _at150052_
                       _u150074_
                       '0
                       _ulen150077_)
                      (_lp150047_
                       _rest150073_
                       (fx+ _at150052_ _ulen150077_))))))
            (if (##pair? _rest150054150062_)
                (let ((_hd150059150083_ (##car _rest150054150062_))
                      (_tl150060150085_ (##cdr _rest150054150062_)))
                  (let* ((_u150088_ _hd150059150083_)
                         (_rest150090_ _tl150060150085_))
                    (_K150058150080_ _rest150090_ _u150088_)))
                (_else150056150070_)))))))
  (define std/srfi/160/c64#c64vector-append-subvectors
    (lambda _args149904_
      (let* ((_len149965_
              (let _lp149907_ ((_rest149910_ _args149904_) (_r149912_ '0))
                (let* ((_rest149914149926_ _rest149910_)
                       (_else149916149934_ (lambda () _r149912_))
                       (_K149918149943_
                        (lambda (_rest149937_ _end149938_ _start149940_)
                          (_lp149907_
                           _rest149937_
                           (fx+ _r149912_ (fx- _end149938_ _start149940_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest149914149926_))
                      (let ((_tl149920149946_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest149914149926_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl149920149946_))
                            (let ((_hd149921149949_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl149920149946_)))
                                  (_tl149922149951_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl149920149946_))))
                              (let ((_start149954_ _hd149921149949_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl149922149951_))
                                    (let ((_hd149923149956_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl149922149951_)))
                                          (_tl149924149958_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl149922149951_))))
                                      (let* ((_end149961_ _hd149923149956_)
                                             (_rest149963_ _tl149924149958_))
                                        (_K149918149943_
                                         _rest149963_
                                         _end149961_
                                         _start149954_)))
                                    (_else149916149934_))))
                            (_else149916149934_)))
                      (_else149916149934_)))))
             (_v149968_
              (let ((__obj299453
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299453
                 _len149965_)
                __obj299453)))
        (let _lp149972_ ((_rest149974_ _args149904_) (_at149975_ '0))
          (let* ((_rest149977149989_ _rest149974_)
                 (_else149979149997_ (lambda () _v149968_))
                 (_K149981150006_
                  (lambda (_rest150000_ _end150001_ _start150002_ _u150003_)
                    (std/srfi/160/c64#c64vector-copy!
                     _v149968_
                     _at149975_
                     _u150003_
                     _start150002_
                     _end150001_)
                    (_lp149972_
                     _rest150000_
                     (fx+ _at149975_ (fx- _end150001_ _start150002_))))))
            (if (let () (declare (not safe)) (##pair? _rest149977149989_))
                (let ((_hd149982150009_
                       (let ()
                         (declare (not safe))
                         (##car _rest149977149989_)))
                      (_tl149983150011_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest149977149989_))))
                  (let ((_u150014_ _hd149982150009_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl149983150011_))
                        (let ((_hd149984150016_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl149983150011_)))
                              (_tl149985150018_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl149983150011_))))
                          (let ((_start150021_ _hd149984150016_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl149985150018_))
                                (let ((_hd149986150023_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl149985150018_)))
                                      (_tl149987150025_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl149985150018_))))
                                  (let* ((_end150028_ _hd149986150023_)
                                         (_rest150030_ _tl149987150025_))
                                    (_K149981150006_
                                     _rest150030_
                                     _end150028_
                                     _start150021_
                                     _u150014_)))
                                (_else149979149997_))))
                        (_else149979149997_))))
                (_else149979149997_)))))))
  (define std/srfi/160/c64#c64vector-empty?
    (lambda (_v149901_)
      (fxzero? (std/srfi/160/cvector#c64vector-length _v149901_))))
  (define std/srfi/160/c64#c64vector=
    (lambda (_v149843_ . _args149845_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149843_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149843_))
        (let ((_vlen149849_ (std/srfi/160/cvector#c64vector-length _v149843_)))
          (let _lp149852_ ((_rest149855_ _args149845_))
            (let* ((_rest149857149865_ _rest149855_)
                   (_else149859149873_ (lambda () '#t))
                   (_K149861149889_
                    (lambda (_rest149876_ _u149877_)
                      (if (##structure-direct-instance-of?
                           _u149877_
                           'std/srfi/160/cvector#c64vector::t)
                          '#!void
                          (error '"Bad argument" _u149877_))
                      (let ((_ulen149880_
                             (std/srfi/160/cvector#c64vector-length
                              _u149877_)))
                        (if (fx= _vlen149849_ _ulen149880_)
                            (let _cmp149883_ ((_i149886_ '0))
                              (if (fx< _i149886_ _vlen149849_)
                                  (if (= (std/srfi/160/cvector#c64vector-ref
                                          _v149843_
                                          _i149886_)
                                         (std/srfi/160/cvector#c64vector-ref
                                          _u149877_
                                          _i149886_))
                                      (_cmp149883_ (fx+ _i149886_ '1))
                                      '#f)
                                  (_lp149852_ _rest149876_)))
                            '#f)))))
              (if (##pair? _rest149857149865_)
                  (let ((_hd149862149892_ (##car _rest149857149865_))
                        (_tl149863149894_ (##cdr _rest149857149865_)))
                    (let* ((_u149897_ _hd149862149892_)
                           (_rest149899_ _tl149863149894_))
                      (_K149861149889_ _rest149899_ _u149897_)))
                  (_else149859149873_))))))))
  (define std/srfi/160/c64#c64vector-take
    (lambda (_v149835_ _n149837_)
      (let ((_u149840_
             (let ((__obj299454
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj299454
                _n149837_)
               __obj299454)))
        (std/srfi/160/c64#c64vector-copy! _u149840_ '0 _v149835_ '0 _n149837_)
        _u149840_)))
  (define std/srfi/160/c64#c64vector-take-right
    (lambda (_v149820_ _n149822_)
      (let* ((_vlen149825_ (std/srfi/160/cvector#c64vector-length _v149820_))
             (_ulen149828_ (fx- _vlen149825_ _n149822_))
             (_u149831_
              (let ((__obj299455
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299455
                 _ulen149828_)
                __obj299455)))
        (std/srfi/160/c64#c64vector-copy!
         _u149831_
         '0
         _v149820_
         _n149822_
         _vlen149825_)
        _u149831_)))
  (define std/srfi/160/c64#c64vector-drop
    (lambda (_v149805_ _n149807_)
      (let* ((_vlen149810_ (std/srfi/160/cvector#c64vector-length _v149805_))
             (_ulen149813_ (fx- _vlen149810_ _n149807_))
             (_u149816_
              (let ((__obj299456
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299456
                 _ulen149813_)
                __obj299456)))
        (std/srfi/160/c64#c64vector-copy!
         _u149816_
         '0
         _v149805_
         _n149807_
         _vlen149810_)
        _u149816_)))
  (define std/srfi/160/c64#c64vector-drop-right
    (lambda (_v149790_ _n149792_)
      (let* ((_vlen149795_ (std/srfi/160/cvector#c64vector-length _v149790_))
             (_ulen149798_ (fx- _vlen149795_ _n149792_))
             (_u149801_
              (let ((__obj299457
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299457
                 _ulen149798_)
                __obj299457)))
        (std/srfi/160/c64#c64vector-copy!
         _u149801_
         '0
         _v149790_
         '0
         _ulen149798_)
        _u149801_)))
  (define std/srfi/160/c64#c64vector-segment
    (lambda (_v149772_ _n149774_)
      (let _lp149777_ ((_i149780_ '0)
                       (_rest149782_
                        (std/srfi/160/cvector#c64vector-length _v149772_))
                       (_r149784_ '()))
        (if (fx> _r149784_ '0)
            (let ((_size149787_ (fxmin _n149774_ _rest149782_)))
              (_lp149777_
               (fx+ _i149780_ _size149787_)
               (fx- _rest149782_ _size149787_)
               (cons (std/srfi/160/c64#c64vector-copy__%
                      _v149772_
                      _i149780_
                      (fx+ _i149780_ _size149787_))
                     _r149784_)))
            (reverse _r149784_)))))
  (define std/srfi/160/c64#c64vector-fold__0
    (lambda (_kons149732_ _knil149734_ _v149736_)
      (if (procedure? _kons149732_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149732_))
      (let ((_end149739_ (std/srfi/160/cvector#c64vector-length _v149736_)))
        (declare (not safe))
        (let _lp149743_ ((_i149746_ '0) (_r149748_ _knil149734_))
          (if (fx< _i149746_ _end149739_)
              (_lp149743_
               (fx+ _i149746_ '1)
               (_kons149732_
                _r149748_
                (std/srfi/160/cvector#c64vector-ref _v149736_ _i149746_)))
              _r149748_)))))
  (define std/srfi/160/c64#c64vector-fold__1
    (lambda (_kons149751_ _knil149752_ _v149753_ . _vs149754_)
      (if (procedure? _kons149751_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149751_))
      (let* ((_vs149757_ (cons _v149753_ _vs149754_))
             (_end149759_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149757_))))
        (declare (not safe))
        (let _lp149763_ ((_i149765_ '0) (_r149766_ _knil149752_))
          (if (fx< _i149765_ _end149759_)
              (_lp149763_
               (fx+ _i149765_ '1)
               (apply _kons149751_
                      _r149766_
                      (map (lambda (_g149767149769_)
                             (std/srfi/160/cvector#c64vector-ref
                              _g149767149769_
                              _i149765_))
                           _vs149757_)))
              _r149766_)))))
  (define std/srfi/160/c64#c64vector-fold
    (lambda _g299474_
      (let ((_g299473_ (let () (declare (not safe)) (##length _g299474_))))
        (cond ((let () (declare (not safe)) (##fx= _g299473_ 3))
               (apply std/srfi/160/c64#c64vector-fold__0 _g299474_))
              ((let () (declare (not safe)) (##fx>= _g299473_ 3))
               (apply std/srfi/160/c64#c64vector-fold__1 _g299474_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-fold
                _g299474_))))))
  (define std/srfi/160/c64#c64vector-fold-right__0
    (lambda (_kons149692_ _knil149694_ _v149696_)
      (if (procedure? _kons149692_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149692_))
      (let ((_last149699_
             (fx- (std/srfi/160/cvector#c64vector-length _v149696_) '1)))
        (declare (not safe))
        (let _lp149703_ ((_i149706_ _last149699_) (_r149708_ _knil149694_))
          (if (fx>= _i149706_ '0)
              (_lp149703_
               (fx- _i149706_ '1)
               (_kons149692_
                _r149708_
                (std/srfi/160/cvector#c64vector-ref _v149696_ _i149706_)))
              _r149708_)))))
  (define std/srfi/160/c64#c64vector-fold-right__1
    (lambda (_kons149711_ _knil149712_ _v149713_ . _vs149714_)
      (if (procedure? _kons149711_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149711_))
      (let* ((_vs149717_ (cons _v149713_ _vs149714_))
             (_last149719_
              (fx- (apply min
                          (map std/srfi/160/cvector#c64vector-length
                               _vs149717_))
                   '1)))
        (declare (not safe))
        (let _lp149723_ ((_i149725_ _last149719_) (_r149726_ _knil149712_))
          (if (fx>= _i149725_ '0)
              (_lp149723_
               (fx- _i149725_ '1)
               (apply _kons149711_
                      _r149726_
                      (map (lambda (_g149727149729_)
                             (std/srfi/160/cvector#c64vector-ref
                              _g149727149729_
                              _i149725_))
                           _vs149717_)))
              _r149726_)))))
  (define std/srfi/160/c64#c64vector-fold-right
    (lambda _g299476_
      (let ((_g299475_ (let () (declare (not safe)) (##length _g299476_))))
        (cond ((let () (declare (not safe)) (##fx= _g299475_ 3))
               (apply std/srfi/160/c64#c64vector-fold-right__0 _g299476_))
              ((let () (declare (not safe)) (##fx>= _g299475_ 3))
               (apply std/srfi/160/c64#c64vector-fold-right__1 _g299476_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-fold-right
                _g299476_))))))
  (define std/srfi/160/c64#c64vector-map__0
    (lambda (_f149652_ _v149654_)
      (if (procedure? _f149652_)
          '#!void
          (error '"Bad argument; expected procedure" _f149652_))
      (let* ((_len149657_ (std/srfi/160/cvector#c64vector-length _v149654_))
             (_u149660_
              (let ((__obj299458
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299458
                 _len149657_)
                __obj299458)))
        (declare (not safe))
        (let _lp149665_ ((_i149668_ '0))
          (if (fx< _i149668_ _len149657_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _u149660_
                 _i149668_
                 (std/srfi/160/cvector#c64vector-ref _v149654_ _i149668_))
                (_lp149665_ (fx+ _i149668_ '1)))
              _u149660_)))))
  (define std/srfi/160/c64#c64vector-map__1
    (lambda (_f149671_ _v149672_ . _vs149673_)
      (if (procedure? _f149671_)
          '#!void
          (error '"Bad argument; expected procedure" _f149671_))
      (let* ((_vs149676_ (cons _v149672_ _vs149673_))
             (_len149678_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149676_)))
             (_u149680_
              (let ((__obj299459
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299459
                 _len149678_)
                __obj299459)))
        (declare (not safe))
        (let _lp149684_ ((_i149686_ '0))
          (if (fx< _i149686_ _len149678_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _u149680_
                 _i149686_
                 (apply _f149671_
                        (map (lambda (_g149687149689_)
                               (std/srfi/160/cvector#c64vector-ref
                                _g149687149689_
                                _i149686_))
                             _vs149676_)))
                (_lp149684_ (fx+ _i149686_ '1)))
              _u149680_)))))
  (define std/srfi/160/c64#c64vector-map
    (lambda _g299478_
      (let ((_g299477_ (let () (declare (not safe)) (##length _g299478_))))
        (cond ((let () (declare (not safe)) (##fx= _g299477_ 2))
               (apply std/srfi/160/c64#c64vector-map__0 _g299478_))
              ((let () (declare (not safe)) (##fx>= _g299477_ 2))
               (apply std/srfi/160/c64#c64vector-map__1 _g299478_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-map
                _g299478_))))))
  (define std/srfi/160/c64#c64vector-map!__0
    (lambda (_f149618_ _v149620_)
      (if (procedure? _f149618_)
          '#!void
          (error '"Bad argument; expected procedure" _f149618_))
      (let ((_len149623_ (std/srfi/160/cvector#c64vector-length _v149620_)))
        (declare (not safe))
        (let _lp149627_ ((_i149630_ '0))
          (if (fx< _i149630_ _len149623_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _v149620_
                 _i149630_
                 (_f149618_
                  (std/srfi/160/cvector#c64vector-ref _v149620_ _i149630_)))
                (_lp149627_ (fx+ _i149630_ '1)))
              _v149620_)))))
  (define std/srfi/160/c64#c64vector-map!__1
    (lambda (_f149633_ _v149634_ . _vs149635_)
      (if (procedure? _f149633_)
          '#!void
          (error '"Bad argument; expected procedure" _f149633_))
      (let* ((_vs149638_ (cons _v149634_ _vs149635_))
             (_len149640_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149638_))))
        (declare (not safe))
        (let _lp149644_ ((_i149646_ '0))
          (if (fx< _i149646_ _len149640_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _v149634_
                 _i149646_
                 (apply _f149633_
                        (map (lambda (_g149647149649_)
                               (std/srfi/160/cvector#c64vector-ref
                                _g149647149649_
                                _i149646_))
                             _vs149638_)))
                (_lp149644_ (fx+ _i149646_ '1)))
              _v149634_)))))
  (define std/srfi/160/c64#c64vector-map!
    (lambda _g299480_
      (let ((_g299479_ (let () (declare (not safe)) (##length _g299480_))))
        (cond ((let () (declare (not safe)) (##fx= _g299479_ 2))
               (apply std/srfi/160/c64#c64vector-map!__0 _g299480_))
              ((let () (declare (not safe)) (##fx>= _g299479_ 2))
               (apply std/srfi/160/c64#c64vector-map!__1 _g299480_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-map!
                _g299480_))))))
  (define std/srfi/160/c64#c64vector-for-each__0
    (lambda (_f149584_ _v149586_)
      (if (procedure? _f149584_)
          '#!void
          (error '"Bad argument; expected procedure" _f149584_))
      (let ((_len149589_ (std/srfi/160/cvector#c64vector-length _v149586_)))
        (declare (not safe))
        (let _lp149593_ ((_i149596_ '0))
          (if (fx< _i149596_ _len149589_)
              (begin
                (_f149584_
                 (std/srfi/160/cvector#c64vector-ref _v149586_ _i149596_))
                (_lp149593_ (fx+ _i149596_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-for-each__1
    (lambda (_f149599_ _v149600_ . _vs149601_)
      (let* ((_vs149604_ (cons _v149600_ _vs149601_))
             (_len149606_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149604_))))
        (declare (not safe))
        (let _lp149610_ ((_i149612_ '0))
          (if (fx< _i149612_ _len149606_)
              (begin
                (apply _f149599_
                       (map (lambda (_g149613149615_)
                              (std/srfi/160/cvector#c64vector-ref
                               _g149613149615_
                               _i149612_))
                            _vs149604_))
                (_lp149610_ (fx+ _i149612_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-for-each
    (lambda _g299482_
      (let ((_g299481_ (let () (declare (not safe)) (##length _g299482_))))
        (cond ((let () (declare (not safe)) (##fx= _g299481_ 2))
               (apply std/srfi/160/c64#c64vector-for-each__0 _g299482_))
              ((let () (declare (not safe)) (##fx>= _g299481_ 2))
               (apply std/srfi/160/c64#c64vector-for-each__1 _g299482_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-for-each
                _g299482_))))))
  (define std/srfi/160/c64#c64vector-count__0
    (lambda (_pred149547_ _v149549_)
      (if (procedure? _pred149547_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149547_))
      (let ((_end149552_ (std/srfi/160/cvector#c64vector-length _v149549_)))
        (declare (not safe))
        (let _lp149556_ ((_i149559_ '0) (_r149561_ '0))
          (if (fx< _i149559_ _end149552_)
              (if (_pred149547_
                   (std/srfi/160/cvector#c64vector-ref _v149549_ _i149559_))
                  (_lp149556_ (fx+ _i149559_ '1) (fx+ _r149561_ '1))
                  (_lp149556_ (fx+ _i149559_ '1) _r149561_))
              _r149561_)))))
  (define std/srfi/160/c64#c64vector-count__1
    (lambda (_pred149564_ _v149565_ . _vs149566_)
      (if (procedure? _pred149564_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149564_))
      (let* ((_vs149569_ (cons _v149565_ _vs149566_))
             (_end149571_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149569_))))
        (declare (not safe))
        (let _lp149575_ ((_i149577_ '0) (_r149578_ '0))
          (if (fx< _i149577_ _end149571_)
              (if (apply _pred149564_
                         (map (lambda (_g149579149581_)
                                (std/srfi/160/cvector#c64vector-ref
                                 _g149579149581_
                                 _i149577_))
                              _vs149569_))
                  (_lp149575_ (fx+ _i149577_ '1) (fx+ _r149578_ '1))
                  (_lp149575_ (fx+ _i149577_ '1) _r149578_))
              _r149578_)))))
  (define std/srfi/160/c64#c64vector-count
    (lambda _g299484_
      (let ((_g299483_ (let () (declare (not safe)) (##length _g299484_))))
        (cond ((let () (declare (not safe)) (##fx= _g299483_ 2))
               (apply std/srfi/160/c64#c64vector-count__0 _g299484_))
              ((let () (declare (not safe)) (##fx>= _g299483_ 2))
               (apply std/srfi/160/c64#c64vector-count__1 _g299484_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-count
                _g299484_))))))
  (define std/srfi/160/c64#c64vector-cumulate
    (lambda (_f149522_ _knil149524_ _v149526_)
      (if (procedure? _f149522_)
          '#!void
          (error '"Bad argument; expected procedure" _f149522_))
      (let* ((_len149529_ (std/srfi/160/cvector#c64vector-length _v149526_))
             (_r149532_
              (let ((__obj299460
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299460
                 _len149529_)
                __obj299460)))
        (declare (not safe))
        (let _lp149537_ ((_i149540_ '0) (_r149542_ _knil149524_))
          (if (fx< _i149540_ _len149529_)
              (let ((_next149544_
                     (_f149522_
                      _r149542_
                      (std/srfi/160/cvector#c64vector-ref
                       _v149526_
                       _i149540_))))
                (std/srfi/160/cvector#c64vector-set!
                 _v149526_
                 _i149540_
                 _next149544_)
                (_lp149537_ (fx+ _i149540_ '1) _next149544_))
              _v149526_)))))
  (define std/srfi/160/c64#c64vector-take-while
    (lambda (_pred149505_ _v149507_)
      (let* ((_len149510_ (std/srfi/160/cvector#c64vector-length _v149507_))
             (_idx149513_
              (std/srfi/160/c64#c64vector-skip__0 _pred149505_ _v149507_))
             (_idx149519_
              (let ((_$e149516_ _idx149513_))
                (if _$e149516_ _$e149516_ _len149510_))))
        (std/srfi/160/c64#c64vector-copy__% _v149507_ '0 _idx149519_))))
  (define std/srfi/160/c64#c64vector-take-while-right
    (lambda (_pred149491_ _v149493_)
      (let* ((_len149496_ (std/srfi/160/cvector#c64vector-length _v149493_))
             (_idx149499_
              (std/srfi/160/c64#c64vector-skip-right__0
               _pred149491_
               _v149493_))
             (_idx149502_ (if _idx149499_ (fx+ _idx149499_ '1) '0)))
        (std/srfi/160/c64#c64vector-copy__%
         _v149493_
         _idx149502_
         _len149496_))))
  (define std/srfi/160/c64#c64vector-drop-while
    (lambda (_pred149474_ _v149476_)
      (let* ((_len149479_ (std/srfi/160/cvector#c64vector-length _v149476_))
             (_idx149482_
              (std/srfi/160/c64#c64vector-skip__0 _pred149474_ _v149476_))
             (_idx149488_
              (let ((_$e149485_ _idx149482_))
                (if _$e149485_ _$e149485_ _len149479_))))
        (std/srfi/160/c64#c64vector-copy__%
         _v149476_
         _idx149488_
         _len149479_))))
  (define std/srfi/160/c64#c64vector-drop-while-right
    (lambda (_pred149460_ _v149462_)
      (let* ((_len149465_ (std/srfi/160/cvector#c64vector-length _v149462_))
             (_idx149468_
              (std/srfi/160/c64#c64vector-skip-right__0
               _pred149460_
               _v149462_))
             (_idx149471_ (if _idx149468_ (fx+ _idx149468_ '1) '0)))
        (std/srfi/160/c64#c64vector-copy__% _v149462_ '0 _idx149471_))))
  (define std/srfi/160/c64#c64vector-index__0
    (lambda (_pred149426_ _v149428_)
      (if (procedure? _pred149426_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149426_))
      (let ((_end149431_ (std/srfi/160/cvector#c64vector-length _v149428_)))
        (declare (not safe))
        (let _lp149435_ ((_i149438_ '0))
          (if (fx< _i149438_ _end149431_)
              (if (_pred149426_
                   (std/srfi/160/cvector#c64vector-ref _v149428_ _i149438_))
                  _i149438_
                  (_lp149435_ (fx+ _i149438_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index__1
    (lambda (_pred149441_ _v149442_ . _vs149443_)
      (if (procedure? _pred149441_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149441_))
      (let* ((_vs149446_ (cons _v149442_ _vs149443_))
             (_end149448_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149446_))))
        (declare (not safe))
        (let _lp149452_ ((_i149454_ '0))
          (if (fx< _i149454_ _end149448_)
              (if (apply _pred149441_
                         (map (lambda (_g149455149457_)
                                (std/srfi/160/cvector#c64vector-ref
                                 _g149455149457_
                                 _i149454_))
                              _vs149446_))
                  _i149454_
                  (_lp149452_ (fx+ _i149454_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index
    (lambda _g299486_
      (let ((_g299485_ (let () (declare (not safe)) (##length _g299486_))))
        (cond ((let () (declare (not safe)) (##fx= _g299485_ 2))
               (apply std/srfi/160/c64#c64vector-index__0 _g299486_))
              ((let () (declare (not safe)) (##fx>= _g299485_ 2))
               (apply std/srfi/160/c64#c64vector-index__1 _g299486_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-index
                _g299486_))))))
  (define std/srfi/160/c64#c64vector-index-right__0
    (lambda (_pred149392_ _v149394_)
      (if (procedure? _pred149392_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149392_))
      (let ((_start149397_
             (fx- (std/srfi/160/cvector#c64vector-length _v149394_) '1)))
        (declare (not safe))
        (let _lp149401_ ((_i149404_ _start149397_))
          (if (fx>= _i149404_ '0)
              (if (_pred149392_
                   (std/srfi/160/cvector#c64vector-ref _v149394_ _i149404_))
                  _i149404_
                  (_lp149401_ (fx- _i149404_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index-right__1
    (lambda (_pred149407_ _v149408_ . _vs149409_)
      (if (procedure? _pred149407_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149407_))
      (let* ((_vs149412_ (cons _v149408_ _vs149409_))
             (_start149414_
              (fx- (apply fxmin
                          (map std/srfi/160/cvector#c64vector-length
                               _vs149412_))
                   '1)))
        (declare (not safe))
        (let _lp149418_ ((_i149420_ _start149414_))
          (if (fx>= _i149420_ '0)
              (if (apply _pred149407_
                         (map (lambda (_g149421149423_)
                                (std/srfi/160/cvector#c64vector-ref
                                 _g149421149423_
                                 _i149420_))
                              _vs149412_))
                  _i149420_
                  (_lp149418_ (fx- _i149420_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index-right
    (lambda _g299488_
      (let ((_g299487_ (let () (declare (not safe)) (##length _g299488_))))
        (cond ((let () (declare (not safe)) (##fx= _g299487_ 2))
               (apply std/srfi/160/c64#c64vector-index-right__0 _g299488_))
              ((let () (declare (not safe)) (##fx>= _g299487_ 2))
               (apply std/srfi/160/c64#c64vector-index-right__1 _g299488_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-index-right
                _g299488_))))))
  (define std/srfi/160/c64#c64vector-skip__0
    (lambda (_pred149376_ _v149378_)
      (std/srfi/160/c64#c64vector-index__0
       (lambda (_$obj149381_) (not (_pred149376_ _$obj149381_)))
       _v149378_)))
  (define std/srfi/160/c64#c64vector-skip__1
    (lambda (_pred149384_ _v149385_ . _vs149386_)
      (apply std/srfi/160/c64#c64vector-index
             (lambda (_$obj149389_) (not (_pred149384_ _$obj149389_)))
             _v149385_
             _vs149386_)))
  (define std/srfi/160/c64#c64vector-skip
    (lambda _g299490_
      (let ((_g299489_ (let () (declare (not safe)) (##length _g299490_))))
        (cond ((let () (declare (not safe)) (##fx= _g299489_ 2))
               (apply std/srfi/160/c64#c64vector-skip__0 _g299490_))
              ((let () (declare (not safe)) (##fx>= _g299489_ 2))
               (apply std/srfi/160/c64#c64vector-skip__1 _g299490_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-skip
                _g299490_))))))
  (define std/srfi/160/c64#c64vector-skip-right__0
    (lambda (_pred149360_ _v149362_)
      (std/srfi/160/c64#c64vector-index-right__0
       (lambda (_$obj149365_) (not (_pred149360_ _$obj149365_)))
       _v149362_)))
  (define std/srfi/160/c64#c64vector-skip-right__1
    (lambda (_pred149368_ _v149369_ . _vs149370_)
      (apply std/srfi/160/c64#c64vector-index-right
             (lambda (_$obj149373_) (not (_pred149368_ _$obj149373_)))
             _v149369_
             _vs149370_)))
  (define std/srfi/160/c64#c64vector-skip-right
    (lambda _g299492_
      (let ((_g299491_ (let () (declare (not safe)) (##length _g299492_))))
        (cond ((let () (declare (not safe)) (##fx= _g299491_ 2))
               (apply std/srfi/160/c64#c64vector-skip-right__0 _g299492_))
              ((let () (declare (not safe)) (##fx>= _g299491_ 2))
               (apply std/srfi/160/c64#c64vector-skip-right__1 _g299492_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-skip-right
                _g299492_))))))
  (define std/srfi/160/c64#c64vector-any__0
    (lambda (_pred149320_ _v149322_)
      (if (procedure? _pred149320_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149320_))
      (let ((_end149325_ (std/srfi/160/cvector#c64vector-length _v149322_)))
        (declare (not safe))
        (let _lp149329_ ((_i149332_ '0))
          (if (fx< _i149332_ _end149325_)
              (let ((_$e149335_
                     (_pred149320_
                      (std/srfi/160/cvector#c64vector-ref
                       _v149322_
                       _i149332_))))
                (if _$e149335_
                    (values _$e149335_)
                    (_lp149329_ (fx+ _i149332_ '1))))
              '#f)))))
  (define std/srfi/160/c64#c64vector-any__1
    (lambda (_pred149338_ _v149339_ . _vs149340_)
      (if (procedure? _pred149338_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149338_))
      (let* ((_v149343_ (cons _v149339_ _vs149340_))
             (_end149345_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149340_))))
        (declare (not safe))
        (let _lp149349_ ((_i149351_ '0))
          (if (fx< _i149351_ _end149345_)
              (let ((_$e149357_
                     (apply _pred149338_
                            (map (lambda (_g149352149354_)
                                   (std/srfi/160/cvector#c64vector-ref
                                    _g149352149354_
                                    _i149351_))
                                 _vs149340_))))
                (if _$e149357_
                    (values _$e149357_)
                    (_lp149349_ (fx+ _i149351_ '1))))
              '#f)))))
  (define std/srfi/160/c64#c64vector-any
    (lambda _g299494_
      (let ((_g299493_ (let () (declare (not safe)) (##length _g299494_))))
        (cond ((let () (declare (not safe)) (##fx= _g299493_ 2))
               (apply std/srfi/160/c64#c64vector-any__0 _g299494_))
              ((let () (declare (not safe)) (##fx>= _g299493_ 2))
               (apply std/srfi/160/c64#c64vector-any__1 _g299494_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-any
                _g299494_))))))
  (define std/srfi/160/c64#c64vector-every__0
    (lambda (_pred149269_ _v149271_)
      (if (procedure? _pred149269_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149269_))
      (let ((_end149274_ (std/srfi/160/cvector#c64vector-length _v149271_)))
        (declare (not safe))
        (let _lp149278_ ((_i149281_ '0) (_r149283_ '#t))
          (if (fx< _i149281_ _end149274_)
              (let ((_$e149286_
                     (_pred149269_
                      (std/srfi/160/cvector#c64vector-ref
                       _v149271_
                       _i149281_))))
                (if _$e149286_
                    ((lambda (_g149288149290_)
                       (_lp149278_ (fx+ _i149281_ '1) _g149288149290_))
                     _$e149286_)
                    '#f))
              _r149283_)))))
  (define std/srfi/160/c64#c64vector-every__1
    (lambda (_pred149293_ _v149294_ . _vs149295_)
      (if (procedure? _pred149293_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149293_))
      (let* ((_v149298_ (cons _v149294_ _vs149295_))
             (_end149300_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149295_))))
        (declare (not safe))
        (let _lp149304_ ((_i149306_ '0) (_r149307_ '#t))
          (if (fx< _i149306_ _end149300_)
              (let ((_$e149313_
                     (apply _pred149293_
                            (map (lambda (_g149308149310_)
                                   (std/srfi/160/cvector#c64vector-ref
                                    _g149308149310_
                                    _i149306_))
                                 _vs149295_))))
                (if _$e149313_
                    ((lambda (_g149315149317_)
                       (_lp149304_ (fx+ _i149306_ '1) _g149315149317_))
                     _$e149313_)
                    '#f))
              _r149307_)))))
  (define std/srfi/160/c64#c64vector-every
    (lambda _g299496_
      (let ((_g299495_ (let () (declare (not safe)) (##length _g299496_))))
        (cond ((let () (declare (not safe)) (##fx= _g299495_ 2))
               (apply std/srfi/160/c64#c64vector-every__0 _g299496_))
              ((let () (declare (not safe)) (##fx>= _g299495_ 2))
               (apply std/srfi/160/c64#c64vector-every__1 _g299496_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-every
                _g299496_))))))
  (define std/srfi/160/c64#c64vector-partition
    (lambda (_pred149240_ _v149242_)
      (let* ((_count149245_
              (std/srfi/160/c64#c64vector-count__0 _pred149240_ _v149242_))
             (_len149248_ (std/srfi/160/cvector#c64vector-length _v149242_))
             (_u149251_
              (let ((__obj299461
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299461
                 _len149248_)
                __obj299461)))
        (declare (not safe))
        (let _lp149256_ ((_i149259_ '0)
                         (_left149261_ '0)
                         (_right149263_ _count149245_))
          (if (fx< _i149259_ _len149248_)
              (let ((_x149266_
                     (std/srfi/160/cvector#c64vector-ref _v149242_ _i149259_)))
                (if (_pred149240_ _x149266_)
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _u149251_
                       _left149261_
                       _x149266_)
                      (_lp149256_
                       (fx+ _i149259_ '1)
                       (fx+ _left149261_ '1)
                       _right149263_))
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _u149251_
                       _right149263_
                       _x149266_)
                      (_lp149256_
                       (fx+ _i149259_ '1)
                       _left149261_
                       (fx+ _right149263_ '1)))))
              _u149251_)))))
  (define std/srfi/160/c64#c64vector-filter
    (lambda (_pred149213_ _v149215_)
      (let* ((_count149218_
              (std/srfi/160/c64#c64vector-count__0 _pred149213_ _v149215_))
             (_u149221_
              (let ((__obj299462
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299462
                 _count149218_)
                __obj299462))
             (_end149224_ (std/srfi/160/cvector#c64vector-length _v149215_)))
        (declare (not safe))
        (let _lp149229_ ((_i149232_ '0) (_j149234_ '0))
          (if (fx< _i149232_ _end149224_)
              (let ((_x149237_
                     (std/srfi/160/cvector#c64vector-ref _v149215_ _i149232_)))
                (if (_pred149213_ _x149237_)
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _u149221_
                       _j149234_
                       _x149237_)
                      (_lp149229_ (fx+ _i149232_ '1) (fx+ _j149234_ '1)))
                    (_lp149229_ (fx+ _i149232_ '1) _j149234_)))
              _u149221_)))))
  (define std/srfi/160/c64#c64vector-remove
    (lambda (_pred149205_ _v149207_)
      (std/srfi/160/c64#c64vector-filter
       (lambda (_$obj149210_) (not (_pred149205_ _$obj149210_)))
       _v149207_)))
  (define std/srfi/160/c64#c64vector-swap
    (lambda (_v149192_ _i149194_ _j149196_)
      (let ((_iv149199_
             (std/srfi/160/cvector#c64vector-ref _v149192_ _i149194_))
            (_jv149201_
             (std/srfi/160/cvector#c64vector-ref _v149192_ _j149196_)))
        (declare (not safe))
        (begin
          (std/srfi/160/cvector#c64vector-set! _v149192_ _i149194_ _jv149201_)
          (std/srfi/160/cvector#c64vector-set!
           _v149192_
           _j149196_
           _iv149199_)))))
  (define std/srfi/160/c64#c64vector-fill!__%
    (lambda (_v149155_ _fill149157_ _start149159_ _end149161_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149155_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149155_))
        (if (std/srfi/160/base#c64? _fill149157_)
            '#!void
            (error '"Bad argument" _fill149157_))
        (if (and (fixnum? _start149159_)
                 (fx<= '0
                       _start149159_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149155_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149159_))
        (if (and (fixnum? _end149161_)
                 (fx<= _start149159_
                       _end149161_
                       (std/srfi/160/cvector#c64vector-length _v149155_)))
            '#!void
            (error '"Index out of range" _end149161_))
        (let _lp149165_ ((_i149168_ _start149159_))
          (if (fx< _i149168_ _end149161_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _v149155_
                 _i149168_
                 _fill149157_)
                (_lp149165_ (fx+ _i149168_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-fill!__0
    (lambda (_v149174_ _fill149175_)
      (let* ((_start149177_ '0)
             (_end149179_ (std/srfi/160/cvector#c64vector-length _v149174_)))
        (std/srfi/160/c64#c64vector-fill!__%
         _v149174_
         _fill149175_
         _start149177_
         _end149179_))))
  (define std/srfi/160/c64#c64vector-fill!__1
    (lambda (_v149181_ _fill149182_ _start149183_)
      (let ((_end149185_ (std/srfi/160/cvector#c64vector-length _v149181_)))
        (std/srfi/160/c64#c64vector-fill!__%
         _v149181_
         _fill149182_
         _start149183_
         _end149185_))))
  (define std/srfi/160/c64#c64vector-fill!
    (lambda _g299498_
      (let ((_g299497_ (let () (declare (not safe)) (##length _g299498_))))
        (cond ((let () (declare (not safe)) (##fx= _g299497_ 2))
               (apply std/srfi/160/c64#c64vector-fill!__0 _g299498_))
              ((let () (declare (not safe)) (##fx= _g299497_ 3))
               (apply std/srfi/160/c64#c64vector-fill!__1 _g299498_))
              ((let () (declare (not safe)) (##fx= _g299497_ 4))
               (apply std/srfi/160/c64#c64vector-fill!__% _g299498_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-fill!
                _g299498_))))))
  (define std/srfi/160/c64#c64vector-reverse!__%
    (lambda (_v149115_ _start149117_ _end149119_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149115_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149115_))
        (if (and (fixnum? _start149117_)
                 (fx<= '0
                       _start149117_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149115_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149117_))
        (if (and (fixnum? _end149119_)
                 (fx<= _start149117_
                       _end149119_
                       (std/srfi/160/cvector#c64vector-length _v149115_)))
            '#!void
            (error '"Index out of range" _end149119_))
        (let _lp149123_ ((_i149126_ _start149117_)
                         (_j149128_ (fx- _end149119_ '1)))
          (if (fx< _i149126_ _j149128_)
              (let ((_iv149131_
                     (std/srfi/160/cvector#c64vector-ref _v149115_ _i149126_))
                    (_jv149133_
                     (std/srfi/160/cvector#c64vector-ref _v149115_ _j149128_)))
                (std/srfi/160/cvector#c64vector-set!
                 _v149115_
                 _i149126_
                 _jv149133_)
                (std/srfi/160/cvector#c64vector-set!
                 _v149115_
                 _j149128_
                 _iv149131_)
                (_lp149123_ (fx+ _i149126_ '1) (fx- _j149128_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-reverse!__0
    (lambda (_v149139_)
      (let* ((_start149141_ '0)
             (_end149143_ (std/srfi/160/cvector#c64vector-length _v149139_)))
        (std/srfi/160/c64#c64vector-reverse!__%
         _v149139_
         _start149141_
         _end149143_))))
  (define std/srfi/160/c64#c64vector-reverse!__1
    (lambda (_v149145_ _start149146_)
      (let ((_end149148_ (std/srfi/160/cvector#c64vector-length _v149145_)))
        (std/srfi/160/c64#c64vector-reverse!__%
         _v149145_
         _start149146_
         _end149148_))))
  (define std/srfi/160/c64#c64vector-reverse!
    (lambda _g299500_
      (let ((_g299499_ (let () (declare (not safe)) (##length _g299500_))))
        (cond ((let () (declare (not safe)) (##fx= _g299499_ 1))
               (apply std/srfi/160/c64#c64vector-reverse!__0 _g299500_))
              ((let () (declare (not safe)) (##fx= _g299499_ 2))
               (apply std/srfi/160/c64#c64vector-reverse!__1 _g299500_))
              ((let () (declare (not safe)) (##fx= _g299499_ 3))
               (apply std/srfi/160/c64#c64vector-reverse!__% _g299500_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-reverse!
                _g299500_))))))
  (define std/srfi/160/c64#c64vector-unfold!
    (lambda (_f149090_ _v149092_ _start149094_ _end149096_ _seed149098_)
      (declare (not safe))
      (begin
        (if (procedure? _f149090_)
            '#!void
            (error '"Bad argument; expected procedure" _f149090_))
        (if (##structure-direct-instance-of?
             _v149092_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149092_))
        (if (and (fixnum? _start149094_)
                 (fx<= '0
                       _start149094_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149092_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149094_))
        (if (and (fixnum? _end149096_)
                 (fx<= _start149094_
                       _end149096_
                       (std/srfi/160/cvector#c64vector-length _v149092_)))
            '#!void
            (error '"Index out of range" _end149096_))
        (let _lp149102_ ((_i149105_ _start149094_)
                         (_state149107_ _seed149098_))
          (if (fx< _i149105_ _end149096_)
              (let ((_g299501_ (_f149090_ _state149107_)))
                (begin
                  (let ((_g299502_
                         (if (##values? _g299501_)
                             (##vector-length _g299501_)
                             1)))
                    (if (not (##fx= _g299502_ 2))
                        (error "Context expects 2 values" _g299502_)))
                  (let ((_x149110_ (##vector-ref _g299501_ 0))
                        (_state149112_ (##vector-ref _g299501_ 1)))
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _v149092_
                       _i149105_
                       _x149110_)
                      (_lp149102_ (fx+ _i149105_ '1) _state149112_)))))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-unfold-right!
    (lambda (_f149066_ _v149068_ _start149070_ _end149072_ _seed149074_)
      (declare (not safe))
      (begin
        (if (procedure? _f149066_)
            '#!void
            (error '"Bad argument; expected procedure" _f149066_))
        (if (##structure-direct-instance-of?
             _v149068_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149068_))
        (if (and (fixnum? _start149070_)
                 (fx<= '0
                       _start149070_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149068_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149070_))
        (if (and (fixnum? _end149072_)
                 (fx<= _start149070_
                       _end149072_
                       (std/srfi/160/cvector#c64vector-length _v149068_)))
            '#!void
            (error '"Index out of range" _end149072_))
        (let _lp149078_ ((_i149081_ (fx- _end149072_ '1))
                         (_state149083_ _seed149074_))
          (if (fx>= _i149081_ _start149070_)
              (let ((_g299503_ (_f149066_ _state149083_)))
                (begin
                  (let ((_g299504_
                         (if (##values? _g299503_)
                             (##vector-length _g299503_)
                             1)))
                    (if (not (##fx= _g299504_ 2))
                        (error "Context expects 2 values" _g299504_)))
                  (let ((_x149086_ (##vector-ref _g299503_ 0))
                        (_state149088_ (##vector-ref _g299503_ 1)))
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _v149068_
                       _i149081_
                       _x149086_)
                      (_lp149078_ (fx- _i149081_ '1) _state149088_)))))
              '#!void)))))
  (define std/srfi/160/c64#reverse-c64vector->list__%
    (lambda (_v149032_ _start149034_ _end149036_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149032_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149032_))
        (if (and (fixnum? _start149034_)
                 (fx<= '0
                       _start149034_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149032_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149034_))
        (if (and (fixnum? _end149036_)
                 (fx<= _start149034_
                       _end149036_
                       (std/srfi/160/cvector#c64vector-length _v149032_)))
            '#!void
            (error '"Index out of range" _end149036_))
        (let _lp149040_ ((_i149043_ _start149034_) (_r149045_ '()))
          (if (fx< _i149043_ _end149036_)
              (_lp149040_
               (fx+ _i149043_ '1)
               (cons (std/srfi/160/cvector#c64vector-ref _v149032_ _i149043_)
                     _r149045_))
              _r149045_)))))
  (define std/srfi/160/c64#reverse-c64vector->list__0
    (lambda (_v149051_)
      (let* ((_start149053_ '0)
             (_end149055_ (std/srfi/160/cvector#c64vector-length _v149051_)))
        (std/srfi/160/c64#reverse-c64vector->list__%
         _v149051_
         _start149053_
         _end149055_))))
  (define std/srfi/160/c64#reverse-c64vector->list__1
    (lambda (_v149057_ _start149058_)
      (let ((_end149060_ (std/srfi/160/cvector#c64vector-length _v149057_)))
        (std/srfi/160/c64#reverse-c64vector->list__%
         _v149057_
         _start149058_
         _end149060_))))
  (define std/srfi/160/c64#reverse-c64vector->list
    (lambda _g299506_
      (let ((_g299505_ (let () (declare (not safe)) (##length _g299506_))))
        (cond ((let () (declare (not safe)) (##fx= _g299505_ 1))
               (apply std/srfi/160/c64#reverse-c64vector->list__0 _g299506_))
              ((let () (declare (not safe)) (##fx= _g299505_ 2))
               (apply std/srfi/160/c64#reverse-c64vector->list__1 _g299506_))
              ((let () (declare (not safe)) (##fx= _g299505_ 3))
               (apply std/srfi/160/c64#reverse-c64vector->list__% _g299506_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#reverse-c64vector->list
                _g299506_))))))
  (define std/srfi/160/c64#reverse-list->c64vector
    (lambda (_lst148978_)
      (let* ((_len148981_ (length _lst148978_))
             (_v148984_
              (let ((__obj299463
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299463
                 _len148981_)
                __obj299463)))
        (declare (not safe))
        (let _lp148989_ ((_rest148992_ _lst148978_) (_i148994_ '0))
          (let* ((_rest148996149004_ _rest148992_)
                 (_else148998149012_ (lambda () _v148984_))
                 (_K149000149019_
                  (lambda (_rest149015_ _x149016_)
                    (if (std/srfi/160/base#c64? _x149016_)
                        '#!void
                        (error '"Bad element" _x149016_))
                    (std/srfi/160/cvector#c64vector-set!
                     _v148984_
                     _i148994_
                     _x149016_)
                    (_lp148989_ _rest149015_ (fx+ _i148994_ '1)))))
            (if (##pair? _rest148996149004_)
                (let ((_hd149001149022_ (##car _rest148996149004_))
                      (_tl149002149024_ (##cdr _rest148996149004_)))
                  (let* ((_x149027_ _hd149001149022_)
                         (_rest149029_ _tl149002149024_))
                    (_K149000149019_ _rest149029_ _x149027_)))
                (_else148998149012_)))))))
  (define std/srfi/160/c64#c64vector->vector__%
    (lambda (_v148939_ _start148941_ _end148943_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v148939_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v148939_))
        (if (and (fixnum? _start148941_)
                 (fx<= '0
                       _start148941_
                       (fx- (std/srfi/160/cvector#c64vector-length _v148939_)
                            '1)))
            '#!void
            (error '"Index out of range" _start148941_))
        (if (and (fixnum? _end148943_)
                 (fx<= _start148941_
                       _end148943_
                       (std/srfi/160/cvector#c64vector-length _v148939_)))
            '#!void
            (error '"Index out of range" _end148943_))
        (let* ((_len148947_ (std/srfi/160/cvector#c64vector-length _v148939_))
               (_u148950_ (make-vector _len148947_)))
          (let _lp148954_ ((_i148957_ '0))
            (if (fx< _i148957_ _len148947_)
                (begin
                  (vector-set!
                   _u148950_
                   _i148957_
                   (std/srfi/160/cvector#c64vector-ref _v148939_ _i148957_))
                  (_lp148954_ (fx+ _i148957_ '1)))
                _u148950_))))))
  (define std/srfi/160/c64#c64vector->vector__0
    (lambda (_v148963_)
      (let* ((_start148965_ '0)
             (_end148967_ (std/srfi/160/cvector#c64vector-length _v148963_)))
        (std/srfi/160/c64#c64vector->vector__%
         _v148963_
         _start148965_
         _end148967_))))
  (define std/srfi/160/c64#c64vector->vector__1
    (lambda (_v148969_ _start148970_)
      (let ((_end148972_ (std/srfi/160/cvector#c64vector-length _v148969_)))
        (std/srfi/160/c64#c64vector->vector__%
         _v148969_
         _start148970_
         _end148972_))))
  (define std/srfi/160/c64#c64vector->vector
    (lambda _g299508_
      (let ((_g299507_ (let () (declare (not safe)) (##length _g299508_))))
        (cond ((let () (declare (not safe)) (##fx= _g299507_ 1))
               (apply std/srfi/160/c64#c64vector->vector__0 _g299508_))
              ((let () (declare (not safe)) (##fx= _g299507_ 2))
               (apply std/srfi/160/c64#c64vector->vector__1 _g299508_))
              ((let () (declare (not safe)) (##fx= _g299507_ 3))
               (apply std/srfi/160/c64#c64vector->vector__% _g299508_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector->vector
                _g299508_))))))
  (define std/srfi/160/c64#vector->c64vector__%
    (lambda (_v148899_ _start148901_ _end148903_)
      (declare (not safe))
      (begin
        (if (vector? _v148899_)
            '#!void
            (error '"Bad argument; expected vector" _v148899_))
        (if (and (fixnum? _start148901_)
                 (fx<= '0 _start148901_ (fx- (vector-length _v148899_) '1)))
            '#!void
            (error '"Index out of range" _start148901_))
        (if (and (fixnum? _end148903_)
                 (fx<= _start148901_ _end148903_ (vector-length _v148899_)))
            '#!void
            (error '"Index out of range" _end148903_))
        (let* ((_len148907_ (vector-length _v148899_))
               (_u148910_
                (let ((__obj299464
                       (make-object std/srfi/160/cvector#c64vector::t '1)))
                  (std/srfi/160/cvector#c64vector:::init!__0
                   __obj299464
                   _len148907_)
                  __obj299464)))
          (let _lp148914_ ((_i148917_ '0))
            (if (fx< _i148917_ _len148907_)
                (begin
                  (std/srfi/160/cvector#c64vector-set!
                   _u148910_
                   _i148917_
                   (vector-ref _v148899_ _i148917_))
                  (_lp148914_ (fx+ _i148917_ '1)))
                _u148910_))))))
  (define std/srfi/160/c64#vector->c64vector__0
    (lambda (_v148923_)
      (let* ((_start148925_ '0) (_end148927_ (vector-length _v148923_)))
        (std/srfi/160/c64#vector->c64vector__%
         _v148923_
         _start148925_
         _end148927_))))
  (define std/srfi/160/c64#vector->c64vector__1
    (lambda (_v148929_ _start148930_)
      (let ((_end148932_ (vector-length _v148929_)))
        (std/srfi/160/c64#vector->c64vector__%
         _v148929_
         _start148930_
         _end148932_))))
  (define std/srfi/160/c64#vector->c64vector
    (lambda _g299510_
      (let ((_g299509_ (let () (declare (not safe)) (##length _g299510_))))
        (cond ((let () (declare (not safe)) (##fx= _g299509_ 1))
               (apply std/srfi/160/c64#vector->c64vector__0 _g299510_))
              ((let () (declare (not safe)) (##fx= _g299509_ 2))
               (apply std/srfi/160/c64#vector->c64vector__1 _g299510_))
              ((let () (declare (not safe)) (##fx= _g299509_ 3))
               (apply std/srfi/160/c64#vector->c64vector__% _g299510_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#vector->c64vector
                _g299510_))))))
  (define std/srfi/160/c64#make-c64vector-generator__%
    (lambda (_v148865_ _start148867_ _end148869_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v148865_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v148865_))
        (if (and (fixnum? _start148867_)
                 (fx<= '0
                       _start148867_
                       (fx- (std/srfi/160/cvector#c64vector-length _v148865_)
                            '1)))
            '#!void
            (error '"Index out of range" _start148867_))
        (if (and (fixnum? _end148869_)
                 (fx<= _start148867_
                       _end148869_
                       (std/srfi/160/cvector#c64vector-length _v148865_)))
            '#!void
            (error '"Index out of range" _end148869_))
        (let ((_i148873_ _start148867_))
          (lambda ()
            (if (fx< _i148873_ _end148869_)
                (let ((_next148877_
                       (std/srfi/160/cvector#c64vector-ref
                        _v148865_
                        _i148873_)))
                  (set! _i148873_ (fx+ _i148873_ '1))
                  _next148877_)
                '#!eof))))))
  (define std/srfi/160/c64#make-c64vector-generator__0
    (lambda (_v148883_)
      (let* ((_start148885_ '0)
             (_end148887_ (std/srfi/160/cvector#c64vector-length _v148883_)))
        (std/srfi/160/c64#make-c64vector-generator__%
         _v148883_
         _start148885_
         _end148887_))))
  (define std/srfi/160/c64#make-c64vector-generator__1
    (lambda (_v148889_ _start148890_)
      (let ((_end148892_ (std/srfi/160/cvector#c64vector-length _v148889_)))
        (std/srfi/160/c64#make-c64vector-generator__%
         _v148889_
         _start148890_
         _end148892_))))
  (define std/srfi/160/c64#make-c64vector-generator
    (lambda _g299512_
      (let ((_g299511_ (let () (declare (not safe)) (##length _g299512_))))
        (cond ((let () (declare (not safe)) (##fx= _g299511_ 1))
               (apply std/srfi/160/c64#make-c64vector-generator__0 _g299512_))
              ((let () (declare (not safe)) (##fx= _g299511_ 2))
               (apply std/srfi/160/c64#make-c64vector-generator__1 _g299512_))
              ((let () (declare (not safe)) (##fx= _g299511_ 3))
               (apply std/srfi/160/c64#make-c64vector-generator__% _g299512_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#make-c64vector-generator
                _g299512_))))))
  (define std/srfi/160/c64#c64vector-comparator
    (let ()
      (letrec ((_<?148836_
                (lambda (_a148839_ _b148841_)
                  (let ((_len-a148844_
                         (std/srfi/160/cvector#c64vector-length _a148839_))
                        (_len-b148846_
                         (std/srfi/160/cvector#c64vector-length _b148841_)))
                    (declare (not safe))
                    (if (fx< _len-a148844_ _len-b148846_)
                        '#t
                        (if (fx> _len-a148844_ _len-b148846_)
                            '#f
                            (let ((_end148850_ _len-a148844_))
                              (let _lp148853_ ((_i148856_ '0))
                                (if (fx< _i148856_ _end148850_)
                                    (let ((_x148859_
                                           (std/srfi/160/cvector#c64vector-ref
                                            _a148839_
                                            _i148856_))
                                          (_y148861_
                                           (std/srfi/160/cvector#c64vector-ref
                                            _b148841_
                                            _i148856_)))
                                      (if (< _x148859_ _y148861_)
                                          '#t
                                          (if (> _x148859_ _y148861_)
                                              '#f
                                              (_lp148853_
                                               (fx+ _i148856_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           std/srfi/160/cvector#c64vector?
           std/srfi/160/c64#c64vector=
           _<?148836_
           equal?-hash)))))
  (define std/srfi/160/c64#write-c64vector__%
    (lambda (_v148813_ _port148815_)
      (let ((_$e148818_ (find-method _v148813_ ':write)))
        (if _$e148818_
            ((lambda (_g148820148822_)
               (_g148820148822_ _v148813_ _port148815_))
             _$e148818_)
            (write _v148813_ (current-output-port))))))
  (define std/srfi/160/c64#write-c64vector__0
    (lambda (_v148828_)
      (let ((_port148830_ (current-output-port)))
        (std/srfi/160/c64#write-c64vector__% _v148828_ _port148830_))))
  (define std/srfi/160/c64#write-c64vector
    (lambda _g299514_
      (let ((_g299513_ (let () (declare (not safe)) (##length _g299514_))))
        (cond ((let () (declare (not safe)) (##fx= _g299513_ 1))
               (apply std/srfi/160/c64#write-c64vector__0 _g299514_))
              ((let () (declare (not safe)) (##fx= _g299513_ 2))
               (apply std/srfi/160/c64#write-c64vector__% _g299514_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#write-c64vector
                _g299514_)))))))
