(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/cvector#c64vector::t
    (make-struct-type
     'std/srfi/160/cvector#c64vector::t
     '#f
     '1
     'c64vector
     '((equal: e) (final: . #t))
     ':init!
     '(e)))
  (define std/srfi/160/cvector#c64vector?
    (make-struct-predicate std/srfi/160/cvector#c64vector::t))
  (define std/srfi/160/cvector#make-c64vector
    (lambda _$args128033_
      (apply make-struct-instance
             std/srfi/160/cvector#c64vector::t
             _$args128033_)))
  (define std/srfi/160/cvector#c64vector-e
    (make-struct-field-accessor std/srfi/160/cvector#c64vector::t '0))
  (define std/srfi/160/cvector#c64vector-e-set!
    (make-struct-field-mutator std/srfi/160/cvector#c64vector::t '0))
  (define std/srfi/160/cvector#&c64vector-e
    (make-struct-field-unchecked-accessor
     std/srfi/160/cvector#c64vector::t
     '0))
  (define std/srfi/160/cvector#&c64vector-e-set!
    (make-struct-field-unchecked-mutator std/srfi/160/cvector#c64vector::t '0))
  (define std/srfi/160/cvector#c128vector::t
    (make-struct-type
     'std/srfi/160/cvector#c128vector::t
     '#f
     '1
     'c128vector
     '((equal: e) (final: . #t))
     'init!
     '(e)))
  (define std/srfi/160/cvector#c128vector?
    (make-struct-predicate std/srfi/160/cvector#c128vector::t))
  (define std/srfi/160/cvector#make-c128vector
    (lambda _$args128030_
      (apply make-struct-instance
             std/srfi/160/cvector#c128vector::t
             _$args128030_)))
  (define std/srfi/160/cvector#c128vector-e
    (make-struct-field-accessor std/srfi/160/cvector#c128vector::t '0))
  (define std/srfi/160/cvector#c128vector-e-set!
    (make-struct-field-mutator std/srfi/160/cvector#c128vector::t '0))
  (define std/srfi/160/cvector#&c128vector-e
    (make-struct-field-unchecked-accessor
     std/srfi/160/cvector#c128vector::t
     '0))
  (define std/srfi/160/cvector#&c128vector-e-set!
    (make-struct-field-unchecked-mutator
     std/srfi/160/cvector#c128vector::t
     '0))
  (define std/srfi/160/cvector#c64vector:::init!__%
    (lambda (_self128012_ _size128013_ _fill128014_)
      (let ((_e128016_ (make-f32vector (fx* '2 _size128013_))))
        (if (let ((__tmp290036
                   (let ()
                     (declare (not safe))
                     (##vector-length _self128012_))))
              (declare (not safe))
              (##fx< '1 __tmp290036))
            (let ()
              (declare (not safe))
              (##vector-set! _self128012_ '1 _e128016_))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self128012_))
        (if _fill128014_
            (begin
              (if (complex? _fill128014_)
                  '#!void
                  (error '"Bad argument; expected complex number"
                         _fill128014_))
              (std/srfi/160/cvector#cvector-fill!
               _e128016_
               _fill128014_
               ##f32vector-set!
               _size128013_))
            '#!void))))
  (define std/srfi/160/cvector#c64vector:::init!__0
    (lambda (_self128021_ _size128022_)
      (let ((_fill128024_ '#f))
        (std/srfi/160/cvector#c64vector:::init!__%
         _self128021_
         _size128022_
         _fill128024_))))
  (define std/srfi/160/cvector#c64vector:::init!
    (lambda _g290038_
      (let ((_g290037_ (let () (declare (not safe)) (##length _g290038_))))
        (cond ((let () (declare (not safe)) (##fx= _g290037_ 2))
               (apply std/srfi/160/cvector#c64vector:::init!__0 _g290038_))
              ((let () (declare (not safe)) (##fx= _g290037_ 3))
               (apply std/srfi/160/cvector#c64vector:::init!__% _g290038_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/cvector#c64vector:::init!
                _g290038_))))))
  (bind-method!
   std/srfi/160/cvector#c64vector::t
   ':init!
   std/srfi/160/cvector#c64vector:::init!
   '#f)
  (define std/srfi/160/cvector#c128vector:::init!__%
    (lambda (_self127871_ _size127872_ _fill127873_)
      (let ((_e127875_ (make-f64vector (fx* '2 _size127872_))))
        (if (let ((__tmp290039
                   (let ()
                     (declare (not safe))
                     (##vector-length _self127871_))))
              (declare (not safe))
              (##fx< '1 __tmp290039))
            (let ()
              (declare (not safe))
              (##vector-set! _self127871_ '1 _e127875_))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self127871_))
        (if _fill127873_
            (begin
              (if (complex? _fill127873_)
                  '#!void
                  (error '"Bad argument; expected complex number"
                         _fill127873_))
              (std/srfi/160/cvector#cvector-fill!
               _e127875_
               _fill127873_
               ##f64vector-set!
               _size127872_))
            '#!void))))
  (define std/srfi/160/cvector#c128vector:::init!__0
    (lambda (_self127880_ _size127881_)
      (let ((_fill127883_ '#f))
        (std/srfi/160/cvector#c128vector:::init!__%
         _self127880_
         _size127881_
         _fill127883_))))
  (define std/srfi/160/cvector#c128vector:::init!
    (lambda _g290041_
      (let ((_g290040_ (let () (declare (not safe)) (##length _g290041_))))
        (cond ((let () (declare (not safe)) (##fx= _g290040_ 2))
               (apply std/srfi/160/cvector#c128vector:::init!__0 _g290041_))
              ((let () (declare (not safe)) (##fx= _g290040_ 3))
               (apply std/srfi/160/cvector#c128vector:::init!__% _g290041_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/cvector#c128vector:::init!
                _g290041_))))))
  (bind-method!
   std/srfi/160/cvector#c128vector::t
   ':init!
   std/srfi/160/cvector#c128vector:::init!
   '#f)
  (define std/srfi/160/cvector#cvector-fill!
    (lambda (_v127732_ _fill127733_ _set-e127734_ _size127735_)
      (declare (not safe))
      (let ((_real127738_ (inexact (real-part _fill127733_)))
            (_imag127739_ (inexact (imag-part _fill127733_))))
        (let _$loop127741_ ((_i127744_ '0))
          (if (fx= _i127744_ _size127735_)
              '#!void
              (begin
                (let ((_j127746_ (fx* _i127744_ '2)))
                  (_set-e127734_ _v127732_ _j127746_ _real127738_)
                  (_set-e127734_ _v127732_ (fx+ _j127746_ '1) _imag127739_))
                (_$loop127741_ (fx+ _i127744_ '1))))))))
  (define std/srfi/160/cvector#make-c64vector*
    (lambda _args127730_ (std/srfi/160/cvector#list->c64vector _args127730_)))
  (define std/srfi/160/cvector#make-c128vector*
    (lambda _args127728_ (std/srfi/160/cvector#list->c128vector _args127728_)))
  (define std/srfi/160/cvector#list->c64vector
    (lambda (_lst127724_)
      (let ((_v127726_
             (let ((__obj290035
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj290035
                (length _lst127724_))
               __obj290035)))
        (std/srfi/160/cvector#cvector-init!
         (let ()
           (declare (not safe))
           (##unchecked-structure-ref
            _v127726_
            '1
            std/srfi/160/cvector#c64vector::t
            '#f))
         _lst127724_
         ##f32vector-set!)
        _v127726_)))
  (define std/srfi/160/cvector#list->c128vector
    (lambda (_lst127720_)
      (let ((_v127722_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              (length _lst127720_))))
        (std/srfi/160/cvector#cvector-init!
         (let ()
           (declare (not safe))
           (##unchecked-structure-ref
            _v127722_
            '1
            std/srfi/160/cvector#c128vector::t
            '#f))
         _lst127720_
         ##f64vector-set!)
        _v127722_)))
  (define std/srfi/160/cvector#cvector-init!
    (lambda (_v127674_ _lst127675_ _set-e127676_)
      (declare (not safe))
      (let _lp127679_ ((_rest127681_ _lst127675_) (_i127682_ '0))
        (let* ((_rest127683127691_ _rest127681_)
               (_else127685127699_ (lambda () '#!void))
               (_K127687127708_
                (lambda (_rest127702_ _x127703_)
                  (if (complex? _x127703_)
                      '#!void
                      (error '"Expected complex number" _x127703_))
                  (let ((_real127705_ (inexact (real-part _x127703_)))
                        (_imag127706_ (inexact (imag-part _x127703_))))
                    (_set-e127676_ _v127674_ _i127682_ _real127705_)
                    (_set-e127676_ _v127674_ (fx+ _i127682_ '1) _imag127706_)
                    (_lp127679_ _rest127702_ (fx+ _i127682_ '2))))))
          (if (##pair? _rest127683127691_)
              (let ((_hd127688127711_ (##car _rest127683127691_))
                    (_tl127689127713_ (##cdr _rest127683127691_)))
                (let* ((_x127716_ _hd127688127711_)
                       (_rest127718_ _tl127689127713_))
                  (_K127687127708_ _rest127718_ _x127716_)))
              '#!void)))))
  (define std/srfi/160/cvector#c64vector-ref
    (lambda (_v127642_ _i127643_)
      (let* ((_v127644127650_ _v127642_)
             (_E127646127654_
              (lambda () (error '"No clause matching" _v127644127650_)))
             (_K127647127666_
              (lambda (_e127657_)
                (let* ((_j127659_ (fx* _i127643_ '2))
                       (_real127661_ (f32vector-ref _e127657_ _j127659_))
                       (_imag127663_
                        (f32vector-ref _e127657_ (fx+ _j127659_ '1))))
                  (let ()
                    (declare (not safe))
                    (##cpxnum-make _real127661_ _imag127663_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127644127650_
               'std/srfi/160/cvector#c64vector::t))
            (let* ((_e127648127669_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127644127650_ '1)))
                   (_e127672_ _e127648127669_))
              (_K127647127666_ _e127672_))
            (_E127646127654_)))))
  (define std/srfi/160/cvector#c64vector-set!
    (lambda (_v127609_ _i127610_ _x127611_)
      (let* ((_v127612127618_ _v127609_)
             (_E127614127622_
              (lambda () (error '"No clause matching" _v127612127618_)))
             (_K127615127634_
              (lambda (_e127625_)
                (let* ((_j127627_ (fx* _i127610_ '2))
                       (_real127629_ (inexact (real-part _x127611_)))
                       (_imag127631_ (inexact (imag-part _x127611_))))
                  (f32vector-set! _e127625_ _j127627_ _real127629_)
                  (f32vector-set!
                   _e127625_
                   (fx+ _j127627_ '1)
                   _imag127631_)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127612127618_
               'std/srfi/160/cvector#c64vector::t))
            (let* ((_e127616127637_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127612127618_ '1)))
                   (_e127640_ _e127616127637_))
              (_K127615127634_ _e127640_))
            (_E127614127622_)))))
  (define std/srfi/160/cvector#c128vector-ref
    (lambda (_v127577_ _i127578_)
      (let* ((_v127579127585_ _v127577_)
             (_E127581127589_
              (lambda () (error '"No clause matching" _v127579127585_)))
             (_K127582127601_
              (lambda (_e127592_)
                (let* ((_j127594_ (fx* _i127578_ '2))
                       (_real127596_ (f64vector-ref _e127592_ _j127594_))
                       (_imag127598_
                        (f64vector-ref _e127592_ (fx+ _j127594_ '1))))
                  (let ()
                    (declare (not safe))
                    (##cpxnum-make _real127596_ _imag127598_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127579127585_
               'std/srfi/160/cvector#c128vector::t))
            (let* ((_e127583127604_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127579127585_ '1)))
                   (_e127607_ _e127583127604_))
              (_K127582127601_ _e127607_))
            (_E127581127589_)))))
  (define std/srfi/160/cvector#c128vector-set!
    (lambda (_v127544_ _i127545_ _x127546_)
      (let* ((_v127547127553_ _v127544_)
             (_E127549127557_
              (lambda () (error '"No clause matching" _v127547127553_)))
             (_K127550127569_
              (lambda (_e127560_)
                (let* ((_j127562_ (fx* _i127545_ '2))
                       (_real127564_ (inexact (real-part _x127546_)))
                       (_imag127566_ (inexact (imag-part _x127546_))))
                  (f64vector-set! _e127560_ _j127562_ _real127564_)
                  (f64vector-set!
                   _e127560_
                   (fx+ _j127562_ '1)
                   _imag127566_)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127547127553_
               'std/srfi/160/cvector#c128vector::t))
            (let* ((_e127551127572_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127547127553_ '1)))
                   (_e127575_ _e127551127572_))
              (_K127550127569_ _e127575_))
            (_E127549127557_)))))
  (define std/srfi/160/cvector#c64vector-length
    (lambda (_v127520_)
      (let* ((_v127521127527_ _v127520_)
             (_E127523127531_
              (lambda () (error '"No clause matching" _v127521127527_)))
             (_K127524127536_
              (lambda (_e127534_)
                (let ((__tmp290042
                       (let ()
                         (declare (not safe))
                         (##f32vector-length _e127534_))))
                  (declare (not safe))
                  (##fxquotient __tmp290042 '2)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127521127527_
               'std/srfi/160/cvector#c64vector::t))
            (let* ((_e127525127539_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127521127527_ '1)))
                   (_e127542_ _e127525127539_))
              (_K127524127536_ _e127542_))
            (_E127523127531_)))))
  (define std/srfi/160/cvector#c128vector-length
    (lambda (_v127496_)
      (let* ((_v127497127503_ _v127496_)
             (_E127499127507_
              (lambda () (error '"No clause matching" _v127497127503_)))
             (_K127500127512_
              (lambda (_e127510_)
                (let ((__tmp290043
                       (let ()
                         (declare (not safe))
                         (##f64vector-length _e127510_))))
                  (declare (not safe))
                  (##fxquotient __tmp290043 '2)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127497127503_
               'std/srfi/160/cvector#c128vector::t))
            (let* ((_e127501127515_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127497127503_ '1)))
                   (_e127518_ _e127501127515_))
              (_K127500127512_ _e127518_))
            (_E127499127507_)))))
  (define std/srfi/160/cvector#c64vector->list
    (lambda (_v127472_)
      (let* ((_v127473127479_ _v127472_)
             (_E127475127483_
              (lambda () (error '"No clause matching" _v127473127479_)))
             (_K127476127488_
              (lambda (_e127486_)
                (std/srfi/160/cvector#cvector->list
                 _e127486_
                 ##f32vector-ref
                 ##f32vector-length))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127473127479_
               'std/srfi/160/cvector#c64vector::t))
            (let* ((_e127477127491_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127473127479_ '1)))
                   (_e127494_ _e127477127491_))
              (_K127476127488_ _e127494_))
            (_E127475127483_)))))
  (define std/srfi/160/cvector#c128vector->list
    (lambda (_v127448_)
      (let* ((_v127449127455_ _v127448_)
             (_E127451127459_
              (lambda () (error '"No clause matching" _v127449127455_)))
             (_K127452127464_
              (lambda (_e127462_)
                (std/srfi/160/cvector#cvector->list
                 _e127462_
                 ##f64vector-ref
                 ##f64vector-length))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _v127449127455_
               'std/srfi/160/cvector#c128vector::t))
            (let* ((_e127453127467_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _v127449127455_ '1)))
                   (_e127470_ _e127453127467_))
              (_K127452127464_ _e127470_))
            (_E127451127459_)))))
  (define std/srfi/160/cvector#cvector->list
    (lambda (_v127434_ _ref-e127435_ _length-e127436_)
      (declare (not safe))
      (letrec* ((_end127438_ (_length-e127436_ _v127434_)))
        (let _lp127440_ ((_i127442_ '0) (_r127443_ '()))
          (if (fx< _i127442_ _end127438_)
              (let ((_real127445_ (_ref-e127435_ _v127434_ _i127442_))
                    (_imag127446_
                     (_ref-e127435_ _v127434_ (fx+ _i127442_ '1))))
                (_lp127440_
                 (fx+ _i127442_ '2)
                 (cons (##cpxnum-make _real127445_ _imag127446_) _r127443_)))
              (reverse _r127443_))))))
  (define std/srfi/160/cvector#c64vector:::write
    (lambda (_self127429_ _port127430_)
      (let ((_lst127432_ (std/srfi/160/cvector#c64vector->list _self127429_)))
        (write '"#c64" _port127430_)
        (write _lst127432_ _port127430_))))
  (bind-method!
   std/srfi/160/cvector#c64vector::t
   ':write
   std/srfi/160/cvector#c64vector:::write
   '#f)
  (define std/srfi/160/cvector#c128vector:::write
    (lambda (_self127302_ _port127303_)
      (let ((_lst127305_ (std/srfi/160/cvector#c128vector->list _self127302_)))
        (write '"#c128" _port127303_)
        (write _lst127305_ _port127303_))))
  (bind-method!
   std/srfi/160/cvector#c128vector::t
   ':write
   std/srfi/160/cvector#c128vector:::write
   '#f))
