(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/s32#s32vector-unfold
    (lambda (_f143081_ _len143083_ _seed143085_)
      (declare (not safe))
      (begin
        (if (procedure? _f143081_)
            '#!void
            (error '"Bad argument; expected procedure" _f143081_))
        (let ((_v143089_ (make-s32vector _len143083_)))
          (let _lp143092_ ((_i143095_ '0) (_state143097_ _seed143085_))
            (if (fx< _i143095_ _len143083_)
                (let ((_g299198_ (_f143081_ _i143095_ _state143097_)))
                  (begin
                    (let ((_g299199_
                           (if (##values? _g299198_)
                               (##vector-length _g299198_)
                               1)))
                      (if (not (##fx= _g299199_ 2))
                          (error "Context expects 2 values" _g299199_)))
                    (let ((_x143100_ (##vector-ref _g299198_ 0))
                          (_state143102_ (##vector-ref _g299198_ 1)))
                      (begin
                        (if (std/srfi/160/base#s32? _x143100_)
                            '#!void
                            (error '"Bad generated value" _x143100_))
                        (s32vector-set! _v143089_ _i143095_ _x143100_)
                        (_lp143092_ (fx+ _i143095_ '1) _state143102_)))))
                _v143089_))))))
  (define std/srfi/160/s32#s32vector-unfold-right
    (lambda (_f143058_ _len143060_ _seed143062_)
      (declare (not safe))
      (begin
        (if (procedure? _f143058_)
            '#!void
            (error '"Bad argument; expected procedure" _f143058_))
        (let ((_v143066_ (make-s32vector _len143060_)))
          (let _lp143069_ ((_i143072_ (fx- _len143060_ '1))
                           (_state143074_ _seed143062_))
            (if (fx>= _i143072_ '0)
                (let ((_g299200_ (_f143058_ _i143072_ _state143074_)))
                  (begin
                    (let ((_g299201_
                           (if (##values? _g299200_)
                               (##vector-length _g299200_)
                               1)))
                      (if (not (##fx= _g299201_ 2))
                          (error "Context expects 2 values" _g299201_)))
                    (let ((_x143077_ (##vector-ref _g299200_ 0))
                          (_state143079_ (##vector-ref _g299200_ 1)))
                      (begin
                        (if (std/srfi/160/base#s32? _x143077_)
                            '#!void
                            (error '"Bad generated value" _x143077_))
                        (s32vector-set! _v143066_ _i143072_ _x143077_)
                        (_lp143069_ (fx- _i143072_ '1) _state143079_)))))
                _v143066_))))))
  (define std/srfi/160/s32#s32vector-copy__%
    (lambda (_vec143030_ _start143032_ _end143034_)
      (let ((_v143037_ (make-s32vector (fx- _end143034_ _start143032_))))
        (std/srfi/160/s32#s32vector-copy!
         _v143037_
         '0
         _vec143030_
         _start143032_
         _end143034_)
        _v143037_)))
  (define std/srfi/160/s32#s32vector-copy__0
    (lambda (_vec143043_)
      (let* ((_start143045_ '0) (_end143047_ (s32vector-length _vec143043_)))
        (std/srfi/160/s32#s32vector-copy__%
         _vec143043_
         _start143045_
         _end143047_))))
  (define std/srfi/160/s32#s32vector-copy__1
    (lambda (_vec143049_ _start143050_)
      (let ((_end143052_ (s32vector-length _vec143049_)))
        (std/srfi/160/s32#s32vector-copy__%
         _vec143049_
         _start143050_
         _end143052_))))
  (define std/srfi/160/s32#s32vector-copy
    (lambda _g299203_
      (let ((_g299202_ (let () (declare (not safe)) (##length _g299203_))))
        (cond ((let () (declare (not safe)) (##fx= _g299202_ 1))
               (apply std/srfi/160/s32#s32vector-copy__0 _g299203_))
              ((let () (declare (not safe)) (##fx= _g299202_ 2))
               (apply std/srfi/160/s32#s32vector-copy__1 _g299203_))
              ((let () (declare (not safe)) (##fx= _g299202_ 3))
               (apply std/srfi/160/s32#s32vector-copy__% _g299203_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-copy
                _g299203_))))))
  (define std/srfi/160/s32#s32vector-copy!
    (lambda (_to143009_ _at143011_ _from143013_ _start143015_ _end143017_)
      (declare (not safe))
      (begin
        (if (s32vector? _to143009_) '#!void (error '"Bad argument" _to143009_))
        (if (s32vector? _from143013_)
            '#!void
            (error '"Bad argument" _from143013_))
        (if (and (fixnum? _at143011_)
                 (fx<= '0 _at143011_ (fx- (s32vector-length _at143011_) '1)))
            '#!void
            (error '"Index out of range" _to143009_ _at143011_))
        (if (and (fixnum? _start143015_)
                 (fx<= '0
                       _start143015_
                       (fx- (s32vector-length _from143013_) '1)))
            '#!void
            (error '"Index out of range" _from143013_ _start143015_))
        (if (and (fixnum? _end143017_)
                 (fx<= _start143015_
                       _end143017_
                       (s32vector-length _from143013_)))
            '#!void
            (error '"Index out of range" _from143013_ _end143017_))
        (if (fx<= (fx- _end143017_ _start143015_)
                  (fx- (s32vector-length _to143009_) _at143011_))
            '#!void
            (error '"Destination area too small"
                   _to143009_
                   _at143011_
                   _from143013_
                   _start143015_
                   _end143017_))
        (let _lp143021_ ((_i143024_ _start143015_) (_j143026_ _at143011_))
          (if (fx< _i143024_ _end143017_)
              (begin
                (s32vector-set!
                 _to143009_
                 _j143026_
                 (s32vector-ref _from143013_ _i143024_))
                (_lp143021_ (fx+ _i143024_ '1) (fx+ _j143026_ '1)))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-reverse-copy__%
    (lambda (_vec142981_ _start142983_ _end142985_)
      (let ((_v142988_ (make-s32vector (fx- _end142985_ _start142983_))))
        (std/srfi/160/s32#s32vector-reverse-copy!
         _v142988_
         '0
         _vec142981_
         _start142983_
         _end142985_)
        _v142988_)))
  (define std/srfi/160/s32#s32vector-reverse-copy__0
    (lambda (_vec142994_)
      (let* ((_start142996_ '0) (_end142998_ (s32vector-length _vec142994_)))
        (std/srfi/160/s32#s32vector-reverse-copy__%
         _vec142994_
         _start142996_
         _end142998_))))
  (define std/srfi/160/s32#s32vector-reverse-copy__1
    (lambda (_vec143000_ _start143001_)
      (let ((_end143003_ (s32vector-length _vec143000_)))
        (std/srfi/160/s32#s32vector-reverse-copy__%
         _vec143000_
         _start143001_
         _end143003_))))
  (define std/srfi/160/s32#s32vector-reverse-copy
    (lambda _g299205_
      (let ((_g299204_ (let () (declare (not safe)) (##length _g299205_))))
        (cond ((let () (declare (not safe)) (##fx= _g299204_ 1))
               (apply std/srfi/160/s32#s32vector-reverse-copy__0 _g299205_))
              ((let () (declare (not safe)) (##fx= _g299204_ 2))
               (apply std/srfi/160/s32#s32vector-reverse-copy__1 _g299205_))
              ((let () (declare (not safe)) (##fx= _g299204_ 3))
               (apply std/srfi/160/s32#s32vector-reverse-copy__% _g299205_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-reverse-copy
                _g299205_))))))
  (define std/srfi/160/s32#s32vector-reverse-copy!
    (lambda (_to142960_ _at142962_ _from142964_ _start142966_ _end142968_)
      (declare (not safe))
      (begin
        (if (s32vector? _to142960_) '#!void (error '"Bad argument" _to142960_))
        (if (s32vector? _from142964_)
            '#!void
            (error '"Bad argument" _from142964_))
        (if (and (fixnum? _at142962_)
                 (fx<= '0 _at142962_ (fx- (s32vector-length _at142962_) '1)))
            '#!void
            (error '"Index out of range" _to142960_ _at142962_))
        (if (and (fixnum? _start142966_)
                 (fx<= '0
                       _start142966_
                       (fx- (s32vector-length _from142964_) '1)))
            '#!void
            (error '"Index out of range" _from142964_ _start142966_))
        (if (and (fixnum? _end142968_)
                 (fx<= _start142966_
                       _end142968_
                       (s32vector-length _from142964_)))
            '#!void
            (error '"Index out of range" _from142964_ _end142968_))
        (if (fx<= (fx- _end142968_ _start142966_)
                  (fx- (s32vector-length _to142960_) _at142962_))
            '#!void
            (error '"Destination area too small"
                   _to142960_
                   _at142962_
                   _from142964_
                   _start142966_
                   _end142968_))
        (let _lp142972_ ((_i142975_ (fx- _end142968_ '1))
                         (_j142977_ _at142962_))
          (if (fx>= _i142975_ _start142966_)
              (begin
                (s32vector-set!
                 _to142960_
                 _j142977_
                 (s32vector-ref _from142964_ _i142975_))
                (_lp142972_ (fx- _i142975_ '1) (fx+ _j142977_ '1)))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-append
    (lambda _args142957_
      (std/srfi/160/s32#s32vector-concatenate _args142957_)))
  (define std/srfi/160/s32#s32vector-concatenate
    (lambda (_lst142897_)
      (let* ((_len142905_
              (foldl1 (lambda (_v142900_ _r142902_)
                        (fx+ (s32vector-length _v142900_) _r142902_))
                      '0
                      _lst142897_))
             (_v142908_ (make-s32vector _len142905_)))
        (declare (not safe))
        (let _lp142912_ ((_rest142915_ _lst142897_) (_at142917_ '0))
          (let* ((_rest142919142927_ _rest142915_)
                 (_else142921142935_ (lambda () _v142908_))
                 (_K142923142945_
                  (lambda (_rest142938_ _u142939_)
                    (let ((_ulen142942_ (s32vector-length _u142939_)))
                      (std/srfi/160/s32#s32vector-copy!
                       _v142908_
                       _at142917_
                       _u142939_
                       '0
                       _ulen142942_)
                      (_lp142912_
                       _rest142938_
                       (fx+ _at142917_ _ulen142942_))))))
            (if (##pair? _rest142919142927_)
                (let ((_hd142924142948_ (##car _rest142919142927_))
                      (_tl142925142950_ (##cdr _rest142919142927_)))
                  (let* ((_u142953_ _hd142924142948_)
                         (_rest142955_ _tl142925142950_))
                    (_K142923142945_ _rest142955_ _u142953_)))
                (_else142921142935_)))))))
  (define std/srfi/160/s32#s32vector-append-subvectors
    (lambda _args142769_
      (let* ((_len142830_
              (let _lp142772_ ((_rest142775_ _args142769_) (_r142777_ '0))
                (let* ((_rest142779142791_ _rest142775_)
                       (_else142781142799_ (lambda () _r142777_))
                       (_K142783142808_
                        (lambda (_rest142802_ _end142803_ _start142805_)
                          (_lp142772_
                           _rest142802_
                           (fx+ _r142777_ (fx- _end142803_ _start142805_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest142779142791_))
                      (let ((_tl142785142811_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest142779142791_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl142785142811_))
                            (let ((_hd142786142814_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl142785142811_)))
                                  (_tl142787142816_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl142785142811_))))
                              (let ((_start142819_ _hd142786142814_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl142787142816_))
                                    (let ((_hd142788142821_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl142787142816_)))
                                          (_tl142789142823_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl142787142816_))))
                                      (let* ((_end142826_ _hd142788142821_)
                                             (_rest142828_ _tl142789142823_))
                                        (_K142783142808_
                                         _rest142828_
                                         _end142826_
                                         _start142819_)))
                                    (_else142781142799_))))
                            (_else142781142799_)))
                      (_else142781142799_)))))
             (_v142833_ (make-s32vector _len142830_)))
        (let _lp142837_ ((_rest142839_ _args142769_) (_at142840_ '0))
          (let* ((_rest142842142854_ _rest142839_)
                 (_else142844142862_ (lambda () _v142833_))
                 (_K142846142871_
                  (lambda (_rest142865_ _end142866_ _start142867_ _u142868_)
                    (std/srfi/160/s32#s32vector-copy!
                     _v142833_
                     _at142840_
                     _u142868_
                     _start142867_
                     _end142866_)
                    (_lp142837_
                     _rest142865_
                     (fx+ _at142840_ (fx- _end142866_ _start142867_))))))
            (if (let () (declare (not safe)) (##pair? _rest142842142854_))
                (let ((_hd142847142874_
                       (let ()
                         (declare (not safe))
                         (##car _rest142842142854_)))
                      (_tl142848142876_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest142842142854_))))
                  (let ((_u142879_ _hd142847142874_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl142848142876_))
                        (let ((_hd142849142881_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl142848142876_)))
                              (_tl142850142883_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl142848142876_))))
                          (let ((_start142886_ _hd142849142881_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl142850142883_))
                                (let ((_hd142851142888_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl142850142883_)))
                                      (_tl142852142890_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl142850142883_))))
                                  (let* ((_end142893_ _hd142851142888_)
                                         (_rest142895_ _tl142852142890_))
                                    (_K142846142871_
                                     _rest142895_
                                     _end142893_
                                     _start142886_
                                     _u142879_)))
                                (_else142844142862_))))
                        (_else142844142862_))))
                (_else142844142862_)))))))
  (define std/srfi/160/s32#s32vector-empty?
    (lambda (_v142766_) (fxzero? (s32vector-length _v142766_))))
  (define std/srfi/160/s32#s32vector=
    (lambda (_v142708_ . _args142710_)
      (declare (not safe))
      (begin
        (if (s32vector? _v142708_) '#!void (error '"Bad argument" _v142708_))
        (let ((_vlen142714_ (s32vector-length _v142708_)))
          (let _lp142717_ ((_rest142720_ _args142710_))
            (let* ((_rest142722142730_ _rest142720_)
                   (_else142724142738_ (lambda () '#t))
                   (_K142726142754_
                    (lambda (_rest142741_ _u142742_)
                      (if (s32vector? _u142742_)
                          '#!void
                          (error '"Bad argument" _u142742_))
                      (let ((_ulen142745_ (s32vector-length _u142742_)))
                        (if (fx= _vlen142714_ _ulen142745_)
                            (let _cmp142748_ ((_i142751_ '0))
                              (if (fx< _i142751_ _vlen142714_)
                                  (if (= (s32vector-ref _v142708_ _i142751_)
                                         (s32vector-ref _u142742_ _i142751_))
                                      (_cmp142748_ (fx+ _i142751_ '1))
                                      '#f)
                                  (_lp142717_ _rest142741_)))
                            '#f)))))
              (if (##pair? _rest142722142730_)
                  (let ((_hd142727142757_ (##car _rest142722142730_))
                        (_tl142728142759_ (##cdr _rest142722142730_)))
                    (let* ((_u142762_ _hd142727142757_)
                           (_rest142764_ _tl142728142759_))
                      (_K142726142754_ _rest142764_ _u142762_)))
                  (_else142724142738_))))))))
  (define std/srfi/160/s32#s32vector-take
    (lambda (_v142700_ _n142702_)
      (let ((_u142705_ (make-s32vector _n142702_)))
        (std/srfi/160/s32#s32vector-copy! _u142705_ '0 _v142700_ '0 _n142702_)
        _u142705_)))
  (define std/srfi/160/s32#s32vector-take-right
    (lambda (_v142685_ _n142687_)
      (let* ((_vlen142690_ (s32vector-length _v142685_))
             (_ulen142693_ (fx- _vlen142690_ _n142687_))
             (_u142696_ (make-s32vector _ulen142693_)))
        (std/srfi/160/s32#s32vector-copy!
         _u142696_
         '0
         _v142685_
         _n142687_
         _vlen142690_)
        _u142696_)))
  (define std/srfi/160/s32#s32vector-drop
    (lambda (_v142670_ _n142672_)
      (let* ((_vlen142675_ (s32vector-length _v142670_))
             (_ulen142678_ (fx- _vlen142675_ _n142672_))
             (_u142681_ (make-s32vector _ulen142678_)))
        (std/srfi/160/s32#s32vector-copy!
         _u142681_
         '0
         _v142670_
         _n142672_
         _vlen142675_)
        _u142681_)))
  (define std/srfi/160/s32#s32vector-drop-right
    (lambda (_v142655_ _n142657_)
      (let* ((_vlen142660_ (s32vector-length _v142655_))
             (_ulen142663_ (fx- _vlen142660_ _n142657_))
             (_u142666_ (make-s32vector _ulen142663_)))
        (std/srfi/160/s32#s32vector-copy!
         _u142666_
         '0
         _v142655_
         '0
         _ulen142663_)
        _u142666_)))
  (define std/srfi/160/s32#s32vector-segment
    (lambda (_v142637_ _n142639_)
      (let _lp142642_ ((_i142645_ '0)
                       (_rest142647_ (s32vector-length _v142637_))
                       (_r142649_ '()))
        (if (fx> _r142649_ '0)
            (let ((_size142652_ (fxmin _n142639_ _rest142647_)))
              (_lp142642_
               (fx+ _i142645_ _size142652_)
               (fx- _rest142647_ _size142652_)
               (cons (std/srfi/160/s32#s32vector-copy__%
                      _v142637_
                      _i142645_
                      (fx+ _i142645_ _size142652_))
                     _r142649_)))
            (reverse _r142649_)))))
  (define std/srfi/160/s32#s32vector-fold__0
    (lambda (_kons142597_ _knil142599_ _v142601_)
      (if (procedure? _kons142597_)
          '#!void
          (error '"Bad argument; expected procedure" _kons142597_))
      (let ((_end142604_ (s32vector-length _v142601_)))
        (declare (not safe))
        (let _lp142608_ ((_i142611_ '0) (_r142613_ _knil142599_))
          (if (fx< _i142611_ _end142604_)
              (_lp142608_
               (fx+ _i142611_ '1)
               (_kons142597_ _r142613_ (s32vector-ref _v142601_ _i142611_)))
              _r142613_)))))
  (define std/srfi/160/s32#s32vector-fold__1
    (lambda (_kons142616_ _knil142617_ _v142618_ . _vs142619_)
      (if (procedure? _kons142616_)
          '#!void
          (error '"Bad argument; expected procedure" _kons142616_))
      (let* ((_vs142622_ (cons _v142618_ _vs142619_))
             (_end142624_ (apply fxmin (map s32vector-length _vs142622_))))
        (declare (not safe))
        (let _lp142628_ ((_i142630_ '0) (_r142631_ _knil142617_))
          (if (fx< _i142630_ _end142624_)
              (_lp142628_
               (fx+ _i142630_ '1)
               (apply _kons142616_
                      _r142631_
                      (map (lambda (_g142632142634_)
                             (s32vector-ref _g142632142634_ _i142630_))
                           _vs142622_)))
              _r142631_)))))
  (define std/srfi/160/s32#s32vector-fold
    (lambda _g299207_
      (let ((_g299206_ (let () (declare (not safe)) (##length _g299207_))))
        (cond ((let () (declare (not safe)) (##fx= _g299206_ 3))
               (apply std/srfi/160/s32#s32vector-fold__0 _g299207_))
              ((let () (declare (not safe)) (##fx>= _g299206_ 3))
               (apply std/srfi/160/s32#s32vector-fold__1 _g299207_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-fold
                _g299207_))))))
  (define std/srfi/160/s32#s32vector-fold-right__0
    (lambda (_kons142557_ _knil142559_ _v142561_)
      (if (procedure? _kons142557_)
          '#!void
          (error '"Bad argument; expected procedure" _kons142557_))
      (let ((_last142564_ (fx- (s32vector-length _v142561_) '1)))
        (declare (not safe))
        (let _lp142568_ ((_i142571_ _last142564_) (_r142573_ _knil142559_))
          (if (fx>= _i142571_ '0)
              (_lp142568_
               (fx- _i142571_ '1)
               (_kons142557_ _r142573_ (s32vector-ref _v142561_ _i142571_)))
              _r142573_)))))
  (define std/srfi/160/s32#s32vector-fold-right__1
    (lambda (_kons142576_ _knil142577_ _v142578_ . _vs142579_)
      (if (procedure? _kons142576_)
          '#!void
          (error '"Bad argument; expected procedure" _kons142576_))
      (let* ((_vs142582_ (cons _v142578_ _vs142579_))
             (_last142584_
              (fx- (apply min (map s32vector-length _vs142582_)) '1)))
        (declare (not safe))
        (let _lp142588_ ((_i142590_ _last142584_) (_r142591_ _knil142577_))
          (if (fx>= _i142590_ '0)
              (_lp142588_
               (fx- _i142590_ '1)
               (apply _kons142576_
                      _r142591_
                      (map (lambda (_g142592142594_)
                             (s32vector-ref _g142592142594_ _i142590_))
                           _vs142582_)))
              _r142591_)))))
  (define std/srfi/160/s32#s32vector-fold-right
    (lambda _g299209_
      (let ((_g299208_ (let () (declare (not safe)) (##length _g299209_))))
        (cond ((let () (declare (not safe)) (##fx= _g299208_ 3))
               (apply std/srfi/160/s32#s32vector-fold-right__0 _g299209_))
              ((let () (declare (not safe)) (##fx>= _g299208_ 3))
               (apply std/srfi/160/s32#s32vector-fold-right__1 _g299209_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-fold-right
                _g299209_))))))
  (define std/srfi/160/s32#s32vector-map__0
    (lambda (_f142517_ _v142519_)
      (if (procedure? _f142517_)
          '#!void
          (error '"Bad argument; expected procedure" _f142517_))
      (let* ((_len142522_ (s32vector-length _v142519_))
             (_u142525_ (make-s32vector _len142522_)))
        (declare (not safe))
        (let _lp142530_ ((_i142533_ '0))
          (if (fx< _i142533_ _len142522_)
              (begin
                (s32vector-set!
                 _u142525_
                 _i142533_
                 (s32vector-ref _v142519_ _i142533_))
                (_lp142530_ (fx+ _i142533_ '1)))
              _u142525_)))))
  (define std/srfi/160/s32#s32vector-map__1
    (lambda (_f142536_ _v142537_ . _vs142538_)
      (if (procedure? _f142536_)
          '#!void
          (error '"Bad argument; expected procedure" _f142536_))
      (let* ((_vs142541_ (cons _v142537_ _vs142538_))
             (_len142543_ (apply fxmin (map s32vector-length _vs142541_)))
             (_u142545_ (make-s32vector _len142543_)))
        (declare (not safe))
        (let _lp142549_ ((_i142551_ '0))
          (if (fx< _i142551_ _len142543_)
              (begin
                (s32vector-set!
                 _u142545_
                 _i142551_
                 (apply _f142536_
                        (map (lambda (_g142552142554_)
                               (s32vector-ref _g142552142554_ _i142551_))
                             _vs142541_)))
                (_lp142549_ (fx+ _i142551_ '1)))
              _u142545_)))))
  (define std/srfi/160/s32#s32vector-map
    (lambda _g299211_
      (let ((_g299210_ (let () (declare (not safe)) (##length _g299211_))))
        (cond ((let () (declare (not safe)) (##fx= _g299210_ 2))
               (apply std/srfi/160/s32#s32vector-map__0 _g299211_))
              ((let () (declare (not safe)) (##fx>= _g299210_ 2))
               (apply std/srfi/160/s32#s32vector-map__1 _g299211_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-map
                _g299211_))))))
  (define std/srfi/160/s32#s32vector-map!__0
    (lambda (_f142483_ _v142485_)
      (if (procedure? _f142483_)
          '#!void
          (error '"Bad argument; expected procedure" _f142483_))
      (let ((_len142488_ (s32vector-length _v142485_)))
        (declare (not safe))
        (let _lp142492_ ((_i142495_ '0))
          (if (fx< _i142495_ _len142488_)
              (begin
                (s32vector-set!
                 _v142485_
                 _i142495_
                 (_f142483_ (s32vector-ref _v142485_ _i142495_)))
                (_lp142492_ (fx+ _i142495_ '1)))
              _v142485_)))))
  (define std/srfi/160/s32#s32vector-map!__1
    (lambda (_f142498_ _v142499_ . _vs142500_)
      (if (procedure? _f142498_)
          '#!void
          (error '"Bad argument; expected procedure" _f142498_))
      (let* ((_vs142503_ (cons _v142499_ _vs142500_))
             (_len142505_ (apply fxmin (map s32vector-length _vs142503_))))
        (declare (not safe))
        (let _lp142509_ ((_i142511_ '0))
          (if (fx< _i142511_ _len142505_)
              (begin
                (s32vector-set!
                 _v142499_
                 _i142511_
                 (apply _f142498_
                        (map (lambda (_g142512142514_)
                               (s32vector-ref _g142512142514_ _i142511_))
                             _vs142503_)))
                (_lp142509_ (fx+ _i142511_ '1)))
              _v142499_)))))
  (define std/srfi/160/s32#s32vector-map!
    (lambda _g299213_
      (let ((_g299212_ (let () (declare (not safe)) (##length _g299213_))))
        (cond ((let () (declare (not safe)) (##fx= _g299212_ 2))
               (apply std/srfi/160/s32#s32vector-map!__0 _g299213_))
              ((let () (declare (not safe)) (##fx>= _g299212_ 2))
               (apply std/srfi/160/s32#s32vector-map!__1 _g299213_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-map!
                _g299213_))))))
  (define std/srfi/160/s32#s32vector-for-each__0
    (lambda (_f142449_ _v142451_)
      (if (procedure? _f142449_)
          '#!void
          (error '"Bad argument; expected procedure" _f142449_))
      (let ((_len142454_ (s32vector-length _v142451_)))
        (declare (not safe))
        (let _lp142458_ ((_i142461_ '0))
          (if (fx< _i142461_ _len142454_)
              (begin
                (_f142449_ (s32vector-ref _v142451_ _i142461_))
                (_lp142458_ (fx+ _i142461_ '1)))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-for-each__1
    (lambda (_f142464_ _v142465_ . _vs142466_)
      (let* ((_vs142469_ (cons _v142465_ _vs142466_))
             (_len142471_ (apply fxmin (map s32vector-length _vs142469_))))
        (declare (not safe))
        (let _lp142475_ ((_i142477_ '0))
          (if (fx< _i142477_ _len142471_)
              (begin
                (apply _f142464_
                       (map (lambda (_g142478142480_)
                              (s32vector-ref _g142478142480_ _i142477_))
                            _vs142469_))
                (_lp142475_ (fx+ _i142477_ '1)))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-for-each
    (lambda _g299215_
      (let ((_g299214_ (let () (declare (not safe)) (##length _g299215_))))
        (cond ((let () (declare (not safe)) (##fx= _g299214_ 2))
               (apply std/srfi/160/s32#s32vector-for-each__0 _g299215_))
              ((let () (declare (not safe)) (##fx>= _g299214_ 2))
               (apply std/srfi/160/s32#s32vector-for-each__1 _g299215_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-for-each
                _g299215_))))))
  (define std/srfi/160/s32#s32vector-count__0
    (lambda (_pred142412_ _v142414_)
      (if (procedure? _pred142412_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142412_))
      (let ((_end142417_ (s32vector-length _v142414_)))
        (declare (not safe))
        (let _lp142421_ ((_i142424_ '0) (_r142426_ '0))
          (if (fx< _i142424_ _end142417_)
              (if (_pred142412_ (s32vector-ref _v142414_ _i142424_))
                  (_lp142421_ (fx+ _i142424_ '1) (fx+ _r142426_ '1))
                  (_lp142421_ (fx+ _i142424_ '1) _r142426_))
              _r142426_)))))
  (define std/srfi/160/s32#s32vector-count__1
    (lambda (_pred142429_ _v142430_ . _vs142431_)
      (if (procedure? _pred142429_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142429_))
      (let* ((_vs142434_ (cons _v142430_ _vs142431_))
             (_end142436_ (apply fxmin (map s32vector-length _vs142434_))))
        (declare (not safe))
        (let _lp142440_ ((_i142442_ '0) (_r142443_ '0))
          (if (fx< _i142442_ _end142436_)
              (if (apply _pred142429_
                         (map (lambda (_g142444142446_)
                                (s32vector-ref _g142444142446_ _i142442_))
                              _vs142434_))
                  (_lp142440_ (fx+ _i142442_ '1) (fx+ _r142443_ '1))
                  (_lp142440_ (fx+ _i142442_ '1) _r142443_))
              _r142443_)))))
  (define std/srfi/160/s32#s32vector-count
    (lambda _g299217_
      (let ((_g299216_ (let () (declare (not safe)) (##length _g299217_))))
        (cond ((let () (declare (not safe)) (##fx= _g299216_ 2))
               (apply std/srfi/160/s32#s32vector-count__0 _g299217_))
              ((let () (declare (not safe)) (##fx>= _g299216_ 2))
               (apply std/srfi/160/s32#s32vector-count__1 _g299217_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-count
                _g299217_))))))
  (define std/srfi/160/s32#s32vector-cumulate
    (lambda (_f142387_ _knil142389_ _v142391_)
      (if (procedure? _f142387_)
          '#!void
          (error '"Bad argument; expected procedure" _f142387_))
      (let* ((_len142394_ (s32vector-length _v142391_))
             (_r142397_ (make-s32vector _len142394_)))
        (declare (not safe))
        (let _lp142402_ ((_i142405_ '0) (_r142407_ _knil142389_))
          (if (fx< _i142405_ _len142394_)
              (let ((_next142409_
                     (_f142387_
                      _r142407_
                      (s32vector-ref _v142391_ _i142405_))))
                (s32vector-set! _v142391_ _i142405_ _next142409_)
                (_lp142402_ (fx+ _i142405_ '1) _next142409_))
              _v142391_)))))
  (define std/srfi/160/s32#s32vector-take-while
    (lambda (_pred142370_ _v142372_)
      (let* ((_len142375_ (s32vector-length _v142372_))
             (_idx142378_
              (std/srfi/160/s32#s32vector-skip__0 _pred142370_ _v142372_))
             (_idx142384_
              (let ((_$e142381_ _idx142378_))
                (if _$e142381_ _$e142381_ _len142375_))))
        (std/srfi/160/s32#s32vector-copy__% _v142372_ '0 _idx142384_))))
  (define std/srfi/160/s32#s32vector-take-while-right
    (lambda (_pred142356_ _v142358_)
      (let* ((_len142361_ (s32vector-length _v142358_))
             (_idx142364_
              (std/srfi/160/s32#s32vector-skip-right__0
               _pred142356_
               _v142358_))
             (_idx142367_ (if _idx142364_ (fx+ _idx142364_ '1) '0)))
        (std/srfi/160/s32#s32vector-copy__%
         _v142358_
         _idx142367_
         _len142361_))))
  (define std/srfi/160/s32#s32vector-drop-while
    (lambda (_pred142339_ _v142341_)
      (let* ((_len142344_ (s32vector-length _v142341_))
             (_idx142347_
              (std/srfi/160/s32#s32vector-skip__0 _pred142339_ _v142341_))
             (_idx142353_
              (let ((_$e142350_ _idx142347_))
                (if _$e142350_ _$e142350_ _len142344_))))
        (std/srfi/160/s32#s32vector-copy__%
         _v142341_
         _idx142353_
         _len142344_))))
  (define std/srfi/160/s32#s32vector-drop-while-right
    (lambda (_pred142325_ _v142327_)
      (let* ((_len142330_ (s32vector-length _v142327_))
             (_idx142333_
              (std/srfi/160/s32#s32vector-skip-right__0
               _pred142325_
               _v142327_))
             (_idx142336_ (if _idx142333_ (fx+ _idx142333_ '1) '0)))
        (std/srfi/160/s32#s32vector-copy__% _v142327_ '0 _idx142336_))))
  (define std/srfi/160/s32#s32vector-index__0
    (lambda (_pred142291_ _v142293_)
      (if (procedure? _pred142291_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142291_))
      (let ((_end142296_ (s32vector-length _v142293_)))
        (declare (not safe))
        (let _lp142300_ ((_i142303_ '0))
          (if (fx< _i142303_ _end142296_)
              (if (_pred142291_ (s32vector-ref _v142293_ _i142303_))
                  _i142303_
                  (_lp142300_ (fx+ _i142303_ '1)))
              '#f)))))
  (define std/srfi/160/s32#s32vector-index__1
    (lambda (_pred142306_ _v142307_ . _vs142308_)
      (if (procedure? _pred142306_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142306_))
      (let* ((_vs142311_ (cons _v142307_ _vs142308_))
             (_end142313_ (apply fxmin (map s32vector-length _vs142311_))))
        (declare (not safe))
        (let _lp142317_ ((_i142319_ '0))
          (if (fx< _i142319_ _end142313_)
              (if (apply _pred142306_
                         (map (lambda (_g142320142322_)
                                (s32vector-ref _g142320142322_ _i142319_))
                              _vs142311_))
                  _i142319_
                  (_lp142317_ (fx+ _i142319_ '1)))
              '#f)))))
  (define std/srfi/160/s32#s32vector-index
    (lambda _g299219_
      (let ((_g299218_ (let () (declare (not safe)) (##length _g299219_))))
        (cond ((let () (declare (not safe)) (##fx= _g299218_ 2))
               (apply std/srfi/160/s32#s32vector-index__0 _g299219_))
              ((let () (declare (not safe)) (##fx>= _g299218_ 2))
               (apply std/srfi/160/s32#s32vector-index__1 _g299219_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-index
                _g299219_))))))
  (define std/srfi/160/s32#s32vector-index-right__0
    (lambda (_pred142257_ _v142259_)
      (if (procedure? _pred142257_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142257_))
      (let ((_start142262_ (fx- (s32vector-length _v142259_) '1)))
        (declare (not safe))
        (let _lp142266_ ((_i142269_ _start142262_))
          (if (fx>= _i142269_ '0)
              (if (_pred142257_ (s32vector-ref _v142259_ _i142269_))
                  _i142269_
                  (_lp142266_ (fx- _i142269_ '1)))
              '#f)))))
  (define std/srfi/160/s32#s32vector-index-right__1
    (lambda (_pred142272_ _v142273_ . _vs142274_)
      (if (procedure? _pred142272_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142272_))
      (let* ((_vs142277_ (cons _v142273_ _vs142274_))
             (_start142279_
              (fx- (apply fxmin (map s32vector-length _vs142277_)) '1)))
        (declare (not safe))
        (let _lp142283_ ((_i142285_ _start142279_))
          (if (fx>= _i142285_ '0)
              (if (apply _pred142272_
                         (map (lambda (_g142286142288_)
                                (s32vector-ref _g142286142288_ _i142285_))
                              _vs142277_))
                  _i142285_
                  (_lp142283_ (fx- _i142285_ '1)))
              '#f)))))
  (define std/srfi/160/s32#s32vector-index-right
    (lambda _g299221_
      (let ((_g299220_ (let () (declare (not safe)) (##length _g299221_))))
        (cond ((let () (declare (not safe)) (##fx= _g299220_ 2))
               (apply std/srfi/160/s32#s32vector-index-right__0 _g299221_))
              ((let () (declare (not safe)) (##fx>= _g299220_ 2))
               (apply std/srfi/160/s32#s32vector-index-right__1 _g299221_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-index-right
                _g299221_))))))
  (define std/srfi/160/s32#s32vector-skip__0
    (lambda (_pred142241_ _v142243_)
      (std/srfi/160/s32#s32vector-index__0
       (lambda (_$obj142246_) (not (_pred142241_ _$obj142246_)))
       _v142243_)))
  (define std/srfi/160/s32#s32vector-skip__1
    (lambda (_pred142249_ _v142250_ . _vs142251_)
      (apply std/srfi/160/s32#s32vector-index
             (lambda (_$obj142254_) (not (_pred142249_ _$obj142254_)))
             _v142250_
             _vs142251_)))
  (define std/srfi/160/s32#s32vector-skip
    (lambda _g299223_
      (let ((_g299222_ (let () (declare (not safe)) (##length _g299223_))))
        (cond ((let () (declare (not safe)) (##fx= _g299222_ 2))
               (apply std/srfi/160/s32#s32vector-skip__0 _g299223_))
              ((let () (declare (not safe)) (##fx>= _g299222_ 2))
               (apply std/srfi/160/s32#s32vector-skip__1 _g299223_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-skip
                _g299223_))))))
  (define std/srfi/160/s32#s32vector-skip-right__0
    (lambda (_pred142225_ _v142227_)
      (std/srfi/160/s32#s32vector-index-right__0
       (lambda (_$obj142230_) (not (_pred142225_ _$obj142230_)))
       _v142227_)))
  (define std/srfi/160/s32#s32vector-skip-right__1
    (lambda (_pred142233_ _v142234_ . _vs142235_)
      (apply std/srfi/160/s32#s32vector-index-right
             (lambda (_$obj142238_) (not (_pred142233_ _$obj142238_)))
             _v142234_
             _vs142235_)))
  (define std/srfi/160/s32#s32vector-skip-right
    (lambda _g299225_
      (let ((_g299224_ (let () (declare (not safe)) (##length _g299225_))))
        (cond ((let () (declare (not safe)) (##fx= _g299224_ 2))
               (apply std/srfi/160/s32#s32vector-skip-right__0 _g299225_))
              ((let () (declare (not safe)) (##fx>= _g299224_ 2))
               (apply std/srfi/160/s32#s32vector-skip-right__1 _g299225_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-skip-right
                _g299225_))))))
  (define std/srfi/160/s32#s32vector-any__0
    (lambda (_pred142185_ _v142187_)
      (if (procedure? _pred142185_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142185_))
      (let ((_end142190_ (s32vector-length _v142187_)))
        (declare (not safe))
        (let _lp142194_ ((_i142197_ '0))
          (if (fx< _i142197_ _end142190_)
              (let ((_$e142200_
                     (_pred142185_ (s32vector-ref _v142187_ _i142197_))))
                (if _$e142200_
                    (values _$e142200_)
                    (_lp142194_ (fx+ _i142197_ '1))))
              '#f)))))
  (define std/srfi/160/s32#s32vector-any__1
    (lambda (_pred142203_ _v142204_ . _vs142205_)
      (if (procedure? _pred142203_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142203_))
      (let* ((_v142208_ (cons _v142204_ _vs142205_))
             (_end142210_ (apply fxmin (map s32vector-length _vs142205_))))
        (declare (not safe))
        (let _lp142214_ ((_i142216_ '0))
          (if (fx< _i142216_ _end142210_)
              (let ((_$e142222_
                     (apply _pred142203_
                            (map (lambda (_g142217142219_)
                                   (s32vector-ref _g142217142219_ _i142216_))
                                 _vs142205_))))
                (if _$e142222_
                    (values _$e142222_)
                    (_lp142214_ (fx+ _i142216_ '1))))
              '#f)))))
  (define std/srfi/160/s32#s32vector-any
    (lambda _g299227_
      (let ((_g299226_ (let () (declare (not safe)) (##length _g299227_))))
        (cond ((let () (declare (not safe)) (##fx= _g299226_ 2))
               (apply std/srfi/160/s32#s32vector-any__0 _g299227_))
              ((let () (declare (not safe)) (##fx>= _g299226_ 2))
               (apply std/srfi/160/s32#s32vector-any__1 _g299227_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-any
                _g299227_))))))
  (define std/srfi/160/s32#s32vector-every__0
    (lambda (_pred142134_ _v142136_)
      (if (procedure? _pred142134_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142134_))
      (let ((_end142139_ (s32vector-length _v142136_)))
        (declare (not safe))
        (let _lp142143_ ((_i142146_ '0) (_r142148_ '#t))
          (if (fx< _i142146_ _end142139_)
              (let ((_$e142151_
                     (_pred142134_ (s32vector-ref _v142136_ _i142146_))))
                (if _$e142151_
                    ((lambda (_g142153142155_)
                       (_lp142143_ (fx+ _i142146_ '1) _g142153142155_))
                     _$e142151_)
                    '#f))
              _r142148_)))))
  (define std/srfi/160/s32#s32vector-every__1
    (lambda (_pred142158_ _v142159_ . _vs142160_)
      (if (procedure? _pred142158_)
          '#!void
          (error '"Bad argument; expected procedure" _pred142158_))
      (let* ((_v142163_ (cons _v142159_ _vs142160_))
             (_end142165_ (apply fxmin (map s32vector-length _vs142160_))))
        (declare (not safe))
        (let _lp142169_ ((_i142171_ '0) (_r142172_ '#t))
          (if (fx< _i142171_ _end142165_)
              (let ((_$e142178_
                     (apply _pred142158_
                            (map (lambda (_g142173142175_)
                                   (s32vector-ref _g142173142175_ _i142171_))
                                 _vs142160_))))
                (if _$e142178_
                    ((lambda (_g142180142182_)
                       (_lp142169_ (fx+ _i142171_ '1) _g142180142182_))
                     _$e142178_)
                    '#f))
              _r142172_)))))
  (define std/srfi/160/s32#s32vector-every
    (lambda _g299229_
      (let ((_g299228_ (let () (declare (not safe)) (##length _g299229_))))
        (cond ((let () (declare (not safe)) (##fx= _g299228_ 2))
               (apply std/srfi/160/s32#s32vector-every__0 _g299229_))
              ((let () (declare (not safe)) (##fx>= _g299228_ 2))
               (apply std/srfi/160/s32#s32vector-every__1 _g299229_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-every
                _g299229_))))))
  (define std/srfi/160/s32#s32vector-partition
    (lambda (_pred142105_ _v142107_)
      (let* ((_count142110_
              (std/srfi/160/s32#s32vector-count__0 _pred142105_ _v142107_))
             (_len142113_ (s32vector-length _v142107_))
             (_u142116_ (make-s32vector _len142113_)))
        (declare (not safe))
        (let _lp142121_ ((_i142124_ '0)
                         (_left142126_ '0)
                         (_right142128_ _count142110_))
          (if (fx< _i142124_ _len142113_)
              (let ((_x142131_ (s32vector-ref _v142107_ _i142124_)))
                (if (_pred142105_ _x142131_)
                    (begin
                      (s32vector-set! _u142116_ _left142126_ _x142131_)
                      (_lp142121_
                       (fx+ _i142124_ '1)
                       (fx+ _left142126_ '1)
                       _right142128_))
                    (begin
                      (s32vector-set! _u142116_ _right142128_ _x142131_)
                      (_lp142121_
                       (fx+ _i142124_ '1)
                       _left142126_
                       (fx+ _right142128_ '1)))))
              _u142116_)))))
  (define std/srfi/160/s32#s32vector-filter
    (lambda (_pred142078_ _v142080_)
      (let* ((_count142083_
              (std/srfi/160/s32#s32vector-count__0 _pred142078_ _v142080_))
             (_u142086_ (make-s32vector _count142083_))
             (_end142089_ (s32vector-length _v142080_)))
        (declare (not safe))
        (let _lp142094_ ((_i142097_ '0) (_j142099_ '0))
          (if (fx< _i142097_ _end142089_)
              (let ((_x142102_ (s32vector-ref _v142080_ _i142097_)))
                (if (_pred142078_ _x142102_)
                    (begin
                      (s32vector-set! _u142086_ _j142099_ _x142102_)
                      (_lp142094_ (fx+ _i142097_ '1) (fx+ _j142099_ '1)))
                    (_lp142094_ (fx+ _i142097_ '1) _j142099_)))
              _u142086_)))))
  (define std/srfi/160/s32#s32vector-remove
    (lambda (_pred142070_ _v142072_)
      (std/srfi/160/s32#s32vector-filter
       (lambda (_$obj142075_) (not (_pred142070_ _$obj142075_)))
       _v142072_)))
  (define std/srfi/160/s32#s32vector-swap
    (lambda (_v142057_ _i142059_ _j142061_)
      (let ((_iv142064_ (s32vector-ref _v142057_ _i142059_))
            (_jv142066_ (s32vector-ref _v142057_ _j142061_)))
        (declare (not safe))
        (begin
          (s32vector-set! _v142057_ _i142059_ _jv142066_)
          (s32vector-set! _v142057_ _j142061_ _iv142064_)))))
  (define std/srfi/160/s32#s32vector-fill!__%
    (lambda (_v142020_ _fill142022_ _start142024_ _end142026_)
      (declare (not safe))
      (begin
        (if (s32vector? _v142020_) '#!void (error '"Bad argument" _v142020_))
        (if (std/srfi/160/base#s32? _fill142022_)
            '#!void
            (error '"Bad argument" _fill142022_))
        (if (and (fixnum? _start142024_)
                 (fx<= '0 _start142024_ (fx- (s32vector-length _v142020_) '1)))
            '#!void
            (error '"Index out of range" _start142024_))
        (if (and (fixnum? _end142026_)
                 (fx<= _start142024_ _end142026_ (s32vector-length _v142020_)))
            '#!void
            (error '"Index out of range" _end142026_))
        (let _lp142030_ ((_i142033_ _start142024_))
          (if (fx< _i142033_ _end142026_)
              (begin
                (s32vector-set! _v142020_ _i142033_ _fill142022_)
                (_lp142030_ (fx+ _i142033_ '1)))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-fill!__0
    (lambda (_v142039_ _fill142040_)
      (let* ((_start142042_ '0) (_end142044_ (s32vector-length _v142039_)))
        (std/srfi/160/s32#s32vector-fill!__%
         _v142039_
         _fill142040_
         _start142042_
         _end142044_))))
  (define std/srfi/160/s32#s32vector-fill!__1
    (lambda (_v142046_ _fill142047_ _start142048_)
      (let ((_end142050_ (s32vector-length _v142046_)))
        (std/srfi/160/s32#s32vector-fill!__%
         _v142046_
         _fill142047_
         _start142048_
         _end142050_))))
  (define std/srfi/160/s32#s32vector-fill!
    (lambda _g299231_
      (let ((_g299230_ (let () (declare (not safe)) (##length _g299231_))))
        (cond ((let () (declare (not safe)) (##fx= _g299230_ 2))
               (apply std/srfi/160/s32#s32vector-fill!__0 _g299231_))
              ((let () (declare (not safe)) (##fx= _g299230_ 3))
               (apply std/srfi/160/s32#s32vector-fill!__1 _g299231_))
              ((let () (declare (not safe)) (##fx= _g299230_ 4))
               (apply std/srfi/160/s32#s32vector-fill!__% _g299231_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-fill!
                _g299231_))))))
  (define std/srfi/160/s32#s32vector-reverse!__%
    (lambda (_v141980_ _start141982_ _end141984_)
      (declare (not safe))
      (begin
        (if (s32vector? _v141980_) '#!void (error '"Bad argument" _v141980_))
        (if (and (fixnum? _start141982_)
                 (fx<= '0 _start141982_ (fx- (s32vector-length _v141980_) '1)))
            '#!void
            (error '"Index out of range" _start141982_))
        (if (and (fixnum? _end141984_)
                 (fx<= _start141982_ _end141984_ (s32vector-length _v141980_)))
            '#!void
            (error '"Index out of range" _end141984_))
        (let _lp141988_ ((_i141991_ _start141982_)
                         (_j141993_ (fx- _end141984_ '1)))
          (if (fx< _i141991_ _j141993_)
              (let ((_iv141996_ (s32vector-ref _v141980_ _i141991_))
                    (_jv141998_ (s32vector-ref _v141980_ _j141993_)))
                (s32vector-set! _v141980_ _i141991_ _jv141998_)
                (s32vector-set! _v141980_ _j141993_ _iv141996_)
                (_lp141988_ (fx+ _i141991_ '1) (fx- _j141993_ '1)))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-reverse!__0
    (lambda (_v142004_)
      (let* ((_start142006_ '0) (_end142008_ (s32vector-length _v142004_)))
        (std/srfi/160/s32#s32vector-reverse!__%
         _v142004_
         _start142006_
         _end142008_))))
  (define std/srfi/160/s32#s32vector-reverse!__1
    (lambda (_v142010_ _start142011_)
      (let ((_end142013_ (s32vector-length _v142010_)))
        (std/srfi/160/s32#s32vector-reverse!__%
         _v142010_
         _start142011_
         _end142013_))))
  (define std/srfi/160/s32#s32vector-reverse!
    (lambda _g299233_
      (let ((_g299232_ (let () (declare (not safe)) (##length _g299233_))))
        (cond ((let () (declare (not safe)) (##fx= _g299232_ 1))
               (apply std/srfi/160/s32#s32vector-reverse!__0 _g299233_))
              ((let () (declare (not safe)) (##fx= _g299232_ 2))
               (apply std/srfi/160/s32#s32vector-reverse!__1 _g299233_))
              ((let () (declare (not safe)) (##fx= _g299232_ 3))
               (apply std/srfi/160/s32#s32vector-reverse!__% _g299233_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector-reverse!
                _g299233_))))))
  (define std/srfi/160/s32#s32vector-unfold!
    (lambda (_f141955_ _v141957_ _start141959_ _end141961_ _seed141963_)
      (declare (not safe))
      (begin
        (if (procedure? _f141955_)
            '#!void
            (error '"Bad argument; expected procedure" _f141955_))
        (if (s32vector? _v141957_) '#!void (error '"Bad argument" _v141957_))
        (if (and (fixnum? _start141959_)
                 (fx<= '0 _start141959_ (fx- (s32vector-length _v141957_) '1)))
            '#!void
            (error '"Index out of range" _start141959_))
        (if (and (fixnum? _end141961_)
                 (fx<= _start141959_ _end141961_ (s32vector-length _v141957_)))
            '#!void
            (error '"Index out of range" _end141961_))
        (let _lp141967_ ((_i141970_ _start141959_)
                         (_state141972_ _seed141963_))
          (if (fx< _i141970_ _end141961_)
              (let ((_g299234_ (_f141955_ _state141972_)))
                (begin
                  (let ((_g299235_
                         (if (##values? _g299234_)
                             (##vector-length _g299234_)
                             1)))
                    (if (not (##fx= _g299235_ 2))
                        (error "Context expects 2 values" _g299235_)))
                  (let ((_x141975_ (##vector-ref _g299234_ 0))
                        (_state141977_ (##vector-ref _g299234_ 1)))
                    (begin
                      (s32vector-set! _v141957_ _i141970_ _x141975_)
                      (_lp141967_ (fx+ _i141970_ '1) _state141977_)))))
              '#!void)))))
  (define std/srfi/160/s32#s32vector-unfold-right!
    (lambda (_f141931_ _v141933_ _start141935_ _end141937_ _seed141939_)
      (declare (not safe))
      (begin
        (if (procedure? _f141931_)
            '#!void
            (error '"Bad argument; expected procedure" _f141931_))
        (if (s32vector? _v141933_) '#!void (error '"Bad argument" _v141933_))
        (if (and (fixnum? _start141935_)
                 (fx<= '0 _start141935_ (fx- (s32vector-length _v141933_) '1)))
            '#!void
            (error '"Index out of range" _start141935_))
        (if (and (fixnum? _end141937_)
                 (fx<= _start141935_ _end141937_ (s32vector-length _v141933_)))
            '#!void
            (error '"Index out of range" _end141937_))
        (let _lp141943_ ((_i141946_ (fx- _end141937_ '1))
                         (_state141948_ _seed141939_))
          (if (fx>= _i141946_ _start141935_)
              (let ((_g299236_ (_f141931_ _state141948_)))
                (begin
                  (let ((_g299237_
                         (if (##values? _g299236_)
                             (##vector-length _g299236_)
                             1)))
                    (if (not (##fx= _g299237_ 2))
                        (error "Context expects 2 values" _g299237_)))
                  (let ((_x141951_ (##vector-ref _g299236_ 0))
                        (_state141953_ (##vector-ref _g299236_ 1)))
                    (begin
                      (s32vector-set! _v141933_ _i141946_ _x141951_)
                      (_lp141943_ (fx- _i141946_ '1) _state141953_)))))
              '#!void)))))
  (define std/srfi/160/s32#reverse-s32vector->list__%
    (lambda (_v141897_ _start141899_ _end141901_)
      (declare (not safe))
      (begin
        (if (s32vector? _v141897_) '#!void (error '"Bad argument" _v141897_))
        (if (and (fixnum? _start141899_)
                 (fx<= '0 _start141899_ (fx- (s32vector-length _v141897_) '1)))
            '#!void
            (error '"Index out of range" _start141899_))
        (if (and (fixnum? _end141901_)
                 (fx<= _start141899_ _end141901_ (s32vector-length _v141897_)))
            '#!void
            (error '"Index out of range" _end141901_))
        (let _lp141905_ ((_i141908_ _start141899_) (_r141910_ '()))
          (if (fx< _i141908_ _end141901_)
              (_lp141905_
               (fx+ _i141908_ '1)
               (cons (s32vector-ref _v141897_ _i141908_) _r141910_))
              _r141910_)))))
  (define std/srfi/160/s32#reverse-s32vector->list__0
    (lambda (_v141916_)
      (let* ((_start141918_ '0) (_end141920_ (s32vector-length _v141916_)))
        (std/srfi/160/s32#reverse-s32vector->list__%
         _v141916_
         _start141918_
         _end141920_))))
  (define std/srfi/160/s32#reverse-s32vector->list__1
    (lambda (_v141922_ _start141923_)
      (let ((_end141925_ (s32vector-length _v141922_)))
        (std/srfi/160/s32#reverse-s32vector->list__%
         _v141922_
         _start141923_
         _end141925_))))
  (define std/srfi/160/s32#reverse-s32vector->list
    (lambda _g299239_
      (let ((_g299238_ (let () (declare (not safe)) (##length _g299239_))))
        (cond ((let () (declare (not safe)) (##fx= _g299238_ 1))
               (apply std/srfi/160/s32#reverse-s32vector->list__0 _g299239_))
              ((let () (declare (not safe)) (##fx= _g299238_ 2))
               (apply std/srfi/160/s32#reverse-s32vector->list__1 _g299239_))
              ((let () (declare (not safe)) (##fx= _g299238_ 3))
               (apply std/srfi/160/s32#reverse-s32vector->list__% _g299239_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#reverse-s32vector->list
                _g299239_))))))
  (define std/srfi/160/s32#reverse-list->s32vector
    (lambda (_lst141843_)
      (let* ((_len141846_ (length _lst141843_))
             (_v141849_ (make-s32vector _len141846_)))
        (declare (not safe))
        (let _lp141854_ ((_rest141857_ _lst141843_) (_i141859_ '0))
          (let* ((_rest141861141869_ _rest141857_)
                 (_else141863141877_ (lambda () _v141849_))
                 (_K141865141884_
                  (lambda (_rest141880_ _x141881_)
                    (if (std/srfi/160/base#s32? _x141881_)
                        '#!void
                        (error '"Bad element" _x141881_))
                    (s32vector-set! _v141849_ _i141859_ _x141881_)
                    (_lp141854_ _rest141880_ (fx+ _i141859_ '1)))))
            (if (##pair? _rest141861141869_)
                (let ((_hd141866141887_ (##car _rest141861141869_))
                      (_tl141867141889_ (##cdr _rest141861141869_)))
                  (let* ((_x141892_ _hd141866141887_)
                         (_rest141894_ _tl141867141889_))
                    (_K141865141884_ _rest141894_ _x141892_)))
                (_else141863141877_)))))))
  (define std/srfi/160/s32#s32vector->vector__%
    (lambda (_v141804_ _start141806_ _end141808_)
      (declare (not safe))
      (begin
        (if (s32vector? _v141804_) '#!void (error '"Bad argument" _v141804_))
        (if (and (fixnum? _start141806_)
                 (fx<= '0 _start141806_ (fx- (s32vector-length _v141804_) '1)))
            '#!void
            (error '"Index out of range" _start141806_))
        (if (and (fixnum? _end141808_)
                 (fx<= _start141806_ _end141808_ (s32vector-length _v141804_)))
            '#!void
            (error '"Index out of range" _end141808_))
        (let* ((_len141812_ (s32vector-length _v141804_))
               (_u141815_ (make-vector _len141812_)))
          (let _lp141819_ ((_i141822_ '0))
            (if (fx< _i141822_ _len141812_)
                (begin
                  (vector-set!
                   _u141815_
                   _i141822_
                   (s32vector-ref _v141804_ _i141822_))
                  (_lp141819_ (fx+ _i141822_ '1)))
                _u141815_))))))
  (define std/srfi/160/s32#s32vector->vector__0
    (lambda (_v141828_)
      (let* ((_start141830_ '0) (_end141832_ (s32vector-length _v141828_)))
        (std/srfi/160/s32#s32vector->vector__%
         _v141828_
         _start141830_
         _end141832_))))
  (define std/srfi/160/s32#s32vector->vector__1
    (lambda (_v141834_ _start141835_)
      (let ((_end141837_ (s32vector-length _v141834_)))
        (std/srfi/160/s32#s32vector->vector__%
         _v141834_
         _start141835_
         _end141837_))))
  (define std/srfi/160/s32#s32vector->vector
    (lambda _g299241_
      (let ((_g299240_ (let () (declare (not safe)) (##length _g299241_))))
        (cond ((let () (declare (not safe)) (##fx= _g299240_ 1))
               (apply std/srfi/160/s32#s32vector->vector__0 _g299241_))
              ((let () (declare (not safe)) (##fx= _g299240_ 2))
               (apply std/srfi/160/s32#s32vector->vector__1 _g299241_))
              ((let () (declare (not safe)) (##fx= _g299240_ 3))
               (apply std/srfi/160/s32#s32vector->vector__% _g299241_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#s32vector->vector
                _g299241_))))))
  (define std/srfi/160/s32#vector->s32vector__%
    (lambda (_v141764_ _start141766_ _end141768_)
      (declare (not safe))
      (begin
        (if (vector? _v141764_)
            '#!void
            (error '"Bad argument; expected vector" _v141764_))
        (if (and (fixnum? _start141766_)
                 (fx<= '0 _start141766_ (fx- (vector-length _v141764_) '1)))
            '#!void
            (error '"Index out of range" _start141766_))
        (if (and (fixnum? _end141768_)
                 (fx<= _start141766_ _end141768_ (vector-length _v141764_)))
            '#!void
            (error '"Index out of range" _end141768_))
        (let* ((_len141772_ (vector-length _v141764_))
               (_u141775_ (make-s32vector _len141772_)))
          (let _lp141779_ ((_i141782_ '0))
            (if (fx< _i141782_ _len141772_)
                (begin
                  (s32vector-set!
                   _u141775_
                   _i141782_
                   (vector-ref _v141764_ _i141782_))
                  (_lp141779_ (fx+ _i141782_ '1)))
                _u141775_))))))
  (define std/srfi/160/s32#vector->s32vector__0
    (lambda (_v141788_)
      (let* ((_start141790_ '0) (_end141792_ (vector-length _v141788_)))
        (std/srfi/160/s32#vector->s32vector__%
         _v141788_
         _start141790_
         _end141792_))))
  (define std/srfi/160/s32#vector->s32vector__1
    (lambda (_v141794_ _start141795_)
      (let ((_end141797_ (vector-length _v141794_)))
        (std/srfi/160/s32#vector->s32vector__%
         _v141794_
         _start141795_
         _end141797_))))
  (define std/srfi/160/s32#vector->s32vector
    (lambda _g299243_
      (let ((_g299242_ (let () (declare (not safe)) (##length _g299243_))))
        (cond ((let () (declare (not safe)) (##fx= _g299242_ 1))
               (apply std/srfi/160/s32#vector->s32vector__0 _g299243_))
              ((let () (declare (not safe)) (##fx= _g299242_ 2))
               (apply std/srfi/160/s32#vector->s32vector__1 _g299243_))
              ((let () (declare (not safe)) (##fx= _g299242_ 3))
               (apply std/srfi/160/s32#vector->s32vector__% _g299243_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#vector->s32vector
                _g299243_))))))
  (define std/srfi/160/s32#make-s32vector-generator__%
    (lambda (_v141730_ _start141732_ _end141734_)
      (declare (not safe))
      (begin
        (if (s32vector? _v141730_) '#!void (error '"Bad argument" _v141730_))
        (if (and (fixnum? _start141732_)
                 (fx<= '0 _start141732_ (fx- (s32vector-length _v141730_) '1)))
            '#!void
            (error '"Index out of range" _start141732_))
        (if (and (fixnum? _end141734_)
                 (fx<= _start141732_ _end141734_ (s32vector-length _v141730_)))
            '#!void
            (error '"Index out of range" _end141734_))
        (let ((_i141738_ _start141732_))
          (lambda ()
            (if (fx< _i141738_ _end141734_)
                (let ((_next141742_ (s32vector-ref _v141730_ _i141738_)))
                  (set! _i141738_ (fx+ _i141738_ '1))
                  _next141742_)
                '#!eof))))))
  (define std/srfi/160/s32#make-s32vector-generator__0
    (lambda (_v141748_)
      (let* ((_start141750_ '0) (_end141752_ (s32vector-length _v141748_)))
        (std/srfi/160/s32#make-s32vector-generator__%
         _v141748_
         _start141750_
         _end141752_))))
  (define std/srfi/160/s32#make-s32vector-generator__1
    (lambda (_v141754_ _start141755_)
      (let ((_end141757_ (s32vector-length _v141754_)))
        (std/srfi/160/s32#make-s32vector-generator__%
         _v141754_
         _start141755_
         _end141757_))))
  (define std/srfi/160/s32#make-s32vector-generator
    (lambda _g299245_
      (let ((_g299244_ (let () (declare (not safe)) (##length _g299245_))))
        (cond ((let () (declare (not safe)) (##fx= _g299244_ 1))
               (apply std/srfi/160/s32#make-s32vector-generator__0 _g299245_))
              ((let () (declare (not safe)) (##fx= _g299244_ 2))
               (apply std/srfi/160/s32#make-s32vector-generator__1 _g299245_))
              ((let () (declare (not safe)) (##fx= _g299244_ 3))
               (apply std/srfi/160/s32#make-s32vector-generator__% _g299245_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#make-s32vector-generator
                _g299245_))))))
  (define std/srfi/160/s32#s32vector-comparator
    (let ()
      (letrec ((_<?141701_
                (lambda (_a141704_ _b141706_)
                  (let ((_len-a141709_ (s32vector-length _a141704_))
                        (_len-b141711_ (s32vector-length _b141706_)))
                    (declare (not safe))
                    (if (fx< _len-a141709_ _len-b141711_)
                        '#t
                        (if (fx> _len-a141709_ _len-b141711_)
                            '#f
                            (let ((_end141715_ _len-a141709_))
                              (let _lp141718_ ((_i141721_ '0))
                                (if (fx< _i141721_ _end141715_)
                                    (let ((_x141724_
                                           (s32vector-ref _a141704_ _i141721_))
                                          (_y141726_
                                           (s32vector-ref
                                            _b141706_
                                            _i141721_)))
                                      (if (< _x141724_ _y141726_)
                                          '#t
                                          (if (> _x141724_ _y141726_)
                                              '#f
                                              (_lp141718_
                                               (fx+ _i141721_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           s32vector?
           std/srfi/160/s32#s32vector=
           _<?141701_
           equal?-hash)))))
  (define std/srfi/160/s32#write-s32vector__%
    (lambda (_v141678_ _port141680_)
      (let ((_$e141683_ (find-method _v141678_ ':write)))
        (if _$e141683_
            ((lambda (_g141685141687_)
               (_g141685141687_ _v141678_ _port141680_))
             _$e141683_)
            (write _v141678_ (current-output-port))))))
  (define std/srfi/160/s32#write-s32vector__0
    (lambda (_v141693_)
      (let ((_port141695_ (current-output-port)))
        (std/srfi/160/s32#write-s32vector__% _v141693_ _port141695_))))
  (define std/srfi/160/s32#write-s32vector
    (lambda _g299247_
      (let ((_g299246_ (let () (declare (not safe)) (##length _g299247_))))
        (cond ((let () (declare (not safe)) (##fx= _g299246_ 1))
               (apply std/srfi/160/s32#write-s32vector__0 _g299247_))
              ((let () (declare (not safe)) (##fx= _g299246_ 2))
               (apply std/srfi/160/s32#write-s32vector__% _g299247_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s32#write-s32vector
                _g299247_)))))))
