(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/s8#s8vector-unfold
    (lambda (_f137373_ _len137375_ _seed137377_)
      (declare (not safe))
      (begin
        (if (procedure? _f137373_)
            '#!void
            (error '"Bad argument; expected procedure" _f137373_))
        (let ((_v137381_ (make-s8vector _len137375_)))
          (let _lp137384_ ((_i137387_ '0) (_state137389_ _seed137377_))
            (if (fx< _i137387_ _len137375_)
                (let ((_g298998_ (_f137373_ _i137387_ _state137389_)))
                  (begin
                    (let ((_g298999_
                           (if (##values? _g298998_)
                               (##vector-length _g298998_)
                               1)))
                      (if (not (##fx= _g298999_ 2))
                          (error "Context expects 2 values" _g298999_)))
                    (let ((_x137392_ (##vector-ref _g298998_ 0))
                          (_state137394_ (##vector-ref _g298998_ 1)))
                      (begin
                        (if (std/srfi/160/base#s8? _x137392_)
                            '#!void
                            (error '"Bad generated value" _x137392_))
                        (s8vector-set! _v137381_ _i137387_ _x137392_)
                        (_lp137384_ (fx+ _i137387_ '1) _state137394_)))))
                _v137381_))))))
  (define std/srfi/160/s8#s8vector-unfold-right
    (lambda (_f137350_ _len137352_ _seed137354_)
      (declare (not safe))
      (begin
        (if (procedure? _f137350_)
            '#!void
            (error '"Bad argument; expected procedure" _f137350_))
        (let ((_v137358_ (make-s8vector _len137352_)))
          (let _lp137361_ ((_i137364_ (fx- _len137352_ '1))
                           (_state137366_ _seed137354_))
            (if (fx>= _i137364_ '0)
                (let ((_g299000_ (_f137350_ _i137364_ _state137366_)))
                  (begin
                    (let ((_g299001_
                           (if (##values? _g299000_)
                               (##vector-length _g299000_)
                               1)))
                      (if (not (##fx= _g299001_ 2))
                          (error "Context expects 2 values" _g299001_)))
                    (let ((_x137369_ (##vector-ref _g299000_ 0))
                          (_state137371_ (##vector-ref _g299000_ 1)))
                      (begin
                        (if (std/srfi/160/base#s8? _x137369_)
                            '#!void
                            (error '"Bad generated value" _x137369_))
                        (s8vector-set! _v137358_ _i137364_ _x137369_)
                        (_lp137361_ (fx- _i137364_ '1) _state137371_)))))
                _v137358_))))))
  (define std/srfi/160/s8#s8vector-copy__%
    (lambda (_vec137322_ _start137324_ _end137326_)
      (let ((_v137329_ (make-s8vector (fx- _end137326_ _start137324_))))
        (std/srfi/160/s8#s8vector-copy!
         _v137329_
         '0
         _vec137322_
         _start137324_
         _end137326_)
        _v137329_)))
  (define std/srfi/160/s8#s8vector-copy__0
    (lambda (_vec137335_)
      (let* ((_start137337_ '0) (_end137339_ (s8vector-length _vec137335_)))
        (std/srfi/160/s8#s8vector-copy__%
         _vec137335_
         _start137337_
         _end137339_))))
  (define std/srfi/160/s8#s8vector-copy__1
    (lambda (_vec137341_ _start137342_)
      (let ((_end137344_ (s8vector-length _vec137341_)))
        (std/srfi/160/s8#s8vector-copy__%
         _vec137341_
         _start137342_
         _end137344_))))
  (define std/srfi/160/s8#s8vector-copy
    (lambda _g299003_
      (let ((_g299002_ (let () (declare (not safe)) (##length _g299003_))))
        (cond ((let () (declare (not safe)) (##fx= _g299002_ 1))
               (apply std/srfi/160/s8#s8vector-copy__0 _g299003_))
              ((let () (declare (not safe)) (##fx= _g299002_ 2))
               (apply std/srfi/160/s8#s8vector-copy__1 _g299003_))
              ((let () (declare (not safe)) (##fx= _g299002_ 3))
               (apply std/srfi/160/s8#s8vector-copy__% _g299003_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-copy
                _g299003_))))))
  (define std/srfi/160/s8#s8vector-copy!
    (lambda (_to137301_ _at137303_ _from137305_ _start137307_ _end137309_)
      (declare (not safe))
      (begin
        (if (s8vector? _to137301_) '#!void (error '"Bad argument" _to137301_))
        (if (s8vector? _from137305_)
            '#!void
            (error '"Bad argument" _from137305_))
        (if (and (fixnum? _at137303_)
                 (fx<= '0 _at137303_ (fx- (s8vector-length _at137303_) '1)))
            '#!void
            (error '"Index out of range" _to137301_ _at137303_))
        (if (and (fixnum? _start137307_)
                 (fx<= '0
                       _start137307_
                       (fx- (s8vector-length _from137305_) '1)))
            '#!void
            (error '"Index out of range" _from137305_ _start137307_))
        (if (and (fixnum? _end137309_)
                 (fx<= _start137307_
                       _end137309_
                       (s8vector-length _from137305_)))
            '#!void
            (error '"Index out of range" _from137305_ _end137309_))
        (if (fx<= (fx- _end137309_ _start137307_)
                  (fx- (s8vector-length _to137301_) _at137303_))
            '#!void
            (error '"Destination area too small"
                   _to137301_
                   _at137303_
                   _from137305_
                   _start137307_
                   _end137309_))
        (let _lp137313_ ((_i137316_ _start137307_) (_j137318_ _at137303_))
          (if (fx< _i137316_ _end137309_)
              (begin
                (s8vector-set!
                 _to137301_
                 _j137318_
                 (s8vector-ref _from137305_ _i137316_))
                (_lp137313_ (fx+ _i137316_ '1) (fx+ _j137318_ '1)))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-reverse-copy__%
    (lambda (_vec137273_ _start137275_ _end137277_)
      (let ((_v137280_ (make-s8vector (fx- _end137277_ _start137275_))))
        (std/srfi/160/s8#s8vector-reverse-copy!
         _v137280_
         '0
         _vec137273_
         _start137275_
         _end137277_)
        _v137280_)))
  (define std/srfi/160/s8#s8vector-reverse-copy__0
    (lambda (_vec137286_)
      (let* ((_start137288_ '0) (_end137290_ (s8vector-length _vec137286_)))
        (std/srfi/160/s8#s8vector-reverse-copy__%
         _vec137286_
         _start137288_
         _end137290_))))
  (define std/srfi/160/s8#s8vector-reverse-copy__1
    (lambda (_vec137292_ _start137293_)
      (let ((_end137295_ (s8vector-length _vec137292_)))
        (std/srfi/160/s8#s8vector-reverse-copy__%
         _vec137292_
         _start137293_
         _end137295_))))
  (define std/srfi/160/s8#s8vector-reverse-copy
    (lambda _g299005_
      (let ((_g299004_ (let () (declare (not safe)) (##length _g299005_))))
        (cond ((let () (declare (not safe)) (##fx= _g299004_ 1))
               (apply std/srfi/160/s8#s8vector-reverse-copy__0 _g299005_))
              ((let () (declare (not safe)) (##fx= _g299004_ 2))
               (apply std/srfi/160/s8#s8vector-reverse-copy__1 _g299005_))
              ((let () (declare (not safe)) (##fx= _g299004_ 3))
               (apply std/srfi/160/s8#s8vector-reverse-copy__% _g299005_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-reverse-copy
                _g299005_))))))
  (define std/srfi/160/s8#s8vector-reverse-copy!
    (lambda (_to137252_ _at137254_ _from137256_ _start137258_ _end137260_)
      (declare (not safe))
      (begin
        (if (s8vector? _to137252_) '#!void (error '"Bad argument" _to137252_))
        (if (s8vector? _from137256_)
            '#!void
            (error '"Bad argument" _from137256_))
        (if (and (fixnum? _at137254_)
                 (fx<= '0 _at137254_ (fx- (s8vector-length _at137254_) '1)))
            '#!void
            (error '"Index out of range" _to137252_ _at137254_))
        (if (and (fixnum? _start137258_)
                 (fx<= '0
                       _start137258_
                       (fx- (s8vector-length _from137256_) '1)))
            '#!void
            (error '"Index out of range" _from137256_ _start137258_))
        (if (and (fixnum? _end137260_)
                 (fx<= _start137258_
                       _end137260_
                       (s8vector-length _from137256_)))
            '#!void
            (error '"Index out of range" _from137256_ _end137260_))
        (if (fx<= (fx- _end137260_ _start137258_)
                  (fx- (s8vector-length _to137252_) _at137254_))
            '#!void
            (error '"Destination area too small"
                   _to137252_
                   _at137254_
                   _from137256_
                   _start137258_
                   _end137260_))
        (let _lp137264_ ((_i137267_ (fx- _end137260_ '1))
                         (_j137269_ _at137254_))
          (if (fx>= _i137267_ _start137258_)
              (begin
                (s8vector-set!
                 _to137252_
                 _j137269_
                 (s8vector-ref _from137256_ _i137267_))
                (_lp137264_ (fx- _i137267_ '1) (fx+ _j137269_ '1)))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-append
    (lambda _args137249_ (std/srfi/160/s8#s8vector-concatenate _args137249_)))
  (define std/srfi/160/s8#s8vector-concatenate
    (lambda (_lst137189_)
      (let* ((_len137197_
              (foldl1 (lambda (_v137192_ _r137194_)
                        (fx+ (s8vector-length _v137192_) _r137194_))
                      '0
                      _lst137189_))
             (_v137200_ (make-s8vector _len137197_)))
        (declare (not safe))
        (let _lp137204_ ((_rest137207_ _lst137189_) (_at137209_ '0))
          (let* ((_rest137211137219_ _rest137207_)
                 (_else137213137227_ (lambda () _v137200_))
                 (_K137215137237_
                  (lambda (_rest137230_ _u137231_)
                    (let ((_ulen137234_ (s8vector-length _u137231_)))
                      (std/srfi/160/s8#s8vector-copy!
                       _v137200_
                       _at137209_
                       _u137231_
                       '0
                       _ulen137234_)
                      (_lp137204_
                       _rest137230_
                       (fx+ _at137209_ _ulen137234_))))))
            (if (##pair? _rest137211137219_)
                (let ((_hd137216137240_ (##car _rest137211137219_))
                      (_tl137217137242_ (##cdr _rest137211137219_)))
                  (let* ((_u137245_ _hd137216137240_)
                         (_rest137247_ _tl137217137242_))
                    (_K137215137237_ _rest137247_ _u137245_)))
                (_else137213137227_)))))))
  (define std/srfi/160/s8#s8vector-append-subvectors
    (lambda _args137061_
      (let* ((_len137122_
              (let _lp137064_ ((_rest137067_ _args137061_) (_r137069_ '0))
                (let* ((_rest137071137083_ _rest137067_)
                       (_else137073137091_ (lambda () _r137069_))
                       (_K137075137100_
                        (lambda (_rest137094_ _end137095_ _start137097_)
                          (_lp137064_
                           _rest137094_
                           (fx+ _r137069_ (fx- _end137095_ _start137097_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest137071137083_))
                      (let ((_tl137077137103_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest137071137083_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl137077137103_))
                            (let ((_hd137078137106_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl137077137103_)))
                                  (_tl137079137108_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl137077137103_))))
                              (let ((_start137111_ _hd137078137106_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl137079137108_))
                                    (let ((_hd137080137113_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl137079137108_)))
                                          (_tl137081137115_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl137079137108_))))
                                      (let* ((_end137118_ _hd137080137113_)
                                             (_rest137120_ _tl137081137115_))
                                        (_K137075137100_
                                         _rest137120_
                                         _end137118_
                                         _start137111_)))
                                    (_else137073137091_))))
                            (_else137073137091_)))
                      (_else137073137091_)))))
             (_v137125_ (make-s8vector _len137122_)))
        (let _lp137129_ ((_rest137131_ _args137061_) (_at137132_ '0))
          (let* ((_rest137134137146_ _rest137131_)
                 (_else137136137154_ (lambda () _v137125_))
                 (_K137138137163_
                  (lambda (_rest137157_ _end137158_ _start137159_ _u137160_)
                    (std/srfi/160/s8#s8vector-copy!
                     _v137125_
                     _at137132_
                     _u137160_
                     _start137159_
                     _end137158_)
                    (_lp137129_
                     _rest137157_
                     (fx+ _at137132_ (fx- _end137158_ _start137159_))))))
            (if (let () (declare (not safe)) (##pair? _rest137134137146_))
                (let ((_hd137139137166_
                       (let ()
                         (declare (not safe))
                         (##car _rest137134137146_)))
                      (_tl137140137168_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest137134137146_))))
                  (let ((_u137171_ _hd137139137166_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl137140137168_))
                        (let ((_hd137141137173_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl137140137168_)))
                              (_tl137142137175_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl137140137168_))))
                          (let ((_start137178_ _hd137141137173_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl137142137175_))
                                (let ((_hd137143137180_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl137142137175_)))
                                      (_tl137144137182_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl137142137175_))))
                                  (let* ((_end137185_ _hd137143137180_)
                                         (_rest137187_ _tl137144137182_))
                                    (_K137138137163_
                                     _rest137187_
                                     _end137185_
                                     _start137178_
                                     _u137171_)))
                                (_else137136137154_))))
                        (_else137136137154_))))
                (_else137136137154_)))))))
  (define std/srfi/160/s8#s8vector-empty?
    (lambda (_v137058_) (fxzero? (s8vector-length _v137058_))))
  (define std/srfi/160/s8#s8vector=
    (lambda (_v137000_ . _args137002_)
      (declare (not safe))
      (begin
        (if (s8vector? _v137000_) '#!void (error '"Bad argument" _v137000_))
        (let ((_vlen137006_ (s8vector-length _v137000_)))
          (let _lp137009_ ((_rest137012_ _args137002_))
            (let* ((_rest137014137022_ _rest137012_)
                   (_else137016137030_ (lambda () '#t))
                   (_K137018137046_
                    (lambda (_rest137033_ _u137034_)
                      (if (s8vector? _u137034_)
                          '#!void
                          (error '"Bad argument" _u137034_))
                      (let ((_ulen137037_ (s8vector-length _u137034_)))
                        (if (fx= _vlen137006_ _ulen137037_)
                            (let _cmp137040_ ((_i137043_ '0))
                              (if (fx< _i137043_ _vlen137006_)
                                  (if (= (s8vector-ref _v137000_ _i137043_)
                                         (s8vector-ref _u137034_ _i137043_))
                                      (_cmp137040_ (fx+ _i137043_ '1))
                                      '#f)
                                  (_lp137009_ _rest137033_)))
                            '#f)))))
              (if (##pair? _rest137014137022_)
                  (let ((_hd137019137049_ (##car _rest137014137022_))
                        (_tl137020137051_ (##cdr _rest137014137022_)))
                    (let* ((_u137054_ _hd137019137049_)
                           (_rest137056_ _tl137020137051_))
                      (_K137018137046_ _rest137056_ _u137054_)))
                  (_else137016137030_))))))))
  (define std/srfi/160/s8#s8vector-take
    (lambda (_v136992_ _n136994_)
      (let ((_u136997_ (make-s8vector _n136994_)))
        (std/srfi/160/s8#s8vector-copy! _u136997_ '0 _v136992_ '0 _n136994_)
        _u136997_)))
  (define std/srfi/160/s8#s8vector-take-right
    (lambda (_v136977_ _n136979_)
      (let* ((_vlen136982_ (s8vector-length _v136977_))
             (_ulen136985_ (fx- _vlen136982_ _n136979_))
             (_u136988_ (make-s8vector _ulen136985_)))
        (std/srfi/160/s8#s8vector-copy!
         _u136988_
         '0
         _v136977_
         _n136979_
         _vlen136982_)
        _u136988_)))
  (define std/srfi/160/s8#s8vector-drop
    (lambda (_v136962_ _n136964_)
      (let* ((_vlen136967_ (s8vector-length _v136962_))
             (_ulen136970_ (fx- _vlen136967_ _n136964_))
             (_u136973_ (make-s8vector _ulen136970_)))
        (std/srfi/160/s8#s8vector-copy!
         _u136973_
         '0
         _v136962_
         _n136964_
         _vlen136967_)
        _u136973_)))
  (define std/srfi/160/s8#s8vector-drop-right
    (lambda (_v136947_ _n136949_)
      (let* ((_vlen136952_ (s8vector-length _v136947_))
             (_ulen136955_ (fx- _vlen136952_ _n136949_))
             (_u136958_ (make-s8vector _ulen136955_)))
        (std/srfi/160/s8#s8vector-copy! _u136958_ '0 _v136947_ '0 _ulen136955_)
        _u136958_)))
  (define std/srfi/160/s8#s8vector-segment
    (lambda (_v136929_ _n136931_)
      (let _lp136934_ ((_i136937_ '0)
                       (_rest136939_ (s8vector-length _v136929_))
                       (_r136941_ '()))
        (if (fx> _r136941_ '0)
            (let ((_size136944_ (fxmin _n136931_ _rest136939_)))
              (_lp136934_
               (fx+ _i136937_ _size136944_)
               (fx- _rest136939_ _size136944_)
               (cons (std/srfi/160/s8#s8vector-copy__%
                      _v136929_
                      _i136937_
                      (fx+ _i136937_ _size136944_))
                     _r136941_)))
            (reverse _r136941_)))))
  (define std/srfi/160/s8#s8vector-fold__0
    (lambda (_kons136889_ _knil136891_ _v136893_)
      (if (procedure? _kons136889_)
          '#!void
          (error '"Bad argument; expected procedure" _kons136889_))
      (let ((_end136896_ (s8vector-length _v136893_)))
        (declare (not safe))
        (let _lp136900_ ((_i136903_ '0) (_r136905_ _knil136891_))
          (if (fx< _i136903_ _end136896_)
              (_lp136900_
               (fx+ _i136903_ '1)
               (_kons136889_ _r136905_ (s8vector-ref _v136893_ _i136903_)))
              _r136905_)))))
  (define std/srfi/160/s8#s8vector-fold__1
    (lambda (_kons136908_ _knil136909_ _v136910_ . _vs136911_)
      (if (procedure? _kons136908_)
          '#!void
          (error '"Bad argument; expected procedure" _kons136908_))
      (let* ((_vs136914_ (cons _v136910_ _vs136911_))
             (_end136916_ (apply fxmin (map s8vector-length _vs136914_))))
        (declare (not safe))
        (let _lp136920_ ((_i136922_ '0) (_r136923_ _knil136909_))
          (if (fx< _i136922_ _end136916_)
              (_lp136920_
               (fx+ _i136922_ '1)
               (apply _kons136908_
                      _r136923_
                      (map (lambda (_g136924136926_)
                             (s8vector-ref _g136924136926_ _i136922_))
                           _vs136914_)))
              _r136923_)))))
  (define std/srfi/160/s8#s8vector-fold
    (lambda _g299007_
      (let ((_g299006_ (let () (declare (not safe)) (##length _g299007_))))
        (cond ((let () (declare (not safe)) (##fx= _g299006_ 3))
               (apply std/srfi/160/s8#s8vector-fold__0 _g299007_))
              ((let () (declare (not safe)) (##fx>= _g299006_ 3))
               (apply std/srfi/160/s8#s8vector-fold__1 _g299007_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-fold
                _g299007_))))))
  (define std/srfi/160/s8#s8vector-fold-right__0
    (lambda (_kons136849_ _knil136851_ _v136853_)
      (if (procedure? _kons136849_)
          '#!void
          (error '"Bad argument; expected procedure" _kons136849_))
      (let ((_last136856_ (fx- (s8vector-length _v136853_) '1)))
        (declare (not safe))
        (let _lp136860_ ((_i136863_ _last136856_) (_r136865_ _knil136851_))
          (if (fx>= _i136863_ '0)
              (_lp136860_
               (fx- _i136863_ '1)
               (_kons136849_ _r136865_ (s8vector-ref _v136853_ _i136863_)))
              _r136865_)))))
  (define std/srfi/160/s8#s8vector-fold-right__1
    (lambda (_kons136868_ _knil136869_ _v136870_ . _vs136871_)
      (if (procedure? _kons136868_)
          '#!void
          (error '"Bad argument; expected procedure" _kons136868_))
      (let* ((_vs136874_ (cons _v136870_ _vs136871_))
             (_last136876_
              (fx- (apply min (map s8vector-length _vs136874_)) '1)))
        (declare (not safe))
        (let _lp136880_ ((_i136882_ _last136876_) (_r136883_ _knil136869_))
          (if (fx>= _i136882_ '0)
              (_lp136880_
               (fx- _i136882_ '1)
               (apply _kons136868_
                      _r136883_
                      (map (lambda (_g136884136886_)
                             (s8vector-ref _g136884136886_ _i136882_))
                           _vs136874_)))
              _r136883_)))))
  (define std/srfi/160/s8#s8vector-fold-right
    (lambda _g299009_
      (let ((_g299008_ (let () (declare (not safe)) (##length _g299009_))))
        (cond ((let () (declare (not safe)) (##fx= _g299008_ 3))
               (apply std/srfi/160/s8#s8vector-fold-right__0 _g299009_))
              ((let () (declare (not safe)) (##fx>= _g299008_ 3))
               (apply std/srfi/160/s8#s8vector-fold-right__1 _g299009_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-fold-right
                _g299009_))))))
  (define std/srfi/160/s8#s8vector-map__0
    (lambda (_f136809_ _v136811_)
      (if (procedure? _f136809_)
          '#!void
          (error '"Bad argument; expected procedure" _f136809_))
      (let* ((_len136814_ (s8vector-length _v136811_))
             (_u136817_ (make-s8vector _len136814_)))
        (declare (not safe))
        (let _lp136822_ ((_i136825_ '0))
          (if (fx< _i136825_ _len136814_)
              (begin
                (s8vector-set!
                 _u136817_
                 _i136825_
                 (s8vector-ref _v136811_ _i136825_))
                (_lp136822_ (fx+ _i136825_ '1)))
              _u136817_)))))
  (define std/srfi/160/s8#s8vector-map__1
    (lambda (_f136828_ _v136829_ . _vs136830_)
      (if (procedure? _f136828_)
          '#!void
          (error '"Bad argument; expected procedure" _f136828_))
      (let* ((_vs136833_ (cons _v136829_ _vs136830_))
             (_len136835_ (apply fxmin (map s8vector-length _vs136833_)))
             (_u136837_ (make-s8vector _len136835_)))
        (declare (not safe))
        (let _lp136841_ ((_i136843_ '0))
          (if (fx< _i136843_ _len136835_)
              (begin
                (s8vector-set!
                 _u136837_
                 _i136843_
                 (apply _f136828_
                        (map (lambda (_g136844136846_)
                               (s8vector-ref _g136844136846_ _i136843_))
                             _vs136833_)))
                (_lp136841_ (fx+ _i136843_ '1)))
              _u136837_)))))
  (define std/srfi/160/s8#s8vector-map
    (lambda _g299011_
      (let ((_g299010_ (let () (declare (not safe)) (##length _g299011_))))
        (cond ((let () (declare (not safe)) (##fx= _g299010_ 2))
               (apply std/srfi/160/s8#s8vector-map__0 _g299011_))
              ((let () (declare (not safe)) (##fx>= _g299010_ 2))
               (apply std/srfi/160/s8#s8vector-map__1 _g299011_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-map
                _g299011_))))))
  (define std/srfi/160/s8#s8vector-map!__0
    (lambda (_f136775_ _v136777_)
      (if (procedure? _f136775_)
          '#!void
          (error '"Bad argument; expected procedure" _f136775_))
      (let ((_len136780_ (s8vector-length _v136777_)))
        (declare (not safe))
        (let _lp136784_ ((_i136787_ '0))
          (if (fx< _i136787_ _len136780_)
              (begin
                (s8vector-set!
                 _v136777_
                 _i136787_
                 (_f136775_ (s8vector-ref _v136777_ _i136787_)))
                (_lp136784_ (fx+ _i136787_ '1)))
              _v136777_)))))
  (define std/srfi/160/s8#s8vector-map!__1
    (lambda (_f136790_ _v136791_ . _vs136792_)
      (if (procedure? _f136790_)
          '#!void
          (error '"Bad argument; expected procedure" _f136790_))
      (let* ((_vs136795_ (cons _v136791_ _vs136792_))
             (_len136797_ (apply fxmin (map s8vector-length _vs136795_))))
        (declare (not safe))
        (let _lp136801_ ((_i136803_ '0))
          (if (fx< _i136803_ _len136797_)
              (begin
                (s8vector-set!
                 _v136791_
                 _i136803_
                 (apply _f136790_
                        (map (lambda (_g136804136806_)
                               (s8vector-ref _g136804136806_ _i136803_))
                             _vs136795_)))
                (_lp136801_ (fx+ _i136803_ '1)))
              _v136791_)))))
  (define std/srfi/160/s8#s8vector-map!
    (lambda _g299013_
      (let ((_g299012_ (let () (declare (not safe)) (##length _g299013_))))
        (cond ((let () (declare (not safe)) (##fx= _g299012_ 2))
               (apply std/srfi/160/s8#s8vector-map!__0 _g299013_))
              ((let () (declare (not safe)) (##fx>= _g299012_ 2))
               (apply std/srfi/160/s8#s8vector-map!__1 _g299013_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-map!
                _g299013_))))))
  (define std/srfi/160/s8#s8vector-for-each__0
    (lambda (_f136741_ _v136743_)
      (if (procedure? _f136741_)
          '#!void
          (error '"Bad argument; expected procedure" _f136741_))
      (let ((_len136746_ (s8vector-length _v136743_)))
        (declare (not safe))
        (let _lp136750_ ((_i136753_ '0))
          (if (fx< _i136753_ _len136746_)
              (begin
                (_f136741_ (s8vector-ref _v136743_ _i136753_))
                (_lp136750_ (fx+ _i136753_ '1)))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-for-each__1
    (lambda (_f136756_ _v136757_ . _vs136758_)
      (let* ((_vs136761_ (cons _v136757_ _vs136758_))
             (_len136763_ (apply fxmin (map s8vector-length _vs136761_))))
        (declare (not safe))
        (let _lp136767_ ((_i136769_ '0))
          (if (fx< _i136769_ _len136763_)
              (begin
                (apply _f136756_
                       (map (lambda (_g136770136772_)
                              (s8vector-ref _g136770136772_ _i136769_))
                            _vs136761_))
                (_lp136767_ (fx+ _i136769_ '1)))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-for-each
    (lambda _g299015_
      (let ((_g299014_ (let () (declare (not safe)) (##length _g299015_))))
        (cond ((let () (declare (not safe)) (##fx= _g299014_ 2))
               (apply std/srfi/160/s8#s8vector-for-each__0 _g299015_))
              ((let () (declare (not safe)) (##fx>= _g299014_ 2))
               (apply std/srfi/160/s8#s8vector-for-each__1 _g299015_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-for-each
                _g299015_))))))
  (define std/srfi/160/s8#s8vector-count__0
    (lambda (_pred136704_ _v136706_)
      (if (procedure? _pred136704_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136704_))
      (let ((_end136709_ (s8vector-length _v136706_)))
        (declare (not safe))
        (let _lp136713_ ((_i136716_ '0) (_r136718_ '0))
          (if (fx< _i136716_ _end136709_)
              (if (_pred136704_ (s8vector-ref _v136706_ _i136716_))
                  (_lp136713_ (fx+ _i136716_ '1) (fx+ _r136718_ '1))
                  (_lp136713_ (fx+ _i136716_ '1) _r136718_))
              _r136718_)))))
  (define std/srfi/160/s8#s8vector-count__1
    (lambda (_pred136721_ _v136722_ . _vs136723_)
      (if (procedure? _pred136721_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136721_))
      (let* ((_vs136726_ (cons _v136722_ _vs136723_))
             (_end136728_ (apply fxmin (map s8vector-length _vs136726_))))
        (declare (not safe))
        (let _lp136732_ ((_i136734_ '0) (_r136735_ '0))
          (if (fx< _i136734_ _end136728_)
              (if (apply _pred136721_
                         (map (lambda (_g136736136738_)
                                (s8vector-ref _g136736136738_ _i136734_))
                              _vs136726_))
                  (_lp136732_ (fx+ _i136734_ '1) (fx+ _r136735_ '1))
                  (_lp136732_ (fx+ _i136734_ '1) _r136735_))
              _r136735_)))))
  (define std/srfi/160/s8#s8vector-count
    (lambda _g299017_
      (let ((_g299016_ (let () (declare (not safe)) (##length _g299017_))))
        (cond ((let () (declare (not safe)) (##fx= _g299016_ 2))
               (apply std/srfi/160/s8#s8vector-count__0 _g299017_))
              ((let () (declare (not safe)) (##fx>= _g299016_ 2))
               (apply std/srfi/160/s8#s8vector-count__1 _g299017_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-count
                _g299017_))))))
  (define std/srfi/160/s8#s8vector-cumulate
    (lambda (_f136679_ _knil136681_ _v136683_)
      (if (procedure? _f136679_)
          '#!void
          (error '"Bad argument; expected procedure" _f136679_))
      (let* ((_len136686_ (s8vector-length _v136683_))
             (_r136689_ (make-s8vector _len136686_)))
        (declare (not safe))
        (let _lp136694_ ((_i136697_ '0) (_r136699_ _knil136681_))
          (if (fx< _i136697_ _len136686_)
              (let ((_next136701_
                     (_f136679_ _r136699_ (s8vector-ref _v136683_ _i136697_))))
                (s8vector-set! _v136683_ _i136697_ _next136701_)
                (_lp136694_ (fx+ _i136697_ '1) _next136701_))
              _v136683_)))))
  (define std/srfi/160/s8#s8vector-take-while
    (lambda (_pred136662_ _v136664_)
      (let* ((_len136667_ (s8vector-length _v136664_))
             (_idx136670_
              (std/srfi/160/s8#s8vector-skip__0 _pred136662_ _v136664_))
             (_idx136676_
              (let ((_$e136673_ _idx136670_))
                (if _$e136673_ _$e136673_ _len136667_))))
        (std/srfi/160/s8#s8vector-copy__% _v136664_ '0 _idx136676_))))
  (define std/srfi/160/s8#s8vector-take-while-right
    (lambda (_pred136648_ _v136650_)
      (let* ((_len136653_ (s8vector-length _v136650_))
             (_idx136656_
              (std/srfi/160/s8#s8vector-skip-right__0 _pred136648_ _v136650_))
             (_idx136659_ (if _idx136656_ (fx+ _idx136656_ '1) '0)))
        (std/srfi/160/s8#s8vector-copy__% _v136650_ _idx136659_ _len136653_))))
  (define std/srfi/160/s8#s8vector-drop-while
    (lambda (_pred136631_ _v136633_)
      (let* ((_len136636_ (s8vector-length _v136633_))
             (_idx136639_
              (std/srfi/160/s8#s8vector-skip__0 _pred136631_ _v136633_))
             (_idx136645_
              (let ((_$e136642_ _idx136639_))
                (if _$e136642_ _$e136642_ _len136636_))))
        (std/srfi/160/s8#s8vector-copy__% _v136633_ _idx136645_ _len136636_))))
  (define std/srfi/160/s8#s8vector-drop-while-right
    (lambda (_pred136617_ _v136619_)
      (let* ((_len136622_ (s8vector-length _v136619_))
             (_idx136625_
              (std/srfi/160/s8#s8vector-skip-right__0 _pred136617_ _v136619_))
             (_idx136628_ (if _idx136625_ (fx+ _idx136625_ '1) '0)))
        (std/srfi/160/s8#s8vector-copy__% _v136619_ '0 _idx136628_))))
  (define std/srfi/160/s8#s8vector-index__0
    (lambda (_pred136583_ _v136585_)
      (if (procedure? _pred136583_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136583_))
      (let ((_end136588_ (s8vector-length _v136585_)))
        (declare (not safe))
        (let _lp136592_ ((_i136595_ '0))
          (if (fx< _i136595_ _end136588_)
              (if (_pred136583_ (s8vector-ref _v136585_ _i136595_))
                  _i136595_
                  (_lp136592_ (fx+ _i136595_ '1)))
              '#f)))))
  (define std/srfi/160/s8#s8vector-index__1
    (lambda (_pred136598_ _v136599_ . _vs136600_)
      (if (procedure? _pred136598_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136598_))
      (let* ((_vs136603_ (cons _v136599_ _vs136600_))
             (_end136605_ (apply fxmin (map s8vector-length _vs136603_))))
        (declare (not safe))
        (let _lp136609_ ((_i136611_ '0))
          (if (fx< _i136611_ _end136605_)
              (if (apply _pred136598_
                         (map (lambda (_g136612136614_)
                                (s8vector-ref _g136612136614_ _i136611_))
                              _vs136603_))
                  _i136611_
                  (_lp136609_ (fx+ _i136611_ '1)))
              '#f)))))
  (define std/srfi/160/s8#s8vector-index
    (lambda _g299019_
      (let ((_g299018_ (let () (declare (not safe)) (##length _g299019_))))
        (cond ((let () (declare (not safe)) (##fx= _g299018_ 2))
               (apply std/srfi/160/s8#s8vector-index__0 _g299019_))
              ((let () (declare (not safe)) (##fx>= _g299018_ 2))
               (apply std/srfi/160/s8#s8vector-index__1 _g299019_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-index
                _g299019_))))))
  (define std/srfi/160/s8#s8vector-index-right__0
    (lambda (_pred136549_ _v136551_)
      (if (procedure? _pred136549_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136549_))
      (let ((_start136554_ (fx- (s8vector-length _v136551_) '1)))
        (declare (not safe))
        (let _lp136558_ ((_i136561_ _start136554_))
          (if (fx>= _i136561_ '0)
              (if (_pred136549_ (s8vector-ref _v136551_ _i136561_))
                  _i136561_
                  (_lp136558_ (fx- _i136561_ '1)))
              '#f)))))
  (define std/srfi/160/s8#s8vector-index-right__1
    (lambda (_pred136564_ _v136565_ . _vs136566_)
      (if (procedure? _pred136564_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136564_))
      (let* ((_vs136569_ (cons _v136565_ _vs136566_))
             (_start136571_
              (fx- (apply fxmin (map s8vector-length _vs136569_)) '1)))
        (declare (not safe))
        (let _lp136575_ ((_i136577_ _start136571_))
          (if (fx>= _i136577_ '0)
              (if (apply _pred136564_
                         (map (lambda (_g136578136580_)
                                (s8vector-ref _g136578136580_ _i136577_))
                              _vs136569_))
                  _i136577_
                  (_lp136575_ (fx- _i136577_ '1)))
              '#f)))))
  (define std/srfi/160/s8#s8vector-index-right
    (lambda _g299021_
      (let ((_g299020_ (let () (declare (not safe)) (##length _g299021_))))
        (cond ((let () (declare (not safe)) (##fx= _g299020_ 2))
               (apply std/srfi/160/s8#s8vector-index-right__0 _g299021_))
              ((let () (declare (not safe)) (##fx>= _g299020_ 2))
               (apply std/srfi/160/s8#s8vector-index-right__1 _g299021_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-index-right
                _g299021_))))))
  (define std/srfi/160/s8#s8vector-skip__0
    (lambda (_pred136533_ _v136535_)
      (std/srfi/160/s8#s8vector-index__0
       (lambda (_$obj136538_) (not (_pred136533_ _$obj136538_)))
       _v136535_)))
  (define std/srfi/160/s8#s8vector-skip__1
    (lambda (_pred136541_ _v136542_ . _vs136543_)
      (apply std/srfi/160/s8#s8vector-index
             (lambda (_$obj136546_) (not (_pred136541_ _$obj136546_)))
             _v136542_
             _vs136543_)))
  (define std/srfi/160/s8#s8vector-skip
    (lambda _g299023_
      (let ((_g299022_ (let () (declare (not safe)) (##length _g299023_))))
        (cond ((let () (declare (not safe)) (##fx= _g299022_ 2))
               (apply std/srfi/160/s8#s8vector-skip__0 _g299023_))
              ((let () (declare (not safe)) (##fx>= _g299022_ 2))
               (apply std/srfi/160/s8#s8vector-skip__1 _g299023_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-skip
                _g299023_))))))
  (define std/srfi/160/s8#s8vector-skip-right__0
    (lambda (_pred136517_ _v136519_)
      (std/srfi/160/s8#s8vector-index-right__0
       (lambda (_$obj136522_) (not (_pred136517_ _$obj136522_)))
       _v136519_)))
  (define std/srfi/160/s8#s8vector-skip-right__1
    (lambda (_pred136525_ _v136526_ . _vs136527_)
      (apply std/srfi/160/s8#s8vector-index-right
             (lambda (_$obj136530_) (not (_pred136525_ _$obj136530_)))
             _v136526_
             _vs136527_)))
  (define std/srfi/160/s8#s8vector-skip-right
    (lambda _g299025_
      (let ((_g299024_ (let () (declare (not safe)) (##length _g299025_))))
        (cond ((let () (declare (not safe)) (##fx= _g299024_ 2))
               (apply std/srfi/160/s8#s8vector-skip-right__0 _g299025_))
              ((let () (declare (not safe)) (##fx>= _g299024_ 2))
               (apply std/srfi/160/s8#s8vector-skip-right__1 _g299025_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-skip-right
                _g299025_))))))
  (define std/srfi/160/s8#s8vector-any__0
    (lambda (_pred136477_ _v136479_)
      (if (procedure? _pred136477_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136477_))
      (let ((_end136482_ (s8vector-length _v136479_)))
        (declare (not safe))
        (let _lp136486_ ((_i136489_ '0))
          (if (fx< _i136489_ _end136482_)
              (let ((_$e136492_
                     (_pred136477_ (s8vector-ref _v136479_ _i136489_))))
                (if _$e136492_
                    (values _$e136492_)
                    (_lp136486_ (fx+ _i136489_ '1))))
              '#f)))))
  (define std/srfi/160/s8#s8vector-any__1
    (lambda (_pred136495_ _v136496_ . _vs136497_)
      (if (procedure? _pred136495_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136495_))
      (let* ((_v136500_ (cons _v136496_ _vs136497_))
             (_end136502_ (apply fxmin (map s8vector-length _vs136497_))))
        (declare (not safe))
        (let _lp136506_ ((_i136508_ '0))
          (if (fx< _i136508_ _end136502_)
              (let ((_$e136514_
                     (apply _pred136495_
                            (map (lambda (_g136509136511_)
                                   (s8vector-ref _g136509136511_ _i136508_))
                                 _vs136497_))))
                (if _$e136514_
                    (values _$e136514_)
                    (_lp136506_ (fx+ _i136508_ '1))))
              '#f)))))
  (define std/srfi/160/s8#s8vector-any
    (lambda _g299027_
      (let ((_g299026_ (let () (declare (not safe)) (##length _g299027_))))
        (cond ((let () (declare (not safe)) (##fx= _g299026_ 2))
               (apply std/srfi/160/s8#s8vector-any__0 _g299027_))
              ((let () (declare (not safe)) (##fx>= _g299026_ 2))
               (apply std/srfi/160/s8#s8vector-any__1 _g299027_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-any
                _g299027_))))))
  (define std/srfi/160/s8#s8vector-every__0
    (lambda (_pred136426_ _v136428_)
      (if (procedure? _pred136426_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136426_))
      (let ((_end136431_ (s8vector-length _v136428_)))
        (declare (not safe))
        (let _lp136435_ ((_i136438_ '0) (_r136440_ '#t))
          (if (fx< _i136438_ _end136431_)
              (let ((_$e136443_
                     (_pred136426_ (s8vector-ref _v136428_ _i136438_))))
                (if _$e136443_
                    ((lambda (_g136445136447_)
                       (_lp136435_ (fx+ _i136438_ '1) _g136445136447_))
                     _$e136443_)
                    '#f))
              _r136440_)))))
  (define std/srfi/160/s8#s8vector-every__1
    (lambda (_pred136450_ _v136451_ . _vs136452_)
      (if (procedure? _pred136450_)
          '#!void
          (error '"Bad argument; expected procedure" _pred136450_))
      (let* ((_v136455_ (cons _v136451_ _vs136452_))
             (_end136457_ (apply fxmin (map s8vector-length _vs136452_))))
        (declare (not safe))
        (let _lp136461_ ((_i136463_ '0) (_r136464_ '#t))
          (if (fx< _i136463_ _end136457_)
              (let ((_$e136470_
                     (apply _pred136450_
                            (map (lambda (_g136465136467_)
                                   (s8vector-ref _g136465136467_ _i136463_))
                                 _vs136452_))))
                (if _$e136470_
                    ((lambda (_g136472136474_)
                       (_lp136461_ (fx+ _i136463_ '1) _g136472136474_))
                     _$e136470_)
                    '#f))
              _r136464_)))))
  (define std/srfi/160/s8#s8vector-every
    (lambda _g299029_
      (let ((_g299028_ (let () (declare (not safe)) (##length _g299029_))))
        (cond ((let () (declare (not safe)) (##fx= _g299028_ 2))
               (apply std/srfi/160/s8#s8vector-every__0 _g299029_))
              ((let () (declare (not safe)) (##fx>= _g299028_ 2))
               (apply std/srfi/160/s8#s8vector-every__1 _g299029_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-every
                _g299029_))))))
  (define std/srfi/160/s8#s8vector-partition
    (lambda (_pred136397_ _v136399_)
      (let* ((_count136402_
              (std/srfi/160/s8#s8vector-count__0 _pred136397_ _v136399_))
             (_len136405_ (s8vector-length _v136399_))
             (_u136408_ (make-s8vector _len136405_)))
        (declare (not safe))
        (let _lp136413_ ((_i136416_ '0)
                         (_left136418_ '0)
                         (_right136420_ _count136402_))
          (if (fx< _i136416_ _len136405_)
              (let ((_x136423_ (s8vector-ref _v136399_ _i136416_)))
                (if (_pred136397_ _x136423_)
                    (begin
                      (s8vector-set! _u136408_ _left136418_ _x136423_)
                      (_lp136413_
                       (fx+ _i136416_ '1)
                       (fx+ _left136418_ '1)
                       _right136420_))
                    (begin
                      (s8vector-set! _u136408_ _right136420_ _x136423_)
                      (_lp136413_
                       (fx+ _i136416_ '1)
                       _left136418_
                       (fx+ _right136420_ '1)))))
              _u136408_)))))
  (define std/srfi/160/s8#s8vector-filter
    (lambda (_pred136370_ _v136372_)
      (let* ((_count136375_
              (std/srfi/160/s8#s8vector-count__0 _pred136370_ _v136372_))
             (_u136378_ (make-s8vector _count136375_))
             (_end136381_ (s8vector-length _v136372_)))
        (declare (not safe))
        (let _lp136386_ ((_i136389_ '0) (_j136391_ '0))
          (if (fx< _i136389_ _end136381_)
              (let ((_x136394_ (s8vector-ref _v136372_ _i136389_)))
                (if (_pred136370_ _x136394_)
                    (begin
                      (s8vector-set! _u136378_ _j136391_ _x136394_)
                      (_lp136386_ (fx+ _i136389_ '1) (fx+ _j136391_ '1)))
                    (_lp136386_ (fx+ _i136389_ '1) _j136391_)))
              _u136378_)))))
  (define std/srfi/160/s8#s8vector-remove
    (lambda (_pred136362_ _v136364_)
      (std/srfi/160/s8#s8vector-filter
       (lambda (_$obj136367_) (not (_pred136362_ _$obj136367_)))
       _v136364_)))
  (define std/srfi/160/s8#s8vector-swap
    (lambda (_v136349_ _i136351_ _j136353_)
      (let ((_iv136356_ (s8vector-ref _v136349_ _i136351_))
            (_jv136358_ (s8vector-ref _v136349_ _j136353_)))
        (declare (not safe))
        (begin
          (s8vector-set! _v136349_ _i136351_ _jv136358_)
          (s8vector-set! _v136349_ _j136353_ _iv136356_)))))
  (define std/srfi/160/s8#s8vector-fill!__%
    (lambda (_v136312_ _fill136314_ _start136316_ _end136318_)
      (declare (not safe))
      (begin
        (if (s8vector? _v136312_) '#!void (error '"Bad argument" _v136312_))
        (if (std/srfi/160/base#s8? _fill136314_)
            '#!void
            (error '"Bad argument" _fill136314_))
        (if (and (fixnum? _start136316_)
                 (fx<= '0 _start136316_ (fx- (s8vector-length _v136312_) '1)))
            '#!void
            (error '"Index out of range" _start136316_))
        (if (and (fixnum? _end136318_)
                 (fx<= _start136316_ _end136318_ (s8vector-length _v136312_)))
            '#!void
            (error '"Index out of range" _end136318_))
        (let _lp136322_ ((_i136325_ _start136316_))
          (if (fx< _i136325_ _end136318_)
              (begin
                (s8vector-set! _v136312_ _i136325_ _fill136314_)
                (_lp136322_ (fx+ _i136325_ '1)))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-fill!__0
    (lambda (_v136331_ _fill136332_)
      (let* ((_start136334_ '0) (_end136336_ (s8vector-length _v136331_)))
        (std/srfi/160/s8#s8vector-fill!__%
         _v136331_
         _fill136332_
         _start136334_
         _end136336_))))
  (define std/srfi/160/s8#s8vector-fill!__1
    (lambda (_v136338_ _fill136339_ _start136340_)
      (let ((_end136342_ (s8vector-length _v136338_)))
        (std/srfi/160/s8#s8vector-fill!__%
         _v136338_
         _fill136339_
         _start136340_
         _end136342_))))
  (define std/srfi/160/s8#s8vector-fill!
    (lambda _g299031_
      (let ((_g299030_ (let () (declare (not safe)) (##length _g299031_))))
        (cond ((let () (declare (not safe)) (##fx= _g299030_ 2))
               (apply std/srfi/160/s8#s8vector-fill!__0 _g299031_))
              ((let () (declare (not safe)) (##fx= _g299030_ 3))
               (apply std/srfi/160/s8#s8vector-fill!__1 _g299031_))
              ((let () (declare (not safe)) (##fx= _g299030_ 4))
               (apply std/srfi/160/s8#s8vector-fill!__% _g299031_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-fill!
                _g299031_))))))
  (define std/srfi/160/s8#s8vector-reverse!__%
    (lambda (_v136272_ _start136274_ _end136276_)
      (declare (not safe))
      (begin
        (if (s8vector? _v136272_) '#!void (error '"Bad argument" _v136272_))
        (if (and (fixnum? _start136274_)
                 (fx<= '0 _start136274_ (fx- (s8vector-length _v136272_) '1)))
            '#!void
            (error '"Index out of range" _start136274_))
        (if (and (fixnum? _end136276_)
                 (fx<= _start136274_ _end136276_ (s8vector-length _v136272_)))
            '#!void
            (error '"Index out of range" _end136276_))
        (let _lp136280_ ((_i136283_ _start136274_)
                         (_j136285_ (fx- _end136276_ '1)))
          (if (fx< _i136283_ _j136285_)
              (let ((_iv136288_ (s8vector-ref _v136272_ _i136283_))
                    (_jv136290_ (s8vector-ref _v136272_ _j136285_)))
                (s8vector-set! _v136272_ _i136283_ _jv136290_)
                (s8vector-set! _v136272_ _j136285_ _iv136288_)
                (_lp136280_ (fx+ _i136283_ '1) (fx- _j136285_ '1)))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-reverse!__0
    (lambda (_v136296_)
      (let* ((_start136298_ '0) (_end136300_ (s8vector-length _v136296_)))
        (std/srfi/160/s8#s8vector-reverse!__%
         _v136296_
         _start136298_
         _end136300_))))
  (define std/srfi/160/s8#s8vector-reverse!__1
    (lambda (_v136302_ _start136303_)
      (let ((_end136305_ (s8vector-length _v136302_)))
        (std/srfi/160/s8#s8vector-reverse!__%
         _v136302_
         _start136303_
         _end136305_))))
  (define std/srfi/160/s8#s8vector-reverse!
    (lambda _g299033_
      (let ((_g299032_ (let () (declare (not safe)) (##length _g299033_))))
        (cond ((let () (declare (not safe)) (##fx= _g299032_ 1))
               (apply std/srfi/160/s8#s8vector-reverse!__0 _g299033_))
              ((let () (declare (not safe)) (##fx= _g299032_ 2))
               (apply std/srfi/160/s8#s8vector-reverse!__1 _g299033_))
              ((let () (declare (not safe)) (##fx= _g299032_ 3))
               (apply std/srfi/160/s8#s8vector-reverse!__% _g299033_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector-reverse!
                _g299033_))))))
  (define std/srfi/160/s8#s8vector-unfold!
    (lambda (_f136247_ _v136249_ _start136251_ _end136253_ _seed136255_)
      (declare (not safe))
      (begin
        (if (procedure? _f136247_)
            '#!void
            (error '"Bad argument; expected procedure" _f136247_))
        (if (s8vector? _v136249_) '#!void (error '"Bad argument" _v136249_))
        (if (and (fixnum? _start136251_)
                 (fx<= '0 _start136251_ (fx- (s8vector-length _v136249_) '1)))
            '#!void
            (error '"Index out of range" _start136251_))
        (if (and (fixnum? _end136253_)
                 (fx<= _start136251_ _end136253_ (s8vector-length _v136249_)))
            '#!void
            (error '"Index out of range" _end136253_))
        (let _lp136259_ ((_i136262_ _start136251_)
                         (_state136264_ _seed136255_))
          (if (fx< _i136262_ _end136253_)
              (let ((_g299034_ (_f136247_ _state136264_)))
                (begin
                  (let ((_g299035_
                         (if (##values? _g299034_)
                             (##vector-length _g299034_)
                             1)))
                    (if (not (##fx= _g299035_ 2))
                        (error "Context expects 2 values" _g299035_)))
                  (let ((_x136267_ (##vector-ref _g299034_ 0))
                        (_state136269_ (##vector-ref _g299034_ 1)))
                    (begin
                      (s8vector-set! _v136249_ _i136262_ _x136267_)
                      (_lp136259_ (fx+ _i136262_ '1) _state136269_)))))
              '#!void)))))
  (define std/srfi/160/s8#s8vector-unfold-right!
    (lambda (_f136223_ _v136225_ _start136227_ _end136229_ _seed136231_)
      (declare (not safe))
      (begin
        (if (procedure? _f136223_)
            '#!void
            (error '"Bad argument; expected procedure" _f136223_))
        (if (s8vector? _v136225_) '#!void (error '"Bad argument" _v136225_))
        (if (and (fixnum? _start136227_)
                 (fx<= '0 _start136227_ (fx- (s8vector-length _v136225_) '1)))
            '#!void
            (error '"Index out of range" _start136227_))
        (if (and (fixnum? _end136229_)
                 (fx<= _start136227_ _end136229_ (s8vector-length _v136225_)))
            '#!void
            (error '"Index out of range" _end136229_))
        (let _lp136235_ ((_i136238_ (fx- _end136229_ '1))
                         (_state136240_ _seed136231_))
          (if (fx>= _i136238_ _start136227_)
              (let ((_g299036_ (_f136223_ _state136240_)))
                (begin
                  (let ((_g299037_
                         (if (##values? _g299036_)
                             (##vector-length _g299036_)
                             1)))
                    (if (not (##fx= _g299037_ 2))
                        (error "Context expects 2 values" _g299037_)))
                  (let ((_x136243_ (##vector-ref _g299036_ 0))
                        (_state136245_ (##vector-ref _g299036_ 1)))
                    (begin
                      (s8vector-set! _v136225_ _i136238_ _x136243_)
                      (_lp136235_ (fx- _i136238_ '1) _state136245_)))))
              '#!void)))))
  (define std/srfi/160/s8#reverse-s8vector->list__%
    (lambda (_v136189_ _start136191_ _end136193_)
      (declare (not safe))
      (begin
        (if (s8vector? _v136189_) '#!void (error '"Bad argument" _v136189_))
        (if (and (fixnum? _start136191_)
                 (fx<= '0 _start136191_ (fx- (s8vector-length _v136189_) '1)))
            '#!void
            (error '"Index out of range" _start136191_))
        (if (and (fixnum? _end136193_)
                 (fx<= _start136191_ _end136193_ (s8vector-length _v136189_)))
            '#!void
            (error '"Index out of range" _end136193_))
        (let _lp136197_ ((_i136200_ _start136191_) (_r136202_ '()))
          (if (fx< _i136200_ _end136193_)
              (_lp136197_
               (fx+ _i136200_ '1)
               (cons (s8vector-ref _v136189_ _i136200_) _r136202_))
              _r136202_)))))
  (define std/srfi/160/s8#reverse-s8vector->list__0
    (lambda (_v136208_)
      (let* ((_start136210_ '0) (_end136212_ (s8vector-length _v136208_)))
        (std/srfi/160/s8#reverse-s8vector->list__%
         _v136208_
         _start136210_
         _end136212_))))
  (define std/srfi/160/s8#reverse-s8vector->list__1
    (lambda (_v136214_ _start136215_)
      (let ((_end136217_ (s8vector-length _v136214_)))
        (std/srfi/160/s8#reverse-s8vector->list__%
         _v136214_
         _start136215_
         _end136217_))))
  (define std/srfi/160/s8#reverse-s8vector->list
    (lambda _g299039_
      (let ((_g299038_ (let () (declare (not safe)) (##length _g299039_))))
        (cond ((let () (declare (not safe)) (##fx= _g299038_ 1))
               (apply std/srfi/160/s8#reverse-s8vector->list__0 _g299039_))
              ((let () (declare (not safe)) (##fx= _g299038_ 2))
               (apply std/srfi/160/s8#reverse-s8vector->list__1 _g299039_))
              ((let () (declare (not safe)) (##fx= _g299038_ 3))
               (apply std/srfi/160/s8#reverse-s8vector->list__% _g299039_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#reverse-s8vector->list
                _g299039_))))))
  (define std/srfi/160/s8#reverse-list->s8vector
    (lambda (_lst136135_)
      (let* ((_len136138_ (length _lst136135_))
             (_v136141_ (make-s8vector _len136138_)))
        (declare (not safe))
        (let _lp136146_ ((_rest136149_ _lst136135_) (_i136151_ '0))
          (let* ((_rest136153136161_ _rest136149_)
                 (_else136155136169_ (lambda () _v136141_))
                 (_K136157136176_
                  (lambda (_rest136172_ _x136173_)
                    (if (std/srfi/160/base#s8? _x136173_)
                        '#!void
                        (error '"Bad element" _x136173_))
                    (s8vector-set! _v136141_ _i136151_ _x136173_)
                    (_lp136146_ _rest136172_ (fx+ _i136151_ '1)))))
            (if (##pair? _rest136153136161_)
                (let ((_hd136158136179_ (##car _rest136153136161_))
                      (_tl136159136181_ (##cdr _rest136153136161_)))
                  (let* ((_x136184_ _hd136158136179_)
                         (_rest136186_ _tl136159136181_))
                    (_K136157136176_ _rest136186_ _x136184_)))
                (_else136155136169_)))))))
  (define std/srfi/160/s8#s8vector->vector__%
    (lambda (_v136096_ _start136098_ _end136100_)
      (declare (not safe))
      (begin
        (if (s8vector? _v136096_) '#!void (error '"Bad argument" _v136096_))
        (if (and (fixnum? _start136098_)
                 (fx<= '0 _start136098_ (fx- (s8vector-length _v136096_) '1)))
            '#!void
            (error '"Index out of range" _start136098_))
        (if (and (fixnum? _end136100_)
                 (fx<= _start136098_ _end136100_ (s8vector-length _v136096_)))
            '#!void
            (error '"Index out of range" _end136100_))
        (let* ((_len136104_ (s8vector-length _v136096_))
               (_u136107_ (make-vector _len136104_)))
          (let _lp136111_ ((_i136114_ '0))
            (if (fx< _i136114_ _len136104_)
                (begin
                  (vector-set!
                   _u136107_
                   _i136114_
                   (s8vector-ref _v136096_ _i136114_))
                  (_lp136111_ (fx+ _i136114_ '1)))
                _u136107_))))))
  (define std/srfi/160/s8#s8vector->vector__0
    (lambda (_v136120_)
      (let* ((_start136122_ '0) (_end136124_ (s8vector-length _v136120_)))
        (std/srfi/160/s8#s8vector->vector__%
         _v136120_
         _start136122_
         _end136124_))))
  (define std/srfi/160/s8#s8vector->vector__1
    (lambda (_v136126_ _start136127_)
      (let ((_end136129_ (s8vector-length _v136126_)))
        (std/srfi/160/s8#s8vector->vector__%
         _v136126_
         _start136127_
         _end136129_))))
  (define std/srfi/160/s8#s8vector->vector
    (lambda _g299041_
      (let ((_g299040_ (let () (declare (not safe)) (##length _g299041_))))
        (cond ((let () (declare (not safe)) (##fx= _g299040_ 1))
               (apply std/srfi/160/s8#s8vector->vector__0 _g299041_))
              ((let () (declare (not safe)) (##fx= _g299040_ 2))
               (apply std/srfi/160/s8#s8vector->vector__1 _g299041_))
              ((let () (declare (not safe)) (##fx= _g299040_ 3))
               (apply std/srfi/160/s8#s8vector->vector__% _g299041_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#s8vector->vector
                _g299041_))))))
  (define std/srfi/160/s8#vector->s8vector__%
    (lambda (_v136056_ _start136058_ _end136060_)
      (declare (not safe))
      (begin
        (if (vector? _v136056_)
            '#!void
            (error '"Bad argument; expected vector" _v136056_))
        (if (and (fixnum? _start136058_)
                 (fx<= '0 _start136058_ (fx- (vector-length _v136056_) '1)))
            '#!void
            (error '"Index out of range" _start136058_))
        (if (and (fixnum? _end136060_)
                 (fx<= _start136058_ _end136060_ (vector-length _v136056_)))
            '#!void
            (error '"Index out of range" _end136060_))
        (let* ((_len136064_ (vector-length _v136056_))
               (_u136067_ (make-s8vector _len136064_)))
          (let _lp136071_ ((_i136074_ '0))
            (if (fx< _i136074_ _len136064_)
                (begin
                  (s8vector-set!
                   _u136067_
                   _i136074_
                   (vector-ref _v136056_ _i136074_))
                  (_lp136071_ (fx+ _i136074_ '1)))
                _u136067_))))))
  (define std/srfi/160/s8#vector->s8vector__0
    (lambda (_v136080_)
      (let* ((_start136082_ '0) (_end136084_ (vector-length _v136080_)))
        (std/srfi/160/s8#vector->s8vector__%
         _v136080_
         _start136082_
         _end136084_))))
  (define std/srfi/160/s8#vector->s8vector__1
    (lambda (_v136086_ _start136087_)
      (let ((_end136089_ (vector-length _v136086_)))
        (std/srfi/160/s8#vector->s8vector__%
         _v136086_
         _start136087_
         _end136089_))))
  (define std/srfi/160/s8#vector->s8vector
    (lambda _g299043_
      (let ((_g299042_ (let () (declare (not safe)) (##length _g299043_))))
        (cond ((let () (declare (not safe)) (##fx= _g299042_ 1))
               (apply std/srfi/160/s8#vector->s8vector__0 _g299043_))
              ((let () (declare (not safe)) (##fx= _g299042_ 2))
               (apply std/srfi/160/s8#vector->s8vector__1 _g299043_))
              ((let () (declare (not safe)) (##fx= _g299042_ 3))
               (apply std/srfi/160/s8#vector->s8vector__% _g299043_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#vector->s8vector
                _g299043_))))))
  (define std/srfi/160/s8#make-s8vector-generator__%
    (lambda (_v136022_ _start136024_ _end136026_)
      (declare (not safe))
      (begin
        (if (s8vector? _v136022_) '#!void (error '"Bad argument" _v136022_))
        (if (and (fixnum? _start136024_)
                 (fx<= '0 _start136024_ (fx- (s8vector-length _v136022_) '1)))
            '#!void
            (error '"Index out of range" _start136024_))
        (if (and (fixnum? _end136026_)
                 (fx<= _start136024_ _end136026_ (s8vector-length _v136022_)))
            '#!void
            (error '"Index out of range" _end136026_))
        (let ((_i136030_ _start136024_))
          (lambda ()
            (if (fx< _i136030_ _end136026_)
                (let ((_next136034_ (s8vector-ref _v136022_ _i136030_)))
                  (set! _i136030_ (fx+ _i136030_ '1))
                  _next136034_)
                '#!eof))))))
  (define std/srfi/160/s8#make-s8vector-generator__0
    (lambda (_v136040_)
      (let* ((_start136042_ '0) (_end136044_ (s8vector-length _v136040_)))
        (std/srfi/160/s8#make-s8vector-generator__%
         _v136040_
         _start136042_
         _end136044_))))
  (define std/srfi/160/s8#make-s8vector-generator__1
    (lambda (_v136046_ _start136047_)
      (let ((_end136049_ (s8vector-length _v136046_)))
        (std/srfi/160/s8#make-s8vector-generator__%
         _v136046_
         _start136047_
         _end136049_))))
  (define std/srfi/160/s8#make-s8vector-generator
    (lambda _g299045_
      (let ((_g299044_ (let () (declare (not safe)) (##length _g299045_))))
        (cond ((let () (declare (not safe)) (##fx= _g299044_ 1))
               (apply std/srfi/160/s8#make-s8vector-generator__0 _g299045_))
              ((let () (declare (not safe)) (##fx= _g299044_ 2))
               (apply std/srfi/160/s8#make-s8vector-generator__1 _g299045_))
              ((let () (declare (not safe)) (##fx= _g299044_ 3))
               (apply std/srfi/160/s8#make-s8vector-generator__% _g299045_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#make-s8vector-generator
                _g299045_))))))
  (define std/srfi/160/s8#s8vector-comparator
    (let ()
      (letrec ((_<?135993_
                (lambda (_a135996_ _b135998_)
                  (let ((_len-a136001_ (s8vector-length _a135996_))
                        (_len-b136003_ (s8vector-length _b135998_)))
                    (declare (not safe))
                    (if (fx< _len-a136001_ _len-b136003_)
                        '#t
                        (if (fx> _len-a136001_ _len-b136003_)
                            '#f
                            (let ((_end136007_ _len-a136001_))
                              (let _lp136010_ ((_i136013_ '0))
                                (if (fx< _i136013_ _end136007_)
                                    (let ((_x136016_
                                           (s8vector-ref _a135996_ _i136013_))
                                          (_y136018_
                                           (s8vector-ref _b135998_ _i136013_)))
                                      (if (< _x136016_ _y136018_)
                                          '#t
                                          (if (> _x136016_ _y136018_)
                                              '#f
                                              (_lp136010_
                                               (fx+ _i136013_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           s8vector?
           std/srfi/160/s8#s8vector=
           _<?135993_
           equal?-hash)))))
  (define std/srfi/160/s8#write-s8vector__%
    (lambda (_v135970_ _port135972_)
      (let ((_$e135975_ (find-method _v135970_ ':write)))
        (if _$e135975_
            ((lambda (_g135977135979_)
               (_g135977135979_ _v135970_ _port135972_))
             _$e135975_)
            (write _v135970_ (current-output-port))))))
  (define std/srfi/160/s8#write-s8vector__0
    (lambda (_v135985_)
      (let ((_port135987_ (current-output-port)))
        (std/srfi/160/s8#write-s8vector__% _v135985_ _port135987_))))
  (define std/srfi/160/s8#write-s8vector
    (lambda _g299047_
      (let ((_g299046_ (let () (declare (not safe)) (##length _g299047_))))
        (cond ((let () (declare (not safe)) (##fx= _g299046_ 1))
               (apply std/srfi/160/s8#write-s8vector__0 _g299047_))
              ((let () (declare (not safe)) (##fx= _g299046_ 2))
               (apply std/srfi/160/s8#write-s8vector__% _g299047_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s8#write-s8vector
                _g299047_)))))))
