(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/u16#u16vector-unfold
    (lambda (_f138800_ _len138802_ _seed138804_)
      (declare (not safe))
      (begin
        (if (procedure? _f138800_)
            '#!void
            (error '"Bad argument; expected procedure" _f138800_))
        (let ((_v138808_ (make-u16vector _len138802_)))
          (let _lp138811_ ((_i138814_ '0) (_state138816_ _seed138804_))
            (if (fx< _i138814_ _len138802_)
                (let ((_g299048_ (_f138800_ _i138814_ _state138816_)))
                  (begin
                    (let ((_g299049_
                           (if (##values? _g299048_)
                               (##vector-length _g299048_)
                               1)))
                      (if (not (##fx= _g299049_ 2))
                          (error "Context expects 2 values" _g299049_)))
                    (let ((_x138819_ (##vector-ref _g299048_ 0))
                          (_state138821_ (##vector-ref _g299048_ 1)))
                      (begin
                        (if (std/srfi/160/base#u16? _x138819_)
                            '#!void
                            (error '"Bad generated value" _x138819_))
                        (u16vector-set! _v138808_ _i138814_ _x138819_)
                        (_lp138811_ (fx+ _i138814_ '1) _state138821_)))))
                _v138808_))))))
  (define std/srfi/160/u16#u16vector-unfold-right
    (lambda (_f138777_ _len138779_ _seed138781_)
      (declare (not safe))
      (begin
        (if (procedure? _f138777_)
            '#!void
            (error '"Bad argument; expected procedure" _f138777_))
        (let ((_v138785_ (make-u16vector _len138779_)))
          (let _lp138788_ ((_i138791_ (fx- _len138779_ '1))
                           (_state138793_ _seed138781_))
            (if (fx>= _i138791_ '0)
                (let ((_g299050_ (_f138777_ _i138791_ _state138793_)))
                  (begin
                    (let ((_g299051_
                           (if (##values? _g299050_)
                               (##vector-length _g299050_)
                               1)))
                      (if (not (##fx= _g299051_ 2))
                          (error "Context expects 2 values" _g299051_)))
                    (let ((_x138796_ (##vector-ref _g299050_ 0))
                          (_state138798_ (##vector-ref _g299050_ 1)))
                      (begin
                        (if (std/srfi/160/base#u16? _x138796_)
                            '#!void
                            (error '"Bad generated value" _x138796_))
                        (u16vector-set! _v138785_ _i138791_ _x138796_)
                        (_lp138788_ (fx- _i138791_ '1) _state138798_)))))
                _v138785_))))))
  (define std/srfi/160/u16#u16vector-copy__%
    (lambda (_vec138749_ _start138751_ _end138753_)
      (let ((_v138756_ (make-u16vector (fx- _end138753_ _start138751_))))
        (std/srfi/160/u16#u16vector-copy!
         _v138756_
         '0
         _vec138749_
         _start138751_
         _end138753_)
        _v138756_)))
  (define std/srfi/160/u16#u16vector-copy__0
    (lambda (_vec138762_)
      (let* ((_start138764_ '0) (_end138766_ (u16vector-length _vec138762_)))
        (std/srfi/160/u16#u16vector-copy__%
         _vec138762_
         _start138764_
         _end138766_))))
  (define std/srfi/160/u16#u16vector-copy__1
    (lambda (_vec138768_ _start138769_)
      (let ((_end138771_ (u16vector-length _vec138768_)))
        (std/srfi/160/u16#u16vector-copy__%
         _vec138768_
         _start138769_
         _end138771_))))
  (define std/srfi/160/u16#u16vector-copy
    (lambda _g299053_
      (let ((_g299052_ (let () (declare (not safe)) (##length _g299053_))))
        (cond ((let () (declare (not safe)) (##fx= _g299052_ 1))
               (apply std/srfi/160/u16#u16vector-copy__0 _g299053_))
              ((let () (declare (not safe)) (##fx= _g299052_ 2))
               (apply std/srfi/160/u16#u16vector-copy__1 _g299053_))
              ((let () (declare (not safe)) (##fx= _g299052_ 3))
               (apply std/srfi/160/u16#u16vector-copy__% _g299053_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-copy
                _g299053_))))))
  (define std/srfi/160/u16#u16vector-copy!
    (lambda (_to138728_ _at138730_ _from138732_ _start138734_ _end138736_)
      (declare (not safe))
      (begin
        (if (u16vector? _to138728_) '#!void (error '"Bad argument" _to138728_))
        (if (u16vector? _from138732_)
            '#!void
            (error '"Bad argument" _from138732_))
        (if (and (fixnum? _at138730_)
                 (fx<= '0 _at138730_ (fx- (u16vector-length _at138730_) '1)))
            '#!void
            (error '"Index out of range" _to138728_ _at138730_))
        (if (and (fixnum? _start138734_)
                 (fx<= '0
                       _start138734_
                       (fx- (u16vector-length _from138732_) '1)))
            '#!void
            (error '"Index out of range" _from138732_ _start138734_))
        (if (and (fixnum? _end138736_)
                 (fx<= _start138734_
                       _end138736_
                       (u16vector-length _from138732_)))
            '#!void
            (error '"Index out of range" _from138732_ _end138736_))
        (if (fx<= (fx- _end138736_ _start138734_)
                  (fx- (u16vector-length _to138728_) _at138730_))
            '#!void
            (error '"Destination area too small"
                   _to138728_
                   _at138730_
                   _from138732_
                   _start138734_
                   _end138736_))
        (let _lp138740_ ((_i138743_ _start138734_) (_j138745_ _at138730_))
          (if (fx< _i138743_ _end138736_)
              (begin
                (u16vector-set!
                 _to138728_
                 _j138745_
                 (u16vector-ref _from138732_ _i138743_))
                (_lp138740_ (fx+ _i138743_ '1) (fx+ _j138745_ '1)))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-reverse-copy__%
    (lambda (_vec138700_ _start138702_ _end138704_)
      (let ((_v138707_ (make-u16vector (fx- _end138704_ _start138702_))))
        (std/srfi/160/u16#u16vector-reverse-copy!
         _v138707_
         '0
         _vec138700_
         _start138702_
         _end138704_)
        _v138707_)))
  (define std/srfi/160/u16#u16vector-reverse-copy__0
    (lambda (_vec138713_)
      (let* ((_start138715_ '0) (_end138717_ (u16vector-length _vec138713_)))
        (std/srfi/160/u16#u16vector-reverse-copy__%
         _vec138713_
         _start138715_
         _end138717_))))
  (define std/srfi/160/u16#u16vector-reverse-copy__1
    (lambda (_vec138719_ _start138720_)
      (let ((_end138722_ (u16vector-length _vec138719_)))
        (std/srfi/160/u16#u16vector-reverse-copy__%
         _vec138719_
         _start138720_
         _end138722_))))
  (define std/srfi/160/u16#u16vector-reverse-copy
    (lambda _g299055_
      (let ((_g299054_ (let () (declare (not safe)) (##length _g299055_))))
        (cond ((let () (declare (not safe)) (##fx= _g299054_ 1))
               (apply std/srfi/160/u16#u16vector-reverse-copy__0 _g299055_))
              ((let () (declare (not safe)) (##fx= _g299054_ 2))
               (apply std/srfi/160/u16#u16vector-reverse-copy__1 _g299055_))
              ((let () (declare (not safe)) (##fx= _g299054_ 3))
               (apply std/srfi/160/u16#u16vector-reverse-copy__% _g299055_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-reverse-copy
                _g299055_))))))
  (define std/srfi/160/u16#u16vector-reverse-copy!
    (lambda (_to138679_ _at138681_ _from138683_ _start138685_ _end138687_)
      (declare (not safe))
      (begin
        (if (u16vector? _to138679_) '#!void (error '"Bad argument" _to138679_))
        (if (u16vector? _from138683_)
            '#!void
            (error '"Bad argument" _from138683_))
        (if (and (fixnum? _at138681_)
                 (fx<= '0 _at138681_ (fx- (u16vector-length _at138681_) '1)))
            '#!void
            (error '"Index out of range" _to138679_ _at138681_))
        (if (and (fixnum? _start138685_)
                 (fx<= '0
                       _start138685_
                       (fx- (u16vector-length _from138683_) '1)))
            '#!void
            (error '"Index out of range" _from138683_ _start138685_))
        (if (and (fixnum? _end138687_)
                 (fx<= _start138685_
                       _end138687_
                       (u16vector-length _from138683_)))
            '#!void
            (error '"Index out of range" _from138683_ _end138687_))
        (if (fx<= (fx- _end138687_ _start138685_)
                  (fx- (u16vector-length _to138679_) _at138681_))
            '#!void
            (error '"Destination area too small"
                   _to138679_
                   _at138681_
                   _from138683_
                   _start138685_
                   _end138687_))
        (let _lp138691_ ((_i138694_ (fx- _end138687_ '1))
                         (_j138696_ _at138681_))
          (if (fx>= _i138694_ _start138685_)
              (begin
                (u16vector-set!
                 _to138679_
                 _j138696_
                 (u16vector-ref _from138683_ _i138694_))
                (_lp138691_ (fx- _i138694_ '1) (fx+ _j138696_ '1)))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-append
    (lambda _args138676_
      (std/srfi/160/u16#u16vector-concatenate _args138676_)))
  (define std/srfi/160/u16#u16vector-concatenate
    (lambda (_lst138616_)
      (let* ((_len138624_
              (foldl1 (lambda (_v138619_ _r138621_)
                        (fx+ (u16vector-length _v138619_) _r138621_))
                      '0
                      _lst138616_))
             (_v138627_ (make-u16vector _len138624_)))
        (declare (not safe))
        (let _lp138631_ ((_rest138634_ _lst138616_) (_at138636_ '0))
          (let* ((_rest138638138646_ _rest138634_)
                 (_else138640138654_ (lambda () _v138627_))
                 (_K138642138664_
                  (lambda (_rest138657_ _u138658_)
                    (let ((_ulen138661_ (u16vector-length _u138658_)))
                      (std/srfi/160/u16#u16vector-copy!
                       _v138627_
                       _at138636_
                       _u138658_
                       '0
                       _ulen138661_)
                      (_lp138631_
                       _rest138657_
                       (fx+ _at138636_ _ulen138661_))))))
            (if (##pair? _rest138638138646_)
                (let ((_hd138643138667_ (##car _rest138638138646_))
                      (_tl138644138669_ (##cdr _rest138638138646_)))
                  (let* ((_u138672_ _hd138643138667_)
                         (_rest138674_ _tl138644138669_))
                    (_K138642138664_ _rest138674_ _u138672_)))
                (_else138640138654_)))))))
  (define std/srfi/160/u16#u16vector-append-subvectors
    (lambda _args138488_
      (let* ((_len138549_
              (let _lp138491_ ((_rest138494_ _args138488_) (_r138496_ '0))
                (let* ((_rest138498138510_ _rest138494_)
                       (_else138500138518_ (lambda () _r138496_))
                       (_K138502138527_
                        (lambda (_rest138521_ _end138522_ _start138524_)
                          (_lp138491_
                           _rest138521_
                           (fx+ _r138496_ (fx- _end138522_ _start138524_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest138498138510_))
                      (let ((_tl138504138530_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest138498138510_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl138504138530_))
                            (let ((_hd138505138533_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl138504138530_)))
                                  (_tl138506138535_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl138504138530_))))
                              (let ((_start138538_ _hd138505138533_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl138506138535_))
                                    (let ((_hd138507138540_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl138506138535_)))
                                          (_tl138508138542_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl138506138535_))))
                                      (let* ((_end138545_ _hd138507138540_)
                                             (_rest138547_ _tl138508138542_))
                                        (_K138502138527_
                                         _rest138547_
                                         _end138545_
                                         _start138538_)))
                                    (_else138500138518_))))
                            (_else138500138518_)))
                      (_else138500138518_)))))
             (_v138552_ (make-u16vector _len138549_)))
        (let _lp138556_ ((_rest138558_ _args138488_) (_at138559_ '0))
          (let* ((_rest138561138573_ _rest138558_)
                 (_else138563138581_ (lambda () _v138552_))
                 (_K138565138590_
                  (lambda (_rest138584_ _end138585_ _start138586_ _u138587_)
                    (std/srfi/160/u16#u16vector-copy!
                     _v138552_
                     _at138559_
                     _u138587_
                     _start138586_
                     _end138585_)
                    (_lp138556_
                     _rest138584_
                     (fx+ _at138559_ (fx- _end138585_ _start138586_))))))
            (if (let () (declare (not safe)) (##pair? _rest138561138573_))
                (let ((_hd138566138593_
                       (let ()
                         (declare (not safe))
                         (##car _rest138561138573_)))
                      (_tl138567138595_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest138561138573_))))
                  (let ((_u138598_ _hd138566138593_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl138567138595_))
                        (let ((_hd138568138600_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl138567138595_)))
                              (_tl138569138602_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl138567138595_))))
                          (let ((_start138605_ _hd138568138600_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl138569138602_))
                                (let ((_hd138570138607_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl138569138602_)))
                                      (_tl138571138609_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl138569138602_))))
                                  (let* ((_end138612_ _hd138570138607_)
                                         (_rest138614_ _tl138571138609_))
                                    (_K138565138590_
                                     _rest138614_
                                     _end138612_
                                     _start138605_
                                     _u138598_)))
                                (_else138563138581_))))
                        (_else138563138581_))))
                (_else138563138581_)))))))
  (define std/srfi/160/u16#u16vector-empty?
    (lambda (_v138485_) (fxzero? (u16vector-length _v138485_))))
  (define std/srfi/160/u16#u16vector=
    (lambda (_v138427_ . _args138429_)
      (declare (not safe))
      (begin
        (if (u16vector? _v138427_) '#!void (error '"Bad argument" _v138427_))
        (let ((_vlen138433_ (u16vector-length _v138427_)))
          (let _lp138436_ ((_rest138439_ _args138429_))
            (let* ((_rest138441138449_ _rest138439_)
                   (_else138443138457_ (lambda () '#t))
                   (_K138445138473_
                    (lambda (_rest138460_ _u138461_)
                      (if (u16vector? _u138461_)
                          '#!void
                          (error '"Bad argument" _u138461_))
                      (let ((_ulen138464_ (u16vector-length _u138461_)))
                        (if (fx= _vlen138433_ _ulen138464_)
                            (let _cmp138467_ ((_i138470_ '0))
                              (if (fx< _i138470_ _vlen138433_)
                                  (if (= (u16vector-ref _v138427_ _i138470_)
                                         (u16vector-ref _u138461_ _i138470_))
                                      (_cmp138467_ (fx+ _i138470_ '1))
                                      '#f)
                                  (_lp138436_ _rest138460_)))
                            '#f)))))
              (if (##pair? _rest138441138449_)
                  (let ((_hd138446138476_ (##car _rest138441138449_))
                        (_tl138447138478_ (##cdr _rest138441138449_)))
                    (let* ((_u138481_ _hd138446138476_)
                           (_rest138483_ _tl138447138478_))
                      (_K138445138473_ _rest138483_ _u138481_)))
                  (_else138443138457_))))))))
  (define std/srfi/160/u16#u16vector-take
    (lambda (_v138419_ _n138421_)
      (let ((_u138424_ (make-u16vector _n138421_)))
        (std/srfi/160/u16#u16vector-copy! _u138424_ '0 _v138419_ '0 _n138421_)
        _u138424_)))
  (define std/srfi/160/u16#u16vector-take-right
    (lambda (_v138404_ _n138406_)
      (let* ((_vlen138409_ (u16vector-length _v138404_))
             (_ulen138412_ (fx- _vlen138409_ _n138406_))
             (_u138415_ (make-u16vector _ulen138412_)))
        (std/srfi/160/u16#u16vector-copy!
         _u138415_
         '0
         _v138404_
         _n138406_
         _vlen138409_)
        _u138415_)))
  (define std/srfi/160/u16#u16vector-drop
    (lambda (_v138389_ _n138391_)
      (let* ((_vlen138394_ (u16vector-length _v138389_))
             (_ulen138397_ (fx- _vlen138394_ _n138391_))
             (_u138400_ (make-u16vector _ulen138397_)))
        (std/srfi/160/u16#u16vector-copy!
         _u138400_
         '0
         _v138389_
         _n138391_
         _vlen138394_)
        _u138400_)))
  (define std/srfi/160/u16#u16vector-drop-right
    (lambda (_v138374_ _n138376_)
      (let* ((_vlen138379_ (u16vector-length _v138374_))
             (_ulen138382_ (fx- _vlen138379_ _n138376_))
             (_u138385_ (make-u16vector _ulen138382_)))
        (std/srfi/160/u16#u16vector-copy!
         _u138385_
         '0
         _v138374_
         '0
         _ulen138382_)
        _u138385_)))
  (define std/srfi/160/u16#u16vector-segment
    (lambda (_v138356_ _n138358_)
      (let _lp138361_ ((_i138364_ '0)
                       (_rest138366_ (u16vector-length _v138356_))
                       (_r138368_ '()))
        (if (fx> _r138368_ '0)
            (let ((_size138371_ (fxmin _n138358_ _rest138366_)))
              (_lp138361_
               (fx+ _i138364_ _size138371_)
               (fx- _rest138366_ _size138371_)
               (cons (std/srfi/160/u16#u16vector-copy__%
                      _v138356_
                      _i138364_
                      (fx+ _i138364_ _size138371_))
                     _r138368_)))
            (reverse _r138368_)))))
  (define std/srfi/160/u16#u16vector-fold__0
    (lambda (_kons138316_ _knil138318_ _v138320_)
      (if (procedure? _kons138316_)
          '#!void
          (error '"Bad argument; expected procedure" _kons138316_))
      (let ((_end138323_ (u16vector-length _v138320_)))
        (declare (not safe))
        (let _lp138327_ ((_i138330_ '0) (_r138332_ _knil138318_))
          (if (fx< _i138330_ _end138323_)
              (_lp138327_
               (fx+ _i138330_ '1)
               (_kons138316_ _r138332_ (u16vector-ref _v138320_ _i138330_)))
              _r138332_)))))
  (define std/srfi/160/u16#u16vector-fold__1
    (lambda (_kons138335_ _knil138336_ _v138337_ . _vs138338_)
      (if (procedure? _kons138335_)
          '#!void
          (error '"Bad argument; expected procedure" _kons138335_))
      (let* ((_vs138341_ (cons _v138337_ _vs138338_))
             (_end138343_ (apply fxmin (map u16vector-length _vs138341_))))
        (declare (not safe))
        (let _lp138347_ ((_i138349_ '0) (_r138350_ _knil138336_))
          (if (fx< _i138349_ _end138343_)
              (_lp138347_
               (fx+ _i138349_ '1)
               (apply _kons138335_
                      _r138350_
                      (map (lambda (_g138351138353_)
                             (u16vector-ref _g138351138353_ _i138349_))
                           _vs138341_)))
              _r138350_)))))
  (define std/srfi/160/u16#u16vector-fold
    (lambda _g299057_
      (let ((_g299056_ (let () (declare (not safe)) (##length _g299057_))))
        (cond ((let () (declare (not safe)) (##fx= _g299056_ 3))
               (apply std/srfi/160/u16#u16vector-fold__0 _g299057_))
              ((let () (declare (not safe)) (##fx>= _g299056_ 3))
               (apply std/srfi/160/u16#u16vector-fold__1 _g299057_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-fold
                _g299057_))))))
  (define std/srfi/160/u16#u16vector-fold-right__0
    (lambda (_kons138276_ _knil138278_ _v138280_)
      (if (procedure? _kons138276_)
          '#!void
          (error '"Bad argument; expected procedure" _kons138276_))
      (let ((_last138283_ (fx- (u16vector-length _v138280_) '1)))
        (declare (not safe))
        (let _lp138287_ ((_i138290_ _last138283_) (_r138292_ _knil138278_))
          (if (fx>= _i138290_ '0)
              (_lp138287_
               (fx- _i138290_ '1)
               (_kons138276_ _r138292_ (u16vector-ref _v138280_ _i138290_)))
              _r138292_)))))
  (define std/srfi/160/u16#u16vector-fold-right__1
    (lambda (_kons138295_ _knil138296_ _v138297_ . _vs138298_)
      (if (procedure? _kons138295_)
          '#!void
          (error '"Bad argument; expected procedure" _kons138295_))
      (let* ((_vs138301_ (cons _v138297_ _vs138298_))
             (_last138303_
              (fx- (apply min (map u16vector-length _vs138301_)) '1)))
        (declare (not safe))
        (let _lp138307_ ((_i138309_ _last138303_) (_r138310_ _knil138296_))
          (if (fx>= _i138309_ '0)
              (_lp138307_
               (fx- _i138309_ '1)
               (apply _kons138295_
                      _r138310_
                      (map (lambda (_g138311138313_)
                             (u16vector-ref _g138311138313_ _i138309_))
                           _vs138301_)))
              _r138310_)))))
  (define std/srfi/160/u16#u16vector-fold-right
    (lambda _g299059_
      (let ((_g299058_ (let () (declare (not safe)) (##length _g299059_))))
        (cond ((let () (declare (not safe)) (##fx= _g299058_ 3))
               (apply std/srfi/160/u16#u16vector-fold-right__0 _g299059_))
              ((let () (declare (not safe)) (##fx>= _g299058_ 3))
               (apply std/srfi/160/u16#u16vector-fold-right__1 _g299059_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-fold-right
                _g299059_))))))
  (define std/srfi/160/u16#u16vector-map__0
    (lambda (_f138236_ _v138238_)
      (if (procedure? _f138236_)
          '#!void
          (error '"Bad argument; expected procedure" _f138236_))
      (let* ((_len138241_ (u16vector-length _v138238_))
             (_u138244_ (make-u16vector _len138241_)))
        (declare (not safe))
        (let _lp138249_ ((_i138252_ '0))
          (if (fx< _i138252_ _len138241_)
              (begin
                (u16vector-set!
                 _u138244_
                 _i138252_
                 (u16vector-ref _v138238_ _i138252_))
                (_lp138249_ (fx+ _i138252_ '1)))
              _u138244_)))))
  (define std/srfi/160/u16#u16vector-map__1
    (lambda (_f138255_ _v138256_ . _vs138257_)
      (if (procedure? _f138255_)
          '#!void
          (error '"Bad argument; expected procedure" _f138255_))
      (let* ((_vs138260_ (cons _v138256_ _vs138257_))
             (_len138262_ (apply fxmin (map u16vector-length _vs138260_)))
             (_u138264_ (make-u16vector _len138262_)))
        (declare (not safe))
        (let _lp138268_ ((_i138270_ '0))
          (if (fx< _i138270_ _len138262_)
              (begin
                (u16vector-set!
                 _u138264_
                 _i138270_
                 (apply _f138255_
                        (map (lambda (_g138271138273_)
                               (u16vector-ref _g138271138273_ _i138270_))
                             _vs138260_)))
                (_lp138268_ (fx+ _i138270_ '1)))
              _u138264_)))))
  (define std/srfi/160/u16#u16vector-map
    (lambda _g299061_
      (let ((_g299060_ (let () (declare (not safe)) (##length _g299061_))))
        (cond ((let () (declare (not safe)) (##fx= _g299060_ 2))
               (apply std/srfi/160/u16#u16vector-map__0 _g299061_))
              ((let () (declare (not safe)) (##fx>= _g299060_ 2))
               (apply std/srfi/160/u16#u16vector-map__1 _g299061_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-map
                _g299061_))))))
  (define std/srfi/160/u16#u16vector-map!__0
    (lambda (_f138202_ _v138204_)
      (if (procedure? _f138202_)
          '#!void
          (error '"Bad argument; expected procedure" _f138202_))
      (let ((_len138207_ (u16vector-length _v138204_)))
        (declare (not safe))
        (let _lp138211_ ((_i138214_ '0))
          (if (fx< _i138214_ _len138207_)
              (begin
                (u16vector-set!
                 _v138204_
                 _i138214_
                 (_f138202_ (u16vector-ref _v138204_ _i138214_)))
                (_lp138211_ (fx+ _i138214_ '1)))
              _v138204_)))))
  (define std/srfi/160/u16#u16vector-map!__1
    (lambda (_f138217_ _v138218_ . _vs138219_)
      (if (procedure? _f138217_)
          '#!void
          (error '"Bad argument; expected procedure" _f138217_))
      (let* ((_vs138222_ (cons _v138218_ _vs138219_))
             (_len138224_ (apply fxmin (map u16vector-length _vs138222_))))
        (declare (not safe))
        (let _lp138228_ ((_i138230_ '0))
          (if (fx< _i138230_ _len138224_)
              (begin
                (u16vector-set!
                 _v138218_
                 _i138230_
                 (apply _f138217_
                        (map (lambda (_g138231138233_)
                               (u16vector-ref _g138231138233_ _i138230_))
                             _vs138222_)))
                (_lp138228_ (fx+ _i138230_ '1)))
              _v138218_)))))
  (define std/srfi/160/u16#u16vector-map!
    (lambda _g299063_
      (let ((_g299062_ (let () (declare (not safe)) (##length _g299063_))))
        (cond ((let () (declare (not safe)) (##fx= _g299062_ 2))
               (apply std/srfi/160/u16#u16vector-map!__0 _g299063_))
              ((let () (declare (not safe)) (##fx>= _g299062_ 2))
               (apply std/srfi/160/u16#u16vector-map!__1 _g299063_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-map!
                _g299063_))))))
  (define std/srfi/160/u16#u16vector-for-each__0
    (lambda (_f138168_ _v138170_)
      (if (procedure? _f138168_)
          '#!void
          (error '"Bad argument; expected procedure" _f138168_))
      (let ((_len138173_ (u16vector-length _v138170_)))
        (declare (not safe))
        (let _lp138177_ ((_i138180_ '0))
          (if (fx< _i138180_ _len138173_)
              (begin
                (_f138168_ (u16vector-ref _v138170_ _i138180_))
                (_lp138177_ (fx+ _i138180_ '1)))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-for-each__1
    (lambda (_f138183_ _v138184_ . _vs138185_)
      (let* ((_vs138188_ (cons _v138184_ _vs138185_))
             (_len138190_ (apply fxmin (map u16vector-length _vs138188_))))
        (declare (not safe))
        (let _lp138194_ ((_i138196_ '0))
          (if (fx< _i138196_ _len138190_)
              (begin
                (apply _f138183_
                       (map (lambda (_g138197138199_)
                              (u16vector-ref _g138197138199_ _i138196_))
                            _vs138188_))
                (_lp138194_ (fx+ _i138196_ '1)))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-for-each
    (lambda _g299065_
      (let ((_g299064_ (let () (declare (not safe)) (##length _g299065_))))
        (cond ((let () (declare (not safe)) (##fx= _g299064_ 2))
               (apply std/srfi/160/u16#u16vector-for-each__0 _g299065_))
              ((let () (declare (not safe)) (##fx>= _g299064_ 2))
               (apply std/srfi/160/u16#u16vector-for-each__1 _g299065_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-for-each
                _g299065_))))))
  (define std/srfi/160/u16#u16vector-count__0
    (lambda (_pred138131_ _v138133_)
      (if (procedure? _pred138131_)
          '#!void
          (error '"Bad argument; expected procedure" _pred138131_))
      (let ((_end138136_ (u16vector-length _v138133_)))
        (declare (not safe))
        (let _lp138140_ ((_i138143_ '0) (_r138145_ '0))
          (if (fx< _i138143_ _end138136_)
              (if (_pred138131_ (u16vector-ref _v138133_ _i138143_))
                  (_lp138140_ (fx+ _i138143_ '1) (fx+ _r138145_ '1))
                  (_lp138140_ (fx+ _i138143_ '1) _r138145_))
              _r138145_)))))
  (define std/srfi/160/u16#u16vector-count__1
    (lambda (_pred138148_ _v138149_ . _vs138150_)
      (if (procedure? _pred138148_)
          '#!void
          (error '"Bad argument; expected procedure" _pred138148_))
      (let* ((_vs138153_ (cons _v138149_ _vs138150_))
             (_end138155_ (apply fxmin (map u16vector-length _vs138153_))))
        (declare (not safe))
        (let _lp138159_ ((_i138161_ '0) (_r138162_ '0))
          (if (fx< _i138161_ _end138155_)
              (if (apply _pred138148_
                         (map (lambda (_g138163138165_)
                                (u16vector-ref _g138163138165_ _i138161_))
                              _vs138153_))
                  (_lp138159_ (fx+ _i138161_ '1) (fx+ _r138162_ '1))
                  (_lp138159_ (fx+ _i138161_ '1) _r138162_))
              _r138162_)))))
  (define std/srfi/160/u16#u16vector-count
    (lambda _g299067_
      (let ((_g299066_ (let () (declare (not safe)) (##length _g299067_))))
        (cond ((let () (declare (not safe)) (##fx= _g299066_ 2))
               (apply std/srfi/160/u16#u16vector-count__0 _g299067_))
              ((let () (declare (not safe)) (##fx>= _g299066_ 2))
               (apply std/srfi/160/u16#u16vector-count__1 _g299067_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-count
                _g299067_))))))
  (define std/srfi/160/u16#u16vector-cumulate
    (lambda (_f138106_ _knil138108_ _v138110_)
      (if (procedure? _f138106_)
          '#!void
          (error '"Bad argument; expected procedure" _f138106_))
      (let* ((_len138113_ (u16vector-length _v138110_))
             (_r138116_ (make-u16vector _len138113_)))
        (declare (not safe))
        (let _lp138121_ ((_i138124_ '0) (_r138126_ _knil138108_))
          (if (fx< _i138124_ _len138113_)
              (let ((_next138128_
                     (_f138106_
                      _r138126_
                      (u16vector-ref _v138110_ _i138124_))))
                (u16vector-set! _v138110_ _i138124_ _next138128_)
                (_lp138121_ (fx+ _i138124_ '1) _next138128_))
              _v138110_)))))
  (define std/srfi/160/u16#u16vector-take-while
    (lambda (_pred138089_ _v138091_)
      (let* ((_len138094_ (u16vector-length _v138091_))
             (_idx138097_
              (std/srfi/160/u16#u16vector-skip__0 _pred138089_ _v138091_))
             (_idx138103_
              (let ((_$e138100_ _idx138097_))
                (if _$e138100_ _$e138100_ _len138094_))))
        (std/srfi/160/u16#u16vector-copy__% _v138091_ '0 _idx138103_))))
  (define std/srfi/160/u16#u16vector-take-while-right
    (lambda (_pred138075_ _v138077_)
      (let* ((_len138080_ (u16vector-length _v138077_))
             (_idx138083_
              (std/srfi/160/u16#u16vector-skip-right__0
               _pred138075_
               _v138077_))
             (_idx138086_ (if _idx138083_ (fx+ _idx138083_ '1) '0)))
        (std/srfi/160/u16#u16vector-copy__%
         _v138077_
         _idx138086_
         _len138080_))))
  (define std/srfi/160/u16#u16vector-drop-while
    (lambda (_pred138058_ _v138060_)
      (let* ((_len138063_ (u16vector-length _v138060_))
             (_idx138066_
              (std/srfi/160/u16#u16vector-skip__0 _pred138058_ _v138060_))
             (_idx138072_
              (let ((_$e138069_ _idx138066_))
                (if _$e138069_ _$e138069_ _len138063_))))
        (std/srfi/160/u16#u16vector-copy__%
         _v138060_
         _idx138072_
         _len138063_))))
  (define std/srfi/160/u16#u16vector-drop-while-right
    (lambda (_pred138044_ _v138046_)
      (let* ((_len138049_ (u16vector-length _v138046_))
             (_idx138052_
              (std/srfi/160/u16#u16vector-skip-right__0
               _pred138044_
               _v138046_))
             (_idx138055_ (if _idx138052_ (fx+ _idx138052_ '1) '0)))
        (std/srfi/160/u16#u16vector-copy__% _v138046_ '0 _idx138055_))))
  (define std/srfi/160/u16#u16vector-index__0
    (lambda (_pred138010_ _v138012_)
      (if (procedure? _pred138010_)
          '#!void
          (error '"Bad argument; expected procedure" _pred138010_))
      (let ((_end138015_ (u16vector-length _v138012_)))
        (declare (not safe))
        (let _lp138019_ ((_i138022_ '0))
          (if (fx< _i138022_ _end138015_)
              (if (_pred138010_ (u16vector-ref _v138012_ _i138022_))
                  _i138022_
                  (_lp138019_ (fx+ _i138022_ '1)))
              '#f)))))
  (define std/srfi/160/u16#u16vector-index__1
    (lambda (_pred138025_ _v138026_ . _vs138027_)
      (if (procedure? _pred138025_)
          '#!void
          (error '"Bad argument; expected procedure" _pred138025_))
      (let* ((_vs138030_ (cons _v138026_ _vs138027_))
             (_end138032_ (apply fxmin (map u16vector-length _vs138030_))))
        (declare (not safe))
        (let _lp138036_ ((_i138038_ '0))
          (if (fx< _i138038_ _end138032_)
              (if (apply _pred138025_
                         (map (lambda (_g138039138041_)
                                (u16vector-ref _g138039138041_ _i138038_))
                              _vs138030_))
                  _i138038_
                  (_lp138036_ (fx+ _i138038_ '1)))
              '#f)))))
  (define std/srfi/160/u16#u16vector-index
    (lambda _g299069_
      (let ((_g299068_ (let () (declare (not safe)) (##length _g299069_))))
        (cond ((let () (declare (not safe)) (##fx= _g299068_ 2))
               (apply std/srfi/160/u16#u16vector-index__0 _g299069_))
              ((let () (declare (not safe)) (##fx>= _g299068_ 2))
               (apply std/srfi/160/u16#u16vector-index__1 _g299069_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-index
                _g299069_))))))
  (define std/srfi/160/u16#u16vector-index-right__0
    (lambda (_pred137976_ _v137978_)
      (if (procedure? _pred137976_)
          '#!void
          (error '"Bad argument; expected procedure" _pred137976_))
      (let ((_start137981_ (fx- (u16vector-length _v137978_) '1)))
        (declare (not safe))
        (let _lp137985_ ((_i137988_ _start137981_))
          (if (fx>= _i137988_ '0)
              (if (_pred137976_ (u16vector-ref _v137978_ _i137988_))
                  _i137988_
                  (_lp137985_ (fx- _i137988_ '1)))
              '#f)))))
  (define std/srfi/160/u16#u16vector-index-right__1
    (lambda (_pred137991_ _v137992_ . _vs137993_)
      (if (procedure? _pred137991_)
          '#!void
          (error '"Bad argument; expected procedure" _pred137991_))
      (let* ((_vs137996_ (cons _v137992_ _vs137993_))
             (_start137998_
              (fx- (apply fxmin (map u16vector-length _vs137996_)) '1)))
        (declare (not safe))
        (let _lp138002_ ((_i138004_ _start137998_))
          (if (fx>= _i138004_ '0)
              (if (apply _pred137991_
                         (map (lambda (_g138005138007_)
                                (u16vector-ref _g138005138007_ _i138004_))
                              _vs137996_))
                  _i138004_
                  (_lp138002_ (fx- _i138004_ '1)))
              '#f)))))
  (define std/srfi/160/u16#u16vector-index-right
    (lambda _g299071_
      (let ((_g299070_ (let () (declare (not safe)) (##length _g299071_))))
        (cond ((let () (declare (not safe)) (##fx= _g299070_ 2))
               (apply std/srfi/160/u16#u16vector-index-right__0 _g299071_))
              ((let () (declare (not safe)) (##fx>= _g299070_ 2))
               (apply std/srfi/160/u16#u16vector-index-right__1 _g299071_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-index-right
                _g299071_))))))
  (define std/srfi/160/u16#u16vector-skip__0
    (lambda (_pred137960_ _v137962_)
      (std/srfi/160/u16#u16vector-index__0
       (lambda (_$obj137965_) (not (_pred137960_ _$obj137965_)))
       _v137962_)))
  (define std/srfi/160/u16#u16vector-skip__1
    (lambda (_pred137968_ _v137969_ . _vs137970_)
      (apply std/srfi/160/u16#u16vector-index
             (lambda (_$obj137973_) (not (_pred137968_ _$obj137973_)))
             _v137969_
             _vs137970_)))
  (define std/srfi/160/u16#u16vector-skip
    (lambda _g299073_
      (let ((_g299072_ (let () (declare (not safe)) (##length _g299073_))))
        (cond ((let () (declare (not safe)) (##fx= _g299072_ 2))
               (apply std/srfi/160/u16#u16vector-skip__0 _g299073_))
              ((let () (declare (not safe)) (##fx>= _g299072_ 2))
               (apply std/srfi/160/u16#u16vector-skip__1 _g299073_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-skip
                _g299073_))))))
  (define std/srfi/160/u16#u16vector-skip-right__0
    (lambda (_pred137944_ _v137946_)
      (std/srfi/160/u16#u16vector-index-right__0
       (lambda (_$obj137949_) (not (_pred137944_ _$obj137949_)))
       _v137946_)))
  (define std/srfi/160/u16#u16vector-skip-right__1
    (lambda (_pred137952_ _v137953_ . _vs137954_)
      (apply std/srfi/160/u16#u16vector-index-right
             (lambda (_$obj137957_) (not (_pred137952_ _$obj137957_)))
             _v137953_
             _vs137954_)))
  (define std/srfi/160/u16#u16vector-skip-right
    (lambda _g299075_
      (let ((_g299074_ (let () (declare (not safe)) (##length _g299075_))))
        (cond ((let () (declare (not safe)) (##fx= _g299074_ 2))
               (apply std/srfi/160/u16#u16vector-skip-right__0 _g299075_))
              ((let () (declare (not safe)) (##fx>= _g299074_ 2))
               (apply std/srfi/160/u16#u16vector-skip-right__1 _g299075_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-skip-right
                _g299075_))))))
  (define std/srfi/160/u16#u16vector-any__0
    (lambda (_pred137904_ _v137906_)
      (if (procedure? _pred137904_)
          '#!void
          (error '"Bad argument; expected procedure" _pred137904_))
      (let ((_end137909_ (u16vector-length _v137906_)))
        (declare (not safe))
        (let _lp137913_ ((_i137916_ '0))
          (if (fx< _i137916_ _end137909_)
              (let ((_$e137919_
                     (_pred137904_ (u16vector-ref _v137906_ _i137916_))))
                (if _$e137919_
                    (values _$e137919_)
                    (_lp137913_ (fx+ _i137916_ '1))))
              '#f)))))
  (define std/srfi/160/u16#u16vector-any__1
    (lambda (_pred137922_ _v137923_ . _vs137924_)
      (if (procedure? _pred137922_)
          '#!void
          (error '"Bad argument; expected procedure" _pred137922_))
      (let* ((_v137927_ (cons _v137923_ _vs137924_))
             (_end137929_ (apply fxmin (map u16vector-length _vs137924_))))
        (declare (not safe))
        (let _lp137933_ ((_i137935_ '0))
          (if (fx< _i137935_ _end137929_)
              (let ((_$e137941_
                     (apply _pred137922_
                            (map (lambda (_g137936137938_)
                                   (u16vector-ref _g137936137938_ _i137935_))
                                 _vs137924_))))
                (if _$e137941_
                    (values _$e137941_)
                    (_lp137933_ (fx+ _i137935_ '1))))
              '#f)))))
  (define std/srfi/160/u16#u16vector-any
    (lambda _g299077_
      (let ((_g299076_ (let () (declare (not safe)) (##length _g299077_))))
        (cond ((let () (declare (not safe)) (##fx= _g299076_ 2))
               (apply std/srfi/160/u16#u16vector-any__0 _g299077_))
              ((let () (declare (not safe)) (##fx>= _g299076_ 2))
               (apply std/srfi/160/u16#u16vector-any__1 _g299077_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-any
                _g299077_))))))
  (define std/srfi/160/u16#u16vector-every__0
    (lambda (_pred137853_ _v137855_)
      (if (procedure? _pred137853_)
          '#!void
          (error '"Bad argument; expected procedure" _pred137853_))
      (let ((_end137858_ (u16vector-length _v137855_)))
        (declare (not safe))
        (let _lp137862_ ((_i137865_ '0) (_r137867_ '#t))
          (if (fx< _i137865_ _end137858_)
              (let ((_$e137870_
                     (_pred137853_ (u16vector-ref _v137855_ _i137865_))))
                (if _$e137870_
                    ((lambda (_g137872137874_)
                       (_lp137862_ (fx+ _i137865_ '1) _g137872137874_))
                     _$e137870_)
                    '#f))
              _r137867_)))))
  (define std/srfi/160/u16#u16vector-every__1
    (lambda (_pred137877_ _v137878_ . _vs137879_)
      (if (procedure? _pred137877_)
          '#!void
          (error '"Bad argument; expected procedure" _pred137877_))
      (let* ((_v137882_ (cons _v137878_ _vs137879_))
             (_end137884_ (apply fxmin (map u16vector-length _vs137879_))))
        (declare (not safe))
        (let _lp137888_ ((_i137890_ '0) (_r137891_ '#t))
          (if (fx< _i137890_ _end137884_)
              (let ((_$e137897_
                     (apply _pred137877_
                            (map (lambda (_g137892137894_)
                                   (u16vector-ref _g137892137894_ _i137890_))
                                 _vs137879_))))
                (if _$e137897_
                    ((lambda (_g137899137901_)
                       (_lp137888_ (fx+ _i137890_ '1) _g137899137901_))
                     _$e137897_)
                    '#f))
              _r137891_)))))
  (define std/srfi/160/u16#u16vector-every
    (lambda _g299079_
      (let ((_g299078_ (let () (declare (not safe)) (##length _g299079_))))
        (cond ((let () (declare (not safe)) (##fx= _g299078_ 2))
               (apply std/srfi/160/u16#u16vector-every__0 _g299079_))
              ((let () (declare (not safe)) (##fx>= _g299078_ 2))
               (apply std/srfi/160/u16#u16vector-every__1 _g299079_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-every
                _g299079_))))))
  (define std/srfi/160/u16#u16vector-partition
    (lambda (_pred137824_ _v137826_)
      (let* ((_count137829_
              (std/srfi/160/u16#u16vector-count__0 _pred137824_ _v137826_))
             (_len137832_ (u16vector-length _v137826_))
             (_u137835_ (make-u16vector _len137832_)))
        (declare (not safe))
        (let _lp137840_ ((_i137843_ '0)
                         (_left137845_ '0)
                         (_right137847_ _count137829_))
          (if (fx< _i137843_ _len137832_)
              (let ((_x137850_ (u16vector-ref _v137826_ _i137843_)))
                (if (_pred137824_ _x137850_)
                    (begin
                      (u16vector-set! _u137835_ _left137845_ _x137850_)
                      (_lp137840_
                       (fx+ _i137843_ '1)
                       (fx+ _left137845_ '1)
                       _right137847_))
                    (begin
                      (u16vector-set! _u137835_ _right137847_ _x137850_)
                      (_lp137840_
                       (fx+ _i137843_ '1)
                       _left137845_
                       (fx+ _right137847_ '1)))))
              _u137835_)))))
  (define std/srfi/160/u16#u16vector-filter
    (lambda (_pred137797_ _v137799_)
      (let* ((_count137802_
              (std/srfi/160/u16#u16vector-count__0 _pred137797_ _v137799_))
             (_u137805_ (make-u16vector _count137802_))
             (_end137808_ (u16vector-length _v137799_)))
        (declare (not safe))
        (let _lp137813_ ((_i137816_ '0) (_j137818_ '0))
          (if (fx< _i137816_ _end137808_)
              (let ((_x137821_ (u16vector-ref _v137799_ _i137816_)))
                (if (_pred137797_ _x137821_)
                    (begin
                      (u16vector-set! _u137805_ _j137818_ _x137821_)
                      (_lp137813_ (fx+ _i137816_ '1) (fx+ _j137818_ '1)))
                    (_lp137813_ (fx+ _i137816_ '1) _j137818_)))
              _u137805_)))))
  (define std/srfi/160/u16#u16vector-remove
    (lambda (_pred137789_ _v137791_)
      (std/srfi/160/u16#u16vector-filter
       (lambda (_$obj137794_) (not (_pred137789_ _$obj137794_)))
       _v137791_)))
  (define std/srfi/160/u16#u16vector-swap
    (lambda (_v137776_ _i137778_ _j137780_)
      (let ((_iv137783_ (u16vector-ref _v137776_ _i137778_))
            (_jv137785_ (u16vector-ref _v137776_ _j137780_)))
        (declare (not safe))
        (begin
          (u16vector-set! _v137776_ _i137778_ _jv137785_)
          (u16vector-set! _v137776_ _j137780_ _iv137783_)))))
  (define std/srfi/160/u16#u16vector-fill!__%
    (lambda (_v137739_ _fill137741_ _start137743_ _end137745_)
      (declare (not safe))
      (begin
        (if (u16vector? _v137739_) '#!void (error '"Bad argument" _v137739_))
        (if (std/srfi/160/base#u16? _fill137741_)
            '#!void
            (error '"Bad argument" _fill137741_))
        (if (and (fixnum? _start137743_)
                 (fx<= '0 _start137743_ (fx- (u16vector-length _v137739_) '1)))
            '#!void
            (error '"Index out of range" _start137743_))
        (if (and (fixnum? _end137745_)
                 (fx<= _start137743_ _end137745_ (u16vector-length _v137739_)))
            '#!void
            (error '"Index out of range" _end137745_))
        (let _lp137749_ ((_i137752_ _start137743_))
          (if (fx< _i137752_ _end137745_)
              (begin
                (u16vector-set! _v137739_ _i137752_ _fill137741_)
                (_lp137749_ (fx+ _i137752_ '1)))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-fill!__0
    (lambda (_v137758_ _fill137759_)
      (let* ((_start137761_ '0) (_end137763_ (u16vector-length _v137758_)))
        (std/srfi/160/u16#u16vector-fill!__%
         _v137758_
         _fill137759_
         _start137761_
         _end137763_))))
  (define std/srfi/160/u16#u16vector-fill!__1
    (lambda (_v137765_ _fill137766_ _start137767_)
      (let ((_end137769_ (u16vector-length _v137765_)))
        (std/srfi/160/u16#u16vector-fill!__%
         _v137765_
         _fill137766_
         _start137767_
         _end137769_))))
  (define std/srfi/160/u16#u16vector-fill!
    (lambda _g299081_
      (let ((_g299080_ (let () (declare (not safe)) (##length _g299081_))))
        (cond ((let () (declare (not safe)) (##fx= _g299080_ 2))
               (apply std/srfi/160/u16#u16vector-fill!__0 _g299081_))
              ((let () (declare (not safe)) (##fx= _g299080_ 3))
               (apply std/srfi/160/u16#u16vector-fill!__1 _g299081_))
              ((let () (declare (not safe)) (##fx= _g299080_ 4))
               (apply std/srfi/160/u16#u16vector-fill!__% _g299081_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-fill!
                _g299081_))))))
  (define std/srfi/160/u16#u16vector-reverse!__%
    (lambda (_v137699_ _start137701_ _end137703_)
      (declare (not safe))
      (begin
        (if (u16vector? _v137699_) '#!void (error '"Bad argument" _v137699_))
        (if (and (fixnum? _start137701_)
                 (fx<= '0 _start137701_ (fx- (u16vector-length _v137699_) '1)))
            '#!void
            (error '"Index out of range" _start137701_))
        (if (and (fixnum? _end137703_)
                 (fx<= _start137701_ _end137703_ (u16vector-length _v137699_)))
            '#!void
            (error '"Index out of range" _end137703_))
        (let _lp137707_ ((_i137710_ _start137701_)
                         (_j137712_ (fx- _end137703_ '1)))
          (if (fx< _i137710_ _j137712_)
              (let ((_iv137715_ (u16vector-ref _v137699_ _i137710_))
                    (_jv137717_ (u16vector-ref _v137699_ _j137712_)))
                (u16vector-set! _v137699_ _i137710_ _jv137717_)
                (u16vector-set! _v137699_ _j137712_ _iv137715_)
                (_lp137707_ (fx+ _i137710_ '1) (fx- _j137712_ '1)))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-reverse!__0
    (lambda (_v137723_)
      (let* ((_start137725_ '0) (_end137727_ (u16vector-length _v137723_)))
        (std/srfi/160/u16#u16vector-reverse!__%
         _v137723_
         _start137725_
         _end137727_))))
  (define std/srfi/160/u16#u16vector-reverse!__1
    (lambda (_v137729_ _start137730_)
      (let ((_end137732_ (u16vector-length _v137729_)))
        (std/srfi/160/u16#u16vector-reverse!__%
         _v137729_
         _start137730_
         _end137732_))))
  (define std/srfi/160/u16#u16vector-reverse!
    (lambda _g299083_
      (let ((_g299082_ (let () (declare (not safe)) (##length _g299083_))))
        (cond ((let () (declare (not safe)) (##fx= _g299082_ 1))
               (apply std/srfi/160/u16#u16vector-reverse!__0 _g299083_))
              ((let () (declare (not safe)) (##fx= _g299082_ 2))
               (apply std/srfi/160/u16#u16vector-reverse!__1 _g299083_))
              ((let () (declare (not safe)) (##fx= _g299082_ 3))
               (apply std/srfi/160/u16#u16vector-reverse!__% _g299083_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector-reverse!
                _g299083_))))))
  (define std/srfi/160/u16#u16vector-unfold!
    (lambda (_f137674_ _v137676_ _start137678_ _end137680_ _seed137682_)
      (declare (not safe))
      (begin
        (if (procedure? _f137674_)
            '#!void
            (error '"Bad argument; expected procedure" _f137674_))
        (if (u16vector? _v137676_) '#!void (error '"Bad argument" _v137676_))
        (if (and (fixnum? _start137678_)
                 (fx<= '0 _start137678_ (fx- (u16vector-length _v137676_) '1)))
            '#!void
            (error '"Index out of range" _start137678_))
        (if (and (fixnum? _end137680_)
                 (fx<= _start137678_ _end137680_ (u16vector-length _v137676_)))
            '#!void
            (error '"Index out of range" _end137680_))
        (let _lp137686_ ((_i137689_ _start137678_)
                         (_state137691_ _seed137682_))
          (if (fx< _i137689_ _end137680_)
              (let ((_g299084_ (_f137674_ _state137691_)))
                (begin
                  (let ((_g299085_
                         (if (##values? _g299084_)
                             (##vector-length _g299084_)
                             1)))
                    (if (not (##fx= _g299085_ 2))
                        (error "Context expects 2 values" _g299085_)))
                  (let ((_x137694_ (##vector-ref _g299084_ 0))
                        (_state137696_ (##vector-ref _g299084_ 1)))
                    (begin
                      (u16vector-set! _v137676_ _i137689_ _x137694_)
                      (_lp137686_ (fx+ _i137689_ '1) _state137696_)))))
              '#!void)))))
  (define std/srfi/160/u16#u16vector-unfold-right!
    (lambda (_f137650_ _v137652_ _start137654_ _end137656_ _seed137658_)
      (declare (not safe))
      (begin
        (if (procedure? _f137650_)
            '#!void
            (error '"Bad argument; expected procedure" _f137650_))
        (if (u16vector? _v137652_) '#!void (error '"Bad argument" _v137652_))
        (if (and (fixnum? _start137654_)
                 (fx<= '0 _start137654_ (fx- (u16vector-length _v137652_) '1)))
            '#!void
            (error '"Index out of range" _start137654_))
        (if (and (fixnum? _end137656_)
                 (fx<= _start137654_ _end137656_ (u16vector-length _v137652_)))
            '#!void
            (error '"Index out of range" _end137656_))
        (let _lp137662_ ((_i137665_ (fx- _end137656_ '1))
                         (_state137667_ _seed137658_))
          (if (fx>= _i137665_ _start137654_)
              (let ((_g299086_ (_f137650_ _state137667_)))
                (begin
                  (let ((_g299087_
                         (if (##values? _g299086_)
                             (##vector-length _g299086_)
                             1)))
                    (if (not (##fx= _g299087_ 2))
                        (error "Context expects 2 values" _g299087_)))
                  (let ((_x137670_ (##vector-ref _g299086_ 0))
                        (_state137672_ (##vector-ref _g299086_ 1)))
                    (begin
                      (u16vector-set! _v137652_ _i137665_ _x137670_)
                      (_lp137662_ (fx- _i137665_ '1) _state137672_)))))
              '#!void)))))
  (define std/srfi/160/u16#reverse-u16vector->list__%
    (lambda (_v137616_ _start137618_ _end137620_)
      (declare (not safe))
      (begin
        (if (u16vector? _v137616_) '#!void (error '"Bad argument" _v137616_))
        (if (and (fixnum? _start137618_)
                 (fx<= '0 _start137618_ (fx- (u16vector-length _v137616_) '1)))
            '#!void
            (error '"Index out of range" _start137618_))
        (if (and (fixnum? _end137620_)
                 (fx<= _start137618_ _end137620_ (u16vector-length _v137616_)))
            '#!void
            (error '"Index out of range" _end137620_))
        (let _lp137624_ ((_i137627_ _start137618_) (_r137629_ '()))
          (if (fx< _i137627_ _end137620_)
              (_lp137624_
               (fx+ _i137627_ '1)
               (cons (u16vector-ref _v137616_ _i137627_) _r137629_))
              _r137629_)))))
  (define std/srfi/160/u16#reverse-u16vector->list__0
    (lambda (_v137635_)
      (let* ((_start137637_ '0) (_end137639_ (u16vector-length _v137635_)))
        (std/srfi/160/u16#reverse-u16vector->list__%
         _v137635_
         _start137637_
         _end137639_))))
  (define std/srfi/160/u16#reverse-u16vector->list__1
    (lambda (_v137641_ _start137642_)
      (let ((_end137644_ (u16vector-length _v137641_)))
        (std/srfi/160/u16#reverse-u16vector->list__%
         _v137641_
         _start137642_
         _end137644_))))
  (define std/srfi/160/u16#reverse-u16vector->list
    (lambda _g299089_
      (let ((_g299088_ (let () (declare (not safe)) (##length _g299089_))))
        (cond ((let () (declare (not safe)) (##fx= _g299088_ 1))
               (apply std/srfi/160/u16#reverse-u16vector->list__0 _g299089_))
              ((let () (declare (not safe)) (##fx= _g299088_ 2))
               (apply std/srfi/160/u16#reverse-u16vector->list__1 _g299089_))
              ((let () (declare (not safe)) (##fx= _g299088_ 3))
               (apply std/srfi/160/u16#reverse-u16vector->list__% _g299089_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#reverse-u16vector->list
                _g299089_))))))
  (define std/srfi/160/u16#reverse-list->u16vector
    (lambda (_lst137562_)
      (let* ((_len137565_ (length _lst137562_))
             (_v137568_ (make-u16vector _len137565_)))
        (declare (not safe))
        (let _lp137573_ ((_rest137576_ _lst137562_) (_i137578_ '0))
          (let* ((_rest137580137588_ _rest137576_)
                 (_else137582137596_ (lambda () _v137568_))
                 (_K137584137603_
                  (lambda (_rest137599_ _x137600_)
                    (if (std/srfi/160/base#u16? _x137600_)
                        '#!void
                        (error '"Bad element" _x137600_))
                    (u16vector-set! _v137568_ _i137578_ _x137600_)
                    (_lp137573_ _rest137599_ (fx+ _i137578_ '1)))))
            (if (##pair? _rest137580137588_)
                (let ((_hd137585137606_ (##car _rest137580137588_))
                      (_tl137586137608_ (##cdr _rest137580137588_)))
                  (let* ((_x137611_ _hd137585137606_)
                         (_rest137613_ _tl137586137608_))
                    (_K137584137603_ _rest137613_ _x137611_)))
                (_else137582137596_)))))))
  (define std/srfi/160/u16#u16vector->vector__%
    (lambda (_v137523_ _start137525_ _end137527_)
      (declare (not safe))
      (begin
        (if (u16vector? _v137523_) '#!void (error '"Bad argument" _v137523_))
        (if (and (fixnum? _start137525_)
                 (fx<= '0 _start137525_ (fx- (u16vector-length _v137523_) '1)))
            '#!void
            (error '"Index out of range" _start137525_))
        (if (and (fixnum? _end137527_)
                 (fx<= _start137525_ _end137527_ (u16vector-length _v137523_)))
            '#!void
            (error '"Index out of range" _end137527_))
        (let* ((_len137531_ (u16vector-length _v137523_))
               (_u137534_ (make-vector _len137531_)))
          (let _lp137538_ ((_i137541_ '0))
            (if (fx< _i137541_ _len137531_)
                (begin
                  (vector-set!
                   _u137534_
                   _i137541_
                   (u16vector-ref _v137523_ _i137541_))
                  (_lp137538_ (fx+ _i137541_ '1)))
                _u137534_))))))
  (define std/srfi/160/u16#u16vector->vector__0
    (lambda (_v137547_)
      (let* ((_start137549_ '0) (_end137551_ (u16vector-length _v137547_)))
        (std/srfi/160/u16#u16vector->vector__%
         _v137547_
         _start137549_
         _end137551_))))
  (define std/srfi/160/u16#u16vector->vector__1
    (lambda (_v137553_ _start137554_)
      (let ((_end137556_ (u16vector-length _v137553_)))
        (std/srfi/160/u16#u16vector->vector__%
         _v137553_
         _start137554_
         _end137556_))))
  (define std/srfi/160/u16#u16vector->vector
    (lambda _g299091_
      (let ((_g299090_ (let () (declare (not safe)) (##length _g299091_))))
        (cond ((let () (declare (not safe)) (##fx= _g299090_ 1))
               (apply std/srfi/160/u16#u16vector->vector__0 _g299091_))
              ((let () (declare (not safe)) (##fx= _g299090_ 2))
               (apply std/srfi/160/u16#u16vector->vector__1 _g299091_))
              ((let () (declare (not safe)) (##fx= _g299090_ 3))
               (apply std/srfi/160/u16#u16vector->vector__% _g299091_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#u16vector->vector
                _g299091_))))))
  (define std/srfi/160/u16#vector->u16vector__%
    (lambda (_v137483_ _start137485_ _end137487_)
      (declare (not safe))
      (begin
        (if (vector? _v137483_)
            '#!void
            (error '"Bad argument; expected vector" _v137483_))
        (if (and (fixnum? _start137485_)
                 (fx<= '0 _start137485_ (fx- (vector-length _v137483_) '1)))
            '#!void
            (error '"Index out of range" _start137485_))
        (if (and (fixnum? _end137487_)
                 (fx<= _start137485_ _end137487_ (vector-length _v137483_)))
            '#!void
            (error '"Index out of range" _end137487_))
        (let* ((_len137491_ (vector-length _v137483_))
               (_u137494_ (make-u16vector _len137491_)))
          (let _lp137498_ ((_i137501_ '0))
            (if (fx< _i137501_ _len137491_)
                (begin
                  (u16vector-set!
                   _u137494_
                   _i137501_
                   (vector-ref _v137483_ _i137501_))
                  (_lp137498_ (fx+ _i137501_ '1)))
                _u137494_))))))
  (define std/srfi/160/u16#vector->u16vector__0
    (lambda (_v137507_)
      (let* ((_start137509_ '0) (_end137511_ (vector-length _v137507_)))
        (std/srfi/160/u16#vector->u16vector__%
         _v137507_
         _start137509_
         _end137511_))))
  (define std/srfi/160/u16#vector->u16vector__1
    (lambda (_v137513_ _start137514_)
      (let ((_end137516_ (vector-length _v137513_)))
        (std/srfi/160/u16#vector->u16vector__%
         _v137513_
         _start137514_
         _end137516_))))
  (define std/srfi/160/u16#vector->u16vector
    (lambda _g299093_
      (let ((_g299092_ (let () (declare (not safe)) (##length _g299093_))))
        (cond ((let () (declare (not safe)) (##fx= _g299092_ 1))
               (apply std/srfi/160/u16#vector->u16vector__0 _g299093_))
              ((let () (declare (not safe)) (##fx= _g299092_ 2))
               (apply std/srfi/160/u16#vector->u16vector__1 _g299093_))
              ((let () (declare (not safe)) (##fx= _g299092_ 3))
               (apply std/srfi/160/u16#vector->u16vector__% _g299093_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#vector->u16vector
                _g299093_))))))
  (define std/srfi/160/u16#make-u16vector-generator__%
    (lambda (_v137449_ _start137451_ _end137453_)
      (declare (not safe))
      (begin
        (if (u16vector? _v137449_) '#!void (error '"Bad argument" _v137449_))
        (if (and (fixnum? _start137451_)
                 (fx<= '0 _start137451_ (fx- (u16vector-length _v137449_) '1)))
            '#!void
            (error '"Index out of range" _start137451_))
        (if (and (fixnum? _end137453_)
                 (fx<= _start137451_ _end137453_ (u16vector-length _v137449_)))
            '#!void
            (error '"Index out of range" _end137453_))
        (let ((_i137457_ _start137451_))
          (lambda ()
            (if (fx< _i137457_ _end137453_)
                (let ((_next137461_ (u16vector-ref _v137449_ _i137457_)))
                  (set! _i137457_ (fx+ _i137457_ '1))
                  _next137461_)
                '#!eof))))))
  (define std/srfi/160/u16#make-u16vector-generator__0
    (lambda (_v137467_)
      (let* ((_start137469_ '0) (_end137471_ (u16vector-length _v137467_)))
        (std/srfi/160/u16#make-u16vector-generator__%
         _v137467_
         _start137469_
         _end137471_))))
  (define std/srfi/160/u16#make-u16vector-generator__1
    (lambda (_v137473_ _start137474_)
      (let ((_end137476_ (u16vector-length _v137473_)))
        (std/srfi/160/u16#make-u16vector-generator__%
         _v137473_
         _start137474_
         _end137476_))))
  (define std/srfi/160/u16#make-u16vector-generator
    (lambda _g299095_
      (let ((_g299094_ (let () (declare (not safe)) (##length _g299095_))))
        (cond ((let () (declare (not safe)) (##fx= _g299094_ 1))
               (apply std/srfi/160/u16#make-u16vector-generator__0 _g299095_))
              ((let () (declare (not safe)) (##fx= _g299094_ 2))
               (apply std/srfi/160/u16#make-u16vector-generator__1 _g299095_))
              ((let () (declare (not safe)) (##fx= _g299094_ 3))
               (apply std/srfi/160/u16#make-u16vector-generator__% _g299095_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#make-u16vector-generator
                _g299095_))))))
  (define std/srfi/160/u16#u16vector-comparator
    (let ()
      (letrec ((_<?137420_
                (lambda (_a137423_ _b137425_)
                  (let ((_len-a137428_ (u16vector-length _a137423_))
                        (_len-b137430_ (u16vector-length _b137425_)))
                    (declare (not safe))
                    (if (fx< _len-a137428_ _len-b137430_)
                        '#t
                        (if (fx> _len-a137428_ _len-b137430_)
                            '#f
                            (let ((_end137434_ _len-a137428_))
                              (let _lp137437_ ((_i137440_ '0))
                                (if (fx< _i137440_ _end137434_)
                                    (let ((_x137443_
                                           (u16vector-ref _a137423_ _i137440_))
                                          (_y137445_
                                           (u16vector-ref
                                            _b137425_
                                            _i137440_)))
                                      (if (< _x137443_ _y137445_)
                                          '#t
                                          (if (> _x137443_ _y137445_)
                                              '#f
                                              (_lp137437_
                                               (fx+ _i137440_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           u16vector?
           std/srfi/160/u16#u16vector=
           _<?137420_
           equal?-hash)))))
  (define std/srfi/160/u16#write-u16vector__%
    (lambda (_v137397_ _port137399_)
      (let ((_$e137402_ (find-method _v137397_ ':write)))
        (if _$e137402_
            ((lambda (_g137404137406_)
               (_g137404137406_ _v137397_ _port137399_))
             _$e137402_)
            (write _v137397_ (current-output-port))))))
  (define std/srfi/160/u16#write-u16vector__0
    (lambda (_v137412_)
      (let ((_port137414_ (current-output-port)))
        (std/srfi/160/u16#write-u16vector__% _v137412_ _port137414_))))
  (define std/srfi/160/u16#write-u16vector
    (lambda _g299097_
      (let ((_g299096_ (let () (declare (not safe)) (##length _g299097_))))
        (cond ((let () (declare (not safe)) (##fx= _g299096_ 1))
               (apply std/srfi/160/u16#write-u16vector__0 _g299097_))
              ((let () (declare (not safe)) (##fx= _g299096_ 2))
               (apply std/srfi/160/u16#write-u16vector__% _g299097_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u16#write-u16vector
                _g299097_)))))))
