(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/u8#u8vector-unfold
    (lambda (_f135946_ _len135948_ _seed135950_)
      (declare (not safe))
      (begin
        (if (procedure? _f135946_)
            '#!void
            (error '"Bad argument; expected procedure" _f135946_))
        (let ((_v135954_ (make-u8vector _len135948_)))
          (let _lp135957_ ((_i135960_ '0) (_state135962_ _seed135950_))
            (if (fx< _i135960_ _len135948_)
                (let ((_g298948_ (_f135946_ _i135960_ _state135962_)))
                  (begin
                    (let ((_g298949_
                           (if (##values? _g298948_)
                               (##vector-length _g298948_)
                               1)))
                      (if (not (##fx= _g298949_ 2))
                          (error "Context expects 2 values" _g298949_)))
                    (let ((_x135965_ (##vector-ref _g298948_ 0))
                          (_state135967_ (##vector-ref _g298948_ 1)))
                      (begin
                        (if (std/srfi/160/base#u8? _x135965_)
                            '#!void
                            (error '"Bad generated value" _x135965_))
                        (u8vector-set! _v135954_ _i135960_ _x135965_)
                        (_lp135957_ (fx+ _i135960_ '1) _state135967_)))))
                _v135954_))))))
  (define std/srfi/160/u8#u8vector-unfold-right
    (lambda (_f135923_ _len135925_ _seed135927_)
      (declare (not safe))
      (begin
        (if (procedure? _f135923_)
            '#!void
            (error '"Bad argument; expected procedure" _f135923_))
        (let ((_v135931_ (make-u8vector _len135925_)))
          (let _lp135934_ ((_i135937_ (fx- _len135925_ '1))
                           (_state135939_ _seed135927_))
            (if (fx>= _i135937_ '0)
                (let ((_g298950_ (_f135923_ _i135937_ _state135939_)))
                  (begin
                    (let ((_g298951_
                           (if (##values? _g298950_)
                               (##vector-length _g298950_)
                               1)))
                      (if (not (##fx= _g298951_ 2))
                          (error "Context expects 2 values" _g298951_)))
                    (let ((_x135942_ (##vector-ref _g298950_ 0))
                          (_state135944_ (##vector-ref _g298950_ 1)))
                      (begin
                        (if (std/srfi/160/base#u8? _x135942_)
                            '#!void
                            (error '"Bad generated value" _x135942_))
                        (u8vector-set! _v135931_ _i135937_ _x135942_)
                        (_lp135934_ (fx- _i135937_ '1) _state135944_)))))
                _v135931_))))))
  (define std/srfi/160/u8#u8vector-copy__%
    (lambda (_vec135895_ _start135897_ _end135899_)
      (let ((_v135902_ (make-u8vector (fx- _end135899_ _start135897_))))
        (std/srfi/160/u8#u8vector-copy!
         _v135902_
         '0
         _vec135895_
         _start135897_
         _end135899_)
        _v135902_)))
  (define std/srfi/160/u8#u8vector-copy__0
    (lambda (_vec135908_)
      (let* ((_start135910_ '0) (_end135912_ (u8vector-length _vec135908_)))
        (std/srfi/160/u8#u8vector-copy__%
         _vec135908_
         _start135910_
         _end135912_))))
  (define std/srfi/160/u8#u8vector-copy__1
    (lambda (_vec135914_ _start135915_)
      (let ((_end135917_ (u8vector-length _vec135914_)))
        (std/srfi/160/u8#u8vector-copy__%
         _vec135914_
         _start135915_
         _end135917_))))
  (define std/srfi/160/u8#u8vector-copy
    (lambda _g298953_
      (let ((_g298952_ (let () (declare (not safe)) (##length _g298953_))))
        (cond ((let () (declare (not safe)) (##fx= _g298952_ 1))
               (apply std/srfi/160/u8#u8vector-copy__0 _g298953_))
              ((let () (declare (not safe)) (##fx= _g298952_ 2))
               (apply std/srfi/160/u8#u8vector-copy__1 _g298953_))
              ((let () (declare (not safe)) (##fx= _g298952_ 3))
               (apply std/srfi/160/u8#u8vector-copy__% _g298953_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-copy
                _g298953_))))))
  (define std/srfi/160/u8#u8vector-copy!
    (lambda (_to135874_ _at135876_ _from135878_ _start135880_ _end135882_)
      (declare (not safe))
      (begin
        (if (u8vector? _to135874_) '#!void (error '"Bad argument" _to135874_))
        (if (u8vector? _from135878_)
            '#!void
            (error '"Bad argument" _from135878_))
        (if (and (fixnum? _at135876_)
                 (fx<= '0 _at135876_ (fx- (u8vector-length _at135876_) '1)))
            '#!void
            (error '"Index out of range" _to135874_ _at135876_))
        (if (and (fixnum? _start135880_)
                 (fx<= '0
                       _start135880_
                       (fx- (u8vector-length _from135878_) '1)))
            '#!void
            (error '"Index out of range" _from135878_ _start135880_))
        (if (and (fixnum? _end135882_)
                 (fx<= _start135880_
                       _end135882_
                       (u8vector-length _from135878_)))
            '#!void
            (error '"Index out of range" _from135878_ _end135882_))
        (if (fx<= (fx- _end135882_ _start135880_)
                  (fx- (u8vector-length _to135874_) _at135876_))
            '#!void
            (error '"Destination area too small"
                   _to135874_
                   _at135876_
                   _from135878_
                   _start135880_
                   _end135882_))
        (let _lp135886_ ((_i135889_ _start135880_) (_j135891_ _at135876_))
          (if (fx< _i135889_ _end135882_)
              (begin
                (u8vector-set!
                 _to135874_
                 _j135891_
                 (u8vector-ref _from135878_ _i135889_))
                (_lp135886_ (fx+ _i135889_ '1) (fx+ _j135891_ '1)))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-reverse-copy__%
    (lambda (_vec135846_ _start135848_ _end135850_)
      (let ((_v135853_ (make-u8vector (fx- _end135850_ _start135848_))))
        (std/srfi/160/u8#u8vector-reverse-copy!
         _v135853_
         '0
         _vec135846_
         _start135848_
         _end135850_)
        _v135853_)))
  (define std/srfi/160/u8#u8vector-reverse-copy__0
    (lambda (_vec135859_)
      (let* ((_start135861_ '0) (_end135863_ (u8vector-length _vec135859_)))
        (std/srfi/160/u8#u8vector-reverse-copy__%
         _vec135859_
         _start135861_
         _end135863_))))
  (define std/srfi/160/u8#u8vector-reverse-copy__1
    (lambda (_vec135865_ _start135866_)
      (let ((_end135868_ (u8vector-length _vec135865_)))
        (std/srfi/160/u8#u8vector-reverse-copy__%
         _vec135865_
         _start135866_
         _end135868_))))
  (define std/srfi/160/u8#u8vector-reverse-copy
    (lambda _g298955_
      (let ((_g298954_ (let () (declare (not safe)) (##length _g298955_))))
        (cond ((let () (declare (not safe)) (##fx= _g298954_ 1))
               (apply std/srfi/160/u8#u8vector-reverse-copy__0 _g298955_))
              ((let () (declare (not safe)) (##fx= _g298954_ 2))
               (apply std/srfi/160/u8#u8vector-reverse-copy__1 _g298955_))
              ((let () (declare (not safe)) (##fx= _g298954_ 3))
               (apply std/srfi/160/u8#u8vector-reverse-copy__% _g298955_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-reverse-copy
                _g298955_))))))
  (define std/srfi/160/u8#u8vector-reverse-copy!
    (lambda (_to135825_ _at135827_ _from135829_ _start135831_ _end135833_)
      (declare (not safe))
      (begin
        (if (u8vector? _to135825_) '#!void (error '"Bad argument" _to135825_))
        (if (u8vector? _from135829_)
            '#!void
            (error '"Bad argument" _from135829_))
        (if (and (fixnum? _at135827_)
                 (fx<= '0 _at135827_ (fx- (u8vector-length _at135827_) '1)))
            '#!void
            (error '"Index out of range" _to135825_ _at135827_))
        (if (and (fixnum? _start135831_)
                 (fx<= '0
                       _start135831_
                       (fx- (u8vector-length _from135829_) '1)))
            '#!void
            (error '"Index out of range" _from135829_ _start135831_))
        (if (and (fixnum? _end135833_)
                 (fx<= _start135831_
                       _end135833_
                       (u8vector-length _from135829_)))
            '#!void
            (error '"Index out of range" _from135829_ _end135833_))
        (if (fx<= (fx- _end135833_ _start135831_)
                  (fx- (u8vector-length _to135825_) _at135827_))
            '#!void
            (error '"Destination area too small"
                   _to135825_
                   _at135827_
                   _from135829_
                   _start135831_
                   _end135833_))
        (let _lp135837_ ((_i135840_ (fx- _end135833_ '1))
                         (_j135842_ _at135827_))
          (if (fx>= _i135840_ _start135831_)
              (begin
                (u8vector-set!
                 _to135825_
                 _j135842_
                 (u8vector-ref _from135829_ _i135840_))
                (_lp135837_ (fx- _i135840_ '1) (fx+ _j135842_ '1)))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-append
    (lambda _args135822_ (std/srfi/160/u8#u8vector-concatenate _args135822_)))
  (define std/srfi/160/u8#u8vector-concatenate
    (lambda (_lst135762_)
      (let* ((_len135770_
              (foldl1 (lambda (_v135765_ _r135767_)
                        (fx+ (u8vector-length _v135765_) _r135767_))
                      '0
                      _lst135762_))
             (_v135773_ (make-u8vector _len135770_)))
        (declare (not safe))
        (let _lp135777_ ((_rest135780_ _lst135762_) (_at135782_ '0))
          (let* ((_rest135784135792_ _rest135780_)
                 (_else135786135800_ (lambda () _v135773_))
                 (_K135788135810_
                  (lambda (_rest135803_ _u135804_)
                    (let ((_ulen135807_ (u8vector-length _u135804_)))
                      (std/srfi/160/u8#u8vector-copy!
                       _v135773_
                       _at135782_
                       _u135804_
                       '0
                       _ulen135807_)
                      (_lp135777_
                       _rest135803_
                       (fx+ _at135782_ _ulen135807_))))))
            (if (##pair? _rest135784135792_)
                (let ((_hd135789135813_ (##car _rest135784135792_))
                      (_tl135790135815_ (##cdr _rest135784135792_)))
                  (let* ((_u135818_ _hd135789135813_)
                         (_rest135820_ _tl135790135815_))
                    (_K135788135810_ _rest135820_ _u135818_)))
                (_else135786135800_)))))))
  (define std/srfi/160/u8#u8vector-append-subvectors
    (lambda _args135634_
      (let* ((_len135695_
              (let _lp135637_ ((_rest135640_ _args135634_) (_r135642_ '0))
                (let* ((_rest135644135656_ _rest135640_)
                       (_else135646135664_ (lambda () _r135642_))
                       (_K135648135673_
                        (lambda (_rest135667_ _end135668_ _start135670_)
                          (_lp135637_
                           _rest135667_
                           (fx+ _r135642_ (fx- _end135668_ _start135670_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest135644135656_))
                      (let ((_tl135650135676_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest135644135656_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl135650135676_))
                            (let ((_hd135651135679_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl135650135676_)))
                                  (_tl135652135681_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl135650135676_))))
                              (let ((_start135684_ _hd135651135679_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl135652135681_))
                                    (let ((_hd135653135686_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl135652135681_)))
                                          (_tl135654135688_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl135652135681_))))
                                      (let* ((_end135691_ _hd135653135686_)
                                             (_rest135693_ _tl135654135688_))
                                        (_K135648135673_
                                         _rest135693_
                                         _end135691_
                                         _start135684_)))
                                    (_else135646135664_))))
                            (_else135646135664_)))
                      (_else135646135664_)))))
             (_v135698_ (make-u8vector _len135695_)))
        (let _lp135702_ ((_rest135704_ _args135634_) (_at135705_ '0))
          (let* ((_rest135707135719_ _rest135704_)
                 (_else135709135727_ (lambda () _v135698_))
                 (_K135711135736_
                  (lambda (_rest135730_ _end135731_ _start135732_ _u135733_)
                    (std/srfi/160/u8#u8vector-copy!
                     _v135698_
                     _at135705_
                     _u135733_
                     _start135732_
                     _end135731_)
                    (_lp135702_
                     _rest135730_
                     (fx+ _at135705_ (fx- _end135731_ _start135732_))))))
            (if (let () (declare (not safe)) (##pair? _rest135707135719_))
                (let ((_hd135712135739_
                       (let ()
                         (declare (not safe))
                         (##car _rest135707135719_)))
                      (_tl135713135741_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest135707135719_))))
                  (let ((_u135744_ _hd135712135739_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl135713135741_))
                        (let ((_hd135714135746_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl135713135741_)))
                              (_tl135715135748_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl135713135741_))))
                          (let ((_start135751_ _hd135714135746_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl135715135748_))
                                (let ((_hd135716135753_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl135715135748_)))
                                      (_tl135717135755_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl135715135748_))))
                                  (let* ((_end135758_ _hd135716135753_)
                                         (_rest135760_ _tl135717135755_))
                                    (_K135711135736_
                                     _rest135760_
                                     _end135758_
                                     _start135751_
                                     _u135744_)))
                                (_else135709135727_))))
                        (_else135709135727_))))
                (_else135709135727_)))))))
  (define std/srfi/160/u8#u8vector-empty?
    (lambda (_v135631_) (fxzero? (u8vector-length _v135631_))))
  (define std/srfi/160/u8#u8vector=
    (lambda (_v135573_ . _args135575_)
      (declare (not safe))
      (begin
        (if (u8vector? _v135573_) '#!void (error '"Bad argument" _v135573_))
        (let ((_vlen135579_ (u8vector-length _v135573_)))
          (let _lp135582_ ((_rest135585_ _args135575_))
            (let* ((_rest135587135595_ _rest135585_)
                   (_else135589135603_ (lambda () '#t))
                   (_K135591135619_
                    (lambda (_rest135606_ _u135607_)
                      (if (u8vector? _u135607_)
                          '#!void
                          (error '"Bad argument" _u135607_))
                      (let ((_ulen135610_ (u8vector-length _u135607_)))
                        (if (fx= _vlen135579_ _ulen135610_)
                            (let _cmp135613_ ((_i135616_ '0))
                              (if (fx< _i135616_ _vlen135579_)
                                  (if (= (u8vector-ref _v135573_ _i135616_)
                                         (u8vector-ref _u135607_ _i135616_))
                                      (_cmp135613_ (fx+ _i135616_ '1))
                                      '#f)
                                  (_lp135582_ _rest135606_)))
                            '#f)))))
              (if (##pair? _rest135587135595_)
                  (let ((_hd135592135622_ (##car _rest135587135595_))
                        (_tl135593135624_ (##cdr _rest135587135595_)))
                    (let* ((_u135627_ _hd135592135622_)
                           (_rest135629_ _tl135593135624_))
                      (_K135591135619_ _rest135629_ _u135627_)))
                  (_else135589135603_))))))))
  (define std/srfi/160/u8#u8vector-take
    (lambda (_v135565_ _n135567_)
      (let ((_u135570_ (make-u8vector _n135567_)))
        (std/srfi/160/u8#u8vector-copy! _u135570_ '0 _v135565_ '0 _n135567_)
        _u135570_)))
  (define std/srfi/160/u8#u8vector-take-right
    (lambda (_v135550_ _n135552_)
      (let* ((_vlen135555_ (u8vector-length _v135550_))
             (_ulen135558_ (fx- _vlen135555_ _n135552_))
             (_u135561_ (make-u8vector _ulen135558_)))
        (std/srfi/160/u8#u8vector-copy!
         _u135561_
         '0
         _v135550_
         _n135552_
         _vlen135555_)
        _u135561_)))
  (define std/srfi/160/u8#u8vector-drop
    (lambda (_v135535_ _n135537_)
      (let* ((_vlen135540_ (u8vector-length _v135535_))
             (_ulen135543_ (fx- _vlen135540_ _n135537_))
             (_u135546_ (make-u8vector _ulen135543_)))
        (std/srfi/160/u8#u8vector-copy!
         _u135546_
         '0
         _v135535_
         _n135537_
         _vlen135540_)
        _u135546_)))
  (define std/srfi/160/u8#u8vector-drop-right
    (lambda (_v135520_ _n135522_)
      (let* ((_vlen135525_ (u8vector-length _v135520_))
             (_ulen135528_ (fx- _vlen135525_ _n135522_))
             (_u135531_ (make-u8vector _ulen135528_)))
        (std/srfi/160/u8#u8vector-copy! _u135531_ '0 _v135520_ '0 _ulen135528_)
        _u135531_)))
  (define std/srfi/160/u8#u8vector-segment
    (lambda (_v135502_ _n135504_)
      (let _lp135507_ ((_i135510_ '0)
                       (_rest135512_ (u8vector-length _v135502_))
                       (_r135514_ '()))
        (if (fx> _r135514_ '0)
            (let ((_size135517_ (fxmin _n135504_ _rest135512_)))
              (_lp135507_
               (fx+ _i135510_ _size135517_)
               (fx- _rest135512_ _size135517_)
               (cons (std/srfi/160/u8#u8vector-copy__%
                      _v135502_
                      _i135510_
                      (fx+ _i135510_ _size135517_))
                     _r135514_)))
            (reverse _r135514_)))))
  (define std/srfi/160/u8#u8vector-fold__0
    (lambda (_kons135462_ _knil135464_ _v135466_)
      (if (procedure? _kons135462_)
          '#!void
          (error '"Bad argument; expected procedure" _kons135462_))
      (let ((_end135469_ (u8vector-length _v135466_)))
        (declare (not safe))
        (let _lp135473_ ((_i135476_ '0) (_r135478_ _knil135464_))
          (if (fx< _i135476_ _end135469_)
              (_lp135473_
               (fx+ _i135476_ '1)
               (_kons135462_ _r135478_ (u8vector-ref _v135466_ _i135476_)))
              _r135478_)))))
  (define std/srfi/160/u8#u8vector-fold__1
    (lambda (_kons135481_ _knil135482_ _v135483_ . _vs135484_)
      (if (procedure? _kons135481_)
          '#!void
          (error '"Bad argument; expected procedure" _kons135481_))
      (let* ((_vs135487_ (cons _v135483_ _vs135484_))
             (_end135489_ (apply fxmin (map u8vector-length _vs135487_))))
        (declare (not safe))
        (let _lp135493_ ((_i135495_ '0) (_r135496_ _knil135482_))
          (if (fx< _i135495_ _end135489_)
              (_lp135493_
               (fx+ _i135495_ '1)
               (apply _kons135481_
                      _r135496_
                      (map (lambda (_g135497135499_)
                             (u8vector-ref _g135497135499_ _i135495_))
                           _vs135487_)))
              _r135496_)))))
  (define std/srfi/160/u8#u8vector-fold
    (lambda _g298957_
      (let ((_g298956_ (let () (declare (not safe)) (##length _g298957_))))
        (cond ((let () (declare (not safe)) (##fx= _g298956_ 3))
               (apply std/srfi/160/u8#u8vector-fold__0 _g298957_))
              ((let () (declare (not safe)) (##fx>= _g298956_ 3))
               (apply std/srfi/160/u8#u8vector-fold__1 _g298957_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-fold
                _g298957_))))))
  (define std/srfi/160/u8#u8vector-fold-right__0
    (lambda (_kons135422_ _knil135424_ _v135426_)
      (if (procedure? _kons135422_)
          '#!void
          (error '"Bad argument; expected procedure" _kons135422_))
      (let ((_last135429_ (fx- (u8vector-length _v135426_) '1)))
        (declare (not safe))
        (let _lp135433_ ((_i135436_ _last135429_) (_r135438_ _knil135424_))
          (if (fx>= _i135436_ '0)
              (_lp135433_
               (fx- _i135436_ '1)
               (_kons135422_ _r135438_ (u8vector-ref _v135426_ _i135436_)))
              _r135438_)))))
  (define std/srfi/160/u8#u8vector-fold-right__1
    (lambda (_kons135441_ _knil135442_ _v135443_ . _vs135444_)
      (if (procedure? _kons135441_)
          '#!void
          (error '"Bad argument; expected procedure" _kons135441_))
      (let* ((_vs135447_ (cons _v135443_ _vs135444_))
             (_last135449_
              (fx- (apply min (map u8vector-length _vs135447_)) '1)))
        (declare (not safe))
        (let _lp135453_ ((_i135455_ _last135449_) (_r135456_ _knil135442_))
          (if (fx>= _i135455_ '0)
              (_lp135453_
               (fx- _i135455_ '1)
               (apply _kons135441_
                      _r135456_
                      (map (lambda (_g135457135459_)
                             (u8vector-ref _g135457135459_ _i135455_))
                           _vs135447_)))
              _r135456_)))))
  (define std/srfi/160/u8#u8vector-fold-right
    (lambda _g298959_
      (let ((_g298958_ (let () (declare (not safe)) (##length _g298959_))))
        (cond ((let () (declare (not safe)) (##fx= _g298958_ 3))
               (apply std/srfi/160/u8#u8vector-fold-right__0 _g298959_))
              ((let () (declare (not safe)) (##fx>= _g298958_ 3))
               (apply std/srfi/160/u8#u8vector-fold-right__1 _g298959_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-fold-right
                _g298959_))))))
  (define std/srfi/160/u8#u8vector-map__0
    (lambda (_f135382_ _v135384_)
      (if (procedure? _f135382_)
          '#!void
          (error '"Bad argument; expected procedure" _f135382_))
      (let* ((_len135387_ (u8vector-length _v135384_))
             (_u135390_ (make-u8vector _len135387_)))
        (declare (not safe))
        (let _lp135395_ ((_i135398_ '0))
          (if (fx< _i135398_ _len135387_)
              (begin
                (u8vector-set!
                 _u135390_
                 _i135398_
                 (u8vector-ref _v135384_ _i135398_))
                (_lp135395_ (fx+ _i135398_ '1)))
              _u135390_)))))
  (define std/srfi/160/u8#u8vector-map__1
    (lambda (_f135401_ _v135402_ . _vs135403_)
      (if (procedure? _f135401_)
          '#!void
          (error '"Bad argument; expected procedure" _f135401_))
      (let* ((_vs135406_ (cons _v135402_ _vs135403_))
             (_len135408_ (apply fxmin (map u8vector-length _vs135406_)))
             (_u135410_ (make-u8vector _len135408_)))
        (declare (not safe))
        (let _lp135414_ ((_i135416_ '0))
          (if (fx< _i135416_ _len135408_)
              (begin
                (u8vector-set!
                 _u135410_
                 _i135416_
                 (apply _f135401_
                        (map (lambda (_g135417135419_)
                               (u8vector-ref _g135417135419_ _i135416_))
                             _vs135406_)))
                (_lp135414_ (fx+ _i135416_ '1)))
              _u135410_)))))
  (define std/srfi/160/u8#u8vector-map
    (lambda _g298961_
      (let ((_g298960_ (let () (declare (not safe)) (##length _g298961_))))
        (cond ((let () (declare (not safe)) (##fx= _g298960_ 2))
               (apply std/srfi/160/u8#u8vector-map__0 _g298961_))
              ((let () (declare (not safe)) (##fx>= _g298960_ 2))
               (apply std/srfi/160/u8#u8vector-map__1 _g298961_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-map
                _g298961_))))))
  (define std/srfi/160/u8#u8vector-map!__0
    (lambda (_f135348_ _v135350_)
      (if (procedure? _f135348_)
          '#!void
          (error '"Bad argument; expected procedure" _f135348_))
      (let ((_len135353_ (u8vector-length _v135350_)))
        (declare (not safe))
        (let _lp135357_ ((_i135360_ '0))
          (if (fx< _i135360_ _len135353_)
              (begin
                (u8vector-set!
                 _v135350_
                 _i135360_
                 (_f135348_ (u8vector-ref _v135350_ _i135360_)))
                (_lp135357_ (fx+ _i135360_ '1)))
              _v135350_)))))
  (define std/srfi/160/u8#u8vector-map!__1
    (lambda (_f135363_ _v135364_ . _vs135365_)
      (if (procedure? _f135363_)
          '#!void
          (error '"Bad argument; expected procedure" _f135363_))
      (let* ((_vs135368_ (cons _v135364_ _vs135365_))
             (_len135370_ (apply fxmin (map u8vector-length _vs135368_))))
        (declare (not safe))
        (let _lp135374_ ((_i135376_ '0))
          (if (fx< _i135376_ _len135370_)
              (begin
                (u8vector-set!
                 _v135364_
                 _i135376_
                 (apply _f135363_
                        (map (lambda (_g135377135379_)
                               (u8vector-ref _g135377135379_ _i135376_))
                             _vs135368_)))
                (_lp135374_ (fx+ _i135376_ '1)))
              _v135364_)))))
  (define std/srfi/160/u8#u8vector-map!
    (lambda _g298963_
      (let ((_g298962_ (let () (declare (not safe)) (##length _g298963_))))
        (cond ((let () (declare (not safe)) (##fx= _g298962_ 2))
               (apply std/srfi/160/u8#u8vector-map!__0 _g298963_))
              ((let () (declare (not safe)) (##fx>= _g298962_ 2))
               (apply std/srfi/160/u8#u8vector-map!__1 _g298963_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-map!
                _g298963_))))))
  (define std/srfi/160/u8#u8vector-for-each__0
    (lambda (_f135314_ _v135316_)
      (if (procedure? _f135314_)
          '#!void
          (error '"Bad argument; expected procedure" _f135314_))
      (let ((_len135319_ (u8vector-length _v135316_)))
        (declare (not safe))
        (let _lp135323_ ((_i135326_ '0))
          (if (fx< _i135326_ _len135319_)
              (begin
                (_f135314_ (u8vector-ref _v135316_ _i135326_))
                (_lp135323_ (fx+ _i135326_ '1)))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-for-each__1
    (lambda (_f135329_ _v135330_ . _vs135331_)
      (let* ((_vs135334_ (cons _v135330_ _vs135331_))
             (_len135336_ (apply fxmin (map u8vector-length _vs135334_))))
        (declare (not safe))
        (let _lp135340_ ((_i135342_ '0))
          (if (fx< _i135342_ _len135336_)
              (begin
                (apply _f135329_
                       (map (lambda (_g135343135345_)
                              (u8vector-ref _g135343135345_ _i135342_))
                            _vs135334_))
                (_lp135340_ (fx+ _i135342_ '1)))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-for-each
    (lambda _g298965_
      (let ((_g298964_ (let () (declare (not safe)) (##length _g298965_))))
        (cond ((let () (declare (not safe)) (##fx= _g298964_ 2))
               (apply std/srfi/160/u8#u8vector-for-each__0 _g298965_))
              ((let () (declare (not safe)) (##fx>= _g298964_ 2))
               (apply std/srfi/160/u8#u8vector-for-each__1 _g298965_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-for-each
                _g298965_))))))
  (define std/srfi/160/u8#u8vector-count__0
    (lambda (_pred135277_ _v135279_)
      (if (procedure? _pred135277_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135277_))
      (let ((_end135282_ (u8vector-length _v135279_)))
        (declare (not safe))
        (let _lp135286_ ((_i135289_ '0) (_r135291_ '0))
          (if (fx< _i135289_ _end135282_)
              (if (_pred135277_ (u8vector-ref _v135279_ _i135289_))
                  (_lp135286_ (fx+ _i135289_ '1) (fx+ _r135291_ '1))
                  (_lp135286_ (fx+ _i135289_ '1) _r135291_))
              _r135291_)))))
  (define std/srfi/160/u8#u8vector-count__1
    (lambda (_pred135294_ _v135295_ . _vs135296_)
      (if (procedure? _pred135294_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135294_))
      (let* ((_vs135299_ (cons _v135295_ _vs135296_))
             (_end135301_ (apply fxmin (map u8vector-length _vs135299_))))
        (declare (not safe))
        (let _lp135305_ ((_i135307_ '0) (_r135308_ '0))
          (if (fx< _i135307_ _end135301_)
              (if (apply _pred135294_
                         (map (lambda (_g135309135311_)
                                (u8vector-ref _g135309135311_ _i135307_))
                              _vs135299_))
                  (_lp135305_ (fx+ _i135307_ '1) (fx+ _r135308_ '1))
                  (_lp135305_ (fx+ _i135307_ '1) _r135308_))
              _r135308_)))))
  (define std/srfi/160/u8#u8vector-count
    (lambda _g298967_
      (let ((_g298966_ (let () (declare (not safe)) (##length _g298967_))))
        (cond ((let () (declare (not safe)) (##fx= _g298966_ 2))
               (apply std/srfi/160/u8#u8vector-count__0 _g298967_))
              ((let () (declare (not safe)) (##fx>= _g298966_ 2))
               (apply std/srfi/160/u8#u8vector-count__1 _g298967_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-count
                _g298967_))))))
  (define std/srfi/160/u8#u8vector-cumulate
    (lambda (_f135252_ _knil135254_ _v135256_)
      (if (procedure? _f135252_)
          '#!void
          (error '"Bad argument; expected procedure" _f135252_))
      (let* ((_len135259_ (u8vector-length _v135256_))
             (_r135262_ (make-u8vector _len135259_)))
        (declare (not safe))
        (let _lp135267_ ((_i135270_ '0) (_r135272_ _knil135254_))
          (if (fx< _i135270_ _len135259_)
              (let ((_next135274_
                     (_f135252_ _r135272_ (u8vector-ref _v135256_ _i135270_))))
                (u8vector-set! _v135256_ _i135270_ _next135274_)
                (_lp135267_ (fx+ _i135270_ '1) _next135274_))
              _v135256_)))))
  (define std/srfi/160/u8#u8vector-take-while
    (lambda (_pred135235_ _v135237_)
      (let* ((_len135240_ (u8vector-length _v135237_))
             (_idx135243_
              (std/srfi/160/u8#u8vector-skip__0 _pred135235_ _v135237_))
             (_idx135249_
              (let ((_$e135246_ _idx135243_))
                (if _$e135246_ _$e135246_ _len135240_))))
        (std/srfi/160/u8#u8vector-copy__% _v135237_ '0 _idx135249_))))
  (define std/srfi/160/u8#u8vector-take-while-right
    (lambda (_pred135221_ _v135223_)
      (let* ((_len135226_ (u8vector-length _v135223_))
             (_idx135229_
              (std/srfi/160/u8#u8vector-skip-right__0 _pred135221_ _v135223_))
             (_idx135232_ (if _idx135229_ (fx+ _idx135229_ '1) '0)))
        (std/srfi/160/u8#u8vector-copy__% _v135223_ _idx135232_ _len135226_))))
  (define std/srfi/160/u8#u8vector-drop-while
    (lambda (_pred135204_ _v135206_)
      (let* ((_len135209_ (u8vector-length _v135206_))
             (_idx135212_
              (std/srfi/160/u8#u8vector-skip__0 _pred135204_ _v135206_))
             (_idx135218_
              (let ((_$e135215_ _idx135212_))
                (if _$e135215_ _$e135215_ _len135209_))))
        (std/srfi/160/u8#u8vector-copy__% _v135206_ _idx135218_ _len135209_))))
  (define std/srfi/160/u8#u8vector-drop-while-right
    (lambda (_pred135190_ _v135192_)
      (let* ((_len135195_ (u8vector-length _v135192_))
             (_idx135198_
              (std/srfi/160/u8#u8vector-skip-right__0 _pred135190_ _v135192_))
             (_idx135201_ (if _idx135198_ (fx+ _idx135198_ '1) '0)))
        (std/srfi/160/u8#u8vector-copy__% _v135192_ '0 _idx135201_))))
  (define std/srfi/160/u8#u8vector-index__0
    (lambda (_pred135156_ _v135158_)
      (if (procedure? _pred135156_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135156_))
      (let ((_end135161_ (u8vector-length _v135158_)))
        (declare (not safe))
        (let _lp135165_ ((_i135168_ '0))
          (if (fx< _i135168_ _end135161_)
              (if (_pred135156_ (u8vector-ref _v135158_ _i135168_))
                  _i135168_
                  (_lp135165_ (fx+ _i135168_ '1)))
              '#f)))))
  (define std/srfi/160/u8#u8vector-index__1
    (lambda (_pred135171_ _v135172_ . _vs135173_)
      (if (procedure? _pred135171_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135171_))
      (let* ((_vs135176_ (cons _v135172_ _vs135173_))
             (_end135178_ (apply fxmin (map u8vector-length _vs135176_))))
        (declare (not safe))
        (let _lp135182_ ((_i135184_ '0))
          (if (fx< _i135184_ _end135178_)
              (if (apply _pred135171_
                         (map (lambda (_g135185135187_)
                                (u8vector-ref _g135185135187_ _i135184_))
                              _vs135176_))
                  _i135184_
                  (_lp135182_ (fx+ _i135184_ '1)))
              '#f)))))
  (define std/srfi/160/u8#u8vector-index
    (lambda _g298969_
      (let ((_g298968_ (let () (declare (not safe)) (##length _g298969_))))
        (cond ((let () (declare (not safe)) (##fx= _g298968_ 2))
               (apply std/srfi/160/u8#u8vector-index__0 _g298969_))
              ((let () (declare (not safe)) (##fx>= _g298968_ 2))
               (apply std/srfi/160/u8#u8vector-index__1 _g298969_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-index
                _g298969_))))))
  (define std/srfi/160/u8#u8vector-index-right__0
    (lambda (_pred135122_ _v135124_)
      (if (procedure? _pred135122_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135122_))
      (let ((_start135127_ (fx- (u8vector-length _v135124_) '1)))
        (declare (not safe))
        (let _lp135131_ ((_i135134_ _start135127_))
          (if (fx>= _i135134_ '0)
              (if (_pred135122_ (u8vector-ref _v135124_ _i135134_))
                  _i135134_
                  (_lp135131_ (fx- _i135134_ '1)))
              '#f)))))
  (define std/srfi/160/u8#u8vector-index-right__1
    (lambda (_pred135137_ _v135138_ . _vs135139_)
      (if (procedure? _pred135137_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135137_))
      (let* ((_vs135142_ (cons _v135138_ _vs135139_))
             (_start135144_
              (fx- (apply fxmin (map u8vector-length _vs135142_)) '1)))
        (declare (not safe))
        (let _lp135148_ ((_i135150_ _start135144_))
          (if (fx>= _i135150_ '0)
              (if (apply _pred135137_
                         (map (lambda (_g135151135153_)
                                (u8vector-ref _g135151135153_ _i135150_))
                              _vs135142_))
                  _i135150_
                  (_lp135148_ (fx- _i135150_ '1)))
              '#f)))))
  (define std/srfi/160/u8#u8vector-index-right
    (lambda _g298971_
      (let ((_g298970_ (let () (declare (not safe)) (##length _g298971_))))
        (cond ((let () (declare (not safe)) (##fx= _g298970_ 2))
               (apply std/srfi/160/u8#u8vector-index-right__0 _g298971_))
              ((let () (declare (not safe)) (##fx>= _g298970_ 2))
               (apply std/srfi/160/u8#u8vector-index-right__1 _g298971_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-index-right
                _g298971_))))))
  (define std/srfi/160/u8#u8vector-skip__0
    (lambda (_pred135106_ _v135108_)
      (std/srfi/160/u8#u8vector-index__0
       (lambda (_$obj135111_) (not (_pred135106_ _$obj135111_)))
       _v135108_)))
  (define std/srfi/160/u8#u8vector-skip__1
    (lambda (_pred135114_ _v135115_ . _vs135116_)
      (apply std/srfi/160/u8#u8vector-index
             (lambda (_$obj135119_) (not (_pred135114_ _$obj135119_)))
             _v135115_
             _vs135116_)))
  (define std/srfi/160/u8#u8vector-skip
    (lambda _g298973_
      (let ((_g298972_ (let () (declare (not safe)) (##length _g298973_))))
        (cond ((let () (declare (not safe)) (##fx= _g298972_ 2))
               (apply std/srfi/160/u8#u8vector-skip__0 _g298973_))
              ((let () (declare (not safe)) (##fx>= _g298972_ 2))
               (apply std/srfi/160/u8#u8vector-skip__1 _g298973_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-skip
                _g298973_))))))
  (define std/srfi/160/u8#u8vector-skip-right__0
    (lambda (_pred135090_ _v135092_)
      (std/srfi/160/u8#u8vector-index-right__0
       (lambda (_$obj135095_) (not (_pred135090_ _$obj135095_)))
       _v135092_)))
  (define std/srfi/160/u8#u8vector-skip-right__1
    (lambda (_pred135098_ _v135099_ . _vs135100_)
      (apply std/srfi/160/u8#u8vector-index-right
             (lambda (_$obj135103_) (not (_pred135098_ _$obj135103_)))
             _v135099_
             _vs135100_)))
  (define std/srfi/160/u8#u8vector-skip-right
    (lambda _g298975_
      (let ((_g298974_ (let () (declare (not safe)) (##length _g298975_))))
        (cond ((let () (declare (not safe)) (##fx= _g298974_ 2))
               (apply std/srfi/160/u8#u8vector-skip-right__0 _g298975_))
              ((let () (declare (not safe)) (##fx>= _g298974_ 2))
               (apply std/srfi/160/u8#u8vector-skip-right__1 _g298975_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-skip-right
                _g298975_))))))
  (define std/srfi/160/u8#u8vector-any__0
    (lambda (_pred135050_ _v135052_)
      (if (procedure? _pred135050_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135050_))
      (let ((_end135055_ (u8vector-length _v135052_)))
        (declare (not safe))
        (let _lp135059_ ((_i135062_ '0))
          (if (fx< _i135062_ _end135055_)
              (let ((_$e135065_
                     (_pred135050_ (u8vector-ref _v135052_ _i135062_))))
                (if _$e135065_
                    (values _$e135065_)
                    (_lp135059_ (fx+ _i135062_ '1))))
              '#f)))))
  (define std/srfi/160/u8#u8vector-any__1
    (lambda (_pred135068_ _v135069_ . _vs135070_)
      (if (procedure? _pred135068_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135068_))
      (let* ((_v135073_ (cons _v135069_ _vs135070_))
             (_end135075_ (apply fxmin (map u8vector-length _vs135070_))))
        (declare (not safe))
        (let _lp135079_ ((_i135081_ '0))
          (if (fx< _i135081_ _end135075_)
              (let ((_$e135087_
                     (apply _pred135068_
                            (map (lambda (_g135082135084_)
                                   (u8vector-ref _g135082135084_ _i135081_))
                                 _vs135070_))))
                (if _$e135087_
                    (values _$e135087_)
                    (_lp135079_ (fx+ _i135081_ '1))))
              '#f)))))
  (define std/srfi/160/u8#u8vector-any
    (lambda _g298977_
      (let ((_g298976_ (let () (declare (not safe)) (##length _g298977_))))
        (cond ((let () (declare (not safe)) (##fx= _g298976_ 2))
               (apply std/srfi/160/u8#u8vector-any__0 _g298977_))
              ((let () (declare (not safe)) (##fx>= _g298976_ 2))
               (apply std/srfi/160/u8#u8vector-any__1 _g298977_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-any
                _g298977_))))))
  (define std/srfi/160/u8#u8vector-every__0
    (lambda (_pred134999_ _v135001_)
      (if (procedure? _pred134999_)
          '#!void
          (error '"Bad argument; expected procedure" _pred134999_))
      (let ((_end135004_ (u8vector-length _v135001_)))
        (declare (not safe))
        (let _lp135008_ ((_i135011_ '0) (_r135013_ '#t))
          (if (fx< _i135011_ _end135004_)
              (let ((_$e135016_
                     (_pred134999_ (u8vector-ref _v135001_ _i135011_))))
                (if _$e135016_
                    ((lambda (_g135018135020_)
                       (_lp135008_ (fx+ _i135011_ '1) _g135018135020_))
                     _$e135016_)
                    '#f))
              _r135013_)))))
  (define std/srfi/160/u8#u8vector-every__1
    (lambda (_pred135023_ _v135024_ . _vs135025_)
      (if (procedure? _pred135023_)
          '#!void
          (error '"Bad argument; expected procedure" _pred135023_))
      (let* ((_v135028_ (cons _v135024_ _vs135025_))
             (_end135030_ (apply fxmin (map u8vector-length _vs135025_))))
        (declare (not safe))
        (let _lp135034_ ((_i135036_ '0) (_r135037_ '#t))
          (if (fx< _i135036_ _end135030_)
              (let ((_$e135043_
                     (apply _pred135023_
                            (map (lambda (_g135038135040_)
                                   (u8vector-ref _g135038135040_ _i135036_))
                                 _vs135025_))))
                (if _$e135043_
                    ((lambda (_g135045135047_)
                       (_lp135034_ (fx+ _i135036_ '1) _g135045135047_))
                     _$e135043_)
                    '#f))
              _r135037_)))))
  (define std/srfi/160/u8#u8vector-every
    (lambda _g298979_
      (let ((_g298978_ (let () (declare (not safe)) (##length _g298979_))))
        (cond ((let () (declare (not safe)) (##fx= _g298978_ 2))
               (apply std/srfi/160/u8#u8vector-every__0 _g298979_))
              ((let () (declare (not safe)) (##fx>= _g298978_ 2))
               (apply std/srfi/160/u8#u8vector-every__1 _g298979_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-every
                _g298979_))))))
  (define std/srfi/160/u8#u8vector-partition
    (lambda (_pred134970_ _v134972_)
      (let* ((_count134975_
              (std/srfi/160/u8#u8vector-count__0 _pred134970_ _v134972_))
             (_len134978_ (u8vector-length _v134972_))
             (_u134981_ (make-u8vector _len134978_)))
        (declare (not safe))
        (let _lp134986_ ((_i134989_ '0)
                         (_left134991_ '0)
                         (_right134993_ _count134975_))
          (if (fx< _i134989_ _len134978_)
              (let ((_x134996_ (u8vector-ref _v134972_ _i134989_)))
                (if (_pred134970_ _x134996_)
                    (begin
                      (u8vector-set! _u134981_ _left134991_ _x134996_)
                      (_lp134986_
                       (fx+ _i134989_ '1)
                       (fx+ _left134991_ '1)
                       _right134993_))
                    (begin
                      (u8vector-set! _u134981_ _right134993_ _x134996_)
                      (_lp134986_
                       (fx+ _i134989_ '1)
                       _left134991_
                       (fx+ _right134993_ '1)))))
              _u134981_)))))
  (define std/srfi/160/u8#u8vector-filter
    (lambda (_pred134943_ _v134945_)
      (let* ((_count134948_
              (std/srfi/160/u8#u8vector-count__0 _pred134943_ _v134945_))
             (_u134951_ (make-u8vector _count134948_))
             (_end134954_ (u8vector-length _v134945_)))
        (declare (not safe))
        (let _lp134959_ ((_i134962_ '0) (_j134964_ '0))
          (if (fx< _i134962_ _end134954_)
              (let ((_x134967_ (u8vector-ref _v134945_ _i134962_)))
                (if (_pred134943_ _x134967_)
                    (begin
                      (u8vector-set! _u134951_ _j134964_ _x134967_)
                      (_lp134959_ (fx+ _i134962_ '1) (fx+ _j134964_ '1)))
                    (_lp134959_ (fx+ _i134962_ '1) _j134964_)))
              _u134951_)))))
  (define std/srfi/160/u8#u8vector-remove
    (lambda (_pred134935_ _v134937_)
      (std/srfi/160/u8#u8vector-filter
       (lambda (_$obj134940_) (not (_pred134935_ _$obj134940_)))
       _v134937_)))
  (define std/srfi/160/u8#u8vector-swap
    (lambda (_v134922_ _i134924_ _j134926_)
      (let ((_iv134929_ (u8vector-ref _v134922_ _i134924_))
            (_jv134931_ (u8vector-ref _v134922_ _j134926_)))
        (declare (not safe))
        (begin
          (u8vector-set! _v134922_ _i134924_ _jv134931_)
          (u8vector-set! _v134922_ _j134926_ _iv134929_)))))
  (define std/srfi/160/u8#u8vector-fill!__%
    (lambda (_v134885_ _fill134887_ _start134889_ _end134891_)
      (declare (not safe))
      (begin
        (if (u8vector? _v134885_) '#!void (error '"Bad argument" _v134885_))
        (if (std/srfi/160/base#u8? _fill134887_)
            '#!void
            (error '"Bad argument" _fill134887_))
        (if (and (fixnum? _start134889_)
                 (fx<= '0 _start134889_ (fx- (u8vector-length _v134885_) '1)))
            '#!void
            (error '"Index out of range" _start134889_))
        (if (and (fixnum? _end134891_)
                 (fx<= _start134889_ _end134891_ (u8vector-length _v134885_)))
            '#!void
            (error '"Index out of range" _end134891_))
        (let _lp134895_ ((_i134898_ _start134889_))
          (if (fx< _i134898_ _end134891_)
              (begin
                (u8vector-set! _v134885_ _i134898_ _fill134887_)
                (_lp134895_ (fx+ _i134898_ '1)))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-fill!__0
    (lambda (_v134904_ _fill134905_)
      (let* ((_start134907_ '0) (_end134909_ (u8vector-length _v134904_)))
        (std/srfi/160/u8#u8vector-fill!__%
         _v134904_
         _fill134905_
         _start134907_
         _end134909_))))
  (define std/srfi/160/u8#u8vector-fill!__1
    (lambda (_v134911_ _fill134912_ _start134913_)
      (let ((_end134915_ (u8vector-length _v134911_)))
        (std/srfi/160/u8#u8vector-fill!__%
         _v134911_
         _fill134912_
         _start134913_
         _end134915_))))
  (define std/srfi/160/u8#u8vector-fill!
    (lambda _g298981_
      (let ((_g298980_ (let () (declare (not safe)) (##length _g298981_))))
        (cond ((let () (declare (not safe)) (##fx= _g298980_ 2))
               (apply std/srfi/160/u8#u8vector-fill!__0 _g298981_))
              ((let () (declare (not safe)) (##fx= _g298980_ 3))
               (apply std/srfi/160/u8#u8vector-fill!__1 _g298981_))
              ((let () (declare (not safe)) (##fx= _g298980_ 4))
               (apply std/srfi/160/u8#u8vector-fill!__% _g298981_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-fill!
                _g298981_))))))
  (define std/srfi/160/u8#u8vector-reverse!__%
    (lambda (_v134845_ _start134847_ _end134849_)
      (declare (not safe))
      (begin
        (if (u8vector? _v134845_) '#!void (error '"Bad argument" _v134845_))
        (if (and (fixnum? _start134847_)
                 (fx<= '0 _start134847_ (fx- (u8vector-length _v134845_) '1)))
            '#!void
            (error '"Index out of range" _start134847_))
        (if (and (fixnum? _end134849_)
                 (fx<= _start134847_ _end134849_ (u8vector-length _v134845_)))
            '#!void
            (error '"Index out of range" _end134849_))
        (let _lp134853_ ((_i134856_ _start134847_)
                         (_j134858_ (fx- _end134849_ '1)))
          (if (fx< _i134856_ _j134858_)
              (let ((_iv134861_ (u8vector-ref _v134845_ _i134856_))
                    (_jv134863_ (u8vector-ref _v134845_ _j134858_)))
                (u8vector-set! _v134845_ _i134856_ _jv134863_)
                (u8vector-set! _v134845_ _j134858_ _iv134861_)
                (_lp134853_ (fx+ _i134856_ '1) (fx- _j134858_ '1)))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-reverse!__0
    (lambda (_v134869_)
      (let* ((_start134871_ '0) (_end134873_ (u8vector-length _v134869_)))
        (std/srfi/160/u8#u8vector-reverse!__%
         _v134869_
         _start134871_
         _end134873_))))
  (define std/srfi/160/u8#u8vector-reverse!__1
    (lambda (_v134875_ _start134876_)
      (let ((_end134878_ (u8vector-length _v134875_)))
        (std/srfi/160/u8#u8vector-reverse!__%
         _v134875_
         _start134876_
         _end134878_))))
  (define std/srfi/160/u8#u8vector-reverse!
    (lambda _g298983_
      (let ((_g298982_ (let () (declare (not safe)) (##length _g298983_))))
        (cond ((let () (declare (not safe)) (##fx= _g298982_ 1))
               (apply std/srfi/160/u8#u8vector-reverse!__0 _g298983_))
              ((let () (declare (not safe)) (##fx= _g298982_ 2))
               (apply std/srfi/160/u8#u8vector-reverse!__1 _g298983_))
              ((let () (declare (not safe)) (##fx= _g298982_ 3))
               (apply std/srfi/160/u8#u8vector-reverse!__% _g298983_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector-reverse!
                _g298983_))))))
  (define std/srfi/160/u8#u8vector-unfold!
    (lambda (_f134820_ _v134822_ _start134824_ _end134826_ _seed134828_)
      (declare (not safe))
      (begin
        (if (procedure? _f134820_)
            '#!void
            (error '"Bad argument; expected procedure" _f134820_))
        (if (u8vector? _v134822_) '#!void (error '"Bad argument" _v134822_))
        (if (and (fixnum? _start134824_)
                 (fx<= '0 _start134824_ (fx- (u8vector-length _v134822_) '1)))
            '#!void
            (error '"Index out of range" _start134824_))
        (if (and (fixnum? _end134826_)
                 (fx<= _start134824_ _end134826_ (u8vector-length _v134822_)))
            '#!void
            (error '"Index out of range" _end134826_))
        (let _lp134832_ ((_i134835_ _start134824_)
                         (_state134837_ _seed134828_))
          (if (fx< _i134835_ _end134826_)
              (let ((_g298984_ (_f134820_ _state134837_)))
                (begin
                  (let ((_g298985_
                         (if (##values? _g298984_)
                             (##vector-length _g298984_)
                             1)))
                    (if (not (##fx= _g298985_ 2))
                        (error "Context expects 2 values" _g298985_)))
                  (let ((_x134840_ (##vector-ref _g298984_ 0))
                        (_state134842_ (##vector-ref _g298984_ 1)))
                    (begin
                      (u8vector-set! _v134822_ _i134835_ _x134840_)
                      (_lp134832_ (fx+ _i134835_ '1) _state134842_)))))
              '#!void)))))
  (define std/srfi/160/u8#u8vector-unfold-right!
    (lambda (_f134796_ _v134798_ _start134800_ _end134802_ _seed134804_)
      (declare (not safe))
      (begin
        (if (procedure? _f134796_)
            '#!void
            (error '"Bad argument; expected procedure" _f134796_))
        (if (u8vector? _v134798_) '#!void (error '"Bad argument" _v134798_))
        (if (and (fixnum? _start134800_)
                 (fx<= '0 _start134800_ (fx- (u8vector-length _v134798_) '1)))
            '#!void
            (error '"Index out of range" _start134800_))
        (if (and (fixnum? _end134802_)
                 (fx<= _start134800_ _end134802_ (u8vector-length _v134798_)))
            '#!void
            (error '"Index out of range" _end134802_))
        (let _lp134808_ ((_i134811_ (fx- _end134802_ '1))
                         (_state134813_ _seed134804_))
          (if (fx>= _i134811_ _start134800_)
              (let ((_g298986_ (_f134796_ _state134813_)))
                (begin
                  (let ((_g298987_
                         (if (##values? _g298986_)
                             (##vector-length _g298986_)
                             1)))
                    (if (not (##fx= _g298987_ 2))
                        (error "Context expects 2 values" _g298987_)))
                  (let ((_x134816_ (##vector-ref _g298986_ 0))
                        (_state134818_ (##vector-ref _g298986_ 1)))
                    (begin
                      (u8vector-set! _v134798_ _i134811_ _x134816_)
                      (_lp134808_ (fx- _i134811_ '1) _state134818_)))))
              '#!void)))))
  (define std/srfi/160/u8#reverse-u8vector->list__%
    (lambda (_v134762_ _start134764_ _end134766_)
      (declare (not safe))
      (begin
        (if (u8vector? _v134762_) '#!void (error '"Bad argument" _v134762_))
        (if (and (fixnum? _start134764_)
                 (fx<= '0 _start134764_ (fx- (u8vector-length _v134762_) '1)))
            '#!void
            (error '"Index out of range" _start134764_))
        (if (and (fixnum? _end134766_)
                 (fx<= _start134764_ _end134766_ (u8vector-length _v134762_)))
            '#!void
            (error '"Index out of range" _end134766_))
        (let _lp134770_ ((_i134773_ _start134764_) (_r134775_ '()))
          (if (fx< _i134773_ _end134766_)
              (_lp134770_
               (fx+ _i134773_ '1)
               (cons (u8vector-ref _v134762_ _i134773_) _r134775_))
              _r134775_)))))
  (define std/srfi/160/u8#reverse-u8vector->list__0
    (lambda (_v134781_)
      (let* ((_start134783_ '0) (_end134785_ (u8vector-length _v134781_)))
        (std/srfi/160/u8#reverse-u8vector->list__%
         _v134781_
         _start134783_
         _end134785_))))
  (define std/srfi/160/u8#reverse-u8vector->list__1
    (lambda (_v134787_ _start134788_)
      (let ((_end134790_ (u8vector-length _v134787_)))
        (std/srfi/160/u8#reverse-u8vector->list__%
         _v134787_
         _start134788_
         _end134790_))))
  (define std/srfi/160/u8#reverse-u8vector->list
    (lambda _g298989_
      (let ((_g298988_ (let () (declare (not safe)) (##length _g298989_))))
        (cond ((let () (declare (not safe)) (##fx= _g298988_ 1))
               (apply std/srfi/160/u8#reverse-u8vector->list__0 _g298989_))
              ((let () (declare (not safe)) (##fx= _g298988_ 2))
               (apply std/srfi/160/u8#reverse-u8vector->list__1 _g298989_))
              ((let () (declare (not safe)) (##fx= _g298988_ 3))
               (apply std/srfi/160/u8#reverse-u8vector->list__% _g298989_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#reverse-u8vector->list
                _g298989_))))))
  (define std/srfi/160/u8#reverse-list->u8vector
    (lambda (_lst134708_)
      (let* ((_len134711_ (length _lst134708_))
             (_v134714_ (make-u8vector _len134711_)))
        (declare (not safe))
        (let _lp134719_ ((_rest134722_ _lst134708_) (_i134724_ '0))
          (let* ((_rest134726134734_ _rest134722_)
                 (_else134728134742_ (lambda () _v134714_))
                 (_K134730134749_
                  (lambda (_rest134745_ _x134746_)
                    (if (std/srfi/160/base#u8? _x134746_)
                        '#!void
                        (error '"Bad element" _x134746_))
                    (u8vector-set! _v134714_ _i134724_ _x134746_)
                    (_lp134719_ _rest134745_ (fx+ _i134724_ '1)))))
            (if (##pair? _rest134726134734_)
                (let ((_hd134731134752_ (##car _rest134726134734_))
                      (_tl134732134754_ (##cdr _rest134726134734_)))
                  (let* ((_x134757_ _hd134731134752_)
                         (_rest134759_ _tl134732134754_))
                    (_K134730134749_ _rest134759_ _x134757_)))
                (_else134728134742_)))))))
  (define std/srfi/160/u8#u8vector->vector__%
    (lambda (_v134669_ _start134671_ _end134673_)
      (declare (not safe))
      (begin
        (if (u8vector? _v134669_) '#!void (error '"Bad argument" _v134669_))
        (if (and (fixnum? _start134671_)
                 (fx<= '0 _start134671_ (fx- (u8vector-length _v134669_) '1)))
            '#!void
            (error '"Index out of range" _start134671_))
        (if (and (fixnum? _end134673_)
                 (fx<= _start134671_ _end134673_ (u8vector-length _v134669_)))
            '#!void
            (error '"Index out of range" _end134673_))
        (let* ((_len134677_ (u8vector-length _v134669_))
               (_u134680_ (make-vector _len134677_)))
          (let _lp134684_ ((_i134687_ '0))
            (if (fx< _i134687_ _len134677_)
                (begin
                  (vector-set!
                   _u134680_
                   _i134687_
                   (u8vector-ref _v134669_ _i134687_))
                  (_lp134684_ (fx+ _i134687_ '1)))
                _u134680_))))))
  (define std/srfi/160/u8#u8vector->vector__0
    (lambda (_v134693_)
      (let* ((_start134695_ '0) (_end134697_ (u8vector-length _v134693_)))
        (std/srfi/160/u8#u8vector->vector__%
         _v134693_
         _start134695_
         _end134697_))))
  (define std/srfi/160/u8#u8vector->vector__1
    (lambda (_v134699_ _start134700_)
      (let ((_end134702_ (u8vector-length _v134699_)))
        (std/srfi/160/u8#u8vector->vector__%
         _v134699_
         _start134700_
         _end134702_))))
  (define std/srfi/160/u8#u8vector->vector
    (lambda _g298991_
      (let ((_g298990_ (let () (declare (not safe)) (##length _g298991_))))
        (cond ((let () (declare (not safe)) (##fx= _g298990_ 1))
               (apply std/srfi/160/u8#u8vector->vector__0 _g298991_))
              ((let () (declare (not safe)) (##fx= _g298990_ 2))
               (apply std/srfi/160/u8#u8vector->vector__1 _g298991_))
              ((let () (declare (not safe)) (##fx= _g298990_ 3))
               (apply std/srfi/160/u8#u8vector->vector__% _g298991_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#u8vector->vector
                _g298991_))))))
  (define std/srfi/160/u8#vector->u8vector__%
    (lambda (_v134629_ _start134631_ _end134633_)
      (declare (not safe))
      (begin
        (if (vector? _v134629_)
            '#!void
            (error '"Bad argument; expected vector" _v134629_))
        (if (and (fixnum? _start134631_)
                 (fx<= '0 _start134631_ (fx- (vector-length _v134629_) '1)))
            '#!void
            (error '"Index out of range" _start134631_))
        (if (and (fixnum? _end134633_)
                 (fx<= _start134631_ _end134633_ (vector-length _v134629_)))
            '#!void
            (error '"Index out of range" _end134633_))
        (let* ((_len134637_ (vector-length _v134629_))
               (_u134640_ (make-u8vector _len134637_)))
          (let _lp134644_ ((_i134647_ '0))
            (if (fx< _i134647_ _len134637_)
                (begin
                  (u8vector-set!
                   _u134640_
                   _i134647_
                   (vector-ref _v134629_ _i134647_))
                  (_lp134644_ (fx+ _i134647_ '1)))
                _u134640_))))))
  (define std/srfi/160/u8#vector->u8vector__0
    (lambda (_v134653_)
      (let* ((_start134655_ '0) (_end134657_ (vector-length _v134653_)))
        (std/srfi/160/u8#vector->u8vector__%
         _v134653_
         _start134655_
         _end134657_))))
  (define std/srfi/160/u8#vector->u8vector__1
    (lambda (_v134659_ _start134660_)
      (let ((_end134662_ (vector-length _v134659_)))
        (std/srfi/160/u8#vector->u8vector__%
         _v134659_
         _start134660_
         _end134662_))))
  (define std/srfi/160/u8#vector->u8vector
    (lambda _g298993_
      (let ((_g298992_ (let () (declare (not safe)) (##length _g298993_))))
        (cond ((let () (declare (not safe)) (##fx= _g298992_ 1))
               (apply std/srfi/160/u8#vector->u8vector__0 _g298993_))
              ((let () (declare (not safe)) (##fx= _g298992_ 2))
               (apply std/srfi/160/u8#vector->u8vector__1 _g298993_))
              ((let () (declare (not safe)) (##fx= _g298992_ 3))
               (apply std/srfi/160/u8#vector->u8vector__% _g298993_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#vector->u8vector
                _g298993_))))))
  (define std/srfi/160/u8#make-u8vector-generator__%
    (lambda (_v134595_ _start134597_ _end134599_)
      (declare (not safe))
      (begin
        (if (u8vector? _v134595_) '#!void (error '"Bad argument" _v134595_))
        (if (and (fixnum? _start134597_)
                 (fx<= '0 _start134597_ (fx- (u8vector-length _v134595_) '1)))
            '#!void
            (error '"Index out of range" _start134597_))
        (if (and (fixnum? _end134599_)
                 (fx<= _start134597_ _end134599_ (u8vector-length _v134595_)))
            '#!void
            (error '"Index out of range" _end134599_))
        (let ((_i134603_ _start134597_))
          (lambda ()
            (if (fx< _i134603_ _end134599_)
                (let ((_next134607_ (u8vector-ref _v134595_ _i134603_)))
                  (set! _i134603_ (fx+ _i134603_ '1))
                  _next134607_)
                '#!eof))))))
  (define std/srfi/160/u8#make-u8vector-generator__0
    (lambda (_v134613_)
      (let* ((_start134615_ '0) (_end134617_ (u8vector-length _v134613_)))
        (std/srfi/160/u8#make-u8vector-generator__%
         _v134613_
         _start134615_
         _end134617_))))
  (define std/srfi/160/u8#make-u8vector-generator__1
    (lambda (_v134619_ _start134620_)
      (let ((_end134622_ (u8vector-length _v134619_)))
        (std/srfi/160/u8#make-u8vector-generator__%
         _v134619_
         _start134620_
         _end134622_))))
  (define std/srfi/160/u8#make-u8vector-generator
    (lambda _g298995_
      (let ((_g298994_ (let () (declare (not safe)) (##length _g298995_))))
        (cond ((let () (declare (not safe)) (##fx= _g298994_ 1))
               (apply std/srfi/160/u8#make-u8vector-generator__0 _g298995_))
              ((let () (declare (not safe)) (##fx= _g298994_ 2))
               (apply std/srfi/160/u8#make-u8vector-generator__1 _g298995_))
              ((let () (declare (not safe)) (##fx= _g298994_ 3))
               (apply std/srfi/160/u8#make-u8vector-generator__% _g298995_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#make-u8vector-generator
                _g298995_))))))
  (define std/srfi/160/u8#u8vector-comparator
    (let ()
      (letrec ((_<?134566_
                (lambda (_a134569_ _b134571_)
                  (let ((_len-a134574_ (u8vector-length _a134569_))
                        (_len-b134576_ (u8vector-length _b134571_)))
                    (declare (not safe))
                    (if (fx< _len-a134574_ _len-b134576_)
                        '#t
                        (if (fx> _len-a134574_ _len-b134576_)
                            '#f
                            (let ((_end134580_ _len-a134574_))
                              (let _lp134583_ ((_i134586_ '0))
                                (if (fx< _i134586_ _end134580_)
                                    (let ((_x134589_
                                           (u8vector-ref _a134569_ _i134586_))
                                          (_y134591_
                                           (u8vector-ref _b134571_ _i134586_)))
                                      (if (< _x134589_ _y134591_)
                                          '#t
                                          (if (> _x134589_ _y134591_)
                                              '#f
                                              (_lp134583_
                                               (fx+ _i134586_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           u8vector?
           std/srfi/160/u8#u8vector=
           _<?134566_
           equal?-hash)))))
  (define std/srfi/160/u8#write-u8vector__%
    (lambda (_v134543_ _port134545_)
      (let ((_$e134548_ (find-method _v134543_ ':write)))
        (if _$e134548_
            ((lambda (_g134550134552_)
               (_g134550134552_ _v134543_ _port134545_))
             _$e134548_)
            (write _v134543_ (current-output-port))))))
  (define std/srfi/160/u8#write-u8vector__0
    (lambda (_v134558_)
      (let ((_port134560_ (current-output-port)))
        (std/srfi/160/u8#write-u8vector__% _v134558_ _port134560_))))
  (define std/srfi/160/u8#write-u8vector
    (lambda _g298997_
      (let ((_g298996_ (let () (declare (not safe)) (##length _g298997_))))
        (cond ((let () (declare (not safe)) (##fx= _g298996_ 1))
               (apply std/srfi/160/u8#write-u8vector__0 _g298997_))
              ((let () (declare (not safe)) (##fx= _g298996_ 2))
               (apply std/srfi/160/u8#write-u8vector__% _g298997_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u8#write-u8vector
                _g298997_)))))))
