(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/srfi-135/kernel8#complain
    (lambda (_name101858_ . _args101859_)
      (apply error
             (string-append
              (symbol->string _name101858_)
              '": illegal arguments")
             _args101859_)))
  (define std/srfi/srfi-135/kernel8#list->bytevector
    (lambda (_bytes101845_)
      (let* ((_n101847_ (length _bytes101845_))
             (_bv101849_ (make-u8vector _n101847_)))
        (let _$loop101852_ ((_i101855_ '0) (_bytes101856_ _bytes101845_))
          (if (= _i101855_ _n101847_)
              '#!void
              (begin
                (u8vector-set! _bv101849_ _i101855_ (car _bytes101856_))
                (_$loop101852_ (+ _i101855_ '1) (cdr _bytes101856_)))))
        _bv101849_)))
  (define std/srfi/srfi-135/kernel8#%string->text
    (lambda (_s101841_)
      (if (string? _s101841_)
          (std/srfi/srfi-135/kernel8#text-tabulate
           (lambda (_i101843_) (string-ref _s101841_ _i101843_))
           (string-length _s101841_))
          (std/srfi/srfi-135/kernel8#complain 'string->text _s101841_))))
  (define std/srfi/srfi-135/kernel8#N '128)
  (define std/srfi/srfi-135/kernel8#length&i0
    (lambda (_len101838_ _i0101839_)
      (+ (* std/srfi/srfi-135/kernel8#N _len101838_) _i0101839_)))
  (define std/srfi/srfi-135/kernel8#text-rtd
    (make-struct-type
     'std/srfi/srfi-135/kernel8#text-rtd
     '#f
     '2
     'text-rtd
     '((fields: k chunks))
     '#f))
  (define std/srfi/srfi-135/kernel8#text?
    (make-struct-predicate std/srfi/srfi-135/kernel8#text-rtd))
  (define std/srfi/srfi-135/kernel8#text.k
    (make-struct-field-accessor std/srfi/srfi-135/kernel8#text-rtd '0))
  (define std/srfi/srfi-135/kernel8#text.chunks
    (make-struct-field-accessor std/srfi/srfi-135/kernel8#text-rtd '1))
  (define std/srfi/srfi-135/kernel8#new-text0
    (lambda (_k101835_ _chunks101836_)
      (make-struct-instance
       std/srfi/srfi-135/kernel8#text-rtd
       _k101835_
       _chunks101836_)))
  (define std/srfi/srfi-135/kernel8#%new-text
    (lambda (_len101831_ _i0101832_ _chunks101833_)
      (let ((__tmp295223
             (std/srfi/srfi-135/kernel8#length&i0 _len101831_ _i0101832_)))
        (declare (not safe))
        (##structure
         std/srfi/srfi-135/kernel8#text-rtd
         __tmp295223
         _chunks101833_))))
  (define std/srfi/srfi-135/kernel8#the-empty-text
    (std/srfi/srfi-135/kernel8#%new-text '0 '0 (vector (make-u8vector '0))))
  (define std/srfi/srfi-135/kernel8#text-length
    (lambda (_txt101829_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of?
             _txt101829_
             'std/srfi/srfi-135/kernel8#text-rtd))
          (quotient
           (##structure-ref
            _txt101829_
            '1
            std/srfi/srfi-135/kernel8#text-rtd
            '#f)
           std/srfi/srfi-135/kernel8#N)
          (error '"text-length: not a text" _txt101829_))))
  (define std/srfi/srfi-135/kernel8#text-ref
    (lambda (_txt101806_ _i101807_)
      (if (and (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _txt101806_
                  'std/srfi/srfi-135/kernel8#text-rtd))
               (exact-integer? _i101807_)
               (<= '0 _i101807_))
          (let* ((_k101809_
                  (##structure-ref
                   _txt101806_
                   '1
                   std/srfi/srfi-135/kernel8#text-rtd
                   '#f))
                 (_chunks101811_
                  (##structure-ref
                   _txt101806_
                   '2
                   std/srfi/srfi-135/kernel8#text-rtd
                   '#f))
                 (_len101813_ (quotient _k101809_ std/srfi/srfi-135/kernel8#N))
                 (_i0101815_ (remainder _k101809_ std/srfi/srfi-135/kernel8#N))
                 (_i+i0101817_ (+ _i101807_ _i0101815_))
                 (_j101819_
                  (quotient _i+i0101817_ std/srfi/srfi-135/kernel8#N))
                 (_ii101821_
                  (remainder _i+i0101817_ std/srfi/srfi-135/kernel8#N)))
            (if (< _i101807_ _len101813_)
                (let* ((_sj101824_ (vector-ref _chunks101811_ _j101819_))
                       (_sjn101826_ (u8vector-length _sj101824_)))
                  (if (if (< _j101819_ (- (vector-length _chunks101811_) '1))
                          (= _sjn101826_ std/srfi/srfi-135/kernel8#N)
                          (= _sjn101826_
                             (remainder
                              (+ _i0101815_ _len101813_)
                              std/srfi/srfi-135/kernel8#N)))
                      (integer->char (u8vector-ref _sj101824_ _ii101821_))
                      (std/srfi/srfi-135/kernel8#%utf8-ref
                       _sj101824_
                       _ii101821_)))
                (error '"text-ref: index out of range" _txt101806_ _i101807_)))
          (error '"text-ref: illegal arguments" _txt101806_ _i101807_))))
  (define std/srfi/srfi-135/kernel8#%text-length
    (lambda (_txt101804_)
      (quotient
       (##structure-ref _txt101804_ '1 std/srfi/srfi-135/kernel8#text-rtd '#f)
       std/srfi/srfi-135/kernel8#N)))
  (define std/srfi/srfi-135/kernel8#%text-ref
    (lambda (_txt101782_ _i101783_)
      (let* ((_k101785_
              (##structure-ref
               _txt101782_
               '1
               std/srfi/srfi-135/kernel8#text-rtd
               '#f))
             (_chunks101787_
              (##structure-ref
               _txt101782_
               '2
               std/srfi/srfi-135/kernel8#text-rtd
               '#f))
             (_len101789_ (quotient _k101785_ std/srfi/srfi-135/kernel8#N))
             (_i0101791_ (remainder _k101785_ std/srfi/srfi-135/kernel8#N))
             (_i+i0101793_ (+ _i101783_ _i0101791_))
             (_j101795_ (quotient _i+i0101793_ std/srfi/srfi-135/kernel8#N))
             (_ii101797_ (remainder _i+i0101793_ std/srfi/srfi-135/kernel8#N))
             (_sj101799_ (vector-ref _chunks101787_ _j101795_))
             (_sjn101801_ (u8vector-length _sj101799_)))
        (if (if (< _j101795_ (- (vector-length _chunks101787_) '1))
                (= _sjn101801_ std/srfi/srfi-135/kernel8#N)
                (= _sjn101801_
                   (remainder
                    (+ _i0101791_ _len101789_)
                    std/srfi/srfi-135/kernel8#N)))
            (integer->char (u8vector-ref _sj101799_ _ii101797_))
            (std/srfi/srfi-135/kernel8#%utf8-ref _sj101799_ _ii101797_)))))
  (define std/srfi/srfi-135/kernel8#%utf8-ref
    (lambda (_bv101772_ _i101773_)
      (let _loop101775_ ((_j101777_ '0) (_k101778_ '0))
        (if (= _i101773_ _j101777_)
            (std/srfi/srfi-135/kernel8#%utf8-char-at _bv101772_ _k101778_)
            (let ((_byte101780_ (u8vector-ref _bv101772_ _k101778_)))
              (if (< _byte101780_ '128)
                  (_loop101775_ (+ _j101777_ '1) (+ _k101778_ '1))
                  (if (< _byte101780_ '224)
                      (_loop101775_ (+ _j101777_ '1) (+ _k101778_ '2))
                      (if (< _byte101780_ '240)
                          (_loop101775_ (+ _j101777_ '1) (+ _k101778_ '3))
                          (_loop101775_
                           (+ _j101777_ '1)
                           (+ _k101778_ '4))))))))))
  (define std/srfi/srfi-135/kernel8#%utf8-char-at
    (lambda (_bv101728_ _k101729_)
      (let ((_byte101731_ (u8vector-ref _bv101728_ _k101729_)))
        (if (< _byte101731_ '128)
            (integer->char _byte101731_)
            (if (< _byte101731_ '224)
                (let* ((_byte2101733_
                        (u8vector-ref _bv101728_ (+ _k101729_ '1)))
                       (_bits1101735_ (- _byte101731_ '192))
                       (_bits2101737_ (- _byte2101733_ '128))
                       (_cp101739_ (+ (* '64 _bits1101735_) _bits2101737_)))
                  (integer->char _cp101739_))
                (if (< _byte101731_ '240)
                    (let* ((_byte2101742_
                            (u8vector-ref _bv101728_ (+ _k101729_ '1)))
                           (_byte3101744_
                            (u8vector-ref _bv101728_ (+ _k101729_ '2)))
                           (_bits1101746_ (- _byte101731_ '224))
                           (_bits2101748_ (- _byte2101742_ '128))
                           (_bits3101750_ (- _byte3101744_ '128))
                           (_cp101752_
                            (+ (* '64 '64 _bits1101746_)
                               (* '64 _bits2101748_)
                               _bits3101750_)))
                      (integer->char _cp101752_))
                    (let* ((_byte2101755_
                            (u8vector-ref _bv101728_ (+ _k101729_ '1)))
                           (_byte3101757_
                            (u8vector-ref _bv101728_ (+ _k101729_ '2)))
                           (_byte4101759_
                            (u8vector-ref _bv101728_ (+ _k101729_ '3)))
                           (_bits1101761_ (- _byte101731_ '240))
                           (_bits2101763_ (- _byte2101755_ '128))
                           (_bits3101765_ (- _byte3101757_ '128))
                           (_bits4101767_ (- _byte4101759_ '128))
                           (_cp101769_
                            (+ (* '64 '64 '64 _bits1101761_)
                               (* '64 '64 _bits2101763_)
                               (* '64 _bits3101765_)
                               _bits4101767_)))
                      (integer->char _cp101769_))))))))
  (define std/srfi/srfi-135/kernel8#text-tabulate
    (lambda (_proc101673_ _len101674_)
      (if (= '0 _len101674_)
          std/srfi/srfi-135/kernel8#the-empty-text
          (let _loop101676_ ((_i101678_ _len101674_)
                             (_chunks101679_ '())
                             (_bytes101680_ '()))
            (if (= '0 _i101678_)
                (std/srfi/srfi-135/kernel8#%new-text
                 _len101674_
                 '0
                 (list->vector
                  (cons (std/srfi/srfi-135/kernel8#list->bytevector
                         _bytes101680_)
                        _chunks101679_)))
                (if (and (= '0
                            (remainder _i101678_ std/srfi/srfi-135/kernel8#N))
                         (not (null? _bytes101680_)))
                    (_loop101676_
                     _i101678_
                     (cons (std/srfi/srfi-135/kernel8#list->bytevector
                            _bytes101680_)
                           _chunks101679_)
                     '())
                    (let* ((_i-1101682_ (- _i101678_ '1))
                           (_c101684_ (_proc101673_ _i-1101682_)))
                      (if (char? _c101684_)
                          (let ((_cp101687_ (char->integer _c101684_)))
                            (_loop101676_
                             _i-1101682_
                             _chunks101679_
                             (if (< _cp101687_ '128)
                                 (cons _cp101687_ _bytes101680_)
                                 (if (< _cp101687_ '2048)
                                     (let* ((_bits1101689_
                                             (quotient _cp101687_ '64))
                                            (_bits2101691_
                                             (remainder _cp101687_ '64))
                                            (_byte1101693_
                                             (+ _bits1101689_ '192))
                                            (_byte2101695_
                                             (+ _bits2101691_ '128)))
                                       (cons _byte1101693_
                                             (cons _byte2101695_
                                                   _bytes101680_)))
                                     (if (< _cp101687_ '65536)
                                         (let* ((_bits1101698_
                                                 (quotient
                                                  _cp101687_
                                                  (* '64 '64)))
                                                (_bits2101700_
                                                 (quotient
                                                  (remainder
                                                   _cp101687_
                                                   (* '64 '64))
                                                  '64))
                                                (_bits3101702_
                                                 (remainder _cp101687_ '64))
                                                (_byte1101704_
                                                 (+ _bits1101698_ '224))
                                                (_byte2101706_
                                                 (+ _bits2101700_ '128))
                                                (_byte3101708_
                                                 (+ _bits3101702_ '128)))
                                           (cons _byte1101704_
                                                 (cons _byte2101706_
                                                       (cons _byte3101708_
                                                             _bytes101680_))))
                                         (let* ((_bits1101711_
                                                 (quotient
                                                  _cp101687_
                                                  (* '64 '64 '64)))
                                                (_bits2101713_
                                                 (quotient
                                                  (remainder
                                                   _cp101687_
                                                   (* '64 '64 '64))
                                                  (* '64 '64)))
                                                (_bits3101715_
                                                 (quotient
                                                  (remainder
                                                   _cp101687_
                                                   (* '64 '64))
                                                  '64))
                                                (_bits4101717_
                                                 (remainder _cp101687_ '64))
                                                (_byte1101719_
                                                 (+ _bits1101711_ '240))
                                                (_byte2101721_
                                                 (+ _bits2101713_ '128))
                                                (_byte3101723_
                                                 (+ _bits3101715_ '128))
                                                (_byte4101725_
                                                 (+ _bits4101717_ '128)))
                                           (cons _byte1101719_
                                                 (cons _byte2101721_
                                                       (cons _byte3101723_
                                                             (cons _byte4101725_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _bytes101680_))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                          (error '"text-tabulate: proc returned a non-character"
                                 _proc101673_
                                 _len101674_
                                 _c101684_)))))))))
  (define std/srfi/srfi-135/kernel8#subtext
    (lambda (_txt101669_ _start101670_ _end101671_)
      (if (and (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _txt101669_
                  'std/srfi/srfi-135/kernel8#text-rtd))
               (exact-integer? _start101670_)
               (exact-integer? _end101671_)
               (<= '0 _start101670_ _end101671_))
          (std/srfi/srfi-135/kernel8#%subtext
           _txt101669_
           _start101670_
           _end101671_)
          (std/srfi/srfi-135/kernel8#complain
           'subtext
           _txt101669_
           _start101670_
           _end101671_))))
  (define std/srfi/srfi-135/kernel8#%subtext
    (lambda (_txt101636_ _start101637_ _end101638_)
      (let* ((_k101640_
              (##structure-ref
               _txt101636_
               '1
               std/srfi/srfi-135/kernel8#text-rtd
               '#f))
             (_chunks101642_
              (##structure-ref
               _txt101636_
               '2
               std/srfi/srfi-135/kernel8#text-rtd
               '#f))
             (_len101644_ (quotient _k101640_ std/srfi/srfi-135/kernel8#N))
             (_i0101646_ (remainder _k101640_ std/srfi/srfi-135/kernel8#N))
             (_i+i0101648_ (+ _start101637_ _i0101646_))
             (_end+i0101650_ (+ _end101638_ _i0101646_))
             (_len+i0101652_ (+ _len101644_ _i0101646_))
             (_jstart101654_
              (quotient _i+i0101648_ std/srfi/srfi-135/kernel8#N))
             (_jend101656_
              (quotient _end+i0101650_ std/srfi/srfi-135/kernel8#N))
             (_jlen101658_ (quotient _len101644_ std/srfi/srfi-135/kernel8#N)))
        (if (<= _end101638_ _len101644_)
            (if (= _start101637_ _end101638_)
                std/srfi/srfi-135/kernel8#the-empty-text
                (if (and (= '0 _jstart101654_) (= _jlen101658_ _jend101656_))
                    (std/srfi/srfi-135/kernel8#%new-text
                     (- _end101638_ _start101637_)
                     _i+i0101648_
                     _chunks101642_)
                    (let ((_v101661_
                           (make-vector
                            (+ '1 (- _jend101656_ _jstart101654_)))))
                      (let _$loop101664_ ((_j101667_ _jstart101654_))
                        (if (> _j101667_ _jend101656_)
                            '#!void
                            (begin
                              (vector-set!
                               _v101661_
                               (- _j101667_ _jstart101654_)
                               (vector-ref _chunks101642_ _j101667_))
                              (_$loop101664_ (+ _j101667_ '1)))))
                      (std/srfi/srfi-135/kernel8#%new-text
                       (- _end101638_ _start101637_)
                       (remainder _i+i0101648_ std/srfi/srfi-135/kernel8#N)
                       _v101661_))))
            (error '"subtext: end out of range"
                   _txt101636_
                   _start101637_
                   _end101638_)))))
  (define std/srfi/srfi-135/kernel8#textual-concatenate
    (lambda (_texts101619_)
      (if (not (list? _texts101619_))
          (std/srfi/srfi-135/kernel8#complain
           'textual-concatenate
           _texts101619_)
          (if (null? _texts101619_)
              std/srfi/srfi-135/kernel8#the-empty-text
              (if (null? (cdr _texts101619_))
                  (let ((_txt101621_ (car _texts101619_)))
                    (if (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _txt101621_
                           'std/srfi/srfi-135/kernel8#text-rtd))
                        _txt101621_
                        (if (string? _txt101621_)
                            (std/srfi/srfi-135/kernel8#%string->text
                             _txt101621_)
                            (std/srfi/srfi-135/kernel8#complain
                             'textual-concatenate
                             _texts101619_))))
                  (let _loop101623_ ((_items101625_ (reverse _texts101619_))
                                     (_real-texts101626_ '())
                                     (_n101627_ '0)
                                     (_longest101628_ '#f)
                                     (_longest-length101629_ '0))
                    (if (null? _items101625_)
                        (std/srfi/srfi-135/kernel8#%text-concatenate-n
                         _real-texts101626_
                         _n101627_
                         _longest101628_
                         _longest-length101629_)
                        (if (let ((__tmp295224 (car _items101625_)))
                              (declare (not safe))
                              (##structure-instance-of?
                               __tmp295224
                               'std/srfi/srfi-135/kernel8#text-rtd))
                            (let* ((_txt101631_ (car _items101625_))
                                   (_k101633_
                                    (std/srfi/srfi-135/kernel8#%text-length
                                     _txt101631_)))
                              (_loop101623_
                               (cdr _items101625_)
                               (cons _txt101631_ _real-texts101626_)
                               (+ _n101627_ _k101633_)
                               (if (> _k101633_ _longest-length101629_)
                                   _txt101631_
                                   _longest101628_)
                               (max _k101633_ _longest-length101629_)))
                            (if (string? (car _items101625_))
                                (_loop101623_
                                 (cons (std/srfi/srfi-135/kernel8#%string->text
                                        (car _items101625_))
                                       (cdr _items101625_))
                                 _real-texts101626_
                                 _n101627_
                                 _longest101628_
                                 _longest-length101629_)
                                (std/srfi/srfi-135/kernel8#complain
                                 'textual-concatenate
                                 _texts101619_))))))))))
  (define std/srfi/srfi-135/kernel8#%text-concatenate-n
    (lambda (_texts101606_ _n101607_ _longest101608_ _longest-length101609_)
      (if (and _longest101608_
               (> _longest-length101609_ std/srfi/srfi-135/kernel8#N)
               (< _n101607_ (+ _longest-length101609_ _longest-length101609_))
               (= '0
                  (remainder
                   (##structure-ref
                    _longest101608_
                    '1
                    std/srfi/srfi-135/kernel8#text-rtd
                    '#f)
                   std/srfi/srfi-135/kernel8#N)))
          (if (eq? _longest101608_ (car _texts101606_))
              (std/srfi/srfi-135/kernel8#%%text-concatenate-n
               _texts101606_
               _n101607_)
              (let _loop101611_ ((_texts101613_ _texts101606_)
                                 (_front101614_ '())
                                 (_front-length101615_ '0))
                (if (eq? _longest101608_ (car _texts101613_))
                    (std/srfi/srfi-135/kernel8#%%text-concatenate-front
                     (reverse _front101614_)
                     (std/srfi/srfi-135/kernel8#%%text-concatenate-n
                      _texts101613_
                      (- _n101607_ _front-length101615_))
                     _front-length101615_
                     _n101607_)
                    (let ((_txt101617_ (car _texts101613_)))
                      (_loop101611_
                       (cdr _texts101613_)
                       (cons _txt101617_ _front101614_)
                       (+ _front-length101615_
                          (std/srfi/srfi-135/kernel8#%text-length
                           _txt101617_)))))))
          (std/srfi/srfi-135/kernel8#%%text-concatenate-n
           _texts101606_
           _n101607_))))
  (define std/srfi/srfi-135/kernel8#%%text-concatenate-n
    (lambda (_texts101574_ _n101575_)
      (if (= '0 _n101575_)
          std/srfi/srfi-135/kernel8#the-empty-text
          (let* ((_n/N101577_ (quotient _n101575_ std/srfi/srfi-135/kernel8#N))
                 (_m101579_ (remainder _n101575_ std/srfi/srfi-135/kernel8#N))
                 (_nchunks101581_ (+ _n/N101577_ (if (= '0 _m101579_) '0 '1)))
                 (_chunks101583_
                  (make-vector _nchunks101581_ 'bug-in-text-concatenate))
                 (_txt101585_ (car _texts101574_))
                 (_k101587_
                  (##structure-ref
                   _txt101585_
                   '1
                   std/srfi/srfi-135/kernel8#text-rtd
                   '#f))
                 (_len101589_ (quotient _k101587_ std/srfi/srfi-135/kernel8#N))
                 (_i0101591_
                  (remainder _k101587_ std/srfi/srfi-135/kernel8#N)))
            (if (and (> _len101589_ std/srfi/srfi-135/kernel8#N)
                     (= '0 _i0101591_))
                (let* ((_j101594_
                        (quotient _len101589_ std/srfi/srfi-135/kernel8#N))
                       (_ti101596_ (* _j101594_ std/srfi/srfi-135/kernel8#N))
                       (_chunks0101598_
                        (##structure-ref
                         _txt101585_
                         '2
                         std/srfi/srfi-135/kernel8#text-rtd
                         '#f)))
                  (let _$loop101601_ ((_i101604_ '0))
                    (if (= _i101604_ _j101594_)
                        '#!void
                        (begin
                          (vector-set!
                           _chunks101583_
                           _i101604_
                           (vector-ref _chunks0101598_ _i101604_))
                          (_$loop101601_ (+ _i101604_ '1)))))
                  (std/srfi/srfi-135/kernel8#%%text-concatenate-finish
                   _n101575_
                   '0
                   _chunks101583_
                   _j101594_
                   _texts101574_
                   _ti101596_))
                (std/srfi/srfi-135/kernel8#%%text-concatenate-finish
                 _n101575_
                 '0
                 _chunks101583_
                 '0
                 _texts101574_
                 '0))))))
  (define std/srfi/srfi-135/kernel8#%%text-concatenate-front
    (lambda (_texts101543_ _txt101544_ _k101545_ _n101546_)
      (let* ((_k/N101548_ (quotient _k101545_ std/srfi/srfi-135/kernel8#N))
             (_mk101550_ (remainder _k101545_ std/srfi/srfi-135/kernel8#N))
             (_i0101552_
              (if (= '0 _mk101550_)
                  '0
                  (- std/srfi/srfi-135/kernel8#N _mk101550_)))
             (_kchunks101554_ (+ _k/N101548_ (if (= '0 _mk101550_) '0 '1)))
             (_n-k101556_ (- _n101546_ _k101545_))
             (_n-k/N101558_ (quotient _n-k101556_ std/srfi/srfi-135/kernel8#N))
             (_m101560_ (remainder _n-k101556_ std/srfi/srfi-135/kernel8#N))
             (_nchunks101562_
              (+ _kchunks101554_ _n-k/N101558_ (if (= '0 _m101560_) '0 '1)))
             (_chunks101564_
              (make-vector _nchunks101562_ 'bug-in-text-concatenate))
             (_chunks2101566_
              (##structure-ref
               _txt101544_
               '2
               std/srfi/srfi-135/kernel8#text-rtd
               '#f)))
        (let _$loop101569_ ((_i101572_ _kchunks101554_))
          (if (= _i101572_ _nchunks101562_)
              '#!void
              (begin
                (vector-set!
                 _chunks101564_
                 _i101572_
                 (vector-ref _chunks2101566_ (- _i101572_ _kchunks101554_)))
                (_$loop101569_ (+ _i101572_ '1)))))
        (std/srfi/srfi-135/kernel8#%%text-concatenate-finish
         _n101546_
         _i0101552_
         _chunks101564_
         '0
         _texts101543_
         '0))))
  (define std/srfi/srfi-135/kernel8#%%text-concatenate-finish
    (lambda (_n101479_
             _i0101480_
             _chunks101481_
             _j101482_
             _texts101483_
             _ti101484_)
      (let _loop101486_ ((_texts101488_ (cdr _texts101483_))
                         (_txt101489_ (car _texts101483_))
                         (_j101490_ _j101482_)
                         (_k101491_ _i0101480_)
                         (_ti101492_ _ti101484_)
                         (_bytes101493_ (make-list _i0101480_ '0)))
        (if (= _k101491_ std/srfi/srfi-135/kernel8#N)
            (begin
              (let ((_bv101495_
                     (std/srfi/srfi-135/kernel8#list->bytevector
                      (reverse _bytes101493_))))
                (vector-set! _chunks101481_ _j101490_ _bv101495_))
              (_loop101486_
               _texts101488_
               _txt101489_
               (+ _j101490_ '1)
               '0
               _ti101492_
               '()))
            (if (= _ti101492_
                   (std/srfi/srfi-135/kernel8#%text-length _txt101489_))
                (if (null? _texts101488_)
                    (begin
                      (if (not (null? _bytes101493_))
                          (let ((_bv101497_
                                 (std/srfi/srfi-135/kernel8#list->bytevector
                                  (reverse _bytes101493_))))
                            (vector-set! _chunks101481_ _j101490_ _bv101497_))
                          '#!void)
                      (std/srfi/srfi-135/kernel8#%new-text
                       _n101479_
                       _i0101480_
                       _chunks101481_))
                    (_loop101486_
                     (cdr _texts101488_)
                     (car _texts101488_)
                     _j101490_
                     _k101491_
                     '0
                     _bytes101493_))
                (let* ((_cp101499_
                        (char->integer
                         (std/srfi/srfi-135/kernel8#%text-ref
                          _txt101489_
                          _ti101492_)))
                       (_bytes101540_
                        (if (< _cp101499_ '128)
                            (cons _cp101499_ _bytes101493_)
                            (if (< _cp101499_ '2048)
                                (let* ((_bits1101501_
                                        (quotient _cp101499_ '64))
                                       (_bits2101503_
                                        (remainder _cp101499_ '64))
                                       (_byte1101505_ (+ _bits1101501_ '192))
                                       (_byte2101507_ (+ _bits2101503_ '128)))
                                  (cons _byte2101507_
                                        (cons _byte1101505_ _bytes101493_)))
                                (if (< _cp101499_ '65536)
                                    (let* ((_bits1101510_
                                            (quotient _cp101499_ (* '64 '64)))
                                           (_bits2101512_
                                            (quotient
                                             (remainder _cp101499_ (* '64 '64))
                                             '64))
                                           (_bits3101514_
                                            (remainder _cp101499_ '64))
                                           (_byte1101516_
                                            (+ _bits1101510_ '224))
                                           (_byte2101518_
                                            (+ _bits2101512_ '128))
                                           (_byte3101520_
                                            (+ _bits3101514_ '128)))
                                      (cons _byte3101520_
                                            (cons _byte2101518_
                                                  (cons _byte1101516_
                                                        _bytes101493_))))
                                    (let* ((_bits1101523_
                                            (quotient
                                             _cp101499_
                                             (* '64 '64 '64)))
                                           (_bits2101525_
                                            (quotient
                                             (remainder
                                              _cp101499_
                                              (* '64 '64 '64))
                                             (* '64 '64)))
                                           (_bits3101527_
                                            (quotient
                                             (remainder _cp101499_ (* '64 '64))
                                             '64))
                                           (_bits4101529_
                                            (remainder _cp101499_ '64))
                                           (_byte1101531_
                                            (+ _bits1101523_ '240))
                                           (_byte2101533_
                                            (+ _bits2101525_ '128))
                                           (_byte3101535_
                                            (+ _bits3101527_ '128))
                                           (_byte4101537_
                                            (+ _bits4101529_ '128)))
                                      (cons _byte4101537_
                                            (cons _byte3101535_
                                                  (cons _byte2101533_
                                                        (cons _byte1101531_
                                                              _bytes101493_))))))))))
                  (_loop101486_
                   _texts101488_
                   _txt101489_
                   _j101490_
                   (+ _k101491_ '1)
                   (+ _ti101492_ '1)
                   _bytes101540_))))))))
