(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/csv#+line-endings+
    (cons std/misc/string#+cr+
          (cons std/misc/string#+lf+ (cons std/misc/string#+crlf+ '()))))
  (define std/text/csv#+strict-line-endings+
    (cons std/misc/string#+crlf+ (cons std/misc/string#+lf+ '())))
  (define std/text/csv#csv-options::t
    (make-struct-type
     'std/text/csv#csv-options::t
     '#f
     '10
     'csv-options
     '((transparent: . #t))
     '#f
     '(separator
       quote
       unquoted-quotequote?
       loose-quote?
       allow-binary?
       eol
       accept-lf?
       accept-cr?
       accept-crlf?
       skip-whitespace?)))
  (define std/text/csv#csv-options?
    (make-struct-predicate std/text/csv#csv-options::t))
  (define std/text/csv#make-csv-options
    (lambda _$args169315_
      (apply make-struct-instance std/text/csv#csv-options::t _$args169315_)))
  (define std/text/csv#csv-options-separator
    (make-struct-field-accessor std/text/csv#csv-options::t '0))
  (define std/text/csv#csv-options-quote
    (make-struct-field-accessor std/text/csv#csv-options::t '1))
  (define std/text/csv#csv-options-unquoted-quotequote?
    (make-struct-field-accessor std/text/csv#csv-options::t '2))
  (define std/text/csv#csv-options-loose-quote?
    (make-struct-field-accessor std/text/csv#csv-options::t '3))
  (define std/text/csv#csv-options-allow-binary?
    (make-struct-field-accessor std/text/csv#csv-options::t '4))
  (define std/text/csv#csv-options-eol
    (make-struct-field-accessor std/text/csv#csv-options::t '5))
  (define std/text/csv#csv-options-accept-lf?
    (make-struct-field-accessor std/text/csv#csv-options::t '6))
  (define std/text/csv#csv-options-accept-cr?
    (make-struct-field-accessor std/text/csv#csv-options::t '7))
  (define std/text/csv#csv-options-accept-crlf?
    (make-struct-field-accessor std/text/csv#csv-options::t '8))
  (define std/text/csv#csv-options-skip-whitespace?
    (make-struct-field-accessor std/text/csv#csv-options::t '9))
  (define std/text/csv#csv-options-separator-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '0))
  (define std/text/csv#csv-options-quote-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '1))
  (define std/text/csv#csv-options-unquoted-quotequote?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '2))
  (define std/text/csv#csv-options-loose-quote?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '3))
  (define std/text/csv#csv-options-allow-binary?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '4))
  (define std/text/csv#csv-options-eol-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '5))
  (define std/text/csv#csv-options-accept-lf?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '6))
  (define std/text/csv#csv-options-accept-cr?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '7))
  (define std/text/csv#csv-options-accept-crlf?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '8))
  (define std/text/csv#csv-options-skip-whitespace?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '9))
  (define std/text/csv#rfc4180-csv-options
    (let ()
      (declare (not safe))
      (##structure
       std/text/csv#csv-options::t
       '#\,
       '#\"
       '#f
       '#f
       '#t
       std/misc/string#+lf+
       '#t
       '#f
       '#t
       '#f)))
  (define std/text/csv#strict-rfc4180-csv-options
    (let ()
      (declare (not safe))
      (##structure
       std/text/csv#csv-options::t
       '#\,
       '#\"
       '#f
       '#f
       '#f
       std/misc/string#+crlf+
       '#f
       '#f
       '#t
       '#f)))
  (define std/text/csv#creativyst-csv-options
    (let ()
      (declare (not safe))
      (##structure
       std/text/csv#csv-options::t
       '#\,
       '#\"
       '#f
       '#f
       '#t
       std/misc/string#+crlf+
       '#t
       '#t
       '#t
       '#t)))
  (define std/text/csv#current-csv-options
    (make-parameter std/text/csv#creativyst-csv-options))
  (define std/text/csv#call-with-rfc4180-csv-syntax
    (lambda (_thunk169312_)
      (call-with-parameters
       (lambda () (_thunk169312_))
       std/text/csv#current-csv-options
       std/text/csv#rfc4180-csv-options)))
  (define std/text/csv#call-with-strict-rfc4180-csv-syntax
    (lambda (_thunk169309_)
      (call-with-parameters
       (lambda () (_thunk169309_))
       std/text/csv#current-csv-options
       std/text/csv#strict-rfc4180-csv-options)))
  (define std/text/csv#call-with-creativyst-csv-syntax
    (lambda (_thunk169306_)
      (call-with-parameters
       (lambda () (_thunk169306_))
       std/text/csv#current-csv-options
       std/text/csv#creativyst-csv-options)))
  (define std/text/csv#valid-eol?
    (lambda (_x169304_) (member _x169304_ std/text/csv#+line-endings+)))
  (define std/text/csv#validate-csv-options__%
    (lambda (_csv-options169242_)
      (let ((_g169247169249_
             (##structure-ref
              _csv-options169242_
              '1
              std/text/csv#csv-options::t
              '#f)))
        (if (char? _g169247169249_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@133.12"
             '(char? {separator})
             (cons (cons '{separator} _g169247169249_) '()))))
      (let ((_g169251169253_
             (##structure-ref
              _csv-options169242_
              '2
              std/text/csv#csv-options::t
              '#f)))
        (if (char? _g169251169253_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@134.12"
             '(char? {quote})
             (cons (cons '{quote} _g169251169253_) '()))))
      (let ((_g169255169257_
             (equal? (##structure-ref
                      _csv-options169242_
                      '1
                      std/text/csv#csv-options::t
                      '#f)
                     (##structure-ref
                      _csv-options169242_
                      '2
                      std/text/csv#csv-options::t
                      '#f))))
        (if (not _g169255169257_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@135.12"
             '(not (equal? {separator} {quote}))
             (cons (cons '(equal? {separator} {quote}) _g169255169257_) '()))))
      (let ((_g169259169261_
             (##structure-ref
              _csv-options169242_
              '3
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169259169261_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@136.12"
             '(boolean? {unquoted-quotequote?})
             (cons (cons '{unquoted-quotequote?} _g169259169261_) '()))))
      (let ((_g169263169265_
             (##structure-ref
              _csv-options169242_
              '4
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169263169265_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@137.12"
             '(boolean? {loose-quote?})
             (cons (cons '{loose-quote?} _g169263169265_) '()))))
      (let ((_g169267169269_
             (##structure-ref
              _csv-options169242_
              '10
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169267169269_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@138.12"
             '(boolean? {skip-whitespace?})
             (cons (cons '{skip-whitespace?} _g169267169269_) '()))))
      (let ((_g169271169273_
             (##structure-ref
              _csv-options169242_
              '6
              std/text/csv#csv-options::t
              '#f)))
        (if (std/text/csv#valid-eol? _g169271169273_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@139.12"
             '(valid-eol? {eol})
             (cons (cons '{eol} _g169271169273_) '()))))
      (let ((_g169275169277_
             (member (string-ref
                      (##structure-ref
                       _csv-options169242_
                       '6
                       std/text/csv#csv-options::t
                       '#f)
                      '0)
                     (cons (##structure-ref
                            _csv-options169242_
                            '1
                            std/text/csv#csv-options::t
                            '#f)
                           (cons (##structure-ref
                                  _csv-options169242_
                                  '2
                                  std/text/csv#csv-options::t
                                  '#f)
                                 '())))))
        (if (not _g169275169277_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@140.12"
             '(not (member (string-ref {eol} 0) [{separator} {quote}]))
             (cons (cons '(member (string-ref {eol} 0) [{separator} {quote}])
                         _g169275169277_)
                   '()))))
      (let ((_g169279169281_
             (##structure-ref
              _csv-options169242_
              '7
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169279169281_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@141.12"
             '(boolean? {accept-lf?})
             (cons (cons '{accept-lf?} _g169279169281_) '()))))
      (let ((_g169283169285_
             (##structure-ref
              _csv-options169242_
              '8
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169283169285_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@142.12"
             '(boolean? {accept-cr?})
             (cons (cons '{accept-cr?} _g169283169285_) '()))))
      (let ((_g169287169289_
             (##structure-ref
              _csv-options169242_
              '9
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169287169289_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@143.12"
             '(boolean? {accept-crlf?})
             (cons (cons '{accept-crlf?} _g169287169289_) '()))))
      (let ((_g169291169293_
             (##structure-ref
              _csv-options169242_
              '10
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169291169293_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@144.12"
             '(boolean? {skip-whitespace?})
             (cons (cons '{skip-whitespace?} _g169291169293_) '()))))))
  (define std/text/csv#validate-csv-options__0
    (lambda ()
      (let ((_csv-options169300_ (std/text/csv#current-csv-options)))
        (std/text/csv#validate-csv-options__% _csv-options169300_))))
  (define std/text/csv#validate-csv-options
    (lambda _g302893_
      (let ((_g302892_ (let () (declare (not safe)) (##length _g302893_))))
        (cond ((let () (declare (not safe)) (##fx= _g302892_ 0))
               (apply std/text/csv#validate-csv-options__0 _g302893_))
              ((let () (declare (not safe)) (##fx= _g302892_ 1))
               (apply std/text/csv#validate-csv-options__% _g302893_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#validate-csv-options
                _g302893_))))))
  (define std/text/csv#char-ascii-text?
    (lambda (_c169231_)
      (let* ((_i169233_ (char->integer _c169231_))
             (_$e169235_ (<= '32 _i169233_ '126)))
        (if _$e169235_
            _$e169235_
            (let ((_$e169238_ (= _i169233_ '10)))
              (if _$e169238_ _$e169238_ (= _i169233_ '13)))))))
  (define std/text/csv#accept
    (lambda (_pred169228_ _port169229_)
      (if (_pred169228_ (peek-char _port169229_))
          (read-char _port169229_)
          '#f)))
  (define std/text/csv#accept=
    (lambda (_c169225_ _port169226_)
      (if (eqv? _c169225_ (peek-char _port169226_))
          (read-char _port169226_)
          '#f)))
  (define std/text/csv#accept-eof
    (lambda (_port169223_) (std/text/csv#accept= '#!eof _port169223_)))
  (define std/text/csv#read-csv-line__%
    (lambda (_port168958_ _csv-options168959_)
      (letrec* ((_ss168965_ (open-output-string))
                (_fields168966_ '())
                (_had-quotes?168967_ '#f)
                (_accept-eol168968_
                 (lambda (_port169199_)
                   (let ((_$e169201_
                          (if (##structure-ref
                               _csv-options168959_
                               '7
                               std/text/csv#csv-options::t
                               '#f)
                              (if (std/text/csv#accept=
                                   '#\newline
                                   _port169199_)
                                  '#t
                                  '#f)
                              '#f)))
                     (if _$e169201_
                         _$e169201_
                         (if (or (##structure-ref
                                  _csv-options168959_
                                  '8
                                  std/text/csv#csv-options::t
                                  '#f)
                                 (##structure-ref
                                  _csv-options168959_
                                  '9
                                  std/text/csv#csv-options::t
                                  '#f))
                             (if (std/text/csv#accept= '#\return _port169199_)
                                 (let ((_$e169207_
                                        (if (##structure-ref
                                             _csv-options168959_
                                             '9
                                             std/text/csv#csv-options::t
                                             '#f)
                                            (std/text/csv#accept=
                                             '#\newline
                                             _port169199_)
                                            '#f)))
                                   (if _$e169207_
                                       _$e169207_
                                       (let ((_$e169210_
                                              (##structure-ref
                                               _csv-options168959_
                                               '8
                                               std/text/csv#csv-options::t
                                               '#f)))
                                         (if _$e169210_
                                             _$e169210_
                                             (std/error#raise-io-error
                                              'accept-eol
                                              '"Carriage-Return without Linefeed!")))))
                                 '#f)
                             '#f)))))
                (_char-csv-space?168969_
                 (lambda (_c169194_)
                   (if (or (eqv? _c169194_ '#\space) (eqv? _c169194_ '#\tab))
                       (not (eqv? _c169194_
                                  (##structure-ref
                                   _csv-options168959_
                                   '1
                                   std/text/csv#csv-options::t
                                   '#f)))
                       '#f)))
                (_accept-space168970_
                 (lambda (_port169192_)
                   (std/text/csv#accept _char-csv-space?168969_ _port169192_)))
                (_accept-spaces168971_
                 (lambda (_port169015_)
                   (let* ((_head169017_ (cons '#f '()))
                          (_tail169020_ _head169017_))
                     (let _loop169184_ ()
                       (let ((_x169187_ (_accept-space168970_ _port169015_)))
                         (if _x169187_
                             (begin
                               (let ((_new-tail169189_ (cons _x169187_ '())))
                                 (let ()
                                   (declare (not safe))
                                   (##set-cdr! _tail169020_ _new-tail169189_))
                                 (set! _tail169020_ _new-tail169189_))
                               (_loop169184_))
                             '#!void)))
                     (let () (declare (not safe)) (##cdr _head169017_)))))
                (_accept-fields168972_
                 (lambda ()
                   (set! _had-quotes?168967_ '#f)
                   (if (##structure-ref
                        _csv-options168959_
                        '10
                        std/text/csv#csv-options::t
                        '#f)
                       (_accept-spaces168971_ _port168958_)
                       '#!void)
                   (if (and (null? _fields168966_)
                            (or (_accept-eol168968_ _port168958_)
                                (std/text/csv#accept-eof _port168958_)))
                       (_done168982_)
                       (_accept-field-start168973_))))
                (_accept-field-start168973_
                 (lambda ()
                   (if (std/text/csv#accept=
                        (##structure-ref
                         _csv-options168959_
                         '1
                         std/text/csv#csv-options::t
                         '#f)
                        _port168958_)
                       (begin (_add168979_ '"") (_accept-fields168972_))
                       (if (std/text/csv#accept=
                            (##structure-ref
                             _csv-options168959_
                             '2
                             std/text/csv#csv-options::t
                             '#f)
                            _port168958_)
                           (if (and (##structure-ref
                                     _csv-options168959_
                                     '3
                                     std/text/csv#csv-options::t
                                     '#f)
                                    (std/text/csv#accept=
                                     (##structure-ref
                                      _csv-options168959_
                                      '2
                                      std/text/csv#csv-options::t
                                      '#f)
                                     _port168958_))
                               (begin
                                 (_add-char168980_
                                  (##structure-ref
                                   _csv-options168959_
                                   '2
                                   std/text/csv#csv-options::t
                                   '#f))
                                 (_accept-field-unquoted168976_))
                               (_accept-field-quoted168974_))
                           (_accept-field-unquoted168976_)))))
                (_accept-field-quoted168974_
                 (lambda ()
                   (set! _had-quotes?168967_ '#t)
                   (if (std/text/csv#accept-eof _port168958_)
                       (std/error#raise-io-error
                        'read-csv-line
                        '"unexpected eof in quotes")
                       (if (std/text/csv#accept=
                            (##structure-ref
                             _csv-options168959_
                             '2
                             std/text/csv#csv-options::t
                             '#f)
                            _port168958_)
                           (if (std/text/csv#accept=
                                (##structure-ref
                                 _csv-options168959_
                                 '2
                                 std/text/csv#csv-options::t
                                 '#f)
                                _port168958_)
                               (_quoted-field-char168975_
                                (##structure-ref
                                 _csv-options168959_
                                 '2
                                 std/text/csv#csv-options::t
                                 '#f))
                               (if (##structure-ref
                                    _csv-options168959_
                                    '4
                                    std/text/csv#csv-options::t
                                    '#f)
                                   (_accept-field-unquoted168976_)
                                   (begin
                                     (_add168979_ (_current-string168981_))
                                     (_end-of-field168978_))))
                           (_quoted-field-char168975_
                            (read-char _port168958_))))))
                (_quoted-field-char168975_
                 (lambda (_c169007_)
                   (_add-char168980_ _c169007_)
                   (_accept-field-quoted168974_)))
                (_accept-field-unquoted168976_
                 (lambda ()
                   (if (##structure-ref
                        _csv-options168959_
                        '10
                        std/text/csv#csv-options::t
                        '#f)
                       (let ((_spaces169002_
                              (_accept-spaces168971_ _port168958_)))
                         (if (std/text/csv#accept=
                              (##structure-ref
                               _csv-options168959_
                               '1
                               std/text/csv#csv-options::t
                               '#f)
                              _port168958_)
                             (begin
                               (_add168979_ (_current-string168981_))
                               (_accept-fields168972_))
                             (if (or (_accept-eol168968_ _port168958_)
                                     (std/text/csv#accept-eof _port168958_))
                                 (begin
                                   (_add168979_ (_current-string168981_))
                                   (_done168982_))
                                 (begin
                                   (for-each _add-char168980_ _spaces169002_)
                                   (_accept-field-unquoted-no-skip168977_)))))
                       (_accept-field-unquoted-no-skip168977_))))
                (_accept-field-unquoted-no-skip168977_
                 (lambda ()
                   (if (std/text/csv#accept=
                        (##structure-ref
                         _csv-options168959_
                         '1
                         std/text/csv#csv-options::t
                         '#f)
                        _port168958_)
                       (begin
                         (_add168979_ (_current-string168981_))
                         (_accept-fields168972_))
                       (if (or (_accept-eol168968_ _port168958_)
                               (std/text/csv#accept-eof _port168958_))
                           (begin
                             (_add168979_ (_current-string168981_))
                             (_done168982_))
                           (if (std/text/csv#accept=
                                (##structure-ref
                                 _csv-options168959_
                                 '2
                                 std/text/csv#csv-options::t
                                 '#f)
                                _port168958_)
                               (if (and (##structure-ref
                                         _csv-options168959_
                                         '3
                                         std/text/csv#csv-options::t
                                         '#f)
                                        (std/text/csv#accept=
                                         (##structure-ref
                                          _csv-options168959_
                                          '2
                                          std/text/csv#csv-options::t
                                          '#f)
                                         _port168958_))
                                   (begin
                                     (_add-char168980_
                                      (##structure-ref
                                       _csv-options168959_
                                       '2
                                       std/text/csv#csv-options::t
                                       '#f))
                                     (_accept-field-unquoted168976_))
                                   (if (##structure-ref
                                        _csv-options168959_
                                        '4
                                        std/text/csv#csv-options::t
                                        '#f)
                                       (_accept-field-quoted168974_)
                                       (std/error#raise-io-error
                                        'read-csv-line
                                        '"unexpected quote in middle of field")))
                               (begin
                                 (_add-char168980_ (read-char _port168958_))
                                 (_accept-field-unquoted168976_)))))))
                (_end-of-field168978_
                 (lambda ()
                   (if (##structure-ref
                        _csv-options168959_
                        '10
                        std/text/csv#csv-options::t
                        '#f)
                       (_accept-spaces168971_ _port168958_)
                       '#!void)
                   (if (or (_accept-eol168968_ _port168958_)
                           (std/text/csv#accept-eof _port168958_))
                       (_done168982_)
                       (if (std/text/csv#accept=
                            (##structure-ref
                             _csv-options168959_
                             '1
                             std/text/csv#csv-options::t
                             '#f)
                            _port168958_)
                           (_accept-fields168972_)
                           (std/error#raise-io-error
                            'read-csv-line
                            '"end of field expected")))))
                (_add168979_
                 (lambda (_x168991_)
                   (set! _fields168966_ (cons _x168991_ _fields168966_))))
                (_add-char168980_
                 (lambda (_c168986_)
                   (if (or (##structure-ref
                            _csv-options168959_
                            '5
                            std/text/csv#csv-options::t
                            '#f)
                           (std/text/csv#char-ascii-text? _c168986_))
                       '#!void
                       (std/error#raise-io-error
                        'read-csv-line
                        '"binary data not allowed"
                        _c168986_))
                   (write-char _c168986_ _ss168965_)))
                (_current-string168981_
                 (lambda () (get-output-string _ss168965_)))
                (_done168982_
                 (lambda () (std/srfi/1#reverse! _fields168966_))))
        (_accept-fields168972_))))
  (define std/text/csv#read-csv-line__0
    (lambda (_port169216_)
      (let ((_csv-options169218_ (std/text/csv#current-csv-options)))
        (std/text/csv#read-csv-line__% _port169216_ _csv-options169218_))))
  (define std/text/csv#read-csv-line
    (lambda _g302895_
      (let ((_g302894_ (let () (declare (not safe)) (##length _g302895_))))
        (cond ((let () (declare (not safe)) (##fx= _g302894_ 1))
               (apply std/text/csv#read-csv-line__0 _g302895_))
              ((let () (declare (not safe)) (##fx= _g302894_ 2))
               (apply std/text/csv#read-csv-line__% _g302895_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#read-csv-line
                _g302895_))))))
  (define std/text/csv#read-csv-lines__%
    (lambda (_port168934_ _csv-options168935_)
      (std/text/csv#validate-csv-options__% _csv-options168935_)
      (std/misc/list-builder#call-with-list-builder
       (lambda (_c168941_ _g302896_)
         (let _lp168943_ ()
           (if (std/text/csv#accept-eof _port168934_)
               '#!void
               (begin
                 (_c168941_
                  (std/text/csv#read-csv-line__%
                   _port168934_
                   _csv-options168935_))
                 (_lp168943_))))))))
  (define std/text/csv#read-csv-lines__0
    (lambda (_port168950_)
      (let ((_csv-options168952_ (std/text/csv#current-csv-options)))
        (std/text/csv#read-csv-lines__% _port168950_ _csv-options168952_))))
  (define std/text/csv#read-csv-lines
    (lambda _g302898_
      (let ((_g302897_ (let () (declare (not safe)) (##length _g302898_))))
        (cond ((let () (declare (not safe)) (##fx= _g302897_ 1))
               (apply std/text/csv#read-csv-lines__0 _g302898_))
              ((let () (declare (not safe)) (##fx= _g302897_ 2))
               (apply std/text/csv#read-csv-lines__% _g302898_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#read-csv-lines
                _g302898_))))))
  (define std/text/csv#read-csv-file__%
    (lambda (_path-or-settings168912_ _csv-options168913_)
      (call-with-input-file
       _path-or-settings168912_
       (lambda (_g168918168920_)
         (std/text/csv#read-csv-lines__%
          _g168918168920_
          _csv-options168913_)))))
  (define std/text/csv#read-csv-file__0
    (lambda (_path-or-settings168926_)
      (let ((_csv-options168928_ (std/text/csv#current-csv-options)))
        (std/text/csv#read-csv-file__%
         _path-or-settings168926_
         _csv-options168928_))))
  (define std/text/csv#read-csv-file
    (lambda _g302900_
      (let ((_g302899_ (let () (declare (not safe)) (##length _g302900_))))
        (cond ((let () (declare (not safe)) (##fx= _g302899_ 1))
               (apply std/text/csv#read-csv-file__0 _g302900_))
              ((let () (declare (not safe)) (##fx= _g302899_ 2))
               (apply std/text/csv#read-csv-file__% _g302900_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#read-csv-file
                _g302900_))))))
  (define std/text/csv#char-needs-quoting?__%
    (lambda (_x168882_ _csv-options168883_)
      (let ((_$e168889_
             (eqv? _x168882_
                   (##structure-ref
                    _csv-options168883_
                    '2
                    std/text/csv#csv-options::t
                    '#f))))
        (if _$e168889_
            _$e168889_
            (let ((_$e168892_
                   (eqv? _x168882_
                         (##structure-ref
                          _csv-options168883_
                          '1
                          std/text/csv#csv-options::t
                          '#f))))
              (if _$e168892_
                  _$e168892_
                  (let ((_$e168895_ (eqv? _x168882_ '#\newline)))
                    (if _$e168895_
                        _$e168895_
                        (let ((_$e168898_ (eqv? _x168882_ '#\return)))
                          (if _$e168898_
                              _$e168898_
                              (not (std/text/csv#char-ascii-text?
                                    _x168882_))))))))))))
  (define std/text/csv#char-needs-quoting?__0
    (lambda (_x168904_)
      (let ((_csv-options168906_ (std/text/csv#current-csv-options)))
        (std/text/csv#char-needs-quoting?__% _x168904_ _csv-options168906_))))
  (define std/text/csv#char-needs-quoting?
    (lambda _g302902_
      (let ((_g302901_ (let () (declare (not safe)) (##length _g302902_))))
        (cond ((let () (declare (not safe)) (##fx= _g302901_ 1))
               (apply std/text/csv#char-needs-quoting?__0 _g302902_))
              ((let () (declare (not safe)) (##fx= _g302901_ 2))
               (apply std/text/csv#char-needs-quoting?__% _g302902_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#char-needs-quoting?
                _g302902_))))))
  (define std/text/csv#char-csv-space?__%
    (lambda (_c168861_ _csv-options168862_)
      (if (or (eqv? _c168861_ '#\space) (eqv? _c168861_ '#\tab))
          (not (eqv? _c168861_
                     (##structure-ref
                      _csv-options168862_
                      '1
                      std/text/csv#csv-options::t
                      '#f)))
          '#f)))
  (define std/text/csv#char-csv-space?__0
    (lambda (_c168874_)
      (let ((_csv-options168876_ (std/text/csv#current-csv-options)))
        (std/text/csv#char-csv-space?__% _c168874_ _csv-options168876_))))
  (define std/text/csv#char-csv-space?
    (lambda _g302904_
      (let ((_g302903_ (let () (declare (not safe)) (##length _g302904_))))
        (cond ((let () (declare (not safe)) (##fx= _g302903_ 1))
               (apply std/text/csv#char-csv-space?__0 _g302904_))
              ((let () (declare (not safe)) (##fx= _g302903_ 2))
               (apply std/text/csv#char-csv-space?__% _g302904_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#char-csv-space?
                _g302904_))))))
  (define std/text/csv#string-needs-quoting?__%
    (lambda (_x168833_ _csv-options168834_)
      (if (not (std/srfi/13#string-null? _x168833_))
          (if (or (std/text/csv#char-csv-space?__%
                   (string-ref _x168833_ '0)
                   _csv-options168834_)
                  (std/text/csv#char-csv-space?__%
                   (string-ref _x168833_ (- (string-length _x168833_) '1))
                   _csv-options168834_)
                  (std/srfi/13#string-any__0
                   (lambda (_g168845168847_)
                     (std/text/csv#char-needs-quoting?__%
                      _g168845168847_
                      _csv-options168834_))
                   _x168833_))
              '#t
              '#f)
          '#f)))
  (define std/text/csv#string-needs-quoting?__0
    (lambda (_x168853_)
      (let ((_csv-options168855_ (std/text/csv#current-csv-options)))
        (std/text/csv#string-needs-quoting?__%
         _x168853_
         _csv-options168855_))))
  (define std/text/csv#string-needs-quoting?
    (lambda _g302906_
      (let ((_g302905_ (let () (declare (not safe)) (##length _g302906_))))
        (cond ((let () (declare (not safe)) (##fx= _g302905_ 1))
               (apply std/text/csv#string-needs-quoting?__0 _g302906_))
              ((let () (declare (not safe)) (##fx= _g302905_ 2))
               (apply std/text/csv#string-needs-quoting?__% _g302906_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#string-needs-quoting?
                _g302906_))))))
  (define std/text/csv#write-csv-lines__%
    (lambda (_lines168808_ _port168809_ _csv-options168810_)
      (for-each
       (lambda (_g168815168817_)
         (std/text/csv#write-csv-line__%
          _g168815168817_
          _port168809_
          _csv-options168810_))
       _lines168808_)))
  (define std/text/csv#write-csv-lines__0
    (lambda (_lines168823_ _port168824_)
      (let ((_csv-options168826_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-lines__%
         _lines168823_
         _port168824_
         _csv-options168826_))))
  (define std/text/csv#write-csv-lines
    (lambda _g302908_
      (let ((_g302907_ (let () (declare (not safe)) (##length _g302908_))))
        (cond ((let () (declare (not safe)) (##fx= _g302907_ 2))
               (apply std/text/csv#write-csv-lines__0 _g302908_))
              ((let () (declare (not safe)) (##fx= _g302907_ 3))
               (apply std/text/csv#write-csv-lines__% _g302908_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-lines
                _g302908_))))))
  (define std/text/csv#write-csv-file__%
    (lambda (_path-or-settings168783_ _lines168784_ _csv-options168785_)
      (call-with-output-file
       _path-or-settings168783_
       (lambda (_g168790168792_)
         (std/text/csv#write-csv-lines__%
          _lines168784_
          _g168790168792_
          _csv-options168785_)))))
  (define std/text/csv#write-csv-file__0
    (lambda (_path-or-settings168798_ _lines168799_)
      (let ((_csv-options168801_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-file__%
         _path-or-settings168798_
         _lines168799_
         _csv-options168801_))))
  (define std/text/csv#write-csv-file
    (lambda _g302910_
      (let ((_g302909_ (let () (declare (not safe)) (##length _g302910_))))
        (cond ((let () (declare (not safe)) (##fx= _g302909_ 2))
               (apply std/text/csv#write-csv-file__0 _g302910_))
              ((let () (declare (not safe)) (##fx= _g302909_ 3))
               (apply std/text/csv#write-csv-file__% _g302910_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-file
                _g302910_))))))
  (define std/text/csv#write-csv-line__%
    (lambda (_fields168720_ _port168721_ _csv-options168722_)
      (let _loop168728_ ((_fields168730_ _fields168720_))
        (let* ((_fields168731168740_ _fields168730_)
               (_E168734168744_
                (lambda ()
                  (error '"No clause matching" _fields168731168740_))))
          (let ((_K168736168758_
                 (lambda (_rest168755_ _first168756_)
                   (std/text/csv#write-csv-field__0 _first168756_ _port168721_)
                   (if (null? _rest168755_)
                       '#!void
                       (write-char
                        (##structure-ref
                         _csv-options168722_
                         '1
                         std/text/csv#csv-options::t
                         '#f)
                        _port168721_))
                   (_loop168728_ _rest168755_)))
                (_K168735168749_
                 (lambda ()
                   (display (##structure-ref
                             _csv-options168722_
                             '6
                             std/text/csv#csv-options::t
                             '#f)
                            _port168721_))))
            (let ((_try-match168733168752_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _fields168731168740_))
                         (_K168735168749_)
                         (_E168734168744_)))))
              (if (let () (declare (not safe)) (##pair? _fields168731168740_))
                  (let ((_tl168738168763_
                         (let ()
                           (declare (not safe))
                           (##cdr _fields168731168740_)))
                        (_hd168737168761_
                         (let ()
                           (declare (not safe))
                           (##car _fields168731168740_))))
                    (let ((_first168766_ _hd168737168761_)
                          (_rest168768_ _tl168738168763_))
                      (_K168736168758_ _rest168768_ _first168766_)))
                  (_try-match168733168752_))))))))
  (define std/text/csv#write-csv-line__0
    (lambda (_fields168773_ _port168774_)
      (let ((_csv-options168776_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-line__%
         _fields168773_
         _port168774_
         _csv-options168776_))))
  (define std/text/csv#write-csv-line
    (lambda _g302912_
      (let ((_g302911_ (let () (declare (not safe)) (##length _g302912_))))
        (cond ((let () (declare (not safe)) (##fx= _g302911_ 2))
               (apply std/text/csv#write-csv-line__0 _g302912_))
              ((let () (declare (not safe)) (##fx= _g302911_ 3))
               (apply std/text/csv#write-csv-line__% _g302912_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-line
                _g302912_))))))
  (define std/text/csv#write-csv-field__%
    (lambda (_field168649_ _port168650_ _csv-options168651_)
      (let* ((_field168656168668_ _field168649_)
             (_else168661168676_
              (lambda () (error '"invalid CSV field" _field168649_))))
        (let ((_K168666168704_ (lambda () '#!void))
              (_K168665168697_
               (lambda () (display _field168649_ _port168650_)))
              (_K168664168689_
               (lambda ()
                 (std/text/csv#write-csv-string-safely__%
                  _field168649_
                  _port168650_
                  _csv-options168651_)))
              (_K168663168681_
               (lambda ()
                 (std/text/csv#write-csv-string-safely__%
                  (symbol->string _field168649_)
                  _port168650_
                  _csv-options168651_))))
          (let* ((_try-match168660168684_
                  (lambda ()
                    (if (symbol? _field168656168668_)
                        (_K168663168681_)
                        (_else168661168676_))))
                 (_try-match168659168692_
                  (lambda ()
                    (if (string? _field168656168668_)
                        (_K168664168689_)
                        (_try-match168660168684_))))
                 (_try-match168658168700_
                  (lambda ()
                    (if (number? _field168656168668_)
                        (_K168665168697_)
                        (_try-match168659168692_)))))
            (if (not _field168656168668_)
                '#!void
                (_try-match168658168700_)))))))
  (define std/text/csv#write-csv-field__0
    (lambda (_field168710_ _port168711_)
      (let ((_csv-options168713_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-field__%
         _field168710_
         _port168711_
         _csv-options168713_))))
  (define std/text/csv#write-csv-field
    (lambda _g302914_
      (let ((_g302913_ (let () (declare (not safe)) (##length _g302914_))))
        (cond ((let () (declare (not safe)) (##fx= _g302913_ 2))
               (apply std/text/csv#write-csv-field__0 _g302914_))
              ((let () (declare (not safe)) (##fx= _g302913_ 3))
               (apply std/text/csv#write-csv-field__% _g302914_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-field
                _g302914_))))))
  (define std/text/csv#write-csv-string-safely__%
    (lambda (_string168628_ _port168629_ _csv-options168630_)
      (if (std/text/csv#string-needs-quoting?__0 _string168628_)
          (std/text/csv#write-quoted-string__%
           _string168628_
           _port168629_
           _csv-options168630_)
          (display _string168628_ _port168629_))))
  (define std/text/csv#write-csv-string-safely__0
    (lambda (_string168639_ _port168640_)
      (let ((_csv-options168642_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-string-safely__%
         _string168639_
         _port168640_
         _csv-options168642_))))
  (define std/text/csv#write-csv-string-safely
    (lambda _g302916_
      (let ((_g302915_ (let () (declare (not safe)) (##length _g302916_))))
        (cond ((let () (declare (not safe)) (##fx= _g302915_ 2))
               (apply std/text/csv#write-csv-string-safely__0 _g302916_))
              ((let () (declare (not safe)) (##fx= _g302915_ 3))
               (apply std/text/csv#write-csv-string-safely__% _g302916_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-string-safely
                _g302916_))))))
  (define std/text/csv#write-quoted-string__%
    (lambda (_string168605_ _port168606_ _csv-options168607_)
      (write-char
       (##structure-ref _csv-options168607_ '2 std/text/csv#csv-options::t '#f)
       _port168606_)
      (std/srfi/13#string-for-each__0
       (lambda (_c168613_)
         (if (char=? _c168613_
                     (##structure-ref
                      _csv-options168607_
                      '2
                      std/text/csv#csv-options::t
                      '#f))
             (write-char _c168613_ _port168606_)
             '#!void)
         (write-char _c168613_ _port168606_))
       _string168605_)
      (write-char
       (##structure-ref _csv-options168607_ '2 std/text/csv#csv-options::t '#f)
       _port168606_)))
  (define std/text/csv#write-quoted-string__0
    (lambda (_string168618_ _port168619_)
      (let ((_csv-options168621_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-quoted-string__%
         _string168618_
         _port168619_
         _csv-options168621_))))
  (define std/text/csv#write-quoted-string
    (lambda _g302918_
      (let ((_g302917_ (let () (declare (not safe)) (##length _g302918_))))
        (cond ((let () (declare (not safe)) (##fx= _g302917_ 2))
               (apply std/text/csv#write-quoted-string__0 _g302918_))
              ((let () (declare (not safe)) (##fx= _g302917_ 3))
               (apply std/text/csv#write-quoted-string__% _g302918_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-quoted-string
                _g302918_)))))))
