(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/web/rack#errorf
    (lambda (_fmt258868_ . _args258869_)
      (std/logger#log-message 'rack '0 _fmt258868_ _args258869_)))
  (define std/web/rack#warnf
    (lambda (_fmt258865_ . _args258866_)
      (std/logger#log-message 'rack '1 _fmt258865_ _args258866_)))
  (define std/web/rack#infof
    (lambda (_fmt258862_ . _args258863_)
      (std/logger#log-message 'rack '2 _fmt258862_ _args258863_)))
  (define std/web/rack#debugf
    (lambda (_fmt258859_ . _args258860_)
      (std/logger#log-message 'rack '3 _fmt258859_ _args258860_)))
  (define std/web/rack#verbosef
    (lambda (_fmt258854_ . _args258856_)
      (std/logger#log-message 'rack '4 _fmt258854_ _args258856_)))
  (define std/web/rack#start-rack-fastcgi-server!
    (lambda (_address258847_ _handler258848_)
      (std/web/fastcgi#start-fastcgi-server!
       _address258847_
       (lambda (_g258849258851_)
         (std/web/rack#rack-fastcgi-respond
          _g258849258851_
          _handler258848_)))))
  (define std/web/rack#rack-fastcgi-respond
    (lambda (_req258700_ _handler258701_)
      (letrec ((_collect-data258703_
                (lambda (_body258796_)
                  (let ((_out258798_ (open-output-u8vector)))
                    (let ((_iterable258821_ _body258796_)
                          (_iter-do258823_
                           (lambda (_val258800_)
                             (let* ((_val258802258807_ _val258800_)
                                    (_E258804258811_
                                     (lambda ()
                                       (error '"No clause matching"
                                              _val258802258807_)))
                                    (_K258805258816_
                                     (lambda (_next258814_)
                                       (if (u8vector? _next258814_)
                                           (write-subu8vector
                                            _next258814_
                                            '0
                                            (u8vector-length _next258814_)
                                            _out258798_)
                                           (if (string? _next258814_)
                                               (write-substring
                                                _next258814_
                                                '0
                                                (string-length _next258814_)
                                                _out258798_)
                                               (std/error#raise-io-error
                                                'rack-fastcgi-respond
                                                '"bad response chunk"
                                                _next258814_)))))
                                    (_next258819_ _val258802258807_))
                               (_K258805258816_ _next258819_)))))
                      (if (pair? _iterable258821_)
                          (for-each _iter-do258823_ _iterable258821_)
                          (if (null? _iterable258821_)
                              '#!void
                              (let* ((_it258826_
                                      (std/iter#iter _iterable258821_))
                                     (_next!258829_
                                      (let ()
                                        (declare (not safe))
                                        (##unchecked-structure-ref
                                         _it258826_
                                         '2
                                         std/iter#iterator::t
                                         '#f))))
                                (declare (not safe))
                                (begin
                                  (let _lp258834_ ()
                                    (let ((_val258838_
                                           (_next!258829_ _it258826_)))
                                      (if (eq? std/iter#iter-end _val258838_)
                                          '#!void
                                          (begin
                                            (_iter-do258823_ _val258838_)
                                            (_lp258834_)))))
                                  (let ((_$e258840_
                                         (##unchecked-structure-ref
                                          _it258826_
                                          '3
                                          std/iter#iterator::t
                                          '#f)))
                                    (if _$e258840_
                                        ((lambda (_g258842258844_)
                                           (_g258842258844_ _it258826_))
                                         _$e258840_)
                                        '#!void))
                                  '#!void)))))
                    (get-output-u8vector _out258798_))))
               (_log-response-error258704_
                (lambda (_e258788_)
                  (std/web/rack#errorf '"rack response error: ~a" _e258788_)
                  (let ((_errstr258794_
                         (call-with-output-string
                          '()
                          (lambda (_g258789258791_)
                            (display-exception _e258788_ _g258789258791_)))))
                    (std/web/fastcgi#fastcgi-write-stderr
                     _req258700_
                     _errstr258794_)))))
        (with-exception-catcher
         (lambda (_g258705258707_)
           (if '#t
               (let ((_e258710_ _g258705258707_))
                 (_log-response-error258704_ _e258710_))
               (raise _g258705258707_)))
         (lambda ()
           (let ((_g311158_
                  (with-exception-catcher
                   (lambda (_g258712258714_)
                     (if '#t
                         (let ((_e258717_ _g258712258714_))
                           (_log-response-error258704_ _e258717_)
                           (values '500 '() '"OOPS! Something went wrong."))
                         (raise _g258712258714_)))
                   (lambda ()
                     (_handler258701_
                      (##structure-ref
                       _req258700_
                       '5
                       std/web/fastcgi#fastcgi-request::t
                       '#f)
                      (##structure-ref
                       _req258700_
                       '6
                       std/web/fastcgi#fastcgi-request::t
                       '#f))))))
             (begin
               (let ((_g311159_
                      (let ()
                        (declare (not safe))
                        (if (##values? _g311158_)
                            (##vector-length _g311158_)
                            1))))
                 (if (not (let () (declare (not safe)) (##fx= _g311159_ 3)))
                     (error "Context expects 3 values" _g311159_)))
               (let ((_status258720_
                      (let () (declare (not safe)) (##vector-ref _g311158_ 0)))
                     (_headers258721_
                      (let () (declare (not safe)) (##vector-ref _g311158_ 1)))
                     (_body258722_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g311158_ 2))))
                 (let* ((_status-text258724_
                         (table-ref
                          std/web/rack#*http-response-codes*
                          _status258720_
                          '"(Unknown)"))
                        (_body-data258726_
                         (if (u8vector? _body258722_)
                             _body258722_
                             (if (string? _body258722_)
                                 (std/text/utf8#string->utf8__0 _body258722_)
                                 (_collect-data258703_ _body258722_))))
                        (_hout258728_ (open-output-u8vector)))
                   (std/format#fprintf
                    _hout258728_
                    '"Status: ~a ~a\r\n"
                    _status258720_
                    _status-text258724_)
                   (let ((_iterable258762_ _headers258721_)
                         (_iter-do258764_
                          (lambda (_val258731_)
                            (let* ((_val258733258740_ _val258731_)
                                   (_E258735258744_
                                    (lambda ()
                                      (error '"No clause matching"
                                             _val258733258740_)))
                                   (_K258736258750_
                                    (lambda (_value258747_ _key258748_)
                                      (std/format#fprintf
                                       _hout258728_
                                       '"~a: ~a\r\n"
                                       _key258748_
                                       _value258747_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _val258733258740_))
                                  (let ((_hd258737258753_
                                         (let ()
                                           (declare (not safe))
                                           (##car _val258733258740_)))
                                        (_tl258738258755_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _val258733258740_))))
                                    (let* ((_key258758_ _hd258737258753_)
                                           (_value258760_ _tl258738258755_))
                                      (_K258736258750_
                                       _value258760_
                                       _key258758_)))
                                  (_E258735258744_))))))
                     (if (pair? _iterable258762_)
                         (for-each _iter-do258764_ _iterable258762_)
                         (if (null? _iterable258762_)
                             '#!void
                             (let* ((_it258767_
                                     (std/iter#iter _iterable258762_))
                                    (_next!258770_
                                     (let ()
                                       (declare (not safe))
                                       (##unchecked-structure-ref
                                        _it258767_
                                        '2
                                        std/iter#iterator::t
                                        '#f))))
                               (declare (not safe))
                               (begin
                                 (let _lp258775_ ()
                                   (let ((_val258779_
                                          (_next!258770_ _it258767_)))
                                     (if (eq? std/iter#iter-end _val258779_)
                                         '#!void
                                         (begin
                                           (_iter-do258764_ _val258779_)
                                           (_lp258775_)))))
                                 (let ((_$e258781_
                                        (##unchecked-structure-ref
                                         _it258767_
                                         '3
                                         std/iter#iterator::t
                                         '#f)))
                                   (if _$e258781_
                                       ((lambda (_g258783258785_)
                                          (_g258783258785_ _it258767_))
                                        _$e258781_)
                                       '#!void))
                                 '#!void)))))
                   (std/format#fprintf
                    _hout258728_
                    '"Content-Length: ~a\r\n"
                    (u8vector-length _body-data258726_))
                   (std/format#fprintf _hout258728_ '"\r\n")
                   (std/web/fastcgi#fastcgi-write-stdout
                    _req258700_
                    (get-output-u8vector _hout258728_))
                   (std/web/fastcgi#fastcgi-write-stdout
                    _req258700_
                    _body-data258726_))))))))))
  (define std/web/rack#*http-response-codes*
    (let ((_ht258697_ (make-table 'test: eq? 'size: '40)))
      (table-set! _ht258697_ '100 '"Continue")
      (table-set! _ht258697_ '101 '"Switching Protocols")
      (table-set! _ht258697_ '200 '"OK")
      (table-set! _ht258697_ '201 '"Created")
      (table-set! _ht258697_ '202 '"Accepted")
      (table-set! _ht258697_ '203 '"Non-Authoritative Information")
      (table-set! _ht258697_ '204 '"No Content")
      (table-set! _ht258697_ '205 '"Reset Content")
      (table-set! _ht258697_ '206 '"Partial Content")
      (table-set! _ht258697_ '300 '"Multiple Choices")
      (table-set! _ht258697_ '301 '"Moved Permanently")
      (table-set! _ht258697_ '302 '"Found")
      (table-set! _ht258697_ '303 '"See Other")
      (table-set! _ht258697_ '304 '"Not Modified")
      (table-set! _ht258697_ '305 '"Use Proxy")
      (table-set! _ht258697_ '307 '"Temporary Redirect")
      (table-set! _ht258697_ '400 '"Bad Request")
      (table-set! _ht258697_ '401 '"Unauthorized")
      (table-set! _ht258697_ '402 '"Payment Required")
      (table-set! _ht258697_ '403 '"Forbidden")
      (table-set! _ht258697_ '404 '"Not Found")
      (table-set! _ht258697_ '405 '"Method Not Allowed")
      (table-set! _ht258697_ '406 '"Not Acceptable")
      (table-set! _ht258697_ '407 '"Proxy Authentication Required")
      (table-set! _ht258697_ '408 '"Request Timeout")
      (table-set! _ht258697_ '409 '"Conflict")
      (table-set! _ht258697_ '410 '"Gone")
      (table-set! _ht258697_ '411 '"Length Required")
      (table-set! _ht258697_ '412 '"Precondition Failed")
      (table-set! _ht258697_ '413 '"Request Entity Too Large")
      (table-set! _ht258697_ '414 '"Request-URI Too Long")
      (table-set! _ht258697_ '415 '"Unsupported Media Type")
      (table-set! _ht258697_ '416 '"Requested Range Not Satisfiable")
      (table-set! _ht258697_ '417 '"Expectation Failed")
      (table-set! _ht258697_ '500 '"Internal Server Error")
      (table-set! _ht258697_ '501 '"Not Implemented")
      (table-set! _ht258697_ '502 '"Bad Gateway")
      (table-set! _ht258697_ '503 '"Service Unavailable")
      (table-set! _ht258697_ '504 '"Gateway Timeout")
      (table-set! _ht258697_ '505 '"HTTP Version Not Supported")
      _ht258697_)))
