(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/xml/ssax#read-xml__%
    (lambda (_g301347_ _ns223361223364_ _source223366_)
      (let* ((_ns223368_
              (if (eq? _ns223361223364_ absent-value) '() _ns223361223364_))
             (_ns223370_
              (if (table? _ns223368_) (table->list _ns223368_) _ns223368_))
             (_ns223404_
              (map (lambda (_e223371223373_)
                     (let* ((_g223375223382_ _e223371223373_)
                            (_E223377223386_
                             (lambda ()
                               (error '"No clause matching" _g223375223382_)))
                            (_K223378223392_
                             (lambda (_id223389_ _uri223390_)
                               (cons (string->symbol _id223389_)
                                     _uri223390_))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _g223375223382_))
                           (let ((_hd223379223395_
                                  (let ()
                                    (declare (not safe))
                                    (##car _g223375223382_)))
                                 (_tl223380223397_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _g223375223382_))))
                             (let* ((_uri223400_ _hd223379223395_)
                                    (_id223402_ _tl223380223397_))
                               (_K223378223392_ _id223402_ _uri223400_)))
                           (_E223377223386_))))
                   _ns223370_)))
        (if (input-port? _source223366_)
            (std/xml/ssax#ssax:xml->sxml _source223366_ _ns223404_)
            (if (string? _source223366_)
                (call-with-input-string
                 _source223366_
                 (lambda (_g223406223408_)
                   (std/xml/ssax#ssax:xml->sxml _g223406223408_ _ns223404_)))
                (if (u8vector? _source223366_)
                    (call-with-input-u8vector
                     _source223366_
                     (lambda (_g223410223412_)
                       (std/xml/ssax#ssax:xml->sxml
                        _g223410223412_
                        _ns223404_)))
                    (error '"Bad input source; expected port, string, or u8vector"
                           _source223366_)))))))
  (define std/xml/ssax#read-xml__@
    (lambda (_keys223360223418_ . _args223420_)
      (apply std/xml/ssax#read-xml__%
             _keys223360223418_
             (table-ref _keys223360223418_ 'namespaces: absent-value)
             _args223420_)))
  (define std/xml/ssax#read-xml
    (lambda _args223362223426_
      (apply keyword-dispatch
             '#(namespaces:)
             std/xml/ssax#read-xml__@
             _args223362223426_)))
  (define std/xml/ssax#ssax:warn void)
  (define std/xml/ssax#string-null? string-empty?)
  (define std/xml/ssax#nl (string '#\newline))
  (define std/xml/ssax#cout
    (lambda _args223355_
      (for-each
       (lambda (_x223357_)
         (if (procedure? _x223357_) (_x223357_) (display _x223357_)))
       _args223355_)))
  (define std/xml/ssax#cerr
    (lambda _args223351_
      (for-each
       (lambda (_x223353_)
         (if (procedure? _x223353_)
             (_x223353_ (current-error-port))
             (display _x223353_ (current-error-port))))
       _args223351_)))
  (define std/xml/ssax#ascii->char integer->char)
  (define std/xml/ssax#ucscode->char
    (lambda (_code223349_) (integer->char _code223349_)))
  (define std/xml/ssax#char-return (std/xml/ssax#ascii->char '13))
  (define std/xml/ssax#char-tab (std/xml/ssax#ascii->char '9))
  (define std/xml/ssax#char-newline (std/xml/ssax#ascii->char '10))
  (define std/xml/ssax#parser-error
    (lambda (_port223345_ _message223346_ . _rest223347_)
      (apply error _message223346_ _rest223347_)))
  (define std/xml/ssax#peek-next-char__%
    (lambda (_port223335_) (read-char _port223335_) (peek-char _port223335_)))
  (define std/xml/ssax#peek-next-char__0
    (lambda ()
      (let ((_port223341_ (current-input-port)))
        (std/xml/ssax#peek-next-char__% _port223341_))))
  (define std/xml/ssax#peek-next-char
    (lambda _g301349_
      (let ((_g301348_ (let () (declare (not safe)) (##length _g301349_))))
        (cond ((let () (declare (not safe)) (##fx= _g301348_ 0))
               (apply std/xml/ssax#peek-next-char__0 _g301349_))
              ((let () (declare (not safe)) (##fx= _g301348_ 1))
               (apply std/xml/ssax#peek-next-char__% _g301349_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#peek-next-char
                _g301349_))))))
  (define std/xml/ssax#assert-curr-char__%
    (lambda (_expected-chars223316_ _comment223317_ _port223318_)
      (let ((_c223320_ (read-char _port223318_)))
        (if (memv _c223320_ _expected-chars223316_)
            _c223320_
            (std/xml/ssax#parser-error
             _port223318_
             '"Wrong character "
             _c223320_
             '" (0x"
             (if (eof-object? _c223320_)
                 '"*eof*"
                 (number->string (char->integer _c223320_) '16))
             '") "
             _comment223317_
             '". "
             _expected-chars223316_
             '" expected")))))
  (define std/xml/ssax#assert-curr-char__0
    (lambda (_expected-chars223325_ _comment223326_)
      (let ((_port223328_ (current-input-port)))
        (std/xml/ssax#assert-curr-char__%
         _expected-chars223325_
         _comment223326_
         _port223328_))))
  (define std/xml/ssax#assert-curr-char
    (lambda _g301351_
      (let ((_g301350_ (let () (declare (not safe)) (##length _g301351_))))
        (cond ((let () (declare (not safe)) (##fx= _g301350_ 2))
               (apply std/xml/ssax#assert-curr-char__0 _g301351_))
              ((let () (declare (not safe)) (##fx= _g301350_ 3))
               (apply std/xml/ssax#assert-curr-char__% _g301351_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#assert-curr-char
                _g301351_))))))
  (define std/xml/ssax#skip-until__%
    (lambda (_arg223293_ _port223294_)
      (if (number? _arg223293_)
          (let _$loop223296_ ((_i223299_ _arg223293_))
            (if (not (positive? _i223299_))
                '#f
                (begin
                  (if (eof-object? (read-char _port223294_))
                      (std/xml/ssax#parser-error
                       _port223294_
                       '"Unexpected EOF while skipping "
                       _arg223293_
                       '" characters")
                      '#!void)
                  (_$loop223296_ (- _i223299_ '1)))))
          (let _loop223301_ ((_c223303_ (read-char _port223294_)))
            (if (memv _c223303_ _arg223293_)
                _c223303_
                (if (eof-object? _c223303_)
                    (if (memq '*eof* _arg223293_)
                        _c223303_
                        (std/xml/ssax#parser-error
                         _port223294_
                         '"Unexpected EOF while skipping until "
                         _arg223293_))
                    (_loop223301_ (read-char _port223294_))))))))
  (define std/xml/ssax#skip-until__0
    (lambda (_arg223308_)
      (let ((_port223310_ (current-input-port)))
        (std/xml/ssax#skip-until__% _arg223308_ _port223310_))))
  (define std/xml/ssax#skip-until
    (lambda _g301353_
      (let ((_g301352_ (let () (declare (not safe)) (##length _g301353_))))
        (cond ((let () (declare (not safe)) (##fx= _g301352_ 1))
               (apply std/xml/ssax#skip-until__0 _g301353_))
              ((let () (declare (not safe)) (##fx= _g301352_ 2))
               (apply std/xml/ssax#skip-until__% _g301353_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#skip-until
                _g301353_))))))
  (define std/xml/ssax#skip-while__%
    (lambda (_skip-chars223274_ _port223275_)
      (let _$loop223277_ ((_c223280_ (peek-char _port223275_)))
        (if (not (memv _c223280_ _skip-chars223274_))
            _c223280_
            (begin
              (read-char _port223275_)
              (_$loop223277_ (peek-char _port223275_)))))))
  (define std/xml/ssax#skip-while__0
    (lambda (_skip-chars223285_)
      (let ((_port223287_ (current-input-port)))
        (std/xml/ssax#skip-while__% _skip-chars223285_ _port223287_))))
  (define std/xml/ssax#skip-while
    (lambda _g301355_
      (let ((_g301354_ (let () (declare (not safe)) (##length _g301355_))))
        (cond ((let () (declare (not safe)) (##fx= _g301354_ 1))
               (apply std/xml/ssax#skip-while__0 _g301355_))
              ((let () (declare (not safe)) (##fx= _g301354_ 2))
               (apply std/xml/ssax#skip-while__% _g301355_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#skip-while
                _g301355_))))))
  (define std/xml/ssax#input-parse:init-buffer
    (let ((_buffer223270_ (make-string '512))) (lambda () _buffer223270_)))
  (define std/xml/ssax#next-token-old__%
    (lambda (_prefix-skipped-chars223232_
             _break-chars223233_
             _comment223234_
             _port223235_)
      (let* ((_buffer223237_ (std/xml/ssax#input-parse:init-buffer))
             (_curr-buf-len223239_ (string-length _buffer223237_))
             (_quantum223241_ _curr-buf-len223239_))
        (let _loop223244_ ((_i223246_ '0)
                           (_c223247_
                            (std/xml/ssax#skip-while__%
                             _prefix-skipped-chars223232_
                             _port223235_)))
          (if (memv _c223247_ _break-chars223233_)
              (substring _buffer223237_ '0 _i223246_)
              (if (eof-object? _c223247_)
                  (if (memq '*eof* _break-chars223233_)
                      (substring _buffer223237_ '0 _i223246_)
                      (std/xml/ssax#parser-error
                       _port223235_
                       '"EOF while reading a token "
                       _comment223234_))
                  (begin
                    (if (>= _i223246_ _curr-buf-len223239_)
                        (begin
                          (set! _buffer223237_
                                (string-append
                                 _buffer223237_
                                 (make-string _quantum223241_)))
                          (set! _quantum223241_ _curr-buf-len223239_)
                          (set! _curr-buf-len223239_
                                (string-length _buffer223237_)))
                        '#!void)
                    (string-set! _buffer223237_ _i223246_ _c223247_)
                    (read-char _port223235_)
                    (_loop223244_
                     (+ '1 _i223246_)
                     (peek-char _port223235_)))))))))
  (define std/xml/ssax#next-token-old__0
    (lambda (_prefix-skipped-chars223252_ _break-chars223253_)
      (let* ((_comment223255_ '"") (_port223257_ (current-input-port)))
        (std/xml/ssax#next-token-old__%
         _prefix-skipped-chars223252_
         _break-chars223253_
         _comment223255_
         _port223257_))))
  (define std/xml/ssax#next-token-old__1
    (lambda (_prefix-skipped-chars223259_ _break-chars223260_ _comment223261_)
      (let ((_port223263_ (current-input-port)))
        (std/xml/ssax#next-token-old__%
         _prefix-skipped-chars223259_
         _break-chars223260_
         _comment223261_
         _port223263_))))
  (define std/xml/ssax#next-token-old
    (lambda _g301357_
      (let ((_g301356_ (let () (declare (not safe)) (##length _g301357_))))
        (cond ((let () (declare (not safe)) (##fx= _g301356_ 2))
               (apply std/xml/ssax#next-token-old__0 _g301357_))
              ((let () (declare (not safe)) (##fx= _g301356_ 3))
               (apply std/xml/ssax#next-token-old__1 _g301357_))
              ((let () (declare (not safe)) (##fx= _g301356_ 4))
               (apply std/xml/ssax#next-token-old__% _g301357_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#next-token-old
                _g301357_))))))
  (define std/xml/ssax#next-token__%
    (lambda (_prefix-skipped-chars223192_
             _break-chars223193_
             _comment223194_
             _port223195_)
      (let _outer223197_ ((_buffer223199_
                           (std/xml/ssax#input-parse:init-buffer))
                          (_filled-buffer-l223200_ '())
                          (_c223201_
                           (std/xml/ssax#skip-while__%
                            _prefix-skipped-chars223192_
                            _port223195_)))
        (let ((_curr-buf-len223203_ (string-length _buffer223199_)))
          (let _loop223205_ ((_i223207_ '0) (_c223208_ _c223201_))
            (if (memv _c223208_ _break-chars223193_)
                (if (null? _filled-buffer-l223200_)
                    (substring _buffer223199_ '0 _i223207_)
                    (std/srfi/13#string-concatenate-reverse__%
                     _filled-buffer-l223200_
                     _buffer223199_
                     _i223207_))
                (if (eof-object? _c223208_)
                    (if (memq '*eof* _break-chars223193_)
                        (if (null? _filled-buffer-l223200_)
                            (substring _buffer223199_ '0 _i223207_)
                            (std/srfi/13#string-concatenate-reverse__%
                             _filled-buffer-l223200_
                             _buffer223199_
                             _i223207_))
                        (std/xml/ssax#parser-error
                         _port223195_
                         '"EOF while reading a token "
                         _comment223194_))
                    (if (>= _i223207_ _curr-buf-len223203_)
                        (_outer223197_
                         (make-string _curr-buf-len223203_)
                         (cons _buffer223199_ _filled-buffer-l223200_)
                         _c223208_)
                        (begin
                          (string-set! _buffer223199_ _i223207_ _c223208_)
                          (read-char _port223195_)
                          (_loop223205_
                           (+ '1 _i223207_)
                           (peek-char _port223195_)))))))))))
  (define std/xml/ssax#next-token__0
    (lambda (_prefix-skipped-chars223213_ _break-chars223214_)
      (let* ((_comment223216_ '"") (_port223218_ (current-input-port)))
        (std/xml/ssax#next-token__%
         _prefix-skipped-chars223213_
         _break-chars223214_
         _comment223216_
         _port223218_))))
  (define std/xml/ssax#next-token__1
    (lambda (_prefix-skipped-chars223220_ _break-chars223221_ _comment223222_)
      (let ((_port223224_ (current-input-port)))
        (std/xml/ssax#next-token__%
         _prefix-skipped-chars223220_
         _break-chars223221_
         _comment223222_
         _port223224_))))
  (define std/xml/ssax#next-token
    (lambda _g301359_
      (let ((_g301358_ (let () (declare (not safe)) (##length _g301359_))))
        (cond ((let () (declare (not safe)) (##fx= _g301358_ 2))
               (apply std/xml/ssax#next-token__0 _g301359_))
              ((let () (declare (not safe)) (##fx= _g301358_ 3))
               (apply std/xml/ssax#next-token__1 _g301359_))
              ((let () (declare (not safe)) (##fx= _g301358_ 4))
               (apply std/xml/ssax#next-token__% _g301359_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#next-token
                _g301359_))))))
  (define std/xml/ssax#next-token-of__%
    (lambda (_incl-list/pred223151_ _port223152_)
      (let* ((_buffer223154_ (std/xml/ssax#input-parse:init-buffer))
             (_curr-buf-len223156_ (string-length _buffer223154_)))
        (if (procedure? _incl-list/pred223151_)
            (let _outer223159_ ((_buffer223161_ _buffer223154_)
                                (_filled-buffer-l223162_ '()))
              (let _loop223164_ ((_i223166_ '0))
                (if (>= _i223166_ _curr-buf-len223156_)
                    (_outer223159_
                     (make-string _curr-buf-len223156_)
                     (cons _buffer223161_ _filled-buffer-l223162_))
                    (let ((_c223168_
                           (_incl-list/pred223151_ (peek-char _port223152_))))
                      (if _c223168_
                          (begin
                            (string-set! _buffer223161_ _i223166_ _c223168_)
                            (read-char _port223152_)
                            (_loop223164_ (+ '1 _i223166_)))
                          (if (null? _filled-buffer-l223162_)
                              (substring _buffer223161_ '0 _i223166_)
                              (std/srfi/13#string-concatenate-reverse__%
                               _filled-buffer-l223162_
                               _buffer223161_
                               _i223166_)))))))
            (let _outer223170_ ((_buffer223172_ _buffer223154_)
                                (_filled-buffer-l223173_ '()))
              (let _loop223175_ ((_i223177_ '0))
                (if (>= _i223177_ _curr-buf-len223156_)
                    (_outer223170_
                     (make-string _curr-buf-len223156_)
                     (cons _buffer223172_ _filled-buffer-l223173_))
                    (let ((_c223179_ (peek-char _port223152_)))
                      (if (not (memv _c223179_ _incl-list/pred223151_))
                          (if (null? _filled-buffer-l223173_)
                              (substring _buffer223172_ '0 _i223177_)
                              (std/srfi/13#string-concatenate-reverse__%
                               _filled-buffer-l223173_
                               _buffer223172_
                               _i223177_))
                          (begin
                            (string-set! _buffer223172_ _i223177_ _c223179_)
                            (read-char _port223152_)
                            (_loop223175_ (+ '1 _i223177_))))))))))))
  (define std/xml/ssax#next-token-of__0
    (lambda (_incl-list/pred223184_)
      (let ((_port223186_ (current-input-port)))
        (std/xml/ssax#next-token-of__% _incl-list/pred223184_ _port223186_))))
  (define std/xml/ssax#next-token-of
    (lambda _g301361_
      (let ((_g301360_ (let () (declare (not safe)) (##length _g301361_))))
        (cond ((let () (declare (not safe)) (##fx= _g301360_ 1))
               (apply std/xml/ssax#next-token-of__0 _g301361_))
              ((let () (declare (not safe)) (##fx= _g301360_ 2))
               (apply std/xml/ssax#next-token-of__% _g301361_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#next-token-of
                _g301361_))))))
  (define std/xml/ssax#*read-line-breaks*
    (list std/xml/ssax#char-newline std/xml/ssax#char-return '*eof*))
  (define std/xml/ssax#read-text-line__%
    (lambda (_port223135_)
      (if (eof-object? (peek-char _port223135_))
          (peek-char _port223135_)
          (let* ((_line223137_
                  (std/xml/ssax#next-token__%
                   '()
                   std/xml/ssax#*read-line-breaks*
                   '"reading a line"
                   _port223135_))
                 (_c223139_ (read-char _port223135_)))
            (if (eqv? _c223139_ std/xml/ssax#char-return)
                (if (eqv? (peek-char _port223135_) '#\newline)
                    (read-char _port223135_)
                    '#f)
                '#f)
            _line223137_))))
  (define std/xml/ssax#read-text-line__0
    (lambda ()
      (let ((_port223146_ (current-input-port)))
        (std/xml/ssax#read-text-line__% _port223146_))))
  (define std/xml/ssax#read-text-line
    (lambda _g301363_
      (let ((_g301362_ (let () (declare (not safe)) (##length _g301363_))))
        (cond ((let () (declare (not safe)) (##fx= _g301362_ 0))
               (apply std/xml/ssax#read-text-line__0 _g301363_))
              ((let () (declare (not safe)) (##fx= _g301362_ 1))
               (apply std/xml/ssax#read-text-line__% _g301363_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#read-text-line
                _g301363_))))))
  (define std/xml/ssax#read-string__%
    (lambda (_n223112_ _port223113_)
      (if (not (positive? _n223112_))
          '""
          (let ((_buffer223115_ (make-string _n223112_)))
            (let _loop223117_ ((_i223119_ '0)
                               (_c223120_ (read-char _port223113_)))
              (if (eof-object? _c223120_)
                  (substring _buffer223115_ '0 _i223119_)
                  (let ((_i1223122_ (+ '1 _i223119_)))
                    (string-set! _buffer223115_ _i223119_ _c223120_)
                    (if (= _i1223122_ _n223112_)
                        _buffer223115_
                        (_loop223117_
                         _i1223122_
                         (read-char _port223113_))))))))))
  (define std/xml/ssax#read-string__0
    (lambda (_n223127_)
      (let ((_port223129_ (current-input-port)))
        (std/xml/ssax#read-string__% _n223127_ _port223129_))))
  (define std/xml/ssax#read-string
    (lambda _g301365_
      (let ((_g301364_ (let () (declare (not safe)) (##length _g301365_))))
        (cond ((let () (declare (not safe)) (##fx= _g301364_ 1))
               (apply std/xml/ssax#read-string__0 _g301365_))
              ((let () (declare (not safe)) (##fx= _g301364_ 2))
               (apply std/xml/ssax#read-string__% _g301365_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#read-string
                _g301365_))))))
  (define std/xml/ssax#MISCIO:find-string-from-port?
    (lambda (_str223077_ _<input-port>223078_ . _max-no-char223079_)
      (set! _max-no-char223079_
            (if (null? _max-no-char223079_) '#f (car _max-no-char223079_)))
      (letrec ((_no-chars-read223081_ '0)
               (_my-peek-char223082_
                (lambda ()
                  (if (or (not _max-no-char223079_)
                          (< _no-chars-read223081_ _max-no-char223079_))
                      (let ((_c223092_ (peek-char _<input-port>223078_)))
                        (if (eof-object? _c223092_) '#f _c223092_))
                      '#f)))
               (_next-char223083_
                (lambda ()
                  (read-char _<input-port>223078_)
                  (set! _no-chars-read223081_ (+ '1 _no-chars-read223081_))))
               (_match-1st-char223084_
                (lambda ()
                  (let ((_c223096_ (_my-peek-char223082_)))
                    (if (not _c223096_)
                        '#f
                        (begin
                          (_next-char223083_)
                          (if (char=? _c223096_ (string-ref _str223077_ '0))
                              (_match-other-chars223085_ '1)
                              (_match-1st-char223084_)))))))
               (_match-other-chars223085_
                (lambda (_pos-to-match223098_)
                  (if (>= _pos-to-match223098_ (string-length _str223077_))
                      _no-chars-read223081_
                      (let ((_c223100_ (_my-peek-char223082_)))
                        (if _c223100_
                            (if (not (char=? _c223100_
                                             (string-ref
                                              _str223077_
                                              _pos-to-match223098_)))
                                (_backtrack223086_ '1 _pos-to-match223098_)
                                (begin
                                  (_next-char223083_)
                                  (_match-other-chars223085_
                                   (+ '1 _pos-to-match223098_))))
                            '#f)))))
               (_backtrack223086_
                (lambda (_i223102_ _matched-substr-len223103_)
                  (let ((_j223105_ (- _matched-substr-len223103_ _i223102_)))
                    (if (<= _j223105_ '0)
                        (_match-1st-char223084_)
                        (let _loop223107_ ((_k223109_ '0))
                          (if (>= _k223109_ _j223105_)
                              (_match-other-chars223085_ _j223105_)
                              (if (char=? (string-ref _str223077_ _k223109_)
                                          (string-ref
                                           _str223077_
                                           (+ _i223102_ _k223109_)))
                                  (_loop223107_ (+ '1 _k223109_))
                                  (_backtrack223086_
                                   (+ '1 _i223102_)
                                   _matched-substr-len223103_)))))))))
        (_match-1st-char223084_))))
  (define std/xml/ssax#find-string-from-port?
    std/xml/ssax#MISCIO:find-string-from-port?)
  (define std/xml/ssax#make-xml-token
    (lambda (_kind223074_ _head223075_) (cons _kind223074_ _head223075_)))
  (define std/xml/ssax#xml-token? pair?)
  (define std/xml/ssax#string-whitespace?
    (lambda (_str223063_)
      (let ((_len223065_ (string-length _str223063_)))
        (if (zero? _len223065_)
            '#t
            (if (= '1 _len223065_)
                (char-whitespace? (string-ref _str223063_ '0))
                (if (= '2 _len223065_)
                    (if (char-whitespace? (string-ref _str223063_ '0))
                        (char-whitespace? (string-ref _str223063_ '1))
                        '#f)
                    (let _loop223067_ ((_i223069_ '0))
                      (let ((_$e223071_ (>= _i223069_ _len223065_)))
                        (if _$e223071_
                            _$e223071_
                            (if (char-whitespace?
                                 (string-ref _str223063_ _i223069_))
                                (_loop223067_ (+ '1 _i223069_))
                                '#f))))))))))
  (define std/xml/ssax#assq-values
    (lambda (_val223055_ _alist223056_)
      (let _loop223058_ ((_alist223060_ _alist223056_) (_scanned223061_ '()))
        (if (null? _alist223060_)
            (values '#f _scanned223061_)
            (if (equal? _val223055_ (caar _alist223060_))
                (values (car _alist223060_)
                        (append _scanned223061_ (cdr _alist223060_)))
                (_loop223058_
                 (cdr _alist223060_)
                 (cons (car _alist223060_) _scanned223061_)))))))
  (define std/xml/ssax#fold-right
    (lambda (_kons223045_ _knil223046_ _lis1223047_)
      (let _recur223049_ ((_lis223051_ _lis1223047_))
        (if (null? _lis223051_)
            _knil223046_
            (let ((_head223053_ (car _lis223051_)))
              (_kons223045_
               _head223053_
               (_recur223049_ (cdr _lis223051_))))))))
  (define std/xml/ssax#fold
    (lambda (_kons223036_ _knil223037_ _lis1223038_)
      (let _lp223040_ ((_lis223042_ _lis1223038_) (_ans223043_ _knil223037_))
        (if (null? _lis223042_)
            _ans223043_
            (_lp223040_
             (cdr _lis223042_)
             (_kons223036_ (car _lis223042_) _ans223043_))))))
  (define std/xml/ssax#ssax:S-chars
    (map std/xml/ssax#ascii->char '(32 10 9 13)))
  (define std/xml/ssax#ssax:skip-S
    (lambda (_port223034_)
      (std/xml/ssax#skip-while__% std/xml/ssax#ssax:S-chars _port223034_)))
  (define std/xml/ssax#ssax:ncname-starting-char?
    (lambda (_a-char223029_)
      (if (char? _a-char223029_)
          (let ((_$e223031_ (char-alphabetic? _a-char223029_)))
            (if _$e223031_ _$e223031_ (char=? '#\_ _a-char223029_)))
          '#f)))
  (define std/xml/ssax#ssax:read-NCName
    (lambda (_port223020_)
      (let* ((_first-char223022_ (peek-char _port223020_))
             (_$e223024_
              (std/xml/ssax#ssax:ncname-starting-char? _first-char223022_)))
        (if _$e223024_
            _$e223024_
            (std/xml/ssax#parser-error
             _port223020_
             '"XMLNS [4] for '"
             _first-char223022_
             '"'")))
      (string->symbol
       (std/xml/ssax#next-token-of__%
        (lambda (_c223027_)
          (if (eof-object? _c223027_)
              '#f
              (if (char-alphabetic? _c223027_)
                  _c223027_
                  (if (std/srfi/13#string-index__0 '"0123456789.-_" _c223027_)
                      _c223027_
                      '#f))))
        _port223020_))))
  (define std/xml/ssax#ssax:read-QName
    (lambda (_port223013_)
      (let* ((_prefix-or-localpart223015_
              (std/xml/ssax#ssax:read-NCName _port223013_))
             (_$e223017_ (peek-char _port223013_)))
        (if (eq? '#\: _$e223017_)
            (begin
              (read-char _port223013_)
              (cons _prefix-or-localpart223015_
                    (std/xml/ssax#ssax:read-NCName _port223013_)))
            _prefix-or-localpart223015_))))
  (define std/xml/ssax#ssax:Prefix-XML (string->symbol '"xml"))
  (define std/xml/ssax#name-compare
    (letrec ((_symbol-compare223005_
              (lambda (_symb1223007_ _symb2223008_)
                (if (eq? _symb1223007_ _symb2223008_)
                    '=
                    (if (string<?
                         (symbol->string _symb1223007_)
                         (symbol->string _symb2223008_))
                        '<
                        '>)))))
      (lambda (_name1223010_ _name2223011_)
        (if (symbol? _name1223010_)
            (if (symbol? _name2223011_)
                (_symbol-compare223005_ _name1223010_ _name2223011_)
                '<)
            (if (symbol? _name2223011_)
                '>
                (if (eq? _name2223011_ std/xml/ssax#ssax:largest-unres-name)
                    '<
                    (if (eq? _name1223010_
                             std/xml/ssax#ssax:largest-unres-name)
                        '>
                        (if (eq? (car _name1223010_) (car _name2223011_))
                            (_symbol-compare223005_
                             (cdr _name1223010_)
                             (cdr _name2223011_))
                            (_symbol-compare223005_
                             (car _name1223010_)
                             (car _name2223011_))))))))))
  (define std/xml/ssax#ssax:largest-unres-name
    (cons (string->symbol '"#LARGEST-SYMBOL")
          (string->symbol '"#LARGEST-SYMBOL")))
  (define std/xml/ssax#ssax:read-markup-token
    (let ()
      (letrec ((_skip-comment218476_
                (lambda (_port223003_)
                  (std/xml/ssax#assert-curr-char__%
                   '(#\-)
                   '"XML [15], second dash"
                   _port223003_)
                  (if (not (std/xml/ssax#find-string-from-port?
                            '"-->"
                            _port223003_))
                      (std/xml/ssax#parser-error
                       _port223003_
                       '"XML [15], no -->")
                      '#!void)
                  (cons 'COMMENT '#f)))
               (_read-cdata218477_
                (lambda (_port218490_)
                  (let ((_$e219860_
                         (string=?
                          '"CDATA["
                          (std/xml/ssax#read-string__% '6 _port218490_))))
                    (if _$e219860_
                        _$e219860_
                        (begin
                          (std/xml/ssax#cerr
                           '"failed assertion: "
                           '(string=? "CDATA[" (read-string 6 port))
                           std/xml/ssax#nl
                           '"bindings"
                           '#\newline
                           'port
                           '": "
                           _port218490_
                           std/xml/ssax#nl)
                          (error '"assertion failure"))))
                  (cons 'CDSECT '#f))))
        (lambda (_port218479_)
          (std/xml/ssax#assert-curr-char__%
           '(#\<)
           '"start of the token"
           _port218479_)
          (let ((_$e218481_ (peek-char _port218479_)))
            (if (eq? '#\/ _$e218481_)
                (begin
                  (read-char _port218479_)
                  (let ((_$r218484_
                         (cons 'END
                               (std/xml/ssax#ssax:read-QName _port218479_))))
                    (std/xml/ssax#ssax:skip-S _port218479_)
                    (std/xml/ssax#assert-curr-char__%
                     '(#\>)
                     '"XML [42]"
                     _port218479_)
                    _$r218484_))
                (if (eq? '#\? _$e218481_)
                    (begin
                      (read-char _port218479_)
                      (cons 'PI (std/xml/ssax#ssax:read-NCName _port218479_)))
                    (if (eq? '#\! _$e218481_)
                        (let ((_$e218487_
                               (std/xml/ssax#peek-next-char__% _port218479_)))
                          (if (eq? '#\- _$e218487_)
                              (begin
                                (read-char _port218479_)
                                (_skip-comment218476_ _port218479_))
                              (if (eq? '#\[ _$e218487_)
                                  (begin
                                    (read-char _port218479_)
                                    (_read-cdata218477_ _port218479_))
                                  (cons 'DECL
                                        (std/xml/ssax#ssax:read-NCName
                                         _port218479_)))))
                        (cons 'START
                              (std/xml/ssax#ssax:read-QName
                               _port218479_))))))))))
  (define std/xml/ssax#ssax:skip-pi
    (lambda (_port218473_)
      (if (not (std/xml/ssax#find-string-from-port? '"?>" _port218473_))
          (std/xml/ssax#parser-error
           _port218473_
           '"Failed to find ?> terminating the PI")
          '#!void)))
  (define std/xml/ssax#ssax:read-pi-body-as-string
    (lambda (_port218466_)
      (std/xml/ssax#ssax:skip-S _port218466_)
      (std/srfi/13#string-concatenate/shared
       (let _loop218468_ ()
         (let ((_pi-fragment218471_
                (std/xml/ssax#next-token__%
                 '()
                 '(#\?)
                 '"reading PI content"
                 _port218466_)))
           (if (eqv? '#\> (std/xml/ssax#peek-next-char__% _port218466_))
               (begin (read-char _port218466_) (cons _pi-fragment218471_ '()))
               (cons _pi-fragment218471_ (cons '"?" (_loop218468_)))))))))
  (define std/xml/ssax#ssax:skip-internal-dtd
    (lambda (_port218464_)
      (if (not (std/xml/ssax#find-string-from-port? '"]>" _port218464_))
          (std/xml/ssax#parser-error
           _port218464_
           '"Failed to find ]> terminating the internal DTD subset")
          '#!void)))
  (define std/xml/ssax#ssax:read-cdata-body
    (let ((_cdata-delimiters218438_
           (list std/xml/ssax#char-return '#\newline '#\] '#\&)))
      (lambda (_port218440_ _str-handler218441_ _seed218442_)
        (let _loop218444_ ((_seed218446_ _seed218442_))
          (let* ((_fragment218448_
                  (std/xml/ssax#next-token__%
                   '()
                   _cdata-delimiters218438_
                   '"reading CDATA"
                   _port218440_))
                 (_$e218450_ (read-char _port218440_)))
            (if (eq? '#\newline _$e218450_)
                (_loop218444_
                 (_str-handler218441_
                  _fragment218448_
                  std/xml/ssax#nl
                  _seed218446_))
                (if (eq? '#\] _$e218450_)
                    (if (not (eqv? (peek-char _port218440_) '#\]))
                        (_loop218444_
                         (_str-handler218441_
                          _fragment218448_
                          '"]"
                          _seed218446_))
                        (let _check-after-second-braket218453_ ((_seed218455_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (std/xml/ssax#string-null? _fragment218448_)
                             _seed218446_
                             (_str-handler218441_
                              _fragment218448_
                              '""
                              _seed218446_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                          (let ((_$e218457_
                                 (std/xml/ssax#peek-next-char__%
                                  _port218440_)))
                            (if (eq? '#\> _$e218457_)
                                (begin (read-char _port218440_) _seed218455_)
                                (if (eq? '#\] _$e218457_)
                                    (_check-after-second-braket218453_
                                     (_str-handler218441_
                                      '"]"
                                      '""
                                      _seed218455_))
                                    (_loop218444_
                                     (_str-handler218441_
                                      '"]]"
                                      '""
                                      _seed218455_)))))))
                    (if (eq? '#\& _$e218450_)
                        (let ((_ent-ref218462_
                               (std/xml/ssax#next-token-of__%
                                (lambda (_c218460_)
                                  (if (not (eof-object? _c218460_))
                                      (if (char-alphabetic? _c218460_)
                                          _c218460_
                                          '#f)
                                      '#f))
                                _port218440_)))
                          (if (and (string=? '"gt" _ent-ref218462_)
                                   (eqv? (peek-char _port218440_) '#\;))
                              (begin
                                (read-char _port218440_)
                                (_loop218444_
                                 (_str-handler218441_
                                  _fragment218448_
                                  '">"
                                  _seed218446_)))
                              (_loop218444_
                               (_str-handler218441_
                                _ent-ref218462_
                                '""
                                (_str-handler218441_
                                 _fragment218448_
                                 '"&"
                                 _seed218446_)))))
                        (begin
                          (if (eqv? (peek-char _port218440_) '#\newline)
                              (read-char _port218440_)
                              '#!void)
                          (_loop218444_
                           (_str-handler218441_
                            _fragment218448_
                            std/xml/ssax#nl
                            _seed218446_)))))))))))
  (define std/xml/ssax#ssax:read-char-ref
    (lambda (_port218429_)
      (let* ((_base218431_
              (if (eqv? (peek-char _port218429_) '#\x)
                  (begin (read-char _port218429_) '16)
                  '10))
             (_name218433_
              (std/xml/ssax#next-token__% '() '(#\;) '"XML [66]" _port218429_))
             (_char-code218435_ (string->number _name218433_ _base218431_)))
        (read-char _port218429_)
        (if (integer? _char-code218435_)
            (integer->char _char-code218435_)
            (std/xml/ssax#parser-error
             _port218429_
             '"[wf-Legalchar] broken for '"
             _name218433_
             '"'")))))
  (define std/xml/ssax#ssax:predefined-parsed-entities
    (cons (cons (string->symbol '"amp") '"&")
          (cons (cons (string->symbol '"lt") '"<")
                (cons (cons (string->symbol '"gt") '">")
                      (cons (cons (string->symbol '"apos") '"'")
                            (cons (cons (string->symbol '"quot") '"\"")
                                  '()))))))
  (define std/xml/ssax#ssax:handle-parsed-entity
    (lambda (_port218402_
             _name218403_
             _entities218404_
             _content-handler218405_
             _str-handler218406_
             _seed218407_)
      (let ((_$e218409_ (assq _name218403_ _entities218404_)))
        (if _$e218409_
            ((lambda (_decl-entity218412_)
               (let ((_ent-body218414_ (cdr _decl-entity218412_))
                     (_new-entities218415_
                      (cons (cons _name218403_ '#f) _entities218404_)))
                 (if (string? _ent-body218414_)
                     (call-with-input-string
                      _ent-body218414_
                      (lambda (_port218417_)
                        (_content-handler218405_
                         _port218417_
                         _new-entities218415_
                         _seed218407_)))
                     (if (procedure? _ent-body218414_)
                         (let* ((_port218419_ (_ent-body218414_))
                                (_$r218421_
                                 (_content-handler218405_
                                  _port218419_
                                  _new-entities218415_
                                  _seed218407_)))
                           (close-input-port _port218419_)
                           _$r218421_)
                         (std/xml/ssax#parser-error
                          _port218402_
                          '"[norecursion] broken for "
                          _name218403_)))))
             _$e218409_)
            (let ((_$e218424_
                   (assq _name218403_
                         std/xml/ssax#ssax:predefined-parsed-entities)))
              (if _$e218424_
                  ((lambda (_decl-entity218427_)
                     (_str-handler218406_
                      (cdr _decl-entity218427_)
                      '""
                      _seed218407_))
                   _$e218424_)
                  (std/xml/ssax#parser-error
                   _port218402_
                   '"[wf-entdeclared] broken for "
                   _name218403_)))))))
  (define std/xml/ssax#make-empty-attlist (lambda () '()))
  (define std/xml/ssax#attlist-add
    (lambda (_attlist218395_ _name-value218396_)
      (if (null? _attlist218395_)
          (cons _name-value218396_ _attlist218395_)
          (let ((_$e218398_
                 (std/xml/ssax#name-compare
                  (car _name-value218396_)
                  (caar _attlist218395_))))
            (if (eq? '= _$e218398_)
                '#f
                (if (eq? '< _$e218398_)
                    (cons _name-value218396_ _attlist218395_)
                    (cons (car _attlist218395_)
                          (std/xml/ssax#attlist-add
                           (cdr _attlist218395_)
                           _name-value218396_))))))))
  (define std/xml/ssax#attlist-null? null?)
  (define std/xml/ssax#attlist-remove-top
    (lambda (_attlist218393_)
      (values (car _attlist218393_) (cdr _attlist218393_))))
  (define std/xml/ssax#attlist->alist
    (lambda (_attlist218391_) _attlist218391_))
  (define std/xml/ssax#attlist-fold std/xml/ssax#fold)
  (define std/xml/ssax#ssax:read-attributes
    (let ((_value-delimeters218345_
           (append std/xml/ssax#ssax:S-chars '(#\< #\&))))
      (letrec ((_read-attrib-value218347_
                (lambda (_delimiter218378_
                         _port218379_
                         _entities218380_
                         _prev-fragments218381_)
                  (let* ((_new-fragments218383_
                          (cons (std/xml/ssax#next-token__%
                                 '()
                                 (cons _delimiter218378_
                                       _value-delimeters218345_)
                                 '"XML [10]"
                                 _port218379_)
                                _prev-fragments218381_))
                         (_cterm218385_ (read-char _port218379_)))
                    (if (or (eof-object? _cterm218385_)
                            (eqv? _cterm218385_ _delimiter218378_))
                        _new-fragments218383_
                        (if (eqv? _cterm218385_ std/xml/ssax#char-return)
                            (begin
                              (if (eqv? (peek-char _port218379_) '#\newline)
                                  (read-char _port218379_)
                                  '#!void)
                              (_read-attrib-value218347_
                               _delimiter218378_
                               _port218379_
                               _entities218380_
                               (cons '" " _new-fragments218383_)))
                            (if (memv _cterm218385_ std/xml/ssax#ssax:S-chars)
                                (_read-attrib-value218347_
                                 _delimiter218378_
                                 _port218379_
                                 _entities218380_
                                 (cons '" " _new-fragments218383_))
                                (if (eqv? _cterm218385_ '#\&)
                                    (if (eqv? (peek-char _port218379_) '#\#)
                                        (begin
                                          (read-char _port218379_)
                                          (_read-attrib-value218347_
                                           _delimiter218378_
                                           _port218379_
                                           _entities218380_
                                           (cons (string (std/xml/ssax#ssax:read-char-ref
                                                          _port218379_))
                                                 _new-fragments218383_)))
                                        (_read-attrib-value218347_
                                         _delimiter218378_
                                         _port218379_
                                         _entities218380_
                                         (_read-named-entity218348_
                                          _port218379_
                                          _entities218380_
                                          _new-fragments218383_)))
                                    (std/xml/ssax#parser-error
                                     _port218379_
                                     '"[CleanAttrVals] broken"))))))))
               (_read-named-entity218348_
                (lambda (_port218364_ _entities218365_ _fragments218366_)
                  (let ((_name218368_
                         (std/xml/ssax#ssax:read-NCName _port218364_)))
                    (std/xml/ssax#assert-curr-char__%
                     '(#\;)
                     '"XML [68]"
                     _port218364_)
                    (std/xml/ssax#ssax:handle-parsed-entity
                     _port218364_
                     _name218368_
                     _entities218365_
                     (lambda (_port218370_ _entities218371_ _fragments218372_)
                       (_read-attrib-value218347_
                        '*eof*
                        _port218370_
                        _entities218371_
                        _fragments218372_))
                     (lambda (_str1218374_ _str2218375_ _fragments218376_)
                       (if (equal? '"" _str2218375_)
                           (cons _str1218374_ _fragments218376_)
                           (cons _str2218375_
                                 (cons _str1218374_ _fragments218376_))))
                     _fragments218366_)))))
        (lambda (_port218350_ _entities218351_)
          (let _loop218353_ ((_attr-list218355_
                              (std/xml/ssax#make-empty-attlist)))
            (if (not (std/xml/ssax#ssax:ncname-starting-char?
                      (std/xml/ssax#ssax:skip-S _port218350_)))
                _attr-list218355_
                (let ((_name218357_
                       (std/xml/ssax#ssax:read-QName _port218350_)))
                  (std/xml/ssax#ssax:skip-S _port218350_)
                  (std/xml/ssax#assert-curr-char__%
                   '(#\=)
                   '"XML [25]"
                   _port218350_)
                  (std/xml/ssax#ssax:skip-S _port218350_)
                  (let ((_delimiter218359_
                         (std/xml/ssax#assert-curr-char__%
                          '(#\' #\")
                          '"XML [10]"
                          _port218350_)))
                    (_loop218353_
                     (let ((_$e218361_
                            (std/xml/ssax#attlist-add
                             _attr-list218355_
                             (cons _name218357_
                                   (std/srfi/13#string-concatenate-reverse/shared__0
                                    (_read-attrib-value218347_
                                     _delimiter218359_
                                     _port218350_
                                     _entities218351_
                                     '()))))))
                       (if _$e218361_
                           _$e218361_
                           (std/xml/ssax#parser-error
                            _port218350_
                            '"[uniqattspec] broken for "
                            _name218357_))))))))))))
  (define std/xml/ssax#ssax:resolve-name
    (lambda (_port218335_
             _unres-name218336_
             _namespaces218337_
             _apply-default-ns?218338_)
      (if (pair? _unres-name218336_)
          (cons (let ((_$e218340_
                       (assq (car _unres-name218336_) _namespaces218337_)))
                  (if _$e218340_
                      (cadr _$e218340_)
                      (if (eq? (car _unres-name218336_)
                               std/xml/ssax#ssax:Prefix-XML)
                          std/xml/ssax#ssax:Prefix-XML
                          (std/xml/ssax#parser-error
                           _port218335_
                           '"[nsc-NSDeclared] broken; prefix "
                           (car _unres-name218336_)))))
                (cdr _unres-name218336_))
          (if _apply-default-ns?218338_
              (let ((_default-ns218343_ (assq '*DEFAULT* _namespaces218337_)))
                (if (and _default-ns218343_ (cadr _default-ns218343_))
                    (cons (cadr _default-ns218343_) _unres-name218336_)
                    _unres-name218336_))
              _unres-name218336_))))
  (define std/xml/ssax#ssax:uri-string->symbol
    (lambda (_uri-str218333_) (string->symbol _uri-str218333_)))
  (define std/xml/ssax#ssax:complete-start-tag
    (let ((_xmlns218229_ (string->symbol '"xmlns"))
          (_largest-dummy-decl-attr218230_
           (list std/xml/ssax#ssax:largest-unres-name '#f '#f '#f)))
      (letrec ((_validate-attrs218232_
                (lambda (_port218287_ _attlist218288_ _decl-attrs218289_)
                  (letrec ((_add-default-decl218291_
                            (lambda (_decl-attr218324_ _result218325_)
                              (let ((_g301366_
                                     (apply values _decl-attr218324_)))
                                (begin
                                  (let ((_g301367_
                                         (let ()
                                           (declare (not safe))
                                           (if (##values? _g301366_)
                                               (##vector-length _g301366_)
                                               1))))
                                    (if (not (let ()
                                               (declare (not safe))
                                               (##fx= _g301367_ 4)))
                                        (error "Context expects 4 values"
                                               _g301367_)))
                                  (let ((_attr-name218327_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301366_ 0)))
                                        (_content-type218328_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301366_ 1)))
                                        (_use-type218329_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301366_ 2)))
                                        (_default-value218330_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301366_ 3))))
                                    (let ()
                                      (if (eq? _use-type218329_ 'REQUIRED)
                                          (std/xml/ssax#parser-error
                                           _port218287_
                                           '"[RequiredAttr] broken for"
                                           _attr-name218327_)
                                          '#f)
                                      (if _default-value218330_
                                          (cons (cons _attr-name218327_
                                                      _default-value218330_)
                                                _result218325_)
                                          _result218325_))))))))
                    (let _loop218293_ ((_attlist218295_ _attlist218288_)
                                       (_decl-attrs218296_ _decl-attrs218289_)
                                       (_result218297_ '()))
                      (if (std/xml/ssax#attlist-null? _attlist218295_)
                          (std/xml/ssax#attlist-fold
                           _add-default-decl218291_
                           _result218297_
                           _decl-attrs218296_)
                          (let ((_g301368_
                                 (std/xml/ssax#attlist-remove-top
                                  _attlist218295_)))
                            (begin
                              (let ((_g301369_
                                     (let ()
                                       (declare (not safe))
                                       (if (##values? _g301368_)
                                           (##vector-length _g301368_)
                                           1))))
                                (if (not (let ()
                                           (declare (not safe))
                                           (##fx= _g301369_ 2)))
                                    (error "Context expects 2 values"
                                           _g301369_)))
                              (let ((_attr218299_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref _g301368_ 0)))
                                    (_attr-others218300_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref _g301368_ 1))))
                                (let ((_g301370_
                                       (if (std/xml/ssax#attlist-null?
                                            _decl-attrs218296_)
                                           (values _largest-dummy-decl-attr218230_
                                                   _decl-attrs218296_)
                                           (std/xml/ssax#attlist-remove-top
                                            _decl-attrs218296_))))
                                  (begin
                                    (let ((_g301371_
                                           (let ()
                                             (declare (not safe))
                                             (if (##values? _g301370_)
                                                 (##vector-length _g301370_)
                                                 1))))
                                      (if (not (let ()
                                                 (declare (not safe))
                                                 (##fx= _g301371_ 2)))
                                          (error "Context expects 2 values"
                                                 _g301371_)))
                                    (let ((_decl-attr218302_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g301370_ 0)))
                                          (_other-decls218303_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g301370_ 1))))
                                      (let ()
                                        (let ((_$e218306_
                                               (std/xml/ssax#name-compare
                                                (car _attr218299_)
                                                (car _decl-attr218302_))))
                                          (if (eq? '< _$e218306_)
                                              (if (or (eq? _xmlns218229_
                                                           (car _attr218299_))
                                                      (and (pair? (car _attr218299_))
                                                           (eq? _xmlns218229_
                                                                (caar _attr218299_))))
                                                  (_loop218293_
                                                   _attr-others218300_
                                                   _decl-attrs218296_
                                                   (cons _attr218299_
                                                         _result218297_))
                                                  (std/xml/ssax#parser-error
                                                   _port218287_
                                                   '"[ValueType] broken for "
                                                   _attr218299_))
                                              (if (eq? '> _$e218306_)
                                                  (_loop218293_
                                                   _attlist218295_
                                                   _other-decls218303_
                                                   (_add-default-decl218291_
                                                    _decl-attr218302_
                                                    _result218297_))
                                                  (let ((_g301372_
                                                         (apply values
                                                                _decl-attr218302_)))
                                                    (begin
                                                      (let ((_g301373_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (if (##values? _g301372_)
                           (##vector-length _g301372_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g301373_ 4)))
                    (error "Context expects 4 values" _g301373_)))
              (let ((_attr-name218312_
                     (let () (declare (not safe)) (##vector-ref _g301372_ 0)))
                    (_content-type218313_
                     (let () (declare (not safe)) (##vector-ref _g301372_ 1)))
                    (_use-type218314_
                     (let () (declare (not safe)) (##vector-ref _g301372_ 2)))
                    (_default-value218315_
                     (let () (declare (not safe)) (##vector-ref _g301372_ 3))))
                (let ()
                  (if (eq? _use-type218314_ 'FIXED)
                      (let ((_$e218318_
                             (equal? (cdr _attr218299_)
                                     _default-value218315_)))
                        (if _$e218318_
                            _$e218318_
                            (std/xml/ssax#parser-error
                             _port218287_
                             '"[FixedAttr] broken for "
                             _attr-name218312_)))
                      (if (eq? _content-type218313_ 'CDATA)
                          '#t
                          (if (pair? _content-type218313_)
                              (let ((_$e218321_
                                     (member (cdr _attr218299_)
                                             _content-type218313_)))
                                (if _$e218321_
                                    _$e218321_
                                    (std/xml/ssax#parser-error
                                     _port218287_
                                     '"[enum] broken for "
                                     _attr-name218312_
                                     '"="
                                     (cdr _attr218299_))))
                              '#!void)))
                  (_loop218293_
                   _attr-others218300_
                   _other-decls218303_
                   (cons _attr218299_ _result218297_)))))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
               (_add-ns218233_
                (lambda (_port218276_
                         _prefix218277_
                         _uri-str218278_
                         _namespaces218279_)
                  (if (equal? '"" _uri-str218278_)
                      (std/xml/ssax#parser-error
                       _port218276_
                       '"[dt-NSName] broken for "
                       _prefix218277_)
                      '#f)
                  (let ((_uri-symbol218281_ (string->symbol _uri-str218278_)))
                    (let _loop218283_ ((_nss218285_ _namespaces218279_))
                      (if (null? _nss218285_)
                          (cons (cons _prefix218277_
                                      (cons _uri-symbol218281_
                                            _uri-symbol218281_))
                                _namespaces218279_)
                          (if (eq? _uri-symbol218281_ (cddar _nss218285_))
                              (cons (cons _prefix218277_
                                          (cons (cadar _nss218285_)
                                                _uri-symbol218281_))
                                    _namespaces218279_)
                              (_loop218283_ (cdr _nss218285_))))))))
               (_adjust-namespace-decl218234_
                (lambda (_port218266_ _attrs218267_ _namespaces218268_)
                  (let _loop218270_ ((_attrs218272_ _attrs218267_)
                                     (_proper-attrs218273_ '())
                                     (_namespaces218274_ _namespaces218268_))
                    (if (null? _attrs218272_)
                        (values _proper-attrs218273_ _namespaces218274_)
                        (if (eq? _xmlns218229_ (caar _attrs218272_))
                            (_loop218270_
                             (cdr _attrs218272_)
                             _proper-attrs218273_
                             (if (equal? '"" (cdar _attrs218272_))
                                 (cons (cons '*DEFAULT* (cons '#f '#f))
                                       _namespaces218274_)
                                 (_add-ns218233_
                                  _port218266_
                                  '*DEFAULT*
                                  (cdar _attrs218272_)
                                  _namespaces218274_)))
                            (if (and (pair? (caar _attrs218272_))
                                     (eq? _xmlns218229_ (caaar _attrs218272_)))
                                (_loop218270_
                                 (cdr _attrs218272_)
                                 _proper-attrs218273_
                                 (_add-ns218233_
                                  _port218266_
                                  (cdaar _attrs218272_)
                                  (cdar _attrs218272_)
                                  _namespaces218274_))
                                (_loop218270_
                                 (cdr _attrs218272_)
                                 (cons (car _attrs218272_)
                                       _proper-attrs218273_)
                                 _namespaces218274_))))))))
        (lambda (_tag-head218236_
                 _port218237_
                 _elems218238_
                 _entities218239_
                 _namespaces218240_)
          (let* ((_attlist218242_
                  (std/xml/ssax#ssax:read-attributes
                   _port218237_
                   _entities218239_))
                 (_empty-el-tag?218244_
                  (begin
                    (std/xml/ssax#ssax:skip-S _port218237_)
                    (if (eqv? '#\/
                              (std/xml/ssax#assert-curr-char__%
                               '(#\> #\/)
                               '"XML [40], XML [44], no '>'"
                               _port218237_))
                        (std/xml/ssax#assert-curr-char__%
                         '(#\>)
                         '"XML [44], no '>'"
                         _port218237_)
                        '#f)))
                 (_g301374_
                  (if _elems218238_
                      (let ((_$e218246_
                             (assoc _tag-head218236_ _elems218238_)))
                        (if _$e218246_
                            ((lambda (_decl-elem218249_)
                               (values (if _empty-el-tag?218244_
                                           'EMPTY-TAG
                                           (cadr _decl-elem218249_))
                                       (caddr _decl-elem218249_)))
                             _$e218246_)
                            (std/xml/ssax#parser-error
                             _port218237_
                             '"[elementvalid] broken, no decl for "
                             _tag-head218236_)))
                      (values (if _empty-el-tag?218244_ 'EMPTY-TAG 'ANY)
                              '#f))))
            (begin
              (let ((_g301375_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g301374_)
                           (##vector-length _g301374_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g301375_ 2)))
                    (error "Context expects 2 values" _g301375_)))
              (let ((_elem-content218251_
                     (let () (declare (not safe)) (##vector-ref _g301374_ 0)))
                    (_decl-attrs218252_
                     (let () (declare (not safe)) (##vector-ref _g301374_ 1))))
                (let* ((_merged-attrs218254_
                        (if _decl-attrs218252_
                            (_validate-attrs218232_
                             _port218237_
                             _attlist218242_
                             _decl-attrs218252_)
                            (std/xml/ssax#attlist->alist _attlist218242_)))
                       (_g301376_
                        (_adjust-namespace-decl218234_
                         _port218237_
                         _merged-attrs218254_
                         _namespaces218240_)))
                  (begin
                    (let ((_g301377_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g301376_)
                                 (##vector-length _g301376_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g301377_ 2)))
                          (error "Context expects 2 values" _g301377_)))
                    (let ((_proper-attrs218256_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g301376_ 0)))
                          (_namespaces218257_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g301376_ 1))))
                      (let ()
                        (values (std/xml/ssax#ssax:resolve-name
                                 _port218237_
                                 _tag-head218236_
                                 _namespaces218257_
                                 '#t)
                                (std/xml/ssax#fold-right
                                 (lambda (_name-value218260_ _attlist218261_)
                                   (let ((_$e218263_
                                          (std/xml/ssax#attlist-add
                                           _attlist218261_
                                           (cons (std/xml/ssax#ssax:resolve-name
                                                  _port218237_
                                                  (car _name-value218260_)
                                                  _namespaces218257_
                                                  '#f)
                                                 (cdr _name-value218260_)))))
                                     (if _$e218263_
                                         _$e218263_
                                         (std/xml/ssax#parser-error
                                          _port218237_
                                          '"[uniqattspec] after NS expansion broken for "
                                          _name-value218260_))))
                                 (std/xml/ssax#make-empty-attlist)
                                 _proper-attrs218256_)
                                _namespaces218257_
                                _elem-content218251_))))))))))))
  (define std/xml/ssax#ssax:read-external-id
    (lambda (_port218215_)
      (let ((_discriminator218217_
             (std/xml/ssax#ssax:read-NCName _port218215_)))
        (std/xml/ssax#assert-curr-char__%
         std/xml/ssax#ssax:S-chars
         '"space after SYSTEM or PUBLIC"
         _port218215_)
        (std/xml/ssax#ssax:skip-S _port218215_)
        (let ((_delimiter218219_
               (std/xml/ssax#assert-curr-char__%
                '(#\' #\")
                '"XML [11], XML [12]"
                _port218215_)))
          (if (eq? _discriminator218217_ (string->symbol '"SYSTEM"))
              (let ((_$r218221_
                     (std/xml/ssax#next-token__%
                      '()
                      (list _delimiter218219_)
                      '"XML [11]"
                      _port218215_)))
                (read-char _port218215_)
                _$r218221_)
              (if (eq? _discriminator218217_ (string->symbol '"PUBLIC"))
                  (begin
                    (std/xml/ssax#skip-until__%
                     (list _delimiter218219_)
                     _port218215_)
                    (std/xml/ssax#assert-curr-char__%
                     std/xml/ssax#ssax:S-chars
                     '"space after PubidLiteral"
                     _port218215_)
                    (std/xml/ssax#ssax:skip-S _port218215_)
                    (let* ((_delimiter218224_
                            (std/xml/ssax#assert-curr-char__%
                             '(#\' #\")
                             '"XML [11]"
                             _port218215_))
                           (_systemid218226_
                            (std/xml/ssax#next-token__%
                             '()
                             (list _delimiter218224_)
                             '"XML [11]"
                             _port218215_)))
                      (read-char _port218215_)
                      _systemid218226_))
                  (std/xml/ssax#parser-error
                   _port218215_
                   '"XML [75], "
                   _discriminator218217_
                   '" rather than SYSTEM or PUBLIC")))))))
  (define std/xml/ssax#ssax:scan-Misc
    (lambda (_port218198_)
      (let _loop218200_ ((_c218202_ (std/xml/ssax#ssax:skip-S _port218198_)))
        (if (eof-object? _c218202_)
            _c218202_
            (if (not (char=? _c218202_ '#\<))
                (std/xml/ssax#parser-error
                 _port218198_
                 '"XML [22], char '"
                 _c218202_
                 '"' unexpected")
                (let* ((_token218204_
                        (std/xml/ssax#ssax:read-markup-token _port218198_))
                       (_$e218206_ (car _token218204_)))
                  (if (eq? 'COMMENT _$e218206_)
                      (_loop218200_ (std/xml/ssax#ssax:skip-S _port218198_))
                      (if (or (eq? 'PI _$e218206_)
                              (eq? 'DECL _$e218206_)
                              (eq? 'START _$e218206_))
                          _token218204_
                          (std/xml/ssax#parser-error
                           _port218198_
                           '"XML [22], unexpected token of kind "
                           (car _token218204_))))))))))
  (define std/xml/ssax#ssax:read-char-data
    (let ((_terminators-usual218155_ (list '#\< '#\& std/xml/ssax#char-return))
          (_terminators-usual-eof218156_
           (list '#\< '*eof* '#\& std/xml/ssax#char-return))
          (_handle-fragment218157_
           (lambda (_fragment218151_ _str-handler218152_ _seed218153_)
             (if (std/xml/ssax#string-null? _fragment218151_)
                 _seed218153_
                 (_str-handler218152_ _fragment218151_ '"" _seed218153_)))))
      (lambda (_port218159_
               _expect-eof?218160_
               _str-handler218161_
               _seed218162_)
        (if (eqv? '#\< (peek-char _port218159_))
            (let* ((_token218164_
                    (std/xml/ssax#ssax:read-markup-token _port218159_))
                   (_$e218166_ (car _token218164_)))
              (if (or (eq? 'START _$e218166_) (eq? 'END _$e218166_))
                  (values _seed218162_ _token218164_)
                  (if (eq? 'CDSECT _$e218166_)
                      (let ((_seed218172_
                             (std/xml/ssax#ssax:read-cdata-body
                              _port218159_
                              _str-handler218161_
                              _seed218162_)))
                        (std/xml/ssax#ssax:read-char-data
                         _port218159_
                         _expect-eof?218160_
                         _str-handler218161_
                         _seed218172_))
                      (if (eq? 'COMMENT _$e218166_)
                          (std/xml/ssax#ssax:read-char-data
                           _port218159_
                           _expect-eof?218160_
                           _str-handler218161_
                           _seed218162_)
                          (values _seed218162_ _token218164_)))))
            (let ((_char-data-terminators218174_
                   (if _expect-eof?218160_
                       _terminators-usual-eof218156_
                       _terminators-usual218155_)))
              (let _loop218176_ ((_seed218178_ _seed218162_))
                (let* ((_fragment218180_
                        (std/xml/ssax#next-token__%
                         '()
                         _char-data-terminators218174_
                         '"reading char data"
                         _port218159_))
                       (_term-char218182_ (peek-char _port218159_)))
                  (if (eof-object? _term-char218182_)
                      (values (_handle-fragment218157_
                               _fragment218180_
                               _str-handler218161_
                               _seed218178_)
                              _term-char218182_)
                      (let ((_$e218185_ _term-char218182_))
                        (if (eq? '#\< _$e218185_)
                            (let* ((_token218188_
                                    (std/xml/ssax#ssax:read-markup-token
                                     _port218159_))
                                   (_$e218190_ (car _token218188_)))
                              (if (eq? 'CDSECT _$e218190_)
                                  (_loop218176_
                                   (std/xml/ssax#ssax:read-cdata-body
                                    _port218159_
                                    _str-handler218161_
                                    (_handle-fragment218157_
                                     _fragment218180_
                                     _str-handler218161_
                                     _seed218178_)))
                                  (if (eq? 'COMMENT _$e218190_)
                                      (_loop218176_
                                       (_handle-fragment218157_
                                        _fragment218180_
                                        _str-handler218161_
                                        _seed218178_))
                                      (values (_handle-fragment218157_
                                               _fragment218180_
                                               _str-handler218161_
                                               _seed218178_)
                                              _token218188_))))
                            (if (eq? '#\& _$e218185_)
                                (let ((_$e218193_
                                       (std/xml/ssax#peek-next-char__%
                                        _port218159_)))
                                  (if (eq? '#\# _$e218193_)
                                      (begin
                                        (read-char _port218159_)
                                        (_loop218176_
                                         (_str-handler218161_
                                          _fragment218180_
                                          (string (std/xml/ssax#ssax:read-char-ref
                                                   _port218159_))
                                          _seed218178_)))
                                      (let ((_name218196_
                                             (std/xml/ssax#ssax:read-NCName
                                              _port218159_)))
                                        (std/xml/ssax#assert-curr-char__%
                                         '(#\;)
                                         '"XML [68]"
                                         _port218159_)
                                        (values (_handle-fragment218157_
                                                 _fragment218180_
                                                 _str-handler218161_
                                                 _seed218178_)
                                                (cons 'ENTITY-REF
                                                      _name218196_)))))
                                (begin
                                  (if (eqv? (std/xml/ssax#peek-next-char__%
                                             _port218159_)
                                            '#\newline)
                                      (read-char _port218159_)
                                      '#!void)
                                  (_loop218176_
                                   (_str-handler218161_
                                    _fragment218180_
                                    (string '#\newline)
                                    _seed218178_))))))))))))))
  (define std/xml/ssax#ssax:assert-token
    (lambda (_token218143_ _kind218144_ _gi218145_ _error-cont218146_)
      (let ((_$e218148_
             (if (std/xml/ssax#xml-token? _token218143_)
                 (if (eq? _kind218144_ (car _token218143_))
                     (equal? _gi218145_ (cdr _token218143_))
                     '#f)
                 '#f)))
        (if _$e218148_
            _$e218148_
            (_error-cont218146_ _token218143_ _kind218144_ _gi218145_)))))
  (define std/xml/ssax#ssax:reverse-collect-str
    (lambda (_fragments218135_)
      (if (null? _fragments218135_)
          '()
          (if (null? (cdr _fragments218135_))
              _fragments218135_
              (let _loop218137_ ((_fragments218139_ _fragments218135_)
                                 (_result218140_ '())
                                 (_strs218141_ '()))
                (if (null? _fragments218139_)
                    (if (null? _strs218141_)
                        _result218140_
                        (cons (std/srfi/13#string-concatenate/shared
                               _strs218141_)
                              _result218140_))
                    (if (string? (car _fragments218139_))
                        (_loop218137_
                         (cdr _fragments218139_)
                         _result218140_
                         (cons (car _fragments218139_) _strs218141_))
                        (_loop218137_
                         (cdr _fragments218139_)
                         (cons (car _fragments218139_)
                               (if (null? _strs218141_)
                                   _result218140_
                                   (cons (std/srfi/13#string-concatenate/shared
                                          _strs218141_)
                                         _result218140_)))
                         '()))))))))
  (define std/xml/ssax#ssax:reverse-collect-str-drop-ws
    (lambda (_fragments218126_)
      (if (null? _fragments218126_)
          '()
          (if (null? (cdr _fragments218126_))
              (if (and (string? (car _fragments218126_))
                       (std/xml/ssax#string-whitespace?
                        (car _fragments218126_)))
                  '()
                  _fragments218126_)
              (let _loop218128_ ((_fragments218130_ _fragments218126_)
                                 (_result218131_ '())
                                 (_strs218132_ '())
                                 (_all-whitespace?218133_ '#t))
                (if (null? _fragments218130_)
                    (if _all-whitespace?218133_
                        _result218131_
                        (cons (std/srfi/13#string-concatenate/shared
                               _strs218132_)
                              _result218131_))
                    (if (string? (car _fragments218130_))
                        (_loop218128_
                         (cdr _fragments218130_)
                         _result218131_
                         (cons (car _fragments218130_) _strs218132_)
                         (if _all-whitespace?218133_
                             (std/xml/ssax#string-whitespace?
                              (car _fragments218130_))
                             '#f))
                        (_loop218128_
                         (cdr _fragments218130_)
                         (cons (car _fragments218130_)
                               (if _all-whitespace?218133_
                                   _result218131_
                                   (cons (std/srfi/13#string-concatenate/shared
                                          _strs218132_)
                                         _result218131_)))
                         '()
                         '#t))))))))
  (define std/xml/ssax#ssax:xml->sxml
    (lambda (_port213154_ _namespace-prefix-assig213155_)
      (letrec ((_namespaces213157_
                (map (lambda (_el213160_)
                       (cons '#f
                             (cons (car _el213160_)
                                   (string->symbol (cdr _el213160_)))))
                     _namespace-prefix-assig213155_))
               (_RES-NAME->SXML213158_
                (lambda (_res-name213162_)
                  (string->symbol
                   (string-append
                    (symbol->string (car _res-name213162_))
                    '":"
                    (symbol->string (cdr _res-name213162_)))))))
        (let ((_result218122_
               (reverse ((lambda (_port215189_ _seed215191_)
                           (letrec ((_handle-decl215194_
                                     (lambda (_port218088_
                                              _token-head218089_
                                              _seed218091_)
                                       (let ((_$e218093_
                                              (eq? (string->symbol '"DOCTYPE")
                                                   _token-head218089_)))
                                         (if _$e218093_
                                             _$e218093_
                                             (std/xml/ssax#parser-error
                                              _port218088_
                                              '"XML [22], expected DOCTYPE declaration, found "
                                              _token-head218089_)))
                                       (std/xml/ssax#assert-curr-char__%
                                        std/xml/ssax#ssax:S-chars
                                        '"XML [28], space after DOCTYPE"
                                        _port218088_)
                                       (std/xml/ssax#ssax:skip-S _port218088_)
                                       (let* ((_docname218096_
                                               (std/xml/ssax#ssax:read-QName
                                                _port218088_))
                                              (_systemid218099_
                                               (if (std/xml/ssax#ssax:ncname-starting-char?
                                                    (std/xml/ssax#ssax:skip-S
                                                     _port218088_))
                                                   (std/xml/ssax#ssax:read-external-id
                                                    _port218088_)
                                                   '#f))
                                              (_internal-subset?218102_
                                               (begin
                                                 (std/xml/ssax#ssax:skip-S
                                                  _port218088_)
                                                 (eqv? '#\[
                                                       (std/xml/ssax#assert-curr-char__%
                                                        '(#\> #\[)
                                                        '"XML [28], end-of-DOCTYPE"
                                                        _port218088_))))
                                              (_g301378_
                                               ((lambda (_port218105_
                                                         _docname218107_
                                                         _systemid218109_
                                                         _internal-subset?218111_
                                                         _seed218113_)
                                                  (if _internal-subset?218111_
                                                      (std/xml/ssax#ssax:skip-internal-dtd
                                                       _port218105_)
                                                      '#!void)
                                                  (values '#f
                                                          '()
                                                          _namespaces213157_
                                                          _seed218113_))
                                                _port218088_
                                                _docname218096_
                                                _systemid218099_
                                                _internal-subset?218102_
                                                _seed218091_)))
                                         (begin
                                           (let ((_g301379_
                                                  (let ()
                                                    (declare (not safe))
                                                    (if (##values? _g301378_)
                                                        (##vector-length
                                                         _g301378_)
                                                        1))))
                                             (if (not (let ()
                                                        (declare (not safe))
                                                        (##fx= _g301379_ 4)))
                                                 (error "Context expects 4 values"
                                                        _g301379_)))
                                           (let ((_elems218116_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301378_
                                                     0)))
                                                 (_entities218117_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301378_
                                                     1)))
                                                 (_namespaces218118_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301378_
                                                     2)))
                                                 (_seed218119_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301378_
                                                     3))))
                                             (let ()
                                               (_scan-for-significant-prolog-token-2215198_
                                                _port218088_
                                                _elems218116_
                                                _entities218117_
                                                _namespaces218118_
                                                _seed218119_)))))))
                                    (_scan-for-significant-prolog-token-1215196_
                                     (lambda (_port217181_ _seed217182_)
                                       (let ((_token217184_
                                              (std/xml/ssax#ssax:scan-Misc
                                               _port217181_)))
                                         (if (eof-object? _token217184_)
                                             (std/xml/ssax#parser-error
                                              _port217181_
                                              '"XML [22], unexpected EOF")
                                             (let ((_$e217186_
                                                    (car _token217184_)))
                                               (if (eq? 'PI _$e217186_)
                                                   (let ((_seed218075_
                                                          ((lambda (_port218064_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _target218065_
                            _seed218066_)
                     (let ((_$e218068_ _target218065_))
                       ((lambda (_port218071_ _pi-tag218072_ _seed218073_)
                          (cons (list '*PI*
                                      _pi-tag218072_
                                      (std/xml/ssax#ssax:read-pi-body-as-string
                                       _port218071_))
                                _seed218073_))
                        _port218064_
                        _target218065_
                        _seed218066_)))
                   _port217181_
                   (cdr _token217184_)
                   _seed217182_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_scan-for-significant-prolog-token-1215196_
                                                      _port217181_
                                                      _seed218075_))
                                                   (if (eq? 'DECL _$e217186_)
                                                       (_handle-decl215194_
                                                        _port217181_
                                                        (cdr _token217184_)
                                                        _seed217182_)
                                                       (if (eq? 'START
                                                                _$e217186_)
                                                           (let ((_g301380_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          ((lambda (_elem-gi218077_ _seed218079_)
                             (values '#f '() _namespaces213157_ _seed218079_))
                           (cdr _token217184_)
                           _seed217182_)))
                     (begin
                       (let ((_g301381_
                              (let ()
                                (declare (not safe))
                                (if (##values? _g301380_)
                                    (##vector-length _g301380_)
                                    1))))
                         (if (not (let ()
                                    (declare (not safe))
                                    (##fx= _g301381_ 4)))
                             (error "Context expects 4 values" _g301381_)))
                       (let ((_elems218082_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301380_ 0)))
                             (_entities218083_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301380_ 1)))
                             (_namespaces218084_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301380_ 2)))
                             (_seed218085_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301380_ 3))))
                         (let ()
                           (_element-parser215200_
                            (cdr _token217184_)
                            _port217181_
                            _elems218082_
                            _entities218083_
                            _namespaces218084_
                            '#f
                            _seed218085_)))))
                   (std/xml/ssax#parser-error
                    _port217181_
                    '"XML [22], unexpected markup "
                    _token217184_)))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                    (_scan-for-significant-prolog-token-2215198_
                                     (lambda (_port216273_
                                              _elems216274_
                                              _entities216276_
                                              _namespaces216278_
                                              _seed216280_)
                                       (let ((_token216282_
                                              (std/xml/ssax#ssax:scan-Misc
                                               _port216273_)))
                                         (if (eof-object? _token216282_)
                                             (std/xml/ssax#parser-error
                                              _port216273_
                                              '"XML [22], unexpected EOF")
                                             (let ((_$e216285_
                                                    (car _token216282_)))
                                               (if (eq? 'PI _$e216285_)
                                                   (let ((_seed217174_
                                                          ((lambda (_port217163_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _target217164_
                            _seed217165_)
                     (let ((_$e217167_ _target217164_))
                       ((lambda (_port217170_ _pi-tag217171_ _seed217172_)
                          (cons (list '*PI*
                                      _pi-tag217171_
                                      (std/xml/ssax#ssax:read-pi-body-as-string
                                       _port217170_))
                                _seed217172_))
                        _port217163_
                        _target217164_
                        _seed217165_)))
                   _port216273_
                   (cdr _token216282_)
                   _seed216280_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_scan-for-significant-prolog-token-2215198_
                                                      _port216273_
                                                      _elems216274_
                                                      _entities216276_
                                                      _namespaces216278_
                                                      _seed217174_))
                                                   (if (eq? 'START _$e216285_)
                                                       (_element-parser215200_
                                                        (cdr _token216282_)
                                                        _port216273_
                                                        _elems216274_
                                                        _entities216276_
                                                        _namespaces216278_
                                                        '#f
                                                        ((lambda (_elem-gi217176_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _seed217178_)
                   _seed217178_)
                 (cdr _token216282_)
                 _seed216280_))
               (std/xml/ssax#parser-error
                _port216273_
                '"XML [22], unexpected markup "
                _token216282_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                    (_element-parser215200_
                                     (lambda (_start-tag-head215203_
                                              _port215205_
                                              _elems215207_
                                              _entities215209_
                                              _namespaces215211_
                                              _preserve-ws?215213_
                                              _seed215215_)
                                       (letrec* ((_xml-space-gi215218_
                                                  (cons std/xml/ssax#ssax:Prefix-XML
                                                        (string->symbol
                                                         '"space"))))
                                         (let _handle-start-tag215221_ ((_start-tag-head215224_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 _start-tag-head215203_)
                                (_port215225_ _port215205_)
                                (_entities215226_ _entities215209_)
                                (_namespaces215227_ _namespaces215211_)
                                (_preserve-ws?215228_ _preserve-ws?215213_)
                                (_parent-seed215229_ _seed215215_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           (let ((_g301382_
                                                  (std/xml/ssax#ssax:complete-start-tag
                                                   _start-tag-head215224_
                                                   _port215225_
                                                   _elems215207_
                                                   _entities215226_
                                                   _namespaces215227_)))
                                             (begin
                                               (let ((_g301383_
                                                      (let ()
                                                        (declare (not safe))
                                                        (if (##values?
                                                             _g301382_)
                                                            (##vector-length
                                                             _g301382_)
                                                            1))))
                                                 (if (not (let ()
                                                            (declare
                                                              (not safe))
                                                            (##fx= _g301383_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           4)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (error "Context expects 4 values"
                                                            _g301383_)))
                                               (let ((_elem-gi215232_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301382_
                                                         0)))
                                                     (_attributes215234_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301382_
                                                         1)))
                                                     (_namespaces215236_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301382_
                                                         2)))
                                                     (_expected-content215237_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301382_
                                                         3))))
                                                 (let ((_seed215251_
                                                        ((lambda (_elem-gi215240_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _attributes215242_
                          _namespaces215244_
                          _expected-content215246_
                          _seed215248_)
                   '())
                 _elem-gi215232_
                 _attributes215234_
                 _namespaces215236_
                 _expected-content215237_
                 _parent-seed215229_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (let ((_$e215254_
                                                          _expected-content215237_))
                                                     (if (eq? 'EMPTY-TAG
                                                              _$e215254_)
                                                         ((lambda (_elem-gi215257_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _attributes215259_
                           _namespaces215261_
                           _parent-seed215263_
                           _seed215265_)
                    (let ((_seed215273_
                           (std/xml/ssax#ssax:reverse-collect-str-drop-ws
                            _seed215265_))
                          (_attrs215274_
                           (std/xml/ssax#attlist-fold
                            (lambda (_attr215268_ _accum215270_)
                              (cons (list (if (symbol? (car _attr215268_))
                                              (car _attr215268_)
                                              (_RES-NAME->SXML213158_
                                               (car _attr215268_)))
                                          (cdr _attr215268_))
                                    _accum215270_))
                            '()
                            _attributes215259_)))
                      (cons (cons (if (symbol? _elem-gi215257_)
                                      _elem-gi215257_
                                      (_RES-NAME->SXML213158_ _elem-gi215257_))
                                  (if (null? _attrs215274_)
                                      _seed215273_
                                      (cons (cons '@ _attrs215274_)
                                            _seed215273_)))
                            _parent-seed215263_)))
                  _elem-gi215232_
                  _attributes215234_
                  _namespaces215236_
                  _parent-seed215229_
                  _seed215251_)
                 (if (eq? 'EMPTY _$e215254_)
                     (begin
                       (std/xml/ssax#ssax:assert-token
                        (if (eqv? '#\< (std/xml/ssax#ssax:skip-S _port215225_))
                            (std/xml/ssax#ssax:read-markup-token _port215225_)
                            '#f)
                        'END
                        _start-tag-head215224_
                        (lambda (_token215277_
                                 _exp-kind215279_
                                 _exp-head215281_)
                          (std/xml/ssax#parser-error
                           _port215225_
                           '"[elementvalid] broken for "
                           _token215277_
                           '" while expecting "
                           _exp-kind215279_
                           _exp-head215281_)))
                       ((lambda (_elem-gi215284_
                                 _attributes215285_
                                 _namespaces215286_
                                 _parent-seed215287_
                                 _seed215288_)
                          (let ((_seed215293_
                                 (std/xml/ssax#ssax:reverse-collect-str-drop-ws
                                  _seed215288_))
                                (_attrs215294_
                                 (std/xml/ssax#attlist-fold
                                  (lambda (_attr215290_ _accum215291_)
                                    (cons (list (if (symbol? (car _attr215290_))
                                                    (car _attr215290_)
                                                    (_RES-NAME->SXML213158_
                                                     (car _attr215290_)))
                                                (cdr _attr215290_))
                                          _accum215291_))
                                  '()
                                  _attributes215285_)))
                            (cons (cons (if (symbol? _elem-gi215284_)
                                            _elem-gi215284_
                                            (_RES-NAME->SXML213158_
                                             _elem-gi215284_))
                                        (if (null? _attrs215294_)
                                            _seed215293_
                                            (cons (cons '@ _attrs215294_)
                                                  _seed215293_)))
                                  _parent-seed215287_)))
                        _elem-gi215232_
                        _attributes215234_
                        _namespaces215236_
                        _parent-seed215229_
                        _seed215251_))
                     (let ((_preserve-ws?215302_
                            (let ((_$e215296_
                                   (assoc _xml-space-gi215218_
                                          _attributes215234_)))
                              (if _$e215296_
                                  ((lambda (_name-value215299_)
                                     (equal? '"preserve"
                                             (cdr _name-value215299_)))
                                   _$e215296_)
                                  _preserve-ws?215228_))))
                       (let _loop215304_ ((_port215307_ _port215225_)
                                          (_entities215308_ _entities215226_)
                                          (_expect-eof?215309_ '#f)
                                          (_seed215311_ _seed215251_))
                         (let ((_g301384_
                                (std/xml/ssax#ssax:read-char-data
                                 _port215307_
                                 _expect-eof?215309_
                                 (lambda (_string1215313_
                                          _string2215315_
                                          _seed215317_)
                                   (if (std/xml/ssax#string-null?
                                        _string2215315_)
                                       (cons _string1215313_ _seed215317_)
                                       (cons _string2215315_
                                             (cons _string1215313_
                                                   _seed215317_))))
                                 _seed215311_)))
                           (begin
                             (let ((_g301385_
                                    (let ()
                                      (declare (not safe))
                                      (if (##values? _g301384_)
                                          (##vector-length _g301384_)
                                          1))))
                               (if (not (let ()
                                          (declare (not safe))
                                          (##fx= _g301385_ 2)))
                                   (error "Context expects 2 values"
                                          _g301385_)))
                             (let ((_seed215320_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g301384_ 0)))
                                   (_term-token215321_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g301384_ 1))))
                               (let ()
                                 (if (eof-object? _term-token215321_)
                                     _seed215320_
                                     (let ((_$e215325_
                                            (car _term-token215321_)))
                                       (if (eq? 'END _$e215325_)
                                           (begin
                                             (std/xml/ssax#ssax:assert-token
                                              _term-token215321_
                                              'END
                                              _start-tag-head215224_
                                              (lambda (_token215328_
                                                       _exp-kind215329_
                                                       _exp-head215330_)
                                                (std/xml/ssax#parser-error
                                                 _port215307_
                                                 '"[GIMatch] broken for "
                                                 _term-token215321_
                                                 '" while expecting "
                                                 _exp-kind215329_
                                                 _exp-head215330_)))
                                             ((lambda (_elem-gi215332_
                                                       _attributes215333_
                                                       _namespaces215334_
                                                       _parent-seed215335_
                                                       _seed215336_)
                                                (let ((_seed215341_
                                                       (std/xml/ssax#ssax:reverse-collect-str-drop-ws
                                                        _seed215336_))
                                                      (_attrs215342_
                                                       (std/xml/ssax#attlist-fold
                                                        (lambda (_attr215338_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _accum215339_)
                  (cons (list (if (symbol? (car _attr215338_))
                                  (car _attr215338_)
                                  (_RES-NAME->SXML213158_ (car _attr215338_)))
                              (cdr _attr215338_))
                        _accum215339_))
                '()
                _attributes215333_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (cons (cons (if (symbol? _elem-gi215332_)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _elem-gi215332_
                          (_RES-NAME->SXML213158_ _elem-gi215332_))
                      (if (null? _attrs215342_)
                          _seed215341_
                          (cons (cons '@ _attrs215342_) _seed215341_)))
                _parent-seed215335_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              _elem-gi215232_
                                              _attributes215234_
                                              _namespaces215236_
                                              _parent-seed215229_
                                              _seed215320_))
                                           (if (eq? 'PI _$e215325_)
                                               (let ((_seed216259_
                                                      ((lambda (_port216245_
                                                                _target216246_
                                                                _seed216247_)
                                                         (let ((_$e216249_
                                                                _target216246_))
                                                           ((lambda (_port216252_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             _pi-tag216254_
                             _seed216256_)
                      (cons (list '*PI*
                                  _pi-tag216254_
                                  (std/xml/ssax#ssax:read-pi-body-as-string
                                   _port216252_))
                            _seed216256_))
                    _port216245_
                    _target216246_
                    _seed216247_)))
               _port215307_
               (cdr _term-token215321_)
               _seed215320_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (_loop215304_
                                                  _port215307_
                                                  _entities215308_
                                                  _expect-eof?215309_
                                                  _seed216259_))
                                               (if (eq? 'ENTITY-REF _$e215325_)
                                                   (let ((_seed216269_
                                                          (std/xml/ssax#ssax:handle-parsed-entity
                                                           _port215307_
                                                           (cdr _term-token215321_)
                                                           _entities215308_
                                                           (lambda (_port216261_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _entities216262_
                            _seed216263_)
                     (_loop215304_
                      _port216261_
                      _entities216262_
                      '#t
                      _seed216263_))
                   (lambda (_string1216265_ _string2216266_ _seed216267_)
                     (if (std/xml/ssax#string-null? _string2216266_)
                         (cons _string1216265_ _seed216267_)
                         (cons _string2216266_
                               (cons _string1216265_ _seed216267_))))
                   _seed215320_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop215304_
                                                      _port215307_
                                                      _entities215308_
                                                      _expect-eof?215309_
                                                      _seed216269_))
                                                   (if (eq? 'START _$e215325_)
                                                       (begin
                                                         (if (eq? _expected-content215237_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          'PCDATA)
                     (std/xml/ssax#parser-error
                      _port215307_
                      '"[elementvalid] broken for "
                      _elem-gi215232_
                      '" with char content only; unexpected token "
                      _term-token215321_)
                     '#!void)
                 (let ((_seed216271_
                        (_handle-start-tag215221_
                         (cdr _term-token215321_)
                         _port215307_
                         _entities215308_
                         _namespaces215236_
                         _preserve-ws?215302_
                         _seed215320_)))
                   (_loop215304_
                    _port215307_
                    _entities215308_
                    _expect-eof?215309_
                    _seed216271_)))
               (std/xml/ssax#parser-error
                _port215307_
                '"XML [43] broken for "
                _term-token215321_)))))))))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                             (_scan-for-significant-prolog-token-1215196_
                              _port215189_
                              _seed215191_)))
                         _port213154_
                         '()))))
          (cons '*TOP*
                (if (null? _namespace-prefix-assig213155_)
                    _result218122_
                    (cons (list '@
                                (cons '*NAMESPACES*
                                      (map (lambda (_ns218124_)
                                             (list (car _ns218124_)
                                                   (cdr _ns218124_)))
                                           _namespace-prefix-assig213155_)))
                          _result218122_)))))))
  (define std/xml/ssax#SSAX:XML->SXML std/xml/ssax#ssax:xml->sxml))
