(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor/rpc/server#errorf
    (lambda (_fmt258041_ . _args258042_)
      (std/logger#log-message 'rpc '0 _fmt258041_ _args258042_)))
  (define std/actor/rpc/server#warnf
    (lambda (_fmt258038_ . _args258039_)
      (std/logger#log-message 'rpc '1 _fmt258038_ _args258039_)))
  (define std/actor/rpc/server#infof
    (lambda (_fmt258035_ . _args258036_)
      (std/logger#log-message 'rpc '2 _fmt258035_ _args258036_)))
  (define std/actor/rpc/server#debugf
    (lambda (_fmt258032_ . _args258033_)
      (std/logger#log-message 'rpc '3 _fmt258032_ _args258033_)))
  (define std/actor/rpc/server#verbosef
    (lambda (_fmt258027_ . _args258029_)
      (std/logger#log-message 'rpc '4 _fmt258027_ _args258029_)))
  (define std/actor/rpc/server#current-rpc-server (make-parameter '#f))
  (define std/actor/rpc/server#start-rpc-server!__%
    (lambda (_g311072_ _proto258004258007_ . _addresses258009_)
      (let ((_proto258011_
             (if (eq? _proto258004258007_ absent-value)
                 (std/actor/rpc/proto/null#rpc-null-proto)
                 _proto258004258007_)))
        (std/logger#start-logger!__0)
        (gerbil/gambit/threads#spawn/group
         'rpc-server
         std/actor/rpc/server#rpc-server
         _proto258011_
         _addresses258009_))))
  (define std/actor/rpc/server#start-rpc-server!__@
    (lambda (_keys258003258016_ . _args258018_)
      (apply std/actor/rpc/server#start-rpc-server!__%
             _keys258003258016_
             (table-ref _keys258003258016_ 'proto: absent-value)
             _args258018_)))
  (define std/actor/rpc/server#start-rpc-server!
    (lambda _args258005258024_
      (apply keyword-dispatch
             '#(proto:)
             std/actor/rpc/server#start-rpc-server!__@
             _args258005258024_)))
  (define std/actor/rpc/server#stop-rpc-server!
    (lambda (_rpcd257996_)
      (let ((_tgroup257998_ (thread-thread-group _rpcd257996_)))
        (with-unwind-protect
         (lambda ()
           (std/actor/message#send-message__0
            _rpcd257996_
            (let ((__tmp311073
                   (let ()
                     (declare (not safe))
                     (##structure std/actor/rpc/base#rpc.shutdown::t))))
              (declare (not safe))
              (##structure std/actor/proto#!event::t __tmp311073)))
           (thread-join! _rpcd257996_))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup257998_))))))
  (define std/actor/rpc/server#rpc-connect__%
    (lambda (_rpcd257967_ _id257968_ _address257969_ _proto257970_)
      (let ((_$e257972_
             (std/actor/rpc/server#rpc-canonical-address _address257969_)))
        (if _$e257972_
            ((lambda (_address257975_)
               (let ((_token257977_
                      (let ()
                        (declare (not safe))
                        (##structure std/actor/proto#!token::t)))
                     (_dest257979_ _rpcd257967_))
                 (std/actor/message#send-message__%
                  _dest257979_
                  (let ((__tmp311074
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/actor/rpc/base#rpc.connect::t
                            _id257968_
                            _address257975_
                            _proto257970_))))
                    (declare (not safe))
                    (##structure
                     std/actor/proto#!call::t
                     __tmp311074
                     _token257977_))
                  '#f
                  '#t)
                 (std/actor/proto#!!call-recv _token257977_ _dest257979_)))
             _$e257972_)
            (error '"Bad rpc address" _address257969_)))))
  (define std/actor/rpc/server#rpc-connect__0
    (lambda (_rpcd257985_ _id257986_ _address257987_)
      (let ((_proto257989_ '#f))
        (std/actor/rpc/server#rpc-connect__%
         _rpcd257985_
         _id257986_
         _address257987_
         _proto257989_))))
  (define std/actor/rpc/server#rpc-connect
    (lambda _g311076_
      (let ((_g311075_ (let () (declare (not safe)) (##length _g311076_))))
        (cond ((let () (declare (not safe)) (##fx= _g311075_ 3))
               (apply std/actor/rpc/server#rpc-connect__0 _g311076_))
              ((let () (declare (not safe)) (##fx= _g311075_ 4))
               (apply std/actor/rpc/server#rpc-connect__% _g311076_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/server#rpc-connect
                _g311076_))))))
  (define std/actor/rpc/server#rpc-register__%
    (lambda (_rpcd257945_ _id257946_ _proto257947_)
      (let ((_token257949_
             (let ()
               (declare (not safe))
               (##structure std/actor/proto#!token::t)))
            (_dest257951_ _rpcd257945_))
        (std/actor/message#send-message__%
         _dest257951_
         (let ((__tmp311077
                (let ()
                  (declare (not safe))
                  (##structure
                   std/actor/rpc/base#rpc.register::t
                   _id257946_
                   _proto257947_))))
           (declare (not safe))
           (##structure std/actor/proto#!call::t __tmp311077 _token257949_))
         '#f
         '#t)
        (std/actor/proto#!!call-recv _token257949_ _dest257951_))))
  (define std/actor/rpc/server#rpc-register__0
    (lambda (_rpcd257957_ _id257958_)
      (let ((_proto257960_ '#f))
        (std/actor/rpc/server#rpc-register__%
         _rpcd257957_
         _id257958_
         _proto257960_))))
  (define std/actor/rpc/server#rpc-register
    (lambda _g311079_
      (let ((_g311078_ (let () (declare (not safe)) (##length _g311079_))))
        (cond ((let () (declare (not safe)) (##fx= _g311078_ 2))
               (apply std/actor/rpc/server#rpc-register__0 _g311079_))
              ((let () (declare (not safe)) (##fx= _g311078_ 3))
               (apply std/actor/rpc/server#rpc-register__% _g311079_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/server#rpc-register
                _g311079_))))))
  (define std/actor/rpc/server#rpc-unregister
    (lambda (_rpcd257936_ _id257937_)
      (let ((_token257939_
             (let ()
               (declare (not safe))
               (##structure std/actor/proto#!token::t)))
            (_dest257941_ _rpcd257936_))
        (std/actor/message#send-message__%
         _dest257941_
         (let ((__tmp311080
                (let ()
                  (declare (not safe))
                  (##structure
                   std/actor/rpc/base#rpc.unregister::t
                   _id257937_))))
           (declare (not safe))
           (##structure std/actor/proto#!call::t __tmp311080 _token257939_))
         '#f
         '#t)
        (std/actor/proto#!!call-recv _token257939_ _dest257941_))))
  (define std/actor/rpc/server#rpc-canonical-address
    (lambda (_address257931_)
      (if (std/net/address#resolved-address? _address257931_)
          _address257931_
          (if (or (std/net/address#inet-address? _address257931_)
                  (std/net/address#inet-address-string? _address257931_))
              (std/net/address#resolve-address _address257931_)
              (if (string? _address257931_) _address257931_ '#f)))))
  (define std/actor/rpc/server#rpc-server
    (lambda (_proto257914_ _addresses257915_)
      (let* ((_sas257917_ (map std/os/socket#socket-address _addresses257915_))
             (_g311081_
              (for-each
               std/actor/rpc/server#rpc-unlink-unix-socket
               _sas257917_))
             (_socks257920_
              (map std/net/socket/api#ssocket-listen _sas257917_)))
        (call-with-parameters
         (lambda ()
           (with-exception-catcher
            (lambda (_g257923257925_)
              (if '#t
                  (let ((_e257928_ _g257923257925_))
                    (if (eq? _e257928_ 'shutdown)
                        '#!void
                        (begin
                          (std/actor/rpc/server#errorf
                           '"unhandled exception: ~a"
                           _e257928_)
                          (raise _e257928_))))
                  (raise _g257923257925_)))
            (lambda ()
              (std/actor/rpc/server#rpc-server-loop
               _socks257920_
               _sas257917_
               _proto257914_))))
         std/actor/rpc/server#current-rpc-server
         (current-thread)))))
  (define std/actor/rpc/server#rpc-unlink-unix-socket
    (lambda (_sa257911_)
      (if (eq? (std/os/_socket#sockaddr_family _sa257911_)
               std/os/_socket#AF_UNIX)
          (with-exception-catcher
           void
           (lambda ()
             (delete-file (std/os/socket#socket-address->string _sa257911_))))
          '#!void)))
  (define std/actor/rpc/server#rpc-server-loop
    (lambda (_socks257208_ _sas257209_ _proto257210_)
      (letrec* ((_connect-e257212_
                 (##structure-ref
                  _proto257210_
                  '1
                  std/actor/rpc/base#!rpc-protocol::t
                  '#f))
                (_accept-e257213_
                 (##structure-ref
                  _proto257210_
                  '2
                  std/actor/rpc/base#!rpc-protocol::t
                  '#f))
                (_actors257214_ (std/actor/rpc/base#make-actor-table))
                (_actor-threads257215_ (make-table 'test: eq?))
                (_conns257216_ (make-table))
                (_threads257217_ (make-table 'test: eq?))
                (_monitors257218_ (make-table 'test: eq?))
                (_acceptors257219_
                 (map (lambda (_sock257908_ _sa257909_)
                        (gerbil/gambit/threads#spawn/name
                         'rpc-server-accept
                         std/actor/rpc/server#rpc-server-accept
                         (current-thread)
                         _sock257908_
                         (std/os/_socket#sockaddr_family _sa257909_)))
                      _socks257208_
                      _sas257209_))
                (_server-connection257220_ '0)
                (_accept-connection257221_
                 (lambda (_cli257898_ _clisa257899_)
                   (let* ((_cliaddr257901_
                           (std/os/socket#socket-address->address
                            _clisa257899_))
                          (_address257903_
                           (list _cliaddr257901_ _server-connection257220_))
                          (_thr257905_
                           (gerbil/gambit/threads#spawn/name
                            'rpc-connection
                            std/actor/rpc/connection#rpc-server-connection
                            (current-thread)
                            _actors257214_
                            _cli257898_
                            _clisa257899_
                            _address257903_
                            _accept-e257213_)))
                     (set! _server-connection257220_
                           (+ _server-connection257220_ '1))
                     (table-set! _conns257216_ _address257903_ _thr257905_)
                     (table-set! _threads257217_ _thr257905_ _address257903_)
                     (std/actor/rpc/base#rpc-monitor__0 _thr257905_))))
                (_open-connection257222_
                 (lambda (_address257886_)
                   (let ((_$e257888_
                          (table-ref _conns257216_ _address257886_ '#f)))
                     (if _$e257888_
                         (values _$e257888_)
                         (if (list? _address257886_)
                             '#f
                             (let ((_address257891_
                                    (std/actor/rpc/server#rpc-canonical-address
                                     _address257886_)))
                               (if (not _address257891_)
                                   '#f
                                   (let ((_$e257893_
                                          (table-ref
                                           _conns257216_
                                           _address257891_
                                           '#f)))
                                     (if _$e257893_
                                         (values _$e257893_)
                                         (let ((_thr257896_
                                                (gerbil/gambit/threads#spawn/name
                                                 'rpc-connection
                                                 std/actor/rpc/connection#rpc-client-connection
                                                 (current-thread)
                                                 _actors257214_
                                                 _address257891_
                                                 _connect-e257212_)))
                                           (table-set!
                                            _conns257216_
                                            _address257891_
                                            _thr257896_)
                                           (table-set!
                                            _threads257217_
                                            _thr257896_
                                            _address257891_)
                                           (std/actor/rpc/base#rpc-monitor__0
                                            _thr257896_)
                                           _thr257896_))))))))))
                (_handle-protocol-action257223_
                 (lambda (_msg257477_)
                   (let* ((_msg257478257487_ _msg257477_)
                          (_E257480257491_
                           (lambda ()
                             (error '"No clause matching" _msg257478257487_)))
                          (_K257481257863_
                           (lambda (_opt257494_
                                    _dest257495_
                                    _src257496_
                                    _content257497_)
                             (let* ((_content257498257548_ _content257497_)
                                    (_else257509257556_
                                     (lambda ()
                                       (std/actor/rpc/server#warnf
                                        '"Unexpected message ~a"
                                        _msg257477_))))
                               (let ((_K257543257847_
                                      (lambda (_cliaddr257844_ _cli257845_)
                                        (_accept-connection257221_
                                         _cli257845_
                                         _cliaddr257844_)))
                                     (_K257541257835_
                                      (lambda ()
                                        (let ((_$e257830_
                                               (table-ref
                                                _threads257217_
                                                _src257496_
                                                '#f)))
                                          (if _$e257830_
                                              ((lambda (_address257833_)
                                                 (std/actor/message#send-message__0
                                                  _src257496_
                                                  (let ((__tmp311082
                                                         (let ()
                                                           (declare (not safe))
                                                           (##structure
                                                            std/actor/rpc/base#rpc.connection-close::t))))
                                                    (declare (not safe))
                                                    (##structure
                                                     std/actor/proto#!event::t
                                                     __tmp311082)))
                                                 (_remove-thread!257225_
                                                  _src257496_))
                                               _$e257830_)
                                              (std/actor/rpc/server#warnf
                                               '"Unexpected protocol mesage ~a"
                                               _msg257477_)))))
                                     (_K257535257799_
                                      (lambda (_k257784_
                                               _proto257785_
                                               _address257786_
                                               _id257787_)
                                        (let* ((_uuid257789_
                                                (std/misc/uuid#UUID
                                                 _id257787_))
                                               (_proto257794_
                                                (let ((_$e257791_
                                                       _proto257785_))
                                                  (if _$e257791_
                                                      _$e257791_
                                                      (std/actor/rpc/base#lookup-protocol
                                                       _uuid257789_)))))
                                          (if (let ()
                                                (declare (not safe))
                                                (##structure-direct-instance-of?
                                                 _proto257794_
                                                 'std/actor/proto#!protocol::t))
                                              (let ((_handler257797_
                                                     (_open-connection257222_
                                                      _address257786_)))
                                                (if _handler257797_
                                                    (std/actor/message#send-message__%
                                                     _src257496_
                                                     (let ((__tmp311083
                                                            (let ((__obj311071
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (make-object std/actor/proto#remote::t '4)))
                      (std/actor/proto#remote:::init!
                       __obj311071
                       _handler257797_
                       _id257787_
                       _address257786_
                       _proto257794_)
                      __obj311071)))
               (declare (not safe))
               (##structure std/actor/proto#!value::t __tmp311083 _k257784_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     '#f
                                                     '#f)
                                                    (std/actor/message#send-message__%
                                                     _src257496_
                                                     (let ((__tmp311084
                                                            (make-struct-instance
                                                             std/actor/proto#rpc-error::t
                                                             'rpc-server
                                                             '"invalid address")))
                                                       (declare (not safe))
                                                       (##structure
                                                        std/actor/proto#!error::t
                                                        __tmp311084
                                                        _k257784_))
                                                     '#f
                                                     '#f)))
                                              (std/actor/message#send-message__%
                                               _src257496_
                                               (let ()
                                                 (declare (not safe))
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"bad protocol"
                                                  _k257784_))
                                               '#f
                                               '#f)))))
                                     (_K257530257759_
                                      (lambda (_k257742_
                                               _proto257743_
                                               _id257744_)
                                        (let ((_uuid257746_
                                               (std/misc/uuid#UUID
                                                _id257744_)))
                                          (if (std/misc/sync#sync-hash-key?
                                               _actors257214_
                                               _uuid257746_)
                                              (std/actor/message#send-message__%
                                               _src257496_
                                               (let ()
                                                 (declare (not safe))
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"duplicate registration"
                                                  _k257742_))
                                               '#f
                                               '#f)
                                              (let ((_proto257751_
                                                     (let ((_$e257748_
                                                            _proto257743_))
                                                       (if _$e257748_
                                                           _$e257748_
                                                           (std/actor/rpc/base#lookup-protocol
                                                            _uuid257746_)))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##structure-direct-instance-of?
                                                       _proto257751_
                                                       'std/actor/proto#!protocol::t))
                                                    (let ((_thread257753_
                                                           (_actor-thread-e257224_
                                                            _src257496_)))
                                                      (std/actor/rpc/base#actor-table-put!
                                                       _actors257214_
                                                       _uuid257746_
                                                       _src257496_
                                                       _proto257751_)
                                                      (hash-update!
                                                       _actor-threads257215_
                                                       _thread257753_
                                                       (lambda (_g257754257756_)
                                                         (cons _uuid257746_
                                                               _g257754257756_))
                                                       '())
                                                      (std/actor/rpc/base#rpc-monitor__0
                                                       _thread257753_)
                                                      (std/actor/message#send-message__%
                                                       _src257496_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##structure
                                                          std/actor/proto#!value::t
                                                          _uuid257746_
                                                          _k257742_))
                                                       '#f
                                                       '#f))
                                                    (std/actor/message#send-message__%
                                                     _src257496_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##structure
                                                        std/actor/proto#!error::t
                                                        '"bad protocol"
                                                        _k257742_))
                                                     '#f
                                                     '#f)))))))
                                     (_K257526257722_
                                      (lambda (_k257708_ _id257709_)
                                        (let* ((_uuid257711_
                                                (std/misc/uuid#UUID
                                                 _id257709_))
                                               (_thread257713_
                                                (_actor-thread-e257224_
                                                 _src257496_)))
                                          (std/misc/sync#sync-hash-remove!
                                           _actors257214_
                                           _uuid257711_)
                                          (let ((_actor-rest257720_
                                                 (remf (lambda (_g257715257717_)
                                                         (std/misc/uuid#uuid=?
                                                          _g257715257717_
                                                          _uuid257711_))
                                                       (table-ref
                                                        _actor-threads257215_
                                                        _thread257713_
                                                        '()))))
                                            (if (null? _actor-rest257720_)
                                                (table-set!
                                                 _actor-threads257215_
                                                 _thread257713_)
                                                (table-set!
                                                 _actor-threads257215_
                                                 _thread257713_
                                                 _actor-rest257720_)))
                                          (std/actor/message#send-message__%
                                           _src257496_
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/actor/proto#!value::t
                                              '#!void
                                              _k257708_))
                                           '#f
                                           '#f))))
                                     (_K257522257688_
                                      (lambda (_k257647_ _id257648_)
                                        (let* ((_uuid257650_
                                                (std/misc/uuid#UUID
                                                 _id257648_))
                                               (_actor257685_
                                                (let ((_$e257652_
                                                       (std/misc/sync#sync-hash-get
                                                        _actors257214_
                                                        _uuid257650_)))
                                                  (if _$e257652_
                                                      ((lambda (_e257654257656_)
                                                         (let* ((_g257658257665_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _e257654257656_)
                        (_E257660257669_
                         (lambda ()
                           (error '"No clause matching" _g257658257665_)))
                        (_K257661257674_
                         (lambda (_actor257672_) _actor257672_)))
                   (if (let ((__tmp311085
                              (if (let ()
                                    (declare (not safe))
                                    (##values? _g257658257665_))
                                  (let ()
                                    (declare (not safe))
                                    (##vector-length _g257658257665_))
                                  '1)))
                         (declare (not safe))
                         (##fx= __tmp311085 '2))
                       (let* ((_e257662257677_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g257658257665_ '0)))
                              (_actor257680_ _e257662257677_)
                              (_e257663257682_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g257658257665_ '1))))
                         (_K257661257674_ _actor257680_))
                       (_E257660257669_))))
               _$e257652_)
              '#f))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                          (std/actor/message#send-message__%
                                           _src257496_
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/actor/proto#!value::t
                                              _actor257685_
                                              _k257647_))
                                           '#f
                                           '#f))))
                                     (_K257519257632_
                                      (lambda (_k257628_)
                                        (let ((_addresses257630_
                                               (map std/os/socket#socket-address->address
                                                    _sas257209_)))
                                          (std/actor/message#send-message__%
                                           _src257496_
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/actor/proto#!value::t
                                              _addresses257630_
                                              _k257628_))
                                           '#f
                                           '#f))))
                                     (_K257516257613_
                                      (lambda (_remote257600_)
                                        (let* ((_address257602_
                                                (##direct-structure-ref
                                                 _remote257600_
                                                 '3
                                                 std/actor/proto#remote::t
                                                 '#f))
                                               (_$e257604_
                                                (table-ref
                                                 _conns257216_
                                                 _address257602_
                                                 '#f)))
                                          (if _$e257604_
                                              ((lambda (_thread257607_)
                                                 (hash-update!
                                                  _monitors257218_
                                                  _thread257607_
                                                  (lambda (_g257608257610_)
                                                    (cons (cons _src257496_
                                                                _remote257600_)
                                                          _g257608257610_))
                                                  '()))
                                               _$e257604_)
                                              (std/actor/message#send-message__0
                                               _src257496_
                                               (let ((__tmp311086
                                                      (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/actor/rpc/base#rpc.disconnect::t
                                                         _remote257600_))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/actor/proto#!event::t
                                                  __tmp311086)))))))
                                     (_K257513257585_
                                      (lambda (_remote257571_)
                                        (let* ((_address257573_
                                                (##direct-structure-ref
                                                 _remote257571_
                                                 '3
                                                 std/actor/proto#remote::t
                                                 '#f))
                                               (_thread257574257576_
                                                (table-ref
                                                 _conns257216_
                                                 _address257573_
                                                 '#f)))
                                          (if _thread257574257576_
                                              (let ((_thread257579_
                                                     _thread257574257576_))
                                                (hash-update!
                                                 _monitors257218_
                                                 _thread257579_
                                                 (lambda (_g257580257582_)
                                                   (remove1 (cons _src257496_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _remote257571_)
                    _g257580257582_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 '()))
                                              '#f))))
                                     (_K257511257561_
                                      (lambda () (raise 'shutdown))))
                                 (let ((_try-match257501257825_
                                        (lambda ()
                                          (if (let ()
                                                (declare (not safe))
                                                (##structure-direct-instance-of?
                                                 _content257498257548_
                                                 'std/actor/proto#!call::t))
                                              (let ((_e257536257802_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##vector-ref
                                                        _content257498257548_
                                                        '1))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##structure-direct-instance-of?
                                                       _e257536257802_
                                                       'std/actor#rpc.connect::t))
                                                    (let* ((_e257538257805_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _e257536257802_
                                                               '1)))
                                                           (_e257539257810_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _e257536257802_
                                                               '2)))
                                                           (_e257540257815_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _e257536257802_
                                                               '3)))
                                                           (_e257537257820_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _content257498257548_
                                                               '2))))
                                                      (let ((_id257808_
                                                             _e257538257805_)
                                                            (_address257813_
                                                             _e257539257810_)
                                                            (_proto257818_
                                                             _e257540257815_)
                                                            (_k257823_
                                                             _e257537257820_))
                                                        (_K257535257799_
                                                         _k257823_
                                                         _proto257818_
                                                         _address257813_
                                                         _id257808_)))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##structure-direct-instance-of?
                                                           _e257536257802_
                                                           'std/actor#rpc.register::t))
                                                        (let* ((_e257533257765_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##vector-ref _e257536257802_ '1)))
                       (_e257534257770_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _e257536257802_ '2)))
                       (_e257532257775_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _content257498257548_ '2))))
                  (let ((_id257768_ _e257533257765_)
                        (_proto257773_ _e257534257770_)
                        (_k257778_ _e257532257775_))
                    (_K257530257759_ _k257778_ _proto257773_ _id257768_)))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _e257536257802_
                       'std/actor#rpc.unregister::t))
                    (let* ((_e257529257728_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _e257536257802_ '1)))
                           (_e257528257733_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _content257498257548_ '2))))
                      (let ((_id257731_ _e257529257728_)
                            (_k257736_ _e257528257733_))
                        (_K257526257722_ _k257736_ _id257731_)))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _e257536257802_
                           'std/actor#rpc.resolve::t))
                        (let* ((_e257525257694_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _e257536257802_ '1)))
                               (_e257524257699_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _content257498257548_ '2))))
                          (let ((_id257697_ _e257525257694_)
                                (_k257702_ _e257524257699_))
                            (_K257522257688_ _k257702_ _id257697_)))
                        (if (let ()
                              (declare (not safe))
                              (##structure-direct-instance-of?
                               _e257536257802_
                               'std/actor#rpc.server-address::t))
                            (let* ((_e257521257638_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _content257498257548_ '2)))
                                   (_k257641_ _e257521257638_))
                              (_K257519257632_ _k257641_))
                            (_else257509257556_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_else257509257556_)))))
                                   (if (let ()
                                         (declare (not safe))
                                         (##structure-direct-instance-of?
                                          _content257498257548_
                                          'std/actor/proto#!event::t))
                                       (let ((_e257544257850_
                                              (let ()
                                                (declare (not safe))
                                                (##vector-ref
                                                 _content257498257548_
                                                 '1))))
                                         (if (let ()
                                               (declare (not safe))
                                               (##structure-direct-instance-of?
                                                _e257544257850_
                                                'std/actor#rpc.connection-accept::t))
                                             (let* ((_e257545257853_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##vector-ref
                                                        _e257544257850_
                                                        '1)))
                                                    (_e257546257858_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##vector-ref
                                                        _e257544257850_
                                                        '2))))
                                               (let ((_cli257856_
                                                      _e257545257853_)
                                                     (_cliaddr257861_
                                                      _e257546257858_))
                                                 (_K257543257847_
                                                  _cliaddr257861_
                                                  _cli257856_)))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##structure-direct-instance-of?
                                                    _e257544257850_
                                                    'std/actor#rpc.connection-shutdown::t))
                                                 (_K257541257835_)
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##structure-direct-instance-of?
                                                        _e257544257850_
                                                        'std/actor#rpc.monitor::t))
                                                     (let* ((_e257518257619_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##vector-ref _e257544257850_ '1)))
                    (_remote257622_ _e257518257619_))
               (_K257516257613_ _remote257622_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##structure-direct-instance-of?
                                                            _e257544257850_
                                                            'std/actor#rpc.unmonitor::t))
                                                         (let* ((_e257515257591_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ()
                           (declare (not safe))
                           (##vector-ref _e257544257850_ '1)))
                        (_remote257594_ _e257515257591_))
                   (_K257513257585_ _remote257594_))
                 (if (let ()
                       (declare (not safe))
                       (##structure-direct-instance-of?
                        _e257544257850_
                        'std/actor#rpc.shutdown::t))
                     (_K257511257561_)
                     (_else257509257556_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                       (_try-match257501257825_))))))))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _msg257478257487_
                            'std/actor/message#message::t))
                         (let* ((_e257482257866_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257478257487_ '1)))
                                (_content257869_ _e257482257866_)
                                (_e257483257871_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257478257487_ '2)))
                                (_src257874_ _e257483257871_)
                                (_e257484257876_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257478257487_ '3)))
                                (_dest257879_ _e257484257876_)
                                (_e257485257881_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257478257487_ '4)))
                                (_opt257884_ _e257485257881_))
                           (_K257481257863_
                            _opt257884_
                            _dest257879_
                            _src257874_
                            _content257869_))
                         (_E257480257491_)))))
                (_actor-thread-e257224_
                 (lambda (_actor257475_)
                   (if (thread? _actor257475_)
                       _actor257475_
                       (if (let ()
                             (declare (not safe))
                             (##structure-instance-of?
                              _actor257475_
                              'std/actor/message#proxy::t))
                           (##structure-ref
                            _actor257475_
                            '1
                            std/actor/message#proxy::t
                            '#f)
                           (error '"Bad actor" _actor257475_)))))
                (_remove-thread!257225_
                 (lambda (_thread257427_)
                   (let ((_$e257429_
                          (table-ref _threads257217_ _thread257427_ '#f)))
                     (if _$e257429_
                         ((lambda (_address257432_)
                            (for-each
                             (lambda (_e257433257435_)
                               (let* ((_g257437257444_ _e257433257435_)
                                      (_E257439257448_
                                       (lambda ()
                                         (error '"No clause matching"
                                                _g257437257444_)))
                                      (_K257440257454_
                                       (lambda (_remote257451_ _actor257452_)
                                         (std/actor/message#send-message__0
                                          _actor257452_
                                          (let ((__tmp311087
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/actor/rpc/base#rpc.disconnect::t
                                                    _remote257451_))))
                                            (declare (not safe))
                                            (##structure
                                             std/actor/proto#!event::t
                                             __tmp311087))))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _g257437257444_))
                                     (let ((_hd257441257457_
                                            (let ()
                                              (declare (not safe))
                                              (##car _g257437257444_)))
                                           (_tl257442257459_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _g257437257444_))))
                                       (let* ((_actor257462_ _hd257441257457_)
                                              (_remote257464_
                                               _tl257442257459_))
                                         (_K257440257454_
                                          _remote257464_
                                          _actor257462_)))
                                     (_E257439257448_))))
                             (table-ref _monitors257218_ _thread257427_ '()))
                            (table-set! _conns257216_ _address257432_)
                            (table-set! _threads257217_ _thread257427_)
                            (table-set! _monitors257218_ _thread257427_))
                          _$e257429_)
                         '#!void))
                   (let ((_$e257466_
                          (table-ref
                           _actor-threads257215_
                           _thread257427_
                           '#f)))
                     (if _$e257466_
                         ((lambda (_uuids257469_)
                            (for-each
                             (lambda (_g257470257472_)
                               (std/misc/sync#sync-hash-remove!
                                _actors257214_
                                _g257470257472_))
                             _uuids257469_)
                            (table-set! _actor-threads257215_ _thread257427_))
                          _$e257466_)
                         '#!void))))
                (_loop257226_
                 (lambda ()
                   (let _loop257288257290_ ()
                     (let ((_next257294_ (thread-mailbox-next)))
                       ((lambda (_msg257297_)
                          (let* ((_msg257299257317_ _msg257297_)
                                 (_else257305257325_
                                  (lambda () (_loop257288257290_))))
                            (let ((_K257315257422_
                                   (lambda (_msg257379_)
                                     (thread-mailbox-extract-and-rewind)
                                     (let ((_dest257381_
                                            (##direct-structure-ref
                                             _msg257379_
                                             '3
                                             std/actor/message#message::t
                                             '#f)))
                                       (if (eq? (current-thread) _dest257381_)
                                           (_handle-protocol-action257223_
                                            _msg257379_)
                                           (if (let ()
                                                 (declare (not safe))
                                                 (##structure-direct-instance-of?
                                                  _dest257381_
                                                  'std/actor/proto#remote::t))
                                               (let* ((_address257383_
                                                       (##direct-structure-ref
                                                        _dest257381_
                                                        '3
                                                        std/actor/proto#remote::t
                                                        '#f))
                                                      (_handler257385_
                                                       (_open-connection257222_
                                                        _address257383_)))
                                                 (if _handler257385_
                                                     (thread-send
                                                      _handler257385_
                                                      _msg257379_)
                                                     (std/actor/rpc/connection#rpc-send-error-response
                                                      _msg257379_
                                                      '"ivalid address")))
                                               (if (let ()
                                                     (declare (not safe))
                                                     (##structure-instance-of?
                                                      _dest257381_
                                                      'std/actor/proto#handle::t))
                                                   (let* ((_uuid257387_
                                                           (##structure-ref
                                                            _dest257381_
                                                            '2
                                                            std/actor/proto#handle::t
                                                            '#f))
                                                          (_$e257389_
                                                           (std/misc/sync#sync-hash-get
                                                            _actors257214_
                                                            _uuid257387_)))
                                                     (if _$e257389_
                                                         ((lambda (_e257391257393_)
                                                            (let* ((_g257395257402_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _e257391257393_)
                           (_E257397257406_
                            (lambda ()
                              (error '"No clause matching" _g257395257402_)))
                           (_K257398257411_
                            (lambda (_actor257409_)
                              (std/actor/message#send__0
                               _actor257409_
                               _msg257379_))))
                      (if (let ((__tmp311088
                                 (if (let ()
                                       (declare (not safe))
                                       (##values? _g257395257402_))
                                     (let ()
                                       (declare (not safe))
                                       (##vector-length _g257395257402_))
                                     '1)))
                            (declare (not safe))
                            (##fx= __tmp311088 '2))
                          (let* ((_e257399257414_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g257395257402_ '0)))
                                 (_actor257417_ _e257399257414_)
                                 (_e257400257419_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g257395257402_ '1))))
                            (_K257398257411_ _actor257417_))
                          (_E257397257406_))))
                  _$e257389_)
                 (std/actor/rpc/connection#rpc-send-error-response
                  _msg257379_
                  '"unknown actor")))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (begin
                                                     (std/actor/rpc/server#warnf
                                                      '"bad destination ~a"
                                                      _dest257381_)
                                                     (std/actor/rpc/connection#rpc-send-error-response
                                                      _msg257379_
                                                      '"bad destination"))))))))
                                  (_K257314257371_
                                   (lambda (_thread257369_)
                                     (thread-mailbox-extract-and-rewind)
                                     (if (memq _thread257369_
                                               _acceptors257219_)
                                         (std/actor/rpc/server#warnf
                                          '"acceptor thread has exited abnormally ~a"
                                          _thread257369_)
                                         (_remove-thread!257225_
                                          _thread257369_))))
                                  (_K257313257362_
                                   (lambda ()
                                     (thread-mailbox-extract-and-rewind)
                                     (_dump!257227_ (current-error-port))))
                                  (_K257308257342_
                                   (lambda (_port257340_)
                                     (thread-mailbox-extract-and-rewind)
                                     (_dump!257227_ _port257340_)))
                                  (_K257307257331_
                                   (lambda (_value257329_)
                                     (thread-mailbox-extract-and-rewind)
                                     (std/actor/rpc/server#warnf
                                      '"unexepected message ~a"
                                      _value257329_))))
                              (let* ((_try-match257303257357_
                                      (lambda ()
                                        (if (let ()
                                              (declare (not safe))
                                              (##pair? _msg257299257317_))
                                            (let ((_tl257310257347_
                                                   (let ()
                                                     (declare (not safe))
                                                     (##cdr _msg257299257317_)))
                                                  (_hd257309257345_
                                                   (let ()
                                                     (declare (not safe))
                                                     (##car _msg257299257317_))))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##eq? _hd257309257345_
                                                           'dump))
                                                  (if (let ()
                                                        (declare (not safe))
                                                        (##pair? _tl257310257347_))
                                                      (let ((_tl257312257352_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##cdr _tl257310257347_)))
                    (_hd257311257350_
                     (let () (declare (not safe)) (##car _tl257310257347_))))
                (if (let () (declare (not safe)) (##null? _tl257312257352_))
                    (let ((_port257355_ _hd257311257350_))
                      (_K257308257342_ _port257355_))
                    (let ((_value257334_ _msg257299257317_))
                      (_K257307257331_ _value257334_))))
              (let ((_value257334_ _msg257299257317_))
                (_K257307257331_ _value257334_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (let ((_value257334_
                                                         _msg257299257317_))
                                                    (_K257307257331_
                                                     _value257334_))))
                                            (let ((_value257334_
                                                   _msg257299257317_))
                                              (_K257307257331_
                                               _value257334_)))))
                                     (_try-match257302257365_
                                      (lambda ()
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _msg257299257317_ 'dump))
                                            (_K257313257362_)
                                            (_try-match257303257357_))))
                                     (_try-match257301257376_
                                      (lambda ()
                                        (if (thread? _msg257299257317_)
                                            (let ((_thread257374_
                                                   _msg257299257317_))
                                              (_K257314257371_ _thread257374_))
                                            (_try-match257302257365_)))))
                                (if (let ()
                                      (declare (not safe))
                                      (##structure-direct-instance-of?
                                       _msg257299257317_
                                       'std/actor/message#message::t))
                                    (let ((_msg257425_ _msg257299257317_))
                                      (_K257315257422_ _msg257425_))
                                    (_try-match257301257376_))))))
                        _next257294_)))
                   (_loop257226_)))
                (_dump!257227_
                 (lambda (_port257242_)
                   (call-with-parameters
                    (lambda ()
                      (displayln '"=== rpc-server ===")
                      (std/misc/sync#sync-hash-do
                       _actors257214_
                       (lambda (_ht257245_)
                         (displayln '"actors: " (table-length _ht257245_))
                         (table-for-each
                          (lambda (_uuid257247_ _actor-state257248_)
                            (let* ((_actor-state257249257256_
                                    _actor-state257248_)
                                   (_E257251257260_
                                    (lambda ()
                                      (error '"No clause matching"
                                             _actor-state257249257256_)))
                                   (_K257252257266_
                                    (lambda (_proto257263_ _actor257264_)
                                      (displayln
                                       (std/misc/uuid#uuid->string
                                        _uuid257247_)
                                       '" -> "
                                       (cons _actor257264_
                                             (cons _proto257263_ '()))))))
                              (if (let ((__tmp311089
                                         (if (let ()
                                               (declare (not safe))
                                               (##values?
                                                _actor-state257249257256_))
                                             (let ()
                                               (declare (not safe))
                                               (##vector-length
                                                _actor-state257249257256_))
                                             '1)))
                                    (declare (not safe))
                                    (##fx= __tmp311089 '2))
                                  (let* ((_e257253257269_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref
                                             _actor-state257249257256_
                                             '0)))
                                         (_actor257272_ _e257253257269_)
                                         (_e257254257274_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref
                                             _actor-state257249257256_
                                             '1)))
                                         (_proto257277_ _e257254257274_))
                                    (_K257252257266_
                                     _proto257277_
                                     _actor257272_))
                                  (_E257251257260_))))
                          _ht257245_)))
                      (displayln
                       '"actor-threads: "
                       (table-length _actor-threads257215_))
                      (table-for-each
                       (lambda (_thread257279_ _uuids257280_)
                         (displayln
                          _thread257279_
                          '" -> "
                          (map std/misc/uuid#uuid->string _uuids257280_)))
                       _actor-threads257215_)
                      (displayln '"connections: " (table-length _conns257216_))
                      (table-for-each
                       (lambda (_address257282_ _conn257283_)
                         (displayln _address257282_ '" -> " _conn257283_))
                       _conns257216_)
                      (displayln '"monitors: " (table-length _monitors257218_))
                      (table-for-each
                       (lambda (_conn257285_ _mons257286_)
                         (displayln _conn257285_ '" -> " _mons257286_))
                       _monitors257218_))
                    current-output-port
                    _port257242_))))
        (for-each std/actor/rpc/base#rpc-monitor _acceptors257219_)
        (with-exception-catcher
         (lambda (_g257228257230_)
           (if '#t
               (let ((_e257233_ _g257228257230_))
                 (for-each
                  (lambda (_g257234257236_)
                    (std/actor/message#send-message__0
                     _g257234257236_
                     (let ((__tmp311090
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/actor/rpc/base#rpc.shutdown::t))))
                       (declare (not safe))
                       (##structure std/actor/proto#!event::t __tmp311090))))
                  (hash-keys _actor-threads257215_))
                 (for-each std/net/socket/api#ssocket-close _socks257208_)
                 (for-each
                  (lambda (_thread257239_)
                    (thread-send _thread257239_ 'shutdown)
                    (std/actor/message#send-message__0
                     _thread257239_
                     (let ((__tmp311091
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/actor/rpc/base#rpc.connection-close::t))))
                       (declare (not safe))
                       (##structure std/actor/proto#!event::t __tmp311091))))
                  (hash-keys _threads257217_))
                 (for-each thread-join! (hash-keys _threads257217_))
                 (std/actor/rpc/connection#rpc-send-error-responses
                  '"server shutdown")
                 (raise _e257233_))
               (raise _g257228257230_)))
         (lambda () (_loop257226_))))))
  (define std/actor/rpc/server#rpc-server-accept
    (lambda (_rpc-server257181_ _sock257182_ _safamily257183_)
      (letrec ((_loop257185_
                (lambda ()
                  (let* ((_cliaddr257201_
                          (std/os/socket#make-socket-address _safamily257183_))
                         (_clisock257203_
                          (std/net/socket/api#ssocket-accept__1
                           _sock257182_
                           _cliaddr257201_)))
                    (std/actor/rpc/server#debugf
                     '"accepted connection from ~a"
                     (let ((_clistr257206_
                            (std/os/socket#socket-address->string
                             _cliaddr257201_)))
                       (if (string-empty? _clistr257206_)
                           '"?"
                           _clistr257206_)))
                    (std/actor/message#send-message__0
                     _rpc-server257181_
                     (let ((__tmp311092
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/actor/rpc/base#rpc.connection-accept::t
                               _clisock257203_
                               _cliaddr257201_))))
                       (declare (not safe))
                       (##structure std/actor/proto#!event::t __tmp311092)))
                    (_loop257185_)))))
        (let _again257187_ ()
          (with-exception-catcher
           (lambda (_g257189257191_)
             (if ((lambda (_$obj257194_) (os-exception? _$obj257194_))
                  _g257189257191_)
                 (let ((_e257197_ _g257189257191_))
                   (std/actor/rpc/server#errorf
                    '"error accepting connection: ~a"
                    _e257197_)
                   (_again257187_))
                 (raise _g257189257191_)))
           (lambda () (_loop257185_))))))))
