(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/bn#BN->bytes
    (lambda (_bn210202_)
      (let* ((_bytes210204_
              (make-u8vector (std/crypto/libcrypto#BN_num_bytes _bn210202_)))
             (_count210206_
              (std/crypto/libcrypto#BN_bn2bin _bn210202_ _bytes210204_)))
        (if (let ((__tmp301653 (u8vector-length _bytes210204_)))
              (declare (not safe))
              (##fx< _count210206_ __tmp301653))
            (u8vector-shrink! _bytes210204_ _count210206_)
            _bytes210204_))))
  (define std/crypto/bn#bytes->BN__%
    (lambda (_bytes210172_ _start210173_ _end210174_)
      (if (u8vector? _bytes210172_)
          (let* ((_end210179_
                  (let ((_$e210176_ _end210174_))
                    (if _$e210176_
                        _$e210176_
                        (u8vector-length _bytes210172_))))
                 (_$e210181_
                  (std/crypto/libcrypto#BN_bin2bn
                   _bytes210172_
                   _start210173_
                   _end210179_)))
            (if _$e210181_
                _$e210181_
                (error '"error decoding BN; NULL pointer" _bytes210172_)))
          (error '"bad argument; expected bytes" _bytes210172_))))
  (define std/crypto/bn#bytes->BN__0
    (lambda (_bytes210187_)
      (let* ((_start210189_ '0) (_end210191_ '#f))
        (std/crypto/bn#bytes->BN__% _bytes210187_ _start210189_ _end210191_))))
  (define std/crypto/bn#bytes->BN__1
    (lambda (_bytes210193_ _start210194_)
      (let ((_end210196_ '#f))
        (std/crypto/bn#bytes->BN__% _bytes210193_ _start210194_ _end210196_))))
  (define std/crypto/bn#bytes->BN
    (lambda _g301655_
      (let ((_g301654_ (let () (declare (not safe)) (##length _g301655_))))
        (cond ((let () (declare (not safe)) (##fx= _g301654_ 1))
               (apply std/crypto/bn#bytes->BN__0 _g301655_))
              ((let () (declare (not safe)) (##fx= _g301654_ 2))
               (apply std/crypto/bn#bytes->BN__1 _g301655_))
              ((let () (declare (not safe)) (##fx= _g301654_ 3))
               (apply std/crypto/bn#bytes->BN__% _g301655_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/bn#bytes->BN
                _g301655_)))))))
