(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/format#format
    (lambda (_fmt10646_ . _args10647_)
      (if (string? _fmt10646_)
          '#!void
          (error '"Expected format string" _fmt10646_))
      (let ((_out10649_ (open-output-string)))
        (std/format#dofmt _out10649_ _fmt10646_ _args10647_)
        (get-output-string _out10649_))))
  (define std/format#printf
    (lambda (_fmt10643_ . _args10644_)
      (apply std/format#fprintf (current-output-port) _fmt10643_ _args10644_)))
  (define std/format#fprintf
    (lambda (_port10639_ _fmt10640_ . _args10641_)
      (if (output-port? _port10639_)
          '#!void
          (error '"Expected output port" _port10639_))
      (if (string? _fmt10640_)
          '#!void
          (error '"Expected format string" _fmt10640_))
      (std/format#dofmt _port10639_ _fmt10640_ _args10641_)))
  (define std/format#eprintf
    (lambda (_fmt10636_ . _args10637_)
      (apply std/format#fprintf (current-error-port) _fmt10636_ _args10637_)
      (force-output (current-error-port))))
  (define std/format#dofmt
    (lambda (_port10611_ _fmt10612_ _args10613_)
      (letrec* ((_len10615_
                 (let () (declare (not safe)) (##string-length _fmt10612_))))
        (call-with-parameters
         (lambda ()
           (let _K10618_ ((_xi10620_ '0) (_rest10621_ _args10613_))
             (if (let () (declare (not safe)) (##fx< _xi10620_ _len10615_))
                 (let ((_next10623_
                        (let ()
                          (declare (not safe))
                          (##string-ref _fmt10612_ _xi10620_)))
                       (_xi10624_
                        (let () (declare (not safe)) (##fx+ _xi10620_ '1))))
                   (if (eq? _next10623_ '#\~)
                       (if (let ()
                             (declare (not safe))
                             (##fx< _xi10624_ _len10615_))
                           (let ((_next10626_
                                  (let ()
                                    (declare (not safe))
                                    (##string-ref _fmt10612_ _xi10624_)))
                                 (_xi10627_
                                  (let ()
                                    (declare (not safe))
                                    (##fx+ _xi10624_ '1))))
                             (let ((_$e10629_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next10626_
                                     '#f)))
                               (if _$e10629_
                                   ((lambda (_g1063110633_)
                                      (_g1063110633_
                                       _next10626_
                                       _K10618_
                                       _xi10627_
                                       _rest10621_))
                                    _$e10629_)
                                   (error '"Unknown format specifier"
                                          _fmt10612_
                                          _next10626_))))
                           (error '"Bad format string" _fmt10612_))
                       (begin
                         (write-char _next10623_)
                         (_K10618_ _xi10624_ _rest10621_))))
                 (if (null? _rest10621_)
                     '#!void
                     (error '"Too many arguments for format string"
                            _fmt10612_
                            _args10613_)))))
         current-output-port
         _port10611_
         std/format#current-format-string
         _fmt10612_
         std/format#current-format-args
         _args10613_))))
  (define std/format#current-format-string (make-parameter '#f))
  (define std/format#current-format-args (make-parameter '#f))
  (define std/format#dispatch-table (make-table 'test: eq?))
  (table-set!
   std/format#dispatch-table
   '#\a
   (lambda (_g291324_ _K10574_ _xi10575_ _rest10576_)
     (let* ((_rest1057710585_ _rest10576_)
            (_else1057910593_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1058110599_
             (lambda (_rest10596_ _arg10597_)
               (display _arg10597_)
               (_K10574_ _xi10575_ _rest10596_))))
       (if (let () (declare (not safe)) (##pair? _rest1057710585_))
           (let ((_hd1058210602_
                  (let () (declare (not safe)) (##car _rest1057710585_)))
                 (_tl1058310604_
                  (let () (declare (not safe)) (##cdr _rest1057710585_))))
             (let* ((_arg10607_ _hd1058210602_) (_rest10609_ _tl1058310604_))
               (_K1058110599_ _rest10609_ _arg10607_)))
           (_else1057910593_)))))
  (table-set!
   std/format#dispatch-table
   '#\A
   (lambda (_g291325_ _K10533_ _xi10535_ _rest10537_)
     (let* ((_rest1053910547_ _rest10537_)
            (_else1054110555_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1054310562_
             (lambda (_rest10558_ _arg10559_)
               (display _arg10559_)
               (_K10533_ _xi10535_ _rest10558_))))
       (if (let () (declare (not safe)) (##pair? _rest1053910547_))
           (let ((_hd1054410565_
                  (let () (declare (not safe)) (##car _rest1053910547_)))
                 (_tl1054510567_
                  (let () (declare (not safe)) (##cdr _rest1053910547_))))
             (let* ((_arg10570_ _hd1054410565_) (_rest10572_ _tl1054510567_))
               (_K1054310562_ _rest10572_ _arg10570_)))
           (_else1054110555_)))))
  (table-set!
   std/format#dispatch-table
   '#\s
   (lambda (_g291326_ _K10496_ _xi10497_ _rest10498_)
     (let* ((_rest1049910507_ _rest10498_)
            (_else1050110515_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1050310521_
             (lambda (_rest10518_ _arg10519_)
               (write _arg10519_)
               (_K10496_ _xi10497_ _rest10518_))))
       (if (let () (declare (not safe)) (##pair? _rest1049910507_))
           (let ((_hd1050410524_
                  (let () (declare (not safe)) (##car _rest1049910507_)))
                 (_tl1050510526_
                  (let () (declare (not safe)) (##cdr _rest1049910507_))))
             (let* ((_arg10529_ _hd1050410524_) (_rest10531_ _tl1050510526_))
               (_K1050310521_ _rest10531_ _arg10529_)))
           (_else1050110515_)))))
  (table-set!
   std/format#dispatch-table
   '#\S
   (lambda (_g291327_ _K10455_ _xi10457_ _rest10459_)
     (let* ((_rest1046110469_ _rest10459_)
            (_else1046310477_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1046510484_
             (lambda (_rest10480_ _arg10481_)
               (write _arg10481_)
               (_K10455_ _xi10457_ _rest10480_))))
       (if (let () (declare (not safe)) (##pair? _rest1046110469_))
           (let ((_hd1046610487_
                  (let () (declare (not safe)) (##car _rest1046110469_)))
                 (_tl1046710489_
                  (let () (declare (not safe)) (##cdr _rest1046110469_))))
             (let* ((_arg10492_ _hd1046610487_) (_rest10494_ _tl1046710489_))
               (_K1046510484_ _rest10494_ _arg10492_)))
           (_else1046310477_)))))
  (table-set!
   std/format#dispatch-table
   '#\c
   (lambda (_g291328_ _K10418_ _xi10419_ _rest10420_)
     (let* ((_rest1042110429_ _rest10420_)
            (_else1042310437_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1042510443_
             (lambda (_rest10440_ _arg10441_)
               (write-char _arg10441_)
               (_K10418_ _xi10419_ _rest10440_))))
       (if (let () (declare (not safe)) (##pair? _rest1042110429_))
           (let ((_hd1042610446_
                  (let () (declare (not safe)) (##car _rest1042110429_)))
                 (_tl1042710448_
                  (let () (declare (not safe)) (##cdr _rest1042110429_))))
             (let* ((_arg10451_ _hd1042610446_) (_rest10453_ _tl1042710448_))
               (_K1042510443_ _rest10453_ _arg10451_)))
           (_else1042310437_)))))
  (table-set!
   std/format#dispatch-table
   '#\C
   (lambda (_g291329_ _K10377_ _xi10379_ _rest10381_)
     (let* ((_rest1038310391_ _rest10381_)
            (_else1038510399_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1038710406_
             (lambda (_rest10402_ _arg10403_)
               (write-char _arg10403_)
               (_K10377_ _xi10379_ _rest10402_))))
       (if (let () (declare (not safe)) (##pair? _rest1038310391_))
           (let ((_hd1038810409_
                  (let () (declare (not safe)) (##car _rest1038310391_)))
                 (_tl1038910411_
                  (let () (declare (not safe)) (##cdr _rest1038310391_))))
             (let* ((_arg10414_ _hd1038810409_) (_rest10416_ _tl1038910411_))
               (_K1038710406_ _rest10416_ _arg10414_)))
           (_else1038510399_)))))
  (table-set!
   std/format#dispatch-table
   '#\u
   (lambda (_g291330_ _K10336_ _xi10337_ _rest10338_)
     (let* ((_rest1033910347_ _rest10338_)
            (_else1034110355_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1034310365_
             (lambda (_rest10358_ _arg10359_)
               ((lambda (_arg10361_)
                  (let ((_i10363_ (char->integer _arg10361_)))
                    (if (let () (declare (not safe)) (##fx< _i10363_ '15))
                        (display '"000")
                        (if (let () (declare (not safe)) (##fx< _i10363_ '255))
                            (display '"00")
                            (if (let ()
                                  (declare (not safe))
                                  (##fx< _i10363_ '4095))
                                (display '"0")
                                '#!void)))
                    (display (number->string _i10363_ '16))))
                _arg10359_)
               (_K10336_ _xi10337_ _rest10358_))))
       (if (let () (declare (not safe)) (##pair? _rest1033910347_))
           (let ((_hd1034410368_
                  (let () (declare (not safe)) (##car _rest1033910347_)))
                 (_tl1034510370_
                  (let () (declare (not safe)) (##cdr _rest1033910347_))))
             (let* ((_arg10373_ _hd1034410368_) (_rest10375_ _tl1034510370_))
               (_K1034310365_ _rest10375_ _arg10373_)))
           (_else1034110355_)))))
  (table-set!
   std/format#dispatch-table
   '#\U
   (lambda (_g291331_ _K10291_ _xi10293_ _rest10295_)
     (let* ((_rest1029710305_ _rest10295_)
            (_else1029910313_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1030110324_
             (lambda (_rest10316_ _arg10317_)
               ((lambda (_arg10320_)
                  (let ((_i10322_ (char->integer _arg10320_)))
                    (if (let () (declare (not safe)) (##fx< _i10322_ '15))
                        (display '"000")
                        (if (let () (declare (not safe)) (##fx< _i10322_ '255))
                            (display '"00")
                            (if (let ()
                                  (declare (not safe))
                                  (##fx< _i10322_ '4095))
                                (display '"0")
                                '#!void)))
                    (display (number->string _i10322_ '16))))
                _arg10317_)
               (_K10291_ _xi10293_ _rest10316_))))
       (if (let () (declare (not safe)) (##pair? _rest1029710305_))
           (let ((_hd1030210327_
                  (let () (declare (not safe)) (##car _rest1029710305_)))
                 (_tl1030310329_
                  (let () (declare (not safe)) (##cdr _rest1029710305_))))
             (let* ((_arg10332_ _hd1030210327_) (_rest10334_ _tl1030310329_))
               (_K1030110324_ _rest10334_ _arg10332_)))
           (_else1029910313_)))))
  (table-set!
   std/format#dispatch-table
   '#\b
   (lambda (_g291332_ _K10252_ _xi10253_ _rest10254_)
     (let* ((_rest1025510263_ _rest10254_)
            (_else1025710271_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1025910279_
             (lambda (_rest10274_ _arg10275_)
               ((lambda (_arg10277_) (display (number->string _arg10277_ '2)))
                _arg10275_)
               (_K10252_ _xi10253_ _rest10274_))))
       (if (let () (declare (not safe)) (##pair? _rest1025510263_))
           (let ((_hd1026010282_
                  (let () (declare (not safe)) (##car _rest1025510263_)))
                 (_tl1026110284_
                  (let () (declare (not safe)) (##cdr _rest1025510263_))))
             (let* ((_arg10287_ _hd1026010282_) (_rest10289_ _tl1026110284_))
               (_K1025910279_ _rest10289_ _arg10287_)))
           (_else1025710271_)))))
  (table-set!
   std/format#dispatch-table
   '#\B
   (lambda (_g291333_ _K10209_ _xi10211_ _rest10213_)
     (let* ((_rest1021510223_ _rest10213_)
            (_else1021710231_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1021910240_
             (lambda (_rest10234_ _arg10235_)
               ((lambda (_arg10238_) (display (number->string _arg10238_ '2)))
                _arg10235_)
               (_K10209_ _xi10211_ _rest10234_))))
       (if (let () (declare (not safe)) (##pair? _rest1021510223_))
           (let ((_hd1022010243_
                  (let () (declare (not safe)) (##car _rest1021510223_)))
                 (_tl1022110245_
                  (let () (declare (not safe)) (##cdr _rest1021510223_))))
             (let* ((_arg10248_ _hd1022010243_) (_rest10250_ _tl1022110245_))
               (_K1021910240_ _rest10250_ _arg10248_)))
           (_else1021710231_)))))
  (table-set!
   std/format#dispatch-table
   '#\o
   (lambda (_g291334_ _K10170_ _xi10171_ _rest10172_)
     (let* ((_rest1017310181_ _rest10172_)
            (_else1017510189_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1017710197_
             (lambda (_rest10192_ _arg10193_)
               ((lambda (_arg10195_) (display (number->string _arg10195_ '8)))
                _arg10193_)
               (_K10170_ _xi10171_ _rest10192_))))
       (if (let () (declare (not safe)) (##pair? _rest1017310181_))
           (let ((_hd1017810200_
                  (let () (declare (not safe)) (##car _rest1017310181_)))
                 (_tl1017910202_
                  (let () (declare (not safe)) (##cdr _rest1017310181_))))
             (let* ((_arg10205_ _hd1017810200_) (_rest10207_ _tl1017910202_))
               (_K1017710197_ _rest10207_ _arg10205_)))
           (_else1017510189_)))))
  (table-set!
   std/format#dispatch-table
   '#\O
   (lambda (_g291335_ _K10127_ _xi10129_ _rest10131_)
     (let* ((_rest1013310141_ _rest10131_)
            (_else1013510149_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1013710158_
             (lambda (_rest10152_ _arg10153_)
               ((lambda (_arg10156_) (display (number->string _arg10156_ '8)))
                _arg10153_)
               (_K10127_ _xi10129_ _rest10152_))))
       (if (let () (declare (not safe)) (##pair? _rest1013310141_))
           (let ((_hd1013810161_
                  (let () (declare (not safe)) (##car _rest1013310141_)))
                 (_tl1013910163_
                  (let () (declare (not safe)) (##cdr _rest1013310141_))))
             (let* ((_arg10166_ _hd1013810161_) (_rest10168_ _tl1013910163_))
               (_K1013710158_ _rest10168_ _arg10166_)))
           (_else1013510149_)))))
  (table-set!
   std/format#dispatch-table
   '#\d
   (lambda (_g291336_ _K10088_ _xi10089_ _rest10090_)
     (let* ((_rest1009110099_ _rest10090_)
            (_else1009310107_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1009510115_
             (lambda (_rest10110_ _arg10111_)
               ((lambda (_arg10113_) (display (number->string _arg10113_ '10)))
                _arg10111_)
               (_K10088_ _xi10089_ _rest10110_))))
       (if (let () (declare (not safe)) (##pair? _rest1009110099_))
           (let ((_hd1009610118_
                  (let () (declare (not safe)) (##car _rest1009110099_)))
                 (_tl1009710120_
                  (let () (declare (not safe)) (##cdr _rest1009110099_))))
             (let* ((_arg10123_ _hd1009610118_) (_rest10125_ _tl1009710120_))
               (_K1009510115_ _rest10125_ _arg10123_)))
           (_else1009310107_)))))
  (table-set!
   std/format#dispatch-table
   '#\D
   (lambda (_g291337_ _K10045_ _xi10047_ _rest10049_)
     (let* ((_rest1005110059_ _rest10049_)
            (_else1005310067_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1005510076_
             (lambda (_rest10070_ _arg10071_)
               ((lambda (_arg10074_) (display (number->string _arg10074_ '10)))
                _arg10071_)
               (_K10045_ _xi10047_ _rest10070_))))
       (if (let () (declare (not safe)) (##pair? _rest1005110059_))
           (let ((_hd1005610079_
                  (let () (declare (not safe)) (##car _rest1005110059_)))
                 (_tl1005710081_
                  (let () (declare (not safe)) (##cdr _rest1005110059_))))
             (let* ((_arg10084_ _hd1005610079_) (_rest10086_ _tl1005710081_))
               (_K1005510076_ _rest10086_ _arg10084_)))
           (_else1005310067_)))))
  (table-set!
   std/format#dispatch-table
   '#\x
   (lambda (_g291338_ _K10003_ _xi10004_ _rest10005_)
     (let* ((_rest1000610014_ _rest10005_)
            (_else1000810022_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K1001010033_
             (lambda (_rest10025_ _arg10026_)
               ((lambda (_arg10028_)
                  (let ((_str10030_ (number->string _arg10028_ '16))
                        (_nbytes10031_
                         (ceiling (/ (integer-length _arg10028_) '8))))
                    (if (zero? _nbytes10031_)
                        (display '"00")
                        (display (std/format#pad-string__%
                                  _str10030_
                                  (* '2 _nbytes10031_)
                                  '#\0)))))
                _arg10026_)
               (_K10003_ _xi10004_ _rest10025_))))
       (if (let () (declare (not safe)) (##pair? _rest1000610014_))
           (let ((_hd1001110036_
                  (let () (declare (not safe)) (##car _rest1000610014_)))
                 (_tl1001210038_
                  (let () (declare (not safe)) (##cdr _rest1000610014_))))
             (let* ((_arg10041_ _hd1001110036_) (_rest10043_ _tl1001210038_))
               (_K1001010033_ _rest10043_ _arg10041_)))
           (_else1000810022_)))))
  (table-set!
   std/format#dispatch-table
   '#\X
   (lambda (_g291339_ _K9957_ _xi9959_ _rest9961_)
     (let* ((_rest99639971_ _rest9961_)
            (_else99659979_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K99679991_
             (lambda (_rest9982_ _arg9983_)
               ((lambda (_arg9986_)
                  (let ((_str9988_ (number->string _arg9986_ '16))
                        (_nbytes9989_
                         (ceiling (/ (integer-length _arg9986_) '8))))
                    (if (zero? _nbytes9989_)
                        (display '"00")
                        (display (std/format#pad-string__%
                                  _str9988_
                                  (* '2 _nbytes9989_)
                                  '#\0)))))
                _arg9983_)
               (_K9957_ _xi9959_ _rest9982_))))
       (if (let () (declare (not safe)) (##pair? _rest99639971_))
           (let ((_hd99689994_
                  (let () (declare (not safe)) (##car _rest99639971_)))
                 (_tl99699996_
                  (let () (declare (not safe)) (##cdr _rest99639971_))))
             (let* ((_arg9999_ _hd99689994_) (_rest10001_ _tl99699996_))
               (_K99679991_ _rest10001_ _arg9999_)))
           (_else99659979_)))))
  (table-set!
   std/format#dispatch-table
   '#\y
   (lambda (_g291340_ _K9920_ _xi9921_ _rest9922_)
     (let* ((_rest99239931_ _rest9922_)
            (_else99259939_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K99279945_
             (lambda (_rest9942_ _arg9943_)
               (pretty-print _arg9943_)
               (_K9920_ _xi9921_ _rest9942_))))
       (if (let () (declare (not safe)) (##pair? _rest99239931_))
           (let ((_hd99289948_
                  (let () (declare (not safe)) (##car _rest99239931_)))
                 (_tl99299950_
                  (let () (declare (not safe)) (##cdr _rest99239931_))))
             (let* ((_arg9953_ _hd99289948_) (_rest9955_ _tl99299950_))
               (_K99279945_ _rest9955_ _arg9953_)))
           (_else99259939_)))))
  (table-set!
   std/format#dispatch-table
   '#\Y
   (lambda (_g291341_ _K9879_ _xi9881_ _rest9883_)
     (let* ((_rest98859893_ _rest9883_)
            (_else98879901_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K98899908_
             (lambda (_rest9904_ _arg9905_)
               (pretty-print _arg9905_)
               (_K9879_ _xi9881_ _rest9904_))))
       (if (let () (declare (not safe)) (##pair? _rest98859893_))
           (let ((_hd98909911_
                  (let () (declare (not safe)) (##car _rest98859893_)))
                 (_tl98919913_
                  (let () (declare (not safe)) (##cdr _rest98859893_))))
             (let* ((_arg9916_ _hd98909911_) (_rest9918_ _tl98919913_))
               (_K98899908_ _rest9918_ _arg9916_)))
           (_else98879901_)))))
  (table-set!
   std/format#dispatch-table
   '#\r
   (lambda (_g291342_ _K9842_ _xi9843_ _rest9844_)
     (let* ((_rest98459853_ _rest9844_)
            (_else98479861_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K98499867_
             (lambda (_rest9864_ _arg9865_)
               (std/misc/repr#print-representation__0 _arg9865_)
               (_K9842_ _xi9843_ _rest9864_))))
       (if (let () (declare (not safe)) (##pair? _rest98459853_))
           (let ((_hd98509870_
                  (let () (declare (not safe)) (##car _rest98459853_)))
                 (_tl98519872_
                  (let () (declare (not safe)) (##cdr _rest98459853_))))
             (let* ((_arg9875_ _hd98509870_) (_rest9877_ _tl98519872_))
               (_K98499867_ _rest9877_ _arg9875_)))
           (_else98479861_)))))
  (table-set!
   std/format#dispatch-table
   '#\R
   (lambda (_g291343_ _K9801_ _xi9803_ _rest9805_)
     (let* ((_rest98079815_ _rest9805_)
            (_else98099823_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K98119830_
             (lambda (_rest9826_ _arg9827_)
               (std/misc/repr#print-representation__0 _arg9827_)
               (_K9801_ _xi9803_ _rest9826_))))
       (if (let () (declare (not safe)) (##pair? _rest98079815_))
           (let ((_hd98129833_
                  (let () (declare (not safe)) (##car _rest98079815_)))
                 (_tl98139835_
                  (let () (declare (not safe)) (##cdr _rest98079815_))))
             (let* ((_arg9838_ _hd98129833_) (_rest9840_ _tl98139835_))
               (_K98119830_ _rest9840_ _arg9838_)))
           (_else98099823_)))))
  (table-set!
   std/format#dispatch-table
   '#\%
   (lambda (_g291344_ _K9797_ _xi9798_ _rest9799_)
     (newline)
     (_K9797_ _xi9798_ _rest9799_)))
  (table-set!
   std/format#dispatch-table
   '#\n
   (lambda (_g291345_ _K9790_ _xi9792_ _rest9794_)
     (newline)
     (_K9790_ _xi9792_ _rest9794_)))
  (table-set!
   std/format#dispatch-table
   '#\~
   (lambda (_g291346_ _K9783_ _xi9785_ _rest9787_)
     (write-char '#\~)
     (_K9783_ _xi9785_ _rest9787_)))
  (table-set!
   std/format#dispatch-table
   '#\t
   (lambda (_g291347_ _K9779_ _xi9780_ _rest9781_)
     (write-char '#\tab)
     (_K9779_ _xi9780_ _rest9781_)))
  (table-set!
   std/format#dispatch-table
   '#\T
   (lambda (_g291348_ _K9772_ _xi9774_ _rest9776_)
     (write-char '#\tab)
     (_K9772_ _xi9774_ _rest9776_)))
  (table-set!
   std/format#dispatch-table
   '#\_
   (lambda (_g291349_ _K9765_ _xi9767_ _rest9769_)
     (write-char '#\space)
     (_K9765_ _xi9767_ _rest9769_)))
  (table-set!
   std/format#dispatch-table
   '#\?
   (lambda (_g291350_ _K9718_ _xi9719_ _rest9720_)
     (let* ((_rest97219731_ _rest9720_)
            (_else97239739_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K97259746_
             (lambda (_rest9742_ _re-args9743_ _re-fmt9744_)
               (display (apply std/format#format _re-fmt9744_ _re-args9743_))
               (_K9718_ _xi9719_ _rest9742_))))
       (if (let () (declare (not safe)) (##pair? _rest97219731_))
           (let ((_hd97269749_
                  (let () (declare (not safe)) (##car _rest97219731_)))
                 (_tl97279751_
                  (let () (declare (not safe)) (##cdr _rest97219731_))))
             (let ((_re-fmt9754_ _hd97269749_))
               (if (let () (declare (not safe)) (##pair? _tl97279751_))
                   (let ((_hd97289756_
                          (let () (declare (not safe)) (##car _tl97279751_)))
                         (_tl97299758_
                          (let () (declare (not safe)) (##cdr _tl97279751_))))
                     (let* ((_re-args9761_ _hd97289756_)
                            (_rest9763_ _tl97299758_))
                       (_K97259746_ _rest9763_ _re-args9761_ _re-fmt9754_)))
                   (_else97239739_))))
           (_else97239739_)))))
  (table-set!
   std/format#dispatch-table
   '#\k
   (lambda (_g291351_ _K9671_ _xi9672_ _rest9673_)
     (let* ((_rest96749684_ _rest9673_)
            (_else96769692_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K96789699_
             (lambda (_rest9695_ _re-args9696_ _re-fmt9697_)
               (display (apply std/format#format _re-fmt9697_ _re-args9696_))
               (_K9671_ _xi9672_ _rest9695_))))
       (if (let () (declare (not safe)) (##pair? _rest96749684_))
           (let ((_hd96799702_
                  (let () (declare (not safe)) (##car _rest96749684_)))
                 (_tl96809704_
                  (let () (declare (not safe)) (##cdr _rest96749684_))))
             (let ((_re-fmt9707_ _hd96799702_))
               (if (let () (declare (not safe)) (##pair? _tl96809704_))
                   (let ((_hd96819709_
                          (let () (declare (not safe)) (##car _tl96809704_)))
                         (_tl96829711_
                          (let () (declare (not safe)) (##cdr _tl96809704_))))
                     (let* ((_re-args9714_ _hd96819709_)
                            (_rest9716_ _tl96829711_))
                       (_K96789699_ _rest9716_ _re-args9714_ _re-fmt9707_)))
                   (_else96769692_))))
           (_else96769692_)))))
  (table-set!
   std/format#dispatch-table
   '#\K
   (lambda (_g291352_ _K9624_ _xi9625_ _rest9626_)
     (let* ((_rest96279637_ _rest9626_)
            (_else96299645_
             (lambda ()
               (error '"Missing format argument"
                      (std/format#current-format-string)
                      (std/format#current-format-args))))
            (_K96319652_
             (lambda (_rest9648_ _re-args9649_ _re-fmt9650_)
               (display (apply std/format#format _re-fmt9650_ _re-args9649_))
               (_K9624_ _xi9625_ _rest9648_))))
       (if (let () (declare (not safe)) (##pair? _rest96279637_))
           (let ((_hd96329655_
                  (let () (declare (not safe)) (##car _rest96279637_)))
                 (_tl96339657_
                  (let () (declare (not safe)) (##cdr _rest96279637_))))
             (let ((_re-fmt9660_ _hd96329655_))
               (if (let () (declare (not safe)) (##pair? _tl96339657_))
                   (let ((_hd96349662_
                          (let () (declare (not safe)) (##car _tl96339657_)))
                         (_tl96359664_
                          (let () (declare (not safe)) (##cdr _tl96339657_))))
                     (let* ((_re-args9667_ _hd96349662_)
                            (_rest9669_ _tl96359664_))
                       (_K96319652_ _rest9669_ _re-args9667_ _re-fmt9660_)))
                   (_else96299645_))))
           (_else96299645_)))))
  (table-set!
   std/format#dispatch-table
   '#\f
   (lambda (_g291353_ _K9620_ _xi9621_ _rest9622_)
     (std/format#format-fixed-float '#f '#f _K9620_ _xi9621_ _rest9622_)))
  (table-set!
   std/format#dispatch-table
   '#\F
   (lambda (_g291354_ _K9616_ _xi9617_ _rest9618_)
     (std/format#format-fixed-float '#f '#f _K9616_ _xi9617_ _rest9618_)))
  (table-set!
   std/format#dispatch-table
   '#\0
   (lambda (_char9533_ _K9534_ _xi9535_ _rest9536_)
     (let* ((_str9538_ (std/format#current-format-string))
            (_len9540_
             (let () (declare (not safe)) (##string-length _str9538_))))
       (let _lp9589_ ((_xi9591_ _xi9535_) (_width9592_ (cons _char9533_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9591_ _len9540_))
             (let ((_next9594_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9538_ _xi9591_)))
                   (_xi9595_
                    (let () (declare (not safe)) (##fx+ _xi9591_ '1))))
               (let ((_$e9597_ _next9594_))
                 (if (or (eq? '#\f _$e9597_) (eq? '#\F _$e9597_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9592_))
                      '#f
                      _K9534_
                      _xi9595_
                      _rest9536_)
                     (if (eq? '#\, _$e9597_)
                         (let _lp29603_ ((_xi9605_ _xi9595_)
                                         (_digits9606_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9605_ _len9540_))
                               (let ((_next9608_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9538_ _xi9605_)))
                                     (_xi9609_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9605_ '1))))
                                 (if (char-numeric? _next9608_)
                                     (_lp29603_
                                      _xi9609_
                                      (cons _next9608_ _digits9606_))
                                     (if (and (memq _next9608_ '(#\f #\F))
                                              (not (null? _digits9606_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9592_))
                                          (std/format#chars->number
                                           (reverse _digits9606_))
                                          _K9534_
                                          _xi9609_
                                          _rest9536_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9538_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9538_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9594_)
                             (_lp9589_ _xi9595_ (cons _next9594_ _width9592_))
                             (let ((_$e9611_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9594_
                                     '#f)))
                               (if _$e9611_
                                   ((lambda (_f9614_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9592_))
                                       _f9614_
                                       _next9594_
                                       _xi9595_
                                       _rest9536_
                                       _K9534_))
                                    _$e9611_)
                                   (error '"Unknown format specifier"
                                          _str9538_
                                          _next9594_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9538_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\1
   (lambda (_char9450_ _K9451_ _xi9452_ _rest9453_)
     (let* ((_str9455_ (std/format#current-format-string))
            (_len9457_
             (let () (declare (not safe)) (##string-length _str9455_))))
       (let _lp9506_ ((_xi9508_ _xi9452_) (_width9509_ (cons _char9450_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9508_ _len9457_))
             (let ((_next9511_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9455_ _xi9508_)))
                   (_xi9512_
                    (let () (declare (not safe)) (##fx+ _xi9508_ '1))))
               (let ((_$e9514_ _next9511_))
                 (if (or (eq? '#\f _$e9514_) (eq? '#\F _$e9514_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9509_))
                      '#f
                      _K9451_
                      _xi9512_
                      _rest9453_)
                     (if (eq? '#\, _$e9514_)
                         (let _lp29520_ ((_xi9522_ _xi9512_)
                                         (_digits9523_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9522_ _len9457_))
                               (let ((_next9525_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9455_ _xi9522_)))
                                     (_xi9526_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9522_ '1))))
                                 (if (char-numeric? _next9525_)
                                     (_lp29520_
                                      _xi9526_
                                      (cons _next9525_ _digits9523_))
                                     (if (and (memq _next9525_ '(#\f #\F))
                                              (not (null? _digits9523_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9509_))
                                          (std/format#chars->number
                                           (reverse _digits9523_))
                                          _K9451_
                                          _xi9526_
                                          _rest9453_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9455_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9455_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9511_)
                             (_lp9506_ _xi9512_ (cons _next9511_ _width9509_))
                             (let ((_$e9528_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9511_
                                     '#f)))
                               (if _$e9528_
                                   ((lambda (_f9531_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9509_))
                                       _f9531_
                                       _next9511_
                                       _xi9512_
                                       _rest9453_
                                       _K9451_))
                                    _$e9528_)
                                   (error '"Unknown format specifier"
                                          _str9455_
                                          _next9511_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9455_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\2
   (lambda (_char9367_ _K9368_ _xi9369_ _rest9370_)
     (let* ((_str9372_ (std/format#current-format-string))
            (_len9374_
             (let () (declare (not safe)) (##string-length _str9372_))))
       (let _lp9423_ ((_xi9425_ _xi9369_) (_width9426_ (cons _char9367_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9425_ _len9374_))
             (let ((_next9428_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9372_ _xi9425_)))
                   (_xi9429_
                    (let () (declare (not safe)) (##fx+ _xi9425_ '1))))
               (let ((_$e9431_ _next9428_))
                 (if (or (eq? '#\f _$e9431_) (eq? '#\F _$e9431_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9426_))
                      '#f
                      _K9368_
                      _xi9429_
                      _rest9370_)
                     (if (eq? '#\, _$e9431_)
                         (let _lp29437_ ((_xi9439_ _xi9429_)
                                         (_digits9440_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9439_ _len9374_))
                               (let ((_next9442_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9372_ _xi9439_)))
                                     (_xi9443_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9439_ '1))))
                                 (if (char-numeric? _next9442_)
                                     (_lp29437_
                                      _xi9443_
                                      (cons _next9442_ _digits9440_))
                                     (if (and (memq _next9442_ '(#\f #\F))
                                              (not (null? _digits9440_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9426_))
                                          (std/format#chars->number
                                           (reverse _digits9440_))
                                          _K9368_
                                          _xi9443_
                                          _rest9370_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9372_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9372_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9428_)
                             (_lp9423_ _xi9429_ (cons _next9428_ _width9426_))
                             (let ((_$e9445_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9428_
                                     '#f)))
                               (if _$e9445_
                                   ((lambda (_f9448_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9426_))
                                       _f9448_
                                       _next9428_
                                       _xi9429_
                                       _rest9370_
                                       _K9368_))
                                    _$e9445_)
                                   (error '"Unknown format specifier"
                                          _str9372_
                                          _next9428_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9372_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\3
   (lambda (_char9284_ _K9285_ _xi9286_ _rest9287_)
     (let* ((_str9289_ (std/format#current-format-string))
            (_len9291_
             (let () (declare (not safe)) (##string-length _str9289_))))
       (let _lp9340_ ((_xi9342_ _xi9286_) (_width9343_ (cons _char9284_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9342_ _len9291_))
             (let ((_next9345_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9289_ _xi9342_)))
                   (_xi9346_
                    (let () (declare (not safe)) (##fx+ _xi9342_ '1))))
               (let ((_$e9348_ _next9345_))
                 (if (or (eq? '#\f _$e9348_) (eq? '#\F _$e9348_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9343_))
                      '#f
                      _K9285_
                      _xi9346_
                      _rest9287_)
                     (if (eq? '#\, _$e9348_)
                         (let _lp29354_ ((_xi9356_ _xi9346_)
                                         (_digits9357_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9356_ _len9291_))
                               (let ((_next9359_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9289_ _xi9356_)))
                                     (_xi9360_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9356_ '1))))
                                 (if (char-numeric? _next9359_)
                                     (_lp29354_
                                      _xi9360_
                                      (cons _next9359_ _digits9357_))
                                     (if (and (memq _next9359_ '(#\f #\F))
                                              (not (null? _digits9357_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9343_))
                                          (std/format#chars->number
                                           (reverse _digits9357_))
                                          _K9285_
                                          _xi9360_
                                          _rest9287_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9289_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9289_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9345_)
                             (_lp9340_ _xi9346_ (cons _next9345_ _width9343_))
                             (let ((_$e9362_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9345_
                                     '#f)))
                               (if _$e9362_
                                   ((lambda (_f9365_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9343_))
                                       _f9365_
                                       _next9345_
                                       _xi9346_
                                       _rest9287_
                                       _K9285_))
                                    _$e9362_)
                                   (error '"Unknown format specifier"
                                          _str9289_
                                          _next9345_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9289_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\4
   (lambda (_char9201_ _K9202_ _xi9203_ _rest9204_)
     (let* ((_str9206_ (std/format#current-format-string))
            (_len9208_
             (let () (declare (not safe)) (##string-length _str9206_))))
       (let _lp9257_ ((_xi9259_ _xi9203_) (_width9260_ (cons _char9201_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9259_ _len9208_))
             (let ((_next9262_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9206_ _xi9259_)))
                   (_xi9263_
                    (let () (declare (not safe)) (##fx+ _xi9259_ '1))))
               (let ((_$e9265_ _next9262_))
                 (if (or (eq? '#\f _$e9265_) (eq? '#\F _$e9265_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9260_))
                      '#f
                      _K9202_
                      _xi9263_
                      _rest9204_)
                     (if (eq? '#\, _$e9265_)
                         (let _lp29271_ ((_xi9273_ _xi9263_)
                                         (_digits9274_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9273_ _len9208_))
                               (let ((_next9276_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9206_ _xi9273_)))
                                     (_xi9277_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9273_ '1))))
                                 (if (char-numeric? _next9276_)
                                     (_lp29271_
                                      _xi9277_
                                      (cons _next9276_ _digits9274_))
                                     (if (and (memq _next9276_ '(#\f #\F))
                                              (not (null? _digits9274_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9260_))
                                          (std/format#chars->number
                                           (reverse _digits9274_))
                                          _K9202_
                                          _xi9277_
                                          _rest9204_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9206_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9206_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9262_)
                             (_lp9257_ _xi9263_ (cons _next9262_ _width9260_))
                             (let ((_$e9279_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9262_
                                     '#f)))
                               (if _$e9279_
                                   ((lambda (_f9282_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9260_))
                                       _f9282_
                                       _next9262_
                                       _xi9263_
                                       _rest9204_
                                       _K9202_))
                                    _$e9279_)
                                   (error '"Unknown format specifier"
                                          _str9206_
                                          _next9262_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9206_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\5
   (lambda (_char9118_ _K9119_ _xi9120_ _rest9121_)
     (let* ((_str9123_ (std/format#current-format-string))
            (_len9125_
             (let () (declare (not safe)) (##string-length _str9123_))))
       (let _lp9174_ ((_xi9176_ _xi9120_) (_width9177_ (cons _char9118_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9176_ _len9125_))
             (let ((_next9179_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9123_ _xi9176_)))
                   (_xi9180_
                    (let () (declare (not safe)) (##fx+ _xi9176_ '1))))
               (let ((_$e9182_ _next9179_))
                 (if (or (eq? '#\f _$e9182_) (eq? '#\F _$e9182_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9177_))
                      '#f
                      _K9119_
                      _xi9180_
                      _rest9121_)
                     (if (eq? '#\, _$e9182_)
                         (let _lp29188_ ((_xi9190_ _xi9180_)
                                         (_digits9191_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9190_ _len9125_))
                               (let ((_next9193_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9123_ _xi9190_)))
                                     (_xi9194_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9190_ '1))))
                                 (if (char-numeric? _next9193_)
                                     (_lp29188_
                                      _xi9194_
                                      (cons _next9193_ _digits9191_))
                                     (if (and (memq _next9193_ '(#\f #\F))
                                              (not (null? _digits9191_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9177_))
                                          (std/format#chars->number
                                           (reverse _digits9191_))
                                          _K9119_
                                          _xi9194_
                                          _rest9121_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9123_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9123_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9179_)
                             (_lp9174_ _xi9180_ (cons _next9179_ _width9177_))
                             (let ((_$e9196_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9179_
                                     '#f)))
                               (if _$e9196_
                                   ((lambda (_f9199_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9177_))
                                       _f9199_
                                       _next9179_
                                       _xi9180_
                                       _rest9121_
                                       _K9119_))
                                    _$e9196_)
                                   (error '"Unknown format specifier"
                                          _str9123_
                                          _next9179_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9123_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\6
   (lambda (_char9035_ _K9036_ _xi9037_ _rest9038_)
     (let* ((_str9040_ (std/format#current-format-string))
            (_len9042_
             (let () (declare (not safe)) (##string-length _str9040_))))
       (let _lp9091_ ((_xi9093_ _xi9037_) (_width9094_ (cons _char9035_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9093_ _len9042_))
             (let ((_next9096_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str9040_ _xi9093_)))
                   (_xi9097_
                    (let () (declare (not safe)) (##fx+ _xi9093_ '1))))
               (let ((_$e9099_ _next9096_))
                 (if (or (eq? '#\f _$e9099_) (eq? '#\F _$e9099_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9094_))
                      '#f
                      _K9036_
                      _xi9097_
                      _rest9038_)
                     (if (eq? '#\, _$e9099_)
                         (let _lp29105_ ((_xi9107_ _xi9097_)
                                         (_digits9108_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9107_ _len9042_))
                               (let ((_next9110_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str9040_ _xi9107_)))
                                     (_xi9111_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9107_ '1))))
                                 (if (char-numeric? _next9110_)
                                     (_lp29105_
                                      _xi9111_
                                      (cons _next9110_ _digits9108_))
                                     (if (and (memq _next9110_ '(#\f #\F))
                                              (not (null? _digits9108_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9094_))
                                          (std/format#chars->number
                                           (reverse _digits9108_))
                                          _K9036_
                                          _xi9111_
                                          _rest9038_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str9040_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str9040_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9096_)
                             (_lp9091_ _xi9097_ (cons _next9096_ _width9094_))
                             (let ((_$e9113_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9096_
                                     '#f)))
                               (if _$e9113_
                                   ((lambda (_f9116_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9094_))
                                       _f9116_
                                       _next9096_
                                       _xi9097_
                                       _rest9038_
                                       _K9036_))
                                    _$e9113_)
                                   (error '"Unknown format specifier"
                                          _str9040_
                                          _next9096_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str9040_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\7
   (lambda (_char8952_ _K8953_ _xi8954_ _rest8955_)
     (let* ((_str8957_ (std/format#current-format-string))
            (_len8959_
             (let () (declare (not safe)) (##string-length _str8957_))))
       (let _lp9008_ ((_xi9010_ _xi8954_) (_width9011_ (cons _char8952_ '())))
         (if (let () (declare (not safe)) (##fx< _xi9010_ _len8959_))
             (let ((_next9013_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str8957_ _xi9010_)))
                   (_xi9014_
                    (let () (declare (not safe)) (##fx+ _xi9010_ '1))))
               (let ((_$e9016_ _next9013_))
                 (if (or (eq? '#\f _$e9016_) (eq? '#\F _$e9016_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width9011_))
                      '#f
                      _K8953_
                      _xi9014_
                      _rest8955_)
                     (if (eq? '#\, _$e9016_)
                         (let _lp29022_ ((_xi9024_ _xi9014_)
                                         (_digits9025_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi9024_ _len8959_))
                               (let ((_next9027_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str8957_ _xi9024_)))
                                     (_xi9028_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi9024_ '1))))
                                 (if (char-numeric? _next9027_)
                                     (_lp29022_
                                      _xi9028_
                                      (cons _next9027_ _digits9025_))
                                     (if (and (memq _next9027_ '(#\f #\F))
                                              (not (null? _digits9025_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width9011_))
                                          (std/format#chars->number
                                           (reverse _digits9025_))
                                          _K8953_
                                          _xi9028_
                                          _rest8955_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str8957_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str8957_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next9013_)
                             (_lp9008_ _xi9014_ (cons _next9013_ _width9011_))
                             (let ((_$e9030_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next9013_
                                     '#f)))
                               (if _$e9030_
                                   ((lambda (_f9033_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width9011_))
                                       _f9033_
                                       _next9013_
                                       _xi9014_
                                       _rest8955_
                                       _K8953_))
                                    _$e9030_)
                                   (error '"Unknown format specifier"
                                          _str8957_
                                          _next9013_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str8957_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\8
   (lambda (_char8869_ _K8870_ _xi8871_ _rest8872_)
     (let* ((_str8874_ (std/format#current-format-string))
            (_len8876_
             (let () (declare (not safe)) (##string-length _str8874_))))
       (let _lp8925_ ((_xi8927_ _xi8871_) (_width8928_ (cons _char8869_ '())))
         (if (let () (declare (not safe)) (##fx< _xi8927_ _len8876_))
             (let ((_next8930_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str8874_ _xi8927_)))
                   (_xi8931_
                    (let () (declare (not safe)) (##fx+ _xi8927_ '1))))
               (let ((_$e8933_ _next8930_))
                 (if (or (eq? '#\f _$e8933_) (eq? '#\F _$e8933_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width8928_))
                      '#f
                      _K8870_
                      _xi8931_
                      _rest8872_)
                     (if (eq? '#\, _$e8933_)
                         (let _lp28939_ ((_xi8941_ _xi8931_)
                                         (_digits8942_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi8941_ _len8876_))
                               (let ((_next8944_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str8874_ _xi8941_)))
                                     (_xi8945_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi8941_ '1))))
                                 (if (char-numeric? _next8944_)
                                     (_lp28939_
                                      _xi8945_
                                      (cons _next8944_ _digits8942_))
                                     (if (and (memq _next8944_ '(#\f #\F))
                                              (not (null? _digits8942_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width8928_))
                                          (std/format#chars->number
                                           (reverse _digits8942_))
                                          _K8870_
                                          _xi8945_
                                          _rest8872_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str8874_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str8874_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next8930_)
                             (_lp8925_ _xi8931_ (cons _next8930_ _width8928_))
                             (let ((_$e8947_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next8930_
                                     '#f)))
                               (if _$e8947_
                                   ((lambda (_f8950_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width8928_))
                                       _f8950_
                                       _next8930_
                                       _xi8931_
                                       _rest8872_
                                       _K8870_))
                                    _$e8947_)
                                   (error '"Unknown format specifier"
                                          _str8874_
                                          _next8930_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str8874_
                    (std/format#current-format-args)))))))
  (table-set!
   std/format#dispatch-table
   '#\9
   (lambda (_char8786_ _K8787_ _xi8788_ _rest8789_)
     (let* ((_str8791_ (std/format#current-format-string))
            (_len8793_
             (let () (declare (not safe)) (##string-length _str8791_))))
       (let _lp8842_ ((_xi8844_ _xi8788_) (_width8845_ (cons _char8786_ '())))
         (if (let () (declare (not safe)) (##fx< _xi8844_ _len8793_))
             (let ((_next8847_
                    (let ()
                      (declare (not safe))
                      (##string-ref _str8791_ _xi8844_)))
                   (_xi8848_
                    (let () (declare (not safe)) (##fx+ _xi8844_ '1))))
               (let ((_$e8850_ _next8847_))
                 (if (or (eq? '#\f _$e8850_) (eq? '#\F _$e8850_))
                     (std/format#format-fixed-float
                      (std/format#chars->number (reverse _width8845_))
                      '#f
                      _K8787_
                      _xi8848_
                      _rest8789_)
                     (if (eq? '#\, _$e8850_)
                         (let _lp28856_ ((_xi8858_ _xi8848_)
                                         (_digits8859_ '()))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _xi8858_ _len8793_))
                               (let ((_next8861_
                                      (let ()
                                        (declare (not safe))
                                        (##string-ref _str8791_ _xi8858_)))
                                     (_xi8862_
                                      (let ()
                                        (declare (not safe))
                                        (##fx+ _xi8858_ '1))))
                                 (if (char-numeric? _next8861_)
                                     (_lp28856_
                                      _xi8862_
                                      (cons _next8861_ _digits8859_))
                                     (if (and (memq _next8861_ '(#\f #\F))
                                              (not (null? _digits8859_)))
                                         (std/format#format-fixed-float
                                          (std/format#chars->number
                                           (reverse _width8845_))
                                          (std/format#chars->number
                                           (reverse _digits8859_))
                                          _K8787_
                                          _xi8862_
                                          _rest8789_)
                                         (error '"Bad format string; malformed fixed width specifier"
                                                _str8791_
                                                (std/format#current-format-args)))))
                               (error '"Bad format string; malformed fixed width specifier"
                                      _str8791_
                                      (std/format#current-format-args))))
                         (if (char-numeric? _next8847_)
                             (_lp8842_ _xi8848_ (cons _next8847_ _width8845_))
                             (let ((_$e8864_
                                    (table-ref
                                     std/format#dispatch-table
                                     _next8847_
                                     '#f)))
                               (if _$e8864_
                                   ((lambda (_f8867_)
                                      (std/format#format-fixed-generic
                                       (std/format#chars->number
                                        (reverse _width8845_))
                                       _f8867_
                                       _next8847_
                                       _xi8848_
                                       _rest8789_
                                       _K8787_))
                                    _$e8864_)
                                   (error '"Unknown format specifier"
                                          _str8791_
                                          _next8847_))))))))
             (error '"Bad format string; malformed fixed width specifier"
                    _str8791_
                    (std/format#current-format-args)))))))
  (define std/format#format-fixed-generic
    (lambda (_width8766_ _f8767_ _next8768_ _xi8769_ _rest8770_ _K8771_)
      (let* ((_xi*8773_ '#f)
             (_rest*8775_ '#f)
             (_K*8780_
              (lambda (_xi8777_ _rest8778_)
                (set! _xi*8773_ _xi8777_)
                (set! _rest*8775_ _rest8778_)))
             (_str8783_
              (with-output-to-string
               '()
               (lambda () (_f8767_ _next8768_ _K*8780_ _xi8769_ _rest8770_)))))
        (display (std/format#pad-string__0 _str8783_ _width8766_))
        (_K8771_ _xi*8773_ _rest*8775_))))
  (define std/format#format-fixed-float
    (lambda (_width8688_ _digits8689_ _K8690_ _xi8691_ _rest8692_)
      (letrec ((_format-fixed8694_
                (lambda (_arg8747_ _digits8748_)
                  (if (number? _arg8747_)
                      (let ((_real8750_ (real-part _arg8747_))
                            (_imag8751_ (imag-part _arg8747_)))
                        (if (not (zero? _imag8751_))
                            (string-append
                             (_format-fixed8694_ _real8750_ _digits8748_)
                             (if (and (finite? _imag8751_)
                                      (positive? _imag8751_))
                                 '"+"
                                 '"")
                             (_format-fixed8694_ _imag8751_ _digits8748_)
                             '"i")
                            (if (not (finite? _real8750_))
                                (number->string _real8750_)
                                (if _digits8748_
                                    (let* ((_shift8753_
                                            (expt '10 _digits8748_))
                                           (_num8755_
                                            (round (* (inexact->exact
                                                       _real8750_)
                                                      _shift8753_)))
                                           (_absnum8757_ (abs _num8755_))
                                           (_pre-str8759_
                                            (number->string
                                             (quotient
                                              _absnum8757_
                                              _shift8753_)))
                                           (_pre-str8761_
                                            (if (negative? _num8755_)
                                                (string-append
                                                 '"-"
                                                 _pre-str8759_)
                                                _pre-str8759_))
                                           (_frac-str8763_
                                            (number->string
                                             (remainder
                                              _absnum8757_
                                              _shift8753_))))
                                      (_compose-float8695_
                                       _digits8748_
                                       _pre-str8761_
                                       _frac-str8763_))
                                    (_pad-zeros8696_
                                     (number->string
                                      (exact->inexact _arg8747_)))))))
                      (error '"Bad argument for float format; expected number"
                             (std/format#current-format-string)
                             (std/format#current-format-args)
                             _arg8747_))))
               (_compose-float8695_
                (lambda (_digits8741_ _pre-str8742_ _frac-str8743_)
                  (let ((_frac-len8745_ (string-length _frac-str8743_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _frac-len8745_ _digits8741_))
                        (string-append
                         _pre-str8742_
                         '"."
                         (make-string
                          (let ()
                            (declare (not safe))
                            (##fx- _digits8741_ _frac-len8745_))
                          '#\0)
                         _frac-str8743_)
                        (if (let ()
                              (declare (not safe))
                              (##fx= _frac-len8745_ _digits8741_))
                            (string-append _pre-str8742_ '"." _frac-str8743_)
                            (if (let ()
                                  (declare (not safe))
                                  (##fx= _digits8741_ '0))
                                (if (equal? _pre-str8742_ '"-0")
                                    '"0"
                                    _pre-str8742_)
                                (error '"BUG: compose-float"
                                       _digits8741_
                                       _pre-str8742_
                                       _frac-str8743_)))))))
               (_pad-zeros8696_
                (lambda (_str8736_)
                  (let ((_dot8738_ (string-index _str8736_ '#\.))
                        (_len8739_ (string-length _str8736_)))
                    (if (not _dot8738_)
                        _str8736_
                        (if (let () (declare (not safe)) (##fxzero? _dot8738_))
                            (string-append '"0" _str8736_)
                            (if (and (let ()
                                       (declare (not safe))
                                       (##fx= _dot8738_ '1))
                                     (eq? (let ()
                                            (declare (not safe))
                                            (##string-ref _str8736_ '0))
                                          '#\-))
                                (string-append
                                 '"-0"
                                 (substring _str8736_ '1 _len8739_))
                                (if (let ((__tmp291355
                                           (let ()
                                             (declare (not safe))
                                             (##fx+ _dot8738_ '1))))
                                      (declare (not safe))
                                      (##fx= __tmp291355 _len8739_))
                                    (string-append _str8736_ '"0")
                                    _str8736_))))))))
        (let* ((_width8701_
                (let ((_$e8698_ _width8688_)) (if _$e8698_ _$e8698_ '0)))
               (_rest87028710_ _rest8692_)
               (_else87048718_
                (lambda ()
                  (error '"Missing format argument"
                         (std/format#current-format-string)
                         (std/format#current-format-args))))
               (_K87068724_
                (lambda (_rest8721_ _arg8722_)
                  (display (std/format#pad-string__0
                            (_format-fixed8694_ _arg8722_ _digits8689_)
                            _width8701_))
                  (_K8690_ _xi8691_ _rest8721_))))
          (if (let () (declare (not safe)) (##pair? _rest87028710_))
              (let ((_hd87078727_
                     (let () (declare (not safe)) (##car _rest87028710_)))
                    (_tl87088729_
                     (let () (declare (not safe)) (##cdr _rest87028710_))))
                (let* ((_arg8732_ _hd87078727_) (_rest8734_ _tl87088729_))
                  (_K87068724_ _rest8734_ _arg8732_)))
              (_else87048718_))))))
  (define std/format#chars->number
    (lambda (_chars8686_) (string->number (apply string _chars8686_))))
  (define std/format#pad-string__%
    (lambda (_str8668_ _width8669_ _char8670_)
      (let ((_len8672_ (string-length _str8668_)))
        (if (let () (declare (not safe)) (##fx< _len8672_ _width8669_))
            (string-append
             (make-string
              (let () (declare (not safe)) (##fx- _width8669_ _len8672_))
              _char8670_)
             _str8668_)
            _str8668_))))
  (define std/format#pad-string__0
    (lambda (_str8677_ _width8678_)
      (let ((_char8680_ '#\space))
        (std/format#pad-string__% _str8677_ _width8678_ _char8680_))))
  (define std/format#pad-string
    (lambda _g291357_
      (let ((_g291356_ (let () (declare (not safe)) (##length _g291357_))))
        (cond ((let () (declare (not safe)) (##fx= _g291356_ 2))
               (apply std/format#pad-string__0 _g291357_))
              ((let () (declare (not safe)) (##fx= _g291356_ 3))
               (apply std/format#pad-string__% _g291357_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/format#pad-string
                _g291357_)))))))
