(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/func#repeat
    (lambda (_v-or-fn234104_ _n-times234105_ . _args234106_)
      (declare (fixnum) (not safe))
      (begin
        (if (fixnum? _n-times234105_)
            '#!void
            (error '"Bad argument; expected fixnum" _n-times234105_))
        (if (procedure? _v-or-fn234104_)
            (let ((_fn234110_
                   (if (null? _args234106_)
                       _v-or-fn234104_
                       (lambda () (apply _v-or-fn234104_ _args234106_)))))
              (let _lp234112_ ((_i234114_ '0) (_acc234115_ '()))
                (if (< _i234114_ _n-times234105_)
                    (_lp234112_
                     (+ _i234114_ '1)
                     (cons (_fn234110_) _acc234115_))
                    (reverse _acc234115_))))
            (let _lp234117_ ((_i234119_ '0) (_acc234120_ '()))
              (if (< _i234119_ _n-times234105_)
                  (_lp234117_
                   (+ _i234119_ '1)
                   (cons _v-or-fn234104_ _acc234120_))
                  _acc234120_))))))
  (define std/misc/func#always
    (lambda (_v-or-fn234099_ . _args234100_)
      (if (procedure? _v-or-fn234099_)
          (lambda () (apply _v-or-fn234099_ _args234100_))
          (lambda () _v-or-fn234099_))))
  (define std/misc/func#compose1__0 (lambda () identity))
  (define std/misc/func#compose1__1 (lambda (_f234088_) _f234088_))
  (define std/misc/func#compose1__2
    (lambda (_f1234090_ _f2234091_)
      (lambda (_x234093_) (_f1234090_ (_f2234091_ _x234093_)))))
  (define std/misc/func#compose1__3
    (lambda (_f1234095_ _f2234096_ . _rest234097_)
      (apply std/misc/func#rcompose1
             (reverse (cons _f1234095_ (cons _f2234096_ _rest234097_))))))
  (define std/misc/func#compose1
    (lambda _g303822_
      (let ((_g303821_ (let () (declare (not safe)) (##length _g303822_))))
        (cond ((let () (declare (not safe)) (##fx= _g303821_ 0))
               (apply std/misc/func#compose1__0 _g303822_))
              ((let () (declare (not safe)) (##fx= _g303821_ 1))
               (apply std/misc/func#compose1__1 _g303822_))
              ((let () (declare (not safe)) (##fx= _g303821_ 2))
               (apply std/misc/func#compose1__2 _g303822_))
              ((let () (declare (not safe)) (##fx>= _g303821_ 2))
               (apply std/misc/func#compose1__3 _g303822_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#compose1
                _g303822_))))))
  (define std/misc/func#rcompose1__0 (lambda () identity))
  (define std/misc/func#rcompose1__1 (lambda (_f234076_) _f234076_))
  (define std/misc/func#rcompose1__2
    (lambda (_f1234078_ _f2234079_)
      (lambda (_x234081_) (_f2234079_ (_f1234078_ _x234081_)))))
  (define std/misc/func#rcompose1__3
    (lambda (_f1234083_ _f2234084_ . _rest234085_)
      (std/misc/func#rcompose1__2
       _f1234083_
       (apply std/misc/func#rcompose1 _f2234084_ _rest234085_))))
  (define std/misc/func#rcompose1
    (lambda _g303824_
      (let ((_g303823_ (let () (declare (not safe)) (##length _g303824_))))
        (cond ((let () (declare (not safe)) (##fx= _g303823_ 0))
               (apply std/misc/func#rcompose1__0 _g303824_))
              ((let () (declare (not safe)) (##fx= _g303823_ 1))
               (apply std/misc/func#rcompose1__1 _g303824_))
              ((let () (declare (not safe)) (##fx= _g303823_ 2))
               (apply std/misc/func#rcompose1__2 _g303824_))
              ((let () (declare (not safe)) (##fx>= _g303823_ 2))
               (apply std/misc/func#rcompose1__3 _g303824_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#rcompose1
                _g303824_))))))
  (define std/misc/func#compose__0 (lambda () identity))
  (define std/misc/func#compose__1 (lambda (_f234064_) _f234064_))
  (define std/misc/func#compose__2
    (lambda (_f1234066_ _f2234067_)
      (lambda _args234069_ (_f1234066_ (apply _f2234067_ _args234069_)))))
  (define std/misc/func#compose__3
    (lambda (_f1234071_ _f2234072_ . _rest234073_)
      (apply std/misc/func#rcompose
             (reverse (cons _f1234071_ (cons _f2234072_ _rest234073_))))))
  (define std/misc/func#compose
    (lambda _g303826_
      (let ((_g303825_ (let () (declare (not safe)) (##length _g303826_))))
        (cond ((let () (declare (not safe)) (##fx= _g303825_ 0))
               (apply std/misc/func#compose__0 _g303826_))
              ((let () (declare (not safe)) (##fx= _g303825_ 1))
               (apply std/misc/func#compose__1 _g303826_))
              ((let () (declare (not safe)) (##fx= _g303825_ 2))
               (apply std/misc/func#compose__2 _g303826_))
              ((let () (declare (not safe)) (##fx>= _g303825_ 2))
               (apply std/misc/func#compose__3 _g303826_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#compose
                _g303826_))))))
  (define std/misc/func#rcompose__0 (lambda () identity))
  (define std/misc/func#rcompose__1 (lambda (_f234052_) _f234052_))
  (define std/misc/func#rcompose__2
    (lambda (_f1234054_ _f2234055_)
      (lambda _args234057_ (_f2234055_ (apply _f1234054_ _args234057_)))))
  (define std/misc/func#rcompose__3
    (lambda (_f1234059_ _f2234060_ . _rest234061_)
      (std/misc/func#rcompose__2
       _f1234059_
       (apply std/misc/func#rcompose _f2234060_ _rest234061_))))
  (define std/misc/func#rcompose
    (lambda _g303828_
      (let ((_g303827_ (let () (declare (not safe)) (##length _g303828_))))
        (cond ((let () (declare (not safe)) (##fx= _g303827_ 0))
               (apply std/misc/func#rcompose__0 _g303828_))
              ((let () (declare (not safe)) (##fx= _g303827_ 1))
               (apply std/misc/func#rcompose__1 _g303828_))
              ((let () (declare (not safe)) (##fx= _g303827_ 2))
               (apply std/misc/func#rcompose__2 _g303828_))
              ((let () (declare (not safe)) (##fx>= _g303827_ 2))
               (apply std/misc/func#rcompose__3 _g303828_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#rcompose
                _g303828_))))))
  (define std/misc/func#compose/values__0 (lambda () values))
  (define std/misc/func#compose/values__1 (lambda (_f234039_) _f234039_))
  (define std/misc/func#compose/values__2
    (lambda (_f1234041_ _f2234042_)
      (lambda _args234044_
        (call-with-values
         (lambda () (apply _f2234042_ _args234044_))
         _f1234041_))))
  (define std/misc/func#compose/values__3
    (lambda (_f1234047_ _f2234048_ . _rest234049_)
      (apply std/misc/func#rcompose/values
             (reverse (cons _f1234047_ (cons _f2234048_ _rest234049_))))))
  (define std/misc/func#compose/values
    (lambda _g303830_
      (let ((_g303829_ (let () (declare (not safe)) (##length _g303830_))))
        (cond ((let () (declare (not safe)) (##fx= _g303829_ 0))
               (apply std/misc/func#compose/values__0 _g303830_))
              ((let () (declare (not safe)) (##fx= _g303829_ 1))
               (apply std/misc/func#compose/values__1 _g303830_))
              ((let () (declare (not safe)) (##fx= _g303829_ 2))
               (apply std/misc/func#compose/values__2 _g303830_))
              ((let () (declare (not safe)) (##fx>= _g303829_ 2))
               (apply std/misc/func#compose/values__3 _g303830_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#compose/values
                _g303830_))))))
  (define std/misc/func#rcompose/values__0 (lambda () values))
  (define std/misc/func#rcompose/values__1 (lambda (_f234026_) _f234026_))
  (define std/misc/func#rcompose/values__2
    (lambda (_f1234028_ _f2234029_)
      (lambda _args234031_
        (call-with-values
         (lambda () (apply _f1234028_ _args234031_))
         _f2234029_))))
  (define std/misc/func#rcompose/values__3
    (lambda (_f1234034_ _f2234035_ . _rest234036_)
      (std/misc/func#rcompose/values__2
       _f1234034_
       (apply std/misc/func#rcompose/values _f2234035_ _rest234036_))))
  (define std/misc/func#rcompose/values
    (lambda _g303832_
      (let ((_g303831_ (let () (declare (not safe)) (##length _g303832_))))
        (cond ((let () (declare (not safe)) (##fx= _g303831_ 0))
               (apply std/misc/func#rcompose/values__0 _g303832_))
              ((let () (declare (not safe)) (##fx= _g303831_ 1))
               (apply std/misc/func#rcompose/values__1 _g303832_))
              ((let () (declare (not safe)) (##fx= _g303831_ 2))
               (apply std/misc/func#rcompose/values__2 _g303832_))
              ((let () (declare (not safe)) (##fx>= _g303831_ 2))
               (apply std/misc/func#rcompose/values__3 _g303832_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#rcompose/values
                _g303832_))))))
  (define std/misc/func#every-of__%
    (lambda (_g303833_ _test233995233998_ _preds234000_ _v234001_)
      (let ((_test234003_
             (if (eq? _test233995233998_ absent-value)
                 equal?
                 _test233995233998_)))
        (andmap1 (lambda (_p234005_)
                   ((if (procedure? _p234005_)
                        _p234005_
                        (lambda (_g234006234008_)
                          (_test234003_ _p234005_ _g234006234008_)))
                    _v234001_))
                 _preds234000_))))
  (define std/misc/func#every-of__@
    (lambda (_keys233994234014_ . _args234016_)
      (apply std/misc/func#every-of__%
             _keys233994234014_
             (table-ref _keys233994234014_ 'test: absent-value)
             _args234016_)))
  (define std/misc/func#every-of
    (lambda _args233996234022_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#every-of__@
             _args233996234022_)))
  (define std/misc/func#any-of__%
    (lambda (_g303834_ _test233963233966_ _preds233968_ _v233969_)
      (let ((_test233971_
             (if (eq? _test233963233966_ absent-value)
                 equal?
                 _test233963233966_)))
        (ormap1 (lambda (_p233973_)
                  ((if (procedure? _p233973_)
                       _p233973_
                       (lambda (_g233974233976_)
                         (_test233971_ _p233973_ _g233974233976_)))
                   _v233969_))
                _preds233968_))))
  (define std/misc/func#any-of__@
    (lambda (_keys233962233982_ . _args233984_)
      (apply std/misc/func#any-of__%
             _keys233962233982_
             (table-ref _keys233962233982_ 'test: absent-value)
             _args233984_)))
  (define std/misc/func#any-of
    (lambda _args233964233990_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#any-of__@
             _args233964233990_)))
  (define std/misc/func#pred-limit
    (lambda (_pred233950_ _limit233951_)
      (letrec ((_test233953_
                (lambda (_v233956_)
                  (declare (fixnum))
                  (if (> _limit233951_ '0)
                      (let ((_v233959_ (_pred233950_ _v233956_)))
                        (if _v233959_
                            (set! _limit233951_ (- _limit233951_ '1))
                            '#!void)
                        _v233959_)
                      '#f))))
        (if _limit233951_
            (if (> _limit233951_ '0) _test233953_ (lambda (_g303835_) '#f))
            _pred233950_))))
  (define std/misc/func#pred-sequence__%
    (lambda (_list233924_ _limit233925_)
      (declare (not safe) (fixnum))
      (letrec* ((_g303836_
                 (let ((_g303837_
                        (if (fixnum? _limit233925_)
                            '#!void
                            (set! _limit233925_ '-1))))
                   #!void
                   _g303837_))
                (_seq233927_ _list233924_)
                (_check233928_
                 (lambda (_v233933_)
                   (letrec* ((_is-match233935_
                              (if (or (equal? (car _seq233927_) _v233933_)
                                      (begin
                                        (set! _seq233927_ _list233924_)
                                        '#f))
                                  (if (set! _seq233927_ (cdr _seq233927_))
                                      (null? _seq233927_)
                                      '#f)
                                  '#f)))
                     (if _is-match233935_
                         (begin
                           (set! _seq233927_ _list233924_)
                           (if (> _limit233925_ '0)
                               (set! _limit233925_ (- _limit233925_ '1))
                               '#!void))
                         '#!void)
                     _is-match233935_))))
        (if (pair? _list233924_)
            (lambda (_v233930_)
              (if (zero? _limit233925_) '#f (_check233928_ _v233930_)))
            (lambda (_g303839_) '#f)))))
  (define std/misc/func#pred-sequence__0
    (lambda (_list233943_)
      (let ((_limit233945_ '#f))
        (std/misc/func#pred-sequence__% _list233943_ _limit233945_))))
  (define std/misc/func#pred-sequence
    (lambda _g303841_
      (let ((_g303840_ (let () (declare (not safe)) (##length _g303841_))))
        (cond ((let () (declare (not safe)) (##fx= _g303840_ 1))
               (apply std/misc/func#pred-sequence__0 _g303841_))
              ((let () (declare (not safe)) (##fx= _g303840_ 2))
               (apply std/misc/func#pred-sequence__% _g303841_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#pred-sequence
                _g303841_))))))
  (define std/misc/func#pred-and
    (lambda (_pred233917_)
      (letrec* ((_res233919_ '#t))
        (lambda (_v233921_)
          (if _res233919_
              (begin (set! _res233919_ (_pred233917_ _v233921_)) _res233919_)
              '#f)))))
  (define std/misc/func#pred-or
    (lambda (_pred233911_)
      (letrec* ((_res233913_ '#f))
        (lambda (_v233915_)
          (if _res233913_
              '#t
              (begin
                (set! _res233913_ (_pred233911_ _v233915_))
                _res233913_))))))
  (define std/misc/func#pred-every-of__%
    (lambda (_g303842_ _test233874233877_ _preds233879_)
      (let ((_test233881_
             (if (eq? _test233874233877_ absent-value)
                 equal?
                 _test233874233877_)))
        (if (pair? _preds233879_)
            (let ((_preds233889_
                   (map (lambda (_p233883_)
                          (if (procedure? _p233883_)
                              _p233883_
                              (lambda (_g233884233886_)
                                (_test233881_ _p233883_ _g233884233886_))))
                        _preds233879_)))
              (lambda (_v233891_)
                (andmap1 (lambda (_g233892233894_) (_g233892233894_ _v233891_))
                         _preds233889_)))
            true))))
  (define std/misc/func#pred-every-of__@
    (lambda (_keys233873233900_ . _args233902_)
      (apply std/misc/func#pred-every-of__%
             _keys233873233900_
             (table-ref _keys233873233900_ 'test: absent-value)
             _args233902_)))
  (define std/misc/func#pred-every-of
    (lambda _args233875233908_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#pred-every-of__@
             _args233875233908_)))
  (define std/misc/func#pred-any-of__%
    (lambda (_g303843_ _test233835233838_ _preds233840_)
      (let ((_test233842_
             (if (eq? _test233835233838_ absent-value)
                 equal?
                 _test233835233838_)))
        (if (pair? _preds233840_)
            (let ((_preds233850_
                   (map (lambda (_p233844_)
                          (if (procedure? _p233844_)
                              _p233844_
                              (lambda (_g233845233847_)
                                (_test233842_ _p233844_ _g233845233847_))))
                        _preds233840_)))
              (lambda (_v233852_)
                (ormap1 (lambda (_g233853233855_) (_g233853233855_ _v233852_))
                        _preds233850_)))
            false))))
  (define std/misc/func#pred-any-of__@
    (lambda (_keys233834233861_ . _args233863_)
      (apply std/misc/func#pred-any-of__%
             _keys233834233861_
             (table-ref _keys233834233861_ 'test: absent-value)
             _args233863_)))
  (define std/misc/func#pred-any-of
    (lambda _args233836233869_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#pred-any-of__@
             _args233836233869_))))
