(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/process#check-process-success
    (lambda (_exit-status231205_ _settings231206_)
      (if (zero? _exit-status231205_)
          '#!void
          (error '"Process exited with non-zero status"
                 _exit-status231205_
                 _settings231206_))))
  (define std/misc/process#run-process__%
    (lambda (_g303129_
             _coprocess231132231143_
             _check-status231133231145_
             _environment231134231147_
             _directory231135231149_
             _stdin-redirection231136231151_
             _stdout-redirection231137231153_
             _stderr-redirection231138231155_
             _pseudo-terminal231139231157_
             _show-console231140231159_
             _command231161_)
      (let* ((_coprocess231163_
              (if (eq? _coprocess231132231143_ absent-value)
                  std/misc/ports#read-all-as-string
                  _coprocess231132231143_))
             (_check-status231165_
              (if (eq? _check-status231133231145_ absent-value)
                  '#t
                  _check-status231133231145_))
             (_environment231167_
              (if (eq? _environment231134231147_ absent-value)
                  '#f
                  _environment231134231147_))
             (_directory231169_
              (if (eq? _directory231135231149_ absent-value)
                  '#f
                  _directory231135231149_))
             (_stdin-redirection231171_
              (if (eq? _stdin-redirection231136231151_ absent-value)
                  '#t
                  _stdin-redirection231136231151_))
             (_stdout-redirection231173_
              (if (eq? _stdout-redirection231137231153_ absent-value)
                  '#t
                  _stdout-redirection231137231153_))
             (_stderr-redirection231175_
              (if (eq? _stderr-redirection231138231155_ absent-value)
                  '#f
                  _stderr-redirection231138231155_))
             (_pseudo-terminal231177_
              (if (eq? _pseudo-terminal231139231157_ absent-value)
                  '#f
                  _pseudo-terminal231139231157_))
             (_show-console231179_
              (if (eq? _show-console231140231159_ absent-value)
                  '#f
                  _show-console231140231159_))
             (_settings231181_
              (cons 'path:
                    (cons (car _command231161_)
                          (cons 'arguments:
                                (cons (cdr _command231161_)
                                      (cons 'environment:
                                            (cons _environment231167_
                                                  (cons 'directory:
                                                        (cons _directory231169_
                                                              (cons 'stdin-redirection:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (cons _stdin-redirection231171_
                                  (cons 'stdout-redirection:
                                        (cons _stdout-redirection231173_
                                              (cons 'stderr-redirection:
                                                    (cons _stderr-redirection231175_
                                                          (cons 'pseudo-terminal:
                                                                (cons _pseudo-terminal231177_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (cons 'show-console:
                                    (cons _show-console231179_
                                          '())))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
             (_process231183_ (open-process _settings231181_)))
        (with-unwind-protect
         (lambda ()
           (letrec* ((_result231187_ (_coprocess231163_ _process231183_))
                     (_status231188_ (process-status _process231183_)))
             (if _check-status231165_
                 ((if (procedure? _check-status231165_)
                      _check-status231165_
                      std/misc/process#check-process-success)
                  _status231188_
                  _settings231181_)
                 '#!void)
             _result231187_))
         (lambda ()
           (close-port _process231183_)
           (process-status _process231183_))))))
  (define std/misc/process#run-process__@
    (lambda (_keys231131231194_ . _args231196_)
      (apply std/misc/process#run-process__%
             _keys231131231194_
             (table-ref _keys231131231194_ 'coprocess: absent-value)
             (table-ref _keys231131231194_ 'check-status: absent-value)
             (table-ref _keys231131231194_ 'environment: absent-value)
             (table-ref _keys231131231194_ 'directory: absent-value)
             (table-ref _keys231131231194_ 'stdin-redirection: absent-value)
             (table-ref _keys231131231194_ 'stdout-redirection: absent-value)
             (table-ref _keys231131231194_ 'stderr-redirection: absent-value)
             (table-ref _keys231131231194_ 'pseudo-terminal: absent-value)
             (table-ref _keys231131231194_ 'show-console: absent-value)
             _args231196_)))
  (define std/misc/process#run-process
    (lambda _args231141231202_
      (apply keyword-dispatch
             '#(stdout-redirection:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                stdin-redirection:
                #f
                #f
                #f
                #f
                #f
                stderr-redirection:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                directory:
                environment:
                pseudo-terminal:
                #f
                #f
                #f
                #f
                #f
                show-console:
                #f
                #f
                #f
                #f
                #f
                #f
                coprocess:
                #f
                #f
                #f
                #f
                #f
                check-status:
                #f
                #f)
             std/misc/process#run-process__@
             _args231141231202_)))
  (define std/misc/process#run-process/batch__%
    (lambda (_g303130_
             _check-status231092231098_
             _environment231093231100_
             _directory231094231102_
             _show-console231095231104_
             _command231106_)
      (let* ((_check-status231108_
              (if (eq? _check-status231092231098_ absent-value)
                  '#t
                  _check-status231092231098_))
             (_environment231110_
              (if (eq? _environment231093231100_ absent-value)
                  '#f
                  _environment231093231100_))
             (_directory231112_
              (if (eq? _directory231094231102_ absent-value)
                  '#f
                  _directory231094231102_))
             (_show-console231114_
              (if (eq? _show-console231095231104_ absent-value)
                  '#f
                  _show-console231095231104_)))
        (std/misc/process#run-process__%
         '#f
         close-output-port
         _check-status231108_
         _environment231110_
         _directory231112_
         absent-value
         '#f
         absent-value
         absent-value
         _show-console231114_
         _command231106_)
        '#!void)))
  (define std/misc/process#run-process/batch__@
    (lambda (_keys231091231119_ . _args231121_)
      (apply std/misc/process#run-process/batch__%
             _keys231091231119_
             (table-ref _keys231091231119_ 'check-status: absent-value)
             (table-ref _keys231091231119_ 'environment: absent-value)
             (table-ref _keys231091231119_ 'directory: absent-value)
             (table-ref _keys231091231119_ 'show-console: absent-value)
             _args231121_)))
  (define std/misc/process#run-process/batch
    (lambda _args231096231127_
      (apply keyword-dispatch
             '#(#f
                #f
                show-console:
                directory:
                environment:
                #f
                check-status:
                #f
                #f)
             std/misc/process#run-process/batch__@
             _args231096231127_))))
