(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/socket/api#ssocket-connect__%
    (lambda (_addr202420_ _timeo202421_)
      (let* ((_sa202423_ (std/os/socket#socket-address _addr202420_))
             (_sock202425_
              (std/os/socket#socket__0
               (std/os/_socket#sockaddr_family _sa202423_)
               std/os/_socket#SOCK_STREAM))
             (_rcon202435_
              (with-exception-catcher
               (lambda (_g202426202428_)
                 (if '#t
                     (let ((_e202431_ _g202426202428_))
                       (close-port _sock202425_)
                       (raise _e202431_))
                     (raise _g202426202428_)))
               (lambda ()
                 (std/os/socket#socket-connect _sock202425_ _sa202423_))))
             (_ssock202437_ (std/net/socket/api#make-ssocket _sock202425_)))
        (let* ((_ssock202439202448_ _ssock202437_)
               (_E202441202452_
                (lambda () (error '"No clause matching" _ssock202439202448_)))
               (_K202442202463_
                (lambda (_close202455_ _wait-out202456_)
                  (if _rcon202435_
                      '#!void
                      (if (_wait-out202456_
                           _ssock202437_
                           (std/net/socket/base#abs-timeout _timeo202421_))
                          '#!void
                          (begin
                            (_close202455_ _ssock202437_ 'inout '#f)
                            (std/error#raise-timeout
                             'ssocket-connect
                             '"connection timeout"
                             _addr202420_))))
                  (let ((_errno202461_
                         (let ((_$e202458_ _rcon202435_))
                           (if _$e202458_
                               _$e202458_
                               (std/os/socket#socket-getsockopt
                                _sock202425_
                                std/os/_socket#SOL_SOCKET
                                std/os/_socket#SO_ERROR)))))
                    (if (##fxzero? _errno202461_)
                        _ssock202437_
                        (begin
                          (_close202455_ _ssock202437_ 'inout '#f)
                          (std/os/error#raise-os-error
                           _errno202461_
                           std/net/socket/api#ssocket-connect
                           _addr202420_
                           _timeo202421_)))))))
          (if (##structure-direct-instance-of?
               _ssock202439202448_
               'std/net/socket/base#!socket::t)
              (let* ((_e202443202466_ (##vector-ref _ssock202439202448_ '1))
                     (_e202444202469_ (##vector-ref _ssock202439202448_ '2))
                     (_e202445202472_ (##vector-ref _ssock202439202448_ '3))
                     (_wait-out202475_ _e202445202472_)
                     (_e202446202477_ (##vector-ref _ssock202439202448_ '4))
                     (_close202480_ _e202446202477_))
                (_K202442202463_ _close202480_ _wait-out202475_))
              (_E202441202452_))))))
  (define std/net/socket/api#ssocket-connect__0
    (lambda (_addr202485_)
      (let ((_timeo202487_ '#f))
        (std/net/socket/api#ssocket-connect__% _addr202485_ _timeo202487_))))
  (define std/net/socket/api#ssocket-connect
    (lambda _g309469_
      (let ((_g309468_ (##length _g309469_)))
        (cond ((##fx= _g309468_ 1)
               (apply std/net/socket/api#ssocket-connect__0 _g309469_))
              ((##fx= _g309468_ 2)
               (apply std/net/socket/api#ssocket-connect__% _g309469_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-connect
                _g309469_))))))
  (define std/net/socket/api#ssocket-listen__%
    (lambda (_addr202380_ _backlog202381_ _opts202382_)
      (let* ((_sa202384_ (std/os/socket#socket-address _addr202380_))
             (_sock202386_
              (std/os/socket#server-socket__0
               (std/os/_socket#sockaddr_family _sa202384_)
               std/os/_socket#SOCK_STREAM)))
        (with-exception-catcher
         (lambda (_g202388202390_)
           (if '#t
               (let ((_e202393_ _g202388202390_))
                 (close-port _sock202386_)
                 (raise _e202393_))
               (raise _g202388202390_)))
         (lambda ()
           (for-each
            (lambda (_g202396202398_)
              (std/os/socket#socket-setsockopt
               _sock202386_
               std/os/_socket#SOL_SOCKET
               _g202396202398_
               '1))
            _opts202382_)
           (std/os/socket#socket-bind _sock202386_ _sa202384_)
           (std/os/socket#socket-listen__% _sock202386_ _backlog202381_)
           (std/net/socket/api#make-ssocket _sock202386_))))))
  (define std/net/socket/api#ssocket-listen__0
    (lambda (_addr202404_)
      (let* ((_backlog202406_ '10)
             (_opts202408_ std/net/socket/api#default-listen-sockopts))
        (std/net/socket/api#ssocket-listen__%
         _addr202404_
         _backlog202406_
         _opts202408_))))
  (define std/net/socket/api#ssocket-listen__1
    (lambda (_addr202410_ _backlog202411_)
      (let ((_opts202413_ std/net/socket/api#default-listen-sockopts))
        (std/net/socket/api#ssocket-listen__%
         _addr202410_
         _backlog202411_
         _opts202413_))))
  (define std/net/socket/api#ssocket-listen
    (lambda _g309471_
      (let ((_g309470_ (##length _g309471_)))
        (cond ((##fx= _g309470_ 1)
               (apply std/net/socket/api#ssocket-listen__0 _g309471_))
              ((##fx= _g309470_ 2)
               (apply std/net/socket/api#ssocket-listen__1 _g309471_))
              ((##fx= _g309470_ 3)
               (apply std/net/socket/api#ssocket-listen__% _g309471_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-listen
                _g309471_))))))
  (define std/net/socket/api#ssocket-accept__%
    (lambda (_ssock202326_ _sa202327_ _timeo202328_)
      (let* ((_ssock202329202335_ _ssock202326_)
             (_E202331202339_
              (lambda () (error '"No clause matching" _ssock202329202335_)))
             (_K202332202353_
              (lambda (_sock202342_)
                (let ((_timeo202344_
                       (std/net/socket/base#abs-timeout _timeo202328_)))
                  (let _lp202346_ ()
                    (let ((_wait-in202349_
                           (##direct-structure-ref
                            _ssock202326_
                            '2
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-in202349_
                          (let ((_cli202351_
                                 (std/os/socket#socket-accept__%
                                  _sock202342_
                                  _sa202327_)))
                            (if _cli202351_
                                (std/net/socket/api#make-ssocket _cli202351_)
                                (if (_wait-in202349_
                                     _ssock202326_
                                     _timeo202344_)
                                    (_lp202346_)
                                    (std/error#raise-timeout
                                     'ssocket-accept
                                     '"accept timeout"
                                     _ssock202326_))))
                          (std/error#raise-io-error
                           'ssocket-accept
                           '"Socket is not open for input"
                           _ssock202326_))))))))
        (if (##structure-direct-instance-of?
             _ssock202329202335_
             'std/net/socket/base#!socket::t)
            (let* ((_e202333202356_ (##vector-ref _ssock202329202335_ '1))
                   (_sock202359_ _e202333202356_))
              (_K202332202353_ _sock202359_))
            (_E202331202339_)))))
  (define std/net/socket/api#ssocket-accept__0
    (lambda (_ssock202364_)
      (let* ((_sa202366_ '#f) (_timeo202368_ '#f))
        (std/net/socket/api#ssocket-accept__%
         _ssock202364_
         _sa202366_
         _timeo202368_))))
  (define std/net/socket/api#ssocket-accept__1
    (lambda (_ssock202370_ _sa202371_)
      (let ((_timeo202373_ '#f))
        (std/net/socket/api#ssocket-accept__%
         _ssock202370_
         _sa202371_
         _timeo202373_))))
  (define std/net/socket/api#ssocket-accept
    (lambda _g309473_
      (let ((_g309472_ (##length _g309473_)))
        (cond ((##fx= _g309472_ 1)
               (apply std/net/socket/api#ssocket-accept__0 _g309473_))
              ((##fx= _g309472_ 2)
               (apply std/net/socket/api#ssocket-accept__1 _g309473_))
              ((##fx= _g309472_ 3)
               (apply std/net/socket/api#ssocket-accept__% _g309473_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-accept
                _g309473_))))))
  (define std/net/socket/api#ssocket-send__%
    (lambda (_ssock202252_ _buf202253_ _start202254_ _end202255_ _timeo202256_)
      (let* ((_ssock202257202263_ _ssock202252_)
             (_E202259202267_
              (lambda () (error '"No clause matching" _ssock202257202263_)))
             (_K202260202284_
              (lambda (_sock202270_)
                (let ((_timeo202272_
                       (std/net/socket/base#abs-timeout _timeo202256_)))
                  (let _lp202274_ ()
                    (let ((_wait-out202277_
                           (##direct-structure-ref
                            _ssock202252_
                            '3
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-out202277_
                          (let* ((_r202279_
                                  (std/os/socket#socket-send__2
                                   _sock202270_
                                   _buf202253_
                                   _start202254_
                                   _end202255_))
                                 (_$e202281_ _r202279_))
                            (if _$e202281_
                                _$e202281_
                                (if (_wait-out202277_
                                     _ssock202252_
                                     _timeo202272_)
                                    (_lp202274_)
                                    (std/error#raise-timeout
                                     'ssocket-send
                                     '"send timeout"
                                     _ssock202252_))))
                          (std/error#raise-io-error
                           'ssocket-send
                           '"Socket is not open for output"
                           _ssock202252_))))))))
        (if (##structure-direct-instance-of?
             _ssock202257202263_
             'std/net/socket/base#!socket::t)
            (let* ((_e202261202287_ (##vector-ref _ssock202257202263_ '1))
                   (_sock202290_ _e202261202287_))
              (_K202260202284_ _sock202290_))
            (_E202259202267_)))))
  (define std/net/socket/api#ssocket-send__0
    (lambda (_ssock202295_ _buf202296_)
      (let* ((_start202298_ '0)
             (_end202300_ (u8vector-length _buf202296_))
             (_timeo202302_ '#f))
        (std/net/socket/api#ssocket-send__%
         _ssock202295_
         _buf202296_
         _start202298_
         _end202300_
         _timeo202302_))))
  (define std/net/socket/api#ssocket-send__1
    (lambda (_ssock202304_ _buf202305_ _start202306_)
      (let* ((_end202308_ (u8vector-length _buf202305_)) (_timeo202310_ '#f))
        (std/net/socket/api#ssocket-send__%
         _ssock202304_
         _buf202305_
         _start202306_
         _end202308_
         _timeo202310_))))
  (define std/net/socket/api#ssocket-send__2
    (lambda (_ssock202312_ _buf202313_ _start202314_ _end202315_)
      (let ((_timeo202317_ '#f))
        (std/net/socket/api#ssocket-send__%
         _ssock202312_
         _buf202313_
         _start202314_
         _end202315_
         _timeo202317_))))
  (define std/net/socket/api#ssocket-send
    (lambda _g309475_
      (let ((_g309474_ (##length _g309475_)))
        (cond ((##fx= _g309474_ 2)
               (apply std/net/socket/api#ssocket-send__0 _g309475_))
              ((##fx= _g309474_ 3)
               (apply std/net/socket/api#ssocket-send__1 _g309475_))
              ((##fx= _g309474_ 4)
               (apply std/net/socket/api#ssocket-send__2 _g309475_))
              ((##fx= _g309474_ 5)
               (apply std/net/socket/api#ssocket-send__% _g309475_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-send
                _g309475_))))))
  (define std/net/socket/api#ssocket-send-all__%
    (lambda (_ssock202179_ _buf202180_ _start202181_ _end202182_ _timeo202183_)
      (let* ((_ssock202184202190_ _ssock202179_)
             (_E202186202194_
              (lambda () (error '"No clause matching" _ssock202184202190_)))
             (_K202187202210_
              (lambda (_sock202197_)
                (let ((_timeo202199_
                       (std/net/socket/base#abs-timeout _timeo202183_)))
                  (let _lp202201_ ((_count202203_ '0)
                                   (_start202204_ _start202181_))
                    (let ((_wait-out202206_
                           (##direct-structure-ref
                            _ssock202179_
                            '3
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-out202206_
                          (if (##fx< _start202204_ _end202182_)
                              (let ((_r202208_
                                     (std/os/socket#socket-send__2
                                      _sock202197_
                                      _buf202180_
                                      _start202204_
                                      _end202182_)))
                                (if _r202208_
                                    (_lp202201_
                                     (##fx+ _count202203_ _r202208_)
                                     (##fx+ _start202204_ _r202208_))
                                    (if (_wait-out202206_
                                         _ssock202179_
                                         _timeo202199_)
                                        (_lp202201_
                                         _count202203_
                                         _start202204_)
                                        (std/error#raise-timeout
                                         'ssocket-send-all
                                         '"send timeout"
                                         _ssock202179_))))
                              _count202203_)
                          (std/error#raise-io-error
                           'ssocket-send-all
                           '"Socket is not open for output"
                           _ssock202179_))))))))
        (if (##structure-direct-instance-of?
             _ssock202184202190_
             'std/net/socket/base#!socket::t)
            (let* ((_e202188202213_ (##vector-ref _ssock202184202190_ '1))
                   (_sock202216_ _e202188202213_))
              (_K202187202210_ _sock202216_))
            (_E202186202194_)))))
  (define std/net/socket/api#ssocket-send-all__0
    (lambda (_ssock202221_ _buf202222_)
      (let* ((_start202224_ '0)
             (_end202226_ (u8vector-length _buf202222_))
             (_timeo202228_ '#f))
        (std/net/socket/api#ssocket-send-all__%
         _ssock202221_
         _buf202222_
         _start202224_
         _end202226_
         _timeo202228_))))
  (define std/net/socket/api#ssocket-send-all__1
    (lambda (_ssock202230_ _buf202231_ _start202232_)
      (let* ((_end202234_ (u8vector-length _buf202231_)) (_timeo202236_ '#f))
        (std/net/socket/api#ssocket-send-all__%
         _ssock202230_
         _buf202231_
         _start202232_
         _end202234_
         _timeo202236_))))
  (define std/net/socket/api#ssocket-send-all__2
    (lambda (_ssock202238_ _buf202239_ _start202240_ _end202241_)
      (let ((_timeo202243_ '#f))
        (std/net/socket/api#ssocket-send-all__%
         _ssock202238_
         _buf202239_
         _start202240_
         _end202241_
         _timeo202243_))))
  (define std/net/socket/api#ssocket-send-all
    (lambda _g309477_
      (let ((_g309476_ (##length _g309477_)))
        (cond ((##fx= _g309476_ 2)
               (apply std/net/socket/api#ssocket-send-all__0 _g309477_))
              ((##fx= _g309476_ 3)
               (apply std/net/socket/api#ssocket-send-all__1 _g309477_))
              ((##fx= _g309476_ 4)
               (apply std/net/socket/api#ssocket-send-all__2 _g309477_))
              ((##fx= _g309476_ 5)
               (apply std/net/socket/api#ssocket-send-all__% _g309477_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-send-all
                _g309477_))))))
  (define std/net/socket/api#ssocket-recv__%
    (lambda (_ssock202105_ _buf202106_ _start202107_ _end202108_ _timeo202109_)
      (let* ((_ssock202110202116_ _ssock202105_)
             (_E202112202120_
              (lambda () (error '"No clause matching" _ssock202110202116_)))
             (_K202113202137_
              (lambda (_sock202123_)
                (let ((_timeo202125_
                       (std/net/socket/base#abs-timeout _timeo202109_)))
                  (let _lp202127_ ()
                    (let ((_wait-in202130_
                           (##direct-structure-ref
                            _ssock202105_
                            '2
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-in202130_
                          (let* ((_r202132_
                                  (std/os/socket#socket-recv__2
                                   _sock202123_
                                   _buf202106_
                                   _start202107_
                                   _end202108_))
                                 (_$e202134_ _r202132_))
                            (if _$e202134_
                                _$e202134_
                                (if (_wait-in202130_
                                     _ssock202105_
                                     _timeo202125_)
                                    (_lp202127_)
                                    (std/error#raise-timeout
                                     'ssocket-recv
                                     '"receive timeout"
                                     _ssock202105_))))
                          (std/error#raise-io-error
                           'ssocket-recv
                           '"Socket is not open for input"
                           _ssock202105_))))))))
        (if (##structure-direct-instance-of?
             _ssock202110202116_
             'std/net/socket/base#!socket::t)
            (let* ((_e202114202140_ (##vector-ref _ssock202110202116_ '1))
                   (_sock202143_ _e202114202140_))
              (_K202113202137_ _sock202143_))
            (_E202112202120_)))))
  (define std/net/socket/api#ssocket-recv__0
    (lambda (_ssock202148_ _buf202149_)
      (let* ((_start202151_ '0)
             (_end202153_ (u8vector-length _buf202149_))
             (_timeo202155_ '#f))
        (std/net/socket/api#ssocket-recv__%
         _ssock202148_
         _buf202149_
         _start202151_
         _end202153_
         _timeo202155_))))
  (define std/net/socket/api#ssocket-recv__1
    (lambda (_ssock202157_ _buf202158_ _start202159_)
      (let* ((_end202161_ (u8vector-length _buf202158_)) (_timeo202163_ '#f))
        (std/net/socket/api#ssocket-recv__%
         _ssock202157_
         _buf202158_
         _start202159_
         _end202161_
         _timeo202163_))))
  (define std/net/socket/api#ssocket-recv__2
    (lambda (_ssock202165_ _buf202166_ _start202167_ _end202168_)
      (let ((_timeo202170_ '#f))
        (std/net/socket/api#ssocket-recv__%
         _ssock202165_
         _buf202166_
         _start202167_
         _end202168_
         _timeo202170_))))
  (define std/net/socket/api#ssocket-recv
    (lambda _g309479_
      (let ((_g309478_ (##length _g309479_)))
        (cond ((##fx= _g309478_ 2)
               (apply std/net/socket/api#ssocket-recv__0 _g309479_))
              ((##fx= _g309478_ 3)
               (apply std/net/socket/api#ssocket-recv__1 _g309479_))
              ((##fx= _g309478_ 4)
               (apply std/net/socket/api#ssocket-recv__2 _g309479_))
              ((##fx= _g309478_ 5)
               (apply std/net/socket/api#ssocket-recv__% _g309479_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-recv
                _g309479_))))))
  (define std/net/socket/api#ssocket-recv-all__%
    (lambda (_ssock202032_ _buf202033_ _start202034_ _end202035_ _timeo202036_)
      (let* ((_ssock202037202043_ _ssock202032_)
             (_E202039202047_
              (lambda () (error '"No clause matching" _ssock202037202043_)))
             (_K202040202063_
              (lambda (_sock202050_)
                (let ((_timeo202052_
                       (std/net/socket/base#abs-timeout _timeo202036_)))
                  (let _lp202054_ ((_count202056_ '0)
                                   (_start202057_ _start202034_))
                    (let ((_wait-in202059_
                           (##direct-structure-ref
                            _ssock202032_
                            '2
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-in202059_
                          (if (##fx>= _start202057_ _end202035_)
                              _count202056_
                              (let ((_r202061_
                                     (std/os/socket#socket-recv__2
                                      _sock202050_
                                      _buf202033_
                                      _start202057_
                                      _end202035_)))
                                (if (not _r202061_)
                                    (if (_wait-in202059_
                                         _ssock202032_
                                         _timeo202052_)
                                        (_lp202054_
                                         _count202056_
                                         _start202057_)
                                        (std/error#raise-timeout
                                         'ssocket-recv-all
                                         '"receive timeout"
                                         _ssock202032_))
                                    (if (##fxzero? _r202061_)
                                        _count202056_
                                        (_lp202054_
                                         (##fx+ _count202056_ _r202061_)
                                         (##fx+ _start202057_ _r202061_))))))
                          (std/error#raise-io-error
                           'ssocket-recv-all
                           '"Socket is not open for input"
                           _ssock202032_))))))))
        (if (##structure-direct-instance-of?
             _ssock202037202043_
             'std/net/socket/base#!socket::t)
            (let* ((_e202041202066_ (##vector-ref _ssock202037202043_ '1))
                   (_sock202069_ _e202041202066_))
              (_K202040202063_ _sock202069_))
            (_E202039202047_)))))
  (define std/net/socket/api#ssocket-recv-all__0
    (lambda (_ssock202074_ _buf202075_)
      (let* ((_start202077_ '0)
             (_end202079_ (u8vector-length _buf202075_))
             (_timeo202081_ '#f))
        (std/net/socket/api#ssocket-recv-all__%
         _ssock202074_
         _buf202075_
         _start202077_
         _end202079_
         _timeo202081_))))
  (define std/net/socket/api#ssocket-recv-all__1
    (lambda (_ssock202083_ _buf202084_ _start202085_)
      (let* ((_end202087_ (u8vector-length _buf202084_)) (_timeo202089_ '#f))
        (std/net/socket/api#ssocket-recv-all__%
         _ssock202083_
         _buf202084_
         _start202085_
         _end202087_
         _timeo202089_))))
  (define std/net/socket/api#ssocket-recv-all__2
    (lambda (_ssock202091_ _buf202092_ _start202093_ _end202094_)
      (let ((_timeo202096_ '#f))
        (std/net/socket/api#ssocket-recv-all__%
         _ssock202091_
         _buf202092_
         _start202093_
         _end202094_
         _timeo202096_))))
  (define std/net/socket/api#ssocket-recv-all
    (lambda _g309481_
      (let ((_g309480_ (##length _g309481_)))
        (cond ((##fx= _g309480_ 2)
               (apply std/net/socket/api#ssocket-recv-all__0 _g309481_))
              ((##fx= _g309480_ 3)
               (apply std/net/socket/api#ssocket-recv-all__1 _g309481_))
              ((##fx= _g309480_ 4)
               (apply std/net/socket/api#ssocket-recv-all__2 _g309481_))
              ((##fx= _g309480_ 5)
               (apply std/net/socket/api#ssocket-recv-all__% _g309481_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-recv-all
                _g309481_))))))
  (define std/net/socket/api#ssocket-socket
    (lambda (_ssock202029_)
      (##direct-structure-ref
       _ssock202029_
       '1
       std/net/socket/base#!socket::t
       '#f)))
  (define std/net/socket/api#ssocket-close
    (lambda (_ssock202027_)
      ((##direct-structure-ref
        _ssock202027_
        '4
        std/net/socket/base#!socket::t
        '#f)
       _ssock202027_
       'inout
       '#f)))
  (define std/net/socket/api#ssocket-close-input__%
    (lambda (_ssock202014_ _shutdown202015_)
      ((##direct-structure-ref
        _ssock202014_
        '4
        std/net/socket/base#!socket::t
        '#f)
       _ssock202014_
       'in
       (if _shutdown202015_ std/os/_socket#SHUT_RD '#f))))
  (define std/net/socket/api#ssocket-close-input__0
    (lambda (_ssock202020_)
      (let ((_shutdown202022_ '#f))
        (std/net/socket/api#ssocket-close-input__%
         _ssock202020_
         _shutdown202022_))))
  (define std/net/socket/api#ssocket-close-input
    (lambda _g309483_
      (let ((_g309482_ (##length _g309483_)))
        (cond ((##fx= _g309482_ 1)
               (apply std/net/socket/api#ssocket-close-input__0 _g309483_))
              ((##fx= _g309482_ 2)
               (apply std/net/socket/api#ssocket-close-input__% _g309483_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-close-input
                _g309483_))))))
  (define std/net/socket/api#ssocket-close-output__%
    (lambda (_ssock202000_ _shutdown202001_)
      ((##direct-structure-ref
        _ssock202000_
        '4
        std/net/socket/base#!socket::t
        '#f)
       _ssock202000_
       'out
       (if _shutdown202001_ std/os/_socket#SHUT_WR '#f))))
  (define std/net/socket/api#ssocket-close-output__0
    (lambda (_ssock202006_)
      (let ((_shutdown202008_ '#f))
        (std/net/socket/api#ssocket-close-output__%
         _ssock202006_
         _shutdown202008_))))
  (define std/net/socket/api#ssocket-close-output
    (lambda _g309485_
      (let ((_g309484_ (##length _g309485_)))
        (cond ((##fx= _g309484_ 1)
               (apply std/net/socket/api#ssocket-close-output__0 _g309485_))
              ((##fx= _g309484_ 2)
               (apply std/net/socket/api#ssocket-close-output__% _g309485_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-close-output
                _g309485_))))))
  (define std/net/socket/api#!socket::destroy std/net/socket/api#ssocket-close)
  (bind-method!
   std/net/socket/base#!socket::t
   'destroy
   std/net/socket/api#!socket::destroy
   '#f)
  (define std/net/socket/api#default-listen-sockopts
    (cons std/os/_socket#SO_REUSEADDR '()))
  (define std/net/socket/api#make-ssocket
    (lambda (_sock201865_)
      (let ((_$e201867_ (std/net/socket/base#current-socket-server)))
        (if _$e201867_
            ((lambda (_srv201870_)
               (let ((_token201872_ (##structure std/actor/proto#!token::t))
                     (_dest201874_ _srv201870_))
                 (std/actor/message#send-message__%
                  _dest201874_
                  (##structure
                   std/actor/proto#!call::t
                   (##structure
                    std/net/socket/base#socket-server.add::t
                    _sock201865_)
                   _token201872_)
                  '#f
                  '#t)
                 (std/actor/proto#!!call-recv _token201872_ _dest201874_)))
             _$e201867_)
            (std/net/socket/basic-socket#basic-socket _sock201865_))))))
