(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/fd#open-raw-device
    (lambda (_direction178625_ _id178626_ _fd178627_)
      (letrec ((_fail178629_
                (lambda ()
                  (let ()
                    (declare (not safe))
                    (##fail-check-settings
                     '1
                     std/os/fd#open-raw-device
                     _direction178625_
                     _id178626_
                     _fd178627_)))))
        (let ((__tmp290390
               (lambda (_psettings178631_)
                 (let ((_device178633_
                        (let ((__tmp290391
                               (let ()
                                 (declare (not safe))
                                 (##psettings->device-flags
                                  _psettings178631_))))
                          (declare (not safe))
                          (##os-device-open-raw-from-fd
                           _fd178627_
                           __tmp290391))))
                   (if (let () (declare (not safe)) (##fixnum? _device178633_))
                       (let ()
                         (declare (not safe))
                         (##raise-os-exception
                          '#f
                          _device178633_
                          std/os/fd#open-raw-device
                          _direction178625_
                          _id178626_
                          _fd178627_))
                       (let ((__tmp290392
                              (cons _id178626_ (cons _fd178627_ '()))))
                         (declare (not safe))
                         (##make-raw-device-port
                          _direction178625_
                          _device178633_
                          _id178626_
                          __tmp290392
                          _fd178627_)))))))
          (declare (not safe))
          (##make-psettings
           _direction178625_
           '()
           '()
           _fail178629_
           __tmp290390)))))
  (define std/os/fd#direction
    (lambda (_dir178620_)
      (let ((_$e178622_ _dir178620_))
        (if (eq? 'in _$e178622_)
            (macro-direction-in)
            (if (eq? 'out _$e178622_)
                (macro-direction-out)
                (if (eq? 'inout _$e178622_)
                    (macro-direction-inout)
                    (error '"Bad direction; must be in, out, or inout"
                           _dir178620_)))))))
  (define std/os/fd#fdopen
    (lambda (_fd178614_ _dir178615_ _t178616_)
      (let ((_dirx178618_ (std/os/fd#direction _dir178615_)))
        (std/os/fd#open-raw-device _dirx178618_ _t178616_ _fd178614_))))
  (define std/os/fd#fdopen-port
    (lambda (_fd178608_ _dir178609_ _name178610_)
      (let ((_dirx178612_ (std/os/fd#direction _dir178609_)))
        (declare (not safe))
        (##open-predefined _dirx178612_ _name178610_ _fd178608_))))
  (define std/os/fd#fd-e
    (lambda (_raw178606_)
      (values (macro-raw-device-port-specific _raw178606_))))
  (define std/os/fd#fd-io-in
    (lambda (_raw178604_)
      (values (macro-raw-device-port-rdevice-condvar _raw178604_))))
  (define std/os/fd#fd-io-out
    (lambda (_raw178602_)
      (values (macro-raw-device-port-wdevice-condvar _raw178602_))))
  (define std/os/fd#fd-type
    (lambda (_raw178600_) (values (macro-raw-device-port-type _raw178600_))))
  (define std/os/fd#fd?
    (lambda (_obj178598_) (values (macro-raw-device-port? _obj178598_))))
  (define std/os/fd#fd-type?
    (lambda (_obj178595_ _t178596_)
      (if (macro-raw-device-port? _obj178595_)
          (eq? (std/os/fd#fd-type _obj178595_) _t178596_)
          '#f))))
