(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/parser/stream#char-stream::t
    (make-struct-type
     'std/parser/stream#char-stream::t
     '#f
     '4
     'char-stream
     '((final: . #t))
     ':init!
     '(port buf loc lines)))
  (define std/parser/stream#char-stream?
    (make-struct-predicate std/parser/stream#char-stream::t))
  (define std/parser/stream#make-char-stream
    (lambda _$args153048_
      (apply make-struct-instance
             std/parser/stream#char-stream::t
             _$args153048_)))
  (define std/parser/stream#char-stream-port
    (make-struct-field-accessor std/parser/stream#char-stream::t '0))
  (define std/parser/stream#char-stream-buf
    (make-struct-field-accessor std/parser/stream#char-stream::t '1))
  (define std/parser/stream#char-stream-loc
    (make-struct-field-accessor std/parser/stream#char-stream::t '2))
  (define std/parser/stream#char-stream-lines
    (make-struct-field-accessor std/parser/stream#char-stream::t '3))
  (define std/parser/stream#char-stream-port-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '0))
  (define std/parser/stream#char-stream-buf-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '1))
  (define std/parser/stream#char-stream-loc-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '2))
  (define std/parser/stream#char-stream-lines-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '3))
  (define std/parser/stream#char-stream:::init!
    (lambda (_self153045_ _port153046_)
      (if (macro-character-input-port? _port153046_)
          '#!void
          (error '"Bad input source; not a character-input-port" _port153046_))
      (if (let ((__tmp290209
                 (let () (declare (not safe)) (##vector-length _self153045_))))
            (declare (not safe))
            (##fx< '4 __tmp290209))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self153045_ '1 _port153046_))
            (let () (declare (not safe)) (##vector-set! _self153045_ '2 '()))
            (let ((__tmp290210
                   (let ()
                     (declare (not safe))
                     (##structure
                      std/parser/base#location::t
                      _port153046_
                      '0
                      '0
                      '0
                      '0))))
              (declare (not safe))
              (##vector-set! _self153045_ '3 __tmp290210))
            (let () (declare (not safe)) (##vector-set! _self153045_ '4 '())))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self153045_))))
  (bind-method!
   std/parser/stream#char-stream::t
   ':init!
   std/parser/stream#char-stream:::init!
   '#f)
  (define std/parser/stream#char-stream-close
    (lambda (_cs152920_)
      (close-input-port
       (##direct-structure-ref
        _cs152920_
        '1
        std/parser/stream#char-stream::t
        '#f))))
  (define std/parser/stream#char-stream-getc
    (lambda (_cs152837_)
      (let* ((_cs152838152847_ _cs152837_)
             (_E152840152851_
              (lambda () (error '"No clause matching" _cs152838152847_)))
             (_K152841152897_
              (lambda (_lines152854_ _loc152855_ _buf152856_ _port152857_)
                (let* ((_buf152858152866_ _buf152856_)
                       (_else152860152879_
                        (lambda ()
                          (let* ((_loc152874_
                                  (std/parser/stream#port-location
                                   _port152857_))
                                 (_char152876_ (read-char _port152857_)))
                            (if (eof-object? _char152876_)
                                '#!void
                                (begin
                                  (##direct-structure-set!
                                   _cs152837_
                                   _loc152874_
                                   '3
                                   std/parser/stream#char-stream::t
                                   '#f)
                                  (if (eq? '#\newline _char152876_)
                                      (##direct-structure-set!
                                       _cs152837_
                                       (cons (##direct-structure-ref
                                              _loc152874_
                                              '5
                                              std/parser/base#location::t
                                              '#f)
                                             _lines152854_)
                                       '4
                                       std/parser/stream#char-stream::t
                                       '#f)
                                      '#!void)))
                            _char152876_)))
                       (_K152862152885_
                        (lambda (_rest152882_ _char152883_)
                          (##direct-structure-set!
                           _cs152837_
                           _rest152882_
                           '2
                           std/parser/stream#char-stream::t
                           '#f)
                          (##direct-structure-set!
                           _cs152837_
                           (std/parser/stream#location-getc
                            _loc152855_
                            _char152883_
                            _lines152854_)
                           '3
                           std/parser/stream#char-stream::t
                           '#f)
                          _char152883_)))
                  (if (let () (declare (not safe)) (##pair? _buf152858152866_))
                      (let ((_hd152863152888_
                             (let ()
                               (declare (not safe))
                               (##car _buf152858152866_)))
                            (_tl152864152890_
                             (let ()
                               (declare (not safe))
                               (##cdr _buf152858152866_))))
                        (let* ((_char152893_ _hd152863152888_)
                               (_rest152895_ _tl152864152890_))
                          (_K152862152885_ _rest152895_ _char152893_)))
                      (_else152860152879_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cs152838152847_
               'std/parser/stream#char-stream::t))
            (let* ((_e152842152900_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152838152847_ '1)))
                   (_port152903_ _e152842152900_)
                   (_e152843152905_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152838152847_ '2)))
                   (_buf152908_ _e152843152905_)
                   (_e152844152910_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152838152847_ '3)))
                   (_loc152913_ _e152844152910_)
                   (_e152845152915_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152838152847_ '4)))
                   (_lines152918_ _e152845152915_))
              (_K152841152897_
               _lines152918_
               _loc152913_
               _buf152908_
               _port152903_))
            (_E152840152851_)))))
  (define std/parser/stream#char-stream-ungetc
    (lambda (_cs152791_ _char152792_)
      (if (eof-object? _char152792_)
          '#!void
          (let* ((_cs152793152802_ _cs152791_)
                 (_E152795152806_
                  (lambda () (error '"No clause matching" _cs152793152802_)))
                 (_K152796152814_
                  (lambda (_lines152809_ _loc152810_ _buf152811_ _port152812_)
                    (##direct-structure-set!
                     _cs152791_
                     (cons _char152792_ _buf152811_)
                     '2
                     std/parser/stream#char-stream::t
                     '#f)
                    (##direct-structure-set!
                     _cs152791_
                     (std/parser/stream#location-ungetc
                      _loc152810_
                      _char152792_
                      _lines152809_)
                     '3
                     std/parser/stream#char-stream::t
                     '#f))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _cs152793152802_
                   'std/parser/stream#char-stream::t))
                (let* ((_e152797152817_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152793152802_ '1)))
                       (_port152820_ _e152797152817_)
                       (_e152798152822_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152793152802_ '2)))
                       (_buf152825_ _e152798152822_)
                       (_e152799152827_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152793152802_ '3)))
                       (_loc152830_ _e152799152827_)
                       (_e152800152832_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152793152802_ '4)))
                       (_lines152835_ _e152800152832_))
                  (_K152796152814_
                   _lines152835_
                   _loc152830_
                   _buf152825_
                   _port152820_))
                (_E152795152806_))))))
  (define std/parser/stream#char-stream-peek
    (lambda (_cs152727_)
      (let* ((_cs152728152735_ _cs152727_)
             (_E152730152739_
              (lambda () (error '"No clause matching" _cs152728152735_)))
             (_K152731152778_
              (lambda (_buf152742_ _port152743_)
                (let* ((_buf152744152752_ _buf152742_)
                       (_else152746152760_
                        (lambda () (peek-char _port152743_)))
                       (_K152748152766_
                        (lambda (_rest152763_ _char152764_) _char152764_)))
                  (if (let () (declare (not safe)) (##pair? _buf152744152752_))
                      (let ((_hd152749152769_
                             (let ()
                               (declare (not safe))
                               (##car _buf152744152752_)))
                            (_tl152750152771_
                             (let ()
                               (declare (not safe))
                               (##cdr _buf152744152752_))))
                        (let* ((_char152774_ _hd152749152769_)
                               (_rest152776_ _tl152750152771_))
                          (_K152748152766_ _rest152776_ _char152774_)))
                      (_else152746152760_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cs152728152735_
               'std/parser/stream#char-stream::t))
            (let* ((_e152732152781_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152728152735_ '1)))
                   (_port152784_ _e152732152781_)
                   (_e152733152786_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152728152735_ '2)))
                   (_buf152789_ _e152733152786_))
              (_K152731152778_ _buf152789_ _port152784_))
            (_E152730152739_)))))
  (define std/parser/stream#location-getc
    (lambda (_loc152676_ _char152677_ _lines152678_)
      (let* ((_loc152679152689_ _loc152676_)
             (_E152681152693_
              (lambda () (error '"No clause matching" _loc152679152689_)))
             (_K152682152701_
              (lambda (_xoff152696_ _col152697_ _line152698_ _port152699_)
                (if (let () (declare (not safe)) (##fx< _xoff152696_ '0))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/parser/base#location::t
                       _port152699_
                       '0
                       '0
                       '1
                       '0))
                    (if (memq _xoff152696_ _lines152678_)
                        (let ((__tmp290212
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _line152698_ '1)))
                              (__tmp290211
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _xoff152696_ '1))))
                          (declare (not safe))
                          (##structure
                           std/parser/base#location::t
                           _port152699_
                           __tmp290212
                           '0
                           '1
                           __tmp290211))
                        (let ((__tmp290214
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _col152697_ '1)))
                              (__tmp290213
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _xoff152696_ '1))))
                          (declare (not safe))
                          (##structure
                           std/parser/base#location::t
                           _port152699_
                           _line152698_
                           __tmp290214
                           '1
                           __tmp290213)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _loc152679152689_
               'std/parser/base#location::t))
            (let* ((_e152683152704_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152679152689_ '1)))
                   (_port152707_ _e152683152704_)
                   (_e152684152709_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152679152689_ '2)))
                   (_line152712_ _e152684152709_)
                   (_e152685152714_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152679152689_ '3)))
                   (_col152717_ _e152685152714_)
                   (_e152686152719_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152679152689_ '4)))
                   (_e152687152722_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152679152689_ '5)))
                   (_xoff152725_ _e152687152722_))
              (_K152682152701_
               _xoff152725_
               _col152717_
               _line152712_
               _port152707_))
            (_E152681152693_)))))
  (define std/parser/stream#location-ungetc
    (lambda (_loc152611_ _char152612_ _lines152613_)
      (let* ((_loc152614152624_ _loc152611_)
             (_E152616152628_
              (lambda () (error '"No clause matching" _loc152614152624_)))
             (_K152617152650_
              (lambda (_xoff152631_ _col152632_ _line152633_ _port152634_)
                (if (let () (declare (not safe)) (##fx> _col152632_ '0))
                    (let ((__tmp290216
                           (let ()
                             (declare (not safe))
                             (##fx- _col152632_ '1)))
                          (__tmp290215
                           (let ()
                             (declare (not safe))
                             (##fx- _xoff152631_ '1))))
                      (declare (not safe))
                      (##structure
                       std/parser/base#location::t
                       _port152634_
                       _line152633_
                       __tmp290216
                       '1
                       __tmp290215))
                    (let* ((_xoff152636_
                            (let ()
                              (declare (not safe))
                              (##fx- _xoff152631_ '1)))
                           (_base152645_
                            (let ((_$e152642_
                                   (find (lambda (_g152637152639_)
                                           (< _g152637152639_ _xoff152636_))
                                         _lines152613_)))
                              (if _$e152642_ _$e152642_ '-1)))
                           (_col152647_
                            (let ()
                              (declare (not safe))
                              (##fx- _xoff152636_ _base152645_ '1))))
                      (let ((__tmp290217
                             (let ()
                               (declare (not safe))
                               (##fx- _line152633_ '1))))
                        (declare (not safe))
                        (##structure
                         std/parser/base#location::t
                         _port152634_
                         __tmp290217
                         _col152647_
                         '1
                         _xoff152636_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _loc152614152624_
               'std/parser/base#location::t))
            (let* ((_e152618152653_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152614152624_ '1)))
                   (_port152656_ _e152618152653_)
                   (_e152619152658_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152614152624_ '2)))
                   (_line152661_ _e152619152658_)
                   (_e152620152663_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152614152624_ '3)))
                   (_col152666_ _e152620152663_)
                   (_e152621152668_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152614152624_ '4)))
                   (_e152622152671_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152614152624_ '5)))
                   (_xoff152674_ _e152622152671_))
              (_K152617152650_
               _xoff152674_
               _col152666_
               _line152661_
               _port152656_))
            (_E152616152628_)))))
  (define std/parser/stream#port-location
    (lambda (_port152602_)
      (let* ((_line152604_ (macro-character-port-rlines _port152602_))
             (_xoff152606_
              (let ((__tmp290219 (macro-character-port-rchars _port152602_))
                    (__tmp290218 (macro-character-port-rlo _port152602_)))
                (declare (not safe))
                (##fx+ __tmp290219 __tmp290218)))
             (_col152608_
              (let ((__tmp290220 (macro-character-port-rcurline _port152602_)))
                (declare (not safe))
                (##fx- _xoff152606_ __tmp290220))))
        (let ()
          (declare (not safe))
          (##structure
           std/parser/base#location::t
           _port152602_
           _line152604_
           _col152608_
           '1
           _xoff152606_))))))
