(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/127#any-null?
    (lambda (_list96536_)
      (if (null? _list96536_)
          '#f
          (if (null? (car _list96536_))
              '#t
              (std/srfi/127#any-null? (cdr _list96536_))))))
  (define std/srfi/127#gappend
    (lambda _args96529_
      (lambda ()
        (if (null? _args96529_)
            (eof-object)
            (let _loop96532_ ((_v96534_ ((car _args96529_))))
              (if (eof-object? _v96534_)
                  (begin
                    (set! _args96529_ (cdr _args96529_))
                    (if (null? _args96529_)
                        (eof-object)
                        (_loop96532_ ((car _args96529_)))))
                  _v96534_))))))
  (define std/srfi/127#generator->lseq
    (lambda (_gen96525_)
      (let ((_value96527_ (_gen96525_)))
        (if (eof-object? _value96527_) '() (cons _value96527_ _gen96525_)))))
  (define std/srfi/127#lseq-car (lambda (_lseq96523_) (car _lseq96523_)))
  (define std/srfi/127#lseq-first (lambda (_lseq96521_) (car _lseq96521_)))
  (define std/srfi/127#lseq-cdr
    (lambda (_lseq96515_)
      (if (procedure? (cdr _lseq96515_))
          (let ((_obj96517_ ((cdr _lseq96515_))))
            (if (eof-object? _obj96517_)
                (begin (set-cdr! _lseq96515_ '()) '())
                (let ((_result96519_ (cons _obj96517_ (cdr _lseq96515_))))
                  (set-cdr! _lseq96515_ _result96519_)
                  _result96519_)))
          (cdr _lseq96515_))))
  (define std/srfi/127#lseq-rest
    (lambda (_lseq96513_) (std/srfi/127#lseq-cdr _lseq96513_)))
  (define std/srfi/127#lseq?
    (lambda (_obj96511_)
      (if (null? _obj96511_)
          '#t
          (if (not (pair? _obj96511_))
              '#f
              (if (procedure? (cdr _obj96511_))
                  '#t
                  (std/srfi/127#lseq? (cdr _obj96511_)))))))
  (define std/srfi/127#lseq=?
    (lambda (_=96504_ _lseq196505_ _lseq296506_)
      (if (and (null? _lseq196505_) (null? _lseq296506_))
          '#t
          (if (or (null? _lseq196505_) (null? _lseq296506_))
              '#f
              (if (_=96504_ (car _lseq196505_) (car _lseq296506_))
                  (std/srfi/127#lseq=?
                   _=96504_
                   (std/srfi/127#lseq-cdr _lseq196505_)
                   (std/srfi/127#lseq-cdr _lseq296506_))
                  '#f)))))
  (define std/srfi/127#lseq-take
    (lambda (_lseq96498_ _i96499_)
      (std/srfi/127#generator->lseq
       (lambda ()
         (if (= _i96499_ '0)
             (eof-object)
             (let ((_result96502_ (car _lseq96498_)))
               (set! _lseq96498_ (std/srfi/127#lseq-cdr _lseq96498_))
               (set! _i96499_ (- _i96499_ '1))
               _result96502_))))))
  (define std/srfi/127#lseq-drop
    (lambda (_lseq96490_ _i96491_)
      (let _loop96493_ ((_i96495_ _i96491_) (_lseq96496_ _lseq96490_))
        (if (= _i96495_ '0)
            _lseq96496_
            (_loop96493_
             (- _i96495_ '1)
             (std/srfi/127#lseq-cdr _lseq96496_))))))
  (define std/srfi/127#lseq-ref
    (lambda (_lseq96487_ _i96488_)
      (car (std/srfi/127#lseq-drop _lseq96487_ _i96488_))))
  (define std/srfi/127#lseq-realize
    (lambda (_lseq96481_)
      (let _loop96483_ ((_next96485_ _lseq96481_))
        (if (null? _next96485_)
            _lseq96481_
            (_loop96483_ (std/srfi/127#lseq-cdr _next96485_))))))
  (define std/srfi/127#lseq-length
    (lambda (_lseq96479_) (length (std/srfi/127#lseq-realize _lseq96479_))))
  (define std/srfi/127#lseq->generator
    (lambda (_lseq96474_)
      (lambda ()
        (if (null? _lseq96474_)
            (eof-object)
            (let ((_result96477_ (car _lseq96474_)))
              (set! _lseq96474_ (std/srfi/127#lseq-cdr _lseq96474_))
              _result96477_)))))
  (define std/srfi/127#lseq-append
    (lambda _lseqs96472_
      (std/srfi/127#generator->lseq
       (apply std/srfi/127#gappend
              (map std/srfi/127#lseq->generator _lseqs96472_)))))
  (define std/srfi/127#safe-lseq-cdr
    (lambda (_obj96470_)
      (if (null? _obj96470_) _obj96470_ (std/srfi/127#lseq-cdr _obj96470_))))
  (define std/srfi/127#lseq-map
    (lambda (_proc96464_ . _lseqs96465_)
      (std/srfi/127#generator->lseq
       (lambda ()
         (if (std/srfi/127#any-null? _lseqs96465_)
             (eof-object)
             (let ((_result96468_
                    (apply _proc96464_
                           (map std/srfi/127#lseq-car _lseqs96465_))))
               (set! _lseqs96465_
                     (map std/srfi/127#safe-lseq-cdr _lseqs96465_))
               _result96468_))))))
  (define std/srfi/127#lseq-zip
    (lambda _lseqs96462_ (apply std/srfi/127#lseq-map list _lseqs96462_)))
  (define std/srfi/127#lseq-for-each
    (lambda (_proc96459_ . _lseqs96460_)
      (apply for-each
             _proc96459_
             (map std/srfi/127#lseq-realize _lseqs96460_))))
  (define std/srfi/127#lseq-filter
    (lambda (_pred96449_ _lseq96450_)
      (std/srfi/127#generator->lseq
       (lambda ()
         (let _loop96453_ ((_lseq196455_ _lseq96450_))
           (if (null? _lseq196455_)
               (eof-object)
               (let ((_result96457_ (car _lseq196455_)))
                 (if (_pred96449_ _result96457_)
                     (begin
                       (set! _lseq96450_ (std/srfi/127#lseq-cdr _lseq196455_))
                       _result96457_)
                     (_loop96453_ (std/srfi/127#lseq-cdr _lseq196455_))))))))))
  (define std/srfi/127#lseq-remove
    (lambda (_pred96444_ _lseq96445_)
      (std/srfi/127#lseq-filter
       (lambda (_x96447_) (not (_pred96444_ _x96447_)))
       _lseq96445_)))
  (define std/srfi/127#lseq-find
    (lambda (_pred96441_ _lseq96442_)
      (if (null? _lseq96442_)
          '#f
          (if (_pred96441_ (car _lseq96442_))
              (car _lseq96442_)
              (std/srfi/127#lseq-find
               _pred96441_
               (std/srfi/127#lseq-cdr _lseq96442_))))))
  (define std/srfi/127#lseq-find-tail
    (lambda (_pred96438_ _lseq96439_)
      (if (null? _lseq96439_)
          '#f
          (if (_pred96438_ (car _lseq96439_))
              _lseq96439_
              (std/srfi/127#lseq-find-tail
               _pred96438_
               (std/srfi/127#lseq-cdr _lseq96439_))))))
  (define std/srfi/127#lseq-take-while
    (lambda (_pred96432_ _lseq96433_)
      (std/srfi/127#generator->lseq
       (lambda ()
         (if (not (_pred96432_ (car _lseq96433_)))
             (eof-object)
             (let ((_result96436_ (car _lseq96433_)))
               (set! _lseq96433_ (std/srfi/127#lseq-cdr _lseq96433_))
               _result96436_))))))
  (define std/srfi/127#lseq-drop-while
    (lambda (_pred96425_ _lseq96426_)
      (let _loop96428_ ((_lseq96430_ _lseq96426_))
        (if (not (_pred96425_ (car _lseq96430_)))
            _lseq96430_
            (_loop96428_ (std/srfi/127#lseq-cdr _lseq96430_))))))
  (define std/srfi/127#lseq-any
    (lambda (_pred96416_ . _lseqs96417_)
      (let _loop96419_ ((_lseqs96421_ _lseqs96417_))
        (if (std/srfi/127#any-null? _lseqs96421_)
            '#f
            (let ((_result96423_
                   (apply _pred96416_
                          (map std/srfi/127#lseq-car _lseqs96421_))))
              (if _result96423_
                  _result96423_
                  (_loop96419_ (map std/srfi/127#lseq-cdr _lseqs96421_))))))))
  (define std/srfi/127#lseq-every
    (lambda (_pred96406_ . _lseqs96407_)
      (let _loop96409_ ((_lseqs96411_ _lseqs96407_) (_last-result96412_ '#t))
        (if (std/srfi/127#any-null? _lseqs96411_)
            _last-result96412_
            (let ((_result96414_
                   (apply _pred96406_
                          (map std/srfi/127#lseq-car _lseqs96411_))))
              (if _result96414_
                  (_loop96409_
                   (map std/srfi/127#lseq-cdr _lseqs96411_)
                   _result96414_)
                  '#f))))))
  (define std/srfi/127#lseq-index
    (lambda (_pred96398_ . _lseqs96399_)
      (let _loop96401_ ((_lseqs96403_ _lseqs96399_) (_n96404_ '0))
        (if (std/srfi/127#any-null? _lseqs96403_)
            '#f
            (if (apply _pred96398_ (map std/srfi/127#lseq-car _lseqs96403_))
                _n96404_
                (_loop96401_
                 (map std/srfi/127#safe-lseq-cdr _lseqs96403_)
                 (+ _n96404_ '1)))))))
  (define std/srfi/127#lseq-member__0
    (lambda (_x96391_ _lseq96392_)
      (std/srfi/127#lseq-member__1 _x96391_ _lseq96392_ equal?)))
  (define std/srfi/127#lseq-member__1
    (lambda (_x96394_ _lseq96395_ _=96396_)
      (if (null? _lseq96395_)
          '#f
          (if (_=96396_ _x96394_ (car _lseq96395_))
              _lseq96395_
              (std/srfi/127#lseq-member__1
               _x96394_
               (std/srfi/127#lseq-cdr _lseq96395_)
               _=96396_)))))
  (define std/srfi/127#lseq-member
    (lambda _g289322_
      (let ((_g289321_ (let () (declare (not safe)) (##length _g289322_))))
        (cond ((let () (declare (not safe)) (##fx= _g289321_ 2))
               (apply std/srfi/127#lseq-member__0 _g289322_))
              ((let () (declare (not safe)) (##fx= _g289321_ 3))
               (apply std/srfi/127#lseq-member__1 _g289322_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/127#lseq-member
                _g289322_))))))
  (define std/srfi/127#lseq-memv
    (lambda (_x96388_ _lseq96389_)
      (std/srfi/127#lseq-member__1 _x96388_ _lseq96389_ eqv?)))
  (define std/srfi/127#lseq-memq
    (lambda (_x96385_ _lseq96386_)
      (std/srfi/127#lseq-member__1 _x96385_ _lseq96386_ eq?))))
