(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/128#comparator::t
    (make-struct-type
     'std/srfi/128#comparator::t
     '#f
     '4
     'comparator
     '((final: . #t))
     '#f
     '(testf eqf orderf hashf)))
  (define std/srfi/128#comparator?
    (make-struct-predicate std/srfi/128#comparator::t))
  (define std/srfi/128#make-comparator
    (lambda _$args93314_
      (apply make-struct-instance std/srfi/128#comparator::t _$args93314_)))
  (define std/srfi/128#comparator-testf
    (make-struct-field-accessor std/srfi/128#comparator::t '0))
  (define std/srfi/128#comparator-eqf
    (make-struct-field-accessor std/srfi/128#comparator::t '1))
  (define std/srfi/128#comparator-orderf
    (make-struct-field-accessor std/srfi/128#comparator::t '2))
  (define std/srfi/128#comparator-hashf
    (make-struct-field-accessor std/srfi/128#comparator::t '3))
  (define std/srfi/128#comparator-testf-set!
    (make-struct-field-mutator std/srfi/128#comparator::t '0))
  (define std/srfi/128#comparator-eqf-set!
    (make-struct-field-mutator std/srfi/128#comparator::t '1))
  (define std/srfi/128#comparator-orderf-set!
    (make-struct-field-mutator std/srfi/128#comparator::t '2))
  (define std/srfi/128#comparator-hashf-set!
    (make-struct-field-mutator std/srfi/128#comparator::t '3))
  (define std/srfi/128#comparator-ordered?
    (lambda (_c93312_)
      (if (##direct-structure-ref _c93312_ '3 std/srfi/128#comparator::t '#f)
          '#t
          '#f)))
  (define std/srfi/128#comparator-hashable?
    (lambda (_c93310_)
      (if (##direct-structure-ref _c93310_ '4 std/srfi/128#comparator::t '#f)
          '#t
          '#f)))
  (define std/srfi/128#no-orderf
    (lambda (_a93307_ _b93308_)
      (error '"Comparator does not provide an ordering function"
             _a93307_
             _b93308_)))
  (define std/srfi/128#no-hashf
    (lambda (_o93305_)
      (error '"Comparator does not provide a hash function" _o93305_)))
  (define std/srfi/128#comparator-ordering-predicate
    (lambda (_c93300_)
      (let ((_$e93302_
             (##direct-structure-ref
              _c93300_
              '3
              std/srfi/128#comparator::t
              '#f)))
        (if _$e93302_ _$e93302_ std/srfi/128#no-orderf))))
  (define std/srfi/128#comparator-hash-function
    (lambda (_c93295_)
      (let ((_$e93297_
             (##direct-structure-ref
              _c93295_
              '4
              std/srfi/128#comparator::t
              '#f)))
        (if _$e93297_ _$e93297_ std/srfi/128#no-hashf))))
  (define std/srfi/128#comparator-test-type
    (lambda (_c93292_ _o93293_)
      ((##direct-structure-ref _c93292_ '1 std/srfi/128#comparator::t '#f)
       _o93293_)))
  (define std/srfi/128#comparator-check-type
    (lambda (_c93286_ _o93287_)
      (let ((_$e93289_ (std/srfi/128#comparator-test-type _c93286_ _o93287_)))
        (if _$e93289_
            _$e93289_
            (error '"Invalid argument" _c93286_ _o93287_)))))
  (define std/srfi/128#comparator-hash
    (lambda (_c93283_ _o93284_)
      ((std/srfi/128#comparator-hash-function _c93283_) _o93284_)))
  (define std/srfi/128#make-pair-comparator
    (lambda (_carc93116_ _cdrc93117_)
      (letrec ((_testf93119_
                (lambda (_o93248_)
                  (let* ((_o9324993257_ _o93248_)
                         (_else9325193265_ (lambda () '#f))
                         (_K9325393271_
                          (lambda (_b93268_ _a93269_)
                            (if (std/srfi/128#comparator-test-type
                                 _carc93116_
                                 _a93269_)
                                (std/srfi/128#comparator-test-type
                                 _cdrc93117_
                                 _b93268_)
                                '#f))))
                    (if (let () (declare (not safe)) (##pair? _o9324993257_))
                        (let ((_hd9325493274_
                               (let ()
                                 (declare (not safe))
                                 (##car _o9324993257_)))
                              (_tl9325593276_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _o9324993257_))))
                          (let* ((_a93279_ _hd9325493274_)
                                 (_b93281_ _tl9325593276_))
                            (_K9325393271_ _b93281_ _a93279_)))
                        (_else9325193265_)))))
               (_eqf93120_
                (lambda (_a93201_ _b93202_)
                  (let ((_a9320393213_ _a93201_) (_b9320493215_ _b93202_))
                    (let* ((_E9320693219_
                            (lambda ()
                              (error '"No clause matching"
                                     _a9320393213_
                                     _b9320493215_)))
                           (_K9320793227_
                            (lambda (_a293222_ _a193223_ _b293224_ _b193225_)
                              (if ((##direct-structure-ref
                                    _carc93116_
                                    '2
                                    std/srfi/128#comparator::t
                                    '#f)
                                   _a193223_
                                   _b193225_)
                                  ((##direct-structure-ref
                                    _cdrc93117_
                                    '2
                                    std/srfi/128#comparator::t
                                    '#f)
                                   _a293222_
                                   _b293224_)
                                  '#f))))
                      (if (let () (declare (not safe)) (##pair? _a9320393213_))
                          (let ((_hd9321093230_
                                 (let ()
                                   (declare (not safe))
                                   (##car _a9320393213_)))
                                (_tl9321193232_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _a9320393213_))))
                            (let* ((_a193235_ _hd9321093230_)
                                   (_a293237_ _tl9321193232_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _b9320493215_))
                                  (let ((_hd9320893239_
                                         (let ()
                                           (declare (not safe))
                                           (##car _b9320493215_)))
                                        (_tl9320993241_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _b9320493215_))))
                                    (let* ((_b193244_ _hd9320893239_)
                                           (_b293246_ _tl9320993241_))
                                      (_K9320793227_
                                       _a293237_
                                       _a193235_
                                       _b293246_
                                       _b193244_)))
                                  (_E9320693219_))))
                          (_E9320693219_))))))
               (_orderf93121_
                (lambda (_a93154_ _b93155_)
                  (let ((_a9315693166_ _a93154_) (_b9315793168_ _b93155_))
                    (let* ((_E9315993172_
                            (lambda ()
                              (error '"No clause matching"
                                     _a9315693166_
                                     _b9315793168_)))
                           (_K9316093180_
                            (lambda (_a293175_ _a193176_ _b293177_ _b193178_)
                              (if ((##direct-structure-ref
                                    _carc93116_
                                    '2
                                    std/srfi/128#comparator::t
                                    '#f)
                                   _a193176_
                                   _b193178_)
                                  (if ((##direct-structure-ref
                                        _cdrc93117_
                                        '2
                                        std/srfi/128#comparator::t
                                        '#f)
                                       _a293175_
                                       _b293177_)
                                      '#f
                                      ((std/srfi/128#comparator-ordering-predicate
                                        _cdrc93117_)
                                       _a293175_
                                       _b293177_))
                                  ((std/srfi/128#comparator-ordering-predicate
                                    _carc93116_)
                                   _a193176_
                                   _b193178_)))))
                      (if (let () (declare (not safe)) (##pair? _a9315693166_))
                          (let ((_hd9316393183_
                                 (let ()
                                   (declare (not safe))
                                   (##car _a9315693166_)))
                                (_tl9316493185_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _a9315693166_))))
                            (let* ((_a193188_ _hd9316393183_)
                                   (_a293190_ _tl9316493185_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _b9315793168_))
                                  (let ((_hd9316193192_
                                         (let ()
                                           (declare (not safe))
                                           (##car _b9315793168_)))
                                        (_tl9316293194_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _b9315793168_))))
                                    (let* ((_b193197_ _hd9316193192_)
                                           (_b293199_ _tl9316293194_))
                                      (_K9316093180_
                                       _a293190_
                                       _a193188_
                                       _b293199_
                                       _b193197_)))
                                  (_E9315993172_))))
                          (_E9315993172_))))))
               (_hashf93122_
                (lambda (_o93124_)
                  (let* ((_o9312593132_ _o93124_)
                         (_E9312793136_
                          (lambda ()
                            (error '"No clause matching" _o9312593132_)))
                         (_K9312893142_
                          (lambda (_b93139_ _a93140_)
                            (bitwise-xor
                             (std/srfi/128#comparator-hash
                              _carc93116_
                              _a93140_)
                             (std/srfi/128#comparator-hash
                              _cdrc93117_
                              _b93139_)))))
                    (if (let () (declare (not safe)) (##pair? _o9312593132_))
                        (let ((_hd9312993145_
                               (let ()
                                 (declare (not safe))
                                 (##car _o9312593132_)))
                              (_tl9313093147_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _o9312593132_))))
                          (let* ((_a93150_ _hd9312993145_)
                                 (_b93152_ _tl9313093147_))
                            (_K9312893142_ _b93152_ _a93150_)))
                        (_E9312793136_))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           _testf93119_
           _eqf93120_
           _orderf93121_
           _hashf93122_)))))
  (define std/srfi/128#make-list-comparator
    (lambda (_elc93083_ _type-test93084_ _empty?93085_ _head93086_ _tail93087_)
      (letrec ((_testf93089_
                (lambda (_o93110_)
                  (if (_type-test93084_ _o93110_)
                      (let _lp93112_ ((_o93114_ _o93110_))
                        (if (_empty?93085_ _o93114_)
                            '#t
                            (if (std/srfi/128#comparator-test-type
                                 _elc93083_
                                 (_head93086_ _o93114_))
                                (_lp93112_ (_tail93087_ _o93114_))
                                '#f)))
                      '#f)))
               (_eqf93090_
                (lambda (_a93107_ _b93108_)
                  (if (_empty?93085_ _a93107_)
                      (_empty?93085_ _b93108_)
                      (if (_empty?93085_ _b93108_)
                          '#f
                          (if ((##direct-structure-ref
                                _elc93083_
                                '2
                                std/srfi/128#comparator::t
                                '#f)
                               (_head93086_ _a93107_)
                               (_head93086_ _b93108_))
                              (_eqf93090_
                               (_tail93087_ _a93107_)
                               (_tail93087_ _b93108_))
                              '#f)))))
               (_orderf93091_
                (lambda (_a93101_ _b93102_)
                  (if (_empty?93085_ _a93101_)
                      (not (_empty?93085_ _b93102_))
                      (if (_empty?93085_ _b93102_)
                          '#f
                          (let ((_$e93104_
                                 ((##direct-structure-ref
                                   _elc93083_
                                   '3
                                   std/srfi/128#comparator::t
                                   '#f)
                                  (_head93086_ _a93101_)
                                  (_head93086_ _b93102_))))
                            (if _$e93104_
                                _$e93104_
                                (_orderf93091_
                                 (_tail93087_ _a93101_)
                                 (_tail93087_ _b93102_))))))))
               (_hashf93092_
                (lambda (_o93094_)
                  (let _lp93096_ ((_rest93098_ _o93094_) (_h93099_ '0))
                    (if (_empty?93085_ _o93094_)
                        _h93099_
                        (_lp93096_
                         (_tail93087_ _o93094_)
                         (bitwise-xor
                          _h93099_
                          (std/srfi/128#comparator-hash
                           _elc93083_
                           (_head93086_ _o93094_)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           _testf93089_
           _eqf93090_
           _orderf93091_
           _hashf93092_)))))
  (define std/srfi/128#make-vector-comparator
    (lambda (_elc93029_ _type-test93030_ _length93031_ _ref93032_)
      (letrec ((_testf93034_
                (lambda (_o93074_)
                  (if (_type-test93030_ _o93074_)
                      (let ((_len93076_ (_length93031_ _o93074_))
                            (_test93077_
                             (##direct-structure-ref
                              _elc93029_
                              '1
                              std/srfi/128#comparator::t
                              '#f)))
                        (let _lp93079_ ((_i93081_ '0))
                          (if (fx< _i93081_ _len93076_)
                              (if (_test93077_ (_ref93032_ _o93074_ _i93081_))
                                  (_lp93079_ (fx+ _i93081_ '1))
                                  '#f)
                              '#t)))
                      '#f)))
               (_eqf93035_
                (lambda (_a93063_ _b93064_)
                  (let ((_len93066_ (_length93031_ _a93063_))
                        (_lenb93067_ (_length93031_ _b93064_))
                        (_eq93068_
                         (##direct-structure-ref
                          _elc93029_
                          '2
                          std/srfi/128#comparator::t
                          '#f)))
                    (if (fx= _len93066_ _lenb93067_)
                        (let _lp93070_ ((_i93072_ '0))
                          (if (fx< _i93072_ _len93066_)
                              (if (_eq93068_
                                   (_ref93032_ _a93063_ _i93072_)
                                   (_ref93032_ _b93064_ _i93072_))
                                  (_lp93070_ (fx+ _i93072_ '1))
                                  '#f)
                              '#t))
                        '#f))))
               (_orderf93036_
                (lambda (_a93049_ _b93050_)
                  (let ((_len93052_ (_length93031_ _a93049_))
                        (_lenb93053_ (_length93031_ _b93050_))
                        (_order93054_
                         (std/srfi/128#comparator-ordering-predicate
                          _elc93029_)))
                    (if (fx< _len93052_ _lenb93053_)
                        '#t
                        (if (fx= _len93052_ _lenb93053_)
                            (let _lp93056_ ((_i93058_ '0))
                              (if (fx< _i93058_ _len93052_)
                                  (let ((_$e93060_
                                         (_order93054_
                                          (_ref93032_ _a93049_ _i93058_)
                                          (_ref93032_ _b93050_ _i93058_))))
                                    (if _$e93060_
                                        _$e93060_
                                        (_lp93056_ (fx+ _i93058_ '1))))
                                  '#f))
                            '#f)))))
               (_hashf93037_
                (lambda (_o93039_)
                  (let ((_len93041_ (_length93031_ _o93039_))
                        (_hash93042_
                         (std/srfi/128#comparator-hash-function _elc93029_)))
                    (let _lp93044_ ((_i93046_ '0) (_h93047_ '0))
                      (if (fx< _i93046_ _len93041_)
                          (_lp93044_
                           (fx+ _i93046_ '1)
                           (bitwise-xor
                            (_hash93042_ (_ref93032_ _o93039_ _i93046_))))
                          _h93047_))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           _testf93034_
           _eqf93035_
           _orderf93036_
           _hashf93037_)))))
  (define std/srfi/128#*eq-comparator*
    (let ()
      (declare (not safe))
      (##structure std/srfi/128#comparator::t true eq? '#f eq?-hash)))
  (define std/srfi/128#make-eq-comparator
    (lambda () std/srfi/128#*eq-comparator*))
  (define std/srfi/128#*eqv-comparator*
    (let ()
      (declare (not safe))
      (##structure std/srfi/128#comparator::t true eqv? '#f eqv?-hash)))
  (define std/srfi/128#make-eqv-comparator
    (lambda () std/srfi/128#*eqv-comparator*))
  (define std/srfi/128#*equal-comparator*
    (let ()
      (declare (not safe))
      (##structure std/srfi/128#comparator::t true equal? '#f equal?-hash)))
  (define std/srfi/128#make-equal-comparator
    (lambda () std/srfi/128#*equal-comparator*))
  (define std/srfi/128#boolean-hash (lambda (_o93024_) (if _o93024_ '1 '0)))
  (define std/srfi/128#char-hash (lambda (_o93022_) (eq?-hash _o93022_)))
  (define std/srfi/128#char-ci-hash
    (lambda (_o93020_) (eq?-hash (char-upcase _o93020_))))
  (define std/srfi/128#default-order
    (lambda (_a93017_ _b93018_)
      (std/srfi/128#:less::apply__1 _a93017_ _b93018_)))
  (define std/srfi/128#*default-comparator*
    (let ()
      (declare (not safe))
      (##structure
       std/srfi/128#comparator::t
       true
       equal?
       std/srfi/128#default-order
       equal?-hash)))
  (define std/srfi/128#make-default-comparator
    (lambda () std/srfi/128#*default-comparator*))
  (define std/srfi/128#*moar-comparators* '())
  (define std/srfi/128#comparator-register-default!
    (lambda (_cmp93014_)
      (set! std/srfi/128#*moar-comparators*
            (cons _cmp93014_ std/srfi/128#*moar-comparators*))))
  (define std/srfi/128#:less::t
    (let ((__obj295108 (make-object std/generic/dispatch#generic::t '4)))
      (std/generic/dispatch#generic:::init!__%
       __obj295108
       ':less
       (lambda (_a92972_ _b92973_)
         (let _lp92975_ ((_rest92977_ std/srfi/128#*moar-comparators*))
           (let* ((_rest9297892986_ _rest92977_)
                  (_else9298092994_
                   (lambda ()
                     (string<?
                      (symbol->string (std/generic/dispatch#type-of _a92972_))
                      (symbol->string
                       (std/generic/dispatch#type-of _b92973_)))))
                  (_K9298293002_
                   (lambda (_rest92997_ _cmp92998_)
                     (let ((_testf93000_
                            (##direct-structure-ref
                             _cmp92998_
                             '1
                             std/srfi/128#comparator::t
                             '#f)))
                       (if (and (_testf93000_ _a92972_)
                                (_testf93000_ _b92973_))
                           ((std/srfi/128#comparator-ordering-predicate
                             _cmp92998_)
                            _a92972_
                            _b92973_)
                           (_lp92975_ _rest92997_))))))
             (if (let () (declare (not safe)) (##pair? _rest9297892986_))
                 (let ((_hd9298393005_
                        (let () (declare (not safe)) (##car _rest9297892986_)))
                       (_tl9298493007_
                        (let ()
                          (declare (not safe))
                          (##cdr _rest9297892986_))))
                   (let* ((_cmp93010_ _hd9298393005_)
                          (_rest93012_ _tl9298493007_))
                     (_K9298293002_ _rest93012_ _cmp93010_)))
                 (_else9298092994_))))))
      __obj295108))
  (define std/srfi/128#:less::apply__0
    (lambda (_arg192951_)
      (std/generic/dispatch#generic-dispatch1
       std/srfi/128#:less::t
       _arg192951_)))
  (define std/srfi/128#:less::apply__1
    (lambda (_arg192954_ _arg292955_)
      (std/generic/dispatch#generic-dispatch2
       std/srfi/128#:less::t
       _arg192954_
       _arg292955_)))
  (define std/srfi/128#:less::apply__2
    (lambda (_arg192958_ _arg292959_ _arg392960_)
      (std/generic/dispatch#generic-dispatch3
       std/srfi/128#:less::t
       _arg192958_
       _arg292959_
       _arg392960_)))
  (define std/srfi/128#:less::apply__3
    (lambda (_arg192963_ _arg292964_ _arg392965_ _arg492966_)
      (std/generic/dispatch#generic-dispatch4
       std/srfi/128#:less::t
       _arg192963_
       _arg292964_
       _arg392965_
       _arg492966_)))
  (define std/srfi/128#:less::apply__4
    (lambda _args92969_
      (apply std/generic/dispatch#generic-dispatch
             std/srfi/128#:less::t
             _args92969_)))
  (define std/srfi/128#:less::apply
    (lambda _g295110_
      (let ((_g295109_ (let () (declare (not safe)) (##length _g295110_))))
        (cond ((let () (declare (not safe)) (##fx= _g295109_ 1))
               (apply std/srfi/128#:less::apply__0 _g295110_))
              ((let () (declare (not safe)) (##fx= _g295109_ 2))
               (apply std/srfi/128#:less::apply__1 _g295110_))
              ((let () (declare (not safe)) (##fx= _g295109_ 3))
               (apply std/srfi/128#:less::apply__2 _g295110_))
              ((let () (declare (not safe)) (##fx= _g295109_ 4))
               (apply std/srfi/128#:less::apply__3 _g295110_))
              (#t (apply std/srfi/128#:less::apply__4 _g295110_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/128#:less::apply
                _g295110_))))))
  (define std/srfi/128#:less::<null>::<pair> (lambda (_a92948_ _b92949_) '#t))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(null t) (cons '(pair t) '()))
   std/srfi/128#:less::<null>::<pair>)
  (define std/srfi/128#:less::<pair>::<null> (lambda (_a92862_ _b92863_) '#f))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(pair t) (cons '(null t) '()))
   std/srfi/128#:less::<pair>::<null>)
  (define std/srfi/128#:less::<pair>::<pair>
    (lambda (_a92722_ _b92723_)
      (let _lp92725_ ((_a92727_ _a92722_) (_b92728_ _b92723_))
        (let ((_a9272992740_ _a92727_) (_b9273092742_ _b92728_))
          (let* ((_else9273292750_
                  (lambda () (if (pair? _a92727_) '#f (not (null? _b92728_)))))
                 (_K9273492758_
                  (lambda (_b192753_ _a192754_ _b292755_ _a292756_)
                    (if (equal? _a192754_ _a292756_)
                        (_lp92725_ _b192753_ _b292755_)
                        (std/srfi/128#:less::apply__1 _a192754_ _a292756_)))))
            (if (let () (declare (not safe)) (##pair? _a9272992740_))
                (let ((_hd9273792761_
                       (let () (declare (not safe)) (##car _a9272992740_)))
                      (_tl9273892763_
                       (let () (declare (not safe)) (##cdr _a9272992740_))))
                  (let* ((_a192766_ _hd9273792761_) (_b192768_ _tl9273892763_))
                    (if (let () (declare (not safe)) (##pair? _b9273092742_))
                        (let ((_hd9273592770_
                               (let ()
                                 (declare (not safe))
                                 (##car _b9273092742_)))
                              (_tl9273692772_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _b9273092742_))))
                          (let* ((_a292775_ _hd9273592770_)
                                 (_b292777_ _tl9273692772_))
                            (_K9273492758_
                             _b192768_
                             _a192766_
                             _b292777_
                             _a292775_)))
                        (_else9273292750_))))
                (_else9273292750_)))))))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(pair t) (cons '(pair t) '()))
   std/srfi/128#:less::<pair>::<pair>)
  (define std/srfi/128#:less::<boolean>::<boolean>
    (lambda (_a92636_ _b92637_) (if _a92636_ '#f _b92637_)))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(boolean t) (cons '(boolean t) '()))
   std/srfi/128#:less::<boolean>::<boolean>)
  (define std/srfi/128#:less::<char>::<char>
    (lambda (_a92550_ _b92551_) (char<? _a92550_ _b92551_)))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(char t) (cons '(char t) '()))
   std/srfi/128#:less::<char>::<char>)
  (define std/srfi/128#:less::<string>::<string>
    (lambda (_a92464_ _b92465_) (string<? _a92464_ _b92465_)))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(string t) (cons '(string t) '()))
   std/srfi/128#:less::<string>::<string>)
  (define std/srfi/128#:less::<symbol>::<symbol>
    (lambda (_a92378_ _b92379_)
      (string<? (symbol->string _a92378_) (symbol->string _b92379_))))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(symbol t) (cons '(symbol t) '()))
   std/srfi/128#:less::<symbol>::<symbol>)
  (define std/srfi/128#:less::<keyword>::<keyword>
    (lambda (_a92292_ _b92293_)
      (string<? (keyword->string _a92292_) (keyword->string _b92293_))))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(keyword t) (cons '(keyword t) '()))
   std/srfi/128#:less::<keyword>::<keyword>)
  (define std/srfi/128#:less::<vector>::<vector>
    (lambda (_a92196_ _b92197_)
      (let ((_len92199_
             (let () (declare (not safe)) (##vector-length _a92196_)))
            (_lenb92200_
             (let () (declare (not safe)) (##vector-length _b92197_))))
        (if (let () (declare (not safe)) (##fx= _len92199_ _lenb92200_))
            (let _lp92202_ ((_i92204_ '0))
              (if (let () (declare (not safe)) (##fx< _i92204_ _len92199_))
                  (let ((_$e92206_
                         (std/srfi/128#:less::apply__1
                          (let ()
                            (declare (not safe))
                            (##vector-ref _a92196_ _i92204_))
                          (let ()
                            (declare (not safe))
                            (##vector-ref _b92197_ _i92204_)))))
                    (if _$e92206_
                        _$e92206_
                        (_lp92202_
                         (let () (declare (not safe)) (##fx+ _i92204_ '1)))))
                  '#f))
            (let () (declare (not safe)) (##fx< _len92199_ _lenb92200_))))))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(vector t) (cons '(vector t) '()))
   std/srfi/128#:less::<vector>::<vector>)
  (define std/srfi/128#:less::<u8vector>::<u8vector>
    (lambda (_a92100_ _b92101_)
      (let ((_len92103_
             (let () (declare (not safe)) (##u8vector-length _a92100_)))
            (_lenb92104_
             (let () (declare (not safe)) (##u8vector-length _b92101_))))
        (if (let () (declare (not safe)) (##fx= _len92103_ _lenb92104_))
            (let _lp92106_ ((_i92108_ '0))
              (if (let () (declare (not safe)) (##fx< _i92108_ _len92103_))
                  (let ((_$e92110_
                         (std/srfi/128#:less::apply__1
                          (let ()
                            (declare (not safe))
                            (##u8vector-ref _a92100_ _i92108_))
                          (let ()
                            (declare (not safe))
                            (##u8vector-ref _b92101_ _i92108_)))))
                    (if _$e92110_
                        _$e92110_
                        (_lp92106_
                         (let () (declare (not safe)) (##fx+ _i92108_ '1)))))
                  '#f))
            (let () (declare (not safe)) (##fx< _len92103_ _lenb92104_))))))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(u8vector t) (cons '(u8vector t) '()))
   std/srfi/128#:less::<u8vector>::<u8vector>)
  (define std/srfi/128#:less::<number>::<number>
    (lambda (_a92011_ _b92012_)
      (let ((_ra92014_ (real-part _a92011_)) (_rb92015_ (real-part _b92012_)))
        (if (< _ra92014_ _rb92015_)
            '#t
            (if (= _ra92014_ _rb92015_)
                (< (imag-part _a92011_) (imag-part _b92012_))
                '#f)))))
  (std/generic/dispatch#generic-bind!
   std/srfi/128#:less::t
   (cons '(number t) (cons '(number t) '()))
   std/srfi/128#:less::<number>::<number>)
  (define std/srfi/128#=?
    (lambda (_cmp91884_ _o91885_ . _rest91886_)
      (let ((_eqf91888_
             (##direct-structure-ref
              _cmp91884_
              '2
              std/srfi/128#comparator::t
              '#f)))
        (let _lp91890_ ((_rest91892_ _rest91886_) (_o191893_ _o91885_))
          (let* ((_rest9189491902_ _rest91892_)
                 (_else9189691910_ (lambda () '#t))
                 (_K9189891916_
                  (lambda (_rest91913_ _o291914_)
                    (if (_eqf91888_ _o191893_ _o291914_)
                        (_lp91890_ _rest91913_ _o291914_)
                        '#f))))
            (if (let () (declare (not safe)) (##pair? _rest9189491902_))
                (let ((_hd9189991919_
                       (let () (declare (not safe)) (##car _rest9189491902_)))
                      (_tl9190091921_
                       (let () (declare (not safe)) (##cdr _rest9189491902_))))
                  (let* ((_o291924_ _hd9189991919_)
                         (_rest91926_ _tl9190091921_))
                    (_K9189891916_ _rest91926_ _o291924_)))
                (_else9189691910_)))))))
  (define std/srfi/128#<?
    (lambda (_cmp91840_ _o91841_ . _rest91842_)
      (let ((_orderf91844_
             (std/srfi/128#comparator-ordering-predicate _cmp91840_)))
        (let _lp91846_ ((_rest91848_ _rest91842_) (_o191849_ _o91841_))
          (let* ((_rest9185091858_ _rest91848_)
                 (_else9185291866_ (lambda () '#t))
                 (_K9185491872_
                  (lambda (_rest91869_ _o291870_)
                    (if (_orderf91844_ _o191849_ _o291870_)
                        (_lp91846_ _rest91869_ _o291870_)
                        '#f))))
            (if (let () (declare (not safe)) (##pair? _rest9185091858_))
                (let ((_hd9185591875_
                       (let () (declare (not safe)) (##car _rest9185091858_)))
                      (_tl9185691877_
                       (let () (declare (not safe)) (##cdr _rest9185091858_))))
                  (let* ((_o291880_ _hd9185591875_)
                         (_rest91882_ _tl9185691877_))
                    (_K9185491872_ _rest91882_ _o291880_)))
                (_else9185291866_)))))))
  (define std/srfi/128#<=?
    (lambda (_cmp91792_ _o91793_ . _rest91794_)
      (let ((_eqf91796_
             (##direct-structure-ref
              _cmp91792_
              '2
              std/srfi/128#comparator::t
              '#f))
            (_orderf91797_
             (std/srfi/128#comparator-ordering-predicate _cmp91792_)))
        (let _lp91799_ ((_rest91801_ _rest91794_) (_o191802_ _o91793_))
          (let* ((_rest9180391811_ _rest91801_)
                 (_else9180591819_ (lambda () '#t))
                 (_K9180791828_
                  (lambda (_rest91822_ _o291823_)
                    (if (or (_eqf91796_ _o191802_ _o291823_)
                            (_orderf91797_ _o191802_ _o291823_))
                        (_lp91799_ _rest91822_ _o291823_)
                        '#f))))
            (if (let () (declare (not safe)) (##pair? _rest9180391811_))
                (let ((_hd9180891831_
                       (let () (declare (not safe)) (##car _rest9180391811_)))
                      (_tl9180991833_
                       (let () (declare (not safe)) (##cdr _rest9180391811_))))
                  (let* ((_o291836_ _hd9180891831_)
                         (_rest91838_ _tl9180991833_))
                    (_K9180791828_ _rest91838_ _o291836_)))
                (_else9180591819_)))))))
  (define std/srfi/128#>?
    (lambda (_cmp91789_ . _args91790_)
      (apply std/srfi/128#<? _cmp91789_ (reverse _args91790_))))
  (define std/srfi/128#>=?
    (lambda (_cmp91786_ . _args91787_)
      (apply std/srfi/128#<=? _cmp91786_ (reverse _args91787_)))))
