(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/146#make-tree
    (lambda (_cmp109711_)
      (let ((__obj302769 (make-object std/misc/rbtree#rbtree::t '2)))
        (std/misc/rbtree#rbtree:::init!__0
         __obj302769
         (lambda (_a109713_ _b109714_)
           (let ((_c109716_ _cmp109711_)
                 (_o1109718_ _a109713_)
                 (_o2109720_ _b109714_))
             (if ((std/srfi/128#comparator-ordering-predicate _c109716_)
                  _o1109718_
                  _o2109720_)
                 '-1
                 (if ((##direct-structure-ref
                       _c109716_
                       '2
                       std/srfi/128#comparator::t
                       '#f)
                      _o1109718_
                      _o2109720_)
                     '0
                     '1)))))
        __obj302769)))
  (define std/srfi/146#tree-generator
    (lambda (_rbtree109704_)
      (letrec* ((_it109706_ (std/misc/rbtree#in-rbtree _rbtree109704_)))
        (lambda ()
          (let ((_next109709_ (std/iter#iter-next! _it109706_)))
            (if (eq? _next109709_ std/iter#iter-end)
                (begin (std/iter#iter-fini! _it109706_) '#!eof)
                _next109709_))))))
  (define std/srfi/146#tree-map
    (lambda (_proc109697_ _rbtree109698_)
      (std/misc/rbtree#rbtree-fold
       (lambda (_k109700_ _v109701_ _r109702_)
         (std/misc/rbtree#rbtree-put _r109702_ _k109700_ _v109701_))
       (let ((__obj302770 (make-object std/misc/rbtree#rbtree::t '2)))
         (std/misc/rbtree#rbtree:::init!__0
          __obj302770
          (##direct-structure-ref
           _rbtree109698_
           '2
           std/misc/rbtree#rbtree::t
           '#f))
         __obj302770)
       _rbtree109698_)))
  (define std/srfi/146#tree-fold
    (lambda (_proc109693_ _iv109694_ _rbtree109695_)
      (std/misc/rbtree#rbtree-fold _proc109693_ _iv109694_ _rbtree109695_)))
  (define std/srfi/146#tree-fold/reverse
    (lambda (_proc109689_ _iv109690_ _rbtree109691_)
      (std/misc/rbtree#rbtree-foldr _proc109689_ _iv109690_ _rbtree109691_)))
  (define std/srfi/146#tree-for-each
    (lambda (_proc109686_ _rbtree109687_)
      (std/misc/rbtree#rbtree-for-each _proc109686_ _rbtree109687_)))
  (define std/srfi/146#tree-search
    (lambda (_cmp109655_
             _rbtree109656_
             _key109657_
             _failure109658_
             _success109659_)
      ((call-with-current-continuation
        (lambda (_K109661_)
          (std/misc/rbtree#rbtree-for-each
           (lambda (_k109663_ _v109664_)
             (let ((_c109666_ _cmp109655_)
                   (_o1109668_ _k109663_)
                   (_o2109670_ _key109657_))
               (if ((std/srfi/128#comparator-ordering-predicate _c109666_)
                    _o1109668_
                    _o2109670_)
                   '#!void
                   (if ((##direct-structure-ref
                         _c109666_
                         '2
                         std/srfi/128#comparator::t
                         '#f)
                        _o1109668_
                        _o2109670_)
                       (_K109661_
                        (lambda ()
                          (_success109659_
                           _k109663_
                           _v109664_
                           (lambda (_new-key109674_
                                    _new-value109675_
                                    _obj109676_)
                             (values (std/misc/rbtree#rbtree-put
                                      (std/misc/rbtree#rbtree-remove
                                       _rbtree109656_
                                       _k109663_)
                                      _new-key109674_
                                      _new-value109675_)
                                     _obj109676_))
                           (lambda (_obj109678_)
                             (values (std/misc/rbtree#rbtree-remove
                                      _rbtree109656_
                                      _k109663_)
                                     _obj109678_)))))
                       (_K109661_
                        (lambda ()
                          (_failure109658_
                           _k109663_
                           _v109664_
                           (lambda (_value109681_ _obj109682_)
                             (values (std/misc/rbtree#rbtree-put
                                      _rbtree109656_
                                      _key109657_
                                      _value109681_)
                                     _obj109682_))
                           (lambda (_obj109684_)
                             (values _rbtree109656_ _obj109684_)))))))))
           _rbtree109656_))))))
  (define std/srfi/146#tree-catenate
    (lambda (_rbtree1109646_
             _pivot-key109647_
             _pivot-value109648_
             _rbtree2109649_)
      (std/misc/rbtree#rbtree-fold
       (lambda (_k109651_ _v109652_ _r109653_)
         (std/misc/rbtree#rbtree-put _r109653_ _k109651_ _v109652_))
       (std/misc/rbtree#rbtree-put
        _rbtree1109646_
        _pivot-key109647_
        _pivot-value109648_)
       _rbtree2109649_)))
  (define std/srfi/146#tree-split
    (lambda (_cmp109626_ _rbtree109627_ _obj109628_)
      (letrec* ((_tree<109630_ (std/srfi/146#make-tree _cmp109626_))
                (_tree<=109631_ (std/srfi/146#make-tree _cmp109626_))
                (_tree=109632_ (std/srfi/146#make-tree _cmp109626_))
                (_tree>=109633_ (std/srfi/146#make-tree _cmp109626_))
                (_tree>109634_ (std/srfi/146#make-tree _cmp109626_)))
        (std/misc/rbtree#rbtree-for-each
         (lambda (_k109636_ _v109637_)
           (let ((_c109639_ _cmp109626_)
                 (_o1109641_ _k109636_)
                 (_o2109643_ _obj109628_))
             (if ((std/srfi/128#comparator-ordering-predicate _c109639_)
                  _o1109641_
                  _o2109643_)
                 (begin
                   (std/misc/rbtree#rbtree-put!
                    _tree<109630_
                    _k109636_
                    _v109637_)
                   (std/misc/rbtree#rbtree-put!
                    _tree<=109631_
                    _k109636_
                    _v109637_))
                 (if ((##direct-structure-ref
                       _c109639_
                       '2
                       std/srfi/128#comparator::t
                       '#f)
                      _o1109641_
                      _o2109643_)
                     (begin
                       (std/misc/rbtree#rbtree-put!
                        _tree<=109631_
                        _k109636_
                        _v109637_)
                       (std/misc/rbtree#rbtree-put!
                        _tree=109632_
                        _k109636_
                        _v109637_)
                       (std/misc/rbtree#rbtree-put!
                        _tree>=109633_
                        _k109636_
                        _v109637_))
                     (begin
                       (std/misc/rbtree#rbtree-put!
                        _tree>=109633_
                        _k109636_
                        _v109637_)
                       (std/misc/rbtree#rbtree-put!
                        _tree>109634_
                        _k109636_
                        _v109637_))))))
         _rbtree109627_)
        (values _tree<109630_
                _tree<=109631_
                _tree=109632_
                _tree>=109633_
                _tree>109634_))))
  (define std/srfi/146#tree-key-predecessor
    (lambda (_cmp109606_ _rbtree109607_ _obj109608_ _failure109609_)
      ((call-with-current-continuation
        (lambda (_K109611_)
          (letrec* ((_prev109613_ '#f))
            (std/misc/rbtree#rbtree-for-each
             (lambda (_k109615_ _v109616_)
               (let ((_c109618_ _cmp109606_)
                     (_o1109620_ _k109615_)
                     (_o2109622_ _obj109608_))
                 (if ((std/srfi/128#comparator-ordering-predicate _c109618_)
                      _o1109620_
                      _o2109622_)
                     (set! _prev109613_ _k109615_)
                     (if ((##direct-structure-ref
                           _c109618_
                           '2
                           std/srfi/128#comparator::t
                           '#f)
                          _o1109620_
                          _o2109622_)
                         (_K109611_
                          (if _prev109613_
                              (lambda () _prev109613_)
                              _failure109609_))
                         _failure109609_))))
             _rbtree109607_)
            _failure109609_))))))
  (define std/srfi/146#tree-key-successor
    (lambda (_cmp109586_ _rbtree109587_ _obj109588_ _failure109589_)
      ((call-with-current-continuation
        (lambda (_K109591_)
          (letrec* ((_suc109593_ '#f))
            (std/misc/rbtree#rbtree-for-each
             (lambda (_k109595_ _v109596_)
               (let ((_c109598_ _cmp109586_)
                     (_o1109600_ _k109595_)
                     (_o2109602_ _obj109588_))
                 (if ((std/srfi/128#comparator-ordering-predicate _c109598_)
                      _o1109600_
                      _o2109602_)
                     _failure109589_
                     (if ((##direct-structure-ref
                           _c109598_
                           '2
                           std/srfi/128#comparator::t
                           '#f)
                          _o1109600_
                          _o2109602_)
                         (_K109591_
                          (if _suc109593_
                              (lambda () _suc109593_)
                              _failure109589_))
                         (set! _suc109593_ _k109595_)))))
             _rbtree109587_)
            _failure109589_))))))
  (define std/srfi/146#<mapping>
    (make-struct-type
     'std/srfi/146#<mapping>
     '#f
     '2
     '<mapping>
     '((fields: comparator tree))
     '#f))
  (define std/srfi/146#mapping? (make-struct-predicate std/srfi/146#<mapping>))
  (define std/srfi/146#mapping-key-comparator
    (make-struct-field-accessor std/srfi/146#<mapping> '0))
  (define std/srfi/146#mapping-tree
    (make-struct-field-accessor std/srfi/146#<mapping> '1))
  (define std/srfi/146#%make-mapping
    (lambda (_comparator109583_ _tree109584_)
      (make-struct-instance
       std/srfi/146#<mapping>
       _comparator109583_
       _tree109584_)))
  (define std/srfi/146#make-empty-mapping
    (lambda (_comparator109578_)
      (let ((_val109580_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109578_
                'std/srfi/128#comparator::t))))
        (if _val109580_ _val109580_ (error)))
      (let ((__tmp302771 (std/srfi/146#make-tree _comparator109578_)))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> _comparator109578_ __tmp302771))))
  (define std/srfi/146#mapping
    (lambda (_comparator109518_ . _args109519_)
      (let ((_val109521_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109518_
                'std/srfi/128#comparator::t))))
        (if _val109521_ _val109521_ (error)))
      (let ((_rbtree109524_ (std/srfi/146#make-tree _comparator109518_)))
        (let _lp109526_ ((_rest109528_ _args109519_))
          (let* ((_rest109529109540_ _rest109528_)
                 (_E109532109544_
                  (lambda ()
                    (error '"No clause matching" _rest109529109540_))))
            (let ((_K109534109559_
                   (lambda (_rest109555_ _v109556_ _k109557_)
                     (std/misc/rbtree#rbtree-put!
                      _rbtree109524_
                      _k109557_
                      _v109556_)
                     (_lp109526_ _rest109555_)))
                  (_K109533109549_
                   (lambda ()
                     (let ()
                       (declare (not safe))
                       (##structure
                        std/srfi/146#<mapping>
                        _comparator109518_
                        _rbtree109524_)))))
              (let ((_try-match109531109552_
                     (lambda ()
                       (if (let ()
                             (declare (not safe))
                             (##null? _rest109529109540_))
                           (_K109533109549_)
                           (_E109532109544_)))))
                (if (let () (declare (not safe)) (##pair? _rest109529109540_))
                    (let ((_tl109536109564_
                           (let ()
                             (declare (not safe))
                             (##cdr _rest109529109540_)))
                          (_hd109535109562_
                           (let ()
                             (declare (not safe))
                             (##car _rest109529109540_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl109536109564_))
                          (let ((_tl109538109571_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl109536109564_)))
                                (_hd109537109569_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl109536109564_))))
                            (let ((_k109567_ _hd109535109562_)
                                  (_v109574_ _hd109537109569_)
                                  (_rest109576_ _tl109538109571_))
                              (_K109534109559_
                               _rest109576_
                               _v109574_
                               _k109567_)))
                          (_E109532109544_)))
                    (_try-match109531109552_)))))))))
  (define std/srfi/146#mapping-unfold
    (lambda (_stop?109492_
             _mapper109493_
             _successor109494_
             _seed109495_
             _comparator109496_)
      (let ((_val109498_ (procedure? _stop?109492_)))
        (if _val109498_ _val109498_ (error)))
      (let ((_val109501_ (procedure? _mapper109493_)))
        (if _val109501_ _val109501_ (error)))
      (let ((_val109504_ (procedure? _successor109494_)))
        (if _val109504_ _val109504_ (error)))
      (let ((_val109507_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109496_
                'std/srfi/128#comparator::t))))
        (if _val109507_ _val109507_ (error)))
      (let _loop109510_ ((_mapping109512_
                          (std/srfi/146#make-empty-mapping _comparator109496_))
                         (_seed109513_ _seed109495_))
        (if (_stop?109492_ _seed109513_)
            _mapping109512_
            (let ((_g302772_ (_mapper109493_ _seed109513_)))
              (begin
                (let ((_g302773_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g302772_)
                             (##vector-length _g302772_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g302773_ 2)))
                      (error "Context expects 2 values" _g302773_)))
                (let ((_key109515_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g302772_ 0)))
                      (_value109516_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g302772_ 1))))
                  (_loop109510_
                   (std/srfi/146#mapping-adjoin
                    _mapping109512_
                    _key109515_
                    _value109516_)
                   (_successor109494_ _seed109513_)))))))))
  (define std/srfi/146#mapping/ordered std/srfi/146#mapping)
  (define std/srfi/146#mapping-unfold/ordered std/srfi/146#mapping-unfold)
  (define std/srfi/146#mapping-empty?
    (lambda (_mapping109484_)
      (let ((_val109486_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109484_
                'std/srfi/146#<mapping>))))
        (if _val109486_ _val109486_ (error)))
      (not (std/srfi/146#mapping-any?
            (lambda (_key109489_ _value109490_) '#t)
            _mapping109484_))))
  (define std/srfi/146#mapping-contains?
    (lambda (_mapping109476_ _key109477_)
      (let ((_val109479_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109476_
                'std/srfi/146#<mapping>))))
        (if _val109479_ _val109479_ (error)))
      (let ((_val109482_
             (std/misc/rbtree#rbtree-ref__%
              (##structure-ref _mapping109476_ '2 std/srfi/146#<mapping> '#f)
              _key109477_
              absent-value)))
        (not (eq? _val109482_ absent-value)))))
  (define std/srfi/146#mapping-disjoint?
    (lambda (_mapping1109462_ _mapping2109463_)
      (let ((_val109465_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1109462_
                'std/srfi/146#<mapping>))))
        (if _val109465_ _val109465_ (error)))
      (let ((_val109468_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2109463_
                'std/srfi/146#<mapping>))))
        (if _val109468_ _val109468_ (error)))
      (call-with-current-continuation
       (lambda (_return109471_)
         (std/srfi/146#mapping-for-each
          (lambda (_key109473_ _value109474_)
            (if (std/srfi/146#mapping-contains? _mapping2109463_ _key109473_)
                (_return109471_ '#f)
                '#!void))
          _mapping1109462_)
         '#t))))
  (define std/srfi/146#mapping-ref__0
    (lambda (_mapping109427_ _key109428_)
      (let ((_val109430_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109427_
                'std/srfi/146#<mapping>))))
        (if _val109430_ _val109430_ (error)))
      (std/srfi/146#mapping-ref__1
       _mapping109427_
       _key109428_
       (lambda () (error '"mapping-ref: key not in mapping" _key109428_)))))
  (define std/srfi/146#mapping-ref__1
    (lambda (_mapping109434_ _key109435_ _failure109436_)
      (let ((_val109438_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109434_
                'std/srfi/146#<mapping>))))
        (if _val109438_ _val109438_ (error)))
      (let ((_val109441_ (procedure? _failure109436_)))
        (if _val109441_ _val109441_ (error)))
      (std/srfi/146#mapping-ref__2
       _mapping109434_
       _key109435_
       _failure109436_
       (lambda (_value109444_) _value109444_))))
  (define std/srfi/146#mapping-ref__2
    (lambda (_mapping109446_ _key109447_ _failure109448_ _success109449_)
      (let ((_val109451_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109446_
                'std/srfi/146#<mapping>))))
        (if _val109451_ _val109451_ (error)))
      (let ((_val109454_ (procedure? _failure109448_)))
        (if _val109454_ _val109454_ (error)))
      (let ((_val109457_ (procedure? _success109449_)))
        (if _val109457_ _val109457_ (error)))
      (let ((_val109460_
             (std/misc/rbtree#rbtree-ref__%
              (##structure-ref _mapping109446_ '2 std/srfi/146#<mapping> '#f)
              _key109447_
              absent-value)))
        (if (eq? _val109460_ absent-value)
            (_failure109448_)
            (_success109449_ _val109460_)))))
  (define std/srfi/146#mapping-ref
    (lambda _g302775_
      (let ((_g302774_ (let () (declare (not safe)) (##length _g302775_))))
        (cond ((let () (declare (not safe)) (##fx= _g302774_ 2))
               (apply std/srfi/146#mapping-ref__0 _g302775_))
              ((let () (declare (not safe)) (##fx= _g302774_ 3))
               (apply std/srfi/146#mapping-ref__1 _g302775_))
              ((let () (declare (not safe)) (##fx= _g302774_ 4))
               (apply std/srfi/146#mapping-ref__2 _g302775_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-ref
                _g302775_))))))
  (define std/srfi/146#mapping-ref/default
    (lambda (_mapping109419_ _key109420_ _default109421_)
      (let ((_val109423_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109419_
                'std/srfi/146#<mapping>))))
        (if _val109423_ _val109423_ (error)))
      (std/srfi/146#mapping-ref__1
       _mapping109419_
       _key109420_
       (lambda () _default109421_))))
  (define std/srfi/146#mapping-adjoin
    (lambda (_mapping109360_ . _args109361_)
      (let ((_val109363_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109360_
                'std/srfi/146#<mapping>))))
        (if _val109363_ _val109363_ (error)))
      (let _lp109366_ ((_rest109368_ _args109361_)
                       (_rbtree109369_
                        (##structure-ref
                         _mapping109360_
                         '2
                         std/srfi/146#<mapping>
                         '#f)))
        (let* ((_rest109370109381_ _rest109368_)
               (_E109373109385_
                (lambda () (error '"No clause matching" _rest109370109381_))))
          (let ((_K109375109400_
                 (lambda (_rest109396_ _v109397_ _k109398_)
                   (if (eq? absent-value
                            (std/misc/rbtree#rbtree-ref__%
                             _rbtree109369_
                             _k109398_
                             absent-value))
                       (_lp109366_
                        _rest109396_
                        (std/misc/rbtree#rbtree-put
                         _k109398_
                         _v109397_
                         _rbtree109369_))
                       (_lp109366_ _rest109396_ _rbtree109369_))))
                (_K109374109390_
                 (lambda ()
                   (let ((__tmp302776
                          (std/srfi/146#mapping-comparator _mapping109360_)))
                     (declare (not safe))
                     (##structure
                      std/srfi/146#<mapping>
                      __tmp302776
                      _rbtree109369_)))))
            (let ((_try-match109372109393_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _rest109370109381_))
                         (_K109374109390_)
                         (_E109373109385_)))))
              (if (let () (declare (not safe)) (##pair? _rest109370109381_))
                  (let ((_tl109377109405_
                         (let ()
                           (declare (not safe))
                           (##cdr _rest109370109381_)))
                        (_hd109376109403_
                         (let ()
                           (declare (not safe))
                           (##car _rest109370109381_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl109377109405_))
                        (let ((_tl109379109412_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl109377109405_)))
                              (_hd109378109410_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl109377109405_))))
                          (let ((_k109408_ _hd109376109403_)
                                (_v109415_ _hd109378109410_)
                                (_rest109417_ _tl109379109412_))
                            (_K109375109400_
                             _rest109417_
                             _v109415_
                             _k109408_)))
                        (_E109373109385_)))
                  (_try-match109372109393_))))))))
  (define std/srfi/146#mapping-adjoin! std/srfi/146#mapping-adjoin)
  (define std/srfi/146#mapping-set
    (lambda (_mapping109301_ . _args109302_)
      (let ((_val109304_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109301_
                'std/srfi/146#<mapping>))))
        (if _val109304_ _val109304_ (error)))
      (let _lp109307_ ((_rest109309_ _args109302_)
                       (_rbtree109310_
                        (##structure-ref
                         _mapping109301_
                         '2
                         std/srfi/146#<mapping>
                         '#f)))
        (let* ((_rest109311109322_ _rest109309_)
               (_E109314109326_
                (lambda () (error '"No clause matching" _rest109311109322_))))
          (let ((_K109316109341_
                 (lambda (_rest109337_ _v109338_ _k109339_)
                   (_lp109307_
                    _rest109337_
                    (std/misc/rbtree#rbtree-put
                     _rbtree109310_
                     _k109339_
                     _v109338_))))
                (_K109315109331_
                 (lambda ()
                   (let ((__tmp302777
                          (std/srfi/146#mapping-comparator _mapping109301_)))
                     (declare (not safe))
                     (##structure
                      std/srfi/146#<mapping>
                      __tmp302777
                      _rbtree109310_)))))
            (let ((_try-match109313109334_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _rest109311109322_))
                         (_K109315109331_)
                         (_E109314109326_)))))
              (if (let () (declare (not safe)) (##pair? _rest109311109322_))
                  (let ((_tl109318109346_
                         (let ()
                           (declare (not safe))
                           (##cdr _rest109311109322_)))
                        (_hd109317109344_
                         (let ()
                           (declare (not safe))
                           (##car _rest109311109322_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl109318109346_))
                        (let ((_tl109320109353_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl109318109346_)))
                              (_hd109319109351_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl109318109346_))))
                          (let ((_k109349_ _hd109317109344_)
                                (_v109356_ _hd109319109351_)
                                (_rest109358_ _tl109320109353_))
                            (_K109316109341_
                             _rest109358_
                             _v109356_
                             _k109349_)))
                        (_E109314109326_)))
                  (_try-match109313109334_))))))))
  (define std/srfi/146#mapping-set! std/srfi/146#mapping-set)
  (define std/srfi/146#mapping-replace
    (lambda (_mapping109294_ _key109295_ _value109296_)
      (let ((_val109298_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109294_
                'std/srfi/146#<mapping>))))
        (if _val109298_ _val109298_ (error)))
      (let ((__tmp302779 (std/srfi/146#mapping-comparator _mapping109294_))
            (__tmp302778
             (std/misc/rbtree#rbtree-put
              (##structure-ref _mapping109294_ '2 std/srfi/146#<mapping> '#f)
              _key109295_
              _value109296_)))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> __tmp302779 __tmp302778))))
  (define std/srfi/146#mapping-replace! std/srfi/146#mapping-replace)
  (define std/srfi/146#mapping-delete
    (lambda (_mapping109288_ . _keys109289_)
      (let ((_val109291_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109288_
                'std/srfi/146#<mapping>))))
        (if _val109291_ _val109291_ (error)))
      (std/srfi/146#mapping-delete-all _mapping109288_ _keys109289_)))
  (define std/srfi/146#mapping-delete! std/srfi/146#mapping-delete)
  (define std/srfi/146#mapping-delete-all
    (lambda (_mapping109276_ _keys109277_)
      (let ((_val109279_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109276_
                'std/srfi/146#<mapping>))))
        (if _val109279_ _val109279_ (error)))
      (let ((_val109282_ (list? _keys109277_)))
        (if _val109282_ _val109282_ (error)))
      (let ((__tmp302781 (std/srfi/146#mapping-comparator _mapping109276_))
            (__tmp302780
             (foldl1 (lambda (_key109285_ _rbtree109286_)
                       (std/misc/rbtree#rbtree-remove
                        _rbtree109286_
                        _key109285_))
                     (##structure-ref
                      _mapping109276_
                      '2
                      std/srfi/146#<mapping>
                      '#f)
                     _keys109277_)))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> __tmp302781 __tmp302780))))
  (define std/srfi/146#mapping-delete-all! std/srfi/146#mapping-delete-all)
  (define std/srfi/146#mapping-intern
    (lambda (_mapping109262_ _key109263_ _failure109264_)
      (let ((_val109266_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109262_
                'std/srfi/146#<mapping>))))
        (if _val109266_ _val109266_ (error)))
      (let ((_val109269_ (procedure? _failure109264_)))
        (if _val109269_ _val109269_ (error)))
      (let ((_val109272_
             (std/misc/rbtree#rbtree-ref__%
              (##structure-ref _mapping109262_ '2 std/srfi/146#<mapping> '#f)
              _key109263_
              absent-value)))
        (if (eq? _val109272_ absent-value)
            (let ((_val109274_ (_failure109264_)))
              (values (let ((__tmp302783
                             (std/srfi/146#mapping-comparator _mapping109262_))
                            (__tmp302782
                             (std/misc/rbtree#rbtree-put
                              (##structure-ref
                               _mapping109262_
                               '2
                               std/srfi/146#<mapping>
                               '#f)
                              _key109263_
                              _val109274_)))
                        (declare (not safe))
                        (##structure
                         std/srfi/146#<mapping>
                         __tmp302783
                         __tmp302782))
                      _val109274_))
            (values _mapping109262_ _val109272_)))))
  (define std/srfi/146#mapping-intern! std/srfi/146#mapping-intern)
  (define std/srfi/146#mapping-update__0
    (lambda (_mapping109232_ _key109233_ _updater109234_)
      (std/srfi/146#mapping-update__1
       _mapping109232_
       _key109233_
       _updater109234_
       (lambda ()
         (error '"mapping-update: key not found in mapping" _key109233_)))))
  (define std/srfi/146#mapping-update__1
    (lambda (_mapping109237_ _key109238_ _updater109239_ _failure109240_)
      (std/srfi/146#mapping-update__2
       _mapping109237_
       _key109238_
       _updater109239_
       _failure109240_
       (lambda (_value109242_) _value109242_))))
  (define std/srfi/146#mapping-update__2
    (lambda (_mapping109244_
             _key109245_
             _updater109246_
             _failure109247_
             _success109248_)
      (let ((_val109250_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109244_
                'std/srfi/146#<mapping>))))
        (if _val109250_ _val109250_ (error)))
      (let ((_val109253_ (procedure? _updater109246_)))
        (if _val109253_ _val109253_ (error)))
      (let ((_val109256_ (procedure? _failure109247_)))
        (if _val109256_ _val109256_ (error)))
      (let ((_val109259_ (procedure? _success109248_)))
        (if _val109259_ _val109259_ (error)))
      (std/srfi/146#mapping-set
       _mapping109244_
       _key109245_
       (_updater109246_
        (std/srfi/146#mapping-ref__2
         _mapping109244_
         _key109245_
         _failure109247_
         _success109248_)))))
  (define std/srfi/146#mapping-update
    (lambda _g302785_
      (let ((_g302784_ (let () (declare (not safe)) (##length _g302785_))))
        (cond ((let () (declare (not safe)) (##fx= _g302784_ 3))
               (apply std/srfi/146#mapping-update__0 _g302785_))
              ((let () (declare (not safe)) (##fx= _g302784_ 4))
               (apply std/srfi/146#mapping-update__1 _g302785_))
              ((let () (declare (not safe)) (##fx= _g302784_ 5))
               (apply std/srfi/146#mapping-update__2 _g302785_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-update
                _g302785_))))))
  (define std/srfi/146#mapping-update! std/srfi/146#mapping-update)
  (define std/srfi/146#mapping-update/default
    (lambda (_mapping109226_ _key109227_ _updater109228_ _default109229_)
      (std/srfi/146#mapping-update__1
       _mapping109226_
       _key109227_
       _updater109228_
       (lambda () _default109229_))))
  (define std/srfi/146#mapping-update!/default
    std/srfi/146#mapping-update/default)
  (define std/srfi/146#mapping-pop__0
    (lambda (_mapping109208_)
      (std/srfi/146#mapping-pop__1
       _mapping109208_
       (lambda () (error '"mapping-pop: mapping has no association")))))
  (define std/srfi/146#mapping-pop__1
    (lambda (_mapping109211_ _failure109212_)
      (let ((_val109214_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109211_
                'std/srfi/146#<mapping>))))
        (if _val109214_ _val109214_ (error)))
      (let ((_val109217_ (procedure? _failure109212_)))
        (if _val109217_ _val109217_ (error)))
      ((call-with-current-continuation
        (lambda (_K109220_)
          (std/misc/rbtree#rbtree-for-each
           (##structure-ref _mapping109211_ '2 std/srfi/146#<mapping> '#f)
           (lambda (_k109222_ _v109223_)
             (_K109220_
              (lambda ()
                (values (let ((__tmp302787
                               (std/srfi/146#mapping-comparator
                                _mapping109211_))
                              (__tmp302786
                               (std/misc/rbtree#rbtree-remove
                                (##structure-ref
                                 _mapping109211_
                                 '2
                                 std/srfi/146#<mapping>
                                 '#f)
                                _k109222_)))
                          (declare (not safe))
                          (##structure
                           std/srfi/146#<mapping>
                           __tmp302787
                           __tmp302786))
                        _k109222_
                        _v109223_)))))
          _failure109212_)))))
  (define std/srfi/146#mapping-pop
    (lambda _g302789_
      (let ((_g302788_ (let () (declare (not safe)) (##length _g302789_))))
        (cond ((let () (declare (not safe)) (##fx= _g302788_ 1))
               (apply std/srfi/146#mapping-pop__0 _g302789_))
              ((let () (declare (not safe)) (##fx= _g302788_ 2))
               (apply std/srfi/146#mapping-pop__1 _g302789_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-pop
                _g302789_))))))
  (define std/srfi/146#mapping-pop! std/srfi/146#mapping-pop)
  (define std/srfi/146#mapping-search
    (lambda (_mapping109178_ _key109179_ _failure109180_ _success109181_)
      (let ((_val109183_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109178_
                'std/srfi/146#<mapping>))))
        (if _val109183_ _val109183_ (error)))
      (let ((_val109186_ (procedure? _failure109180_)))
        (if _val109186_ _val109186_ (error)))
      (let ((_val109189_ (procedure? _success109181_)))
        (if _val109189_ _val109189_ (error)))
      (call-with-current-continuation
       (lambda (_return109192_)
         (let* ((_comparator109194_
                 (##structure-ref
                  _mapping109178_
                  '1
                  std/srfi/146#<mapping>
                  '#f))
                (_g302790_
                 (std/srfi/146#tree-search
                  _comparator109194_
                  (##structure-ref
                   _mapping109178_
                   '2
                   std/srfi/146#<mapping>
                   '#f)
                  _key109179_
                  (lambda (_insert109196_ _ignore109197_)
                    (_failure109180_
                     (lambda (_value109199_ _obj109200_)
                       (_insert109196_ _key109179_ _value109199_ _obj109200_))
                     (lambda (_obj109202_)
                       (_return109192_ _mapping109178_ _obj109202_))))
                  _success109181_)))
           (begin
             (let ((_g302791_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302790_)
                          (##vector-length _g302790_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302791_ 2)))
                   (error "Context expects 2 values" _g302791_)))
             (let ((_tree109204_
                    (let () (declare (not safe)) (##vector-ref _g302790_ 0)))
                   (_obj109205_
                    (let () (declare (not safe)) (##vector-ref _g302790_ 1))))
               (let ()
                 (values (let ()
                           (declare (not safe))
                           (##structure
                            std/srfi/146#<mapping>
                            _comparator109194_
                            _tree109204_))
                         _obj109205_)))))))))
  (define std/srfi/146#mapping-search! std/srfi/146#mapping-search)
  (define std/srfi/146#mapping-size
    (lambda (_mapping109170_)
      (let ((_val109172_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109170_
                'std/srfi/146#<mapping>))))
        (if _val109172_ _val109172_ (error)))
      (std/srfi/146#mapping-count
       (lambda (_key109175_ _value109176_) '#t)
       _mapping109170_)))
  (define std/srfi/146#mapping-find
    (lambda (_predicate109152_ _mapping109153_ _failure109154_)
      (let ((_val109156_ (procedure? _predicate109152_)))
        (if _val109156_ _val109156_ (error)))
      (let ((_val109159_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109153_
                'std/srfi/146#<mapping>))))
        (if _val109159_ _val109159_ (error)))
      (let ((_val109162_ (procedure? _failure109154_)))
        (if _val109162_ _val109162_ (error)))
      (call-with-current-continuation
       (lambda (_return109165_)
         (std/srfi/146#mapping-for-each
          (lambda (_key109167_ _value109168_)
            (if (_predicate109152_ _key109167_ _value109168_)
                (_return109165_ _key109167_ _value109168_)
                '#!void))
          _mapping109153_)
         (_failure109154_)))))
  (define std/srfi/146#mapping-count
    (lambda (_predicate109139_ _mapping109140_)
      (let ((_val109142_ (procedure? _predicate109139_)))
        (if _val109142_ _val109142_ (error)))
      (let ((_val109145_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109140_
                'std/srfi/146#<mapping>))))
        (if _val109145_ _val109145_ (error)))
      (std/srfi/146#mapping-fold
       (lambda (_key109148_ _value109149_ _count109150_)
         (if (_predicate109139_ _key109148_ _value109149_)
             (+ '1 _count109150_)
             _count109150_))
       '0
       _mapping109140_)))
  (define std/srfi/146#mapping-any?
    (lambda (_predicate109125_ _mapping109126_)
      (let ((_val109128_ (procedure? _predicate109125_)))
        (if _val109128_ _val109128_ (error)))
      (let ((_val109131_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109126_
                'std/srfi/146#<mapping>))))
        (if _val109131_ _val109131_ (error)))
      (call-with-current-continuation
       (lambda (_return109134_)
         (std/srfi/146#mapping-for-each
          (lambda (_key109136_ _value109137_)
            (if (_predicate109125_ _key109136_ _value109137_)
                (_return109134_ '#t)
                '#!void))
          _mapping109126_)
         '#f))))
  (define std/srfi/146#mapping-every?
    (lambda (_predicate109113_ _mapping109114_)
      (let ((_val109116_ (procedure? _predicate109113_)))
        (if _val109116_ _val109116_ (error)))
      (let ((_val109119_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109114_
                'std/srfi/146#<mapping>))))
        (if _val109119_ _val109119_ (error)))
      (not (std/srfi/146#mapping-any?
            (lambda (_key109122_ _value109123_)
              (not (_predicate109113_ _key109122_ _value109123_)))
            _mapping109114_))))
  (define std/srfi/146#mapping-keys
    (lambda (_mapping109104_)
      (let ((_val109106_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109104_
                'std/srfi/146#<mapping>))))
        (if _val109106_ _val109106_ (error)))
      (std/srfi/146#mapping-fold/reverse
       (lambda (_key109109_ _value109110_ _keys109111_)
         (cons _key109109_ _keys109111_))
       '()
       _mapping109104_)))
  (define std/srfi/146#mapping-values
    (lambda (_mapping109095_)
      (let ((_val109097_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109095_
                'std/srfi/146#<mapping>))))
        (if _val109097_ _val109097_ (error)))
      (std/srfi/146#mapping-fold/reverse
       (lambda (_key109100_ _value109101_ _values109102_)
         (cons _value109101_ _values109102_))
       '()
       _mapping109095_)))
  (define std/srfi/146#mapping-entries
    (lambda (_mapping109090_)
      (let ((_val109092_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109090_
                'std/srfi/146#<mapping>))))
        (if _val109092_ _val109092_ (error)))
      (values (std/srfi/146#mapping-keys _mapping109090_)
              (std/srfi/146#mapping-values _mapping109090_))))
  (define std/srfi/146#mapping-map
    (lambda (_proc109070_ _comparator109071_ _mapping109072_)
      (let ((_val109074_ (procedure? _proc109070_)))
        (if _val109074_ _val109074_ (error)))
      (let ((_val109077_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109071_
                'std/srfi/128#comparator::t))))
        (if _val109077_ _val109077_ (error)))
      (let ((_val109080_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109072_
                'std/srfi/146#<mapping>))))
        (if _val109080_ _val109080_ (error)))
      (std/srfi/146#mapping-fold
       (lambda (_key109083_ _value109084_ _mapping109085_)
         (let ((_g302792_ (_proc109070_ _key109083_ _value109084_)))
           (begin
             (let ((_g302793_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302792_)
                          (##vector-length _g302792_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302793_ 2)))
                   (error "Context expects 2 values" _g302793_)))
             (let ((_key109087_
                    (let () (declare (not safe)) (##vector-ref _g302792_ 0)))
                   (_value109088_
                    (let () (declare (not safe)) (##vector-ref _g302792_ 1))))
               (std/srfi/146#mapping-set
                _mapping109085_
                _key109087_
                _value109088_)))))
       (std/srfi/146#make-empty-mapping _comparator109071_)
       _mapping109072_)))
  (define std/srfi/146#mapping-for-each
    (lambda (_proc109061_ _mapping109062_)
      (let ((_val109064_ (procedure? _proc109061_)))
        (if _val109064_ _val109064_ (error)))
      (let ((_val109067_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109062_
                'std/srfi/146#<mapping>))))
        (if _val109067_ _val109067_ (error)))
      (std/misc/rbtree#rbtree-for-each
       _proc109061_
       (##structure-ref _mapping109062_ '2 std/srfi/146#<mapping> '#f))))
  (define std/srfi/146#mapping-fold
    (lambda (_proc109051_ _acc109052_ _mapping109053_)
      (let ((_val109055_ (procedure? _proc109051_)))
        (if _val109055_ _val109055_ (error)))
      (let ((_val109058_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109053_
                'std/srfi/146#<mapping>))))
        (if _val109058_ _val109058_ (error)))
      (std/misc/rbtree#rbtree-fold
       _proc109051_
       _acc109052_
       (##structure-ref _mapping109053_ '2 std/srfi/146#<mapping> '#f))))
  (define std/srfi/146#mapping-map->list
    (lambda (_proc109038_ _mapping109039_)
      (let ((_val109041_ (procedure? _proc109038_)))
        (if _val109041_ _val109041_ (error)))
      (let ((_val109044_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109039_
                'std/srfi/146#<mapping>))))
        (if _val109044_ _val109044_ (error)))
      (std/srfi/146#mapping-fold/reverse
       (lambda (_key109047_ _value109048_ _lst109049_)
         (cons (_proc109038_ _key109047_ _value109048_) _lst109049_))
       '()
       _mapping109039_)))
  (define std/srfi/146#mapping-filter
    (lambda (_predicate109025_ _mapping109026_)
      (let ((_val109028_ (procedure? _predicate109025_)))
        (if _val109028_ _val109028_ (error)))
      (let ((_val109031_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109026_
                'std/srfi/146#<mapping>))))
        (if _val109031_ _val109031_ (error)))
      (std/srfi/146#mapping-fold
       (lambda (_key109034_ _value109035_ _mapping109036_)
         (if (_predicate109025_ _key109034_ _value109035_)
             (std/srfi/146#mapping-set
              _mapping109036_
              _key109034_
              _value109035_)
             _mapping109036_))
       (std/srfi/146#make-empty-mapping
        (##structure-ref _mapping109026_ '1 std/srfi/146#<mapping> '#f))
       _mapping109026_)))
  (define std/srfi/146#mapping-filter! std/srfi/146#mapping-filter)
  (define std/srfi/146#mapping-remove
    (lambda (_predicate109013_ _mapping109014_)
      (let ((_val109016_ (procedure? _predicate109013_)))
        (if _val109016_ _val109016_ (error)))
      (let ((_val109019_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109014_
                'std/srfi/146#<mapping>))))
        (if _val109019_ _val109019_ (error)))
      (std/srfi/146#mapping-filter
       (lambda (_key109022_ _value109023_)
         (not (_predicate109013_ _key109022_ _value109023_)))
       _mapping109014_)))
  (define std/srfi/146#mapping-remove! std/srfi/146#mapping-remove)
  (define std/srfi/146#mapping-partition
    (lambda (_predicate109004_ _mapping109005_)
      (let ((_val109007_ (procedure? _predicate109004_)))
        (if _val109007_ _val109007_ (error)))
      (let ((_val109010_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109005_
                'std/srfi/146#<mapping>))))
        (if _val109010_ _val109010_ (error)))
      (values (std/srfi/146#mapping-filter _predicate109004_ _mapping109005_)
              (std/srfi/146#mapping-remove
               _predicate109004_
               _mapping109005_))))
  (define std/srfi/146#mapping-partition! std/srfi/146#mapping-partition)
  (define std/srfi/146#mapping-copy
    (lambda (_mapping108999_)
      (let ((_val109001_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108999_
                'std/srfi/146#<mapping>))))
        (if _val109001_ _val109001_ (error)))
      _mapping108999_))
  (define std/srfi/146#mapping->alist
    (lambda (_mapping108990_)
      (let ((_val108992_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108990_
                'std/srfi/146#<mapping>))))
        (if _val108992_ _val108992_ (error)))
      (reverse (std/srfi/146#mapping-fold
                (lambda (_key108995_ _value108996_ _alist108997_)
                  (cons (cons _key108995_ _value108996_) _alist108997_))
                '()
                _mapping108990_))))
  (define std/srfi/146#alist->mapping
    (lambda (_comparator108976_ _alist108977_)
      (let ((_val108979_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108976_
                'std/srfi/128#comparator::t))))
        (if _val108979_ _val108979_ (error)))
      (let ((_val108982_ (list? _alist108977_)))
        (if _val108982_ _val108982_ (error)))
      (std/srfi/146#mapping-unfold
       null?
       (lambda (_alist108985_)
         (let ((_key108987_ (caar _alist108985_))
               (_value108988_ (cdar _alist108985_)))
           (values _key108987_ _value108988_)))
       cdr
       _alist108977_
       _comparator108976_)))
  (define std/srfi/146#alist->mapping!
    (lambda (_mapping108961_ _alist108962_)
      (let ((_val108964_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108961_
                'std/srfi/146#<mapping>))))
        (if _val108964_ _val108964_ (error)))
      (let ((_val108967_ (list? _alist108962_)))
        (if _val108967_ _val108967_ (error)))
      (foldl1 (lambda (_association108970_ _mapping108971_)
                (let ((_key108973_ (car _association108970_))
                      (_value108974_ (cdr _association108970_)))
                  (std/srfi/146#mapping-set
                   _mapping108971_
                   _key108973_
                   _value108974_)))
              _mapping108961_
              _alist108962_)))
  (define std/srfi/146#alist->mapping/ordered std/srfi/146#alist->mapping)
  (define std/srfi/146#alist->mapping/ordered! std/srfi/146#alist->mapping!)
  (define std/srfi/146#mapping=?__0
    (lambda (_comparator108946_ _mapping108947_)
      (let ((_val108949_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108947_
                'std/srfi/146#<mapping>))))
        (if _val108949_ _val108949_ (error)))
      '#t))
  (define std/srfi/146#mapping=?__2
    (lambda (_comparator108956_
             _mapping1108957_
             _mapping2108958_
             .
             _mappings108959_)
      (if (std/srfi/146#%mapping=?
           _comparator108956_
           _mapping1108957_
           _mapping2108958_)
          (apply std/srfi/146#mapping=?
                 _comparator108956_
                 _mapping2108958_
                 _mappings108959_)
          '#f)))
  (define std/srfi/146#mapping=?
    (lambda _g302795_
      (let ((_g302794_ (let () (declare (not safe)) (##length _g302795_))))
        (cond ((let () (declare (not safe)) (##fx= _g302794_ 2))
               (apply std/srfi/146#mapping=?__0 _g302795_))
              ((let () (declare (not safe)) (##fx= _g302794_ 3))
               (apply std/srfi/146#%mapping=? _g302795_))
              ((let () (declare (not safe)) (##fx>= _g302794_ 3))
               (apply std/srfi/146#mapping=?__2 _g302795_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping=?
                _g302795_))))))
  (define std/srfi/146#%mapping=?
    (lambda (_comparator108942_ _mapping1108943_ _mapping2108944_)
      (if (eq? (##structure-ref _mapping1108943_ '1 std/srfi/146#<mapping> '#f)
               (##structure-ref
                _mapping2108944_
                '1
                std/srfi/146#<mapping>
                '#f))
          (if (std/srfi/146#%mapping<=?
               _comparator108942_
               _mapping1108943_
               _mapping2108944_)
              (std/srfi/146#%mapping<=?
               _comparator108942_
               _mapping2108944_
               _mapping1108943_)
              '#f)
          '#f)))
  (define std/srfi/146#mapping<=?__0
    (lambda (_comparator108909_ _mapping108910_)
      (let ((_val108912_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108910_
                'std/srfi/146#<mapping>))))
        (if _val108912_ _val108912_ (error)))
      '#t))
  (define std/srfi/146#mapping<=?__1
    (lambda (_comparator108915_ _mapping1108916_ _mapping2108917_)
      (let ((_val108919_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108915_
                'std/srfi/128#comparator::t))))
        (if _val108919_ _val108919_ (error)))
      (let ((_val108922_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108916_
                'std/srfi/146#<mapping>))))
        (if _val108922_ _val108922_ (error)))
      (let ((_val108925_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108917_
                'std/srfi/146#<mapping>))))
        (if _val108925_ _val108925_ (error)))
      (std/srfi/146#%mapping<=?
       _comparator108915_
       _mapping1108916_
       _mapping2108917_)))
  (define std/srfi/146#mapping<=?__2
    (lambda (_comparator108928_
             _mapping1108929_
             _mapping2108930_
             .
             _mappings108931_)
      (let ((_val108933_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108928_
                'std/srfi/128#comparator::t))))
        (if _val108933_ _val108933_ (error)))
      (let ((_val108936_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108929_
                'std/srfi/146#<mapping>))))
        (if _val108936_ _val108936_ (error)))
      (let ((_val108939_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108930_
                'std/srfi/146#<mapping>))))
        (if _val108939_ _val108939_ (error)))
      (if (std/srfi/146#%mapping<=?
           _comparator108928_
           _mapping1108929_
           _mapping2108930_)
          (apply std/srfi/146#mapping<=?
                 _comparator108928_
                 _mapping2108930_
                 _mappings108931_)
          '#f)))
  (define std/srfi/146#mapping<=?
    (lambda _g302797_
      (let ((_g302796_ (let () (declare (not safe)) (##length _g302797_))))
        (cond ((let () (declare (not safe)) (##fx= _g302796_ 2))
               (apply std/srfi/146#mapping<=?__0 _g302797_))
              ((let () (declare (not safe)) (##fx= _g302796_ 3))
               (apply std/srfi/146#mapping<=?__1 _g302797_))
              ((let () (declare (not safe)) (##fx>= _g302796_ 3))
               (apply std/srfi/146#mapping<=?__2 _g302797_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping<=?
                _g302797_))))))
  (define std/srfi/146#%mapping<=?
    (lambda (_comparator108881_ _mapping1108882_ _mapping2108883_)
      (let ((_val108885_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108881_
                'std/srfi/128#comparator::t))))
        (if _val108885_ _val108885_ (error)))
      (let ((_val108888_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108882_
                'std/srfi/146#<mapping>))))
        (if _val108888_ _val108888_ (error)))
      (let ((_val108891_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108883_
                'std/srfi/146#<mapping>))))
        (if _val108891_ _val108891_ (error)))
      (let ((_less?108894_
             (std/srfi/128#comparator-ordering-predicate
              (##structure-ref
               _mapping1108882_
               '1
               std/srfi/146#<mapping>
               '#f)))
            (_equality-predicate108895_
             (##direct-structure-ref
              _comparator108881_
              '2
              std/srfi/128#comparator::t
              '#f))
            (_gen1108896_
             (std/srfi/146#tree-generator
              (##structure-ref
               _mapping1108882_
               '2
               std/srfi/146#<mapping>
               '#f)))
            (_gen2108897_
             (std/srfi/146#tree-generator
              (##structure-ref
               _mapping2108883_
               '2
               std/srfi/146#<mapping>
               '#f))))
        (let _loop108899_ ((_item1108901_ (_gen1108896_))
                           (_item2108902_ (_gen2108897_)))
          (if (eof-object? _item1108901_)
              '#t
              (if (eof-object? _item2108902_)
                  '#f
                  (let ((_key1108904_ (car _item1108901_))
                        (_value1108905_ (cadr _item1108901_))
                        (_key2108906_ (car _item2108902_))
                        (_value2108907_ (cadr _item2108902_)))
                    (if (_less?108894_ _key1108904_ _key2108906_)
                        '#f
                        (if (_less?108894_ _key2108906_ _key1108904_)
                            (_loop108899_ _item1108901_ (_gen2108897_))
                            (if (_equality-predicate108895_
                                 _value1108905_
                                 _value2108907_)
                                (_loop108899_ (_gen1108896_) (_gen2108897_))
                                '#f))))))))))
  (define std/srfi/146#mapping>?__0
    (lambda (_comparator108848_ _mapping108849_)
      (let ((_val108851_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108849_
                'std/srfi/146#<mapping>))))
        (if _val108851_ _val108851_ (error)))
      '#t))
  (define std/srfi/146#mapping>?__1
    (lambda (_comparator108854_ _mapping1108855_ _mapping2108856_)
      (let ((_val108858_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108854_
                'std/srfi/128#comparator::t))))
        (if _val108858_ _val108858_ (error)))
      (let ((_val108861_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108855_
                'std/srfi/146#<mapping>))))
        (if _val108861_ _val108861_ (error)))
      (let ((_val108864_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108856_
                'std/srfi/146#<mapping>))))
        (if _val108864_ _val108864_ (error)))
      (std/srfi/146#%mapping>?
       _comparator108854_
       _mapping1108855_
       _mapping2108856_)))
  (define std/srfi/146#mapping>?__2
    (lambda (_comparator108867_
             _mapping1108868_
             _mapping2108869_
             .
             _mappings108870_)
      (let ((_val108872_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108867_
                'std/srfi/128#comparator::t))))
        (if _val108872_ _val108872_ (error)))
      (let ((_val108875_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108868_
                'std/srfi/146#<mapping>))))
        (if _val108875_ _val108875_ (error)))
      (let ((_val108878_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108869_
                'std/srfi/146#<mapping>))))
        (if _val108878_ _val108878_ (error)))
      (if (std/srfi/146#%mapping>?
           _comparator108867_
           _mapping1108868_
           _mapping2108869_)
          (apply std/srfi/146#mapping>?
                 _comparator108867_
                 _mapping2108869_
                 _mappings108870_)
          '#f)))
  (define std/srfi/146#mapping>?
    (lambda _g302799_
      (let ((_g302798_ (let () (declare (not safe)) (##length _g302799_))))
        (cond ((let () (declare (not safe)) (##fx= _g302798_ 2))
               (apply std/srfi/146#mapping>?__0 _g302799_))
              ((let () (declare (not safe)) (##fx= _g302798_ 3))
               (apply std/srfi/146#mapping>?__1 _g302799_))
              ((let () (declare (not safe)) (##fx>= _g302798_ 3))
               (apply std/srfi/146#mapping>?__2 _g302799_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping>?
                _g302799_))))))
  (define std/srfi/146#%mapping>?
    (lambda (_comparator108835_ _mapping1108836_ _mapping2108837_)
      (let ((_val108839_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108835_
                'std/srfi/128#comparator::t))))
        (if _val108839_ _val108839_ (error)))
      (let ((_val108842_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108836_
                'std/srfi/146#<mapping>))))
        (if _val108842_ _val108842_ (error)))
      (let ((_val108845_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108837_
                'std/srfi/146#<mapping>))))
        (if _val108845_ _val108845_ (error)))
      (not (std/srfi/146#%mapping<=?
            _comparator108835_
            _mapping1108836_
            _mapping2108837_))))
  (define std/srfi/146#mapping<?__0
    (lambda (_comparator108802_ _mapping108803_)
      (let ((_val108805_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108803_
                'std/srfi/146#<mapping>))))
        (if _val108805_ _val108805_ (error)))
      '#t))
  (define std/srfi/146#mapping<?__1
    (lambda (_comparator108808_ _mapping1108809_ _mapping2108810_)
      (let ((_val108812_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108808_
                'std/srfi/128#comparator::t))))
        (if _val108812_ _val108812_ (error)))
      (let ((_val108815_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108809_
                'std/srfi/146#<mapping>))))
        (if _val108815_ _val108815_ (error)))
      (let ((_val108818_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108810_
                'std/srfi/146#<mapping>))))
        (if _val108818_ _val108818_ (error)))
      (std/srfi/146#%mapping<?
       _comparator108808_
       _mapping1108809_
       _mapping2108810_)))
  (define std/srfi/146#mapping<?__2
    (lambda (_comparator108821_
             _mapping1108822_
             _mapping2108823_
             .
             _mappings108824_)
      (let ((_val108826_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108821_
                'std/srfi/128#comparator::t))))
        (if _val108826_ _val108826_ (error)))
      (let ((_val108829_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108822_
                'std/srfi/146#<mapping>))))
        (if _val108829_ _val108829_ (error)))
      (let ((_val108832_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108823_
                'std/srfi/146#<mapping>))))
        (if _val108832_ _val108832_ (error)))
      (if (std/srfi/146#%mapping<?
           _comparator108821_
           _mapping1108822_
           _mapping2108823_)
          (apply std/srfi/146#mapping<?
                 _comparator108821_
                 _mapping2108823_
                 _mappings108824_)
          '#f)))
  (define std/srfi/146#mapping<?
    (lambda _g302801_
      (let ((_g302800_ (let () (declare (not safe)) (##length _g302801_))))
        (cond ((let () (declare (not safe)) (##fx= _g302800_ 2))
               (apply std/srfi/146#mapping<?__0 _g302801_))
              ((let () (declare (not safe)) (##fx= _g302800_ 3))
               (apply std/srfi/146#mapping<?__1 _g302801_))
              ((let () (declare (not safe)) (##fx>= _g302800_ 3))
               (apply std/srfi/146#mapping<?__2 _g302801_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping<?
                _g302801_))))))
  (define std/srfi/146#%mapping<?
    (lambda (_comparator108789_ _mapping1108790_ _mapping2108791_)
      (let ((_val108793_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108789_
                'std/srfi/128#comparator::t))))
        (if _val108793_ _val108793_ (error)))
      (let ((_val108796_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108790_
                'std/srfi/146#<mapping>))))
        (if _val108796_ _val108796_ (error)))
      (let ((_val108799_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108791_
                'std/srfi/146#<mapping>))))
        (if _val108799_ _val108799_ (error)))
      (std/srfi/146#%mapping>?
       _comparator108789_
       _mapping2108791_
       _mapping1108790_)))
  (define std/srfi/146#mapping>=?__0
    (lambda (_comparator108756_ _mapping108757_)
      (let ((_val108759_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108757_
                'std/srfi/146#<mapping>))))
        (if _val108759_ _val108759_ (error)))
      '#t))
  (define std/srfi/146#mapping>=?__1
    (lambda (_comparator108762_ _mapping1108763_ _mapping2108764_)
      (let ((_val108766_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108762_
                'std/srfi/128#comparator::t))))
        (if _val108766_ _val108766_ (error)))
      (let ((_val108769_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108763_
                'std/srfi/146#<mapping>))))
        (if _val108769_ _val108769_ (error)))
      (let ((_val108772_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108764_
                'std/srfi/146#<mapping>))))
        (if _val108772_ _val108772_ (error)))
      (std/srfi/146#%mapping>=?
       _comparator108762_
       _mapping1108763_
       _mapping2108764_)))
  (define std/srfi/146#mapping>=?__2
    (lambda (_comparator108775_
             _mapping1108776_
             _mapping2108777_
             .
             _mappings108778_)
      (let ((_val108780_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108775_
                'std/srfi/128#comparator::t))))
        (if _val108780_ _val108780_ (error)))
      (let ((_val108783_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108776_
                'std/srfi/146#<mapping>))))
        (if _val108783_ _val108783_ (error)))
      (let ((_val108786_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108777_
                'std/srfi/146#<mapping>))))
        (if _val108786_ _val108786_ (error)))
      (if (std/srfi/146#%mapping>=?
           _comparator108775_
           _mapping1108776_
           _mapping2108777_)
          (apply std/srfi/146#mapping>=?
                 _comparator108775_
                 _mapping2108777_
                 _mappings108778_)
          '#f)))
  (define std/srfi/146#mapping>=?
    (lambda _g302803_
      (let ((_g302802_ (let () (declare (not safe)) (##length _g302803_))))
        (cond ((let () (declare (not safe)) (##fx= _g302802_ 2))
               (apply std/srfi/146#mapping>=?__0 _g302803_))
              ((let () (declare (not safe)) (##fx= _g302802_ 3))
               (apply std/srfi/146#mapping>=?__1 _g302803_))
              ((let () (declare (not safe)) (##fx>= _g302802_ 3))
               (apply std/srfi/146#mapping>=?__2 _g302803_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping>=?
                _g302803_))))))
  (define std/srfi/146#%mapping>=?
    (lambda (_comparator108743_ _mapping1108744_ _mapping2108745_)
      (let ((_val108747_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108743_
                'std/srfi/128#comparator::t))))
        (if _val108747_ _val108747_ (error)))
      (let ((_val108750_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108744_
                'std/srfi/146#<mapping>))))
        (if _val108750_ _val108750_ (error)))
      (let ((_val108753_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108745_
                'std/srfi/146#<mapping>))))
        (if _val108753_ _val108753_ (error)))
      (not (std/srfi/146#%mapping<?
            _comparator108743_
            _mapping1108744_
            _mapping2108745_))))
  (define std/srfi/146#%mapping-union
    (lambda (_mapping1108725_ _mapping2108726_)
      (std/srfi/146#mapping-fold
       (lambda (_key2108728_ _value2108729_ _mapping108730_)
         (let ((_g302804_
                (std/srfi/146#mapping-search
                 _mapping108730_
                 _key2108728_
                 (lambda (_insert108732_ _ignore108733_)
                   (_insert108732_ _value2108729_ '#f))
                 (lambda (_key1108735_
                          _value1108736_
                          _update108737_
                          _remove108738_)
                   (_update108737_ _key1108735_ _value1108736_ '#f)))))
           (begin
             (let ((_g302805_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302804_)
                          (##vector-length _g302804_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302805_ 2)))
                   (error "Context expects 2 values" _g302805_)))
             (let ((_mapping108740_
                    (let () (declare (not safe)) (##vector-ref _g302804_ 0)))
                   (_obj108741_
                    (let () (declare (not safe)) (##vector-ref _g302804_ 1))))
               _mapping108740_))))
       _mapping1108725_
       _mapping2108726_)))
  (define std/srfi/146#%mapping-intersection
    (lambda (_mapping1108719_ _mapping2108720_)
      (std/srfi/146#mapping-filter
       (lambda (_key1108722_ _value1108723_)
         (std/srfi/146#mapping-contains? _mapping2108720_ _key1108722_))
       _mapping1108719_)))
  (define std/srfi/146#%mapping-difference
    (lambda (_mapping1108701_ _mapping2108702_)
      (std/srfi/146#mapping-fold
       (lambda (_key2108704_ _value2108705_ _mapping108706_)
         (let ((_g302806_
                (std/srfi/146#mapping-search
                 _mapping108706_
                 _key2108704_
                 (lambda (_insert108708_ _ignore108709_) (_ignore108709_ '#f))
                 (lambda (_key1108711_
                          _value1108712_
                          _update108713_
                          _remove108714_)
                   (_remove108714_ '#f)))))
           (begin
             (let ((_g302807_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302806_)
                          (##vector-length _g302806_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302807_ 2)))
                   (error "Context expects 2 values" _g302807_)))
             (let ((_mapping108716_
                    (let () (declare (not safe)) (##vector-ref _g302806_ 0)))
                   (_obj108717_
                    (let () (declare (not safe)) (##vector-ref _g302806_ 1))))
               _mapping108716_))))
       _mapping1108701_
       _mapping2108702_)))
  (define std/srfi/146#%mapping-xor
    (lambda (_mapping1108683_ _mapping2108684_)
      (std/srfi/146#mapping-fold
       (lambda (_key2108686_ _value2108687_ _mapping108688_)
         (let ((_g302808_
                (std/srfi/146#mapping-search
                 _mapping108688_
                 _key2108686_
                 (lambda (_insert108690_ _ignore108691_)
                   (_insert108690_ _value2108687_ '#f))
                 (lambda (_key1108693_
                          _value1108694_
                          _update108695_
                          _remove108696_)
                   (_remove108696_ '#f)))))
           (begin
             (let ((_g302809_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302808_)
                          (##vector-length _g302808_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302809_ 2)))
                   (error "Context expects 2 values" _g302809_)))
             (let ((_mapping108698_
                    (let () (declare (not safe)) (##vector-ref _g302808_ 0)))
                   (_obj108699_
                    (let () (declare (not safe)) (##vector-ref _g302808_ 1))))
               _mapping108698_))))
       _mapping1108683_
       _mapping2108684_)))
  (define std/srfi/146#mapping-union__0
    (lambda (_mapping108659_)
      (let ((_val108661_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108659_
                'std/srfi/146#<mapping>))))
        (if _val108661_ _val108661_ (error)))
      _mapping108659_))
  (define std/srfi/146#mapping-union__1
    (lambda (_mapping1108664_ _mapping2108665_)
      (let ((_val108667_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108664_
                'std/srfi/146#<mapping>))))
        (if _val108667_ _val108667_ (error)))
      (let ((_val108670_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108665_
                'std/srfi/146#<mapping>))))
        (if _val108670_ _val108670_ (error)))
      (std/srfi/146#%mapping-union _mapping1108664_ _mapping2108665_)))
  (define std/srfi/146#mapping-union__2
    (lambda (_mapping1108673_ _mapping2108674_ . _mappings108675_)
      (let ((_val108677_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108673_
                'std/srfi/146#<mapping>))))
        (if _val108677_ _val108677_ (error)))
      (let ((_val108680_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108674_
                'std/srfi/146#<mapping>))))
        (if _val108680_ _val108680_ (error)))
      (apply std/srfi/146#mapping-union
             (std/srfi/146#%mapping-union _mapping1108673_ _mapping2108674_)
             _mappings108675_)))
  (define std/srfi/146#mapping-union
    (lambda _g302811_
      (let ((_g302810_ (let () (declare (not safe)) (##length _g302811_))))
        (cond ((let () (declare (not safe)) (##fx= _g302810_ 1))
               (apply std/srfi/146#mapping-union__0 _g302811_))
              ((let () (declare (not safe)) (##fx= _g302810_ 2))
               (apply std/srfi/146#mapping-union__1 _g302811_))
              ((let () (declare (not safe)) (##fx>= _g302810_ 2))
               (apply std/srfi/146#mapping-union__2 _g302811_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-union
                _g302811_))))))
  (define std/srfi/146#mapping-union! std/srfi/146#mapping-union)
  (define std/srfi/146#mapping-intersection__0
    (lambda (_mapping108635_)
      (let ((_val108637_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108635_
                'std/srfi/146#<mapping>))))
        (if _val108637_ _val108637_ (error)))
      _mapping108635_))
  (define std/srfi/146#mapping-intersection__1
    (lambda (_mapping1108640_ _mapping2108641_)
      (let ((_val108643_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108640_
                'std/srfi/146#<mapping>))))
        (if _val108643_ _val108643_ (error)))
      (let ((_val108646_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108641_
                'std/srfi/146#<mapping>))))
        (if _val108646_ _val108646_ (error)))
      (std/srfi/146#%mapping-intersection _mapping1108640_ _mapping2108641_)))
  (define std/srfi/146#mapping-intersection__2
    (lambda (_mapping1108649_ _mapping2108650_ . _mappings108651_)
      (let ((_val108653_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108649_
                'std/srfi/146#<mapping>))))
        (if _val108653_ _val108653_ (error)))
      (let ((_val108656_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108650_
                'std/srfi/146#<mapping>))))
        (if _val108656_ _val108656_ (error)))
      (apply std/srfi/146#mapping-intersection
             (std/srfi/146#%mapping-intersection
              _mapping1108649_
              _mapping2108650_)
             _mappings108651_)))
  (define std/srfi/146#mapping-intersection
    (lambda _g302813_
      (let ((_g302812_ (let () (declare (not safe)) (##length _g302813_))))
        (cond ((let () (declare (not safe)) (##fx= _g302812_ 1))
               (apply std/srfi/146#mapping-intersection__0 _g302813_))
              ((let () (declare (not safe)) (##fx= _g302812_ 2))
               (apply std/srfi/146#mapping-intersection__1 _g302813_))
              ((let () (declare (not safe)) (##fx>= _g302812_ 2))
               (apply std/srfi/146#mapping-intersection__2 _g302813_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-intersection
                _g302813_))))))
  (define std/srfi/146#mapping-intersection! std/srfi/146#mapping-intersection)
  (define std/srfi/146#mapping-difference__0
    (lambda (_mapping108611_)
      (let ((_val108613_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108611_
                'std/srfi/146#<mapping>))))
        (if _val108613_ _val108613_ (error)))
      _mapping108611_))
  (define std/srfi/146#mapping-difference__1
    (lambda (_mapping1108616_ _mapping2108617_)
      (let ((_val108619_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108616_
                'std/srfi/146#<mapping>))))
        (if _val108619_ _val108619_ (error)))
      (let ((_val108622_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108617_
                'std/srfi/146#<mapping>))))
        (if _val108622_ _val108622_ (error)))
      (std/srfi/146#%mapping-difference _mapping1108616_ _mapping2108617_)))
  (define std/srfi/146#mapping-difference__2
    (lambda (_mapping1108625_ _mapping2108626_ . _mappings108627_)
      (let ((_val108629_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108625_
                'std/srfi/146#<mapping>))))
        (if _val108629_ _val108629_ (error)))
      (let ((_val108632_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108626_
                'std/srfi/146#<mapping>))))
        (if _val108632_ _val108632_ (error)))
      (apply std/srfi/146#mapping-difference
             (std/srfi/146#%mapping-difference
              _mapping1108625_
              _mapping2108626_)
             _mappings108627_)))
  (define std/srfi/146#mapping-difference
    (lambda _g302815_
      (let ((_g302814_ (let () (declare (not safe)) (##length _g302815_))))
        (cond ((let () (declare (not safe)) (##fx= _g302814_ 1))
               (apply std/srfi/146#mapping-difference__0 _g302815_))
              ((let () (declare (not safe)) (##fx= _g302814_ 2))
               (apply std/srfi/146#mapping-difference__1 _g302815_))
              ((let () (declare (not safe)) (##fx>= _g302814_ 2))
               (apply std/srfi/146#mapping-difference__2 _g302815_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-difference
                _g302815_))))))
  (define std/srfi/146#mapping-difference! std/srfi/146#mapping-difference)
  (define std/srfi/146#mapping-xor__0
    (lambda (_mapping108587_)
      (let ((_val108589_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108587_
                'std/srfi/146#<mapping>))))
        (if _val108589_ _val108589_ (error)))
      _mapping108587_))
  (define std/srfi/146#mapping-xor__1
    (lambda (_mapping1108592_ _mapping2108593_)
      (let ((_val108595_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108592_
                'std/srfi/146#<mapping>))))
        (if _val108595_ _val108595_ (error)))
      (let ((_val108598_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108593_
                'std/srfi/146#<mapping>))))
        (if _val108598_ _val108598_ (error)))
      (std/srfi/146#%mapping-xor _mapping1108592_ _mapping2108593_)))
  (define std/srfi/146#mapping-xor__2
    (lambda (_mapping1108601_ _mapping2108602_ . _mappings108603_)
      (let ((_val108605_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108601_
                'std/srfi/146#<mapping>))))
        (if _val108605_ _val108605_ (error)))
      (let ((_val108608_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108602_
                'std/srfi/146#<mapping>))))
        (if _val108608_ _val108608_ (error)))
      (apply std/srfi/146#mapping-xor
             (std/srfi/146#%mapping-xor _mapping1108601_ _mapping2108602_)
             _mappings108603_)))
  (define std/srfi/146#mapping-xor
    (lambda _g302817_
      (let ((_g302816_ (let () (declare (not safe)) (##length _g302817_))))
        (cond ((let () (declare (not safe)) (##fx= _g302816_ 1))
               (apply std/srfi/146#mapping-xor__0 _g302817_))
              ((let () (declare (not safe)) (##fx= _g302816_ 2))
               (apply std/srfi/146#mapping-xor__1 _g302817_))
              ((let () (declare (not safe)) (##fx>= _g302816_ 2))
               (apply std/srfi/146#mapping-xor__2 _g302817_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-xor
                _g302817_))))))
  (define std/srfi/146#mapping-xor! std/srfi/146#mapping-xor)
  (define std/srfi/146#mapping-min-key
    (lambda (_mapping108576_)
      (let ((_val108578_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108576_
                'std/srfi/146#<mapping>))))
        (if _val108578_ _val108578_ (error)))
      (call-with-current-continuation
       (lambda (_return108581_)
         (std/srfi/146#mapping-fold
          (lambda (_key108583_ _value108584_ _acc108585_)
            (_return108581_ _key108583_))
          '#f
          _mapping108576_)
         (error '"mapping-min-key: empty map")))))
  (define std/srfi/146#mapping-max-key
    (lambda (_mapping108565_)
      (let ((_val108567_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108565_
                'std/srfi/146#<mapping>))))
        (if _val108567_ _val108567_ (error)))
      (call-with-current-continuation
       (lambda (_return108570_)
         (std/srfi/146#mapping-fold/reverse
          (lambda (_key108572_ _value108573_ _acc108574_)
            (_return108570_ _key108572_))
          '#f
          _mapping108565_)
         (error '"mapping-max-key: empty map")))))
  (define std/srfi/146#mapping-min-value
    (lambda (_mapping108554_)
      (let ((_val108556_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108554_
                'std/srfi/146#<mapping>))))
        (if _val108556_ _val108556_ (error)))
      (call-with-current-continuation
       (lambda (_return108559_)
         (std/srfi/146#mapping-fold
          (lambda (_key108561_ _value108562_ _acc108563_)
            (_return108559_ _value108562_))
          '#f
          _mapping108554_)
         (error '"mapping-min-value: empty map")))))
  (define std/srfi/146#mapping-max-value
    (lambda (_mapping108543_)
      (let ((_val108545_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108543_
                'std/srfi/146#<mapping>))))
        (if _val108545_ _val108545_ (error)))
      (call-with-current-continuation
       (lambda (_return108548_)
         (std/srfi/146#mapping-fold/reverse
          (lambda (_key108550_ _value108551_ _acc108552_)
            (_return108548_ _value108551_))
          '#f
          _mapping108543_)
         (error '"mapping-max-value: empty map")))))
  (define std/srfi/146#mapping-min-entry
    (lambda (_mapping108532_)
      (let ((_val108534_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108532_
                'std/srfi/146#<mapping>))))
        (if _val108534_ _val108534_ (error)))
      (call-with-current-continuation
       (lambda (_return108537_)
         (std/srfi/146#mapping-fold
          (lambda (_key108539_ _value108540_ _acc108541_)
            (_return108537_ _key108539_ _value108540_))
          '#f
          _mapping108532_)
         (error '"mapping-min-key: empty map")))))
  (define std/srfi/146#mapping-max-entry
    (lambda (_mapping108521_)
      (let ((_val108523_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108521_
                'std/srfi/146#<mapping>))))
        (if _val108523_ _val108523_ (error)))
      (call-with-current-continuation
       (lambda (_return108526_)
         (std/srfi/146#mapping-fold/reverse
          (lambda (_key108528_ _value108529_ _acc108530_)
            (_return108526_ _key108528_ _value108529_))
          '#f
          _mapping108521_)
         (error '"mapping-max-key: empty map")))))
  (define std/srfi/146#mapping-key-predecessor
    (lambda (_mapping108511_ _obj108512_ _failure108513_)
      (let ((_val108515_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108511_
                'std/srfi/146#<mapping>))))
        (if _val108515_ _val108515_ (error)))
      (let ((_val108518_ (procedure? _failure108513_)))
        (if _val108518_ _val108518_ (error)))
      (std/srfi/146#tree-key-predecessor
       (##structure-ref _mapping108511_ '1 std/srfi/146#<mapping> '#f)
       (##structure-ref _mapping108511_ '2 std/srfi/146#<mapping> '#f)
       _obj108512_
       _failure108513_)))
  (define std/srfi/146#mapping-key-successor
    (lambda (_mapping108501_ _obj108502_ _failure108503_)
      (let ((_val108505_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108501_
                'std/srfi/146#<mapping>))))
        (if _val108505_ _val108505_ (error)))
      (let ((_val108508_ (procedure? _failure108503_)))
        (if _val108508_ _val108508_ (error)))
      (std/srfi/146#tree-key-successor
       (##structure-ref _mapping108501_ '1 std/srfi/146#<mapping> '#f)
       (##structure-ref _mapping108501_ '2 std/srfi/146#<mapping> '#f)
       _obj108502_
       _failure108503_)))
  (define std/srfi/146#mapping-range=
    (lambda (_mapping108487_ _obj108488_)
      (let ((_val108490_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108487_
                'std/srfi/146#<mapping>))))
        (if _val108490_ _val108490_ (error)))
      (let* ((_comparator108493_
              (##structure-ref _mapping108487_ '1 std/srfi/146#<mapping> '#f))
             (_g302818_
              (std/srfi/146#tree-split
               _comparator108493_
               (##structure-ref _mapping108487_ '2 std/srfi/146#<mapping> '#f)
               _obj108488_)))
        (begin
          (let ((_g302819_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302818_) (##vector-length _g302818_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302819_ 5)))
                (error "Context expects 5 values" _g302819_)))
          (let ((_tree<108495_
                 (let () (declare (not safe)) (##vector-ref _g302818_ 0)))
                (_tree<=108496_
                 (let () (declare (not safe)) (##vector-ref _g302818_ 1)))
                (_tree=108497_
                 (let () (declare (not safe)) (##vector-ref _g302818_ 2)))
                (_tree>=108498_
                 (let () (declare (not safe)) (##vector-ref _g302818_ 3)))
                (_tree>108499_
                 (let () (declare (not safe)) (##vector-ref _g302818_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108493_
               _tree=108497_)))))))
  (define std/srfi/146#mapping-range<
    (lambda (_mapping108473_ _obj108474_)
      (let ((_val108476_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108473_
                'std/srfi/146#<mapping>))))
        (if _val108476_ _val108476_ (error)))
      (let* ((_comparator108479_
              (##structure-ref _mapping108473_ '1 std/srfi/146#<mapping> '#f))
             (_g302820_
              (std/srfi/146#tree-split
               _comparator108479_
               (##structure-ref _mapping108473_ '2 std/srfi/146#<mapping> '#f)
               _obj108474_)))
        (begin
          (let ((_g302821_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302820_) (##vector-length _g302820_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302821_ 5)))
                (error "Context expects 5 values" _g302821_)))
          (let ((_tree<108481_
                 (let () (declare (not safe)) (##vector-ref _g302820_ 0)))
                (_tree<=108482_
                 (let () (declare (not safe)) (##vector-ref _g302820_ 1)))
                (_tree=108483_
                 (let () (declare (not safe)) (##vector-ref _g302820_ 2)))
                (_tree>=108484_
                 (let () (declare (not safe)) (##vector-ref _g302820_ 3)))
                (_tree>108485_
                 (let () (declare (not safe)) (##vector-ref _g302820_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108479_
               _tree<108481_)))))))
  (define std/srfi/146#mapping-range<=
    (lambda (_mapping108459_ _obj108460_)
      (let ((_val108462_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108459_
                'std/srfi/146#<mapping>))))
        (if _val108462_ _val108462_ (error)))
      (let* ((_comparator108465_
              (##structure-ref _mapping108459_ '1 std/srfi/146#<mapping> '#f))
             (_g302822_
              (std/srfi/146#tree-split
               _comparator108465_
               (##structure-ref _mapping108459_ '2 std/srfi/146#<mapping> '#f)
               _obj108460_)))
        (begin
          (let ((_g302823_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302822_) (##vector-length _g302822_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302823_ 5)))
                (error "Context expects 5 values" _g302823_)))
          (let ((_tree<108467_
                 (let () (declare (not safe)) (##vector-ref _g302822_ 0)))
                (_tree<=108468_
                 (let () (declare (not safe)) (##vector-ref _g302822_ 1)))
                (_tree=108469_
                 (let () (declare (not safe)) (##vector-ref _g302822_ 2)))
                (_tree>=108470_
                 (let () (declare (not safe)) (##vector-ref _g302822_ 3)))
                (_tree>108471_
                 (let () (declare (not safe)) (##vector-ref _g302822_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108465_
               _tree<=108468_)))))))
  (define std/srfi/146#mapping-range>
    (lambda (_mapping108445_ _obj108446_)
      (let ((_val108448_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108445_
                'std/srfi/146#<mapping>))))
        (if _val108448_ _val108448_ (error)))
      (let* ((_comparator108451_
              (##structure-ref _mapping108445_ '1 std/srfi/146#<mapping> '#f))
             (_g302824_
              (std/srfi/146#tree-split
               _comparator108451_
               (##structure-ref _mapping108445_ '2 std/srfi/146#<mapping> '#f)
               _obj108446_)))
        (begin
          (let ((_g302825_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302824_) (##vector-length _g302824_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302825_ 5)))
                (error "Context expects 5 values" _g302825_)))
          (let ((_tree<108453_
                 (let () (declare (not safe)) (##vector-ref _g302824_ 0)))
                (_tree<=108454_
                 (let () (declare (not safe)) (##vector-ref _g302824_ 1)))
                (_tree=108455_
                 (let () (declare (not safe)) (##vector-ref _g302824_ 2)))
                (_tree>=108456_
                 (let () (declare (not safe)) (##vector-ref _g302824_ 3)))
                (_tree>108457_
                 (let () (declare (not safe)) (##vector-ref _g302824_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108451_
               _tree>108457_)))))))
  (define std/srfi/146#mapping-range>=
    (lambda (_mapping108428_ _obj108429_)
      (let ((_val108431_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108428_
                'std/srfi/146#<mapping>))))
        (if _val108431_ _val108431_ (error)))
      (let ((_val108434_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108428_
                'std/srfi/146#<mapping>))))
        (if _val108434_ _val108434_ (error)))
      (let* ((_comparator108437_
              (##structure-ref _mapping108428_ '1 std/srfi/146#<mapping> '#f))
             (_g302826_
              (std/srfi/146#tree-split
               _comparator108437_
               (##structure-ref _mapping108428_ '2 std/srfi/146#<mapping> '#f)
               _obj108429_)))
        (begin
          (let ((_g302827_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302826_) (##vector-length _g302826_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302827_ 5)))
                (error "Context expects 5 values" _g302827_)))
          (let ((_tree<108439_
                 (let () (declare (not safe)) (##vector-ref _g302826_ 0)))
                (_tree<=108440_
                 (let () (declare (not safe)) (##vector-ref _g302826_ 1)))
                (_tree=108441_
                 (let () (declare (not safe)) (##vector-ref _g302826_ 2)))
                (_tree>=108442_
                 (let () (declare (not safe)) (##vector-ref _g302826_ 3)))
                (_tree>108443_
                 (let () (declare (not safe)) (##vector-ref _g302826_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108437_
               _tree>=108442_)))))))
  (define std/srfi/146#mapping-range=! std/srfi/146#mapping-range=)
  (define std/srfi/146#mapping-range<! std/srfi/146#mapping-range<)
  (define std/srfi/146#mapping-range>! std/srfi/146#mapping-range>)
  (define std/srfi/146#mapping-range<=! std/srfi/146#mapping-range<=)
  (define std/srfi/146#mapping-range>=! std/srfi/146#mapping-range>=)
  (define std/srfi/146#mapping-split
    (lambda (_mapping108414_ _obj108415_)
      (let ((_val108417_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108414_
                'std/srfi/146#<mapping>))))
        (if _val108417_ _val108417_ (error)))
      (let* ((_comparator108420_
              (##structure-ref _mapping108414_ '1 std/srfi/146#<mapping> '#f))
             (_g302828_
              (std/srfi/146#tree-split
               _comparator108420_
               (##structure-ref _mapping108414_ '2 std/srfi/146#<mapping> '#f)
               _obj108415_)))
        (begin
          (let ((_g302829_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302828_) (##vector-length _g302828_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302829_ 5)))
                (error "Context expects 5 values" _g302829_)))
          (let ((_tree<108422_
                 (let () (declare (not safe)) (##vector-ref _g302828_ 0)))
                (_tree<=108423_
                 (let () (declare (not safe)) (##vector-ref _g302828_ 1)))
                (_tree=108424_
                 (let () (declare (not safe)) (##vector-ref _g302828_ 2)))
                (_tree>=108425_
                 (let () (declare (not safe)) (##vector-ref _g302828_ 3)))
                (_tree>108426_
                 (let () (declare (not safe)) (##vector-ref _g302828_ 4))))
            (values (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108420_
                       _tree<108422_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108420_
                       _tree<=108423_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108420_
                       _tree=108424_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108420_
                       _tree>=108425_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108420_
                       _tree>108426_))))))))
  (define std/srfi/146#mapping-split! std/srfi/146#mapping-split)
  (define std/srfi/146#mapping-catenate
    (lambda (_comparator108399_
             _mapping1108400_
             _pivot-key108401_
             _pivot-value108402_
             _mapping2108403_)
      (let ((_val108405_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108399_
                'std/srfi/128#comparator::t))))
        (if _val108405_ _val108405_ (error)))
      (let ((_val108408_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108400_
                'std/srfi/146#<mapping>))))
        (if _val108408_ _val108408_ (error)))
      (let ((_val108411_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108403_
                'std/srfi/146#<mapping>))))
        (if _val108411_ _val108411_ (error)))
      (let ((__tmp302830
             (std/srfi/146#tree-catenate
              (##structure-ref _mapping1108400_ '2 std/srfi/146#<mapping> '#f)
              _pivot-key108401_
              _pivot-value108402_
              (##structure-ref
               _mapping2108403_
               '2
               std/srfi/146#<mapping>
               '#f))))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> _comparator108399_ __tmp302830))))
  (define std/srfi/146#mapping-catenate! std/srfi/146#mapping-catenate)
  (define std/srfi/146#mapping-map/monotone
    (lambda (_proc108386_ _comparator108387_ _mapping108388_)
      (let ((_val108390_ (procedure? _proc108386_)))
        (if _val108390_ _val108390_ (error)))
      (let ((_val108393_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108387_
                'std/srfi/128#comparator::t))))
        (if _val108393_ _val108393_ (error)))
      (let ((_val108396_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108388_
                'std/srfi/146#<mapping>))))
        (if _val108396_ _val108396_ (error)))
      (let ((__tmp302831
             (std/srfi/146#tree-map
              _proc108386_
              (##structure-ref
               _mapping108388_
               '2
               std/srfi/146#<mapping>
               '#f))))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> _comparator108387_ __tmp302831))))
  (define std/srfi/146#mapping-map/monotone! std/srfi/146#mapping-map/monotone)
  (define std/srfi/146#mapping-fold/reverse
    (lambda (_proc108376_ _acc108377_ _mapping108378_)
      (let ((_val108380_ (procedure? _proc108376_)))
        (if _val108380_ _val108380_ (error)))
      (let ((_val108383_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108378_
                'std/srfi/146#<mapping>))))
        (if _val108383_ _val108383_ (error)))
      (std/misc/rbtree#rbtree-foldr
       _proc108376_
       _acc108377_
       (##structure-ref _mapping108378_ '2 std/srfi/146#<mapping> '#f))))
  (define std/srfi/146#mapping-equality
    (lambda (_comparator108368_)
      (let ((_val108370_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108368_
                'std/srfi/128#comparator::t))))
        (if _val108370_ _val108370_ (error)))
      (lambda (_mapping1108373_ _mapping2108374_)
        (std/srfi/146#%mapping=?
         _comparator108368_
         _mapping1108373_
         _mapping2108374_))))
  (define std/srfi/146#mapping-ordering
    (lambda (_comparator108335_)
      (let ((_val108337_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108335_
                'std/srfi/128#comparator::t))))
        (if _val108337_ _val108337_ (error)))
      (let ((_value-equality108340_
             (##direct-structure-ref
              _comparator108335_
              '2
              std/srfi/128#comparator::t
              '#f))
            (_value-ordering108341_
             (std/srfi/128#comparator-ordering-predicate _comparator108335_)))
        (lambda (_mapping1108343_ _mapping2108344_)
          (let* ((_key-comparator108346_
                  (##structure-ref
                   _mapping1108343_
                   '1
                   std/srfi/146#<mapping>
                   '#f))
                 (_equality108348_
                  (##direct-structure-ref
                   _key-comparator108346_
                   '2
                   std/srfi/128#comparator::t
                   '#f))
                 (_ordering108350_
                  (std/srfi/128#comparator-ordering-predicate
                   _key-comparator108346_))
                 (_gen1108352_
                  (std/srfi/146#tree-generator
                   (##structure-ref
                    _mapping1108343_
                    '2
                    std/srfi/146#<mapping>
                    '#f)))
                 (_gen2108354_
                  (std/srfi/146#tree-generator
                   (##structure-ref
                    _mapping2108344_
                    '2
                    std/srfi/146#<mapping>
                    '#f))))
            (let _loop108357_ ()
              (let ((_item1108360_ (_gen1108352_))
                    (_item2108361_ (_gen2108354_)))
                (if (eof-object? _item1108360_)
                    (not (eof-object? _item2108361_))
                    (if (eof-object? _item2108361_)
                        '#f
                        (let ((_key1108363_ (car _item1108360_))
                              (_value1108364_ (cadr _item1108360_))
                              (_key2108365_ (car _item2108361_))
                              (_value2108366_ (cadr _item2108361_)))
                          (if (_equality108348_ _key1108363_ _key2108365_)
                              (if (_value-equality108340_
                                   _value1108364_
                                   _value2108366_)
                                  (_loop108357_)
                                  (_value-ordering108341_
                                   _value1108364_
                                   _value2108366_))
                              (_ordering108350_
                               _key1108363_
                               _key2108365_))))))))))))
  (define std/srfi/146#make-mapping-comparator
    (lambda (_comparator108333_)
      (let ((__tmp302833 (std/srfi/146#mapping-equality _comparator108333_))
            (__tmp302832 (std/srfi/146#mapping-ordering _comparator108333_)))
        (declare (not safe))
        (##structure
         std/srfi/128#comparator::t
         std/srfi/146#mapping?
         __tmp302833
         __tmp302832
         '#f))))
  (define std/srfi/146#mapping-comparator
    (std/srfi/146#make-mapping-comparator
     (std/srfi/128#make-default-comparator)))
  (std/srfi/128#comparator-register-default! std/srfi/146#mapping-comparator))
