(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/151#bitwise-nand
    (lambda (_i105652_ _j105653_)
      (bitwise-not (bitwise-and _i105652_ _j105653_))))
  (define std/srfi/151#bitwise-nor
    (lambda (_i105649_ _j105650_)
      (bitwise-not (bitwise-ior _i105649_ _j105650_))))
  (define std/srfi/151#bitwise-andc1
    (lambda (_i105646_ _j105647_)
      (bitwise-and (bitwise-not _i105646_) _j105647_)))
  (define std/srfi/151#bitwise-andc2
    (lambda (_i105643_ _j105644_)
      (bitwise-and _i105643_ (bitwise-not _j105644_))))
  (define std/srfi/151#bitwise-orc1
    (lambda (_i105640_ _j105641_)
      (bitwise-ior (bitwise-not _i105640_) _j105641_)))
  (define std/srfi/151#bitwise-orc2
    (lambda (_i105637_ _j105638_)
      (bitwise-ior _i105637_ (bitwise-not _j105638_))))
  (define std/srfi/151#bitwise-eqv
    (lambda _args105630_
      (let _lp105632_ ((_args105634_ _args105630_) (_ans105635_ '-1))
        (if (pair? _args105634_)
            (_lp105632_
             (cdr _args105634_)
             (bitwise-not (bitwise-xor _ans105635_ (car _args105634_))))
            _ans105635_))))
  (define std/srfi/151#mask
    (lambda (_start105627_ _end105628_)
      (bitwise-not (arithmetic-shift '-1 (- _end105628_ _start105627_)))))
  (define std/srfi/151#any-bit-set?
    (lambda (_test-bits105624_ _n105625_)
      (not (zero? (bitwise-and _test-bits105624_ _n105625_)))))
  (define std/srfi/151#every-bit-set?
    (lambda (_test-bits105621_ _n105622_)
      (= _test-bits105621_ (bitwise-and _test-bits105621_ _n105622_))))
  (define std/srfi/151#bit-field
    (lambda (_n105617_ _start105618_ _end105619_)
      (bitwise-and
       (std/srfi/151#mask _start105618_ _end105619_)
       (arithmetic-shift _n105617_ (- _start105618_)))))
  (define std/srfi/151#bit-field-any?
    (lambda (_n105613_ _start105614_ _end105615_)
      (not (zero? (bitwise-and
                   (arithmetic-shift _n105613_ (- _start105614_))
                   (std/srfi/151#mask _start105614_ _end105615_))))))
  (define std/srfi/151#bit-field-every?
    (lambda (_n105607_ _start105608_ _end105609_)
      (let ((_m105611_ (std/srfi/151#mask _start105608_ _end105609_)))
        (eqv? _m105611_
              (bitwise-and
               (arithmetic-shift _n105607_ (- _start105608_))
               _m105611_)))))
  (define std/srfi/151#bit-field-clear
    (lambda (_n105603_ _start105604_ _end105605_)
      (std/srfi/151#bit-field-replace _n105603_ '0 _start105604_ _end105605_)))
  (define std/srfi/151#bit-field-set
    (lambda (_n105599_ _start105600_ _end105601_)
      (std/srfi/151#bit-field-replace
       _n105599_
       '-1
       _start105600_
       _end105601_)))
  (define std/srfi/151#bit-field-replace
    (lambda (_n105592_ _newfield105593_ _start105594_ _end105595_)
      (let ((_m105597_ (std/srfi/151#mask _start105594_ _end105595_)))
        (bitwise-ior
         (bitwise-and
          _n105592_
          (bitwise-not (arithmetic-shift _m105597_ _start105594_)))
         (arithmetic-shift
          (bitwise-and _newfield105593_ _m105597_)
          _start105594_)))))
  (define std/srfi/151#bit-field-replace-same
    (lambda (_to105587_ _from105588_ _start105589_ _end105590_)
      (std/srfi/151#bitwise-if
       (arithmetic-shift
        (std/srfi/151#mask _start105589_ _end105590_)
        _start105589_)
       _from105588_
       _to105587_)))
  (define std/srfi/151#bit-field-rotate
    (lambda (_n105576_ _count105577_ _start105578_ _end105579_)
      (letrec* ((_width105581_ (- _end105579_ _start105578_)))
        (set! _count105577_ (modulo _count105577_ _width105581_))
        (let ((_mask105583_
               (bitwise-not (arithmetic-shift '-1 _width105581_))))
          (letrec* ((_zn105585_
                     (bitwise-and
                      _mask105583_
                      (arithmetic-shift _n105576_ (- _start105578_)))))
            (bitwise-ior
             (arithmetic-shift
              (bitwise-ior
               (bitwise-and
                _mask105583_
                (arithmetic-shift _zn105585_ _count105577_))
               (arithmetic-shift _zn105585_ (- _count105577_ _width105581_)))
              _start105578_)
             (bitwise-and
              (bitwise-not (arithmetic-shift _mask105583_ _start105578_))
              _n105576_)))))))
  (define std/srfi/151#bit-reverse
    (lambda (_k105566_ _n105567_)
      (let _$loop105569_ ((_m105572_
                           (if (negative? _n105567_)
                               (bitwise-not _n105567_)
                               _n105567_))
                          (_k105573_ (+ '-1 _k105566_))
                          (_rvs105574_ '0))
        (if (negative? _k105573_)
            (if (negative? _n105567_) (bitwise-not _rvs105574_) _rvs105574_)
            (_$loop105569_
             (arithmetic-shift _m105572_ '-1)
             (+ '-1 _k105573_)
             (bitwise-ior
              (arithmetic-shift _rvs105574_ '1)
              (bitwise-and '1 _m105572_)))))))
  (define std/srfi/151#bit-field-reverse
    (lambda (_n105556_ _start105557_ _end105558_)
      (letrec* ((_width105560_ (- _end105558_ _start105557_)))
        (let ((_mask105562_
               (bitwise-not (arithmetic-shift '-1 _width105560_))))
          (letrec* ((_zn105564_
                     (bitwise-and
                      _mask105562_
                      (arithmetic-shift _n105556_ (- _start105557_)))))
            (bitwise-ior
             (arithmetic-shift
              (std/srfi/151#bit-reverse _width105560_ _zn105564_)
              _start105557_)
             (bitwise-and
              (bitwise-not (arithmetic-shift _mask105562_ _start105557_))
              _n105556_)))))))
  (define std/srfi/151#copy-bit
    (lambda (_index105552_ _to105553_ _bool105554_)
      (if _bool105554_
          (bitwise-ior _to105553_ (arithmetic-shift '1 _index105552_))
          (bitwise-and
           _to105553_
           (bitwise-not (arithmetic-shift '1 _index105552_))))))
  (define std/srfi/151#bits->list
    (lambda (_k105536_ . _len105537_)
      (if (null? _len105537_)
          (let _$loop105539_ ((_k105542_ _k105536_) (_lst105543_ '()))
            (if (<= _k105542_ '0)
                (reverse _lst105543_)
                (_$loop105539_
                 (arithmetic-shift _k105542_ '-1)
                 (cons (odd? _k105542_) _lst105543_))))
          (let _$loop105545_ ((_idx105548_ (+ '-1 (car _len105537_)))
                              (_k105549_ _k105536_)
                              (_lst105550_ '()))
            (if (negative? _idx105548_)
                (reverse _lst105550_)
                (_$loop105545_
                 (+ '-1 _idx105548_)
                 (arithmetic-shift _k105549_ '-1)
                 (cons (odd? _k105549_) _lst105550_)))))))
  (define std/srfi/151#list->bits
    (lambda (_bools105528_)
      (let _$loop105530_ ((_bs105533_ (reverse _bools105528_))
                          (_acc105534_ '0))
        (if (null? _bs105533_)
            _acc105534_
            (_$loop105530_
             (cdr _bs105533_)
             (+ _acc105534_ _acc105534_ (if (car _bs105533_) '1 '0)))))))
  (define std/srfi/151#bits
    (lambda _bools105526_ (std/srfi/151#list->bits _bools105526_)))
  (define std/srfi/151#bitwise-if
    (lambda (_mask105522_ _n0105523_ _n1105524_)
      (bitwise-ior
       (bitwise-and _mask105522_ _n0105523_)
       (bitwise-and (bitwise-not _mask105522_) _n1105524_))))
  (define std/srfi/151#bits->vector__0
    (lambda (_i105517_) (list->vector (std/srfi/151#bits->list _i105517_))))
  (define std/srfi/151#bits->vector__1
    (lambda (_i105519_ _len105520_)
      (list->vector (std/srfi/151#bits->list _i105519_ _len105520_))))
  (define std/srfi/151#bits->vector
    (lambda _g289748_
      (let ((_g289747_ (let () (declare (not safe)) (##length _g289748_))))
        (cond ((let () (declare (not safe)) (##fx= _g289747_ 1))
               (apply std/srfi/151#bits->vector__0 _g289748_))
              ((let () (declare (not safe)) (##fx= _g289747_ 2))
               (apply std/srfi/151#bits->vector__1 _g289748_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/151#bits->vector
                _g289748_))))))
  (define std/srfi/151#vector->bits
    (lambda (_vector105515_)
      (std/srfi/151#list->bits (vector->list _vector105515_))))
  (define std/srfi/151#bit-swap
    (lambda (_n1105508_ _n2105509_ _i105510_)
      (let ((_n1-bit105512_ (bit-set? _n1105508_ _i105510_))
            (_n2-bit105513_ (bit-set? _n2105509_ _i105510_)))
        (std/srfi/151#copy-bit
         _n2105509_
         (std/srfi/151#copy-bit _n1105508_ _i105510_ _n2-bit105513_)
         _n1-bit105512_))))
  (define std/srfi/151#bitwise-fold
    (lambda (_proc105497_ _seed105498_ _i105499_)
      (let ((_len105501_ (integer-length _i105499_)))
        (let _loop105503_ ((_n105505_ '0) (_r105506_ _seed105498_))
          (if (= _n105505_ _len105501_)
              _r105506_
              (_loop105503_
               (+ _n105505_ '1)
               (_proc105497_ (bit-set? _n105505_ _i105499_) _r105506_)))))))
  (define std/srfi/151#bitwise-for-each
    (lambda (_proc105488_ _i105489_)
      (let ((_len105491_ (integer-length _i105489_)))
        (let _loop105493_ ((_n105495_ '0))
          (if (< _n105495_ _len105491_)
              (begin
                (_proc105488_ (bit-set? _n105495_ _i105489_))
                (_loop105493_ (+ _n105495_ '1)))
              '#!void)))))
  (define std/srfi/151#bitwise-unfold
    (lambda (_stop?105477_ _mapper105478_ _successor105479_ _seed105480_)
      (let _loop105482_ ((_n105484_ '0)
                         (_result105485_ '0)
                         (_state105486_ _seed105480_))
        (if (_stop?105477_ _state105486_)
            _result105485_
            (_loop105482_
             (+ _n105484_ '1)
             (std/srfi/151#copy-bit
              _n105484_
              _result105485_
              (_mapper105478_ _state105486_))
             (_successor105479_ _state105486_))))))
  (define std/srfi/151#make-bitwise-generator
    (lambda (_i105472_)
      (lambda ()
        (let ((_bit105475_ (bit-set? '0 _i105472_)))
          (set! _i105472_ (arithmetic-shift _i105472_ '-1))
          _bit105475_)))))
