(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/f32#f32vector-unfold
    (lambda (_f147362_ _len147364_ _seed147366_)
      (declare (not safe))
      (begin
        (if (procedure? _f147362_)
            '#!void
            (error '"Bad argument; expected procedure" _f147362_))
        (let ((_v147370_ (make-f32vector _len147364_)))
          (let _lp147373_ ((_i147376_ '0) (_state147378_ _seed147366_))
            (if (fx< _i147376_ _len147364_)
                (let ((_g299348_ (_f147362_ _i147376_ _state147378_)))
                  (begin
                    (let ((_g299349_
                           (if (##values? _g299348_)
                               (##vector-length _g299348_)
                               1)))
                      (if (not (##fx= _g299349_ 2))
                          (error "Context expects 2 values" _g299349_)))
                    (let ((_x147381_ (##vector-ref _g299348_ 0))
                          (_state147383_ (##vector-ref _g299348_ 1)))
                      (begin
                        (if (flonum? _x147381_)
                            '#!void
                            (error '"Bad generated value" _x147381_))
                        (f32vector-set! _v147370_ _i147376_ _x147381_)
                        (_lp147373_ (fx+ _i147376_ '1) _state147383_)))))
                _v147370_))))))
  (define std/srfi/160/f32#f32vector-unfold-right
    (lambda (_f147339_ _len147341_ _seed147343_)
      (declare (not safe))
      (begin
        (if (procedure? _f147339_)
            '#!void
            (error '"Bad argument; expected procedure" _f147339_))
        (let ((_v147347_ (make-f32vector _len147341_)))
          (let _lp147350_ ((_i147353_ (fx- _len147341_ '1))
                           (_state147355_ _seed147343_))
            (if (fx>= _i147353_ '0)
                (let ((_g299350_ (_f147339_ _i147353_ _state147355_)))
                  (begin
                    (let ((_g299351_
                           (if (##values? _g299350_)
                               (##vector-length _g299350_)
                               1)))
                      (if (not (##fx= _g299351_ 2))
                          (error "Context expects 2 values" _g299351_)))
                    (let ((_x147358_ (##vector-ref _g299350_ 0))
                          (_state147360_ (##vector-ref _g299350_ 1)))
                      (begin
                        (if (flonum? _x147358_)
                            '#!void
                            (error '"Bad generated value" _x147358_))
                        (f32vector-set! _v147347_ _i147353_ _x147358_)
                        (_lp147350_ (fx- _i147353_ '1) _state147360_)))))
                _v147347_))))))
  (define std/srfi/160/f32#f32vector-copy__%
    (lambda (_vec147311_ _start147313_ _end147315_)
      (let ((_v147318_ (make-f32vector (fx- _end147315_ _start147313_))))
        (std/srfi/160/f32#f32vector-copy!
         _v147318_
         '0
         _vec147311_
         _start147313_
         _end147315_)
        _v147318_)))
  (define std/srfi/160/f32#f32vector-copy__0
    (lambda (_vec147324_)
      (let* ((_start147326_ '0) (_end147328_ (f32vector-length _vec147324_)))
        (std/srfi/160/f32#f32vector-copy__%
         _vec147324_
         _start147326_
         _end147328_))))
  (define std/srfi/160/f32#f32vector-copy__1
    (lambda (_vec147330_ _start147331_)
      (let ((_end147333_ (f32vector-length _vec147330_)))
        (std/srfi/160/f32#f32vector-copy__%
         _vec147330_
         _start147331_
         _end147333_))))
  (define std/srfi/160/f32#f32vector-copy
    (lambda _g299353_
      (let ((_g299352_ (let () (declare (not safe)) (##length _g299353_))))
        (cond ((let () (declare (not safe)) (##fx= _g299352_ 1))
               (apply std/srfi/160/f32#f32vector-copy__0 _g299353_))
              ((let () (declare (not safe)) (##fx= _g299352_ 2))
               (apply std/srfi/160/f32#f32vector-copy__1 _g299353_))
              ((let () (declare (not safe)) (##fx= _g299352_ 3))
               (apply std/srfi/160/f32#f32vector-copy__% _g299353_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-copy
                _g299353_))))))
  (define std/srfi/160/f32#f32vector-copy!
    (lambda (_to147290_ _at147292_ _from147294_ _start147296_ _end147298_)
      (declare (not safe))
      (begin
        (if (f32vector? _to147290_) '#!void (error '"Bad argument" _to147290_))
        (if (f32vector? _from147294_)
            '#!void
            (error '"Bad argument" _from147294_))
        (if (and (fixnum? _at147292_)
                 (fx<= '0 _at147292_ (fx- (f32vector-length _at147292_) '1)))
            '#!void
            (error '"Index out of range" _to147290_ _at147292_))
        (if (and (fixnum? _start147296_)
                 (fx<= '0
                       _start147296_
                       (fx- (f32vector-length _from147294_) '1)))
            '#!void
            (error '"Index out of range" _from147294_ _start147296_))
        (if (and (fixnum? _end147298_)
                 (fx<= _start147296_
                       _end147298_
                       (f32vector-length _from147294_)))
            '#!void
            (error '"Index out of range" _from147294_ _end147298_))
        (if (fx<= (fx- _end147298_ _start147296_)
                  (fx- (f32vector-length _to147290_) _at147292_))
            '#!void
            (error '"Destination area too small"
                   _to147290_
                   _at147292_
                   _from147294_
                   _start147296_
                   _end147298_))
        (let _lp147302_ ((_i147305_ _start147296_) (_j147307_ _at147292_))
          (if (fx< _i147305_ _end147298_)
              (begin
                (f32vector-set!
                 _to147290_
                 _j147307_
                 (f32vector-ref _from147294_ _i147305_))
                (_lp147302_ (fx+ _i147305_ '1) (fx+ _j147307_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-reverse-copy__%
    (lambda (_vec147262_ _start147264_ _end147266_)
      (let ((_v147269_ (make-f32vector (fx- _end147266_ _start147264_))))
        (std/srfi/160/f32#f32vector-reverse-copy!
         _v147269_
         '0
         _vec147262_
         _start147264_
         _end147266_)
        _v147269_)))
  (define std/srfi/160/f32#f32vector-reverse-copy__0
    (lambda (_vec147275_)
      (let* ((_start147277_ '0) (_end147279_ (f32vector-length _vec147275_)))
        (std/srfi/160/f32#f32vector-reverse-copy__%
         _vec147275_
         _start147277_
         _end147279_))))
  (define std/srfi/160/f32#f32vector-reverse-copy__1
    (lambda (_vec147281_ _start147282_)
      (let ((_end147284_ (f32vector-length _vec147281_)))
        (std/srfi/160/f32#f32vector-reverse-copy__%
         _vec147281_
         _start147282_
         _end147284_))))
  (define std/srfi/160/f32#f32vector-reverse-copy
    (lambda _g299355_
      (let ((_g299354_ (let () (declare (not safe)) (##length _g299355_))))
        (cond ((let () (declare (not safe)) (##fx= _g299354_ 1))
               (apply std/srfi/160/f32#f32vector-reverse-copy__0 _g299355_))
              ((let () (declare (not safe)) (##fx= _g299354_ 2))
               (apply std/srfi/160/f32#f32vector-reverse-copy__1 _g299355_))
              ((let () (declare (not safe)) (##fx= _g299354_ 3))
               (apply std/srfi/160/f32#f32vector-reverse-copy__% _g299355_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-reverse-copy
                _g299355_))))))
  (define std/srfi/160/f32#f32vector-reverse-copy!
    (lambda (_to147241_ _at147243_ _from147245_ _start147247_ _end147249_)
      (declare (not safe))
      (begin
        (if (f32vector? _to147241_) '#!void (error '"Bad argument" _to147241_))
        (if (f32vector? _from147245_)
            '#!void
            (error '"Bad argument" _from147245_))
        (if (and (fixnum? _at147243_)
                 (fx<= '0 _at147243_ (fx- (f32vector-length _at147243_) '1)))
            '#!void
            (error '"Index out of range" _to147241_ _at147243_))
        (if (and (fixnum? _start147247_)
                 (fx<= '0
                       _start147247_
                       (fx- (f32vector-length _from147245_) '1)))
            '#!void
            (error '"Index out of range" _from147245_ _start147247_))
        (if (and (fixnum? _end147249_)
                 (fx<= _start147247_
                       _end147249_
                       (f32vector-length _from147245_)))
            '#!void
            (error '"Index out of range" _from147245_ _end147249_))
        (if (fx<= (fx- _end147249_ _start147247_)
                  (fx- (f32vector-length _to147241_) _at147243_))
            '#!void
            (error '"Destination area too small"
                   _to147241_
                   _at147243_
                   _from147245_
                   _start147247_
                   _end147249_))
        (let _lp147253_ ((_i147256_ (fx- _end147249_ '1))
                         (_j147258_ _at147243_))
          (if (fx>= _i147256_ _start147247_)
              (begin
                (f32vector-set!
                 _to147241_
                 _j147258_
                 (f32vector-ref _from147245_ _i147256_))
                (_lp147253_ (fx- _i147256_ '1) (fx+ _j147258_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-append
    (lambda _args147238_
      (std/srfi/160/f32#f32vector-concatenate _args147238_)))
  (define std/srfi/160/f32#f32vector-concatenate
    (lambda (_lst147178_)
      (let* ((_len147186_
              (foldl1 (lambda (_v147181_ _r147183_)
                        (fx+ (f32vector-length _v147181_) _r147183_))
                      '0
                      _lst147178_))
             (_v147189_ (make-f32vector _len147186_)))
        (declare (not safe))
        (let _lp147193_ ((_rest147196_ _lst147178_) (_at147198_ '0))
          (let* ((_rest147200147208_ _rest147196_)
                 (_else147202147216_ (lambda () _v147189_))
                 (_K147204147226_
                  (lambda (_rest147219_ _u147220_)
                    (let ((_ulen147223_ (f32vector-length _u147220_)))
                      (std/srfi/160/f32#f32vector-copy!
                       _v147189_
                       _at147198_
                       _u147220_
                       '0
                       _ulen147223_)
                      (_lp147193_
                       _rest147219_
                       (fx+ _at147198_ _ulen147223_))))))
            (if (##pair? _rest147200147208_)
                (let ((_hd147205147229_ (##car _rest147200147208_))
                      (_tl147206147231_ (##cdr _rest147200147208_)))
                  (let* ((_u147234_ _hd147205147229_)
                         (_rest147236_ _tl147206147231_))
                    (_K147204147226_ _rest147236_ _u147234_)))
                (_else147202147216_)))))))
  (define std/srfi/160/f32#f32vector-append-subvectors
    (lambda _args147050_
      (let* ((_len147111_
              (let _lp147053_ ((_rest147056_ _args147050_) (_r147058_ '0))
                (let* ((_rest147060147072_ _rest147056_)
                       (_else147062147080_ (lambda () _r147058_))
                       (_K147064147089_
                        (lambda (_rest147083_ _end147084_ _start147086_)
                          (_lp147053_
                           _rest147083_
                           (fx+ _r147058_ (fx- _end147084_ _start147086_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest147060147072_))
                      (let ((_tl147066147092_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest147060147072_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl147066147092_))
                            (let ((_hd147067147095_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl147066147092_)))
                                  (_tl147068147097_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl147066147092_))))
                              (let ((_start147100_ _hd147067147095_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl147068147097_))
                                    (let ((_hd147069147102_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl147068147097_)))
                                          (_tl147070147104_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl147068147097_))))
                                      (let* ((_end147107_ _hd147069147102_)
                                             (_rest147109_ _tl147070147104_))
                                        (_K147064147089_
                                         _rest147109_
                                         _end147107_
                                         _start147100_)))
                                    (_else147062147080_))))
                            (_else147062147080_)))
                      (_else147062147080_)))))
             (_v147114_ (make-f32vector _len147111_)))
        (let _lp147118_ ((_rest147120_ _args147050_) (_at147121_ '0))
          (let* ((_rest147123147135_ _rest147120_)
                 (_else147125147143_ (lambda () _v147114_))
                 (_K147127147152_
                  (lambda (_rest147146_ _end147147_ _start147148_ _u147149_)
                    (std/srfi/160/f32#f32vector-copy!
                     _v147114_
                     _at147121_
                     _u147149_
                     _start147148_
                     _end147147_)
                    (_lp147118_
                     _rest147146_
                     (fx+ _at147121_ (fx- _end147147_ _start147148_))))))
            (if (let () (declare (not safe)) (##pair? _rest147123147135_))
                (let ((_hd147128147155_
                       (let ()
                         (declare (not safe))
                         (##car _rest147123147135_)))
                      (_tl147129147157_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest147123147135_))))
                  (let ((_u147160_ _hd147128147155_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl147129147157_))
                        (let ((_hd147130147162_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl147129147157_)))
                              (_tl147131147164_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl147129147157_))))
                          (let ((_start147167_ _hd147130147162_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl147131147164_))
                                (let ((_hd147132147169_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl147131147164_)))
                                      (_tl147133147171_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl147131147164_))))
                                  (let* ((_end147174_ _hd147132147169_)
                                         (_rest147176_ _tl147133147171_))
                                    (_K147127147152_
                                     _rest147176_
                                     _end147174_
                                     _start147167_
                                     _u147160_)))
                                (_else147125147143_))))
                        (_else147125147143_))))
                (_else147125147143_)))))))
  (define std/srfi/160/f32#f32vector-empty?
    (lambda (_v147047_) (fxzero? (f32vector-length _v147047_))))
  (define std/srfi/160/f32#f32vector=
    (lambda (_v146989_ . _args146991_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146989_) '#!void (error '"Bad argument" _v146989_))
        (let ((_vlen146995_ (f32vector-length _v146989_)))
          (let _lp146998_ ((_rest147001_ _args146991_))
            (let* ((_rest147003147011_ _rest147001_)
                   (_else147005147019_ (lambda () '#t))
                   (_K147007147035_
                    (lambda (_rest147022_ _u147023_)
                      (if (f32vector? _u147023_)
                          '#!void
                          (error '"Bad argument" _u147023_))
                      (let ((_ulen147026_ (f32vector-length _u147023_)))
                        (if (fx= _vlen146995_ _ulen147026_)
                            (let _cmp147029_ ((_i147032_ '0))
                              (if (fx< _i147032_ _vlen146995_)
                                  (if (= (f32vector-ref _v146989_ _i147032_)
                                         (f32vector-ref _u147023_ _i147032_))
                                      (_cmp147029_ (fx+ _i147032_ '1))
                                      '#f)
                                  (_lp146998_ _rest147022_)))
                            '#f)))))
              (if (##pair? _rest147003147011_)
                  (let ((_hd147008147038_ (##car _rest147003147011_))
                        (_tl147009147040_ (##cdr _rest147003147011_)))
                    (let* ((_u147043_ _hd147008147038_)
                           (_rest147045_ _tl147009147040_))
                      (_K147007147035_ _rest147045_ _u147043_)))
                  (_else147005147019_))))))))
  (define std/srfi/160/f32#f32vector-take
    (lambda (_v146981_ _n146983_)
      (let ((_u146986_ (make-f32vector _n146983_)))
        (std/srfi/160/f32#f32vector-copy! _u146986_ '0 _v146981_ '0 _n146983_)
        _u146986_)))
  (define std/srfi/160/f32#f32vector-take-right
    (lambda (_v146966_ _n146968_)
      (let* ((_vlen146971_ (f32vector-length _v146966_))
             (_ulen146974_ (fx- _vlen146971_ _n146968_))
             (_u146977_ (make-f32vector _ulen146974_)))
        (std/srfi/160/f32#f32vector-copy!
         _u146977_
         '0
         _v146966_
         _n146968_
         _vlen146971_)
        _u146977_)))
  (define std/srfi/160/f32#f32vector-drop
    (lambda (_v146951_ _n146953_)
      (let* ((_vlen146956_ (f32vector-length _v146951_))
             (_ulen146959_ (fx- _vlen146956_ _n146953_))
             (_u146962_ (make-f32vector _ulen146959_)))
        (std/srfi/160/f32#f32vector-copy!
         _u146962_
         '0
         _v146951_
         _n146953_
         _vlen146956_)
        _u146962_)))
  (define std/srfi/160/f32#f32vector-drop-right
    (lambda (_v146936_ _n146938_)
      (let* ((_vlen146941_ (f32vector-length _v146936_))
             (_ulen146944_ (fx- _vlen146941_ _n146938_))
             (_u146947_ (make-f32vector _ulen146944_)))
        (std/srfi/160/f32#f32vector-copy!
         _u146947_
         '0
         _v146936_
         '0
         _ulen146944_)
        _u146947_)))
  (define std/srfi/160/f32#f32vector-segment
    (lambda (_v146918_ _n146920_)
      (let _lp146923_ ((_i146926_ '0)
                       (_rest146928_ (f32vector-length _v146918_))
                       (_r146930_ '()))
        (if (fx> _r146930_ '0)
            (let ((_size146933_ (fxmin _n146920_ _rest146928_)))
              (_lp146923_
               (fx+ _i146926_ _size146933_)
               (fx- _rest146928_ _size146933_)
               (cons (std/srfi/160/f32#f32vector-copy__%
                      _v146918_
                      _i146926_
                      (fx+ _i146926_ _size146933_))
                     _r146930_)))
            (reverse _r146930_)))))
  (define std/srfi/160/f32#f32vector-fold__0
    (lambda (_kons146878_ _knil146880_ _v146882_)
      (if (procedure? _kons146878_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146878_))
      (let ((_end146885_ (f32vector-length _v146882_)))
        (declare (not safe))
        (let _lp146889_ ((_i146892_ '0) (_r146894_ _knil146880_))
          (if (fx< _i146892_ _end146885_)
              (_lp146889_
               (fx+ _i146892_ '1)
               (_kons146878_ _r146894_ (f32vector-ref _v146882_ _i146892_)))
              _r146894_)))))
  (define std/srfi/160/f32#f32vector-fold__1
    (lambda (_kons146897_ _knil146898_ _v146899_ . _vs146900_)
      (if (procedure? _kons146897_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146897_))
      (let* ((_vs146903_ (cons _v146899_ _vs146900_))
             (_end146905_ (apply fxmin (map f32vector-length _vs146903_))))
        (declare (not safe))
        (let _lp146909_ ((_i146911_ '0) (_r146912_ _knil146898_))
          (if (fx< _i146911_ _end146905_)
              (_lp146909_
               (fx+ _i146911_ '1)
               (apply _kons146897_
                      _r146912_
                      (map (lambda (_g146913146915_)
                             (f32vector-ref _g146913146915_ _i146911_))
                           _vs146903_)))
              _r146912_)))))
  (define std/srfi/160/f32#f32vector-fold
    (lambda _g299357_
      (let ((_g299356_ (let () (declare (not safe)) (##length _g299357_))))
        (cond ((let () (declare (not safe)) (##fx= _g299356_ 3))
               (apply std/srfi/160/f32#f32vector-fold__0 _g299357_))
              ((let () (declare (not safe)) (##fx>= _g299356_ 3))
               (apply std/srfi/160/f32#f32vector-fold__1 _g299357_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-fold
                _g299357_))))))
  (define std/srfi/160/f32#f32vector-fold-right__0
    (lambda (_kons146838_ _knil146840_ _v146842_)
      (if (procedure? _kons146838_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146838_))
      (let ((_last146845_ (fx- (f32vector-length _v146842_) '1)))
        (declare (not safe))
        (let _lp146849_ ((_i146852_ _last146845_) (_r146854_ _knil146840_))
          (if (fx>= _i146852_ '0)
              (_lp146849_
               (fx- _i146852_ '1)
               (_kons146838_ _r146854_ (f32vector-ref _v146842_ _i146852_)))
              _r146854_)))))
  (define std/srfi/160/f32#f32vector-fold-right__1
    (lambda (_kons146857_ _knil146858_ _v146859_ . _vs146860_)
      (if (procedure? _kons146857_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146857_))
      (let* ((_vs146863_ (cons _v146859_ _vs146860_))
             (_last146865_
              (fx- (apply min (map f32vector-length _vs146863_)) '1)))
        (declare (not safe))
        (let _lp146869_ ((_i146871_ _last146865_) (_r146872_ _knil146858_))
          (if (fx>= _i146871_ '0)
              (_lp146869_
               (fx- _i146871_ '1)
               (apply _kons146857_
                      _r146872_
                      (map (lambda (_g146873146875_)
                             (f32vector-ref _g146873146875_ _i146871_))
                           _vs146863_)))
              _r146872_)))))
  (define std/srfi/160/f32#f32vector-fold-right
    (lambda _g299359_
      (let ((_g299358_ (let () (declare (not safe)) (##length _g299359_))))
        (cond ((let () (declare (not safe)) (##fx= _g299358_ 3))
               (apply std/srfi/160/f32#f32vector-fold-right__0 _g299359_))
              ((let () (declare (not safe)) (##fx>= _g299358_ 3))
               (apply std/srfi/160/f32#f32vector-fold-right__1 _g299359_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-fold-right
                _g299359_))))))
  (define std/srfi/160/f32#f32vector-map__0
    (lambda (_f146798_ _v146800_)
      (if (procedure? _f146798_)
          '#!void
          (error '"Bad argument; expected procedure" _f146798_))
      (let* ((_len146803_ (f32vector-length _v146800_))
             (_u146806_ (make-f32vector _len146803_)))
        (declare (not safe))
        (let _lp146811_ ((_i146814_ '0))
          (if (fx< _i146814_ _len146803_)
              (begin
                (f32vector-set!
                 _u146806_
                 _i146814_
                 (f32vector-ref _v146800_ _i146814_))
                (_lp146811_ (fx+ _i146814_ '1)))
              _u146806_)))))
  (define std/srfi/160/f32#f32vector-map__1
    (lambda (_f146817_ _v146818_ . _vs146819_)
      (if (procedure? _f146817_)
          '#!void
          (error '"Bad argument; expected procedure" _f146817_))
      (let* ((_vs146822_ (cons _v146818_ _vs146819_))
             (_len146824_ (apply fxmin (map f32vector-length _vs146822_)))
             (_u146826_ (make-f32vector _len146824_)))
        (declare (not safe))
        (let _lp146830_ ((_i146832_ '0))
          (if (fx< _i146832_ _len146824_)
              (begin
                (f32vector-set!
                 _u146826_
                 _i146832_
                 (apply _f146817_
                        (map (lambda (_g146833146835_)
                               (f32vector-ref _g146833146835_ _i146832_))
                             _vs146822_)))
                (_lp146830_ (fx+ _i146832_ '1)))
              _u146826_)))))
  (define std/srfi/160/f32#f32vector-map
    (lambda _g299361_
      (let ((_g299360_ (let () (declare (not safe)) (##length _g299361_))))
        (cond ((let () (declare (not safe)) (##fx= _g299360_ 2))
               (apply std/srfi/160/f32#f32vector-map__0 _g299361_))
              ((let () (declare (not safe)) (##fx>= _g299360_ 2))
               (apply std/srfi/160/f32#f32vector-map__1 _g299361_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-map
                _g299361_))))))
  (define std/srfi/160/f32#f32vector-map!__0
    (lambda (_f146764_ _v146766_)
      (if (procedure? _f146764_)
          '#!void
          (error '"Bad argument; expected procedure" _f146764_))
      (let ((_len146769_ (f32vector-length _v146766_)))
        (declare (not safe))
        (let _lp146773_ ((_i146776_ '0))
          (if (fx< _i146776_ _len146769_)
              (begin
                (f32vector-set!
                 _v146766_
                 _i146776_
                 (_f146764_ (f32vector-ref _v146766_ _i146776_)))
                (_lp146773_ (fx+ _i146776_ '1)))
              _v146766_)))))
  (define std/srfi/160/f32#f32vector-map!__1
    (lambda (_f146779_ _v146780_ . _vs146781_)
      (if (procedure? _f146779_)
          '#!void
          (error '"Bad argument; expected procedure" _f146779_))
      (let* ((_vs146784_ (cons _v146780_ _vs146781_))
             (_len146786_ (apply fxmin (map f32vector-length _vs146784_))))
        (declare (not safe))
        (let _lp146790_ ((_i146792_ '0))
          (if (fx< _i146792_ _len146786_)
              (begin
                (f32vector-set!
                 _v146780_
                 _i146792_
                 (apply _f146779_
                        (map (lambda (_g146793146795_)
                               (f32vector-ref _g146793146795_ _i146792_))
                             _vs146784_)))
                (_lp146790_ (fx+ _i146792_ '1)))
              _v146780_)))))
  (define std/srfi/160/f32#f32vector-map!
    (lambda _g299363_
      (let ((_g299362_ (let () (declare (not safe)) (##length _g299363_))))
        (cond ((let () (declare (not safe)) (##fx= _g299362_ 2))
               (apply std/srfi/160/f32#f32vector-map!__0 _g299363_))
              ((let () (declare (not safe)) (##fx>= _g299362_ 2))
               (apply std/srfi/160/f32#f32vector-map!__1 _g299363_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-map!
                _g299363_))))))
  (define std/srfi/160/f32#f32vector-for-each__0
    (lambda (_f146730_ _v146732_)
      (if (procedure? _f146730_)
          '#!void
          (error '"Bad argument; expected procedure" _f146730_))
      (let ((_len146735_ (f32vector-length _v146732_)))
        (declare (not safe))
        (let _lp146739_ ((_i146742_ '0))
          (if (fx< _i146742_ _len146735_)
              (begin
                (_f146730_ (f32vector-ref _v146732_ _i146742_))
                (_lp146739_ (fx+ _i146742_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-for-each__1
    (lambda (_f146745_ _v146746_ . _vs146747_)
      (let* ((_vs146750_ (cons _v146746_ _vs146747_))
             (_len146752_ (apply fxmin (map f32vector-length _vs146750_))))
        (declare (not safe))
        (let _lp146756_ ((_i146758_ '0))
          (if (fx< _i146758_ _len146752_)
              (begin
                (apply _f146745_
                       (map (lambda (_g146759146761_)
                              (f32vector-ref _g146759146761_ _i146758_))
                            _vs146750_))
                (_lp146756_ (fx+ _i146758_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-for-each
    (lambda _g299365_
      (let ((_g299364_ (let () (declare (not safe)) (##length _g299365_))))
        (cond ((let () (declare (not safe)) (##fx= _g299364_ 2))
               (apply std/srfi/160/f32#f32vector-for-each__0 _g299365_))
              ((let () (declare (not safe)) (##fx>= _g299364_ 2))
               (apply std/srfi/160/f32#f32vector-for-each__1 _g299365_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-for-each
                _g299365_))))))
  (define std/srfi/160/f32#f32vector-count__0
    (lambda (_pred146693_ _v146695_)
      (if (procedure? _pred146693_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146693_))
      (let ((_end146698_ (f32vector-length _v146695_)))
        (declare (not safe))
        (let _lp146702_ ((_i146705_ '0) (_r146707_ '0))
          (if (fx< _i146705_ _end146698_)
              (if (_pred146693_ (f32vector-ref _v146695_ _i146705_))
                  (_lp146702_ (fx+ _i146705_ '1) (fx+ _r146707_ '1))
                  (_lp146702_ (fx+ _i146705_ '1) _r146707_))
              _r146707_)))))
  (define std/srfi/160/f32#f32vector-count__1
    (lambda (_pred146710_ _v146711_ . _vs146712_)
      (if (procedure? _pred146710_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146710_))
      (let* ((_vs146715_ (cons _v146711_ _vs146712_))
             (_end146717_ (apply fxmin (map f32vector-length _vs146715_))))
        (declare (not safe))
        (let _lp146721_ ((_i146723_ '0) (_r146724_ '0))
          (if (fx< _i146723_ _end146717_)
              (if (apply _pred146710_
                         (map (lambda (_g146725146727_)
                                (f32vector-ref _g146725146727_ _i146723_))
                              _vs146715_))
                  (_lp146721_ (fx+ _i146723_ '1) (fx+ _r146724_ '1))
                  (_lp146721_ (fx+ _i146723_ '1) _r146724_))
              _r146724_)))))
  (define std/srfi/160/f32#f32vector-count
    (lambda _g299367_
      (let ((_g299366_ (let () (declare (not safe)) (##length _g299367_))))
        (cond ((let () (declare (not safe)) (##fx= _g299366_ 2))
               (apply std/srfi/160/f32#f32vector-count__0 _g299367_))
              ((let () (declare (not safe)) (##fx>= _g299366_ 2))
               (apply std/srfi/160/f32#f32vector-count__1 _g299367_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-count
                _g299367_))))))
  (define std/srfi/160/f32#f32vector-cumulate
    (lambda (_f146668_ _knil146670_ _v146672_)
      (if (procedure? _f146668_)
          '#!void
          (error '"Bad argument; expected procedure" _f146668_))
      (let* ((_len146675_ (f32vector-length _v146672_))
             (_r146678_ (make-f32vector _len146675_)))
        (declare (not safe))
        (let _lp146683_ ((_i146686_ '0) (_r146688_ _knil146670_))
          (if (fx< _i146686_ _len146675_)
              (let ((_next146690_
                     (_f146668_
                      _r146688_
                      (f32vector-ref _v146672_ _i146686_))))
                (f32vector-set! _v146672_ _i146686_ _next146690_)
                (_lp146683_ (fx+ _i146686_ '1) _next146690_))
              _v146672_)))))
  (define std/srfi/160/f32#f32vector-take-while
    (lambda (_pred146651_ _v146653_)
      (let* ((_len146656_ (f32vector-length _v146653_))
             (_idx146659_
              (std/srfi/160/f32#f32vector-skip__0 _pred146651_ _v146653_))
             (_idx146665_
              (let ((_$e146662_ _idx146659_))
                (if _$e146662_ _$e146662_ _len146656_))))
        (std/srfi/160/f32#f32vector-copy__% _v146653_ '0 _idx146665_))))
  (define std/srfi/160/f32#f32vector-take-while-right
    (lambda (_pred146637_ _v146639_)
      (let* ((_len146642_ (f32vector-length _v146639_))
             (_idx146645_
              (std/srfi/160/f32#f32vector-skip-right__0
               _pred146637_
               _v146639_))
             (_idx146648_ (if _idx146645_ (fx+ _idx146645_ '1) '0)))
        (std/srfi/160/f32#f32vector-copy__%
         _v146639_
         _idx146648_
         _len146642_))))
  (define std/srfi/160/f32#f32vector-drop-while
    (lambda (_pred146620_ _v146622_)
      (let* ((_len146625_ (f32vector-length _v146622_))
             (_idx146628_
              (std/srfi/160/f32#f32vector-skip__0 _pred146620_ _v146622_))
             (_idx146634_
              (let ((_$e146631_ _idx146628_))
                (if _$e146631_ _$e146631_ _len146625_))))
        (std/srfi/160/f32#f32vector-copy__%
         _v146622_
         _idx146634_
         _len146625_))))
  (define std/srfi/160/f32#f32vector-drop-while-right
    (lambda (_pred146606_ _v146608_)
      (let* ((_len146611_ (f32vector-length _v146608_))
             (_idx146614_
              (std/srfi/160/f32#f32vector-skip-right__0
               _pred146606_
               _v146608_))
             (_idx146617_ (if _idx146614_ (fx+ _idx146614_ '1) '0)))
        (std/srfi/160/f32#f32vector-copy__% _v146608_ '0 _idx146617_))))
  (define std/srfi/160/f32#f32vector-index__0
    (lambda (_pred146572_ _v146574_)
      (if (procedure? _pred146572_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146572_))
      (let ((_end146577_ (f32vector-length _v146574_)))
        (declare (not safe))
        (let _lp146581_ ((_i146584_ '0))
          (if (fx< _i146584_ _end146577_)
              (if (_pred146572_ (f32vector-ref _v146574_ _i146584_))
                  _i146584_
                  (_lp146581_ (fx+ _i146584_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index__1
    (lambda (_pred146587_ _v146588_ . _vs146589_)
      (if (procedure? _pred146587_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146587_))
      (let* ((_vs146592_ (cons _v146588_ _vs146589_))
             (_end146594_ (apply fxmin (map f32vector-length _vs146592_))))
        (declare (not safe))
        (let _lp146598_ ((_i146600_ '0))
          (if (fx< _i146600_ _end146594_)
              (if (apply _pred146587_
                         (map (lambda (_g146601146603_)
                                (f32vector-ref _g146601146603_ _i146600_))
                              _vs146592_))
                  _i146600_
                  (_lp146598_ (fx+ _i146600_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index
    (lambda _g299369_
      (let ((_g299368_ (let () (declare (not safe)) (##length _g299369_))))
        (cond ((let () (declare (not safe)) (##fx= _g299368_ 2))
               (apply std/srfi/160/f32#f32vector-index__0 _g299369_))
              ((let () (declare (not safe)) (##fx>= _g299368_ 2))
               (apply std/srfi/160/f32#f32vector-index__1 _g299369_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-index
                _g299369_))))))
  (define std/srfi/160/f32#f32vector-index-right__0
    (lambda (_pred146538_ _v146540_)
      (if (procedure? _pred146538_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146538_))
      (let ((_start146543_ (fx- (f32vector-length _v146540_) '1)))
        (declare (not safe))
        (let _lp146547_ ((_i146550_ _start146543_))
          (if (fx>= _i146550_ '0)
              (if (_pred146538_ (f32vector-ref _v146540_ _i146550_))
                  _i146550_
                  (_lp146547_ (fx- _i146550_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index-right__1
    (lambda (_pred146553_ _v146554_ . _vs146555_)
      (if (procedure? _pred146553_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146553_))
      (let* ((_vs146558_ (cons _v146554_ _vs146555_))
             (_start146560_
              (fx- (apply fxmin (map f32vector-length _vs146558_)) '1)))
        (declare (not safe))
        (let _lp146564_ ((_i146566_ _start146560_))
          (if (fx>= _i146566_ '0)
              (if (apply _pred146553_
                         (map (lambda (_g146567146569_)
                                (f32vector-ref _g146567146569_ _i146566_))
                              _vs146558_))
                  _i146566_
                  (_lp146564_ (fx- _i146566_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index-right
    (lambda _g299371_
      (let ((_g299370_ (let () (declare (not safe)) (##length _g299371_))))
        (cond ((let () (declare (not safe)) (##fx= _g299370_ 2))
               (apply std/srfi/160/f32#f32vector-index-right__0 _g299371_))
              ((let () (declare (not safe)) (##fx>= _g299370_ 2))
               (apply std/srfi/160/f32#f32vector-index-right__1 _g299371_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-index-right
                _g299371_))))))
  (define std/srfi/160/f32#f32vector-skip__0
    (lambda (_pred146522_ _v146524_)
      (std/srfi/160/f32#f32vector-index__0
       (lambda (_$obj146527_) (not (_pred146522_ _$obj146527_)))
       _v146524_)))
  (define std/srfi/160/f32#f32vector-skip__1
    (lambda (_pred146530_ _v146531_ . _vs146532_)
      (apply std/srfi/160/f32#f32vector-index
             (lambda (_$obj146535_) (not (_pred146530_ _$obj146535_)))
             _v146531_
             _vs146532_)))
  (define std/srfi/160/f32#f32vector-skip
    (lambda _g299373_
      (let ((_g299372_ (let () (declare (not safe)) (##length _g299373_))))
        (cond ((let () (declare (not safe)) (##fx= _g299372_ 2))
               (apply std/srfi/160/f32#f32vector-skip__0 _g299373_))
              ((let () (declare (not safe)) (##fx>= _g299372_ 2))
               (apply std/srfi/160/f32#f32vector-skip__1 _g299373_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-skip
                _g299373_))))))
  (define std/srfi/160/f32#f32vector-skip-right__0
    (lambda (_pred146506_ _v146508_)
      (std/srfi/160/f32#f32vector-index-right__0
       (lambda (_$obj146511_) (not (_pred146506_ _$obj146511_)))
       _v146508_)))
  (define std/srfi/160/f32#f32vector-skip-right__1
    (lambda (_pred146514_ _v146515_ . _vs146516_)
      (apply std/srfi/160/f32#f32vector-index-right
             (lambda (_$obj146519_) (not (_pred146514_ _$obj146519_)))
             _v146515_
             _vs146516_)))
  (define std/srfi/160/f32#f32vector-skip-right
    (lambda _g299375_
      (let ((_g299374_ (let () (declare (not safe)) (##length _g299375_))))
        (cond ((let () (declare (not safe)) (##fx= _g299374_ 2))
               (apply std/srfi/160/f32#f32vector-skip-right__0 _g299375_))
              ((let () (declare (not safe)) (##fx>= _g299374_ 2))
               (apply std/srfi/160/f32#f32vector-skip-right__1 _g299375_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-skip-right
                _g299375_))))))
  (define std/srfi/160/f32#f32vector-any__0
    (lambda (_pred146466_ _v146468_)
      (if (procedure? _pred146466_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146466_))
      (let ((_end146471_ (f32vector-length _v146468_)))
        (declare (not safe))
        (let _lp146475_ ((_i146478_ '0))
          (if (fx< _i146478_ _end146471_)
              (let ((_$e146481_
                     (_pred146466_ (f32vector-ref _v146468_ _i146478_))))
                (if _$e146481_
                    (values _$e146481_)
                    (_lp146475_ (fx+ _i146478_ '1))))
              '#f)))))
  (define std/srfi/160/f32#f32vector-any__1
    (lambda (_pred146484_ _v146485_ . _vs146486_)
      (if (procedure? _pred146484_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146484_))
      (let* ((_v146489_ (cons _v146485_ _vs146486_))
             (_end146491_ (apply fxmin (map f32vector-length _vs146486_))))
        (declare (not safe))
        (let _lp146495_ ((_i146497_ '0))
          (if (fx< _i146497_ _end146491_)
              (let ((_$e146503_
                     (apply _pred146484_
                            (map (lambda (_g146498146500_)
                                   (f32vector-ref _g146498146500_ _i146497_))
                                 _vs146486_))))
                (if _$e146503_
                    (values _$e146503_)
                    (_lp146495_ (fx+ _i146497_ '1))))
              '#f)))))
  (define std/srfi/160/f32#f32vector-any
    (lambda _g299377_
      (let ((_g299376_ (let () (declare (not safe)) (##length _g299377_))))
        (cond ((let () (declare (not safe)) (##fx= _g299376_ 2))
               (apply std/srfi/160/f32#f32vector-any__0 _g299377_))
              ((let () (declare (not safe)) (##fx>= _g299376_ 2))
               (apply std/srfi/160/f32#f32vector-any__1 _g299377_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-any
                _g299377_))))))
  (define std/srfi/160/f32#f32vector-every__0
    (lambda (_pred146415_ _v146417_)
      (if (procedure? _pred146415_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146415_))
      (let ((_end146420_ (f32vector-length _v146417_)))
        (declare (not safe))
        (let _lp146424_ ((_i146427_ '0) (_r146429_ '#t))
          (if (fx< _i146427_ _end146420_)
              (let ((_$e146432_
                     (_pred146415_ (f32vector-ref _v146417_ _i146427_))))
                (if _$e146432_
                    ((lambda (_g146434146436_)
                       (_lp146424_ (fx+ _i146427_ '1) _g146434146436_))
                     _$e146432_)
                    '#f))
              _r146429_)))))
  (define std/srfi/160/f32#f32vector-every__1
    (lambda (_pred146439_ _v146440_ . _vs146441_)
      (if (procedure? _pred146439_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146439_))
      (let* ((_v146444_ (cons _v146440_ _vs146441_))
             (_end146446_ (apply fxmin (map f32vector-length _vs146441_))))
        (declare (not safe))
        (let _lp146450_ ((_i146452_ '0) (_r146453_ '#t))
          (if (fx< _i146452_ _end146446_)
              (let ((_$e146459_
                     (apply _pred146439_
                            (map (lambda (_g146454146456_)
                                   (f32vector-ref _g146454146456_ _i146452_))
                                 _vs146441_))))
                (if _$e146459_
                    ((lambda (_g146461146463_)
                       (_lp146450_ (fx+ _i146452_ '1) _g146461146463_))
                     _$e146459_)
                    '#f))
              _r146453_)))))
  (define std/srfi/160/f32#f32vector-every
    (lambda _g299379_
      (let ((_g299378_ (let () (declare (not safe)) (##length _g299379_))))
        (cond ((let () (declare (not safe)) (##fx= _g299378_ 2))
               (apply std/srfi/160/f32#f32vector-every__0 _g299379_))
              ((let () (declare (not safe)) (##fx>= _g299378_ 2))
               (apply std/srfi/160/f32#f32vector-every__1 _g299379_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-every
                _g299379_))))))
  (define std/srfi/160/f32#f32vector-partition
    (lambda (_pred146386_ _v146388_)
      (let* ((_count146391_
              (std/srfi/160/f32#f32vector-count__0 _pred146386_ _v146388_))
             (_len146394_ (f32vector-length _v146388_))
             (_u146397_ (make-f32vector _len146394_)))
        (declare (not safe))
        (let _lp146402_ ((_i146405_ '0)
                         (_left146407_ '0)
                         (_right146409_ _count146391_))
          (if (fx< _i146405_ _len146394_)
              (let ((_x146412_ (f32vector-ref _v146388_ _i146405_)))
                (if (_pred146386_ _x146412_)
                    (begin
                      (f32vector-set! _u146397_ _left146407_ _x146412_)
                      (_lp146402_
                       (fx+ _i146405_ '1)
                       (fx+ _left146407_ '1)
                       _right146409_))
                    (begin
                      (f32vector-set! _u146397_ _right146409_ _x146412_)
                      (_lp146402_
                       (fx+ _i146405_ '1)
                       _left146407_
                       (fx+ _right146409_ '1)))))
              _u146397_)))))
  (define std/srfi/160/f32#f32vector-filter
    (lambda (_pred146359_ _v146361_)
      (let* ((_count146364_
              (std/srfi/160/f32#f32vector-count__0 _pred146359_ _v146361_))
             (_u146367_ (make-f32vector _count146364_))
             (_end146370_ (f32vector-length _v146361_)))
        (declare (not safe))
        (let _lp146375_ ((_i146378_ '0) (_j146380_ '0))
          (if (fx< _i146378_ _end146370_)
              (let ((_x146383_ (f32vector-ref _v146361_ _i146378_)))
                (if (_pred146359_ _x146383_)
                    (begin
                      (f32vector-set! _u146367_ _j146380_ _x146383_)
                      (_lp146375_ (fx+ _i146378_ '1) (fx+ _j146380_ '1)))
                    (_lp146375_ (fx+ _i146378_ '1) _j146380_)))
              _u146367_)))))
  (define std/srfi/160/f32#f32vector-remove
    (lambda (_pred146351_ _v146353_)
      (std/srfi/160/f32#f32vector-filter
       (lambda (_$obj146356_) (not (_pred146351_ _$obj146356_)))
       _v146353_)))
  (define std/srfi/160/f32#f32vector-swap
    (lambda (_v146338_ _i146340_ _j146342_)
      (let ((_iv146345_ (f32vector-ref _v146338_ _i146340_))
            (_jv146347_ (f32vector-ref _v146338_ _j146342_)))
        (declare (not safe))
        (begin
          (f32vector-set! _v146338_ _i146340_ _jv146347_)
          (f32vector-set! _v146338_ _j146342_ _iv146345_)))))
  (define std/srfi/160/f32#f32vector-fill!__%
    (lambda (_v146301_ _fill146303_ _start146305_ _end146307_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146301_) '#!void (error '"Bad argument" _v146301_))
        (if (flonum? _fill146303_)
            '#!void
            (error '"Bad argument" _fill146303_))
        (if (and (fixnum? _start146305_)
                 (fx<= '0 _start146305_ (fx- (f32vector-length _v146301_) '1)))
            '#!void
            (error '"Index out of range" _start146305_))
        (if (and (fixnum? _end146307_)
                 (fx<= _start146305_ _end146307_ (f32vector-length _v146301_)))
            '#!void
            (error '"Index out of range" _end146307_))
        (let _lp146311_ ((_i146314_ _start146305_))
          (if (fx< _i146314_ _end146307_)
              (begin
                (f32vector-set! _v146301_ _i146314_ _fill146303_)
                (_lp146311_ (fx+ _i146314_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-fill!__0
    (lambda (_v146320_ _fill146321_)
      (let* ((_start146323_ '0) (_end146325_ (f32vector-length _v146320_)))
        (std/srfi/160/f32#f32vector-fill!__%
         _v146320_
         _fill146321_
         _start146323_
         _end146325_))))
  (define std/srfi/160/f32#f32vector-fill!__1
    (lambda (_v146327_ _fill146328_ _start146329_)
      (let ((_end146331_ (f32vector-length _v146327_)))
        (std/srfi/160/f32#f32vector-fill!__%
         _v146327_
         _fill146328_
         _start146329_
         _end146331_))))
  (define std/srfi/160/f32#f32vector-fill!
    (lambda _g299381_
      (let ((_g299380_ (let () (declare (not safe)) (##length _g299381_))))
        (cond ((let () (declare (not safe)) (##fx= _g299380_ 2))
               (apply std/srfi/160/f32#f32vector-fill!__0 _g299381_))
              ((let () (declare (not safe)) (##fx= _g299380_ 3))
               (apply std/srfi/160/f32#f32vector-fill!__1 _g299381_))
              ((let () (declare (not safe)) (##fx= _g299380_ 4))
               (apply std/srfi/160/f32#f32vector-fill!__% _g299381_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-fill!
                _g299381_))))))
  (define std/srfi/160/f32#f32vector-reverse!__%
    (lambda (_v146261_ _start146263_ _end146265_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146261_) '#!void (error '"Bad argument" _v146261_))
        (if (and (fixnum? _start146263_)
                 (fx<= '0 _start146263_ (fx- (f32vector-length _v146261_) '1)))
            '#!void
            (error '"Index out of range" _start146263_))
        (if (and (fixnum? _end146265_)
                 (fx<= _start146263_ _end146265_ (f32vector-length _v146261_)))
            '#!void
            (error '"Index out of range" _end146265_))
        (let _lp146269_ ((_i146272_ _start146263_)
                         (_j146274_ (fx- _end146265_ '1)))
          (if (fx< _i146272_ _j146274_)
              (let ((_iv146277_ (f32vector-ref _v146261_ _i146272_))
                    (_jv146279_ (f32vector-ref _v146261_ _j146274_)))
                (f32vector-set! _v146261_ _i146272_ _jv146279_)
                (f32vector-set! _v146261_ _j146274_ _iv146277_)
                (_lp146269_ (fx+ _i146272_ '1) (fx- _j146274_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-reverse!__0
    (lambda (_v146285_)
      (let* ((_start146287_ '0) (_end146289_ (f32vector-length _v146285_)))
        (std/srfi/160/f32#f32vector-reverse!__%
         _v146285_
         _start146287_
         _end146289_))))
  (define std/srfi/160/f32#f32vector-reverse!__1
    (lambda (_v146291_ _start146292_)
      (let ((_end146294_ (f32vector-length _v146291_)))
        (std/srfi/160/f32#f32vector-reverse!__%
         _v146291_
         _start146292_
         _end146294_))))
  (define std/srfi/160/f32#f32vector-reverse!
    (lambda _g299383_
      (let ((_g299382_ (let () (declare (not safe)) (##length _g299383_))))
        (cond ((let () (declare (not safe)) (##fx= _g299382_ 1))
               (apply std/srfi/160/f32#f32vector-reverse!__0 _g299383_))
              ((let () (declare (not safe)) (##fx= _g299382_ 2))
               (apply std/srfi/160/f32#f32vector-reverse!__1 _g299383_))
              ((let () (declare (not safe)) (##fx= _g299382_ 3))
               (apply std/srfi/160/f32#f32vector-reverse!__% _g299383_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-reverse!
                _g299383_))))))
  (define std/srfi/160/f32#f32vector-unfold!
    (lambda (_f146236_ _v146238_ _start146240_ _end146242_ _seed146244_)
      (declare (not safe))
      (begin
        (if (procedure? _f146236_)
            '#!void
            (error '"Bad argument; expected procedure" _f146236_))
        (if (f32vector? _v146238_) '#!void (error '"Bad argument" _v146238_))
        (if (and (fixnum? _start146240_)
                 (fx<= '0 _start146240_ (fx- (f32vector-length _v146238_) '1)))
            '#!void
            (error '"Index out of range" _start146240_))
        (if (and (fixnum? _end146242_)
                 (fx<= _start146240_ _end146242_ (f32vector-length _v146238_)))
            '#!void
            (error '"Index out of range" _end146242_))
        (let _lp146248_ ((_i146251_ _start146240_)
                         (_state146253_ _seed146244_))
          (if (fx< _i146251_ _end146242_)
              (let ((_g299384_ (_f146236_ _state146253_)))
                (begin
                  (let ((_g299385_
                         (if (##values? _g299384_)
                             (##vector-length _g299384_)
                             1)))
                    (if (not (##fx= _g299385_ 2))
                        (error "Context expects 2 values" _g299385_)))
                  (let ((_x146256_ (##vector-ref _g299384_ 0))
                        (_state146258_ (##vector-ref _g299384_ 1)))
                    (begin
                      (f32vector-set! _v146238_ _i146251_ _x146256_)
                      (_lp146248_ (fx+ _i146251_ '1) _state146258_)))))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-unfold-right!
    (lambda (_f146212_ _v146214_ _start146216_ _end146218_ _seed146220_)
      (declare (not safe))
      (begin
        (if (procedure? _f146212_)
            '#!void
            (error '"Bad argument; expected procedure" _f146212_))
        (if (f32vector? _v146214_) '#!void (error '"Bad argument" _v146214_))
        (if (and (fixnum? _start146216_)
                 (fx<= '0 _start146216_ (fx- (f32vector-length _v146214_) '1)))
            '#!void
            (error '"Index out of range" _start146216_))
        (if (and (fixnum? _end146218_)
                 (fx<= _start146216_ _end146218_ (f32vector-length _v146214_)))
            '#!void
            (error '"Index out of range" _end146218_))
        (let _lp146224_ ((_i146227_ (fx- _end146218_ '1))
                         (_state146229_ _seed146220_))
          (if (fx>= _i146227_ _start146216_)
              (let ((_g299386_ (_f146212_ _state146229_)))
                (begin
                  (let ((_g299387_
                         (if (##values? _g299386_)
                             (##vector-length _g299386_)
                             1)))
                    (if (not (##fx= _g299387_ 2))
                        (error "Context expects 2 values" _g299387_)))
                  (let ((_x146232_ (##vector-ref _g299386_ 0))
                        (_state146234_ (##vector-ref _g299386_ 1)))
                    (begin
                      (f32vector-set! _v146214_ _i146227_ _x146232_)
                      (_lp146224_ (fx- _i146227_ '1) _state146234_)))))
              '#!void)))))
  (define std/srfi/160/f32#reverse-f32vector->list__%
    (lambda (_v146178_ _start146180_ _end146182_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146178_) '#!void (error '"Bad argument" _v146178_))
        (if (and (fixnum? _start146180_)
                 (fx<= '0 _start146180_ (fx- (f32vector-length _v146178_) '1)))
            '#!void
            (error '"Index out of range" _start146180_))
        (if (and (fixnum? _end146182_)
                 (fx<= _start146180_ _end146182_ (f32vector-length _v146178_)))
            '#!void
            (error '"Index out of range" _end146182_))
        (let _lp146186_ ((_i146189_ _start146180_) (_r146191_ '()))
          (if (fx< _i146189_ _end146182_)
              (_lp146186_
               (fx+ _i146189_ '1)
               (cons (f32vector-ref _v146178_ _i146189_) _r146191_))
              _r146191_)))))
  (define std/srfi/160/f32#reverse-f32vector->list__0
    (lambda (_v146197_)
      (let* ((_start146199_ '0) (_end146201_ (f32vector-length _v146197_)))
        (std/srfi/160/f32#reverse-f32vector->list__%
         _v146197_
         _start146199_
         _end146201_))))
  (define std/srfi/160/f32#reverse-f32vector->list__1
    (lambda (_v146203_ _start146204_)
      (let ((_end146206_ (f32vector-length _v146203_)))
        (std/srfi/160/f32#reverse-f32vector->list__%
         _v146203_
         _start146204_
         _end146206_))))
  (define std/srfi/160/f32#reverse-f32vector->list
    (lambda _g299389_
      (let ((_g299388_ (let () (declare (not safe)) (##length _g299389_))))
        (cond ((let () (declare (not safe)) (##fx= _g299388_ 1))
               (apply std/srfi/160/f32#reverse-f32vector->list__0 _g299389_))
              ((let () (declare (not safe)) (##fx= _g299388_ 2))
               (apply std/srfi/160/f32#reverse-f32vector->list__1 _g299389_))
              ((let () (declare (not safe)) (##fx= _g299388_ 3))
               (apply std/srfi/160/f32#reverse-f32vector->list__% _g299389_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#reverse-f32vector->list
                _g299389_))))))
  (define std/srfi/160/f32#reverse-list->f32vector
    (lambda (_lst146124_)
      (let* ((_len146127_ (length _lst146124_))
             (_v146130_ (make-f32vector _len146127_)))
        (declare (not safe))
        (let _lp146135_ ((_rest146138_ _lst146124_) (_i146140_ '0))
          (let* ((_rest146142146150_ _rest146138_)
                 (_else146144146158_ (lambda () _v146130_))
                 (_K146146146165_
                  (lambda (_rest146161_ _x146162_)
                    (if (flonum? _x146162_)
                        '#!void
                        (error '"Bad element" _x146162_))
                    (f32vector-set! _v146130_ _i146140_ _x146162_)
                    (_lp146135_ _rest146161_ (fx+ _i146140_ '1)))))
            (if (##pair? _rest146142146150_)
                (let ((_hd146147146168_ (##car _rest146142146150_))
                      (_tl146148146170_ (##cdr _rest146142146150_)))
                  (let* ((_x146173_ _hd146147146168_)
                         (_rest146175_ _tl146148146170_))
                    (_K146146146165_ _rest146175_ _x146173_)))
                (_else146144146158_)))))))
  (define std/srfi/160/f32#f32vector->vector__%
    (lambda (_v146085_ _start146087_ _end146089_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146085_) '#!void (error '"Bad argument" _v146085_))
        (if (and (fixnum? _start146087_)
                 (fx<= '0 _start146087_ (fx- (f32vector-length _v146085_) '1)))
            '#!void
            (error '"Index out of range" _start146087_))
        (if (and (fixnum? _end146089_)
                 (fx<= _start146087_ _end146089_ (f32vector-length _v146085_)))
            '#!void
            (error '"Index out of range" _end146089_))
        (let* ((_len146093_ (f32vector-length _v146085_))
               (_u146096_ (make-vector _len146093_)))
          (let _lp146100_ ((_i146103_ '0))
            (if (fx< _i146103_ _len146093_)
                (begin
                  (vector-set!
                   _u146096_
                   _i146103_
                   (f32vector-ref _v146085_ _i146103_))
                  (_lp146100_ (fx+ _i146103_ '1)))
                _u146096_))))))
  (define std/srfi/160/f32#f32vector->vector__0
    (lambda (_v146109_)
      (let* ((_start146111_ '0) (_end146113_ (f32vector-length _v146109_)))
        (std/srfi/160/f32#f32vector->vector__%
         _v146109_
         _start146111_
         _end146113_))))
  (define std/srfi/160/f32#f32vector->vector__1
    (lambda (_v146115_ _start146116_)
      (let ((_end146118_ (f32vector-length _v146115_)))
        (std/srfi/160/f32#f32vector->vector__%
         _v146115_
         _start146116_
         _end146118_))))
  (define std/srfi/160/f32#f32vector->vector
    (lambda _g299391_
      (let ((_g299390_ (let () (declare (not safe)) (##length _g299391_))))
        (cond ((let () (declare (not safe)) (##fx= _g299390_ 1))
               (apply std/srfi/160/f32#f32vector->vector__0 _g299391_))
              ((let () (declare (not safe)) (##fx= _g299390_ 2))
               (apply std/srfi/160/f32#f32vector->vector__1 _g299391_))
              ((let () (declare (not safe)) (##fx= _g299390_ 3))
               (apply std/srfi/160/f32#f32vector->vector__% _g299391_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector->vector
                _g299391_))))))
  (define std/srfi/160/f32#vector->f32vector__%
    (lambda (_v146045_ _start146047_ _end146049_)
      (declare (not safe))
      (begin
        (if (vector? _v146045_)
            '#!void
            (error '"Bad argument; expected vector" _v146045_))
        (if (and (fixnum? _start146047_)
                 (fx<= '0 _start146047_ (fx- (vector-length _v146045_) '1)))
            '#!void
            (error '"Index out of range" _start146047_))
        (if (and (fixnum? _end146049_)
                 (fx<= _start146047_ _end146049_ (vector-length _v146045_)))
            '#!void
            (error '"Index out of range" _end146049_))
        (let* ((_len146053_ (vector-length _v146045_))
               (_u146056_ (make-f32vector _len146053_)))
          (let _lp146060_ ((_i146063_ '0))
            (if (fx< _i146063_ _len146053_)
                (begin
                  (f32vector-set!
                   _u146056_
                   _i146063_
                   (vector-ref _v146045_ _i146063_))
                  (_lp146060_ (fx+ _i146063_ '1)))
                _u146056_))))))
  (define std/srfi/160/f32#vector->f32vector__0
    (lambda (_v146069_)
      (let* ((_start146071_ '0) (_end146073_ (vector-length _v146069_)))
        (std/srfi/160/f32#vector->f32vector__%
         _v146069_
         _start146071_
         _end146073_))))
  (define std/srfi/160/f32#vector->f32vector__1
    (lambda (_v146075_ _start146076_)
      (let ((_end146078_ (vector-length _v146075_)))
        (std/srfi/160/f32#vector->f32vector__%
         _v146075_
         _start146076_
         _end146078_))))
  (define std/srfi/160/f32#vector->f32vector
    (lambda _g299393_
      (let ((_g299392_ (let () (declare (not safe)) (##length _g299393_))))
        (cond ((let () (declare (not safe)) (##fx= _g299392_ 1))
               (apply std/srfi/160/f32#vector->f32vector__0 _g299393_))
              ((let () (declare (not safe)) (##fx= _g299392_ 2))
               (apply std/srfi/160/f32#vector->f32vector__1 _g299393_))
              ((let () (declare (not safe)) (##fx= _g299392_ 3))
               (apply std/srfi/160/f32#vector->f32vector__% _g299393_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#vector->f32vector
                _g299393_))))))
  (define std/srfi/160/f32#make-f32vector-generator__%
    (lambda (_v146011_ _start146013_ _end146015_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146011_) '#!void (error '"Bad argument" _v146011_))
        (if (and (fixnum? _start146013_)
                 (fx<= '0 _start146013_ (fx- (f32vector-length _v146011_) '1)))
            '#!void
            (error '"Index out of range" _start146013_))
        (if (and (fixnum? _end146015_)
                 (fx<= _start146013_ _end146015_ (f32vector-length _v146011_)))
            '#!void
            (error '"Index out of range" _end146015_))
        (let ((_i146019_ _start146013_))
          (lambda ()
            (if (fx< _i146019_ _end146015_)
                (let ((_next146023_ (f32vector-ref _v146011_ _i146019_)))
                  (set! _i146019_ (fx+ _i146019_ '1))
                  _next146023_)
                '#!eof))))))
  (define std/srfi/160/f32#make-f32vector-generator__0
    (lambda (_v146029_)
      (let* ((_start146031_ '0) (_end146033_ (f32vector-length _v146029_)))
        (std/srfi/160/f32#make-f32vector-generator__%
         _v146029_
         _start146031_
         _end146033_))))
  (define std/srfi/160/f32#make-f32vector-generator__1
    (lambda (_v146035_ _start146036_)
      (let ((_end146038_ (f32vector-length _v146035_)))
        (std/srfi/160/f32#make-f32vector-generator__%
         _v146035_
         _start146036_
         _end146038_))))
  (define std/srfi/160/f32#make-f32vector-generator
    (lambda _g299395_
      (let ((_g299394_ (let () (declare (not safe)) (##length _g299395_))))
        (cond ((let () (declare (not safe)) (##fx= _g299394_ 1))
               (apply std/srfi/160/f32#make-f32vector-generator__0 _g299395_))
              ((let () (declare (not safe)) (##fx= _g299394_ 2))
               (apply std/srfi/160/f32#make-f32vector-generator__1 _g299395_))
              ((let () (declare (not safe)) (##fx= _g299394_ 3))
               (apply std/srfi/160/f32#make-f32vector-generator__% _g299395_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#make-f32vector-generator
                _g299395_))))))
  (define std/srfi/160/f32#f32vector-comparator
    (let ()
      (letrec ((_<?145982_
                (lambda (_a145985_ _b145987_)
                  (let ((_len-a145990_ (f32vector-length _a145985_))
                        (_len-b145992_ (f32vector-length _b145987_)))
                    (declare (not safe))
                    (if (fx< _len-a145990_ _len-b145992_)
                        '#t
                        (if (fx> _len-a145990_ _len-b145992_)
                            '#f
                            (let ((_end145996_ _len-a145990_))
                              (let _lp145999_ ((_i146002_ '0))
                                (if (fx< _i146002_ _end145996_)
                                    (let ((_x146005_
                                           (f32vector-ref _a145985_ _i146002_))
                                          (_y146007_
                                           (f32vector-ref
                                            _b145987_
                                            _i146002_)))
                                      (if (< _x146005_ _y146007_)
                                          '#t
                                          (if (> _x146005_ _y146007_)
                                              '#f
                                              (_lp145999_
                                               (fx+ _i146002_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           f32vector?
           std/srfi/160/f32#f32vector=
           _<?145982_
           equal?-hash)))))
  (define std/srfi/160/f32#write-f32vector__%
    (lambda (_v145959_ _port145961_)
      (let ((_$e145964_ (find-method _v145959_ ':write)))
        (if _$e145964_
            ((lambda (_g145966145968_)
               (_g145966145968_ _v145959_ _port145961_))
             _$e145964_)
            (write _v145959_ (current-output-port))))))
  (define std/srfi/160/f32#write-f32vector__0
    (lambda (_v145974_)
      (let ((_port145976_ (current-output-port)))
        (std/srfi/160/f32#write-f32vector__% _v145974_ _port145976_))))
  (define std/srfi/160/f32#write-f32vector
    (lambda _g299397_
      (let ((_g299396_ (let () (declare (not safe)) (##length _g299397_))))
        (cond ((let () (declare (not safe)) (##fx= _g299396_ 1))
               (apply std/srfi/160/f32#write-f32vector__0 _g299397_))
              ((let () (declare (not safe)) (##fx= _g299396_ 2))
               (apply std/srfi/160/f32#write-f32vector__% _g299397_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#write-f32vector
                _g299397_)))))))
