(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/f64#f64vector-unfold
    (lambda (_f148789_ _len148791_ _seed148793_)
      (declare (not safe))
      (begin
        (if (procedure? _f148789_)
            '#!void
            (error '"Bad argument; expected procedure" _f148789_))
        (let ((_v148797_ (make-f64vector _len148791_)))
          (let _lp148800_ ((_i148803_ '0) (_state148805_ _seed148793_))
            (if (fx< _i148803_ _len148791_)
                (let ((_g299398_ (_f148789_ _i148803_ _state148805_)))
                  (begin
                    (let ((_g299399_
                           (if (##values? _g299398_)
                               (##vector-length _g299398_)
                               1)))
                      (if (not (##fx= _g299399_ 2))
                          (error "Context expects 2 values" _g299399_)))
                    (let ((_x148808_ (##vector-ref _g299398_ 0))
                          (_state148810_ (##vector-ref _g299398_ 1)))
                      (begin
                        (if (flonum? _x148808_)
                            '#!void
                            (error '"Bad generated value" _x148808_))
                        (f64vector-set! _v148797_ _i148803_ _x148808_)
                        (_lp148800_ (fx+ _i148803_ '1) _state148810_)))))
                _v148797_))))))
  (define std/srfi/160/f64#f64vector-unfold-right
    (lambda (_f148766_ _len148768_ _seed148770_)
      (declare (not safe))
      (begin
        (if (procedure? _f148766_)
            '#!void
            (error '"Bad argument; expected procedure" _f148766_))
        (let ((_v148774_ (make-f64vector _len148768_)))
          (let _lp148777_ ((_i148780_ (fx- _len148768_ '1))
                           (_state148782_ _seed148770_))
            (if (fx>= _i148780_ '0)
                (let ((_g299400_ (_f148766_ _i148780_ _state148782_)))
                  (begin
                    (let ((_g299401_
                           (if (##values? _g299400_)
                               (##vector-length _g299400_)
                               1)))
                      (if (not (##fx= _g299401_ 2))
                          (error "Context expects 2 values" _g299401_)))
                    (let ((_x148785_ (##vector-ref _g299400_ 0))
                          (_state148787_ (##vector-ref _g299400_ 1)))
                      (begin
                        (if (flonum? _x148785_)
                            '#!void
                            (error '"Bad generated value" _x148785_))
                        (f64vector-set! _v148774_ _i148780_ _x148785_)
                        (_lp148777_ (fx- _i148780_ '1) _state148787_)))))
                _v148774_))))))
  (define std/srfi/160/f64#f64vector-copy__%
    (lambda (_vec148738_ _start148740_ _end148742_)
      (let ((_v148745_ (make-f64vector (fx- _end148742_ _start148740_))))
        (std/srfi/160/f64#f64vector-copy!
         _v148745_
         '0
         _vec148738_
         _start148740_
         _end148742_)
        _v148745_)))
  (define std/srfi/160/f64#f64vector-copy__0
    (lambda (_vec148751_)
      (let* ((_start148753_ '0) (_end148755_ (f64vector-length _vec148751_)))
        (std/srfi/160/f64#f64vector-copy__%
         _vec148751_
         _start148753_
         _end148755_))))
  (define std/srfi/160/f64#f64vector-copy__1
    (lambda (_vec148757_ _start148758_)
      (let ((_end148760_ (f64vector-length _vec148757_)))
        (std/srfi/160/f64#f64vector-copy__%
         _vec148757_
         _start148758_
         _end148760_))))
  (define std/srfi/160/f64#f64vector-copy
    (lambda _g299403_
      (let ((_g299402_ (let () (declare (not safe)) (##length _g299403_))))
        (cond ((let () (declare (not safe)) (##fx= _g299402_ 1))
               (apply std/srfi/160/f64#f64vector-copy__0 _g299403_))
              ((let () (declare (not safe)) (##fx= _g299402_ 2))
               (apply std/srfi/160/f64#f64vector-copy__1 _g299403_))
              ((let () (declare (not safe)) (##fx= _g299402_ 3))
               (apply std/srfi/160/f64#f64vector-copy__% _g299403_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-copy
                _g299403_))))))
  (define std/srfi/160/f64#f64vector-copy!
    (lambda (_to148717_ _at148719_ _from148721_ _start148723_ _end148725_)
      (declare (not safe))
      (begin
        (if (f64vector? _to148717_) '#!void (error '"Bad argument" _to148717_))
        (if (f64vector? _from148721_)
            '#!void
            (error '"Bad argument" _from148721_))
        (if (and (fixnum? _at148719_)
                 (fx<= '0 _at148719_ (fx- (f64vector-length _at148719_) '1)))
            '#!void
            (error '"Index out of range" _to148717_ _at148719_))
        (if (and (fixnum? _start148723_)
                 (fx<= '0
                       _start148723_
                       (fx- (f64vector-length _from148721_) '1)))
            '#!void
            (error '"Index out of range" _from148721_ _start148723_))
        (if (and (fixnum? _end148725_)
                 (fx<= _start148723_
                       _end148725_
                       (f64vector-length _from148721_)))
            '#!void
            (error '"Index out of range" _from148721_ _end148725_))
        (if (fx<= (fx- _end148725_ _start148723_)
                  (fx- (f64vector-length _to148717_) _at148719_))
            '#!void
            (error '"Destination area too small"
                   _to148717_
                   _at148719_
                   _from148721_
                   _start148723_
                   _end148725_))
        (let _lp148729_ ((_i148732_ _start148723_) (_j148734_ _at148719_))
          (if (fx< _i148732_ _end148725_)
              (begin
                (f64vector-set!
                 _to148717_
                 _j148734_
                 (f64vector-ref _from148721_ _i148732_))
                (_lp148729_ (fx+ _i148732_ '1) (fx+ _j148734_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-reverse-copy__%
    (lambda (_vec148689_ _start148691_ _end148693_)
      (let ((_v148696_ (make-f64vector (fx- _end148693_ _start148691_))))
        (std/srfi/160/f64#f64vector-reverse-copy!
         _v148696_
         '0
         _vec148689_
         _start148691_
         _end148693_)
        _v148696_)))
  (define std/srfi/160/f64#f64vector-reverse-copy__0
    (lambda (_vec148702_)
      (let* ((_start148704_ '0) (_end148706_ (f64vector-length _vec148702_)))
        (std/srfi/160/f64#f64vector-reverse-copy__%
         _vec148702_
         _start148704_
         _end148706_))))
  (define std/srfi/160/f64#f64vector-reverse-copy__1
    (lambda (_vec148708_ _start148709_)
      (let ((_end148711_ (f64vector-length _vec148708_)))
        (std/srfi/160/f64#f64vector-reverse-copy__%
         _vec148708_
         _start148709_
         _end148711_))))
  (define std/srfi/160/f64#f64vector-reverse-copy
    (lambda _g299405_
      (let ((_g299404_ (let () (declare (not safe)) (##length _g299405_))))
        (cond ((let () (declare (not safe)) (##fx= _g299404_ 1))
               (apply std/srfi/160/f64#f64vector-reverse-copy__0 _g299405_))
              ((let () (declare (not safe)) (##fx= _g299404_ 2))
               (apply std/srfi/160/f64#f64vector-reverse-copy__1 _g299405_))
              ((let () (declare (not safe)) (##fx= _g299404_ 3))
               (apply std/srfi/160/f64#f64vector-reverse-copy__% _g299405_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-reverse-copy
                _g299405_))))))
  (define std/srfi/160/f64#f64vector-reverse-copy!
    (lambda (_to148668_ _at148670_ _from148672_ _start148674_ _end148676_)
      (declare (not safe))
      (begin
        (if (f64vector? _to148668_) '#!void (error '"Bad argument" _to148668_))
        (if (f64vector? _from148672_)
            '#!void
            (error '"Bad argument" _from148672_))
        (if (and (fixnum? _at148670_)
                 (fx<= '0 _at148670_ (fx- (f64vector-length _at148670_) '1)))
            '#!void
            (error '"Index out of range" _to148668_ _at148670_))
        (if (and (fixnum? _start148674_)
                 (fx<= '0
                       _start148674_
                       (fx- (f64vector-length _from148672_) '1)))
            '#!void
            (error '"Index out of range" _from148672_ _start148674_))
        (if (and (fixnum? _end148676_)
                 (fx<= _start148674_
                       _end148676_
                       (f64vector-length _from148672_)))
            '#!void
            (error '"Index out of range" _from148672_ _end148676_))
        (if (fx<= (fx- _end148676_ _start148674_)
                  (fx- (f64vector-length _to148668_) _at148670_))
            '#!void
            (error '"Destination area too small"
                   _to148668_
                   _at148670_
                   _from148672_
                   _start148674_
                   _end148676_))
        (let _lp148680_ ((_i148683_ (fx- _end148676_ '1))
                         (_j148685_ _at148670_))
          (if (fx>= _i148683_ _start148674_)
              (begin
                (f64vector-set!
                 _to148668_
                 _j148685_
                 (f64vector-ref _from148672_ _i148683_))
                (_lp148680_ (fx- _i148683_ '1) (fx+ _j148685_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-append
    (lambda _args148665_
      (std/srfi/160/f64#f64vector-concatenate _args148665_)))
  (define std/srfi/160/f64#f64vector-concatenate
    (lambda (_lst148605_)
      (let* ((_len148613_
              (foldl1 (lambda (_v148608_ _r148610_)
                        (fx+ (f64vector-length _v148608_) _r148610_))
                      '0
                      _lst148605_))
             (_v148616_ (make-f64vector _len148613_)))
        (declare (not safe))
        (let _lp148620_ ((_rest148623_ _lst148605_) (_at148625_ '0))
          (let* ((_rest148627148635_ _rest148623_)
                 (_else148629148643_ (lambda () _v148616_))
                 (_K148631148653_
                  (lambda (_rest148646_ _u148647_)
                    (let ((_ulen148650_ (f64vector-length _u148647_)))
                      (std/srfi/160/f64#f64vector-copy!
                       _v148616_
                       _at148625_
                       _u148647_
                       '0
                       _ulen148650_)
                      (_lp148620_
                       _rest148646_
                       (fx+ _at148625_ _ulen148650_))))))
            (if (##pair? _rest148627148635_)
                (let ((_hd148632148656_ (##car _rest148627148635_))
                      (_tl148633148658_ (##cdr _rest148627148635_)))
                  (let* ((_u148661_ _hd148632148656_)
                         (_rest148663_ _tl148633148658_))
                    (_K148631148653_ _rest148663_ _u148661_)))
                (_else148629148643_)))))))
  (define std/srfi/160/f64#f64vector-append-subvectors
    (lambda _args148477_
      (let* ((_len148538_
              (let _lp148480_ ((_rest148483_ _args148477_) (_r148485_ '0))
                (let* ((_rest148487148499_ _rest148483_)
                       (_else148489148507_ (lambda () _r148485_))
                       (_K148491148516_
                        (lambda (_rest148510_ _end148511_ _start148513_)
                          (_lp148480_
                           _rest148510_
                           (fx+ _r148485_ (fx- _end148511_ _start148513_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest148487148499_))
                      (let ((_tl148493148519_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest148487148499_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl148493148519_))
                            (let ((_hd148494148522_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl148493148519_)))
                                  (_tl148495148524_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl148493148519_))))
                              (let ((_start148527_ _hd148494148522_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl148495148524_))
                                    (let ((_hd148496148529_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl148495148524_)))
                                          (_tl148497148531_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl148495148524_))))
                                      (let* ((_end148534_ _hd148496148529_)
                                             (_rest148536_ _tl148497148531_))
                                        (_K148491148516_
                                         _rest148536_
                                         _end148534_
                                         _start148527_)))
                                    (_else148489148507_))))
                            (_else148489148507_)))
                      (_else148489148507_)))))
             (_v148541_ (make-f64vector _len148538_)))
        (let _lp148545_ ((_rest148547_ _args148477_) (_at148548_ '0))
          (let* ((_rest148550148562_ _rest148547_)
                 (_else148552148570_ (lambda () _v148541_))
                 (_K148554148579_
                  (lambda (_rest148573_ _end148574_ _start148575_ _u148576_)
                    (std/srfi/160/f64#f64vector-copy!
                     _v148541_
                     _at148548_
                     _u148576_
                     _start148575_
                     _end148574_)
                    (_lp148545_
                     _rest148573_
                     (fx+ _at148548_ (fx- _end148574_ _start148575_))))))
            (if (let () (declare (not safe)) (##pair? _rest148550148562_))
                (let ((_hd148555148582_
                       (let ()
                         (declare (not safe))
                         (##car _rest148550148562_)))
                      (_tl148556148584_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest148550148562_))))
                  (let ((_u148587_ _hd148555148582_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl148556148584_))
                        (let ((_hd148557148589_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl148556148584_)))
                              (_tl148558148591_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl148556148584_))))
                          (let ((_start148594_ _hd148557148589_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl148558148591_))
                                (let ((_hd148559148596_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl148558148591_)))
                                      (_tl148560148598_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl148558148591_))))
                                  (let* ((_end148601_ _hd148559148596_)
                                         (_rest148603_ _tl148560148598_))
                                    (_K148554148579_
                                     _rest148603_
                                     _end148601_
                                     _start148594_
                                     _u148587_)))
                                (_else148552148570_))))
                        (_else148552148570_))))
                (_else148552148570_)))))))
  (define std/srfi/160/f64#f64vector-empty?
    (lambda (_v148474_) (fxzero? (f64vector-length _v148474_))))
  (define std/srfi/160/f64#f64vector=
    (lambda (_v148416_ . _args148418_)
      (declare (not safe))
      (begin
        (if (f64vector? _v148416_) '#!void (error '"Bad argument" _v148416_))
        (let ((_vlen148422_ (f64vector-length _v148416_)))
          (let _lp148425_ ((_rest148428_ _args148418_))
            (let* ((_rest148430148438_ _rest148428_)
                   (_else148432148446_ (lambda () '#t))
                   (_K148434148462_
                    (lambda (_rest148449_ _u148450_)
                      (if (f64vector? _u148450_)
                          '#!void
                          (error '"Bad argument" _u148450_))
                      (let ((_ulen148453_ (f64vector-length _u148450_)))
                        (if (fx= _vlen148422_ _ulen148453_)
                            (let _cmp148456_ ((_i148459_ '0))
                              (if (fx< _i148459_ _vlen148422_)
                                  (if (= (f64vector-ref _v148416_ _i148459_)
                                         (f64vector-ref _u148450_ _i148459_))
                                      (_cmp148456_ (fx+ _i148459_ '1))
                                      '#f)
                                  (_lp148425_ _rest148449_)))
                            '#f)))))
              (if (##pair? _rest148430148438_)
                  (let ((_hd148435148465_ (##car _rest148430148438_))
                        (_tl148436148467_ (##cdr _rest148430148438_)))
                    (let* ((_u148470_ _hd148435148465_)
                           (_rest148472_ _tl148436148467_))
                      (_K148434148462_ _rest148472_ _u148470_)))
                  (_else148432148446_))))))))
  (define std/srfi/160/f64#f64vector-take
    (lambda (_v148408_ _n148410_)
      (let ((_u148413_ (make-f64vector _n148410_)))
        (std/srfi/160/f64#f64vector-copy! _u148413_ '0 _v148408_ '0 _n148410_)
        _u148413_)))
  (define std/srfi/160/f64#f64vector-take-right
    (lambda (_v148393_ _n148395_)
      (let* ((_vlen148398_ (f64vector-length _v148393_))
             (_ulen148401_ (fx- _vlen148398_ _n148395_))
             (_u148404_ (make-f64vector _ulen148401_)))
        (std/srfi/160/f64#f64vector-copy!
         _u148404_
         '0
         _v148393_
         _n148395_
         _vlen148398_)
        _u148404_)))
  (define std/srfi/160/f64#f64vector-drop
    (lambda (_v148378_ _n148380_)
      (let* ((_vlen148383_ (f64vector-length _v148378_))
             (_ulen148386_ (fx- _vlen148383_ _n148380_))
             (_u148389_ (make-f64vector _ulen148386_)))
        (std/srfi/160/f64#f64vector-copy!
         _u148389_
         '0
         _v148378_
         _n148380_
         _vlen148383_)
        _u148389_)))
  (define std/srfi/160/f64#f64vector-drop-right
    (lambda (_v148363_ _n148365_)
      (let* ((_vlen148368_ (f64vector-length _v148363_))
             (_ulen148371_ (fx- _vlen148368_ _n148365_))
             (_u148374_ (make-f64vector _ulen148371_)))
        (std/srfi/160/f64#f64vector-copy!
         _u148374_
         '0
         _v148363_
         '0
         _ulen148371_)
        _u148374_)))
  (define std/srfi/160/f64#f64vector-segment
    (lambda (_v148345_ _n148347_)
      (let _lp148350_ ((_i148353_ '0)
                       (_rest148355_ (f64vector-length _v148345_))
                       (_r148357_ '()))
        (if (fx> _r148357_ '0)
            (let ((_size148360_ (fxmin _n148347_ _rest148355_)))
              (_lp148350_
               (fx+ _i148353_ _size148360_)
               (fx- _rest148355_ _size148360_)
               (cons (std/srfi/160/f64#f64vector-copy__%
                      _v148345_
                      _i148353_
                      (fx+ _i148353_ _size148360_))
                     _r148357_)))
            (reverse _r148357_)))))
  (define std/srfi/160/f64#f64vector-fold__0
    (lambda (_kons148305_ _knil148307_ _v148309_)
      (if (procedure? _kons148305_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148305_))
      (let ((_end148312_ (f64vector-length _v148309_)))
        (declare (not safe))
        (let _lp148316_ ((_i148319_ '0) (_r148321_ _knil148307_))
          (if (fx< _i148319_ _end148312_)
              (_lp148316_
               (fx+ _i148319_ '1)
               (_kons148305_ _r148321_ (f64vector-ref _v148309_ _i148319_)))
              _r148321_)))))
  (define std/srfi/160/f64#f64vector-fold__1
    (lambda (_kons148324_ _knil148325_ _v148326_ . _vs148327_)
      (if (procedure? _kons148324_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148324_))
      (let* ((_vs148330_ (cons _v148326_ _vs148327_))
             (_end148332_ (apply fxmin (map f64vector-length _vs148330_))))
        (declare (not safe))
        (let _lp148336_ ((_i148338_ '0) (_r148339_ _knil148325_))
          (if (fx< _i148338_ _end148332_)
              (_lp148336_
               (fx+ _i148338_ '1)
               (apply _kons148324_
                      _r148339_
                      (map (lambda (_g148340148342_)
                             (f64vector-ref _g148340148342_ _i148338_))
                           _vs148330_)))
              _r148339_)))))
  (define std/srfi/160/f64#f64vector-fold
    (lambda _g299407_
      (let ((_g299406_ (let () (declare (not safe)) (##length _g299407_))))
        (cond ((let () (declare (not safe)) (##fx= _g299406_ 3))
               (apply std/srfi/160/f64#f64vector-fold__0 _g299407_))
              ((let () (declare (not safe)) (##fx>= _g299406_ 3))
               (apply std/srfi/160/f64#f64vector-fold__1 _g299407_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-fold
                _g299407_))))))
  (define std/srfi/160/f64#f64vector-fold-right__0
    (lambda (_kons148265_ _knil148267_ _v148269_)
      (if (procedure? _kons148265_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148265_))
      (let ((_last148272_ (fx- (f64vector-length _v148269_) '1)))
        (declare (not safe))
        (let _lp148276_ ((_i148279_ _last148272_) (_r148281_ _knil148267_))
          (if (fx>= _i148279_ '0)
              (_lp148276_
               (fx- _i148279_ '1)
               (_kons148265_ _r148281_ (f64vector-ref _v148269_ _i148279_)))
              _r148281_)))))
  (define std/srfi/160/f64#f64vector-fold-right__1
    (lambda (_kons148284_ _knil148285_ _v148286_ . _vs148287_)
      (if (procedure? _kons148284_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148284_))
      (let* ((_vs148290_ (cons _v148286_ _vs148287_))
             (_last148292_
              (fx- (apply min (map f64vector-length _vs148290_)) '1)))
        (declare (not safe))
        (let _lp148296_ ((_i148298_ _last148292_) (_r148299_ _knil148285_))
          (if (fx>= _i148298_ '0)
              (_lp148296_
               (fx- _i148298_ '1)
               (apply _kons148284_
                      _r148299_
                      (map (lambda (_g148300148302_)
                             (f64vector-ref _g148300148302_ _i148298_))
                           _vs148290_)))
              _r148299_)))))
  (define std/srfi/160/f64#f64vector-fold-right
    (lambda _g299409_
      (let ((_g299408_ (let () (declare (not safe)) (##length _g299409_))))
        (cond ((let () (declare (not safe)) (##fx= _g299408_ 3))
               (apply std/srfi/160/f64#f64vector-fold-right__0 _g299409_))
              ((let () (declare (not safe)) (##fx>= _g299408_ 3))
               (apply std/srfi/160/f64#f64vector-fold-right__1 _g299409_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-fold-right
                _g299409_))))))
  (define std/srfi/160/f64#f64vector-map__0
    (lambda (_f148225_ _v148227_)
      (if (procedure? _f148225_)
          '#!void
          (error '"Bad argument; expected procedure" _f148225_))
      (let* ((_len148230_ (f64vector-length _v148227_))
             (_u148233_ (make-f64vector _len148230_)))
        (declare (not safe))
        (let _lp148238_ ((_i148241_ '0))
          (if (fx< _i148241_ _len148230_)
              (begin
                (f64vector-set!
                 _u148233_
                 _i148241_
                 (f64vector-ref _v148227_ _i148241_))
                (_lp148238_ (fx+ _i148241_ '1)))
              _u148233_)))))
  (define std/srfi/160/f64#f64vector-map__1
    (lambda (_f148244_ _v148245_ . _vs148246_)
      (if (procedure? _f148244_)
          '#!void
          (error '"Bad argument; expected procedure" _f148244_))
      (let* ((_vs148249_ (cons _v148245_ _vs148246_))
             (_len148251_ (apply fxmin (map f64vector-length _vs148249_)))
             (_u148253_ (make-f64vector _len148251_)))
        (declare (not safe))
        (let _lp148257_ ((_i148259_ '0))
          (if (fx< _i148259_ _len148251_)
              (begin
                (f64vector-set!
                 _u148253_
                 _i148259_
                 (apply _f148244_
                        (map (lambda (_g148260148262_)
                               (f64vector-ref _g148260148262_ _i148259_))
                             _vs148249_)))
                (_lp148257_ (fx+ _i148259_ '1)))
              _u148253_)))))
  (define std/srfi/160/f64#f64vector-map
    (lambda _g299411_
      (let ((_g299410_ (let () (declare (not safe)) (##length _g299411_))))
        (cond ((let () (declare (not safe)) (##fx= _g299410_ 2))
               (apply std/srfi/160/f64#f64vector-map__0 _g299411_))
              ((let () (declare (not safe)) (##fx>= _g299410_ 2))
               (apply std/srfi/160/f64#f64vector-map__1 _g299411_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-map
                _g299411_))))))
  (define std/srfi/160/f64#f64vector-map!__0
    (lambda (_f148191_ _v148193_)
      (if (procedure? _f148191_)
          '#!void
          (error '"Bad argument; expected procedure" _f148191_))
      (let ((_len148196_ (f64vector-length _v148193_)))
        (declare (not safe))
        (let _lp148200_ ((_i148203_ '0))
          (if (fx< _i148203_ _len148196_)
              (begin
                (f64vector-set!
                 _v148193_
                 _i148203_
                 (_f148191_ (f64vector-ref _v148193_ _i148203_)))
                (_lp148200_ (fx+ _i148203_ '1)))
              _v148193_)))))
  (define std/srfi/160/f64#f64vector-map!__1
    (lambda (_f148206_ _v148207_ . _vs148208_)
      (if (procedure? _f148206_)
          '#!void
          (error '"Bad argument; expected procedure" _f148206_))
      (let* ((_vs148211_ (cons _v148207_ _vs148208_))
             (_len148213_ (apply fxmin (map f64vector-length _vs148211_))))
        (declare (not safe))
        (let _lp148217_ ((_i148219_ '0))
          (if (fx< _i148219_ _len148213_)
              (begin
                (f64vector-set!
                 _v148207_
                 _i148219_
                 (apply _f148206_
                        (map (lambda (_g148220148222_)
                               (f64vector-ref _g148220148222_ _i148219_))
                             _vs148211_)))
                (_lp148217_ (fx+ _i148219_ '1)))
              _v148207_)))))
  (define std/srfi/160/f64#f64vector-map!
    (lambda _g299413_
      (let ((_g299412_ (let () (declare (not safe)) (##length _g299413_))))
        (cond ((let () (declare (not safe)) (##fx= _g299412_ 2))
               (apply std/srfi/160/f64#f64vector-map!__0 _g299413_))
              ((let () (declare (not safe)) (##fx>= _g299412_ 2))
               (apply std/srfi/160/f64#f64vector-map!__1 _g299413_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-map!
                _g299413_))))))
  (define std/srfi/160/f64#f64vector-for-each__0
    (lambda (_f148157_ _v148159_)
      (if (procedure? _f148157_)
          '#!void
          (error '"Bad argument; expected procedure" _f148157_))
      (let ((_len148162_ (f64vector-length _v148159_)))
        (declare (not safe))
        (let _lp148166_ ((_i148169_ '0))
          (if (fx< _i148169_ _len148162_)
              (begin
                (_f148157_ (f64vector-ref _v148159_ _i148169_))
                (_lp148166_ (fx+ _i148169_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-for-each__1
    (lambda (_f148172_ _v148173_ . _vs148174_)
      (let* ((_vs148177_ (cons _v148173_ _vs148174_))
             (_len148179_ (apply fxmin (map f64vector-length _vs148177_))))
        (declare (not safe))
        (let _lp148183_ ((_i148185_ '0))
          (if (fx< _i148185_ _len148179_)
              (begin
                (apply _f148172_
                       (map (lambda (_g148186148188_)
                              (f64vector-ref _g148186148188_ _i148185_))
                            _vs148177_))
                (_lp148183_ (fx+ _i148185_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-for-each
    (lambda _g299415_
      (let ((_g299414_ (let () (declare (not safe)) (##length _g299415_))))
        (cond ((let () (declare (not safe)) (##fx= _g299414_ 2))
               (apply std/srfi/160/f64#f64vector-for-each__0 _g299415_))
              ((let () (declare (not safe)) (##fx>= _g299414_ 2))
               (apply std/srfi/160/f64#f64vector-for-each__1 _g299415_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-for-each
                _g299415_))))))
  (define std/srfi/160/f64#f64vector-count__0
    (lambda (_pred148120_ _v148122_)
      (if (procedure? _pred148120_)
          '#!void
          (error '"Bad argument; expected procedure" _pred148120_))
      (let ((_end148125_ (f64vector-length _v148122_)))
        (declare (not safe))
        (let _lp148129_ ((_i148132_ '0) (_r148134_ '0))
          (if (fx< _i148132_ _end148125_)
              (if (_pred148120_ (f64vector-ref _v148122_ _i148132_))
                  (_lp148129_ (fx+ _i148132_ '1) (fx+ _r148134_ '1))
                  (_lp148129_ (fx+ _i148132_ '1) _r148134_))
              _r148134_)))))
  (define std/srfi/160/f64#f64vector-count__1
    (lambda (_pred148137_ _v148138_ . _vs148139_)
      (if (procedure? _pred148137_)
          '#!void
          (error '"Bad argument; expected procedure" _pred148137_))
      (let* ((_vs148142_ (cons _v148138_ _vs148139_))
             (_end148144_ (apply fxmin (map f64vector-length _vs148142_))))
        (declare (not safe))
        (let _lp148148_ ((_i148150_ '0) (_r148151_ '0))
          (if (fx< _i148150_ _end148144_)
              (if (apply _pred148137_
                         (map (lambda (_g148152148154_)
                                (f64vector-ref _g148152148154_ _i148150_))
                              _vs148142_))
                  (_lp148148_ (fx+ _i148150_ '1) (fx+ _r148151_ '1))
                  (_lp148148_ (fx+ _i148150_ '1) _r148151_))
              _r148151_)))))
  (define std/srfi/160/f64#f64vector-count
    (lambda _g299417_
      (let ((_g299416_ (let () (declare (not safe)) (##length _g299417_))))
        (cond ((let () (declare (not safe)) (##fx= _g299416_ 2))
               (apply std/srfi/160/f64#f64vector-count__0 _g299417_))
              ((let () (declare (not safe)) (##fx>= _g299416_ 2))
               (apply std/srfi/160/f64#f64vector-count__1 _g299417_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-count
                _g299417_))))))
  (define std/srfi/160/f64#f64vector-cumulate
    (lambda (_f148095_ _knil148097_ _v148099_)
      (if (procedure? _f148095_)
          '#!void
          (error '"Bad argument; expected procedure" _f148095_))
      (let* ((_len148102_ (f64vector-length _v148099_))
             (_r148105_ (make-f64vector _len148102_)))
        (declare (not safe))
        (let _lp148110_ ((_i148113_ '0) (_r148115_ _knil148097_))
          (if (fx< _i148113_ _len148102_)
              (let ((_next148117_
                     (_f148095_
                      _r148115_
                      (f64vector-ref _v148099_ _i148113_))))
                (f64vector-set! _v148099_ _i148113_ _next148117_)
                (_lp148110_ (fx+ _i148113_ '1) _next148117_))
              _v148099_)))))
  (define std/srfi/160/f64#f64vector-take-while
    (lambda (_pred148078_ _v148080_)
      (let* ((_len148083_ (f64vector-length _v148080_))
             (_idx148086_
              (std/srfi/160/f64#f64vector-skip__0 _pred148078_ _v148080_))
             (_idx148092_
              (let ((_$e148089_ _idx148086_))
                (if _$e148089_ _$e148089_ _len148083_))))
        (std/srfi/160/f64#f64vector-copy__% _v148080_ '0 _idx148092_))))
  (define std/srfi/160/f64#f64vector-take-while-right
    (lambda (_pred148064_ _v148066_)
      (let* ((_len148069_ (f64vector-length _v148066_))
             (_idx148072_
              (std/srfi/160/f64#f64vector-skip-right__0
               _pred148064_
               _v148066_))
             (_idx148075_ (if _idx148072_ (fx+ _idx148072_ '1) '0)))
        (std/srfi/160/f64#f64vector-copy__%
         _v148066_
         _idx148075_
         _len148069_))))
  (define std/srfi/160/f64#f64vector-drop-while
    (lambda (_pred148047_ _v148049_)
      (let* ((_len148052_ (f64vector-length _v148049_))
             (_idx148055_
              (std/srfi/160/f64#f64vector-skip__0 _pred148047_ _v148049_))
             (_idx148061_
              (let ((_$e148058_ _idx148055_))
                (if _$e148058_ _$e148058_ _len148052_))))
        (std/srfi/160/f64#f64vector-copy__%
         _v148049_
         _idx148061_
         _len148052_))))
  (define std/srfi/160/f64#f64vector-drop-while-right
    (lambda (_pred148033_ _v148035_)
      (let* ((_len148038_ (f64vector-length _v148035_))
             (_idx148041_
              (std/srfi/160/f64#f64vector-skip-right__0
               _pred148033_
               _v148035_))
             (_idx148044_ (if _idx148041_ (fx+ _idx148041_ '1) '0)))
        (std/srfi/160/f64#f64vector-copy__% _v148035_ '0 _idx148044_))))
  (define std/srfi/160/f64#f64vector-index__0
    (lambda (_pred147999_ _v148001_)
      (if (procedure? _pred147999_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147999_))
      (let ((_end148004_ (f64vector-length _v148001_)))
        (declare (not safe))
        (let _lp148008_ ((_i148011_ '0))
          (if (fx< _i148011_ _end148004_)
              (if (_pred147999_ (f64vector-ref _v148001_ _i148011_))
                  _i148011_
                  (_lp148008_ (fx+ _i148011_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index__1
    (lambda (_pred148014_ _v148015_ . _vs148016_)
      (if (procedure? _pred148014_)
          '#!void
          (error '"Bad argument; expected procedure" _pred148014_))
      (let* ((_vs148019_ (cons _v148015_ _vs148016_))
             (_end148021_ (apply fxmin (map f64vector-length _vs148019_))))
        (declare (not safe))
        (let _lp148025_ ((_i148027_ '0))
          (if (fx< _i148027_ _end148021_)
              (if (apply _pred148014_
                         (map (lambda (_g148028148030_)
                                (f64vector-ref _g148028148030_ _i148027_))
                              _vs148019_))
                  _i148027_
                  (_lp148025_ (fx+ _i148027_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index
    (lambda _g299419_
      (let ((_g299418_ (let () (declare (not safe)) (##length _g299419_))))
        (cond ((let () (declare (not safe)) (##fx= _g299418_ 2))
               (apply std/srfi/160/f64#f64vector-index__0 _g299419_))
              ((let () (declare (not safe)) (##fx>= _g299418_ 2))
               (apply std/srfi/160/f64#f64vector-index__1 _g299419_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-index
                _g299419_))))))
  (define std/srfi/160/f64#f64vector-index-right__0
    (lambda (_pred147965_ _v147967_)
      (if (procedure? _pred147965_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147965_))
      (let ((_start147970_ (fx- (f64vector-length _v147967_) '1)))
        (declare (not safe))
        (let _lp147974_ ((_i147977_ _start147970_))
          (if (fx>= _i147977_ '0)
              (if (_pred147965_ (f64vector-ref _v147967_ _i147977_))
                  _i147977_
                  (_lp147974_ (fx- _i147977_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index-right__1
    (lambda (_pred147980_ _v147981_ . _vs147982_)
      (if (procedure? _pred147980_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147980_))
      (let* ((_vs147985_ (cons _v147981_ _vs147982_))
             (_start147987_
              (fx- (apply fxmin (map f64vector-length _vs147985_)) '1)))
        (declare (not safe))
        (let _lp147991_ ((_i147993_ _start147987_))
          (if (fx>= _i147993_ '0)
              (if (apply _pred147980_
                         (map (lambda (_g147994147996_)
                                (f64vector-ref _g147994147996_ _i147993_))
                              _vs147985_))
                  _i147993_
                  (_lp147991_ (fx- _i147993_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index-right
    (lambda _g299421_
      (let ((_g299420_ (let () (declare (not safe)) (##length _g299421_))))
        (cond ((let () (declare (not safe)) (##fx= _g299420_ 2))
               (apply std/srfi/160/f64#f64vector-index-right__0 _g299421_))
              ((let () (declare (not safe)) (##fx>= _g299420_ 2))
               (apply std/srfi/160/f64#f64vector-index-right__1 _g299421_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-index-right
                _g299421_))))))
  (define std/srfi/160/f64#f64vector-skip__0
    (lambda (_pred147949_ _v147951_)
      (std/srfi/160/f64#f64vector-index__0
       (lambda (_$obj147954_) (not (_pred147949_ _$obj147954_)))
       _v147951_)))
  (define std/srfi/160/f64#f64vector-skip__1
    (lambda (_pred147957_ _v147958_ . _vs147959_)
      (apply std/srfi/160/f64#f64vector-index
             (lambda (_$obj147962_) (not (_pred147957_ _$obj147962_)))
             _v147958_
             _vs147959_)))
  (define std/srfi/160/f64#f64vector-skip
    (lambda _g299423_
      (let ((_g299422_ (let () (declare (not safe)) (##length _g299423_))))
        (cond ((let () (declare (not safe)) (##fx= _g299422_ 2))
               (apply std/srfi/160/f64#f64vector-skip__0 _g299423_))
              ((let () (declare (not safe)) (##fx>= _g299422_ 2))
               (apply std/srfi/160/f64#f64vector-skip__1 _g299423_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-skip
                _g299423_))))))
  (define std/srfi/160/f64#f64vector-skip-right__0
    (lambda (_pred147933_ _v147935_)
      (std/srfi/160/f64#f64vector-index-right__0
       (lambda (_$obj147938_) (not (_pred147933_ _$obj147938_)))
       _v147935_)))
  (define std/srfi/160/f64#f64vector-skip-right__1
    (lambda (_pred147941_ _v147942_ . _vs147943_)
      (apply std/srfi/160/f64#f64vector-index-right
             (lambda (_$obj147946_) (not (_pred147941_ _$obj147946_)))
             _v147942_
             _vs147943_)))
  (define std/srfi/160/f64#f64vector-skip-right
    (lambda _g299425_
      (let ((_g299424_ (let () (declare (not safe)) (##length _g299425_))))
        (cond ((let () (declare (not safe)) (##fx= _g299424_ 2))
               (apply std/srfi/160/f64#f64vector-skip-right__0 _g299425_))
              ((let () (declare (not safe)) (##fx>= _g299424_ 2))
               (apply std/srfi/160/f64#f64vector-skip-right__1 _g299425_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-skip-right
                _g299425_))))))
  (define std/srfi/160/f64#f64vector-any__0
    (lambda (_pred147893_ _v147895_)
      (if (procedure? _pred147893_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147893_))
      (let ((_end147898_ (f64vector-length _v147895_)))
        (declare (not safe))
        (let _lp147902_ ((_i147905_ '0))
          (if (fx< _i147905_ _end147898_)
              (let ((_$e147908_
                     (_pred147893_ (f64vector-ref _v147895_ _i147905_))))
                (if _$e147908_
                    (values _$e147908_)
                    (_lp147902_ (fx+ _i147905_ '1))))
              '#f)))))
  (define std/srfi/160/f64#f64vector-any__1
    (lambda (_pred147911_ _v147912_ . _vs147913_)
      (if (procedure? _pred147911_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147911_))
      (let* ((_v147916_ (cons _v147912_ _vs147913_))
             (_end147918_ (apply fxmin (map f64vector-length _vs147913_))))
        (declare (not safe))
        (let _lp147922_ ((_i147924_ '0))
          (if (fx< _i147924_ _end147918_)
              (let ((_$e147930_
                     (apply _pred147911_
                            (map (lambda (_g147925147927_)
                                   (f64vector-ref _g147925147927_ _i147924_))
                                 _vs147913_))))
                (if _$e147930_
                    (values _$e147930_)
                    (_lp147922_ (fx+ _i147924_ '1))))
              '#f)))))
  (define std/srfi/160/f64#f64vector-any
    (lambda _g299427_
      (let ((_g299426_ (let () (declare (not safe)) (##length _g299427_))))
        (cond ((let () (declare (not safe)) (##fx= _g299426_ 2))
               (apply std/srfi/160/f64#f64vector-any__0 _g299427_))
              ((let () (declare (not safe)) (##fx>= _g299426_ 2))
               (apply std/srfi/160/f64#f64vector-any__1 _g299427_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-any
                _g299427_))))))
  (define std/srfi/160/f64#f64vector-every__0
    (lambda (_pred147842_ _v147844_)
      (if (procedure? _pred147842_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147842_))
      (let ((_end147847_ (f64vector-length _v147844_)))
        (declare (not safe))
        (let _lp147851_ ((_i147854_ '0) (_r147856_ '#t))
          (if (fx< _i147854_ _end147847_)
              (let ((_$e147859_
                     (_pred147842_ (f64vector-ref _v147844_ _i147854_))))
                (if _$e147859_
                    ((lambda (_g147861147863_)
                       (_lp147851_ (fx+ _i147854_ '1) _g147861147863_))
                     _$e147859_)
                    '#f))
              _r147856_)))))
  (define std/srfi/160/f64#f64vector-every__1
    (lambda (_pred147866_ _v147867_ . _vs147868_)
      (if (procedure? _pred147866_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147866_))
      (let* ((_v147871_ (cons _v147867_ _vs147868_))
             (_end147873_ (apply fxmin (map f64vector-length _vs147868_))))
        (declare (not safe))
        (let _lp147877_ ((_i147879_ '0) (_r147880_ '#t))
          (if (fx< _i147879_ _end147873_)
              (let ((_$e147886_
                     (apply _pred147866_
                            (map (lambda (_g147881147883_)
                                   (f64vector-ref _g147881147883_ _i147879_))
                                 _vs147868_))))
                (if _$e147886_
                    ((lambda (_g147888147890_)
                       (_lp147877_ (fx+ _i147879_ '1) _g147888147890_))
                     _$e147886_)
                    '#f))
              _r147880_)))))
  (define std/srfi/160/f64#f64vector-every
    (lambda _g299429_
      (let ((_g299428_ (let () (declare (not safe)) (##length _g299429_))))
        (cond ((let () (declare (not safe)) (##fx= _g299428_ 2))
               (apply std/srfi/160/f64#f64vector-every__0 _g299429_))
              ((let () (declare (not safe)) (##fx>= _g299428_ 2))
               (apply std/srfi/160/f64#f64vector-every__1 _g299429_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-every
                _g299429_))))))
  (define std/srfi/160/f64#f64vector-partition
    (lambda (_pred147813_ _v147815_)
      (let* ((_count147818_
              (std/srfi/160/f64#f64vector-count__0 _pred147813_ _v147815_))
             (_len147821_ (f64vector-length _v147815_))
             (_u147824_ (make-f64vector _len147821_)))
        (declare (not safe))
        (let _lp147829_ ((_i147832_ '0)
                         (_left147834_ '0)
                         (_right147836_ _count147818_))
          (if (fx< _i147832_ _len147821_)
              (let ((_x147839_ (f64vector-ref _v147815_ _i147832_)))
                (if (_pred147813_ _x147839_)
                    (begin
                      (f64vector-set! _u147824_ _left147834_ _x147839_)
                      (_lp147829_
                       (fx+ _i147832_ '1)
                       (fx+ _left147834_ '1)
                       _right147836_))
                    (begin
                      (f64vector-set! _u147824_ _right147836_ _x147839_)
                      (_lp147829_
                       (fx+ _i147832_ '1)
                       _left147834_
                       (fx+ _right147836_ '1)))))
              _u147824_)))))
  (define std/srfi/160/f64#f64vector-filter
    (lambda (_pred147786_ _v147788_)
      (let* ((_count147791_
              (std/srfi/160/f64#f64vector-count__0 _pred147786_ _v147788_))
             (_u147794_ (make-f64vector _count147791_))
             (_end147797_ (f64vector-length _v147788_)))
        (declare (not safe))
        (let _lp147802_ ((_i147805_ '0) (_j147807_ '0))
          (if (fx< _i147805_ _end147797_)
              (let ((_x147810_ (f64vector-ref _v147788_ _i147805_)))
                (if (_pred147786_ _x147810_)
                    (begin
                      (f64vector-set! _u147794_ _j147807_ _x147810_)
                      (_lp147802_ (fx+ _i147805_ '1) (fx+ _j147807_ '1)))
                    (_lp147802_ (fx+ _i147805_ '1) _j147807_)))
              _u147794_)))))
  (define std/srfi/160/f64#f64vector-remove
    (lambda (_pred147778_ _v147780_)
      (std/srfi/160/f64#f64vector-filter
       (lambda (_$obj147783_) (not (_pred147778_ _$obj147783_)))
       _v147780_)))
  (define std/srfi/160/f64#f64vector-swap
    (lambda (_v147765_ _i147767_ _j147769_)
      (let ((_iv147772_ (f64vector-ref _v147765_ _i147767_))
            (_jv147774_ (f64vector-ref _v147765_ _j147769_)))
        (declare (not safe))
        (begin
          (f64vector-set! _v147765_ _i147767_ _jv147774_)
          (f64vector-set! _v147765_ _j147769_ _iv147772_)))))
  (define std/srfi/160/f64#f64vector-fill!__%
    (lambda (_v147728_ _fill147730_ _start147732_ _end147734_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147728_) '#!void (error '"Bad argument" _v147728_))
        (if (flonum? _fill147730_)
            '#!void
            (error '"Bad argument" _fill147730_))
        (if (and (fixnum? _start147732_)
                 (fx<= '0 _start147732_ (fx- (f64vector-length _v147728_) '1)))
            '#!void
            (error '"Index out of range" _start147732_))
        (if (and (fixnum? _end147734_)
                 (fx<= _start147732_ _end147734_ (f64vector-length _v147728_)))
            '#!void
            (error '"Index out of range" _end147734_))
        (let _lp147738_ ((_i147741_ _start147732_))
          (if (fx< _i147741_ _end147734_)
              (begin
                (f64vector-set! _v147728_ _i147741_ _fill147730_)
                (_lp147738_ (fx+ _i147741_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-fill!__0
    (lambda (_v147747_ _fill147748_)
      (let* ((_start147750_ '0) (_end147752_ (f64vector-length _v147747_)))
        (std/srfi/160/f64#f64vector-fill!__%
         _v147747_
         _fill147748_
         _start147750_
         _end147752_))))
  (define std/srfi/160/f64#f64vector-fill!__1
    (lambda (_v147754_ _fill147755_ _start147756_)
      (let ((_end147758_ (f64vector-length _v147754_)))
        (std/srfi/160/f64#f64vector-fill!__%
         _v147754_
         _fill147755_
         _start147756_
         _end147758_))))
  (define std/srfi/160/f64#f64vector-fill!
    (lambda _g299431_
      (let ((_g299430_ (let () (declare (not safe)) (##length _g299431_))))
        (cond ((let () (declare (not safe)) (##fx= _g299430_ 2))
               (apply std/srfi/160/f64#f64vector-fill!__0 _g299431_))
              ((let () (declare (not safe)) (##fx= _g299430_ 3))
               (apply std/srfi/160/f64#f64vector-fill!__1 _g299431_))
              ((let () (declare (not safe)) (##fx= _g299430_ 4))
               (apply std/srfi/160/f64#f64vector-fill!__% _g299431_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-fill!
                _g299431_))))))
  (define std/srfi/160/f64#f64vector-reverse!__%
    (lambda (_v147688_ _start147690_ _end147692_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147688_) '#!void (error '"Bad argument" _v147688_))
        (if (and (fixnum? _start147690_)
                 (fx<= '0 _start147690_ (fx- (f64vector-length _v147688_) '1)))
            '#!void
            (error '"Index out of range" _start147690_))
        (if (and (fixnum? _end147692_)
                 (fx<= _start147690_ _end147692_ (f64vector-length _v147688_)))
            '#!void
            (error '"Index out of range" _end147692_))
        (let _lp147696_ ((_i147699_ _start147690_)
                         (_j147701_ (fx- _end147692_ '1)))
          (if (fx< _i147699_ _j147701_)
              (let ((_iv147704_ (f64vector-ref _v147688_ _i147699_))
                    (_jv147706_ (f64vector-ref _v147688_ _j147701_)))
                (f64vector-set! _v147688_ _i147699_ _jv147706_)
                (f64vector-set! _v147688_ _j147701_ _iv147704_)
                (_lp147696_ (fx+ _i147699_ '1) (fx- _j147701_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-reverse!__0
    (lambda (_v147712_)
      (let* ((_start147714_ '0) (_end147716_ (f64vector-length _v147712_)))
        (std/srfi/160/f64#f64vector-reverse!__%
         _v147712_
         _start147714_
         _end147716_))))
  (define std/srfi/160/f64#f64vector-reverse!__1
    (lambda (_v147718_ _start147719_)
      (let ((_end147721_ (f64vector-length _v147718_)))
        (std/srfi/160/f64#f64vector-reverse!__%
         _v147718_
         _start147719_
         _end147721_))))
  (define std/srfi/160/f64#f64vector-reverse!
    (lambda _g299433_
      (let ((_g299432_ (let () (declare (not safe)) (##length _g299433_))))
        (cond ((let () (declare (not safe)) (##fx= _g299432_ 1))
               (apply std/srfi/160/f64#f64vector-reverse!__0 _g299433_))
              ((let () (declare (not safe)) (##fx= _g299432_ 2))
               (apply std/srfi/160/f64#f64vector-reverse!__1 _g299433_))
              ((let () (declare (not safe)) (##fx= _g299432_ 3))
               (apply std/srfi/160/f64#f64vector-reverse!__% _g299433_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-reverse!
                _g299433_))))))
  (define std/srfi/160/f64#f64vector-unfold!
    (lambda (_f147663_ _v147665_ _start147667_ _end147669_ _seed147671_)
      (declare (not safe))
      (begin
        (if (procedure? _f147663_)
            '#!void
            (error '"Bad argument; expected procedure" _f147663_))
        (if (f64vector? _v147665_) '#!void (error '"Bad argument" _v147665_))
        (if (and (fixnum? _start147667_)
                 (fx<= '0 _start147667_ (fx- (f64vector-length _v147665_) '1)))
            '#!void
            (error '"Index out of range" _start147667_))
        (if (and (fixnum? _end147669_)
                 (fx<= _start147667_ _end147669_ (f64vector-length _v147665_)))
            '#!void
            (error '"Index out of range" _end147669_))
        (let _lp147675_ ((_i147678_ _start147667_)
                         (_state147680_ _seed147671_))
          (if (fx< _i147678_ _end147669_)
              (let ((_g299434_ (_f147663_ _state147680_)))
                (begin
                  (let ((_g299435_
                         (if (##values? _g299434_)
                             (##vector-length _g299434_)
                             1)))
                    (if (not (##fx= _g299435_ 2))
                        (error "Context expects 2 values" _g299435_)))
                  (let ((_x147683_ (##vector-ref _g299434_ 0))
                        (_state147685_ (##vector-ref _g299434_ 1)))
                    (begin
                      (f64vector-set! _v147665_ _i147678_ _x147683_)
                      (_lp147675_ (fx+ _i147678_ '1) _state147685_)))))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-unfold-right!
    (lambda (_f147639_ _v147641_ _start147643_ _end147645_ _seed147647_)
      (declare (not safe))
      (begin
        (if (procedure? _f147639_)
            '#!void
            (error '"Bad argument; expected procedure" _f147639_))
        (if (f64vector? _v147641_) '#!void (error '"Bad argument" _v147641_))
        (if (and (fixnum? _start147643_)
                 (fx<= '0 _start147643_ (fx- (f64vector-length _v147641_) '1)))
            '#!void
            (error '"Index out of range" _start147643_))
        (if (and (fixnum? _end147645_)
                 (fx<= _start147643_ _end147645_ (f64vector-length _v147641_)))
            '#!void
            (error '"Index out of range" _end147645_))
        (let _lp147651_ ((_i147654_ (fx- _end147645_ '1))
                         (_state147656_ _seed147647_))
          (if (fx>= _i147654_ _start147643_)
              (let ((_g299436_ (_f147639_ _state147656_)))
                (begin
                  (let ((_g299437_
                         (if (##values? _g299436_)
                             (##vector-length _g299436_)
                             1)))
                    (if (not (##fx= _g299437_ 2))
                        (error "Context expects 2 values" _g299437_)))
                  (let ((_x147659_ (##vector-ref _g299436_ 0))
                        (_state147661_ (##vector-ref _g299436_ 1)))
                    (begin
                      (f64vector-set! _v147641_ _i147654_ _x147659_)
                      (_lp147651_ (fx- _i147654_ '1) _state147661_)))))
              '#!void)))))
  (define std/srfi/160/f64#reverse-f64vector->list__%
    (lambda (_v147605_ _start147607_ _end147609_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147605_) '#!void (error '"Bad argument" _v147605_))
        (if (and (fixnum? _start147607_)
                 (fx<= '0 _start147607_ (fx- (f64vector-length _v147605_) '1)))
            '#!void
            (error '"Index out of range" _start147607_))
        (if (and (fixnum? _end147609_)
                 (fx<= _start147607_ _end147609_ (f64vector-length _v147605_)))
            '#!void
            (error '"Index out of range" _end147609_))
        (let _lp147613_ ((_i147616_ _start147607_) (_r147618_ '()))
          (if (fx< _i147616_ _end147609_)
              (_lp147613_
               (fx+ _i147616_ '1)
               (cons (f64vector-ref _v147605_ _i147616_) _r147618_))
              _r147618_)))))
  (define std/srfi/160/f64#reverse-f64vector->list__0
    (lambda (_v147624_)
      (let* ((_start147626_ '0) (_end147628_ (f64vector-length _v147624_)))
        (std/srfi/160/f64#reverse-f64vector->list__%
         _v147624_
         _start147626_
         _end147628_))))
  (define std/srfi/160/f64#reverse-f64vector->list__1
    (lambda (_v147630_ _start147631_)
      (let ((_end147633_ (f64vector-length _v147630_)))
        (std/srfi/160/f64#reverse-f64vector->list__%
         _v147630_
         _start147631_
         _end147633_))))
  (define std/srfi/160/f64#reverse-f64vector->list
    (lambda _g299439_
      (let ((_g299438_ (let () (declare (not safe)) (##length _g299439_))))
        (cond ((let () (declare (not safe)) (##fx= _g299438_ 1))
               (apply std/srfi/160/f64#reverse-f64vector->list__0 _g299439_))
              ((let () (declare (not safe)) (##fx= _g299438_ 2))
               (apply std/srfi/160/f64#reverse-f64vector->list__1 _g299439_))
              ((let () (declare (not safe)) (##fx= _g299438_ 3))
               (apply std/srfi/160/f64#reverse-f64vector->list__% _g299439_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#reverse-f64vector->list
                _g299439_))))))
  (define std/srfi/160/f64#reverse-list->f64vector
    (lambda (_lst147551_)
      (let* ((_len147554_ (length _lst147551_))
             (_v147557_ (make-f64vector _len147554_)))
        (declare (not safe))
        (let _lp147562_ ((_rest147565_ _lst147551_) (_i147567_ '0))
          (let* ((_rest147569147577_ _rest147565_)
                 (_else147571147585_ (lambda () _v147557_))
                 (_K147573147592_
                  (lambda (_rest147588_ _x147589_)
                    (if (flonum? _x147589_)
                        '#!void
                        (error '"Bad element" _x147589_))
                    (f64vector-set! _v147557_ _i147567_ _x147589_)
                    (_lp147562_ _rest147588_ (fx+ _i147567_ '1)))))
            (if (##pair? _rest147569147577_)
                (let ((_hd147574147595_ (##car _rest147569147577_))
                      (_tl147575147597_ (##cdr _rest147569147577_)))
                  (let* ((_x147600_ _hd147574147595_)
                         (_rest147602_ _tl147575147597_))
                    (_K147573147592_ _rest147602_ _x147600_)))
                (_else147571147585_)))))))
  (define std/srfi/160/f64#f64vector->vector__%
    (lambda (_v147512_ _start147514_ _end147516_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147512_) '#!void (error '"Bad argument" _v147512_))
        (if (and (fixnum? _start147514_)
                 (fx<= '0 _start147514_ (fx- (f64vector-length _v147512_) '1)))
            '#!void
            (error '"Index out of range" _start147514_))
        (if (and (fixnum? _end147516_)
                 (fx<= _start147514_ _end147516_ (f64vector-length _v147512_)))
            '#!void
            (error '"Index out of range" _end147516_))
        (let* ((_len147520_ (f64vector-length _v147512_))
               (_u147523_ (make-vector _len147520_)))
          (let _lp147527_ ((_i147530_ '0))
            (if (fx< _i147530_ _len147520_)
                (begin
                  (vector-set!
                   _u147523_
                   _i147530_
                   (f64vector-ref _v147512_ _i147530_))
                  (_lp147527_ (fx+ _i147530_ '1)))
                _u147523_))))))
  (define std/srfi/160/f64#f64vector->vector__0
    (lambda (_v147536_)
      (let* ((_start147538_ '0) (_end147540_ (f64vector-length _v147536_)))
        (std/srfi/160/f64#f64vector->vector__%
         _v147536_
         _start147538_
         _end147540_))))
  (define std/srfi/160/f64#f64vector->vector__1
    (lambda (_v147542_ _start147543_)
      (let ((_end147545_ (f64vector-length _v147542_)))
        (std/srfi/160/f64#f64vector->vector__%
         _v147542_
         _start147543_
         _end147545_))))
  (define std/srfi/160/f64#f64vector->vector
    (lambda _g299441_
      (let ((_g299440_ (let () (declare (not safe)) (##length _g299441_))))
        (cond ((let () (declare (not safe)) (##fx= _g299440_ 1))
               (apply std/srfi/160/f64#f64vector->vector__0 _g299441_))
              ((let () (declare (not safe)) (##fx= _g299440_ 2))
               (apply std/srfi/160/f64#f64vector->vector__1 _g299441_))
              ((let () (declare (not safe)) (##fx= _g299440_ 3))
               (apply std/srfi/160/f64#f64vector->vector__% _g299441_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector->vector
                _g299441_))))))
  (define std/srfi/160/f64#vector->f64vector__%
    (lambda (_v147472_ _start147474_ _end147476_)
      (declare (not safe))
      (begin
        (if (vector? _v147472_)
            '#!void
            (error '"Bad argument; expected vector" _v147472_))
        (if (and (fixnum? _start147474_)
                 (fx<= '0 _start147474_ (fx- (vector-length _v147472_) '1)))
            '#!void
            (error '"Index out of range" _start147474_))
        (if (and (fixnum? _end147476_)
                 (fx<= _start147474_ _end147476_ (vector-length _v147472_)))
            '#!void
            (error '"Index out of range" _end147476_))
        (let* ((_len147480_ (vector-length _v147472_))
               (_u147483_ (make-f64vector _len147480_)))
          (let _lp147487_ ((_i147490_ '0))
            (if (fx< _i147490_ _len147480_)
                (begin
                  (f64vector-set!
                   _u147483_
                   _i147490_
                   (vector-ref _v147472_ _i147490_))
                  (_lp147487_ (fx+ _i147490_ '1)))
                _u147483_))))))
  (define std/srfi/160/f64#vector->f64vector__0
    (lambda (_v147496_)
      (let* ((_start147498_ '0) (_end147500_ (vector-length _v147496_)))
        (std/srfi/160/f64#vector->f64vector__%
         _v147496_
         _start147498_
         _end147500_))))
  (define std/srfi/160/f64#vector->f64vector__1
    (lambda (_v147502_ _start147503_)
      (let ((_end147505_ (vector-length _v147502_)))
        (std/srfi/160/f64#vector->f64vector__%
         _v147502_
         _start147503_
         _end147505_))))
  (define std/srfi/160/f64#vector->f64vector
    (lambda _g299443_
      (let ((_g299442_ (let () (declare (not safe)) (##length _g299443_))))
        (cond ((let () (declare (not safe)) (##fx= _g299442_ 1))
               (apply std/srfi/160/f64#vector->f64vector__0 _g299443_))
              ((let () (declare (not safe)) (##fx= _g299442_ 2))
               (apply std/srfi/160/f64#vector->f64vector__1 _g299443_))
              ((let () (declare (not safe)) (##fx= _g299442_ 3))
               (apply std/srfi/160/f64#vector->f64vector__% _g299443_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#vector->f64vector
                _g299443_))))))
  (define std/srfi/160/f64#make-f64vector-generator__%
    (lambda (_v147438_ _start147440_ _end147442_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147438_) '#!void (error '"Bad argument" _v147438_))
        (if (and (fixnum? _start147440_)
                 (fx<= '0 _start147440_ (fx- (f64vector-length _v147438_) '1)))
            '#!void
            (error '"Index out of range" _start147440_))
        (if (and (fixnum? _end147442_)
                 (fx<= _start147440_ _end147442_ (f64vector-length _v147438_)))
            '#!void
            (error '"Index out of range" _end147442_))
        (let ((_i147446_ _start147440_))
          (lambda ()
            (if (fx< _i147446_ _end147442_)
                (let ((_next147450_ (f64vector-ref _v147438_ _i147446_)))
                  (set! _i147446_ (fx+ _i147446_ '1))
                  _next147450_)
                '#!eof))))))
  (define std/srfi/160/f64#make-f64vector-generator__0
    (lambda (_v147456_)
      (let* ((_start147458_ '0) (_end147460_ (f64vector-length _v147456_)))
        (std/srfi/160/f64#make-f64vector-generator__%
         _v147456_
         _start147458_
         _end147460_))))
  (define std/srfi/160/f64#make-f64vector-generator__1
    (lambda (_v147462_ _start147463_)
      (let ((_end147465_ (f64vector-length _v147462_)))
        (std/srfi/160/f64#make-f64vector-generator__%
         _v147462_
         _start147463_
         _end147465_))))
  (define std/srfi/160/f64#make-f64vector-generator
    (lambda _g299445_
      (let ((_g299444_ (let () (declare (not safe)) (##length _g299445_))))
        (cond ((let () (declare (not safe)) (##fx= _g299444_ 1))
               (apply std/srfi/160/f64#make-f64vector-generator__0 _g299445_))
              ((let () (declare (not safe)) (##fx= _g299444_ 2))
               (apply std/srfi/160/f64#make-f64vector-generator__1 _g299445_))
              ((let () (declare (not safe)) (##fx= _g299444_ 3))
               (apply std/srfi/160/f64#make-f64vector-generator__% _g299445_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#make-f64vector-generator
                _g299445_))))))
  (define std/srfi/160/f64#f64vector-comparator
    (let ()
      (letrec ((_<?147409_
                (lambda (_a147412_ _b147414_)
                  (let ((_len-a147417_ (f64vector-length _a147412_))
                        (_len-b147419_ (f64vector-length _b147414_)))
                    (declare (not safe))
                    (if (fx< _len-a147417_ _len-b147419_)
                        '#t
                        (if (fx> _len-a147417_ _len-b147419_)
                            '#f
                            (let ((_end147423_ _len-a147417_))
                              (let _lp147426_ ((_i147429_ '0))
                                (if (fx< _i147429_ _end147423_)
                                    (let ((_x147432_
                                           (f64vector-ref _a147412_ _i147429_))
                                          (_y147434_
                                           (f64vector-ref
                                            _b147414_
                                            _i147429_)))
                                      (if (< _x147432_ _y147434_)
                                          '#t
                                          (if (> _x147432_ _y147434_)
                                              '#f
                                              (_lp147426_
                                               (fx+ _i147429_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           f64vector?
           std/srfi/160/f64#f64vector=
           _<?147409_
           equal?-hash)))))
  (define std/srfi/160/f64#write-f64vector__%
    (lambda (_v147386_ _port147388_)
      (let ((_$e147391_ (find-method _v147386_ ':write)))
        (if _$e147391_
            ((lambda (_g147393147395_)
               (_g147393147395_ _v147386_ _port147388_))
             _$e147391_)
            (write _v147386_ (current-output-port))))))
  (define std/srfi/160/f64#write-f64vector__0
    (lambda (_v147401_)
      (let ((_port147403_ (current-output-port)))
        (std/srfi/160/f64#write-f64vector__% _v147401_ _port147403_))))
  (define std/srfi/160/f64#write-f64vector
    (lambda _g299447_
      (let ((_g299446_ (let () (declare (not safe)) (##length _g299447_))))
        (cond ((let () (declare (not safe)) (##fx= _g299446_ 1))
               (apply std/srfi/160/f64#write-f64vector__0 _g299447_))
              ((let () (declare (not safe)) (##fx= _g299446_ 2))
               (apply std/srfi/160/f64#write-f64vector__% _g299447_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#write-f64vector
                _g299447_)))))))
