(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/s64#s64vector-unfold
    (lambda (_f145935_ _len145937_ _seed145939_)
      (declare (not safe))
      (begin
        (if (procedure? _f145935_)
            '#!void
            (error '"Bad argument; expected procedure" _f145935_))
        (let ((_v145943_ (make-s64vector _len145937_)))
          (let _lp145946_ ((_i145949_ '0) (_state145951_ _seed145939_))
            (if (fx< _i145949_ _len145937_)
                (let ((_g299298_ (_f145935_ _i145949_ _state145951_)))
                  (begin
                    (let ((_g299299_
                           (if (##values? _g299298_)
                               (##vector-length _g299298_)
                               1)))
                      (if (not (##fx= _g299299_ 2))
                          (error "Context expects 2 values" _g299299_)))
                    (let ((_x145954_ (##vector-ref _g299298_ 0))
                          (_state145956_ (##vector-ref _g299298_ 1)))
                      (begin
                        (if (std/srfi/160/base#s64? _x145954_)
                            '#!void
                            (error '"Bad generated value" _x145954_))
                        (s64vector-set! _v145943_ _i145949_ _x145954_)
                        (_lp145946_ (fx+ _i145949_ '1) _state145956_)))))
                _v145943_))))))
  (define std/srfi/160/s64#s64vector-unfold-right
    (lambda (_f145912_ _len145914_ _seed145916_)
      (declare (not safe))
      (begin
        (if (procedure? _f145912_)
            '#!void
            (error '"Bad argument; expected procedure" _f145912_))
        (let ((_v145920_ (make-s64vector _len145914_)))
          (let _lp145923_ ((_i145926_ (fx- _len145914_ '1))
                           (_state145928_ _seed145916_))
            (if (fx>= _i145926_ '0)
                (let ((_g299300_ (_f145912_ _i145926_ _state145928_)))
                  (begin
                    (let ((_g299301_
                           (if (##values? _g299300_)
                               (##vector-length _g299300_)
                               1)))
                      (if (not (##fx= _g299301_ 2))
                          (error "Context expects 2 values" _g299301_)))
                    (let ((_x145931_ (##vector-ref _g299300_ 0))
                          (_state145933_ (##vector-ref _g299300_ 1)))
                      (begin
                        (if (std/srfi/160/base#s64? _x145931_)
                            '#!void
                            (error '"Bad generated value" _x145931_))
                        (s64vector-set! _v145920_ _i145926_ _x145931_)
                        (_lp145923_ (fx- _i145926_ '1) _state145933_)))))
                _v145920_))))))
  (define std/srfi/160/s64#s64vector-copy__%
    (lambda (_vec145884_ _start145886_ _end145888_)
      (let ((_v145891_ (make-s64vector (fx- _end145888_ _start145886_))))
        (std/srfi/160/s64#s64vector-copy!
         _v145891_
         '0
         _vec145884_
         _start145886_
         _end145888_)
        _v145891_)))
  (define std/srfi/160/s64#s64vector-copy__0
    (lambda (_vec145897_)
      (let* ((_start145899_ '0) (_end145901_ (s64vector-length _vec145897_)))
        (std/srfi/160/s64#s64vector-copy__%
         _vec145897_
         _start145899_
         _end145901_))))
  (define std/srfi/160/s64#s64vector-copy__1
    (lambda (_vec145903_ _start145904_)
      (let ((_end145906_ (s64vector-length _vec145903_)))
        (std/srfi/160/s64#s64vector-copy__%
         _vec145903_
         _start145904_
         _end145906_))))
  (define std/srfi/160/s64#s64vector-copy
    (lambda _g299303_
      (let ((_g299302_ (let () (declare (not safe)) (##length _g299303_))))
        (cond ((let () (declare (not safe)) (##fx= _g299302_ 1))
               (apply std/srfi/160/s64#s64vector-copy__0 _g299303_))
              ((let () (declare (not safe)) (##fx= _g299302_ 2))
               (apply std/srfi/160/s64#s64vector-copy__1 _g299303_))
              ((let () (declare (not safe)) (##fx= _g299302_ 3))
               (apply std/srfi/160/s64#s64vector-copy__% _g299303_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-copy
                _g299303_))))))
  (define std/srfi/160/s64#s64vector-copy!
    (lambda (_to145863_ _at145865_ _from145867_ _start145869_ _end145871_)
      (declare (not safe))
      (begin
        (if (s64vector? _to145863_) '#!void (error '"Bad argument" _to145863_))
        (if (s64vector? _from145867_)
            '#!void
            (error '"Bad argument" _from145867_))
        (if (and (fixnum? _at145865_)
                 (fx<= '0 _at145865_ (fx- (s64vector-length _at145865_) '1)))
            '#!void
            (error '"Index out of range" _to145863_ _at145865_))
        (if (and (fixnum? _start145869_)
                 (fx<= '0
                       _start145869_
                       (fx- (s64vector-length _from145867_) '1)))
            '#!void
            (error '"Index out of range" _from145867_ _start145869_))
        (if (and (fixnum? _end145871_)
                 (fx<= _start145869_
                       _end145871_
                       (s64vector-length _from145867_)))
            '#!void
            (error '"Index out of range" _from145867_ _end145871_))
        (if (fx<= (fx- _end145871_ _start145869_)
                  (fx- (s64vector-length _to145863_) _at145865_))
            '#!void
            (error '"Destination area too small"
                   _to145863_
                   _at145865_
                   _from145867_
                   _start145869_
                   _end145871_))
        (let _lp145875_ ((_i145878_ _start145869_) (_j145880_ _at145865_))
          (if (fx< _i145878_ _end145871_)
              (begin
                (s64vector-set!
                 _to145863_
                 _j145880_
                 (s64vector-ref _from145867_ _i145878_))
                (_lp145875_ (fx+ _i145878_ '1) (fx+ _j145880_ '1)))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-reverse-copy__%
    (lambda (_vec145835_ _start145837_ _end145839_)
      (let ((_v145842_ (make-s64vector (fx- _end145839_ _start145837_))))
        (std/srfi/160/s64#s64vector-reverse-copy!
         _v145842_
         '0
         _vec145835_
         _start145837_
         _end145839_)
        _v145842_)))
  (define std/srfi/160/s64#s64vector-reverse-copy__0
    (lambda (_vec145848_)
      (let* ((_start145850_ '0) (_end145852_ (s64vector-length _vec145848_)))
        (std/srfi/160/s64#s64vector-reverse-copy__%
         _vec145848_
         _start145850_
         _end145852_))))
  (define std/srfi/160/s64#s64vector-reverse-copy__1
    (lambda (_vec145854_ _start145855_)
      (let ((_end145857_ (s64vector-length _vec145854_)))
        (std/srfi/160/s64#s64vector-reverse-copy__%
         _vec145854_
         _start145855_
         _end145857_))))
  (define std/srfi/160/s64#s64vector-reverse-copy
    (lambda _g299305_
      (let ((_g299304_ (let () (declare (not safe)) (##length _g299305_))))
        (cond ((let () (declare (not safe)) (##fx= _g299304_ 1))
               (apply std/srfi/160/s64#s64vector-reverse-copy__0 _g299305_))
              ((let () (declare (not safe)) (##fx= _g299304_ 2))
               (apply std/srfi/160/s64#s64vector-reverse-copy__1 _g299305_))
              ((let () (declare (not safe)) (##fx= _g299304_ 3))
               (apply std/srfi/160/s64#s64vector-reverse-copy__% _g299305_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-reverse-copy
                _g299305_))))))
  (define std/srfi/160/s64#s64vector-reverse-copy!
    (lambda (_to145814_ _at145816_ _from145818_ _start145820_ _end145822_)
      (declare (not safe))
      (begin
        (if (s64vector? _to145814_) '#!void (error '"Bad argument" _to145814_))
        (if (s64vector? _from145818_)
            '#!void
            (error '"Bad argument" _from145818_))
        (if (and (fixnum? _at145816_)
                 (fx<= '0 _at145816_ (fx- (s64vector-length _at145816_) '1)))
            '#!void
            (error '"Index out of range" _to145814_ _at145816_))
        (if (and (fixnum? _start145820_)
                 (fx<= '0
                       _start145820_
                       (fx- (s64vector-length _from145818_) '1)))
            '#!void
            (error '"Index out of range" _from145818_ _start145820_))
        (if (and (fixnum? _end145822_)
                 (fx<= _start145820_
                       _end145822_
                       (s64vector-length _from145818_)))
            '#!void
            (error '"Index out of range" _from145818_ _end145822_))
        (if (fx<= (fx- _end145822_ _start145820_)
                  (fx- (s64vector-length _to145814_) _at145816_))
            '#!void
            (error '"Destination area too small"
                   _to145814_
                   _at145816_
                   _from145818_
                   _start145820_
                   _end145822_))
        (let _lp145826_ ((_i145829_ (fx- _end145822_ '1))
                         (_j145831_ _at145816_))
          (if (fx>= _i145829_ _start145820_)
              (begin
                (s64vector-set!
                 _to145814_
                 _j145831_
                 (s64vector-ref _from145818_ _i145829_))
                (_lp145826_ (fx- _i145829_ '1) (fx+ _j145831_ '1)))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-append
    (lambda _args145811_
      (std/srfi/160/s64#s64vector-concatenate _args145811_)))
  (define std/srfi/160/s64#s64vector-concatenate
    (lambda (_lst145751_)
      (let* ((_len145759_
              (foldl1 (lambda (_v145754_ _r145756_)
                        (fx+ (s64vector-length _v145754_) _r145756_))
                      '0
                      _lst145751_))
             (_v145762_ (make-s64vector _len145759_)))
        (declare (not safe))
        (let _lp145766_ ((_rest145769_ _lst145751_) (_at145771_ '0))
          (let* ((_rest145773145781_ _rest145769_)
                 (_else145775145789_ (lambda () _v145762_))
                 (_K145777145799_
                  (lambda (_rest145792_ _u145793_)
                    (let ((_ulen145796_ (s64vector-length _u145793_)))
                      (std/srfi/160/s64#s64vector-copy!
                       _v145762_
                       _at145771_
                       _u145793_
                       '0
                       _ulen145796_)
                      (_lp145766_
                       _rest145792_
                       (fx+ _at145771_ _ulen145796_))))))
            (if (##pair? _rest145773145781_)
                (let ((_hd145778145802_ (##car _rest145773145781_))
                      (_tl145779145804_ (##cdr _rest145773145781_)))
                  (let* ((_u145807_ _hd145778145802_)
                         (_rest145809_ _tl145779145804_))
                    (_K145777145799_ _rest145809_ _u145807_)))
                (_else145775145789_)))))))
  (define std/srfi/160/s64#s64vector-append-subvectors
    (lambda _args145623_
      (let* ((_len145684_
              (let _lp145626_ ((_rest145629_ _args145623_) (_r145631_ '0))
                (let* ((_rest145633145645_ _rest145629_)
                       (_else145635145653_ (lambda () _r145631_))
                       (_K145637145662_
                        (lambda (_rest145656_ _end145657_ _start145659_)
                          (_lp145626_
                           _rest145656_
                           (fx+ _r145631_ (fx- _end145657_ _start145659_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest145633145645_))
                      (let ((_tl145639145665_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest145633145645_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl145639145665_))
                            (let ((_hd145640145668_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl145639145665_)))
                                  (_tl145641145670_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl145639145665_))))
                              (let ((_start145673_ _hd145640145668_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl145641145670_))
                                    (let ((_hd145642145675_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl145641145670_)))
                                          (_tl145643145677_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl145641145670_))))
                                      (let* ((_end145680_ _hd145642145675_)
                                             (_rest145682_ _tl145643145677_))
                                        (_K145637145662_
                                         _rest145682_
                                         _end145680_
                                         _start145673_)))
                                    (_else145635145653_))))
                            (_else145635145653_)))
                      (_else145635145653_)))))
             (_v145687_ (make-s64vector _len145684_)))
        (let _lp145691_ ((_rest145693_ _args145623_) (_at145694_ '0))
          (let* ((_rest145696145708_ _rest145693_)
                 (_else145698145716_ (lambda () _v145687_))
                 (_K145700145725_
                  (lambda (_rest145719_ _end145720_ _start145721_ _u145722_)
                    (std/srfi/160/s64#s64vector-copy!
                     _v145687_
                     _at145694_
                     _u145722_
                     _start145721_
                     _end145720_)
                    (_lp145691_
                     _rest145719_
                     (fx+ _at145694_ (fx- _end145720_ _start145721_))))))
            (if (let () (declare (not safe)) (##pair? _rest145696145708_))
                (let ((_hd145701145728_
                       (let ()
                         (declare (not safe))
                         (##car _rest145696145708_)))
                      (_tl145702145730_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest145696145708_))))
                  (let ((_u145733_ _hd145701145728_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl145702145730_))
                        (let ((_hd145703145735_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl145702145730_)))
                              (_tl145704145737_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl145702145730_))))
                          (let ((_start145740_ _hd145703145735_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl145704145737_))
                                (let ((_hd145705145742_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl145704145737_)))
                                      (_tl145706145744_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl145704145737_))))
                                  (let* ((_end145747_ _hd145705145742_)
                                         (_rest145749_ _tl145706145744_))
                                    (_K145700145725_
                                     _rest145749_
                                     _end145747_
                                     _start145740_
                                     _u145733_)))
                                (_else145698145716_))))
                        (_else145698145716_))))
                (_else145698145716_)))))))
  (define std/srfi/160/s64#s64vector-empty?
    (lambda (_v145620_) (fxzero? (s64vector-length _v145620_))))
  (define std/srfi/160/s64#s64vector=
    (lambda (_v145562_ . _args145564_)
      (declare (not safe))
      (begin
        (if (s64vector? _v145562_) '#!void (error '"Bad argument" _v145562_))
        (let ((_vlen145568_ (s64vector-length _v145562_)))
          (let _lp145571_ ((_rest145574_ _args145564_))
            (let* ((_rest145576145584_ _rest145574_)
                   (_else145578145592_ (lambda () '#t))
                   (_K145580145608_
                    (lambda (_rest145595_ _u145596_)
                      (if (s64vector? _u145596_)
                          '#!void
                          (error '"Bad argument" _u145596_))
                      (let ((_ulen145599_ (s64vector-length _u145596_)))
                        (if (fx= _vlen145568_ _ulen145599_)
                            (let _cmp145602_ ((_i145605_ '0))
                              (if (fx< _i145605_ _vlen145568_)
                                  (if (= (s64vector-ref _v145562_ _i145605_)
                                         (s64vector-ref _u145596_ _i145605_))
                                      (_cmp145602_ (fx+ _i145605_ '1))
                                      '#f)
                                  (_lp145571_ _rest145595_)))
                            '#f)))))
              (if (##pair? _rest145576145584_)
                  (let ((_hd145581145611_ (##car _rest145576145584_))
                        (_tl145582145613_ (##cdr _rest145576145584_)))
                    (let* ((_u145616_ _hd145581145611_)
                           (_rest145618_ _tl145582145613_))
                      (_K145580145608_ _rest145618_ _u145616_)))
                  (_else145578145592_))))))))
  (define std/srfi/160/s64#s64vector-take
    (lambda (_v145554_ _n145556_)
      (let ((_u145559_ (make-s64vector _n145556_)))
        (std/srfi/160/s64#s64vector-copy! _u145559_ '0 _v145554_ '0 _n145556_)
        _u145559_)))
  (define std/srfi/160/s64#s64vector-take-right
    (lambda (_v145539_ _n145541_)
      (let* ((_vlen145544_ (s64vector-length _v145539_))
             (_ulen145547_ (fx- _vlen145544_ _n145541_))
             (_u145550_ (make-s64vector _ulen145547_)))
        (std/srfi/160/s64#s64vector-copy!
         _u145550_
         '0
         _v145539_
         _n145541_
         _vlen145544_)
        _u145550_)))
  (define std/srfi/160/s64#s64vector-drop
    (lambda (_v145524_ _n145526_)
      (let* ((_vlen145529_ (s64vector-length _v145524_))
             (_ulen145532_ (fx- _vlen145529_ _n145526_))
             (_u145535_ (make-s64vector _ulen145532_)))
        (std/srfi/160/s64#s64vector-copy!
         _u145535_
         '0
         _v145524_
         _n145526_
         _vlen145529_)
        _u145535_)))
  (define std/srfi/160/s64#s64vector-drop-right
    (lambda (_v145509_ _n145511_)
      (let* ((_vlen145514_ (s64vector-length _v145509_))
             (_ulen145517_ (fx- _vlen145514_ _n145511_))
             (_u145520_ (make-s64vector _ulen145517_)))
        (std/srfi/160/s64#s64vector-copy!
         _u145520_
         '0
         _v145509_
         '0
         _ulen145517_)
        _u145520_)))
  (define std/srfi/160/s64#s64vector-segment
    (lambda (_v145491_ _n145493_)
      (let _lp145496_ ((_i145499_ '0)
                       (_rest145501_ (s64vector-length _v145491_))
                       (_r145503_ '()))
        (if (fx> _r145503_ '0)
            (let ((_size145506_ (fxmin _n145493_ _rest145501_)))
              (_lp145496_
               (fx+ _i145499_ _size145506_)
               (fx- _rest145501_ _size145506_)
               (cons (std/srfi/160/s64#s64vector-copy__%
                      _v145491_
                      _i145499_
                      (fx+ _i145499_ _size145506_))
                     _r145503_)))
            (reverse _r145503_)))))
  (define std/srfi/160/s64#s64vector-fold__0
    (lambda (_kons145451_ _knil145453_ _v145455_)
      (if (procedure? _kons145451_)
          '#!void
          (error '"Bad argument; expected procedure" _kons145451_))
      (let ((_end145458_ (s64vector-length _v145455_)))
        (declare (not safe))
        (let _lp145462_ ((_i145465_ '0) (_r145467_ _knil145453_))
          (if (fx< _i145465_ _end145458_)
              (_lp145462_
               (fx+ _i145465_ '1)
               (_kons145451_ _r145467_ (s64vector-ref _v145455_ _i145465_)))
              _r145467_)))))
  (define std/srfi/160/s64#s64vector-fold__1
    (lambda (_kons145470_ _knil145471_ _v145472_ . _vs145473_)
      (if (procedure? _kons145470_)
          '#!void
          (error '"Bad argument; expected procedure" _kons145470_))
      (let* ((_vs145476_ (cons _v145472_ _vs145473_))
             (_end145478_ (apply fxmin (map s64vector-length _vs145476_))))
        (declare (not safe))
        (let _lp145482_ ((_i145484_ '0) (_r145485_ _knil145471_))
          (if (fx< _i145484_ _end145478_)
              (_lp145482_
               (fx+ _i145484_ '1)
               (apply _kons145470_
                      _r145485_
                      (map (lambda (_g145486145488_)
                             (s64vector-ref _g145486145488_ _i145484_))
                           _vs145476_)))
              _r145485_)))))
  (define std/srfi/160/s64#s64vector-fold
    (lambda _g299307_
      (let ((_g299306_ (let () (declare (not safe)) (##length _g299307_))))
        (cond ((let () (declare (not safe)) (##fx= _g299306_ 3))
               (apply std/srfi/160/s64#s64vector-fold__0 _g299307_))
              ((let () (declare (not safe)) (##fx>= _g299306_ 3))
               (apply std/srfi/160/s64#s64vector-fold__1 _g299307_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-fold
                _g299307_))))))
  (define std/srfi/160/s64#s64vector-fold-right__0
    (lambda (_kons145411_ _knil145413_ _v145415_)
      (if (procedure? _kons145411_)
          '#!void
          (error '"Bad argument; expected procedure" _kons145411_))
      (let ((_last145418_ (fx- (s64vector-length _v145415_) '1)))
        (declare (not safe))
        (let _lp145422_ ((_i145425_ _last145418_) (_r145427_ _knil145413_))
          (if (fx>= _i145425_ '0)
              (_lp145422_
               (fx- _i145425_ '1)
               (_kons145411_ _r145427_ (s64vector-ref _v145415_ _i145425_)))
              _r145427_)))))
  (define std/srfi/160/s64#s64vector-fold-right__1
    (lambda (_kons145430_ _knil145431_ _v145432_ . _vs145433_)
      (if (procedure? _kons145430_)
          '#!void
          (error '"Bad argument; expected procedure" _kons145430_))
      (let* ((_vs145436_ (cons _v145432_ _vs145433_))
             (_last145438_
              (fx- (apply min (map s64vector-length _vs145436_)) '1)))
        (declare (not safe))
        (let _lp145442_ ((_i145444_ _last145438_) (_r145445_ _knil145431_))
          (if (fx>= _i145444_ '0)
              (_lp145442_
               (fx- _i145444_ '1)
               (apply _kons145430_
                      _r145445_
                      (map (lambda (_g145446145448_)
                             (s64vector-ref _g145446145448_ _i145444_))
                           _vs145436_)))
              _r145445_)))))
  (define std/srfi/160/s64#s64vector-fold-right
    (lambda _g299309_
      (let ((_g299308_ (let () (declare (not safe)) (##length _g299309_))))
        (cond ((let () (declare (not safe)) (##fx= _g299308_ 3))
               (apply std/srfi/160/s64#s64vector-fold-right__0 _g299309_))
              ((let () (declare (not safe)) (##fx>= _g299308_ 3))
               (apply std/srfi/160/s64#s64vector-fold-right__1 _g299309_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-fold-right
                _g299309_))))))
  (define std/srfi/160/s64#s64vector-map__0
    (lambda (_f145371_ _v145373_)
      (if (procedure? _f145371_)
          '#!void
          (error '"Bad argument; expected procedure" _f145371_))
      (let* ((_len145376_ (s64vector-length _v145373_))
             (_u145379_ (make-s64vector _len145376_)))
        (declare (not safe))
        (let _lp145384_ ((_i145387_ '0))
          (if (fx< _i145387_ _len145376_)
              (begin
                (s64vector-set!
                 _u145379_
                 _i145387_
                 (s64vector-ref _v145373_ _i145387_))
                (_lp145384_ (fx+ _i145387_ '1)))
              _u145379_)))))
  (define std/srfi/160/s64#s64vector-map__1
    (lambda (_f145390_ _v145391_ . _vs145392_)
      (if (procedure? _f145390_)
          '#!void
          (error '"Bad argument; expected procedure" _f145390_))
      (let* ((_vs145395_ (cons _v145391_ _vs145392_))
             (_len145397_ (apply fxmin (map s64vector-length _vs145395_)))
             (_u145399_ (make-s64vector _len145397_)))
        (declare (not safe))
        (let _lp145403_ ((_i145405_ '0))
          (if (fx< _i145405_ _len145397_)
              (begin
                (s64vector-set!
                 _u145399_
                 _i145405_
                 (apply _f145390_
                        (map (lambda (_g145406145408_)
                               (s64vector-ref _g145406145408_ _i145405_))
                             _vs145395_)))
                (_lp145403_ (fx+ _i145405_ '1)))
              _u145399_)))))
  (define std/srfi/160/s64#s64vector-map
    (lambda _g299311_
      (let ((_g299310_ (let () (declare (not safe)) (##length _g299311_))))
        (cond ((let () (declare (not safe)) (##fx= _g299310_ 2))
               (apply std/srfi/160/s64#s64vector-map__0 _g299311_))
              ((let () (declare (not safe)) (##fx>= _g299310_ 2))
               (apply std/srfi/160/s64#s64vector-map__1 _g299311_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-map
                _g299311_))))))
  (define std/srfi/160/s64#s64vector-map!__0
    (lambda (_f145337_ _v145339_)
      (if (procedure? _f145337_)
          '#!void
          (error '"Bad argument; expected procedure" _f145337_))
      (let ((_len145342_ (s64vector-length _v145339_)))
        (declare (not safe))
        (let _lp145346_ ((_i145349_ '0))
          (if (fx< _i145349_ _len145342_)
              (begin
                (s64vector-set!
                 _v145339_
                 _i145349_
                 (_f145337_ (s64vector-ref _v145339_ _i145349_)))
                (_lp145346_ (fx+ _i145349_ '1)))
              _v145339_)))))
  (define std/srfi/160/s64#s64vector-map!__1
    (lambda (_f145352_ _v145353_ . _vs145354_)
      (if (procedure? _f145352_)
          '#!void
          (error '"Bad argument; expected procedure" _f145352_))
      (let* ((_vs145357_ (cons _v145353_ _vs145354_))
             (_len145359_ (apply fxmin (map s64vector-length _vs145357_))))
        (declare (not safe))
        (let _lp145363_ ((_i145365_ '0))
          (if (fx< _i145365_ _len145359_)
              (begin
                (s64vector-set!
                 _v145353_
                 _i145365_
                 (apply _f145352_
                        (map (lambda (_g145366145368_)
                               (s64vector-ref _g145366145368_ _i145365_))
                             _vs145357_)))
                (_lp145363_ (fx+ _i145365_ '1)))
              _v145353_)))))
  (define std/srfi/160/s64#s64vector-map!
    (lambda _g299313_
      (let ((_g299312_ (let () (declare (not safe)) (##length _g299313_))))
        (cond ((let () (declare (not safe)) (##fx= _g299312_ 2))
               (apply std/srfi/160/s64#s64vector-map!__0 _g299313_))
              ((let () (declare (not safe)) (##fx>= _g299312_ 2))
               (apply std/srfi/160/s64#s64vector-map!__1 _g299313_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-map!
                _g299313_))))))
  (define std/srfi/160/s64#s64vector-for-each__0
    (lambda (_f145303_ _v145305_)
      (if (procedure? _f145303_)
          '#!void
          (error '"Bad argument; expected procedure" _f145303_))
      (let ((_len145308_ (s64vector-length _v145305_)))
        (declare (not safe))
        (let _lp145312_ ((_i145315_ '0))
          (if (fx< _i145315_ _len145308_)
              (begin
                (_f145303_ (s64vector-ref _v145305_ _i145315_))
                (_lp145312_ (fx+ _i145315_ '1)))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-for-each__1
    (lambda (_f145318_ _v145319_ . _vs145320_)
      (let* ((_vs145323_ (cons _v145319_ _vs145320_))
             (_len145325_ (apply fxmin (map s64vector-length _vs145323_))))
        (declare (not safe))
        (let _lp145329_ ((_i145331_ '0))
          (if (fx< _i145331_ _len145325_)
              (begin
                (apply _f145318_
                       (map (lambda (_g145332145334_)
                              (s64vector-ref _g145332145334_ _i145331_))
                            _vs145323_))
                (_lp145329_ (fx+ _i145331_ '1)))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-for-each
    (lambda _g299315_
      (let ((_g299314_ (let () (declare (not safe)) (##length _g299315_))))
        (cond ((let () (declare (not safe)) (##fx= _g299314_ 2))
               (apply std/srfi/160/s64#s64vector-for-each__0 _g299315_))
              ((let () (declare (not safe)) (##fx>= _g299314_ 2))
               (apply std/srfi/160/s64#s64vector-for-each__1 _g299315_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-for-each
                _g299315_))))))
  (define std/srfi/160/s64#s64vector-count__0
    (lambda (_pred145266_ _v145268_)
      (if (procedure? _pred145266_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145266_))
      (let ((_end145271_ (s64vector-length _v145268_)))
        (declare (not safe))
        (let _lp145275_ ((_i145278_ '0) (_r145280_ '0))
          (if (fx< _i145278_ _end145271_)
              (if (_pred145266_ (s64vector-ref _v145268_ _i145278_))
                  (_lp145275_ (fx+ _i145278_ '1) (fx+ _r145280_ '1))
                  (_lp145275_ (fx+ _i145278_ '1) _r145280_))
              _r145280_)))))
  (define std/srfi/160/s64#s64vector-count__1
    (lambda (_pred145283_ _v145284_ . _vs145285_)
      (if (procedure? _pred145283_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145283_))
      (let* ((_vs145288_ (cons _v145284_ _vs145285_))
             (_end145290_ (apply fxmin (map s64vector-length _vs145288_))))
        (declare (not safe))
        (let _lp145294_ ((_i145296_ '0) (_r145297_ '0))
          (if (fx< _i145296_ _end145290_)
              (if (apply _pred145283_
                         (map (lambda (_g145298145300_)
                                (s64vector-ref _g145298145300_ _i145296_))
                              _vs145288_))
                  (_lp145294_ (fx+ _i145296_ '1) (fx+ _r145297_ '1))
                  (_lp145294_ (fx+ _i145296_ '1) _r145297_))
              _r145297_)))))
  (define std/srfi/160/s64#s64vector-count
    (lambda _g299317_
      (let ((_g299316_ (let () (declare (not safe)) (##length _g299317_))))
        (cond ((let () (declare (not safe)) (##fx= _g299316_ 2))
               (apply std/srfi/160/s64#s64vector-count__0 _g299317_))
              ((let () (declare (not safe)) (##fx>= _g299316_ 2))
               (apply std/srfi/160/s64#s64vector-count__1 _g299317_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-count
                _g299317_))))))
  (define std/srfi/160/s64#s64vector-cumulate
    (lambda (_f145241_ _knil145243_ _v145245_)
      (if (procedure? _f145241_)
          '#!void
          (error '"Bad argument; expected procedure" _f145241_))
      (let* ((_len145248_ (s64vector-length _v145245_))
             (_r145251_ (make-s64vector _len145248_)))
        (declare (not safe))
        (let _lp145256_ ((_i145259_ '0) (_r145261_ _knil145243_))
          (if (fx< _i145259_ _len145248_)
              (let ((_next145263_
                     (_f145241_
                      _r145261_
                      (s64vector-ref _v145245_ _i145259_))))
                (s64vector-set! _v145245_ _i145259_ _next145263_)
                (_lp145256_ (fx+ _i145259_ '1) _next145263_))
              _v145245_)))))
  (define std/srfi/160/s64#s64vector-take-while
    (lambda (_pred145224_ _v145226_)
      (let* ((_len145229_ (s64vector-length _v145226_))
             (_idx145232_
              (std/srfi/160/s64#s64vector-skip__0 _pred145224_ _v145226_))
             (_idx145238_
              (let ((_$e145235_ _idx145232_))
                (if _$e145235_ _$e145235_ _len145229_))))
        (std/srfi/160/s64#s64vector-copy__% _v145226_ '0 _idx145238_))))
  (define std/srfi/160/s64#s64vector-take-while-right
    (lambda (_pred145210_ _v145212_)
      (let* ((_len145215_ (s64vector-length _v145212_))
             (_idx145218_
              (std/srfi/160/s64#s64vector-skip-right__0
               _pred145210_
               _v145212_))
             (_idx145221_ (if _idx145218_ (fx+ _idx145218_ '1) '0)))
        (std/srfi/160/s64#s64vector-copy__%
         _v145212_
         _idx145221_
         _len145215_))))
  (define std/srfi/160/s64#s64vector-drop-while
    (lambda (_pred145193_ _v145195_)
      (let* ((_len145198_ (s64vector-length _v145195_))
             (_idx145201_
              (std/srfi/160/s64#s64vector-skip__0 _pred145193_ _v145195_))
             (_idx145207_
              (let ((_$e145204_ _idx145201_))
                (if _$e145204_ _$e145204_ _len145198_))))
        (std/srfi/160/s64#s64vector-copy__%
         _v145195_
         _idx145207_
         _len145198_))))
  (define std/srfi/160/s64#s64vector-drop-while-right
    (lambda (_pred145179_ _v145181_)
      (let* ((_len145184_ (s64vector-length _v145181_))
             (_idx145187_
              (std/srfi/160/s64#s64vector-skip-right__0
               _pred145179_
               _v145181_))
             (_idx145190_ (if _idx145187_ (fx+ _idx145187_ '1) '0)))
        (std/srfi/160/s64#s64vector-copy__% _v145181_ '0 _idx145190_))))
  (define std/srfi/160/s64#s64vector-index__0
    (lambda (_pred145145_ _v145147_)
      (if (procedure? _pred145145_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145145_))
      (let ((_end145150_ (s64vector-length _v145147_)))
        (declare (not safe))
        (let _lp145154_ ((_i145157_ '0))
          (if (fx< _i145157_ _end145150_)
              (if (_pred145145_ (s64vector-ref _v145147_ _i145157_))
                  _i145157_
                  (_lp145154_ (fx+ _i145157_ '1)))
              '#f)))))
  (define std/srfi/160/s64#s64vector-index__1
    (lambda (_pred145160_ _v145161_ . _vs145162_)
      (if (procedure? _pred145160_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145160_))
      (let* ((_vs145165_ (cons _v145161_ _vs145162_))
             (_end145167_ (apply fxmin (map s64vector-length _vs145165_))))
        (declare (not safe))
        (let _lp145171_ ((_i145173_ '0))
          (if (fx< _i145173_ _end145167_)
              (if (apply _pred145160_
                         (map (lambda (_g145174145176_)
                                (s64vector-ref _g145174145176_ _i145173_))
                              _vs145165_))
                  _i145173_
                  (_lp145171_ (fx+ _i145173_ '1)))
              '#f)))))
  (define std/srfi/160/s64#s64vector-index
    (lambda _g299319_
      (let ((_g299318_ (let () (declare (not safe)) (##length _g299319_))))
        (cond ((let () (declare (not safe)) (##fx= _g299318_ 2))
               (apply std/srfi/160/s64#s64vector-index__0 _g299319_))
              ((let () (declare (not safe)) (##fx>= _g299318_ 2))
               (apply std/srfi/160/s64#s64vector-index__1 _g299319_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-index
                _g299319_))))))
  (define std/srfi/160/s64#s64vector-index-right__0
    (lambda (_pred145111_ _v145113_)
      (if (procedure? _pred145111_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145111_))
      (let ((_start145116_ (fx- (s64vector-length _v145113_) '1)))
        (declare (not safe))
        (let _lp145120_ ((_i145123_ _start145116_))
          (if (fx>= _i145123_ '0)
              (if (_pred145111_ (s64vector-ref _v145113_ _i145123_))
                  _i145123_
                  (_lp145120_ (fx- _i145123_ '1)))
              '#f)))))
  (define std/srfi/160/s64#s64vector-index-right__1
    (lambda (_pred145126_ _v145127_ . _vs145128_)
      (if (procedure? _pred145126_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145126_))
      (let* ((_vs145131_ (cons _v145127_ _vs145128_))
             (_start145133_
              (fx- (apply fxmin (map s64vector-length _vs145131_)) '1)))
        (declare (not safe))
        (let _lp145137_ ((_i145139_ _start145133_))
          (if (fx>= _i145139_ '0)
              (if (apply _pred145126_
                         (map (lambda (_g145140145142_)
                                (s64vector-ref _g145140145142_ _i145139_))
                              _vs145131_))
                  _i145139_
                  (_lp145137_ (fx- _i145139_ '1)))
              '#f)))))
  (define std/srfi/160/s64#s64vector-index-right
    (lambda _g299321_
      (let ((_g299320_ (let () (declare (not safe)) (##length _g299321_))))
        (cond ((let () (declare (not safe)) (##fx= _g299320_ 2))
               (apply std/srfi/160/s64#s64vector-index-right__0 _g299321_))
              ((let () (declare (not safe)) (##fx>= _g299320_ 2))
               (apply std/srfi/160/s64#s64vector-index-right__1 _g299321_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-index-right
                _g299321_))))))
  (define std/srfi/160/s64#s64vector-skip__0
    (lambda (_pred145095_ _v145097_)
      (std/srfi/160/s64#s64vector-index__0
       (lambda (_$obj145100_) (not (_pred145095_ _$obj145100_)))
       _v145097_)))
  (define std/srfi/160/s64#s64vector-skip__1
    (lambda (_pred145103_ _v145104_ . _vs145105_)
      (apply std/srfi/160/s64#s64vector-index
             (lambda (_$obj145108_) (not (_pred145103_ _$obj145108_)))
             _v145104_
             _vs145105_)))
  (define std/srfi/160/s64#s64vector-skip
    (lambda _g299323_
      (let ((_g299322_ (let () (declare (not safe)) (##length _g299323_))))
        (cond ((let () (declare (not safe)) (##fx= _g299322_ 2))
               (apply std/srfi/160/s64#s64vector-skip__0 _g299323_))
              ((let () (declare (not safe)) (##fx>= _g299322_ 2))
               (apply std/srfi/160/s64#s64vector-skip__1 _g299323_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-skip
                _g299323_))))))
  (define std/srfi/160/s64#s64vector-skip-right__0
    (lambda (_pred145079_ _v145081_)
      (std/srfi/160/s64#s64vector-index-right__0
       (lambda (_$obj145084_) (not (_pred145079_ _$obj145084_)))
       _v145081_)))
  (define std/srfi/160/s64#s64vector-skip-right__1
    (lambda (_pred145087_ _v145088_ . _vs145089_)
      (apply std/srfi/160/s64#s64vector-index-right
             (lambda (_$obj145092_) (not (_pred145087_ _$obj145092_)))
             _v145088_
             _vs145089_)))
  (define std/srfi/160/s64#s64vector-skip-right
    (lambda _g299325_
      (let ((_g299324_ (let () (declare (not safe)) (##length _g299325_))))
        (cond ((let () (declare (not safe)) (##fx= _g299324_ 2))
               (apply std/srfi/160/s64#s64vector-skip-right__0 _g299325_))
              ((let () (declare (not safe)) (##fx>= _g299324_ 2))
               (apply std/srfi/160/s64#s64vector-skip-right__1 _g299325_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-skip-right
                _g299325_))))))
  (define std/srfi/160/s64#s64vector-any__0
    (lambda (_pred145039_ _v145041_)
      (if (procedure? _pred145039_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145039_))
      (let ((_end145044_ (s64vector-length _v145041_)))
        (declare (not safe))
        (let _lp145048_ ((_i145051_ '0))
          (if (fx< _i145051_ _end145044_)
              (let ((_$e145054_
                     (_pred145039_ (s64vector-ref _v145041_ _i145051_))))
                (if _$e145054_
                    (values _$e145054_)
                    (_lp145048_ (fx+ _i145051_ '1))))
              '#f)))))
  (define std/srfi/160/s64#s64vector-any__1
    (lambda (_pred145057_ _v145058_ . _vs145059_)
      (if (procedure? _pred145057_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145057_))
      (let* ((_v145062_ (cons _v145058_ _vs145059_))
             (_end145064_ (apply fxmin (map s64vector-length _vs145059_))))
        (declare (not safe))
        (let _lp145068_ ((_i145070_ '0))
          (if (fx< _i145070_ _end145064_)
              (let ((_$e145076_
                     (apply _pred145057_
                            (map (lambda (_g145071145073_)
                                   (s64vector-ref _g145071145073_ _i145070_))
                                 _vs145059_))))
                (if _$e145076_
                    (values _$e145076_)
                    (_lp145068_ (fx+ _i145070_ '1))))
              '#f)))))
  (define std/srfi/160/s64#s64vector-any
    (lambda _g299327_
      (let ((_g299326_ (let () (declare (not safe)) (##length _g299327_))))
        (cond ((let () (declare (not safe)) (##fx= _g299326_ 2))
               (apply std/srfi/160/s64#s64vector-any__0 _g299327_))
              ((let () (declare (not safe)) (##fx>= _g299326_ 2))
               (apply std/srfi/160/s64#s64vector-any__1 _g299327_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-any
                _g299327_))))))
  (define std/srfi/160/s64#s64vector-every__0
    (lambda (_pred144988_ _v144990_)
      (if (procedure? _pred144988_)
          '#!void
          (error '"Bad argument; expected procedure" _pred144988_))
      (let ((_end144993_ (s64vector-length _v144990_)))
        (declare (not safe))
        (let _lp144997_ ((_i145000_ '0) (_r145002_ '#t))
          (if (fx< _i145000_ _end144993_)
              (let ((_$e145005_
                     (_pred144988_ (s64vector-ref _v144990_ _i145000_))))
                (if _$e145005_
                    ((lambda (_g145007145009_)
                       (_lp144997_ (fx+ _i145000_ '1) _g145007145009_))
                     _$e145005_)
                    '#f))
              _r145002_)))))
  (define std/srfi/160/s64#s64vector-every__1
    (lambda (_pred145012_ _v145013_ . _vs145014_)
      (if (procedure? _pred145012_)
          '#!void
          (error '"Bad argument; expected procedure" _pred145012_))
      (let* ((_v145017_ (cons _v145013_ _vs145014_))
             (_end145019_ (apply fxmin (map s64vector-length _vs145014_))))
        (declare (not safe))
        (let _lp145023_ ((_i145025_ '0) (_r145026_ '#t))
          (if (fx< _i145025_ _end145019_)
              (let ((_$e145032_
                     (apply _pred145012_
                            (map (lambda (_g145027145029_)
                                   (s64vector-ref _g145027145029_ _i145025_))
                                 _vs145014_))))
                (if _$e145032_
                    ((lambda (_g145034145036_)
                       (_lp145023_ (fx+ _i145025_ '1) _g145034145036_))
                     _$e145032_)
                    '#f))
              _r145026_)))))
  (define std/srfi/160/s64#s64vector-every
    (lambda _g299329_
      (let ((_g299328_ (let () (declare (not safe)) (##length _g299329_))))
        (cond ((let () (declare (not safe)) (##fx= _g299328_ 2))
               (apply std/srfi/160/s64#s64vector-every__0 _g299329_))
              ((let () (declare (not safe)) (##fx>= _g299328_ 2))
               (apply std/srfi/160/s64#s64vector-every__1 _g299329_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-every
                _g299329_))))))
  (define std/srfi/160/s64#s64vector-partition
    (lambda (_pred144959_ _v144961_)
      (let* ((_count144964_
              (std/srfi/160/s64#s64vector-count__0 _pred144959_ _v144961_))
             (_len144967_ (s64vector-length _v144961_))
             (_u144970_ (make-s64vector _len144967_)))
        (declare (not safe))
        (let _lp144975_ ((_i144978_ '0)
                         (_left144980_ '0)
                         (_right144982_ _count144964_))
          (if (fx< _i144978_ _len144967_)
              (let ((_x144985_ (s64vector-ref _v144961_ _i144978_)))
                (if (_pred144959_ _x144985_)
                    (begin
                      (s64vector-set! _u144970_ _left144980_ _x144985_)
                      (_lp144975_
                       (fx+ _i144978_ '1)
                       (fx+ _left144980_ '1)
                       _right144982_))
                    (begin
                      (s64vector-set! _u144970_ _right144982_ _x144985_)
                      (_lp144975_
                       (fx+ _i144978_ '1)
                       _left144980_
                       (fx+ _right144982_ '1)))))
              _u144970_)))))
  (define std/srfi/160/s64#s64vector-filter
    (lambda (_pred144932_ _v144934_)
      (let* ((_count144937_
              (std/srfi/160/s64#s64vector-count__0 _pred144932_ _v144934_))
             (_u144940_ (make-s64vector _count144937_))
             (_end144943_ (s64vector-length _v144934_)))
        (declare (not safe))
        (let _lp144948_ ((_i144951_ '0) (_j144953_ '0))
          (if (fx< _i144951_ _end144943_)
              (let ((_x144956_ (s64vector-ref _v144934_ _i144951_)))
                (if (_pred144932_ _x144956_)
                    (begin
                      (s64vector-set! _u144940_ _j144953_ _x144956_)
                      (_lp144948_ (fx+ _i144951_ '1) (fx+ _j144953_ '1)))
                    (_lp144948_ (fx+ _i144951_ '1) _j144953_)))
              _u144940_)))))
  (define std/srfi/160/s64#s64vector-remove
    (lambda (_pred144924_ _v144926_)
      (std/srfi/160/s64#s64vector-filter
       (lambda (_$obj144929_) (not (_pred144924_ _$obj144929_)))
       _v144926_)))
  (define std/srfi/160/s64#s64vector-swap
    (lambda (_v144911_ _i144913_ _j144915_)
      (let ((_iv144918_ (s64vector-ref _v144911_ _i144913_))
            (_jv144920_ (s64vector-ref _v144911_ _j144915_)))
        (declare (not safe))
        (begin
          (s64vector-set! _v144911_ _i144913_ _jv144920_)
          (s64vector-set! _v144911_ _j144915_ _iv144918_)))))
  (define std/srfi/160/s64#s64vector-fill!__%
    (lambda (_v144874_ _fill144876_ _start144878_ _end144880_)
      (declare (not safe))
      (begin
        (if (s64vector? _v144874_) '#!void (error '"Bad argument" _v144874_))
        (if (std/srfi/160/base#s64? _fill144876_)
            '#!void
            (error '"Bad argument" _fill144876_))
        (if (and (fixnum? _start144878_)
                 (fx<= '0 _start144878_ (fx- (s64vector-length _v144874_) '1)))
            '#!void
            (error '"Index out of range" _start144878_))
        (if (and (fixnum? _end144880_)
                 (fx<= _start144878_ _end144880_ (s64vector-length _v144874_)))
            '#!void
            (error '"Index out of range" _end144880_))
        (let _lp144884_ ((_i144887_ _start144878_))
          (if (fx< _i144887_ _end144880_)
              (begin
                (s64vector-set! _v144874_ _i144887_ _fill144876_)
                (_lp144884_ (fx+ _i144887_ '1)))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-fill!__0
    (lambda (_v144893_ _fill144894_)
      (let* ((_start144896_ '0) (_end144898_ (s64vector-length _v144893_)))
        (std/srfi/160/s64#s64vector-fill!__%
         _v144893_
         _fill144894_
         _start144896_
         _end144898_))))
  (define std/srfi/160/s64#s64vector-fill!__1
    (lambda (_v144900_ _fill144901_ _start144902_)
      (let ((_end144904_ (s64vector-length _v144900_)))
        (std/srfi/160/s64#s64vector-fill!__%
         _v144900_
         _fill144901_
         _start144902_
         _end144904_))))
  (define std/srfi/160/s64#s64vector-fill!
    (lambda _g299331_
      (let ((_g299330_ (let () (declare (not safe)) (##length _g299331_))))
        (cond ((let () (declare (not safe)) (##fx= _g299330_ 2))
               (apply std/srfi/160/s64#s64vector-fill!__0 _g299331_))
              ((let () (declare (not safe)) (##fx= _g299330_ 3))
               (apply std/srfi/160/s64#s64vector-fill!__1 _g299331_))
              ((let () (declare (not safe)) (##fx= _g299330_ 4))
               (apply std/srfi/160/s64#s64vector-fill!__% _g299331_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-fill!
                _g299331_))))))
  (define std/srfi/160/s64#s64vector-reverse!__%
    (lambda (_v144834_ _start144836_ _end144838_)
      (declare (not safe))
      (begin
        (if (s64vector? _v144834_) '#!void (error '"Bad argument" _v144834_))
        (if (and (fixnum? _start144836_)
                 (fx<= '0 _start144836_ (fx- (s64vector-length _v144834_) '1)))
            '#!void
            (error '"Index out of range" _start144836_))
        (if (and (fixnum? _end144838_)
                 (fx<= _start144836_ _end144838_ (s64vector-length _v144834_)))
            '#!void
            (error '"Index out of range" _end144838_))
        (let _lp144842_ ((_i144845_ _start144836_)
                         (_j144847_ (fx- _end144838_ '1)))
          (if (fx< _i144845_ _j144847_)
              (let ((_iv144850_ (s64vector-ref _v144834_ _i144845_))
                    (_jv144852_ (s64vector-ref _v144834_ _j144847_)))
                (s64vector-set! _v144834_ _i144845_ _jv144852_)
                (s64vector-set! _v144834_ _j144847_ _iv144850_)
                (_lp144842_ (fx+ _i144845_ '1) (fx- _j144847_ '1)))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-reverse!__0
    (lambda (_v144858_)
      (let* ((_start144860_ '0) (_end144862_ (s64vector-length _v144858_)))
        (std/srfi/160/s64#s64vector-reverse!__%
         _v144858_
         _start144860_
         _end144862_))))
  (define std/srfi/160/s64#s64vector-reverse!__1
    (lambda (_v144864_ _start144865_)
      (let ((_end144867_ (s64vector-length _v144864_)))
        (std/srfi/160/s64#s64vector-reverse!__%
         _v144864_
         _start144865_
         _end144867_))))
  (define std/srfi/160/s64#s64vector-reverse!
    (lambda _g299333_
      (let ((_g299332_ (let () (declare (not safe)) (##length _g299333_))))
        (cond ((let () (declare (not safe)) (##fx= _g299332_ 1))
               (apply std/srfi/160/s64#s64vector-reverse!__0 _g299333_))
              ((let () (declare (not safe)) (##fx= _g299332_ 2))
               (apply std/srfi/160/s64#s64vector-reverse!__1 _g299333_))
              ((let () (declare (not safe)) (##fx= _g299332_ 3))
               (apply std/srfi/160/s64#s64vector-reverse!__% _g299333_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector-reverse!
                _g299333_))))))
  (define std/srfi/160/s64#s64vector-unfold!
    (lambda (_f144809_ _v144811_ _start144813_ _end144815_ _seed144817_)
      (declare (not safe))
      (begin
        (if (procedure? _f144809_)
            '#!void
            (error '"Bad argument; expected procedure" _f144809_))
        (if (s64vector? _v144811_) '#!void (error '"Bad argument" _v144811_))
        (if (and (fixnum? _start144813_)
                 (fx<= '0 _start144813_ (fx- (s64vector-length _v144811_) '1)))
            '#!void
            (error '"Index out of range" _start144813_))
        (if (and (fixnum? _end144815_)
                 (fx<= _start144813_ _end144815_ (s64vector-length _v144811_)))
            '#!void
            (error '"Index out of range" _end144815_))
        (let _lp144821_ ((_i144824_ _start144813_)
                         (_state144826_ _seed144817_))
          (if (fx< _i144824_ _end144815_)
              (let ((_g299334_ (_f144809_ _state144826_)))
                (begin
                  (let ((_g299335_
                         (if (##values? _g299334_)
                             (##vector-length _g299334_)
                             1)))
                    (if (not (##fx= _g299335_ 2))
                        (error "Context expects 2 values" _g299335_)))
                  (let ((_x144829_ (##vector-ref _g299334_ 0))
                        (_state144831_ (##vector-ref _g299334_ 1)))
                    (begin
                      (s64vector-set! _v144811_ _i144824_ _x144829_)
                      (_lp144821_ (fx+ _i144824_ '1) _state144831_)))))
              '#!void)))))
  (define std/srfi/160/s64#s64vector-unfold-right!
    (lambda (_f144785_ _v144787_ _start144789_ _end144791_ _seed144793_)
      (declare (not safe))
      (begin
        (if (procedure? _f144785_)
            '#!void
            (error '"Bad argument; expected procedure" _f144785_))
        (if (s64vector? _v144787_) '#!void (error '"Bad argument" _v144787_))
        (if (and (fixnum? _start144789_)
                 (fx<= '0 _start144789_ (fx- (s64vector-length _v144787_) '1)))
            '#!void
            (error '"Index out of range" _start144789_))
        (if (and (fixnum? _end144791_)
                 (fx<= _start144789_ _end144791_ (s64vector-length _v144787_)))
            '#!void
            (error '"Index out of range" _end144791_))
        (let _lp144797_ ((_i144800_ (fx- _end144791_ '1))
                         (_state144802_ _seed144793_))
          (if (fx>= _i144800_ _start144789_)
              (let ((_g299336_ (_f144785_ _state144802_)))
                (begin
                  (let ((_g299337_
                         (if (##values? _g299336_)
                             (##vector-length _g299336_)
                             1)))
                    (if (not (##fx= _g299337_ 2))
                        (error "Context expects 2 values" _g299337_)))
                  (let ((_x144805_ (##vector-ref _g299336_ 0))
                        (_state144807_ (##vector-ref _g299336_ 1)))
                    (begin
                      (s64vector-set! _v144787_ _i144800_ _x144805_)
                      (_lp144797_ (fx- _i144800_ '1) _state144807_)))))
              '#!void)))))
  (define std/srfi/160/s64#reverse-s64vector->list__%
    (lambda (_v144751_ _start144753_ _end144755_)
      (declare (not safe))
      (begin
        (if (s64vector? _v144751_) '#!void (error '"Bad argument" _v144751_))
        (if (and (fixnum? _start144753_)
                 (fx<= '0 _start144753_ (fx- (s64vector-length _v144751_) '1)))
            '#!void
            (error '"Index out of range" _start144753_))
        (if (and (fixnum? _end144755_)
                 (fx<= _start144753_ _end144755_ (s64vector-length _v144751_)))
            '#!void
            (error '"Index out of range" _end144755_))
        (let _lp144759_ ((_i144762_ _start144753_) (_r144764_ '()))
          (if (fx< _i144762_ _end144755_)
              (_lp144759_
               (fx+ _i144762_ '1)
               (cons (s64vector-ref _v144751_ _i144762_) _r144764_))
              _r144764_)))))
  (define std/srfi/160/s64#reverse-s64vector->list__0
    (lambda (_v144770_)
      (let* ((_start144772_ '0) (_end144774_ (s64vector-length _v144770_)))
        (std/srfi/160/s64#reverse-s64vector->list__%
         _v144770_
         _start144772_
         _end144774_))))
  (define std/srfi/160/s64#reverse-s64vector->list__1
    (lambda (_v144776_ _start144777_)
      (let ((_end144779_ (s64vector-length _v144776_)))
        (std/srfi/160/s64#reverse-s64vector->list__%
         _v144776_
         _start144777_
         _end144779_))))
  (define std/srfi/160/s64#reverse-s64vector->list
    (lambda _g299339_
      (let ((_g299338_ (let () (declare (not safe)) (##length _g299339_))))
        (cond ((let () (declare (not safe)) (##fx= _g299338_ 1))
               (apply std/srfi/160/s64#reverse-s64vector->list__0 _g299339_))
              ((let () (declare (not safe)) (##fx= _g299338_ 2))
               (apply std/srfi/160/s64#reverse-s64vector->list__1 _g299339_))
              ((let () (declare (not safe)) (##fx= _g299338_ 3))
               (apply std/srfi/160/s64#reverse-s64vector->list__% _g299339_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#reverse-s64vector->list
                _g299339_))))))
  (define std/srfi/160/s64#reverse-list->s64vector
    (lambda (_lst144697_)
      (let* ((_len144700_ (length _lst144697_))
             (_v144703_ (make-s64vector _len144700_)))
        (declare (not safe))
        (let _lp144708_ ((_rest144711_ _lst144697_) (_i144713_ '0))
          (let* ((_rest144715144723_ _rest144711_)
                 (_else144717144731_ (lambda () _v144703_))
                 (_K144719144738_
                  (lambda (_rest144734_ _x144735_)
                    (if (std/srfi/160/base#s64? _x144735_)
                        '#!void
                        (error '"Bad element" _x144735_))
                    (s64vector-set! _v144703_ _i144713_ _x144735_)
                    (_lp144708_ _rest144734_ (fx+ _i144713_ '1)))))
            (if (##pair? _rest144715144723_)
                (let ((_hd144720144741_ (##car _rest144715144723_))
                      (_tl144721144743_ (##cdr _rest144715144723_)))
                  (let* ((_x144746_ _hd144720144741_)
                         (_rest144748_ _tl144721144743_))
                    (_K144719144738_ _rest144748_ _x144746_)))
                (_else144717144731_)))))))
  (define std/srfi/160/s64#s64vector->vector__%
    (lambda (_v144658_ _start144660_ _end144662_)
      (declare (not safe))
      (begin
        (if (s64vector? _v144658_) '#!void (error '"Bad argument" _v144658_))
        (if (and (fixnum? _start144660_)
                 (fx<= '0 _start144660_ (fx- (s64vector-length _v144658_) '1)))
            '#!void
            (error '"Index out of range" _start144660_))
        (if (and (fixnum? _end144662_)
                 (fx<= _start144660_ _end144662_ (s64vector-length _v144658_)))
            '#!void
            (error '"Index out of range" _end144662_))
        (let* ((_len144666_ (s64vector-length _v144658_))
               (_u144669_ (make-vector _len144666_)))
          (let _lp144673_ ((_i144676_ '0))
            (if (fx< _i144676_ _len144666_)
                (begin
                  (vector-set!
                   _u144669_
                   _i144676_
                   (s64vector-ref _v144658_ _i144676_))
                  (_lp144673_ (fx+ _i144676_ '1)))
                _u144669_))))))
  (define std/srfi/160/s64#s64vector->vector__0
    (lambda (_v144682_)
      (let* ((_start144684_ '0) (_end144686_ (s64vector-length _v144682_)))
        (std/srfi/160/s64#s64vector->vector__%
         _v144682_
         _start144684_
         _end144686_))))
  (define std/srfi/160/s64#s64vector->vector__1
    (lambda (_v144688_ _start144689_)
      (let ((_end144691_ (s64vector-length _v144688_)))
        (std/srfi/160/s64#s64vector->vector__%
         _v144688_
         _start144689_
         _end144691_))))
  (define std/srfi/160/s64#s64vector->vector
    (lambda _g299341_
      (let ((_g299340_ (let () (declare (not safe)) (##length _g299341_))))
        (cond ((let () (declare (not safe)) (##fx= _g299340_ 1))
               (apply std/srfi/160/s64#s64vector->vector__0 _g299341_))
              ((let () (declare (not safe)) (##fx= _g299340_ 2))
               (apply std/srfi/160/s64#s64vector->vector__1 _g299341_))
              ((let () (declare (not safe)) (##fx= _g299340_ 3))
               (apply std/srfi/160/s64#s64vector->vector__% _g299341_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#s64vector->vector
                _g299341_))))))
  (define std/srfi/160/s64#vector->s64vector__%
    (lambda (_v144618_ _start144620_ _end144622_)
      (declare (not safe))
      (begin
        (if (vector? _v144618_)
            '#!void
            (error '"Bad argument; expected vector" _v144618_))
        (if (and (fixnum? _start144620_)
                 (fx<= '0 _start144620_ (fx- (vector-length _v144618_) '1)))
            '#!void
            (error '"Index out of range" _start144620_))
        (if (and (fixnum? _end144622_)
                 (fx<= _start144620_ _end144622_ (vector-length _v144618_)))
            '#!void
            (error '"Index out of range" _end144622_))
        (let* ((_len144626_ (vector-length _v144618_))
               (_u144629_ (make-s64vector _len144626_)))
          (let _lp144633_ ((_i144636_ '0))
            (if (fx< _i144636_ _len144626_)
                (begin
                  (s64vector-set!
                   _u144629_
                   _i144636_
                   (vector-ref _v144618_ _i144636_))
                  (_lp144633_ (fx+ _i144636_ '1)))
                _u144629_))))))
  (define std/srfi/160/s64#vector->s64vector__0
    (lambda (_v144642_)
      (let* ((_start144644_ '0) (_end144646_ (vector-length _v144642_)))
        (std/srfi/160/s64#vector->s64vector__%
         _v144642_
         _start144644_
         _end144646_))))
  (define std/srfi/160/s64#vector->s64vector__1
    (lambda (_v144648_ _start144649_)
      (let ((_end144651_ (vector-length _v144648_)))
        (std/srfi/160/s64#vector->s64vector__%
         _v144648_
         _start144649_
         _end144651_))))
  (define std/srfi/160/s64#vector->s64vector
    (lambda _g299343_
      (let ((_g299342_ (let () (declare (not safe)) (##length _g299343_))))
        (cond ((let () (declare (not safe)) (##fx= _g299342_ 1))
               (apply std/srfi/160/s64#vector->s64vector__0 _g299343_))
              ((let () (declare (not safe)) (##fx= _g299342_ 2))
               (apply std/srfi/160/s64#vector->s64vector__1 _g299343_))
              ((let () (declare (not safe)) (##fx= _g299342_ 3))
               (apply std/srfi/160/s64#vector->s64vector__% _g299343_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#vector->s64vector
                _g299343_))))))
  (define std/srfi/160/s64#make-s64vector-generator__%
    (lambda (_v144584_ _start144586_ _end144588_)
      (declare (not safe))
      (begin
        (if (s64vector? _v144584_) '#!void (error '"Bad argument" _v144584_))
        (if (and (fixnum? _start144586_)
                 (fx<= '0 _start144586_ (fx- (s64vector-length _v144584_) '1)))
            '#!void
            (error '"Index out of range" _start144586_))
        (if (and (fixnum? _end144588_)
                 (fx<= _start144586_ _end144588_ (s64vector-length _v144584_)))
            '#!void
            (error '"Index out of range" _end144588_))
        (let ((_i144592_ _start144586_))
          (lambda ()
            (if (fx< _i144592_ _end144588_)
                (let ((_next144596_ (s64vector-ref _v144584_ _i144592_)))
                  (set! _i144592_ (fx+ _i144592_ '1))
                  _next144596_)
                '#!eof))))))
  (define std/srfi/160/s64#make-s64vector-generator__0
    (lambda (_v144602_)
      (let* ((_start144604_ '0) (_end144606_ (s64vector-length _v144602_)))
        (std/srfi/160/s64#make-s64vector-generator__%
         _v144602_
         _start144604_
         _end144606_))))
  (define std/srfi/160/s64#make-s64vector-generator__1
    (lambda (_v144608_ _start144609_)
      (let ((_end144611_ (s64vector-length _v144608_)))
        (std/srfi/160/s64#make-s64vector-generator__%
         _v144608_
         _start144609_
         _end144611_))))
  (define std/srfi/160/s64#make-s64vector-generator
    (lambda _g299345_
      (let ((_g299344_ (let () (declare (not safe)) (##length _g299345_))))
        (cond ((let () (declare (not safe)) (##fx= _g299344_ 1))
               (apply std/srfi/160/s64#make-s64vector-generator__0 _g299345_))
              ((let () (declare (not safe)) (##fx= _g299344_ 2))
               (apply std/srfi/160/s64#make-s64vector-generator__1 _g299345_))
              ((let () (declare (not safe)) (##fx= _g299344_ 3))
               (apply std/srfi/160/s64#make-s64vector-generator__% _g299345_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#make-s64vector-generator
                _g299345_))))))
  (define std/srfi/160/s64#s64vector-comparator
    (let ()
      (letrec ((_<?144555_
                (lambda (_a144558_ _b144560_)
                  (let ((_len-a144563_ (s64vector-length _a144558_))
                        (_len-b144565_ (s64vector-length _b144560_)))
                    (declare (not safe))
                    (if (fx< _len-a144563_ _len-b144565_)
                        '#t
                        (if (fx> _len-a144563_ _len-b144565_)
                            '#f
                            (let ((_end144569_ _len-a144563_))
                              (let _lp144572_ ((_i144575_ '0))
                                (if (fx< _i144575_ _end144569_)
                                    (let ((_x144578_
                                           (s64vector-ref _a144558_ _i144575_))
                                          (_y144580_
                                           (s64vector-ref
                                            _b144560_
                                            _i144575_)))
                                      (if (< _x144578_ _y144580_)
                                          '#t
                                          (if (> _x144578_ _y144580_)
                                              '#f
                                              (_lp144572_
                                               (fx+ _i144575_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           s64vector?
           std/srfi/160/s64#s64vector=
           _<?144555_
           equal?-hash)))))
  (define std/srfi/160/s64#write-s64vector__%
    (lambda (_v144532_ _port144534_)
      (let ((_$e144537_ (find-method _v144532_ ':write)))
        (if _$e144537_
            ((lambda (_g144539144541_)
               (_g144539144541_ _v144532_ _port144534_))
             _$e144537_)
            (write _v144532_ (current-output-port))))))
  (define std/srfi/160/s64#write-s64vector__0
    (lambda (_v144547_)
      (let ((_port144549_ (current-output-port)))
        (std/srfi/160/s64#write-s64vector__% _v144547_ _port144549_))))
  (define std/srfi/160/s64#write-s64vector
    (lambda _g299347_
      (let ((_g299346_ (let () (declare (not safe)) (##length _g299347_))))
        (cond ((let () (declare (not safe)) (##fx= _g299346_ 1))
               (apply std/srfi/160/s64#write-s64vector__0 _g299347_))
              ((let () (declare (not safe)) (##fx= _g299346_ 2))
               (apply std/srfi/160/s64#write-s64vector__% _g299347_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s64#write-s64vector
                _g299347_)))))))
