(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/41#stream-type
    (make-struct-type
     'std/srfi/41#stream-type
     '#f
     '1
     'stream-type
     '((fields: box))
     '#f))
  (define std/srfi/41#stream? (make-struct-predicate std/srfi/41#stream-type))
  (define std/srfi/41#stream-promise
    (make-struct-field-accessor std/srfi/41#stream-type '0))
  (define std/srfi/41#stream-promise!
    (make-struct-field-mutator std/srfi/41#stream-type '0))
  (define std/srfi/41#make-stream
    (lambda (_box65733_)
      (make-struct-instance std/srfi/41#stream-type _box65733_)))
  (define std/srfi/41#stream-eager
    (lambda (_expr65731_)
      (let ((__tmp294802 (cons 'eager _expr65731_)))
        (declare (not safe))
        (##structure std/srfi/41#stream-type __tmp294802))))
  (define std/srfi/41#stream-force
    (lambda (_promise65719_)
      (let* ((_content65721_
              (##structure-ref _promise65719_ '1 std/srfi/41#stream-type '#f))
             (_$e65723_ (car _content65721_)))
        (if (eq? 'eager _$e65723_)
            (cdr _content65721_)
            (if (eq? 'lazy _$e65723_)
                (let* ((_promise*65726_ ((cdr _content65721_)))
                       (_content65728_
                        (##structure-ref
                         _promise65719_
                         '1
                         std/srfi/41#stream-type
                         '#f)))
                  (if (not (eqv? (car _content65728_) 'eager))
                      (begin
                        (set-car!
                         _content65728_
                         (car (##structure-ref
                               _promise*65726_
                               '1
                               std/srfi/41#stream-type
                               '#f)))
                        (set-cdr!
                         _content65728_
                         (cdr (##structure-ref
                               _promise*65726_
                               '1
                               std/srfi/41#stream-type
                               '#f)))
                        (##structure-set!
                         _promise*65726_
                         _content65728_
                         '1
                         std/srfi/41#stream-type
                         '#f))
                      '#!void)
                  (std/srfi/41#stream-force _promise65719_))
                '#!void)))))
  (define std/srfi/41#stream-null
    (let ((__tmp294803
           (cons 'lazy
                 (lambda () (std/srfi/41#stream-eager (cons 'stream 'null))))))
      (declare (not safe))
      (##structure std/srfi/41#stream-type __tmp294803)))
  (define std/srfi/41#stream-pare-type
    (make-struct-type
     'std/srfi/41#stream-pare-type
     '#f
     '2
     'stream-pare-type
     '((fields: kar kdr))
     '#f))
  (define std/srfi/41#stream-pare?
    (make-struct-predicate std/srfi/41#stream-pare-type))
  (define std/srfi/41#stream-kar
    (make-struct-field-accessor std/srfi/41#stream-pare-type '0))
  (define std/srfi/41#stream-kdr
    (make-struct-field-accessor std/srfi/41#stream-pare-type '1))
  (define std/srfi/41#make-stream-pare
    (lambda (_kar65715_ _kdr65716_)
      (make-struct-instance
       std/srfi/41#stream-pare-type
       _kar65715_
       _kdr65716_)))
  (define std/srfi/41#stream-pair?
    (lambda (_obj65713_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj65713_ 'std/srfi/41#stream-type))
          (let ((__tmp294804 (std/srfi/41#stream-force _obj65713_)))
            (declare (not safe))
            (##structure-instance-of?
             __tmp294804
             'std/srfi/41#stream-pare-type))
          '#f)))
  (define std/srfi/41#stream-null?
    (lambda (_obj65711_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj65711_ 'std/srfi/41#stream-type))
          (eqv? (std/srfi/41#stream-force _obj65711_)
                (std/srfi/41#stream-force std/srfi/41#stream-null))
          '#f)))
  (define std/srfi/41#stream-car
    (lambda (_strm65709_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65709_
                  'std/srfi/41#stream-type)))
          (error 'stream-car '"non-stream")
          (if (std/srfi/41#stream-null? _strm65709_)
              (error 'stream-car '"null stream")
              (std/srfi/41#stream-force
               (##structure-ref
                (std/srfi/41#stream-force _strm65709_)
                '1
                std/srfi/41#stream-pare-type
                '#f))))))
  (define std/srfi/41#stream-cdr
    (lambda (_strm65707_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65707_
                  'std/srfi/41#stream-type)))
          (error 'stream-cdr '"non-stream")
          (if (std/srfi/41#stream-null? _strm65707_)
              (error 'stream-cdr '"null stream")
              (##structure-ref
               (std/srfi/41#stream-force _strm65707_)
               '2
               std/srfi/41#stream-pare-type
               '#f)))))
  (define std/srfi/41#exists
    (lambda (_pred?65701_ . _lists65702_)
      (if (not (null? (car _lists65702_)))
          (let ((_$e65704_ (apply _pred?65701_ (map car _lists65702_))))
            (if _$e65704_
                _$e65704_
                (apply std/srfi/41#exists
                       _pred?65701_
                       (map cdr _lists65702_))))
          '#f)))
  (define std/srfi/41#list->stream
    (lambda (_objs65691_)
      (letrec ((_list->stream65693_
                (lambda (_objs65695_)
                  (let ((__tmp294805
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (null? _objs65695_)
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294808
                                               (let ((__tmp294809
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (car _objs65695_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294809)))
                                              (__tmp294806
                                               (let ((__tmp294807
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_list->stream65693_
                                                               (cdr _objs65695_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294807))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294808
                                           __tmp294806)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294805)))))
        (if (not (list? _objs65691_))
            (error 'list->stream '"non-list argument")
            (_list->stream65693_ _objs65691_)))))
  (define std/srfi/41#port->stream
    (lambda _port65677_
      (letrec ((_port->stream65679_
                (lambda (_p65683_)
                  (let ((__tmp294810
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (let ((_c65687_ (read-char _p65683_)))
                                     (if (eof-object? _c65687_)
                                         std/srfi/41#stream-null
                                         (std/srfi/41#stream-eager
                                          (let ((__tmp294813
                                                 (let ((__tmp294814
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (std/srfi/41#stream-eager
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _c65687_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294814)))
                                                (__tmp294811
                                                 (let ((__tmp294812
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (_port->stream65679_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _p65683_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294812))))
                                            (declare (not safe))
                                            (##structure
                                             std/srfi/41#stream-pare-type
                                             __tmp294813
                                             __tmp294811))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294810)))))
        (let ((_p65681_
               (if (null? _port65677_)
                   (current-input-port)
                   (car _port65677_))))
          (if (not (input-port? _p65681_))
              (error 'port->stream '"non-input-port argument")
              (_port->stream65679_ _p65681_))))))
  (define std/srfi/41#stream->list
    (lambda _args65664_
      (let ((_n65666_ (if (= '1 (length _args65664_)) '#f (car _args65664_)))
            (_strm65667_
             (if (= '1 (length _args65664_))
                 (car _args65664_)
                 (cadr _args65664_))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65667_
                    'std/srfi/41#stream-type)))
            (error 'stream->list '"non-stream argument")
            (if (and _n65666_ (not (integer? _n65666_)))
                (error 'stream->list '"non-integer count")
                (if (and _n65666_ (negative? _n65666_))
                    (error 'stream->list '"negative count")
                    (let _loop65669_ ((_n65671_ (if _n65666_ _n65666_ '-1))
                                      (_strm65672_ _strm65667_))
                      (if (or (zero? _n65671_)
                              (std/srfi/41#stream-null? _strm65672_))
                          '()
                          (cons (std/srfi/41#stream-car _strm65672_)
                                (_loop65669_
                                 (- _n65671_ '1)
                                 (std/srfi/41#stream-cdr _strm65672_)))))))))))
  (define std/srfi/41#stream-append
    (lambda _strms65652_
      (letrec ((_stream-append65654_
                (lambda (_strms65658_)
                  (let ((__tmp294815
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (null? (cdr _strms65658_))
                                       (car _strms65658_)
                                       (if (std/srfi/41#stream-null?
                                            (car _strms65658_))
                                           (_stream-append65654_
                                            (cdr _strms65658_))
                                           (std/srfi/41#stream-eager
                                            (let ((__tmp294818
                                                   (let ((__tmp294819
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (std/srfi/41#stream-eager
                           (std/srfi/41#stream-car (car _strms65658_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294819)))
                                                  (__tmp294816
                                                   (let ((__tmp294817
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (_stream-append65654_
                           (cons (std/srfi/41#stream-cdr (car _strms65658_))
                                 (cdr _strms65658_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294817))))
                                              (declare (not safe))
                                              (##structure
                                               std/srfi/41#stream-pare-type
                                               __tmp294818
                                               __tmp294816))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294815)))))
        (if (null? _strms65652_)
            std/srfi/41#stream-null
            (if (std/srfi/41#exists
                 (lambda (_x65656_)
                   (not (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _x65656_
                           'std/srfi/41#stream-type))))
                 _strms65652_)
                (error 'stream-append '"non-stream argument")
                (_stream-append65654_ _strms65652_))))))
  (define std/srfi/41#stream-concat
    (lambda (_strms65640_)
      (letrec ((_stream-concat65642_
                (lambda (_strms65644_)
                  (let ((__tmp294820
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strms65644_)
                                       std/srfi/41#stream-null
                                       (if (not (let ((__tmp294821
                                                       (std/srfi/41#stream-car
                                                        _strms65644_)))
                                                  (declare (not safe))
                                                  (##structure-instance-of?
                                                   __tmp294821
                                                   'std/srfi/41#stream-type)))
                                           (error 'stream-concat
                                                  '"non-stream object in input stream")
                                           (if (std/srfi/41#stream-null?
                                                (std/srfi/41#stream-car
                                                 _strms65644_))
                                               (_stream-concat65642_
                                                (std/srfi/41#stream-cdr
                                                 _strms65644_))
                                               (std/srfi/41#stream-eager
                                                (let ((__tmp294828
                                                       (let ((__tmp294829
                                                              (cons 'lazy
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (lambda ()
                              (std/srfi/41#stream-eager
                               (std/srfi/41#stream-car
                                (std/srfi/41#stream-car _strms65644_)))))))
                 (declare (not safe))
                 (##structure std/srfi/41#stream-type __tmp294829)))
              (__tmp294822
               (let ((__tmp294823
                      (cons 'lazy
                            (lambda ()
                              (_stream-concat65642_
                               (std/srfi/41#stream-eager
                                (let ((__tmp294826
                                       (let ((__tmp294827
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-eager
                                                       (std/srfi/41#stream-cdr
                                                        (std/srfi/41#stream-car
                                                         _strms65644_)))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294827)))
                                      (__tmp294824
                                       (let ((__tmp294825
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-cdr
                                                       _strms65644_)))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294825))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/41#stream-pare-type
                                   __tmp294826
                                   __tmp294824))))))))
                 (declare (not safe))
                 (##structure std/srfi/41#stream-type __tmp294823))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (declare (not safe))
                                                  (##structure
                                                   std/srfi/41#stream-pare-type
                                                   __tmp294828
                                                   __tmp294822)))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294820)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strms65640_
                    'std/srfi/41#stream-type)))
            (error 'stream-concat '"non-stream argument")
            (_stream-concat65642_ _strms65640_)))))
  (define std/srfi/41#stream-constant
    (lambda _objs65632_
      (let ((__tmp294830
             (cons 'lazy
                   (lambda ()
                     (let ()
                       (if (null? _objs65632_)
                           std/srfi/41#stream-null
                           (if (null? (cdr _objs65632_))
                               (std/srfi/41#stream-eager
                                (let ((__tmp294833
                                       (let ((__tmp294834
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-eager
                                                       (car _objs65632_))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294834)))
                                      (__tmp294831
                                       (let ((__tmp294832
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-constant
                                                       (car _objs65632_))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294832))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/41#stream-pare-type
                                   __tmp294833
                                   __tmp294831)))
                               (std/srfi/41#stream-eager
                                (let ((__tmp294837
                                       (let ((__tmp294838
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-eager
                                                       (car _objs65632_))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294838)))
                                      (__tmp294835
                                       (let ((__tmp294836
                                              (cons 'lazy
                                                    (lambda ()
                                                      (apply std/srfi/41#stream-constant
                                                             (append (cdr _objs65632_)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (list (car _objs65632_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294836))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/41#stream-pare-type
                                   __tmp294837
                                   __tmp294835))))))))))
        (declare (not safe))
        (##structure std/srfi/41#stream-type __tmp294830))))
  (define std/srfi/41#stream-drop
    (lambda (_n65619_ _strm65620_)
      (letrec ((_stream-drop65622_
                (lambda (_n65624_ _strm65625_)
                  (let ((__tmp294839
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (or (zero? _n65624_)
                                           (std/srfi/41#stream-null?
                                            _strm65625_))
                                       _strm65625_
                                       (_stream-drop65622_
                                        (- _n65624_ '1)
                                        (std/srfi/41#stream-cdr
                                         _strm65625_))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294839)))))
        (if (not (integer? _n65619_))
            (error 'stream-drop '"non-integer argument")
            (if (negative? _n65619_)
                (error 'stream-drop '"negative argument")
                (if (not (let ()
                           (declare (not safe))
                           (##structure-instance-of?
                            _strm65620_
                            'std/srfi/41#stream-type)))
                    (error 'stream-drop '"non-stream argument")
                    (_stream-drop65622_ _n65619_ _strm65620_)))))))
  (define std/srfi/41#stream-drop-while
    (lambda (_pred?65610_ _strm65611_)
      (letrec ((_stream-drop-while65613_
                (lambda (_strm65615_)
                  (let ((__tmp294840
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (and (std/srfi/41#stream-pair?
                                             _strm65615_)
                                            (_pred?65610_
                                             (std/srfi/41#stream-car
                                              _strm65615_)))
                                       (_stream-drop-while65613_
                                        (std/srfi/41#stream-cdr _strm65615_))
                                       _strm65615_))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294840)))))
        (if (not (procedure? _pred?65610_))
            (error 'stream-drop-while '"non-procedural argument")
            (if (not (let ()
                       (declare (not safe))
                       (##structure-instance-of?
                        _strm65611_
                        'std/srfi/41#stream-type)))
                (error 'stream-drop-while '"non-stream argument")
                (_stream-drop-while65613_ _strm65611_))))))
  (define std/srfi/41#stream-filter
    (lambda (_pred?65599_ _strm65600_)
      (letrec ((_stream-filter65602_
                (lambda (_strm65604_)
                  (let ((__tmp294841
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65604_)
                                       std/srfi/41#stream-null
                                       (if (_pred?65599_
                                            (std/srfi/41#stream-car
                                             _strm65604_))
                                           (std/srfi/41#stream-eager
                                            (let ((__tmp294844
                                                   (let ((__tmp294845
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (std/srfi/41#stream-eager
                           (std/srfi/41#stream-car _strm65604_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294845)))
                                                  (__tmp294842
                                                   (let ((__tmp294843
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (_stream-filter65602_
                           (std/srfi/41#stream-cdr _strm65604_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294843))))
                                              (declare (not safe))
                                              (##structure
                                               std/srfi/41#stream-pare-type
                                               __tmp294844
                                               __tmp294842)))
                                           (_stream-filter65602_
                                            (std/srfi/41#stream-cdr
                                             _strm65604_)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294841)))))
        (if (not (procedure? _pred?65599_))
            (error 'stream-filter '"non-procedural argument")
            (if (not (let ()
                       (declare (not safe))
                       (##structure-instance-of?
                        _strm65600_
                        'std/srfi/41#stream-type)))
                (error 'stream-filter '"non-stream argument")
                (_stream-filter65602_ _strm65600_))))))
  (define std/srfi/41#stream-fold
    (lambda (_proc65590_ _base65591_ _strm65592_)
      (if (not (procedure? _proc65590_))
          (error 'stream-fold '"non-procedural argument")
          (if (not (let ()
                     (declare (not safe))
                     (##structure-instance-of?
                      _strm65592_
                      'std/srfi/41#stream-type)))
              (error 'stream-fold '"non-stream argument")
              (let _loop65594_ ((_base65596_ _base65591_)
                                (_strm65597_ _strm65592_))
                (if (std/srfi/41#stream-null? _strm65597_)
                    _base65596_
                    (_loop65594_
                     (_proc65590_
                      _base65596_
                      (std/srfi/41#stream-car _strm65597_))
                     (std/srfi/41#stream-cdr _strm65597_))))))))
  (define std/srfi/41#stream-for-each
    (lambda (_proc65581_ . _strms65582_)
      (letrec ((_stream-for-each65584_
                (lambda (_strms65588_)
                  (if (not (std/srfi/41#exists
                            std/srfi/41#stream-null?
                            _strms65588_))
                      (begin
                        (apply _proc65581_
                               (map std/srfi/41#stream-car _strms65588_))
                        (_stream-for-each65584_
                         (map std/srfi/41#stream-cdr _strms65588_)))
                      '#!void))))
        (if (not (procedure? _proc65581_))
            (error 'stream-for-each '"non-procedural argument")
            (if (null? _strms65582_)
                (error 'stream-for-each '"no stream arguments")
                (if (std/srfi/41#exists
                     (lambda (_x65586_)
                       (not (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _x65586_
                               'std/srfi/41#stream-type))))
                     _strms65582_)
                    (error 'stream-for-each '"non-stream argument")
                    (_stream-for-each65584_ _strms65582_)))))))
  (define std/srfi/41#stream-from
    (lambda (_first65567_ . _step65568_)
      (letrec ((_stream-from65570_
                (lambda (_first65574_ _delta65575_)
                  (let ((__tmp294846
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (std/srfi/41#stream-eager
                                    (let ((__tmp294849
                                           (let ((__tmp294850
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (std/srfi/41#stream-eager
                                                           _first65574_)))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294850)))
                                          (__tmp294847
                                           (let ((__tmp294848
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (_stream-from65570_
                                                           (+ _first65574_
                                                              _delta65575_)
                                                           _delta65575_)))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294848))))
                                      (declare (not safe))
                                      (##structure
                                       std/srfi/41#stream-pare-type
                                       __tmp294849
                                       __tmp294847))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294846)))))
        (let ((_delta65572_ (if (null? _step65568_) '1 (car _step65568_))))
          (if (not (number? _first65567_))
              (error 'stream-from '"non-numeric starting number")
              (if (not (number? _delta65572_))
                  (error 'stream-from '"non-numeric step size")
                  (_stream-from65570_ _first65567_ _delta65572_)))))))
  (define std/srfi/41#stream-iterate
    (lambda (_proc65556_ _base65557_)
      (letrec ((_stream-iterate65559_
                (lambda (_base65561_)
                  (let ((__tmp294851
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (std/srfi/41#stream-eager
                                    (let ((__tmp294854
                                           (let ((__tmp294855
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (std/srfi/41#stream-eager
                                                           _base65561_)))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294855)))
                                          (__tmp294852
                                           (let ((__tmp294853
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (_stream-iterate65559_
                                                           (_proc65556_
                                                            _base65561_))))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294853))))
                                      (declare (not safe))
                                      (##structure
                                       std/srfi/41#stream-pare-type
                                       __tmp294854
                                       __tmp294852))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294851)))))
        (if (not (procedure? _proc65556_))
            (error 'stream-iterate '"non-procedural argument")
            (_stream-iterate65559_ _base65557_)))))
  (define std/srfi/41#stream-length
    (lambda (_strm65549_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65549_
                  'std/srfi/41#stream-type)))
          (error 'stream-length '"non-stream argument")
          (let _loop65551_ ((_len65553_ '0) (_strm65554_ _strm65549_))
            (if (std/srfi/41#stream-null? _strm65554_)
                _len65553_
                (_loop65551_
                 (+ _len65553_ '1)
                 (std/srfi/41#stream-cdr _strm65554_)))))))
  (define std/srfi/41#stream-map
    (lambda (_proc65536_ . _strms65537_)
      (letrec ((_stream-map65539_
                (lambda (_strms65543_)
                  (let ((__tmp294856
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#exists
                                        std/srfi/41#stream-null?
                                        _strms65543_)
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294859
                                               (let ((__tmp294860
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (apply _proc65536_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (map std/srfi/41#stream-car _strms65543_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294860)))
                                              (__tmp294857
                                               (let ((__tmp294858
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-map65539_
                                                               (map std/srfi/41#stream-cdr
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _strms65543_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294858))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294859
                                           __tmp294857)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294856)))))
        (if (not (procedure? _proc65536_))
            (error 'stream-map '"non-procedural argument")
            (if (null? _strms65537_)
                (error 'stream-map '"no stream arguments")
                (if (std/srfi/41#exists
                     (lambda (_x65541_)
                       (not (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _x65541_
                               'std/srfi/41#stream-type))))
                     _strms65537_)
                    (error 'stream-map '"non-stream argument")
                    (_stream-map65539_ _strms65537_)))))))
  (define std/srfi/41#stream-range
    (lambda (_first65517_ _past65518_ . _step65519_)
      (letrec ((_stream-range65521_
                (lambda (_first65527_ _past65528_ _delta65529_ _lt?65530_)
                  (let ((__tmp294861
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (_lt?65530_ _first65527_ _past65528_)
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294864
                                               (let ((__tmp294865
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               _first65527_)))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294865)))
                                              (__tmp294862
                                               (let ((__tmp294863
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-range65521_
                                                               (+ _first65527_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _delta65529_)
                       _past65528_
                       _delta65529_
                       _lt?65530_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294863))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294864
                                           __tmp294862)))
                                       std/srfi/41#stream-null))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294861)))))
        (if (not (number? _first65517_))
            (error 'stream-range '"non-numeric starting number")
            (if (not (number? _past65518_))
                (error 'stream-range '"non-numeric ending number")
                (let ((_delta65523_
                       (if (pair? _step65519_)
                           (car _step65519_)
                           (if (< _first65517_ _past65518_) '1 '-1))))
                  (if (not (number? _delta65523_))
                      (error 'stream-range '"non-numeric step size")
                      (let ((_lt?65525_ (if (< '0 _delta65523_) < >)))
                        (_stream-range65521_
                         _first65517_
                         _past65518_
                         _delta65523_
                         _lt?65525_)))))))))
  (define std/srfi/41#stream-ref
    (lambda (_strm65509_ _n65510_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65509_
                  'std/srfi/41#stream-type)))
          (error 'stream-ref '"non-stream argument")
          (if (not (integer? _n65510_))
              (error 'stream-ref '"non-integer argument")
              (if (negative? _n65510_)
                  (error 'stream-ref '"negative argument")
                  (let _loop65512_ ((_strm65514_ _strm65509_)
                                    (_n65515_ _n65510_))
                    (if (std/srfi/41#stream-null? _strm65514_)
                        (error 'stream-ref '"beyond end of stream")
                        (if (zero? _n65515_)
                            (std/srfi/41#stream-car _strm65514_)
                            (_loop65512_
                             (std/srfi/41#stream-cdr _strm65514_)
                             (- _n65515_ '1))))))))))
  (define std/srfi/41#stream-reverse
    (lambda (_strm65498_)
      (letrec ((_stream-reverse65500_
                (lambda (_strm65502_ _rev65503_)
                  (let ((__tmp294866
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65502_)
                                       _rev65503_
                                       (_stream-reverse65500_
                                        (std/srfi/41#stream-cdr _strm65502_)
                                        (std/srfi/41#stream-eager
                                         (let ((__tmp294869
                                                (let ((__tmp294870
                                                       (cons 'lazy
                                                             (lambda ()
                                                               (std/srfi/41#stream-eager
                                                                (std/srfi/41#stream-car
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _strm65502_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (declare (not safe))
                                                  (##structure
                                                   std/srfi/41#stream-type
                                                   __tmp294870)))
                                               (__tmp294867
                                                (let ((__tmp294868
                                                       (cons 'lazy
                                                             (lambda ()
                                                               _rev65503_))))
                                                  (declare (not safe))
                                                  (##structure
                                                   std/srfi/41#stream-type
                                                   __tmp294868))))
                                           (declare (not safe))
                                           (##structure
                                            std/srfi/41#stream-pare-type
                                            __tmp294869
                                            __tmp294867))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294866)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65498_
                    'std/srfi/41#stream-type)))
            (error 'stream-reverse '"non-stream argument")
            (_stream-reverse65500_ _strm65498_ std/srfi/41#stream-null)))))
  (define std/srfi/41#stream-scan
    (lambda (_proc65483_ _base65484_ _strm65485_)
      (letrec ((_stream-scan65487_
                (lambda (_base65489_ _strm65490_)
                  (let ((__tmp294871
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65490_)
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294874
                                               (let ((__tmp294875
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               _base65489_)))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294875)))
                                              (__tmp294872
                                               (let ((__tmp294873
                                                      (cons 'lazy
                                                            (lambda ()
                                                              std/srfi/41#stream-null))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294873))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294874
                                           __tmp294872)))
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294878
                                               (let ((__tmp294879
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               _base65489_)))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294879)))
                                              (__tmp294876
                                               (let ((__tmp294877
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-scan65487_
                                                               (_proc65483_
                                                                _base65489_
                                                                (std/srfi/41#stream-car
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _strm65490_))
                       (std/srfi/41#stream-cdr _strm65490_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294877))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294878
                                           __tmp294876)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294871)))))
        (if (not (procedure? _proc65483_))
            (error 'stream-scan '"non-procedural argument")
            (if (not (let ()
                       (declare (not safe))
                       (##structure-instance-of?
                        _strm65485_
                        'std/srfi/41#stream-type)))
                (error 'stream-scan '"non-stream argument")
                (_stream-scan65487_ _base65484_ _strm65485_))))))
  (define std/srfi/41#stream-take
    (lambda (_n65468_ _strm65469_)
      (letrec ((_stream-take65471_
                (lambda (_n65473_ _strm65474_)
                  (let ((__tmp294880
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (or (std/srfi/41#stream-null?
                                            _strm65474_)
                                           (zero? _n65473_))
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294883
                                               (let ((__tmp294884
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (std/srfi/41#stream-car
                                                                _strm65474_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294884)))
                                              (__tmp294881
                                               (let ((__tmp294882
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-take65471_
                                                               (- _n65473_ '1)
                                                               (std/srfi/41#stream-cdr
                                                                _strm65474_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294882))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294883
                                           __tmp294881)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294880)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65469_
                    'std/srfi/41#stream-type)))
            (error 'stream-take '"non-stream argument")
            (if (not (integer? _n65468_))
                (error 'stream-take '"non-integer argument")
                (if (negative? _n65468_)
                    (error 'stream-take '"negative argument")
                    (_stream-take65471_ _n65468_ _strm65469_)))))))
  (define std/srfi/41#stream-take-while
    (lambda (_pred?65457_ _strm65458_)
      (letrec ((_stream-take-while65460_
                (lambda (_strm65462_)
                  (let ((__tmp294885
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65462_)
                                       std/srfi/41#stream-null
                                       (if (_pred?65457_
                                            (std/srfi/41#stream-car
                                             _strm65462_))
                                           (std/srfi/41#stream-eager
                                            (let ((__tmp294888
                                                   (let ((__tmp294889
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (std/srfi/41#stream-eager
                           (std/srfi/41#stream-car _strm65462_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294889)))
                                                  (__tmp294886
                                                   (let ((__tmp294887
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (_stream-take-while65460_
                           (std/srfi/41#stream-cdr _strm65462_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294887))))
                                              (declare (not safe))
                                              (##structure
                                               std/srfi/41#stream-pare-type
                                               __tmp294888
                                               __tmp294886)))
                                           std/srfi/41#stream-null)))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294885)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65458_
                    'std/srfi/41#stream-type)))
            (error 'stream-take-while '"non-stream argument")
            (if (not (procedure? _pred?65457_))
                (error 'stream-take-while '"non-procedural argument")
                (_stream-take-while65460_ _strm65458_))))))
  (define std/srfi/41#stream-unfold
    (lambda (_mapper65444_ _pred?65445_ _generator65446_ _base65447_)
      (letrec ((_stream-unfold65449_
                (lambda (_base65451_)
                  (let ((__tmp294890
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (_pred?65445_ _base65451_)
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294893
                                               (let ((__tmp294894
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (_mapper65444_
                                                                _base65451_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294894)))
                                              (__tmp294891
                                               (let ((__tmp294892
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-unfold65449_
                                                               (_generator65446_
                                                                _base65451_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294892))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294893
                                           __tmp294891)))
                                       std/srfi/41#stream-null))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294890)))))
        (if (not (procedure? _mapper65444_))
            (error 'stream-unfold '"non-procedural mapper")
            (if (not (procedure? _pred?65445_))
                (error 'stream-unfold '"non-procedural pred?")
                (if (not (procedure? _generator65446_))
                    (error 'stream-unfold '"non-procedural generator")
                    (_stream-unfold65449_ _base65447_)))))))
  (define std/srfi/41#stream-unfolds
    (lambda (_gen65403_ _seed65404_)
      (letrec ((_len-values65406_
                (lambda (_gen65438_ _seed65439_)
                  (call-with-values
                   (lambda () (_gen65438_ _seed65439_))
                   (lambda _vs65442_ (- (length _vs65442_) '1)))))
               (_unfold-result-stream65407_
                (lambda (_gen65427_ _seed65428_)
                  (let ((__tmp294895
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (call-with-values
                                    (lambda () (_gen65427_ _seed65428_))
                                    (lambda (_next65433_ . _results65434_)
                                      (std/srfi/41#stream-eager
                                       (let ((__tmp294898
                                              (let ((__tmp294899
                                                     (cons 'lazy
                                                           (lambda ()
                                                             (std/srfi/41#stream-eager
                                                              _results65434_)))))
                                                (declare (not safe))
                                                (##structure
                                                 std/srfi/41#stream-type
                                                 __tmp294899)))
                                             (__tmp294896
                                              (let ((__tmp294897
                                                     (cons 'lazy
                                                           (lambda ()
                                                             (_unfold-result-stream65407_
                                                              _gen65427_
                                                              _next65433_)))))
                                                (declare (not safe))
                                                (##structure
                                                 std/srfi/41#stream-type
                                                 __tmp294897))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-pare-type
                                          __tmp294898
                                          __tmp294896))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294895))))
               (_result-stream->output-stream65408_
                (lambda (_result-stream65418_ _i65419_)
                  (let ((__tmp294900
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (let ((_result65423_
                                          (list-ref
                                           (std/srfi/41#stream-car
                                            _result-stream65418_)
                                           (- _i65419_ '1))))
                                     (if (pair? _result65423_)
                                         (std/srfi/41#stream-eager
                                          (let ((__tmp294903
                                                 (let ((__tmp294904
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (std/srfi/41#stream-eager
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (car _result65423_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294904)))
                                                (__tmp294901
                                                 (let ((__tmp294902
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (_result-stream->output-stream65408_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (std/srfi/41#stream-cdr _result-stream65418_)
                         _i65419_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294902))))
                                            (declare (not safe))
                                            (##structure
                                             std/srfi/41#stream-pare-type
                                             __tmp294903
                                             __tmp294901)))
                                         (if (not _result65423_)
                                             (_result-stream->output-stream65408_
                                              (std/srfi/41#stream-cdr
                                               _result-stream65418_)
                                              _i65419_)
                                             (if (null? _result65423_)
                                                 std/srfi/41#stream-null
                                                 (error 'stream-unfolds
                                                        '"can't happen"))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294900))))
               (_result-stream->output-streams65409_
                (lambda (_result-stream65411_)
                  (let _loop65413_ ((_i65415_
                                     (_len-values65406_
                                      _gen65403_
                                      _seed65404_))
                                    (_outputs65416_ '()))
                    (if (zero? _i65415_)
                        (apply values _outputs65416_)
                        (_loop65413_
                         (- _i65415_ '1)
                         (cons (_result-stream->output-stream65408_
                                _result-stream65411_
                                _i65415_)
                               _outputs65416_)))))))
        (if (not (procedure? _gen65403_))
            (error 'stream-unfolds '"non-procedural argument")
            (_result-stream->output-streams65409_
             (_unfold-result-stream65407_ _gen65403_ _seed65404_))))))
  (define std/srfi/41#stream-zip
    (lambda _strms65391_
      (letrec ((_stream-zip65393_
                (lambda (_strms65397_)
                  (let ((__tmp294905
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#exists
                                        std/srfi/41#stream-null?
                                        _strms65397_)
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294908
                                               (let ((__tmp294909
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (map std/srfi/41#stream-car
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _strms65397_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294909)))
                                              (__tmp294906
                                               (let ((__tmp294907
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-zip65393_
                                                               (map std/srfi/41#stream-cdr
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _strms65397_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294907))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294908
                                           __tmp294906)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294905)))))
        (if (null? _strms65391_)
            (error 'stream-zip '"no stream arguments")
            (if (std/srfi/41#exists
                 (lambda (_x65395_)
                   (not (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _x65395_
                           'std/srfi/41#stream-type))))
                 _strms65391_)
                (error 'stream-zip '"non-stream argument")
                (_stream-zip65393_ _strms65391_)))))))
