(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/xml/libxml#parser-e
    (lambda (_source210919_
             _parse-string210920_
             _parse-u8vector210921_
             _parse-port210922_)
      (if (string? _source210919_)
          _parse-string210920_
          (if (u8vector? _source210919_)
              (lambda (_src210924_ _url210925_ _enc210926_ _opt210927_)
                (_parse-u8vector210921_
                 _src210924_
                 '0
                 (u8vector-length _src210924_)
                 _url210925_
                 _enc210926_
                 _opt210927_))
              (if (input-port? _source210919_)
                  _parse-port210922_
                  (error '"Illegal source; Expected string, u8vector, or input-port"
                         _source210919_))))))
  (define std/xml/libxml#parse-xml__%
    (lambda (_g290447_
             _url210874210880_
             _encoding210875210882_
             _options210876210884_
             _ns210877210886_
             _source210888_)
      (let* ((_url210890_
              (if (eq? _url210874210880_ absent-value)
                  '"none.xml"
                  _url210874210880_))
             (_encoding210892_
              (if (eq? _encoding210875210882_ absent-value)
                  '"UTF-8"
                  _encoding210875210882_))
             (_options210894_
              (if (eq? _options210876210884_ absent-value)
                  std/xml/libxml#parse-xml-default-options
                  _options210876210884_))
             (_ns210896_
              (if (eq? _ns210877210886_ absent-value) '() _ns210877210886_))
             (_parse210898_
              (std/xml/libxml#parser-e
               _source210888_
               std/xml/libxml#xmlRead-string
               std/xml/libxml#xmlRead-u8vector
               std/xml/libxml#xmlRead-port))
             (_xtree210900_
              (_parse210898_
               _source210888_
               _url210890_
               _encoding210892_
               _options210894_)))
        (if _xtree210900_
            (with-unwind-protect
             (lambda ()
               (std/xml/libxml#xml-doc->sxml _xtree210900_ _ns210896_))
             (lambda () (std/xml/libxml#xmlFreeDoc _xtree210900_)))
            (error '"Error parsing xml; no parse tree" _source210888_)))))
  (define std/xml/libxml#parse-xml__@
    (lambda (_keys210873210908_ . _args210910_)
      (apply std/xml/libxml#parse-xml__%
             _keys210873210908_
             (table-ref _keys210873210908_ 'url: absent-value)
             (table-ref _keys210873210908_ 'encoding: absent-value)
             (table-ref _keys210873210908_ 'options: absent-value)
             (table-ref _keys210873210908_ 'namespaces: absent-value)
             _args210910_)))
  (define std/xml/libxml#parse-xml
    (lambda _args210878210916_
      (apply keyword-dispatch
             '#(url: options: #f #f encoding: namespaces:)
             std/xml/libxml#parse-xml__@
             _args210878210916_)))
  (define std/xml/libxml#parse-html__%
    (lambda (_g290448_
             _url210827210833_
             _encoding210828210835_
             _options210829210837_
             _filter-els210830210839_
             _source210841_)
      (let* ((_url210843_
              (if (eq? _url210827210833_ absent-value)
                  '"none.html"
                  _url210827210833_))
             (_encoding210845_
              (if (eq? _encoding210828210835_ absent-value)
                  '"UTF-8"
                  _encoding210828210835_))
             (_options210847_
              (if (eq? _options210829210837_ absent-value)
                  std/xml/libxml#parse-html-default-options
                  _options210829210837_))
             (_filter-els210849_
              (if (eq? _filter-els210830210839_ absent-value)
                  '()
                  _filter-els210830210839_))
             (_parse210851_
              (std/xml/libxml#parser-e
               _source210841_
               std/xml/libxml#htmlRead-string
               std/xml/libxml#htmlRead-u8vector
               std/xml/libxml#htmlRead-port))
             (_xtree210853_
              (_parse210851_
               _source210841_
               _url210843_
               _encoding210845_
               _options210847_)))
        (if _xtree210853_
            (with-unwind-protect
             (lambda ()
               (std/xml/libxml#html-doc->sxml
                _xtree210853_
                (std/xml/libxml#node-filter-e _filter-els210849_)))
             (lambda () (std/xml/libxml#xmlFreeDoc _xtree210853_)))
            (error '"Error parsing html; no parse tree" _source210841_)))))
  (define std/xml/libxml#parse-html__@
    (lambda (_keys210826210861_ . _args210863_)
      (apply std/xml/libxml#parse-html__%
             _keys210826210861_
             (table-ref _keys210826210861_ 'url: absent-value)
             (table-ref _keys210826210861_ 'encoding: absent-value)
             (table-ref _keys210826210861_ 'options: absent-value)
             (table-ref _keys210826210861_ 'filter: absent-value)
             _args210863_)))
  (define std/xml/libxml#parse-html
    (lambda _args210831210869_
      (apply keyword-dispatch
             '#(encoding: options: url: filter:)
             std/xml/libxml#parse-html__@
             _args210831210869_)))
  (define std/xml/libxml#xml-doc->sxml
    (lambda (_xtree210792_ _ns210793_)
      (letrec* ((_nsmap210795_
                 (if (table? _ns210793_)
                     _ns210793_
                     (if (pair? _ns210793_) (list->table _ns210793_) '#f)))
                (_ns-name-e210796_
                 (lambda (_node210810_ _node-name210811_ _node-ns210812_)
                   (let ((_name210814_ (_node-name210811_ _node210810_))
                         (_ns210815_ (_node-ns210812_ _node210810_)))
                     (if _ns210815_
                         (let* ((_href210817_
                                 (std/xml/libxml#xmlNs-href _ns210815_))
                                (_pre210822_
                                 (let ((_$e210819_
                                        (if _nsmap210795_
                                            (table-ref
                                             _nsmap210795_
                                             _href210817_
                                             '#f)
                                            '#f)))
                                   (if _$e210819_ _$e210819_ _href210817_))))
                           (string->symbol
                            (string-append _pre210822_ '":" _name210814_)))
                         (string->symbol _name210814_)))))
                (_element-e210797_
                 (lambda (_node210808_)
                   (_ns-name-e210796_
                    _node210808_
                    std/xml/libxml#xmlNode-name
                    std/xml/libxml#xmlNode-ns)))
                (_attribute-e210798_
                 (lambda (_node210806_)
                   (_ns-name-e210796_
                    _node210806_
                    std/xml/libxml#xmlAttr-name
                    std/xml/libxml#xmlAttr-ns))))
        (let ((_body210803_
               (std/xml/libxml#xmlNode->sxml
                (std/xml/libxml#xmlDocGetRootElement _xtree210792_)
                false
                _element-e210797_
                _attribute-e210798_))
              (_nsassoc210804_
               (if _nsmap210795_
                   (hash-map
                    (lambda (_href210800_ _pre210801_)
                      (cons (string->symbol _pre210801_)
                            (cons _href210800_ '())))
                    _nsmap210795_)
                   '#f)))
          (if _nsassoc210804_
              (cons '*TOP*
                    (cons (cons '@
                                (cons (cons '*NAMESPACES* _nsassoc210804_)
                                      '()))
                          _body210803_))
              (cons '*TOP* _body210803_))))))
  (define std/xml/libxml#html-doc->sxml
    (lambda (_xtree210789_ _filter-e210790_)
      (cons '*TOP*
            (std/xml/libxml#xmlNode->sxml
             (std/xml/libxml#xmlDocGetRootElement _xtree210789_)
             _filter-e210790_
             std/xml/libxml#xmlNode-name-e
             std/xml/libxml#xmlAttr-name-e))))
  (define std/xml/libxml#xmlNode->sxml
    (lambda (_node210773_
             _filter-e210774_
             _element-e210775_
             _attribute-e210776_)
      (let _recur210778_ ((_node210780_ _node210773_))
        (if _node210780_
            (if (_filter-e210774_ _node210780_)
                (_recur210778_ (std/xml/libxml#xmlNode-next _node210780_))
                (let ((_type210782_ (std/xml/libxml#xmlNode-type _node210780_))
                      (_rest210783_
                       (_recur210778_
                        (std/xml/libxml#xmlNode-next _node210780_))))
                  (if (eq? _type210782_ std/xml/libxml#XML_ELEMENT_NODE)
                      (let ((_el210785_ (_element-e210775_ _node210780_))
                            (_attr210786_
                             (std/xml/libxml#xmlNode-properties _node210780_))
                            (_children210787_
                             (_recur210778_
                              (std/xml/libxml#xmlNode-children _node210780_))))
                        (if _attr210786_
                            (cons (cons _el210785_
                                        (cons (cons '@
                                                    (std/xml/libxml#xmlAttr->list
                                                     _attr210786_
                                                     _attribute-e210776_))
                                              _children210787_))
                                  _rest210783_)
                            (cons (cons _el210785_ _children210787_)
                                  _rest210783_)))
                      (if (eq? _type210782_ std/xml/libxml#XML_TEXT_NODE)
                          (cons (std/xml/libxml#xmlNode-content _node210780_)
                                _rest210783_)
                          (if (eq? _type210782_
                                   std/xml/libxml#XML_CDATA_SECTION_NODE)
                              (cons (cons '*CDATA*
                                          (cons (std/xml/libxml#xmlNode-content
                                                 _node210780_)
                                                '()))
                                    _rest210783_)
                              (if (eq? _type210782_
                                       std/xml/libxml#XML_COMMENT_NODE)
                                  _rest210783_
                                  (error '"Unexpected node"
                                         (std/xml/libxml#xmlNode-name
                                          _node210780_)
                                         _type210782_)))))))
            '()))))
  (define std/xml/libxml#xmlAttr->list
    (lambda (_attr210761_ _attribute-e210762_)
      (let _recur210764_ ((_attr210766_ _attr210761_))
        (if _attr210766_
            (let* ((_value210768_
                    (std/xml/libxml#xmlAttr-children _attr210766_))
                   (_value210770_
                    (if _value210768_
                        (cons (std/xml/libxml#xmlNode-content _value210768_)
                              '())
                        '())))
              (cons (cons (_attribute-e210762_ _attr210766_) _value210770_)
                    (_recur210764_
                     (std/xml/libxml#xmlAttr-next _attr210766_))))
            '()))))
  (define std/xml/libxml#xmlNode-name-e
    (lambda (_node210759_)
      (string->symbol (std/xml/libxml#xmlNode-name _node210759_))))
  (define std/xml/libxml#xmlAttr-name-e
    (lambda (_node210757_)
      (string->symbol (std/xml/libxml#xmlAttr-name _node210757_))))
  (define std/xml/libxml#parse-xml-default-options
    (fxior std/xml/libxml#XML_PARSE_NOENT
           std/xml/libxml#XML_PARSE_NONET
           std/xml/libxml#XML_PARSE_NOBLANKS))
  (define std/xml/libxml#parse-html-default-options
    (fxior std/xml/libxml#HTML_PARSE_RECOVER
           std/xml/libxml#HTML_PARSE_NOERROR
           std/xml/libxml#HTML_PARSE_NOWARNING
           std/xml/libxml#HTML_PARSE_NONET
           std/xml/libxml#HTML_PARSE_NOBLANKS))
  (define std/xml/libxml#node-filter-e
    (lambda (_elems210747_)
      (if (null? _elems210747_)
          false
          (lambda (_node210749_)
            (let ((_name210750210752_
                   (std/xml/libxml#xmlNode-name _node210749_)))
              (if _name210750210752_
                  (let ((_name210755_ _name210750210752_))
                    (member _name210755_ _elems210747_))
                  '#f)))))))
