prelude: :gerbil/compiler/ssxi
package: std/actor/rpc

(begin
  (declare-type std/actor/rpc/connection#errorf (@lambda (1) #f))
  (declare-type std/actor/rpc/connection#warnf (@lambda (1) #f))
  (declare-type std/actor/rpc/connection#infof (@lambda (1) #f))
  (declare-type std/actor/rpc/connection#debugf (@lambda (1) #f))
  (declare-type std/actor/rpc/connection#verbosef (@lambda (1) #f))
  (declare-type std/actor/rpc/connection#rpc-server-connection (@lambda 6 #f))
  (declare-type std/actor/rpc/connection#rpc-client-connection (@lambda 4 #f))
  (declare-type std/actor/rpc/connection#rpc-set-nodelay! (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#set-rpc-keep-alive-interval!
   (@lambda 1 #f))
  (declare-type std/actor/rpc/connection#set-rpc-idle-timeout! (@lambda 1 #f))
  (declare-type std/actor/rpc/connection#set-rpc-call-timeout! (@lambda 1 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table::t
   (@struct-type
    std/actor/rpc/connection#continuation-table::t
    #f
    6
    :init!
    ((final: . #t))))
  (declare-type
   std/actor/rpc/connection#continuation-table?
   (@struct-pred std/actor/rpc/connection#continuation-table::t))
  (declare-type
   std/actor/rpc/connection#make-continuation-table
   (@struct-cons std/actor/rpc/connection#continuation-table::t))
  (declare-type
   std/actor/rpc/connection#continuation-table-mx
   (@struct-getf std/actor/rpc/connection#continuation-table::t 0 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-continuations
   (@struct-getf std/actor/rpc/connection#continuation-table::t 1 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-stream-continuations
   (@struct-getf std/actor/rpc/connection#continuation-table::t 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-stream-actors
   (@struct-getf std/actor/rpc/connection#continuation-table::t 3 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-timeouts
   (@struct-getf std/actor/rpc/connection#continuation-table::t 4 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-continuation-timeouts
   (@struct-getf std/actor/rpc/connection#continuation-table::t 5 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-mx-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 0 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-continuations-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 1 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-stream-continuations-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-stream-actors-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 3 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-timeouts-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 4 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-continuation-timeouts-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 5 #f))
  (declare-type
   std/actor/rpc/connection#&continuation-table-mx
   (@struct-getf std/actor/rpc/connection#continuation-table::t 0 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-continuations
   (@struct-getf std/actor/rpc/connection#continuation-table::t 1 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-stream-continuations
   (@struct-getf std/actor/rpc/connection#continuation-table::t 2 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-stream-actors
   (@struct-getf std/actor/rpc/connection#continuation-table::t 3 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-timeouts
   (@struct-getf std/actor/rpc/connection#continuation-table::t 4 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-continuation-timeouts
   (@struct-getf std/actor/rpc/connection#continuation-table::t 5 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-mx-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 0 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-continuations-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 1 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-stream-continuations-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 2 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-stream-actors-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 3 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-timeouts-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 4 #t))
  (declare-type
   std/actor/rpc/connection#&continuation-table-continuation-timeouts-set!
   (@struct-setf std/actor/rpc/connection#continuation-table::t 5 #t))
  (declare-type
   std/actor/rpc/connection#continuation-table:::init!
   (@lambda 1 #f))
  (declare-method
   std/actor/rpc/connection#continuation-table::t
   :init!
   std/actor/rpc/connection#continuation-table:::init!
   #f)
  (declare-type std/actor/rpc/connection#continuation-table-get (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-remove!
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-get-stream-actor
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-put-stream-actor!
   (@lambda 3 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-remove-stream-actor!
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-get-stream-cont
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-get-timeout
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-dump!__%
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-dump!__0
   (@lambda 1 #f))
  (declare-type
   std/actor/rpc/connection#continuation-table-dump!
   (@case-lambda
    (1 std/actor/rpc/connection#continuation-table-dump!__0)
    (2 std/actor/rpc/connection#continuation-table-dump!__%)))
  (declare-type std/actor/rpc/connection#rpc-connection-loop (@lambda 5 #f))
  (declare-type std/actor/rpc/connection#rpc-connection-writer (@lambda 2 #f))
  (declare-type std/actor/rpc/connection#rpc-connection-reader (@lambda 7 #f))
  (declare-type std/actor/rpc/connection#rpc-options-timeout (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#rpc-connection-shutdown
   (@lambda 1 #f))
  (declare-type std/actor/rpc/connection#rpc-connection-cleanup (@lambda 3 #f))
  (declare-type
   std/actor/rpc/connection#rpc-send-error-response
   (@lambda 2 #f))
  (declare-type
   std/actor/rpc/connection#rpc-send-error-responses
   (@lambda 1 #f)))
