prelude: :gerbil/compiler/ssxi
package: std/db

(begin
  (declare-type
   std/db/postgresql#postgresql-connection::t
   (@struct-type
    std/db/postgresql#postgresql-connection::t
    std/db/dbi#connection::t
    4
    :init!
    ((print: host port user db) (final: . #t))))
  (declare-type
   std/db/postgresql#postgresql-connection?
   (@struct-pred std/db/postgresql#postgresql-connection::t))
  (declare-type
   std/db/postgresql#make-postgresql-connection
   (@struct-cons std/db/postgresql#postgresql-connection::t))
  (declare-type
   std/db/postgresql#postgresql-connection-host
   (@struct-getf std/db/postgresql#postgresql-connection::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-port
   (@struct-getf std/db/postgresql#postgresql-connection::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-user
   (@struct-getf std/db/postgresql#postgresql-connection::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-db
   (@struct-getf std/db/postgresql#postgresql-connection::t 3 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-host-set!
   (@struct-setf std/db/postgresql#postgresql-connection::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-port-set!
   (@struct-setf std/db/postgresql#postgresql-connection::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-user-set!
   (@struct-setf std/db/postgresql#postgresql-connection::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-connection-db-set!
   (@struct-setf std/db/postgresql#postgresql-connection::t 3 #f))
  (declare-type std/db/postgresql#postgresql-connection:::init! (@lambda 6 #f))
  (declare-method
   std/db/postgresql#postgresql-connection::t
   :init!
   std/db/postgresql#postgresql-connection:::init!
   #f)
  (declare-type std/db/postgresql#postgresql-connect__% (@lambda 6 #f))
  (declare-type
   std/db/postgresql#postgresql-connect__@
   (@kw-lambda-dispatch
    (host: port: user: passwd: db:)
    std/db/postgresql#postgresql-connect__%))
  (declare-type
   std/db/postgresql#postgresql-connect
   (@kw-lambda
    (passwd: port: host: user: db:)
    std/db/postgresql#postgresql-connect__@))
  (declare-type
   std/db/postgresql#postgresql-connection::close
   (@lambda 1 std/db/postgresql-driver#postgresql-close!))
  (declare-method
   std/db/postgresql#postgresql-connection::t
   close
   std/db/postgresql#postgresql-connection::close
   #f)
  (declare-type
   std/db/postgresql#postgresql-command::t
   (@struct-type
    std/db/postgresql#postgresql-command::t
    std/db/dbi#statement::t
    5
    :init!
    ((print: complete))))
  (declare-type
   std/db/postgresql#postgresql-command?
   (@struct-pred std/db/postgresql#postgresql-command::t))
  (declare-type
   std/db/postgresql#make-postgresql-command
   (@struct-cons std/db/postgresql#postgresql-command::t))
  (declare-type
   std/db/postgresql#postgresql-command-conn
   (@struct-getf std/db/postgresql#postgresql-command::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-command-complete
   (@struct-getf std/db/postgresql#postgresql-command::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-command-notices
   (@struct-getf std/db/postgresql#postgresql-command::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-command-input
   (@struct-getf std/db/postgresql#postgresql-command::t 3 #f))
  (declare-type
   std/db/postgresql#postgresql-command-token
   (@struct-getf std/db/postgresql#postgresql-command::t 4 #f))
  (declare-type
   std/db/postgresql#postgresql-command-conn-set!
   (@struct-setf std/db/postgresql#postgresql-command::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-command-complete-set!
   (@struct-setf std/db/postgresql#postgresql-command::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-command-notices-set!
   (@struct-setf std/db/postgresql#postgresql-command::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-command-input-set!
   (@struct-setf std/db/postgresql#postgresql-command::t 3 #f))
  (declare-type
   std/db/postgresql#postgresql-command-token-set!
   (@struct-setf std/db/postgresql#postgresql-command::t 4 #f))
  (declare-type
   std/db/postgresql#!unnamed::t
   (@struct-type std/db/postgresql#!unnamed::t #f 0 #f ((final: . #t))))
  (declare-type
   std/db/postgresql#!unnamed?
   (@struct-pred std/db/postgresql#!unnamed::t))
  (declare-type
   std/db/postgresql#make-!unnamed
   (@struct-cons std/db/postgresql#!unnamed::t))
  (declare-type std/db/postgresql#postgresql-command:::init!__% (@lambda 5 #f))
  (declare-type
   std/db/postgresql#postgresql-command:::init!__@
   (@kw-lambda-dispatch
    (name: complete:)
    std/db/postgresql#postgresql-command:::init!__%))
  (declare-type
   std/db/postgresql#postgresql-command:::init!
   (@kw-lambda
    (name: complete:)
    std/db/postgresql#postgresql-command:::init!__@))
  (declare-method
   std/db/postgresql#postgresql-command::t
   :init!
   std/db/postgresql#postgresql-command:::init!
   #f)
  (declare-type
   std/db/postgresql#postgresql-command::query-start
   (ast-rules
    (%#call %#ref)
    ((%#call _ (%#ref arg) ...) (%#quote #!void))
    ((%#call _ arg ...) (%#begin arg ... (%#quote #!void)))))
  (declare-method
   std/db/postgresql#postgresql-command::t
   query-start
   std/db/postgresql#postgresql-command::query-start
   #f)
  (declare-method
   std/db/postgresql#postgresql-command::t
   query-fini
   std/db/postgresql#postgresql-command::query-fini
   #f)
  (declare-type
   std/db/postgresql#postgresql-command::query-fetch
   (@lambda (0) #f))
  (declare-method
   std/db/postgresql#postgresql-command::t
   query-fetch
   std/db/postgresql#postgresql-command::query-fetch
   #f)
  (declare-type
   std/db/postgresql#postgresql-command::query-row
   (@struct-getf std/db/postgresql#postgresql-command::t 1 #f))
  (declare-method
   std/db/postgresql#postgresql-command::t
   query-row
   std/db/postgresql#postgresql-command::query-row
   #f)
  (declare-type std/db/postgresql#postgresql-command::columns (@lambda (0) #f))
  (declare-method
   std/db/postgresql#postgresql-command::t
   columns
   std/db/postgresql#postgresql-command::columns
   #f)
  (declare-type std/db/postgresql#wrap-notice-handler (@lambda 2 #f))
  (declare-type std/db/postgresql#postgresql-command::reset (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-command::reset::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-command::reset::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-command::t
   reset
   std/db/postgresql#postgresql-command::reset
   #f)
  (declare-type
   std/db/postgresql#postgresql-statement::t
   (@struct-type
    std/db/postgresql#postgresql-statement::t
    std/db/postgresql#postgresql-command::t
    4
    :init!
    ((final: . #t))))
  (declare-type
   std/db/postgresql#postgresql-statement?
   (@struct-pred std/db/postgresql#postgresql-statement::t))
  (declare-type
   std/db/postgresql#make-postgresql-statement
   (@struct-cons std/db/postgresql#postgresql-statement::t))
  (declare-type
   std/db/postgresql#postgresql-statement-cols
   (@struct-getf std/db/postgresql#postgresql-statement::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-params
   (@struct-getf std/db/postgresql#postgresql-statement::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-bind
   (@struct-getf std/db/postgresql#postgresql-statement::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-row
   (@struct-getf std/db/postgresql#postgresql-statement::t 3 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-cols-set!
   (@struct-setf std/db/postgresql#postgresql-statement::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-params-set!
   (@struct-setf std/db/postgresql#postgresql-statement::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-bind-set!
   (@struct-setf std/db/postgresql#postgresql-statement::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-statement-row-set!
   (@struct-setf std/db/postgresql#postgresql-statement::t 3 #f))
  (declare-type
   std/db/postgresql#postgresql-statement:::init!__%
   (@lambda 6 #f))
  (declare-type
   std/db/postgresql#postgresql-statement:::init!__@
   (@kw-lambda-dispatch
    (name: params:)
    std/db/postgresql#postgresql-statement:::init!__%))
  (declare-type
   std/db/postgresql#postgresql-statement:::init!
   (@kw-lambda
    (name: params:)
    std/db/postgresql#postgresql-statement:::init!__@))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   :init!
   std/db/postgresql#postgresql-statement:::init!
   #f)
  (declare-type
   std/db/postgresql#postgresql-statement::query-row
   (@lambda 1 std/db/postgresql#postgresql-statement-row))
  (declare-type
   std/db/postgresql#postgresql-statement::query-row::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::query-row::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   query-row
   std/db/postgresql#postgresql-statement::query-row
   #f)
  (declare-type std/db/postgresql#postgresql-statement::columns (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::columns::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::columns::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   columns
   std/db/postgresql#postgresql-statement::columns
   #f)
  (declare-method
   std/db/postgresql#postgresql-statement::t
   query-fini
   std/db/postgresql#postgresql-statement::query-fini
   #f)
  (declare-type
   std/db/postgresql#postgresql-statement-in-query?
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::query-start
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::query-start::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::query-start::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   query-start
   std/db/postgresql#postgresql-statement::query-start
   #f)
  (declare-type
   std/db/postgresql#postgresql-statement::query-fetch
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   query-fetch
   std/db/postgresql#postgresql-statement::query-fetch
   #f)
  (declare-type
   std/db/postgresql#postgresql-connection::prepare
   (@lambda 2 #f))
  (declare-method
   std/db/postgresql#postgresql-connection::t
   prepare
   std/db/postgresql#postgresql-connection::prepare
   #f)
  (declare-type std/db/postgresql#postgresql-statement::bind (@lambda (1) #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   bind
   std/db/postgresql#postgresql-statement::bind
   #f)
  (declare-type std/db/postgresql#postgresql-statement::clear (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::clear::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::clear::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   clear
   std/db/postgresql#postgresql-statement::clear
   #f)
  (declare-type std/db/postgresql#postgresql-statement::exec (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::exec::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::exec::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   exec
   std/db/postgresql#postgresql-statement::exec
   #f)
  (declare-type
   std/db/postgresql#postgresql-statement::finalize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::finalize::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::finalize::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   finalize
   std/db/postgresql#postgresql-statement::finalize
   #f)
  (declare-type std/db/postgresql#postgresql-statement::reset (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::reset::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-statement::reset::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-statement::t
   reset
   std/db/postgresql#postgresql-statement::reset
   #f)
  (declare-type
   std/db/postgresql#postgresql-query::t
   (@struct-type
    std/db/postgresql#postgresql-query::t
    std/db/postgresql#postgresql-command::t
    3
    :init!
    ((print: greedy str) (final: . #t))))
  (declare-type
   std/db/postgresql#postgresql-query?
   (@struct-pred std/db/postgresql#postgresql-query::t))
  (declare-type
   std/db/postgresql#make-postgresql-query
   (@struct-cons std/db/postgresql#postgresql-query::t))
  (declare-type
   std/db/postgresql#postgresql-query-str
   (@struct-getf std/db/postgresql#postgresql-query::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-query-cmd
   (@struct-getf std/db/postgresql#postgresql-query::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-query-greedy
   (@struct-getf std/db/postgresql#postgresql-query::t 2 #f))
  (declare-type
   std/db/postgresql#postgresql-query-str-set!
   (@struct-setf std/db/postgresql#postgresql-query::t 0 #f))
  (declare-type
   std/db/postgresql#postgresql-query-cmd-set!
   (@struct-setf std/db/postgresql#postgresql-query::t 1 #f))
  (declare-type
   std/db/postgresql#postgresql-query-greedy-set!
   (@struct-setf std/db/postgresql#postgresql-query::t 2 #f))
  (declare-type std/db/postgresql#postgresql-query:::init!__% (@lambda 5 #f))
  (declare-type
   std/db/postgresql#postgresql-query:::init!__@
   (@kw-lambda-dispatch
    (greedy:)
    std/db/postgresql#postgresql-query:::init!__%))
  (declare-type
   std/db/postgresql#postgresql-query:::init!
   (@kw-lambda (greedy:) std/db/postgresql#postgresql-query:::init!__@))
  (declare-method
   std/db/postgresql#postgresql-query::t
   :init!
   std/db/postgresql#postgresql-query:::init!
   #f)
  (declare-type std/db/postgresql#postgresql-query::exec (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-query::t
   exec
   std/db/postgresql#postgresql-query::exec
   #f)
  (declare-type
   std/db/postgresql#postgresql-query::query-row
   (@struct-getf std/db/postgresql#postgresql-query::t 1 #f))
  (declare-method
   std/db/postgresql#postgresql-query::t
   query-row
   std/db/postgresql#postgresql-query::query-row
   #f)
  (declare-type std/db/postgresql#postgresql-query::query-start (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-query::query-start::specialize
   (@lambda 1 #f))
  (declare-type
   std/db/postgresql#postgresql-query::query-start::specialize::unchecked
   (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-query::t
   query-start
   std/db/postgresql#postgresql-query::query-start
   #f)
  (declare-type std/db/postgresql#postgresql-query::query-fetch (@lambda 1 #f))
  (declare-method
   std/db/postgresql#postgresql-query::t
   query-fetch
   std/db/postgresql#postgresql-query::query-fetch
   #f)
  (declare-type
   std/db/postgresql#catalog::t
   (@struct-type std/db/postgresql#catalog::t #f 2 :init! ((final: . #t))))
  (declare-type
   std/db/postgresql#catalog?
   (@struct-pred std/db/postgresql#catalog::t))
  (declare-type
   std/db/postgresql#make-catalog
   (@struct-cons std/db/postgresql#catalog::t))
  (declare-type
   std/db/postgresql#catalog-s
   (@struct-getf std/db/postgresql#catalog::t 0 #f))
  (declare-type
   std/db/postgresql#catalog-d
   (@struct-getf std/db/postgresql#catalog::t 1 #f))
  (declare-type
   std/db/postgresql#catalog-s-set!
   (@struct-setf std/db/postgresql#catalog::t 0 #f))
  (declare-type
   std/db/postgresql#catalog-d-set!
   (@struct-setf std/db/postgresql#catalog::t 1 #f))
  (declare-type std/db/postgresql#catalog:::init! (@lambda (1) #f))
  (declare-method
   std/db/postgresql#catalog::t
   :init!
   std/db/postgresql#catalog:::init!
   #f)
  (declare-type std/db/postgresql#catalog-serializer (@lambda 2 #f))
  (declare-type std/db/postgresql#catalog-deserializer (@lambda 2 #f))
  (declare-type std/db/postgresql#serialize-boolean (@lambda 1 #f))
  (declare-type std/db/postgresql#deserialize-boolean (@lambda 1 #f))
  (declare-type std/db/postgresql#serialize-date (@lambda 1 #f))
  (declare-type std/db/postgresql#deserialize-date (@lambda 1 #f))
  (declare-type std/db/postgresql#serialize-timestamp (@lambda 1 #f))
  (declare-type std/db/postgresql#deserialize-timestamp (@lambda 1 #f))
  (declare-type std/db/postgresql#serialize-timestamptz (@lambda 1 #f))
  (declare-type std/db/postgresql#deserialize-timestamptz (@lambda 1 #f))
  (declare-type std/db/postgresql#identity-string (@lambda 1 #f)))
